-- MD5
function MD5(str)
	return CMD5:generate(str , string.len(str) )
end
--过万数字转换
function numShift( value )
	value = tonumber( value )
	return ( value > 10000 and math.floor( value / 10000) .. "万" or value )
end
--混合msas生成新精灵
function mixedGraph(originSp,maskSp)
	rt = CCRenderTexture:create(rectWidth, rectHeight)
	maskSp:setAnchorPoint(ccp(0,0))
	originSp:setAnchorPoint(ccp(0,0))
	--[[指定了新来的颜色(source values)如何被运算。九个枚举型被接受使用：
	GL_ZERO, 
	GL_ONE, 
	GL_DST_COLOR,
	GL_ONE_MINUS_DST_COLOR,
	GL_SRC_ALPHA, 
	GL_ONE_MINUS_SRC_ALPHA, 
	GL_DST_ALPHA, 
	GL_ONE_MINUS_DST_ALPHA, 
	GL_SRC_ALPHA_SATURATE.
	
	参数 destfactor:
	指定帧缓冲区的颜色(destination values)如何被运算。八个枚举型被接受使用：
	GL_ZERO, 
	GL_ONE, 
	GL_SRC_COLOR, 
	GL_ONE_MINUS_SRC_COLOR, 
	GL_SRC_ALPHA, 
	GL_ONE_MINUS_SRC_ALPHA, 
	GL_DST_ALPHA,
	GL_ONE_MINUS_DST_ALPHA]]--
	
	blendFunc=ccBlendFunc:new()
	blendFunc.src = 1
	blendFunc.dst = 1
	maskSp:setBlendFunc(blendFunc)
	
	blendFunc.src = 6			-- mask图片的当前alpha值是多少，如果是0（完全透明），那么就显示mask的。如果是1（完全不透明）
	blendFunc.dst = 0				-- maskSprite不可见
	maskSp:setBlendFunc(blendFunc)
	
	
	local org_visit = originSp.visit
	
	function originSp.visit(self)
		glEnable(GL_SCISSOR_TEST)
		glScissor(0, 0, rectWidth, rectHeight)
		org_visit(self)
		glDisable(GL_SCISSOR_TEST);
	end
	rt:begin()
	maskSp:visit()
	originSp:visit()
	rt:endToLua()
	


	
	local retval = CCSprite:createWithTexture(rt:getSprite():getTexture())
	retval:setFlipY(true)--是否翻转
	return retval
end

--[[ 获取所有子节点里的 CCSprite ]]
function getAllSprites( root )
	local sprites = {}

	local function _getAllSprites( _root )
		local childs_num = _root:getChildrenCount()
		if childs_num == 0 then return end

		local childs = _root:getChildren()
		for i = 0 , childs_num - 1 do
			local child = tolua.cast( childs:objectAtIndex(i) , "CCNode")

			if child:getTag() == 102 then
				sprites[#sprites + 1] = tolua.cast( child , "CCSprite")
			end

			_getAllSprites(child)
		end
	end

	_getAllSprites( root )

	return sprites
end

--设置锚点与位置,x,y默认为0，锚点默认为0
function setAnchPos(node,x,y,anX,anY)
	local posX , posY , aX , aY = x or 0 , y or 0 , anX or 0 , anY or 0
	node:setAnchorPoint(ccp(aX,aY))
	node:setPosition(ccp(posX,posY))
end

--根据type读取相应的配置文件
function getConfig(type , cid , key , other , group )
	local isOtherGame = getIsOtherGame( group )
	local config = {}
	if type == "equip" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Equip")
	elseif type == "general" then
		if isOtherGame then
			config = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fsheroconfig" )
		else
			config = requires(IMG_PATH,"GameLuaScript/Config/Hero")
		end
	elseif type == "pet"  then
		if isOtherGame then
			config = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fsnewpet" )
		else
			config = requires(IMG_PATH,"GameLuaScript/Config/Pet")
		end
	elseif type == "prop" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Prop")
	elseif type == "skill" or type == "generalskill" then
		-- if isOtherGame then
		-- 	config = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fskill" )
		-- else
			config = requires(IMG_PATH,"GameLuaScript/Config/Skill")
		-- end
	elseif type == "natural" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Natural")
	elseif type == "suit" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Suit")
	elseif type == "gn" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Generalnatrual")
	elseif type == "petskill" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Petskill")
	elseif type == "mission" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Mission")
	elseif type == "instance" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Instance")
	elseif type == "npc" then
		config = requires(IMG_PATH,"GameLuaScript/Config/Npc")
	elseif type == "data_skillexp" then
		config = requires(IMG_PATH,"GameLuaScript/Config/data_skillexp")
	elseif type == "data_stoneexp" then
		config = requires(IMG_PATH,"GameLuaScript/Config/data_stoneexp")
	elseif type == "data_stonefigure" then
		config = requires(IMG_PATH,"GameLuaScript/Config/data_stonefigure")
	elseif type == "data_lost" then
		config = requires(IMG_PATH,"GameLuaScript/Config/data_lost")
	elseif type == "generalexp" then
		config = requires(IMG_PATH,"GameLuaScript/Config/generalexp")
	elseif type == "petlvexp" then
		config = requires(IMG_PATH,"GameLuaScript/Config/petlvexp")
	elseif type == "transmission" then
		config = requires(IMG_PATH,"GameLuaScript/Config/transmission_config")
	elseif type == "natural" then
		config = requires(IMG_PATH, "GameLuaScript/Config/Natural")
	elseif type == "help" then
		config = requires(IMG_PATH, "GameLuaScript/Config/help")
	elseif type == "generallead" then
		config = requires(IMG_PATH, "GameLuaScript/Config/generallead")
	elseif type == "generalstageconfig" then
		config = requires(IMG_PATH, "GameLuaScript/Config/generalstageconfig")
	elseif type == "wenzimiaoshu" then
		config = requires(IMG_PATH, "GameLuaScript/Config/wenzimiaoshu")
	elseif type == "clexpend" then
		config = requires(IMG_PATH, "GameLuaScript/Config/clexpend")
	elseif type == "clequip" then
		config = requires(IMG_PATH, "GameLuaScript/Config/clequip")
	elseif type == "multi" then
		config = requires(IMG_PATH, "GameLuaScript/Config/fbLimit")
	elseif type == "generalstar" then
		config = requires(IMG_PATH, "GameLuaScript/Config/xingdian")
	elseif type == "petstar" then
		config = requires(IMG_PATH, "GameLuaScript/Config/petxingdian")
	elseif type == "skillstar" then
		config = requires(IMG_PATH, "GameLuaScript/Config/skillxingdian")
	elseif type == "lingyuan" then
		config = requires(IMG_PATH, "GameLuaScript/Config/lingyuan")
	elseif type == "random" then
		config = requires(IMG_PATH, "GameLuaScript/Config/random")
	elseif type == "equipGoldCompose" then
		config = requires(IMG_PATH, "GameLuaScript/Config/equipgoldcompose")		
	elseif type == "xilian" then
		config = requires(IMG_PATH, "GameLuaScript/Config/xilian")		
	elseif type == "xilianname" then
		config = requires(IMG_PATH, "GameLuaScript/Config/xilianname")		
	elseif type == "xilianattribute" then
		config = requires(IMG_PATH, "GameLuaScript/Config/xilianattribute")	
	elseif type == "vipjz" then
		config = requires(IMG_PATH, "GameLuaScript/Config/vipjz")		
	end
	
	--反回对应的配置文件
	if type and not cid then
		return config
	end
	
	if config[cid..""] then
		if other then
			return config[cid..""][key..""][other]
		elseif key then
			if type == "petskill" then
				return config[cid..""][key..""]
--				return config[cid..""]["1"][key..""]--这个是早之前的config取值方式 ，如果后边有报错，看一下这里，顺便把报错的改成上边的形式
			else
				return config[cid..""][key..""]
			end
		else
			return config[cid..""]
		end
	else
--		echo("配置文件未找到，请检查cid是否有误")
	end
end



--自定义table遍历的顺序，原理，将原table的索引取出，按自定义顺序存在数组中，然后按照顺序取即可
function tableIterator(t,sortRule)
	local index = {}								
	for key in pairs(t) do
		index[#index + 1] = key
	end		
	table.sort(index,sortRule) 
	local i = 0
	return function()		
		i = i + 1 
		return index[i], t[index[i]]  
	end
end

function getSortList(t, sortRule)
	local index = {}								
	for key in pairs(t or {}) do
		index[#index + 1] = key
	end		
	table.sort(index,sortRule) 
	return index
end

--时间转换  
 function timeConvert( value , key, noHour )
	local hour,min,sec
	hour = math.floor(value / 3600)
	if hour >= 1 then
		min = math.floor((value - hour * 3600) / 60)
	else
		min = math.floor(value / 60)
	end
	sec = math.floor(value % 60 )
	
	hour = hour<10 and "0"..hour or hour 
	min = min<10 and "0"..min or min 
	sec = sec<10 and "0"..sec or sec
	
	if key == "hour" then
		return hour
	end
	if key == "min" then
		return min
	end
	if key == "sec" then
		return sec
	end
	
	if noHour then
		return min .. ":" .. sec
	else
		return hour .. ":" .. min .. ":" .. sec
	end
end

--背包更新函数
function updateBagInfo(type, data)
	if type == "_U_bag" then
		for k, v in pairs(data) do
			DATA_Bag:set(k,v)
		end
	elseif type == "_D_bag" then
		for k,v in pairs(data) do
			local detail 
			
			if k == "equip" then
				detail = DATA_Equip
			elseif k == "skill" then
			elseif k == "prop" then
			elseif k == "general" then
				detail = DATA_General
			elseif k == "pet" then
				detail = DATA_Pet
			end
			detail:insert(v)
		end
	end
end

-- 获取美术字
function getImageNum( num , imagePath , params )
	if type(params) ~= "table" then params = {} end
	local decimals = params.decimals and true or false
	
	if not decimals then
		num = math.round( num )
	end
	num = num < 0 and 0 or num
	
	local image_path = imagePath
	local frames = display.newFramesWithImage( image_path , decimals and 11 or 10 )

	local count_str = tostring( num )
	local len = string.len( count_str )

    local sprite = display.newSpriteWithFrame( frames[1] )
    -- local offset = params.offset or 0
    local skewing =  params.offset or 0
    local offset = 0
    local height = sprite:getContentSize().height
    
	local width = sprite:getContentSize().width
	
    local render = CCRenderTexture:create( width * len , sprite:getContentSize().height )
	render:begin()

    for i = 1 , len do
        local label = ( string.sub( count_str , i , i ) == "." ) and 10 or ( string.sub( count_str , i , i ) )

        local sprite = display.newSpriteWithFrame( frames[label + 1])
        display.align(sprite, display.LEFT_BOTTOM , offset , 0)

        offset = offset + (width or sprite:getContentSize().width) + skewing

        sprite:visit()
    end

    render:endToLua()

    local final_sprite = CCSprite:createWithTexture( render:getSprite():getTexture() )
    final_sprite:setFlipY(true)

    return final_sprite , offset , height
end
-- 获取CID对应的类型
function getCidType( _cid )
    return DATA_IDTYPE:getType( _cid )
end
--获取是否其它游戏资源
function getIsOtherGame( group )
	if not group then return false end
	
	local sceneName =  display.getRunningScene()["name"]
	local isOtherGame = false
	if sceneName == "battle" then
		local logic = requires(IMG_PATH,"GameLuaScript/Scene/battle/logicLayer")
		isOtherGame = logic:getShenZhan( group ) 
	elseif sceneName == "battleNew" then
		local def = requires(IMG_PATH,"GameLuaScript/Scene/battleNew/def")
		isOtherGame = def.isGodwarBattle(group)
	end
	return isOtherGame
end

-- 获取图片地址
function getImageByType(cid , size , onlyName , group , force_img_id)
	if size == nil then size = "s" end
	local specialElement = {
		skill_coin	= COMMONPATH .. cid .. ".png" ,									--技能币
		ly			= IMG_PATH .. "image/prop/" .. cid .. ".png" ,					--灵源
		crystal		= IMG_PATH .. "image/prop/" .. cid .. ".png" ,					--能量水晶
		skill_money	= IMG_PATH .. "image/prop/" .. cid .. ".png" ,					--封神币
		sg			= IMG_PATH .. "image/prop/" .. cid .. ".png" ,					--神格
		qy			= IMG_PATH .. "image/prop/" .. cid .. ".png" ,					--气运
		vipexp		= IMG_PATH .. "image/prop/" .. cid .. ".png" ,					--VIP经验
		gold		= IMG_PATH .. "image/prop/" .. cid .. ".png" ,					--黄金
		card10		= IMG_PATH .. "image/prop/card10.png" ,							--10元月卡
		card30		= IMG_PATH .. "image/prop/card30.png" ,							--30元月卡
		card50		= IMG_PATH .. "image/prop/card50.png" ,							--50元月卡
		card78		= IMG_PATH .. "image/prop/card78.png" ,							--78元季卡
		silver		= IMG_PATH .. "image/prop/" .. cid .. ".png" , 					--银两
		honor		= IMG_PATH .. "image/common/honor.png" , 						--荣誉
		task_power	= IMG_PATH .. "image/prop/s_power.png" , 						--体力
		power		= IMG_PATH .. "image/prop/s_power.png" , 						--体力
		task_tribute= IMG_PATH .. "image/common/tribute.png" , 						--帮威
		task_exp	= IMG_PATH .. "image/common/tribute.png" , 						--帮贡
		soul1		= IMG_PATH .. "image/scene/forge/general_icon_1.png" , 			--一星英雄将魂
		soul2		= IMG_PATH .. "image/scene/forge/general_icon_2.png" , 			--二星英雄将魂
		soul3		= IMG_PATH .. "image/scene/forge/general_icon_3.png" , 			--三星英雄将魂
		soul4		= IMG_PATH .. "image/scene/forge/general_icon_4.png" , 			--四星英雄将魂
		chip1		= IMG_PATH .. "image/scene/forge/equip_icon_1.png" , 			--一星装备碎片
		chip2		= IMG_PATH .. "image/scene/forge/equip_icon_2.png" , 			--二星装备碎片
		chip3		= IMG_PATH .. "image/scene/forge/equip_icon_3.png" , 			--三星装备碎片
		chip4		= IMG_PATH .. "image/scene/forge/equip_icon_4.png" , 			--四星装备碎片
		animal1		= IMG_PATH .. "image/scene/forge/pet_icon_1.png" , 				--一星兽魂
		animal2		= IMG_PATH .. "image/scene/forge/pet_icon_2.png" , 				--二星兽魂
		animal3		= IMG_PATH .. "image/scene/forge/pet_icon_3.png" , 				--三星兽魂
		animal4		= IMG_PATH .. "image/scene/forge/pet_icon_4.png" , 				--四星兽魂
			hld		= IMG_PATH .. "image/scene/power/hld.png" , 				--四星兽魂
		["10000"]	= IMG_PATH .. "image/prop/10000.png" , 				--大黄金袋
		["10001"]	= IMG_PATH .. "image/prop/10001.png" , 				--宝石袋
		["10002"]	= IMG_PATH .. "image/prop/10002.png" , 				--银币袋
		["10003"]	= IMG_PATH .. "image/prop/10003.png" , 				--鸡血袋
		["10004"]	= IMG_PATH .. "image/prop/10004.png" , 				--小黄金袋
		["10005"]	= IMG_PATH .. "image/prop/10005.png" , 				--传功丹袋
		["10006"]	= IMG_PATH .. "image/prop/10006.png" , 				--装备碎片袋
	}
	
	if specialElement[cid.. ""] then
		return specialElement[cid.. ""]
	end
	
	if cid == "体力" then
		return IMG_PATH .. "image/prop/s_power.png"
	end
	
	if cid == "扫荡令" then
		return IMG_PATH .. "image/prop/s_16016.png"
	end
	
	
	local isOtherGame = getIsOtherGame( group )
	local type = getCidType(cid)
	local dir = type
	local prefix = size .. "_"
	local img_id = cid
	if type == "prop" then
		if size == "b" or size == "m" then
			prefix = "b_"
		else
			prefix = "s_"
		end
	elseif type == "general" or type == "hero" then
	
		if isOtherGame then
			dir = "scene/godwar/other/" .. isOtherGame .. "/hero"
		else
			dir = "hero"
		end

		if force_img_id then
			img_id = force_img_id
		else
			img_id = getConfig("general" , cid , "logo_id" , nil , group )
		end
		if size == "b" then
			prefix = "b_general"
		elseif size == "c" then
			prefix = "c_general"
		elseif size == "m" then
			prefix = "general"
		else
			prefix = "s_general"
		end
	elseif type == "npc" then
		
		if isOtherGame then
			dir = "scene/godwar/other/" .. isOtherGame .. "/hero"
		else
			dir = "hero"
		end
		
	
		img_id = getConfig("npc" , cid , "logo_id" , nil , group )
		
		if size == "b" then
			if img_id < 18000 then
				prefix = "b_general"		--boss npc有大图，
			else
				prefix = "general"		--npc没有大图，
			end
		elseif size == "c" then
			prefix = "c_general"
		elseif size == "m" then
			prefix = "general"
		else
			prefix = "s_general"
		end
	elseif type == "pet" then
	
		if isOtherGame then
			dir = "scene/godwar/other/" .. isOtherGame .. "/pet"
		end
		
		if size == "b" then
			prefix = "b_"
		elseif size == "m" then
			prefix = ""
		else
			prefix = "s_"
		end
	elseif type == "skill" or type == "petskill" then
		if isOtherGame then
			dir = "scene/godwar/other/" .. isOtherGame .. "/skill"
		else
			dir = "skill"
		end
		if size == "b" or size == "m" then
			prefix = ""
		else
			prefix = ""
		end
	elseif type == "equip" then
		if size == "b" or size == "m" then
			prefix = "b_"
		else
			prefix = ""
		end
	end
	if onlyName then
		return prefix .. img_id .. ".png"
	end
	return IMG_PATH .. "image/" .. dir .. "/" .. prefix .. img_id .. ".png"
end


--[[功能对应等级开放]]
function checkOpened(type)
	local Config_Open = requires(IMG_PATH , "GameLuaScript/Config/Open")
	local cur = DATA_Guide:get()
	
	if not isset(Config_Open , type) then return true end

	local config = Config_Open[type]
	if cur["map_id"] > config[1] or (cur["map_id"] == config[1] and cur["mission_id"] >= config[2]) then
		return true
	else
		return "需要玩家您打过关卡" .. config[1] .. "-" .. config[2] .. "才能开启"
	end
end

--[[获取引导提示信息]]
function getGuideInfo()
	local Config_Open = requires(IMG_PATH , "GameLuaScript/Config/Open")
	local cur = DATA_Guide:get()
	local old = DATA_Guide:getOld()

	-- 关卡无变化
	if cur["map_id"] == old["map_id"] and cur["mission_id"] == old["mission_id"] then
		return false
	end

	local id = cur["map_id"] .. "-" .. cur["mission_id"]
	if not isset(Config_Open , id) then return false end

	return Config_Open[id]
end

--根据传递进来的动作创建一个队列
function getSequenceAction(...)
	local action = CCArray:create()
	for i = 1, arg["n"] do
		action:addObject(arg[i])	
	end
	return CCSequence:create(action)
end

--同时
function getSpawnAction(...)
	local action = CCArray:create()
	for i = 1, arg["n"] do
		action:addObject(arg[i])	
	end
	return CCSpawn:create(action)
end

--背包是否已超出上限
function isBagFull(callback, items)
	local full
	local max = DATA_Vip:getBagMax()
	local tab = {
		general = "英雄",
		equip = "装备",
		pet = "幻兽",
		skill = "技能",
		prop = "道具",
	}

	for type, name in pairs(tab) do
		local list = DATA_Bag:get(type)
		
		if table.nums(list or {}) + (table.nums(items or {}) ) >= max  then
			local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
			local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
			
			full = true
			local layer = display.newLayer()
			local mask 
			
			local bg = display.newSprite(COMMONPATH.."tip_bg.png")
			setAnchPos(bg, 240, 425, 0.5, 0.5)
			
			layer:addChild(bg)
			
			local str = "您的" .. name .. "背包已满，无法容纳这么丰厚的关卡掉落啦！"
			if type == "general" or type == "equip" or type == "pet" then
				str = str.."\n点击确定按钮跳转到打造功能"
			else
				str = str.."\n点击确定按钮跳进入背包"
			end
			local tip = display.strokeLabel(replaceStr(str), 0, 0, 24, ccc3(0x2c, 0, 0), nil, nil, {
				dimensions_width = bg:getContentSize().width - 30,
				dimensions_height = bg:getContentSize().height
			})
			setAnchPos(tip, 240, 380, 0.5, 0.5)
			layer:addChild(tip)
			
			local cancel = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 300, 350 ,{
				front = COMMONPATH.."cancel.png",
				priority = -151,
				callback = function()
					display.getRunningScene():removeChild(mask:getLayer(), true)
				end
			})
			layer:addChild(cancel:getLayer())
			
			
			local ok = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 100, 350, {
				priority = -151,
				front = COMMONPATH.."ok.png",
				callback = function()
					if callback then
						callback()
					else
						if type == "general" then
							switchScene("forge")
						elseif type == "equip" then
							switchScene("forge")
						elseif type == "pet" then
							switchScene("forge")
						elseif type == "skill" then
							switchScene("bag")
						elseif type == "prop" then
							switchScene("bag")
						end
					end
				end
			})
			layer:addChild(ok:getLayer())
			
			mask = KNMask:new({item = layer, priority = -150})
			display.getRunningScene():addChild(mask:getLayer())
			break
		end
	end
	return full
end

--获取配置文件中的信息
function getConfigTable(kind, filter)
	local info
	local result = {}	
	if kind == "general" or kind == "hero" then
		info = requires(IMG_PATH, "GameLuaScript/Config/Hero")
		for k, v in pairs(info) do
			if not filter then
				if v["hidden"] == 0 then --不是怪物
					result[k] = v
				end
			elseif type(filter) == "table" then
				local legal = true
				for sk, sv in pairs(filter) do
					if v[sk] ~= sv then
						legal = false
						break
					end
				end
				if legal and v["hidden"] == 0 then
					result[k] = v	
				end
			end
		end	
	elseif kind == "equip" then 
		info = requires(IMG_PATH, "GameLuaScript/Config/Equip")
		for k, v in pairs(info) do
			if not filter then
				result[k] = v
			elseif type(filter) == "table" then
				for sk , sv in pairs(filter) do
					if v[sk] == sv then
							result[k] = v
						break
					end
				end
			end
		end
		--getSortList(result)
	end
	return result
end

--黄金不足提示
function countGold( _needGoldNum )
	_needGoldNum = tonumber(_needGoldNum)
	local my_gold = tonumber( DATA_Account:get("gold") )
	if _needGoldNum > my_gold then
		KNMsg.getInstance():boxShow( "您当前的黄金数量不够，交易失败。\n请及时充值。" ,{ 
																			confirmText = COMMONPATH .. "chongzhi.png" , 
																			confirmFun = function() switchScene("pay") end , 
																			cancelFun = function() end 
																			} )
		return false
	end
	return true
end

--判断附加属性是否激活
function checkActive(kind, params)

	local active
	local p = params or {}

	if kind == "general" or kind == "hero" then
		local nType = getConfig("natural", p.nid, "type")
		local need = getConfig("natural", p.nid, "condition")
		if not need then
			return false
		end
		if nType == 1 then   --齐上阵的
			local check = true
			for k, v in pairs(need) do
				local on
				if params.method then--阵法

					for k,v2 in pairs(params.method) do
						local roleInfo = DATA_Bag:get("general", v2)
						if roleInfo and tonumber(roleInfo.cid) == tonumber(v) then
							on = true
							break
						end
					end

				else
				 	on = DATA_Formation:checkOnByCid(tonumber(v))
				end
				if not on  then
					check = false
					break
				end
			end
			active = check
		else                 --装备穿戴

			local check = false
			for k, v in pairs(need) do

				if DATA_ROLE_SKILL_EQUIP:isDress(p.id, v) then
					check = true
					break
				end

				local flag = DATA_ROLE_SKILL_EQUIP:isDressdOnZhenFaHero(p.id , v)
				-- dump(flag , "flag")
				-- dump(p.nid , "p.nid")
				if flag then 
					check = true
					break
				end

				-- if G_zhenfa_equip and table.nums(G_zhenfa_equip) ~= 0 then 
				-- 	for k1, v1 in pairs(G_zhenfa_equip) do
				-- 		for sk1, sv1 in pairs(v1) do
				-- 			if tonumber(sv1["cid"]) == v then
				-- 				check = true
				-- 				break
				-- 			end
				-- 		end
				-- 	end
				-- end
--				local roleId = DATA_ROLE_SKILL_EQUIP:getRoleId(v.."", "equip", true) 
--				print("---------英雄",roleId)
--				if roleId then
--					if tonumber(DATA_Bag:get("general", roleId, "cid")) == tonumber(p.cid) then
--						check = true
--						break
--					end
--				end
			end
			active = check
		end
	elseif kind == "equip" then  --装备的附加属性是否被激活

		local heroId = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(p.id), "equip",false,true)
		local needStar = getConfig("equip", p.cid, "apstar")
		local needRole = getConfig("equip", p.cid, "apstype")
		local heroCid = DATA_Bag:get("general", heroId, "cid")

		-- dump(heroCid)

		if heroCid==nil then

			if G_zhenfa_equip and table.nums(G_zhenfa_equip) ~= 0 then 
				for k, v in pairs(G_zhenfa_equip) do
					for sk, sv in pairs(v) do
						if tonumber(sv["id"]) == tonumber(heroId) then
							heroCid=sv["cid"]
							break
						end
					end
				end
			end
		end 
		
		if getConfig("general", heroCid, "star") == needStar and
			getConfig("general", heroCid, "role") == needRole then
				active = true
		end
	end
	return active
end

--文字换行处理
function createLabel( params )
	params = params or {}
	local str = params.str or ""
	local total_width = params.width or 100		-- 文字总宽度
	local color = params.color or ccc3( 0x2c , 0x00 , 0x00 )
	local size = params.size or 20
	local x = params.x or 0
	local y = params.y or 0
	local line = 1														-- 行数
	-- 估算一行的字符数量
	local enter_num = string.len(str) - string.len(string.gsub(str , "\n" , ""))
	local label = CCLabelTTF:create(str , FONT , size )
	local label_size = label:getContentSize()
	local line_height = label_size.height

	if enter_num > 0 then
		line_height = CCLabelTTF:create("测" , FONT , size ):getContentSize().height
	end

	if label_size.width > total_width then			-- 大于一行
		line = math.ceil( label_size.width / total_width )
	end

	line = line + enter_num

	if line > 1 then
		label:setDimensions( CCSize:new( total_width , 0 ) )
	end

	label:setColor( color )
	label:setHorizontalAlignment( params.align or 0 )			-- 文字左对齐
	setAnchPos(label , x , y )
	
	return label, line
end
function formatMsg(str , replace)
	if not str then return "" end

	if type(replace) == "table" and table.nums(replace) > 0 then
		local nums = 0

		str = string.gsub(str , "#s#" , function()
			nums = nums + 1
			if replace[nums] ~= nil then
				local replace_type = type(replace[nums])
				if replace_type == "string" or replace_type == "number" then
					return replace[nums]
				else
					return ""
				end
			end

			return ""
		end)
	end

	local return_str = ""
	while true do
		local start_pos , end_pos , color = string.find(str , "%[color=(#[a-f0-9]+)%]")
		if start_pos == nil then break end
		local start_pos_2 , end_pos_2 = string.find(str , "%[/color%]" , end_pos)
		if start_pos_2 == nil then break end
		local first_str = string.sub(str , 0 , start_pos - 1)
		local second_str = string.sub(str , end_pos + 1 , start_pos_2 - 1)

		return_str = return_str .. first_str .. second_str
		str = string.sub(str , end_pos_2 + 1)
	end


	return return_str .. str
end

function replaceStr(str)
	local data = requires(IMG_PATH,"GameLuaScript/Config/tihuan")
	
	--没有替换内容
	if str == nil or data == nil or table.nums(data) == 0 then
		return str
	end
	
	local result = str
	for i = 1, table.nums(data) do
		result = string.gsub(result, data[i].name, data[i].rename)	
	end
	
	return result
end


function getTitle()
	return  {
		{10,"无"},
		{9,replaceStr("小有名气")},
		{8,replaceStr("青云直上")},
		{7,replaceStr("锋芒毕露")},
		{6,replaceStr("风华正茂")},
		{5,replaceStr("声名鹊起")},
		{4,replaceStr("名声显赫")},
		{3,replaceStr("中流砥柱")},
		{2,replaceStr("风云人物")},
		{1,replaceStr("威震九州")},
		{0,replaceStr("盖世英雄")},
	}
end

--微博分享功能
function shareGame(params)
--	local scene = display.getRunningScene()
	local data = requires(IMG_PATH,"GameLuaScript/Config/share")
	params = params or {}
	local msg = {
		["hero"] = data["penglai"] ,
		["lv_up"] = data["lvup"] 
	}
	
	local function tips(str, index1, index2)
		if callShare and CHANNEL_ID == "tmsj" then
			callShare(index1, index2, str)
		elseif __INNER_IOS_SDK_VER >= 3 and channel_delegate:getInst():wechatShare(index1,index2,str) then
		elseif LuaCallAppStore:getInstance().callWeChatShare and CHANNEL_ID == "tmsjIosAppStore" then --ios微信分享
			LuaCallAppStore:getInstance():callWeChatShare(index1,index2,str)
		else
			local url = CONFIG_HOST .. "/html.php?m=share&a=tencent_weibo&server_id=" .. DATA_Session:get("server_id") .. "&sid=" .. DATA_Session:get("sid") .. "&uid=" .. DATA_Session:get("uid") .. "&channel=" .. CHANNEL_ID .. "&channel_group=" .. CHANNEL_GROUP .. "&index1="..index1.."&index2="..index2
			KNMsg.getInstance():boxShow(string.sub(str, 1, string.find("@") - 1), {confirmFun = function()
				if device.platform == "android" or  device.platform == "wp8" then
					UpdataRes:getInstance():openUrl( url )
				elseif device.platform =="ios" then
	       			UpdateDataOC:getInstance():openUrl(url)
	       		end
			end, cancelFun = function()end})
		end
	end
	
	if params.type == "lv_up" then
		for k, v in pairs(msg["lv_up"]) do
			if DATA_User:get("lv") == k then
				tips(v.giftdesc.."@"..v.about.."@"..v.url, "lvup", k)
				break
			end
		end		
	elseif params.type == "hero" then
		tips(string.gsub(msg["hero"][4].giftdesc, "general", params.heroName).."@"..string.gsub(msg["hero"][4].about, "general", params.heroName).."@"..msg["hero"][4].url..params.heroId, "penglai", 4)
	end
	
end

function getShareGift(type, num)
	HTTP:call("share", "share", {index1 = type, index2 = num}, {
		success_callback = function(data, func)
			func(data)
		end
	})
end

function showTip(params)
	params = params or {}
	local priority = params.priority or -131
	
	local mask, layer
	
	--按钮背景的默认路径
	local tempPath = COMMONPATH
	local normal, pre = "btn_bg_red.png", "btn_bg_red_pre.png"
	
	layer = display.newLayer()	
	layer:ignoreAnchorPointForPosition(false)
	
	local bg = display.newSprite(params.bg or COMMONPATH.."tip_bg.png") 
	setAnchPos(bg)
	layer:addChild(bg)
	
	layer:setContentSize(bg:getContentSize())
--	setAnchPos(layer, 30, 400)
	setAnchPos(layer, 240, 425 + (params.offsetY or 0), 0.5, 0.5)
	
	--标题背景
	if params.title_bg then
		bg = display.newSprite(params.title_bg)
		setAnchPos(bg, 240 + (params.titleBgX or 0), layer:getContentSize().height - (params.titleOffsetY or 0) , 0.5 ,0.5)
		layer:addChild(bg)
	end
	
	--标题文字
	if params.title_text then
		bg = display.newSprite(params.title_text)
		setAnchPos(bg, layer:getContentSize().width / 2 + (params.titleTextX or 0), layer:getContentSize().height - (params.titleOffsetY or 0) + (params.titleTextY or 0), 0.5 ,0.5)
		layer:addChild(bg)
	end
	
	if params.content then
		if not params.cx and not params.cy then
			params.content:ignoreAnchorPointForPosition(false)
		end
		setAnchPos(params.content, params.cx or (layer:getContentSize().width / 2 + (params.contentOffsetX or 0)), params.cy or (layer:getContentSize().height / 2 + 50 + (params.contentOffsetY or 0)), 0.5, 0.5)
		layer:addChild(params.content)
	end
	
	local function removeFunc(removeCallback)
		layer:runAction(getSequenceAction(CCScaleTo:create(0.2, 0), CCCallFunc:create(function()
			mask:remove()
			if removeCallback then
				removeCallback()
			end
		end)))
	end
	
	local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
	local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
	
	--中部按钮
	if params.center then
		local btn = KNBtn:new(params.center.path or tempPath, {params.center.normal or normal, params.center.pre or pre}, layer:getContentSize().width / 2, 50 + (params.offsetY or 0), {
				priority = priority - 1,
				anchMid = true,
				front = params.center.front or (tempPath.."ok.png"),
				callback =  function()
					if params.center.remove then
						removeFunc(params.center.removeCallback)
					end
					if params.center.callback then
						params.center.callback()
					end
				end
			
			} )
		layer:addChild(btn:getLayer())
	end
	
	--左边按钮
	if params.left then
		local btn = KNBtn:new(params.left.path or tempPath, {params.left.normal or normal, params.left.pre or pre}, 20, 50 + (params.offsetY or 0), {
				priority = priority - 1,
				front = params.left.front or (tempPath.."ok.png"),
				callback = function()
					if params.left.remove then
						removeFunc(params.left.removeCallback)
					end
					if params.left.callback then
						params.left.callback()
					end
				end
		} )
		layer:addChild(btn:getLayer())
	end
	
	--右边按钮
	if params.right then
		local width = display.newSprite((params.right.path or tempPath)..(params.right.normal or normal)):getContentSize().width
		local btn = KNBtn:new(params.right.path or tempPath, {params.right.normal or normal, params.right.pre or pre}, layer:getContentSize().width - width - 20, 50 + (params.offsetY or 0), {
				priority = priority - 1,
				front = params.right.front or (tempPath.."cancel.png"),
				callback = function()
					if params.right.remove then
						removeFunc(params.right.removeCallback)
					end
					if params.right.callback then
						params.right.callback()
					end
				end
		} )
		layer:addChild(btn:getLayer())
	end
	
	--其它关闭按钮
	if params.close then
		local height = display.newSprite((params.close.path or tempPath)..params.close.normal):getContentSize().height
		local btn = KNBtn:new(params.close.path or tempPath, {params.close.normal, params.close.pre}, params.close.x or 20, params.close.y or layer:getContentSize().height - height - 5, {
				priority = priority - 1,
				front = params.close.front,
				callback = function()
					if params.close.noRemove then
					else
						removeFunc(params.close.removeCallback)
					end
					
					if params.close.callback then
						params.close.callback()
					end
				end
		} )
		layer:addChild(btn:getLayer())
	end
	
	
	mask = KNMask:new({item = layer, priority = params.priority})
	
	if not params.noAni then
		layer:setScale(0)
		layer:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.8, 1)))
	end
	
	--计时调用的方法
	if params.timeFunc then
		layer:runAction(getSequenceAction(CCDelayTime:create(params.timeFunc.delay), CCCallFunc:create(params.timeFunc.func)))
	end
	
	if params.parent then
		params.parent:addChild(mask:getLayer(), 10)
	else
		display.getRunningScene():addChild(mask:getLayer())
	end
	
	return mask
--	mask:getLayer():setScale(0)
--	mask:getLayer():runAction(CCScaleTo:create(0.5 , 1))
end


function print_log(data)
		local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
		
		local str 
		if device.platform == "android" then
			str = WRITE_PATH .."log.txt" 
		elseif device.platform == "windows" then
			str = "c:\\log.txt"
		else
			return
		end
		
		local temp = {}
		local content =  io.readfile(str)
		if content then
			temp = json.decode(content)
		end
		table.insert(temp, data)
		
		io.writefile(str, json.encode(temp))
end

function heartBeatCtl(stop, key)
	-- 心跳包
		CCLuaLog("create heart beat")
		local times = 0
		local heartbeat_function = function()
			times = times + 1
			if times >= 30 then
				local cur_scene = display.getRunningScene()
				if cur_scene.name == "battle" then return end

				if key == "new" then
					SOCKET:getInstance("swar"):send("user", "heartbeat", 1003, {}, {
						no_mask = true,
						no_loading = true,
					})
				else
					SOCKET:getInstance("battle"):call("heartbeat" , "go" , "heartbeat" , {} , {
						no_mask = true,
						no_loading = true,
						error_callback = function(data)
							print("heartbeat failed")
						end
					})
	
				end
				times = 0
			end
		end

		if stop then
			Clock:removeTimeFun("heartbeat")
		else
			if not Clock:getKeyIsExist("heartbeat") then
				times = 30
				Clock:addTimeFun( "heartbeat" , heartbeat_function )
			end
		end 
end

function getHeadPath(sex, game)
	if sex == nil then
		return "sex1.jpg"
	else
		sex = tonumber(sex)
		if game then --神战使用
			return "other/"..game.."/head/"..sex..".jpg"
		else
			return sex > 2 and "head/".. sex .. ".jpg" or "sex"..sex..".jpg"
		end
	end
end

--过万数字转换
function numChange( value )
	value = tonumber( value )
	return ( value > 10000 and math.floor(value / 10000) .. "万" or value )
end

--检查是否超过30级
function checkIsOver30(  )
	if KNFileManager.readfile("savefile.txt" , "isOver30" , "=") == "0" then
		KNMsg.getInstance():flashShow("未达到30级,本功能暂不开放")
		return 0
	else
		--KNMsg.getInstance():flashShow("已达到30级")
		return 1
	end
end 
--检查是否存在30级资源
function checkIsExsitRes30(  )
	if KNFileManager.readfile("savefile.txt" , "isExsitRes30" , "=") == "0" then
		KNMsg.getInstance():flashShow("未有30级资源,请更新后进入")
		return 0
	else
		--KNMsg.getInstance():flashShow("有30级资源")
		return 1
	end
end 



--创建动画
function createAnimation(format,delay,begin)
    begin = begin or 0
    local ret
    local maxFrame = 50
    for i=begin,maxFrame do
        local frame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(string.format(format,i))
        if not frame then
            break
        end
        if not ret then
            ret = CCAnimation:create()
        end
        ret:addSpriteFrame(frame)
    end
    if ret then
        ret:setDelayPerUnit(delay)
    end
    return ret
end

--shake震动
function shakeNode(node, time, level, origin)
	local origin = origin or ccp(0, 0)
	local actions = CCArray:create()
	for i=1,9 do
		actions:addObject(CCMoveTo:create(time/10, ccpAdd(origin, ccp(math.random(-5, 5)*level, math.random(-5, 5)*level))))
	end
	actions:addObject(CCMoveTo:create(time/10, origin))
	node:runAction(CCSequence:create(actions))
end

--震动2
function shakeNode2(node, space)
	local origin = ccp(node:getPosition())
	node:runs({
		-- CCPlace:create(ccpAdd(origin, ccp(-40, -80))),
		-- CCDelayTime:create(space),
		CCRotateTo:create(0, 5-360),
		CCPlace:create(ccpAdd(origin, ccp(-10, -25))),
		CCDelayTime:create(space),
		CCPlace:create(ccpAdd(origin, ccp(5, -15))),
		-- CCDelayTime:create(space),
		CCRotateTo:create(0, 2.5),
		-- CCPlace:create(ccpAdd(origin, ccp(-20, -10))),
		CCDelayTime:create(space),
		CCPlace:create(origin),
		CCRotateTo:create(0, 5),
		CCDelayTime:create(space),
		CCPlace:create(ccpAdd(origin, ccp(15, 15))),
		CCDelayTime:create(space),
		CCRotateTo:create(0, 0),
		CCPlace:create(origin),
	})
end
