--带光标输入文本框
local M = {}

function M:new( params )
	local this = {}
	setmetatable(this , self)
	self.__index = self
	params = params or {}
	
	this.width = params.width or 100		--文字框宽度
	this.height = params.height or 22		--文本框高度
	this.size = params.size or 20			--文字大小
	this.defStr = params.defStr or ""		--默认提醒字符串
	this.textstr = params.existStr or ""	--已经存在的字符(主要在用在帐号输入的地方，如果帐号已经存在，就将字符存起来)
	this.normalBg = params.normalBg or ""
	this.priority = params.priority or -129
	
	local defColor = params.defColor or ccc3( 0xff , 0xfb , 0xd4 )
	local inputColor = params.inputColor or ccc3( 0x4d , 0x15 , 0x15 )
				
	this.layer = display.newLayer()
	
	local windowlayer
	local s
	-- 输入框
	s = CCScale9Sprite:create(this.normalBg)
	this.textfield = CCEditBox:create(CCSizeMake( this.width , this.height) , s) --CCTextFieldTTF:textFieldWithPlaceHolder( this.defStr , FONT , this.size )
	this.textfield:setText( this.textstr )
	setAnchPos(this.textfield , 0 , 0 , 0 , 0)
	this.textfield:setColor( defColor )
	this.textfield:setFontSize(this.size)
	this.textfield:setPlaceholderFontColor( inputColor )
	this.textfield:setPlaceHolder(this.defStr)
	
	windowlayer = WindowLayer:createWindow()
	windowlayer:setAnchorPoint( ccp( 0 , 0.5 ) )
	windowlayer:setContentSize( CCSizeMake( this.width , this.height + 8 ) )
	windowlayer:addChild( this.textfield )
	if device.platform == "wp8" then
		windowlayer:setPosition(windowlayer:getPositionX(), windowlayer:getPositionY() - 11)
	end
	this.layer:addChild( windowlayer )
	
	this.textfield:setTouchPriority(this.priority)
	
	return this
end

function M:getLayer()
	return self.layer
end

function M:startInput()
	--self.textfield:visit()
end

function M:stopInput( isClear )
		
end

function M:getString()
	return self.textfield:getText()
end

function M:setString( _str )
	self.textfield:setText( _str )
end
--返回文字个数
function M:getCharCount()
	return 10 --self.textfield:getCharCount()
end

function M:attachWithIME()
end

function M:detachWithIME()
end

return M