local effect = {}

function effect.load(path, id)
	path = string.sub(path,0,string.len(path) - 1)
	path = path .."/" ..id
	display.addSpriteFramesWithFile(path ..".plist", path ..".png")
end

function effect.clear(path, id)
	path = string.sub(path,0,string.len(path) - 1)
	path = path .."/" ..id
	display.removeSpriteFramesWithFile(path ..".plist", path ..".png")
end

--[[
用例:
	local layer = display.newLayer()
	local effect = requires("", "GameLuaScript/Common/KNEffect")
	effect.get("image/", "mission", true, function()
		print("特效播放结束回调")
	end):addTo(layer)

参数
--path: 路径
--id: 特效id
--noForever: 是否不循环
--callback: 特效播放结束回调
]]

function effect.get(path, id, noForever, callback, delay)
	effect.load(path, id)
	local filename = "#" ..id .."/1.png"
	local sprite = display.newSprite(filename)
	if not sprite then
		return nil
	end
	local action = createAnimation(id .."/%d.png", delay or .06, 1)
	local dur = action:getDuration()
	if not noForever then--循环
		sprite:runAction(CCRepeatForever:create(CCAnimate:create(action)))
	else--不循环
		local actionEnd = function()
			sprite:removeSelf()
			if callback then callback() end
		end
		sprite:runAction( CCSequence:createWithTwoActions( CCAnimate:create(action), CCCallFunc:create(actionEnd) ) )
		-- sprite:runs({CCAnimate:create(action), CCCallFunc:create(actionEnd)})
	end
	return sprite,dur
end

return effect