local KNProgress = {
	layer,
	params,
	progress,
	percent,
	text
}

function KNProgress:new(dir, res, x, y, params)
	local this = {} 
	setmetatable(this,self)
	self.__index = self
	
	this.params = params or {}
	this.layer = display.newLayer()
	
	local res = res or {}
	
	this.progress = CCProgressTimer:create(display.newSprite(dir..res[2]))
	setAnchPos(this.progress)
	
	if res[1] then
		local bg = display.newSprite(dir..res[1])
		setAnchPos(bg)
		this.layer:addChild(bg)
		
		this.layer:setContentSize(bg:getContentSize())
		
		bg:setScaleX(this.params.scaleX or 1)
		bg:setScaleY(this.params.scaleY or 1)
	else
		this.layer:setContentSize(this.progress:getContentSize())
	end
	
	setAnchPos(this.layer, x, y)
	
	this.progress:setScaleX(this.params.scaleX or 1)
	this.progress:setScaleY(this.params.scaleY or 1)
	
	
	this.percent  = this.params.percent or (this.params.cur / this.params.max * 100)
	local percent = this.percent
	if this.params.forcePercent then
		if this.percent > 0 and this.percent < 20 then
			percent = 20
		end
	end
	
	
	--进度条的属性设置
	this.progress:setType(kCCProgressTimerTypeBar)           --类型，kCCProgressTimerTypeBar 横向，kCCProgressTimerRidial 圆
	this.progress:setMidpoint(ccp(0, 0))                     --进度方向
	this.progress:setBarChangeRate(ccp(1,0))                 --对应方向上是否进行设置
	this.progress:setPercentage(percent)                           --进度0--100
	this.layer:addChild(this.progress)
	
	if this.params.showText then
		this.text = createLabel({str = this.params.cur.."/"..this.params.max, size = 16, color = this.params.color or ccc3(0x2c, 0, 0), width = 400})
		setAnchPos(this.text, this.layer:getContentSize().width / 2, this.layer:getContentSize().height / 2,0.5, 0.5)
		this.layer:addChild(this.text)
	end
	
	if this.params["leftIcon"] then
		local icon = display.newSprite(dir..this.params["leftIcon"][1])
		setAnchPos(icon,this.params["leftIcon"][2] , this.params["leftIcon"][3], 1, 0.5)
		this.layer:addChild(icon)
		icon:setScale(this.params.iconScale or 1)
		
		
		
		if this.params["leftIcon"][4] then
			local append = createLabel({str = this.params["leftIcon"][4], color = ccc3(255,255,255), size = 18})
			setAnchPos(append,this.params["leftIcon"][2] - icon:getContentSize().width * this.params.iconScale / 2 , this.params["leftIcon"][3], 0.5, 0.5)
			this.layer:addChild(append, 1)	
		end
	end
	
	return this
end

function KNProgress:getCur()
	return self.percent
end

function KNProgress:getLayer()
	return self.layer
end



return  KNProgress