--[[

通用数据存储

]]

--[[包含所有 DATA]]
local _datas = {
	"Session",
	"User",
	"Chat",
	"Account",
	"General",
	"Formation",
	"Battle",
	"Power",
	"Energy",
	"Mission",
	"Instance",
	"Wash",
	"Bag",
	"Pet",
	"Equip",
	-- "UpdataData",
	"Hatch",
	"Shop",
	"RoleSkillEquip",
	"Result",
	"PetSkillDress",
	"Martial",
	"PetSkillDress",
	"Pulse",
	"Uplevel",
	"StoneList",
	"ExpConfig",
	"Uplevel",
	"IdType",
	"Rank",
	"Info",
	"Olgift",
	"Guide",
	"OtherPlay",
	"Incubation",
	"pulseTisp",
	"Activity",
	"Notice",
	"Gang",
	"Vip",
	"Friend",
	"Task",
	"Head",
	"HeadLine",
	"Dragon",
	"GodCell",
	"NewDailyTask",
	"SoulTemple",
}

for i = 1 , #_datas do
	requires(IMG_PATH , "GameLuaScript/Data/" .. _datas[i])
end


local M = {}

--[[初始化]]
function M.init()
	for i = 1 , #_datas do
		requires(IMG_PATH , "GameLuaScript/Data/" .. _datas[i]):init()
	end
end

--[[处理公用数据]]
function M.saveCommonData( data )
	local result = data["result"]
	if type(result) ~= "table" then return false end
	--dump(result["_G_general_stage_conf"])
	-- 存储数据
	if isset(result , "_G_userinfo")           then DATA_User:set( result["_G_userinfo"] )                                end
	if isset(result , "_G_account")            then DATA_Account:set( result["_G_account"] )                              end
	if isset(result , "_G_lingyuan")           then DATA_Account:setType( "lingyuan" , result["_G_lingyuan"] )            end	--灵源值
	if isset(result , "_G_shop_valuable_card") then DATA_Info:set_type( "valuable_card_conf" , result["_G_shop_valuable_card"] )            end	--灵源值
	if isset(result , "_G_qy")           	   then DATA_GodCell:setType( "qiyun" , result["_G_qy"] )            		  end	--气运值
	if isset(result , "_G_sg")           	   then DATA_GodCell:setType( "shenge" , result["_G_sg"] )            		  end	--神格碎片
	if isset(result , "_G_lingyuan")           then DATA_GodCell:setType( "lingyuan" , result["_G_lingyuan"] )           end	--灵源值
	if isset(result , "_G_first_pay")           then DATA_GodCell:setType( "first_pay" , result["_G_first_pay"] )           end	--是否首充
	if isset(result , "_G_power")              then DATA_Power:set( result["_G_power"] )                                  end
	if isset(result , "_G_energy")             then DATA_Energy:set( result["_G_energy"] )                                end
	if isset(result , "_G_formation")          then DATA_Formation:set(result["_G_formation"])                            end
	if isset(result , "_G_formation_conf")     then DATA_Formation:setConf(result["_G_formation_conf"])                   end
	if isset(result , "_G_bag_equip")          then DATA_Bag:set("equip",result["_G_bag_equip"])                          end
	if isset(result , "_G_bag_skill")          then DATA_Bag:set("skill",result["_G_bag_skill"])                          end
	if isset(result , "_G_bag_pet")            then DATA_Bag:set("pet",result["_G_bag_pet"])                              end
	if isset(result , "_G_bag_prop")           then DATA_Bag:set("prop",result["_G_bag_prop"])                            end
	if isset(result , "_G_bag_general")        then DATA_Bag:set("general",result["_G_bag_general"])                      end
	if isset(result , "_G_bag_qlprop")         then DATA_Bag:set("qlprop",result["_G_bag_qlprop"])                        end 
	if isset(result , "_G_equip_inlay")        then DATA_Bag:set("inlay",result["_G_equip_inlay"])                        end --装备镶嵌数据
	if isset(result , "_G_pet_on")             then DATA_Pet:setFighting(result["_G_pet_on"])                             end
	if isset(result , "_G_general_dress")      then DATA_ROLE_SKILL_EQUIP:set(result["_G_general_dress"])                 end
	if isset(result , "_G_pet_dress")          then DATA_PetSkillDress:set(result["_G_pet_dress"])                        end
	if isset(result , "_G_martial")            then DATA_Martial:set(result["_G_martial"])                                end
	if isset(result , "_U_bag")                then updateBagInfo("_U_bag",result["_U_bag"])                              end
	if isset(result , "_D_bag")                then updateBagInfo("_D_bag",result["_D_bag"])                              end
	if isset(result , "_G_id_type")            then DATA_IDTYPE:set(result["_G_id_type"])                     				end
	if isset(result , "_G_ranking_level")      then DATA_Rank:setKey("level",result["_G_ranking_level"]) end
	if isset(result , "_G_ranking_athletics")  then DATA_Rank:setKey("athletics",result["_G_ranking_athletics"]) end
	if isset(result , "_G_ranking_ability")    then DATA_Rank:setKey("ability",result["_G_ranking_ability"]) end
	if isset(result , "_G_message_talk")       then DATA_Info:set_type("_G_message_talk",result["_G_message_talk"]) end
	if isset(result , "_G_message_system")     then DATA_Info:set_type("_G_message_system",result["_G_message_system"]) end
	if isset(result , "_G_message_battle")     then DATA_Info:set_type("_G_message_battle",result["_G_message_battle"]) end
	if isset(result , "_G_message_broadcast")  then DATA_Info:set_type("_G_message_broadcast",result["_G_message_broadcast"]) end
	if isset(result , "_G_online_award")  	   then DATA_Info:set_type("_G_online_award",result["_G_online_award"]) end   --在线奖励数据
	if isset(result , "_G_olgift")             then DATA_Olgift:set_type("olgift" , result["_G_olgift"] ) end
	if isset(result , "_G_fame")               then DATA_User:set_fame( result["_G_fame"] ) end
	if isset(result , "_G_wash_max_percent")   then DATA_User:set_percent( result["_G_wash_max_percent"] ) end
	if isset(result , "_G_mission_cur")        then DATA_Guide:setStep( result["_G_mission_cur"] ) end
	if isset(result , "_G_hatch_fee")          then DATA_Incubation:set( result["_G_hatch_fee"] ) end
	if isset(result , "_G_pulse_conf")         then DATA_PulseTisp:set( result["_G_pulse_conf"] ) end
	if isset(result , "_G_skillexpback")       then DATA_Bag:set_skillexp(result["_G_skillexpback"]) end
	if isset(result , "_T_updatetip")      	   then DATA_Notice:set(result["_T_updatetip"]) end
	if isset(result , "_G_loginaward_tip")     then DATA_Notice:setGetNum( result["_G_loginaward_tip"] ) end	--设置当前可领取奖励个数
	if isset(result , "_G_msgcount")      	   then DATA_Chat:initNum(result["_G_msgcount"]) end
	if isset(result , "_G_viplv")			   then DATA_Vip:set_type( "viplv" , result["_G_viplv"] ) end		--只有一个vip等级
	if isset(result , "_G_vipinfo")			   then DATA_Vip:set_type( "vipinfo" , result["_G_vipinfo"] ) end		--只有一个vip等级
	if isset(result , "_G_bangzhanrank")	   then DATA_User:setGangRank( result["_G_bangzhanrank"] ) end		--帮派帮战中排名
	if isset(result , "_G_absolute")	   	   then DATA_User:setAtkFactor( result["_G_absolute"] ) end		--帮派帮战中宠物攻击系数
	if isset(result , "_G_headinfo")	   	   then DATA_Head:set( result["_G_headinfo"] ) 	end				--头像数据
	if isset(result , "_G_goldequipexp")	   then GOLDEQUIP_EXP = result["_G_goldequipexp"] end			--黄金装备吞噬经验
	if isset(result , "_T_headlines")	  	   then DATA_HeadLine:set( result["_T_headlines"] ) end			--今日头条数据
	if isset(result , "_G_dragon_state")	   then DATA_Dragon:set( result["_G_dragon_state"] ) end		--龙脉数据
	if isset(result , "_G_coin")	   		   then G_coin = result["_G_coin"] end		--龙脉数据
	if isset(result , "_G_shenzhan_top")	   then TOP_THREE = result["_G_shenzhan_top"] end	--最强三人	
	if isset(result , "_G_shenzhan_next")	   then SHENZHAN_NEXT = result["_G_shenzhan_next"] end	--最强三人	
	if isset(result , "_G_silvercard")	       then G_SILVERCARD = result["_G_silvercard"] end	--最强三人	
	if isset(result , "_G_expcard")	           then G_EXPCARD = result["_G_expcard"] end	--最强三人	
	if isset(result , "_T_alliance_name")	   then _T_alliance_name = result["_T_alliance_name"] end	--帮派名称
	if isset(result , "_G_new_year_skin")	   then G_new_year_skin = result["_G_new_year_skin"] end	--是否启用新年皮肤
	if isset(result , "_G_zhenfa_equip")	   then G_zhenfa_equip = result["_G_zhenfa_equip"] end	    --上阵装备是否装备
	if isset(result , "_G_road_to_god")	  	   then G_road_to_god = result["_G_road_to_god"] end	    --战神之路
	if isset(result , "_G_seven_days_reward")  then G_seven_days_reward = result["_G_seven_days_reward"] end	    --七日豪礼
	if isset(result , "_T_lvup")			   then 
		--主角等级升到20级的时候会在进入首页的时候显示 威望开放的功能 
		if tonumber(result["_T_lvup"]["lv"]) == 20 then   
			 DATA_Info:set_type("isShowWeiWangInfoLayer" , true)
		end
	end
	if isset(result , "_G_newdailytask")	   then DATA_NewDailyTask:set( result["_G_newdailytask"] ) 		end	
	if isset(result , "empire_info")	   	   then DATA_SoulTemple:set("info" , result["empire_info"])  end	--魂殿的数据	

	if isset(result , "_G_jzsj_config")	   	   then DATA_Info:set_type("jzsj_config" , result["_G_jzsj_config"])   end	--专属金装配置表
	if isset(result , "_G_wxsj_config")	   	   then DATA_Info:set_type("wxsj_config" , result["_G_wxsj_config"])   end	--专属金装配置表
	if isset(result , "_G_zhenfa")	   	  	   then DATA_Info:set_type("zhenfa" , result["_G_zhenfa"]) end	--阵法英雄

	if isset(result , "_G_zhanchang")		   then DATA_Info:set_type("pvp_open_module" , result["_G_zhanchang"]) end	--战场开发模块
	if isset(result , "_G_godwarOpenTime")		then DATA_Info:set_type("godwarOpenTime" , result["_G_godwarOpenTime"]) end	--战场开发模块

	if isset(result , "_G_friend_msgcount")		then DATA_Info:set_type("friend_msgcount" , result["_G_friend_msgcount"]) end	--战场开发模块

	return true
end


return M
