--[[

所有 socket 通信发送前以及回调

]]


local M = {}

--[[验证]]
function M.verify_check( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
		if __INNER_VERSION__ then
			data["inner_v"] = __INNER_VERSION__
		end

		if CHANNEL_SERVER then
			data["channel_server"] = CHANNEL_SERVER
		end
	elseif type == 2 then
		-- 回调处理
		local result = data["result"]
		
		local session_data = result["session"]

		-- 存储数据!~
		if session_data ~= nil then
			DATA_Session:set({ uid = session_data["uid"] , sid = session_data["sid"] , server_id = session_data["server_id"] })
		end

		if result["IN_COMPANY"] then
			IN_COMPANY = true
		end

		-- 版号特殊手机
		IN_BANHAO = nil
		if result["IN_BANHAO"] then
			IN_BANHAO = true
		end

		-- 执行成功回调
		callback(data)

		switchScene("servers" , result)
	end

	return true , data
end

--[[登录]]
function M.login_develop( type , data , callback )
	--dump(data)
	if type == 1 then
		-- 发送前数据处理
		if __INNER_VERSION__ then
			data["inner_v"] = __INNER_VERSION__
		end
		
		if CHANNEL_GROUP == "dhsh" or  CHANNEL_GROUP == "qosh" or  CHANNEL_GROUP == "tmsj" or  CHANNEL_GROUP == "jstf" then
			if __INNER_JIAMI__ ~= nil then
				data["inner_jiami"] = __INNER_JIAMI__
			else
				data["inner_jiami"] = 0
			end
		else
			data["inner_jiami"] = 1
		end
	elseif type == 2 then
		-- 回调处理
		local result = data["result"]

		local session_data = result["session"]

		-- 存储数据!~
		if session_data ~= nil then
			DATA_Session:set({ uid = session_data["uid"] , sid = session_data["sid"] , server_id = session_data["server_id"] })
		end

		-- 执行成功回调
		callback(data)

		-- 判断是否是新号
		if isset(result , "new_open_id") then
			-- 跳转到注册页面
			if CHANNEL_GROUP == "tmsj" or  CHANNEL_GROUP == "xmws" or CHANNEL_GROUP == "td" or CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
				switchScene("theworld",{open_id = result["open_id"]})
			else
				switchScene("newguy" , {open_id = result["open_id"]})
			end
	
		else
			-- 登录成功后，尝试连接长连接服务器
			SOCKET:getInstance("battle"):call("log" , "in" , "login" , {} , {
				success_callback = function()
--					 KNGuide:setStep( 10001 )	-- 新手引导
					-- 登录成功后，跳转到首页
					switchScene("home" , { isFirst = true })
				end
			})
		end
	end

	return true , data
end

--[[登录]]
function M.login_quick( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		return M.login_develop( type , data , callback )
	end

	return true , data
end

--[[注册]]
function M.login_reg( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		local result = data["result"]

		
		-- 登录成功后，尝试连接长连接服务器
		SOCKET:getInstance("battle"):call("log" , "in" , "login" , {} , {
			success_callback = function()
				KNGuide:setStep( 100 )	-- 新手引导
				
				----------------------------------
				if CHANNEL_ID == "hyylt" or CHANNEL_ID == "hy.leteng" then
					DirectChannel.instance():call(
					{
						action = "stat",
						serverId = DATA_Session:get("server_id"),
						roleName = DATA_User:get("name"),
						roleId = DATA_Session:get("uid"),
					})
				end
				----------------------------------

				-- 登录成功后，跳转到首页
				switchScene("home" , { isFirst = true , new_guy = true  })
			end
		})

		-- 执行成功回调
		callback(data)
	end

	return true , data
end


--[[wap]]
function M.wap_getid( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		switchScene("wapid")
	end

	return true , data
end


function M.wap_set( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		switchScene("home" , {} , function()
			KNMsg:getInstance():flashShow("保存wap游戏id成功")
		end)
	end

	return true , data
end

--[[发送世界聊天]]
function M.chat_sendworld( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		if callback ~= nil then
			callback(data)
		end
	end
	return true , data
end

function M.mission_get( type , data , callback )
	if type == 1 then
	else
		local result = data["result"]
		DATA_Mission:set(result["current"]["map_id"],result)
		DATA_Mission:setByKey("rank", data["result"]["ranking"])
		callback()
	end
	return true , data
end

function M.mission_cleanup_start(type, data, callback)
	if type == 1 then
	else
		DATA_Mission:setByKey("cleanup", data["result"]["cleanup"])
		callback()
	end
	return true, data
end

function M.mission_cleanup_cancel(type, data, callback)
	if type == 1 then
	else
		DATA_Mission:setByKey("cleanup", {})
		callback()
	end
	return true, data
end

function M.mission_cleanup_subtime(type, data, callback)
	if type == 1 then
	else
		DATA_Mission:setByKey("cleanup",data["result"]["cleanup"])
		callback()
	end
	return true, data
end

function M.mission_cleanup(type, data, callback)
	if type == 1 then
	else
		local result = data["result"]
		dump(result)
		DATA_Mission:setData(result["current"]["map_id"], "missions", result["current"]["mission_id"], result["missions"][1])
		DATA_Mission:setByKey("cleanup", {})
		DATA_Result:set( result )
		callback(result["current"]["map_id"])
	end
	return true, data
end

function M.inshero_get(type , data , callback)
	if type == 1 then
	else
		DATA_Instance:set("hero",data["result"])
		callback()
	end
	return true , data
end


function M.insheronewnew_get(type , data , callback)
	if type == 1 then
	else
		DATA_Instance:set("hero",data["result"])
		callback()
	end
	return true , data
end

--抽签
function M.insheronewnew_draw(type , data , callback)
	if type == 1 then
	else
		DATA_Instance:set("hero",data["result"]["get"])
		callback()
	end
	return true , data
end

--兑换英雄
function M.insheronewnew_exchange(type , data , callback)
	if type == 1 then
	else
		DATA_Instance:set("hero",data["result"]["get"])
		callback(data["result"]["awards"]["drop"][1])
	end
	return true , data
end

--更改签面
function M.insheronewnew_alter(type , data , callback)
	if type == 1 then
	else
		DATA_Instance:set("hero",data["result"]["get"])
		callback()
	end
	return true , data
end

function M.inshero_refresh(type , data , callback)
	if type == 1 then
	else
		DATA_Instance:set("hero","current_award", data["result"]["current_award"])
		callback()
	end
	return true , data
end


function M.inspet_refresh(type , data , callback)
	if type == 1 then
	else
		DATA_Instance:set("pet","current_award", data["result"]["current_award"])
		callback()
	end
	return true , data
end

function M.inspetnew_get(type , data , callback)
	if type == 1 then
	
	else
		DATA_Instance:set("pet","instance",data["result"]["instance"])
--		DATA_Instance:set("pet","message", data["result"]["message"])
		callback()
	end
	return true , data
end

function M.inspetnew_finish(type , data , callback)
	if type == 1 then
	
	else
		DATA_Instance:set("pet", "instance",data["result"]["get"]["instance"])
		for k, v in pairs(data["result"]["message"]) do
			if string.find(k, "last") then
				DATA_Instance:setPetFb("message", k, v)
			else
				DATA_Instance:addPetArray("message", k, v)	
			end
		end
		
		local isNil = false
		if ( not data["result"]["awards"] )   then
			isNil = true 
		end
		callback( isNil )
	end
	return true , data
end

function M.insequip_get(type , data , callback)
	if type == 1 then
	else
		for k, v in pairs(data["result"]) do
			if k ~= "instance" then
				DATA_Instance:set("equip", k, v)
			else
				DATA_Instance:set("equip", tonumber(data["result"]["current_map"]), v)
			end
		end
		callback(data["result"])
	end
	return true , data
end


function M.insequip_dig(type, data, callback)
	if type == 1 then
	else
		local result = data["result"]
		DATA_Instance:set("equip", result["map_id"],25, result["boss_data"])
		callback(result["awards"])
	end
	return true, data
end

function M.insequip_openbox(type, data, callback)
	if type == 1 then
	else
		for k, v in pairs(data["result"]["get"]) do
			if k ~= "instance" then
				DATA_Instance:set("equip", k, v)
			else
				DATA_Instance:set("equip", data["result"]["get"]["current_map"], v)
			end
		end
		callback(data["result"]["awards"])
	end
	return true, data
end


function M.insequip_useshu(type, data, callback)
	if type == 1 then
	else
		DATA_Instance:set("equip", "point", data["result"]["get"]["point"])
		callback()
	end
	return true, data
end

function M.insskill_get(type, data, callback)
	if type == 1 then
	else
		DATA_Instance:set("skill",data["result"])
		callback()
	end
	return true, data
end

function M.insskill_buypoint(type, data, callback)
	if type == 1 then
	else
		DATA_Instance:set("skill",data["result"]["get"])
		callback()
	end
	return true, data
end


function M.insskill_refresh(type, data, callback)
	if type == 1 then
	else
		DATA_Instance:set("skill",data["result"]["get"])
		callback()
	end
	return true, data
end


function M.insskill_roll(type, data, callback)
	if type == 1 then
	else
		DATA_Instance:set("skill",data["result"]["get"])
		callback(data["result"])
	end
	return true, data
end

function M.formation_get(type , data , callback)
	if type == 1 then

	else
		local result = data["result"]

		DATA_Formation:set(result)
		callback()
	end
	return true , data
end


function M.wash_get(type , data , callback)
	if type == 1 then

	else
			local result = data["result"]
			DATA_Wash:set(result)
			callback()
	end
	return true,data
end

function M.wash_wash(type , data , callback)
	if type == 1 then

	else
		local result = data["result"]
		DATA_Wash:set(result)
		callback()
	end
	return true,data
end

--武将传功
function M.general_transmission(type, data, callback)
	if type == 1 then
	else
		callback(data)
	end
	return true, data
end

--孵化状态
function M.pet_get_hatch(type, data, callback)
	if type == 1 then
	else
		DATA_Hatch:set(data["result"])
		callback()
	end
	return true, data
end

--取消孵化
function M.pet_cancel_hatch(type, data, callback)
	if type == 1 then
	else
		DATA_Hatch:upData(data["result"]["incubator"])
	
		callback()
	end
	return true, data
end

--孵化完成
function M.pet_hatch_complete(type, data, callback)
	if type == 1 then
	else
		DATA_Hatch:upData(data["result"]["incubator"])
	
		callback( data )
	end
	return true, data
end
--孵化完成(一键收取)
function M.pet_onekey_complete(type, data, callback)
	if type == 1 then
	else
		DATA_Hatch:upData(data["result"]["incubator"])
	
		callback( data )
	end
	return true, data
end
--孵化加速
function M.pet_hatch_acce(type, data, callback)
	if type == 1 then
		
	else
		DATA_Hatch:upData(data["result"]["incubator"])
		callback()
	end
	return true, data
end

--开启孵化位
function M.pet_add_hatch(type, data, callback)
	if type == 1 then
	else
		DATA_Hatch:upData(data["result"]["incubator"])
		callback()
	end
	return true, data
end
--开始孵化
function M.pet_set_hatch(type, data, callback)
	if type == 1 then
	else
		DATA_Hatch:upData(data["result"]["incubator"])
	
		callback()
	end
	return true, data
end

function M.pet_merge(type,data,callback)
	if type == 1 then
	else
		callback(data)
	end
	return true,data
end


function M.shop_get(type, data, callback)
	if type == 1 then
	else
		DATA_Shop:set(data["result"])
		callback(data)
	end
	return true, data
end

function M.shop_buy(type, data, callback)
	if type == 1 then
	else
		callback(data)
	end
	return true, data
end

--黄金装备合成
function M.equip_newgoldequip(type, data, callback)
	if type == 1 then
	else
		callback(data["result"] , M.inform)
	end
	return true, data
end

function M.equip_get(type, data, callback)
	if type == 1 then
	else
--		DATA_Equip:insert(data["result"]["equip"])
		callback(data)
	end
	return true, data
end
--英雄换装
function M.equip_dress(type, data, callback)
	if type == 1 then
	else
		DATA_ROLE_SKILL_EQUIP:set(data["result"]["_G_general_dress"])
		callback(data)
	end
	return true, data
end
--英雄换技能
function M.skill_dress(type, data, callback)
	if type == 1 then
	else
		DATA_ROLE_SKILL_EQUIP:set(data["result"]["_G_general_dress"])
		callback(data)
	end
	return true, data
end
--英雄换技能
function M.skill_petskill_dress_new(type, data, callback)
	if type == 1 then
	else
--		DATA_ROLE_SKILL_EQUIP:set(data["result"]["_G_general_dress"])
		callback(data)
	end
	return true, data
end
--技能合成
function M.skill_merge(type, data, callback)
	if type == 1 then
	else
		callback(data)
	end
	return true, data
end

function M.skill_exchange(type, data, callback)
	if type == 1 then
	else
		callback(data)
	end
	return true, data
end


function M.bag_get(type, data, callback)
	if type == 1 then
	else
		DATA_Bag:set(data["result"]["type"],data["result"]["data"])
		callback()
	end

	return true, data
end


function M.user_set_chenghao(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["chenghao"])
	end
	return true, data
end
		



function M.bag_sell(type, data, callback)
	if  type == 1 then
	else
		callback(data)
	end	
	return true, data
end

function M.bag_usehonor(type, data, callback)
	if type == 1 then
	else
		callback(data["result"], M.inform)
	end
	return true, data
end

function M.bag_uselingyuan(type, data, callback)
	if type == 1 then
	else
		callback(data["result"], M.inform)
	end
	return true, data
end

function M.equip_equipup(type, data, callback)
	if type == 1 then
	else
		callback(data)
	end
	return true, data
end


function M.general_martial(type, data, callback)
	if type == 1 then
	else
		callback(data)
	end
	return true, data
end

function M.pulse_get(type, data, callback)
	if type == 1 then
	else
		DATA_Pulse:set(data)
		callback(data)
	end
	return true, data
end

function M.pulse_initial(type, data, callback)
	if type == 1 then
	else
		DATA_Pulse:set(data)
		callback(data)
	end
	return true, data
end

function M.pulse_feed(type, data, callback)
	if type == 1 then
	else
		DATA_Pulse:set(data)
		callback()
	end
	return true, data
end

function M.pulse_dig(type, data, callback)

	if type == 1 then

	else
		DATA_Pulse:set(data)
		callback()
		
	end

	return true, data
end


function M.status_get(type, data, callback)
	if type == 1 then
	else
		callback({rank = data["result"]["athletics_rank"], ability = data["result"]["ability"] , gang = data["result"]["alliance"] , emperor = data["result"]["emperor"], chenghao = data["result"]["chenghao"], pve_ability = data["result"]["pve_ability"],pvp_ability = data["result"]["pvp_ability"]  })
	end
	return true, data
end

function M.status_eat(type, data, callback)
	if type == 1 then
	else
		callback(data)
	end
	return true, data
end

--[[邮件领取]]
function M.message_recv_mail(type, data, callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		local tempData = DATA_Info:get_type( "_G_message_mail" )
		for key , v in pairs( tempData ) do
			if data.result.mail_msg and ( v.id == data.result.mail_msg.id ) then 
				tempData[key] = data.result.mail_msg
				break
			end
		end
		DATA_Info:set_type( "_G_message_mail" , tempData )
		callback( data.result.mail_msg )
	end
	return true, data
end


function M.message_get(type, data, callback)
	if type == 1 then
	else
		if data and data["result"] then 
			for k,v in pairs(data["result"]) do
				DATA_Info:set_type( k , v )
			end
		end
		callback()
	end
	return true, data
end

--新手成就礼包数据获取
function M.achievegift_get(type , data , callback)
	if type == 1 then

	else
		DATA_Olgift:set_type("achievegift" , data["result"] )
		callback()
	end
	return true,data
end

--新手成就礼包领取
function M.achievegift_receive(type , data , callback)
	if type == 1 then

	else
		DATA_Olgift:set_type("achievegift" , data["result"]["get"] )
		callback()
	end
	return true,data
end

function M.soul_get(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["_G_soul"])
	end
	return true, data
end

function M.soul_dismantling(type, data, callback)
	if type == 1 then
	else
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_soul"])
	end
	return true, data
end

function M.soul_ok_dismantling(type, data, callback)
	if type == 1 then
	else
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_soul"])
	end
	return true, data
end

function M.soul_fuse(type, data, callback)
	if type == 1 then
	else
		local id
		for k, v in pairs(data["result"]["_U_bag"]["general"]) do
			id = k 
		end
		callback(data["result"]["_G_soul"],id)
	end
	return true, data
end

function M.soul_ok_fuse(type, data, callback)
	if type == 1 then
	else
		local id
		for k, v in pairs(data["result"]["_U_bag"]["general"]) do
			id = k 
		end
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_soul"],id)
	end
	return true, data
end

function M.soul_directionalfuse(type, data, callback)
	if type == 1 then
	else
		local id
		for k, v in pairs(data["result"]["_U_bag"]["general"]) do
			id = k 
		end
		callback(data["result"]["_G_soul"],id)
	end
	return true, data
end


function M.equippieces_get(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["_G_chip"])
	end
	return true, data
end

function M.equippieces_dismantling(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["_G_chip"])
	end
	return true, data
end

function M.equippieces_ok_dismantling(type, data, callback)
	if type == 1 then
	else
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_chip"])
	end
	return true, data
end


function M.equippieces_fuse(type, data, callback)

	if type == 1 then
	else
		local id
		for k, v in pairs(data["result"]["_U_bag"]["equip"]) do
			id = k 
		end
		callback(data["result"]["_G_chip"],id)
	end
	return true, data
end


function M.equippieces_ok_fuse(type, data, callback)

	if type == 1 then
	else
		local id
		for k, v in pairs(data["result"]["_U_bag"]["equip"]) do
			id = k 
		end
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_chip"],id)
	end
	return true, data
end


function M.animalsoul_get(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["_G_animal"])
	end
	return true, data
end


function M.animalsoul_dismantling(type, data, callback)
	if type == 1 then
	else
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_animal"])
	end
	return true, data
end


function M.animalsoul_ok_dismantling(type, data, callback)
	if type == 1 then
	else
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_animal"])
	end
	return true, data
end

function M.animalsoul_fuse(type, data, callback)
	if type == 1 then
	else
		local id
		for k, v in pairs(data["result"]["_U_bag"]["pet"]) do
			id = k 
		end
		callback(data["result"]["_G_animal"],id)
	end
	return true, data
end

function M.animalsoul_ok_fuse(type, data, callback)
	if type == 1 then
	else
		local id
		for k, v in pairs(data["result"]["_U_bag"]["pet"]) do
			id = k 
		end
		if data["result"].msgstr then
			KNMsg.getInstance():flashShow(data["result"].msgstr)
		end
		callback(data["result"]["_G_animal"],id)
	end
	return true, data
end

--查看其它玩家基本信息
function M.profile_get(type, data, callback)
	if type == 1 then
	else
		DATA_OTHER:set_type( "base" , data["result"] )
		callback()
	end
	return true, data
end

--查看跨服玩家信息
function M.profile_get_other_server(type, data, callback)
	if type == 1 then
	else
		DATA_OTHER:set_type( "base" , data["result"] )
		callback()
	end
	return true, data
end

--查看其它玩家阵法信息
function M.profile_getuidformation(type, data, callback)
	if type == 1 then
	else
		DATA_OTHER:set_type( "formation" , data["result"] )
		callback()
	end
	return true, data
end

--[[
function M.pet_upgrade(type, data, callback)
	if type == 1 then
	else
		-- msg = data["msg"]
		callback()
	end
	return true, data
end
]]


--活动入口
function M.activity_get(type , data , callback)
	if type == 1 then
	else
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--活动公用发包
function M.activity_receive(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--连续登陆领奖
function M.activity_receive_login(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end

--帮派任务活动
function M.activity_receive_allianceachieve(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--火影加意志点
function M.activity_receive_hy_yizhi(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--火影意志点兑换
function M.activity_receive_hy_yizhi_lottery(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback( data["result"]["data"]["cids"] )
	end
	return true,data
end

--好汉目标活动
function M.activity_receive_achieve(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--国庆活动 --每日任务
function M.activity_receive_everydaytask(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--国庆活动 --每日充值
function M.activity_receive_everydaypay(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--国庆活动 --收集活动
function M.activity_receive_collect(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end

-- 万元话费
function M.activity_receive_leveling_gifts_calls_gold(type, data, callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback(data["result"])
	end
	return true,data
end

--跨服武道大会
function M.activity_reg_pkgameglobal(type, data, callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"]["get"] )
		callback(data["result"],M.inform)
	end
	return true,data
end



--跨服武道大会 鼓舞玩家
function M.activity_pkgameglobal_guwu(type, data, callback)
	if type == 1 then

	else
		callback(data["result"])
		DATA_Activity:set_type( data["result"]["get"] )
	end
	return true,data
end

--跨服武道大会 购买鼓舞点
function M.activity_pkgameglobal_buy_guwu(type, data, callback)
	if type == 1 then

	else
		callback(data["result"])
		DATA_Activity:set_type( data["result"]["get"] )
	end
	return true,data
end

--跨服武道大会 升级属性
function M.activity_pkgameglobal_up_attr(type, data, callback)
	if type == 1 then

	else
		callback(data["result"])
		DATA_Activity:set_type( data["result"]["get"] )
	end
	return true,data
end

--跨服武道大会 积分购买物品
function M.activity_pkgameglobal_buy(type, data, callback)
	if type == 1 then

	else
		callback(data["result"])
		DATA_Activity:set_type( data["result"]["get"] )
		M.inform( data["result"] )
	end
	return true,data
end  

--跨服武道大会 领取奖励
function M.activity_pkgameglobal_receive(type, data, callback)
	if type == 1 then

	else
		callback(data["result"])
		M.inform( data["result"] )
	end
	return true,data
end 



--帮会充值
function M.activity_get(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback(data["result"])
	end
	return true,data
end

-- 每日务农 领奖
function M.activity_receive_farm_gift(type, data, callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback(data["result"])
	end
	return true,data
end

-- 每日务农 报名
function M.activity_receive_farm_apply(type, data, callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback(data["result"])
	end
	return true,data
end


function M.activity_receive_leveling_gifts_calls(type, data, callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback(data["result"])
	end
	return true,data
end

function M.activity_receive_leveling_gifts_mobile(type, data, callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback(data["result"])
	end
	return true,data
end

-- 火影限时首充
function M.activity_receive_singlepaymax_hy_new(type, data, callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback(data["result"])
	end
	return true,data
end

--超值月卡
function M.activity_receive_valuablecard(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--消费好礼
function M.activity_receive_achieve3day(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--升级活动
function M.activity_receive_lvup(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--对酒活动
function M.activity_receive_wine(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--充值奖励活动
function M.activity_receive_payment(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--首充礼包
function M.activity_receive_firstpay(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--五星英雄
function M.activity_receive_singlepaymax(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--全民福利
function M.activity_receive_welfare(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--登陆奖励
function M.activity_receive_sign_in(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--登陆奖励vip奖励领取
function M.activity_receive_sign_in_vipgift(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--成长计划
function M.activity_receive_growth_plan_shop(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--成长计划领取
function M.activity_receive_growth_plan_gold(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--释放烟花
function M.activity_usefirework(type , data , callback)
	if type == 1 then
	else
		DATA_Activity:set_type( data["result"] )
		callback( data["result"] )
	end
	return true,data
end
--烟花积分
function M.activity_receive_firework(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--烟花积分
function M.activity_receive_n2beipay(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end

--超值兑换
function M.activity_receive_xchange(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--超值兑换
function M.activity_receive_lottery(type , data , callback)
	if type == 1 then

	else
		DATA_Activity:set_type( data["result"] )
		local tempData = data["result"].data
		local isNormal = awardCell( tempData["config"]["award"][ tempData.index + 1 ] , { isNormal = true } )
		local tipFun = nil
		if not isNormal then
			tipFun = function() M.inform( data["result"] ) end 
		end
		callback( { data = tempData , tipFun = tipFun } )
	end
	return true,data
end
--免费抽奖
function M.activity_receive_free_lottery(type , data , callback)
	if type == 1 then

	else
		DATA_Activity:set_type( data["result"] )
		local tempData = data["result"].data
		local isNormal = awardCell( tempData["config"]["award"][ tempData.index + 1 ] , { isNormal = true } )
		local tipFun = nil
		if not isNormal then
			tipFun = function() M.inform( data["result"] ) end 
		end
		callback( { data = tempData , tipFun = tipFun } )
	end
	return true,data
end

--武道大会报名
function M.activity_reg_pkgame(type , data , callback)
	if type == 1 then

	else
		DATA_Activity:set_type( data["result"]["get"] )
		callback(data["result"])
	end
	return true,data
end


--武道领取奖励
function M.activity_receive_pkgame(type , data , callback)
	if type == 1 then
		
	else
		DATA_Activity:set_type( data["result"]["get"] )
		callback(data["result"] , M.inform )
	end
	return true,data
end


function M.rob_getlist(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["list"])	
	end
	return true, data
end

--获取帮派数据
function M.alliance_get(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set( data["result"] )
		callback()
	end
	return true,data
end
--获取其它帮派排行数据
function M.alliance_rank(type , data , callback)
	if type == 1 then
	else
		if data["result"]["apply"] then
			DATA_Gang:set_type( "apply" , data["result"]["apply"] )
			data["result"]["apply"] = nil
		end
		
		DATA_Gang:set_type( "rank" , data["result"] )
		callback()
	end
	return true,data
end
--创建帮派
function M.alliance__create(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set( data["result"] )
		callback()
	end
	return true,data
end


--申请加入帮派
function M.alliance_application(type , data , callback)
	if type == 1 then
	else
		if data["result"].info  then
			DATA_Gang:set_type( "info" , data["result"].info )
			DATA_Gang:set_type( "list" , data["result"].list )
		else
			DATA_Gang:set_type( "apply" , data["result"]["apply"] )
		end
		callback()
	end
	return true,data
end
--取消帮派申请
function M.alliance_exitapplication(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "apply" , data["result"] )
		callback()
	end
	return true,data
end

--编辑公告
function M.alliance_notice(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set( data["result"] )
		callback( data["result"] )
	end
	return true,data
end
--踢人、退出
function M.alliance_excluding(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type("info" ,  data["result"].info )
		DATA_Gang:set_type("list" ,  data["result"].list )
		callback( data["result"] )
	end
	return true,data
end
--加入帮派后帮派列表
function M.alliance_totalrank(type , data , callback)
	if type == 1 then
	else
		--rank   总榜
		--rank_top   总榜排名
		--ability   战力
		--ability_top   战力排行数
		--tribute   帮威
		--tribute_top   帮威排行
		DATA_Gang:set_type( "gang_rank" , data["result"] )
		callback( )
	end
	return true,data
end
--加入帮派后帮派列表
function M.alliance_eventmovement(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "event_movement" , data["result"].event_movement )
		callback( )
	end
	return true,data
end

--帮派祈福界面数据
function M.alliance_clifford(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "pray" , data["result"] )
		callback( )
	end
	return true,data
end
--帮派祈福界面数据
function M.alliance_sendclifford(type , data , callback)
	if type == 1 then
	else
		
		local tempData = DATA_Gang:get("pray")
		tempData = tempData or {}
		tempData.rands = data["result"].rands
		DATA_Gang:set_type( "pray" , tempData )
		
		callback(data["result"] )
	end
	return true,data
end


--帮派收人数据
function M.alliance_fresh(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "applylist" , data["result"].applylist )
		callback( )
	end
	return true,data
end
--帮派拒绝申请者加入
function M.alliance_refuse(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "applylist" , data["result"].applylist )
		callback( )
	end
	return true,data
end
--帮派一键拒绝申请者加入
function M.alliance_refuseonekey(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "applylist" , data["result"].applylist )
		callback( )
	end
	return true,data
end
--帮派 申请同意
function M.alliance_agree(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "info" , data["result"].info )
		DATA_Gang:set_type( "list" , data["result"].list )
		DATA_Gang:set_type( "applylist" , data["result"].applylist )
		callback( )
	end
	return true,data
end
--帮派一键同意
function M.alliance_agreeonekey(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "info" , data["result"].info )
		DATA_Gang:set_type( "list" , data["result"].list )
		DATA_Gang:set_type( "applylist" , data["result"].applylist )
		callback( )
	end
	return true,data
end
--帮派任命
function M.alliance_manage(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "info" , data["result"].info )
		DATA_Gang:set_type( "list" , data["result"].list )
		callback( )
	end
	return true,data
end
--帮派升级
function M.alliance_escalate(type , data , callback)
	if type == 1 then
	else
		if data["result"].info then
			DATA_Gang:set_type( "info" , data["result"].info )
			DATA_Gang:set_type( "list" , data["result"].list )
		else
			DATA_Gang:set_type( "gangup" , data["result"] )
		end
		callback( )
	end
	return true,data
end
--帮派任务捐献
function M.alliance_task(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "task" , data["result"] )
		DATA_Gang:set_type( "rob" , data["result"].rob )
		
		callback( )
	end
	return true,data
end
--驻防任务
function M.alliancerob_zhufang(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "rob" , data["result"].rob )
		
		callback( )
	end
	return true,data
end
--驻防领奖
function M.alliancerob_zhufang_award(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Gang:set_type( "rob" , data["result"].rob )
		callback( )
	end
	return true,data
end
--查看驻防列表
function M.alliancerob_defenderlist(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "rob_list" , data["result"] )
		callback( )
	end
	return true,data
end

--确认捐献
function M.alliance_senddonate(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "info" , data["result"].info )
		DATA_Gang:set_type( "list" , data["result"].list )
		if data["result"].donate then
			local tempData = DATA_Gang:get( "task" )
			tempData.donate = data["result"].donate
			DATA_Gang:set_type( "task" ,tempData )
		end
		
		if data["result"].task then
			local tempData = DATA_Gang:get("task") or {}
			tempData.task = data["result"].task
			DATA_Gang:set_type( "task" , tempData )
		end 
		
		callback( )
	end
	return true,data
end
--重置任务
function M.alliance_resettask(type , data , callback)
	if type == 1 then
	else
		local tempData = DATA_Gang:get("task") or {}
		tempData.task = data["result"].task
		DATA_Gang:set_type( "task" , tempData )
		callback( )
	end
	return true,data
end
--执行任务
function M.alliance_posttask(type , data , callback)
	if type == 1 then
	else
		local tempData = DATA_Gang:get("task") or {}
		tempData.task = data["result"].task
		
		DATA_Gang:set_type( "task" , tempData )
		DATA_Gang:set_type( "info" , data["result"].info )
		DATA_Gang:set_type( "list" , data["result"].list )
		
		callback( )
	end
	return true,data
end
--接受任务
function M.alliance_receivetask(type , data , callback)
	if type == 1 then
	else
		local tempData = DATA_Gang:get("task") or {}
		tempData.task = data["result"].task
		DATA_Gang:set_type( "task" , tempData )
		callback( )
	end
	return true,data
end
--帮会自动加人与验证加人切换
function M.alliance_switchuser(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "applylist" , data["result"].applylist )
		DATA_Gang:set_type( "list" , data["result"].list )
		callback( )
	end
	return true,data
end
--帮会商城
function M.alliance_shop(type , data , callback)
	if type == 1 then
	else
		--[[
		local order = {weapon = 1, jewelry = 2, defender = 3, shoe = 4}
		table.sort( data["result"]["equipmentconfig"], function(first, second)
			if first["star"] > second["star"] then
				return true
			elseif first["star"] == second["star"] then
				return order[ first["type"] ] < order[ second["type"] ]
			else
				return false
			end
		end )]]
		DATA_Gang:set_type( "shop" , data["result"] )
		callback( )
	end
	return true,data
end
--开启帮会宝石加成
function M.alliance_wakeprop(type , data , callback)
	if type == 1 then
	else
		local tempData = DATA_Gang:get("shop")
		tempData.gemconfig = data["result"].gemconfig
		tempData.equipmentconfig = data["result"].equipmentconfig
		DATA_Gang:set_type( "shop" , tempData )
		
		DATA_Gang:set_type( "info" , data["result"].info )
		DATA_Gang:set_type( "list" , data["result"].list )
		callback( )
	end
	return true,data
end
--开启帮会宝石购买
function M.alliance_shopprop(type , data , callback)
	if type == 1 then
	else
		DATA_Gang:set_type( "info" , data["result"].info )
		DATA_Gang:set_type( "list" , data["result"].list )
		callback( )
	end
	return true,data
end

function M.message_get_wajue(type , data , callback)
	if type == 1 then
	else
		local result = data["result"]["_G_message_wajue"]
		callback(result[#result])
	end
	return true,data
end


--读取帮派聊天数据
function M.alliance_getchat(type , data , callback)
	if type == 1 then
	else
		if data["result"].code then
			DATA_Info:set_type( "gang" , data["result"] )
		else
			DATA_Info:set_type( "gang" , data["result"].chat )
		end
		callback()
	end
	return true,data
end


--读取好友聊天数据
function M.message_get_siliao(type , data , callback)
	if type == 1 then
	else
		DATA_Info:set_type( "friend" , data["result"]._G_message_siliao )
		callback()
	end
	return true,data
end

--读取自定义聊天数据
function M.message_get_scene_msg(type , data , callback)
	if type == 1 then
	else
	
		DATA_Info:set_type( "custom" , data["result"] )
		callback()
	end
	return true,data
end

--获取世界聊天数据
function M.message_gettalk(type, data, callback)
	if type == 1 then
	else
		DATA_Info:set_type("_G_message_talk" , data["result"]._G_message_talk )
		callback()
	end
	return true, data
end

--获取vip配置信息
function M.vip_get(type , data , callback)
	if type == 1 then
	else
		DATA_Vip:set_type( "vip" , data["result"] )
		callback()
	end
	return true,data
end
function M.vip_receive(type , data , callback)
	if type == 1 then
	else
		DATA_Vip:set_type( "vip" , data["result"].get )
		callback()
		switchScene("vip" , {} , function()
			M.inform( data["result"] )
		end)
	end
	return true,data
end

function M.evolvepool_merge(type, data, callback)
	if type == 1 then
	else
		--传物品的id与cid
		callback(data["result"]["id"], data["result"]["awards"]["drop"][1])
	end
	
	return true, data
end

function M.evolvepool_merge_skill(type, data, callback)
	if type == 1 then
	else
		--传物品的id与cid
		callback(data["result"]["id"], data["result"]["awards"]["drop"][1])
	end
	
	return true, data
end

--使用vip礼包
function M.bag_usevipkit(type, data, callback)
	if type == 1 then
	else
		--传物品的id与cid
		callback(data["result"],M.inform)
	end
	
	return true, data
end


--使用新年礼包
function M.bag_useenvelope(type, data, callback)
	if type == 1 then
	else
		--传物品的id与cid
		callback(data["result"],M.inform)
	end
	
	return true, data
end

--使用祝福礼包
function M.bag_usezhufukit(type, data, callback)
	if type == 1 then
	else
		--传物品的id与cid
		callback(data["result"],M.inform)
	end
	
	return true, data
end



function M.penglai_get(type, data, callback)
	if type == 1 then
	else
		--传物品的id与cid
		callback(data["result"]["_G_penglai"])
	end
	
	return true, data
end
--大于20级玩家返还活动
function M.feedback_lvgt20(type, data, callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		callback()
	end
	return true, data
end
--排名100玩家返还活动
function M.feedback_rank100(type, data, callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		callback()
	end
	return true, data
end
--大于20级玩家返还活动
function M.ucactivation_lvgt20(type, data, callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		callback()
	end
	return true, data
end
--排名100玩家返还活动
function M.ucactivation_rank100(type, data, callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		callback()
	end
	return true, data
end


--领取充值返利数据
function M.feedback_pay(type, data, callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		callback()
	end
	return true, data
end
--唐门激活码领取
function M.tmsjactivation_receive(type, data, callback)
	if type == 1 then
	else
		-- 回调处理
		switchScene("home" , {} , function()
			M.inform( data["result"] )
		end)
	end
	return true, data
end
--[[uc激活码]]
function M.ucactivation_receive( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		switchScene("home" , {} , function()
			M.inform( data["result"] )
		end)
	end

	return true , data
end
--[[官服大话激活码]]
function M.dhshjhm_receive( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		switchScene("home" , {} , function()
			M.inform( data["result"] )
		end)
	end

	return true , data
end
--[[联运大话激活码]]
function M.dhshjhm_receive_union( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		switchScene("home" , {} , function()
			M.inform( data["result"] )
		end)
	end

	return true , data
end
--获取好友数据
function M.friends_get( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		DATA_Friend:set( data["result"] )
		callback( )
	end
	return true , data
end
--添加好友数据
function M.friends_addfrd( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		KNMsg.getInstance():flashShow( "好友添加成功！" )
		DATA_Friend:set( data["result"].get )
		callback( )
	end
	return true , data
end
--删除好友
function M.friends_delfrd( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		KNMsg.getInstance():flashShow( "删除成功！" )
		DATA_Friend:set( data["result"].get )
		callback( )
	end
	return true , data
end
--祝福好友
function M.friends_zhufu( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		DATA_Friend:set( data["result"].get )
		if data["result"].success then
			KNMsg.getInstance():flashShow( "祝福成功！" )
		end
		callback( )
	end
	return true , data
end
--查找好友
function M.friends_search( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		DATA_OTHER:set_type( "base" , data["result"] )
		callback()
	end
	return true , data
end
--删除仇人
function M.friends_delenermy( type , data , callback )
	if type == 1 then
		-- 发送前数据处理
	elseif type == 2 then
		-- 回调处理
		DATA_Friend:set( data["result"].get )
		callback()
	end
	return true , data
end


--累积冲值 累充大礼
function M.activity_receive_paycount(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end

--今日  累充大礼
function M.activity_receive_everydayrecharge(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--天天有礼
function M.activity_receive_everydaygifts(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--消费大礼
function M.activity_receive_consume(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--单充大礼
function M.activity_receive_singlepay(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--中秋登陆礼包
function M.activity_receive_logincount(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end
--帮战大厅数据
function M.bangzhan_frontpage_info(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "warsHall" , data["result"] )
		callback()
	end
	return true,data
end
--帮战排行榜数据获取
function M.bangzhan_get_rank(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "warsRank" , data["result"] )
		callback()
	end
	return true,data
end
--帮战选择参战人员
function M.bangzhan_select_member(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "warsHall" , data["result"] )
		callback()
	end
	return true,data
end
--帮主报名参加帮战
function M.bangzhan_sign_in(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "warsHall" , data["result"] )
		callback()
	end
	return true,data
end
--帮主报名参加帮战
function M.bangzhan_get_rank_list(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "wars_all_rank" , data["result"] )
		callback()
	end
	return true,data
end
--帮战领奖
function M.bangzhan_receive(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		local tempData = data["result"]
		tempData.awards = nil
		local warsHallData = DATA_Gang:get( "warsHall" )
		warsHallData.award = data["result"].award
		DATA_Gang:set( tempData )
		DATA_Gang:set_type( "warsHall" , warsHallData )
		callback( )
	end
	return true,data
end
--帮战鼓舞
function M.bangzhan_get_guwu(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "join_buff" , data["result"] )
		callback( )
	end
	return true,data
end
--帮战鼓舞
function M.bangzhan_guwu(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "join_buff" , data["result"] )
		callback( )
	end
	return true,data
end

--帮战未参战人员鼓舞士气
--请求进入该界面
function M.bangzhan_get_cash_guwu(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "not_go_inspire" , data["result"] )
		callback( data["result"] )
	end
	return true,data
end

--提交鼓舞士气请求
function M.bangzhan_cash_guwu(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "not_go_inspire_submit" , data["result"] )
		callback( data["result"] )
	end
	return true,data
end


--帮派掠夺数据获取
function M.alliancerob_get(type , data , callback)
	if type == 1 then

	else
		DATA_Gang:set_type( "harry" , data["result"] )
		callback(data["result"] )
	end
	return true,data
end


function M.socialclass_award_info(type, data, callback)
	if type == 1 then
	else
		
		callback(data["result"]["config"])
	end
	return true, data
end

function M.socialclass_pass_fight(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["map_info"])
		
	end
	return true, data
end


function M.socialclass_receive_award(type , data , callback)
	if type == 1 then
        
    else
		callback(data["result"], M.inform)
	end
	return true,data
end


function M.socialclass_getmusicaward(type , data , callback)
	if type == 1 then
        
        else
		callback(data)
	end
	return true,data
end


function M.socialclass_pass_addcd(type, data, callback)
	if type == 1 then
	else
		callback(data["result"]["map_info"])
	end
	return true, data
end


function M.share_share(type, data, callback)
	if type == 1 then
	else
		callback(data["result"], M.inform)
	end
	return true, data
end


--获取任务数据
function M.dailytask_get(type, data, callback)
	if type == 1 then
    else
        DATA_Task:set( data["result"] )
		callback()
	end
	return true, data
end
--任务刷新
function M.dailytask_refresh(type, data, callback)
	if type == 1 then
    else
        DATA_Task:set( data["result"].get )
		callback()
	end
	return true, data
end
--任务接受
function M.dailytask_accept(type, data, callback)
	if type == 1 then
    else
        DATA_Task:set( data["result"].get )
		callback( data["result"].get )
	end
	return true, data
end
--任务接受
function M.dailytask_giveup(type, data, callback)
	if type == 1 then
    else
        DATA_Task:set( data["result"].get )
		callback()
	end
	return true, data
end
--任务一键完成
function M.dailytask_ok_finish(type, data, callback)
	if type == 1 then
    else
        DATA_Task:set( data["result"].get )
		callback( data["result"] )
	end
	return true, data
end
--任务一键完成
function M.dailytask_finish(type, data, callback)
	if type == 1 then
    else
        DATA_Task:set( data["result"].get )
		callback( data["result"] )
	end
	return true, data
end


function M.kuafu_getMRTInfo(type, data, callback)
	if  type == 1 then
	else
		dump(data)
		callback(data["result"])
	end
	return true, data
end

function M.kuafu_getZoneList(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.kuafu_bgStartZiGe(type, data, callback)
	if  type == 1 then
	else
	end
	return true, data
end



function M.kuafu_getAward(type, data, callback)
	if  type == 1 then
	else
		dump(data)
		callback(data.result)
	end
	return true, data
end


function M.kuafu_corpsFight(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"]["report"])
	end
	return true, data
end


function M.activity_receive_friends_gift(type, data, callback)
	if type == 1 then
	else
		callback(data["result"], M.inform)
	end
	return true, data
end

function M.activity_receive_friends_codekey(type, data, callback)
	if type == 1 then
	else
		callback(data["result"], M.inform)
	end
	return true, data
end	



--购买粹炼石
function M.shop_buy_cuilian(type , data , callback)
	if type == 1 then
	else
		M.inform( data["result"] )
		callback(data["result"])
	end
	return true , data
end

--藏宝楼扫荡
function M.insequip_cleanup(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.bag_use_ganen(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.pet_transmission(type, data, callback)
	if  type == 1 then
	else
		callback(data)
	end
	return true, data
end

function M.activity_receive_anniversary_synthesis(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.activity_receive_anniversary_exchange(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.equip_moveAttribute(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end


function M.activity_receive_lantern_open(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.activity_receive_lantern_dt(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.activity_receive_lantern_award(type, data, callback)
	if  type == 1 then
	else
		callback(data["result"])
	end
	return true, data
end

function M.activity_receive_online_award(type, data, callback)
	if  type == 1 then
	else
		callback(data)
	end
	return true, data
end

function M.task_receiveAward(type , data , callback)
	if type == 1 then
	else
		--dump(data['result'])
		M.inform( data["result"] )
		callback(data["result"])
	end
	return true , data
end


function M.alliance_sendimpeachment(type , data , callback)
	if type == 1 then
	else
		callback(data["result"])
	end
	return true , data
end

function M.activity_receive_firstcome(type , data , callback)
	if type == 1 then

	else
		M.inform( data["result"] )
		DATA_Activity:set_type( data["result"] )
		callback()
	end
	return true,data
end

--奖励领取提示
function M.inform( data , info )
	local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
	inform( data , info )
end


return M


