--活动页面
local M = {}

local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")
local data
local handler
local curClock
local activityType
local icon
local curKey = "1"	--
local isNewYear = true	--是否新年活动
local curFace		--当前界面
local activityList = {}
function M:setHandler( value )
	handler = value
end
function M:getCurKey()
	return curKey
end
function M:new(params)
	curKey = params and params.curKey or "1"
	curFace = nil 
	
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	-- 基础层
	this.baseLayer = display.newLayer()
	this.listLayer = display.newLayer()
	this.viewLayer = display.newLayer()
	

	isNewYear = DATA_Activity:getIsNewYear()
	
	-- 背景
	local bg = display.newSprite( PATH .. ( isNewYear and "newyear/" or "" )  .. "activity_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )
	
	
	activityList = DATA_Activity:getlist()		
	icon = DATA_Activity:getIcon()
	dump(activityList)
	--test
	-- activityList["7"] = "anniversary"
	-- icon["7"] = {
	-- 	icon = "anniversary",
	-- 	iconname = "anniversary_name",
	-- 	modeid = 3,
	-- 	typeid = "firework_all"
	--  }
	--test end

	local scroll = KNScrollView:new( 10, 710, 460, 100, 10 , true )
	local group = KNRadioGroup:new()
	for i = 1 , table.nums(activityList) do
		local curName = activityList[ i .. ""]
		local curIcon = icon[ i .. ""]

		local activityBtn = KNBtn:new( PATH .. "list/" , { curIcon.icon  .. ".png" , "select.png" } , 0 , 0 ,
		{
			id = curName , 
			parent = scroll,
			noHide = true,
			upSelect = true,
			selectZOrder = 1,
			disableWhenChoose = true ,
			other = {{ PATH .. "list/" .. curIcon.iconname .. ".png" , 5 , 3} , ( curName == "payment" or curName == "singlepaymax" ) and { PATH .. "list/curfew.png" , 5 , 33} or nil} , 
			callback = function()
			
				self:clearAllClock()
				this:requestData( { typeid = curIcon.typeid , index = i , typename = curName } )
				
--				if curName == "payment" then
--					this:paymentActivity()
--				else
--					HTTP:call("activity", "get", { type = curIcon.typeid } , {success_callback = 
--					function()
--						curKey =  i .. ""
--						this:selectActivity( curName )
--					end})
--				end

			end
		},group)
		scroll:addChild(activityBtn:getLayer(), activityBtn )
	end
	scroll:alignCenter()
	this.listLayer:addChild(scroll:getLayer() )
	
	if params and params.findCurKeyByName then 
		for key , value in pairs(activityList) do 
			if value == params.findCurKeyByName then 
				curKey = key				
				scroll:scrollTo(params.findCurKeyByName)
				break
			end
		end
	end
	
	group:chooseByIndex(tonumber(curKey) , true)

	this.baseLayer:addChild(this.viewLayer , 1 )
	this.baseLayer:addChild(this.listLayer)
	
	
	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "activity" , ( isNewYear and 6 or 5 )  , { title_hide = false , tail_hide = true } )
	this.baseLayer:addChild( this.infoLayer:getLayer() )	
	
	
--	this:selectActivity()

	-- 新手引导
	if KNGuide:getStep() == 10001 then
		local activity_index = self:getActivityIndex("leveling_gifts")
		if activity_index > 0 then
			local btn = scroll:getItems(activity_index)
			local btn_range = btn:getRange()

			KNGuide:show( btn:getLayer() , {
				x = btn_range:getMinX(),
				y = btn_range:getMinY(),
				remove = true,
				callback = function()
					local activity_index = self:getActivityIndex("logincount")
					
					if activity_index > 0 then
						local btn = scroll:getItems(activity_index)
						local btn_range = btn:getRange()

						KNGuide:show( btn:getLayer() , {
							x = btn_range:getMinX(),
							y = btn_range:getMinY(),							
						})
					end
				end
			})
		end
	end

	-- 新手引导
	if KNGuide:getStep() == 10101 then
		local activity_index = self:getActivityIndex("exciting_activities")
		if activity_index > 0 then
			local btn = scroll:getItems(activity_index)
			local btn_range = btn:getRange()

			KNGuide:show( btn:getLayer() , {
				x = btn_range:getMinX(),
				y = btn_range:getMinY(),
				remove = true,
				callback = function()
					group:chooseByIndex(activity_index , true)
				end
			})
		end
	end

	return this
end
function M:getLayer()
	return self.baseLayer 
end
function M:getCurFace()
	return curFace
end
--数据切换
function M:requestData( params )
	HTTP:call("activity", "get", { type = params.typeid } , {success_callback = 
	function( tempData )
		if params.index then
			curKey =  params.index .. ""
		end
		if params.parentLayer then
			params.data = tempData.data
			params.isFirst = true
		end
		self:selectActivity( params.typename , params )
	end})
end
function M:getActivityIndex(gettype)
	local index = 0
	for i = 1 , table.nums(activityList) do
		if gettype == activityList[i .. ""] then
			index = i
			break
		end
	end

	return index
end
function M:getActivityType()
	return activityType
end
--刷新数据
function M:selectActivity( _activityType , params )
	
	activityType = _activityType or DATA_Activity:getCurType()
	
	curFace = nil
	data = DATA_Activity:getCurData()
	
	data.noremove = nil 
	local paramsFiltration = nil
	if params and params.parentLayer then								--只有精彩活动走这里
		paramsFiltration = { 
		parentLayer = params.parentLayer , 
		data = ( params.isFirst and params.data or data )  , 	--不是第一次，则可能是点击领取后的数据，这里有更新数据的意思
		refreshFun = function() self:clearAllClock( { noWine = true }) self:selectActivity( _activityType , params ) end  --refreshFun回调刷新自己
		}
		data.noremove = true 
		params.isFirst = false 
	elseif params then 
		paramsFiltration = params
	end
	
	
	if self.viewLayer and not data.noremove then
		if handler then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handler)
			handler = nil
		end
		self.awardProp = nil
		self.viewLayer:removeFromParentAndCleanup(true)	-- 清除自己
		self.viewLayer = display.newLayer()
		self.baseLayer:addChild(self.viewLayer , 1 )
	end
	
	
	if icon[curKey].modeid == 1 then 		--列表list形式  
		self:listActivity()
	elseif icon[curKey].modeid == 2 then	--转盘抽奖
		
	elseif icon[curKey].modeid == 3 then	--单独开发
		local manLayer = requires(IMG_PATH,"GameLuaScript/Scene/activity/cell/" .. activityType )	
		manLayer:show( paramsFiltration )
		
	end
	
end
function M:getData()
	return data
end

function M:setCurFace( value )
	curFace = value
end


--列表
function M:listActivity()
	
	self:baseLayout({ line = {} })
	local scroll = KNScrollView:new( 0, 94, 480, 470 , 10 , false )
	local function createItem( params )
		params = params or {}
		local layer = display.newLayer()
		
		local bg = display.newSprite( COMMONPATH .. "item_bg.png" )
		setAnchPos( bg , 0 , 0 )
		layer:addChild( bg )
		
		
		layer:addChild( display.newSprite( PATH .. "vip_bg_bar.png" , 107 , 82 , 0 , 0 ) )
		layer:addChild( display.strokeLabel( params.data.content , 107, 80 , 18, ccc3( 0xfd , 0xfa , 0xd7 ) , nil , nil , { dimensions_width = 231 , dimensions_height = 25 , align = 1 } ) )
		
		local itemAwardData = params.data.award
		local awardProp = {}
		for i = 1 , #itemAwardData do
			local curProp = awardCell( itemAwardData[i] , { parent = scroll } )
			setAnchPos( curProp , 28 + ( i - 1 ) * 85 , 10 )
			layer:addChild( curProp )
			awardProp[ #awardProp + 1 ] = curProp
		end
		
		local isEnable =  true
		local isComplete = false
		if data.received then
			--是否已经领取
			for j = 1 , #data.received do
				if tonumber( data.received[j]) == tonumber( params.index ) then
					isComplete = true
					break
				end
			end
		end
		local getBtn = KNBtn:new( COMMONPATH , 
			isEnable and ( isComplete and { "long_btn_grey.png" }  or { "long_btn.png" ,"long_btn_pre.png"} ) or { "long_btn_grey.png" } , 
			305 , 
			18 ,
			{
--				priority = -130,
				parent = scroll , 
				front = COMMONPATH .. ( isEnable and (isComplete and "get_over.png" or  "all_get.png" ) or "get_over.png" ) ,
				callback = 
				function()
					if isEnable and not isComplete then
						if isBagFull() then
						    return false
						end

						self:sendFun( { typeid = data.typeid , index = params.index } )
					else
					end
				end
			})
		layer:addChild( getBtn:getLayer() )
		
		
		layer:setContentSize( bg:getContentSize() )
		return layer , getBtn
	end

	local guide_step = KNGuide:getStep()
	local guide_btn = nil

	local sort = data.config 
	for i = 1 , #sort do
		local curData = sort[i]
		local item , getBtn = createItem( { index = i -1 , viplv = curData.viplv , data = curData } )
		scroll:addChild( item )

		if data.type == "logincount" and guide_step == 10003 then
			guide_btn = getBtn
		end
	end
	scroll:alignCenter()
	self.viewLayer:addChild(scroll:getLayer() )
	
	self.viewLayer:addChild( display.newSprite( PATH .. "activity_awards_title.png" , 25 , 562 , 0 , 0 ) )
	
	self.viewLayer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 20 , 585 + 20 , 0 , 0 ) )	--活动时间
	self.viewLayer:addChild( display.strokeLabel( data.endtime or "" , 120 , 588 + 20 , 20, ccc3( 0xfe , 0xfc , 0xd3 )  ) )	--活动时间
	
	self.viewLayer:addChild( display.strokeLabel( data.showcontent or "" , 125 , 565 , 20, ccc3( 0xfe , 0xfc , 0xd3 ) , nil , nil , {dimensions_width = 340 ,	dimensions_height = 24 , align = 2	} ) )	--活动时间
	
	if guide_btn then
		local btn_range = guide_btn:getRange()
		KNGuide:show( guide_btn:getLayer() , {
			x = btn_range:getMinX(),
			y = 463,
			callback = function()
				GLOBAL_INFOLAYER:refreshBtn()
			end
		})
	end

end
--活动领取
function M:sendFun( params )
	params = params or {}
	HTTP:call("activity", "receive", params ,{success_callback = 
	function()
		self:getAction( { onComplete = function() self:selectActivity() end } )
	end})
end

--是否有活动说明
function M:baseLayout( params )
	params = params or {}
	
	if data.tips and data.tips ~= "" then
		local activityTitle = display.strokeLabel( "活动内容：" , 17 , 670 , 18 , ccc3( 0xff , 0xff , 0xfd ) , nil , nil , {
					dimensions_width = 100 ,
					dimensions_height = 24,
					align = 0
				})
		
		local activityText = display.strokeLabel( data.tips , 100 , 645 , 18 , ccc3( 0xff , 0xff , 0xfd ) , nil , nil , {
					dimensions_width = 354,
					dimensions_height = 50,
					align = 0
				})
				
		self.viewLayer:addChild( activityTitle )
		self.viewLayer:addChild( activityText )
	end
	
	--分隔线
	if params.line then
		local lineData = params.line or {}
		local pathStr = lineData.path or COMMONPATH .. "tab_line.png"
		if isNewYear then
			pathStr = PATH .. "newyear/tab_line.png"
		end
		local addX = lineData.x or display.cx
		local addY = lineData.y or 643
		local line = display.newSprite( pathStr )
		setAnchPos(line , addX , addY , 0.5 , 0.5 )
		self.viewLayer:addChild( line )
	end
	
	if params.noShowBg then return end
		
	
	
	--背景
	if params.frame then
		local framsData = params.frame or {}
		local pathStr = framsData.path or PATH .. ( ( isNewYear and "newyear/" or "" ) .. "frame.png")
		
		local addX = framsData.x or display.cx
		local addY = framsData.y or 107
		
		local frame = display.newSprite( pathStr )
		setAnchPos(frame , addX , addY , 0.5 )
		self.viewLayer:addChild( frame )
		
		if not framsData.path and isNewYear then
			--self.viewLayer:addChild( display.newSprite( PATH .. "newyear/banger.png" , display.cx , 500 - 120  , 0.5 , 0  )  )
		end
	end
	
end
--删除时钟
function M:delHandler()
	if handler then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handler)
		handler = nil
	end
end
function M:downTime( key , timeTextAry ,downFun , _type )
	local type = _type and _type or 0
	local timeText = {}
	local function refreshTime()
		local curTime = downFun()
		if curTime < 0 then curTime = 0 end
		local dayNum = math.floor( tonumber(timeConvert( curTime , "hour"))/24 )
		curTime = curTime - dayNum * 86400
		timeTextAry[1]:setString( dayNum )												--天
		timeTextAry[2]:setString( math.mod( timeConvert( curTime , "hour") , 24 )  )	--时
		timeTextAry[3]:setString( timeConvert( curTime , "min")  )						--分
		timeTextAry[4]:setString( timeConvert( curTime , "sec")  )						--秒
		if curTime <= 0 then
			Clock:removeTimeFun( key )
		end
	end
	--24小时，不展示天数
	local function refreshTime1()
		local curTime = downFun()
		if curTime < 0 then curTime = 0 end
		local dayNum = math.floor( tonumber(timeConvert( curTime , "hour"))/24 )
		curTime = curTime - dayNum * 86400
		
		timeTextAry[1]:setString( math.mod( timeConvert( curTime , "hour") , 24 ) .. ":" .. timeConvert( curTime , "min") .. ":" .. timeConvert( curTime , "sec") )
		if curTime <= 0 then
			timeTextAry[1]:setString("")
			Clock:removeTimeFun( key )
		end
	end
	curClock = key  
	if type == 0 then
		Clock:addTimeFun( key , refreshTime )
	elseif type == 1 then
		Clock:addTimeFun( key , refreshTime1 )
	end
end
--清除当前运行的时钟
function M:clearClock()
	Clock:removeTimeFun( curClock )
end
--领取动画，暂时不做
function M:getAction( params )
	local awardProp = params.awardProp	or {}--奖励道具
	local completeFun = params.onComplete or function()end
	completeFun()
--	KNMsg.getInstance():flashShow( "今天奖励已领取！" )
end


--清除所有可能的时钟
function M:clearAllClock( params )
	params = params or {}
	
	self:clearClock()
	if not params.noWine then
		DATA_Activity:delWineData()		--清除对酒数据，以停止时钟
	end
	
	Clock:removeTimeFun( "wineClock" )
	Clock:removeTimeFun( "payTime" )
	Clock:removeTimeFun( "newest_free_lottery" )
	Clock:removeTimeFun( "boss_fight_cold" )
	Clock:removeTimeFun( "boss_start" )
	self:delHandler()
end







return M