--帮派任务
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")

function M:show()
	local data = ACTIVITY:getData()
	local text = {}		--任务文字
	local textFlag = {}	--是否完成标记
	local completeNum = 0
	
	local scroll = KNScrollView:new( 0 , 120 , 480 , 96 + 370 , 5 , false )
	local function createPage( index )
		if ACTIVITY.awardProp then
			for i ,v in pairs(ACTIVITY.awardProp) do
				v:removeFromParentAndCleanup(true)	-- 清除自己
			end
		end
		
		local award = data.award
		
		--文字设置
		ACTIVITY.taskText = {}
		local condition = data.config.condition
		local isEnable = true
		for i = 1 , #condition do
			local curData = condition[i]
			if i <= #condition then
				local completeState = "  (".. curData.cur .. "/" .. curData.max ..")"
				text[i]:setString( i .. ":" .. curData.str .. completeState)
				if curData.cur >= curData.max then
					text[i]:setColor( ccc3( 0xef , 0x00 , 0x00 ) )
					textFlag[i]:setVisible( true )
					completeNum = completeNum + 1
				else
					text[i]:setColor( ccc3( 0x2c , 0x00 , 0x00 ) )
					textFlag[i]:setVisible( false )
					isEnable = false 
				end
			else
				text[i]:setString( "" )
				textFlag[i]:setVisible( false )
			end
		end
	end
	
	ACTIVITY:baseLayout( { line = {} , frame = {} } )
	local layer = display.newLayer()
	layer:setContentSize( CCSizeMake( 480 , 370 ) )
	local baseY = 10
	ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 20 , 585 , 0 , 0 ) )	--活动时间
	ACTIVITY.viewLayer:addChild( display.strokeLabel( data.endtime or "" , 120 , 588 , 20, ccc3( 0x2c , 0x00 , 0x00 )  ) )	--活动时间
	
	local shade1 = display.newSprite( PATH .. "shade5.png" )
	setAnchPos( shade1 , display.cx , 0 , 0.5 )
	layer:addChild( shade1 )
	
	local todayTitle = display.newSprite( PATH .. "task_text.png" )
	setAnchPos(todayTitle , 40 , (device.platform == "wp8" and shade1:getPositionY() or shade1.y) + shade1:getContentSize().height - 20 , 0 , 0 )
	layer:addChild( todayTitle )
	
	
	for i = 1 , table.nums( data.config.condition ) do
		text[i] = display.strokeLabel( "" , 70, 545 - i * 30 - 210 , 18, ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , { dimensions_width = 390 , dimensions_height = 30 , align = 0 } )
		layer:addChild( text[i] )
		
		textFlag[i] = display.newSprite( PATH .. "complete_flag.png")
		setAnchPos( textFlag[i] , 48, 561 - i * 30 - 210 )
		layer:addChild( textFlag[i] )
	end
	
	
	
	createPage( 1 )
	
	local function awardGroup( tempData , index )
		local groupLayer = display.newLayer()
		groupLayer:addChild( display.newSprite( PATH .. "shade1.png" , 0 , 0 , 0 , 0 ) )
		groupLayer:addChild( display.newSprite( PATH .. "task_num_title.png" , 44 , 112 , 0 , 0.5 ) )
		groupLayer:addChild( display.strokeLabel( tempData.times , 130 , 96 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , { dimensions_width = 25 , dimensions_height = 30 , align = 1 } ) )
		
		local awardsData = tempData.awards
		for i = 1 , #awardsData do
			local awardProp = awardCell( awardsData[i] , { parent = scroll } )
			
			setAnchPos( awardProp , 50 + ( i - 1 ) * 97 , 20 , 0 , 0 )
			groupLayer:addChild( awardProp )
		end
			
		--领取按钮
		local isEnable = completeNum >= tonumber( tempData.times )
		local isComplete = false
		for i = 1 , table.nums( data.received ) do 
			if tonumber( data.received[i] ) == index then
				isComplete = true
			end
		end
		
		local textData =  { "(" .. ( isComplete and 1 or 0 ) .. "/1)" , 16 , ccc3( 0x2c , 0x00 , 0x00 ), ccp( 0 , -35 ) , nil , 17 } 
		local getBtn = KNBtn:new( COMMONPATH , 
			isEnable and ( isComplete and { "btn_bg_dis.png" } or { "btn_bg.png" ,"btn_bg_pre.png"} )  or { "btn_bg_dis.png" } , 
			330 , 45 ,
			{
				priority = -130,
				parent = scroll ,
				front = COMMONPATH .. ( isEnable and  ( isComplete  and "get_complete.png" or "get.png" ) or"get_grey.png"  ) ,
				text = textData  ,
				callback = 
				function()
					if isEnable and not isComplete then
						if isBagFull() then
						    return false
						end
						HTTP:call("activity", "receive_allianceachieve", { typeid = data.typeid , index = index },{success_callback = 
						function()
							ACTIVITY:getAction( { awardProp = ACTIVITY.awardProp , onComplete = function() ACTIVITY:selectActivity() end } )
						end})
					else
--						KNMsg.getInstance():flashShow( "当前任务未完成不可领取！" )
					end
				end
			}):getLayer()
		groupLayer:addChild( getBtn )
		
		groupLayer:setContentSize( CCSizeMake( 460 , 120 ) )
		return groupLayer
	end
	
	scroll:addChild( layer )
	for i = 1 , table.nums( data.config.awards ) do
		local curGroup = awardGroup( data.config.awards[ i .. "" ] , i )
		scroll:addChild( curGroup )
	end
	scroll:alignCenter()
	ACTIVITY.viewLayer:addChild(scroll:getLayer() )
end
return M
