--每日签到
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local CURPATH = PATH .. "new_sign_in/"
local data = ACTIVITY:getData()
local tab_config = { 3 , 7 , 12 , 18 , 27 }
local cur_tab = 1
function M:get_days(year, month)        --获取指定年月的天数和第一天的星期
    local bigmonth = "(1)(3)(5)(7)(8)(10)(12)"
    local strmonth = "%(" .. month .. "%)"
    local week = os.date("*t", os.time{year = year, month = month, day = 1})["wday"]
    if month == 2 then
        if year % 4 == 0 then
            return 29, week
        else
            return 28, week
        end
    elseif string.find(bigmonth, strmonth) ~= nil then
        return 31, week
    else
        return 30, week
    end
end

function M:get_frame(params)
	local dayFrame = display.newSprite( CURPATH .. "frame.jpg" , params.x or 0 , params.y or 0 , 0 , 0 )

    local frameSize = dayFrame:getContentSize()

    local dayText = display.strokeLabel( params.num or "" , 0 , 0 , 18,  params.gray and ccc3(121,121,121) or ccc3( 255 , 255 , 255 ) )
    setAnchPos( dayText , frameSize.width/2 , frameSize.height/2 , 0.5 , 0.5 )
    dayFrame:addChild( dayText )


    if params.sign_type then 
        if params.sign_type == "sign" then 
            dayFrame:addChild( display.newSprite( CURPATH .. "normal_sign.png" , frameSize.width / 2 , frameSize.height / 2 , 0.5 , 0.5 ) )
        elseif params.sign_type == "repair_sign" then 
            dayFrame:addChild( display.newSprite( CURPATH .. "repair_sign.png" , frameSize.width / 2 , frameSize.height / 2 , 0.5 , 0.5 ) )
        end
    end

    return dayFrame
end

function M:get_calendar_layer(year, month, days, week) 
    
    local calendarLayer = display.newLayer()
    local lastdays , daycnt = 0 , week + days > 35 and  42 or 35        --lastdays 上个月的总天数    daycnt :  表格一共有多少天
    local startX , startY , marginX , marginY = 38 , daycnt == 42 and 501 or 486 , 59 , 33
    local x , y  = startX , startY
    local str_month = string.format( "%02d" , month )
    local sign_day = data.received or {}
    local repair_day = data.b_day_list or {}
    -- local repair_day = { 20 , 21 , 23 }

    local sign_day_str , repair_day_str = "" , ""

    for i=1,#sign_day do
        sign_day_str = sign_day_str .. "("..sign_day[i]..")"
    end
    print("sign_day_str = " ..sign_day_str)
    for i=1,#repair_day do
        repair_day_str = repair_day_str .. "("..repair_day[i]..")"
    end

    if month > 1 then 
   		lastdays = self:get_days(year ,month-1 )
    else
   		lastdays = self:get_days(year-1,12)
   	end

   	for i = 1 , week-1 do                                               --上个月的日期
   		calendarLayer:addChild( self:get_frame( { num = lastdays - (week-1) + i , x = x , y = y ,gray = true} ) )
   		x = x + marginX
   	end


    local day = week 

    for i = 1, days do

        local sign_type , findStr = "" , "%("..i.."%)"
        if string.find( sign_day_str , findStr ) ~= nil  then 
            sign_type = "sign"
        elseif string.find( repair_day_str , findStr ) ~= nil then 
            sign_type = "repair_sign"
        end

        calendarLayer:addChild( self:get_frame( { num = i , x = x , y = y , sign_type = sign_type} ) )

         if day % 7 == 0 then
            x = startX
            y = y - marginY
        else
            x = x + marginX
        end

        day = day + 1
       
    end

    for i = week + days , daycnt  do                                      --下个月的日期
    	calendarLayer:addChild( self:get_frame( { num = i - (week+days) + 1 , x = x , y = y ,gray = true} ) )
    	if i % 7 == 0 then
            x = startX
            y = y - marginY
        else
            x = x + marginX
        end

        i = i + 1
    end

    return calendarLayer
end

function M:get_signLayer()              --获得 签到的弹出层

    local repairLayer = display.newLayer()
    local offSetY = -40
    local sign_award_data = data.sign_in_award

    repairLayer:addChild( display.newSprite( CURPATH.."tip_bg.png" , display.cx , 389 + offSetY, 0.5 , 0 ) )
    repairLayer:addChild( display.newSprite( CURPATH.."today_sign.png" , 105 , 428 + offSetY, 0 , 0 ) )
    
    for i=1,#sign_award_data.award do
         local curProp = awardCell( sign_award_data.award[i]  )
         setAnchPos( curProp , 255 + ( i - 1 ) * 100 , 404 + offSetY)
         repairLayer:addChild( curProp )
    end

    if tonumber(sign_award_data.vip) ~= 0 then               -- 二四六  没有双倍奖励
        repairLayer:addChild( display.strokeLabel( "V"..sign_award_data.vip.."及以上可以获得双倍奖励" , 115 , 362 + offSetY, 20, ccc3( 0 , 0 , 0 ) ) )
    end

    showTip({
      content = repairLayer,
      center = {
        remove = true,
        callback = function() 
            HTTP:call("activity", "receive_daily_attendance", {} ,{
                  success_callback = function(data)
                      KNMsg.getInstance():flashShow( "签到成功，签到次数+1" )
                      self:refresh(data)
                  end
            })
        end
      },
      close = {
        normal = "back_img.png",
        pre = "back_img_press.png",
      },
    })

end

function M:get_repairLayer()                --获得 补签的弹出层

    local signLayer = display.newLayer()

    local offSetY = -40

    signLayer:addChild( display.newSprite( CURPATH.."tip_bg.png" , display.cx , 384 + offSetY, 0.5 , 0 ) )
    signLayer:addChild( display.newSprite( CURPATH.."r_u_sure.png" , display.cx , 440 + offSetY, 0.5 , 0 ) )
    
    signLayer:addChild( display.strokeLabel( data.gold or "" , 189 , 440 + offSetY, 18, ccc3( 0 , 0 , 0 ) ) )
    signLayer:addChild( display.strokeLabel( "（每日限补签一次）" , 80 , 397 + offSetY, 20, ccc3( 0 , 0 , 0 ) ) )


    showTip({
      content = signLayer,
      center = {
        remove = true,
        callback = function() 
             HTTP:call("activity", "receive_daily_attendance_bq", {} ,{
                  success_callback = function(data)
                        KNMsg.getInstance():flashShow( "补签成功，签到次数+1" )
                        self:refresh(data)
                  end
            })
        end
      },
      close = {
        normal = "back_img.png",
        pre = "back_img_press.png",
      },
    })

end

function M:refresh(data)                --刷新数据
    DATA_Activity:set_type(data)
    inform( data )
    ACTIVITY:selectActivity( DATA_Activity:getCurType(), { cur_tab = cur_tab} )
end

function M:show(params)
    dump(data , "data")
    cur_tab = params and params.cur_tab or 1            --每次刷新界面的时候保存 选中的tab

    data = ACTIVITY:getData()
    ACTIVITY:baseLayout({ line = {} })

    -- local curyear  = os.date("*t")["year"]              --当前年份
    -- local curmonth = os.date("*t")["month"]             --当前月份
    -- local curday   = os.date("*t")["day"]               --当前日期
    -- local cruweek  = os.date("*t")["wday"]              --当前星期

    local cur_date = string.split( data.day.."" , "-" )
    local curyear , curmonth , cur_day = tonumber(cur_date[1]) , tonumber(cur_date[2]) , tonumber(cur_date[3])          --当前年 月 日 由服务器传过来
    local days , week = self:get_days(curyear,curmonth)

    local pkgameLayer = display.newLayer()

    pkgameLayer:addChild( display.newSprite( CURPATH .. "bg.png" , display.cx , 92 , 0.5, 0 ) )
    pkgameLayer:addChild( display.newSprite( CURPATH .. "day_bg.png" , display.cx , 326 , 0.5, 0 ) )

    local month_bg = display.newSprite( CURPATH .. "month_bg.png" , 20 , 582 , 0  ,0 )
    pkgameLayer:addChild(month_bg )
      
    local frames = display.newFramesWithImage( CURPATH.."shuzi.png" , 12 )
    local monthImg = display.newSpriteWithFrame(frames[curmonth] , 20 , month_bg:getContentSize().height  / 2 )
    setAnchPos( monthImg , 20 , month_bg:getContentSize().height  / 2  , 0 , 0.5 )
    month_bg:addChild( monthImg )

    month_bg:addChild( display.newSprite( CURPATH .. "month_text.png" , 65 , month_bg:getContentSize().height  / 2 , 0 , 0.5 ) )

    pkgameLayer:addChild( self:get_calendar_layer(curyear,curmonth,days,week ) )

    pkgameLayer:addChild( display.newSprite( CURPATH .. "signed_cnt.png" , 30 , 283 , 0  , 0 ) )
    pkgameLayer:addChild( display.strokeLabel( data.received_count or "" , 156 , 283 , 24, ccc3( 255 , 255 , 255 ) ) )

    local is_repair = not data.b_received

    local repair_sign_btn = KNBtn:new( COMMONPATH , is_repair and {"long_btn_grey.png"} or { "long_btn.png" , "long_btn_pre.png"} , 210 , 275 , {               --补签按钮
        front = CURPATH .. (is_repair and "already_repair_text.png" or  "repair_text.png"),
        callback = function()
            if tonumber(data.b_day) == 0 then 
                KNMsg:getInstance():flashShow("当前不需要补签")
                return 
            end

            self:get_repairLayer()
        end
    } )
    repair_sign_btn:setEnable(not is_repair)
    pkgameLayer:addChild( repair_sign_btn:getLayer() )

    local is_sign = false
    for _, v in pairs(data.received) do
        if cur_day == tonumber(v) then 
            is_sign = true
        end
    end

    local sign_btn = KNBtn:new( COMMONPATH , is_sign and {"long_btn_grey.png"} or { "long_btn.png" , "long_btn_pre.png"} , 338 , 275 , {                    --签到按钮
        front = CURPATH .. (is_sign and "already_sign_text.png" or "sign_text.png"),
        callback = function()
             self:get_signLayer()
        end
    } )
    sign_btn:setEnable(not is_sign)
    pkgameLayer:addChild( sign_btn:getLayer() )

    local awardLayer
    local function refreshAwardLayer(count)                     --奖励层
        if awardLayer then 
            awardLayer:removeSelf()
        end

        awardLayer = display.newLayer()

        local awardData = data.config[ count.."" ]

        for i=1,#awardData.award do
             local curProp = awardCell( awardData.award[i] , {priority = -129} )
             setAnchPos( curProp , 53 + ( i - 1 ) * 100 , 138 )
             awardLayer:addChild( curProp )
        end

        local isGet = false

        for k,v in pairs(data.gift_received) do
            if v == count then isGet = true end
        end

        local get_btn = KNBtn:new( COMMONPATH , isGet and {"long_btn_grey.png"} or { "long_btn.png" , "long_btn_pre.png"} , 343 , 147 , {
              front = COMMONPATH .. (isGet and "get_over.png" or "get.png"),
              callback = function()
                 HTTP:call("activity", "receive_daily_attendance_gift", { index = count } ,{
                          success_callback = function(data)
                               self:refresh(data)
                          end
                     })
              end
        })
        get_btn:setEnable(not isGet)
        awardLayer:addChild( get_btn:getLayer() )
        pkgameLayer:addChild( awardLayer )
    end


    local group = KNRadioGroup:new()

    for i = 1 , #tab_config do                                  
        local tempBtn = KNBtn:new(CURPATH,{"tab.png","tab_selected.png"} , 32 + (i-1)*83 , 226 ,{
            disableWhenChoose = true,
            upSelect = true,
            id = i,
            front = CURPATH.."cout_"..tab_config[i]..".png",
            callback = function()
                cur_tab = i
                refreshAwardLayer( tab_config[cur_tab] )
            end
          },group):getLayer()
          
        pkgameLayer:addChild( tempBtn )
    end

    pkgameLayer:addChild( display.newSprite( CURPATH .. "award_bg.png" , display.cx , 117 , 0.5 , 0 ) )

    refreshAwardLayer( tab_config[cur_tab] ) 
    group:chooseByIndex(cur_tab)

    ACTIVITY.viewLayer:addChild( pkgameLayer )
 
end
return M
