--先到先得
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")



function M:show( params )
	params = params or {} 
	local topParams = params
	local parentLayer = params.parentLayer or ACTIVITY.viewLayer
	local isParent = params.parentLayer and true or false
	local parentLayreOffY = 0
	local curLayer = display.newLayer()
	local data = nil
	if params.parentLayer then
		data = params.data
		parentLayreOffY = 25
		setAnchPos( curLayer , 0 , parentLayreOffY , 0 , 0  )
	else
		data = ACTIVITY:getData()
		--dump(data)
		ACTIVITY:baseLayout({ line = {} })
	end
	parentLayer:addChild( curLayer )
	
	local isFirstItem = true

	local function createItem( params )

		params = params or {}
		--dump(params)

		local layer = display.newLayer()
		
		local bg = display.newSprite( PATH .."firstComeItemBg.png" )
		setAnchPos( bg , 0 , 0 )
		layer:addChild( bg )
		
		local lvBg = display.newSprite( PATH .. "firstComeItemTitle.png" )
		setAnchPos( lvBg , 60 , 105 )
		bg:addChild( lvBg )
		
		
		local lvGiftText = display.strokeLabel( params.data.content, 125, 110 , 18, ccc3( 89, 207, 253) , nil , nil , { dimensions_width = 180 , dimensions_height = 25 , align = 1 } )
		bg:addChild( lvGiftText )
		
		local itemAwardData = params.data.award
		local awardProp = {}
		for i = 1 , #itemAwardData do
			local curProp = awardCell( itemAwardData[i] )
			setAnchPos( curProp , 28 + ( i - 1 ) * 85 , 17 )
			layer:addChild( curProp )
			awardProp[ #awardProp + 1 ] = curProp
		end
		
		--received 0 未达条件,1 未领但可以领取, 2 已领  |(额外的状态,资源已领完不可领)
		local isOk = false --是否可以领取奖励
		local btnImg = {"btn_bg.png" ,"btn_bg_pre.png"}
		local frontImg = "get.png"

		if params.data.received ==0 then
			btnImg={"btn_bg_dis.png"}
			frontImg="get_grey.png"
		elseif params.data.received==1 then
			btnImg={"btn_bg.png" ,"btn_bg_pre.png"}
			frontImg = "get.png"
			isOk=true
		elseif params.data.received==2 then
			btnImg={"btn_bg_dis.png"}
			frontImg="get_over.png"
		elseif params.data.num==params.data.max then --30份已领完
			btnImg={"btn_bg_dis.png"}
			frontImg="get_grey.png"
		end
		
		local getBtn = KNBtn:new( COMMONPATH , 
			btnImg,
			330 , 
			40 ,
			{
				priority = -130,
				front = COMMONPATH ..frontImg ,
				callback = 
				function()
					if isOk then
						if isBagFull() then
						    return false
						end
						HTTP:call("activity", "receive_firstcome", {  index = params.id },{success_callback = 
						function(data)
							--dump(data)
							
							ACTIVITY:getAction( { awardProp = awardProp , onComplete = function()  									
									if isParent then 
										curLayer:removeFromParentAndCleanup(true)
										topParams.refreshFun()
									else
										ACTIVITY:selectActivity() 
									end   
								end } )
						end})
					else
--						KNMsg.getInstance():flashShow( "今天奖励已领取！" )
					end
				end
			})
		layer:addChild( getBtn:getLayer() )

		--剩余份数
		local leastNumsSp = display.newSprite(PATH.."leastNums.png",330,25)
		layer:addChild(leastNumsSp)

		local leastNumsLab = display.strokeLabel( params.data.num.."/"..params.data.max, 378, 13, 20, ccc3(0xff, 0xfb, 0xd4))
		layer:addChild(leastNumsLab)
		
		if isFirstItem  and isParent then
			isFirstItem = false
			layer:setContentSize( CCSize( bg:getContentSize().width , bg:getContentSize().height + parentLayreOffY ) )
		else
			layer:setContentSize( bg:getContentSize() )
		end


		return layer , getBtn
	end





	local isNew = ( ( data.endtime and  data.endtime ~= "" ) and true or false )
	
	if isNew and not isParent then
		curLayer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 20 , 595 + 12 , 0 , 0 ) )	--活动时间
		curLayer:addChild( display.strokeLabel( data.endtime or "" , 120 , 598 + 12 , 20, ccc3( 0xfe , 0xfc , 0xd3 )  ) )	--活动时间
	end

	local scroll = KNScrollView:new( 0, 94 + parentLayreOffY , 480, 510 + parentLayreOffY , 10 , false )
	-- local sort = {}
	-- for key , v in pairs(data.config) do
	-- 	sort[ #sort + 1 ] = key
	-- end
	-- local sortFunc = function(a, b) return tonumber( b ) > tonumber( a ) end
	-- table.sort(sort, sortFunc)

	guide_btn = nil
	
	for i = 1 , #data.config do
		local curData = data.config[i]
		local item , getBtn = createItem({ id=(i-1) ,data = curData })
		scroll:addChild( item )

		if i == 1 and KNGuide:getStep() == 10103 then
			guide_btn = getBtn
		end
	end
	scroll:alignCenter()
	curLayer:addChild(scroll:getLayer() )
	
	if guide_btn then
		local btn_range = guide_btn:getRange()
		KNGuide:show( guide_btn:getLayer() , {
			x = btn_range:getMinX(),
			y = btn_range:getMinY(),
			remove = true,
			callback = function()
				-- GLOBAL_INFOLAYER:refreshBtn()
			end
		})
	end
end
return M
