--万元话费
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")

function M:show()
	local data = ACTIVITY:getData()
	
	thiz = ACTIVITY
	local workpath = PATH .. "leveling_gifts/"
	ACTIVITY:baseLayout( { line = {} } )
	
	-- 条目背景
	ACTIVITY.viewLayer:addChild( display.newSprite( workpath .. "scroll_bg.png", display.cx, 103, 0.5, 0 ) )
	ACTIVITY.viewLayer:addChild( display.newSprite( workpath .. "img_bg.jpg", display.cx, 103, 0.5, 0 ) )
	
	------------------------
	local isNew = ( ( data.endtime and  data.endtime ~= "" ) and true or false )
	if isNew then
		ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 60, 585 , 0, 0 ) )	--活动时间
		ACTIVITY.viewLayer:addChild( display.strokeLabel( data.endtime or "", 160, 578 + 10, 20, ccc3( 0xfe, 0xfc, 0xd3 )  ) )	--活动时间
	end
	------------------------
	
	-- 剩余可用话费点
	ACTIVITY.viewLayer:addChild( display.newSprite( workpath .. "tip_bg.png" , 40, 337, 0, 0 ) )
	ACTIVITY.viewLayer:addChild( display.newSprite( workpath .. "remain.png" , 60, 347, 0, 0 ) )
	ACTIVITY.viewLayer:addChild( display.strokeLabel( tostring(data.calls_num), 240, 347, 20, ccc3( 0xfe, 0xfc, 0xd3 ) ) )
	
	-- 获取规则
	local helpBtn = KNBtn:new(COMMONPATH , {"btn_bg.png", "btn_bg_pre.png"}, 315, 340,
	{
		front = workpath .. "gain.png",
		callback = function()
			local mask = baseMask( {isConfirm = true, bgInfo = { path = COMMONPATH .. "bg_smaller.png" ,  y = 136 } } )
			-- 规则
			local rule = 	"1.每升一级可获得5点积分\n2.等级达到15级后，可开始使用积分兑换黄金，兑换黄金不限次数\n3.兑换的黄金会即时到账"
						 
			mask:addChild( display.strokeLabel( rule, 40, 216, 18, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
			{
				dimensions_width = 388,
				dimensions_height = 480,
				align = 0,
			}) )
		end
	})
	ACTIVITY.viewLayer:addChild( helpBtn:getLayer() )
	
	-- scroll view
	local createItem = function(params)
		local layer = display.newLayer()
		
		local bg = display.newSprite(workpath .. "item_bg.png")
		setAnchPos(bg, 0, 0)
		layer:addChild(bg)
		layer:setContentSize( bg:getContentSize() )
		
		-- tip
		layer:addChild( display.newSprite(workpath .. params.tip, 40, 60, 0, 0) )
		
		-- 兑换按钮
		local exchangeBtn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png", }, 260, 50,
		{
			front = COMMONPATH .. "xchange.png",
			callback = function()
				local mask = baseMask()
				
				-- -- 二次确认
				-- mask:addChild( display.strokeLabel( params.confirm, 60, 420, 20, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
				-- {
				-- 	dimensions_width = 343,
				-- 	dimensions_height = 100,
				-- 	align = 0,
				-- }) )

				if tonumber(params.phoneCard) == 50 then
					mask:addChild( display.strokeLabel( data.show_config["25"], 60, 450, 20, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
					{
						dimensions_width = 343,
						dimensions_height = 100,
						align = 0,
					}) )
				elseif tonumber(params.phoneCard) == 100 then
					mask:addChild( display.strokeLabel( data.show_config["35"], 60, 450, 20, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
					{
						dimensions_width = 343,
						dimensions_height = 100,
						align = 0,
					}) )
				else
					mask:addChild( display.strokeLabel( params.confirm, 60, 420, 20, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
						{
							dimensions_width = 343,
							dimensions_height = 100,
							align = 0,
						}) )

				end
				
				-- 确定按钮
				local confirmBtn
				confirmBtn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png", }, 80, 390,
				{
					priority = -131,
					front = COMMONPATH .. "confirm.png",
					callback = function()
						mask:remove()
						
						if params.phoneCard then
							HTTP:call("activity", "receive_leveling_gifts_calls", { num = params.phoneCard },
							{
								success_callback = function(response)
									thiz:selectActivity("leveling_gifts")
									KNMsg:getInstance():flashShow( "兑换成功,话费将于7个工作日内充值到您绑定的手机号码内!" )
								end
							})
						else
							HTTP:call("activity", "receive_leveling_gifts_calls_gold", nil,
							{
								success_callback = function(response)
									thiz:selectActivity("leveling_gifts")
								end
							})
						end
					end
				})
				mask:addChild( confirmBtn:getLayer() )
				
				-- 取消按钮
				local cancelBtn
				cancelBtn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png", }, 250, 390,
				{
					priority = -131,
					front = COMMONPATH .. "cancel.png",
					callback = function()
						mask:remove()
					end
				})
				mask:addChild( cancelBtn:getLayer() )
			end
		})
		layer:addChild( exchangeBtn:getLayer() )
		
		-- 本服剩余
		if params.remain then
			local bg = display.newSprite(workpath .. "remain_num_bg.png", 270, 8, 0, 0)
			layer:addChild(bg)
			local remain_num = display.strokeLabel( "当前剩余" .. params.num .. "张", 10, 4, 18, ccc3(0xff, 0xff, 0xff) )
			bg:addChild(remain_num)
			
		end
		
		return layer
	end
	
--	local scroll = KNScrollView:new(17, 160, 444, 378, 5, false)
	
	local itemConfig =
	{
		{ tip = "point_1.png",  remain = false, confirm = "剩余" .. data.calls_num .. "积分点，共计可兑换" .. data.calls_num * 15 .. "黄金，是否兑换？", },
		{ tip = "point_50.png", remain = true, num = data.calls_50, confirm = "兑换50元话费将消耗50话费点，是否兑换？", phoneCard = 50, },
		{ tip = "point_80.png", remain = true, num = data.calls_100, confirm = "兑换100元话费将消耗80话费点，是否兑换？", phoneCard = 100, },
	}
	
	local item = createItem(itemConfig[1])
	setAnchPos(item,20,180,0.5)
	ACTIVITY.viewLayer:addChild(item)
	
--	for i = 1, #itemConfig do
--		local item = createItem(itemConfig[i])
--		scroll:addChild(item)
--	end
	
--	scroll:alignCenter()
--	ACTIVITY.viewLayer:addChild( scroll:getLayer() )
	
--	-- 绑定手机号
--	ACTIVITY.viewLayer:addChild( display.newSprite( workpath .. "phone_number.png" , 60, 120, 0, 0 ) )
--	local phone_number = display.strokeLabel( (data.mobile == 0) and "未绑定" or tostring(data.mobile), 170, 125, 20, ccc3( 0xfe, 0xfc, 0xd3 )  )
--	ACTIVITY.viewLayer:addChild( phone_number )
	
--	-- 绑定按钮
--	local bindBtn
--	bindBtn = KNBtn:new(COMMONPATH , {"btn_bg.png", "btn_bg_pre.png", "btn_bg_grey.png"}, 310, 120,
--	{
--		front = workpath .. "bind.png",
--		callback = function()
--			local mask = baseMask()
--				
--			-- 提示信息
--			local tips = "为保证话费正常到账，请输入正确的手机号码！"
--			mask:addChild( display.strokeLabel( tips, 60, 470, 20, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
--			{
--				dimensions_width = 343,
--				dimensions_height = 100,
--				align = 0,
--			}) )
--			
--			-- 手机号输入框
--			local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
--			local inputText
--			
--			local openSoftKeyboard = function()
--				inputText:startInput()
--			end
--			local closeSoftKeyboard = function()
--				inputText:stopInput()
--			end
--			
--			local inputBgBtn = KNBtn:new(workpath, { "inputBg.png" }, 102, 450,
--			{
--				priority = -131,
--				--scale = true,
--				callback = function()
--					openSoftKeyboard()
--				end
--			})
--			mask:addChild( inputBgBtn:getLayer() )
--							
--			inputText = KNInputText:new(
--			{	
--				width = 365, 
--				height = 28, 
--				size = 20 , 
--				defStr = "请输入手机号", 
--				existStr = nil,
--				defColor = ccc3( 0x00, 0x00, 0x00 ), 
--				inputColor = ccc3( 0x4d, 0x15, 0x15 )
--			})
--			setAnchPos( inputText:getLayer() , 110, 473 )
--			mask:addChild( inputText:getLayer() )
--			
--			-- 确定按钮
--			local confirmBtn
--			confirmBtn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png", }, 80, 390,
--			{
--				priority = -131,
--				front = COMMONPATH .. "confirm.png",
--				callback = function()
--					
--					local input = inputText:getString()
--					if input == "" then
--						KNMsg:getInstance():flashShow( "手机号码不能为空!" )
--						return
--					end
--					
--					closeSoftKeyboard()
--					mask:remove()
--					
--					local mask = baseMask()
--					-- 二次确认
--					local tips = "您绑定的手机号为[" .. input .. "]，绑定后不能更改，是否绑定？"
--					mask:addChild( display.strokeLabel( tips, 60, 420, 20, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
--					{
--						dimensions_width = 343,
--						dimensions_height = 100,
--						align = 0,
--					}) )
--					
--					-- 确定按钮
--					local confirmBtn
--					confirmBtn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png", }, 80, 390,
--					{
--						priority = -131,
--						front = COMMONPATH .. "confirm.png",
--						callback = function()
--							mask:remove()
--							HTTP:call("activity", "receive_leveling_gifts_mobile", {mobile = input},
--							{
--								success_callback = function(response)
--									bindBtn:setEnable(false)
--									phone_number:setString(response.data.mobile)
--									KNMsg:getInstance():flashShow( "绑定成功!" )
--								end
--							})
--						end
--					})
--					mask:addChild( confirmBtn:getLayer() )
--				
--					-- 取消按钮
--					local cancelBtn
--					cancelBtn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png", }, 250, 390,
--					{
--						priority = -131,
--						front = COMMONPATH .. "cancel.png",
--						callback = function()
--							mask:remove()
--						end
--					})
--					mask:addChild( cancelBtn:getLayer() )
--				end
--			})
--			mask:addChild( confirmBtn:getLayer() )
--			
--			-- 取消按钮
--			local cancelBtn
--			cancelBtn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png", }, 250, 390,
--			{
--				priority = -131,
--				front = COMMONPATH .. "cancel.png",
--				callback = function()
--					closeSoftKeyboard()
--					mask:remove()
--				end
--			})
--			mask:addChild( cancelBtn:getLayer() )
--		end
--	})
--	ACTIVITY.viewLayer:addChild( bindBtn:getLayer() )
--	-- 已绑定不可点击
--	if data.mobile ~= 0 then bindBtn:setEnable(false) end
 
end
return M
