--充值奖励
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")

function M:show()
	local data = ACTIVITY:getData()
	ACTIVITY:baseLayout({ line = {} , frame = {} })
	local baseY = 107
	
	local todayBg = display.newSprite( PATH .. "payment_bg.png" )
	setAnchPos( todayBg , display.cx , baseY + 30 , 0.5 )
	ACTIVITY.viewLayer:addChild( todayBg )
	
	
	--充值按钮
	local payBtn = KNBtn:new( COMMONPATH , { "btn_bg.png" ,"btn_bg_pre.png"}, 357 , 510 ,
	{
		priority = -149,
		front = COMMONPATH .. "pay.png" ,
		callback = 
		function()
			switchScene("pay")
		end
	}):getLayer()
	ACTIVITY.viewLayer:addChild( payBtn )
	
	
	--累计充值黄金数
	local totalGold = display.strokeLabel( "您已累计充值黄金：" .. data.paygold , 115 , 517 , 18 , ccc3( 0xff , 0xfe , 0xfe ) , nil , nil , {
			dimensions_width = 250,
			dimensions_height = 25,
			align = 0
		})
	ACTIVITY.viewLayer:addChild( totalGold )
	
	
--	local timeText = {}
--	local function refreshTime()
--		local curTime = DATA_Activity:getPayTime()
--		if curTime < 0 then curTime = 0 end
--		for i = 1 , #timeText do
--			if timeText[i] then
--				timeText[i]:removeFromParentAndCleanup(true)
--				timeText[i] = nil
--			end
--		end
--		
--		if curTime <= 0 then
--			Clock:removeTimeFun( "payTime" , refreshTime )
--		end
--		
--		--天
--		local dayNum = math.floor( tonumber(timeConvert( curTime , "hour"))/24 )
--		timeText[1] = display.strokeLabel( dayNum  , 226 , 572 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) , nil , nil , {
--				dimensions_width = 25,
--				dimensions_height = 20,
--				align = 1
--			})
--		ACTIVITY.viewLayer:addChild( timeText[1] )
--		curTime = curTime - dayNum * 86400
--		
--		--时
--		timeText[2] = display.strokeLabel( math.mod( timeConvert( curTime , "hour") , 24 )  , 226 + 42 , 572 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) , nil , nil , {
--				dimensions_width = 25,
--				dimensions_height = 20,
--				align = 1
--			})
--		ACTIVITY.viewLayer:addChild( timeText[2] )
--		--分
--		timeText[3] = display.strokeLabel( timeConvert( curTime , "min")  , 226 + 42 + 42 , 570 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) , nil , nil , {
--				dimensions_width = 25,
--				dimensions_height = 20,
--				align = 1
--			})
--		ACTIVITY.viewLayer:addChild( timeText[3] )
--		--秒
--		timeText[4] = display.strokeLabel( timeConvert( curTime , "sec")  , 226 + 42 + 41 + 40 , 572 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) , nil , nil , {
--				dimensions_width = 25,
--				dimensions_height = 20,
--				align = 1
--			})
--		ACTIVITY.viewLayer:addChild( timeText[4] )
--		
--	end
--	Clock:addTimeFun( "payTime" , refreshTime )
--	上边注销的部分为未做优化前的代码，下面为优化后的代码
		
	local timeText = {}
	local timeX , timeY , offsetX = 226 , 572 , 41
	for i = 1 , 4 do
		timeText[i] = display.strokeLabel( ""  , timeX + ( i - 1 )* offsetX , timeY , 18 , ccc3( 0x2e , 0x00 , 0x03 ) , nil , nil , {
				dimensions_width = 25,
				dimensions_height = 20,
				align = 1
			})
		ACTIVITY.viewLayer:addChild( timeText[i] )
	end
	ACTIVITY:downTime( "payTime" , function() return DATA_Activity:getPayTime() end)

	
	local function createGet( index )
		local curData = data.config[index .. ""]
		
		local isOne = index == 1
		
		local costGold = tonumber( curData.condition ) - tonumber( data.paygold )
		local isEnable = costGold <= 0	--是否可领取
		costGold = isEnable and 0 or costGold	--保证不能出现负数
		
		
		local payGold = display.strokeLabel( costGold , 107 , isOne and 473 or 348 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) , nil , nil , {
			dimensions_width = 44,
			dimensions_height = 20,
			align = 1
		})
		ACTIVITY.viewLayer:addChild( payGold )
		
		
		for i = 1 , #curData.award do
			local curProp = awardCell( curData.award[i] )
			setAnchPos( curProp , 100 , isOne and 390 or 260 )
			ACTIVITY.viewLayer:addChild( curProp )
		end
		
		
		
		--领取按钮
		local isComplete = false
		if data.received then
			--是否已经领取
			for j = 1 , #data.received do
				if data.received[j] == tonumber( index ) then
					isComplete = true
					break
				end
			end
		end
		
		local getBtn = KNBtn:new( COMMONPATH , 
			isEnable and ( isComplete and { "btn_bg_red2.png" } or { "btn_bg_red.png" ,"btn_bg_red_pre.png"} )  or { "btn_bg_red2.png" } , 
			245 , 
			isOne and 400 or 274 ,
			{
				priority = -130,
				front = COMMONPATH .. ( isEnable and  (isComplete  and "get_complete.png" or "get.png") or ( isComplete and "get_complete.png" or "get_grey.png" ) ) ,
				callback = 
				function()
					if isEnable and not isComplete then
						if isBagFull() then
						    return false
						end
						HTTP:call("activity", "receive_payment", { typeid = data.typeid , index = index },{success_callback = 
						function()
							ACTIVITY:getAction( { awardProp = ACTIVITY.awardProp , onComplete = function() ACTIVITY:selectActivity() end } )
						end})
					end
				end
			}):getLayer()
		ACTIVITY.viewLayer:addChild( getBtn )
	end
	
	for i = 1 , table.nums( data.config ) do
		createGet( i )
	end
	
 
end
return M
