--五星英雄
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")

function M:show()
	local data = ACTIVITY:getData()
	ACTIVITY:baseLayout({ line = {} , frame = {} })
	
	local baseY = 107
	
	local isNew = ( ( data.endtime and  data.endtime ~= "" ) and true or false )
	
	if isNew then
		ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 20 , 585 , 0 , 0 ) )	--活动时间
		ACTIVITY.viewLayer:addChild( display.strokeLabel( data.endtime or "" , 120 , 588 , 20, ccc3( 0xfe , 0xfc , 0xd3 )  ) )	--活动时间
	else
		ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "down_time_tip.png" , display.cx , 558 , 0.5 , 0  ) )
	end
		
	ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "singlepaymax_tip".. ( isNew and "2" or "" ) .. ".png" , display.cx , 475 , 0.5 , 0  ) )
	local awardBg = display.newSprite( PATH .. "shade1.png" , display.cx , 275 , 0.5 , 0  ) 
	awardBg:setScaleY(1.4)
	ACTIVITY.viewLayer:addChild( awardBg )
	
	--今天奖励
	local awardProp = {}
	local curAward = data.config.award
	for i = 1 , #curAward do
		local curProp = awardCell( curAward[i] , { name = true ,  star = not isNew } )
		setAnchPos( curProp , ( isNew and 100 or display.cx ) + ( i - 1 ) * 94 - 33 , ( isNew and 320 or 340 ) )
		ACTIVITY.viewLayer:addChild( curProp )
		awardProp[ #awardProp + 1 ] = curProp
	end
	
	--充值与领取	
	local isPay =  tonumber( data.paynum ) < tonumber( data.config.paymax )
	local isGet =  tonumber( data.received ) ~= 1
	
	local getBtn = KNBtn:new( COMMONPATH , 
		isGet and { "btn_bg_red.png" ,"btn_bg_red_pre.png" , "btn_bg_red2.png" } or { "btn_bg_red2.png" } , 
		display.cx - 72 , 
		222 ,
		{
			priority = -130,
			front = COMMONPATH .. ( isPay and "quick_pay.png" or ( isGet and "quick_get.png" or "quick_get_gray.png") ) ,
			callback = 
			function()
				if isPay then
					pushScene("pay" , { closeFun = function() popScene() end })
				else
					if isGet then
						HTTP:call("activity", "receive_singlepaymax", { typeid = data.typeid },{success_callback = 
						function()
							ACTIVITY:getAction( { awardProp = awardProp , onComplete = function() ACTIVITY:selectActivity() end } )
						end})
					end
				end
			end
		})
	ACTIVITY.viewLayer:addChild( getBtn:getLayer() )
	


	

	
	if not isNew then
		local timeText = {}
		local timeX , timeY = 215 , 562
		for i = 1 , 4 do
			timeText[i] = display.strokeLabel( "00"  , timeX + ( i - 1 )* 50 , timeY , 18 , ccc3( 0x2e , 0x00 , 0x03 ) , nil , nil , {
					dimensions_width = 25,
					dimensions_height = 20,
					align = 1
				})
			ACTIVITY.viewLayer:addChild( timeText[i] )
		end
		
		
		ACTIVITY.viewLayer:addChild( display.strokeLabel( "活动说明:" , 54 , 186 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) ) )
		ACTIVITY.viewLayer:addChild( display.strokeLabel( replaceStr("1.单笔充值满30元即可获1个5星英雄锦囊") , 70 , 163 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) ) )
		ACTIVITY.viewLayer:addChild( display.strokeLabel( "2.请在活动结束前充值，仅此1次，切勿错过" , 70 , 141 , 18 , ccc3( 0x2e , 0x00 , 0x03 ) ) )
		--是否过期
		local function setStale()
			if DATA_Activity:getSinglepaymaxClock() <= 0  then
				getBtn:setEnable( false )
				getBtn:setFront( COMMONPATH .. "stale_grey.png")	
				ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "stale.png" , display.cx , 400 , 0.5 , 0  ) )
			end
		end	
		
		ACTIVITY:downTime( "singlepaymax" , timeText , function() 
														if DATA_Activity:getSinglepaymaxClock() > 0  then
															setStale()
														end
														return DATA_Activity:getSinglepaymaxDataTime() 
													end ) 
		setStale()
	end
	
	

 
end
return M
