--火影限时首充
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")

local PayMaxHyNewIndex = 0

if CHANNEL_ID == "tgxy.ydmm" or CHANNEL_ID == "tgxy3.ydmm" then 
	PayMaxHyNewIndex = 2 
else
	PayMaxHyNewIndex = 3
end

function M:show()
	local data = ACTIVITY:getData()
	
	local workpath = PATH .. "singlepaymax_hy_new/"
		
	ACTIVITY:baseLayout( { line = {} } )
	
	------------------------
	local isNew = ( ( data.endtime and  data.endtime ~= "" ) and true or false )
	if isNew then
		ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 20, 595, 0, 0 ) )	--活动时间
		ACTIVITY.viewLayer:addChild( display.strokeLabel( data.endtime or "", 120, 595, 20, ccc3( 0xfe, 0xfc, 0xd3 )  ) )	--活动时间
	end
	------------------------

	if device.platform ~= "wp8" then

		-- 获取帮助
		local helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png", "help_press.png"}, 370, 587,
		{
			callback = function()
				local mask = baseMask( {isShowBack = true, bgInfo = { path = IMG_PATH .. "image/scene/chat/" .. "info_bg_small.png",  y = 136 } } )
				-- 规则
				local rule = "1.首充大礼包3选1,仅限领取1次\n\n" ..
							 "2.首次充值相对应的金额即可领取对应的首充大礼包\n" ..
							 "    1≤首次充值金额＜30元可获得1元首充礼包\n" .. 
							 "    30元≤首次充值金额＜100元可获得30元首充礼包\n" ..	
							 "    首次充值金额≥100元可获100元首充礼包\n\n" .. 
							 "3.活动期间,仅限首次充值才能领取奖励"
				mask:addChild( display.strokeLabel( rule, 29, 137, 18, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
				{
					dimensions_width = 419,
					dimensions_height = 357,
					align = 0,
				}) )
			end
		})
		ACTIVITY.viewLayer:addChild( helpBtn:getLayer() )

	end

	--
		
	-- 条目背景
	ACTIVITY.viewLayer:addChild( display.newSprite( workpath .. "bg.png", display.cx, 130, 0.5, 0 ) )
	
	-- 说明
	ACTIVITY.viewLayer:addChild( display.strokeLabel( "说明：首充大礼包三选一，仅限领取一次。", 50, 100, 20, ccc3( 0xfe, 0xfc, 0xd3 ) ) )
	
	-- 选项组配置
	local itemConfig =
	{
		{
			index = 1,
			icon = {"copper_n.png", "copper_s.png"},
			title = { "首充1元礼包", 16, ccc3(0xff, 0xff, 0xff), {x = 0, y = -28} },
			pos = {x = 14, y = 453},
			price = workpath .. "yuan1.png",
			gold = workpath .. "gold688.png",
		},
		
		{
			index = 2,
			icon = {"silver_n.png", "silver_s.png"},
			title = { "首充30元礼包", 16, ccc3(0xff, 0xff, 0xff), {x = 0, y = -28} },
			pos = {x = 14, y = 313},
			price = workpath .. "yuan30.png",
			gold = workpath .. "gold2888.png",
		},
		
		{
			index = 3,
			icon = {"gold_n.png", "gold_s.png"},
			title = { "首充100元礼包", 16, ccc3(0xff, 0xff, 0xff), {x = 0, y = -28} },
			pos = {x = 14, y = 177},
			price = workpath .. "yuan100.png",
			gold = workpath .. "gold6888.png",
		},
	}

	local offsetY , margin = 0 , 0
	if CHANNEL_ID == "tgxy.ydmm" or CHANNEL_ID == "tgxy3.ydmm" then 
		offsetY = -50
		itemConfig[#itemConfig] = nil
	end
	
	local isPayed = data.paynum > 0
	
	for i, v in ipairs(data.received) do
		if v == 1 then PayMaxHyNewIndex = i break end
	end
	
	-- 选项组
	local buildItemView
	local group = KNRadioGroup:new()
	for i = 1, #itemConfig do
		local config = itemConfig[i]
		local itemBtn = KNBtn:new(workpath, config.icon, config.pos.x, config.pos.y + offsetY,
		{
			upSelect = true,
			disableWhenChoose = true,	-- 选中状态下再次点击本选项不再触发回调
			text = config.title,
			callback = function()
				PayMaxHyNewIndex = i
				if ACTIVITY.viewLayer.item then
					ACTIVITY.viewLayer.item:removeFromParentAndCleanup(true)	-- 清除自己
				end
				ACTIVITY.viewLayer.item = display.newLayer()
				ACTIVITY.viewLayer:addChild(ACTIVITY.viewLayer.item)
				buildItemView(ACTIVITY.viewLayer.item, config)
			end
		}, group)
		
		ACTIVITY.viewLayer:addChild( itemBtn:getLayer() )
	end
	
	buildItemView = function(itemView, config)
		itemView:addChild( display.newSprite(workpath .. "price.png", 195, 507, 0, 0) )
		itemView:addChild( display.newSprite(config.price, 250, 506, 0, 0) )
		
		itemView:addChild( display.newSprite(workpath .. "gold.png", 175, 470, 0, 0) )
		itemView:addChild( display.newSprite(config.gold, 225, 470, 0, 0) )
		
		itemView:addChild( display.newSprite(workpath .. "benefit.png", 205, 433, 0, 0) )
		
		-- 奖品
		itemView:addChild( display.newSprite(workpath .. "gift.png", 290, 364, 0.5, 0) )
		
		local award = data.config[config.index].award
		for i = 1, #award do
			local btn = awardCell(award[i])
			setAnchPos(btn, #award == 3 and (180 + ( i - 1 ) * 85) or (180 + ( i - 1 ) * 135) , 270)
			itemView:addChild(btn)
		end
		
		if isPayed then
			if data.received[config.index] == 1 then
				-- 可领取奖励
				local btn = KNBtn:new(COMMONPATH , {"long_btn.png", "long_btn_pre.png", "long_btn_grey.png"}, 240, 166,
				{
					front = COMMONPATH .. "quick_get.png",
					callback = function()
						HTTP:call("activity", "receive_singlepaymax_hy_new", { index = config.index - 1 },
						{
							success_callback = function(response)
								ACTIVITY:selectActivity("singlepaymax_hy_new")
							end
						})
					end
				})
				itemView:addChild( btn:getLayer() )
			elseif data.received[config.index] == 2 then
				-- 已经领取
				local btn = KNBtn:new(COMMONPATH , {"long_btn.png", "long_btn_pre.png", "long_btn_grey.png"}, 240, 166,
				{
					front = workpath .. "already_get.png",
					callback = function()
					
					end
				})
				itemView:addChild( btn:getLayer() )
				btn:setEnable(false)
			else
				-- 不能领取
				local btn = KNBtn:new(COMMONPATH , {"long_btn.png", "long_btn_pre.png", "long_btn_grey.png"}, 240, 166,
				{
					front = workpath .. "quick_pay_grey.png",
					callback = function()
					
					end
				})
				itemView:addChild( btn:getLayer() )
				btn:setEnable(false)
			end
		else
			-- 去充值
			local btn = KNBtn:new(COMMONPATH , {"long_btn.png", "long_btn_pre.png", "long_btn_grey.png"}, 240, 166,
			{
				front = COMMONPATH .. "quick_pay.png",
				callback = function()
					switchScene("pay")
				end
			})
			itemView:addChild( btn:getLayer() )
		end
	end
	
	group:chooseByIndex(PayMaxHyNewIndex, true)
 
end
return M
