--天界神树
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local ACTIVITY_PATH = IMG_PATH .. "image/scene/activity_new/tree/"

local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")



function M:show()
	local this = {}
	setmetatable(this,self)
	self.__index = self

	this.my_data = ACTIVITY:getData()

	
	ACTIVITY:baseLayout({ line = {} , frame = {} })
	
	this.layer = ACTIVITY.viewLayer
	
	this.layer:addChild( display.newSprite( ACTIVITY_PATH .. "tree.jpg" , 6 , 99 , 0 , 0 ) )
	this.layer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 20 , 650 , 0 , 0 ) )	--活动时间
	this.layer:addChild( display.strokeLabel( this.my_data.endtime or "" , 120 , 653  , 20, ccc3( 0xff , 0xff , 0xff )  ) )	--活动时间
	-- this.layer:addChild( display.strokeLabel( this.my_data.showcontent or "" , 195 , 599 , 20, ccc3( 0xff , 0xff , 0xff )  ) )	

	this.viewLayer = nil

	this:my()
end


function M:my()
	-- dump(self.my_data)

	if self.viewLayer ~= nil then
		self.viewLayer:removeFromParentAndCleanup(true)
		self.viewLayer = nil
	end

	self.viewLayer = display.newLayer()
	self.friends_showed = false
	self.friends_data = nil
	self.friends_layer = nil
	self.message_layer = nil

	-- 消息列表按钮
	local xiaoxi_btn = KNBtn:new(COMMONPATH , {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 320 , 592 , {
		front = ACTIVITY_PATH .. "xiaoxi.png",
		callback = function()
			self:showMessage()
		end
	})
	self.viewLayer:addChild(xiaoxi_btn:getLayer())

	-- 帮助按钮
	local help_btn = KNBtn:new(COMMONPATH , {"help.png" , "help_press.png"} , 25 , 592 , {				--帮助按钮
		scale = true,
		callback = function()
		 	local tempLayer = baseMask({  
				titlePath = COMMONPATH .. "help_title.png" , 
				bgInfo = { y = 270 ,  path = IMG_PATH  .. "image/scene/mission/wipe_bg.png" } , 
				isShowBack = { x = 35 , y = 565 , backFun = function() end } , 
				priority = -131
			})
						
			local scroll
			local strConfig = replaceStr(self.my_data.rules)
			local function createText()
				local helpTips = createLabel({str = strConfig , x = 60 , y = 55,size = 18, width = 340,color = ccc3(46 , 18 , 14)})
				return helpTips
			end
			
			scroll = KNScrollView:new( 68 , 293  , 380 , 275 , 10 ,  false , nil , { priority = -133 } )	
			scroll:addChild( createText() )
			
			tempLayer:addChild( scroll:getLayer() )
		end
	})
	self.viewLayer:addChild( help_btn:getLayer() )


	-- 成熟度
	local score_max = self.my_data.data.grow_max
	local score_cur = score_max - self.my_data.data.grow_cd
	local score_bar = KNBar:new("exp" , 88 , 730 , { closeText = true , maxValue = score_max  , curValue = score_cur  , color = ccc3( 255 , 255 , 255 ) })
	self.viewLayer:addChild( score_bar )

	local chengshu_text = display.strokeLabel( "成熟时间：" , 135 , 114  , 16 , ccc3( 0xff , 0xff , 0xff ))
	self.viewLayer:addChild(chengshu_text)

	local chengshu_timeText = display.strokeLabel("" , 230 , 114  , 16 , ccc3( 0xff , 0xff , 0xff ))
	self.viewLayer:addChild(chengshu_timeText)

	ACTIVITY:downTime("activity_tree_chengshu" , {chengshu_timeText} , function()
		self.my_data.data.grow_cd = self.my_data.data.grow_cd - 1
		if self.my_data.data.grow_cd <= 0 then
			self.my_data.data.grow_cd = 0

			-- chengshu_text:setVisible(false)
			-- chengshu_timeText:setVisible(false)
		end
		return self.my_data.data.grow_cd
	end , 2)
	

	-- 浇水按钮
	local jiaoshui_btn = KNBtn:new(COMMONPATH , {"btn_bg.png" , "btn_bg_pre.png"}, 20 , 142 , {
		front = ACTIVITY_PATH .. "jiaoshui.png",
		callback = function()
			HTTP:call("activity", "tree_water", { },{
				success_callback = function(ret_data)
					self.my_data = ret_data.data.data
					KNMsg.getInstance():flashShow( ret_data.msg )
					self:my()
				end
			})
		end
	})
	self.viewLayer:addChild(jiaoshui_btn:getLayer())

	local jiaoshui_text = display.strokeLabel( "浇水剩余时间：" , 120 , 152  , 20 , ccc3( 0xff , 0xff , 0xff ))
	self.viewLayer:addChild(jiaoshui_text)

	local jiaoshui_timeText = display.strokeLabel("" , 265 , 151  , 20 , ccc3( 0xff , 0xff , 0xff ))
	self.viewLayer:addChild(jiaoshui_timeText)

	ACTIVITY:downTime("activity_tree_jiaoshui" , {jiaoshui_timeText} , function()
		self.my_data.data.water_cd = self.my_data.data.water_cd - 1
		if self.my_data.data.water_cd <= 0 then
			self.my_data.data.water_cd = 0

			jiaoshui_text:setVisible(false)
			jiaoshui_timeText:setVisible(false)
		end
		return self.my_data.data.water_cd
	end , 2)


	-- 等级
	self.viewLayer:addChild( display.strokeLabel( "Lv " .. self.my_data.data.lv , 20 , 110  , 24, ccc3( 0xff , 0xff , 0xff )  ) )


	-- 好友按钮
	local haoyou_btn = KNBtn:new(COMMONPATH , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 328 , 107 , {
		front = ACTIVITY_PATH .. "haoyou.png",
		callback = function()
			self:showFriends()
		end
	})
	self.viewLayer:addChild(haoyou_btn:getLayer())


	-- 5个果实
	local award_pos = {
		{78 , 478},
		{159 , 383},
		{237 , 496},
		{24 , 348},
		{258 , 295},
	}

	--[[
	self.my_data.award.arr = {
		{cid = 6001 , num = 10},
		{cid = 9006 , num = 20},
		{cid = 9010 , num = 1},
		{cid = 16031 , num = 2},
		{cid = 16042 , num = 999},
	}
	]]

	for i = 1 , #self.my_data.award.arr do
		if award_pos[i] then
			local cur = awardCell( self.my_data.award.arr[i] , {
				ClickFun = function()
					HTTP:call("activity", "tree_harvest", { },{
						success_callback = function(ret_data)
							self.my_data = ret_data.data.data
							KNMsg.getInstance():flashShow( ret_data.msg )
							self:my()
						end
					})
				end
			})
			setAnchPos( cur , award_pos[i][1] , award_pos[i][2] )
			self.viewLayer:addChild( cur )

			self.viewLayer:addChild( display.newSprite( ACTIVITY_PATH .. "status_bg.png" , award_pos[i][1] + 31 , award_pos[i][2] - 20 ) )
			if self.my_data.data.grow_cd == 0 then
				self.viewLayer:addChild( display.newSprite( ACTIVITY_PATH .. "kezhai.png" , award_pos[i][1] + 30 , award_pos[i][2] - 20 ) )

				local frames = display.newFrames( COMMONPATH .. "effect/prop_wrap_light/%1d.png", 1 , 8 , false , true)
				self.viewLayer:addChild( display.playFrames(award_pos[i][1] + 32 , award_pos[i][2] + 34 , frames , 0.15 , {forever = true}) )
			else
				self.viewLayer:addChild( display.strokeLabel( "未成熟" , award_pos[i][1] + 7 , award_pos[i][2] - 29  , 16 , ccc3( 0xff , 0xff , 0xff )  ) )
			end
		end
	end


	self.layer:addChild(self.viewLayer)
end


-- 好友列表
function M:showFriends(offset , page)
	if self.friends_data == nil then
		HTTP:call("activity", "tree_get_friends", { },{
			success_callback = function(data)
				dump(data)
				self.friends_data = data
				self:showFriends(offset)
			end
		})
		return
	end

	if page ~= true and self.friends_showed == true then
		self.friends_layer:removeFromParentAndCleanup(true)
		self.friends_layer = nil

		self.friends_showed = false
		return
	end

	self.friends_showed = true
	
	if self.friends_layer ~= nil then
		self.friends_layer:removeFromParentAndCleanup(true)
		self.friends_layer = nil
	end

	self.friends_layer = display.newLayer()
	self.viewLayer:addChild(self.friends_layer)

	self.friends_layer:addChild( display.newSprite( ACTIVITY_PATH .. "friends_bg.png" , 360 , 325 ) )

	-- 显示好友列表
	local scroll
	
	scroll = KNScrollView:new( 273 , 203 , 190 , 270 , 7 ,  false , nil , { priority = -136 } )	

	local limit = 20
	offset = offset or 1
	if offset > #self.friends_data then offset = 1 + (math.ceil(#self.friends_data / limit) - 1) * limit end
	if offset < 1 then offset = 1 end
	-- print("offset: " .. offset)
	local end_offset = math.min(offset + limit - 1 , #self.friends_data)
	for i = offset , end_offset do
		local one = self.friends_data[i]

		local oneBtn = KNBtn:new( COMMONPATH , { getHeadPath(one.logo) } , 0 , 0 , {
			id = one.uid , 
			parent = scroll,
			noHide = true,
			upSelect = true,
			selectZOrder = 1,
			priority = -140,
			swallowsTouches = false,
			text = {one.name , 20 , ccc3( 0xff , 0xff , 0xff) , {x = 70 , y = -5}} , 
			callback = function()
				HTTP:call("activity", "get_friend_tree", {f_uid = one.uid} , {
					success_callback = function(ret_data)
						-- dump(ret_data)
						self:other(one.uid , ret_data)
					end
				})
			end
		})
		oneBtn:setBgScale(0.8)
		oneBtn:getLayer():setContentSize(CCSize(183 , 56))

		scroll:addChild( oneBtn:getLayer() , oneBtn )
	end
	
	self.friends_layer:addChild( scroll:getLayer() )

	-- 页码
	local pre_btn = KNBtn:new(PATH .. "friendInvite",{"next_page.png"}, 290, 168, {
		flipX = true,
		priority = -140,
		callback = function()
			self:showFriends(offset - limit , true)
		end
	})
	self.friends_layer:addChild(pre_btn:getLayer())
	pre_btn:setBgScale(0.7)

	local next_btn = KNBtn:new(PATH .. "friendInvite",{"next_page.png"}, 400, 168, {
		priority = -140,
		callback = function()
			self:showFriends(offset + limit , true)
		end
	})
	self.friends_layer:addChild(next_btn:getLayer())
	next_btn:setBgScale(0.7)

	local cur_page = math.floor(offset / limit) + 1
	local page_count = math.ceil(#self.friends_data / limit)
	if page_count < 1 then page_count = 1 end
	local pageNum = display.strokeLabel( cur_page .. "/" .. page_count , 0 , 0 , 20, ccc3(0xff, 0xff, 0xff))
	setAnchPos(pageNum, 360 , 173 , 0.5)
	self.friends_layer:addChild(pageNum)

	-- 屏蔽事件
	self.friends_layer:registerScriptTouchHandler(function(type,x,y)
		if x >= 250 and y >= 167 and x <= 470 and y <= 490 then
			return true
		else
			return false
		end
	end , false , -135 , true)
	self.friends_layer:setTouchEnabled(true)

	self.friends_layer:setContentSize(CCSize(208 , 332))
end


function M:hideFriends()
	if self.friends_showed == true then
		self.friends_layer:removeFromParentAndCleanup(true)
		self.friends_layer = nil

		self.friends_showed = false
		return
	end
end


-- 消息列表
function M:showMessage()	
	local data = self.my_data.data.friends_feed
	if not data or #data == 0 then
		KNMsg.getInstance():flashShow("暂时没有消息")
		return
	end

	self.message_layer = baseMask({  
		titlePath = ACTIVITY_PATH .. "xiaoxi_title.png" , 
		bgInfo = { y = 270 ,  path = IMG_PATH  .. "image/scene/mission/wipe_bg.png" } , 
		isShowBack = { x = 35 , y = 565 , backFun = function() end } , 
		priority = -131
	})
				
	local scroll = KNScrollView:new( 50 , 293  , 395 , 275 , 10 ,  false , nil , { priority = -133 })
	for i = 1 , #data do
		local one_row = display.newLayer()
		one_row:setContentSize(CCSize(386 , 76))

		one_row:addChild(display.newSprite( COMMONPATH .. getHeadPath(data[i].logo) , 0 , 5 , 0 , 0 ))
		one_row:addChild(display.strokeLabel( data[i].msg , 75 , -5 , 16, ccc3(0x00, 0x00, 0x00) , nil , nil , {
			dimensions_width = 215,
			dimensions_height = 70,
			align = 0,
		}))

		local help_ta_btn = KNBtn:new(COMMONPATH , {"btn_bg.png" , "btn_bg_pre.png"} , 290 , 20, {
			front = ACTIVITY_PATH .. "help_ta.png",
			priority = -134,
			callback = function()
				HTTP:call("activity", "get_friend_tree", {f_uid = data[i].uid} , {
					success_callback = function(ret_data)
						dump(ret_data)
						self:other(data[i].uid , ret_data)
					end
				})
			end
		})
		one_row:addChild(help_ta_btn:getLayer())

		scroll:addChild( one_row )
	end
	
	self.message_layer:addChild( scroll:getLayer() )


	self:hideFriends()
end

function M:hideMessage()
	if self.message_layer ~= nil then
		self.message_layer:remove()
		-- self.message_layer:removeFromParentAndCleanup(true)
		self.message_layer = nil
	end
end



-- 看别人
function M:other(uid , data)
	-- dump(data)

	if self.viewLayer ~= nil then
		self.viewLayer:removeFromParentAndCleanup(true)
		self.viewLayer = nil
	end

	self.viewLayer = display.newLayer()

	-- 我的神树按钮
	local my_btn = KNBtn:new(COMMONPATH , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 320 , 592 , {
		front = ACTIVITY_PATH .. "my.png",
		callback = function()
			self:my()
		end
	})
	self.viewLayer:addChild(my_btn:getLayer())


	-- 当日施肥上限
	self.viewLayer:addChild( display.strokeLabel( data.friend_name , 0 , 570  , 24 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , {
		align = 2,
		dimensions_width = 228,
		dimensions_height = 30,
	}))
	self.viewLayer:addChild( display.newSprite( ACTIVITY_PATH .. "other.png" , 270 , 583 ) )


	-- 当日施肥上限
	self.viewLayer:addChild( display.strokeLabel( "该神树当日施肥上限：" .. data.f_feed_num .. "/" .. data.f_feed_max , 20 , 605  , 20 , ccc3( 0xff , 0xff , 0xff )  ) )
	

	-- 施肥按钮
	local shifei_btn = KNBtn:new(COMMONPATH , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 150 , 125 , {
		front = ACTIVITY_PATH .. "shifei.png",
		callback = function()
			HTTP:call("activity", "tree_feed", {f_uid = uid} , {
				success_callback = function(ret_data)
					-- dump(ret_data)
					self:other(uid , ret_data)
					KNMsg.getInstance():flashShow(ret_data.msg)
				end
			})
		end
	})
	self.viewLayer:addChild(shifei_btn:getLayer())
	self.viewLayer:addChild( display.strokeLabel( "您可施肥次数：" .. data.my_feed_num .. "/" .. data.my_feed_max , 300 , 138  , 20, ccc3( 0xff , 0xff , 0xff )  ) )


	-- 等级
	self.viewLayer:addChild( display.strokeLabel( "Lv " .. data.lv , 76 , 190  , 24 , ccc3( 0xff , 0xff , 0xff )  ) )

	-- 成熟度
	local score_max = data.f_grow_max
	local score_cur = score_max - data.f_grow_cd
	local score_bar = KNBar:new("exp" , 151 , 652 , { closeText = true , maxValue = score_max  , curValue = score_cur  , color = ccc3( 255 , 255 , 255 ) })
	self.viewLayer:addChild( score_bar )

	local chengshu_text = display.strokeLabel( "成熟时间：" , 198 , 194  , 16 , ccc3( 0xff , 0xff , 0xff ))
	self.viewLayer:addChild(chengshu_text)

	local chengshu_timeText = display.strokeLabel("" , 293 , 194  , 16 , ccc3( 0xff , 0xff , 0xff ))
	self.viewLayer:addChild(chengshu_timeText)

	ACTIVITY:downTime("activity_tree_chengshu" , {chengshu_timeText} , function()
		data.f_grow_cd = data.f_grow_cd - 1
		if data.f_grow_cd <= 0 then
			data.f_grow_cd = 0

			-- chengshu_text:setVisible(false)
			-- chengshu_timeText:setVisible(false)
		end
		return data.f_grow_cd
	end , 2)


	-- 5个果实
	local award_pos = {
		{78 , 478},
		{159 , 383},
		{237 , 496},
		{24 , 348},
		{258 , 295},
	}
	--[[
	local awardData = {
		{cid = 6001 , num = 10},
		{cid = 9006 , num = 20},
		{cid = 9010 , num = 1},
		{cid = 16031 , num = 2},
		{cid = 16042 , num = 999},
	}
	]]

	for i = 1 , #data.award.arr do
		if award_pos[i] then
			local cur = awardCell( data.award.arr[i] , {
				ClickFun = function()
					KNMsg.getInstance():flashShow( "不能摘取别人的神树" )
				end
			})
			setAnchPos( cur , award_pos[i][1] , award_pos[i][2] )
			self.viewLayer:addChild( cur )

			self.viewLayer:addChild( display.newSprite( ACTIVITY_PATH .. "status_bg.png" , award_pos[i][1] + 31 , award_pos[i][2] - 20 ) )
			if data.f_grow_cd == 0 then
				self.viewLayer:addChild( display.newSprite( ACTIVITY_PATH .. "kezhai.png" , award_pos[i][1] + 30 , award_pos[i][2] - 20 ) )
			else
				self.viewLayer:addChild( display.strokeLabel( "未成熟" , award_pos[i][1] + 7 , award_pos[i][2] - 29  , 16 , ccc3( 0xff , 0xff , 0xff )  ) )
			end
		end
	end


	self.layer:addChild(self.viewLayer)

	self:hideMessage()
end




return M
