--全民福利
local M = {}
local PATH = IMG_PATH .. "image/scene/activity_new/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")

function M:show()
	local data = ACTIVITY:getData()
	local isNew = ( ( data.endtime and  data.endtime ~= "" ) and true or false )
	
	ACTIVITY:baseLayout({ line = {} })
	local scroll = KNScrollView:new( 0, 94, 480, 470 , 10 , false )
	local function createItem( params )
		params = params or {}
		local layer = display.newLayer()
		
		local img,vipBarImg = "item_bg.png","vip_bg_bar.png"
		if G_new_year_skin and G_new_year_skin==1 then
			img="item_bg_2015.png"
			vipBarImg="vip_bg_bar_2015.png"
		end
		
		local bg = display.newSprite( COMMONPATH .. img )
		setAnchPos( bg , 0 , 0 )
		layer:addChild( bg )
		
		
		layer:addChild( display.newSprite( PATH .. vipBarImg , 107 , 82 , 0 , 0 ) )
		layer:addChild( display.strokeLabel( "VIP" .. params.viplv .. "及以上用户可领取" , 107, 80 , 18, ccc3( 0xfd , 0xfa , 0xd7 ) , nil , nil , { dimensions_width = 231 , dimensions_height = 25 , align = 1 } ) )
		
		local itemAwardData = params.data.award
		local awardProp = {}
		for i = 1 , #itemAwardData do
			local curProp = awardCell( itemAwardData[i] , { parent = scroll } )
			setAnchPos( curProp , 28 + ( i - 1 ) * 85 , 10 )
			layer:addChild( curProp )
			awardProp[ #awardProp + 1 ] = curProp
		end
		
		local isEnable =  true
		local isComplete = false
		if data.received then
			--是否已经领取
			for j = 1 , #data.received do
				if tonumber( data.received[j]) == tonumber( params.index ) then
					isComplete = true
					break
				end
			end
		end
		local getBtn = KNBtn:new( COMMONPATH , 
			isEnable and ( isComplete and { "long_btn_grey.png" }  or { "long_btn.png" ,"long_btn_pre.png"} ) or { "long_btn_grey.png" } , 
			305 , 
			18 ,
			{
--				priority = -130,
				parent = scroll , 
				front = COMMONPATH .. ( isEnable and (isComplete and "get_over.png" or  "all_get.png" ) or "get_over.png" ) ,
				callback = 
				function()
					if isEnable and not isComplete then
						if isBagFull() then
						    return false
						end
						
						if params.viplv == 0 and tonumber( DATA_User:get("lv") ) < 10 then
							KNMsg.getInstance():flashShow( "玩家等级达到10级才可领取该奖励，赶快去关卡升级吧！" )
							return 
						end
						
						if  DATA_Vip:get("viplv") < params.viplv then
							KNMsg.getInstance():boxShow( "您的VIP等级未达到，暂不能领取该奖励！" ,{ 
																	confirmText = PATH .. "become_vip.png" , 
																	cancelText = COMMONPATH .. "back.png" , 
																	confirmFun = function() switchScene("pay") end , 
																	cancelFun = function() end 
																	} )
							return
						end
						HTTP:call("activity", "receive_welfare", { typeid = data.typeid , index = params.index },{success_callback = 
						function()
							ACTIVITY:getAction( { awardProp = awardProp , onComplete = function() ACTIVITY:selectActivity() end } )
						end})
					else
--						KNMsg.getInstance():flashShow( "今天奖励已领取！" )
					end
				end
			}):getLayer()
		layer:addChild( getBtn )
		
		
		layer:setContentSize( bg:getContentSize() )
		return layer
	end
	
	
	local sort = data.config 
	
	for i = 1 , #sort do
		local curData = sort[i]
		local item = createItem( { index = i -1 , viplv = curData.viplv , data = curData } )
		scroll:addChild( item )
	end
	scroll:alignCenter()
	ACTIVITY.viewLayer:addChild(scroll:getLayer() )
	
	ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "activity_awards_title.png" , 25 , 562 , 0 , 0 ) )
--	ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "down_time_tip.png" , display.cx , 605 , 0.5 , 0  ) )
	
	ACTIVITY.viewLayer:addChild( display.newSprite( PATH .. "activity_time_text.png" , 20 , 585 + 20 , 0 , 0 ) )	--活动时间
	ACTIVITY.viewLayer:addChild( display.strokeLabel( data.endtime or "" , 120 , 588 + 20 , 20, ccc3( 0xfe , 0xfc , 0xd3 )  ) )	--活动时间
	
--	local timeText = {}
--	local timeX , timeY = 215 , 610
--	for i = 1 , 4 do
--		timeText[i] = display.strokeLabel( "00"  , timeX + ( i - 1 )* 50 , timeY , 18 , ccc3( 0xff , 0xfc , 0xd1 ) , nil , nil , {
--				dimensions_width = 25,
--				dimensions_height = 20,
--				align = 1
--			})
--		ACTIVITY.viewLayer:addChild( timeText[i] )
--	end
--	ACTIVITY:downTime( "welfare" , timeText , function() return DATA_Activity:getwelfareDataTime() end ) 
end
return M
