
local PATH=IMG_PATH.."image/scene/activity_new/aresRoad/"
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local wearEquipCell = requires(IMG_PATH , "GameLuaScript/Scene/hero/wearEquipCell")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local Config_Property = requires(IMG_PATH , "GameLuaScript/Config/Property")


local M={
	baseLayer,
	infoLayer,
	curLayer,
	viewLayer,
	width,
	height,
	numbers,
	lvIntroduction,
}


local _G_road_to_god={}




function M:new(params)

	local this={}
	setmetatable(this,self)
	self.__index=self


	this.baseLayer = display.newLayer()
	this.curLayer = display.newLayer()
	this.viewLayer = display.newLayer()

	local bg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(bg,0,425,0,0.5)
	this.baseLayer:addChild(bg)


	local bgList = display.newSprite(PATH.."equipListbg.png")
	setAnchPos(bgList,17,420,0,0.5)
	this.curLayer:addChild(bgList)



	this.baseLayer:addChild(this.curLayer,1)
	this.baseLayer:addChild(this.viewLayer)


	this.width=bgList:getContentSize().width
	this.height=bgList:getContentSize().height


	this.infoLayer = InfoLayer:new(
			"aresRoadLayer" ,
			0 ,
			{
				title_text = COMMONPATH.."aresRoadTitle.png",
				tail_hide = true,
				closeCallback = function()

					if _G_road_to_god=={} then
						_G_road_to_god=nil
					end

					switchScene("home",{_G_road_to_god=_G_road_to_god})

				end
			}
		)
	this.baseLayer:addChild(this.infoLayer:getLayer())

	this.numbers=1
	local attr={}
	this.lvIntroduction={
	["1"]="初入神界  追随辰东踏上征途",
	["2"]="挑战副本  获取丰富资源",
	["3"]="勇者无畏  勇者狭路相逢",
	["4"]="神之龙脉  打通阵位激活龙脉",
	["5"]="铁血战场  点燃成神之路",
	["6"]="巅峰对决  问鼎最强王者",
	["7"]="装备进化  锻造绝世神兵",
	["8"]="天神神皇  修者破茧成蝶",
	}

	if CHANNEL_GROUP == "tmsj" or CHANNEL_GROUP=="tmsjtest" then
		this.lvIntroduction["1"]="初入神界  追随三少踏上征途"
		this.lvIntroduction["8"]="天神神皇  英雄破茧成蝶"
	elseif CHANNEL_GROUP == "tmsj2"  then
		this.lvIntroduction["1"]="初入神界  追随三少踏上征途"
		this.lvIntroduction["8"]="天神神皇  英雄破茧成蝶"
	elseif CHANNEL_GROUP=="hyylt" or CHANNEL_GROUP=="hy" then
		this.lvIntroduction["1"]="初入忍界  踏上火影征途"
		this.lvIntroduction["5"]="铁血战场  点燃仙化之路"
		this.lvIntroduction["8"]="天咒神咒  忍者破茧成蝶"
	elseif CHANNEL_GROUP=="dhsh" or CHANNEL_GROUP=="qosh"  then
		this.lvIntroduction["1"]="初入江湖  踏上王者征途"
		this.lvIntroduction["5"]="铁血战场  点燃封王之路"
		this.lvIntroduction["8"]="天神神皇  英雄破茧成蝶"
	elseif CHANNEL_GROUP=="tgxy" or CHANNEL_GROUP=="tgxy2" then
		-- do nothing default
	elseif CHANNEL_GROUP == "td" or CHANNEL_GROUP == "jstf" then
		this.lvIntroduction["1"]="初入神界  追随土豆踏上征途"
		this.lvIntroduction["8"]="天神神皇  英雄破茧成蝶"
	else

	end

	if params.data then
		if params.data.data then
			attr=params.data.data
		end
	end

	local key_table={}
	for key,_ in pairs(attr) do
		table.insert(key_table,key)
	end
	table.sort(key_table)
	if key_table and table.nums(key_table)~=0 then
		for _,key in pairs(key_table) do
			this:itemOfEquips(key,attr[key])
		end
	end

	return this

end

function M:getLayer()
	return self.baseLayer
end


function M:itemOfEquips(key,value)

	local  button_forbidden=0
	local  has_get=0

	if value.button_forbidden then
		button_forbidden=value.button_forbidden
	end

	if value.has_get then
		has_get=value.has_get
	end

	local posY=self.height-80-(self.numbers-1)*180

	local itemBg=display.newSprite(PATH.."itemBg.png",display.cx,posY,0.5,0)
	self.curLayer:addChild(itemBg,1)

	local lvHead1 = display.newSprite(PATH.."lvHead"..key..".png",display.cx-40,posY+110,0.5,0)
	self.curLayer:addChild(lvHead1,2)

	local lvText1 = display.newSprite(PATH.."lvText"..key..".png",display.cx+25,posY+127,0.5,0)
	self.curLayer:addChild(lvText1,2)

	local lvStart1 = display.newSprite(PATH.."lvStart"..key..".png",display.cx+25,posY+108,0.5,0)
	self.curLayer:addChild(lvStart1,2)

	--55,56,24
	local colorText=ccc3(231,232,226)
	-- ccc3(231,232,226)
	local lvIntroduction1 = display.strokeLabel(self.lvIntroduction[tostring(key)],display.cx-60,posY+85,16,colorText,0.5,0)
	self.curLayer:addChild(lvIntroduction1,2)


	--显示某个等级的奖励
	if value.award  then
		local award=value.award
		for i = 1 ,#award do
			local curProp = awardCell(award[i])
			setAnchPos(curProp,40+ (i-1)*75,posY+10)
			self.curLayer:addChild(curProp,2)
		end
	end


	local getBtn = KNBtn:new(COMMONPATH ,tonumber(button_forbidden)==0 and {"btn_bg.png" , "btn_bg_pre.png"} or {"btn_bg_grey.png","btn_bg_dis.png"} ,
		355,
		posY+24,
		{
			front=tonumber(has_get)==0 and COMMONPATH.."get.png" or COMMONPATH.."get_over.png",
			scale = true,
			callback = function()
				HTTP:call("user" , "get_the_road_to_god_award", { key=key} , {
							success_callback = function(data)

								local msg=data.msg

								if data._G_road_to_god then
									_G_road_to_god=data._G_road_to_god
								end


								HTTP:call("user" , "the_road_to_god", {} , {
									success_callback = function(data)
										switchScene("aresRoad",{data=data},function()
											KNMsg.getInstance():flashShow(msg)
										end)
									end
								})
							end
						})
			end
		}
	)
	self.curLayer:addChild(getBtn:getLayer(),2)

	self.numbers=self.numbers+1

end


return M
