--[[英雄模块，首页点击英雄图标进入]]

local PATH = IMG_PATH .. "image/scene/bag/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")--require "GameLuaScript/Scene/common/infolayer"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
--local BagItem = requires(IMG_PATH , "GameLuaScript/Scene/common/listitem")--require "GameLuaScript/Scene/bag/bagitem"
local BagItem = requires(IMG_PATH , "GameLuaScript/Scene/common/ListItemGrid")--require "GameLuaScript/Scene/bag/bagitem"
local SelectList = requires(IMG_PATH,"GameLuaScript/Scene/common/selectlist")
local Config = requires(IMG_PATH,"GameLuaScript/Config/Property")
local KNCardpopup = requires(IMG_PATH,"GameLuaScript/Common/KNCardpopup")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")

local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")

local PAGEITEMS = 25

local BagLayer = {
	baseLayer,
	layer,
	itemsLayer,
	infoLayer,
	sell,
	group,
	statLayer,  --出售时的统计层
	selectNum,
	total,
	totalValue,
	sellItems,    --选择出售的元素
	maxPage,   --总页数
	curPage,   --当前页数
	keyList,   --背包物品序列
	scroll,   --背包滑动列表

}

function BagLayer:new(data)
	
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	this.baseLayer = display.newLayer()
    this.layer = display.newLayer()
   	this.sellItems = {}
   	this.total = 0
   	this.maxPage = 1
   	this.curPage = 1
   	this.keyList = {}
   	local data =data or {}

	local bg = display.newSprite(SCENECOMMON.."bg.png")
	setAnchPos(bg)

	local listBg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(listBg,0,425,0,0.5)
	this.layer:addChild(listBg)



	local bagConfig = {
		{
			"general",
			"tab_hero"
		},
		{
			"equip",
			"tab_equip"
		},
		{
			"skill",
			"tab_skill"
		},
		{
			"pet",
			"tab_pet"
		},
		{
			"prop",
			"tab_props"
		},

	}
	local temp
	local startX,startY = 10,690
	this.group = KNRadioGroup:new()
	for i = 1, #bagConfig do
		temp = KNBtn:new(COMMONPATH.."tab/",{"tab_star_normal.png","tab_star_select.png"},startX,startY,{
			disableWhenChoose = true,
			upSelect = true,
			id = bagConfig[i][1],
			front = {COMMONPATH.."tab/"..bagConfig[i][2].."_normal.png",COMMONPATH.."tab/"..bagConfig[i][2]..".png"},

			callback = function()
				--清空出售的数据
				this.selectNum = 0
				this.total = 0
				this.sellItems = {}
				this.sell = false
				this:createStatLayer(bagConfig[i][1])

				this:createBag(bagConfig[i][1])
			end
		},this.group)
		this.layer:addChild(temp:getLayer())
		startX = startX + temp:getWidth() + 4
	end

	local line = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(line, 6, 685)
	this.layer:addChild(line)

	this:createBag(data.kind or "general", data.offset, data.page)


	this.infoLayer = InfoLayer:new(layerName, 0, {title_text = PATH.."bag_text.png", tail_hide = true})

	this.baseLayer:addChild(bg)
	this.baseLayer:addChild(this.layer)
	this.baseLayer:addChild(this.infoLayer:getLayer())


	return this.baseLayer

end

function BagLayer:createBag(kind,offset, page)
	if self.itemsLayer then
		self.layer:removeChild(self.itemsLayer,true)

	end

	local optBtnGrey = false
	local btn_opt = nil
	if kind == "equip" then
		-- 判断等级开放
		if checkOpened("equip_strenthen") ~= true then
			optBtnGrey = true
			btn_opt = "strengthen_small_grey.png"
		end
	elseif kind == "general" then
		if checkOpened("byexp") ~= true then
			optBtnGrey = true
			btn_opt = "chuangong_small_grey.png"
		end
	elseif kind == "pet" then
		if checkOpened("pet") ~= true then
			optBtnGrey = true
		end
	end



	local function newSort(l, r)

		local lValue, rValue = 0, 0

		local l_bag_info = DATA_Bag:get(kind , l)
		local r_bag_info = DATA_Bag:get(kind , r)

		if kind == "general" then
			local lOn, lPos = DATA_Formation:checkIsExist(tonumber(l))
			local rOn, rPos = DATA_Formation:checkIsExist(tonumber(r))
			if lOn then
				lValue = 100000 + (8 - lPos) * 10000
			end

			if rOn then
				rValue = 100000 + (8 - rPos) * 10000
			end

			local l_star
			local r_star

			if l_bag_info.star and r_bag_info.star then
				l_star = l_bag_info.star
				r_star = r_bag_info.star
			else
				l_star = getConfig(kind, l_bag_info.cid , "star")
				if l_bag_info.cid == r_bag_info.cid then
					r_star = l_star
				else
					r_star = getConfig(kind , r_bag_info.cid , "star")
				end
			end

			lValue = lValue + l_star * 500 + l_bag_info.lv
			rValue = rValue + r_star * 500 + r_bag_info.lv
			-- lValue = lValue + getConfig(kind, DATA_Bag:get(kind,l,"cid"),"star") * 500 + DATA_Bag:get(kind, l, "lv")
			-- rValue = rValue + getConfig(kind, DATA_Bag:get(kind,r,"cid"),"star") * 500 + DATA_Bag:get(kind, r, "lv")

			--增加阵法战的排序
			if DATA_Info:get_type("zhenfa") then 
				for i,v in pairs(DATA_Info:get_type("zhenfa")) do
					if tonumber(v) == tonumber(l) then 
						lValue = lValue+10000 
					elseif tonumber(v) == tonumber(r) then 
						rValue = rValue+10000 
					end
				end
			end

		elseif kind == "equip" then
			local typeValue = {
				["weapon"] = 4,
				["defender"] = 3,
				["shoe"] = 2,
				["jewelry"] = 1,
			}
			local lDress = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(l), "equip")
			local rDress = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(r), "equip")


			if lDress then
				local _, pos = DATA_Formation:checkIsExist(tonumber(lDress))
				lValue = 1000000 + typeValue[DATA_Bag:get(kind, l, "type")] * 100000 + (8 - pos) * 5000
			end

			if rDress then
				local _, pos =  DATA_Formation:checkIsExist(tonumber(rDress))
				rValue = 1000000 + typeValue[DATA_Bag:get(kind, r, "type")] * 100000 +(8 - pos) * 5000
			end

			if l_bag_info.star and r_bag_info.star then
				l_star = l_bag_info.star
				r_star = r_bag_info.star
			else
				l_star = getConfig(kind, l_bag_info.cid , "star")
				if l_bag_info.cid == r_bag_info.cid then
					r_star = l_star
				else
					r_star = getConfig(kind , r_bag_info.cid , "star")
				end
			end

			local lIsDress , num1 = DATA_ROLE_SKILL_EQUIP:isDressdOnZhenFa(l)
			local rIsDress , num2 = DATA_ROLE_SKILL_EQUIP:isDressdOnZhenFa(r)


			if lIsDress then 
				lValue = lValue + (6-num1)*100000 + typeValue[DATA_Bag:get(kind, l, "type")] * 100000
			end

			if rIsDress then
				rValue = rValue + (6-num2)*100000 + typeValue[DATA_Bag:get(kind, r, "type")] * 100000
			end


			lValue = tonumber(lValue) + tonumber(l_star) * 500 + (tonumber(l_bag_info.lv) or 0)
			rValue = tonumber(rValue) + tonumber(r_star) * 500 + (tonumber(r_bag_info.lv) or 0)


		elseif kind == "skill" then
			local lType = l_bag_info.type
			local rType = r_bag_info.type

			local function getValue(t, id)
				local value = 0
				if t == "petskill" then
					value = 100000
				else
					local dress = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(id), "skill")

					if dress then
						local _, pos =  DATA_Formation:checkIsExist(tonumber(dress))
						value = 1000000  +(8 - pos) * 5000
					end
				end
				return value
			end

			lValue = getValue(lType, l)
			rValue = getValue(rType, r)

			if l_bag_info.star and r_bag_info.star then
				l_star = l_bag_info.star
				r_star = r_bag_info.star
			else
				l_star = getConfig(kind, l_bag_info.cid , "star")
				if l_bag_info.cid == r_bag_info.cid then
					r_star = l_star
				else
					r_star = getConfig(kind , r_bag_info.cid , "star")
				end
			end

			lValue = lValue + l_star * 500 + (l_bag_info.lv or 0)
			rValue = rValue + r_star * 500 + (r_bag_info.lv or 0)
		elseif kind=="pet" then

			if l_bag_info.star and r_bag_info.star then
				l_star = l_bag_info.star
				r_star = r_bag_info.star
			else
				l_star = getConfig(kind, l_bag_info.cid , "star")
				if l_bag_info.cid == r_bag_info.cid then
					r_star = l_star
				else
					r_star = getConfig(kind , r_bag_info.cid , "star")
				end
			end


			lValue =lValue + l_star * 1000000 + l_bag_info.lv *500 + (DATA_Pet:getFighting() == l_bag_info.id and 100000000000 or 0)
			rValue =rValue + r_star * 1000000 + r_bag_info.lv *500 + (DATA_Pet:getFighting() == r_bag_info.id and 100000000000 or 0)


		elseif kind =="prop" then --道具按照important 升序排列
			--dump(r_bag_info)
			lValue = r_bag_info.important * 1000000+tonumber(r_bag_info.cid)*10+l_bag_info.num
			rValue = l_bag_info.important * 1000000+tonumber(l_bag_info.cid)*10+r_bag_info.num

		end

		return lValue > rValue
	end

	self.itemsLayer = display.newLayer()
	if DATA_Bag:count(kind) > 0 then
		self.curPage = page or 1
		self.keyList[kind] = getSortList(DATA_Bag:getTable(kind), newSort)

		if self.sell then
			self.scroll = KNScrollView:new(15,205,450,480,5,false,0,{
							--debug=true,
						})

			local num = 1
			while num <= #self.keyList[kind] do
				if DATA_ROLE_SKILL_EQUIP:getRoleId(self.keyList[kind][num], kind) then
					table.remove(self.keyList[kind], num)
					num = num - 1
				end
				num = num + 1
			end

		else
			self.scroll = KNScrollView:new(15,155,450,530,5,false,0,{
				 --debug=true,
				})
		end

		--self.scroll:setEnable(false)
		self.maxPage = math.ceil(#self.keyList[kind] / PAGEITEMS)


		--背包每页显示PAGEITEMS定义的元素个数
		local max = #self.keyList[kind] - self.curPage * PAGEITEMS

		if max >= 0 then
			max = self.curPage * PAGEITEMS
		elseif max < 0 then
			max = (self.curPage - 1) * PAGEITEMS + (PAGEITEMS + max)
		end

		local pos = {5,95,185,275,365}

		local lineLayer
		local posCount = 1

		local imageName = PATH.."bag.png"
		display.addSpriteFramesWithFile(PATH.."bag.plist",imageName)
		GlOBAL_BATCH = display.newBatchNode(imageName)
		self.scroll:getLayer():addChild(GlOBAL_BATCH)

		for i=(self.curPage - 1) * PAGEITEMS + 1, max   do

			if (i-1)%5==0 then
				lineLayer = display.newLayer() --逢5换行
				lineLayer:setContentSize(CCSizeMake(450,100))
				self.scroll:addChild(lineLayer)
		       	posCount=1

       		end

			local v = DATA_Bag:get(kind, self.keyList[kind][i])

			if v["type"] == "stonepatch" then
				btn_opt = "hecheng_small.png"
			else
				btn_opt = nil
			end

			-- 按钮变灰
			local set_optBtnGrey = false
			if optBtnGrey ~= true then
				if kind == "skill" then
					local str = nil
					if DATA_Bag:get("skill" , v.id , "type") == "generalskill" then
						str = DATA_Bag:get("general" , DATA_ROLE_SKILL_EQUIP:getRoleId(v.id , "skill") , "name")
					else
						str = DATA_Bag:get("pet" , DATA_PetSkillDress:isDress(v.id) , "name")
					end

					if not str then
						set_optBtnGrey = true
					end
				elseif kind == "pet" then
					if DATA_Pet:getFighting() == v.id then
						set_optBtnGrey = true
					end
				end
			end

			local item
			item = BagItem:new(kind , v["id"] , {
				sell = self.sell,
				parent = self.scroll,
				optBtnGrey = set_optBtnGrey or optBtnGrey,
				btn_opt = btn_opt,
				x=pos[posCount],
				y=lineLayer:getPositionY(),
				iconCallback = function()	--当点击图标按钮后先从全局数据中查找是否存在数据，若没有则请求网络，否则隐藏用户信息栏，显示详细界面

					if self.sell then--当出售状态时,点击图标也做为触发勾选方法
						item:check(not item:isSelect())

						if item:isSelect() then
						self.sellItems[item:getId()] = item:getId()
						self.total = self.total + DATA_Bag:get(kind,item:getId(),"price") * (DATA_Bag:get(kind, item:getId(), "num") or 1)
						else
							self.sellItems[item:getId()] = nil
							self.total = self.total - DATA_Bag:get(kind,item:getId(),"price") * (DATA_Bag:get(kind, item:getId(), "num") or 1)
						end

						self.totalValue:setString(self.total)
						self.selectNum:setString(table.nums(self.sellItems))

						return
					end

					local DATA = self:getDataFile(kind)

					if DATA:haveData(v["id"] , kind) or kind == "pet" then
						pushScene("detail" , {
							detail = kind,
							id = v["id"],
							propOpt = item:getUseFun(),
							-- backCallback = function()
							-- 	switchScene("bag", { kind = kind, offset = 0, page = self.curPage })
							-- end
						})
					else
						HTTP:call(kind , "get" , {
							id = v["id"]
						} , {
							success_callback = function()
								pushScene("detail" , {
									detail = kind,
									id = v["id"],
									-- backCallback = function()
									-- 	switchScene("bag", { kind = kind, offset = 0, page = self.curPage })
									-- end
								})
							end
						})
					end
				end,

				checkBoxOpt = function()	--出售时点击复选框的操作
					if item:isSelect() then
						self.sellItems[item:getId()] = item:getId()
						self.total = self.total + DATA_Bag:get(kind,item:getId(),"price") * (DATA_Bag:get(kind, item:getId(), "num") or 1)
					else
						self.sellItems[item:getId()] = nil
						self.total = self.total - DATA_Bag:get(kind,item:getId(),"price") * (DATA_Bag:get(kind, item:getId(), "num") or 1)
					end

					self.totalValue:setString(self.total)
					self.selectNum:setString(table.nums(self.sellItems))
				end,
				optCallback = function()	--点按钮的操作

					if kind == "skill" then
						local str = nil
						if DATA_Bag:get("skill" , item:getId() , "type") == "generalskill" then
							str = DATA_Bag:get("general" , DATA_ROLE_SKILL_EQUIP:getRoleId(item:getId() , "skill") , "name")
						else
							str = DATA_Bag:get("pet" , DATA_PetSkillDress:isDress(item:getId()) , "name")
						end

						if not str then
							KNMsg:getInstance():flashShow("未装备的技能不可升级")
							return
						end

						if tonumber(DATA_Bag:get("skill", item:getId(), "lv")) >= table.nums(getConfig("data_skillexp", getConfig("skill", DATA_Bag:get("skill", item:getId(), "cid"), "star"))) then
							KNMsg:getInstance():flashShow("技能已达最大等级")
							return
						end

						if DATA_Bag:get("skill" , item:getId() , "type") == "generalskill" then
							local cid = DATA_Bag:get("skill" , item:getId() , "cid")
							local Skill_Config = requires(IMG_PATH , "GameLuaScript/Config/Skill")
							local config_data = Skill_Config[cid]

							if tonumber( config_data.isgod ) == 1 then
								KNMsg:getInstance():flashShow("功能未开放")
								return
							end

							switchScene("strengthen", {gid = item:getId(),mode = "heroskill",types = 2})
						else
							switchScene("strengthen", {gid = item:getId(),mode = "petplainskill",types = 2})
						end

						--[[pushScene("strengthen" , {
							type = "strength_skill" ,
							targetID = item:getId(),
							resumeCallback = function()
								self:createBag(kind,scroll:getOffset())
							end
						})	]]
					elseif kind == "general" then
						-- 判断等级开放
						local check_result = checkOpened("byexp")
						if check_result ~= true then
							KNMsg:getInstance():flashShow(check_result)
							return
						end


						local curHeroData = DATA_Bag:get( "general" , item:getId() )
						if curHeroData.lv <=1 then
							KNMsg.getInstance():flashShow( replaceStr( "一级武将不可做传功者！" ) )
						else
							pushScene("byexp" , { source = curHeroData , backtype = "back_bag"} )
						end

					elseif kind == "equip" then
						-- 判断等级开放
						local check_result = checkOpened("equip_strenthen")
						if check_result ~= true then
							KNMsg:getInstance():flashShow(check_result)
							return
						end
							local Config_max = requires(IMG_PATH , "GameLuaScript/Config/equipstrongmax")
							local star = DATA_Bag:get( kind , item:getId() , "star")
							local curLv = tonumber( DATA_Bag:get( kind , item:getId() , "lv") )

							if DATA_User:get("lv") < 50 and curLv >= Config_max[ star ][ "levmax" ] then
								KNMsg:getInstance():flashShow( "装备已经达" .. replaceStr( "强化" ) .. "上限50级后将开启" .. replaceStr( "淬炼" ) )
							else
								HTTP:call("shop","cuilian_config",{} , {
										success_callback = function( tempData )
												pushScene("strengthen",{ type = "strength_equip" , isQuench = ( DATA_User:get("lv") >= 50 and DATA_Bag:isQuench( item:getId() ) ), targetID = item:getId(),vipConfig=tempData, resumeCallback =
																	 function()
																		self:createBag(kind,self.scroll:getOffset())
																	end})
										end
									})

							end

					elseif kind == "pet" then
						-- 判断等级开放
						local check_result = checkOpened("pet")
						if check_result ~= true then
							KNMsg:getInstance():flashShow(check_result)
							return
						end

						if DATA_Pet:getFighting() == item:getId() then
							KNMsg:getInstance():flashShow("该幻兽已出战")
							return
						end

						HTTP:call("pet" , "seton" , {
							id = item:getId()
						} , {
							success_callback = function()
								switchScene("pet")
							end
						})
					elseif kind == "prop"  then
					dump(v.type)
						if v['type']=="fivestarhero" or v['type']=="highstarhero" or v['type']=="fivestarstrong"   then --五星英雄超级包
							HTTP:call("bag", "use_fivestarhero", {prop_key = v["id"]}, {
									success_callback = function(data)
										
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											--KNMsg.getInstance():flashShow(data.msg)
											local fbLayer = requires(IMG_PATH , "GameLuaScript/Scene/fb/fblayer")
											
											fbLayer:popCardList({[1]=data.gid})
										end)
									end
								})
						elseif v['type']=="goatpacket" then
							HTTP:call("bag", "use_goatpacket", {prop_key = v["id"]}, {
									success_callback = function(data)
										
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											KNMsg.getInstance():flashShow(data.msg)
										end)
									end
								})

						elseif v["type"] == "energydrug" or v["type"] == "powerdrug" then                    --主角丹药
							HTTP:call("status", "eat", {id = item:getId()},{success_callback=
							function(data)
								CCLuaLog("OPOPAction")
								switchScene("bag",{kind = "prop", offset = self.scroll:getOffset(), page = self.curPage
								} , function()
									KNMsg.getInstance():flashShow("物品使用成功,"..getConfig("prop", v["cid"], "bagdesc"))
								end)
							end})
						--帮派改名
						elseif v["type"] == "achangenick" then

							HTTP:call("alliance", "get", {},{success_callback =
								function()


									if DATA_Gang:get("list") == nil or DATA_Gang:get("list").userstate ~= 100 then

										KNMsg:getInstance():flashShow( "只有帮主才可以修改帮派名称!" )
										return
									end

									local KNInputText

									if device.platform == "wp8" then
										KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNEditBox")
									else
										KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
									end


									local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")

									-- 输入框
									local inputText
									local isInputing = false
									local openSoftKeyboard = function()
										if not isInputing then inputText:startInput() isInputing = true end
									end
									local closeSoftKeyboard = function()
										if isInputing then inputText:stopInput() isInputing = false end
									end

									local layer = baseMask( { titlePath = PATH .. "change_gang_name_card_title.png", isShowBack = { x = 30, y = 545, backFun = closeSoftKeyboard } } )

									-- 提示信息: 输入新昵称
									layer:addChild( display.newSprite( PATH .. "change_name_tip.png", 52, 533, 0, 1.0 ) )

									if device.platform ~= "wp8" then

									    local inputBgBtn = KNBtn:new( PATH, { "inputBg.png" }, 52, 450,
									    {
												priority = -131,
												scale = true,
												callback = function()
													openSoftKeyboard()
												end
										})
										layer:addChild( inputBgBtn:getLayer() )

									end

								 	inputText = KNInputText:new(
								 				{	width = 365,
													height = 28,
													size = 20 ,
													--defStr = "(6个汉字以内)",
													existStr = nil,
													defColor = ccc3( 0x00, 0x00, 0x00 ),
													inputColor = ccc3( 0x4d, 0x15, 0x15 ),
													normalBg = PATH .. "inputBg.png", -- only for wp8
													priority = -131, -- only for wp8
												})
									setAnchPos( inputText:getLayer() , 55, 473 )
									layer:addChild( inputText:getLayer() )


									-- 提示信息: (6个汉字以内)
									layer:addChild( display.strokeLabel( "(6个汉字以内)", 310, 420 + 80, 20 , ccc3(0x2c , 0x00 , 0x00 ), 2, ccc3(0x40 , 0x1d , 0x0c ), { dimensions_width = 130, dimensions_height = 30, align = 0 } ) )
									layer:addChild( display.strokeLabel( "说明：切勿使用特殊符号！", display.cx - 124 ,  420  , 20 , ccc3(0xff , 0x00 , 0x00 ), 2, ccc3(0x40 , 0x1d , 0x0c ), { dimensions_width = 250 , dimensions_height = 30 , align = 1 } ) )

									-- 确认按钮
									layer:addChild( KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 71,  356,
									{
										priority = -131,
										front = COMMONPATH .. "confirm.png" ,
										callback = function()
											local input = inputText:getString()
											if input == "" then
												KNMsg:getInstance():flashShow( "帮派名称不能为空!" )
											elseif string.find(input, "%%") then
												KNMsg:getInstance():flashShow( "不能输入特殊字符!" )
											else
												closeSoftKeyboard()

												HTTP:call( "alliance", "alterinfo", { name = input , id = item:getId() },
												{
													success_callback = function()
														--layer:remove()
														switchScene("bag", { kind = kind, offset = self.scroll:getOffset(), page = self.curPage }, function( ... )
															KNMsg:getInstance():flashShow( "帮派名称修改成功!" )
														end)
													end
												})
											end
										end
									} ):getLayer() )

									-- 取消按钮
									layer:addChild( KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 260,  356,
									{
										priority = -131 ,
										front = COMMONPATH .. "cancel.png" ,
										callback = function()
											closeSoftKeyboard()
											layer:remove()
										end
									} ):getLayer() )

							end})
						elseif v["type"] == "changenick" then

							HTTP:call("alliance", "get", {},{success_callback =
								function()
								local KNInputText

								if device.platform == "wp8" then
									KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNEditBox")
								else
									KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
								end

								local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")


								-- 输入框
								local inputText
								local isInputing = false
								local openSoftKeyboard = function()
									if not isInputing then inputText:startInput() isInputing = true end
								end
								local closeSoftKeyboard = function()
									if isInputing then inputText:stopInput() isInputing = false end
								end

								local layer = baseMask( { titlePath = PATH .. "change_name_card_title.png", isShowBack = { x = 30, y = 545, backFun = closeSoftKeyboard } } )

								-- 提示信息: 输入新昵称
								layer:addChild( display.newSprite( PATH .. "change_name_tip.png", 52, 533, 0, 1.0 ) )

								if device.platform ~= "wp8" then

								    local inputBgBtn = KNBtn:new( PATH, { "inputBg.png" }, 52, 450,
								    {
											priority = -131,
											scale = true,
											callback = function()
												openSoftKeyboard()
											end
									})
									layer:addChild( inputBgBtn:getLayer() )

								end

							 	inputText = KNInputText:new(
							 				{	width = 365,
												height = 28,
												size = 20 ,
												--defStr = "(6个汉字以内)",
												existStr = nil,
												defColor = ccc3( 0x00, 0x00, 0x00 ),
												inputColor = ccc3( 0x4d, 0x15, 0x15 ),
												normalBg = PATH .. "inputBg.png", -- only for wp8
												priority = -131,  -- only for wp8
											})
								setAnchPos( inputText:getLayer() , 55, 473 )
								layer:addChild( inputText:getLayer() )


								-- 提示信息: (6个汉字以内)
								layer:addChild( display.strokeLabel( "(6个汉字以内)", 310, 420 + 80 , 20 , ccc3(0x2c , 0x00 , 0x00 ), 2, ccc3(0x40 , 0x1d , 0x0c ), { dimensions_width = 130, dimensions_height = 30, align = 0 } ) )
								layer:addChild( display.strokeLabel( "说明：切勿使用特殊符号！", display.cx - 124 ,  420  , 20 , ccc3(0xff , 0x00 , 0x00 ), 2, ccc3(0x40 , 0x1d , 0x0c ), { dimensions_width = 250 , dimensions_height = 30 , align = 1 } ) )

								-- 确认按钮
								layer:addChild( KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 71,  356,
								{
									priority = -131,
									front = COMMONPATH .. "confirm.png" ,
									callback = function()
										local input = inputText:getString()
										if input == "" then
											KNMsg:getInstance():flashShow( "昵称不能为空!" )
										elseif string.find(input, "%%") then
											KNMsg:getInstance():flashShow( "不能输入特殊字符!" )
										else
											closeSoftKeyboard()

											HTTP:call( "user", "change_name", { name = input },
											{
												success_callback = function()
													--layer:remove()
													switchScene("bag", { kind = kind, offset = self.scroll:getOffset(), page = self.curPage }, function( ... )
														KNMsg:getInstance():flashShow( "昵称修改成功!" )
													end)
												end
											})
										end
									end
								} ):getLayer() )

								-- 取消按钮
								layer:addChild( KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 260,  356,
								{
									priority = -131 ,
									front = COMMONPATH .. "cancel.png" ,
									callback = function()
										closeSoftKeyboard()
										layer:remove()
									end
								} ):getLayer() )
							end})
						-- 退帮令
						elseif v["type"] == "Hold" then
							KNMsg.getInstance():flashShow("退出" .. replaceStr("帮派") .. "时才可使用")
						-- 藏宝图
						elseif v["type"] == "goldmap" then
							local g_props = {}
							local handle
							local jiansu_handle
							local awardLayer = display.newLayer()
							local bginfopath = IMG_PATH  .. "image/common/booty_.png"
							local baseMaskPox = 120
							local bootyPath = IMG_PATH .. "image/scene/bag/"
							local COMMONPATH = IMG_PATH .. "image/common/"
							local backimgpox = 15
							local backimgpoy = 608
							local tempLayer = baseMask({
								bgInfo = { y = baseMaskPox ,  path = bginfopath} ,
								isShowBack = {
									x = backimgpox , 
									y = backimgpoy , 
									backFun = function()
										if handle then
											CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
											handle = nil
										end

										if jiansu_handle then
											CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(jiansu_handle)
											handle = nil
										end
										-- 刷新道具界面
										self:createBag("prop")
									end
								} ,
								priority = -130
							})
							
							local layer = display.newLayer()
							local bg = display.newSprite(bootyPath.."booty.png")
							setAnchPos(bg, 238,661, 0.5, 0.5)
							local bgtitle = display.newSprite(bootyPath.."title_bg.png")
							setAnchPos(bgtitle, 238,656, 0.5, 0.5)
							layer:addChild(bgtitle)
							layer:addChild(bg,1)
							tempLayer:addChild(layer,10)
							--		放置中间的那个圆轮
							local   booty_circle=display.newSprite(COMMONPATH.."circle_booty.png")
							setAnchPos(booty_circle,display.cx,display.cy-30, 0.5, 0.5)
							tempLayer:addChild(booty_circle)
							local cx_=65
							local cy_=572
							local cy_1 = 230
							local  poses = {
								{["cx"] = cx_ + 87 , ["cy"] = cy_},
								{["cx"]=cx_+87*2,["cy"]=cy_},
								{["cx"]=cx_+87*3,["cy"]=cy_},
								{["cx"]=cx_+87*4,["cy"]=cy_},
								{["cx"]=cx_+87*4,["cy"]=cy_-85.5},
								{["cx"]=cx_+87*4,["cy"]=cy_-85.5*2},
								{["cx"]=cx_+87*4,["cy"]=cy_-85.5*3},
								{["cx"]=cx_+87*4,["cy"]=cy_-85.5*4},
								{["cx"]=cx_+87*3,["cy"]=cy_1},
								{["cx"]=cx_+87*2,["cy"]=cy_1},
								{["cx"]=cx_+87,["cy"]=cy_1},
								{["cx"]=cx_,["cy"]=cy_1},
								{["cx"]=cx_,["cy"]=cy_1+85.5},
								{["cx"]=cx_,["cy"]=cy_1+85.5*2},
								{["cx"]=cx_,["cy"]=cy_1+85.5*3},
								{["cx"]=cx_,["cy"]=cy_}
							}
							local cur_index = 1
							local selectP = display.newSprite(COMMONPATH.."select1.png")
							local stop_index = nil
							local success_msg = nil
							-- 减速
							local function jiansu()
								local run_times = 0
								-- 跑一格
								local function runOne(time)
									jiansu_handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
										CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(jiansu_handle)
										jiansu_handle = nil
										run_times = run_times + 1

										-- 判断是否循环了16次
										local cur_pos1 = poses[cur_index]
										if run_times < #poses then
											runOne(0.04 + (run_times - 1) * 0.05)
										else
											if success_msg then
												-- KNMsg.getInstance():flashShow(success_msg)
												--				执行动画
												local namepic = getImageByType(g_props[stop_index]["cid"] , "s")
												local sprite1=display.newSprite(namepic)
												setAnchPos(sprite1,cur_pos1.cx+20,cur_pos1.cy)
												tempLayer:addChild(sprite1)
												local move=CCMoveTo:create(0.5,ccp(display.cx-35,display.cy-52))
												local end1=CCCallFunc:create(
													function()
														KNMsg.getInstance():flashShow(success_msg)
													end
												)
												local array=CCArray:create()
												array:addObject(move)
												array:addObject(end1)
												local seq=CCSequence:create(array)
												sprite1:runAction(seq)
											end
											return
										end

										cur_index = cur_index + 1
										if cur_index > #poses then
											cur_index = 1
										end

										local cur_pos = poses[cur_index]
										setAnchPos(selectP , cur_pos.cx , cur_pos.cy , 0.5 , 0.5)
									end , time , false)
								end
								runOne(0.04)
							end

							
							
							handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
								if stop_index ~= nil and cur_index == stop_index then
									CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
									handle = nil
									jiansu(stop_index)
									return
								end

								cur_index = cur_index + 1
								if cur_index > #poses then
									cur_index = 1
								end

								local cur_pos = poses[cur_index]
								setAnchPos(selectP , cur_pos.cx , cur_pos.cy , 0.5 , 0.5)
							end , 0.04 , false)
							tempLayer:addChild(selectP , 10)

							local function showAward(data)
								--			for 循环存储数组
								local props=data["props"]
								for k,v in ipairs(props) do
									g_props[k]=v
								end

								local Posx=36
								local Posy=538-85
								for i=1,5 do
									local award=props[i]
									local curProp = awardCell(award)
									setAnchPos( curProp ,36+ ( i - 1 ) * 85 ,538)
									tempLayer:addChild(curProp)
								end
								for i=6,8 do
									local award=props[i]
									local curProp = awardCell(award)
									setAnchPos( curProp ,36+4*85 ,Posy)
									tempLayer:addChild(curProp)
									Posy=Posy-85
								end
								Posx=36+4*85
								for i=9,13 do
									local award=props[i]
									local curProp = awardCell(award)
									setAnchPos( curProp ,Posx ,538-4*85)
									tempLayer:addChild(curProp)
									Posx=Posx-85
								end
								Posy=538-3*85
								for i=14,16 do
									local award=props[i]
									local curProp = awardCell(award)
									setAnchPos( curProp ,36 ,Posy)
									tempLayer:addChild(curProp)
									Posy=Posy+85
								end
							end

							local function animasAward(data)
								stop_index = data.rand_key
								success_msg = data.msg
							end

							--
							local curlayer=display.newLayer()
							HTTP:call("bag", "use_goldmap", {id=v["id"]}, {
							success_callback = function(data)
								showAward(data)
							end
							})
							local betBtn
							local betBtnagin
							betBtn= KNBtn:new( COMMONPATH , {"btn_bg_red.png","btn_bg_red_pre.png"},168 ,140 , {
							front=COMMONPATH.."revealer.png",
							scale = true,
							priority=-135,
							callback = function()
								betBtn:setEnable(false)
								betBtn:setState(DISABLE)
								--	按钮变换禁用
								--	开始探宝
								HTTP:call("bag", "get_goldmap_prop", {is_disabled=1}, {
									success_callback = function(data)
										curlayer:removeFromParentAndCleanup(true)
										animasAward(data)

										betBtnagin= KNBtn:new( COMMONPATH , {"btn_bg_red2.png"} ,168 ,140 , {
											front=COMMONPATH.."revealer.png",
											scale = true,
											priority=-128,
											callback = function()
											end
										})
										curlayer = display.newLayer()
										curlayer:addChild(betBtnagin:getLayer(),15)
										tempLayer:addChild(curlayer)
									end
								})
							end})
							curlayer:addChild(betBtn:getLayer(),15)
							tempLayer:addChild(curlayer)
							tempLayer:addChild(awardLayer)

						elseif v.type == "stoneessence" then
								KNMsg:getInstance():flashShow( "可在经脉宝石升级时使用!" )
--								HTTP:call("pulse" , "get", { id = DATA_Formation:get("on")[1].gid } , {
--									success_callback = function()
--										switchScene("pulse",DATA_Formation:get("on")[1].gid)
--									end}
--								)
						elseif v.type == "fumo" then
							KNMsg:getInstance():flashShow( "在装备详情中进入附魔系统!" )
						elseif v.type == "skillessence" then
							KNMsg.getInstance():flashShow("可在技能升级时进行使用")
--							HTTP:call("general" , "get",{},{success_callback =
--								function()
--									DATA_General:haveGet(true)
--									DATA_Formation:set_index(1)
--									switchScene("hero",{gid = DATA_Formation:getCur() })
--								end
--							})
						elseif v["type"] == "challengebook" then
							HTTP:call("insequip","useshu", {id = item:getId()}, {
							success_callback = function()
							switchScene("bag",{kind = "prop", offset = self.scroll:getOffset()
								} , function()
									KNMsg.getInstance():flashShow("挑战书已使用，藏宝楼挑战次数增加!")
								end)
							end
							})
						elseif v["type"] == "heart" then
							switchScene("pet", {}, function()
								KNMsg.getInstance():flashShow("请进入四星以上幻兽刷技能界面进行技能兑换")
							end)
						elseif v["type"] == "fiveskillkit" then
							HTTP:call("bag", "use_fiveskillkit", {id = v["id"]}, {
									success_callback = function(data)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											KNMsg.getInstance():flashShow(data.msg)
										end)
									end
								})
						elseif v["type"] == "godfiveskillkit" then
							HTTP:call("bag", "use_godfiveskillkit", {id = v["id"]}, {
									success_callback = function(data,func)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											KNMsg.getInstance():flashShow(data.msg)
										end)
									end
								})
						elseif v["type"] == "zfchip" then
								HTTP:call("bag", "use_zfchip", {id = v["id"]}, {
									success_callback = function(data,func)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											KNMsg.getInstance():flashShow(data.msg)
										end)
									end
								})
						elseif v["type"] == "petegg" then                        --幻兽蛋
							-- 判断等级开放
							local check_result = checkOpened("hatch")
							if check_result ~= true then
								KNMsg:getInstance():flashShow(check_result)
								return
							end
								switchScene("incubation")
						elseif string.find(v["type"],"kit") then                    --锦囊
							if isBagFull() then
								return false
							end
							HTTP:call("bag","usekit",{id = v['id']},{
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(), page = self.curPage},
									function()
										local card_popup = KNCardpopup:new(data.cid , function()
											end , {
	--											init_x =  196,
	--											init_y = 211,
	--											end_x =  196,
	--											end_y =  211,
	--											top_tips = display.strokeLabel("锦囊已使用，获得物品:", 0, 0, 20),
											})
											display.getRunningScene():addChild(card_popup:play())
	--									KNMsg.getInstance():flashShow("锦囊已使用，获得物品:"..data.name)
									end)
								end
							})
						elseif v.type == "equipfixed" then
						HTTP:call("bag","use_equipfixed",{id = v['id']},{
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(), page = self.curPage},
									function()
										local list = {}
										local index = 1
										for k, v in pairs(data._U_bag.equip) do
											table.insert(list,v.cid)
										end
										local function pop(index)
											local card_popup = KNCardpopup:new(list[index] , function()
													if index == table.nums(list) then
													else
														pop(index + 1)
													end
												end , {
													end_x = -80,
													end_y = -350,
												})
											display.getRunningScene():addChild(card_popup:play())
										end
										pop(index)
									end)
								end
							})
						elseif v["type"] == "stonepatch" then
							if isBagFull() then
								return false
							end

							if DATA_Bag:getTypeCount("prop", DATA_Bag:get("prop", v["id"], "cid"))  >= 5 then
								self:combine("prop", v["id"], self.scroll)
							else
								KNMsg.getInstance():flashShow("碎片不足，5个以上碎片才可以合成")
							end

						elseif v["type"] == "ganen" then  --感恩礼券

							if isBagFull() then
								return false
							end
							HTTP:call("bag" , "use_ganen",{id = v['id']} , {
									success_callback = function(data)
												switchScene("bag",{kind = "prop", offset = self.scroll:getOffset(), page = self.curPage
														} , function()
																inform(data)
														end)
									end
								})
						elseif v["type"] == "yuebing" then  --感恩礼券

							if isBagFull() then
								return false
							end
							HTTP:call("bag" , "use_yuebing",{id = v['id']} , {
									success_callback = function(data)
												switchScene("bag",{kind = "prop", offset = self.scroll:getOffset(), page = self.curPage
														} , function()
																inform(data)
														end)
									end
								})
						elseif v["type"] == "heiyaoshi" then  --感恩礼券

							pushScene("propertyTransfer")

						elseif v["type"] == "transmission" then
							-- 判断等级开放
							local check_result = checkOpened("byexp")
							if check_result ~= true then
								KNMsg:getInstance():flashShow(check_result)
								return
							end

							-- switchScene("byexp")
							pushScene("byexp" , { backtype = "back_bag"} )
						elseif v["type"] == "stone" then
							-- 判断等级开放
							local check_result = checkOpened("pulse")
							if check_result ~= true then
								KNMsg:getInstance():flashShow(check_result)
								return
							end

							local hero = DATA_Formation:get_index(1)
							if DATA_General:haveGet() then
								HTTP:call("pulse" , "get", { id = hero.gid } , {
									success_callback = function()
										switchScene("pulse" , hero.gid)
									end
								})
							else
								HTTP:call("general" , "get",{} , {
									success_callback = function()
										HTTP:call("pulse" , "get", { id = hero.gid } , {
											success_callback = function()
												switchScene("pulse" , hero.gid)
											end
										})
									end
								})
							end
						elseif v["type"] == "vip" then
							--dump(v)
							if v.cid=="16031" and DATA_Power:get("num")==200 then
									-- KNMsg.getInstance():boxShow("当前体力已达到上限200,\n开启礼包后不会再获得体力\n(点确定继续开启，取消返回)", {cancelFun = function()end, confirmFun = function()
											HTTP:call("bag", "usevipkit", {id = v["id"]}, {
												success_callback = function(data,func)
													switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
														func(data)
													end)
												end
											})
									-- end})
							else
								HTTP:call("bag", "usevipkit", {id = v["id"]}, {
									success_callback = function(data,func)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											func(data)
										end)
									end
								})
							end

						elseif v["type"] == "palyerexp" then
							HTTP:call("bag", "use_exp", {id = v["id"]}, {
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
										KNMsg.getInstance():flashShow("使用成功，主角等级提升")
									end)
								end
							})
						elseif v["type"] == "heroexp" then
							HTTP:call("general" , "get",{},{success_callback =
								function()
									DATA_General:haveGet(true)
									DATA_Formation:set_index(1)
									switchScene("hero",{gid = DATA_Formation:getCur() })
								end
							})
						elseif v["type"] == "viptest" then
							HTTP:call("bag", "usev3card", {id = v['id']}, {
								success_callback = function()
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										KNMsg.getInstance():flashShow("vip3体验卡使用成功，尊享vip特权3天!~")
									end)
								end
							})
						elseif v["type"] == "honor" then
--							self:use(v['id'], DATA_Bag:get("prop", v["id"], "num"), scroll, function()end)
							self:use(v['id'], DATA_Bag:get("prop", v["id"], "num"), self.scroll, function(num)
								HTTP:call("bag", "usehonor", {id = v['id'], num = num}, {
									success_callback = function(data, fun)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(), page = self.curPage}, function()
											fun(data)
										end)
									end
								})
							end)
						elseif v["type"] == "lingyuan" then

							self:use(v['id'], DATA_Bag:get("prop", v["id"], "num"), self.scroll, function(num)
								HTTP:call("bag", "uselingyuan", {id = v['id'], num = num}, {
									success_callback = function(data, fun)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(), page = self.curPage}, function()
											fun(data)
										end)
									end
								})
							end)
						elseif v["type"] == "zhufu" then
							HTTP:call("bag", "usezhufukit", {id = v["id"]}, {
								success_callback = function(data,func)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
										func(data)
									end)
								end
							})
						elseif v.type == "silverrand" or v.type == "goldrand" or v.type == "lingyuanrand" then
							HTTP:call("bag", "use_"..v.type, {id = v["id"]}, {
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
										local func = requires(IMG_PATH, "GameLuaScript/Network/httpActions")
										dump(data)
										func.inform(data)
									end)
								end
							})
						elseif v.type == "heroexpcard" then
							HTTP:call("bag", "use_"..v.type, {id = v["id"]}, {
									success_callback = function(data)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											KNMsg.getInstance():flashShow(data.str)
										end)
									end
								})
						elseif v.type == "expcard" or v.type == "silvercard" then
							HTTP:call("bag", "use_"..v.type, {id = v["id"]}, {
									success_callback = function(data)
										switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
											KNMsg.getInstance():flashShow(data.str)
										end)
									end
								})

						elseif v["type"] == "stonefu" then
							HTTP:call("bag", "usestonetfu", {id = v["id"]}, {
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										KNMsg.getInstance():flashShow(data.str)
									end)
								end
							})
						elseif v["type"] == "godstone" then
							HTTP:call("general" , "get",{},{success_callback =
								function()
									DATA_General:haveGet(true)
									DATA_Formation:set_index(1)
									switchScene("hero",{gid = DATA_Formation:getCur() })
								end
							})
						elseif v["type"] == "timelimitgodstone" then
							HTTP:call("general" , "get",{},{success_callback =
								function()
									DATA_General:haveGet(true)
									DATA_Formation:set_index(1)
									switchScene("hero",{gid = DATA_Formation:getCur() })
								end
							})
						elseif v["type"] == "godhero" then
							HTTP:call("bag", "use_godhero", {id = v["id"]}, {
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										KNMsg.getInstance():flashShow(data.str)
									end)
								end
							})
						elseif v["type"] == "godequipbox" or v["type"] == "godskillbox" or v["type"] == "godwirebox" then
							HTTP:call("bag", "use_godbox", {id = v["cid"]}, {
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										KNMsg.getInstance():flashShow(data.msg)
									end)
								end
							})
						elseif v["type"] == "lotterybox" then
							HTTP:call("bag", "use_lotterybox", {id = v["id"]}, {
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										KNMsg.getInstance():flashShow(data.msg)
									end)
								end
							})
						elseif v["type"] == "herosale" or v.type == "petsale" or v.type == "skillsale" then
							HTTP:call("bag", "usesale", {id = v["id"]}, {
								success_callback = function(data)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										KNMsg.getInstance():flashShow(data.str)
									end)
								end
							})
						elseif v["type"] == "envelope" then
							HTTP:call("bag", "useenvelope", {id = v["id"]}, {
								success_callback = function(data, func)
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										func(data)
									end)
								end
							})
						elseif v["type"] == "equipstrongfu" then
							--列表
							local list
							list = SelectList:new("equip",self.viewLayer,display.newSprite(COMMONPATH .. "title/quick_up_title.png"),{
								btn_opt = "use.png",
								target = true,
								all = true,
								exceptUse = true,
								y = 85 ,
								showTitle = true ,
								filter = {star = getConfig("prop", v.cid, "star")},
								optCallback = function()
									local targetId = list:getCurItem():getId()
									showTip({
										content = createLabel({str = '您确定要快速强化此装备到当前最大强化等级吗？', width = 300, size = 24}),
										right = {
											remove = true
										},
										left = {
											remove = true,
											callback = function()
												HTTP:call("equip", "equipstrongfu", {equip_id = targetId, fu_id = v.id}, {
													success_callback = function()
														switchScene("bag", {kind = kind, offset = self.scroll:getOffset(), page = self.curPage}, function()
															KNMsg.getInstance():flashShow("恭喜您快速强化成功，装备已达最大等级")
														end)
													end,error_callback = function(data)
														KNMsg.getInstance():flashShow(data.msg)
														list:getCurItem():resetCurrent()
													end
												})
											end
										}
									})
								end
								})
							self.baseLayer:addChild(list:getLayer())

						elseif v["type"] == "lingyuanessence" then
							KNMsg:getInstance():flashShow("在提升神格等阶的时候使用")

						elseif v["type"] == "jbtx" then
							dump("ZCCS")
							HTTP:call("bag", "use_jbtx", {prop_key = v["id"]}, {
								success_callback = function(data )
									switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage}, function()
										KNMsg:getInstance():flashShow( data.msg or "" )
									end)
								end
							})
						end
					end


				end
			})
			--检查是否有选中的出售元素
			if table.hasValue(self.sellItems, v["id"]) then
				item:check(true)
			end

			setAnchPos(item:getLayer(),pos[posCount],15)
			lineLayer:addChild(item:getLayer() )

			posCount=posCount+1
		end

		if offset then
			self.group:chooseById(kind,false)
			self.scroll:setOffset(offset)
		end
		self.scroll:alignCenter()
		--self.scroll:effectIn()
		self.itemsLayer:addChild(self.scroll:getLayer())
		if kind=="prop" then
			local zhengLiBtn = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"},15,105,{
				front = PATH.."zhengli.png",
				scale = true,
				callback = function()
						HTTP:call("bag","sortOut",{ } , {
									success_callback = function( data)
											
											switchScene("bag", {kind = kind, offset = self.scroll:getOffset(),page = self.curPage},function()
												KNMsg.getInstance():flashShow(data.msg)
												
											end)
									end
							})
				end})
			self.itemsLayer:addChild(zhengLiBtn:getLayer())
		end

		--显示物品当前数量
		self.itemsLayer:addChild(createLabel({str = DATA_Bag:count(kind).."/"..DATA_Vip:getBagMax(), x = 30+65, y = 115,size=16, color = ccc3(255, 255,255)}))

		if not self.sell then
			local sellBtn
			sellBtn = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"},15+365,105,{
			front = PATH.."bag_sell.png",
			scale = true,
			callback = function()
				local cur_tab = self.group:getId()
				if cur_tab == "general" then
					KNMsg.getInstance():flashShow("英雄不可出售")
					return
				end
				if cur_tab == "pet" then
					KNMsg.getInstance():flashShow("幻兽不可出售")
					return
				end

				self.sell = true
				self.sellItems = {}
				self:createBag(cur_tab)
				self:createStatLayer(cur_tab, newSort)
				sellBtn:showBtn(false)
				sellBtn:setEnable(false)
			end})
			self.itemsLayer:addChild(sellBtn:getLayer())
		end


		local bg = display.newSprite(COMMONPATH.."page_bg.png")
		setAnchPos(bg,240,110,0.5)
		self.itemsLayer:addChild(bg)

		local pageNum = display.strokeLabel(self.curPage.."/"..self.maxPage, 0, 0, 20, ccc3(0xff, 0xfb, 0xd4))
		setAnchPos(pageNum, 240, 115, 0.5)
		self.itemsLayer:addChild(pageNum)

		--翻页按钮
		local pre = KNBtn:new(COMMONPATH,{"next_big.png"}, 150, 100, {
			scale = true,
			flipX = true,
			callback = function()
				if self.curPage > 1 then
					self:createBag(kind, offset, self.curPage - 1)
				end
			end
		})
		self.itemsLayer:addChild(pre:getLayer())

		local next = KNBtn:new(COMMONPATH,{"next_big.png"}, 285, 100, {
			scale = true,
			callback = function()
				if self.curPage < self.maxPage then
					self:createBag(kind, offset, self.curPage + 1)
				end
			end
		})
		self.itemsLayer:addChild(next:getLayer())


	else

		local text = display.newSprite(COMMONPATH.."empty.png")
		setAnchPos(text,240, 425, 0.5,0.5)
		self.itemsLayer:addChild(text)
	end
	self.layer:addChild(self.itemsLayer)
end




function BagLayer:createStatLayer(kind, rule)
	if self.statLayer then
		self.layer:removeChild(self.statLayer,true)
	end

	if self.sell then
		self.statLayer = display.newLayer()
		local countBg = display.newSprite(PATH.."bag_num_bg.png")
		local countText = display.newSprite(PATH.."bag_num_text.png")
		local valueBg = display.newSprite(PATH.."bag_value_bg.png")
		local valueText = display.newSprite(COMMONPATH.."silver.png")
		self.selectNum = CCLabelTTF:create("0",FONT,20)
		self.totalValue = CCLabelTTF:create("0",FONT,20)

		--一键选 当前
		local oneKeyBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},-25+320,-55,{scale = true, front = COMMONPATH.."onekey.png", callback =
			function()
				self.total = 0
				for k, v in pairs(self.keyList[kind]) do
					if getConfig(kind, DATA_Bag:get(kind, v.."", "cid"), "star") < 4 then
						self.sellItems[tonumber(v)] = tonumber(v)
					end
				end

				if table.nums(self.sellItems) > 0 then
					for k, v in pairs(self.sellItems) do
						self.total = self.total + DATA_Bag:get(kind,v,"price") * (DATA_Bag:get(kind, v, "num") or 1)
					end
					self:createBag(kind, nil, self.curPage)
					self.selectNum:setString(table.nums(self.sellItems))
					self.totalValue:setString(self.total)
					KNMsg.getInstance():flashShow("已为您选取当前类型所有三星及以下物品")
				else
					KNMsg.getInstance():flashShow("当前类型没有三星以下物品,稀有物品请您谨慎出售")
				end

			end
			})

		local okBtn = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"},250,0,{scale = true, front = COMMONPATH.."ok.png", callback =
			function()
				local special = false
				for k, v in pairs(self.sellItems) do
					if getConfig(kind, DATA_Bag:get(kind, v.."", "cid"), "star") > 3 then
						special = true
						break
					end
				end

				if special then
					showTip({
						content = createLabel({str = "您选择的物品中存在珍稀物品，您确定要出售吗？", width = 400 }),
						priority= -160,
						left = {

							remove = true,
							callback = function()
								HTTP:call("bag","sell",{type = kind,ids = string.join(self.sellItems,",")},{success_callback=
									function(data)

										self.layer:removeChild(self.statLayer,true)
										self.sell = false
										self.sellItems = {}
										self.keyList[kind] = getSortList(DATA_Bag:getTable(kind), rule)
										self:createBag(kind)
										KNMsg.getInstance():flashShow(data['result']['msg'])
										self.total = 0
									end
								})
							end
						},right = {
							remove = true
						}
					})
				else
					HTTP:call("bag","sell",{type = kind,ids = string.join(self.sellItems,",")},{success_callback=
							function(data)

								self.layer:removeChild(self.statLayer,true)
								self.sell = false
								self.sellItems = {}
								self.keyList[kind] = getSortList(DATA_Bag:getTable(kind), rule)
								self:createBag(kind)
								KNMsg.getInstance():flashShow(data['result']['msg'])
								self.total = 0
							end
						})
				end
			end
			})

		local cancelBtn = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"},340,0,{scale = true,front = COMMONPATH.."cancel.png", callback=
			function()
				self.layer:removeChild(self.statLayer,true)
				self.sell = false
				self.total = 0
				self.sellItems = {}
				self:createBag(self.group:getId())
			end
			})

		setAnchPos(countText,10,10)
		setAnchPos(countBg,55,5)
		setAnchPos(valueText,100,10)
		setAnchPos(valueBg,130,5)
		setAnchPos(self.selectNum,62,10)
		setAnchPos(self.totalValue,150,10)
		setAnchPos(self.statLayer,30,160)

		self.statLayer:addChild(countBg)
		self.statLayer:addChild(valueBg)
		self.statLayer:addChild(countText)
		self.statLayer:addChild(valueText)
		self.statLayer:addChild(okBtn:getLayer())
		self.statLayer:addChild(oneKeyBtn:getLayer())
		self.statLayer:addChild(cancelBtn:getLayer())
		self.statLayer:addChild(self.selectNum)
		self.statLayer:addChild(self.totalValue)

		self.layer:addChild(self.statLayer)
	end
end


--多个道具使用
function BagLayer:use(id , max, scroll, callback )
	self.buyLayer = display.newLayer()
	local baseX = display.cx
	local baseY = display.cy - 28

	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos( bg , baseX - 193 , baseY , 0 , 0 )
	self.buyLayer:addChild(bg)

	--物品Icon
	local icon = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , baseX - 148 , baseY + 135 , {  front = getImageByType(DATA_Bag:get("prop", id , "cid") , "s") } )
	self.buyLayer:addChild( icon:getLayer() )

	-- 名字
	self.name = display.strokeLabel( DATA_Bag:get("prop", id,"name") , baseX - 75 , baseY + 170 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 130 , dimensions_height = 30 ,align = 0 } )
	self.buyLayer:addChild( self.name )

	--购买数量
	local numBg = display.newSprite(PATH.."bag_num_bg.png")
	local num = 1
	setAnchPos(numBg,baseX + 116 , baseY + 136 , 0 )
	self.buyLayer:addChild(numBg)

	--数量文本
	local numText = display.strokeLabel( 1 .. "" , baseX + 116 , baseY + 136 , 20 , ccc3(0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 36 , dimensions_height = 30 ,align = 1 } )
	self.buyLayer:addChild(numText)

--	if math.floor(DATA_Bag:getTypeCount("prop", DATA_Bag:get(type, id, "cid")) / 5) > 1 then
		--修改数值
		local function changeValue()
			numText:setString(num)
		end

		--划动条
		local slider = KNSlider:new( "buy" ,  {
											x = baseX - 106 ,
											y = baseY -53 ,
											minimum = 1 ,
											maximum = max,
											value = 1 ,
											callback  = function( _curIndex ) num =  _curIndex  changeValue() end ,
											priority = -140
											} )
		self.buyLayer:addChild( slider )

		--增减按钮
		local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX + 128 , baseY + 77 , {
			scale = true,
			priority = -130,
			callback = function()
				if num < 99 then
					num = num + 1
					slider:setValue( num )
				end
			end
		})

		local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX - 165 , baseY + 77 ,{
			scale = true,
			priority = -130,
			callback = function()
				if num > 1 then
					num = num - 1
					slider:setValue( num )
				end
			end
		})
		minusBtn:setFlip(true)

		addBtn:getLayer():setScale( 0.9 )
		minusBtn:getLayer():setScale( 0.9 )
		self.buyLayer:addChild(addBtn:getLayer())
		self.buyLayer:addChild(minusBtn:getLayer())


--	end


	local mask = KNMask:new( {item = self.buyLayer } )
	--确定，取消按钮
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, baseX - 134 , baseY + 28 ,{
		front = COMMONPATH .. "use_small.png" ,
		scale = true,
		priority = -130,
		callback = function()
			callback(num)
		end
	})
	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , baseX + 54 , baseY + 28 ,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			mask:remove()
			-- self.baseLayer:removeChild(mask:getLayer(),true)
		end})
	self.buyLayer:addChild(ok:getLayer())
	self.buyLayer:addChild(cancel:getLayer())


	self.baseLayer:addChild(mask:getLayer())
end

--宝石合成
function BagLayer:combine( type , id , scroll )
	self.buyLayer = display.newLayer()
	local baseX = display.cx
	local baseY = display.cy - 28

	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos( bg , baseX - 193 , baseY , 0 , 0 )
	self.buyLayer:addChild(bg)

	--物品Icon
	local icon = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , baseX - 148 , baseY + 135 , {  front = getImageByType(DATA_Bag:get(type, id , "cid") , "s") } )
	self.buyLayer:addChild( icon:getLayer() )

	-- 名字
	self.name = display.strokeLabel( DATA_Bag:get(type, id,"name") , baseX - 75 , baseY + 170 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 130 , dimensions_height = 30 ,align = 0 } )
	self.buyLayer:addChild( self.name )

	--购买数量
	local numBg = display.newSprite(PATH.."bag_num_bg.png")
	local num = 1
	setAnchPos(numBg,baseX + 116 , baseY + 136 , 0 )
	self.buyLayer:addChild(numBg)

	--数量文本
	local numText = display.strokeLabel( 1 .. "" , baseX + 116 , baseY + 136 , 20 , ccc3(0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 36 , dimensions_height = 30 ,align = 1 } )
	self.buyLayer:addChild(numText)

--	if math.floor(DATA_Bag:getTypeCount("prop", DATA_Bag:get(type, id, "cid")) / 5) > 1 then
		--修改数值
		local function changeValue()
			numText:setString(num)
		end

		--划动条
		local slider = KNSlider:new( "buy" ,  {
											x = baseX - 106 ,
											y = baseY -53 ,
											minimum = 1 ,
											maximum = math.floor(DATA_Bag:getTypeCount("prop", DATA_Bag:get(type, id, "cid")) / 5),
											value = 1 ,
											callback  = function( _curIndex ) num =  _curIndex  changeValue() end ,
											priority = -140
											} )
		self.buyLayer:addChild( slider )

		--增减按钮
		local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX + 128 , baseY + 77 , {
			scale = true,
			priority = -130,
			callback = function()
				if num < 99 then
					num = num + 1
					slider:setValue( num )
				end
			end
		})

		local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX - 165 , baseY + 77 ,{
			scale = true,
			priority = -130,
			callback = function()
				if num > 1 then
					num = num - 1
					slider:setValue( num )
				end
			end
		})
		minusBtn:setFlip(true)

		addBtn:getLayer():setScale( 0.9 )
		minusBtn:getLayer():setScale( 0.9 )
		self.buyLayer:addChild(addBtn:getLayer())
		self.buyLayer:addChild(minusBtn:getLayer())


--	end


	local mask = KNMask:new( {item = self.buyLayer } )
	--确定，取消按钮
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, baseX - 134 , baseY + 28 ,{
		front = COMMONPATH.."hecheng_small.png" ,
		scale = true,
		priority = -130,
		callback = function()
			HTTP:call("pulse", "merge", {num = num , id = id}, {
				success_callback = function()
					switchScene("bag",{kind = "prop", offset = self.scroll:getOffset(),page = self.curPage
								} , function()
									KNMsg.getInstance():flashShow("宝石已合成")
								end)
				end
			})
		end
	})
	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , baseX + 54 , baseY + 28 ,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			mask:remove()
			-- self.baseLayer:removeChild(mask:getLayer(),true)
		end})
	self.buyLayer:addChild(ok:getLayer())
	self.buyLayer:addChild(cancel:getLayer())


	self.baseLayer:addChild(mask:getLayer())
end

--跟据类型断需要哪一个全局数据文件,和详细信息类名
function BagLayer:getDataFile(kind)
	local data
	if kind == "equip" then
		data = DATA_Equip
	elseif kind == "skill" then
		data = DATA_Bag
	elseif kind == "pet" then
		data = DATA_Pet
	elseif kind == "prop" then
		data = DATA_Bag
	elseif kind == "general" then
		data = DATA_General
	end
	return data
end
return BagLayer
