--[[

特效层

]]--


local M = {}

local heroCell = requires(IMG_PATH,"GameLuaScript/Scene/battle/heroCell")
local petLayer = requires(IMG_PATH,"GameLuaScript/Scene/battle/pet/petLayer")
local logic = requires( IMG_PATH , "GameLuaScript/Scene/battle/logicLayer")
local slideBossData
function M:create( data )
	local layer = display:newLayer()
	slideBossData = data.boss or {}

	return layer
end

function M:actions(data)
	--添加被克效果
	if data.atk and data.be_atk then
		
		local function showEff( tempData )
			local atkHero   = heroCell:get( data.atk[1].group , data.atk[1].index)	--攻击者
			local beAtkHero = heroCell:get( tempData.group    , tempData.index )	--被攻者
			local atkRole   = atkHero:getData( "role" )
			local beAtkRole = beAtkHero:getData( "role" )
			--相克关系
			local restrain = {
								[ "13" ] = "1克3" , 
								[ "21" ] = "2克1" , 
								[ "32" ] = "3克2" , 
								} 
			if restrain[ atkRole..beAtkRole.."" ] then
				local beAtkSize = beAtkHero:getPositionAndSize()
				
				local restrainSp = display.newSprite( IMG_PATH .. "image/scene/battle/effect/restrain.png" )
				
				setAnchPos( restrainSp , beAtkSize._cx + 20 , beAtkSize._y + 50 , 0.5 , 0.5)
				
				
				--[[特效开始]]
				restrainSp:setScale(0.3)
				transition.scaleTo(restrainSp, {
					time = 0.1,
					scale = 2.5,
				})
				transition.scaleTo(restrainSp, {
					delay = 0.2,
					time = 0.2,
					scale = 1,
				})
				
				
				transition.fadeOut(restrainSp, {
					delay = 0.7,
					time = 0.3,
					onComplete = function()
						restrainSp:removeFromParentAndCleanup(true)	-- 清除自己
					end
				})
				
				logic:getLayer( "effect" ):addChild( restrainSp )
			end
		end
		for key , v in pairs(data.be_atk) do
			showEff(v)
		end
	end
	
	M:changeActions( data["change"] , data )
	
	--修改宠物怒气值
	if data.p1_sp ~= nil then petLayer:selfRefreshPetSp( data , 1 ) end
	if data.p2_sp ~= nil then petLayer:selfRefreshPetSp( data , 2 ) end
	
	if data.dizhi then
		local be_atk = data["be_atk"][1]
		local atk_hero = heroCell:get( be_atk["group"] , be_atk["index"] )
		
		local effSprite
		local effFrames = display.newFramesWithImage( IMG_PATH.."image/scene/battle/dizhi_eff.png" , 10 , 2  )
		effSprite =display.playFrames( 0  , 0  , effFrames , 0.15 , { onComplete =
																		 function() 
																			effSprite:removeFromParentAndCleanup( true ) 
																		 end
																		 } )
		setAnchPos(effSprite , atk_hero._cx  , atk_hero._cy , 0.5 , 0.5 )
--		setAnchPos(effSprite , ( tonumber( data.dizhi ) == 1 and 100 or 390 )  , ( tonumber( data.dizhi ) == 1 and 100 or 760 ) , 0.5 , 0.5 )
		display.getRunningScene():addChild( effSprite )
		
		effSprite:setScale( 0.1 )
		
		transition.scaleTo(effSprite , { time = 0.2 , scale = 1 } )
		transition.moveTo( effSprite , {
			time = 0.2,
--			x = atk_hero._cx,
--			y = atk_hero._cy,
			x = ( tonumber( data.dizhi ) == 1 and 100 or 390 ) ,
			y = ( tonumber( data.dizhi ) == 1 and 100 or 760 ) ,
		})
	end
	
	if data.status then

		local function overHandler()
			logic:resume( "jinyan" )
			logic:resume( )
		end
		local effectTime = 0.15	
		local function renderEffect( tempData , key )
		
			logic:pause( "jinyan" )
			
			--目标英雄
			local targetHero = requires( IMG_PATH,"GameLuaScript/Scene/battle/heroCell"):get( tempData.group , tempData.index )
			local targetSizeInfo = targetHero:getPositionAndSize()
			
			--添加状态图片
			local function lockEffect()
				-- 清除上一个状态的图片
				local targetHeroLastEffect = targetHero:getData()["last_effect"]
				if targetHeroLastEffect then
					local targetHeroData = targetHero:getData()[targetHeroLastEffect]
					if targetHeroData and targetHeroData.flag then
						targetHeroData.flag:removeFromParentAndCleanup( true )
						targetHeroData = nil
					end
				end
	
				
				--给目标英英雄添加 效果数据
				local  flagSp = display.newSprite(IMG_PATH.."image/scene/battle/pet/eff_flag/".. tempData.type .. "_flag.png")
				--英雄状态记录
				if data.status then
					targetHero:setData( tempData.type , { keep = tempData.keep , flag = flagSp })
					targetHero:setData( "last_effect" , data.type)
					local lockSpSize = flagSp:getContentSize()
					setAnchPos( flagSp , lockSpSize.width / 2 - 5, lockSpSize.height / 2 , 0.5 , 0.5 )
					targetHero:addChild(flagSp)
				end
				
				local actionTime = 0.2
				local actions = CCArray:create()
				actions:addObject( CCFadeIn:create( actionTime ))
				actions:addObject( CCCallFunc:create( overHandler) )
				flagSp:runAction( CCSequence:create( actions ) )
			end
			
	    	local atk = data["atk"][1]
			local atk_hero = heroCell:get( atk["group"] , atk["index"] )
			--效果动画
			local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/jinyan_eff.png" , 12 )
			
			for i = 1 , 10 do
				local sprite
				sprite = display.playFrames(
					targetHero._cx, 
					targetHero._cy,
					frames,
					0.15,
					{
						delay = 0.05,
						onComplete = function()
							sprite:removeFromParentAndCleanup(true)	-- 清除自己
							if i == 10 then
								local isExist = false 
								for k , v1 in pairs( data.change ) do
									if v1.group == tempData.group and v1.index  == tempData.index and v1["hp"] > 0 then
										isExist = true
									end
								end
										
								--改变锁定状态(必须人还活着)
								if isExist then
									lockEffect()
								else
									overHandler()
								end
							end
						end
					}
				)
				
			
			
				setAnchPos( sprite , atk_hero._cx , atk_hero._cy , 0.5 , 0.5 )
				transition.moveTo( sprite , { delay = i * 0.1 ,  time = 0.2 , x = targetHero._cx , y = targetHero._cy , } )
				
				sprite:setScale( 0.1 )
				transition.scaleTo(sprite , { time = 0.2 , scale = 1 } )
				
				display.getRunningScene():addChild( sprite )
			end
			
		end
				
		
		for key , v in pairs( data.status ) do
			if v.type == "jinyan" then
				renderEffect( v , key )
			end
		end
	end
	
	
end

--[[ change 字段公用特效 ]]
function M:changeActions( change_data , data )
	if type(change_data) ~= "table" then return end
	for i = 1 , #change_data do
		-- 扣血
		local cur_data = change_data[i]
		local cur_hero = heroCell:get( cur_data["group"] , cur_data["index"] )
		cur_hero:setData("hp" , cur_data["hp"])
		cur_hero:refreshViewHp()
		
		-- 显示掉血动画
		local isCrit = ( isset(cur_data , "actions") and cur_data["actions"]["crit"] ) and true or false --是否是暴击掉血
		isCrit = ( isset(cur_data , "actions") and cur_data["actions"]["shanghai"] ) and true or false		--乘胜追击  掉血
			
		local effect_changeHp = requires(IMG_PATH,"GameLuaScript/Scene/battle/effect/changeHp")
		effect_changeHp:run( cur_hero , cur_data["hp_diff"] , { isCrit = isCrit } )

		--清除挂掉的人
		local function clear()
			local heroAction_die = requires(IMG_PATH,"GameLuaScript/Scene/battle/heroAction/die")
			heroAction_die:normal( cur_hero , {
				onComplete = function()
					--死亡动画执行完毕
					if cur_data["actions"] and cur_data["actions"]["is_zibao"] then
						
					else
						heroCell:clear( cur_data["group"] , cur_data["index"] )
					end
				end
			})
		end


		-- 附加动作
		local isFly = false
		if isset(cur_data , "actions") then

			--二级属性文字提示
			local attribEffect = requires(IMG_PATH,"GameLuaScript/Scene/battle/effect/twoAttribText")
			attribEffect:run(  cur_hero , cur_data["actions"] , data )
--			-- 闪避
--			if cur_data["actions"]["dodge"] then
--				local effect_dodge = requires(IMG_PATH,"GameLuaScript/Scene/battle/effect/dodge")
--				effect_dodge:run( cur_hero )
--			end
--
--			-- 暴击
--			if cur_data["actions"]["crit"] then
--				local effect_critical = requires(IMG_PATH,"GameLuaScript/Scene/battle/effect/critical")
--				effect_critical:run( cur_hero )
--			end
--
--			-- 击飞
--			if cur_data["actions"]["fly"] then
--				isFly = true
--				local effect_fly = requires(IMG_PATH,"GameLuaScript/Scene/battle/effect/fly")
--				effect_fly:run( cur_hero ,{ clear = clear})
--			end

		end

		-- 受击效果
		if cur_data["hp_diff"] < 0 then
			local heroAction_be_attack = requires(IMG_PATH,"GameLuaScript/Scene/battle/heroAction/be_attack")
			heroAction_be_attack:normal( cur_hero )
		end
		
		--已方武将死亡
		if tonumber(cur_data["hp"]) <= 0 then
--			local handle
--			local function delayRealize()
--				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
--				handle = nil
--				clear()
--			end
--			handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(delayRealize , 0.5 , false)
--			--延迟死亡使后续一些
--			cur_hero:setVisible( false )
			--划动掉宝 敌方死亡触发
			
			clear()
			local dieCid = cur_hero:getData().cid or cur_hero:getData().npc_id
			if cur_data["group"] == 2 and slideBossData.boss_cid == dieCid then
				local effect_slide = requires(IMG_PATH,"GameLuaScript/Scene/battle/effect/slide")
				local tempData = slideBossData or {}
				--出现slide证明当前英雄已死亡,需要执行清除
				effect_slide:run( cur_hero ,  tempData )
			end
		end


		--显示掉宝动画
		if cur_data["drop"] then
			local effect_dorp = requires(IMG_PATH,"GameLuaScript/Scene/battle/effect/drop")
			effect_dorp:run( cur_hero , cur_data["drop"] )
		end

	end
end

return M
