--[[

战斗结果

]]


local M = {}
local HeroLayer = requires(IMG_PATH,"GameLuaScript/Scene/hero/herolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local Upgrade = requires(IMG_PATH,"GameLuaScript/Scene/common/upgrade")
local KNShowbylist = requires(IMG_PATH , "GameLuaScript/Common/KNShowbylist")
local KNNumberroll = requires(IMG_PATH,"GameLuaScript/Common/KNNumberroll")
local KNCardpopup = requires(IMG_PATH,"GameLuaScript/Common/KNCardpopup")
local KNBar = requires(IMG_PATH , "GameLuaScript/Common/KNBar")
local award_handle = nil		-- 弹出奖励动画的定时器
local card_mask
local result_sprite
local confirmBtn		-- 确定按钮
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")

local PATH = IMG_PATH.."image/scene/battle/fruit/"
local WIN_PATH = IMG_PATH.."image/scene/battle/fruit/win/"
local LOST_PATH = IMG_PATH.."image/scene/battle/fruit/lost/"
local TITLE_PATH = WIN_PATH .. "title_win.png"		
local girl		--女孩
local bgFrame	--公用
local addType 	--坐标类型
local resultData
local battleParams
local logic
if not __INNER_USE_NEW_BATTLE then
	logic = requires(IMG_PATH,"GameLuaScript/Scene/battle/logicLayer")
end

function M:create( params )
	confirmBtn = nil
	addType = 0
	params = params or {}
	
	--强制清除宠物目标选择层
	local scene = display.getRunningScene()
	if scene:getChildByTag("899") then
		local selectMask = scene:getChildByTag("899")
		if selectMask then
			scene:removeChild(selectMask , true)
		end
	end
	
	if DATA_Battle:getMod() == "guide" then
		if DATA_Battle:getAct() == "godwar" then
		
		elseif DATA_Battle:getAct() == "join" then
		
		elseif DATA_Battle:getAct() == "revolt" then
			
		else
			return M:guide_result()
		end
	end
	
	local fbMode = {
					 inshero  = "十字坡" ,		
					 insequip = "藏宝楼" ,
					 inspet   = "景阳岗" , 	
					 insskill = "如意阁" , 	
					 rob 	  = "夺宝" , 	
					}
	
	--战斗结果数据
	resultData = DATA_Result:get()

	--扫荡数据
	if params.type == "mopUp" then
		return M:mission_result( params )
	end
	
	
	-- 数据兼容
	resultData.awards = resultData.awards or {}

	if resultData.is_win then
		
		if tonumber( resultData.is_win ) ~= 1 then
			M:warLost()
		else
			if resultData.type == "rob" or  resultData.type == "mining" or resultData.type == "socialclass" or resultData.type == "socialclassfight" or resultData.type=="trial" or resultData.type=="guoqing_activity" then
				if resultData.success == 0 then
					M:warLost()

				else
					audio.playMusic( IMG_PATH .. "sound/win.mp3" , false )
				end
			else
				audio.playMusic( IMG_PATH .. "sound/win.mp3" , false )
			end
		end

	else
		if DATA_Battle:get("win") ~= 1 then
			M:warLost()
		else
			if resultData.type == "rob" or  resultData.type == "mining" or resultData.type == "socialclass" or resultData.type == "socialclassfight" or resultData.type=="trial" or resultData.type=="guoqing_activity" then
				if resultData.success == 0 then
					M:warLost()
				else
					audio.playMusic( IMG_PATH .. "sound/win.mp3" , false )
				end
			else
				audio.playMusic( IMG_PATH .. "sound/win.mp3" , false )
			end
		end
	end
	
	if fbMode[ resultData.type ] then	--磨练
		return M:instance_result()
	elseif resultData.type == "athletics" then	--竞技
		return M:athletics_result()
	elseif resultData.type == "friends" then	--好友切磋
		return M:friends_result()
	elseif resultData.type == "mining" then		--抢夺矿山
		return M:mining_result()
	elseif resultData.type == "trial" then		--铁血试炼战斗
		return M:trial_result()
	elseif resultData.type == "guoqing_activity" then		--国庆活动爬塔战斗
		return M:guoqing_result()
	elseif resultData.type == "xinmo" then		--心魔试炼战斗结算
		local function backFun(  )
			HTTP:call("xinmo","initData",{},{
							success_callback = function(data)
								pushScene("xinmo",data)
						end})
		end

		return M:mission_result( { backFun = backFun } )
		
	elseif resultData.type == "common_fuben_silver" or resultData.type == "common_fuben_sourcehope" or resultData.type == "common_fuben_exp" or resultData.type == "common_fuben_cuilian" or resultData.type == "common_fuben_skill" then		--单人副本战斗
		return M:silver_result()
	elseif resultData.type == "kuafu" then
		return M:prewar_result()
	elseif resultData.type == "socialclass" or resultData.type == "socialclassfight" then		--皇权
		return M:power_result()
	elseif resultData.type == "godwar" then
		return M:godwar_result()
	elseif DATA_Battle:getAct() == "join" then	--神战招揽
		TITLE_PATH = WIN_PATH .. "mission_win.png"
		return M:join_result() 
	elseif DATA_Battle:getAct() == "revolt" then	--神战反击
		TITLE_PATH = WIN_PATH .. "mission_win.png"
		return M:revolt_result() 
	elseif DATA_Battle:getMod() == "empire" or DATA_Battle:getMod()=="empirearena" then 
		return M:empire_result() 
	elseif DATA_Battle:getMod() == "zhenfawar" then 
		return M:zhenfawar_result(params)
	elseif DATA_Battle:getAct() == "receive_ruins" then 
		return M:ruins_result()
	else

		TITLE_PATH = WIN_PATH .. "mission_win.png"
		return M:mission_result()		--任务
	end

end

--战斗失败
function M:warLost()
	--数据兼容
	resultData = resultData or {}
	audio.playMusic( IMG_PATH .. "sound/lose.mp3" , false )
	
	result_sprite = display.newSprite( LOST_PATH .. "lost_bg.jpg")
	local size = result_sprite:getContentSize()
	
	local baseHeight = 16
	local lostTipPath
	if resultData.type == "athletics" then	lostTipPath = "lost_tip_athletics.png"		--竞技
	elseif resultData.type == "insskill" then lostTipPath = "lost_tip_skill.png"		--如意阁
	elseif resultData.type == "mining" and resultData.success == 0  then lostTipPath = "tip_mine_text.png"		--矿山战斗胜利但已经被别人占领
	elseif resultData.type == "trial" and resultData.success == 0  then lostTipPath = "lost_title.png"	--铁血试炼失败
	elseif resultData.type == "guoqing_activity" and resultData.success == 0  then lostTipPath = "lost_title.png"	--国庆活动失败
	elseif resultData.type == "common_fuben_silver" or resultData.type == "common_fuben_sourcehope" or resultData.type == "common_fuben_exp" or resultData.type == "common_fuben_cuilian" or resultData.type == "common_fuben_skill" and resultData.success == 0  then lostTipPath = "lost_title.png"	--单人副本失败
	elseif resultData.type == "join" and resultData.success == 0  then lostTipPath = "lost_title.png"		--招揽结算
	elseif resultData.type == "revolt" and resultData.success == 0  then lostTipPath = "lost_title.png"		--苦力反击
	else lostTipPath = "lost_tip_text.png"	
	end

	local existMiss = {
				insequip = "insequip" , 
				mission = "mission" , 
				mining = "mining",
				athletics = "athletics",
	}
	
	
	local lostPath
	if resultData.type == "rob" then
		 lostPath = "rob_lost.png"
	elseif resultData.type == "godwar" then
		if resultData.fight == "revenge" then
			 lostPath = "revenge_lost.png"
		elseif resultData.fight == "rob" then
			 lostPath = "godrob_lost.png"
		else
			 lostPath = "lost_title.png" 
		end
	else
		 lostPath = "lost_title.png" 
	end

	if tonumber(resultData.is_win) == -1 then 
		 lostPath = "dogfall_title.png" 
	end

	local lostTitle = display.newSprite( LOST_PATH .. lostPath)
	bgFrame = display.newSprite( LOST_PATH .. "lost_bg_frame.png")
	girl = display.newSprite( PATH .. "girl.png")
	local girlFace = display.newSprite( LOST_PATH .. "lost_face.jpg")
	local tipText = display.newSprite( LOST_PATH .. lostTipPath )
	local tipTitle = display.newSprite( LOST_PATH .. "tip_title.png")
	
	
	setAnchPos( result_sprite , display.cx - size.width / 2 , display.cy - size.height / 2 )
	setAnchPos( lostTitle , display.cx + 17 , 900 , 0.5 )
	setAnchPos( bgFrame , 20 , display.cy - baseHeight , 0 , 0.5 )
	setAnchPos( girl , 188 , display.cy - 27  , 0 , 0.5 )
	setAnchPos( girlFace , 188 + 131  , display.cy - 27 + 72 , 0 , 0.5 )
	setAnchPos( tipText , 45 , display.cy - baseHeight + 60 , 0 , 0.5 )
	setAnchPos( tipTitle , 45 , display.cy - baseHeight + 6  , 0 , 0.5 )

	result_sprite:addChild( lostTitle )
	result_sprite:addChild( bgFrame )
	result_sprite:addChild( girl )
	result_sprite:addChild( girlFace )

	if existMiss[ resultData.type .. "" ] then
		result_sprite:addChild( tipText )
	end
	result_sprite:addChild( tipTitle )
	local isHit = false
	--去强化
	local goStrengthen = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"} , ( existMiss[ resultData.type .. "" ] and 64 or ( display.cx - 73 ) ), 56 ,
		{
			priority = -150,
			front = LOST_PATH .. ( DATA_User:get("lv") <= 8 and "go_strengthen2.png" or "go_strengthen.png" ) ,
			callback = 
			function()
				if isHit then
					return 
				end
				isHit = true 
				
				if DATA_User:get("lv") <= 8 then
					if DATA_General:haveGet() then
						DATA_Formation:set_index(1)
						pushScene("hero",{gid = DATA_Formation:getCur() , closeFun = function() popScene() end })
					else
						HTTP:call("general" , "get",{},{success_callback =
							function()
								DATA_General:haveGet(true)
								DATA_Formation:set_index(1)
								pushScene("hero",{ gid = DATA_Formation:getCur() , closeFun = function() popScene() end })
							end
						})
					end
				else
					local homeLayer = requires(IMG_PATH,"GameLuaScript/Scene/home/homelayer")
					switchScene( "home" , nil , function() homeLayer:createAide() end ) 
				end
			end
		}):getLayer()
	
	

	if resultData.type ~= "join" and resultData.type ~= "revolt" then
		goStrengthen:setTag("222")
		result_sprite:addChild( goStrengthen )
	end
	
	--去打造
	if existMiss[ resultData.type .. "" ]  then
		local goForge = KNBtn:new( COMMONPATH , 
			{ "btn_bg_red.png" ,"btn_bg_red_pre.png"} , 275 , 56 ,
			{
				priority = -150,
				front = LOST_PATH ..  ( DATA_User:get("lv") <= 8 and "go_forge2.png" or "go_forge.png" )  ,
				callback = 
				function()
					if isHit then
						return 
					end
					isHit = true 
					
					if DATA_User:get("lv") <= 8 then
						-- 判断等级开放
						local check_result = checkOpened("forge")
						if check_result ~= true then
							KNMsg:getInstance():flashShow(check_result, {z=9999})
							return
						end
						pushScene( "forge" , { closeFun = function() popScene() end })
					else
						KNMsg.getInstance():boxShow( "1：如果游戏前期就遇到了困难，提升等级是提升实力最快的方式\n2：关卡里面的BOSS关卡可以提供大量经验值哦" , { 
																					confirmText = IMG_PATH .. "image/scene/aide/go_mission.png" , 
																					confirmFun = function()
																						if not DATA_Mission:get() then
																							HTTP:call("mission" , "get",{},{success_callback = function()
																								switchScene("mission")
																							end })
																						else
																							switchScene("mission")
																						end
																					end , 
																					cancelFun = function() switchScene("home") end,
																					z=9999 
																					} )	
					end
				end
			}):getLayer()
		if resultData.type ~= "join" and resultData.type ~= "revolt" then
			result_sprite:addChild( goForge )
		end
	end
	
	
	transition.moveTo( lostTitle , { time = 0.3 , y = 655 , easing  = "BACKOUT" })
	
	if resultData.type == "athletics" then
		local tempText = display.strokeLabel( "+" .. resultData.awards.fame , 45 + 113 , display.cy - baseHeight   , 18 , ccc3( 0xff , 0xfb , 0xd4 ) , nil , nil , { dimensions_width = 200 , dimensions_height = 70 , align = 0 } )
		result_sprite:addChild( tempText )
	end
		local tipStr = ( DATA_User:get("lv") ) and ( getConfig("data_lost")[ math.random( 1 , DATA_User:get("lv") ) .. "" ] or {} ) or {}
	if tipStr.describe then
		tipStr = tipStr.describe
	else
		tipStr = "召唤高星级战将，\n可提升战队的整体实力！"
	end
	if resultData.type == "rob" then
		tipStr = "糟糕，被对手发现，带着物品跑路啦！好可惜，差点就抢夺成功了TAT~"
	elseif resultData.type == "join" then
		if resultData.join_type and resultData.join_type == "loot" then
			tipStr = "对方太强大了，赶紧提升自己的战力吧！"
		elseif resultData.join_type and resultData.join_type == "fuchou" then
			tipStr = "复仇失败！对方不屑的看了你一眼，施施然扭头走人了！"
		else
			tipStr = "对方太强大了，赶紧提升自己的战力抓取更强的苦力吧"
		end

		--神战掉落装备
		if 1 == resultData.skill_full then
			display.strokeLabel("神战技能仓库已满，无法再获得技能", 20, 146, 20, ccc3(216, 210, 184)):addTo(result_sprite)
		elseif resultData.skill then
			local GODWAR_PATH = IMG_PATH.."image/scene/godwar/"
			display.newSprite(GODWAR_PATH .."spoils.png",111, 280):addTo(result_sprite)
			display.strokeLabel(resultData.skill.name, 57, 156, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			display.strokeLabel("(仅限神战内使用)", 165, 268, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			local wearEquipCell = requires(IMG_PATH , "GameLuaScript/Scene/hero/wearEquipCell")
			local equipSeatCell = wearEquipCell:new(
				74 ,
				186 ,
				resultData.skill,
				function()
					pushScene("detail" , {
						detail = "skill",
						data = resultData.skill,
						priority = -151,
						godwar = true,
						noNavigation = true,
					})
				end,
				result_sprite,
				false,
				false,
				"godwar",
				-132
			)
			result_sprite:addChild( equipSeatCell:getLayer() )
		end
	elseif resultData.type == "revolt" then
		tipStr = "对方太强大了，赶紧提升战力去~"
	elseif resultData.type == "godwar" then
		
--		tipTitle = display.newSprite(LOST_PATH .. "godwar_lose.png")
--		setAnchPos(tipTitle, 40, 400)
--		result_sprite:addChild( tipTitle )
--		tipStr = "神币+"..resultData.score 
		
		tipStr = "提升战将和幻兽等级\n，可提升战队的整体实力 "
		result_sprite:removeChild( goStrengthen, true )

		--神战掉落装备
		if 1 == resultData.data.random_equip_full then
			display.strokeLabel("神战装备仓库已满，无法再获得装备", 20, 146, 20, ccc3(216, 210, 184)):addTo(result_sprite)
		elseif resultData.data.random_equip then
			local GODWAR_PATH = IMG_PATH.."image/scene/godwar/"
			display.newSprite(GODWAR_PATH .."spoils.png",111, 280):addTo(result_sprite)
			display.strokeLabel(resultData.data.random_equip.name, 57, 156, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			display.strokeLabel("(仅限神战内使用)", 165, 268, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			local wearEquipCell = requires(IMG_PATH , "GameLuaScript/Scene/hero/wearEquipCell")
			local equipSeatCell = wearEquipCell:new(
				74 ,
				186 ,
				resultData.data.random_equip,
				function()
					pushScene("detail" , {
						detail = "equip",
						data = resultData.data.random_equip,
						priority = -151,
						godwar = true,
						noNavigation = true,
					})
				end,
				result_sprite,
				false,
				false,
				"godwar",
				-132
			)
			result_sprite:addChild( equipSeatCell:getLayer() )
		end
	end
	local tempText = display.strokeLabel( replaceStr(tipStr) , 45 , display.cy - baseHeight - 100  , 18 , resultData.type == "rob" and ccc3( 0x0c , 0xfc , 0xff ) or ccc3( 0xff , 0xfb , 0xd4 ) , nil , nil , { dimensions_width = 200 , dimensions_height = 90 , align = 0 } )
	result_sprite:addChild( tempText )
	
	
	if resultData.msg and  (resultData.type == "socialclass" or resultData.type == "socialclassfight")  then
		result_sprite:addChild( display.strokeLabel( resultData.msg , 45 , display.cy - baseHeight - 234  , 18 , ccc3( 0x0c , 0xfc , 0xff ) , nil , nil , { dimensions_width = 200 , dimensions_height = 90 , align = 0 } ) )
	end
end
--胜利基础
function M:baseWin( params )	
	params = params or {}
	local showGirl = params.showGirl
	local showBgFrame = params.showBgFrame
	
	result_sprite = display.newLayer()
	
	local downSp = display.newSprite( WIN_PATH .. "down_bg.jpg")
	local lightBg = display.newSprite(WIN_PATH.."eff.png")
	local topSp = display.newSprite( WIN_PATH .. "top_bg.jpg")
	local centerSp = display.newSprite( WIN_PATH .. "center_bg.jpg")
	
	
	setAnchPos( downSp , display.cx ,  0 , 0.5 , 0 )
	setAnchPos( lightBg , display.cx ,  132 + 524 , 0.5 , 0.5 )
	setAnchPos( centerSp , display.cx ,  132 - 7 , 0.5 , 0 )
	setAnchPos( topSp , display.cx ,  132 + 529  , 0.5 , 0 )
	
	result_sprite:addChild(downSp)
	result_sprite:addChild( topSp )
	result_sprite:addChild(lightBg)
	result_sprite:addChild( centerSp )
	
	lightBg:runAction(CCRepeatForever:create(CCRotateBy:create(1,20)))
	
	local size = result_sprite:getContentSize()
	

	local baseHeight = 16
	local winTitleBg = display.newSprite( WIN_PATH .. "win_title_bg.png" )
	
		
	local winPath
	if resultData.type == "rob" then
		 winPath = WIN_PATH.."rob_win.png"
	elseif resultData.type == "godwar" then
		if resultData.fight == "revenge" then
			 winPath = WIN_PATH.."revenge_win.png"
		elseif resultData.fight == "rob" then
			 winPath = WIN_PATH.."godrob_win.png"
		else
			 winPath = TITLE_PATH
		end
	else
		 winPath = TITLE_PATH
	end
	local winTitle = display.newSprite( winPath ) 	--胜利标题
	
	bgFrame = display.newSprite( WIN_PATH .. "win_bg_frame.png")
	girl = display.newSprite( PATH .. "girl.png")

	
	setAnchPos( result_sprite , 0  , 0 , 0 , 0 )
	setAnchPos( winTitleBg , display.cx , 900 , 0.5 )
	setAnchPos( winTitle , display.cx , 900 , 0.5 , 0 )
	setAnchPos( bgFrame , 20 , display.cy - baseHeight , 0 , 0.5 )
	setAnchPos( girl , 188 , display.cy - 27  , 0 , 0.5 )
	
	
	result_sprite:addChild( winTitleBg )
	result_sprite:addChild( winTitle )
	result_sprite:addChild( bgFrame )
	result_sprite:addChild( girl )
	
	
	girl:setVisible( showGirl )
	bgFrame:setVisible( showBgFrame )
	
	
	local function actionBackFun()
		if resultData.missions then
			local startNum = ( params.type and params.type == "mopUp" ) and resultData.missions[1].star or resultData.missions[resultData.current.mission_id].star
			local i = 0
			local function showStar()
				i = i + 1
				if i > startNum then
					if params.actionFun then  params.actionFun() end 
				else
					local adornStar = display.newSprite( COMMONPATH .. "star.png" )
					setAnchPos( adornStar , ( display.cx - startNum * 18 + i * 37 ) - 18  , 676 , 0.5 , 0.5  )
					result_sprite:addChild( adornStar )
					
					adornStar:setScale(5)
					transition.scaleTo( adornStar , { time = 0.3 , scale = 1 , onComplete = showStar ,  easing  = "BACKOUT"})
				end
			end
			showStar()
		else
			if params.actionFun then  params.actionFun() end 
		end
	end
	
	transition.moveTo( winTitleBg , {time = 0.5 , y = 663 , easing  = "BACKOUT" })
	transition.moveTo( winTitle , {time = 0.5 , y = 684 , easing  = "BACKOUT" , onComplete = actionBackFun })
end

--发现遗迹
function M:findRuins()

	local layer = KNBtn:new( IMG_PATH .. "image/scene/activity_new/shenmiyiji/"  , {"faxianyiji.jpg"} , display.cx  , display.cy - 38 , { priority = -1000, anchMid = true ,  }):getLayer():scale(0)

	transition.scaleTo(layer , {  scale = 1, time = 0.4 , easing = "ELASTICOUT" })

	KNBtn:new( COMMONPATH  , {"btn_bg_red.png","btn_bg_red_pre.png"} , display.cx  , 74 , {  
		anchMid = true , 
		priority = -1001,
		front =  IMG_PATH .. "image/scene/activity_new/shenmiyiji/qianwangyiji.png",
		callback = function()
             HTTP:call("activity","get",{  } , {
					success_callback = function(  )
							 switchScene("activity" , {findCurKeyByName="ruins"})
					end
				})	
        end
	}):getLayer():addTo(layer)

	return layer

end

function M:mission_result( params )
--	local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
--	local response = io.readfile("c:\\battle8.txt")
--	response = json.decode( response )
--	resultData = response.result
--	
--	resultData.through = {award = "100000体力" , firsttime = 1 ,  brilliant = 1 }		--award 通关奖励	--firsttime 第一次通关	--brilliant 全三星通关
--	resultData._T_lvup = { lv = 2 ,maxlv = 4 }	--主公升级
--	resultData._T_hero_lvup = { ["121"] = "121" ,["94"] = "94" ,["217"] = "217" , ["158"] = "158" , ["156"] = "156" ,["146"] = "146" }	--各个英雄生机
--	
--	resultData._D_bag = resultData._D_bag or {}
--	resultData._D_bag.general = resultData._D_bag.general or {}
--	resultData._D_bag.general[ "121" ] = { cid = "1106" , lv = "2" , exp = 500 ,  cur_exp = 50 , id = 121 }
--	resultData._D_bag.general[ "94" ] = { cid = "1109" , lv = "2" , exp = 500 ,  cur_exp = 50  , id = 94 }
--	resultData._D_bag.general[ "217" ] = { cid = "1117" , lv = "2" , exp = 500 ,  cur_exp = 50 , id = 217 }
--	resultData._D_bag.general[ "158" ] = { cid = "1115" , lv = "2" , exp = 500 ,  cur_exp = 50 , id = 158 }
--	resultData._D_bag.general[ "156" ] = { cid = "1120" , lv = "2" , exp = 500 ,  cur_exp = 50 , id = 156 }
--	resultData._D_bag.general[ "146" ] = { cid = "1110" , lv = "2" , exp = 500 ,  cur_exp = 50 , id = 146 }
--	
--	resultData.awards = resultData.awards or {}						 	
-- 	resultData.awards.exp = resultData.awards.exp or 300
-- 	
-- 	
--	resultData.T_hero_expadd = {
--								["121"] = 20 , 
--								["94"] =  20 , 
--								["217"] = 20 , 
--								["158"] = 20 , 
--								["156"] = 60 , 
--								["146"] = 60 , 
--							 	}
	
	params = params or {}
	local layer = display.newLayer()
	local mask
	
	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	local isManUp = false
	--显示确定按钮
	local function showConfirmBtn()
		confirmBtn:getLayer():setVisible(true)
		confirmBtn:setEnable(true)
		if isManUp then
			shareGame( { type = "lv_up" } )
		end

		--显示确定按钮的时候如果发现遗迹则弹出发现遗迹页面
		if resultData.activity and (table.nums(resultData.activity)~=0) then 
				dump(resultData.activity , "resultData.activity")

			 result_sprite:addChild( self:findRuins() , 100 )
		end

	end
	--返回事件处理
	local function backFun()
		if award_handle ~= nil then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(award_handle)
			award_handle = nil
		end
		
		--通关展示
		local function passShow( params )
			params = params or {}
			local showLayer = display.newLayer()
			
			local roleImage = display.newSprite( COMMONPATH .. "guide_logo.png" )
			setAnchPos(roleImage , 24 , display.cy + 30 )
			showLayer:addChild( roleImage )
			
			local bg = display.newSprite(  PATH .. "pass_bg.png" )
			setAnchPos( bg , display.cx , display.cy  , 0.5 , 0.5 )
			showLayer:addChild( bg )
			
			local missionConfig = requires(IMG_PATH, "GameLuaScript/Config/Mission")
			local curMapName = missionConfig[ resultData["current"]["map_id"] .. "" ].map_name
			
			local tipConfig = {
								["10"] = replaceStr("少侠好身手！通过“") .. curMapName .. "”的考验！感觉您还没到极限，挑战自己的极限吧！会有你意想不到的收获哦！" , 
								["01"] = replaceStr("少侠你战斗力简直爆表！通过“") .. curMapName .. "”的所有评级都为三星！称雄世界已然不远！" , 
								["11"] = replaceStr("少侠你已经超神了！首次通过“") .. curMapName .. "”就以全三星的姿态过关！少侠一出谁与争锋啊！" , 
							}
			local tipStr = tipConfig[ resultData.through.firsttime .. resultData.through.brilliant .. "" ]
			local tipText = display.strokeLabel(tipStr , 144, 190 + 150 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , 2 , nil , {
							dimensions_width = 280,
							dimensions_height = 120,
							align = 0,})
			showLayer:addChild( tipText )
			
			--奖励图标
			local awardIcon = KNBtn:new( IMG_PATH .. "image/scene/fb/"  , {"item_bg.png"} , 50  , display.cy - 45 , { front =getImageByType( "16005" , "s")  }):getLayer()
			showLayer:addChild( awardIcon )
			
			--奖励名称
			local awardName = display.strokeLabel( resultData.through.award , 43, display.cy - 75 , 16 , ccc3( 0x2c , 0x00 , 0x00 ) , 2 , nil , {
			dimensions_width = 100,
			dimensions_height = 30,
			align = 1,})
			showLayer:addChild( awardName )
			
			--是否第一次通过
			local tempDelay = 0.4
			if resultData.through.firsttime == 1 then
				local firstFlag = display.newSprite(  PATH .. "pass_flag.png" )
				setAnchPos( firstFlag , 368 , display.cy - 80 , 0.5 , 0.5 )
				showLayer:addChild( firstFlag )
				
				firstFlag:setOpacity(0.3)
				firstFlag:setScale(3)
				transition.fadeIn(firstFlag , { delay = tempDelay ,time = 0})
				transition.scaleTo(firstFlag , { delay = tempDelay , scale = 1, time = 0.4 , easing = "ELASTICOUT" })
				
				tempDelay = 0.8
			end		
			--是否全三星通过		
			if resultData.through.brilliant == 1 then
				local starFlag = display.newSprite(  PATH .. "star_flag.png" )
				setAnchPos( starFlag , 240 , display.cy - 80 , 0.5 , 0.5 )
				showLayer:addChild( starFlag )
				
				
				starFlag:setOpacity(0.3)
				starFlag:setScale(3)
				transition.fadeIn(starFlag , { delay = tempDelay ,time = 0})
				transition.scaleTo(starFlag , { delay = tempDelay , scale = 1, time = 0.4 , easing = "ELASTICOUT" })
			end	
			
			local passMask
			local function clear()
				if showLayer then
					showLayer:removeFromParentAndCleanup(true)
				end
				
				passMask:remove()
				
				if params.passBackFun then params.passBackFun() end
				
			end
			
			passMask = KNMask:new({ item = showLayer , opacity = 200 , click = clear })		
			local scene = display.getRunningScene()
			scene:addChild( passMask:getLayer() )		
		end
		
		local function jumpOutFun()
			if params.backFun then
				params.backFun()	--磨练的藏宝楼同任务结算相同，但返不同
			else
				switchScene(resultData.type.."",{kind = "mission", level = resultData["jump"]["map_id"]}, function()
					if (resultData.current.map_id == table.nums(getConfig("mission"))) and
						(resultData.current.mission_id == table.nums(getConfig("mission", resultData.current.map_id.."")) - 2) and resultData.is_win == 1 then
							showTip({
								content = createLabel({str="恭喜您已通关，请期待后续神秘任务", width = 380, size = 24, color = ccc3(0x2c, 0, 0)}),
								center = {
									remove = true
								}
							})
					end
				end)
			end
		end
    
		
		local function passBackFun()
			if getGuideInfo() then
				Upgrade:mainHero( resultData , {backFun = jumpOutFun } )
			else
				jumpOutFun()
			end 
		end
		
				
		if confirmBtn then
			confirmBtn:getLayer():removeFromParentAndCleanup(true)
			confirmBtn = nil
		end

		mask:remove()

		
		if resultData.through and resultData.through.firsttime then--存在通关奖励时
			passShow( { passBackFun = passBackFun })
		else
			passBackFun()
		end
		
	end
	local baseY = 256
	local baseX = 42
	
	
	local isRowBoss
	if params.type == "mopUp" then
		isRowBoss = false
		win = 1
	else
		isRowBoss = tonumber( resultData.cut_num )>0 
	end
	 
	-- 添加战斗背景图片
	if win == 1 then
		local awards = resultData.awards or {}
		
		local function careatTitle( name )
			local titleBg = display.newSprite( WIN_PATH .. "title_bg.png")
			local nameSp = display.newSprite( WIN_PATH .. name .. ".png" )
			titleBg:addChild( nameSp )
			setAnchPos( nameSp , 6 , 0 , 0 , 0 )
			return titleBg
		end
		local actionTime = 0.2
		local function showOther()
			local function showAarad()
				--获得奖励信息
				local function showAwards()
					if awards.drop then
						local cids = {}
						for key , cid in pairs(resultData.awards.drop) do
							cids[#cids + 1] = cid
						end
						
						if #cids ~= 0 then
							-- 播放获得卡牌的动画
							-- if params.type == "mopUp" then
								local scroll = KNScrollView:new( 40 , 130 , 400, 170 , 50 , true , nil , { turnBtn = IMG_PATH .. "image/scene/gang/next.png" , turnBtnPriority = -140  } )
				 				for k = 1 , #cids do
									local item = awardCell( { cid = cids[k] } , { star = true , nameColor = ccc3( 0xfe , 0xfc , 0xd3 ) , name = true } )
					 				scroll:addChild( item )
				 				end
								scroll:alignCenter()
								result_sprite:addChild(scroll:getLayer() )
								showConfirmBtn()
							-- else
								-- M:playGetCards(cids , showConfirmBtn )
							-- end
						else
							showConfirmBtn()
						end
					else
						showConfirmBtn()
					end
				end
			
				--获得奖励标题
				local getPropSp = careatTitle( "get_prop" )
				setAnchPos( getPropSp , 22 , 252 , 0 , 0 )
				result_sprite:addChild( getPropSp )
				transition.moveTo( getPropSp , { time = actionTime , x = 22 } )
				
				-- 触发定时器
				award_handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
					CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(award_handle)
					award_handle = nil
					showAwards()
				end , 0.2 , false)
			end
			
			--展示英雄信息
			local function showHero()
				local upStr = nil
				--英雄信息
				if resultData._D_bag and resultData._D_bag.general then
					local onHero = DATA_Formation:get_ON( "on" )
					local backHero = DATA_Formation:get_ON( "back" )
					local allHero = {}	--所有上阵武将id
					for i = 1 , table.nums(onHero) do
						allHero[ #allHero + 1 ] = onHero[i].gid
					end
					for i = 1 , table.nums(backHero) do
						 allHero[ #allHero + 1 ] = backHero[i].gid
					end
					
					local addExp = {}	--英雄添加经验文字
					local showUpFlag = {}
				
					for i = 1 , 8 do
						local index = i - 1
						local addX , addY = 84 + index % 4 * 83 , 408 - math.floor( index / 4 ) * 93 
						if i > #allHero then
							local heroBtn = KNBtn:new( SCENECOMMON , { "skill_frame4.png" } , addX , addY ):getLayer()
							result_sprite:addChild( heroBtn )
						else
							local curData = resultData._D_bag.general[ allHero[i] .. "" ]
							if curData then
								local isUp =  resultData._T_hero_lvup and resultData._T_hero_lvup[ allHero[i].."" ] --当前英雄是否升级
								if not upStr then
									upStr = HeroLayer:coutUpTip( curData.id , true )
								end
								
								local otherData = { {COMMONPATH.."star_border/border_".. getConfig( getCidType( curData.cid ) , curData.cid, "star")  ..".png", -14, -15 } }
								if isUp then
									otherData[#otherData + 1] = { COMMONPATH .. "select2.png" , -11 , -10 , -10 }
								end
								otherData[#otherData + 1] = { COMMONPATH .. "equip_lv_bg.png" , 35 , 42 } 
								
								local heroBtn = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , 
									addX , 
									addY ,
									{
										front = getImageByType( curData.cid ) ,
										other =  otherData , 
										text = { curData.lv , 18 , ccc3( 0xff , 0xff , 0xff ) , { x = 18 , y = 20	} , nil , 20 } ,
									})
								result_sprite:addChild( heroBtn:getLayer() )
								
								--升级提示
								showUpFlag[ i .. "" ] = function()
															if isUp then
																local upFlag = display.newSprite( WIN_PATH .. "up_flag.png" )
																setAnchPos( upFlag , heroBtn:getX() + 34 ,heroBtn:getY()  , 0.5 )
																result_sprite:addChild( upFlag )
																
																local function loopPlayUp()
																	setAnchPos( upFlag , heroBtn:getX() + 34 , heroBtn:getY() , 0.5 )
																	local upAction = CCArray:create()
																	upAction:addObject( CCMoveTo:create( 1 , ccp( heroBtn:getX() + 34 , heroBtn:getY() + 40 ) ) )
																	upAction:addObject( CCCallFunc:create( loopPlayUp ) )
																	upFlag:runAction( CCSequence:create( upAction ) )
																end
																loopPlayUp()
															end
														end
								
								
								
								
								addExp[ i .. "" ] = display.strokeLabel( "+" .. resultData.T_hero_expadd[ curData.id .. "" ] , heroBtn:getX() - 3 , heroBtn:getY() , 18 , ccc3( 0x53 , 0xff , 0x15 ) , nil , nil , {
									dimensions_width = 70 ,
									dimensions_height = 20,
									align = 1
								})
								
								local expBar = KNBar:new("exp1" , addX , 454 + math.floor( index / 4 ) * 90 , { 
																			maxValue = curData.exp , 
																			curValue = 0 , 
																			color = ccc3(0x2c , 0x00 , 0x01 ) ,
																			actionTime = 0.5 , 
																			} )
								expBar:setIsShowText( false )
								expBar:setCurValue( curData.cur_exp , true )
								result_sprite:addChild( expBar )
							end
						end
					end
						local shadeMask = display.newSprite( PATH .. "exp_shade.png")
						setAnchPos( shadeMask , display.cx , display.cy - 33 , 0.5 , 0.5)
						result_sprite:addChild( shadeMask )
						
						local function clearShadeMask()
							shadeMask:removeFromParentAndCleanup(true)
							
--							local getUpgrad = {}--收集没有获得正常经验值的英雄名字
--							local isUpgrad = false
--							for key , v in pairs(resultData.T_hero_expadd) do
--								if  v < resultData.awards.exp then
--									isUpgrad = true
--									local cruData = resultData._D_bag.general[key .. ""]
--									getUpgrad[ #getUpgrad + 1 ] =  getConfig( getCidType(cruData.cid) , cruData.cid , "name" )
--								end 
--							end
--							
--							if isUpgrad then
--								local getherName = string.join(getUpgrad, ",")
--								local upgradTip = display.strokeLabel( "有英雄达到等级上限，需进化英雄或提升主角等级" , 40 , 10 , 18 , ccc3( 0xff , 0xfb , 0xd4 ) , nil , nil , {
--									dimensions_width = 400 ,
--									dimensions_height = 50,
--									align = 1
--								})
--								result_sprite:addChild( upgradTip )
--							end
							
							local tipsText = display.strokeLabel( replaceStr("每个英雄获得经验：+" .. resultData.awards.exp)  , 0 ,275 , 18 , ccc3( 0x07 , 0xff , 0xfc ) , nil , nil , {
									dimensions_width = 480 ,
									dimensions_height = 30,
									align = 1
								})
							result_sprite:addChild( tipsText )
							
							for key , v in pairs(showUpFlag) do
								v()
							end
							
							showAarad()
							
						end
						local tempCount = 0
						for key , v in pairs(addExp) do
							tempCount = tempCount + 1
							local isLast = tempCount >= table.nums( addExp )
							result_sprite:addChild( v )
							
							transition.moveTo( v , { time = 1.5 , y = 40 , onComplete = 
																		function()
																			v:removeFromParentAndCleanup(true)
																			if isLast then
																				clearShadeMask()
																			end
																		end	})
						
						end
				end
				if upStr then
					result_sprite:addChild(  display.strokeLabel( upStr , 40 , 10 , 18 , ccc3( 0x5c , 0xe3 , 0xe5 ) , nil , nil , {
									dimensions_width = 400 ,
									dimensions_height = 50,
									align = 0
								}) )
				end
			end
			
			
			
			
			
			
			
			--生成主公信息
			local function showMan()
				local function createMan()
					local manLayer = display.newLayer()
					
					local expBar = KNBar:new("exp" , 121 , 297 , { 
																	maxValue = DATA_User:get("lvup_exp") , 
																	curValue = 0 , 
																	color = ccc3(0x2c , 0x00 , 0x01 ) ,
																	actionTime = 0.5 , 
																	} )
					expBar:setCurValue( DATA_User:get("cur_exp") , true )
					manLayer:addChild( expBar )
					
					isManUp = resultData._T_lvup and tonumber( resultData._T_lvup.lv ) ~= 0	--主公是否升级

					if isManUp and __INNER_IOS_SDK_VER and __INNER_IOS_SDK_VER >= 4 then
						if CHANNEL_ID == "appFameOfficial2" then
							local params = {
								type = "upload_level",
								id = DATA_Session:get("uid") .."",
								level = DATA_User:get("lv") ..""
							}
							channel_delegate:getInst():call(json.encode(params), function() end)
						end
					end

					if isManUp and ( CHANNEL_ID == "tmsj.heitao" or CHANNEL_ID == "tmsj.heitao1" or CHANNEL_ID == "hy.changmeng" or CHANNEL_ID == "hy.changmeng1" or CHANNEL_ID == "hy.changmeng2" ) then 
						DirectChannel.instance():call(
							{
								action = "levelChange",
								server_id = DATA_Session:get("server_id") , 
								server_name = DATA_GodCell:get("server_name"),
								user_lv = DATA_User:get("lv"),
								user_name = DATA_User:get("name"),

								callback = function()
									
								end
							})
					end

					local tempTable 
					if isManUp  then
						tempTable = {  
										{ IMG_PATH.."image/scene/common/navigation/level_bg.png" , -17 , 54 } ,
										{ COMMONPATH .. "select2.png" , -11 , -10 , -10 } , 
									}
					else
						tempTable = { IMG_PATH.."image/scene/common/navigation/level_bg.png" , -17 , 54 }
					end
					
					local manImage = KNBtn:new( COMMONPATH , { getHeadPath( DATA_Head:get()["default"] ) } , 
						display.cx - 174 , 
						display.cy + 98 ,
						{
							front = COMMONPATH.."role_frame.png" ,
							other = tempTable , 
							text = { DATA_User:get("lv") , 18 , ccc3( 0xbf , 0x3a , 0x01 ) , { x = -33 , y = 38	} , nil , 20 } ,
							callback = function()
							end
						}):getLayer()
					manLayer:addChild( manImage )
					
					--主公升级动画
					if isManUp then
						local upFlag = display.newSprite( WIN_PATH .. "up_flag.png" )
						setAnchPos( upFlag , 34 , 0 , 0.5    )
						manImage:addChild( upFlag , 10)
						
						local function loopPlayUp()
							setAnchPos( upFlag , 34 , 0 , 0.5 )
							local upAction = CCArray:create()
							upAction:addObject( CCMoveTo:create( 1 , ccp( 30 , 40) ) )
							upAction:addObject( CCCallFunc:create( loopPlayUp ) )
							upFlag:runAction( CCSequence:create( upAction ) )
						end
						loopPlayUp()
					end
					
					local manName= display.strokeLabel( DATA_User:get("name") , 152 , 576 , 20 , ccc3( 0xff , 0xfb , 0xd5 ) )
					manLayer:addChild( manName )
					
					return manLayer
				end
				
				--生成宠物图像
				local function createPet()
					local petLayer = display.newLayer()
					
					
					local petData , addExp
					for key , v in pairs(resultData._T_pet_expadd) do
						petData = DATA_Bag:get("pet" , key )
						addExp = v
					end
					local lv , cur_exp , max_exp = DATA_Pet:calcExp(petData.exp)
					petData.lv = lv
					petData.cur_exp = cur_exp
					petData.max_exp = max_exp
					
					local isManUp = resultData._T_pet_lvup	--宠物是否升级
					
					local otherData = { {COMMONPATH.."star_border/border_".. getConfig( getCidType( petData.cid ) , petData.cid, "star")  .. ".png", -14, -15 } }
					if isManUp then
						otherData[#otherData + 1] = { COMMONPATH .. "select2.png" , -11 , -10 , -10 }
					end
					otherData[#otherData + 1] = { COMMONPATH .. "equip_lv_bg.png" , 35 , 42 } 
					
					local manImage = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } ,  
						393 , 528 ,
						{
							front = getImageByType( petData.cid ) ,
							other = otherData , 
							text = { petData.lv , 18 , ccc3( 0xff , 0xff , 0xff ) , { x = 18 , y = 20	} , nil , 20 } ,
							callback = function()
							end
						})
					petLayer:addChild( manImage:getLayer() )
					
					local expBar = KNBar:new("exp1" , 392 , 335 , { 
																maxValue = petData.exp , 
																curValue = 0 , 
																color = ccc3(0x2c , 0x00 , 0x01 ) ,
																actionTime = 0.5 , 
																} )
					expBar:setIsShowText( false )
					expBar:setCurValue( petData.cur_exp , true )
					result_sprite:addChild( expBar )
					
					local expText = display.strokeLabel( "+" .. addExp , manImage:getX() - 3 , manImage:getY() , 18 , ccc3( 0x53 , 0xff , 0x15 ) , nil , nil , {
						dimensions_width = 70 ,
						dimensions_height = 20,
						align = 1
					})
					result_sprite:addChild( expText , 20 )
					transition.moveTo( expText , { delay = 0.2 , time = 1.5 , y = ( device.platform == "wp8" and expText:getPositionY() or expText.y) + 45 , onComplete = function() 
						expText:removeFromParentAndCleanup( true ) 
						expText = nil
						--宠物升级动画
						if isManUp then
							local upFlag = display.newSprite( WIN_PATH .. "up_flag.png" )
							setAnchPos( upFlag , 34 , 0 , 0.5    )
							manImage:getLayer():addChild( upFlag , 10)
							
							local function loopPlayUp()
								setAnchPos( upFlag , 34 , 0 , 0.5 )
								local upAction = CCArray:create()
								upAction:addObject( CCMoveTo:create( 1 , ccp( 30 , 40) ) )
								upAction:addObject( CCCallFunc:create( loopPlayUp ) )
								upFlag:runAction( CCSequence:create( upAction ) )
							end
							loopPlayUp()
						end
						
					end })
					
					result_sprite:addChild( petLayer )
				end
				result_sprite:addChild( createMan() )
				if resultData._T_pet_expadd then  createPet() end
					
			
				if awards.silver then
					--获得银两
					local silverSp = display.newSprite( COMMONPATH .. "silver.png" )
					setAnchPos( silverSp , 284 , 519 , 0 , 0 )
					result_sprite:addChild( silverSp )
					
					local silverNum = display.strokeLabel( "+" .. awards.silver , 317 , 523 , 18 , ccc3( 0x53 , 0xff , 0x15 ) , nil , nil , {
						dimensions_width = 100 ,
						dimensions_height = 20 ,
						align = 0
						} )
					result_sprite:addChild( silverNum )
					
					local prestigeNum = display.strokeLabel( "EXP:+" .. ( awards.prestige or 0 ) .. ( awards.zhujue_exp_add and "(+"..awards.zhujue_exp_add..")" or "" )  , 132 , 523 , 18 , ccc3( 0x53 , 0xff , 0x15 ) , nil , nil , {
						dimensions_width = 200 ,
						dimensions_height = 20 ,
						align = 0
						} )
					result_sprite:addChild( prestigeNum )
				end
				
				--展示英雄数据
				local heroSp = careatTitle( "hero" )
				setAnchPos( heroSp , -50 , 486 , 0 , 0 )
				result_sprite:addChild( heroSp )
				transition.moveTo( heroSp , { delay = 0.2 , time = actionTime , x = 22 , onComplete = showHero } )
			end
			
			
			isRowBoss = false
			
			--主公标题
			local manSp = careatTitle( "man" )
			setAnchPos( manSp , -50 , 609 , 0 , 0 )
			result_sprite:addChild( manSp )
			transition.moveTo( manSp , { time = actionTime , x = 22 , onComplete =  showMan } )
		end
		
		
		
		
		
		local rowBossLayer 
		--切Boss奖励展示
		local function rowBossAward()
			rowBossLayer = display.newLayer()
			
		 	local ROW_PATH = WIN_PATH .. "row/"
		 	--展示切牌掉落的道具奖励
		 	local function showAwardFun()
		 		if resultData.cut.drop then
				 	local rowBossTitle = careatTitle( "row_award" )
					setAnchPos( rowBossTitle , -50 , 323 , 0 , 0 )
					rowBossLayer:addChild( rowBossTitle )
					transition.moveTo( rowBossTitle , { time = actionTime , x = 22  } )
					
		 			local cids = {}
		 			
					local scroll = KNScrollView:new( 70 , 150 , 340, 160 , 10 , false   )
					local tempCutDrop = {}
					for cutKey , cutV in pairs(resultData.cut.drop)do
						tempCutDrop[#tempCutDrop + 1] =  { cid = cutKey , num = cutV }
					end
		 			for t = 1 , math.ceil(#tempCutDrop/4) do
		 				cids[#cids + 1] = { [1] = tempCutDrop[t*4-3] , [2] = tempCutDrop[t*4 - 2 ] ,[3] = tempCutDrop[t*4-1] , [4] = tempCutDrop[t*4] }
		 			end
		 			
		 			for t = 1 , #cids do
	 					local tempLayer = display.newLayer()
	 					tempLayer:setContentSize( CCSizeMake( 340 , 70 ) )
		 				for k = 1 , #cids[t] do
							local item = awardCell( { cid = cids[t][k].cid , num = cids[t][k].num } )
							setAnchPos( item , ( k - 1 ) * 90 , 0 , 0 , 0  )
							tempLayer:addChild(item)
		 				end
		 				scroll:addChild( tempLayer )
		 			end
					scroll:alignCenter()
					rowBossLayer:addChild(scroll:getLayer() )
					
					showConfirmBtn()
		 		else
		 			showConfirmBtn()
		 		end
		 	end
		 	--展示切boss得到的银币和金币
		 	local function showAwardSilver()
				
		 		resultData.cut = resultData.cut or {}
		 		if resultData.cut.silver or resultData.cut.gold then
				 	local rowBossTitle = careatTitle( "silver_title" )
					setAnchPos( rowBossTitle , -50 , 440 , 0 , 0 )
					rowBossLayer:addChild( rowBossTitle )
					transition.moveTo( rowBossTitle , { time = actionTime , x = 22 , onComplete =  showAwardFun } )
					
					local moneyIndex = 0
					if resultData.cut.silver then
						local silver = awardCell( { cid = "silver" , num = resultData.cut.silver } )
						rowBossLayer:addChild( silver )
						local addX , addY = 75 + moneyIndex * 170 , 359
						setAnchPos( silver , addX , addY )
						moneyIndex = moneyIndex + 1
					end
					if resultData.cut.gold then
						local gold = awardCell( { cid = "gold" , num = resultData.cut.gold } )
						rowBossLayer:addChild( gold )
						local addX , addY = 75 + moneyIndex * 170 , 359
						setAnchPos( gold , addX , addY )
						moneyIndex = moneyIndex + 1
					end

		 		else
		 			showAwardFun()
		 		end
		 	end
		 	
		 	local rowBossTitle = careatTitle( "row_boss_num" )
			setAnchPos( rowBossTitle , -50 , 609 , 0 , 0 )
			rowBossLayer:addChild( rowBossTitle )
			transition.moveTo( rowBossTitle , { time = actionTime , x = 22 , onComplete =
			function()
				local rowNumBg = display.newSprite( ROW_PATH .. "row_num_bg.png" )
				setAnchPos(rowNumBg , display.cx , 541 , 0.5 , 0.5)
				rowBossLayer:addChild(rowNumBg)
				
				local rowNum = getImageNum( resultData.cut_num , ROW_PATH.."num.png" , { decimals = true })
				setAnchPos(rowNum , display.cx , 541 , 0.5 , 0.5)
				rowBossLayer:addChild(rowNum)
				rowNum:setScale(5)
				transition.scaleTo( rowNum , { time = 0.3 , scale = 1 , onComplete = showStar ,  easing  = "BACKOUT" , onComplete =  showAwardSilver })
			end } )
			
			
			result_sprite:addChild( rowBossLayer )
		end
		--背景图
		M:baseWin({ type = params.type == "mopUp" and "mopUp" or nil , actionFun = isRowBoss and rowBossAward or showOther , showGirl = false , showBgFrame = false })
		
		-- 确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 65 , 
							{ 
								priority = -132 , 
								scale = true , 
								front = COMMONPATH.."confirm.png" , 
								callback = 
								function()
									if isRowBoss then
										local function clearRowBoss()
											rowBossLayer:removeFromParentAndCleanup(true)
											showOther()
										end
										transition.moveTo(rowBossLayer , {time = 0.5 , x = - 480 ,onComplete = clearRowBoss })
									else
										backFun()
									end  
								end 
							} )
		confirmBtn:getLayer():setVisible(false)
		confirmBtn:setEnable(false)
		result_sprite:addChild( confirmBtn:getLayer() )
		
		mask = KNMask:new( { item = result_sprite } )
	else
		-- 失败  点击返回首页
		mask = KNMask:new( { item = result_sprite } )
		if params.backFun then
			mask:click( params.backFun )	--磨练的藏宝楼同任务结算相同，但返不同
		else
			mask:click(backFun)
		end
	end

	
	layer:addChild( mask:getLayer() )
	
    return layer
end



--副本结算
function M:instance_result()
	local fbLayer = requires(IMG_PATH,"GameLuaScript/Scene/fb/fblayer")
	local fbMode = {
				 inshero  = "hero" ,		
				 inspet   = "pet", 	
				 insskill = "skill" , 	
				 insequip = "equip" ,
				 rob      = "rob" ,
				}
	local layer = display.newLayer()
	local mask
	
	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	--返回事件处理
	local function backFun()
		if award_handle ~= nil then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(award_handle)
			award_handle = nil
		end
		
		local function jumpOutFun()
			if resultData.type == "rob" then
					HTTP:call("rob", "get", {},
								{ 
									success_callback =
									 function(data)
										switchScene( "pvp" , { state = fbMode[resultData.type] , robData = data , star = resultData.star } )
									end
								})
			else
				local func, dig
				if resultData.type == "insequip" then
					if win == 1 then
						if resultData.get.ins_id == 25 and resultData.get.current_map == DATA_Instance:get("equip", "max", "map_id") then 
							dig = true
							-- if resultData.get.current_map == 18 then
								KNMsg.getInstance():flashShow("恭喜您已通关藏宝楼所有副本！~")
							-- else
							-- 	func  = function()
							-- 		KNMsg.getInstance():flashShow("恭喜通关藏宝楼第"..resultData.get.current_map.."层，第"..(resultData.get.current_map + 1).."层已开启")
							-- 	end
							-- end
						elseif resultData.get["ins_id"] == 25 then
							dig = true
							KNMsg.getInstance():flashShow("恭喜通关藏宝楼第"..resultData.get.current_map.."层，第"..(resultData.get.current_map + 1).."层已开启")
						end
					end
				end	
				switchScene( "fb" , { state = fbMode[resultData.type], coming = true, map =  resultData.get.current_map, dig = dig } , func)
			end
		end
    
		
		if resultData._T_hero_lvup or ( resultData._T_lvup and tonumber( resultData._T_lvup.lv ) ~= 0 ) or  getGuideInfo() then
			if resultData.type ~= "insequip" then mask:remove() end
			Upgrade:mainHero( resultData , { backFun = jumpOutFun} )
		else
			if resultData.type ~= "insequip" and resultData.type ~= "rob" then 
				mask:remove() 
			end
			jumpOutFun()
		end 
	end
	
	--藏宝楼结算 同任务
	if resultData.type == "insequip" then
		return M:mission_result( { backFun = backFun } )
	end
	
	local baseY = 256
	local baseX = 42
	-- 添加战斗背景图片
	if win == 1 and ( resultData.type == "insskill" or resultData.type == "rob" )then
		addType = 1
		--不存在英雄锦囊
		--背景图
		M:baseWin({ actionFun = showOther , showGirl = true , showBgFrame = true })
		
		
		--奖励功勋
		local getSkillTitle = display.newSprite( WIN_PATH .. ( resultData.type ~= "rob" and "get_skill.png" or "get_text.png" ) )
		setAnchPos( getSkillTitle , 70 , 475 , 0 , 0.5 )
		result_sprite:addChild( getSkillTitle )

		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png","btn_bg_red_pre.png" }, display.cx - 146 / 2 , 50 , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )

		confirmBtn:getLayer():setVisible(false)
		confirmBtn:setEnable(false)


		local awards = resultData.awards or {}
		--获得奖励信息
		local function showAwards()
			--显示确定按钮
			local function showConfirmBtn()
				confirmBtn:getLayer():setVisible(true)
				confirmBtn:setEnable(true)
			end
			if awards.drop and table.nums(awards.drop) ~= 0 then
				local function mopUpAward( cid , num )
					local robElement = {
										soul_1 = { name = "一星将魂" , star = 1 , path = IMG_PATH .. "image/scene/forge/general_icon_1.png" } ,
										soul_2 = { name = "二星将魂" , star = 2 , path = IMG_PATH .. "image/scene/forge/general_icon_2.png" } ,
										chip_1 = { name = "一星碎片" , star = 1 , path = IMG_PATH .. "image/scene/forge/equip_icon_1.png" } ,
										chip_2 = { name = "二星碎片" , star = 2 , path = IMG_PATH .. "image/scene/forge/equip_icon_2.png" } ,}
					
					local num = num or 0
					local curName , star
					local otherData , textData
					if robElement[ cid ] then
						curName = robElement[ cid ].name
						star = robElement[ cid ].star
						
						otherData = {}
						for j = 1 , star do
							otherData[ #otherData + 1 ] = { IMG_PATH .. "image/scene/home/star.png" ,  7 - star * 12 + j * 24  , -27 }
						end
						textData = { curName , 18 , ccc3( 0xfe , 0xfc , 0xd3 ) , { x = 1 , y = -70	} , nil , 20 }
					else
						curName = getConfig( getCidType( cid ) ,  cid , "name" ) 
						star = getConfig( getCidType( cid ) ,  cid , "star" )
					
						otherData = {}
						for j = 1 , star do
							otherData[ #otherData + 1 ] = { IMG_PATH .. "image/scene/home/star.png" ,  7 - star * 12 + j * 24  , -27 }
						end
						if num > 1 then
							otherData[ star+1 ] = { COMMONPATH .. "equip_lv_bg.png" , 46 , 54 } 
						end
						
						local isPetskill =( getCidType(cid) == "petskill" )
						textData = {}
						if isPetskill then
							otherData[ #otherData + 1 ] = {IMG_PATH.."image/scene/bag/kind_bg.png", 0 , 2 }
							textData = { {"兽",16, ccc3(255,255,255), ccp(-20, 23),nil, 17} , { curName , 18 , ccc3( 0xfe , 0xfc , 0xd3 ) , { x = 1 , y = -70	} , nil , 20 } , ( (num > 1) and { num , 18 , ccc3( 0xff , 0xff , 0xff ) , { x = 32 , y = 32} , nil , 20 } or nil ) }
						else
							textData = ( num > 1) and {{ curName , 18 , ccc3( 0xfe , 0xfc , 0xd3 ) , { x = 1 , y = -70	} , nil , 20 } , { num , 18 , ccc3( 0xff , 0xff , 0xff ) , { x = 32 , y = 32} , nil , 20 } } or { curName , 18 , ccc3( 0xfe , 0xfc , 0xd3 ) , { x = 1 , y = -70	} , nil , 20 }
						end
					end
					
					local awardBtn = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , 0 , 0 ,
							{
								front =  ( robElement[ cid ] and robElement[ cid ].path or getImageByType( cid ) ) ,
								other = otherData , 
								text = textData ,
								callback = function()end,
							}):getLayer()
					return awardBtn
				end
				for key , v in pairs(awards.drop) do
					local tempAward = resultData.type == "rob" and mopUpAward( v , 0 )  or mopUpAward( key , v ) 
					setAnchPos(tempAward , 110 , 378 )
					result_sprite:addChild( tempAward )
				end
				showConfirmBtn()
			else
				showConfirmBtn()
			end
		end

		-- 触发定时器
		award_handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(award_handle)
			award_handle = nil
			showAwards()
		end , 0.2 , false)
	else
		-- 失败  点击返回首页
		mask = KNMask:new({ item = result_sprite })
		mask:click(backFun)
		layer:addChild( mask:getLayer() )
		return layer
	end
	

	
	mask = KNMask:new({ item = result_sprite })
	layer:addChild( mask:getLayer() )
	

    return layer
end





--竞技结算页面
function M:athletics_result()
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	--返回事件处理
	local isHit = false
	local function backFun()
		if isHit then
			return
		end
		isHit = true
		
		if resultData._T_lvup and tonumber( resultData._T_lvup.lv ) ~= 0 then
			mask:remove()
			Upgrade:new( resultData._T_lvup , { backFun = function() switchScene( "athletics" , {data = resultData["data"], challenge = true } ) end } )
		else
			switchScene("athletics",{data = resultData["data"], challenge = true})
		end 
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		--奖励功勋
		local athleticsAwardText = display.newSprite( WIN_PATH .. "get_silver.png" )
		setAnchPos( athleticsAwardText , 70 , 445 , 0 , 0.5 )
		result_sprite:addChild( athleticsAwardText )
		--奖励功勋数量
		local fameT = display.strokeLabel("+" .. ( resultData.awards.silver or 0 )   , 0, 0 , 20 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 85 , dimensions_height = 30 , align = 0 } )
		setAnchPos( fameT , 227 , 442 , 0.5 , 0.5 )
		result_sprite:addChild( fameT )
		
		--连胜次数
		local  winning_streak_text = display.newSprite( WIN_PATH .. "winning_streak.png" )
		setAnchPos( winning_streak_text , 70 , 373 , 0 , 0.5 )
		result_sprite:addChild( winning_streak_text )
		
		--连胜次数
		local winning_streak_num = display.strokeLabel( ( resultData.my.successionwin or 0 ) , 0, 0 , 20 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 85 , dimensions_height = 30 , align = 0 } )
		setAnchPos( winning_streak_num , 180 , 368 , 0.5 , 0.5 )
		result_sprite:addChild( winning_streak_num )
	
		
	
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

    return layer
end
--好友切磋复仇结算页面
function M:friends_result()
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	--返回事件处理
	local function backFun()
		switchScene( "friend" , { activity = resultData["data"] } )
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		if resultData.action == 1 then			--切磋
			if resultData.awards and resultData.awards.silver then		--有奖励则提示
				local athleticsAwardText = display.newSprite( WIN_PATH .. "get_silver.png" )
				setAnchPos( athleticsAwardText , 70 , 445 , 0 , 0.5 )
				result_sprite:addChild( athleticsAwardText )
				--奖励功勋数量
				local fameT = display.strokeLabel("+" .. ( resultData.awards.silver or 0 )   , 0, 0 , 20 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 85 , dimensions_height = 30 , align = 0 } )
				setAnchPos( fameT , 227 , 442 , 0.5 , 0.5 )
				result_sprite:addChild( fameT )
			else
				result_sprite:addChild( display.newSprite( WIN_PATH .. "compare_notes.png" ,  52 , 390 , 0 , 0 ) )
			end
		elseif resultData.action == 2 then		--复仇
			result_sprite:addChild( display.newSprite( WIN_PATH .. "revenge.png" ,  52 , 390 , 0 , 0 ) )
		end

		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

    return layer
end


function M:prewar_result()
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		HTTP:call("kuafu", "getEntrance", {}, {
			success_callback = function(data)
				if data.to == "corps" then
					HTTP:call("kuafu", "getAllCorps", {}, {
						success_callback = function(data)
							switchScene("swar_pre", data)
						end
					})
				else
				end
			end})
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		result_sprite:addChild( display.newSprite( WIN_PATH .. "spre_win.png" ,  52 , 390 , 0 , 0 ) )

		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end
    return layer
end

--矿山结算页面
function M:mining_result()
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		switchScene( "diggings" ,resultData.data)
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		result_sprite:addChild( display.newSprite( WIN_PATH .. "mine.png" ,  52 , 390 , 0 , 0 ) )

		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

    return layer
end


function M:ruins_result(params)
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		local logic = requires(IMG_PATH,"GameLuaScript/Scene/battle/logicLayer")
		if logic:getParams().resultCallFun then
			logic:getParams().resultCallFun()
		end
	end
	
	--确定按钮
	confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
	layer:addChild( confirmBtn:getLayer() , 2 )			
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
	else
		if result_sprite:getChildByTag(222) then 
			result_sprite:removeChildByTag(222,true)
		end

		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end
		
	local fameT = display.strokeLabel(resultData.msg or ""  , -90, 5 , 18 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 180 , dimensions_height = 125 , align = 0 } )
	setAnchPos( fameT , 227-90, 442+5, 0.5 , 0.5 )
	result_sprite:addChild( fameT )

    return layer
end



function M:zhenfawar_result(params)
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		local logic = requires(IMG_PATH,"GameLuaScript/Scene/battle/logicLayer")
		if logic:getParams().resultCallFun then
			logic:getParams().resultCallFun()
		end
	end
	

	--确定按钮
	confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = params.backFun } )
	layer:addChild( confirmBtn:getLayer() , 2 )			
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
	else
		if result_sprite:getChildByTag(222) then 
			result_sprite:removeChildByTag(222,true)
		end

		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(params.backFun)
	end

	local config = {
		"shangzhen",
		"zhenfa",
	}

	for i=1,#config do
		local name = config[i]
		local label = display.newSprite( IMG_PATH .. "image/scene/zhenFaWar/"..name.."_label.png" , 49 , i == 1 and 269 or 225 , 0 , 0 )
		result_sprite:addChild( label )
		label:addChild( createLabel({ str = tonumber(resultData.win_info[i..""])==0 and "失败" or "成功", x=53 , y = 5 , size = 18, color = ccc3(222,222,222)}) )
		label:addChild( KNBtn:new( COMMONPATH , { "btn_bg.png" ,"btn_bg_pre.png"}, 155 , label:getContentSize().height /2  , { 
				priority = -132 , 
				anchMid = true,
				front = IMG_PATH .. "image/scene/bloodTrial/look.png",
				callback = function()
						HTTP:call("zhenfawar", "getBattleResultInfo", { type=i }, {
							success_callback = function(data)
								DATA_Battle:setMod("zhenfawar")
								DATA_Battle:setAct("challenge")
								DATA_Battle:set( data)
								pushScene("battle" ,  {overFun = function() 
									popScene()
								end})
							end
							})
				end 
		} ):getLayer() )

	end


	local fameT = display.strokeLabel(resultData.msg or ""  , -90, 5 , 18 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 180 , dimensions_height = 125 , align = 0 } )
	setAnchPos( fameT , 227-90, 442+5, 0.5 , 0.5 )
	result_sprite:addChild( fameT )

    return layer
end

--魂殿结算
function M:empire_result()

	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()


		if __INNER_USE_NEW_BATTLE then
			local scene = display.getRunningScene()
			if scene.params and scene.params.resultCallFun then
				scene.params.resultCallFun()
			end
		else
			local logic = requires(IMG_PATH,"GameLuaScript/Scene/battle/logicLayer")
			if logic:getParams().resultCallFun then
				logic:getParams().resultCallFun()
			end
		end
	end
							
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		if result_sprite:getChildByTag(222) then 
			result_sprite:removeChildByTag(222,true)
		end

		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end


	if KNGuide:getStep() == 20090 then 
		KNGuide:show( confirmBtn:getLayer() )
	end 


	local fameT = display.strokeLabel(resultData.msg  , -90, 5 , 18 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 180 , dimensions_height = 125 , align = 0 } )
	setAnchPos( fameT , 227-90, 442+5, 0.5 , 0.5 )
	result_sprite:addChild( fameT )

    return layer
end

--铁血试炼结算
function M:trial_result()

	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		
		HTTP:call("trial","getInfo",{  } , {
					success_callback = function( data )
							switchScene("bloodTrial",data)
							end
				})	
								

	end
	



	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

	local fameT = display.strokeLabel(resultData.msg  , -90, 5 , 18 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 180 , dimensions_height = 125 , align = 0 } )
	setAnchPos( fameT , 227-90, 442+5, 0.5 , 0.5 )
	result_sprite:addChild( fameT )

    return layer
end


--国庆爬塔结算
function M:guoqing_result()

	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		
		HTTP:call("activity","get",{  } , {
					success_callback = function(  )
							switchScene("activity",{findCurKeyByName="guoqing_activity"})
							end
				})	
								

	end
	



	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

	local fameT = display.strokeLabel(resultData.msg  , -90, 5 , 18 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 180 , dimensions_height = 125 , align = 0 } )
	setAnchPos( fameT , 227-90, 440, 0.5 , 0.5 )
	result_sprite:addChild( fameT )

    return layer
end






--银两副本结算
function M:silver_result()

	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	--返回事件处理
	local function backFun()
		
		HTTP:call("commonfuben","getMissionList",{fuben_type = SILVERWARLAYER_DATA.fuben_type , degree = SILVERWARLAYER_DATA.fuben_type..SILVERWARLAYER_DATA.degree } , {
					success_callback = function( data )
							switchScene("silverwar",data)
							end
				})	
								

	end
	


	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

	local fameT = display.strokeLabel(resultData.msg  , -90, 5 , 18 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 180 , dimensions_height = 125 , align = 0 } )
	setAnchPos( fameT , 227-90, 442+5, 0.5 , 0.5 )
	result_sprite:addChild( fameT )

    return layer
end


--神战结算页面
function M:godwar_result()
	local layer = display.newLayer()
	local mask
	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		HTTP:call("fengshen", "getJFSummary", {}, {
			success_callback = function(data)
				switchScene("godwar",{
					data = data,
					inWar = true, 
				}, function()
					audio.playMusic( IMG_PATH .. "sound/godwar_field.mp3" , true )
					if resultData.data.hpPack ~= nil and resultData.data.hpPack.type == nil then
						KNMsg.getInstance():flashShow("您的加血包已经使用完，请及时购买")		
					end
					
					if resultData.data.sysmsg then
						GODWAR:sysMsg( resultData.data.sysmsg)
					end
				end)
			end
		})
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		local title, y
		if resultData.fight == "revenge" then
			title = "revenge_coin.png"
			y = 430
			
			result_sprite:addChild(createLabel({str = resultData.data.coin2 or 0, size = 24, color = ccc3(255,255,255), x = 132, width = 400, y = 400}))
		else
			title = resultData.challenge == "fight" and "godwar_win.png" or "godwar_dragon_win.png"
			y = 350
			
			if resultData.challenge == "fight" then
				result_sprite:addChild(createLabel({str = (resultData.data.coin or 0)  + (resultData.data.xrCoin or 0) , size = 24, color = ccc3(255,255,255), x = 162, width = 400, y = 445}))
				
				if resultData.data.challenge_master_coin and resultData.data.challenge_master_coin > 0 then
					local extra = createLabel({str = "从对方主城中额外获得"..resultData.data.challenge_master_coin.."神币" , size = 20, color = ccc3(0,255,0), x = 162, width = 400, y = 145})
					setAnchPos(extra, 240,140,0.5)
					result_sprite:addChild(extra)
				end
			else
				result_sprite:addChild(createLabel({str = resultData.data.dragon , size = 24, color = ccc3(255,255,255), x = 172, width = 400, y = 445}))
			end
			
			result_sprite:addChild(createLabel({str = resultData.data.score or 0, size = 24, color = ccc3(255,255,255), x = 162, width = 400, y = 410}))
			
			result_sprite:addChild(createLabel({str = resultData.data.conWin or 0, size = 24, color = ccc3(255,255,255), x = 112, width = 400, y = 350}))
		end
		
		result_sprite:addChild( display.newSprite( WIN_PATH .. title ,  52 , y , 0 , 0 ) )

		--神战掉落装备
		if 1 == resultData.data.random_equip_full then
			display.strokeLabel("神战装备仓库已满，无法再获得装备", 20, 146, 20, ccc3(216, 210, 184)):addTo(result_sprite)
		elseif resultData.data.random_equip then
			local GODWAR_PATH = IMG_PATH.."image/scene/godwar/"
			display.newSprite(GODWAR_PATH .."spoils.png",111, 280):addTo(result_sprite)
			display.strokeLabel(resultData.data.random_equip.name, 57, 156, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			display.strokeLabel("(仅限神战内使用)", 165, 268, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			local wearEquipCell = requires(IMG_PATH , "GameLuaScript/Scene/hero/wearEquipCell")
			local equipSeatCell = wearEquipCell:new(
				74 ,
				186 ,
				resultData.data.random_equip,
				function()
					pushScene("detail" , {
						detail = "equip",
						data = resultData.data.random_equip,
						priority = -151,
						godwar = true,
						noNavigation = true,
					})
				end,
				result_sprite,
				false,
				false,
				"godwar",
				-132
			)
			result_sprite:addChild( equipSeatCell:getLayer() )
		end
		
		mask = KNMask:new({ item = result_sprite})
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		if resultData.fight == nil then
			local coin = display.newSprite(LOST_PATH .. (resultData.challenge == "fight" and "godwar_coin.png" or "godwar_dragon.png"))	
			setAnchPos(coin, 45, 450)
			result_sprite:addChild(coin)
			
			result_sprite:addChild(createLabel({str = resultData.challenge == "fight" and resultData.data.coin or resultData.data.coin, size = 24, color = ccc3(255,255,255), x = 170, width = 400, y = 450}))
		end
		
		
		
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

    return layer
end

--神战招揽页面
function M:join_result()
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		switchScene( "godwar" , { join = "zhaolan" } )
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		if resultData.join_type and resultData.join_type == "loot" then 
			result_sprite:addChild( display.strokeLabel( "成功劫掠对方的"..resultData["material"].."水晶储藏量到你的矿山中!" , 45 , 350 , 18 ,  ccc3( 0x0c , 0xfc , 0xff )  , nil , nil , { dimensions_width = 200 , dimensions_height = 90 , align = 0 } ) )
		elseif resultData.join_type and resultData.join_type == "fuchou" then 
			result_sprite:addChild( display.strokeLabel( "恭喜复仇成功！【"..resultData.server_name.."】中的【"..resultData.name.."】仓惶逃跑，丢失了"..resultData["material"].."水晶!" , 45 , 350 , 18 ,  ccc3( 0x0c , 0xfc , 0xff )  , nil , nil , { dimensions_width = 200 , dimensions_height = 0 , align = 0 } ) )
		else
			result_sprite:addChild( display.strokeLabel( "【" .. resultData.slave_server_name  .. "】的英雄【" .. resultData.slave_name .. "】已经被你抓回了苦力作坊！开始努力工作了。" , 45 , 380 , 18 ,  ccc3( 0x0c , 0xfc , 0xff )  , nil , nil , { dimensions_width = 200 , dimensions_height = 0 , align = 0 } ) )
		end
--		or ccc3( 0xff , 0xfb , 0xd4 )
		mask = KNMask:new({ item = result_sprite})
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )

		--神战掉落装备
		if 1 == resultData.skill_full then
			display.strokeLabel("神战技能仓库已满，无法再获得技能", 20, 146, 20, ccc3(216, 210, 184)):addTo(result_sprite)
		elseif resultData.skill then
			local GODWAR_PATH = IMG_PATH.."image/scene/godwar/"
			display.newSprite(GODWAR_PATH .."spoils.png",111, 280):addTo(result_sprite)
			display.strokeLabel(resultData.skill.name, 57, 156, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			display.strokeLabel("(仅限神战内使用)", 165, 268, 20, ccc3(216, 210, 184)):addTo(result_sprite)
			local wearEquipCell = requires(IMG_PATH , "GameLuaScript/Scene/hero/wearEquipCell")
			local equipSeatCell = wearEquipCell:new(
				74 ,
				186 ,
				resultData.skill,
				function()
					pushScene("detail" , {
						detail = "skill",
						data = resultData.skill,
						priority = -151,
						godwar = true,
						noNavigation = true,
					})
				end,
				result_sprite,
				false,
				false,
				"godwar",
				-132
			)
			result_sprite:addChild( equipSeatCell:getLayer() )
		end
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

    return layer
end
--神战反击
function M:revolt_result()
	local layer = display.newLayer()
	local mask
	
	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		switchScene( "godwar" , { join = "revolt" } )
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })

		result_sprite:addChild( display.strokeLabel( "复仇成功！对方损失了".. ( resultData.material or 0 ) .."水晶！" , 45 , 380 , 18 ,  ccc3( 0x0c , 0xfc , 0xff )  , nil , nil , { dimensions_width = 300 , dimensions_height = 0 , align = 0 } ) )
--		or ccc3( 0xff , 0xfb , 0xd4 )
		mask = KNMask:new({ item = result_sprite})
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

    return layer
end

--皇权结算页面
function M:power_result()
	local layer = display.newLayer()
	local mask

	--战斗输赢
	local win = DATA_Battle:get("win")
	if resultData.is_win then win = tonumber( resultData.is_win ) end
	if resultData.success == 0 then win = 0 end
	
	--返回事件处理
	local function backFun()
		switchScene( "power" ,{data = resultData, fight = true})
	end
	
	if win == 1 then
		M:baseWin({ showGirl = true , showBgFrame = true })
		
		result_sprite:addChild( display.newSprite( WIN_PATH .. "power_win.png" ,  52 , 390 , 0 , 0 ) )

		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		
		--确定按钮
		confirmBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 146 / 2 , 50  , { priority = -132 , scale = true , front = COMMONPATH.."confirm.png" , callback = backFun } )
		layer:addChild( confirmBtn:getLayer() , 2 )
	else
		mask = KNMask:new({ item = result_sprite })
		layer:addChild( mask:getLayer() )
		-- 失败  点击返回首页
		mask:click(backFun)
	end

    return layer
end

--演示战斗
function M:guide_result()

	local layer = display.newLayer()
	local mask
	
	local function backFun()
		if __INNER_USE_NEW_BATTLE then
			local scene = display.getRunningScene()
			if scene.params and scene.params.resultCallFun then
				scene.params.resultCallFun()
			end
		else
			local logic = requires(IMG_PATH,"GameLuaScript/Scene/battle/logicLayer")
			if logic:getParams().resultCallFun then
				logic:getParams().resultCallFun()
			end
		end
	end
	
	--战斗失败
	M:warLost()
	
	mask = KNMask:new({ item = result_sprite })
	layer:addChild( mask:getLayer() )
	
	mask:click(backFun)

    return layer
end


--[[播放卡牌获得动画]]
function M:playGetCards(cids , backFun , params )
	params = params or {}
	local scene = display.getRunningScene()

	card_mask = KNMask:new({priority = -133})
	scene:addChild(card_mask:getLayer() , 100)

	local callback
	callback = function(index)
		local next_index = index + 1
		if cids[next_index] then
			M:playOneCard(cids[next_index] , next_index , callback , params )
		else
			scene:removeChild(card_mask:getLayer() , true)

			if backFun then
				backFun()
			end
		end
	end
	
	
	M:playOneCard(cids[1] , 1 , callback , params )
end

function M:playOneCard(cid , index , callback , params )
	local curLayer = params.parentLayer or result_sprite
	local tempData = DATA_Result:get().awards or {}
	if tempData.dropkit then
		M:popOneCard( cid , index , callback)
	else
		local baseX = 42
		local baseY = 256
	
		local card_x = baseX + 49 + (index - 1) * 74
		local card_y = baseY - 153
		
		local curName = getConfig( getCidType( cid ) ,  cid , "name" ) 
		local star = getConfig( getCidType( cid ) ,  cid , "star" )
		local otherData = {}
		for j = 1 , star do
			otherData[ #otherData + 1 ] = { IMG_PATH .. "image/scene/home/star.png" ,  7 - star * 12 + j * 24  , -27 }
		end
		local isPetskill =( getCidType(cid) == "petskill" )
		local textData = {}
		if isPetskill then
			otherData[ #otherData + 1 ] = {IMG_PATH.."image/scene/bag/kind_bg.png", 0 , 2 }
			textData = { {"兽",16, ccc3(255,255,255), ccp(-20, 23),nil, 17} , { curName , 18 , ccc3( 0xfe , 0xfc , 0xd3 ) , { x = 1 , y = -70	} , nil , 20 } }
		else
			textData = { curName , 18 , ccc3( 0xfe , 0xfc , 0xd3 ) , { x = 1 , y = -70	} , nil , 20 }
		end
		
		local addX
		local addY
		if addType == 0 	then addX = 80 + ( index - 1 ) * 130 addY = 180
		elseif addType == 1	then addX = 100 addY = 373
		elseif addType == 2	then addX = 70 + ( index - 1 ) % 4 * 90 addY = 245 - math.floor(( index - 1 )/4)*85
		end

		local awardBtn = awardCell( { cid = cid } , { nameColor = ccc3( 0xfe , 0xfc , 0xd3 ) , name = true , star = true })
		setAnchPos( awardBtn , addX , addY  )
		curLayer:addChild( awardBtn )
		
		
		local handle
		handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
			handle = nil
	
			M:popOneCard(cid , index , callback)
		end , 0.22 , false)
	end
end

function M:popOneCard(cid , index , callback)
	local baseX = 42
	local baseY = 189
	local card_x = ( addType == 0 and 80 or 100) + ( index - 1 ) * 130 
	local card_y = ( addType == 0 and 189 or 373)

	local top_tips = nil
	local tempData = DATA_Result:get().awards
-- 	if tempData.dropkit then
-- 		top_tips = display.newLayer()
		
		
-- 		local roleImageBg = display.newSprite( IMG_PATH .. "image/scene/common/box.png")
-- 		setAnchPos(roleImageBg , 50 , -14 )
		
-- 		local roleImage = display.newSprite( getImageByType(logic:getfoeAgent() , "s"))
-- 		setAnchPos(roleImage , 53 , -5 )
		
-- 		--击败文字
-- 		local talkText = display.newSprite( PATH .. "talk_text.png" )
-- 		setAnchPos(talkText , 127, -15)
		
-- 		--威望
-- 		local prestigeText = display.newSprite( IMG_PATH .. "image/scene/battle/result/prestige.png" )
-- 		setAnchPos(prestigeText , 53 , -400)
		
-- 		--经验
-- 		local expText = display.newSprite( IMG_PATH .. "image/scene/battle/result/exp.png" )
-- 		setAnchPos(expText , 186 , -400)
		
-- 		--银两
-- 		local silverText = display.newSprite( IMG_PATH .. "image/scene/battle/result/silver.png" )
-- 		setAnchPos(silverText , 53 , -430)
		
		
		
-- 		local expT = display.strokeLabel("+" .. ( tempData.exp or 0 ) , 236, -410 , 16 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , { dimensions_width = 85 , dimensions_height = 30 , align = 0 } )
-- 		local prestigeT = display.strokeLabel( "+" .. ( tempData.prestige or 0 ) , 106 , -410 , 16 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , { dimensions_width = 85 , dimensions_height = 30 , align = 0 } )
-- 		local silverT = display.strokeLabel(  "+" ..  ( tempData.silver or 0 ) , 106, -430 , 16 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , { dimensions_width = 85 , dimensions_height = 20 , align = 0 } )
		
-- 		top_tips:addChild(expT)
-- 		top_tips:addChild(prestigeT)
-- 		top_tips:addChild(silverT)
		
-- --		local cid_type = getCidType(cid)
-- --		local config = getConfig(cid_type , cid)
-- --		local top_tips_label = CCLabelTTF:create(config["name"] , FONT , 30)
-- --		top_tips_label:setColor( ccc3( 0xff , 0xfb , 0xd4 ) )
-- --		setAnchPos(top_tips_label , 190 , 0 , 0.5)
-- --	
-- --		function top_tips:setOpacity(opacity)
-- --			top_tips_sprite:setOpacity(opacity)
-- --			top_tips_label:setOpacity(opacity)
-- --		end
-- --		top_tips:addChild(top_tips_label)
-- 		setAnchPos(top_tips , 60 , 720)
		
-- 		top_tips:addChild(roleImageBg)
-- 		top_tips:addChild(roleImage)
		
-- 		top_tips:addChild(talkText)
-- 		top_tips:addChild(expText)
		
-- 		top_tips:addChild(prestigeText)
-- 		top_tips:addChild(silverText)
-- 	end


-- 	local card_popup = KNCardpopup:new(cid , function()
-- 		callback(index)
-- 	end , {
-- 		init_x = card_x - 196,
-- 		init_y = card_y - 211,
-- 		end_x = card_x - 196,
-- 		end_y = card_y - 211 - 230 ,
-- 		top_tips = top_tips,
-- 	})


-- 	card_mask:getLayer():addChild( card_popup:play() )
	callback(index)
end

return M
