local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local cut = class("cut", function() return display.newNode() end)
cut.__index = cut

function cut:ctor(scene, role, func)
	local scaleRatio = 1.5
	local cardx, cardy = display.cx, 500
	role:moveTo(.1, cardx, cardy)
	role:scaleTo(.1, scaleRatio)

	CCNodeExtend.extend(CCLayerColor:create(ccc4(0, 0, 0, 188)))
		:addTo(self)
		:size(display.width, display.height)
	display.strokeLabel("请左右划牌来切开牌", 150, 340, 20, ccc3(255, 0, 0)):addTo(self)
	display.newSprite(def.oldimage .."fruit/win/row/row_num_bg.png", display.cx, 720):addTo(self)

	local hand = display.newSprite(def.oldimage .."hand.png", -100, 500):addTo(scene, display.height+3):anchor(0, 1)
	local arr = CCArray:create()
	arr:addObject(CCShow:create())
	arr:addObject(CCPlace:create(ccp(200, 560)))
	arr:addObject(CCMoveBy:create(.2, ccp(60, 30)))
	arr:addObject(CCMoveBy:create(.2, ccp(-40, -60)))
	arr:addObject(CCMoveBy:create(.2, ccp(30, 20)))
	arr:addObject(CCMoveBy:create(.2, ccp(-80, -100)))
	arr:addObject(CCHide:create())
	arr:addObject(CCDelayTime:create(.2))
	local seq = CCSequence:create(arr)
	hand:run(CCRepeatForever:create(tolua.cast(seq, "CCActionInterval")))

	local w = role.touchSize.width*scaleRatio
	local h = role.touchSize.height*scaleRatio
	local rect = CCRect(cardx-w/2, cardy-h/2, w, h)
	local rowNum = 0
	local cutTime = 0
	local countDownTime = 3
	local firstPoint,movePoint,beginSlide,beginAngle,slided,rowNumSp,countDonSp

	local function removeHelp()
		if hand then 
			hand:removeSelf() 
			hand = nil
		end
	end

	local function refreshTime()
		if countDonSp then
			countDonSp:removeFromParentAndCleanup(true)
			countDonSp = nil
		else
			local countDownTimeText = display.newSprite(def.oldimage .."count_down_text.png")
			setAnchPos( countDownTimeText , 23 , display.height - 40 , 0 , 0.5 )
			self:addChild( countDownTimeText )
		end
		countDonSp = getImageNum( countDownTime - cutTime  , def.oldimage .."fruit/win/row/num.png" , { decimals = true })
		setAnchPos( countDonSp , 338  , display.height - 40 , 0 , 0.5 )
		self:addChild( countDonSp )
		cutTime = cutTime + 1
	end
	refreshTime()

	local function refreshRowNum()
		if rowNumSp then
			rowNumSp:removeFromParentAndCleanup(true)
			rowNumSp = nil
		end
		rowNumSp = getImageNum( rowNum, IMG_PATH .. "image/scene/battle/fruit/win/row/num.png" , { decimals = true })
		setAnchPos( rowNumSp , display.cx , 720 , 0.5 , 0.5 )
		self:addChild( rowNumSp )
	end
	refreshRowNum()

	display.newLayer():addTo(self):enableTouch(true):onTouch(function(eventType, x, y)
		local function countFun( _angleValue )
			rowNum = rowNum + 1
			refreshRowNum()	
						
			--限制光效区域
			local x = ( x > ( rect.origin.x + rect.size.width ) ) and ( rect.origin.x + rect.size.width ) or x
			x = ( x < ( rect.origin.x ) ) and rect.origin.x or x
			local y = ( y > ( rect.origin.y + rect.size.height ) ) and ( rect.origin.y + rect.size.height ) or y
			y = ( y < ( rect.origin.y ) ) and rect.origin.y or y
			
			local gap = rect.size.width / 2
			if scene.boss.cleanup_award then
				local dropCidData = scene.boss.cleanup_award[rowNum] or scene.boss.cleanup_award[1]
				local propSp = display.newSprite( getImageByType( dropCidData.c ) )
				setAnchPos( propSp , display.cx + ( math.random(1,3)>2 and -gap or gap ) , display.cy , 0.5 , 0.5)
				scene:addChild( propSp, display.height+3 )
				--掉落 
				transition.moveTo( propSp ,{ time= 1 , x = 150 , y = 10 })
				transition.scaleTo( propSp ,{ time= 1 , scale = 0.5 ,onComplete = function() propSp:removeSelf() end })
			end

			--人物抖动
			transition.shake(role , { initScale = scaleRatio , addScale = 0.3})
														
			local knifeShade = display.newSprite(def.oldimage .."knife_shade.png")
			setAnchPos( knifeShade , x  , y  , 0.5 , 0.5 )
			scene:addChild( knifeShade, display.height+3 )
			knifeShade:setRotation( 360 - _angleValue)
			transition.moveTo( knifeShade , { delay = 0.05 , time = 0.1 , onComplete = function() knifeShade:removeFromParentAndCleanup(true) end})		
			
			local knife = display.newSprite(def.oldimage .."knife.png")
			setAnchPos( knife , x , y , 0.5 , 0.5 )
			scene:addChild( knife, display.height+3 )
			knife:setRotation( 360 - _angleValue)
			transition.moveTo( knife , {time = 0.1 , onComplete = function() knife:removeFromParentAndCleanup(true) end})		
		end

	    if eventType == CCTOUCHBEGAN then
	    	--去掉帮助
	    	removeHelp()
			-- 判断是否点中了这张卡牌
	    	if rect:containsPoint( ccp(x , y) ) then
	    		firstPoint = { x = x , y = y}
	    		movePoint = { x = x , y = y}
	    		beginSlide = true
	    		beginAngle = nil
	    		slided = 0
	    	else
	    		beginSlide = false
    		end
    		return true
		elseif eventType == CCTOUCHMOVED then
			if not beginSlide then
				if rect:containsPoint( ccp(x , y) ) then
	    			firstPoint = { x = x , y = y}
	    			movePoint = { x = x , y = y}
	    			beginSlide = true
	    			beginAngle = nil
	    			slided = 0
    			end
    			
    			return false
			end
			
			local distance = math.sqrt( (x - movePoint.x) * (x - movePoint.x) + (y - movePoint.y) * (y - movePoint.y) )
			if distance > 2 then
				local angle = math.deg( math.acos( (x - movePoint.x) / distance ) )
				if y - movePoint.y < 0 then
					angle = 360 - angle
				end
				movePoint = { x = x , y = y}
				
				if beginAngle == nil then
					beginAngle = angle
				else
					local max = 90
					local diff = angle - beginAngle
					if math.abs( diff ) <= max then
						-- 方向没有变
						slided = slided + 1
					else
						diff = angle - (beginAngle + 360)
						if math.abs( diff ) <= max then
							-- 方向没有变
							slided = slided + 1
						else
							beginSlide = false
							slided = 0
						end
					end
				end
				
				if slided == 2 then
					countFun(beginAngle)
				end			
			end
			
		elseif eventType == CCTOUCHENDED then
			beginSlide = false
		end
		return true
	end, false, -999, true)

	Clock:removeTimeFun( "cut" )
	Clock:addTimeFun( "cut" , refreshTime )

	scene:lockPlay()

	local handle
	local function timeHandler()
		scene:unlockPlay()

		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
		handle = nil

		Clock:removeTimeFun( "cut" )

		removeHelp()
		self:removeSelf()

		scene.rowNum = rowNum
		func()
	end
	handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(timeHandler , countDownTime , false)
end

return cut