local def = {}

-- def.debug = 1
def.oldimage = IMG_PATH .. "image/scene/battle/"
def.image =  IMG_PATH .. "image/scene/battleNew/"

--是否是神战战斗
def.isGodwarBattle = function(group)
	return DATA_Battle:get("game" ..group)
end

--原始站位
def.getPos = function(group, index, isBossWar)
	if group == 2 and isBossWar then
		return display.cx, 600
	end
	return 480/4*(index-.5), 1==group and 205 or 650
end

--宠物buf frame数
def.petBufFrame = {
	mabi = 6,
	dongjie = 6,
	hunluan = 5,
	zhongdu = 5,
	huifu = 5,
}

--宠物buf 美术文件名
def.petBufText = {
	mabi = "mabi",
	dongjie = "dongjie",
	hunluan = "chaos",
	zhongdu = "zhongdu",
	huifu = "recover",
}


--中心点
def.centerPos = {
	{display.cx, display.cy-200},
	{display.cx, display.cy+200},
}

--特效发起类型
def.fire = {
	none = 0,		--无
	self = 1,		--攻击者自身播放
	up2center = 2,	--垂直向中心点发射
	up2top = 3,		--垂直向天发射
	center = 4,		--中心点播放
	centery_and_flipy = 5,	--y为中心点, x为自己坐标, 并且镜像
	center_and_fadeout = 6, --中心点播放+渐变消失
}

--特效轨迹类型
def.locus = {
	none = 0,	--无
	move1 = 1,	--平移
	move2 = 2, 	--平移＋旋转
	center2dest = 3,--中心点向受击出发
	move3 = 4,--平移＋旋转+不循环播放+轨迹时间为播放时间+坐标为（x是人物坐标， y是display.cy）
}

--特效受击类型
def.hit = {
	none = 0,	--无
	self = 1,	--受击者身上发起(群体的也是)
	multi = 2,	--群体受击， 每个人身上按间隔时间播放
	center = 3  --群体受击， 受击群体中心发起

}
--卡牌方向
def.dir = {
	left = 1,
	right = 2,
	center = 3
}

--被克关系
def.restrain = {
	["13"] = 1,
	["21"] = 1,
	["32"] = 1
}

--攻击者 二级技能
def.atkType = {
	crit = true,	--暴击
	hit = true,		--命中
	kill = true,	--必杀
	xixue = true,	--吸血  饮血狂屠（器灵）
	fangyu = true,	--防御  背水一战（器灵）
}

--受击者 二级技能
def.hitType = {
	block = true,	--格挡
	dodge = true,	--闪避
	ctatk = true 	--反击
}

--控制节奏
def.wait = {
	atk = .2,
	atk_skill = .2,
	skillpetnew = .2
}

function def.getShortName(group)
	local groupName = def.isGodwarBattle(group)
	groupName = groupName or CHANNEL_GROUP
	if groupName == "tgxy" or groupName == "tgxy2" then
		return "tgxy"
	elseif groupName == "tmsj" or groupName == "tmsj2" then
		return "tmsj"
	elseif groupName == "td" then
		return "td"
	elseif groupName == "hy" then
		return "hy"
	end
	return "dhsh"
end

function def.getSkillTexts(id, effect, group)
	local short = def.getShortName(group)
	effect.load("skillText-" ..short)
    local ret = {}
    local maxFrame = 10
    for i=1, maxFrame do
        local frame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(short .."_t" ..id .."/" ..i ..".png")
        if not frame then
            break
        end
        ret[#ret+1] = frame
    end
    return ret
end
   
function def.playSkillTextEff(x, y, frame, scene, parent, effect, func)
	local function get() return CCSpriteExtend.extend(CCSprite:createWithSpriteFrame(frame)) end 
	local speed = scene.speed
	local spr
	
	spr = get():pos(x, y):addTo(parent, display.height):opacity(0):scale(5)
		:runs({
			CCSpawn:createWithTwoActions(
				CCScaleTo:create(.21*speed, 1), 
				CCFadeIn:create(.21*speed)
			),
			CCCallFunc:create(function()
				effect.get("skillTextBg", true):addTo(spr, -1):pos(spr:getw()/2, spr:geth()/2)
				get():pos(spr:getw()/2, spr:geth()/2):addTo(spr)
					:run(CCSpawn:createWithTwoActions(CCScaleTo:create(.25*speed, 3), CCFadeOut:create(.25*speed)))
--				shakeNode(scene, .25*speed, 1)
				func()
			end)
		})
	return spr
end

return def