local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local effect = {}

--延迟表
effect.delay = {
	["pet-1"] = .12,
	["3014-3"] = .12,
	["3020-3"] = .12,
	["3022-3"] = .12,
	["3023-3"] = .12,
	["3030-3"] = .12,
	["3031-3"] = .12,
	["3033-3"] = .12,
	["3063-3"] = .12,
	["3064-3"] = .12,
}

--替换表
effect.replace = {
}

--缩放表
effect.scale = {
	["3026-1"] = 1.5,
}

function effect.load(id, path)
	path = path or (def.image .."effect/" ..id)
	display.addSpriteFramesWithFile(path ..".plist", path ..".png")
end

function effect.clear(id, path)
	path = path or (def.image .."effect/" ..id)
	display.removeSpriteFramesWithFile(path ..".plist", path ..".png")
end

--id: 特效id
--noForever: 是否不循环
--callback: 特效播放结束回调
function effect.get(id, noForever, callback)
	if type(id) == "string" then
		if effect.replace[id] then id = effect.replace[id] end
		effect.load(id)
	else
		effect.load(id[1], id[2])
		id = id[1]
	end
	local filename = "#" ..id .."/1.png"
	local sprite = display.newSprite(filename)
	if not sprite then
		return nil
	end

	--受击放大----------------
	local strs = string.split(id, "-")
	if #strs >= 2 and strs[2] == "3" then
		sprite:scale(1.5)
	end
	--受击放大----------------

	if effect.scale[id] then sprite:scale(effect.scale[id]) end
	if effect[id] then return effect[id](id, filename, callback) end
	local action = createAnimation(id .."/%d.png", (nil == effect.delay[id] and .06 or effect.delay[id]) * (display.getRunningScene().speed or 1), 1)
	local dur = action:getDuration()
	if not noForever then--循环
		sprite:run(CCRepeatForever:create(CCAnimate:create(action)))
	else--不循环
		local actionEnd = function()
			sprite:removeSelf()
			if callback then callback() end
		end
		sprite:runs({CCAnimate:create(action), CCCallFunc:create(actionEnd)})
	end
	return sprite,dur
end

function effect.get2(path, frameCnt, line, delay, noForever, callback)
	delay = delay * (display.getRunningScene().speed or 1)
	local frames = display.newFramesWithImage(path, frameCnt, line)
	local sprite = display.newSpriteWithFrame(frames[1])
    local action = display.newAnimation(frames, delay)
    local dur = action:getDuration()
	if not noForever then--循环
		sprite:run(CCRepeatForever:create(CCAnimate:create(action)))
	else--不循环
		local actionEnd = function()
			sprite:removeSelf()
			if callback then callback() end
		end
		sprite:runs({CCAnimate:create(action), CCCallFunc:create(actionEnd)})
	end
	return sprite, dur
end

--[[
个别特效的附加处理
]]

return effect