local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local eff = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/eff")
local effect = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/effect")
local npc = requires(IMG_PATH, "GameLuaScript/Config/Npc")
local hero = requires(IMG_PATH, "GameLuaScript/Config/Hero")
local skill = requires(IMG_PATH, "GameLuaScript/Config/Skill")
local res = {}

--要加载的特效
res.effs = {
	"big-skill",
	"ground",
	"halo",
	"normal",
	"fatal",
	"dead",
	"dead-center",
	"makeup",
	"skillTip"
}

--图片
res.pics = {}

--音效
res.sounds = {
	"sound/battle/enter.mp3",
	"sound/battle/makeup.mp3",
	"sound/battle/skillyell.mp3",
	"sound/battle/dead.mp3",
	"sound/battle/dead-center.mp3",
}

--test
res.replaces = {}

function res.init(func, report)
	scheduler.performWithDelayGlobal(function() 
		res.load(func, report)
	end, .01)
end

function res.load(func, report)
	--宠物
	if report.prepare.p1_pet.cid then
		res.pics[#res.pics+1] = "image/pet/" ..report.prepare.p1_pet.cid ..".png"

	end
	if report.prepare.p2_pet.cid then
		res.pics[#res.pics+1] = "image/pet/" ..report.prepare.p2_pet.cid ..".png"
	end

	--解析战报
	for i=1,3 do
		local round = report[i ..""]
		if not round then
			break
		end
		for j,v in ipairs(round) do
			--人物
			if "queue" == v.type and 1 == i then
				local getpicid = function(data)
					local pic_id
					if data.cid then
						pic_id = hero[tostring(data.cid)].logo_id
					else
						pic_id = npc[tostring(data.npc_id)].logo_id
					end
					return pic_id
				end
				local roles = {v.data.p1, v.data.p1_back, v.data.p2, v.data.p2_back}
				for _,v in ipairs(roles) do
					for _,v2 in ipairs(v) do
						res.pics[#res.pics+1] = "image/hero/b_general" ..getpicid(v2) ..".png"
					end
				end
			--技能
			elseif "atk_skill" == v.type then
				local skillData = skill["" ..v.data.skill_cid]
				local effData = eff["" ..skillData.effect_id]
--test-------------------------------
				if not effData then
					if 3 == skillData.target then
						local ids = {3033,3034,3037,3038,3912,3913,3914,3915,3916,3917,3918}
						local tmpid = ids[math.random(#ids)] ..""
						res.replaces[skillData.effect_id] = tmpid
						skillData.effect_id = tmpid
					else
						local ids = {3901,3902,3903,3904,3905,3906,3907,3908,3909,3910,3911,3931,3932,3935,3936}
						local tmpid = ids[math.random(#ids)] ..""
						res.replaces["" ..skillData.effect_id] = tmpid
						skillData.effect_id = tmpid
					end
					effData = eff["" ..skillData.effect_id]
				end
--test end-------------------------------
				if effData.locus > 0 then res.effs[#res.effs+1] = skillData.effect_id .."-1" end
				if effData.hit > 0 then res.effs[#res.effs+1] = skillData.effect_id .."-2" end
				if effData.buf > 0 then res.effs[#res.effs+1] = skillData.effect_id .."-3" end
				res.sounds[#res.sounds+1] = "sound/battle/skill/" ..skillData.effect_id ..".mp3"
			--宠物技能
			elseif "skillpetnew" == v.type then
				local effData = eff[v.data.type]
				if effData.locus > 0 then res.effs[#res.effs+1] = v.data.type .."-1" end
				if effData.hit > 0 then res.effs[#res.effs+1] = v.data.type .."-2" end
				if effData.buf > 0 then res.effs[#res.effs+1] = v.data.type .."-3" end
				res.sounds[#res.sounds+1] = "sound/battle/pet/" ..v.data.type ..".mp3"
			end			
		end
	end

	local loadFile
	loadFile = function(i, j, k)
		if i < #res.effs then
			effect.load(res.effs[i])
			i = i + 1
			scheduler.performWithDelayGlobal(function() loadFile(i, j, k) end, 0)
		elseif j < #res.pics then
			CCTextureCache:sharedTextureCache():addImage(res.pics[j])
			j = j + 1
			scheduler.performWithDelayGlobal(function() loadFile(i, j, k) end, 0)
		elseif k < #res.sounds then
			audio.preloadMusic(res.sounds[k])
			k = k + 1
			scheduler.performWithDelayGlobal(function() loadFile(i, j, k) end, 0)
		else
			func()
		end
	end
	loadFile(1,1,1)
end

function res.clear()
	for i,v in ipairs(res.effs) do
		print("释放特效: " ..v)
		effect.clear(v)
	end
	for i,v in ipairs(res.pics) do
		print("释放图片: " ..v)
		CCTextureCache:sharedTextureCache():removeTextureForKey(v)
	end
end

return res