local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local cut = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/cut")
local effect = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/effect")
local npc = requires(IMG_PATH, "GameLuaScript/Config/Npc")
local hero = requires(IMG_PATH, "GameLuaScript/Config/Hero")
local hpBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")
local M = class("role", function() return display.newNode() end)
M.__index = M

table.merge(M, {
	data = nil,
	p = {
		group = nil,--1 自己 2对方
		index = nil--自己队中的编号
	},
	originPos = nil,
	lastY = nil,
	bigpic = nil,
	hp = {
		inst = nil,
		cur = nil,
		max = nil,
	},
	bufs = {},
	sprs = {},
	attacking = nil,
	touchSize = nil,
})

function M:ctor(data)
	self.sprs = {}
	local function add(p)
		self.sprs[#self.sprs+1] = p
		return p
	end

	local scene = display.getRunningScene()
	local bg, hp

	if scene.isBossWar and data._group == 2 then--boss
		--背景
		bg = add(display.newSprite(def.oldimage.."boss/boss_bg.png"):addTo(self))
		--人物图
		self.bigpic = def.oldimage.."boss/boss.png"
		add(display.newSprite(self.bigpic, 20, 50):addTo(self))
		--血量
		hp = hpBar:new("hp_boss" , 0 , 0 , { barOffset = -10 , isOnlyCur = true , curValue = data.hp , maxValue = data.org_hp , textSize = 14 , icon = "icon"} )
			:pos(-95, -130)
			:addTo(self)
		hp:setIsShowText( true )
		--等级
		local offsetx = data.lv < 10 and 9 or (data.lv < 100 and 5 or 0)
		display.strokeLabel(data.lv or "0", -95+offsetx, -140, 15, ccc3(253, 252, 172)):addTo(self)
	else
		if data.shenyuan_shenweilv and tonumber( data.shenyuan_shenweilv ) ~= 0 then
			bg = add(display.newSprite(def.oldimage .."role/shenyuan_shenweilv.png", 0, 8):addTo(self))
			add(effect.get2(def.oldimage .."role/shenyuan_eff.png", 10, 1, .1):pos(38, 85):addTo(self, 1))
		else
			bg = add(display.newSprite(def.oldimage.."role/role_bg.png"):addTo(self))
		end

		local curCid = data.cid or ( getConfig( getCidType( data.npc_id ) ,data.npc_id ,"gid" ) ) 
		local curType = getCidType( curCid )

		--是否神脉
		local isGodwarBattle = def.isGodwarBattle(data._group)
		local isShenMai = false
		if not isGodwarBattle then
			if not data.npc_id then
				local shenmaiData = DATA_Bag:get( curType ,  data.id )
				if shenmaiData and tonumber(  shenmaiData["god_frame"] ) == 1  then isShenMai = true end
			end
		end

		--特殊英雄的背景框
		if getConfig( curType , curCid , "special" , nil , data._group ) == 1 then		
			add(display.newSprite( def.oldimage.."role/special_frame.png"):addTo(self))
		end
		
		-- 英雄图片
		local heroImage
		if isGodwarBattle then
			heroImage = getImageByType(data.cid or data.npc_id , "m", nil, data._group)
			self.bigpic = getImageByType(data.cid or data.npc_id , "b", nil, data._group)
		else		
			local hero_img_path = IMG_PATH .. "image/hero/"
			if HAS_GOD_GENERAL and data["god"] == 1 then
				hero_img_path = IMG_PATH .. "image/hero/shen/"-- 天神
			end
			heroImage = hero_img_path ..getImageByType( data.cid or data.npc_id , "m" , true )
			self.bigpic = hero_img_path ..getImageByType( data.cid or data.npc_id , "b" , true )
		end

		if "tgxy2"==CHANNEL_GROUP or "tgxy"==CHANNEL_GROUP then 
			add(display.newSprite(heroImage):pos(1,1):addTo(self))
		else
			add(display.newSprite(heroImage):addTo(self))
		end 

		--卡牌颜色
		add(display.newSprite(def.oldimage.."role/mask"..data.star..".png"):pos(0, -65):addTo(self))
		
		--神脉
		if isShenMai then
			add(display.newSprite( def.oldimage .."role/god_frame.png"):addTo(self))
			if data.role ~= 0 then--职业
				add(display.newSprite(def.oldimage.. "role/god_job" ..data.role ..".png"):pos(0, 80):addTo(self))
			end
			add(effect.get2(def.oldimage .. "role/god_eff.png", 12, 1, .2):pos(-2, -48):addTo(self))
		end

		--血条
		hp = hpBar:new("hp" , 0 , 0 , { barOffset = -10 , isOnlyCur = true , curValue = data.hp , maxValue = data.org_hp , textSize = 14 , icon = "icon"} )
			:pos(-50, -56)
			:addTo(self)
		hp:setIsShowText( true )

		--等级
		local offsetx = data.lv < 10 and 9 or (data.lv < 100 and 5 or 0)
		display.strokeLabel(data.lv or "0", -50+offsetx, -65, 15, ccc3(253, 252, 172)):addTo(self)
		
		--英雄星级
		local heroStarNum = getConfig( curType , curCid , "star" , nil , data._group )	
		for i=1, heroStarNum do
			add(display.newSprite(def.oldimage .."hero_star.png"):pos(-50+i*16, -70):scale(1.1):addTo(self))
		end
		
		--职业
		if data.role ~= 0 and not isShenMai then
			add(display.newSprite(def.oldimage .."job" ..(data.role or 1)..".png"):pos(-38, 55):addTo(self))
		end
	end
	
	--self
	self.p = {
		group = data._group,
		index = data._index+1
	}
	self:pos(def.getPos(self.p.group, self.p.index, scene.isBossWar))
	self.hp = {
		inst = hp,
		cur = data.hp,
		max = data.org_hp,
	}
	self.touchSize = bg:getContentSize()
	self.data = data
	self.bufs = {}
	self.lastY = -1
	self.originPos = ccp(self:getPosition())
	self:hide()

	--如果有附加状态则生成附加状态数据
	if data.status then
		for k,v in pairs(data.status) do
		 	self:addBuf(k, true)
		end
	end

	--处理血条
	self:handleHP(self.hp.cur)
end

function M:getTouchRect()
	local w = self.touchSize.width
	local h = self.touchSize.height
	return CCRect(self:getPositionX()-w/2, self:getPositionY()-h/2, w, h)
end

function M:born()
	local time = .2
	for i,v in ipairs(self.sprs) do
		v:opacity(0):run(CCFadeIn:create(time))
	end
	self:scale(5):show()
	self:runs({
		CCScaleTo:create(time, 1),
		CCCallFunc:create(function()
			effect.get("smoke", true):addTo(self, -1)
--			shakeNode(self:getParent(), time, 1)
		end)
	})
	return self
end

function M:say(str, func)
	local frame = display.newSprite(def.image .."talk.png")
		:anchor(0, 0)
		:pos(30, 120)
		:addTo(self)
	display.strokeLabel(str, 20, 40, 20, display.COLOR_BLACK, nil, nil, {
		dimensions_width = 200,
		dimensions_height = 120,
		align = 0
	})
	:addTo(frame)
	:runs({
		CCDelayTime:create(2),
		CCCallFunc:create(function()
			frame:removeSelf()
			func()
		end),
	})
end

function M:skillSelected()
	for i,v in ipairs(self.sprs) do
		local seq = CCSequence:createWithTwoActions(CCFadeOut:create(.2), CCFadeIn:create(.2))
		v.selectAction = CCRepeatForever:create(tolua.cast(seq, "CCActionInterval"))
		v:run(v.selectAction)
	end

end

function M:skillUnselected()
	for i,v in ipairs(self.sprs) do
		if v.selectAction then
			v:stopAction(v.selectAction)
			v.selectAction = nil
			v:opacity(255)
		end
	end
	
end

function M:handleHP(hp)
	if hp then
		self.hp.cur = hp
		self.hp.inst:setPercent(self.hp.cur/self.hp.max)
	end
end

function M:handleChange(change, attacker)
	local scene = self:getParent()
	local speed = scene.speed

	--血条
	self:handleHP(change.hp)

	--数字
	if change.hp_diff and 0 ~= change.hp_diff then
		local filename, w, h
		if change.hp_diff <= 0 then
			filename, w, h = "num4.png", 29, 37
		else
			filename, w, h = "num1.png", 27, 32
		end
		local label
		label = CCNodeExtend.extend(CCLabelAtlas:create(tostring(math.abs(change.hp_diff)), def.image ..filename, w, h, string.byte('0')))
			:anchor(.5,.5)
			:pos(self:getPositionX(),self:getPositionY())
			:addTo(scene, display.height+1)
			:scale(.75)
			:runs({
				CCDelayTime:create(.06*speed),
				CCScaleTo:create(.06*speed, 1.5),
				CCScaleTo:create(.12*speed, 1),
				CCDelayTime:create(.12*speed),
				CCFadeOut:create(.42*speed),
				CCCallFunc:create(function()
					label:removeSelf()
				end)
			})
	end

	--二级技能
	local showType = function(role, type)
		local sprite
		sprite = display.newSprite(def.oldimage .."effect/" ..type .."_text.png", 0, 80)
			:addTo(role)
			:scale(0)
			:runs({
				CCScaleTo:create(.2*speed, 1),
				CCDelayTime:create(.5*speed),
				CCCallFunc:create(function()
					sprite:removeSelf()
				end)
			})
	end
	if change.actions then
		for k,v in pairs(change.actions) do
			if def.hitType[k] then
				showType(self, k)
			end
		end
		if attacker then
			for k,v in pairs(change.actions) do
				if def.atkType[k] then
					showType(attacker, k)
				end
			end
		end
	end
end

function M:handleRestrain(attacker)
	local scene = self:getParent()
	local speed = scene.speed
	if def.restrain[attacker.data.role..self.data.role..""] then
		local sprite
		sprite = display.newSprite(def.oldimage .."effect/restrain.png")
			:addTo(self)
			:runs({
				CCSpawn:createWithTwoActions(
					CCFadeTo:create(1*speed, 128),
					CCMoveBy:create(1*speed, ccp(0, -50))
				),
				CCCallFunc:create(function()
					sprite:removeSelf()
				end)
			})
	end
end

function M:handlePetSkillText(data)
	local scene = self:getParent()
	local speed = scene.speed
	if data.type == "mabi" or data.type == "hunluan" then
		local sprite
		if data.type == "mabi" then
			sprite = display.newSprite(def.oldimage .."effect/def_text_flag.png")
		else
			sprite = display.newSprite(def.oldimage .."effect/atk_text_flag.png")
		end
		display.newSprite(def.oldimage .."effect/reduce_flag.png", 50, 20):addTo(sprite)
		display.newSprite(def.oldimage .."effect/per_cent.png", 120, 20):addTo(sprite)
		local num =  math.floor( getConfig("petskill" , data.cid , data.lv).debuff )
		local label
		label = CCNodeExtend.extend(CCLabelAtlas:create(tostring(math.abs(num)), def.image .."num6.png", 29, 37, string.byte('0')))
			:anchor(.5,.5):pos(80, 20):addTo(sprite)
		sprite:addTo(self)
			:pos(-35, -80)
			:scale(.01)
			:opacity(0)
			:runs({
				CCSpawn:createWithTwoActions(
					CCScaleTo:create(.3*speed, .8),
					CCFadeIn:create(.3*speed)
				),
				CCDelayTime:create(1*speed),
				CCCallFunc:create(function()
					sprite:removeSelf()
				end)
			})
	end
end

function M:handlePetSkillFaild(type)
	local scene = self:getParent()
	local speed = scene.speed
	local sprite
	sprite = display.newSprite(def.oldimage .."pet/eff_flag/" ..type .."_lost.png")
		:addTo(self, 0, 50)
		:runs({
			CCSpawn:createWithTwoActions(
				CCFadeOut:create(1*speed),
				CCMoveBy:create(1*speed, ccp(0, 50))
			),
			CCCallFunc:create(function()
				sprite:removeSelf()
			end)
		})
end

function M:addBuf(type, skipHitEffect)
	if not skipHitEffect then
		effect.get2(def.oldimage .."pet/eff_flag/eff_" ..type ..".png", def.petBufFrame[type], 1, .1, true):addTo(self)

		local text = def.petBufText[type]
		if text then	
			local scene = self:getParent()
			local speed = scene.speed
			local sprite
			sprite = display.newSprite(def.oldimage .."effect/" ..text .."_text.png")
				:addTo(self, 1)
				:runs({
					CCSpawn:createWithTwoActions(
						CCFadeOut:create(1*speed),
						CCMoveBy:create(1*speed, ccp(0, 50))
					),
					CCCallFunc:create(function()
						sprite:removeSelf()
					end)
				})
		end
	end
	if "huifu" == type then
		return
	end
	for i,v in ipairs(self.bufs) do
		if v.type == type then
			return
		end
	end
	self.bufs[#self.bufs+1] = {
		type = type,
		flag = (type ~= "huifu") and display.newSprite(def.oldimage .."pet/eff_flag/" ..type .."_flag.png"):addTo(self) or nil,
	}
end

function M:removeBuf(type)
	for i,v in ipairs(self.bufs) do
		if v.type == type then
			if v.flag then v.flag:removeSelf() end
			table.remove(self.bufs, i)
			break
		end
	end
	local color = self:getResumeColor()
	for i,v in ipairs(self.sprs) do
		v:setColor(color)
	end
end

function M:getResumeColor()
	return display.COLOR_WHITE
end

--人杰攻击
function M:attack1(defencer, change, func)
	local scene = self:getParent()
	local speed = scene.speed
	local config
	config = {
	    --移动时间，角度, 偏移x, 偏移y
		{.18, 45, -50, 50}, {.06, -50, 70, -50}, {.12, -50, 0, 0}, {.12, 0, 0, 0},
		get = function(idx)
			local d = config[idx][1]*speed
			local r = (1 == self.p.group and 1 or -1)
			return CCSpawn:createWithTwoActions(
				CCRotateTo:create(d, 360-config[idx][2]), 
				CCMoveTo:create(d, ccp(self.originPos.x+config[idx][3]*r, self.originPos.y+config[idx][4]*r))
			)
		end
	}
	self:runs({
		config.get(1),
		CCDelayTime:create(.18*speed),
		CCCallFunc:create(function()
			local eff
			eff = effect.get("attack1-2"):addTo(scene):pos(self:getPosition())
				:runs({
					CCMoveTo:create(.3*speed, ccp(defencer:getPosition())),
					CCCallFunc:create(function()
						eff:removeSelf()
						defencer:byHit1(self, change, func)
					end)
				})
				:runs({
					CCRotateTo:create(.15*speed, 180),
					CCRotateTo:create(.15*speed, 359)
				})
		end),
		config.get(2),
		CCDelayTime:create(.06*speed),
		config.get(3),
		config.get(4),
	})
end

--被人杰攻击
function M:byHit1(attacker, change, func)
	local scene = self:getParent()
	local speed = scene.speed

	--暴击和乘胜追击
	if nil ~= change.actions and nil ~= change.actions.crit and nil ~= change.actions.shanghai then
		audio.playSound(IMG_PATH .. "sound/crit.mp3")
		shakeNode(scene, .1*speed, 1)
	else
		audio.playSound(IMG_PATH .. "sound/atk.mp3")
	end

	effect.get("attack1-3", true):addTo(scene, display.height):pos(self:getPosition())
	for i,v in ipairs(self.sprs) do
		v:setColor(ccc3(255, 0, 0))
		v:runs({
			CCDelayTime:create(.36*speed),
			CCCallFunc:create(function() 
				local color = self:getResumeColor()
				v:setColor(color)
			end)
		})
	end
	
	local config
	config = {
	--移动时间，角度, 偏移x, 偏移y
		{.06, -10, 0, -10}, {.06, -10, -0, 30}, {.06, 5, 5, -5}, {.06, -15, -10, 10}, {.06, 0, 0, 0},
		get = function(idx)
			local d = config[idx][1]*speed
			local r = (1 == self.p.group and 1 or -1)
			return CCSpawn:createWithTwoActions(
				CCRotateTo:create(d, config[idx][2]*r), 
				CCMoveTo:create(d, ccp(self.originPos.x+config[idx][3]*r, self.originPos.y+config[idx][4]*r))
			)
		end
	}
	self:runs({
		config.get(1),
		CCDelayTime:create(.06*speed),
		config.get(2),
		config.get(3),
		config.get(4),
		config.get(5),
		CCCallFunc:create(function()
			self:handleChange(change, attacker)
			self:handleRestrain(attacker)
		end),
		-- CCDelayTime:create(.5*speed),
		CCCallFunc:create(function()
			self:checkDead(func)
		end)
	})
end

--鬼雄攻击
function M:attack2(defencer, change, func)
	local scene = self:getParent()
	local speed = scene.speed
	local config
	config = {
	    --移动时间，透明度, 偏移y
		{.3, 128, -20}, {.06, 128, -10}, {.12, 128, -20}, {.12, 0, -30},
		getMove = function(idx)
			local d = config[idx][1]*speed
			local r = (1 == self.p.group and 1 or -1)
			local arr = CCArray:create()
			arr:addObject(CCMoveTo:create(d, ccp(self.originPos.x, self.originPos.y+config[idx][3]*r)))
			if 0 == config[idx][2] then
				arr:addObject(CCHide:create())
			end
			return CCSequence:create(arr)
		end,
		getFade = function(idx)
			local d = config[idx][1]*speed
			return CCFadeTo:create(d, config[idx][2])
		end
	}
	for i,v in ipairs(self.sprs) do
		v:runs({
			config.getFade(1),
			config.getFade(2),
			config.getFade(3),
			config.getFade(4),
		})
	end
	self:runs({
		config.getMove(1),
		config.getMove(2),
		config.getMove(3),
		CCCallFunc:create(function()
			defencer:byHit2(self, change, function()
				for i,v in ipairs(self.sprs) do
					v:run(CCFadeTo:create(.06*speed, 255))
				end
				self:runs({
					CCShow:create(),
					CCMoveTo:create(.06*speed, ccp(self.originPos.x, self.originPos.y)),
					CCCallFunc:create(func)
				})
			end)
		end),
		config.getMove(4),
	})
end

--被鬼雄攻击
function M:byHit2(attacker, change, func)
	local scene = self:getParent()
	local speed = scene.speed
	
	--暴击和乘胜追击
	if nil ~= change.actions and nil ~= change.actions.crit and nil ~= change.actions.shanghai then
		audio.playSound(IMG_PATH .. "sound/crit.mp3")
		shakeNode(scene, .1*speed, 1)
	else
		audio.playSound(IMG_PATH .. "sound/atk.mp3")
	end

	effect.get("attack2-3", true):addTo(scene, display.height):pos(self:getPosition())
	for i,v in ipairs(self.sprs) do
		v:setColor(ccc3(255, 0, 0))
		v:runs({
			CCDelayTime:create(.36*speed),
			CCCallFunc:create(function() 
				local color = self:getResumeColor()
				v:setColor(color)
			end)
		})
	end
	
	local config
	config = {
	--移动时间，角度, 偏移x, 偏移y
		{.06, 30, 0, 15}, {.06, 30, 15, -20}, {.06, -5, -10, -10}, {.06, 5, 10, -5}, {.06, 0, 0, 0},
		get = function(idx)
			local d = config[idx][1]*speed
			local r = (1 == self.p.group and 1 or -1)
			return CCSpawn:createWithTwoActions(
				CCRotateTo:create(d, config[idx][2]*r), 
				CCMoveTo:create(d, ccp(self.originPos.x+config[idx][3]*r, self.originPos.y+config[idx][4]*r))
			)
		end
	}
	self:runs({
		config.get(1),
		CCDelayTime:create(.06*speed),
		config.get(2),
		config.get(3),
		config.get(4),
		config.get(5),
		CCCallFunc:create(function()
			self:handleChange(change, attacker)
			self:handleRestrain(attacker)
		end),
		-- CCDelayTime:create(.5*speed),
		CCCallFunc:create(function()
			self:checkDead(func)
		end)
	})
end

--英豪攻击
function M:attack3(defencer, change, func)
	local scene = self:getParent()
	local speed = scene.speed
	local config
	config = {
	    --角度, 偏移x, 偏移y
		{85, 20, -35},{180, 0, -50},{270, -20, -35},{0, 0, 0},{90, 30, -10},{180, 0, -30},{270, -20, -35},{45, 20, 0},{0, 0, -40},
		get = function(idx)
			local d = .03*speed
			local r = (1 == self.p.group and 1 or -1)
			return CCSpawn:createWithTwoActions(
				CCRotateTo:create(d, 360-config[idx][1]), 
				CCMoveTo:create(d, ccp(defencer.originPos.x+config[idx][2]*r, defencer.originPos.y+config[idx][3]*r))
			)
		end
	}
	local r = (1 == self.p.group and 1 or -1)
	self:runs({
		CCMoveTo:create(.12*speed, ccp(self.originPos.x, self.originPos.y+(-40)*r)),
		CCMoveTo:create(.18*speed, ccp(self.originPos.x, defencer.originPos.y+(-40)*r)),
		config.get(1),
		config.get(2),
		config.get(3),
		config.get(4),
		config.get(5),
		config.get(6),
		CCCallFunc:create(function()
			defencer:byHit3(self, change, func)
		end),
		config.get(7),
		config.get(8),
		config.get(9),
		CCMoveTo:create(.12*speed, ccp(self.originPos.x, self.originPos.y+(-40)*r)),
		CCMoveTo:create(.12*speed, ccp(self.originPos.x, self.originPos.y)),
	})
end

--被英豪攻击
function M:byHit3(attacker, change, func)
	local scene = self:getParent()
	local speed = scene.speed

	--暴击和乘胜追击
	if nil ~= change.actions and nil ~= change.actions.crit and nil ~= change.actions.shanghai then
		audio.playSound(IMG_PATH .. "sound/crit.mp3")
		shakeNode(scene, .1*speed, 1)
	else
		audio.playSound(IMG_PATH .. "sound/atk.mp3")
	end

	effect.get("attack3-3", true):addTo(scene, display.height):pos(self:getPosition())
	for i,v in ipairs(self.sprs) do
		v:setColor(ccc3(255, 0, 0))
		v:runs({
			CCDelayTime:create(.36*speed),
			CCCallFunc:create(function() 
				local color = self:getResumeColor()
				v:setColor(color)
			end)
		})
	end
	
	local config
	config = {
	--移动时间，角度, 偏移x, 偏移y
		{.06, 345, 20, 0}, {.06, 5, 10, 30}, {.06, 350, -5, -10}, {.06, 5, 10, 0}, {.06, 0, 0, 0},
		get = function(idx)
			local d = config[idx][1]*speed
			local r = (1 == self.p.group and 1 or -1)
			return CCSpawn:createWithTwoActions(
				CCRotateTo:create(d, 360-config[idx][2]), 
				CCMoveTo:create(d, ccp(self.originPos.x+config[idx][3]*r, self.originPos.y+config[idx][4]*r))
			)
		end
	}
	self:runs({
		config.get(1),
		CCDelayTime:create(.06*speed),
		config.get(2),
		config.get(3),
		config.get(4),
		config.get(5),
		CCCallFunc:create(function()
			self:handleChange(change, attacker)
			self:handleRestrain(attacker)
		end),
		-- CCDelayTime:create(.5*speed),
		CCCallFunc:create(function()
			self:checkDead(func)
		end)
	})
end

function M:attack(defencer, change, func)
	if self.data.role < 1 or self.data.role > 3 then self.data.role = 1 end
	self.attacking = true
	self["attack" ..self.data.role](self, defencer, change, function() 
		self.attacking = false
		func()
	end)
end

function M:skill1(func, skillid)
	local scene = self:getParent()
	local speed = scene.speed
	local isSelf = 1 == self.p.group
	local ofsy = isSelf and -80 or 80
	local color
	color = CCNodeExtend.extend(CCLayerColor:create(ccc4(0, 0, 0, 55)))
		:addTo(scene, display.height-1)
		:size(display.width, display.height-1)
		:runs({
			CCFadeTo:create(.35*speed, 128),
			CCCallFunc:create(function() 
				local texts = def.getSkillTexts(skillid, effect, self.data._group)
				for i,v in ipairs(texts) do
					CCSpriteExtend.extend(CCSprite:createWithSpriteFrame(v)):addTo(color)
						:pos(isSelf and 80 or display.width-80, display.cy-(i-1)*80)
						:opacity(0)
						:fadeIn(.3*speed)
				end
			end),
		})
		:add(display.newSprite(def.image .."skill1bg.png", isSelf and 0 or display.width, display.cy+ofsy)
			:runs({
				CCMoveTo:create(1.2*speed, ccp(isSelf and display.width or 0, display.cy+ofsy)),
				CCFadeOut:create(.24*speed),
				CCCallFunc:create(function() 
					color:removeSelf() 
					func()
				end)
			}))
		:add(display.newSprite(self.bigpic):anchor(isSelf and 1 or 0, .5):pos(isSelf and 0 or display.width, display.cy+ofsy)
			:runs({
				CCMoveTo:create(.06*14*speed, ccp(isSelf and display.width or 0, display.cy+ofsy)),
				CCDelayTime:create(.06*6*speed),
				CCFadeOut:create(.24*speed),
			}))
end


function M:skill2(func, skillid)
	local scene = self:getParent()
	local speed = scene.speed
	for i,v in ipairs(self.sprs) do
		v:runs({
			CCDelayTime:create(.5*speed),
			CCFadeOut:create(.3*speed)
		})
	end
	self:runs({
		CCScaleTo:create(.5*speed, 2),
		CCDelayTime:create(.3*speed),
		CCHide:create(),
		CCCallFunc:create(function() 
			local texts = def.getSkillTexts(skillid, effect, self.data._group)
			local text_sprs = {}
			local function play(idx)
				if idx > #texts then
					self:runs({
						CCDelayTime:create(.5*speed),
						CCShow:create(),
						CCCallFunc:create(function() 
							for i,v in ipairs(self.sprs) do
								v:run(CCFadeIn:create(.5*speed))
							end
							for i,v in ipairs(text_sprs) do
								v:runs({
									CCFadeOut:create(.5*speed),
									CCCallFunc:create(function() v:removeSelf() end)
								})
							end
						end),
						CCScaleTo:create(.5*speed, .8),
						CCScaleTo:create(.1*speed, 1),
						CCCallFunc:create(func)
					})
					return
				end
				text_sprs[#text_sprs+1] = def.playSkillTextEff(display.width/(#texts+1)*(idx), display.cy, texts[idx], scene, scene, effect, function() play(idx+1) end)
			end
			play(1)
		end)
	})
end

function M:skill3(func, skillid)
	local scene = self:getParent()
	local speed = scene.speed
	local r = (1 == self.p.group and 1 or -1)
	effect.get("skillTextBg2", true, function() 
		self:runs({
			CCSpawn:createWithTwoActions(
				CCScaleTo:create(.12*speed, 1.5), 
				CCMoveTo:create(.12*speed, ccp(self.originPos.x, self.originPos.y+20*r))
			),
	    	CCOrbitCamera:create(.3*speed, 1, 0, 0, 180, 0, 0),
	    	CCOrbitCamera:create(.3*speed, 1, 0, 180, 180, 0, 0),
	    	CCCallFunc:create(func),
	    	CCSpawn:createWithTwoActions(
				CCScaleTo:create(.12*speed, 1), 
				CCMoveTo:create(.12*speed, ccp(self.originPos.x, self.originPos.y))
			),
	    })
	end):addTo(scene, display.height-1):center()

    self:runs({
    	CCDelayTime:create(.4),
    	CCCallFunc:create(function()
			local texts = def.getSkillTexts(skillid, effect, self.data._group)
			local w, space = 60, 5
			local count = #texts*(w+space)-space
			for i,v in ipairs(texts) do
				local word
				word = CCSpriteExtend.extend(CCSprite:createWithSpriteFrame(v)):addTo(scene, display.height-1)
					:anchor(0, .5)
					:pos(display.cx-count/2+(i-1)*(w+space), display.cy)
					:opacity(0)
					:runs({
						CCFadeIn:create(.4*speed),
						CCDelayTime:create(.4*speed),
						CCFadeOut:create(.4*speed),
						CCCallFunc:create(function() word:removeSelf() end),
					})
			end
    	end)
    })
end

function M:skill(func, skillid)
	if self.data.role < 1 or self.data.role > 3 then self.data.role = 1 end
	self.attacking = true
	self["skill" ..self.data.role](self, function() 
		self.attacking = false
		func()
	end, skillid)
end

function M:commonByHit(attacker, change, func)
	local scene = self:getParent()
	local speed = scene.speed

	for i,v in ipairs(self.sprs) do
		v:setColor(ccc3(255, 0, 0))
		v:runs({
			CCDelayTime:create(.36*speed),
			CCCallFunc:create(function() 
				local color = self:getResumeColor()
				v:run(CCTintTo:create(1, color.r, color.g, color.b))
			end)
		})
	end
	
	local config
	config = {
	--移动时间，角度, 偏移x, 偏移y
		{.06, -10, 0, -10}, {.06, -10, -0, 30}, {.06, 5, 5, -5}, {.06, -15, -10, 10}, {.06, 0, 0, 0},
		get = function(idx)
			local d = config[idx][1]*speed
			local r = (1 == self.p.group and 1 or -1)
			return CCSpawn:createWithTwoActions(
				CCRotateTo:create(d, config[idx][2]*r), 
				CCMoveTo:create(d, ccp(self.originPos.x+config[idx][3]*r, self.originPos.y+config[idx][4]*r))
			)
		end
	}
	self:runs({
		config.get(1),
		CCDelayTime:create(.06*speed),
		config.get(2),
		config.get(3),
		config.get(4),
		config.get(5),
		CCCallFunc:create(function()
			self:handleChange(change, attacker)
			if attacker then self:handleRestrain(attacker) end
		end),
		CCDelayTime:create(.3*speed),
		CCCallFunc:create(function()
			self:checkDead(func)
		end)
	})
	return .7*speed
end

function M:bySkillHit(attacker, change, func)
	return self:commonByHit(attacker, change, func)
end

function M:byPetHit(data, change, status, isDebuff, func)
	local scene = self:getParent()
	local speed = scene.speed

	if isDebuff then--释放成功
		if status and 1 == tonumber(status.is_ignore) then--挡住了
			effect.get2(def.oldimage .."pet/resist.png", 6, 1, .1*speed, true):addTo(self)
			self:handleChange(change)
		else
			self:addBuf(data.type)
			self:handlePetSkillText(data)
			return self:commonByHit(nil, change, func)
		end
	else--释放失败
		self:handlePetSkillFaild(data.type)
		self:handleChange(change)
	end
	scheduler.performWithDelayGlobal(func, .3*speed)
	return .3*speed
end

function M:byBufHit(type, change, func)
	return self:commonByHit(nil, change, func)
end

function M:checkDead(func)
	if self.hp.cur <= 0 then
		local scene = self:getParent()
		local speed = scene.speed
		if 2 == self.p.group and scene.boss and scene.boss.boss_cid == (self.data.cid or self.data.npc_id) then--切牌
			self.cutting = true
			cut.new(scene, self, function() 
				self:hide()
				self.cutting = false
				func()
			end):addTo(scene, display.height)
		else
			for i,v in ipairs(self.sprs) do
				v:runs({
					CCFadeOut:create(.3*speed)
				})
			end
			self:runs({
				CCDelayTime:create(.3*speed),
				CCHide:create(),
				CCCallFunc:create(function() if func then func() end end)
			})		
		end
	else
		if func then func() end
	end
end

return M
