--[[
	step 公共函数
]]
local M = {}

function M.getChange(role, change)
	for i,v in ipairs(change) do
		if v.group == role.p.group and v.index+1 == role.p.index then
			return v
		end
	end
	return nil
end

function M.getStatus(role, status)
	for i,v in ipairs(status) do
		if v.group == role.p.group and v.index+1 == role.p.index then
			return v
		end
	end
	return nil
end

function M.handlePetSkill(scene, data, func, bufType)
	for i,v in ipairs(data.keep) do
		local defencer = scene:getRole(v.group, v.index)
		if defencer then
			defencer:removeBuf(bufType)
		end
	end

	if not data.change then
		func()
		return
	end

	local cur = #data.change
	local byHitFuncEnd = function()
		cur = cur-1
		if 0 == cur then func() end
	end
	for i,v in ipairs(data.change) do
		local defencer = scene:getRole(v.group, v.index)
		if defencer then
			defencer:byBufHit(bufType, M.getChange(defencer, data.change), byHitFuncEnd)
		else
			cur = cur-1
		end
	end
	if 0 == cur then func() end
end

return M