local skill = requires(IMG_PATH, "GameLuaScript/Config/Skill")
local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local effect = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/effect")
local comm = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/step/aaa_comm")
local M = {}

function M.launch(scene, data, func)
	--攻击者
	local attacker = scene:getRole(data.atk[1].group, data.atk[1].index)
	local skillData = skill["" ..data.skill_cid]

	local isOtherGame = getIsOtherGame(attacker.data._group)
	local eff, useOld
	if CHANNEL_GROUP == "tmsj" and (not isOtherGame or isOtherGame == "tmsj") then--不是神战，或者神战是唐门世界的一方才用新技能
		eff = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/eff")
		skillData.effect_id = skillData.effect_id2
	else
		eff = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/eff_old")
		useOld = true
	end

	--test---------------------------------------------------------
	-- local ids = {3906}
	-- local tmpid = ids[math.random(#ids)] ..""
	-- skillData.effect_id = tmpid
	---------------------------------------------------------

	--特效数据
	local effData = eff["" ..skillData.effect_id]
	if not effData then--配置表漏了
		print("effData notExist:" ..skillData.effect_id)
		skillData.effect_id = useOld and "3031" or "3001"
		effData = eff[skillData.effect_id]
	end
	effData.useOld = useOld

	--神技能
	local godSkill = nil

	--技能释放完毕
	local showEnd = function()
		if godSkill then
			for i,v in ipairs(godSkill.sprs) do
				v:fadeOut(.1*scene.speed)
			end
			godSkill.bg:runs({
				CCDelayTime:create(.1*scene.speed),
				CCCallFunc:create(function() 
					godSkill.bg:removeSelf()
					godSkill = nil
					func()
				end)
			})
		else
			func()
		end
	end

	--受击
	local showHit = function()
		local roles = {}
		for i,v in ipairs(data.be_atk) do
			local defencer = scene:getRole(v.group, v.index)
			if defencer then
				roles[#roles+1] = defencer
			end
		end
		local byHit = function()
			local hitTime = 0
			for i,v in ipairs(roles) do
				hitTime = v:bySkillHit(attacker, comm.getChange(v, data.change), 1==i and showEnd or nil)
			end
			-- scheduler.performWithDelayGlobal(showEnd, hitTime)
		end
		if effData.useOld then
			local group = attacker.p.group == 1 and 2 or 1
			for i,v in ipairs(roles) do
				local x, y = v.originPos.x, v.originPos.y
				if effData.ofsx then
					x = x + effData.ofsx
				end
				if effData.ofsy then
					y = y + effData.ofsy
				end
				effect.get2(def.oldimage .."skillAction/" ..skillData.effect_id ..".png", effData.cnt, effData.line, .15, true):addTo(scene, display.height):pos(x, y)
			end
			byHit()
		elseif def.hit.none ~= effData.hit then
			local dur = 0
			if def.hit.self == effData.hit then
				local group = attacker.p.group == 1 and 2 or 1
				for i,v in ipairs(roles) do
					local x, y = v.originPos.x, v.originPos.y
					local sprite = effect.get(skillData.effect_id .."-3", true):addTo(scene, display.height):pos(x, y)

					if tostring(skillData.effect_id) == "3017" then
						sprite:flipY(1 == attacker.p.group)		
					end
				end
				byHit()
			elseif def.hit.multi == effData.hit then
				local space = .15*scene*speed
				local group = attacker.p.group == 1 and 2 or 1
				for i=1,4 do
					local x, y = def.getPos(group, i)
					scheduler.performWithDelayGlobal(function() 
						effect.get(skillData.effect_id .."-3", true):addTo(scene, display.height):pos(x, y)
					end, (i-1)*space)
				end
				scheduler.performWithDelayGlobal(byHit, 4*space)
			elseif def.hit.center == effData.hit then
				local group = attacker.p.group == 1 and 2 or 1
				local pos = def.centerPos[group]
				local sprite, time = effect.get(skillData.effect_id .."-3", true)
				sprite:pos(pos[1], pos[2]):addTo(scene, display.height)
				scheduler.performWithDelayGlobal(byHit, time)

				if tostring(skillData.effect_id) == "3011" then
					if 1 == attacker.p.group then 
						sprite:flipY(true):pos(pos[1], pos[2]+80)
					end
				end
			end
			-- --震动
			-- scheduler.performWithDelayGlobal(function()
			-- 	shakeNode(scene, .5, 10)
			-- 	for i=1,2 do for j=1,4 do
			-- 	    local role = scene.roles[i][j]
			-- 	    if role and role:isVisible() then
			-- 			shakeNode2(role, .03)
			-- 	    end
			--     end end
			--     if scene.pet[1] then shakeNode2(scene.pet[1], .03) end
			--     if scene.pet[2] then shakeNode2(scene.pet[2], .03) end
			-- end, dur)
		else
			byHit()
		end
	end

	--轨迹
	local showLocusFunc = function()
		if effData.useOld then--使用旧技能
			local nodes = {}
	        local time = 0
	        local speed = 1500
	        local endFunc = function() 
	            for i,v in ipairs(nodes) do
	                v:removeSelf()
	            end
	            showHit()
	        end
			local srcPos, path, frameCnt
			if godSkill then
				srcPos, path, frameCnt = godSkill.pos, def.oldimage .."heroAction/skill_attack_god.png", 7
			else
				srcPos, path, frameCnt = ccp(attacker:getPosition()), def.oldimage .."heroAction/skill_attack.png", 5
			end
	 		local x, y = srcPos.x, srcPos.y
			for i,v in ipairs(data.be_atk) do
				local defencer = scene:getRole(v.group, v.index)
				if defencer then
					local flyTime = ccpDistance(ccp(x, y), ccp(defencer:getPosition()))/speed
					time = math.max(time, flyTime)*scene.speed
					nodes[#nodes+1] = effect.get2(path, frameCnt, 1, .15)
						:pos(x, y)
						:moveTo(flyTime, defencer:getPosition())
						:addTo(scene, display.height)
					local pi = 3.14
					local angle = math.atan((defencer:getPositionY()-y)/(x-defencer:getPositionX()))
					angle = 270+180/pi*angle
					if defencer:getPositionX() > x then
						angle = angle + 180
					end
					nodes[#nodes]:rotation(angle)
								 :pos(x, y+40)
				end
			end
			scheduler.performWithDelayGlobal(endFunc, time)
		elseif def.locus.none ==  effData.locus then--无
			showHit()
		elseif def.locus.move3 ==  effData.locus then--平移＋旋转+不循环播放+轨迹时间为播放时间+坐标为（x是人物坐标， y是display.cy）
	        local time
			for i,v in ipairs(data.be_atk) do
				local defencer = scene:getRole(v.group, v.index)
				if defencer then
					local x, y = defencer:getPositionX(), display.cy
					local spr
					spr, time = effect.get(skillData.effect_id .."-2", true)
					spr:addTo(scene, display.height):pos(x, y):moveTo(time, defencer:getPosition())
					local pi = 3.14
					local angle = math.atan((defencer:getPositionY()-y)/(x-defencer:getPositionX()))
					angle = 180+180/pi*angle
					if defencer:getPositionX() > x then
						angle = angle + 180
					end
					spr:rotation(angle):pos(x, y+40)
				end
			end
			scheduler.performWithDelayGlobal(showHit, time)
		else
			local nodes = {}
	        local time = 0
	        local speed = 2000
	        local endFunc = function() 
	            for i,v in ipairs(nodes) do
	                v:removeSelf()
	            end
	            showHit()
	        end
			local srcPos = godSkill and godSkill.pos or ccp(attacker:getPosition())
	 		local x, y = srcPos.x, srcPos.y
	 		if def.locus.center2dest ==  effData.locus then
	 			x, y = display.cx, display.cy
	 		end
			for i,v in ipairs(data.be_atk) do
				local defencer = scene:getRole(v.group, v.index)
				if defencer then
					local flyTime = ccpDistance(ccp(x, y), ccp(defencer:getPosition()))/speed
					time = math.max(time, flyTime)*scene.speed
					nodes[#nodes+1] = effect.get(skillData.effect_id .."-2")
						:pos(x, y)
						:moveTo(flyTime, defencer:getPosition())
						:addTo(scene, display.height)
					if def.locus.move1 ~=  effData.locus then
						local pi = 3.14
						local angle = math.atan((defencer:getPositionY()-y)/(x-defencer:getPositionX()))
						angle = 180+180/pi*angle
						if defencer:getPositionX() > x then
							angle = angle + 180
						end
						nodes[#nodes]:rotation(angle)
									 :pos(x, y+40)
					end
				end
			end
			scheduler.performWithDelayGlobal(endFunc, time)
		end
	end

	--显示施放
	local showFire = function()
		if skillData.useOld then
			showLocusFunc()
			return
		end
		if skillData.star > 3 then
			audio.playSound(IMG_PATH .. "sound/atk_skill.mp3")
		else
			audio.playSound(IMG_PATH .. "sound/small_atk_skill.mp3")
		end
		local srcPos = godSkill and godSkill.pos or ccp(attacker:getPosition())
		if def.fire.none == effData.fire then--无
			showLocusFunc()
		elseif def.fire.self == effData.fire then--攻击者自身播放
			effect.get(skillData.effect_id .."-1", true, function()
				showLocusFunc()
			end):addTo(scene, display.height):pos(srcPos.x, srcPos.y)
		elseif def.fire.up2center == effData.fire then--垂直向中心点发射
			local spr, dur = effect.get(skillData.effect_id .."-1", true, function()
				showLocusFunc()
			end)
			spr:addTo(scene, display.height):pos(srcPos.x, srcPos.y):moveTo(dur, display.cx, display.cy)
		elseif def.fire.up2top == effData.fire then--垂直向天发射
			local spr, dur = effect.get(skillData.effect_id .."-1", true, function()
				showLocusFunc()
			end)
			spr:addTo(scene, display.height):pos(srcPos.x, srcPos.y):moveTo(dur, srcPos.x, srcPos.y+display.height)
		elseif def.fire.center == effData.fire then--中心点播放
			effect.get(skillData.effect_id .."-1", true, function()
				showLocusFunc()
			end):addTo(scene, display.height):pos(display.cx, display.cy)
		elseif def.fire.centery_and_flipy == effData.fire then--y为中心点, x为自己坐标, 并且镜像
			effect.get(skillData.effect_id .."-1", true, function()
				showLocusFunc()
			end):addTo(scene, display.height):pos(srcPos.x, display.cy):rotation(attacker.p.group==1 and 0 or 180)
		elseif def.fire.center_and_fadeout == effData.fire then--中心点播放+渐变消失
			local spr
			spr = effect.get(skillData.effect_id .."-1"):addTo(scene, display.height):pos(display.cx, display.cy)
				:scale(1)
				:opacity(0)
				:runs({
					CCScaleTo:create(.5*scene.speed, 1.3),
					CCCallFunc:create(function() 
						spr:removeSelf()
						showLocusFunc()
					end)
				})
				:runs({
					CCFadeIn:create(.15*scene.speed),
					CCDelayTime:create(.2*scene.speed),
					CCFadeOut:create(.15*scene.speed)
				})
		else
			showLocusFunc()
		end
	end

	--显示神技能
	local showGodSkill = function()
		local speed = scene.speed
		local isSelf = 1 == attacker.p.group
		local ofsy = isSelf and -80 or 80
		local function show() 
			godSkill = {
				bg = CCNodeExtend.extend(CCLayerColor:create(ccc4(0, 0, 0, 55))):size(display.width, display.height):addTo(scene, display.height),
				pos = ccp(display.cx, isSelf and 300 or 600),
				sprs = {}
			}
			attacker:runs({
				CCMoveTo:create(.4*speed, godSkill.pos),
				CCDelayTime:create(.12*speed),
				CCHide:create(),
			})
			scheduler.performWithDelayGlobal(function() 
				godSkill.sprs[1] = display.newSprite(attacker.bigpic, godSkill.pos.x, godSkill.pos.y):addTo(godSkill.bg)
					:opacity(0)
					:scale(.3)
					:fadeIn(.4*speed)
					:runs({
						CCScaleTo:create(.5*speed, 1.2),
						CCScaleTo:create(.1*speed, 1),
						CCCallFunc:create(function()
							attacker:show():pos(attacker.originPos.x, attacker.originPos.y)

							local seq = CCSequence:createWithTwoActions(CCMoveBy:create(.5*speed, ccp(0, -20)), CCMoveBy:create(.5*speed, ccp(0, 20)))
							godSkill.sprs[1]:run(CCRepeatForever:create(tolua.cast(seq, "CCActionInterval")))

							local texts = def.getSkillTexts(data.skill_cid, effect, attacker.data._group)
							local function play(idx)
								if idx > #texts then
									showFire()
									return
								end
								godSkill.sprs[#godSkill.sprs+1] = def.playSkillTextEff(isSelf and 80 or display.width-80, display.cy+110-(idx-2)*80, texts[idx], scene, godSkill.bg, effect, function() play(idx+1) end)
							end
							play(1)
						end)
					})
			end, .2)
		end
		local color
		color = CCNodeExtend.extend(CCLayerColor:create(ccc4(0, 0, 0, 55)))
			:addTo(scene, display.height-1)
			:size(display.width, display.height-1)
			:fadeTo(.35*speed, 128)
			:add(display.newSprite(def.oldimage .."heroSkill/god_bg.png", isSelf and 0 or display.width, display.cy+ofsy)
				:runs({
					CCMoveTo:create(1.2*speed, ccp(isSelf and display.width or 0, display.cy+ofsy)),
					CCFadeOut:create(.24*speed),
					CCCallFunc:create(function() 
						color:removeSelf() 
						show()
					end)
				}))
			:add(effect.get({"dragon", def.oldimage .."heroSkill/dragon"}):pos(display.cx, display.cy+ofsy))
			:add(display.newSprite(attacker.bigpic):anchor(isSelf and 1 or 0, .5):pos(isSelf and 0 or display.width, display.cy+ofsy)
				:runs({
					CCMoveTo:create(.06*14*speed, ccp(isSelf and display.width or 0, display.cy+ofsy)),
					CCDelayTime:create(.06*6*speed),
					CCFadeOut:create(.24*speed),
				}))
	end

	if 1 == skillData.isgod then--神技能
		showGodSkill()
	else
		attacker:skill(showFire, data.skill_cid)
	end

end

return M