local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local role = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/role")
local hero = requires(IMG_PATH, "GameLuaScript/Config/Hero")
local npc = requires(IMG_PATH, "GameLuaScript/Config/Npc")
local M = {}

function M.launch(scene, data, func)
	if scene.index.round ~= 1 then
		M.update(scene, data, func)
		return
	end

	--神脉, 龙
	local function show(filename, x, y)
		display.newSprite(def.oldimage .."dragon/" ..filename .."_bg_flag.png", x, y):addTo(scene)
		display.newSprite(def.oldimage .."dragon/" ..filename .."_flag.png", x, y):addTo(scene, display.height-1)
	end
	local prepare_data = scene.report.prepare
	if def.debug or (prepare_data.lm_uid_1 and ( tonumber( prepare_data.lm_uid_1 ) ~= 0 )) then
		time = show("down", display.cx-20, 230)
	end
	if def.debug or (prepare_data.lm_uid_2 and ( tonumber( prepare_data.lm_uid_2 ) ~= 0 )) then
		time = show("up", display.cx, 640)
	end

	--宠物怒气
	scene.pet_sp = {0, 0}
	local roles = {}

	--人物
	local both = {data.p1, data.p2}
	for i,v in ipairs(both) do
		for i2,v2 in ipairs(v) do
			scene.roles[v2._group][v2._index+1] = role.new(v2):addTo(scene)
			roles[#roles+1] = scene.roles[v2._group][v2._index+1]
			if 1 == i then
				scene.agile.self = scene.agile.self+v2.agi
			else
				scene.agile.target = scene.agile.target+v2.agi
			end
		end
	end

	--随机时间出生
	local space = .2
	local delays = {}
	for i=1,#roles do
		delays[#delays+1] = space*(i-1)
	end

	-- 出生
	for i,v in ipairs(roles) do
		local index = math.random(#delays)
		scheduler.performWithDelayGlobal(handler(v, v.born), delays[index])
		table.remove(delays, index)
	end

	--替补
	both = {data.p1_back, data.p2_back}
	for i,v in ipairs(both) do
		scene.ui:initBacks(i, v)
		for i2,v2 in ipairs(v) do
			if 1 == i then
				scene.agile.self = scene.agile.self+v2.agi
			else
				scene.agile.target = scene.agile.target+v2.agi
			end
		end
	end


	--额外加成的敏捷
	if scene.report.other then
		local addition_agi_1 = scene.report.other.addition_agi_1 or 0
		local addition_agi_2 = scene.report.other.addition_agi_2 or 0
		scene.agile.self = scene.agile.self+addition_agi_1
		scene.agile.target = scene.agile.target+addition_agi_2
	end

	--对话
	local showTalk = function()
		-- if def.debug then
			func()
			-- return
		-- end
	-- 	local talks = scene.report.prepare.talk

	-- 	if (not talks) or 0 == table.nums(talks) then
	-- 		func()
	-- 		return
	-- 	end
	-- 	talks = talks.start

	-- 	local i = 1
	-- 	-- local j = 1
	-- 	local say
	-- 	say = function()
	-- 		if i > table.nums(talks) then
	-- 			func()
	-- 			return
	-- 		end
	-- 		-- if j > #talks[i] then
	-- 		-- 	i = i + 1
	-- 		-- 	j = 1
	-- 		-- 	say()
	-- 		-- 	return
	-- 		-- end
	-- 		local talk = talks[i]
	-- 		local offset = talk.who == 0 and -200 or 200
	-- 		local frame = display.newSprite(def.image .."talk.png")
	-- 			:pos(display.cx, display.cy+offset)
	-- 			:addTo(scene, display.height)
	-- 		display.strokeLabel(talk.str, 20, 60, 20, display.COLOR_WHITE, nil, nil, {
	-- 			dimensions_width = 270,
	-- 			dimensions_height = 160,
	-- 		})
	-- 		:anchor(0, 1)
	-- 		:pos(frame:getContentSize().width/2, frame:getContentSize().height - 30)
	-- 		:addTo(frame)
	-- 		:runs({
	-- 			CCDelayTime:create(5),
	-- 			CCCallFunc:create(function()
	-- 				frame:removeSelf()
	-- 				say()
	-- 			end),
	-- 		})
	-- 		if talk.who == "songjiang2" then
	-- 			display.newSprite(def.image .."songjiang2.png"):anchor(0, 0):addTo(frame)
	-- 		else 
	-- 			local getpicid = function(data)
	-- 				local pic_id
	-- 				if data.cid then
	-- 					pic_id = hero[tostring(data.cid)].logo_id
	-- 				else
	-- 					pic_id = npc[tostring(data.npc_id)].logo_id
	-- 				end
	-- 				return pic_id
	-- 			end
	-- 			local filename
	-- 			if talk.who > 0 then
	-- 				filename = "image/hero/b_general" ..talk.who ..".png"
	-- 			elseif -1 == talk.who then
	-- 				filename = "image/hero/b_general" ..getpicid(data.p2[1]) ..".png"
	-- 			elseif 0 == talk.who then
	-- 				filename = "image/hero/b_general" ..getpicid(data.p1[1]) ..".png"
	-- 			end
	-- 			local sprite = display.newSprite(filename, 0, 5):anchor(0,0):scale(.7):addTo(frame)
	-- 			sprite:setTextureRect(CCRect(0,0,sprite:getContentSize().width,sprite:getContentSize().height*.7))
	-- 		end
	-- 		-- j = j + 1
	-- 		i = i + 1
	-- 	end
	-- 	say()
	end

	scene.foeAgent = data.p2[1].cid or data.p2[1].npc_id
	scene.backs = {data.p1_back or {}, data.p2_back or {}}
	scheduler.performWithDelayGlobal(showTalk, #roles*space)
end


function M.update(scene, data, func)
	--人物
	for i=1,2 do for j=1,4 do
    	local role = scene.roles[i][j]
    	if role then
    		role:removeSelf()
    	end
    end end

	scene.roles = {{},{}}
	local both = {data.p1, data.p2}
	for i,v in ipairs(both) do
		for i2,v2 in ipairs(v) do
			scene.roles[v2._group][v2._index+1] = role.new(v2):addTo(scene):show()
		end
	end

	--替补
	for i=1,2 do
		for j=1,4 do
			scene.ui:removeBack(i, j)
		end
	end

	both = {data.p1_back, data.p2_back}
	for i,v in ipairs(both) do
		scene.ui:initBacks(i, v)
	end
	scene.backs = {data.p1_back or {}, data.p2_back or {}}

	--end
	func()
end

return M