local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local effect = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/effect")
local comm = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/step/aaa_comm")
local M = {}

function M.launch(scene, data, func)
	if def.debug then
		data.cid = 2503
	end

	local speed = scene.speed
	local r = (1 == data.group and 1 or -1)
	local x, y = display.cx, display.cy-100*r

	local function showHit()
		audio.playSound(IMG_PATH .. "sound/pet_skill_atk.mp3")
		local hitTime = 0
		local first = true
		for i,v in ipairs(data.change) do
			local defencer = scene:getRole(v.group, v.index)
			if defencer then
				local isDebuff = 1 == tonumber(data.is_debuff)
				local status
				if isDebuff then
					status = comm.getStatus(defencer, data.status)
				end
				hitTime = defencer:byPetHit(data, comm.getChange(defencer, data.change), status, isDebuff, first and func or nil)
				first = false
			end
		end
		-- scheduler.performWithDelayGlobal(func, hitTime)
	end

	local function showLocusFunc()
		local nodes = {}
        local time = 0
        local flySpeed = 500
        local endFunc = function() 
            for i,v in ipairs(nodes) do
                v:removeSelf()
            end
            showHit()
        end

		for i,v in ipairs(data.change) do
			local defencer = scene:getRole(v.group, v.index)
			if defencer then
				local flyTime = ccpDistance(ccp(x, y), ccp(defencer:getPosition()))/flySpeed*speed
				time = math.max(time, flyTime)
				nodes[#nodes+1] = effect.get("pet-2")
					:pos(x, y)
					:moveTo(flyTime, defencer:getPosition())
					:addTo(scene, display.height)
			end
		end
		scheduler.performWithDelayGlobal(endFunc, time)
	end
	
	local pet
	pet = display.newSprite(IMG_PATH .."image/pet/b_" ..scene.report.prepare["p" ..data.group .."_pet"].cid ..".png", x, y):addTo(scene, display.height)
		:opacity(0):scale(.01)
		:runs({
			CCSpawn:createWithTwoActions(
				CCFadeIn:create(.3*speed),
				CCScaleTo:create(.3*speed, 1)
			),
			CCCallFunc:create(function()
				audio.playSound(IMG_PATH .. "sound/pet_skill_start.mp3") 
				effect.get("pet-0", true, function() 
					effect.get("pet-1", true):addTo(pet):pos(pet:getw()/2, pet:geth()/2)
					pet:runs({
						CCDelayTime:create(.12*speed),
						CCMoveTo:create(.12*speed, ccp(x-10, y-10)),
						CCMoveTo:create(.12*speed, ccp(x, y)),
						CCMoveTo:create(.12*speed, ccp(x-10, y)),
						CCMoveTo:create(.12*speed, ccp(x, y)),
						CCCallFunc:create(showLocusFunc),
						CCFadeOut:create(.36*speed),
						CCCallFunc:create(function()
							pet:removeSelf()
						end)
					})
				end):addTo(pet):pos(pet:getw()/2, pet:geth()/2)
			end),
		})
end

return M