local def = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/def")
local effect = requires(IMG_PATH, "GameLuaScript/Scene/battleNew/effect")
local M = {}

function M.launch(scene, data, func)
	--显示轮数
	local showTurn = function()
		local layer = display.newLayer():pos(-display.width, 0):addTo(scene, display.height)
		display.newSprite(def.oldimage .."turn/turn_bg.png", display.cx, display.cy):addTo(layer)
		display.newSprite(def.oldimage .."turn/turn" ..math.min(3, data.turn) ..".png", display.cx, display.cy):addTo(layer)
		layer:runs({
			CCMoveTo:create(.1*scene.speed, ccp(-25, 0)),
			CCMoveTo:create(1*scene.speed, ccp(25, 0)),
			CCMoveTo:create(.1*scene.speed, ccp(display.width, 0)),
			CCCallFunc:create(function()
				layer:removeSelf()
				func()
			end)
		})
	end
	--vs\显示敏捷\先手后手
	local showAgile = function()
		if 1 ~= data.turn then
			showTurn()
			return
		else
			scheduler.performWithDelayGlobal(showTurn, 1.5*scene.speed)
		end
		--vs
		effect.get("vs", true):addTo(scene, display.height-1):center()
		--敏捷
		scheduler.performWithDelayGlobal(function()
			local show = function(value , add_value, x, y)
				local spr
				spr = display.newSprite(def.image .."text_agile.png", x, y):addTo(scene, display.height-1):opacity(0)
				:runs({
					CCFadeIn:create(.2*scene.speed),
					CCDelayTime:create(.8*scene.speed),
					CCFadeOut:create(.2*scene.speed),
					CCCallFunc:create(function() spr:removeSelf() end)
				})
				local agi_node = CCNodeExtend.extend(CCLabelAtlas:create(tostring(value), def.image .. "num2.png", 24, 30, string.byte('0')))
				agi_node:anchor(0, .5):pos(spr:getContentSize().width, spr:getContentSize().height/2):addTo(spr):opacity(0)
					:runs({
						CCFadeIn:create(.2*scene.speed),
						CCDelayTime:create(.8*scene.speed),
						CCFadeOut:create(.2*scene.speed),
					})
					
				if add_value and tonumber(add_value) > 0 then 
					local addLabel = createLabel({str = "(+"..add_value..")", size = 24, width = 400,x = agi_node:getContentSize().width , y = 0, color = ccc3(236,169,37)})
					agi_node:addChild(addLabel)
				end

			end

			local addition_agi_1 = DATA_Battle:get("report")["other"].addition_agi_1 or 0
			local addition_agi_2 = DATA_Battle:get("report")["other"].addition_agi_2 or 0

			show(scene.agile.self, addition_agi_1 , 200, 310)
			show(scene.agile.target, addition_agi_2 , 70, 540)
		end, .2*scene.speed)
		--先手/后手
		scheduler.performWithDelayGlobal(function()
			local show = function(file, offset, time)
				local sprite
				sprite = display.newSprite(def.image ..file, display.cx+15, display.cy+offset*3)
					:addTo(scene, display.height)
					:scale(3)
					:runs({
						CCSpawn:createWithTwoActions(CCMoveTo:create(.2*scene.speed, ccp(display.cx+15, display.cy+offset)), CCScaleTo:create(.2*scene.speed, 1)),
						CCDelayTime:create(time),
						CCFadeOut:create(.2*scene.speed),
						CCCallFunc:create(function() sprite:removeSelf() end),
					})
			end
			show("text_first.png", scene.agile.self >= scene.agile.target and -70 or 70, .4*scene.speed)
			scheduler.performWithDelayGlobal(function()
				show("text_second.png", scene.agile.self < scene.agile.target and -70 or 70, .3*scene.speed)
			end, .1*scene.speed)
		end, .3*scene.speed)
		--震动
		scheduler.performWithDelayGlobal(function()
			-- shakeNode(scene, .1*scene.speed, 1)
		end, .3*scene.speed)
	end

	--显示组合加成
	local showMarkup = function()
		local show = function(y, filename)
			audio.playSound(IMG_PATH .. "sound/atk_skill.mp3")
			effect.get2(def.oldimage .."pet/markup_eff.png", 4, 1, .2, true):addTo(scene, display.height-1):pos(display.cx, y)
			local text
			text = display.newSprite(filename or def.image .."markup_text.png"):addTo(scene, display.height-1):pos(display.cx, y):opacity(0)
				:runs({
					CCFadeIn:create(.5*scene.speed),
					CCDelayTime:create(.5*scene.speed),
					CCFadeOut:create(.2*scene.speed),
					CCCallFunc:create(function() text:removeSelf()end)
				})
			return 1.2*scene.speed
		end
		local time = 0
		if def.debug or (scene.report.prepare.p1_natural and 1 == scene.report.prepare.p1_natural) then
			time = show(170)
		end
		if def.debug or (scene.report.prepare.p2_natural and 1 == scene.report.prepare.p2_natural) then
			time = show(620)
		end
		if def.debug or (1 == scene.report.prepare.uid1_rank) then
			time = show(270, def.oldimage .."first_gang_flag.png")
		end
		if def.debug or (1 == scene.report.prepare.uid2_rank) then
			time = show(720, def.oldimage .."first_gang_flag.png")
		end
		scheduler.performWithDelayGlobal(showAgile, time)
	end

	--显示龙脉加成
	local showLongmai = function()
		local show = function(y)
			audio.playSound(IMG_PATH .. "sound/atk_skill.mp3")	
			effect.get2(def.oldimage .."dragon/5.png", 8, 2, .1, true):addTo(scene, display.height-1):pos(display.cx, y)
			scheduler.performWithDelayGlobal(function()
				effect.get2(def.oldimage .."pet/markup_eff.png", 4, 1, .2, true):addTo(scene, display.height-1):pos(display.cx, y)
				local text
				text = display.newSprite(def.oldimage .."markup_dragon.png"):addTo(scene, display.height-1):pos(display.cx, y):opacity(0)
					:runs({
						CCFadeIn:create(.5*scene.speed),
						CCDelayTime:create(.5*scene.speed),
						CCFadeOut:create(.2*scene.speed),
						CCCallFunc:create(function() text:removeSelf()end)
					})
			end, .5*scene.speed)
			return 1.5*scene.speed
		end
		local time = 0
		local prepare_data = scene.report.prepare
		if def.debug or (prepare_data.lm_uid_1 and ( tonumber( prepare_data.lm_uid_1 ) ~= 0 )) then
			time = show(220)
		end
		if def.debug or (prepare_data.lm_uid_2 and ( tonumber( prepare_data.lm_uid_2 ) ~= 0 )) then
			time = show(670)
		end
		scheduler.performWithDelayGlobal(showMarkup, time)
	end
	if 1 == data.turn then
		showLongmai()
	else
		showTurn()
	end
end

return M