--主界面

local M = {
	contentLayer  --容器层
	
}

local PATH = IMG_PATH .. "image/scene/bloodTrial/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")



function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	--dump(args)

	-- 基础层
	this.baseLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "bloodTrialLayer" , 0 , { title_text = PATH.."bloodTrialTitle.png", tail_hide = true, closeCallback = function()
		
		if DATA_GodCell:getGodBackFlag() then 
			DATA_GodCell:executeFunc()
		else
			popScene()
		end
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	local tabConfig = {
						"shiLian",
						"jiangLi",						
						"lianSheng",
						"shengChang"
						}
	--tab标签
	local group = KNRadioGroup:new()

	this.contentLayer=this:createShiLian(args)
	this.baseLayer:addChild(this.contentLayer)
	--group:chooseByIndex(1,true)

	for i=1,#tabConfig do
			
			local tempBtn = KNBtn:new( COMMONPATH ,{"tab/tab_star_normal.png","tab/tab_star_select.png"} , 15+(i-1)*95 , 692,{
						    priority = -128,
							disableWhenChoose = true,
							upSelect = true,
							id = i,
							front = {PATH .. tabConfig[i] .."_unselect.png",PATH.. tabConfig[i] .."_select.png"},
							callback=
							function()
								
								if tabConfig[i]=="jiangLi" then
									HTTP:call("trial","getAwardsList",{  } , {
										success_callback = function( data )
												dump(data)
												this.contentLayer=this:createJiangLi(data)
												this.baseLayer:addChild(this.contentLayer)
										end
									})
									
								elseif tabConfig[i] =="shiLian" then
									
									HTTP:call("trial","getInfo",{  } , {
										success_callback = function( data )
												dump(data)
												this.contentLayer=this:createShiLian(data)
												this.baseLayer:addChild(this.contentLayer)
										end
									})								
									
								elseif tabConfig[i] == "lianSheng" then
									
									HTTP:call("trial","getStraightWinList",{  } , {
										success_callback = function( data )
												dump(data)
												this.contentLayer=this:createLianSheng(data)
												this.baseLayer:addChild(this.contentLayer)
										end
									})

								elseif tabConfig[i]	=="shengChang" then
									HTTP:call("trial","getWinList",{  } , {
										success_callback = function( data )
												dump(data)
												this.contentLayer=this:createShengChang(data,1)
												this.baseLayer:addChild(this.contentLayer)
										end
									})

								end

							end
						},group):getLayer()
						
			this.baseLayer:addChild( tempBtn )

	end

	 --分割线
	local lineSp = display.newSprite(COMMONPATH .. "tab_line.png")
	setAnchPos(lineSp,5,690)
	this.baseLayer:addChild( lineSp )


	return this.baseLayer 
end




function M:createJiangLi( jiangLiData )
    
   if self.contentLayer then self.contentLayer:removeFromParentAndCleanup(true) end

    local tempLayer =display.newLayer()

	local tempScrollView = KNScrollView:new(15,102,450,585,8,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
    tempLayer:addChild(tempScrollView:getLayer())
	
    for i=1,#jiangLiData do
    		 local  itemBg = display.newSprite(COMMONPATH .."item_bg.png")
	       	 setAnchPos(itemBg,0,0)
	       	 tempScrollView:addChild(itemBg)

	       	 if jiangLiData[i]["num"] then
		       	 local jiangLiIcon = display.newSprite(PATH.."qiYunIcon.png")
		       	 setAnchPos(jiangLiIcon,26,25)
		       	 itemBg:addChild(jiangLiIcon)
	       	 else
	       	 	 local jiangLiIcon = display.newSprite(PATH.."shenGeIcon.png")
		       	 setAnchPos(jiangLiIcon,26,25)
		       	 itemBg:addChild(jiangLiIcon)
	       	 end
	       	 local jiangLiLab = display.strokeLabel( jiangLiData[i]["award"] , 125 , 65 , 22 ,ccc3(75,30,16) )
	       	 itemBg:addChild(jiangLiLab)

	       	 local jiangLiDesc = display.strokeLabel( jiangLiData[i]["des"] , 125 , 40 , 18 ,ccc3(75,30,16) )
	       	 itemBg:addChild(jiangLiDesc)

	       	 if jiangLiData[i]["num"] then --气运奖励
	       	 	local jingDu = display.strokeLabel( "进度:"..jiangLiData[i]["current"].."/"..jiangLiData[i]["num"] , 125 , 20 , 18 ,ccc3(75,30,16) )
	       		itemBg:addChild(jingDu)
	       	 else--神格奖励
	       	 	local yesterdayRank = display.strokeLabel( "昨日名次:"..jiangLiData[i]["current"], 125 , 20 , 18 ,ccc3(75,30,16) )
	       		itemBg:addChild(yesterdayRank)
	       	 end
	       	 
	       	 if jiangLiData[i]["get"] ==1 then --已领取显示完成

	       	 	 local  doneSp = display.newSprite(PATH .."done.png")
	       		 setAnchPos(doneSp,330,15)
	       	 	 itemBg:addChild(doneSp)
	       	 else
	       	 	local imgName = {"btn_bg.png" , "btn_bg_pre.png"}
	       	 	local isOk = true  --是否已经达到领取条件
	       	 	if jiangLiData[i]["num"] and jiangLiData[i]["num"]>jiangLiData[i]["current"] then --未达到条件
	       	 		
	       	 		imgName={"btn_bg_grey.png"}
	       	 		isOk=false

	       	 	elseif jiangLiData[i]["rank"]  then

	       	 		local  currentType = type(jiangLiData[i]["current"])
	       	 		
	       	 		if currentType=="number" then
	       	 			if jiangLiData[i]["rank"]<jiangLiData[i]["current"] then
			       	 		imgName={"btn_bg_grey.png"}
			       	 		isOk=false
		       	 		end
	       	 		elseif currentType=="string" then  --1000名以外
	       	 			imgName={"btn_bg_grey.png"}
	       	 			isOk=false
	       	 		end	
	       	 	 	
	       	 	end
	       	 	local getBtn = KNBtn:new(COMMONPATH, imgName, 345, 30 , {
						priority = -131 , 
						front= COMMONPATH.."get.png",
						callback = function()
								if isOk then--领奖
									HTTP:call("trial","receiveAward",{ aid = jiangLiData[i]['aid']} , {
										success_callback = function( data )
												
												KNMsg:getInstance():flashShow( data['msg'])

												HTTP:call("trial","getAwardsList",{  } , {
														success_callback = function( data )
																
																self.contentLayer=self:createJiangLi(data)
																self.baseLayer:addChild(self.contentLayer)
														end
													})
									

										end
									})

								else
									KNMsg:getInstance():flashShow( "未达到领取条件")
								end
						end
					}):getLayer()
				itemBg:addChild(getBtn)

	       	 end
	       	 


    end


    return tempLayer

end


function M:createShiLian( shiLianData )
	if self.contentLayer then self.contentLayer:removeFromParentAndCleanup(true) end

	local tempLayer = display.newLayer()

	local  bg = display.newSprite(PATH .."shiLianBg.png")
	setAnchPos(bg,0,240)
	tempLayer:addChild(bg)

	local shenGeLab =  display.newSprite(PATH .."shenGeLab.png")
	setAnchPos(shenGeLab,50,400)
	bg:addChild(shenGeLab)
	--神格值
	local shenGeNum = display.strokeLabel(shiLianData['shenge'] , shenGeLab:getContentSize().width , 2 , 23 ,ccc3(248,243,206))
	shenGeLab:addChild(shenGeNum)

	local qiYunLab =  display.newSprite(PATH .."qiYunLab.png")
	setAnchPos(qiYunLab,290,400)
	bg:addChild(qiYunLab)

	local qiYunNum = display.strokeLabel(shiLianData['qiyun'] , qiYunLab:getContentSize().width , 2 , 23 ,ccc3(248,243,206))
	qiYunLab:addChild(qiYunNum)

	--左边框
	local frameLeft = display.newSprite(PATH.."frame.png")
	setAnchPos(frameLeft,15,130)
	bg:addChild(frameLeft)
	local iStatus = display.newSprite(PATH.."iStatus.png")
	setAnchPos(iStatus,42,178)
	frameLeft:addChild(iStatus)
	local myZhanLiLab = display.newSprite(PATH.."zhanLi.png")
	setAnchPos(myZhanLiLab,30,22)
	frameLeft:addChild(myZhanLiLab)

	local myTouXiang = display.newSprite( COMMONPATH..getHeadPath( DATA_Head:get()["default"] ))
	setAnchPos(myTouXiang,60,105)
	frameLeft:addChild(myTouXiang)
	local frame = display.newSprite(COMMONPATH.."role_frame.png")
	setAnchPos(frame,-2,-3)
	myTouXiang:addChild(frame)
	
	local lvBg = display.newSprite(COMMONPATH .. "equip_lv_bg.png")
   	setAnchPos(lvBg, 36 ,0)
   	myTouXiang:addChild(lvBg)
   	local myLv = display.strokeLabel( DATA_User:get("lv") , 15 , 10 , 17 ,ccc3(248,243,206))
	myLv:setAnchorPoint(ccp(0.5,0.5))
	lvBg:addChild(myLv)

	local myName = display.strokeLabel( DATA_User:get("name") , 0 , 80 , 19 ,ccc3(248,243,206), nil , nil , {
  					dimensions_width = 200 ,
    				dimensions_height = 24,
  
    				} )
	
	frameLeft:addChild(myName)

	local myServerName = display.strokeLabel( shiLianData['me']['servername'] , 90 , 75 , 18 ,ccc3(248,243,206))
	myServerName:setAnchorPoint(ccp(0.5,0.5))
	frameLeft:addChild(myServerName)

	local myZhanLi = display.strokeLabel( shiLianData['me']['ability'] , myZhanLiLab:getContentSize().width +8, 2 , 20 ,ccc3(248,243,206))
	myZhanLiLab:addChild(myZhanLi)

	--右边框
	local frameRight = display.newSprite(PATH.."frame.png")
	setAnchPos(frameRight,278,130)
	bg:addChild(frameRight)
	local enemyStatus = display.newSprite(PATH.."enemyStatus.png")
	setAnchPos(enemyStatus,42,178)
	frameRight:addChild(enemyStatus)
	local enemyZhanLiLab = display.newSprite(PATH.."zhanLi.png")
	setAnchPos(enemyZhanLiLab,30,22)
	frameRight:addChild(enemyZhanLiLab)

	local vsLab = display.newSprite(PATH.."vs.png")
	setAnchPos(vsLab,183,170)
	bg:addChild(vsLab)
	local light = display.newSprite(PATH.."light.png")
	setAnchPos(light,-120,-45)
	vsLab:addChild(light)


	local enemyTouXiang = display.newSprite( COMMONPATH..getHeadPath(  shiLianData['rival']['head'] ))
	setAnchPos(enemyTouXiang,60,105)
	frameRight:addChild(enemyTouXiang)
	local frame = display.newSprite(COMMONPATH.."role_frame.png")
	setAnchPos(frame,-2,-3)
	enemyTouXiang:addChild(frame)
	
	local lvBg = display.newSprite(COMMONPATH .. "equip_lv_bg.png")
   	setAnchPos(lvBg, 36 ,0)
   	enemyTouXiang:addChild(lvBg)
   	local enemyLv = display.strokeLabel( shiLianData['rival']['lv'] , 15 , 10 , 17 ,ccc3(248,243,206))
	enemyLv:setAnchorPoint(ccp(0.5,0.5))
	lvBg:addChild(enemyLv)

	local enemyName = display.strokeLabel(shiLianData['rival']['name'] , 0  , 80 , 19 ,ccc3(248,243,206) , nil , nil , {
  					dimensions_width = 200 ,
    				dimensions_height = 24,
  
    				} )
	frameRight:addChild(enemyName)

	local enemyServerName = display.strokeLabel( shiLianData['rival']['servername'] , frameRight:getContentSize().width/2 , 75 , 18 ,ccc3(248,243,206))
	enemyServerName:setAnchorPoint(ccp(0.5,0.5))
	frameRight:addChild(enemyServerName)

	local enemyZhanLi = display.strokeLabel(shiLianData['rival']['ability'] ,enemyZhanLiLab:getContentSize().width +8, 2 , 20 ,ccc3(248,243,206))
	enemyZhanLiLab:addChild(enemyZhanLi)


	--奖励文字
	local txtPos = {{30,-60},{260,-60},{30,-90},{260,-90},{30,-120},{260,-120}}--坐标

	for i=1,#shiLianData['award'] do
		
		if i<7 then  --最多6条
		
			local awardTxt = display.strokeLabel( i..". "..shiLianData['award'][i]['des2'].."("..shiLianData['award'][i]['current'].."/"..(shiLianData['award'][i]['rank']~=nil and shiLianData['award'][i]['rank'] or shiLianData['award'][i]['num'])..")" , txtPos[i][1] , txtPos[i][2] , 17 ,ccc3(248,243,206))
			bg:addChild(awardTxt)

			--如果达成条件
			local currentType = type(shiLianData['award'][i]['current'])

			if currentType=="string" then


			elseif currentType=="number" then
				if shiLianData['award'][i]['get']==1 then --已经领取
					awardTxt:setColor(ccc3(207,80,67))
					
					local gou = display.newSprite(PATH .."complete_flag.png")
					setAnchPos(gou,txtPos[i][1]-25 , txtPos[i][2])
					bg:addChild(gou)

				elseif shiLianData['award'][i]['rank'] and shiLianData['award'][i]['current']<= shiLianData['award'][i]['rank'] and shiLianData['award'][i]['current']>0 then --达成
					awardTxt:setColor(ccc3(207,80,67))
					
					local gou = display.newSprite(PATH .."complete_flag.png")
					setAnchPos(gou,txtPos[i][1]-25 , txtPos[i][2])
					bg:addChild(gou)
				elseif shiLianData['award'][i]['num'] and shiLianData['award'][i]['current']>= shiLianData['award'][i]['num'] then
					awardTxt:setColor(ccc3(207,80,67))
					
					local gou = display.newSprite(PATH .."complete_flag.png")
					setAnchPos(gou,txtPos[i][1]-25 , txtPos[i][2])
					bg:addChild(gou)
				end


			end

		end
		
	end



	--更换
	local changeBtn = KNBtn:new(PATH, {"change.png" , "changeSelect.png"} , 320, 90 , {
						priority = -131 , 
						callback = function()
								
								HTTP:call("trial","refreshRival",{  } , {
										success_callback = function( data )
													dump(data)
													enemyName:setString(data['rival']['name'])
													enemyLv:setString(data['rival']['lv'])
													enemyServerName:setString(data['rival']['servername'])
													enemyZhanLi:setString(data['rival']['ability'])
													enemyTouXiang:setTexture(display.newSprite(COMMONPATH..getHeadPath(  data['rival']['head'] )):getTexture()  )		
									end
									})
						end
					}):getLayer()
	bg:addChild(changeBtn)

	local gold = display.newSprite(COMMONPATH.."gold.png")
	setAnchPos(gold,changeBtn:getContentSize().width,5)
	changeBtn:addChild(gold)

	local goldNum = display.strokeLabel( shiLianData['refresh_gold'] , gold:getContentSize().width , 2 , 20 ,ccc3(248,243,206) )
	gold:addChild(goldNum)


	--战斗
	local fightBtn = KNBtn:new(COMMONPATH, {"long_btn.png" , "long_btn_pre.png"} , 190, -10 , {
						priority = -131 , 
						front= PATH.."fight.png",
						callback = function()

								
								SOCKET:getInstance("battle"):call("trial" , "challenge" , "execute" , { type = "", target ="" } )
									
								
						end
					}):getLayer()
	bg:addChild(fightBtn)

	local ciShu = display.strokeLabel("次数: "..shiLianData['times'] , fightBtn:getContentSize().width+15 , 8 , 20 ,ccc3(248,243,206))
	fightBtn:addChild(ciShu)

	--增加次数
	local addCiShuBtn = KNBtn:new(COMMONPATH, {"add.png"} , fightBtn:getContentSize().width+100, -3 , {
						priority = -131 , 
						scale=true,
						callback = function()
								local mask
								local tempLayer =display.newLayer()
						
								local bg = display.newSprite(COMMONPATH.."tip_bg.png")
								setAnchPos(bg,25,350)
								tempLayer:addChild(bg)								
								

								local buySp = display.newSprite(PATH .."buy.png")
								setAnchPos(buySp,70,165)
								bg:addChild(buySp)

								local buyDesc = display.strokeLabel("铁血试炼攻击次数+1" , buySp:getContentSize().width+15 , -20 , 19 ,ccc3(76,36,17) )
								buySp:addChild(buyDesc)


								local costSp = display.newSprite(COMMONPATH .."cost.png")
								setAnchPos(costSp,70,105)
								bg:addChild(costSp)

								local costDesc = display.strokeLabel("黄金:"..shiLianData['buy_gold'] , costSp:getContentSize().width+15 , -20 , 19 ,ccc3(76,36,17) )
								costSp:addChild(costDesc)

								--确定购买
								local confirmBtn = KNBtn:new(COMMONPATH, {"long_btn.png","long_btn_pre.png" }, 160 , 20 , {
											priority = -133,
											scale = true,
											front=COMMONPATH.."confirm.png",
											callback = function()
														HTTP:call("trial","buyTimes",{  } , {
																success_callback = function( data )
																		dump(data)
																		mask:remove()
																		HTTP:call("trial","getInfo",{  } , {
																			success_callback = function( data )
																					dump(data)
																					self.contentLayer=self:createShiLian(data)
																					self.baseLayer:addChild(self.contentLayer)
																			end
																		})	
																end
															})
														

													end})
									bg:addChild(confirmBtn:getLayer())



								--关闭按钮
								local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 10 , 195 , {
											priority = -133,
											scale = true,
											callback = function()
														
														mask:remove()

													end})
											bg:addChild(close:getLayer())

								mask = KNMask:new({item = tempLayer, click = function(x,y)  end ,priority= -132})

								self.baseLayer:addChild(mask:getLayer())


						end
					}):getLayer()
	fightBtn:addChild(addCiShuBtn)

	local jiangLiSp = display.newSprite(PATH.."jiangLiSp.png")
	setAnchPos(jiangLiSp,15,-30)
	bg:addChild(jiangLiSp)

	local shade_bg = display.newSprite(COMMONPATH.."shade_bg2.png")
	setAnchPos(shade_bg,5,-138)
	shade_bg:setScaleY(0.6)
	bg:addChild(shade_bg)

	return tempLayer
end


function M:createLianSheng(lianShengData  )
	if self.contentLayer then self.contentLayer:removeFromParentAndCleanup(true) end

	local tempLayer =display.newLayer()

	 --分割线
	local lineSp = display.newSprite(COMMONPATH .. "tab_line.png")
	setAnchPos(lineSp,5,583)
	tempLayer:addChild( lineSp )

	local lianShengBar = display.newSprite(PATH.."lianShengBar.jpg")
	setAnchPos(lianShengBar,5,585)
	tempLayer:addChild(lianShengBar)

	local lianShengCiShuSP = display.newSprite(PATH .."myLianShengNum.png")
	setAnchPos(lianShengCiShuSP,20,66)
	lianShengBar:addChild(lianShengCiShuSP)

	local lianShengCiShuNum = display.strokeLabel(lianShengData['me']['straight_win'] , lianShengCiShuSP:getContentSize().width, 0 , 24 , ccc3( 110 , 211 , 26))
	lianShengCiShuSP:addChild(lianShengCiShuNum)

	local myRankLab = display.newSprite(PATH.."myServRank.png")
	setAnchPos(myRankLab,335,82)
	lianShengBar:addChild(myRankLab)

	local rankBg =display.newSprite(PATH.."rankBg.png")
	setAnchPos(rankBg,362,13)
	lianShengBar:addChild(rankBg)

	local rank_type = type(lianShengData['me']['rank'])  --判断排名类型
	if rank_type=="number" then
		local myRankNum = getImageNum(lianShengData['me']['rank'], COMMONPATH .. "cirt.png")
		myRankNum:setAnchorPoint(ccp(0.5, 0.5))
		myRankNum:setPosition(ccp(rankBg:getContentSize().width*0.5,37))
		myRankNum:setScale(0.5)
		rankBg:addChild(myRankNum)
	elseif rank_type=="string" then
		local rankDesc = display.strokeLabel(lianShengData['me']['rank'] , 5, -15 , 16 , ccc3( 223 , 206 , 164))
		rankBg:addChild(rankDesc)
 	end

	local tempScrollView = KNScrollView:new(15,102,450,480,8,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
    tempLayer:addChild(tempScrollView:getLayer())
   
    for i=1,#lianShengData['list'] do
    		 local  itemBg = display.newSprite(COMMONPATH .."item_bg.png")
	       	 setAnchPos(itemBg,0,0)
	       	 tempScrollView:addChild(itemBg)

	       	 --头像
	       	 -- local touXiang = display.newSprite(COMMONPATH .. getHeadPath( lianShengData['list'][i]['head'] ))
	       	 -- setAnchPos(touXiang,25,20)
	       	 -- itemBg:addChild(touXiang)

	    	--头像
			local touXiangBtn = KNBtn:new(COMMONPATH, { getHeadPath( lianShengData['list'][i]['head'] ) }, 25 , 20 , {
							priority = -133,
							parent=tempScrollView,
							callback = function()
									print("aaaaaaaaa")
									HTTP:call("profile","get",{ touid = lianShengData['list'][i]['uid'] },{success_callback =  function()

														local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
														display.getRunningScene():addChild( otherPalyerInfo:new( { isFriend = true } ):getLayer() )
											end})	

									end})
			itemBg:addChild(touXiangBtn:getLayer())


	       	 local frame = display.newSprite(COMMONPATH.."role_frame.png")
	       	 setAnchPos(frame,-2,-3)
	       	 touXiangBtn:getLayer():addChild(frame)

	       	 local userName = display.strokeLabel("姓名:   "..lianShengData['list'][i]['name'] , 120 , 65 , 19 ,ccc3(76,36,17) )
	       	 local lianShengCiShu = display.strokeLabel("连胜次数: ".. lianShengData['list'][i]['straight_win'], 120 , 40 , 19 ,ccc3(76,36,17) )
	       	
	       	 itemBg:addChild(userName)
	       	 itemBg:addChild(lianShengCiShu)
	       	 

	       	 local rankBg =display.newSprite(PATH.."rankBg.png")
			 setAnchPos(rankBg,360,20)
			 itemBg:addChild(rankBg)

	       	 local rankNum = getImageNum(i, COMMONPATH .. "cirt.png")
	       	 setAnchPos(rankNum,38,35)
		     rankNum:setAnchorPoint(ccp(0.5, 0.5))
	       	 rankNum:setScale(0.6)
	       	 rankBg:addChild(rankNum)

    end

	return tempLayer
end


function M:createShengChang( shengChangData,pageIndex)
	if self.contentLayer then self.contentLayer:removeFromParentAndCleanup(true) end

	local tempLayer = display.newLayer()

	 --分割线
	local lineSp = display.newSprite(COMMONPATH .. "tab_line.png")
	setAnchPos(lineSp,5,583)
	tempLayer:addChild( lineSp )

	local shengChangBar = display.newSprite(PATH.."shengChangBar.jpg")
	setAnchPos(shengChangBar,5,585)
	tempLayer:addChild(shengChangBar)

	local lianShengCiShuSP = display.newSprite(PATH .."shengChangAndPoHuai.png")
	setAnchPos(lianShengCiShuSP,20,45)
	shengChangBar:addChild(lianShengCiShuSP)

	local winCiShu = display.strokeLabel(shengChangData['me']['win'] , lianShengCiShuSP:getContentSize().width+5, 20 , 24 , ccc3( 110 , 211 , 26))
	lianShengCiShuSP:addChild(winCiShu)

	local destroyed = display.strokeLabel(shengChangData['me']['destroyed'] , lianShengCiShuSP:getContentSize().width+5, -3 , 24 , ccc3( 110 , 211 , 26))
	lianShengCiShuSP:addChild(destroyed)

	--破坏纪录
	local poHuaiHistoryBtn = KNBtn:new(COMMONPATH, {"long_btn.png" , "long_btn_pre.png"} , 20, 3 , {
			priority = -131, 
			scale=true,
			front=PATH.."poHuaiHistory.png",
			callback = function()

				local mask
				local tempLayer =display.newLayer()
		
				local bg = display.newSprite(COMMONPATH.."bg_smaller.png")
				setAnchPos(bg,15,120)
				tempLayer:addChild(bg)

				--前景
				local inBg = display.newSprite(PATH.."poHuaiInBg.png")
				setAnchPos(inBg,13,40)
				bg:addChild(inBg)

				--破坏和被破坏纪录
				--type 1,被破坏,2破坏
				local historyContentLayer
				local function creteHistory( historyData ,type )
					if historyContentLayer then historyContentLayer:removeFromParentAndCleanup(true) end

					local tempHistoryLayer = display.newLayer()

					local pohuaiDesc = display.strokeLabel("被破坏5,50,500,5000次时才会降低1次胜场" ,50 , 525 , 19 , ccc3( 100 , 218 , 212))
					tempHistoryLayer:addChild(pohuaiDesc)

					local tempScrollView = KNScrollView:new(33,170,415,350,5,false,0,{
	
				   		 priority = -135,
				    	 --debug=true,
				    })
    				tempScrollView:alignCenter()
    				tempHistoryLayer:addChild(tempScrollView:getLayer())

    				for i=1,#historyData do
    					local lineLayer = display.newLayer() 
    					--local lineLayer=CCLayerColor:create( ccc4(255 , 255 , 255 , 100) )--每一行的层
	    				lineLayer:setContentSize(CCSizeMake(410,100))

	    				local separatorUp = display.newSprite(COMMONPATH.."separator.png")
	    				setAnchPos(separatorUp,60,90)
	    				lineLayer:addChild(separatorUp)

	    				local separatorDown = display.newSprite(COMMONPATH.."separator.png")
	    				setAnchPos(separatorDown,60,-5)
	    				lineLayer:addChild(separatorDown)

	    				if type==2 then --破坏列表
		    				local chengGong = display.newSprite(PATH.."poHuaiDone.png")
		    				setAnchPos(chengGong,300,10)
		    				lineLayer:addChild(chengGong)

		    			elseif type==1 then --被破坏列表显示复仇按钮
		    				
		    				local imgName = {"btn_bg.png","btn_bg_pre.png"}
		    				if historyData[i]['is_fuchou']==1 then --该玩家被复仇过
		    					imgName={"btn_bg_grey.png"}
		    				end
		    				
		    				local fuchouBtn = KNBtn:new(COMMONPATH, imgName, 320 , 55 , {
										priority = -133,
										front=PATH.."fuchou.png",
										scale = true,
										callback = function()
													if historyData[i]['is_fuchou']==1 then
														KNMsg:getInstance():flashShow("已对该玩家进行了复仇")
													else
														SOCKET:getInstance("battle"):call("trial" , "destroy" , "execute" , { enemyUid = historyData[i]['uid'], destroyType="fuChou" } )
													end
												end})
							lineLayer:addChild(fuchouBtn:getLayer())

							--查看
							local lookBtn = KNBtn:new(COMMONPATH, imgName, 320 , 8 , {
										priority = -133,
										front=PATH.."look.png",
										scale = true,
										callback = function()
															HTTP:call("trial", "show_battle", { enemy_uid= historyData[i]['uid']}, {
																success_callback = function(tempData)
																				--dump(tempData)
																				DATA_Battle:setMod("guide")
																				DATA_Battle:setAct("execute")
																				DATA_Battle:set( tempData["show"] )
																				pushScene("battle" , { resultCallFun = function()end, overFun = function()
																					popScene()
																					

																				end })
															end
														})


													
												end})
							lineLayer:addChild(lookBtn:getLayer())


	    				end

	    				-- local distDesc = display.strokeLabel(historyData[i]['msg'], 50, 0 , 15 , ccc3( 223 , 206 , 164))
	    				-- distDesc:setDimensions(CCSize:new( 360 , 50 ))
	    				-- lineLayer:addChild(distDesc)

	    				 local touXiangBtn = KNBtn:new(COMMONPATH, { getHeadPath( historyData[i]['head'] ) }, 30 , 25 , {
							priority = -133,
							parent=tempScrollView,
							callback = function()
										
									HTTP:call("profile","get_other_server",{ touid = historyData[i]['uid'] },{success_callback =  function(data)
												local allServerPlayerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/allServerPlayerInfo")
												display.getRunningScene():addChild( allServerPlayerInfo:new( { isFriend = true } ):getLayer() )
											end})	

									end})
						lineLayer:addChild(touXiangBtn:getLayer())


				       	 local frame = display.newSprite(COMMONPATH.."role_frame.png")
				       	 setAnchPos(frame,-2,-3)
				       	 touXiangBtn:getLayer():addChild(frame)

				       	 local lvBg = display.newSprite(COMMONPATH .. "egg_num_bg.png")
		   				 setAnchPos(lvBg, 50 ,50)
		   				 touXiangBtn:getLayer():addChild(lvBg)

			  			--等级
			  			local playerLv = display.strokeLabel( historyData[i]['lv'] , 12 , 10 , 15 ,ccc3(248,243,206))
						playerLv:setAnchorPoint(ccp(0.5,0.5))
						lvBg:addChild(playerLv)

						local userName = display.strokeLabel( historyData[i]['name'] , 65 , 17 , 16 ,ccc3(253,248,210) )
						userName:setAnchorPoint(ccp(0.5,0.5))
		       	 		userName:setPosition(ccp(65,17))
		       	 		lineLayer:addChild(userName)

		       	 		local rank = display.strokeLabel("胜利排行: "..historyData[i]['rank'], 130 , 70 , 16 ,ccc3(248,243,206))
		       	 		local servName = display.strokeLabel("【"..historyData[i]["servername"].. "】", 130 , 45 , 16 ,ccc3(248,243,206))
		       	 		local zhanLi = display.strokeLabel("战力: "..historyData[i]['ability'], 130 , 20 , 16 ,ccc3(248,243,206))
		       	 		
		       	 		lineLayer:addChild(rank)
		       	 		lineLayer:addChild(servName)
		       	 		lineLayer:addChild(zhanLi)

	    				tempScrollView:addChild(lineLayer)
    				end
    				

    				return tempHistoryLayer
				end 

				HTTP:call("trial","getDestroyedList",{  } , {
										success_callback = function( data )
													dump(data)
													historyContentLayer = creteHistory(data,1)
													tempLayer:addChild(historyContentLayer)			
									end
									})

				local tabConfig = {"beiPoHuai","poHuai"}

				local group = KNRadioGroup:new()

				for i=1,2 do
					local tempBtn = KNBtn:new( COMMONPATH ,{"tab/tab_star_normal.png","tab/tab_star_select.png"} , 40+(i-1)*95 , 555,{
						    priority = -134,
							disableWhenChoose = true,
							upSelect = true,
							id = i,
							front = {PATH .. tabConfig[i] .."UnSelect.png",PATH.. tabConfig[i] .."Select.png"},
							callback=
							function()
								if i==1 then --被破坏纪录
										HTTP:call("trial","getDestroyedList",{  } , {
											success_callback = function( data )
													dump(data)
													historyContentLayer = creteHistory(data,i)
													tempLayer:addChild(historyContentLayer)			
											end
											})
								elseif i==2 then
										HTTP:call("trial","getDestroyList",{  } , {
											success_callback = function( data )
													dump(data)
													historyContentLayer = creteHistory(data,i)
													tempLayer:addChild(historyContentLayer)			
											end
											})


								end	
								

							end
						},group):getLayer()
					tempLayer:addChild( tempBtn )
				end

				

				--标题背景
				local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
				setAnchPos(title_bgSp,110,540)
				bg:addChild(title_bgSp)

				--标题文字
				local title_Sp = display.newSprite(PATH.."poHuaiHistoryTitle.png")
				setAnchPos(title_Sp,140,550)
				bg:addChild(title_Sp)


				--关闭按钮
				local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 10 , 515 , {
							priority = -133,
							scale = true,
							callback = function()
										
										mask:remove()

									end})
							bg:addChild(close:getLayer())

				mask = KNMask:new({item = tempLayer, click = function(x,y)  end ,priority= -132})

				self.baseLayer:addChild(mask:getLayer())
								
			end
			}):getLayer()
	shengChangBar:addChild(poHuaiHistoryBtn)

	local myRankLab = display.newSprite(PATH.."myAllServRank.png")
	setAnchPos(myRankLab,335,82)
	shengChangBar:addChild(myRankLab)

	local rankBg =display.newSprite(PATH.."rankBg.png")
	setAnchPos(rankBg,362,13)
	shengChangBar:addChild(rankBg)

	local rank_type = type(shengChangData['me']['rank'])  --判断排名类型
	if rank_type=="number" then
		local myRankNum = getImageNum(shengChangData['me']['rank'], COMMONPATH .. "cirt.png")
		myRankNum:setAnchorPoint(ccp(0.5, 0.5))
		myRankNum:setPosition(ccp(rankBg:getContentSize().width*0.5,37))
		myRankNum:setScale(0.5)
		rankBg:addChild(myRankNum)
	elseif rank_type=="string" then
		local rankDesc = display.strokeLabel(shengChangData['me']['rank'] , 5, -15 , 16 , ccc3( 223 , 206 , 164))
		rankBg:addChild(rankDesc)
 	end

	local pageCount = math.ceil( #shengChangData['list']/10) --总页码

	local pageLab = display.strokeLabel( pageIndex .."/"..pageCount, 215, 110 , 22 , ccc3( 223 , 206 , 164) )
    tempLayer:addChild(pageLab)

    --增减翻页按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 255 , 102 , {
				scale = true,
				priority = -130,
				callback = function()
					
					if pageIndex<pageCount then
						pageIndex=pageIndex+1
						self.contentLayer= self:createShengChang(shengChangData,pageIndex)
						self.baseLayer:addChild(self.contentLayer)
					end
					
			end
			})
	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 175 , 102 ,{
				scale = true,
				priority = -130,
				callback = function()
					if pageIndex>1 then
						pageIndex=pageIndex-1
						self.contentLayer= self:createShengChang(shengChangData,pageIndex)
						self.baseLayer:addChild(self.contentLayer)
					end
					
				end
				})
	minusBtn:setFlip(true)
	addBtn:getLayer():setScale( 0.8 )
	minusBtn:getLayer():setScale( 0.8 )
	tempLayer:addChild(addBtn:getLayer())
	tempLayer:addChild(minusBtn:getLayer())

	--滑动列表
	local tempScrollView = KNScrollView:new(15,145,450,435,8,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
    tempLayer:addChild(tempScrollView:getLayer())

     for i=1+((pageIndex-1)*10),pageIndex*10 do

     		 if shengChangData['list'][i] then

	     		 local  itemBg = display.newSprite(COMMONPATH .."item_bg.png")
		       	 setAnchPos(itemBg,0,0)
		       	 tempScrollView:addChild(itemBg)

		       	 --头像
		       	 -- local touXiang = display.newSprite(COMMONPATH .. getHeadPath( shengChangData['list'][i]['head'] ))
		       	 -- setAnchPos(touXiang,115,20)
		       	 -- itemBg:addChild(touXiang)
		       	 local touXiangBtn = KNBtn:new(COMMONPATH, { getHeadPath( shengChangData['list'][i]['head'] ) }, 115 , 35 , {
							priority = -133,
							parent=tempScrollView,
							callback = function()
										
									HTTP:call("profile","get_other_server",{ touid = shengChangData['list'][i]['uid'] },{success_callback = 
																									function(data)
												local allServerPlayerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/allServerPlayerInfo")
												display.getRunningScene():addChild( allServerPlayerInfo:new( { isFriend = true } ):getLayer() )
											end})	

									end})
				itemBg:addChild(touXiangBtn:getLayer())


		       	 local frame = display.newSprite(COMMONPATH.."role_frame.png")
		       	 setAnchPos(frame,-2,-3)
		       	 touXiangBtn:getLayer():addChild(frame)

		       	 --如果有等级
		       	 if shengChangData['list'][i]['lv'] then
			       	 local lvBg = display.newSprite(COMMONPATH .. "egg_num_bg.png")
	   				 setAnchPos(lvBg, 50 ,50)
	   				 touXiangBtn:getLayer():addChild(lvBg)

		  			--等级
		  			local playerLv = display.strokeLabel( shengChangData['list'][i]['lv'] , 12 , 10 , 15 ,ccc3(248,243,206))
					playerLv:setAnchorPoint(ccp(0.5,0.5))
					lvBg:addChild(playerLv)
				end

		       	 local rankBg =display.newSprite(PATH.."rankBg.png")
			 	 setAnchPos(rankBg,20,20)
			 	 itemBg:addChild(rankBg)
		       	 
		       	 local rankNum = getImageNum(i, COMMONPATH .. "cirt.png")
		       	 setAnchPos(rankNum,38,35)
		         rankNum:setAnchorPoint(ccp(0.5, 0.5))
		       	 rankNum:setScale(0.6)
		       	 rankBg:addChild(rankNum)


		       	 --local userName = display.strokeLabel("姓名:  "..shengChangData['list'][i]['name'] , 195 , 65 , 18 ,ccc3(76,36,17) )	
		       	 local userName = display.strokeLabel( shengChangData['list'][i]['name'] , 117 , 18 , 18 ,ccc3(76,36,17) )	
		       	 userName:setAnchorPoint(ccp(0.5,0.5))
		       	 userName:setPosition(ccp(150,17))	 
		       	 local winCiShu = display.strokeLabel("胜利场次: "..shengChangData['list'][i]['win']+shengChangData['list'][i]['destroyed'] , 210 , 80 , 16 ,ccc3(76,36,17) )
		       	 local poHuaiCiShu = display.strokeLabel("被破坏胜场: "..shengChangData['list'][i]['destroyed'] , 210 , 60 , 16 ,ccc3(76,36,17) )
		       	 local youXiaoCiShu = display.strokeLabel("有效胜场: "..shengChangData['list'][i]['win'] , 210 , 40 , 16 ,ccc3(76,36,17) )
		       	 local servName = display.strokeLabel(shengChangData['list'][i]['servername']  , 210 , 20 , 16 ,ccc3(76,36,17) )

		       	 itemBg:addChild(userName)
		       	 itemBg:addChild(winCiShu) 
		       	 itemBg:addChild(poHuaiCiShu)
		       	 itemBg:addChild(youXiaoCiShu)
		       	 itemBg:addChild(servName)

		       	 local imgName = {"btn_bg.png" , "btn_bg_pre.png"}
		       	 
		       	 if shengChangData['list'][i]['lv'] and shengChangData['list'][i]['lv']<DATA_User:get('lv') then --灰色
		       	 	imgName={"btn_bg_grey.png"}
		       	 elseif shengChangData['list'][i]['lv'] and shengChangData['list'][i]['lv']>=DATA_User:get('lv') and (shengChangData['list'][i]['lv']-DATA_User:get('lv'))<=5 then--绿色
		       	 	imgName={"btn_green.png","btn_green_pre.png"}
		       	 elseif shengChangData['list'][i]['lv'] and (shengChangData['list'][i]['lv']-DATA_User:get('lv'))>5 then --红色
		       	 	imgName={"btn_hong.png","btn_hong_pre.png"}
		       	 end
		       	 --破坏btn
		       	 local poHuaiBtn = KNBtn:new(COMMONPATH, imgName , 355, 30 , {
						priority = -131, 
						scale=true,
						front=PATH.."poHuai.png",
						callback = function()
								if imgName[1]=="btn_bg_grey.png" then
									KNMsg:getInstance():flashShow("太弱,敌人不值得出手")
									return
								end
								SOCKET:getInstance("battle"):call("trial" , "destroy" , "execute" , { enemyUid = shengChangData['list'][i]['uid'], destroyType="destroy" } )
						end
					}):getLayer()
				itemBg:addChild(poHuaiBtn)

	       	end

     end



	return tempLayer
end


return M