--[[

卡牌类

]]

local M = {}
local heros = {}

local hpBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")
local logic = requires(IMG_PATH,"GameLuaScript/Scene/boss/logicLayer")

--[[获取对象]]
function M:get( group , index )
	if heros[group] == nil or heros[group][index] == nil then return nil end
	return heros[group][index]
end


--[[数据初始化 清空所有数据]]
function M:init( first )
	if first then heros = {} end

	local temp_heros = {}
	for i = 1 , 2 do			-- 两方
		temp_heros[i] = {}
		for j = 0 , 3 do		-- 上阵4人
			if heros[i] ~= nil and heros[i][j] ~= nil then
				heros[i][j]:removeFromParentAndCleanup(true)
				heros[i][j] = nil
			end

			temp_heros[i][j] = nil
		end
	end

	heros = temp_heros
end


--[[清空单个数据]]
function M:clear( group , index )
	if heros[group][index] then
		heros[group][index]:removeFromParentAndCleanup(true)
		heros[group][index] = nil
	end
	
	local isExsit = false	--当前组是否全部死亡
	
	for i = 0 , 4 do
		if heros[group][i] then
			isExsit = true
			break
		end
	end
	if not isExsit then
		local scene = display.getRunningScene()
		local selectMask = scene:getChildByTag("899")
		
		if selectMask then
			scene:removeChild(selectMask , true)
		end
		logic:resume("select")
	end
	
	return true
end


--[[生成对象]]
function M.new( data , param )
	if type(param) ~= "table" then param = {} end
	local clickCallback = param.click or nil
	local selectFun = nil	--只用于宠物选择
	-- 容器
	local hero = display.newLayer()
	-- local hero = CCLayerColor:create( ccc4(255 , 255 , 255 , 100) )
	local isShenMai = false

	

	-- 英雄的数据
	local _data = data
	local hero_group = _data["_group"]
	local hero_index = _data["_index"]

	local curCid, curType,shenmaiData
	if hero_group == 1 then
	    curCid = data.cid or ( getConfig( getCidType( data.npc_id ) ,data.npc_id ,"gid" ) ) 
		curType = getCidType( curCid )
		shenmaiData = DATA_Bag:get( curType ,  data.id ) or nil		--是否神脉
		if shenmaiData and tonumber(  shenmaiData["god_frame"] ) == 1 then isShenMai = true end
	end

	
	-- 英雄背景图片
	local bgColorFrame
	if data.shenyuan_shenweilv and tonumber( data.shenyuan_shenweilv ) ~= 0 then
		bgColorFrame = display.newSprite(IMG_PATH.."image/scene/battle/role/shenyuan_shenweilv.png")
		display.align(bgColorFrame , display.LEFT_BOTTOM , 0 , 0)
		hero:addChild(bgColorFrame)
		
		local sprite
		local frames = display.newFramesWithImage(IMG_PATH .. "image/scene/battle/role/shenyuan_eff.png" , 10 )
		sprite = display.playFrames( 100 , 173 ,frames,0.1,{forever = true })
		hero:addChild( sprite , 100 )
		
	else
		if hero_group == 2 then
			bgColorFrame = display.newSprite(IMG_PATH.."image/scene/battle/boss/boss_bg.png")
		else
			bgColorFrame = display.newSprite(IMG_PATH.."image/scene/battle/role/role_bg.png")
		end
		display.align(bgColorFrame , display.LEFT_BOTTOM , 0 , 0)
		hero:addChild(bgColorFrame)
	end

	-- 获取大小
	local frameSize = bgColorFrame:getContentSize()
	hero:setContentSize( CCSize(frameSize.width , frameSize.height ) )
	
	--特殊英雄	
	if hero_group == 1 and getConfig( curType , curCid , "special" , nil , data._group ) == 1 then		
		hero:addChild( display.newSprite( IMG_PATH.."image/scene/battle/role/special_frame.png" , -6 , 0 , 0 , 0 ) )
	end
	
	-- 英雄图片
	local heroImage 
	if hero_group == 2 then
		heroImage = display.newSprite( IMG_PATH.."image/scene/battle/boss/boss.png" )
	else
		heroImage = display.newSprite( getImageByType( data.cid or data.npc_id , "m" , nil , hero_group ) )
	end
	
	local bgSize = bgColorFrame:getContentSize()
	setAnchPos(heroImage, bgSize.width / 2, 0, 0.5)
--	display.align(heroImage , display.BOTTOM , bgSize.width / 2 + 2,0 )
	-- heroImage:setPosition( 0 , 10 )
	hero:addChild(heroImage)
	
	if hero_group == 1 then
		local maskSp = display.newSprite(IMG_PATH.."image/scene/battle/role/mask"..data.star..".png")
		display.align(maskSp , display.LEFT_BOTTOM , 6 , 6 )
		hero:addChild(maskSp)
	end
	
	if isShenMai then
		hero:addChild( display.newSprite( IMG_PATH.."image/scene/battle/role/god_frame.png" , -6 , 0 , 0 , 0 ) )
		
		if data.role ~= 0 then
			local jobSp = display.newSprite(IMG_PATH.."image/scene/battle/role/god_job".. data.role..".png")
			setAnchPos( jobSp , 38  , 121 + 20 )
			hero:addChild(jobSp )
		end
		
    	local frames = display.newFramesWithImage(IMG_PATH .. "image/scene/battle/role/god_eff.png" , 12 )
        local god_eff = display.playFrames( 55  , 40 , frames , 0.2 , { forever = true ,  })
        hero:addChild( god_eff )  
	end
	
	-- 血条
	local hp_bar = hpBar:new(hero_group == 1 and "hp" or "hp_boss" , 0 , 0 , { barOffset = -10 , isOnlyCur = true , curValue = data.hp , maxValue = data.org_hp , textSize = 14 , icon = "icon"} )
	-- hp_bar:setPosition( -47 , -44 )
	if hero_group == 1 then
		display.align(hp_bar , display.LEFT_BOTTOM , 5 , 31 )
	else
		display.align(hp_bar , display.LEFT_BOTTOM , 0 , 25 )
	end
	
	hp_bar:setIsShowText( true )
	hero:addChild(hp_bar)

	--血条Icon上文字
	local lvText
	if isset( data , "lv" ) then
		lvText = CCLabelTTF:create( data.lv , FONT ,15)
	else
		lvText = CCLabelTTF:create( "20" , FONT , 15)
	end

	hero:addChild(lvText)
	lvText:setColor(ccc3( 253 , 252 , 172 ))
	if device.platform == "wp8" then
		lvText:setPosition( hp_bar:getPositionX() + 14 , hp_bar:getPositionY())
	else
		lvText:setPosition( hp_bar.x + 14 , hp_bar.y )
	end
	
	if hero_group == 1 then
		--英雄星级
		local heroStarNum = getConfig( curType , curCid , "star" , nil , data._group )
		
		for i = 1 , heroStarNum do
			local starSp = display.newSprite(IMG_PATH.."image/scene/battle/hero_star.png")
			setAnchPos( starSp , 51 - heroStarNum * 7 + i * 14 , 18 , 0.5 , 0.5 )
			hero:addChild( starSp )
		end
	end
	
	

	if data.role ~= 0 and not isShenMai and hero_group == 1 then
		local jobSp = display.newSprite(IMG_PATH.."image/scene/battle/job".. data.role..".png")
		setAnchPos( jobSp , 6 , 121 )
		hero:addChild(jobSp)
	end
	
	--如果有附加状态则生成附加状态数据
	if data.status then
		for key , v in pairs( data.status ) do
		 	local  flagSp = display.newSprite(IMG_PATH.."image/scene/battle/pet/eff_flag/"..key.."_flag.png")
			--给目标英英雄添加 效果数据
			_data[key..""] = { keep = v.keep ,  flag = flagSp}
			local lockSpSize = flagSp:getContentSize()
			flagSp:setPosition(lockSpSize.width / 2 - 5 , lockSpSize.height / 2 )
			hero:addChild( flagSp )
		end
	end
		


	-- 点击区域记录
	local rect = CCRectMake(0 , 0 , frameSize.width , frameSize.height)

	--[[------------ 对外接口 ------------]]
	--[[重置 setPosition 接口]]
	local old_setPosition = hero.setPosition
	local newX = nil
	local newY = nil
	function hero:setPosition(x , y)
		newX = x
		newY = y
		
		rect = CCRectMake(x , y , frameSize.width , frameSize.height)
		old_setPosition(hero , x , y)
	end

	--[[获取卡牌的位置和尺寸]]
	function hero:getPositionAndSize()
		local hero_x , hero_y = hero:getPosition()
		-- local hero_size = hero:getContentSize()
		local hero_width = frameSize.width
		local hero_height = frameSize.height

		return {
			_x = hero_x,
			_y = hero_y,
			_cx = hero_x + hero_width / 2,
			_cy = hero_y + hero_height / 2,
			_width = hero_width,
			_height = hero_height,
		}
	end
	
	--[[设置英雄数据]]
	function hero:setData( key , value )
		_data[key] = value
	end

	--[[获取英雄数据]]
	function hero:getData( key )
		if key ~= nil then return _data[key] end

		return _data
	end

	--[[刷新英雄卡牌血量]]
	function hero:refreshViewHp()
		hp_bar:setCurValue( _data["hp"] , false )
	end

	function hero:setClickCallback(callback)
		clickCallback = callback
	end
	
	--设置宠物选择回调
	function hero:setSelectFun(callback)
		selectFun = callback
	end
	

	

	-- 存储数据
	if heros[hero_group] == nil then heros[hero_group] = {} end
	heros[hero_group][hero_index] = hero


	-- 点击事件
	local function onTouch(eventType , x , y)
	    if eventType == CCTOUCHBEGAN then
	    	-- 判断是否点中了这张卡牌
	    	if rect:containsPoint( ccp(x , y) ) then
	    		return true
	    	else
	    		return false
	    	end
	    end
	    if eventType == CCTOUCHMOVED then return true end

	    if eventType == CCTOUCHENDED then
	    	-- 点击回调函数
	    	if selectFun then
	    		selectFun( _data  )
	    		transition.blink(hero, { time = 1 , num = 4 })

	    		
				local function tipEff()
					local frames = display.newFramesWithImage( COMMONPATH .. "btn_tip.png" , 7 )
					local btnTip 
					btnTip = display.playFrames(
						0 , 0, 
						frames,
						0.15,
						{
							onComplete = function()
							
								hero:setVisible( true )
								btnTip:removeFromParentAndCleanup(true)	-- 清除自己
							end
						}
					)
					setAnchPos( btnTip , frameSize.width / 2 , frameSize.height / 2 , 0.5 , 0.5)
					-- 添加到 特效层
					hero:addChild( btnTip )
				end
				tipEff()
	    		selectFun = nil 
	    	else
		    	if clickCallback and hero_group == 1 then clickCallback(_data) end
	    	end
	    	
	        return true
	    end

	    return false
	end

	heros[hero_group][hero_index]:setTouchEnabled( true )
	heros[hero_group][hero_index]:registerScriptTouchHandler(onTouch)

	return heros[hero_group][hero_index]
end


return M
