--[[

首页场景

]]


collectgarbage("setpause" , 100)
collectgarbage("setstepmul" , 5000)


-- [[ 包含各种 Layer ]]
local logicLayer = requires(IMG_PATH,"GameLuaScript/Scene/boss/logicLayer")
local bgLayer = requires(IMG_PATH,"GameLuaScript/Scene/boss/bgLayer")
local intoLayer = requires(IMG_PATH,"GameLuaScript/Scene/boss/intoAnimation")
local skipLayer = requires(IMG_PATH,"GameLuaScript/Scene/boss/skipLayer")
local M = {}
local bg
function M:create( param )
	local scene = display.newScene("boss")
	if type( param ) ~= "table" then param = {} end
	-- 战斗ID
	--[[
	local report_id = DATA_Battle:get("report_id")
	local win = DATA_Battle:get("win")
	]]
	
	audio.preloadSound(IMG_PATH .. "sound/atk.mp3")
	audio.preloadSound(IMG_PATH .. "sound/atk_skill.mp3")
	
	audio.preloadMusic(IMG_PATH .. "sound/battle_bg.mp3")
	
	audio.preloadMusic(IMG_PATH .. "sound/lose.mp3")
	audio.preloadMusic(IMG_PATH .. "sound/win.mp3")
	
	
	SimpleAudioEngine:sharedEngine():setBackgroundMusicVolume(1)
	audio.playMusic( IMG_PATH .. "sound/battle_bg.mp3" , true )
	
	local report = DATA_Battle:get("report")
	local prepare_data = report["prepare"]

	---------------插入layer---------------------
	if param.showLayer then
	else
		bg = bgLayer:create()
		scene:addChild( bg )	-- 背景

		if prepare_data.lm_uid_1  and ( tonumber( prepare_data.lm_uid_1 ) ~= 0 ) then
			bg:addChild( display.newSprite( IMG_PATH .. "image/scene/battle/dragon/down_bg_flag.png" , display.cx , 108 , 0.5 , 0 ) )
		end
		if prepare_data.lm_uid_2 and ( tonumber( prepare_data.lm_uid_2 ) ~= 0 ) then
			bg:addChild( display.newSprite( IMG_PATH .. "image/scene/battle/dragon/up_bg_flag.png" , display.cx , 672 + 24 , 0.5 , 1 ) )
		end
		
	end

	
	-- 战斗逻辑层 创建
	local function createLogic()
		scene:addChild( logicLayer:create( param ) )
	end
	--创建跳过按钮层
	local skip  =  skipLayer:create( param.battleType )
	
	--进场动画控制
	if param.showLayer then
		local resultLayer = requires(IMG_PATH,"GameLuaScript/Scene/boss/" .. param.showLayer )
		scene:addChild( resultLayer:create() , 100 )
	else
		createLogic()
	end

	
--	if param.intoAnimation then
--		scene:addChild( intoLayer:create( { showInfo = param.showInfo , animationOverCallFun = createLogic } ) )
--	else
--		createLogic()
--	end


	---------------------------------------------

	
	scene:addChild( skip )
	
	function scene:onExit()
		audio.stopMusic(true)
	end
	
	return scene
end
--四星五星技能控制层
function M:skillHide( isShow )
	bg:setVisible( isShow )
end
return M
