--[[

技能攻击

]]


local M = {}

local logic = requires(IMG_PATH,"GameLuaScript/Scene/boss/logicLayer")
local heroCell = requires(IMG_PATH,"GameLuaScript/Scene/boss/heroCell")
local effectLayer = requires(IMG_PATH,"GameLuaScript/Scene/boss/effectLayer")
local ShowSkill = requires(IMG_PATH,"GameLuaScript/Scene/boss/effect/showSkill")
local skillConfig = requires(IMG_PATH,"GameLuaScript/Config/Skill")

local heroAction_move = requires(IMG_PATH,"GameLuaScript/Scene/boss/heroAction/move")
local heroAction_attack = requires(IMG_PATH,"GameLuaScript/Scene/boss/heroAction/attack")
local heroAction_be_attack = requires(IMG_PATH,"GameLuaScript/Scene/boss/heroAction/be_attack")

--[[执行]]
function M:run( type , data )
	-- 攻击方
	local index = 0	
	local atk_data = data["atk"][1]		-- 普通攻击，肯定只有一个攻击者
	local atk_hero = heroCell:get( atk_data["group"] , atk_data["index"] )
	local isBigSkill = false	--是否是三星级以上技能
	local isNewEff = false	--是否是新版本技能效果
	if  CHANNEL_GROUP == "hy" or  CHANNEL_ID == "hytest" then isNewEff = true end
	

	-- 被攻击方
--	local moreSkill = { ["3008"] = "3008" , ["3010"] = "3010" } --攻击多人，但不是攻击所有敌方成员
--	local be_atk_data = data["be_atk"][1]	-- 普通攻击，肯定只有一个被攻击者
	--查找多人攻击的最左边被攻击者，方便效果定位
--	if moreSkill[ data.skill_cid .. "" ] then
--		local tempIndex	= data["be_atk"][1]["index"]
--		for i = 1 , #data["be_atk"] do
--			if tonumber( tempIndex ) > tonumber( data["be_atk"][i]["index"] ) then
--				tempIndex = data["be_atk"][i]["index"]
--				be_atk_data = data["be_atk"][i]
--			end
--		end
--	end
--	local be_atk_hero = heroCell:get( be_atk_data["group"] , be_atk_data["index"] )

	
	--所有被攻击者跳跃动画
	local function beAtkAction()
		for i = 1 , #data["be_atk"] do
			local curData = data["be_atk"][i]
			local tempHero = heroCell:get( curData["group"] , curData["index"] )
			heroAction_move:jumpOnce( tempHero , { noRecover = true })
		end
	end
	

	--存在的技能效果
	local haveSkill = { 
						["3031"]  = 8  ,
						["3032"]  = 8  ,
						["3033"]  = 8  ,
						["3034"]  = 8  ,
						["3035"]  = 8  ,
						["3036"]  = 8  ,
						["3037"]  = 8  ,
						["3038"]  = 8  ,
						["3901"]  = 4  ,
						["3902"]  = 4  ,
						["3903"]  = 4  , 
						["3904"]  = 4  ,
						["3905"]  = 4  ,
						["3906"]  = 4  ,
						["3907"]  = 5  ,
						["3908"]  = 4  ,
						["3909"]  = 4  ,
						["3910"]  = 4  ,
						["3911"]  = 4  ,
						["3912"]  = 4  ,
						["3913"]  = 4  ,
						["3914"]  = 4  ,
						["3915"]  = 4  ,
						["3916"]  = 4  ,
						["3917"]  = 4  ,
						["3918"]  = 10  ,
						["3919"]  = 14  ,
						["3920"]  = 8  ,
						}
	local moreLine = {  ["3031"] = 2 , ["3032"] = 2 , ["3035"] = 2 , ["3038"] = 2 , ["3918"] = 2 , ["3919"] = 2  }		--多行		
	--新加技能偏移量
	local newEffOff = {}
	for key , v in pairs( haveSkill ) do
		newEffOff[key] = { 0 , 0 }
	end
	if isNewEff then
		haveSkill["3901"]  = 8  
		haveSkill["3902"]  = 14  
		haveSkill["3903"]  = 10  
		haveSkill["3904"]  = 12  
		haveSkill["3905"]  = 12  
		haveSkill["3906"]  = 12  
--		haveSkill["3907"]  =  5  --以前技能异常 该技能已经被清除，
		haveSkill["3908"]  = 8  
		haveSkill["3909"]  = 14  
		haveSkill["3910"]  = 12  
		haveSkill["3911"]  = 8  
		haveSkill["3912"]  = 14  
		haveSkill["3913"]  = 14  
		haveSkill["3914"]  = 14  
		haveSkill["3915"]  = 14  
		haveSkill["3916"]  = 14  
		haveSkill["3917"]  = 16  
		
		moreLine[ "3902"] = 2 
		moreLine[ "3903"] = 2 
		moreLine[ "3904"] = 2 
		moreLine[ "3905"] = 2 
		moreLine[ "3906"] = 2 
		moreLine[ "3908"] = 2 
		moreLine[ "3909"] = 2 
		moreLine[ "3910"] = 2 
		moreLine[ "3912"] = 2 
		moreLine[ "3913"] = 2 
		moreLine[ "3914"] = 2 
		moreLine[ "3915"] = 2 
		moreLine[ "3916"] = 2 
		moreLine[ "3917"] = 2 
	end
	
	local converSKillCid
	if data.skill_cid ~= "3051" then
		--已经存在技能文字
		converSKillCid = skillConfig[ data.skill_cid.."" ].effect_id .. ""
	end
	
	--攻击效果
	local function atk_Eff( tempParams )
		local effSprite
		local lineNum = moreLine[converSKillCid ..""] and moreLine[converSKillCid ..""] or 1
		local effFrames = display.newFramesWithImage( IMG_PATH.."image/scene/battle/skillAction/".. converSKillCid ..".png" , haveSkill[ converSKillCid ] , lineNum  )
		effSprite =display.playFrames( 0  , 0  , effFrames , 0.15 , { onComplete =
																		 function() 
																			effSprite:removeFromParentAndCleanup( true ) 
																			if isBigSkill then
																				logic:skillHide(true) 
																			end
																			if tempParams.overHandler then tempParams.overHandler() end
																			if tempParams.offset then setAnchPos( logic:getLayer( tempParams.offset.targetLayer), 0 , 0 ) end
																		 end
																		 } )
		
		local targetSize = tempParams["be_atk_hero"]:getPositionAndSize()
		local effectSize = effSprite:getContentSize()
		--效果坐标
		local effectPoint = {}
		--单体攻击(特效中心点与人物中心点对齐)
		if 	   converSKillCid == "3901"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 + 26
		elseif converSKillCid == "3902"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 
		elseif converSKillCid == "3903"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 
		elseif converSKillCid == "3904"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 
		elseif converSKillCid == "3905"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3908"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3909"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 
		elseif converSKillCid == "3910"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 
		elseif converSKillCid == "3911"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 + 40
		elseif converSKillCid == "3914"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3915"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3917"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3031"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 + 30 , targetSize._cy - effectSize.height / 2 + 70
		elseif converSKillCid == "3032"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 + 10 , targetSize._cy - effectSize.height / 2 + 70
		elseif converSKillCid == "3033"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 + 70
		elseif converSKillCid == "3034"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 + 80
		elseif converSKillCid == "3035"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 - 10 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3036"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 + 40
		elseif converSKillCid == "3037"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3038"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2 + 40
		--全体攻击(全体攻击，效果从x轴10像素处开始)
		elseif converSKillCid == "3906"  then effectPoint.x , effectPoint.y = 10 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3907"  then effectPoint.x , effectPoint.y = 10 , targetSize._cy - effectSize.height / 2 
		elseif converSKillCid == "3912"  then effectPoint.x , effectPoint.y = 10 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3913"  then effectPoint.x , effectPoint.y = 10 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3916"  then effectPoint.x , effectPoint.y = 10 , targetSize._cy - effectSize.height / 2
		
		elseif converSKillCid == "3918"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3919"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		elseif converSKillCid == "3920"  then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
		end
		
		if isNewEff then
			--新技能攻击没有群体攻击
			if converSKillCid == "3906"  	then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
			elseif converSKillCid == "3907" then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
			elseif converSKillCid == "3912" then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
			elseif converSKillCid == "3913" then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
			elseif converSKillCid == "3916" then effectPoint.x , effectPoint.y = targetSize._cx - effectSize.width / 2 , targetSize._cy - effectSize.height / 2
			end
		end
		
		--为了兼容新版本技能而添加的便宜量
		effectPoint.x = effectPoint.x + newEffOff[converSKillCid][1]
		effectPoint.y = effectPoint.y + newEffOff[converSKillCid][2]
		
		--offset值由showSkill传过来
		if tempParams.offset then
			setAnchPos(effSprite , effectPoint.x  , effectPoint.y + tempParams.offset.valueY , 0 , 0 )
		else
			setAnchPos(effSprite , effectPoint.x  , effectPoint.y , 0 , 0 )
		end
		
		logic:getLayer("effect"):addChild( effSprite )
	end
	--被攻击者效果
	local function be_atkEff( tempParams )
		if not tempParams then tempParams = {} end
		index = index + 1 
		tempParams[ "be_atk_hero" ] = heroCell:get( data["be_atk"][index]["group"] , data["be_atk"][index]["index"] ) 
		
		if data.skill_cid ~= "3051" then
			-- 攻击效果(刀光)
			heroAction_attack:skill( atk_hero , tempParams[ "be_atk_hero" ] , {
				onComplete = function()
					atk_Eff( tempParams )
	--				transition.shake()
					beAtkAction()
					-- 掉血 刷新宠物怒气值
					effectLayer:actions( data )
					if isBigSkill then
						audio.playSound(IMG_PATH .. "sound/atk_skill.mp3")
					else
						audio.playSound(IMG_PATH .. "sound/small_atk_skill.mp3")
					end
					-- 恢复战斗进程
					local handle
					local function callback()
						CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
						handle = nil
						logic:resume()
					end
					handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(callback, 0.3, false)
				end,
				isgod = skillConfig[ data.skill_cid.."" ].isgod
			})
		else
			local name  = display.newSprite(IMG_PATH.."image/scene/battle/boss/skill_name.png") 
			setAnchPos(name, 420,600,0.5,0.5)
			logic:getLayer("effect"):addChild(name)
			name:setScale(0)
			
			name:runAction(getSequenceAction(CCEaseElasticOut:create(CCScaleTo:create(1,1)),CCFadeOut:create(1.5),CCCallFunc:create(function()
				name:removeFromParentAndCleanup(true)
			end)))
						
			local frames = display.newFramesWithImage(IMG_PATH .. "image/scene/battle/boss/boss_skill_prep.png" , 9, 3)
			local sprite 
			sprite = display.playFrames(
				atk_hero:getPositionX()  + atk_hero:getContentSize().width / 2, 
				atk_hero:getPositionY() + atk_hero:getContentSize().height / 2,
				frames,
				0.2,
				{
					onComplete = function()
						sprite:removeFromParentAndCleanup(true)	-- 清除自己
						
						
						local eff = display.newFramesWithImage(IMG_PATH .. "image/scene/battle/boss/boss_skill_atk.png" , 10, 2)
						local effSp 
						effSp = display.playFrames(
								atk_hero:getPositionX()  + atk_hero:getContentSize().width / 2, 
								atk_hero:getPositionY() - atk_hero:getContentSize().height / 2,
								eff,
								0.2,
								{
									onComplete  = function()
										effSp:removeFromParentAndCleanup(true)	-- 清除自己
										beAtkAction()
										effectLayer:actions( data )
											-- 恢复战斗进程
										local handle
										local function callback()
											CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
											handle = nil
											logic:resume()
										end
										handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(callback, 0.3, false)
									end
								})			
								effSp:setScale(2)
								logic:getLayer("effect"):addChild(effSp)
					end
				})
			sprite:setScale(2)
			logic:getLayer("effect"):addChild(sprite)
		end
	end
	
	
	local isOtherGame = getIsOtherGame( atk_data["group"] )	--是否是其它游戏
	isOtherGame = false
	
	if data.skill_cid == "3051" then
		be_atkEff()
		return
	end
	
	
	--攻击者效果表现 大于三星则单独页面表现效果
	if tonumber( skillConfig[ data.skill_cid .. "" ].star ) > 3 then
		isBigSkill = true
		ShowSkill:run( atk_hero , heroCell:get( data["be_atk"][1]["group"] , data["be_atk"][1]["index"] ) , { skillID = data.skill_cid , callBack = be_atkEff, isgod = skillConfig[ data.skill_cid.."" ].isgod })
		
		if isNewEff then
			--新技能全部是单体攻击，所以需要展示每个被攻击者身上的效果 ，原版中有群体攻击不必须单独处理
			if table.nums( data["be_atk"] ) > 1 then 
				for i = 2 , table.nums( data["be_atk"]  ) do
					ShowSkill:run( atk_hero , heroCell:get( data["be_atk"][i]["group"] , data["be_atk"][i]["index"] ) , { skillID = data.skill_cid , callBack = be_atkEff, isgod = skillConfig[ data.skill_cid.."" ].isgod })
				end
			end
		end
	else
		isBigSkill = false
		--添加技能名称
		local function commonEff()
			local atkHeroSize = atk_hero:getPositionAndSize()
			
			local sprite
			local frames = display.newFramesWithImage(IMG_PATH .. "image/scene/battle/def_eff.png" , 7 )
			sprite = display.playFrames(
				atkHeroSize._cx, 
				atkHeroSize._cy,
				frames,
				0.1,
				{
					onComplete = function()
						sprite:removeFromParentAndCleanup(true)	-- 清除自己
					end
				}
			)
			sprite:setAnchorPoint( ccp(0.5 , 0.5) )
			if atk_data["group"] == 2 then sprite:setFlipY(true) end
			-- 添加到 特效层
			logic:getLayer("effect"):addChild( sprite )
			
			--[[播放动画]]
			heroAction_move:jumpOnce( atk_hero , { noRecover = true })
			
			--攻击者 技能名称 弹出
	 		local atk_heroSize = atk_hero:getPositionAndSize()
	 		
			local skillTextBg = display.newSprite(IMG_PATH .. "image/scene/battle/skil_text_bg.png")
			local bgSize = skillTextBg:getContentSize()
			local skillText = display.newSprite(IMG_PATH .. ( isOtherGame and "image/scene/godwar/other/" .. isOtherGame .. "/skillAction/text_" or "image/scene/battle/skillAction/text_" ) .. data.skill_cid .. ".png")
			local skillTextSize = skillText:getContentSize()
			setAnchPos( skillText , bgSize.width / 2 , 5 , 0.5 )
			skillTextBg:addChild( skillText )
			
			setAnchPos( skillTextBg , atk_heroSize._cx  ,atk_heroSize._y + atk_heroSize._height , 0.5 )
			logic:getLayer("effect"):addChild( skillTextBg )
			
			
			skillTextBg:setScale(0.3)
			transition.scaleTo(skillTextBg, {
				time = 0.6,
				scale = 1,
				easing = "ELASTICOUT",
			})
		
			transition.fadeOut(skillTextBg, {
				delay = 0.8,
				time = 0.4,
				onComplete = function()
					skillTextBg:removeFromParentAndCleanup(true)	-- 清除自己
				end
			})
		end
		
		
		--攻击者自身效果表现
		local startFun  = CCCallFunc:create(function() atk_hero:setAnchorPoint( ccp( 0.5 , 0.5) ) end )
		local flipx  = CCOrbitCamera:create( 0.3 , 1 , 0 , 0 , 360 , 0 , 0 )
		local delay = CCDelayTime:create(0.1)
		local overFun  = CCCallFunc:create( function() atk_hero:setAnchorPoint( ccp( 0 , 0) ) end )
		
		local array = CCArray:create()
		array:addObject(startFun)
		array:addObject( CCDelayTime:create(0.5) )
		array:addObject( CCCallFunc:create(commonEff) )
		array:addObject(flipx)
		array:addObject(delay)
		array:addObject(overFun)
		array:addObject(CCCallFunc:create(be_atkEff))
		atk_hero:runAction( CCSequence:create(array) )
	end
	

	
	
--[[
	-- 变大过去后的回调
	onComplete = function()
		-- 挥舞动作
		heroAction_attack:wave( atk_hero , {
			onComplete = function()
				-- 掉血
				effectLayer:actions( data )

				-- 回来
				heroAction_move:moveback( atk_hero , {
					onComplete = function()
						-- 恢复战斗进程
						logic:resume()
					end,
				})
			end
		})

		-- 攻击效果(刀光)
		heroAction_attack:normal( atk_hero )
	end]]--
end


return M
