--[[一条数据]]
local KNMask = requires(IMG_PATH , "GameLuaScript/Common/KNMask")
local detailOne = requires(IMG_PATH , "GameLuaScript/Scene/chat/detailOne")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local PATH = IMG_PATH .. "image/scene/chat/"
local PATH_GARDEN = IMG_PATH .. "image/scene/kingGarden/"

local oneMessage = {
	layer,
}

function oneMessage:talknew(data , message_type , params)
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	params = params or {}

	--替换聊天中的称号
	local temp = data.template
	local _, num = string.gsub(temp,"【#s#】", "")
	if num >= 2 then
		data.msg[1] = replaceStr(data.msg[1])
	end
	
	this.layer = display.newLayer()

	local str = self:formatMsg(data["template"] , data["msg"] or {})
	
	if params.type == "world"  and data.item[1] then
		if tonumber( data.item[1].uid ) ~= tonumber( DATA_Session:get("uid") ) then
			str = str .. " -加为好友-"
		end
	end

	local total_width = 410-- 文字总宽度
	local line = 1														-- 行数

	--如果是有红包， 则改变文本框的长度
	if data.source and tonumber(data.source.is_redbag) == 1 then
		total_width = 385
	end

	-- 估算一行的字符数量
	local label = CCLabelTTF:create(str , FONT , params.fontSize or 20)
	local label_size = label:getContentSize()
	local line_height = label_size.height			-- 行高(下面会重新计算)

	if label_size.width > total_width then			-- 大于一行
		line = math.ceil( label_size.width / total_width )
		label:setDimensions( CCSize:new( total_width , line * line_height + 15  ) )
--		label:setDimensions( CCSize:new( total_width ,0) )
	end


	label:setColor( params.color or ccc3( 0x2c , 0x00 , 0x00 ) )
	setAnchPos(label , 0 , 0)
	label:setHorizontalAlignment( 0 )			-- 文字左对齐
	this.layer:addChild( label )

	if data.source and tonumber(data.source.is_redbag) == 1 then 
		--label_size.width % total_width + 5 , -8
		--total_width + 5 , line * line_height - 35

		KNBtn:new( IMG_PATH .. "image/scene/gang/red_packet/" , { "icon.png" } ,total_width + 5 , line * line_height - 20 ,{
			parent = params.parent , 
			priority = params.priority and (params.priority-1) or -132 ,
			callback = function()

				-- if tonumber(data.source.redbag_key)==3 then 
				-- 	return 
				-- end

				
				HTTP:call("alliance","open_redbag",{ redbag_uid = data.source.uid , key = data.source.redbag_key , type = "chat" , redbag_date = data.source.redbag_date },{success_callback = 
						function(_data)
							dump(_data , "_data")
							requires(IMG_PATH,"GameLuaScript/Scene/gang/redPacket"):redPacketDispatcher(_data)
						
						end
					})

				

			end }):getLayer():addTo(label)


		-- label:addChild( display.newSprite( IMG_PATH .. "image/scene/gang/red_packet/icon.png" , label_size.width % total_width + 5 , -8 , 0 , 0 ) )
	end



	local total_height = line * line_height + 16		-- 总高度
	-- 横线
	if not params.first_line then
		local rule = display.newSprite(IMG_PATH .. "image/scene/chat/rule.png")
		setAnchPos(rule , -20 , total_height + 5)	
		this.layer:addChild(rule)

		total_height = total_height + 5
	end
	
--	-- 箭头
--	if has_items then
--		local arrow = display.newSprite(IMG_PATH .. "image/scene/chat/arrow.png")
--		setAnchPos(arrow , 380 , total_height / 2 - 2 , 0 , 0.5)	
--		this.layer:addChild(arrow)
--	end


	this.layer:setContentSize( CCSizeMake( 410 , total_height ) )


	-- 设置可点击
--	if has_items then
		local init_y = 0
		this.layer:registerScriptTouchHandler(function( type , x , y )
		local range = this:getRange()
		if range:containsPoint(ccp(x,y)) and y <params.parent:getY() + params.parent:getHeight() and y > params.parent:getY()  then
			if type == CCTOUCHBEGAN then
					init_y = y
			elseif type == CCTOUCHMOVED then
			elseif type == CCTOUCHENDED then
				if math.abs(y - init_y) < 30 then
				
					if params.type == "friend"  then
						--私聊界面，定位聊天对象
						local curData = data.item
						local tempData
						for i = 1 , #curData do
							if tonumber( curData[i].uid ) ~=  tonumber( DATA_Session:get("uid") ) then
								tempData = curData[i]
							end
						end
						params.backFun( tempData )
					else
						--其它的界面，弹出个人信息与加好友
						
						local curUid
						if params.type == "gang" then
							curUid = data.msg[5]
						elseif params.type == "world" then
							curUid = data.item[1].uid
						elseif params.type == "custom" then
							curUid = data.item[1].uid
						end
						
						if tonumber( curUid ) ==  tonumber( DATA_Session:get("uid") )  then

							KNMsg:getInstance():flashShow("不能查看自己的信息")
							return 
							--不能查看自己的信息
							-- HTTP:call("status" , "get" , {} , {
							-- 	success_callback = function(params)
							-- 		switchScene("userinfo",params)
							-- 	end
							-- })
						else
							HTTP:call("profile","get",{ touid = curUid },{success_callback = 
								function()
									local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
									display.getRunningScene():addChild( otherPalyerInfo:new({priority = (params.priority or -131)-1 }):getLayer() )
								end})
						end
					end
				end
					
			end
			return true
		else
			return false
		end
		end , false , params.priority or -131)
		this.layer:setTouchEnabled(true)
--	end
	
	return this
end


function oneMessage:new(data , message_type , params)
	local this = {}
	setmetatable(this,self)
	self.__index  = self
	params = params or {}
	local type = params.type 
	local parent = params.parent or {}
	this.layer = display.newLayer()
	local bg = display.newSprite( COMMONPATH .. "item_bg.png" , 0 , 0 , 0 , 0 )
	this.layer:addChild( bg )
	this.layer:setContentSize( bg:getContentSize() )
	this.layer:addChild( display.newSprite( PATH .. "item_text_bg.png" , 10 , 10 , 0 , 0 ) )
	local str = self:formatMsg(data["template"] , data["msg"] or {})
--	if type then
--		str = ( type == "world" and "【世界】" or "【帮派】" ) ..  str
--	end
	local has_items = false
	if message_type ~= "talk" and data.item and #data.item > 0 then
		has_items = true
	end

	local total_width = 330												-- 文字总宽度
--	local total_width = has_items and 370 or 410						-- 文字总宽度
	local line = 1														-- 行数



	-- 估算一行的字符数量
	local label = CCLabelTTF:create(str , FONT , params.fontSize or 20 )
	local label_size = label:getContentSize()
	local line_height = label_size.height			-- 行高(下面会重新计算)

	if label_size.width > total_width then			-- 大于一行
		line = math.ceil( label_size.width / total_width )
		label:setDimensions( CCSize:new( total_width , line * line_height +10) )
	end

	label:setColor( params.color or  ccc3( 0xff , 0xfb , 0xd5 ) )
--	label:setColor( params.color or  ccc3( 0x2c , 0x00 , 0x00 ) )
	setAnchPos(label , 20 , 90 , 0 , 1 )
	label:setHorizontalAlignment( 0 )			-- 文字左对齐
	this.layer:addChild( label )


	local total_height = line * line_height + 6		-- 总高度

	local function clickFun()
		local additionInfo = data.item 
	
		local function createElement()
			local tempLayer = baseMask( {  titlePath = PATH .. "operation_title.png" , isShowBack = true } )
			
			if additionInfo[1].type == "wakuang" then
				tempLayer:addChild( display.strokeLabel( additionInfo[1].name .. "申请你保护矿山" , display.cx - 150 , 505 , 20 , ccc3( 0x2c , 0x00 , 0x00 ), nil , nil , {
					dimensions_width = 300 ,
					dimensions_height = 0,
					align = 1
				}))
				--接受
				tempLayer:addChild( KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" } , display.cx - 40 , 400 ,{
											parent = parent , 
											priority = -131 ,
											front = COMMONPATH .. "consent.png"  , 
											callback = function()
													HTTP:call("mining","guard_accept",{ from_uid = additionInfo[1].uid , opt_time = data.time  },{success_callback = 
													function()
														KNMsg.getInstance():flashShow( "保护成功！" )	
													end})
											end }):getLayer() )
--				--拒绝
--				tempLayer:addChild( KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" } , 275 , 400 ,{
--											parent = parent , 
--											priority = -131 ,
--											front = COMMONPATH .. "reject.png"  , 
--											callback = function()
--												tempLayer:remove()
--											end }):getLayer() )
				return		
			end
			
			local roleData = nil	--是否存在角色
			local goods = nil		--是否存在物品
			for i = 1 , #additionInfo do
				if additionInfo[i].uid then
					roleData = additionInfo[i]
				end
				if additionInfo[i].cid then
					goods = additionInfo[i]
				end
			end
			
			local addX , addY = 125 , 500
			if roleData then
				tempLayer:addChild( display.newSprite( PATH .. "role_title.png" , addX , addY  , 0 , 0 ) )
				tempLayer:addChild( KNBtn:new( COMMONPATH , { "big.png" , "big_pre.png" } ,  addX + 75 , addY - 3 ,{
											parent = parent , 
											priority = -131 ,
											text = { { roleData.name , 16 , ccc3( 0 , 0 , 0 ) } }  , 
											callback = function()
												--查看他人信息
												if  tonumber( roleData["uid"] ) ~= tonumber( DATA_Session:get("uid") ) then
													HTTP:call("profile","get",{ touid = roleData.uid },{success_callback = 
													function()
														local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
														display.getRunningScene():addChild( otherPalyerInfo:new( ):getLayer() )
													end})
												end
											end }):getLayer() )

			end
			if goods then
				addY = addY - 65
				local goodsData = getConfig( getCidType( goods.cid ) ,  goods.cid )
				tempLayer:addChild( display.newSprite( PATH .. "goods_title.png" , addX , addY , 0 , 0 ) )
				tempLayer:addChild( KNBtn:new( COMMONPATH , { "big.png" , "big_pre.png" } , addX + 75  , addY - 3 ,{
						parent = parent , 
						priority = -131 ,
						text = { { goodsData.name , 16 , ccc3( 0 , 0 , 0 ) } }  , 
						callback = function()
							awardCell( goods , { getClickFun = true })( { otherAttribValue = goods.figure } )
						end }):getLayer()  )
			end
			if roleData then	
				local addX = ( message_type == "battle" and 76  or ( display.cx - 73 ) )
				local addBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png"  , "btn_bg_red_pre.png" , "btn_bg_red2.png"} , addX  , 370 , {
							scale = true,
							priority = -131 ,
							front = IMG_PATH.."image/scene/userinfo/add_friend.png" , 
							callback = function()
								if tonumber( roleData["uid"] ) ~= tonumber( DATA_Session:get("uid") ) then
									HTTP:call("friends","addfrd",{ id = roleData["uid"] },{success_callback = 
												function()
													tempLayer:remove()
												end})
								else
									KNMsg.getInstance():flashShow( "不能添加自己为好友!" )	
								end
								
							end
							})
				tempLayer:addChild( addBtn:getLayer() )
				
				if message_type == "battle" then
					--战斗回放按钮
					local battleReplayBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png"  , "btn_bg_red_pre.png" , "btn_bg_red2.png"} , 261  , 370 , {
								scale = true,
								priority = -131 ,
								front = PATH .. "battle_replay.png" , 
								callback = function()
									KNMsg.getInstance():flashShow( "暂未开放!" )	
								end
								})
					tempLayer:addChild( battleReplayBtn:getLayer() )
				end
			end
		end
		
		
		if table.nums(additionInfo)~=0 then
			createElement()
			if message_type == "system" then			--系统
	
			elseif message_type == "battle" then		--战报
				
			elseif message_type == "consume" then		--消费
				
			end
		end

	end
	
	local existElement = { 
							system = "system" , 
							battle = "battle" , 
							consume = "consume" ,
							social = "social" ,
							}
	if existElement[message_type] and table.nums( data.item  ) ~= 0 then

		if message_type == "social" and data['item'][1]['type'] == "garden_music" then
			--仙舞接受帝王邀请
			local okBtn = KNBtn:new( COMMONPATH , {"btn_bg.png","btn_bg_pre.png"}, 357 , 53 , {
												parent = parent ,
												front = COMMONPATH .. "jieShouLab.png" ,
												callback = function()
													local mask =self:showXianYinLayer()
													display:getRunningScene():addChild(mask:getLayer())
												end
											}):getLayer()
			this.layer:addChild( okBtn )

		elseif message_type == "social" and data['item'][1]['type'] == "multiFb" then
			--接受多人副本邀请
			local okBtn = KNBtn:new( COMMONPATH , {"btn_bg.png","btn_bg_pre.png"}, 357 , 53 , {
												parent = parent ,
												front = COMMONPATH .. "jieShouLab.png" ,
												callback = function()

														HTTP:call("fubenroom", "hasPermission", {}, {
															success_callback = function()
															    
																switchScene("multiFb", {isForYaoQing=1 , yaoQingRoomId=data['item'][1]['rid'] , fuid=data['item'][1]['uid']} )
															end
														})

														 


												end
											}):getLayer()
			this.layer:addChild( okBtn )	
		else
			local operationBtn = KNBtn:new( COMMONPATH , {"btn_bg.png","btn_bg_pre.png"}, 357 , 53 , {
												parent = parent ,
												front = IMG_PATH .. "image/scene/friend/text_operate.png" ,
												callback = clickFun
											}):getLayer()
			this.layer:addChild( operationBtn )
		end
	end
	
	--邮件领取单独处理
	if  message_type == "mail" then
		local getBtn
		--dump(data.conf)
		
			getBtn = KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" , "btn_bg_dis.png" } , 357 , 53 , {
												parent = parent ,
												front = COMMONPATH .. ( data.recv == 0 and "get.png" or "get_over2.png" ) ,
												callback = function()
													local tempLayer = baseMask( {  titlePath = PATH .. "get_award_title.png" , isShowBack = true } )
													
													local awardBg = display.newSprite( IMG_PATH .. "image/scene/activity_new/shade1.png" , display.cx , display.cy + 40  , 0.5 , 0.5 ) 
													awardBg:setScaleY(1.4)
													tempLayer:addChild( awardBg )
													
													--今天奖励
													local curAward = data.conf or {}
													local scroll = KNScrollView:new( 55 , display.cy - 20 , 360 , 130 , 20 , true , nil , { priority = -140 ,   turnBtn = ( #curAward>4 and  IMG_PATH .. "image/scene/gang/next.png" or nil ) , turnBtnPriority = ( #curAward>4 and -140 or nil ) } )
													for i = 1 , #curAward do
														local curProp = awardCell( curAward[i] ,{ name = true })
														setAnchPos( curProp ,67 + ( i - 1 ) * 94 , 445 )
														scroll:addChild( curProp )
													end
													scroll:alignCenter()
													tempLayer:addChild(scroll:getLayer() )
													
													if data.recv == 0 then
														local getawadsBtn
														getawadsBtn = KNBtn:new( COMMONPATH , {"btn_bg_red.png","btn_bg_red_pre.png"} , display.cx - 73 , display.cy - 75 , {
														priority = - 131 ,
														parent = parent ,
														front = COMMONPATH .. "get.png" ,
														callback = function(  )
															tempLayer:remove()
															HTTP:call("message" , "recv_mail" , { id = data.id } , {
																success_callback = function( tempData )
																	
																	if data.recv == 0 then
																		data.recv = 1
	--																	getBtn:setFront( COMMONPATH .. "get.png" )
	--																	getBtn:setEnable( true )
	--																else
																		getBtn:setFront( COMMONPATH .. "get_over2.png" )
	--																	getBtn:setEnable( false )
																	end
																end
															})	
														end
														})								
														tempLayer:addChild( getawadsBtn:getLayer() )
														getawadsBtn:setEnable( true )
													end
												end
											})
			this.layer:addChild( getBtn:getLayer() )
		if table.nums(data.conf)==0 then --没有奖励数据时，不能点击
			getBtn:setBg(1, COMMONPATH.."btn_bg_dis.png" )
			getBtn:setFront( COMMONPATH .. "get_grey.png" )
			getBtn:setEnable(false)
		end
--		getBtn:setEnable( data.recv == 0 )
	end
	
	return this
end

function oneMessage:formatMsg(str , replace)
	if not str then return "" end

	if type(replace) == "table" and table.nums(replace) > 0 then
		local nums = 0

		str = string.gsub(str , "#s#" , function()
			nums = nums + 1
			if replace[nums] ~= nil then
				local replace_type = type(replace[nums])
				if replace_type == "string" or replace_type == "number" then
					return replace[nums]
				else
					return ""
				end
			end

			return ""
		end)
	end

	local return_str = ""
	while true do
		local start_pos , end_pos , color = string.find(str , "%[color=(#[a-f0-9]+)%]")
		if start_pos == nil then break end
		local start_pos_2 , end_pos_2 = string.find(str , "%[/color%]" , end_pos)
		if start_pos_2 == nil then break end
		local first_str = string.sub(str , 0 , start_pos - 1)
		local second_str = string.sub(str , end_pos + 1 , start_pos_2 - 1)

		return_str = return_str .. first_str .. second_str
		str = string.sub(str , end_pos_2 + 1)
	end


	return return_str .. str
end

function oneMessage:getLayer()
	return self.layer
end


--获取所有父组件，取得按钮的绝对位置
function oneMessage:getRange()
	local x = self.layer:getPositionX()
	local y = self.layer:getPositionY()

	local parent = self.layer:getParent()
	if parent then
		x = x + parent:getPositionX()
		y = y + parent:getPositionY()
		while parent:getParent() do
			parent = parent:getParent()
			x = x + parent:getPositionX()
			y = y + parent:getPositionY()
		end
	end
	return CCRectMake(x,y,self.layer:getContentSize().width,self.layer:getContentSize().height)
end


--显示仙舞层
function oneMessage:showXianYinLayer( )
	local mask
	--local xianYinLayer =CCLayerColor:create( ccc4(152 , 255 , 255 , 100) )   --帮会详情
	local xianYinLayer =display.newLayer()
	setAnchPos(xianYinLayer,0,0,0.5,0.5)

	--背景
	local bg = display.newSprite(PATH_GARDEN.."layerBg.png")
	setAnchPos(bg,20,170)
	xianYinLayer:addChild(bg)

	--标题背景
 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
 	setAnchPos(title_bgSp,90,450)
 	bg:addChild(title_bgSp)

	--标题文字
 	local title_Sp = display.newSprite(PATH_GARDEN.."xianWuTitle.png")
 	setAnchPos(title_Sp,90,450)
 	bg:addChild(title_Sp)

 	--前景
 	local  fg = display.newSprite(PATH_GARDEN .. "xianWuFg.jpg")
 	setAnchPos(fg,10,20)
 	bg:addChild(fg)

 	--粒子
 	local  particleShine = CCParticleSystemQuad:create(PATH_GARDEN .. "shine.plist"); 
 	setAnchPos(particleShine,30,60)
 	fg:addChild(particleShine)
    
    --粒子
 	local  particleBlue = CCParticleSystemQuad:create(PATH_GARDEN .. "blue.plist"); 
 	setAnchPos(particleBlue,85,330)
 	fg:addChild(particleBlue)

	--看仙舞按钮
    local lookXianWuBtn = KNBtn:new(COMMONPATH, {"long_btn.png" , "long_btn_pre.png" }, 150 , 12 , {
			priority = -131,
			scale = true,
			front = PATH_GARDEN .. "guanKanXianWu.png",
			callback = function()
				HTTP:call("socialclass","getmusicaward",{},{success_callback = 
								function(data)
									KNMsg.getInstance():flashShow( data['msg'])	
								end
							})
			end})
	fg:addChild(lookXianWuBtn:getLayer())

	--关闭按钮
    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 0 , 450 , {
			priority = -131,
			scale = true,
			callback = function()
				mask:remove()
			end})
	bg:addChild(close:getLayer())


	mask = KNMask:new({item = xianYinLayer, click = function(x, y)  end})
	return mask
end

return oneMessage
