--[[一条数据]]
local KNMask = requires(IMG_PATH , "GameLuaScript/Common/KNMask")
local detailOne = requires(IMG_PATH , "GameLuaScript/Scene/chat/detailOne")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local json = requires(IMG_PATH,"GameLuaScript/Network/dkjson")--require("GameLuaScript/Network/dkjson")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local PATH = IMG_PATH .. "image/scene/chat/"
local VOICEPATH = PATH .. "voice/"

local voiceItem = {
	layer,
}

function voiceItem:formatTime( greenTime )

	local date = os.date("*t", greenTime ) 

	return  date.hour .. ":" ..  string.format( "%02d" , date.min ) 
end

local function getSizeByDuration(dur)
	local width , height = 93 , 39

	if dur then 
		width =  width + tonumber(dur) * 2
	end

	return CCSizeMake( width , height )
end

function voiceItem:new(data , params)
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	params = params or {}
	-- dump(data , "data")
	-- dump(params , "params")
	
	this.layer = display.newLayer()

	local itemSize = CCSizeMake( 410 , 50 )

	local userInfo = json.decode( data.userInfo )

	local isSelf =  ( userInfo.userName == DATA_User:get("name") )

	local redPoint

	local titleLabel = display.strokeLabel( "【".. (userInfo.userJob or "") .."】" , 0 , 0 , 20 ,ccc3( 0xfe , 0xfb , 0xd2 ) )
	setAnchPos( titleLabel , 0 , itemSize.height - 10 , 0 , 1 )
	this.layer:addChild(titleLabel)

	local nameLabel = display.strokeLabel( ( isSelf and "自己" or userInfo.userName ) .. ":" , titleLabel:getContentSize().width + 10 , 0 , 20 ,ccc3( 0xfe , 0xfb , 0xd2 ) )
	setAnchPos( nameLabel , titleLabel:getContentSize().width + 10 , itemSize.height - 10 , 0 , 1 )
	this.layer:addChild(nameLabel)

	local voiceBtn = KNBtn:new( VOICEPATH , {  isSelf and "selfPlay.png" or "otherPlay.png" } , titleLabel:getContentSize().width + nameLabel:getContentSize().width + 20 , 0 ,{
							scale9 = true,
							scale9Size = getSizeByDuration( data.duration ),
							front = VOICEPATH .. "voice_ani.png",
							priority = -220 ,
							text = { data.duration .. "\"" , 18 , ccc3( 44 , 0 , 1 ) , ccp( 25 , 0 ) , nil , 17 },
							callback = function()
							
								if redPoint then
									redPoint:removeSelf()
									redPoint = nil
									data.isPlayed = true
								end

								if device.platform == "android" then 
									DirectChannel.instance():call(
										{
											clazz = "yunwa",
											action = "yunwa_clcikVoiceBtn",
											voiceId = data.voiceId,
											callback = function()
												
											end
										})
								end
							end })
	this.layer:addChild( voiceBtn:getLayer() )

	if not data.isPlayed  and not isSelf then 
		redPoint = display.newSprite(VOICEPATH .. "redPoint.png" , voiceBtn:getLayer():getContentSize().width  , voiceBtn:getLayer():getContentSize().height  , 1 , 1 )
		voiceBtn:getLayer():addChild( redPoint )
	end


	local timeLabel = display.strokeLabel( self:formatTime( data.time ) ,0  , 0 , 20 ,ccc3( 0xfe , 0xfb , 0xd2 ) )
	setAnchPos( timeLabel , voiceBtn:getLayer():getPositionX() + voiceBtn:getLayer():getContentSize().width + 10 , itemSize.height - 20 , 0 , 1 )
	this.layer:addChild(timeLabel)

	this.layer:setContentSize( itemSize )	


	local init_y = 0
		this.layer:registerScriptTouchHandler(function( type , x , y )
		local range = this:getRange()
		if range:containsPoint(ccp(x,y)) and y <params.parent:getY() + params.parent:getHeight() and y > params.parent:getY()  then
			if type == CCTOUCHBEGAN then
					init_y = y
			elseif type == CCTOUCHMOVED then
			elseif type == CCTOUCHENDED then
				if math.abs(y - init_y) < 30 then
				
					--其它的界面，弹出个人信息与加好友
					
					local curUid = userInfo.uid
					
					if tonumber( curUid ) ==  tonumber( DATA_Session:get("uid") )  then
						KNMsg:getInstance():flashShow("不能查看自己的信息")
						return 
					else
						HTTP:call("profile","get",{ touid = curUid },{success_callback = 
							function()
								local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
								display.getRunningScene():addChild( otherPalyerInfo:new({priority = params.priority-1 }):getLayer() )
							end})
					end
				end
					
			end
			return true
		else
			return false
		end
		end , false , params.priority or -131)
		this.layer:setTouchEnabled(true)

	
	return this

end

--获取所有父组件，取得按钮的绝对位置
function voiceItem:getRange()
	local x = self.layer:getPositionX()
	local y = self.layer:getPositionY()

	local parent = self.layer:getParent()
	if parent then
		x = x + parent:getPositionX()
		y = y + parent:getPositionY()
		while parent:getParent() do
			parent = parent:getParent()
			x = x + parent:getPositionX()
			y = y + parent:getPositionY()
		end
	end
	return CCRectMake(x,y,self.layer:getContentSize().width,self.layer:getContentSize().height)
end

function voiceItem:getLayer()
	return self.layer
end

return voiceItem