-- 设置界面
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNClock = requires(IMG_PATH,"GameLuaScript/Common/KNClock")

local KNInputText

if device.platform == "wp8" then
	KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNEditBox")
else
	KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
end

local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local oneMessage = requires(IMG_PATH , "GameLuaScript/Scene/chat/oneMessage")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local voiceMsgItem = requires(IMG_PATH , "GameLuaScript/Scene/chat/voiceMsgItem")

local PATH = IMG_PATH .. "image/scene/chat/"
local curType , data , group ,  empty_sprite 
local friendData = nil
local isAll = true		--好友聊天中是否显示全部
local newAddX = 35
local newAddY = 50		--输入框新调整坐标
local offSetX , offSetY = 0 , 0
local scroll_y = 480  + newAddY	 
local scroll_height = 310 - newAddY
local delayTime = 5
local allSingleBtn 
local M = {
}
--设置聊天对象

function M:new( params )
	local this = {}
	setmetatable(this , self)
	self.__index = self
	TALK = this
	this.params = params or {}
	this.params.priority = this.params.priority or -129
	curType = params.type or "world"


	if curType == "custom" then
		DATA_Info:setCustomKey( string.join( this.params.custom["sendParams"] , "_") )
	end
	
	friendData = params.friendData
	if friendData then isAll = false end
	
	
	this.baseLayer = display.newLayer()
	this.tabLayer = display.newLayer()
	this.inputLayer =display.newLayer()
	
	DATA_Info:setIsMsg( false )	--消除消息状动画
	
	local mask , layer ,  tableElement 
	layer = display.newLayer()
	
	this.baseLayer:addChild( layer )
	this.baseLayer:addChild( this.tabLayer , 21 )
	
	-- 背景
	layer:addChild( display.newSprite(PATH .. "talk_bg.png" , display.cx , 357 , 0.5 , 0 ) )
	this.baseLayer:addChild( display.newSprite(PATH .. "talk_top_bg.png" , display.cx , 357+431 , 0.5 , 0 ) , 20 )


	--关闭
	local closeBtn = KNBtn:new( PATH , { "close.png" ,"close_press.png"}, 420 , 795 ,
	{
		priority = this.params.priority - 1, 
		callback = 
		function()
			DATA_Info:setIsMsg( false )
			DATA_Info:setIsOpen()
			mask:remove()
		end
	}):getLayer()
	this.tabLayer:addChild( closeBtn )

	
	if curType == "custom" or curType == "server" or curType == "war" or curType == "godwar" then
		tableElement = this.params.custom[ "customTable" ]
	else
		tableElement = { "world" , "gang" , "friend" }
	end
	
	local startX,startY = 20 , 797
	group = KNRadioGroup:new()
	for i = 1, #tableElement do
		local temp = KNBtn:new( PATH , {"btn_gray.png" , "btn_" .. tableElement[i] .. ".png" }  , startX , startY , {
			disableWhenChoose = true,
			priority = this.params.priority - 1, 
			upSelect = true,
			id = tableElement[i],
			front = PATH..tableElement[i].."_text.png" ,
			callback=
			function()
				curType = tableElement[i]
				this:refreshData()
				this:changeStauts( false )
			end
		},group)
		this.tabLayer:addChild(temp:getLayer())
		startX = startX + temp:getWidth() + 18
	end
	group:chooseById( curType , false )	--激活的选项

	-- this:createList()
	this:refreshData()
	this:showChatBox()
	this.baseLayer:addChild( this.inputLayer , 50 )
	
	setAnchPos( this.baseLayer , 0 , display.height )
	transition.moveTo( this.baseLayer , { delay = 0.5 , time = 0.5 , y = 0 , easing = "BACKOUT" })
	mask = KNMask:new( { opacity = 180 , item = this.baseLayer , priority = this.params.priority} )
	
	

	function mask:stopKeyBoard()
		self.textfield:stopInput( true )
		DATA_Info:setIsOpen()
	end
	return mask
end


function M:refreshData()

	if curType == "gang" then

		HTTP:call("alliance" , "getchat" , {} , {
			success_callback = function()
				data = DATA_Info:get_type("gang")
				if data.code == 1  then
					KNMsg:getInstance():flashShow("亲，你还没有加入一个帮会！")
					curType = "world"
					group:chooseById( curType , false )	--激活的选项
					data = DATA_Info:get_type("_G_message_talk")
					if not data then
						group:chooseById( curType , true )
					end
					return
				end
				self:createList( )
			end
		})
	
	elseif curType == "server" or curType =="war" then
		self:createList()
	elseif curType == "custom" then
	
		HTTP:call("message" , "get_scene_msg" , self.params.custom["sendParams"] , {
			success_callback = function()

				self:createList()
			end
		})
	
	end
end

function M:getType()
	return curType
end

function M:addItem( _data , type )
	local i = table.nums( data )
	if i<=1 then
		--小于1时，之前为空，需要重新创建，会自动处理
		self:createList()
	else
		if  _data.msgType and _data.msgType == "gang_voice" then 
			local voiceItem = voiceMsgItem:new( _data , { priority = self.params.priority - 3 , parent = self.scroll })
			self.scroll:addChild( voiceItem:getLayer() )

			self:orderByTime( data , DATA_Info:get_type("gang_voice") )
		else
			local one_message = oneMessage:talknew( _data , nil , {
				type = curType ,
				index = i,
				first_line = true,
				priority = self.params.priority-2,
				parent = self.scroll ,
				color = ccc3( 0xfe , 0xfb , 0xd2 ) ,
				backFun = function( data )  end ,
			})
			self.scroll:addChild( one_message:getLayer() , one_message )
		end
		
		--实时接收到的数据添加进来后 重置滚动条
		if #data > 1 then
			self.scroll:setIndex( i , true )
		end
	end
end

function M:orderByTime( data , voice_data )


	local function tableMerge( dest , src )
		if src and type(src) == "table" then 
			for i,v in ipairs(src) do
				dest[#dest+1] = v
			end
		end
	end

	tableMerge( data , voice_data )

	local function sortByTime( a , b)
		return tonumber(a.time) < tonumber(b.time)
	end

	table.sort( data , sortByTime )
end

function M:createList()

	local layer = display.newLayer()

	if self.viewLayer then
		self.baseLayer:removeChild( self.viewLayer, true )
	end
	
	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )
	self.viewLayer:addChild( layer )
	
	if curType == "gang" then

		scroll_y = 480  + newAddY	 
		scroll_height = 310 - newAddY

		data = DATA_Info:get_type("gang")
		self:orderByTime( data , DATA_Info:get_type("gang_voice") )

	elseif curType == "custom" then

		scroll_y = 400  + newAddY	 
		scroll_height = 385 - newAddY

		data = DATA_Info:get_type( "custom" )
		data = data[ self.params.custom["sendParams"]["scene"] .. "_" .. self.params.custom["sendParams"]["scene_id"] ] or {}
	end

	if #data > 0 then
		-- 展示滚动消息
		self.scroll = KNScrollView:new(35 , scroll_y , 420 , scroll_height , 2 , false , 0 , {priority = self.params.priority - 1})
		for i = 1 , #data do
			if data[i].msgType == "gang_voice" then
				local voiceItem = voiceMsgItem:new( data[i] , { priority = self.params.priority - 3 , parent = self.scroll } )
				self.scroll:addChild( voiceItem:getLayer() )
			else
				local one_message = oneMessage:talknew( data[i] , nil , {
					type = curType ,
					index = i,
					first_line = true,
					parent = self.scroll ,
					color = ccc3( 0xfe , 0xfb , 0xd2 ) ,
					priority = self.params.priority-2,
					backFun = function( tempData )  end ,
				})
				self.scroll:addChild(one_message:getLayer() , one_message)
			end
		end
		--生成后定位
		if #data > 1 then
			self.scroll:setIndex(#data , true)
		end
		layer:addChild( self.scroll:getLayer() )
		
	else
		--没有数据的时候，显示为空
		empty_sprite = display.newSprite(IMG_PATH .. "image/common/empty.png")
		setAnchPos(empty_sprite , display.cx , display.cy + 120 , 0.5 , 0.5)
		layer:addChild( empty_sprite )
	end
	self:showChatBox()
end


function M:changeStauts( status )

	if device.platform == "wp8" then 
		return
	end
	
	local moveLength = 0
	if status == true then
		self.textfield:startInput()
		moveLength = 60
		if #data>0 then
			setAnchPos( self.scroll:getLayer() , 0 , moveLength )
		end
	else
		self.textfield:stopInput( false )
		if #data>0 then
			setAnchPos( self.scroll:getLayer() , 0 , 0 )
		end
	end

	setAnchPos( self.moveLayer , 0 , moveLength )
	setAnchPos( self.textfield:getLayer() , 44 + newAddX + offSetX , 443 + moveLength + newAddY + offSetY)
	
end

local function delayFun()
	delayTime = delayTime - 1
	if delayTime <= 0 then
		KNClock:removeTimeFun( "talk" )
		delayTime = 0
	end
end

function M:sendMsg( str )

	if KNClock:getKeyIsExist("talk") then
		if delayTime ~= 0 then
			KNMsg:getInstance():flashShow("亲，你说话太快了，请隔5秒再发送哦。")
			return
		end
	else

	end

	if str == "" or str == "点击输入信息"  then 
		KNMsg:getInstance():flashShow("没有输入内容")
	elseif  string.utf8len(str) > 45 then	--45个汉字
		KNMsg:getInstance():flashShow("输入内容过长无法发送")
	else
		delayTime = 5
		KNClock:addTimeFun( "talk" , delayFun )
		
		if curType == "gang" then
			HTTP:call("alliance" , "sendchat" , {
				content = str
			} , {
				success_callback = function()
					self:changeStauts(false)
				end
			})
		elseif curType == "custom" then
			local paramsData = clone( self.params.custom["sendParams"] )
			paramsData.content = str
			HTTP:call("message" , "send_scene_msg" , paramsData , {
				success_callback = function()
					self:changeStauts(false)
				end
			})
	
		
		end
	end

	self.textfield:setString("")
end

function M:showChatBox( )

	if curType ~= "gang" then 
		offSetX , offSetY = -25 , -90
	else
		offSetX , offSetY = 0 , 0
	end

	if self.chatBoxLayer then 
		self.chatBoxLayer:removeSelf()
	end

	self.chatBoxLayer = display.newLayer()
	self.inputLayer:addChild( self.chatBoxLayer )

	self.moveLayer = display.newLayer()
	self.chatBoxLayer:addChild( self.moveLayer )

	-- 切换真假输入框的状态
	self.textfield = KNInputText:new( { width = 365 , 
									height = (device.platform == "wp8" and 38 or 28) , 
									size = 20 , 
									defStr = "点击输入信息" , 
									existStr = nil ,
									defColor = ccc3( 0x4d , 0x15 , 0x15 ) , 
									inputColor = ccc3( 0x4d , 0x15 , 0x15 ),
									normalBg = PATH .. "talk_input_bg.png",
									priority = self.params.priority - 1,
									} )
	setAnchPos( self.textfield:getLayer() , 44 + newAddX + offSetX  , 443 + newAddY + offSetY )
	self.chatBoxLayer:addChild( self.textfield:getLayer() , 10 )
	
	local input_bg ,  recordBtn , switchInput , toText , send_btn

	-- 真假输入框的背景
	if device.platform ~= "wp8" then
		input_bg =  KNBtn:new(PATH, {"talk_input_bg.png"} , 28 + newAddX + offSetX, 420 + newAddY + offSetY , {
			priority = self.params.priority - 1,
			callback = function()
				self:changeStauts(true)
			end
			})
		self.moveLayer:addChild(input_bg:getLayer())
	end
	
	--说话提示文字
	toText = display.strokeLabel( ""  ,  130 + newAddX + offSetX , 375  + newAddY + offSetY, 20 , ccc3(0xff , 0xfc , 0xd3 ) , nil , nil ,
				 {
				 	 dimensions_width = 200 , 
				 	 dimensions_height = 30 , 
				 	 align = 0 
			 	})
 	self.chatBoxLayer:addChild( toText )

	
	-- 发送输入框
	send_btn = KNBtn:new(PATH .. "voice", { "sendBtn.png" } , 377 + newAddX + offSetX + ( curType == "gang" and 0 or 10 ) , 420 + newAddY + offSetY, {
		priority = -1000,
		-- priority = self.params.priority - 1,
		text = { "发送" , 18 , ccc3( 44 , 0 , 1 ) , { x = 0 , y = 0 } , nil , 17 }	,
		scale = true,
		noHide = true,
		callback = function()
			self:sendMsg( self.textfield:getString() )
		end
	})

	
	if device.platform == "wp8" then
		self.chatBoxLayer:addChild( send_btn:getLayer(), 11 )
	else
		self.moveLayer:addChild( send_btn:getLayer() )
	end
	
	if device.platform ~= "wp8" then
		-- self:recordImg(self.chatBoxLayer)
		local beginY = 0
		self.inputLayer:setTouchEnabled(true)
		self.inputLayer:registerScriptTouchHandler( 
			function(event,x,y)

				if event == CCTOUCHBEGAN then
					beginY = y
				end
				
				if event == CCTOUCHENDED then
					if math.abs( beginY - y ) < 30 then	--如果是移动则输入入法不消失
						self:changeStauts(false)
					end
				end 
				return true 
			end , false , -222 )
						
	end


	local isKeyBoardOutput = true

	if curType == "gang" then 
		recordBtn = KNBtn:new( PATH .. "voice" , { "pressToTalk.png" , "pressToTalk_pre.png" } , 60 , 418 + newAddY , {
				text = { "按住	说话" , 16 , ccc3( 44 , 0 , 1 ) , { x = 0 , y = 0 } , nil , 17 },
				-- upSelect = true,
				priority = self.params.priority - 1,
				touchBeginCallback = function()
					
					if device.platform == "android" then 
						DirectChannel.instance():call(
							{
								clazz = "yunwa",
								msgType = curType,
								action = "yunwa_startRecord",
								callback = function()
									
								end
							})
					end

				end,

				touchEndCallback = function()

					if device.platform == "android" then 
						DirectChannel.instance():call(
							{
								clazz = "yunwa",
								action = "yunwa_stopRecord",
								callback = function()
									
								end
							})
					else
						local json = requires(IMG_PATH,"GameLuaScript/Network/dkjson")--require("GameLuaScript/Network/dkjson")
						local userInfo = { userName =  DATA_User:get("name") , userJob = "帮主" , uid = DATA_Session:get("uid")  }

						local msg = {
							isPlayed = false,
							name =  DATA_User:get("name") ,
							duration = math.random( 0 , 60),
							userInfo = json.encode(userInfo),
							msgType = "gang_voice",
						}
						DATA_Info:insertVoiceData( "gang" , msg )
					end

					
				end
				})
		recordBtn:setEnable( not isKeyBoardOutput )
		recordBtn:showBtn( not isKeyBoardOutput )
		self.moveLayer:addChild( recordBtn:getLayer() )

		switchInput = KNBtn:new( PATH .. "voice" , isKeyBoardOutput and { "voice.png" } or {"keyboard.png"} , 3 , 420 + newAddY , {
				priority = self.params.priority - 1,
				callback = function()

					isKeyBoardOutput = not isKeyBoardOutput

					recordBtn:setEnable( not isKeyBoardOutput )
					recordBtn:showBtn( not isKeyBoardOutput )

					send_btn:setEnable( isKeyBoardOutput )
					send_btn:showBtn( isKeyBoardOutput )

					input_bg:setEnable( isKeyBoardOutput )
					input_bg:showBtn( isKeyBoardOutput )

					self.textfield:getLayer():setVisible( isKeyBoardOutput )
					self:changeStauts(false)

					switchInput:setBg( 1 , PATH .. "voice/".. (isKeyBoardOutput and "voice.png" or "keyboard.png") )

				end
				})
		self.moveLayer:addChild( switchInput:getLayer() )
	end

	local shortMsgConfig = {
		"不要挂机了",
		"注意防御!",
		"左路攻击!",
		"右路攻击!",
		"注意宝箱!",
		"攻击!",
	}

	if curType == "gang" then 
		for i,v in ipairs(shortMsgConfig) do
			
			local shortMsg = KNBtn:new( PATH .. "voice" , {"shortMsg.png"} , 4 + ( (i-1)%3 )*158 , 331 + newAddY + (i > 3 and 43 or 0) , {
					text = { v or "" , 16 , ccc3( 44 , 0 , 1 ) , { x = 0 , y = 0 } , nil , 17 },
					priority = self.params.priority - 1,
					callback = function()
						self:sendMsg(v or "")
					end
					})
			self.moveLayer:addChild( shortMsg:getLayer() )

		end
	end


end


return M