--[[是物品列表的显示信息，可以传递type来设置显示的元素
	equip,skill,pet,prop,general         表格形式
]]
local PATH = IMG_PATH.."image/common/"
local BAGPATH = IMG_PATH.."image/scene/bag/"
local KNBtn = requires (IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNCheckBox = requires (IMG_PATH,"GameLuaScript/Common/KNCheckBox")
local Property = requires(IMG_PATH, "GameLuaScript/Config/Property")
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local ListItem = {
	layer,
	id,
	optBtn,  --操作按钮
	checkBox,  --选择框
	params,  --传递父组件parent来计算点击的偏移量，iconCallback是点击图按钮的回调，checkBoxOpt,点击复选框的操作
	current,   --点击操作按钮时，此标志为真
	useFunCallBack,--使用道具回调
}

function ListItem:new(type,id,params)
	local this = {}
	setmetatable(this,self)
	self.__index = self
	
	this.layer = display.newLayer()
	this.id = id
	this.params = params or {}

	
	this.layer:setContentSize(CCSizeMake(80,80))
		
	local function createItem()	
		local DATA = {}
		if this.params.data then
			for k,v in pairs(this.params.data) do 
				DATA[k] = v
			end
			DATA.get = 
			function(self,t,cid,key) --为了对应bag函数的方法
				if key == "lv" then
					return 1
				end
				return DATA[cid..""][key] 
			end
		else
			DATA = DATA_Bag
		end
		
		local lvFrame = display.newSprite( BAGPATH .. "lvFrame.png" , 8 , -16 , 0 , 0 ) 
		this.layer:addChild(lvFrame)

		
		-- local lvFrame = display.newSpriteWithFrame(display.newSpriteFrame("lvFrame.png"),this.params.x+55,this.params.y+170+(this.params["sell"] and 50 or 0))
		-- GlOBAL_BATCH:addChild(lvFrame)
		
		if type~="prop" then

			local lv = DATA:get(type,id,"lv")
			local lvStr=""
			-- 幻兽需要自己算等级
			if type == "pet" then
				lv = DATA_Pet:calcExp(DATA:get(type,id,"exp"))
			end

			if lv then
				local tempStr = "Lv"..lv
				if type == "skill" then
					local cid = DATA_Bag:get("skill" , id , "cid")
					local Skill_Config = requires(IMG_PATH , "GameLuaScript/Config/Skill")
					local config_data = Skill_Config[cid..""]
					if tonumber( config_data.isgod ) == 1 then
					 	tempStr = lv .. "段"
					end
				end
				lvStr = tempStr
			end

			
			-- local lvSpFrame = display.newSpriteFrame("lv.png")
			-- local lvSp = display.newSpriteWithFrame(lvSpFrame,this.params.x+45,this.params.y+165+(this.params["sell"] and 50 or 0))
			--GlOBAL_BATCH:addChild(lvSp)
			-- local lvSp = display.newSprite(BAGPATH.."lv.png",20,-16,0,0)
			-- this.layer:addChild(lvSp)
			


			local lvLab = display.strokeLabel(lvStr,20+35-10,-15+10,18, ccc3( 255 , 255 , 255 ) )
			lvLab:setAnchorPoint(ccp(0.5,0.5))
			this.layer:addChild(lvLab,20)
		else
			local num = DATA_Bag:get(type,id,"num")
			local numText =display.strokeLabel(num,20+20,-15+10,18, ccc3( 255 , 255 , 255 ) )
			numText:setAnchorPoint(ccp(0.5,0.5))
			this.layer:addChild(numText,20)
		end
	

		local isNew = DATA:get(type,id,"new")
		if isNew==1 then
			local 	newSp = display.newSprite(BAGPATH.."new.png", 20+15,38 , 0 , 0)
			this.layer:addChild(newSp,2)
			-- local newSp = display.newSpriteFrame("new.png")
			-- local newSp = display.newSpriteWithFrame(newSp,this.params.x+50+20,this.params.y+170+60)
			-- GlOBAL_BATCH:addChild(newSp)
		end
		
		
		this:initOptBtn(type,id)

		if this.params["sell"] then
			this:initCheckBox()
		end
		
		this:setState(type)
	end
	

	createItem()
	
	return this
end

function ListItem:getLayer()
	return self.layer
end

function ListItem:initOptBtn(type,id)
	local icon, iconStr
	local btnStr , btnBg

	local cid = DATA_Bag:get(type , id , "cid") or id

	
	if type == "general" then
		local hero_img_path = IMG_PATH .. "image/hero/"
		if HAS_GOD_GENERAL and DATA_Bag:get(type , id , "god") == 1 then
			hero_img_path = IMG_PATH .. "image/hero/shen/"			-- 天神
		end
		iconStr = hero_img_path .. getImageByType(cid , "s" , true)
	else
		iconStr = getImageByType(cid , "s")
	end

	btnBg = {"btn_bg.png", "btn_bg_pre.png"}
	if self.params["optBtnGrey"] then
		btnBg = {"btn_bg_dis.png"}
	end

	if type == "equip" then
		btnStr = ( ( DATA_User:get("lv") >= 50 and DATA_Bag:isQuench( id ) ) and "quenching.png" or  "strengthen_small.png" ) 
	elseif type == "pet" then
		btnStr = self.params["optBtnGrey"] and "fight_small_grey.png" or "fight_small.png"
	elseif type == "skill" then
		btnStr = self.params["optBtnGrey"] and "up_small_grey.png" or "up_small.png"
	elseif type == "general" then
		btnStr = self.params["optBtnGrey"] and "chuangong_small_grey.png" or "chuangong_small.png"
	elseif type == "prop" then
		btnStr = "use_small.png"
	end
--	iconStr = DATA_Bag:get(type,id,"type").."_icon.png"
--	print(DATA_Bag:get(type,id,"type"))
	
	--若有设置按钮图片,则优先使用
	if self.params["btn_opt"] then
		btnStr = self.params["btn_opt"]
	end
	
	local scale
	if self.params["iconCallback"] then
		scale = true
	end
	
	local other = {}
	local text
	if type == "skill" and DATA_Bag:get("skill", id, "type") == "petskill" then
		table.insert(other,{IMG_PATH.."image/scene/bag/kind_bg.png", 0, 2})
		text = {"兽",16, ccc3(255,255,255), ccp(-20, 23),nil, 17}
	end
	
	table.insert(other, {COMMONPATH.."star_border/border_"..getConfig(type, DATA_Bag:get(type , id , "cid"), "star")..".png", -14, -14})
	
	icon = KNBtn:new(SCENECOMMON,{"skill_frame1.png"},8,8,{
		parent = self.params["parent"],
		front = iconStr ,frontScale = {1,0,3}, 
		priority = self.params["priority"],
		scale = scale,
		other = other,
		text = text,
		callback= self.params["iconCallback"]
	})
	self.layer:addChild(icon:getLayer())	

	--如果装备有阶位，则在装备图标上面加上阶位
	if type == "equip" then 
		local equipData = DATA_Bag:get("equip" , id)
		if equipData and equipData.pro_lv and tonumber(equipData.pro_lv) > 0  then 
			local layer = getZhuanshuLabel( equipData.pro_lv ) 
			setAnchPos( layer , 0 , 13  ,0  ,0 )
			icon:getLayer():addChild( layer , 100 )
		end	
	end


	self.useFunCallBack=function (  )
		self.current = true
		self.params["optCallback"]()
	end

	-- if not self.params["check"] and not self.params["sell"] then
	-- 	self.optBtn = KNBtn:new(PATH , btnBg , 350 , 50 , {
	-- 		front = PATH..btnStr,
	-- 		parent = self.params["parent"],
	-- 		priority = self.params["priority"],
	-- 		callback = 
	-- 		function() 
	-- 			self.current = true
	-- 			self.params["optCallback"]()
	-- 		end
	-- 	})
	--self.layer:addChild(self.optBtn:getLayer())
	--end
end

function ListItem:initCheckBox()
	self.checkBox = KNCheckBox:new(30+18,33+18,{path=PATH,
							parent = self.params["parent"],
							checkBoxOpt = self.params["checkBoxOpt"],
							file={"check_false.png","check_true.png"}})
	
	
	self.layer:addChild(self.checkBox:getLayer())
	self.checkBox:check(self.params["checked"])
end


function ListItem:setState(type)
	local state, str
	if type == "equip" then

		str = DATA_Bag:get("general",DATA_ROLE_SKILL_EQUIP:getRoleId(self.id, type),"name")
		if str then
			local img = display.newSprite(BAGPATH.."chuan.png")
			setAnchPos(img, 53, 53)
			self.layer:addChild(img)
		else 
			--该处将添加阵字图片
			local strZhen
			if G_zhenfa_equip~=nil and table.nums(G_zhenfa_equip)~=0 then 
				for key , v in pairs(G_zhenfa_equip) do
					for key1,v1 in pairs(v) do
						if v1.id == self.id then
							strZhen = getConfig(getCidType(v1.cid),v1.cid, "name")
							break
						end
					end 
				end
			end

			if strZhen then
				local imgBg= display.newSprite(BAGPATH.."zhenBg.png")
				setAnchPos(imgBg, 53, 53)
				self.layer:addChild(imgBg)

				local img = display.newSprite(BAGPATH.."zhen.png")
				setAnchPos(img, 55, 57)
				self.layer:addChild(img)
			end

		end




	elseif type == "general" then
		if DATA_Formation:checkIsExist(self.id) then
			if self.params.greyBg then
				state = display.newSprite(BAGPATH.."shangzhen.png")
				--state = display.newSpriteWithFrame(display.newSpriteFrame("shangzhen.png"),self.params.x+50+20,self.params.y+170+57)
			else
				state = display.newSprite(BAGPATH.."shangzhen.png")
				--state = display.newSpriteWithFrame(display.newSpriteFrame("shangzhen.png"),self.params.x+50+20,self.params.y+170+57)
			end
				--GlOBAL_BATCH:addChild(state)
			 setAnchPos(state, 53-15,53-15)
			 self.layer:addChild(state)
		else
			if DATA_Info:get_type("zhenfa") then 
				for i,v in pairs(DATA_Info:get_type("zhenfa")) do
					if tonumber(v) == tonumber(self.id) then 
						state = display.newSprite(BAGPATH.."zhenfa.png")
						setAnchPos(state, 53-15,53-15)
						self.layer:addChild(state)
						break
					end
				end
			end
		end
	elseif type == "pet" then
		if DATA_Pet:getFighting() == self.id then
			state = display.newSprite(BAGPATH.."shangzhen.png")
			setAnchPos(state,53-15,53-15)
			self.layer:addChild(state)
			
		end
	elseif type == "skill" then
		if DATA_Bag:get(type,self.id,"type") == "generalskill" then
			str = DATA_Bag:get("general",DATA_ROLE_SKILL_EQUIP:getRoleId(self.id, type),"name")
			if str then

				local img = display.newSprite(BAGPATH.."chuan.png")
				setAnchPos(img, 53, 53)
				self.layer:addChild(img)

				-- local chuanSp = display.newSpriteFrame("chuan.png")
				-- local chuanSp = display.newSpriteWithFrame(chuanSp,self.params.x+50+30,self.params.y+170+70)
				-- GlOBAL_BATCH:addChild(chuanSp)
				
			end
		else
			str = DATA_Bag:get("pet",DATA_PetSkillDress:isDress(self.id),"name")		
			if str then

				local img = display.newSprite(BAGPATH.."chuan.png")
				setAnchPos(img, 53, 53)
				self.layer:addChild(img)
				
				-- local chuanSp = display.newSpriteFrame("chuan.png")
				-- local chuanSp = display.newSpriteWithFrame(chuanSp,self.params.x+50+30,self.params.y+170+70)
				-- GlOBAL_BATCH:addChild(chuanSp)
				
			end
		end	
	end



end


function ListItem:getX()
	if self.params["parent"] then
		return self.layer:getPositionX() + self.params["parent"]:getX() + self.params["parent"]:getOffsetX()
		end
	return self.layer:getPositionX()
end

function ListItem:getY()
	if self.params["parent"] then
		return self.layer:getPositionY() + self.params["parent"]:getY() + self.params["parent"]:getOffsetY()
	end
	return self.layer:getPositionY()
end


function ListItem:getWidth()
	return self.layer:getContentSize().width
end

function ListItem:getHeight()
	return self.layer:getContentSize().height
end

function ListItem:isSelect()
	return self.checkBox:isSelect()
end

function ListItem:getUseFun()
	return self.useFunCallBack
end

function ListItem:check(bool)
	self.checkBox:check(bool)
end

function ListItem:isCurrent()
	return self.current
end

function ListItem:resetCurrent()
	self.current = false
end

function ListItem:getId()
	return self.id
end

function ListItem:getOptBtn()
	return self.optBtn
end

function ListItem:getCheckbox()
	return self.checkBox
end

return ListItem