-- 跨服玩家信息
local PATH = IMG_PATH.."image/scene/userinfo/"
local COMMONPATH = IMG_PATH .. "image/common/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local M = {

}


function M:new( params )
	params = params or {}

	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	this.layer = display.newLayer()
	local content = display.newLayer()
	-- 背景
	local bg = display.newSprite(COMMONPATH .."bg.png")
	setAnchPos(bg , 13 , 200)
	content:addChild(bg)

	local list_title_bg = display.newSprite(COMMONPATH .. "list_title.png")
	setAnchPos(list_title_bg , 25 , 633)
	content:addChild(list_title_bg)

	local title = display.newSprite(COMMONPATH .. "player_info_title.png")
	setAnchPos(title , 138 , 633)
	content:addChild(title)
	

	-- 创建他人基本信息
	local curData = DATA_OTHER:get("base")
	local function createUserLayer()
	
		local userInfoLayer = display.newLayer()
		
		local infoBg = display.newSprite(PATH.."info_bg.png")	
		setAnchPos(infoBg , 245 , 670 , 0.5 , 0.5)
		userInfoLayer:addChild(infoBg)
		
		--玩家头像
		infoBg = display.newSprite(COMMONPATH .. getHeadPath( curData.sex ))
		setAnchPos( infoBg , 57 , 630 )
		userInfoLayer:addChild(infoBg)
		
		infoBg = display.newSprite(COMMONPATH.."role_frame.png")
		setAnchPos(infoBg,56,627)
		userInfoLayer:addChild(infoBg)
		
		--名称显示
		local text = display.newSprite(PATH.."name.png")
		setAnchPos( text , 130 , 680 )
		userInfoLayer:addChild(text)
		
		if curData.viplv ~= 0 then
			userInfoLayer:addChild( display.newSprite(  IMG_PATH.."image/scene/vip/v" .. curData.viplv .. ".png" , 210 , 680 , 0 , 0 ) )
		end
		text = display.strokeLabel( curData.name , ( curData.viplv ~= 0 and 250 or 210 ) , 678 , 24 , ccc3(0x4a,0x08,0x08) )
		userInfoLayer:addChild(text)
		
		--称号显示
		text = display.newSprite(PATH.."title.png")
		setAnchPos(text,130,635)
		userInfoLayer:addChild(text)
		
		if curData.chenghao["1"].type == 1 then
			local str ="v0.png"
			for i = 1, #getTitle() do
				if not curData.rank or tonumber(curData.rank) > 10 then
				
				elseif tonumber(curData.rank) > getTitle()[i][1] then
					str = "v"..(i - 1)..".png"
					break
				end
			end
			text = display.newSprite(PATH..str)
			setAnchPos(text, 210, 635)
			userInfoLayer:addChild(text)
		else
			text = display.newSprite(PATH.."p"..curData.chenghao["1"].rank..".png")
			setAnchPos(text, 210, 635)
			userInfoLayer:addChild(text)
		end

		
		
		local detailBg = display.newSprite( IMG_PATH.."image/scene/activity_new/new_pkgame/".."person_detail_bg.png" )	
		setAnchPos(detailBg,245,457,0.5)
		userInfoLayer:addChild(detailBg)
		detailBg:setScaleY(0.9)
		
		local config = requires(IMG_PATH, "GameLuaScript/Config/User")
		local commanderValue = config[curData.lv..""]["lead"]

		local showElement = {
				{ text = "id" 		, value = curData.touid 	} ,													--玩家id
				{ text = "level" 	, value = curData.lv 	} ,														--玩家等级
				{ text = "server_name"		, value = curData[ "server_name" ]} ,									--大区
				{ text = "value"	, value = curData.ability	} ,													--玩家战力
				{ text = "on"		, value = curData[ "formation_count" ].."/" .. curData[ "formation_max" ]	} ,	--上阵武将
				{ text = "gang"		, value = 	curData.alliance} ,													--帮会
		}

		local addX , addY
		for i = 1 , #showElement do
			local curData = showElement[i]
			if curData.text ~= "" then
				addX = 60 + ( i - 1 ) % 2 * 212
				addY = 560 - math.floor( ( i - 1 ) / 2 ) * 45
				local pathStr = PATH .. curData.text .. ".png"
				if curData.text == "gold" or curData.text == "silver" then
					pathStr = COMMONPATH .. curData.text .. ".png"
				end
				
				userInfoLayer:addChild( display.newSprite( pathStr , addX , addY , 0 , 0  ) )
				addX = addX + 93
				if curData.text == "on" then
					addX = addX + 18
				elseif curData.text == "vip_text" then
					addX = addX + 10
				elseif curData.text == "gold" or curData.text == "silver" then
					addX = addX - 50
				end
				userInfoLayer:addChild( display.strokeLabel(curData.value , addX  , addY , 20 , ccc3( 0xff , 0xfb , 0xd4 ) ) )
			end
		end
		
		setAnchPos(userInfoLayer , 0 , -110)
		return userInfoLayer
	end
	
	content:addChild( createUserLayer() )
	
	
	
	
	--close按钮
	local closeBtn = KNBtn:new(IMG_PATH .. "image/scene/chat/", { "close.png"  , "close_press.png" } ,  display.cx + 27 + 163  , 235 + 377  , {
	scale = true,
	priority = -220,
	callback = function()
		this.layer:removeFromParentAndCleanup( true )
	end
	}):getLayer()
	content:addChild(closeBtn)

	--关闭按钮
	local closeBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png"  , "btn_bg_red_pre.png" } ,  160  , 240  , {
	scale = true,
	front = COMMONPATH .. "colse_text.png" , 
	priority = -220,
	callback = function()
		this.layer:removeFromParentAndCleanup( true )
	end
	}):getLayer()
	content:addChild(closeBtn)
	


	-- 遮罩
	local mask = KNMask:new({item = content , priority = -220})
	this.layer:addChild( mask:getLayer() )

	
    return this
end

function M:getLayer()
	return self.layer
end

return M