-- 常用基本元素
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNClock = requires(IMG_PATH,"GameLuaScript/Common/KNClock")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")

--标题
function createTitle( titlePath , params )
	params= params or {}
	
	local addX = 0
	local addY = 0
	local offX = params.offX or 0
	
	local titleBg = display.newSprite( IMG_PATH .. "image/scene/mission/title_bg.png")
	setAnchPos(titleBg, addX , addY , 0.5 , 0.5 )
	
	local title = display.newSprite( titlePath )
	setAnchPos(title, titleBg:getContentSize().width/2 - title:getContentSize().width/2 - 24 + offX  , addY + titleBg:getContentSize().height/2 ,  0 , 0.5 )
	titleBg:addChild(title)
	
	return titleBg
end
--延迟时间
function delayFun( time , _fun)
	local handle
	local function tempFun()
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
		handle = nil
		_fun()
	end
	handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(tempFun , time , false)
end
--移除对像
function delObj( _obj )
	if _obj then
		if _obj[ "getLayer" ] then
			xpcall( function() _obj:getLayer():removeFromParentAndCleanup(true) end , function() _obj = nil end )	-- 清除自己
		else
			_obj:removeFromParentAndCleanup(true)	-- 清除自己
		end
		_obj = nil 
	end
end
--两点间角度计算
function countAngle( params )
	params = params or {}
	
	local dx = params.cutP.x - params.nextP.x
	local dy = params.cutP.y - params.nextP.y 
	
	local distance = math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))
	local degree = -math.deg(math.acos(dx / distance))	--角度
	
	--横线X相等，转90
	if params.cutP.y < params.nextP.y then
		--一二像限
		if params.cutP.x < params.nextP.x then--下个点X大于上个点
			--第一像限
			degree = degree - 90
			
			if math.abs( degree ) > 180 then 
				degree = math.abs( degree - 90 )
			end
			
		elseif params.cutP.x == params.nextP.x then
			degree = -180
		else
			--第二像限
			degree = math.abs( degree )
			
		end
	else
		--三四像限
		if params.cutP.x < params.nextP.x then
			--第三像限
			degree = degree
		elseif params.cutP.x == params.nextP.x then
			degree = 0
		else
			--第四像限
			degree = degree
		end
	end
	
	return degree
end
--弹出提示奖励
function showAwards( params )
	params = params or {}
	local data = params.data or {}
	local backFun = params.backFun or function()end
	local isShowTitle = true

	local offsetX = params.offsetX or 0
	
	local isShowConfirm = true
	if params.noConfirm then
		isShowConfirm = false
	end
	if params.noTitle then
		isShowTitle = false
	end
	local isShowStar = true
	if params.noStar then
		isShowStar = false
	end
	
	local tempLayer = baseMask( {  titlePath = ( isShowTitle and IMG_PATH.."image/scene/task/complete_title.png" or nil ) , isConfirm = ( isShowConfirm and { path = COMMONPATH .. "confirm.png" , confirmFun = backFun } or nil ) } )	
	if params.showAwardBg then
		local bgFrame = display.newSprite( params.showAwardBg["path"] , display.cx + params.showAwardBg["offX"] , 336 + params.showAwardBg["offY"] , 0.5 , 0 ) 
		bgFrame:setScale( params.showAwardBg.scale )
		tempLayer:addChild( bgFrame )
		
	end
	
	local cidGather = {}
	if data.awards then
		for key , v in pairs( data.awards ) do
			if key ~= "drop" then
				cidGather[#cidGather+1] = { cid = key , num = v }
			end
		end
		if data.awards.drop then
			for key , v in pairs( data.awards.drop ) do
				cidGather[#cidGather+1] = { cid = key , num = v }
			end
		end
	end
	
	if data.award then
		cidGather = data.award
	end
	
	if #cidGather < 5 then
		local initX = display.cx - ( #cidGather - 1 )/2 * ( 100 + offsetX )
		for i = 1 , table.nums( cidGather ) do
			local item = awardCell( cidGather[i] , { star = isShowStar , nameColor = ccc3( 0x2c , 0x00 , 0x00 ) , name = true } )
			setAnchPos( item ,  initX + ( i - 1 ) * ( 100 + offsetX ) - 33  , 460 , 0 , 0 )
			tempLayer:addChild( item )
		end
	else
		local scroll = KNScrollView:new( 52 , 400 , 370 , 170 , 50 , true , nil , { priority = -140 , turnBtn = IMG_PATH .. "image/scene/gang/next.png" , turnBtnPriority = -140  } )
		for key , v in pairs( cidGather ) do
			local item = awardCell( v , { star = isShowStar , nameColor = ccc3( 0x2c , 0x00 , 0x00 ) , name = true } )
			
			scroll:addChild( item )
			scroll:alignCenter()
		end
		tempLayer:addChild( scroll:getLayer() )
	end
	return tempLayer 
end
--单选按钮列表
function tableList( params )
	params = params or {}
	local layer = display.newLayer()	
	local listConfig = params.listConfig
	local clickFun = params.clickFun or function()end
	local curType =params.def or listConfig[1]
	local startX,startY = params.x or 10 , params.y or 596
	local group = KNRadioGroup:new()
	
	for i = 1, table.nums( listConfig.config ) do
		local curValue = listConfig.config[i]
		local oneStr = listConfig.path ..curValue ..".png"
		local twoStr = listConfig.ending and listConfig.path ..curValue.. listConfig.ending .. ".png" or listConfig.path ..curValue.."_select.png"
		local temp = KNBtn:new( COMMONPATH.."tab/", {"tab_star_normal.png","tab_star_select.png"}, startX , startY , {
			disableWhenChoose = true,
			upSelect = true,
			id = listConfig.config[i] ,
			front = { oneStr , twoStr } ,
			callback=
			function()
				clickFun( listConfig.config[i] )
			end
		},group)
		layer:addChild(temp:getLayer())
		startX = startX + temp:getWidth() + 18
	end
	group:chooseById( curType , true )	--激活的选项
	
	layer:addChild( display.newSprite( COMMONPATH.."tab_line.png"  , 6 , startY - 3 , 0 , 0 ) )		--分隔线
	return layer
end
--常用弹出界面
function baseMask( params )
	params = params or {}
	local isBackBtn = params.isShowBack or false--时否显示返回按钮
	local isConfirm = params.isConfirm or nil --是否有确定按钮
	local bgInfo = params.bgInfo or { path = COMMONPATH .. "tip_bg.png" ,  y = 336 }
	local titlePath = params.titlePath or nil	--是否有标题
	
	local mask
	local layer = display.newLayer()
	local bg = display.newSprite( bgInfo.path , display.cx , bgInfo.y , 0.5 , 0 )
	layer:addChild( bg )
	
	if type(titlePath) == "string" then
		local titleSp = createTitle(titlePath)
		setAnchPos( titleSp , display.cx + 50 , bgInfo.y + bg:getContentSize().height + 10  , 0.5 , 0.5  )
		layer:addChild( titleSp ) 
	elseif type(titlePath) == "table" then
		local titleSp = createTitle(titlePath.path)
		setAnchPos( titleSp , display.cx + 50 + ( titlePath.offX or 0 ) , bgInfo.y + bg:getContentSize().height + 10 + ( titlePath.offY or 0 ) , 0.5 , 0.5  )
		layer:addChild( titleSp ) 
	end
	
	if isBackBtn then
		local addX = type(isBackBtn) == "table" and isBackBtn.x or 30 
		local addY = type(isBackBtn) == "table" and isBackBtn.y or 545 
		--退出界面
		local priorityDefault=-131
		if params.special then 
			priorityDefault=-150
		else
			priorityDefault=-131
		end 
		dump(priorityDefault)
		layer:addChild( KNBtn:new( COMMONPATH , { "back_img.png" , "back_img_press.png" } , addX , addY , {
								priority = ( type( params.isShowBack ) == "table" and params.isShowBack.priority or  priorityDefault  or priorityDefault ),
								callback = function()
									if type(isBackBtn) == "table" and isBackBtn.backFun then
										isBackBtn.backFun()
									end
									mask:remove()
								end
								} ):getLayer() )
	end
	if isConfirm then
		--确定界面
		layer:addChild( KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , display.cx - 73 ,  bgInfo.y + ( type( isConfirm ) == "table" and isConfirm.offy or 20 )  , {
								priority = -131 ,
								front = type( isConfirm ) == "table" and isConfirm.path or COMMONPATH .. "confirm.png" , 
								callback = function()
									mask:remove()
									if type( isConfirm ) == "table" and  isConfirm.confirmFun then
										isConfirm.confirmFun()
									end
								end
								} ):getLayer() )
	end
	
	if params.noAction then
		setAnchPos( layer , 0 , 0 , 0 , 0 )
	else
		setAnchPos( layer , 0 , display.height , 0 , 0 )
		transition.moveTo( layer , { delay = ( params.delay or 0 ) , time = 0.5 , y = 0 , easing = "BACKOUT"})
	end
	
	mask = KNMask:new({ item = layer , priority = params.priority or  -130 })
	local scene = display.getRunningScene()
	scene:addChild( mask:getLayer() )
	
	function layer:remove()
		mask:remove()
	end
	function layer:getBg()
		return bg
	end
	return layer
end


--奖励道具
--tipStr 自定义提示 
function awardCell( awardData , params )
	params = params or {}
	local rejectElement = {
				skill_coin = { name ="技能币" , desc = "技能币：用于兑换技能" , star = nil } ,
				ly = { name ="灵源点" , desc = "灵源点：用于神格的开启和进阶" , star = nil } ,
				sg = { name ="神格碎片" , desc = "神格碎片：用于点燃阵位神火" , star = nil } ,
				qy = { name ="气运点" , desc = "气运点：用于神格的进阶" , star = nil } ,
				vipexp = { name ="VIP经验" , desc = "VIP经验：用于提升VIP等级" , star = nil } ,
				silver = { name ="银两" ,  desc = "银两: 游戏中的普通货币"  , star = nil } , 
				honor = { name ="荣誉" ,  desc = "荣誉: 帮派商城中所需的货币，可在帮战中获得"  , star = nil } , 
				gold = { name = "黄金" , desc = "黄金: 游戏中的充值货币"  , star = nil} , 
				task_tribute = { name = "帮威" , desc = "帮威:用于帮会商店购买宝石、装备"  , star = nil} , 
				task_exp = { name = "帮贡" , desc = "帮贡:用于帮会升级和帮会商店道具开启"  , star = nil} , 
				task_power = { name = "体力" , desc = "体力:用于闯关的消耗"  , star = nil} , 
				power = { name = "体力" , desc = "体力:用于闯关的消耗"  , star = nil} , 
				funds = { name = "资金" , desc = "资金:用于帮会升级和帮会商店道具开启"  , star = nil} , 
				chip1 = { name = "一星装备碎片" , desc = "一星装备碎片:用于打造二星装备"  , star = 1} , 
				chip2 = { name = "二星装备碎片" , desc = "二星装备碎片:用于打造三星装备"  , star = 2} , 
				chip3 = { name = "三星装备碎片" , desc = "三星装备碎片:用于打造四星装备"  , star = 3} , 
				chip4 = { name = "四星装备碎片" , desc = "四星装备碎片:用于打造五星装备"  , star = 4} , 
				soul1 = { name = "一星英雄将魂" , desc = "一星英雄将魂:用于合成二星英雄"  , star = 1} , 
				soul2 = { name = "二星英雄将魂" , desc = "二星英雄将魂:用于合成三星英雄"  , star = 2} , 
				soul3 = { name = "三星英雄将魂" , desc = "三星英雄将魂:用于合成四星英雄"  , star = 3} , 
				soul4 = { name = "四星英雄将魂" , desc = "四星英雄将魂:用于合成五星英雄"  , star = 4} , 
				hld = { name = "皇力点" , desc = "皇力点数，皇力排行榜前18名可额外增加跨服战的资格赛中的每日去提升排名的次数。 "  , star = nil} , 
				animal1 = { name = "一星兽魂" , desc = "一星兽魂:用于合成二星幻兽"  , star = 1} , 
				animal2 = { name = "二星兽魂" , desc = "二星兽魂:用于合成三星幻兽"  , star = 2} , 
				animal3 = { name = "三星兽魂" , desc = "三星兽魂:用于合成四星幻兽"  , star = 3} , 
				animal4 = { name = "四星兽魂" , desc = "四星兽魂:用于合成五星幻兽"  , star = 4} , 
				card10	= { name = "10元月卡" , desc = "购买10元月卡可获1200黄金,分30天领取"  , star = nil } , 
				card30	= { name = "30元月卡" , desc = "购买30元月卡可获3000黄金,分30天领取"  , star = nil } , 
				card50	= { name = "50元月卡" , desc = "购买50元月卡可获5100黄金,分30天领取"  , star = nil } , 
				card78	= { name = "78元季卡" , desc = "购买78元季卡可获14400黄金,分90天领取"  , star = nil } , 
				crystal	= { name = "能量水晶" , desc = "封神战中用于提升出战英雄、幻兽等级"  , star = nil } , 
				skill_money	= { name = "封神币" , desc = "用于提升龙脉等级"  , star = nil } , 
				["10000"]	= { name = "大黄金袋" , desc = "打开随机获得:100~150黄金"  , star = nil } , 
				["10001"]	= { name = "宝石袋" , desc = "打开随机获得5~10个成品宝石"  , star = nil } , 
				["10002"]	= { name = "银币袋" , desc = "打开随机获得:50000~80000银币"  , star = nil } , 
				["10003"]	= { name = "鸡血袋" , desc = "打开随机获得1~3个小鸡血丸,一定几率额外可获1个大鸡血丸"  , star = nil } , 
				["10004"]	= { name = "小黄金袋" , desc = "打开随机获得50~100黄金"  , star = nil } , 
				["10005"]	= { name = "传功丹袋" , desc = "打开随机获得5~15个普通传功丹,一定几率额外可获1个秘制传功丹"  , star = nil } , 
				["10006"]	= { name = "装备碎片袋" , desc = "打开随机获得2星装备碎片3~6个,一定几率额外可获3星装备碎片x1"  , star = nil } , 
	 	}
	if params.getPropConf then 
		return rejectElement
	end

	if params.isNormal then
		local isNormal = true
		if rejectElement[awardData["cid"] .. "" ] then
			isNormal = false
		end
		return isNormal
	end
	local typeValue = ( (not rejectElement[ awardData["cid"] .. "" ]) and awardData["cid"] ~= "体力" and awardData["cid"] ~= "扫荡令" ) and  getCidType(awardData["cid"]) or nil
	local isStar = tonumber( string.sub( awardData["cid"] , -1) ) ~= 0 and tonumber( string.sub( awardData["cid"] , -1) ) or nil --是否自带星级 
	if params.noStarColor then isStar = false end	--屏蔽rejectElement中 cid值为数字但没有star值的道具展示错误星期颜色
	
	local isPetskill = ( typeValue == "petskill" )	--是否是宠物技能
	local function clickFun( tempParams )
		tempParams = tempParams or {}
		if params.tipStr then
			KNMsg.getInstance():flashShow( params.tipStr )
			return
		end
	 	--当点击图标按钮后先从全局数据中查找是否存在数据，若没有则请求网络，否则隐藏用户信息栏，显示详细界面
	 	if (not rejectElement[ awardData["cid"] .. "" ]) and awardData["cid"] ~= "体力" and awardData["cid"] ~= "扫荡令"  then
			local detail_type = getCidType(awardData["cid"])
			local data = getConfig( detail_type , awardData["cid"] )
			
			data["cid"] = awardData["cid"]
			data["lv"] = awardData["lv"]
			if tempParams.otherAttribValue then		--系统消息中 他们装备攻击值等无法前台计算，由后台处理
				data.otherAttribValue = tempParams.otherAttribValue
			end
			pushScene("detail" , {
				detail = detail_type,
				data = data,
			})
		else
			local str = ""
			if ( rejectElement[ awardData["cid"] .. "" ] ) then str = replaceStr( rejectElement[ awardData["cid"].. "" ].desc ) 
			elseif awardData["cid"] == "power" then str = "每次喝酒可获".. awardData.num .. "点体力"
			elseif awardData["cid"] == "扫荡令" then str = "每次喝酒可获10个扫荡令"
			end
			KNMsg.getInstance():flashShow( str )
		end
	end
	if params.getClickFun then
		return clickFun
	end
	local textData
	if params.noNumConver == true then 
		textData = awardData.num and { { awardData.num , 14 , ccc3( 0xff , 0xff , 0xff ) , { x = 20 , y = -22 }  , nil , 17 } }or nil
	else
		textData = awardData.num and { {( tonumber( awardData.num ) < 10000 and tonumber( awardData.num ) or math.floor(tonumber( awardData.num )/10000) .. "万" ) , 14 , ccc3( 0xff , 0xff , 0xff ) , { x = 20 , y = -22 }  , nil , 17 } }or nil
	end
	
	
	
	local otherData = nil
	if typeValue then
		otherData = otherData or {}
		otherData[#otherData + 1 ] =  {COMMONPATH.."star_border/border_".. getConfig( typeValue , awardData["cid"], "star") ..".png", -14, -15 }
	else
		if isStar then
			otherData = otherData or {}
			otherData[#otherData + 1 ] = {COMMONPATH.."star_border/border_".. isStar ..".png", -14, -15 } 
		end
	end
	
	
	if awardData.num then
		otherData = otherData or {}
		if not params.nonum then
			otherData[#otherData + 1 ] = { IMG_PATH .. "image/scene/activity_new/num_bg.png" , 34 , 0 }
		end
	end
	
	
	if isPetskill then
		otherData = otherData or {}
		otherData[ #otherData + 1 ] = {IMG_PATH.."image/scene/bag/kind_bg.png", 0 , 2 }
	end
	

	if params.noNumAndBg then
		textData = nil
		otherData=nil
	end
	
	if params.name then
		textData = textData or {}
		local nameStr
		if rejectElement[awardData.cid .. "" ]  then
			nameStr = replaceStr( rejectElement[awardData.cid .. ""].name )
		else
			nameStr = getConfig( getCidType( awardData.cid ) , awardData.cid , "name" )	
		end
		
		table.insert( textData, { nameStr ,  ( type(params.name) == "table" and ( params.name.size or 14 ) or 14 ) , ( type(params.name) == "table" and ( params.name.color or ccc3( 0x2c , 0x00 , 0x00 ) )or ccc3( 0x2c , 0x00 , 0x00 ) ) , { x = 0 , y = ( type(params.name) == "table" and ( params.name.offy or 0 ) or 0 ) + ( params.star and - 70 or -50 ) } , nil , 17 } )
		
		if isPetskill then
			table.insert( textData, {"兽",16, ccc3(255,255,255), ccp(-20, 23),nil, 17}  )
		end
	end
	
	local star
	if params.star then
		if rejectElement[ awardData.cid .. "" ] then
			star = rejectElement[ awardData.cid .. "" ].star
		else
			star = getConfig( getCidType( awardData.cid ) ,  awardData.cid , "star" )
		end
		if star then
			otherData = otherData or {}
			for j = 1 , star do
				table.insert( otherData, { IMG_PATH .. "image/scene/home/star.png" ,  7 - star * 12 + j * 24  , ( type(params.star) == "table" and ( params.star.offy or 0 ) or 0 )  - 27 } )
			end
		end
	end

    local iconPath = getImageByType( awardData.cid , "s")

   
	local equipBtn = KNBtn:new( SCENECOMMON , 
								{ "skill_frame1.png" } ,
								 0 , 0 , 
								 { 
								 	parent = params.parent , 
								 	priority = params.priority or -130,
								 	scale = not params.noScale,
								 	front = iconPath , 
								 	other = otherData , 
								 	text = textData ,
								 	callback = function()
									 	if params.noClick then
										 	return
										end
										if params.ClickFun then
											params.ClickFun()
											return 
										end
										clickFun()
							 		 end
								 })
	if params.getLayer then
		return equipBtn , star
	end
	return equipBtn:getLayer() , star
end
--跳转场景
function gotoScene( name )
	if 		name == "equip_dismantling" then	--装备分解
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 2})
	elseif 	name == "hero_dismantling" 	then	--英雄分解
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 1})
	elseif 	name == "fjly" 	then				--灵源
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 5})
	elseif 	name == "evolve_general" 	then	--炼成4星英雄进化符1次
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 4})
	elseif 	name == "pet_hatch" 	then	--银两孵化任意幻兽蛋10次
		local check_result = checkOpened("pet")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene( "incubation" )
	elseif 	name == "pet_dismantling" 	then	--宠物分解
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 3})
	elseif 	name == "equipup" 			then	--装备强化
		switchScene("bag",{kind = "equip", offset = 2 })
	elseif 	name == "cuilian" 			then	--装备淬炼
		switchScene("bag",{kind = "equip", offset = 2 })
	elseif 	name == "equip_fuse" 		then	--装备合成
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 2})
	elseif 	name == "hero_fuse" or name == "hero_dingxiang_fuse"		then	--英雄合成
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 1})
	elseif 	name == "pet_fuse" 			then	--宠物合成
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 3})
	elseif 	name == "hero_upgrade" 		then	--进化三星以上任意英雄1次
		HTTP:call("general" , "get",{},{success_callback =
						function()
							DATA_General:haveGet(true)
							DATA_Formation:set_index(1)
							switchScene("hero",{gid = DATA_Formation:getCur() })
						end
					})
	elseif 	name == "pet_upgrade" 		then	--进化三星以上任意幻兽1次
		switchScene( "pet" )
	elseif 	name == "mission" 			then	--前去挑战14_15关卡2次
		DATA_Mission:setByKey("current","map_id",DATA_Mission:get("max","map_id"))
		DATA_Mission:setByKey("current","mission_id",DATA_Mission:get("max","mission_id"))
		HTTP:call("mission" , "get",{},{success_callback = function()
			switchScene("mission")
		end })
	elseif 	name == "insequip" or name == "insequip_wajue" then	--前去藏宝楼挑战5_7关卡
		local check_result = checkOpened("fb_equip")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("fb" , { coming = "equip"})
	elseif 	name == "inspet" 			then	--前去皇家狩猎10次
		local check_result = checkOpened("fb_equip")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("fb" , { coming = "pet"})
	elseif 	name == "insskill" 			then	--在快活林进行5回抡骰子
		local check_result = checkOpened("fb_equip")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("fb" , { coming = "skill"})
	elseif 	name == "skillfb" 			then	--通关多人副本1次
		local check_result = checkOpened("fb_equip")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("fb" , { coming = "multi"})
	elseif 	name == "xingyuan" 			then	--开启星源点
		-- 判断等级开放
		local check_result = checkOpened("forge")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("forge" , { index = 5})
	elseif 	name == "penglai" 			then	--进行1次高级招将
		local check_result = checkOpened("fb_equip")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("fb" , { coming = "hero"} )
	elseif 	name == "pet_gold" 			then	--黄金孵化幻兽蛋
		local check_result = checkOpened("pet")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene( "incubation" )
	elseif 	name == "athletics" or name == "athletics_award"	then	--竞技场挑战
		local check_result = checkOpened("athletics")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene( "pvp" , { coming = "athletics"} )
	elseif 	name == "rob" 				then	--夺宝
		local check_result = checkOpened("athletics")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("pvp" , {coming = "rob"} )
	elseif 	name == "mining" or name == "mining_buy_buff" or name == "mining_receive" then	--矿山
		local check_result = checkOpened("athletics")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene("pvp" , {coming = "diggings"} )
	elseif 	name == "bangzhan" or name == "qifu" then	--帮战
		local check_result = checkOpened("gang")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end

		--帮派
		HTTP:call("alliance", "get", {},{success_callback = 
		function()
			switchScene( "gang" )
		end})
	elseif 	name == "lueduo" 			then	--掠夺战
		local check_result = checkOpened("gang")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		--帮派
		HTTP:call("alliance", "get", {},{success_callback = 
		function()
			switchScene("gang")
		end})
	elseif 	name == "defense" 			then	--参与1次驻防
		local check_result = checkOpened("gang")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		--帮派
		HTTP:call("alliance", "get", {},{success_callback = 
		function()
			switchScene("gang")
		end})
	elseif 	name == "socialclass" 		then	--进入皇权中发生一次战斗
		local check_result = checkOpened("athletics")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end
		switchScene( "pvp" , { coming = "power"} )
	elseif 	name == "pay" 				then	--一次性充值50黄金
		switchScene("pay")
	elseif 	name == "pluse" 			then	--给经脉镶嵌1颗宝石
		-- 判断等级开放
		local check_result = checkOpened("pulse")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end

		local hero = DATA_Formation:get_index(1)
		if DATA_General:haveGet() then
			HTTP:call("pulse" , "get", { id = hero.gid } , {
				success_callback = function()
					switchScene("pulse" , hero.gid)
				end
			})
		else
			HTTP:call("general" , "get",{} , {
				success_callback = function()
					HTTP:call("pulse" , "get", { id = hero.gid } , {
						success_callback = function()
							switchScene("pulse" , hero.gid)
						end
					})
				end
			})
		end
	elseif 	name == "chat_gang" 				then	--在帮会聊天中发言1次
		switchScene("home")
		
		local function delay()
			local curTalk
			local talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/talk")
			curTalk = talkLayer:new( {type = "gang" } )
			local curScene = display.getRunningScene()
			curScene:addChild( curTalk:getLayer()  )
		end
		delayFun( 0.01 , delay )
	elseif 	name == "chat_world" 				then	--在世界聊天中发言1次
		switchScene("home")
		
		local function delay()
			local curTalk
			local talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/talk")
			curTalk = talkLayer:new( {type = "world" } )
			local curScene = display.getRunningScene()
			curScene:addChild( curTalk:getLayer()  )
		end
		delayFun( 0.01 , delay )
	elseif 	name == "shop" 				then	--在商城中购买1个喇叭
		if DATA_Shop:haveData() then
			switchScene("shop")
		else
			HTTP:call("shop","get",{},{success_callback=
				function()
					switchScene("shop")
				end
			})
		end
	elseif 	name == "qiecuo" 			then	--对2个好友发起切磋
		local check_result = checkOpened("friend")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end

		HTTP:call("friends","get",{},{success_callback=
		function()
			switchScene("friend")
		end})
	elseif 	name == "zhufu" 			then	--对2个好友发起祝福
		local check_result = checkOpened("friend")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end

		HTTP:call("friends","get",{},{success_callback=
		function()
			switchScene("friend")
		end})
	elseif 	name == "fuchou" 			then	--对2个仇人发起复仇
		local check_result = checkOpened("friend")
		if check_result ~= true then
			KNMsg:getInstance():flashShow(check_result)
			return
		end

		HTTP:call("friends","get",{},{success_callback=
		function()
			switchScene("friend")
		end})
	end
end

--奖励领取提示
function inform( data , info )
	if data.awards then
		local str = ""
		local decollator = "    "	--分割符
		
		if info then
			str = info
		end

		local function countDrop( dropData )
			local tempStr = ""
			for key , v in pairs( dropData ) do	
				local curName = getConfig( getCidType( key ) , key , "name" )
				tempStr = tempStr .. curName .. "  +" .. v .. decollator
			end
			return tempStr
		end
		local isBox = false
		for key , v in pairs( data.awards ) do
			if key == "power"			then str = str .. "体力  +" .. v
			elseif key == "skill_coin"	then str = str .. "技能币  +" .. v
			elseif key == "qy"			then str = str .. "气运点  +" .. v
			elseif key == "ly"			then str = str .. "灵源点  +" .. v
			elseif key == "sg"			then str = str .. "神格碎片  +" .. v
			elseif key == "vipexp"		then str = str .. "VIP经验  +" .. v
			elseif key == "gold"		then str = str .. "黄金  +" .. v
			elseif key == "honor"		then str = str .. "荣誉  +" .. v
			elseif key == "silver"		then str = str .. "银币  +" .. v
			elseif key == "task_tribute"then str = str .. "帮威  +" .. v
			elseif key == "task_exp"	then str = str .. "帮贡  +" .. v
			elseif key == "funds"		then str = str .. "资金  +" .. v
			elseif key == "task_power"	then str = str .. "体力  +" .. v
			elseif key == "power"		then str = str .. "体力  +" .. v
			elseif key == "chip1"		then str = str .. "一星装备碎片  +" .. v
			elseif key == "lingyuan"	then str = str .. "灵源值  +" .. v
			elseif key == "chip2"		then str = str .. "二星装备碎片  +" .. v
			elseif key == "chip3"		then str = str .. "三星装备碎片  +" .. v
			elseif key == "chip4"		then str = str .. "四星装备碎片  +" .. v
			elseif key == "soul1"		then str = str .. "一星英雄将魂  +" .. v
			elseif key == "soul2"		then str = str .. "二星英雄将魂  +" .. v
			elseif key == "soul3"		then str = str .. "三星英雄将魂  +" .. v
			elseif key == "soul4"		then str = str .. "四星英雄将魂  +" .. v
			elseif key == "animal1"		then str = str .. "一星兽魂  +" .. v
			elseif key == "animal2"		then str = str .. "二星兽魂  +" .. v
			elseif key == "animal3"		then str = str .. "三星兽魂  +" .. v
			elseif key == "animal4"		then str = str .. "四星兽魂  +" .. v
			elseif key == "crystal"		then str = str .. "能量水晶  +" .. v
			elseif key == "skill_money"		then str = str .. "封神币  +" .. v

			elseif key == "_tip_"		then str = str .. v isBox = true 
			elseif key == "drop"	then str = str .. countDrop( v )
			end
			str = str ..  decollator
		end
		
		if string.len(str) > 150 then
			str = string.sub( str , 0, 150 ) .. " ..."
		end
		
		if isBox then
			KNMsg.getInstance():boxShow( str ,{ 
												confirmText = COMMONPATH .. "confirm.png" , 
												confirmFun = function()  end , 
												} )
		else
			KNMsg.getInstance():flashShow( str )
		end
	elseif data.addStr then
		KNMsg.getInstance():flashShow( data.addStr )
	end
end

function getZhuanshuLabel(Lv)
	local layer = display.newLayer()
	local bg = display.newSprite( IMG_PATH .. "image/scene/goldequip/zhuanshu/zhuanshu_bg.png" , 0 , 0 ,0 , 0 )
	local size = bg:getContentSize()
	layer:setContentSize( size )
	layer:addChild( bg )
	layer:addChild( display.newSprite( IMG_PATH .. "image/scene/goldequip/zhuanshu/" .. Lv .. ".png" , -3 , 18 , 0 , 0  ) )
	layer:addChild( display.newSprite( IMG_PATH .. "image/scene/goldequip/zhuanshu/zhuanshu_label.png" , 9,31 , 0, 0 ) )

	local effect = requires(IMG_PATH,"GameLuaScript/Common/KNEffect")
	effect.get(IMG_PATH .. "image/scene/goldequip/zhuanshu/", "zhuanshu_eff"):pos(31,23):addTo(layer):scale(1.05)

	return layer
end

function showOpenNewModel( params )
	audio.playSound(IMG_PATH .. "sound/upgrade.mp3")
	local layer = display.newLayer()
	local mask = KNMask:new({ item = layer ,  opacity = 230 })
	
	--背景层
	local layerBg = display.newSprite( IMG_PATH .. "image/scene/upgrade/" .. "layer_bg.png")
	setAnchPos( layerBg , display.cx , display.cy , 0.5 , 0.5 )
	layer:addChild(layerBg)

	--背景
	local bg = display.newSprite( IMG_PATH .. "image/scene/upgrade/" .. "bg.png")
	setAnchPos( bg , display.cx + 4 , display.cy + 30 , 0.5 , 0.5 )
	layer:addChild(bg)

	local title_text = display.strokeLabel( params.title_text or "" , display.cx - 50 , display.cy + 20 , 24 , ccc3(25,91,110) , nil , nil , {
		dimensions_width = 200,
		dimensions_height = 112,
		align = 0,
	}) 
	layer:addChild( title_text )

	--文字
	local text = display.strokeLabel( params.text or "" , display.cx - 100 , display.cy - 42 , 18 , nil , nil , nil , {
		dimensions_width = 200,
		dimensions_height = 112,
		align = 0,
	}) 
	layer:addChild( text )

	-- 按钮
	local okBtn = KNBtn:new(
		COMMONPATH ,
		{ "btn_bg_red.png" , "btn_bg_red_pre.png"} ,
		display.cx - 80 ,
		display.cy - 125 , 
		{
			scale = true ,
			priority = -130,
			front = params.frontStr , 
			callback = function()
				if params.okBtnCallback then 
					params.okBtnCallback()
				end
			end
		}
	)
	layer:addChild( okBtn:getLayer() )
	
	transition.moveTo(layer , {time = 1 , x = 0 , easing = "ELASTICOUT" })

	return mask
end
