-- 设置界面
local PATH = IMG_PATH .. "image/scene/headline/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNRadioGroup = requires(IMG_PATH, "GameLuaScript/Common/KNRadioGroup")
local M = {
	layer , 
	baseLayer,
	scrollLayer,
}


function M:new()
	local this = {}
	setmetatable(this , self)
	self.__index = self
	local mask
	this.layer = display.newLayer()
	this.baseLayer = display.newLayer()
	
	if DATA_HeadLine:get("_ranking_headlines_state") ~= true then
		return "no headlines"
	end

	-- 背5
	local bg = display.newSprite(PATH .. "frame.png")
	setAnchPos( bg , display.cx , display.cy , 0.5 , 0.5 )
	this.layer:addChild( bg )
	this.layer:addChild( display.newSprite( PATH .. "headline_title_bg.png" , display.cx , 495 , 0.5 , 0  ) )
	this.layer:addChild( display.newSprite( PATH .. "headline_title.png" , display.cx , 635 , 0.5 , 0  ) )
	this.layer:addChild( display.newSprite( PATH .. "bg.png" , display.cx , 90 , 0.5 , 0  ) , -2)

	local helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png","help_press.png"}, 390 , 625 , {
			priority = -220,
			scale = true,
			callback = function()
				local mask

				local tempLayer =display.newLayer()
				--背景
				local bg = display.newSprite(IMG_PATH.."image/scene/chat/".."info_bg_big.png")
				setAnchPos(bg,240,150, 0.5)
				tempLayer:addChild(bg)
				--标题背景
			 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
			 	setAnchPos(title_bgSp,100,520)
			 	bg:addChild(title_bgSp)
				--标题文字
			 	local title_Sp = display.newSprite(COMMONPATH.."help_title.png")
			 	setAnchPos(title_Sp,65,520)
			 	bg:addChild(title_Sp)

			 	local str = "1.获得以下光辉事件的玩家,次日开始,记录在每日头条中\n"..
					 		"1.1至尊武道大会单赛区的冠军 \n"..
					 		"1.2至尊武道大会至尊赛的冠军\n"..
					 		"1.3本服武道大会冠军\n"..
					 		"1.4每届的第一帮帮主 \n"..
					 		"1.5每日单服消费榜首\n"..
					 		"2.当有新的头条玩家产生时,将取代原本在该类头条展示的玩家,并且置顶\n"..
					 		"3.当同一条有多个头条需要展示时,展示优先权:至尊武道大会至尊赛冠军＞至尊武道大会单赛区冠军＞第一帮帮主＞本服武道大会冠军＞每日消费榜首 \n"..
					 		"4.如果玩家觉得还有哪些类事件可以上头条,请登录论坛留言,我们将择优采取大家的宝贵意见\n"


			 	local helpTips = createLabel({str = str , x = 40, y = 55,size = 20, width = 370,color = ccc3(46 , 18 , 14)})
			 	-- bg:addChild(helpTips)

			 	local scroll = KNScrollView:new( 20 , 200 , 440 , 450 , 20 , false , 0 , { priority = -230} )
			 	scroll:addChild(helpTips)
				scroll:alignCenter()
				tempLayer:addChild(scroll:getLayer() )

			 	--关闭按钮
			    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 510 , {
						priority = -221,
						scale = true,
						callback = function()
							mask:remove()
						end})
				bg:addChild(close:getLayer())
			 	mask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -220})
			 	this.layer:addChild(mask:getLayer(), 10)
			end
	})
	this.layer:addChild(helpBtn:getLayer() , 0)


	--关闭
	local closeBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 72 , 120 ,
	{
		priority = -210,
		front = COMMONPATH .. "colse_text.png" ,
		callback = 
		function()
			mask:remove()
			switchScene("home")
		end
	}):getLayer()
	this.layer:addChild( closeBtn )

	this:createScrollLayer()
	
	this.layer:setScale(0.1)
	transition.scaleTo(this.layer , {time = 0.1 , scale = 1 , easing = "BACKOUT" })
	setAnchPos( this.layer , 0 , 0 )
	
	mask = KNMask:new({ item = this.layer , priority = -210 })

	this.baseLayer:addChild(mask:getLayer())
	-- return mask
	return this
end

function M:createScrollLayer()
	if self.scrollLayer then 
		self.layer:removeChild( self.scrollLayer , true)
	end
	dump(DATA_HeadLine:get())
	local scroll = KNScrollView:new( 20 , 174 , 440 , 440 , 10 , false , 0 , { priority = -212} )
	local headline_data = DATA_HeadLine:get("list")
	scroll:alignCenter()
	for i=1 , #headline_data do 
		local tempLayer = self:createItem(headline_data[i])
		scroll:addChild( tempLayer )
	end

	scroll:alignCenter()
	self.scrollLayer = display.newLayer()
	self.scrollLayer:addChild( scroll:getLayer() )

	self.layer:addChild( self.scrollLayer )
end


function M:createLaPiaoLayer(isShowAction)

	local lapiao_data = DATA_HeadLine:get("set_up")
	local tempLayer = display.newLayer()
	local mask = KNMask:new({ item = tempLayer , priority = -240 })

	local tempImg = display.newSprite( PATH .. "lapiao_bg.png" )
	setAnchPos( tempImg , 240 , 148 , 0.5  )
	tempLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "lapiao_frame.png" )
	setAnchPos( tempImg , 240 , 288 , 0.5  )
	tempLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "lapiao_title.png" )
	setAnchPos( tempImg , 240 , 589 , 0.5  )
	tempLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "kuizengmobaizhe.png" )
	setAnchPos( tempImg , 240 , 504 , 0.5  )
	tempLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "canUse.png" )
	setAnchPos( tempImg , 105 , 361 )
	tempLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "everyTime.png" )
	setAnchPos( tempImg , 108 , 445  )
	tempLayer:addChild( tempImg )

	local function getIndexByvalue(value)
		for k , v in pairs(lapiao_data.config_1) do
			if v == value then 
				return k
			end
		end
	end

	local num_count = 0
	local num_type = getIndexByvalue( lapiao_data.index ) or 1

	local num_text = display.strokeLabel( "" , 317 , 360 , 20, ccc3( 0xdf , 0x2e , 0x43 ) ) 
	tempLayer:addChild( num_text )

	local time_text = display.strokeLabel( "" , 302 , 247 , 16, ccc3( 0xdf , 0x2e , 0x43 ) ) 
	tempLayer:addChild( time_text )


	-- local action = CCRepeatForever:create( CCBlink:create(1 , 1) )
	-- num_text:runAction(action)
	-- transition.blink(time_text, { time = 1 , num = 4 , forever = true})

	tempLayer:addChild( display.strokeLabel( "已有"..(lapiao_data.num or 0).."人领取你的馈赠" , 88 , 190 , 16, ccc3( 0 , 0 , 0 ) ) )
	tempLayer:addChild( display.strokeLabel( "当离开头条时，剩余的黄金将直接退还给你！" , 88 , 168 , 16, ccc3( 0 , 0 , 0 ) ) )

	local nextTime = lapiao_data.endtime or 0
	local timeCount = 0 
	local function refreshTime()
		nextTime = nextTime - 1
		local nextTimeStr =  timeConvert( nextTime )
		if nextTime <= 0 then
			time_text:setString("冷却时间：00:00:00")
		else 
			time_text:setString( "冷却时间："..replaceStr( nextTimeStr ) )
		end
	end
	local handler = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(refreshTime , 1 , false)
	refreshTime()
	
	local num_group = KNRadioGroup:new()
	for i = 1, #lapiao_data.config_1 do
		local goldImg = display.newSprite( COMMONPATH .. "gold.png" )
		setAnchPos( goldImg , 130 + (i - 1) * 105 , 407  )
		tempLayer:addChild( goldImg )

		tempLayer:addChild(	display.strokeLabel( lapiao_data.config_1[i] or "" , 164 + (i - 1) * 105 , 407 , 20, ccc3( 0 , 0 , 0 ) ) )

		local btn = KNBtn:new(IMG_PATH .. "image/scene/multiFb/hire", {"normalPoint.png" , "selectedPoint.png"},100 + (i - 1) * 105 , 407, {
			upSelect = true,
			priority = -240,
			callback = function()
				num_type = i
			end
		}, num_group)
		tempLayer:addChild(btn:getLayer())
	end
	num_group:chooseByIndex(num_type, true)

	for i = 1 , #lapiao_data.config_2 do
		local add_btn = KNBtn:new( PATH , {"add_frame.png"} , 138 + (i-1)*130 , 309 , {
			priority = -240,
			front = PATH .. "add_"..lapiao_data.config_2[i].."_text.png",
			other = { COMMONPATH .."gold.png" , 11 , 5 }, 
			scale = true,
			callback = function()
				num_count = num_count + lapiao_data.config_2[i]
				num_text:setString("+" .. num_count)
			end})
		tempLayer:addChild( add_btn:getLayer() )
	end

	local save_btn = KNBtn:new( COMMONPATH , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 160, 231 , {
			front = PATH .. "save_text.png",
			priority = -240,
			callback = function()
				print("save")
				-- if num_count == 0 then 
				-- 	KNMsg:getInstance():flashShow("保存失败,馈赠总额不足")
				-- 	return 
				-- end

				HTTP:call("headlines", "set_up", { index = lapiao_data.config_1[num_type] , sum = num_count },{
					success_callback = function(data)
						if handler then
							CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handler)
							handler = nil
						end	
						dump(data)
						self:createScrollLayer()
						-- DATA_Dragon:set( data )
						KNMsg:getInstance():flashShow(data.return_msg)
						mask:remove()
						self.baseLayer:addChild( self:createLaPiaoLayer():getLayer() )
					end
				})

			end})
	tempLayer:addChild( save_btn:getLayer() )

	local num_btn = KNBtn:new( PATH , {"num_frame.png"} , 230, 355 , {
			priority = -240,
			text = {lapiao_data.sum_money.."" or "" , 20 , ccc3( 255 , 255 , 255 )},
			disable = true , 
			callback = function()

			end})
	tempLayer:addChild( num_btn:getLayer() )

	local helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png","help_press.png"}, 397 , 552 , {
			priority = -241,
			scale = true,
			callback = function()
				local helpMask

				local helpLayer =display.newLayer()
				--背景
				local bg = display.newSprite(IMG_PATH.."image/scene/chat/".."info_bg_big.png")
				setAnchPos(bg,240,150, 0.5)
				helpLayer:addChild(bg)
				--标题背景
			 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
			 	setAnchPos(title_bgSp,100,520)
			 	bg:addChild(title_bgSp)
				--标题文字
			 	local title_Sp = display.newSprite(COMMONPATH.."help_title.png")
			 	setAnchPos(title_Sp,65,520)
			 	bg:addChild(title_Sp)

			 	local str = "1.在今日头条上的用户,可对自己进行拉票\n"..
					 		"2.拉票可选择 \"1黄金\"\"3黄金\"\"5黄金\"3种拉票形式,且投入黄金,保存后,其他用户可以在膜拜榜中,看到膜拜可获得的黄金,来拉动其他用户膜拜\n"..
					 		"3.设定馈赠金额后,每次玩家对你进行膜拜,将扣除你设定的回馈金额的黄金,给予到对你进行膜拜的用户账号中,直到黄金扣除完为止\n"..
					 		"4.当用户已经下了今日头条,但是可用馈赠总额还有剩余时,黄金将自动全部退还到该头条用户账号中\n"..
					 		"5.每次保存设定后,会有10分钟的冷却时间,冷却时间内将无法进行更改保存 \n"
					 		
			 	local helpTips = createLabel({str = str , x = 40, y = 55,size = 20, width = 370,color = ccc3(46 , 18 , 14)})
			 	-- bg:addChild(helpTips)

			 	local scroll = KNScrollView:new( 20 , 200 , 440 , 450 , 20 , false , 0 , { priority = -251} )
			 	scroll:addChild(helpTips)
				scroll:alignCenter()
				helpLayer:addChild(scroll:getLayer() )

			 	--关闭按钮
			    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 510 , {
						priority = -251,
						scale = true,
						callback = function()
							helpMask:remove()
						end})
				bg:addChild(close:getLayer())
			 	helpMask = KNMask:new({item = helpLayer, click = function(x, y)  end ,priority= -250})
			 	tempLayer:addChild(helpMask:getLayer(), 10)
			end
	})
	tempLayer:addChild(helpBtn:getLayer() , 0)
	
	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 25 , 543 , {
			priority = -240,
			scale = true,
			callback = function()
				if handler then
					CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handler)
					handler = nil
				end	
				mask:remove()
			end})
	tempLayer:addChild(close:getLayer())

	if isShowAction then
		setAnchPos( tempLayer , 0 , display.height , 0 , 0 )
		transition.moveTo( tempLayer , { time = 0.5 , y = 0 , easing = "BACKOUT"})
	end

	return mask
end


function M:createItem(param)
	local tempLayer = display.newLayer()

	local item_bg = display.newSprite(PATH .. "item_frame.png")
	setAnchPos( item_bg , 0 , 0 )
	tempLayer:addChild(item_bg)

	local item_line = display.newSprite(PATH .. "item_line.png")
	setAnchPos( item_line , 190 , 124 , 0.5 )
	tempLayer:addChild(item_line)

	item_line = display.newSprite(COMMONPATH .. "gold.png")
	setAnchPos( item_line , 281 , 12 , 0.5 )
	tempLayer:addChild(item_line)

	item_line = display.newSprite(COMMONPATH .. "silver.png")
	setAnchPos( item_line , 184 , 12 , 0.5 )
	tempLayer:addChild(item_line)

	local icon = KNBtn:new(COMMONPATH, { getHeadPath(param.img) },5,48,{
		priority = -212 ,
		-- other = {COMMONPATH.."role_frame.png", -1, -3},
		front = COMMONPATH.."role_frame.png",
		parent = scroll,
		callback = function()
			
		end 
	} )
	tempLayer:addChild(icon:getLayer())

	local lv_bg =display.newSprite( COMMONPATH .."equip_lv_bg.png" )
	setAnchPos( lv_bg , 50 , 100 )
	tempLayer:addChild( lv_bg )

	local worship_btn

	if tonumber(param.uid) == tonumber(DATA_User:get("uid")) then
		worship_btn = KNBtn:new( PATH, { "lapiao_btn.png" , "lapiao_btn_pre.png" }, 0, 0 , {
			priority = -212 ,
			front = PATH .. "lapiao_text.png" , 
			parent = scroll ,
			callback = function()
				HTTP:call("headlines", "get", { },{
					success_callback = function(data)
						self.baseLayer:addChild(self:createLaPiaoLayer(true):getLayer() , 10)
					end
				})
			end 
		} )
	else
		worship_btn = KNBtn:new(COMMONPATH, { "btn_bg.png" , "btn_bg_pre.png" }, 0, 0 , {
			priority = -212 ,
			front = PATH .. "worship_text.png" , 
			parent = scroll ,
			callback = function()
				HTTP:call("headlines", "worship", { touid = param.uid },{
					success_callback = function(data)
						dump(data)
						KNMsg:getInstance():flashShow( data.return_msg or "" )
					end
				})
			end 
		} )
	end
	tempLayer:addChild(worship_btn:getLayer())

	local lv_label = display.strokeLabel( param.lv or "" , 88 , 87 , 18, ccc3( 255 , 255 , 255 ) )
	setAnchPos( lv_label , lv_bg:getContentSize().width / 2,0 , 0.5 )
	lv_bg:addChild( lv_label )

	tempLayer:addChild( display.strokeLabel( param.name or "" , 88 , 87 , 18, ccc3( 0xff , 0xfb , 0xd4 )  ) )
	tempLayer:addChild( display.strokeLabel( param.game or "", 220 , 87 , 18, ccc3( 0x5a , 0xf7 , 0xf5 ) ))
	tempLayer:addChild( display.strokeLabel( param.content or ""  , 88 , 51 , 18, ccc3( 0xff , 0xfb , 0xd4 )))
	tempLayer:addChild( display.strokeLabel( "膜拜得：" , 88 , 15 , 18, ccc3( 0xff , 0xfb , 0xd4 ) ) )

	tempLayer:addChild( display.strokeLabel( param.silver or "", 210 , 15 , 18, ccc3( 0xff , 0xfb , 0xd4 ) ))
	tempLayer:addChild( display.strokeLabel( param.gold or "", 305 , 15 , 18, ccc3( 0xff , 0xfb , 0xd4 ) ))


	tempLayer:setContentSize( CCSizeMake(item_bg:getContentSize().width , 127) )

	return tempLayer
end

function M:getLayer()
	return self.baseLayer
end

return M