-- 全局变量
GLOBAL_INFOLAYER = nil




local PATH = IMG_PATH .. "image/scene/common/"
local FRIENDINFOPATH = IMG_PATH .. "image/scene/friend/helpToFight/"

--[[
    用户信息及底部控制按钮层，可以由其他场景直接添加，创建时须要提供对应的layerName并以此来设置底部按钮的选中状态
    layerName取值｛首页：home , 背包:bag , 酒馆:tavern，消息：msg , 商城:shop , 设置:setting｝
    可以使用showInfo函数来设定是否显示用户信息栏
]]
local KNBar = requires(IMG_PATH , "GameLuaScript/Common/KNBar")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local SelectList = requires(IMG_PATH,"GameLuaScript/Scene/common/selectlist")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local InfoLayer = {
	userInfoLayer,  --用户信息
	navigationLayer, -- 导航栏
	msgLayer,          --聊天信息栏
	layer,      --功能层
	chooseBtn,   --当前选中的按钮项
	title,
	back_btn,
	view_type,
}
local scroll

function InfoLayer:new(layerName , view_type , params)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.params = params or {}
	if view_type == nil then view_type = 1 end
	this.view_type = view_type
	this.msgText = nil

	-- 首页的元素拆分开
	this.layer = display.newLayer()
	this.layer:setTag(8888)

	local delayTime = false
	delayFun( 0.01 , function() delayTime = true end)

	--隐藏信息背景
	if not this.params["title_hide"] then
		this.title = this.params.titleBg and display.newSprite(this.params.titleBg) or display.newSprite(PATH .. "title_" .. view_type .. ".png")
		setAnchPos(this.title , 0 , display.height - this.title:getContentSize().height)
		this.layer:addChild( this.title )

		if view_type == 0 then
			this.back_btn = KNBtn:new(COMMONPATH, {"back_img.png" , "back_img_press.png"} , 50 + (this.params.closeOffset or 0)  , 765 , {
				priority = this.params.priority and this.params.priority - 1 or nil,
				callback = function()
					if delayTime then
						if this.params.closeCallback   then
							this.params.closeCallback()
						else
							switchScene("home")
						end
					end
				end
			})
			this.layer:addChild(this.back_btn:getLayer())

			if not this.params["tail_hide"] then
				local tail =  display.newSprite(COMMONPATH.."title_tail.png")
				setAnchPos(tail , 0 , display.height - this.title:getContentSize().height * 1.45)
				this.layer:addChild( tail )
			end
		end
	end

	--标题
	if this.params["title_text"] then
		this.name = nil
		if type(this.params["title_text"]) == "string" then
			 this.name = display.newSprite(this.params["title_text"])
		else
			this.name = this.params["title_text"]
		end
		setAnchPos( this.name , 240 , display.height - this.title:getContentSize().height / 2 + 4 , 0.5 , 0.7 )
		this.layer:addChild( this.name )
	end


	if view_type > 1 then
		this:refreshInfo()
	end

	-- initMsg()
	if not this.params.disableChat then
		this:refreshMsg()
	else
		this.msgLayer = display.newLayer()
	end
	this:refreshBtn(layerName)


	if not this.params.hideMsgLayer then 
		GLOBAL_INFOLAYER = this
	end
    
    return this
end
--刷新标题
function InfoLayer:refreshTitle( path )
	if self.name then
		self.name:removeFromParentAndCleanup( true )
		self.name = nil
	end

	self.name = display.newSprite( path )
	setAnchPos( self.name , 240 , display.height - self.title:getContentSize().height / 2 + 4 , 0.5 , 0.7 )
	self.layer:addChild( self.name )
end

function InfoLayer:getBackBtn()
	return self.back_btn
end

function InfoLayer:getLayer()
	return self.layer
end

function InfoLayer:update(type)
	if self.layer then
		if not type then
			self:refreshMsg()
			self:refreshInfo()
		end

		if type == "msg" then
			self:refreshMsg()
		end

		if type == "info" then
			self:refreshInfo()
		end
	end
end


function InfoLayer:refreshBtn(layerName)
	self.navigationLayer = display.newLayer()

--	if not layerName or layerName ~= "home" then
--		local bottom_black = display.newSprite(PATH .. "bottom_black.png")
--		setAnchPos(bottom_black , 0 , 0)
--		self.navigationLayer:addChild(bottom_black)
--	end

	local bottom = self.params.bottom and display.newSprite(self.params.bottom) or display.newSprite(PATH .. "bottom.png")
	setAnchPos(bottom , 0 , -3)
	self.navigationLayer:addChild(bottom)

	local optionY = 0
	local initX = 25
	local spaceX = 87

	--首页底部的按钮信息
	local guide_step = KNGuide:getStep()
	local btnInfo = {}

	btnInfo[#btnInfo + 1] = { --首页
		"home" ,
		initX ,
		optionY ,
		{"na_home.png" , "na_home_pre.png"},
		function()
			--callShare(888, "发送一个游戏分享进来看看")
			switchScene("home")
		end
	}

	btnInfo[#btnInfo + 1] = { --背包
		"bag" ,
		initX + spaceX ,
		optionY ,
		{"na_bag.png" , "na_bag_pre.png"},
		function()
--				if DATA_Bag:haveData("equip") then
--					switchScene("bag")
--				else
--					HTTP:call("bag","get",{type = "equip"},{success_callback=
--					function()
--					end})
--				end
			switchScene("bag")
		end
	}

	btnInfo[#btnInfo + 1] = { --
		"ranklist" ,
		initX + spaceX * 2 ,
		optionY ,
		{"na_ranklist.png" , "na_ranklist_pre.png"},
		function()
			if DATA_HeadLine:get("_ranking_headlines_state") then
				switchScene("ranklist","worShip")
			else
				switchScene("ranklist","level")
			end
		end
	}

	btnInfo[#btnInfo + 1] = { -- 帮会
		"gang" ,
		initX + spaceX * 3 ,
		optionY ,
		{"gang.png" , "gang_press.png"},
		function()
			local check_result = checkOpened("gang")
			if check_result ~= true then
				KNMsg:getInstance():flashShow(check_result)
				return
			end

			--帮派
			HTTP:call("alliance", "get", {},{success_callback =
			function()
				switchScene("gang")
			end})
		end
	}

	if IN_BANHAO == nil then
		btnInfo[#btnInfo + 1] = { -- 商城
			"shop" ,
			initX + spaceX * 3 ,
			optionY ,
			{"na_shop.png" , "na_shop_pre.png"},
			function()
				if DATA_Shop:haveData() then
					switchScene("shop")
				else
					HTTP:call("shop","get",{},{success_callback=
						function()
							switchScene("shop")
						end
					})
				end
			end
		}


		btnInfo[#btnInfo + 1] = { --好友
			"friend" ,
			initX ,
			optionY ,
			{"friend.png" , "friend_pre.png"},
			function()
				local check_result = checkOpened("friend")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end

				HTTP:call("friends","get",{},{success_callback=
				function()
					switchScene("friend")
				end})
			end
		}
	end

	btnInfo[#btnInfo + 1] = { --设置
		"setting" ,
		initX + spaceX * 4 ,
		optionY ,
		{"na_setting.png" , "na_setting_pre.png"},
		function()

			HTTP:call("profile","setting_info",{channel_id=CHANNEL_ID,channel_group=CHANNEL_GROUP},{success_callback=function(data)

				local SettingLayer = requires(IMG_PATH, "GameLuaScript/Scene/common/setting")
				display.getRunningScene():addChild( SettingLayer:new(data):getLayer() )

			end
			})

		end
	}

	local temp, select
--	{ }
	local btn_names = {}
	scroll = KNScrollView:new( 30 , 0 , 420 , 83 , 5 , true , nil , { turnBtn = IMG_PATH .. "image/scene/gang/next.png", priority = self.params.priority and self.params.priority - 1 or nil } )
	for i , v in pairs(btnInfo) do
		temp = KNBtn:new(PATH .. "navigation", v[4] , 0 , 0 , {
			parent = scroll ,
--			upSelect = true ,
			frontZOrder = -10 ,
			priority = self.params.priority,
			front = PATH .. "btn_bg.png" ,
			callback = function()
				if self.params.preCall then
					self.params.preCall()
				end
				if v[1] == "gang" then
					v[5]()
				else
					if display.getRunningScene()["name"] ~= v[1] then
						v[5]()
					end
				end
			end,
			scale = true ,
		})

		scroll:addChild( temp:getLayer(), temp )

		btn_names[v[1]] = i
	end
	scroll:alignCenter()
	self.navigationLayer:addChild(scroll:getLayer() )

	self.layer:addChild(self.navigationLayer)
	--禁用导航按钮
	if self.params.noNavigation then
		local mask = KNMask:new({priority = self.params.priority})
		mask:getLayer():setContentSize(CCSize(480, 90))
		self.layer:addChild(mask:getLayer())
	elseif self.params.hideNavigation then
		self.navigationLayer:setVisible(false)
		self.navigationLayer:setPositionY(-500)
		if self.msgLayer then  self.msgLayer:setTouchEnabled(false) end
	end


	local guide_btn = nil
	if guide_step == 2000 then
		guide_btn = "bag"
	elseif guide_step == 208 or guide_step == 303 or guide_step == 504 or guide_step == 703 or guide_step == 805 or guide_step == 809 or guide_step == 1508 or guide_step == 10004 or guide_step == 15803 or guide_step == 10103 or guide_step == 15205 or guide_step == 15209 or guide_step == 15005 or guide_step == 15110 then
		guide_btn = "home"
	elseif guide_step == 3500 then
		guide_btn = "gang"
	elseif guide_step == 3600 then
		guide_btn = "friend"
	end

	if guide_btn ~= nil then
		if btn_names[guide_btn] > 3 then
			scroll:setIndex(btn_names[guide_btn] , true)
		end

		local temp = scroll:getItems( btn_names[guide_btn] )
		local btn_range = temp:getRange()
		KNGuide:show( temp:getLayer() , {
			x = btn_range:getMinX(),
			y = btn_range:getMinY(),
		})
	end
		--[[
	if v[1] == "bag" then
		-- 新手引导

			local btn_range = temp:getRange()
			KNGuide:show( temp:getLayer() , {
				x = btn_range:getMinX(),
				y = btn_range:getMinY(),
			})
		end
	elseif v[1] == "home" then
		-- 新手引导
		if guide_step == 208 or guide_step == 303 or guide_step == 504 or guide_step == 703 or guide_step == 1508 then
			local btn_range = temp:getRange()
			KNGuide:show( temp:getLayer() , {
				x = btn_range:getMinX(),
				y = btn_range:getMinY(),
			})
		end
	elseif v[1] == "gang" then
		-- 新手引导
		if guide_step == 3500 then
			local btn_range = temp:getRange()
			KNGuide:show( temp:getLayer() , {
				x = btn_range:getMinX(),
				y = btn_range:getMinY(),
			})
		end
	elseif v[1] == "friend" then
		-- 新手引导
		if guide_step == 3600 then
			local btn_range = temp:getRange()
			KNGuide:show( temp:getLayer() , {
				x = btn_range:getMinX(),
				y = btn_range:getMinY(),
			})
		end
	end
	]]

end
--只用于小助手动画中
function InfoLayer:showMoreBtn()
	scroll:setIndex( 4 , true )
end

function InfoLayer:refreshInfo()

	local numMax_pox=225;
	local numMax_poy=700;
	local add_small_pox=295;
	local add_small_poy=697;


	local offsetX = -100

	if CHANNEL_GROUP == "tmsj" or CHANNEL_GROUP == "td" then

	else
		numMax_pox=222;
		numMax_poy=694;
		add_small_pox=295;
		add_small_poy=691;
	end

	--太古2布局不一样
	if CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
		self:refreshInfo_tgxy2()
		return
	end

	if self.userInfoLayer then
		self.layer:removeChild(self.userInfoLayer,true)
	end
	self.userInfoLayer = display.newLayer()

	if self.view_type == 3 then

--		self.userInfoLayer:addChild( KNBar:new("power" , 120 , 150 , { maxValue = DATA_Power:get("max") , curValue = DATA_Power:get("num"), color = ccc3(255, 255, 255) }))
		self.userInfoLayer:addChild( display.strokeLabel( DATA_Power:get("num") .. "/" .. DATA_Power:get("max")  ,numMax_pox + offsetX , numMax_poy , 18 , ccc3( 0x93 , 0xfa , 0x31 ) ) )
		--self.userInfoLayer:addChild( display.strokeLabel(DATA_Formation:countLead() .. "/" .. DATA_User:getLead()  , 265 , 694 , 18 , ccc3( 0x93 , 0xfa , 0x31 ) ) )
		--self.userInfoLayer:addChild( display.newSprite( SCENECOMMON .. "lead_text.png" , 220 , 693 , 0 , 0 ) )

		self.userInfoLayer:addChild( KNBar:new("home_exp" , 80 , 105 , { maxValue = DATA_User:get("lvup_exp") , curValue = DATA_User:get("cur_exp") }) )

		if (G_SILVERCARD and G_SILVERCARD > 0) or (G_EXPCARD and G_EXPCARD > 0) or (tonumber(DATA_User:get("lv"))>=20 and tonumber(DATA_User:get("lv"))<=77) then
			local seq = CCSequence:createWithTwoActions(CCFadeTo:create(1, 255*.3), CCFadeTo:create(1, 255))
			display.newSprite(PATH .."headLight.png", 61, 765):addTo(self.userInfoLayer):run(CCRepeatForever:create(tolua.cast(seq, "CCActionInterval")))
		end


		local function leadFun()
			local layer = display.newLayer()

			layer:addChild( display.newSprite( IMG_PATH .. "image/scene/mission/wipe_bg.png" , display.cx , 277 , 0.5 , 0 ) )
			layer:addChild( display.newSprite( IMG_PATH .. "image/scene/userinfo/lead_bg.png" , display.cx , 335 , 0.5 , 0 ) )
			layer:addChild( display.strokeLabel("1.统帅力随玩家的等级提升自动增加" , 110 , 313 , 18 , ccc3(0x2c , 0x00 , 0x00) ) )
			layer:addChild( display.strokeLabel(replaceStr("2.上阵英雄需玩家的统帅力达到要求") , 110 , 293 , 18 , ccc3(0x2c , 0x00 , 0x00)) )

			local leadConfig = getConfig( "generallead" )
			for i = 1 , table.nums( leadConfig ) do
				layer:addChild( display.strokeLabel( leadConfig[i..""]["lead"] .. "点" , 340 , 495 - ( i - 1 ) * 38 , 20 , ccc3( 0xff , 0xfb , 0xd6 ) ) )
				for j = 1 , i do
					layer:addChild( display.newSprite( COMMONPATH .. "star.png" , ( 125 - i/2 * 30 ) + j * 30  , 490 - ( i - 1 ) * 37 , 0.5 , 0 ) )
				end
			end





			local mask = KNMask:new( { item = layer } )
			local colseBtn = KNBtn:new(IMG_PATH .. "image/scene/chat/",{"close.png","close_press.png"} , 418 , 600 ,{ scale = true,priority = -130,callback=
				function()
					mask:remove()
				end}):getLayer()
			layer:addChild( colseBtn )
			setAnchPos( layer , 0 , display.height )
			transition.moveTo(layer , {time = 0.5 , easing = "BACKOUT" , y = 0 })
			local scene = display:getRunningScene()
			scene:addChild( mask:getLayer() )
		end
		--self.userInfoLayer:addChild(KNBtn:new(COMMONPATH, {"lead.png", "lead_pre.png"}, 336 , 692, {callback = leadFun } ):getLayer())

		self.userInfoLayer:addChild(KNBtn:new(COMMONPATH, {"add_small.png", "add_small_press.png"}, add_small_pox+offsetX,add_small_poy, {
			callback = function()
				if not DATA_Bag:getTypeNum("prop", "powerdrug") then
					KNMsg.getInstance():boxShow(replaceStr("您没有鸡血丸了，要去商城购买吗？"), {cancelFun = function()end, confirmFun = function()
						HTTP:call("shop","get",{},{success_callback=
							function()
								switchScene("shop")
							end
						})
					end})
					return false
				end
				local list
				list = SelectList:new("prop",self.userInfoLayer,display.newSprite(COMMONPATH.."title/prop_text.png"),{
					btn_opt = "use.png",
					y = 85,
					showTitle = true ,
					filter = {type = "powerdrug"},
					optCallback = function()
						list:destroy()
						HTTP:call("status", "eat", {id = list:getCurItem():getId()}, {
							success_callback = function(data)
								switchScene("home", {}, function()
									KNMsg.getInstance():flashShow(replaceStr("鸡血丸使用成功，体力增加"))
								end)
							end
						})
--						HTTP:call("status", "eat", {id = list:getCurItem():getId()},{success_callback=
--							function()
----								switchScene("home", {}, function()
----									KNMsg.getInstance():flashShow("使用成功，体力增加")
----								end)
--							end})
					end
				})

				local scene = display:getRunningScene()
				scene:addChild(list:getLayer() , 11)
			end
		}):getLayer())

		-- logo
		self.userInfoLayer:addChild(KNBtn:new( COMMONPATH , { getHeadPath( DATA_Head:get()["default"] ) } , 29 , 733 , {
			front = COMMONPATH .."role_frame.png",
--			other = { IMG_PATH .. "image/scene/vip/vip_flag.png" , -15 , -10 } ,
			callback = function()
				HTTP:call("status" , "get" , {} , {
					success_callback = function(params)
						switchScene("userinfo",params)
					end
				})
			end
		}):getLayer())
		self.userInfoLayer:addChild( display.newSprite(PATH .. "navigation/level_bg.png" , 33 , 795) )

		if DATA_Vip:isVip() then
			self.userInfoLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/vip/v" .. DATA_Vip:get( "viplv" ) .. ".png" , 90 , 759  , 0 , 0 ) )
		end
		self.userInfoLayer:addChild( display.strokeLabel(DATA_User:get("name") , ( DATA_Vip:isVip() and 135 or 100 ) , 762 , 22 , ccc3(255 , 251 , 212) , 2 ) )

		local level_label = display.strokeLabel(DATA_User:get("lv") , 30 , 785 , 18 , ccc3(179 , 58 , 0) )
		setAnchPos(level_label , 32 , 785 , 0.5)
		self.userInfoLayer:addChild( level_label )


		self.userInfoLayer:addChild( display.newSprite(PATH .. "navigation/money_bg.png" , 325 , 782) )
		self.userInfoLayer:addChild( display.newSprite(PATH .. "navigation/money_bg.png" , 325 , 752) )
		self.userInfoLayer:addChild( display.newSprite(COMMONPATH.."gold.png" , 282 , 782) )
		self.userInfoLayer:addChild( display.newSprite(COMMONPATH.."silver.png" , 282 , 752) )

		local gold = DATA_Account:get("gold")
		local silver = DATA_Account:get("silver")

		gold = gold > 100000 and math.floor(gold / 10000).."万" or gold
		silver = silver > 100000 and math.floor(silver / 10000).."万" or silver

		self.userInfoLayer:addChild( display.strokeLabel(gold, 305 , 771 , 18 , ccc3(255 , 251 , 212) , 2 ) )
		self.userInfoLayer:addChild( display.strokeLabel(silver, 305 , 741 , 18 , ccc3(255 , 251 , 212) , 2 ) )


		if IN_BANHAO == nil then
			if DATA_GodCell:get("first_pay") == 1  then
				-- 首充三倍按钮
				local pos
				if CHANNEL_GROUP == "hy" then
					pos = { x = 398 , y = 729}
				else
					pos = { x = 370 , y = 712}
				end


				local first_pay_btn = KNBtn:new(PATH .. "navigation" , { "first_pay.png" , "first_pay_pre.png" } , pos.x ,pos.y , {
					callback = function()
						HTTP:call("activity" , "get", {} , {
							success_callback = function()
								local check_result = checkOpened("activity")
								if check_result ~= true then
									KNMsg:getInstance():flashShow(check_result)
									return
								end

								switchScene( "activity" ,  { findCurKeyByName = "singlepaymax_hy_new" } )
							end
						})
					end,
					scale = true,
				})
				self.userInfoLayer:addChild(first_pay_btn:getLayer())
			else
				-- 充值按钮
				local charge_btn = KNBtn:new(PATH .. "navigation" , {"vip.png" , "vip_pre.png"} , 398 , 729 , {
					callback = function()
						HTTP:call("vip" , "get" , {} , {
							success_callback = function()
								switchScene("vip")
							end
						})
					end,
					scale = true,
				})
				self.userInfoLayer:addChild(charge_btn:getLayer())
			end
		end



		local count = 0


		if DATA_Info:get_type("friend_msgcount") then 
			for k,v in pairs(DATA_Info:get_type("friend_msgcount")) do
				count = v + count
			end
		end

		--好友信息按钮
		KNBtn:new(IMG_PATH.."image/scene/friend/helpToFight/" , { "friend.png" } , 272 , 694 , {
			text =  count ~= 0 and {count, 18, ccc3(0xff, 0xfb, 0xd4), ccp(18, 14) , nil , 17} or nil,
			other = count ~= 0 and {COMMONPATH.."egg_num_bg.png", 25, 22} or nil,
			callback = function()
				local check_result = checkOpened("friend")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end
				display.getRunningScene():addChild(self:showFriendInfoLayer())
			end
		}):getLayer():addTo(self.userInfoLayer)

		--邮件信息按钮
		KNBtn:new(IMG_PATH.."image/scene/friend/helpToFight/" , { "email.png" } , 329 , 690 , {
			text = DATA_Chat:getNum() ~= 0 and { DATA_Chat:getNum() > 20 and 20 or DATA_Chat:getNum() , 18, ccc3(0xff, 0xfb, 0xd4), ccp(18, 12), nil , 17} or nil,
			other = DATA_Chat:getNum() ~= 0 and {COMMONPATH.."egg_num_bg.png", 30, 20} or nil,
			callback = function()
					HTTP:call("message" , "get" , {} , {
						success_callback = function()
							switchScene("chat")
						end
					})
			end
		}):getLayer():addTo(self.userInfoLayer)

	end
	self.layer:addChild(self.userInfoLayer)
end

function InfoLayer:createScroll( params )
	if self.scrolllayer then 
		self.scrolllayer:removeSelf()
		self.scrolllayer = nil
	end

	self.scrolllayer = display.newLayer()

	if params.parent then 
	 	params.parent:addChild( self.scrolllayer )
	end

	local data = params._data or {}

	local function getItem(_data)
        local size = CCSizeMake( 422 , 130 )
        local item = display.newLayer()
        item:setContentSize( size )

        local offsetY = 20

        item:addChild( display.newSprite( FRIENDINFOPATH .. "item_bg.png" , size.width/2 ,size.height/2 , 0.5,0.5 ):scaley(1.2) )

        KNBtn:new(COMMONPATH, {getHeadPath( _data.logo )   },54 , 30+offsetY ,{
            front = COMMONPATH ..  "role_frame.png",
            priority = -220,
            callback = function()
                
            end,
        } ):getLayer():addTo(item)

        local isCompleted = false

        if tonumber(_data.recv) ~= 0 then 
        	isCompleted = true
        end

        local btn_str =  isCompleted and FRIENDINFOPATH .. "agree_gray.png" or  IMG_PATH.."image/scene/gang/gang_list/agree.png"
        if _data.btn_type == 2 then 
        	btn_str =  FRIENDINFOPATH .. (isCompleted and "congra_label_dis.png" or "congra_label.png")
        elseif _data.btn_type == 3 then 
        	btn_str = isCompleted and FRIENDINFOPATH.."confirm_dis.png" or COMMONPATH .. "confirm.png"
        elseif _data.btn_type == 4 then 
        	btn_str = isCompleted and COMMONPATH.."get_grey.png" or COMMONPATH .. "get.png"
        end

        local btn = KNBtn:new(COMMONPATH, isCompleted and {"btn_bg_dis.png"} or { "btn_bg.png" , "btn_bg_pre.png" },329 , 62 ,{
            front = btn_str,
            priority = -220,
            callback = function()

            	HTTP:call(_data.m , _data.a, _data.param ,{
                    success_callback = function(ohterData)

                    	dump(ohterData , "data1111")

                    	if _data.from and _data.from == "empire_invite" then 

                    		HTTP:call("empire","initEmpire",{  } , {
								success_callback = function(data)
										if tonumber(data.empire_info.first) == 1 then 
											KNGuide:setStep( 20000 )	-- 新手引导
										end
										switchScene("soulTemple" , { data = data ,  closeCallback = function() switchScene("pvp") end , moveTo = "chuangjianduiwu" , ohterData = ohterData } )		
									end
							})

                    	else
                    		KNMsg:getInstance():flashShow( data.msg or "" )
							HTTP:call("friends" , "getMessage",{ type = params.type },{
			                    success_callback = function(data)
									self:createScroll( {parent = params.parent , _data = data , type = params.type } )
			                end })
                    	end
                end })

                
            end,
        } )

        btn:setEnable( not isCompleted )
        btn:getLayer():addTo(item)

        item:addChild( createLabel({str = _data.name or "" , x = 140 , y = 72+offsetY,size = 14, width = 276, height = 26 ,color = ccc3(255 , 208 , 205)}) )
        item:addChild( createLabel({str = "战力：".._data.ability , x = 140 , y = 49+offsetY,size = 14, width = 276, height = 26 ,color = ccc3(255 , 208 , 205)}) )
        item:addChild( createLabel({str = "最近上线：".._data.last_login , x = 140 , y = 27+offsetY,size = 14, width = 276, height = 26 ,color = ccc3(255 , 208 , 205)}) )


        item:addChild( createLabel({str = _data.msg or "" , x = 56 , y = 6,size = 14, width = 276, height = 26 ,color = ccc3(101 , 235 , 238)}) )
        item:addChild( createLabel({str = tonumber(_data.cost) ~= 0 and ("获得"..(numChange(_data.cost) or "").."银两") or "" , x = 56+275 , y = 6,size = 14, width = 276, height = 26 ,color = ccc3(101 , 235 , 238)}) )
        

        return item
    end

    local scroll = KNScrollView:new( 30 , 161  , 427 , 381 , 0 ,  false , nil , { priority = -152 } )    
    scroll:alignCenter(true)

    local list = data.list or {}

    for i=1,#list do
    	local item = getItem(list[i])
        scroll:addChild( item )
    end


    self.scrolllayer:addChild(scroll:getLayer())

end

function InfoLayer:showFriendInfoLayer()
	local tempLayer = display.newLayer()
	local mask = KNMask:new({item = tempLayer, priority = -151})
	
	local bg = display.newSprite( COMMONPATH .. "change_bg.png" , display.cx , 123 , 0.5 , 0 ):addTo(tempLayer)

	display.newSprite( IMG_PATH .. "image/scene/mission/title_bg.png" , display.cx , 513 , 0.5 , 0 ):addTo(bg)
	display.newSprite( FRIENDINFOPATH .. "friendInfo_title.png" , display.cx - 30 , 513 , 0.5 , 0 ):addTo(bg)

	local scroll_bg = display.newSprite( FRIENDINFOPATH .. "bg.png" , display.cx - 8 , 31 , 0.5 , 0 ):addTo(bg , 1)

	local group = KNRadioGroup:new()
    
    local tabConfig = { "all" , "congra", "invite", "relative" }

    for i=1,#tabConfig do
        local btn = KNBtn:new(COMMONPATH.."tab/", {"tab_star_normal.png", "tab_star_select.png"} ,40 + (i-1) * 101, 419, {
            id = i,
            front = {FRIENDINFOPATH..tabConfig[i]..".png", FRIENDINFOPATH..tabConfig[i].."_pre.png"},
            priority = -220,
            callback = function()

                HTTP:call("friends" , "getMessage",{ type = tabConfig[i] },{
                    success_callback = function(_data)
                    	-- dump(_data , "_data")
						self:createScroll( {parent = tempLayer , _data = _data , type = tabConfig[i] } )
                end })
            end
            
        },group)
        bg:addChild(btn:getLayer())
    end
    group:chooseByIndex(1, true)


	KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 14 , 495 , {
		priority = -152,
		callback = function()
			mask:remove()
			self.scrolllayer = nil
			self:update()
	end}):getLayer():addTo(bg)


	setAnchPos( tempLayer , 0 , display.height , 0 , 0 )
	transition.moveTo( tempLayer , { time = 0.5 , y = 0 , easing = "BACKOUT"})

	return mask:getLayer()

end

function InfoLayer:refreshInfo_tgxy2()
	if self.userInfoLayer then
		self.layer:removeChild(self.userInfoLayer,true)
	end
	self.userInfoLayer = display.newLayer()

	if self.view_type == 3 then

		CCLuaLog("asas")
		CCLuaLog( DATA_Power:get("num"))
--		self.userInfoLayer:addChild( KNBar:new("power" , 120 , 150 , { maxValue = DATA_Power:get("max") , curValue = DATA_Power:get("num"), color = ccc3(255, 255, 255) }))
		self.userInfoLayer:addChild( display.strokeLabel( DATA_Power:get("num") .. "/" .. DATA_Power:get("max")  , 115 , 723 , 18 , ccc3( 0x93 , 0xfa , 0x31 ) ) )
		--self.userInfoLayer:addChild( display.strokeLabel(DATA_Formation:countLead() .. "/" .. DATA_User:getLead()  , 285 , 722 , 18 , ccc3( 0x93 , 0xfa , 0x31 ) ) )
		--self.userInfoLayer:addChild( display.newSprite( SCENECOMMON .. "lead_text.png" , 240 , 720 , 0 , 0 ) )

		self.userInfoLayer:addChild( KNBar:new("home_exp" , 80 , 89 , { maxValue = DATA_User:get("lvup_exp") , curValue = DATA_User:get("cur_exp") }))

		if (G_SILVERCARD and G_SILVERCARD > 0) or (G_EXPCARD and G_EXPCARD > 0) or (tonumber(DATA_User:get("lv"))>=20 and tonumber(DATA_User:get("lv"))<=77) then
			local seq = CCSequence:createWithTwoActions(CCFadeTo:create(1, 255*.3), CCFadeTo:create(1, 255))
			display.newSprite(PATH .."headLight.png", 60, 782):addTo(self.userInfoLayer):run(CCRepeatForever:create(tolua.cast(seq, "CCActionInterval")))
		end

		local function leadFun()
			local layer = display.newLayer()

			layer:addChild( display.newSprite( IMG_PATH .. "image/scene/mission/wipe_bg.png" , display.cx , 277 , 0.5 , 0 ) )
			layer:addChild( display.newSprite( IMG_PATH .. "image/scene/userinfo/lead_bg.png" , display.cx , 335 , 0.5 , 0 ) )
			layer:addChild( display.strokeLabel("1.统帅力随玩家的等级提升自动增加" , 110 , 313 , 18 , ccc3(0x2c , 0x00 , 0x00) ) )
			layer:addChild( display.strokeLabel(replaceStr("2.上阵英雄需玩家的统帅力达到要求") , 110 , 293 , 18 , ccc3(0x2c , 0x00 , 0x00)) )

			local leadConfig = getConfig( "generallead" )
			for i = 1 , table.nums( leadConfig ) do
				layer:addChild( display.strokeLabel( leadConfig[i..""]["lead"] .. "点" , 340 , 495 - ( i - 1 ) * 38 , 20 , ccc3( 0xff , 0xfb , 0xd6 ) ) )
				for j = 1 , i do
					layer:addChild( display.newSprite( COMMONPATH .. "star.png" , ( 125 - i/2 * 30 ) + j * 30  , 490 - ( i - 1 ) * 37 , 0.5 , 0 ) )
				end
			end





			local mask = KNMask:new( { item = layer } )
			local colseBtn = KNBtn:new(IMG_PATH .. "image/scene/chat/",{"close.png","close_press.png"} , 418 , 600 ,{ scale = true,priority = -130,callback=
				function()
					mask:remove()
				end}):getLayer()
			layer:addChild( colseBtn )
			setAnchPos( layer , 0 , display.height )
			transition.moveTo(layer , {time = 0.5 , easing = "BACKOUT" , y = 0 })
			local scene = display:getRunningScene()
			scene:addChild( mask:getLayer() )
		end
		--self.userInfoLayer:addChild(KNBtn:new(COMMONPATH, {"lead.png", "lead_pre.png"}, 352 , 719, {callback = leadFun } ):getLayer())

		self.userInfoLayer:addChild(KNBtn:new(COMMONPATH, {"add_small.png", "add_small_press.png"}, 185 , 719, {
			callback = function()
				if not DATA_Bag:getTypeNum("prop", "powerdrug") then
					KNMsg.getInstance():boxShow(replaceStr("您没有鸡血丸了，要去商城购买吗？"), {cancelFun = function()end, confirmFun = function()
						HTTP:call("shop","get",{},{success_callback=
							function()
								switchScene("shop")
							end
						})
					end})
					return false
				end
				local list
				list = SelectList:new("prop",self.userInfoLayer,display.newSprite(COMMONPATH.."title/prop_text.png"),{
					btn_opt = "use.png",
					y = 85,
					showTitle = true ,
					filter = {type = "powerdrug"},
					optCallback = function()
						list:destroy()
						HTTP:call("status", "eat", {id = list:getCurItem():getId()}, {
							success_callback = function(data)
								switchScene("home", {}, function()
									KNMsg.getInstance():flashShow(replaceStr("鸡血丸使用成功，体力增加"))
								end)
							end
						})
--						HTTP:call("status", "eat", {id = list:getCurItem():getId()},{success_callback=
--							function()
----								switchScene("home", {}, function()
----									KNMsg.getInstance():flashShow("使用成功，体力增加")
----								end)
--							end})
					end
				})
				local scene = display:getRunningScene()
				scene:addChild(list:getLayer() , 11)
			end
		}):getLayer())

		-- logo
		self.userInfoLayer:addChild(KNBtn:new( COMMONPATH , { getHeadPath( DATA_Head:get()["default"] ) } , 29 , 753 , {
			front = COMMONPATH .."role_frame.png",
--			other = { IMG_PATH .. "image/scene/vip/vip_flag.png" , -15 , -10 } ,
			callback = function()
				HTTP:call("status" , "get" , {} , {
					success_callback = function(params)
						switchScene("userinfo",params)
					end
				})
			end
		}):getLayer())
		self.userInfoLayer:addChild( display.newSprite(PATH .. "navigation/level_bg.png" , 33 , 810) )

		if DATA_Vip:isVip() then
			self.userInfoLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/vip/v" .. DATA_Vip:get( "viplv" ) .. ".png" , 90 , 779  , 0 , 0 ) )
		end
		self.userInfoLayer:addChild( display.strokeLabel(DATA_User:get("name") , ( DATA_Vip:isVip() and 135 or 100 ) , 779 , 22 , ccc3(255 , 251 , 212) , 2 ) )

		local level_label = display.strokeLabel(DATA_User:get("lv") , 30 , 800 , 18 , ccc3(179 , 58 , 0) )
		setAnchPos(level_label , 32 , 800 , 0.5)
		self.userInfoLayer:addChild( level_label )


		self.userInfoLayer:addChild( display.newSprite(PATH .. "navigation/money_bg.png" , 325 , 802) )
		self.userInfoLayer:addChild( display.newSprite(PATH .. "navigation/money_bg.png" , 325 , 772) )
		self.userInfoLayer:addChild( display.newSprite(COMMONPATH.."gold.png" , 284 , 799) )
		self.userInfoLayer:addChild( display.newSprite(COMMONPATH.."silver.png" , 284 , 769) )

		local gold = DATA_Account:get("gold")
		local silver = DATA_Account:get("silver")

		gold = gold > 100000 and math.floor(gold / 10000).."万" or gold
		silver = silver > 100000 and math.floor(silver / 10000).."万" or silver

		self.userInfoLayer:addChild( display.strokeLabel(gold, 305 , 788 , 18 , ccc3(255 , 251 , 212) , 2 ) )
		self.userInfoLayer:addChild( display.strokeLabel(silver, 305 , 758 , 18 , ccc3(255 , 251 , 212) , 2 ) )


		if IN_BANHAO == nil then
			if DATA_GodCell:get("first_pay") == 1  then
				-- 首充三倍按钮
				local pos
				if CHANNEL_GROUP == "hy" then
					pos = { x = 398 , y = 729}
				else
					pos = { x = 370 , y = 712}
				end


				local first_pay_btn = KNBtn:new(PATH .. "navigation" , { "first_pay.png" , "first_pay_pre.png" } , pos.x ,pos.y , {
					callback = function()
						HTTP:call("activity" , "get", {} , {
							success_callback = function()
								local check_result = checkOpened("activity")
								if check_result ~= true then
									KNMsg:getInstance():flashShow(check_result)
									return
								end

								switchScene( "activity" ,  { findCurKeyByName = "singlepaymax_hy_new" } )
							end
						})
					end,
					scale = true,
				})
				self.userInfoLayer:addChild(first_pay_btn:getLayer())
			else
				-- 充值按钮
				local charge_btn = KNBtn:new(PATH .. "navigation" , {"vip.png" , "vip_pre.png"} , 387 , 729 , {
					callback = function()
						HTTP:call("vip" , "get" , {} , {
							success_callback = function()
								switchScene("vip")
							end
						})
					end,
					scale = true,
				})
				self.userInfoLayer:addChild(charge_btn:getLayer())
			end
		end

		local count = 0


		if DATA_Info:get_type("friend_msgcount") then 
			for k,v in pairs(DATA_Info:get_type("friend_msgcount")) do
				count = v + count
			end
		end

		--好友信息按钮
		KNBtn:new(IMG_PATH.."image/scene/friend/helpToFight/" , { "friend.png" } , 272 , 716 , {
			text =  count ~= 0 and {count, 18, ccc3(0xff, 0xfb, 0xd4), ccp(18, 14) , nil , 17} or nil,
			other = count ~= 0 and {COMMONPATH.."egg_num_bg.png", 25, 22} or nil,
			callback = function()
				local check_result = checkOpened("friend")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end
				display.getRunningScene():addChild(self:showFriendInfoLayer())
			end
		}):getLayer():addTo(self.userInfoLayer)

		--邮件信息按钮
		KNBtn:new(IMG_PATH.."image/scene/friend/helpToFight/" , { "email.png" } , 329 , 716 , {
			text = DATA_Chat:getNum() ~= 0 and { DATA_Chat:getNum() > 20 and 20 or DATA_Chat:getNum() , 18, ccc3(0xff, 0xfb, 0xd4), ccp(18, 12), nil , 17} or nil,
			other = DATA_Chat:getNum() ~= 0 and {COMMONPATH.."egg_num_bg.png", 30, 20} or nil,
			callback = function()
					HTTP:call("message" , "get" , {} , {
						success_callback = function()
							switchScene("chat")
						end
					})
			end
		}):getLayer():addTo(self.userInfoLayer)


	end
	self.layer:addChild(self.userInfoLayer)
end


function InfoLayer:refreshMsg()

		if self.params.hideMsgLayer then 
			return 
		end

		if self.msgLayer then
			self.layer:removeChild(self.msgLayer , true)
		end

		self.msgLayer = display.newLayer()

		-- 图片
		self.msgLayer:addChild( display.newSprite(PATH .. "navigation/na_msg.png" , 427 , 15) )


		local msg = "提示：账号及黄金买卖骗子多，请勿参与！"
		local last_msg = DATA_Chat:getLast()
		if last_msg ~= nil and last_msg ~= false and last_msg.templateno ~= 4 then
			msg = self:formatMsg(last_msg.template , last_msg.msg or {})
		end
		if device.platform == "ios" then
				self.msgLayer:addChild( display.strokeLabel( msg , 30 , 3 , 20 , ccc3(255 , 251 , 212) , nil , nil , {
					dimensions_width = 380,
					dimensions_height = 24,
					align = 0,
				}))
		else
			 local showWidth = 380	--可见宽度
			 self.msgText = display.strokeLabel( msg , 0 , 3 , 20 , ccc3(255 , 251 , 212) , nil , nil , {
			 	dimensions_width = 1500 ,
			 	dimensions_height = 24,
			 	align = 0,
			 })
	 		 local windowlayer = WindowLayer:createWindow()
			 windowlayer:setAnchorPoint( ccp(0 , 0 ) )
			 windowlayer:setPosition( 30 , 0 )
			 windowlayer:setContentSize( CCSizeMake( showWidth , 43 ) )
			 windowlayer:addChild( self.msgText )
			 self.msgLayer:addChild( windowlayer )

			--临时计算长
			local tempText = display.strokeLabel( msg , 0 , 3 , 20 , ccc3(255 , 251 , 212))
			local widthValue = tempText:getContentSize().width - showWidth
			local fall = 0		--初始位置
			local effectiveRange = 30	--有效延长距离
			local isForward = false	--是否是正方向
			local addOffX = 1		--单次移动像素
			local refreshTime = 0.01	--刷新时间
			local function rollText()
					if isForward then
						fall = fall + addOffX
						if fall >= effectiveRange then
							isForward = false
						end
					else
						fall = fall - addOffX
						if fall < -widthValue - effectiveRange then
							isForward = true
						end
					end
					if self.msgText then
						xpcall( function() setAnchPos( self.msgText , fall , 3 ) end , function() self.msgText = nil end)
					end
			end

			local handle

			if widthValue > 0 then
			 	handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc( rollText , refreshTime , false)
			else
			 	if handle then
					CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
			 	end
				handle = nil
			end

		end

--		 local showWidth = 380	--可见宽度
--		 local msgText = display.strokeLabel( msg , 0 , 3 , 20 , ccc3(255 , 251 , 212) , nil , nil , {
--		 	dimensions_width = 0,
--		 	dimensions_height = 24,
--		 	align = 0,
--		 })
--		 local windowlayer = WindowLayer:createWindow()
--		 windowlayer:setAnchorPoint( ccp(0 , 0 ) )
--		 windowlayer:setPosition( 30 , 0 )
--		 windowlayer:setContentSize( CCSizeMake( showWidth , 43 ) )
--		 windowlayer:addChild( msgText )
--		 self.msgLayer:addChild( windowlayer )
--
--		 local widthValue = msgText:getContentSize().width - showWidth
--		 local timeRate = widthValue / 100
--		 local isDouble = false	--是否是双次
--		 local function rollText( value )
--		 	local addX = isDouble and 0 or  -widthValue
--		 	isDouble = not isDouble
--		 	transition.moveTo( msgText , { x = addX , time = 3 + 3 * timeRate , onComplete = rollText })
--		 end
--		 if widthValue > 0 then
--		 	rollText( )
--		 end

		-- 提醒数字
		local msg_num = DATA_Chat:getNum()
		if msg_num > 0 then
			if msg_num > 20 then msg_num = 20 end

			self.msgLayer:addChild( display.newSprite(PATH .. "navigation/na_msg_num.png" , 443 , 10) )

			local msg_num_label = display.strokeLabel( msg_num , 444 , 0 , 16 , ccc3(255 , 255 , 255) )
			msg_num_label:setAnchPos( ccp(0.5 , 0 ) )
			self.msgLayer:addChild( msg_num_label )
		end


		if self.view_type == 3 or self.view_type == 5 then
			if CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
				setAnchPos(self.msgLayer , 0 , display.height - 27)
			else
				setAnchPos(self.msgLayer , 0 , display.height - 33 - 4)
			end
		elseif self.view_type == 1 or self.view_type == 2 then
			setAnchPos(self.msgLayer , 0 , display.height - 45 - 4)
		else
			setAnchPos(self.msgLayer , 0 , display.height - 25 - 4)
		end
		self.layer:addChild(self.msgLayer , 10)


		-- 点击事件
		local touchRect = CCRectMake(0 , display.height - 35 , display.width , 35)
		self.msgLayer:addTouchEventListener(function(event , x , y)
			if event == CCTOUCHBEGAN then
				if not touchRect:containsPoint( ccp(x , y) ) then
					return false
				end

				return true
			elseif event == CCTOUCHMOVED then
				return true
			elseif event == CCTOUCHENDED then
				if not touchRect:containsPoint( ccp(x , y) ) then
					return false
				end

				local scene = display.getRunningScene()
				if scene.name ~= "chat" then
					HTTP:call("message" , "get" , {} , {
						success_callback = function()
							switchScene("chat")
						end
					})
				end
			end

			return false
		end)
		if self.params.hideNavigation or self.params.disableChat then
			self.msgLayer:setTouchEnabled(false)
		else
			self.msgLayer:setTouchEnabled(true)
		end
end

--是否显示信息栏
function InfoLayer:showInfo( title_type )
	if title_type == 1 then
		self.userInfoLayer:setVisible(false)
	else
		self.userInfoLayer:setVisible(true)
	end
	self.layer:removeChild(self.title,true)
	self.title = display.newSprite(PATH .. "title_" .. title_type .. ".png")
	setAnchPos(self.title , 0 , display.height - self.title:getContentSize().height)
	self.layer:addChild(self.title , -1)
end


function InfoLayer:formatMsg(str , replace)
	if not str then return "" end

	if type(replace) == "table" and table.nums(replace) > 0 then
		local nums = 0

		str = string.gsub(str , "#s#" , function()
			nums = nums + 1
			if replace[nums] ~= nil then
				local replace_type = type(replace[nums])
				if replace_type == "string" or replace_type == "number" then
					return replace[nums]
				else
					return ""
				end
			end

			return ""
		end)
	end

	local return_str = ""
	while true do
		local start_pos , end_pos , color = string.find(str , "%[color=(#[a-f0-9]+)%]")
		if start_pos == nil then break end
		local start_pos_2 , end_pos_2 = string.find(str , "%[/color%]" , end_pos)
		if start_pos_2 == nil then break end
		local first_str = string.sub(str , 0 , start_pos - 1)
		local second_str = string.sub(str , end_pos + 1 , start_pos_2 - 1)

		return_str = return_str .. first_str .. second_str
		str = string.sub(str , end_pos_2 + 1)
	end


	return return_str .. str
end


return InfoLayer
