-- 设置界面
local PATH = IMG_PATH .. "image/scene/setting/"
local COMMONPATH = IMG_PATH .. "image/common/"

local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local mask
local SettingLayer = {
    BBSUrl,
    gongLveUrl,
    isBBSUrlShow,
    isGongLveUrlShow,
    isCDKey,--1为开，0为关
    isAcountManage,
}


function SettingLayer:new(data)
	dump(data)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.layer = display.newLayer()
	local setting_layer = display.newLayer()
    local settingScrollView = KNScrollView:new(10,260,454,340,3,false,0,{
    	priority = -131,
    	})
    --setAnchPos(settingScrollView, 13, 200)

    this.BBSUrl=data['forum']['addr']
    this.gongLveUrl=data['strategy']['addr']
    this.isBBSUrlShow=data['forum']['show']
    this.isGongLveUrlShow=data['strategy']['show']
    this.isCDKey=data['cdkey']['show']
    this.isAcountManage=data['account_manage']['show']



	-- 背景
	local bg = display.newSprite(PATH .. "bg.png")
	setAnchPos(bg , 13 , 200)
	setting_layer:addChild(bg)

	local list_title_bg = display.newSprite(COMMONPATH .. "list_title.png")
	setAnchPos(list_title_bg , 25 , 612)
	setting_layer:addChild(list_title_bg)

	local title = display.newSprite(PATH .. "setting_title.png")
	setAnchPos(title , 170 , 613)
	setting_layer:addChild(title)
	

	local closeBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" } , display.cx - 75 , 218 , {
		scale = true,
		priority = -130,
		front = COMMONPATH .. "colse_text.png" , 
		callback = function()
			this.layer:removeFromParentAndCleanup()
		end
	}):getLayer()
	setting_layer:addChild(closeBtn)



	-- 音乐
	local music_bg = display.newSprite(COMMONPATH .. "item_bg_high.png")
	setAnchPos(music_bg , 28 , 525)
	--setting_layer:addChild(music_bg)
	settingScrollView:addChild(music_bg)

	local music_title = display.newSprite(PATH .. "music.png")
	setAnchPos(music_title , 10 , 20)
	--setting_layer:addChild(music_title)
	music_bg:addChild(music_title)
	
	
	
	local function createBtn( target )
		if target then target:removeFromParentAndCleanup( true ) end 
		
		local isEffect = audio.isMusicPlaying()
		local musicBtn
		musicBtn = KNBtn:new(COMMONPATH, isEffect and { "btn_bg.png" } or { "btn_bg_grey.png" } , 330 , 20 , {
			front = PATH .. ( isEffect and "opened.png" or "closed.png"),
			priority = -130,
			callback = function()
				if isEffect then
					audio.stopMusic( false )
					audio.disable()
					KNFileManager.updatafile("savefile.txt" , "sound" , "=" , 1)
				else
					KNFileManager.updatafile("savefile.txt" , "sound" , "=" , 0)
					audio.enable()
					if audio.isMusicPlaying() == false then
						audio.playMusic( IMG_PATH .. "sound/background.mp3" , true )
					end
					
				end
				createBtn( musicBtn )
			end
		}):getLayer()
		--setting_layer:addChild(musicBtn)
		music_bg:addChild(musicBtn)
	end
	createBtn()


	-- 音效
	local sound_effect_bg = display.newSprite(COMMONPATH .. "item_bg_high.png")
	setAnchPos(sound_effect_bg , 28 , 441)
	--setting_layer:addChild(sound_effect_bg)
	settingScrollView:addChild(sound_effect_bg)
	
	local sound_effect_title = display.newSprite(PATH .. "sound_effect.png")
	setAnchPos(sound_effect_title , 10 , 20)
	--setting_layer:addChild(sound_effect_title)
	sound_effect_bg:addChild(sound_effect_title)
	
	local function createEffect( target )
		if target then target:removeFromParentAndCleanup( true ) end 
		
		local isPlay = audio.getIsEffect()
		local sound_effectBtn
		sound_effectBtn = KNBtn:new(COMMONPATH, isPlay and { "btn_bg.png" } or { "btn_bg_grey.png" } , 330 , 20 , {
			front = PATH .. ( isPlay and "opened.png" or "closed.png"),
			priority = -130,
			callback = function()
				if isPlay then
					KNFileManager.updatafile("savefile.txt" , "audio" , "=" , 1)
					audio.setIsEffect( false )
					--audio.playSound()
					--audio.setIsEffect( not  isPlay )
					
					createEffect( sound_effectBtn )
				else
					KNFileManager.updatafile("savefile.txt" , "audio" , "=" , 0)
					audio.setIsEffect( true )
					createEffect( sound_effectBtn )
				end
				
				
			end
		}):getLayer()
		--setting_layer:addChild(sound_effectBtn)
		sound_effect_bg:addChild(sound_effectBtn)
	end
	createEffect()
	--小助手
	local cur_mission_step = DATA_Guide:get()
	if (cur_mission_step["map_id"] > 11  or (cur_mission_step["map_id"] == 11  and cur_mission_step["mission_id"] >= 5) ) and OPENAIDE then
		local aideBtn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
			parent = settingScrollView , 
			other =  { PATH .. "aide.png" , 10 , 20 } , 
			priority = -130,
			callback = function()
				mask:remove()
				local homeLayer = requires(IMG_PATH,"GameLuaScript/Scene/home/homelayer")
				homeLayer:createAide()
			end
		}):getLayer()
		settingScrollView:addChild(aideBtn)
	end

	if IN_BANHAO == nil then
		--公告
		local noticeBtn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
			parent = settingScrollView , 
			other =  { COMMONPATH .. "notice.png" , 0 , 20 } , 
			priority = -130,
			callback = function()
				mask:remove()
				
				local noticeLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/notice")
				local curScene = display.getRunningScene()
				local temp = noticeLayer:new()
				if temp ~= "not notice" then
					curScene:addChild( temp:getLayer() )
				else
					KNMsg.getInstance():flashShow( "当前没有公告！" )
				end
			end
		}):getLayer()
		settingScrollView:addChild(noticeBtn)
	end

	if IN_BANHAO == nil then
		local headLineBtn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } ,28, 0 , {
			parent = settingScrollView , 
			other =  { PATH .. "headline.png" , 10 , 20 } , 
			priority = -130,
			callback = function()
				
				HTTP:call("headlines", "get", {} , {success_callback = function()
						local headlineLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/headline")
						local curScene = display.getRunningScene()
						local temp = headlineLayer:new()
						if temp ~= "no headlines" then 
							curScene:addChild( temp:getLayer() )
						else
							KNMsg.getInstance():flashShow( "当前没有头条！" )
						end
						return
				end})
				mask:remove()

			end
		}):getLayer()
		settingScrollView:addChild(headLineBtn)
	end
	

	-- 游戏论坛
if this.isBBSUrlShow == 1 and IN_BANHAO == nil then
	local feedback_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 357 , {
		parent = settingScrollView , 
		other =  { PATH .. "bbs.png" , 10 , 20 } , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()
			local bbs_url = this.BBSUrl
			if device.platform == "android" or device.platform == "wp8" then
				UpdataRes:getInstance():openUrl( bbs_url )
			elseif device.platform =="ios" then
       			UpdateDataOC:getInstance():openUrl(bbs_url)
			else	
				local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
				local response = io.readfile(IMG_PATH .. "temp_battle.txt")
				response = json.decode( response )

				DATA_Battle:setMod("guide")
				DATA_Battle:setAct("execute")
				DATA_Battle:set( response )
				local function overFun()
					switchScene("home")
				end
				
				switchScene("battle" , { resultCallFun = overFun } )
			end
		end
	}):getLayer()
	--setting_layer:addChild(feedback_bg)
	settingScrollView:addChild(feedback_bg)
end
	
if this.isGongLveUrlShow == 1 and IN_BANHAO == nil then	
-- 游戏攻略
	local help_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 273 , {
		parent = settingScrollView , 
		other = { PATH .. "gonglve.png" , 10 , 20 }  , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()
			local bbs_url = this.gongLveUrl
			if device.platform == "android" or  device.platform == "wp8" then
				UpdataRes:getInstance():openUrl( bbs_url )
			elseif device.platform =="ios" then
       			UpdateDataOC:getInstance():openUrl(bbs_url)
       		end
		end
	}):getLayer()
	--setting_layer:addChild(help_bg)
	settingScrollView:addChild(help_bg)
end


-- 更多游戏
if CHANNEL_ID == "uucun" then
	local more_games_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 273 , {
		parent = settingScrollView , 
		other = { PATH .. "more_games.png" , 10 , 20 }  , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()
			local url = "http://ad.plat56.com"

			if device.platform == "android" or  device.platform == "wp8" then
				UpdataRes:getInstance():openUrl( url )
			elseif device.platform =="ios" then
       			UpdateDataOC:getInstance():openUrl(url)
       		end
		end
	}):getLayer()
	settingScrollView:addChild(more_games_bg)
end

-- 多酷 客服电话&QQ
if CHANNEL_ID == "longyin" or CHANNEL_ID == "mi" or CHANNEL_ID == "mm" or CHANNEL_ID == "downjoy" or CHANNEL_ID == "DK" or CHANNEL_ID == "anzhi" or CHANNEL_ID == "kugou" or CHANNEL_ID == "sohu" or CHANNEL_ID == "shoumeng" or CHANNEL_ID == "gfan" or CHANNEL_ID == "nearme.gamecenter" or CHANNEL_ID == "dahua" or CHANNEL_ID == "ifeng" or CHANNEL_ID == "changwan" or CHANNEL_ID == "tianyi" or CHANNEL_ID == "wdj" 
		or CHANNEL_ID == "ppw" or CHANNEL_ID == "sky" or CHANNEL_ID == "sqwan" or CHANNEL_ID == "dianjin" or CHANNEL_ID == "lybd" or CHANNEL_ID == "meizu" or CHANNEL_ID == "ywyd" or CHANNEL_ID == "nd91" or CHANNEL_ID == "egame"  or CHANNEL_ID == "fgwan" or CHANNEL_GAME == "ayou" then
	local more_games_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 273 , {
		parent = settingScrollView , 
		other = { PATH .. "dk/qq.png" , 10 , 20 }  , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function() end
	}):getLayer()
	settingScrollView:addChild(more_games_bg)

	local more_games_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 273 , {
		parent = settingScrollView , 
		other = { PATH .. "dk/mobile.png" , 10 , 20 }  , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function() end
	}):getLayer()
	settingScrollView:addChild(more_games_bg)
end

-- 移动mm 客服电话&QQ
--[[
if CHANNEL_ID == "mm" then
	local more_games_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 273 , {
		parent = settingScrollView , 
		other = { PATH .. "mm/qq.png" , 10 , 20 }  , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function() end
	}):getLayer()
	settingScrollView:addChild(more_games_bg)

	local more_games_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 273 , {
		parent = settingScrollView , 
		other = { PATH .. "mm/mobile.png" , 10 , 20 }  , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function() end
	}):getLayer()
	settingScrollView:addChild(more_games_bg)
end
]]

 --CHANNEL_ID=="tmsjIosAppStore" or CHANNEL_ID == "jstfIosAppStore" or CHANNEL_ID == "hysjIosAppStore" or CHANNEL_ID =="tgxyIosAppStore"
 --if CHANNEL_ID == "hysjIosAppStore" or CHANNEL_ID =="tgxyIosAppStore" then
 if this.isCDKey == 1 and IN_BANHAO == nil then
 --else
-- 激活码
 
	local help_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 273 , {
		parent = settingScrollView , 
		other = { PATH .. ( "jihuoma.png" ) , 10 , 20 }  , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()
			switchScene("uc_jihuoma")
		end
	}):getLayer()
	settingScrollView:addChild(help_bg)	
end
	

if CHANNEL_ID == "hysjIos91" or CHANNEL_ID == "tgxyIos91" then
    -- 91社区
	local center91_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 357 , {
		parent = settingScrollView , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()

			if device.platform =="ios" then
       			LuaCall91PlatForm:getInstance():enter91Center()
			end
		end
	}):getLayer()
	--setting_layer:addChild(feedback_bg)
	settingScrollView:addChild(center91_bg)

	local center91_title = display.newSprite(PATH .. "91Center.png")
	setAnchPos(center91_title , 10 , 20)
	--setting_layer:addChild(feedback_title)
	center91_bg:addChild(center91_title)


    -- 91平台18183BBS
	local BBS18183_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 357 , {
		parent = settingScrollView , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()
			if device.platform =="ios" then
       			LuaCall91PlatForm:getInstance():enter18183BBS()
			end
		end
	}):getLayer()
	--setting_layer:addChild(feedback_bg)
	settingScrollView:addChild(BBS18183_bg)

	local BBS18183_title = display.newSprite(PATH .. "18183BBS.png")
	setAnchPos(BBS18183_title , 10 , 20)
	--setting_layer:addChild(feedback_title)
	BBS18183_bg:addChild(BBS18183_title)


	-- 91用户反馈
	local userFeedBack_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 357 , {
		parent = settingScrollView , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()
			if device.platform =="ios" then
       			LuaCall91PlatForm:getInstance():userFeedBack()
			end
		end
	}):getLayer()
	--setting_layer:addChild(feedback_bg)
	settingScrollView:addChild(userFeedBack_bg)

	local userFeedBack_title = display.newSprite(PATH .. "userFeedBack.png")
	setAnchPos(userFeedBack_title , 10 , 20)
	--setting_layer:addChild(feedback_title)
	userFeedBack_bg:addChild(userFeedBack_title)
end


-- 游龙腾,pp助手，同步推
if CHANNEL_ID == "tmsjIosPP" or CHANNEL_ID == "tmsjIosItools" or CHANNEL_ID == "tmsjIosKY" or CHANNEL_ID == "tmsjIosTBT" or CHANNEL_ID == "hysjIosYLT" or (CHANNEL_ID == "hysjIosAppStore" and not __INNER_IOS_SDK_VER) or CHANNEL_ID == "hysjIosPP" or CHANNEL_ID=="hysjIosTBT" or CHANNEL_ID=="hysjIosKY" or CHANNEL_ID == "tgxyIosKY" or CHANNEL_ID== "hyxsdIosItools" or CHANNEL_ID == "tgxyIosPP" or CHANNEL_ID == "tgxyIosItools" then

	-- ylt 个人中心
	local center91_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 357 , {
		parent = settingScrollView , 
		priority = -130,
		upSelect = true,
		parent = settingScrollView,
		callback = function()

			if device.platform =="ios" then
				if CHANNEL_ID == "hysjIosYLT" or CHANNEL_ID == "hysjIosAppStore" then
       				LuaCallYLTSDK:getInstance():showUserCenter()
       			elseif CHANNEL_ID == "hysjIosPP" or CHANNEL_ID == "tgxyIosPP" or CHANNEL_ID == "tmsjIosPP" then
       				LuaCallPPSDK:getInstance():showUserCenter()
       			elseif CHANNEL_ID == "hysjIosTBT" or CHANNEL_ID == "tgxyIosTBT" or CHANNEL_ID == "tmsjIosTBT" then
       				LuaCallTBTPlatform:getInstance():showUserCenter()
       			elseif CHANNEL_ID == "hysjIosKY" or CHANNEL_ID == "tgxyIosKY" or CHANNEL_ID == "tmsjIosKY" then
       				KNMsg.getInstance():flashShow("对不起，快用助手个人中心暂未开放")
                elseif CHANNEL_ID == "hyxsdIosItools" or CHANNEL_ID == "tgxyIosItools" or CHANNEL_ID == "tmsjIosItools" then
                    LuaCalliToolsSDK:getInstance():showUserCenter()
       			end
			end
		end
	}):getLayer()
	--setting_layer:addChild(feedback_bg)
	settingScrollView:addChild(center91_bg)

	local center91_title = display.newSprite(PATH .. "userCenter.png")
	setAnchPos(center91_title , 10 , 20)
	--setting_layer:addChild(feedback_title)

	if CHANNEL_ID == "tmsjDK" then
	
	else 
		center91_bg:addChild(center91_title)
	end 

	-- 注销,pp没有
	if CHANNEL_ID ~="hysjIosPP" and CHANNEL_ID ~="hysjIosTBT" and CHANNEL_ID ~= "tmsjIosPP" and CHANNEL_ID ~= "tgxyIosPP" and CHANNEL_ID ~= "tgxyIosTBT" and CHANNEL_ID ~= "tmsjIosTBT" and CHANNEL_ID ~= "hysjIosAppStore" then
		local logout_bg = KNBtn:new( COMMONPATH , { "item_bg_high.png" } , 28 , 357 , {
			parent = settingScrollView , 
			priority = -130,
			upSelect = true,
			parent = settingScrollView,
			callback = function()
				if device.platform =="ios" then
	       			if CHANNEL_ID == "hysjIosYLT" or CHANNEL_ID == "hysjIosAppStore" then
	       				LuaCallYLTSDK:getInstance():logout()
	       			elseif CHANNEL_ID =="hysjIosKY" or CHANNEL_ID == "tgxyIosKY" or CHANNEL_ID == "tmsjIosKY" then
	       				LuaCallKYSDK:getInstance():logout()
	       			end
				end
			end
		}):getLayer()
		--setting_layer:addChild(feedback_bg)
		settingScrollView:addChild(logout_bg)

		local logout_title = display.newSprite(PATH .. "loginOut.png")
		setAnchPos(logout_title , 10 , 20)
		--setting_layer:addChild(feedback_title)
		logout_bg:addChild(logout_title)
	end
end

	
if CHANNEL_ID == "game1" or CHANNEL_ID == "test" or CHANNEL_ID == "windows" then
	--领取充值返三倍黄金
	local getGold = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
		parent = settingScrollView , 
		other =   { PATH .. "get_gold.png" , 10 , 20 } ,
		priority = -130,
		callback = function()
			local function showGold( tempData )
				tempData = tempData or {}
				
				local popLayer = display.newLayer()
				local popmask
				popLayer:addChild( display.newSprite( COMMONPATH .. "tip_bg.png" , display.cx , 336 , 0.5 , 0 ) )
				popLayer:addChild( display.newSprite( PATH .. "get_gold_tip.png" , display.cx , 505 , 0.5 , 0 ) )
				popLayer:addChild( display.newSprite( PATH .. "today_get.png" , display.cx , 443 , 0.5 , 0 ) )
				--之前充值了多少
				popLayer:addChild( display.strokeLabel( tempData.paygold , 255 , 540, 18 , ccc3(0x2c, 0x00, 0x00 ), nil, nil, {
					dimensions_width = 50,
					dimensions_height = 20 ,
					align = 1,
				}) )
				--总计可领
				popLayer:addChild( display.strokeLabel( tonumber(tempData.paygold) * 3 , 50 , 508, 18 , ccc3(0x2c, 0x00, 0x00 ), nil, nil, {
					dimensions_width = 67,
					dimensions_height = 20 ,
					align = 1,
				}) )
				--每天可领
				popLayer:addChild( display.strokeLabel( tempData.onceback , 322 , 508, 18 , ccc3(0x2c, 0x00, 0x00 ), nil, nil, {
					dimensions_width = 67,
					dimensions_height = 20 ,
					align = 1,
				}) )
				--今天可领
				popLayer:addChild( display.strokeLabel( tempData.onceback , 180 , 448, 18 , ccc3(0x2c, 0x00, 0x00 ), nil, nil, {
					dimensions_width = 50,
					dimensions_height = 20 ,
					align = 1,
				}) )
				--还能领取多少次
				popLayer:addChild( display.strokeLabel( tempData.remain , 375 , 448, 18 , ccc3(0x2c, 0x00, 0x00 ), nil, nil, {
					dimensions_width = 25,
					dimensions_height = 20 ,
					align = 1,
				}) )
				
				popLayer:addChild( KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, 77 , 361 , {
											front = COMMONPATH .. "get.png" ,
											priority = -131,
											callback = 
											function()
												HTTP:call("feedback", "pay", {} , {success_callback = function() popmask:remove()  end})
											end}):getLayer())
				popLayer:addChild( KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, 267 , 361 , {
											front = COMMONPATH .. "cancel.png" ,
											priority = -131,
											callback = 
											function()
												popmask:remove()
											end}):getLayer())
									
				setAnchPos( popLayer , 0 , display.height )
				transition.moveTo(  popLayer , { time = 0.3 , y = 0 , easing = "BACKOUT" })
				popmask = KNMask:new( { item = popLayer , priority = -131 } )
				this.layer:addChild( popmask:getLayer() )
			end
			HTTP:call("feedback", "get_pay", {} , {success_callback = function(tempData) showGold( tempData ) end})
		end
	}):getLayer()
	settingScrollView:addChild( getGold )
end


if CHANNEL_ID == "game1" or CHANNEL_GROUP == "tgxy" or CHANNEL_ID == "tgxy2.test.haoyi" or CHANNEL_ID == "tmsj" or CHANNEL_ID == "tmsjIosAppStore" or CHANNEL_ID == "tmsjmyapp" or CHANNEL_ID == "tmsj_bds" or CHANNEL_ID == "tmsj.gdt" or CHANNEL_ID == "tmsjios" or CHANNEL_ID == "jstfIosAppStore" or CHANNEL_ID == "windows" then
	--账号管理
	local passwordBtn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
		parent = settingScrollView , 
		other =   { PATH .. "password.png" , 10 , 20 } ,
		priority = -130,
		callback = function()
			local url = CONFIG_HOST .. "/html.php?m=security&a=password&server_id=" .. DATA_Session:get("server_id") .. "&sid=" .. DATA_Session:get("sid") .. "&uid=" .. DATA_Session:get("uid") .. "&channel=" .. CHANNEL_ID .. "&channel_group=" .. CHANNEL_GROUP
			if device.platform == "android" or  device.platform == "wp8" then
				UpdataRes:getInstance():openUrl( url )
			elseif device.platform =="ios" then
       			UpdateDataOC:getInstance():openUrl(url)
       		else
       			KNMsg.getInstance():flashShow("手机才能使用该功能")
       		end
		end
	}):getLayer()
	settingScrollView:addChild( passwordBtn )
end

if CHANNEL_ID == "jstf" or CHANNEL_ID == "jstf_iospj" or CHANNEL_ID == "jstf_bds" then
	--账号管理(第一波SDK)
	local passwordBtn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
		parent = settingScrollView , 
		other =   { PATH .. "password.png" , 10 , 20 } ,
		priority = -130,
		callback = function()
			local url = CONFIG_HOST .. "/html.php?m=jstfsecurity&a=password&server_id=" .. DATA_Session:get("server_id") .. "&sid=" .. DATA_Session:get("sid") .. "&uid=" .. DATA_Session:get("uid") .. "&channel=" .. CHANNEL_ID .. "&channel_group=" .. CHANNEL_GROUP
			if device.platform == "android" or  device.platform == "wp8" then
				UpdataRes:getInstance():openUrl( url )
			elseif device.platform =="ios" then
       			UpdateDataOC:getInstance():openUrl(url)
       		else
       			KNMsg.getInstance():flashShow("手机才能使用该功能")
       		end
		end
	}):getLayer()
	settingScrollView:addChild( passwordBtn )
end

if CHANNEL_ID == "hyDK" then
	local passwordBtn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
		parent = settingScrollView , 
		other =   { PATH .. "userCenter.png" , 10 , 20 } ,
		priority = -130,
		callback = function()
			if device.platform == "android" then
				hyDKSDK:getInstance():hyDKAccountManager(function() end)
			elseif device.platform =="ios" then
       			
       		else
       			KNMsg.getInstance():flashShow("手机才能使用该功能")
       		end
		end
	}):getLayer()
	settingScrollView:addChild( passwordBtn )
end

if CHANNEL_ID == "one.HUAWEI" or CHANNEL_ID == "tgxy.huawei" then
	--注销sdk账号
	local btn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
		parent = settingScrollView , 
		other =   { PATH .. "loginOut.png" , 10 , 20 },
		priority = -130,
		callback = function()
			if device.platform == "android" then
				huaweiSDK:getInstance():huaweiLogout(function(response)
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end)
			elseif device.platform =="ios" then
       			
       		else
       			KNMsg.getInstance():flashShow("手机才能使用该功能")
       		end
		end
	}):getLayer()
	settingScrollView:addChild(btn)
end

if CHANNEL_ID == "hy.uc" or CHANNEL_ID == "tgxy.uc" or CHANNEL_ID == "tmsj.uc" or CHANNEL_ID == "uc" then
	--注销sdk账号
	local btn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
		parent = settingScrollView , 
		other =   { PATH .. "loginOut.png" , 10 , 20 },
		priority = -130,
		callback = function()
			if device.platform == "android" then
				ucSDK:getInstance():ucLogout(function(response)
					dump(response, "logout")
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end)
			elseif device.platform =="ios" then
       			
       		else
       			KNMsg.getInstance():flashShow("手机才能使用该功能")
       		end
		end
	}):getLayer()
	settingScrollView:addChild(btn)
end

if CHANNEL_ID == "hyqihoo" or CHANNEL_ID == "tgxyqihoo" or CHANNEL_ID == "tmsjqihoo"  then
	-- 退出
	local btn = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
		parent = settingScrollView , 
		other =   { PATH .. "exit.png" , 10 , 20 },
		priority = -130,
		callback = function()
			if device.platform == "android" then
				san60SDK:getInstance():san60Exit()
			elseif device.platform =="ios" then
       			
       		else
       			KNMsg.getInstance():flashShow("手机才能使用该功能")
       		end
		end
	}):getLayer()
	settingScrollView:addChild(btn)
end

local addItem = 
 function(icon, callback)
	local btn = KNBtn:new(COMMONPATH , { "item_bg_high.png" }, 28, 0,
	{
		parent = settingScrollView , 
		other =   { PATH .. icon, 10, 20 },
		priority = -130,
		callback = function()
			if type(callback) == "function" then callback() end
		end
	})
	settingScrollView:addChild(btn:getLayer())
	return btn
end

if CHANNEL_ID == "hyylt" or CHANNEL_ID == "hy.leteng" or CHANNEL_ID == "hyylt20070" or CHANNEL_ID == "hyylt20071" or CHANNEL_ID == "hyylt20072" or CHANNEL_ID == "hyylt20073" or CHANNEL_ID == "hyylt20074" or CHANNEL_ID == "hyylt20075" then
	addItem("userCenter.png", function()
		DirectChannel.instance():call( { action = "manage", })
	end)
	
	addItem("loginOut.png", function()
		DirectChannel.instance():call(
		{
			action = "logout",
			callback = function(response)
				dump(response, "logout")
				Clock:removeTimeFun("heartbeat")
				SOCKET:getInstance("battle"):close()
				SOCKET:delInstance("battle")
				switchScene("login")
			end
		})
	end)
	
	if __INNER_VERSION__ and __INNER_VERSION__ >= 1 then
		addItem("tieba.png", function()
			DirectChannel.instance():call(
			{
				action = "enter",
				name = "火影小时代",
			})
		end)
	end
end

if CHANNEL_ID == "hydl" or CHANNEL_ID == "tgxydl" or CHANNEL_ID == "tmsjdl" then	
	addItem("loginOut.png", function()
		dlSDK:getInstance():dlLogout(function()
			dump(response, "logout")
			Clock:removeTimeFun("heartbeat")
			SOCKET:getInstance("battle"):close()
			SOCKET:delInstance("battle")
			switchScene("login")
		end)
	end)
end


if CHANNEL_ID == "hy.mi" or CHANNEL_ID == "tgxy.mi" or CHANNEL_ID =="tgxy.yiwan.ewan" or CHANNEL_ID =="tgxy.yiwan.ewan" or CHANNEL_ID == "tmsj.mi" then	
	addItem("userCenter.png", function()
		DirectChannel.instance():call(
		{
			action = "manage",
		})
	end)
end

if CHANNEL_ID =="tgxy.nearme.gamecenter" or CHANNEL_ID =="tmsj.nearme.gamecenter" then	
	addItem("forum.png", function()
		DirectChannel.instance():call(
		{
			action = "forum",
		})
	end)
end


if CHANNEL_ID == "tmsj.heitao" or CHANNEL_ID == "tmsj.heitao1" then 
	DirectChannel.instance():call(
		{
			action = "isEnabledBBS",
			name = "唐门世界",
			callback = function(response)

				if response["result"] == "true" then
					addItem("forum.png", function()
						DirectChannel.instance():call(
						{
							action = "openBBS",
						})
					end)
				end
				
			end
	})
end


-- 百度贴吧__INNER_VERSION__ >= 1才存在sdk
if CHANNEL_ID == "tmsjDK" and __INNER_VERSION__ and __INNER_VERSION__ >= 1 then	
	--[[
	addItem("tieba.png", function()
		DirectChannel.instance():call(
		{
			action = "enter",
			name = "唐门世界",
		})
	end)
	--]]
end

--ios游龙腾官方和越狱 百度贴吧
if CHANNEL_ID == "hysjIosYLT" or (CHANNEL_ID =="hysjIosAppStore" and not __INNER_IOS_SDK_VER) then	
	addItem("tieba.png", function()
		if UpdateDataOC:getInstance().openBaiDuTieBa then
			UpdateDataOC:getInstance():openBaiDuTieBa()
		end
	end)
end

--更换账号
if CHANNEL_ID == "tgxy3.sougou" or CHANNEL_ID =="tgxy.vivo" or CHANNEL_ID =="tgxy3.wdj" or CHANNEL_ID == "tgxy3.sg" then 
	addItem("changeAc.png", function()
		DirectChannel.instance():call(
		{
			action = "switchUser",
		})
	end)
end

if device.platform ~= "wp8" then

	addItem("serverInfo.png", function()
		local getMergeInfo = function(merge)
			local isMerged, info = false, ""
			if type(merge) == "table" then
				if #merge > 0 then isMerged = true end

				info = "合("
				for i = 1, #merge do
					if i == 1 or i == #merge then 
						info = info .. string.split(merge[i],"-")[1]
					end
					if i == 1 then info = info .. " 至 " end
				end
				info = info .. ")"

			end

			return isMerged, info
		end

		HTTP:call("profile", "get_merge_info", nil,
		{
			success_callback = function(response)
				-- dump(response, "response")

				mask:remove()

				local mask = baseMask( 
				{
					isShowBack = true,
					bgInfo = { path = IMG_PATH .. "image/scene/mission/bg.png",  y = 146 } }
				)


				local titleBg = display.newSprite( IMG_PATH .. "image/scene/mission/title_bg.png")
				setAnchPos(titleBg, display.cx, 637, 0.5, 0.5)
				mask:addChild(titleBg)
		
				local title = display.newSprite(PATH .. "t_serverInfo.png")
				setAnchPos(title, (titleBg:getContentSize().width - title:getContentSize().width) / 2, titleBg:getContentSize().height/2,  0, 0.5)
				titleBg:addChild(title)

				--命名服务器信息
				local named_server = response.headlines_server_name or ""

				-- 当前服务器
				local cur = response.myinfo
				local info = "当前服务器：".. named_server .. cur.name
				local isMerged, mergeInfo = getMergeInfo(cur.list)
				if isMerged then info = info .. "\n" .. mergeInfo end
									 
				mask:addChild( display.strokeLabel( info, 95, 502, 18, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
				{
					dimensions_width = 330,
					dimensions_height = 80,
					align = 0,
				}) )

				local mergeInfoBg = display.newSprite( PATH .. "merge_bg.png", 43, 220, 0, 0)
				local posX, posY = mergeInfoBg:getPositionX(), mergeInfoBg:getPositionY()
				
				local size = mergeInfoBg:getContentSize()

				mask:addChild(mergeInfoBg)
				mask:addChild( display.newSprite( PATH .. "all_merge.png", display.cx, 220 + size.height + 5, 0.5, 0) )

				local scroll = KNScrollView:new(posX + 10, posY + 10, size.width - 20, size.height - 20, 0, false, 0, { priority = -220,  } )
				scroll:alignCenter()
				mask:addChild( scroll:getLayer() )

				local allMerge = response.allinfo
				-- local allMerge = { { name = "官方1服", list = { "" } }, { name = "官方2服", list = { "" } } }
				local info = ""
				if #allMerge > 0 then
					for i = 1, #allMerge do
						local cur = allMerge[i]
						local isMerged, mergeInfo = getMergeInfo(cur.list)
						if isMerged then info = info .. (i == 1 and "" or "\n\n") .. cur.name .. "：" .. mergeInfo end
					end
				else
					info = "尚无合区"
				end

				local layer = display.newLayer()
				local width = size.width - 20
				local height = 30 * ( (#allMerge == 0) and 1 or #allMerge)
				local text = display.strokeLabel( info, 0, 0, 18, ccc3( 0x00, 0xff, 0x00 ), nil, nil,
				{
					dimensions_width = width,
					dimensions_height = height,
					align = 0,
				})
				layer:addChild(text)
				layer:setContentSize( text:getContentSize() )
				scroll:addChild(layer)
				
			end
		})
		
	end)

	
end

do--更改账号
	if __INNER_SELF_LOGIN then
		local changeAc = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
			parent = settingScrollView , 
			other =   { PATH .. "changeAc.png" , 10 , 20 } ,
			priority = -130,
			callback = function()
				mask:remove()
				if SOCKET:returnInstance("battle") then
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
				end
				switchScene("login")
			end
		}):getLayer()
		settingScrollView:addChild( changeAc )
	end
end


--------------------------------------------------------------------------
--新的ios联运方案, 以后旧ios的联运平台会慢慢转移到这[ by antion 2014.09.15 ]
if __INNER_IOS_SDK_VER then
	if channel_delegate:getInst():hasUserCenter() then
		if CHANNEL_ID == "tmsjDK" then 
			dump(" tmsjDK -- donothing")
		else 
			addItem("userCenter.png", function()
			channel_delegate:getInst():userCenter()
			end)
		end

	end

	if __INNER_IOS_SDK_VER >= 4 then--4以上加了多功能函数
		local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
		--检查是否有百度贴吧
		if channel_delegate:getInst():call(json.encode({type="hasBaiduTieba"}), function()end) then
			addItem("tieba.png", function()
				channel_delegate:getInst():call(json.encode({type="baiduTieba"}), function()end)
			end)
		end
		--检查是否有注销
		if channel_delegate:getInst():call(json.encode({type="hasLogout"}), function()end) then
			addItem("loginOut.png", function()
				channel_delegate:getInst():call(json.encode({type="logout"}), function()end)
			end)
		end
	end
end
--------------------------------------------------------------------------


--------------------------------------------------------------------------
--开启、屏蔽陌生人私聊
HTTP:call("message", "get_reject_stranger_status", nil, {
	success_callback = function(data)
		local isRej = data.reject_stranger
		local item
		item = addItem(isRej == 0 and "privateChat1.png" or "privateChat2.png", function()
			HTTP:call("message", "set_reject_stranger_status", {is_reject=isRej == 0 and 1 or 0}, {
				success_callback = function(data)
					isRej = isRej == 0 and 1 or 0
					item:setOther(display.newSprite(PATH ..(isRej == 0 and "privateChat1.png" or "privateChat2.png")))
				end
			})
		end)
		settingScrollView:alignCenter()
	end
})
--------------------------------------------------------------------------

-- do--退出游戏
-- 	local exitGame = KNBtn:new(COMMONPATH , { "item_bg_high.png" } , 28, 0 , {
-- 		parent = settingScrollView , 
-- 		other =   { PATH .. "exitGame.png" , 10 , 20 } ,
-- 		priority = -130,
-- 		callback = function()
-- 			KNMsg.getInstance():boxShow( "是否确认退出游戏? \n\n\n" ,{ 
-- 				confirmFun = function() 
-- 					mask:remove()
-- 					os.exit(0) 
-- 				end, 
-- 				cancelFun = function() end 
-- 			})
-- 		end
-- 	}):getLayer()
-- 	settingScrollView:addChild( exitGame )
-- end

    setting_layer:addChild(settingScrollView:getLayer())
    settingScrollView:alignCenter()

	-- 遮罩
	setAnchPos( setting_layer , 0 , -display.height )
	transition.moveTo(  setting_layer , { time = 0.5 , y = 0 , easing = "SINEOUT" })
	
	mask = KNMask:new({item = setting_layer})
	this.layer:addChild( mask:getLayer() )
	

	
	

	
    return this
end


function SettingLayer:getLayer()
	return self.layer
end


return SettingLayer
