-- 设置界面
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNClock = requires(IMG_PATH,"GameLuaScript/Common/KNClock")

local KNInputText

if device.platform == "wp8" then
	KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNEditBox")
else
	KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
end

local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local oneMessage = requires(IMG_PATH , "GameLuaScript/Scene/chat/oneMessage")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")

local PATH = IMG_PATH .. "image/scene/chat/"
local data 
local friendData = nil
local isAll = true		--好友聊天中是否显示全部
local newAddY = 50		--输入框新调整坐标
local scroll_y = 420  + newAddY	 
local scroll_height = 360 - newAddY
local delayTime = 5
local allSingleBtn 
local M = {
}
--设置聊天对象

function M:new( params )
	local this = {}
	setmetatable(this , self)
	self.__index = self
	TALK = this
	this.params = params or {}
	this.params.priority = this.params.priority or -129
	self.curType = params.type or "world"
	
	if self.curType == "custom" then
		DATA_Info:setCustomKey( string.join( this.params.custom["sendParams"] , "_") )
	end
	
	friendData = params.friendData
	if friendData then isAll = false end
	
	
	this.baseLayer = display.newLayer()
	this.tabLayer = display.newLayer()
	this.inputLayer =display.newLayer()
	
	DATA_Info:setIsMsg( false )	--消除消息状动画
	
	local mask , layer ,  tableElement 
	layer = display.newLayer()
	
	this.baseLayer:addChild( layer )
	this.baseLayer:addChild( this.tabLayer , 21 )
	
	-- 背景
	layer:addChild( display.newSprite(PATH .. "talk_bg.png" , display.cx , 357 , 0.5 , 0 ) )
	this.baseLayer:addChild( display.newSprite(PATH .. "talk_top_bg.png" , display.cx , 357+431 , 0.5 , 0 ) , 20 )
	this:showChatBox()
	--关闭
	local closeBtn = KNBtn:new( PATH , { "close.png" ,"close_press.png"}, 420 , 795 ,
	{
		priority = this.params.priority - 1, 
		callback = 
		function()
			DATA_Info:setIsMsg( false )
			DATA_Info:setIsOpen()
			mask:remove()
		end
	}):getLayer()
	this.tabLayer:addChild( closeBtn )

	
	
	
	
	if self.curType == "custom" or self.curType == "server" or self.curType == "war" or self.curType == "godwar" then
		tableElement = this.params.custom[ "customTable" ]
	else
		tableElement = { "world" , "gang" , "friend" }
	end
	
	local startX,startY = 20 , 797
	self.group = KNRadioGroup:new()
	for i = 1, #tableElement do
		local temp = KNBtn:new( PATH , {"btn_gray.png" , "btn_" .. tableElement[i] .. ".png" }  , startX , startY , {
			disableWhenChoose = true,
			priority = this.params.priority - 1, 
			upSelect = true,
			id = tableElement[i],
			front = PATH..tableElement[i].."_text.png" ,
			callback=
			function()
				this:changeStauts( false )
				self.curType = tableElement[i]
				this:refreshData()
			end
		},self.group)
		this.tabLayer:addChild(temp:getLayer())
		startX = startX + temp:getWidth() + 18
	end
	self.group:chooseById( self.curType , false )	--激活的选项
	this:refreshData()
	
	this.baseLayer:addChild( this.inputLayer , 50 )
	
	setAnchPos( this.baseLayer , 0 , display.height )
	transition.moveTo( this.baseLayer , { delay = 0.5 , time = 0.5 , y = 0 , easing = "BACKOUT" })
	mask = KNMask:new( { opacity = 180 , item = this.baseLayer , priority = this.params.priority} )
	
	function mask:stopKeyBoard()
		self.textfield:stopInput( true )
		DATA_Info:setIsOpen()
	end
	return mask
end
function M:setFriendData( tempData )
	if self.curType == "friend" then
		friendData = tempData
		self.toText:setString( friendData and "我对【" .. friendData.name .."】说:" or "" )
		isAll = false
		delayFun( 0.01 , function() self:createList() end)
		delayTime = 0
	end
end
function M:refreshData()
	self:setState()
	if self.curType == "world" then
		HTTP:call("message" , "gettalk" , {} , {
		
			success_callback = function()
				self:createList()
			end
		})
	elseif self.curType == "gang" then
		HTTP:call("alliance" , "getchat" , {} , {
			success_callback = function()
				data = DATA_Info:get_type("gang")
				if data.code == 1  then
					KNMsg:getInstance():flashShow("亲，你还没有加入一个帮会！")
					self.curType = "world"
					self.group:chooseById( self.curType , false )	--激活的选项
					data = DATA_Info:get_type("_G_message_talk")
					if not data then
						self.group:chooseById( self.curType , true )
					end
					return
				end
				self:createList( )
			end
		})
	elseif self.curType == "friend" then
		HTTP:call("message" , "get_siliao" , {} , {
			success_callback = function()
				self:createList()
			end
		})
	elseif self.curType == "server" or self.curType =="war" then
		self:createList()
	elseif self.curType == "godwar" then
		self:createList()
	elseif self.curType == "custom" then
		HTTP:call("message" , "get_scene_msg" , self.params.custom["sendParams"] , {
			success_callback = function()
				self:createList()
			end
		})
	
	end
end

function M:getType()
	return self.curType
end

function M:addItem( _data , type )
	local i = table.nums( data )
	if i<=1 then
		--小于1时，之前为空，需要重新创建，会自动处理
		self:createList()
	else
		local one_message = oneMessage:talknew( _data , nil , {
			type = self.curType ,
			index = i,
			first_line = true,
			parent = self.scroll ,
			color = ccc3( 0xfe , 0xfb , 0xd2 ) ,
			backFun = function( data ) self:setFriendData( data ) end ,
		})
		self.scroll:addChild( one_message:getLayer() , one_message )
		
		--实时接收到的数据添加进来后 重置滚动条
		if #data > 1 then
			self.scroll:setIndex( i , true )
		end
	end
end

function M:createList()
	local layer = display.newLayer()

	if self.viewLayer then
		self.baseLayer:removeChild( self.viewLayer, true )
	end
	
	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )
	self.viewLayer:addChild( layer )
	
	delObj( allSingleBtn )
	
	if self.curType == "gang" then
		data = DATA_Info:get_type("gang") or {}
	elseif self.curType == "friend" then
		data = DATA_Info:get_type( "friend" ) or {}
		local tempData = isAll and data or {}
		if friendData then
			for key , v in pairs( data ) do
				if not isAll then
					if tonumber( v.uid ) == tonumber( friendData.uid ) then
						tempData[ #tempData + 1 ] = v
					end
				end
			end
			data = tempData
		end
		
		
		--显示当前玩家聊天记录/所有聊天记录
		
		allSingleBtn = KNBtn:new( COMMONPATH , { "long_btn.png" , "long_btn_pre.png" }, 310 , 800 ,
		{
			priority = self.params.priority - 1, 
			front = PATH .. ( isAll and "show_all.png" or  "show_single.png" ) , 
			callback = 
			function()
				if isAll and not friendData then
					KNMsg:getInstance():flashShow("请选择说话对象！")
					return
				end
					isAll = not isAll
					if isAll then
						allSingleBtn:setFront( PATH .. "show_all.png" )
					else
						allSingleBtn:setFront( PATH .. "show_single.png" )
					end
					self:createList()
				end
			
		})
		self.tabLayer:addChild( allSingleBtn:getLayer() )
		
	elseif self.curType == "custom" then
		data = DATA_Info:get_type( "custom" )
		data = data[ self.params.custom["sendParams"]["scene"] .. "_" .. self.params.custom["sendParams"]["scene_id"] ] or {}
	elseif self.curType == "world" then
		data = DATA_Info:get_type("_G_message_talk") or {}
	elseif self.curType == "server" or self.curType == "war" then
		data = DATA_Info:get_type(self.curType) or {}
	elseif self.curType == "godwar" then
		data = DATA_Info:get_type(self.curType) or {}
	end
	
	if #data > 0 then
		-- 展示滚动消息
		self.scroll = KNScrollView:new(30 , scroll_y , 445 , scroll_height , 2 , false , 0 , {priority = self.params.priority - 1})
		for i = 1 , #data do
			local one_message = oneMessage:talknew( data[i] , nil , {
				type = self.curType ,
				index = i,
				first_line = true,
				parent = self.scroll ,
				color = ccc3( 0xfe , 0xfb , 0xd2 ) ,
				backFun = function( tempData ) self:setFriendData( tempData )  end ,
			})
			self.scroll:addChild(one_message:getLayer() , one_message)
		end
		--生成后定位
		if #data > 1 then
			self.scroll:setIndex(#data , true)
		end
		layer:addChild( self.scroll:getLayer() )
		
	else
		--没有数据的时候，显示为空
		self.empty_sprite = display.newSprite(IMG_PATH .. "image/common/empty.png")
		setAnchPos(self.empty_sprite , display.cx , display.cy + 120 , 0.5 , 0.5)
		layer:addChild( self.empty_sprite )
	end
	
end



function M:changeStauts( status )

	if device.platform == "wp8" then 
		return
	end
	
	local moveLength = 0
	local friendAddY = self.curType == "friend" and 30 or 0 
	if status == true then
		self.textfield:startInput()
		scroll_y = 520
		scroll_height = 240
		moveLength = 80
		if #data>0 then
			setAnchPos( self.scroll:getLayer() , 0 , 80 )
		end
	else
		-- print(self.textfield:getString())
		self.textfield:stopInput( false )
		scroll_y = 420 + newAddY
		scroll_height = 340 - newAddY
		moveLength = 0
		if #data>0 then
			setAnchPos( self.scroll:getLayer() , 0 , 0 )
		end
	end

	setAnchPos( self.haveHornNumSp , 26 , 331 + moveLength + newAddY )	
	setAnchPos( self.hornNum , 115 , 324 + moveLength + newAddY)	
	setAnchPos(self.send_btn , 373 , 363 + moveLength + newAddY)
	setAnchPos(self.input_bg , 14 , 360 + moveLength + newAddY)
	setAnchPos( self.textfield:getLayer() , 30 , 383 + moveLength + newAddY)
	setAnchPos( self.toText , 130  , 315  + moveLength + newAddY  )
	setAnchPos( self.findPlay:getLayer() ,13 , 315 + moveLength + newAddY  )
	
	
--	self:createList()
end
function M:showChatBox( )
	-- 切换真假输入框的状态
	self.textfield = KNInputText:new( { width = 365 , 
									height = (device.platform == "wp8" and 38 or 28) , 
									size = 20 , 
									defStr = "点击输入信息" , 
									existStr = nil ,
									defColor = ccc3( 0x4d , 0x15 , 0x15 ) , 
									inputColor = ccc3( 0x4d , 0x15 , 0x15 ),
									normalBg = PATH .. "talk_input_bg.png",
									priority = self.params.priority - 1,
									} )
	setAnchPos( self.textfield:getLayer() , 30  , 383 + newAddY )
	self.inputLayer:addChild( self.textfield:getLayer() , 10 )
	

	-- 真假输入框的背景
		
	if device.platform ~= "wp8" then
		self.input_bg =  KNBtn:new(PATH, {"talk_input_bg.png"} , 14 , 360 + newAddY  , {
			priority = self.params.priority - 1,
			callback = function()
				self:changeStauts(true)
			end
			}):getLayer()
		self.inputLayer:addChild(self.input_bg)
	end
	
	--说话提示文字
	self.toText = display.strokeLabel( friendData and "我对【" .. friendData.name .."】说:" or ""  ,  130  , 315  + newAddY , 20 , ccc3(0xff , 0xfc , 0xd3 ) , nil , nil ,
				 {
				 	 dimensions_width = 200 , 
				 	 dimensions_height = 30 , 
				 	 align = 0 
			 	})
 	self.inputLayer:addChild( self.toText )
 	--查找玩家
	self.findPlay = KNBtn:new( COMMONPATH , { "long_btn.png" , "long_btn_pre.png" } , 13 , 315 + newAddY , {
							priority = self.params.priority - 1,
							front = IMG_PATH .. "image/scene/friend/find_player_text.png" ,
							callback = function()
								local friendLayer = requires(IMG_PATH , "GameLuaScript/Scene/friend/friendLayer")
								friendLayer:findFriend( { type = "talk" ,priority = self.params.priority - 2, backFun = function( tempData ) self:setFriendData( tempData ) end } )
							end
							})
	self.inputLayer:addChild( self.findPlay:getLayer() )

	--拥有喇叭数
	self.haveHornNumSp = display.newSprite(PATH .. "have_horn_num.png")
	setAnchPos( self.haveHornNumSp , 26 , 331 + newAddY )			
	self.inputLayer:addChild( self.haveHornNumSp )
	
	--喇叭数
	local isHorn , hornTotleNum = DATA_Bag:getTypeNum( "prop" , "horn" )
	self.hornNum = display.strokeLabel( hornTotleNum or 0  ,  115  , 324  + newAddY , 18 , ccc3(0xff , 0xfc , 0xd3 ) , nil , nil ,
				 {
				 	 dimensions_width = 80 , 
				 	 dimensions_height = 30 , 
				 	 align = 0 
				 })
	self.inputLayer:addChild( self.hornNum )
	
	local function delayFun()
		delayTime = delayTime - 1
		if delayTime <= 0 then
			KNClock:removeTimeFun( "talk" )
			delayTime = 0
		end
	end
	
	if self.curType == "godwar" then
		local bg = display.newSprite(IMG_PATH.."image/scene/godwar/use.png")
		setAnchPos(bg, 10, 324 + newAddY)
		self.inputLayer:addChild(bg)
		
		 bg = display.newSprite(COMMONPATH.."gold.png")
		setAnchPos(bg, 60, 324 + newAddY)
		self.inputLayer:addChild(bg)
			
		bg = createLabel({str = self.params.cost, size = 21, color = ccc3(255,255,255)})	
		setAnchPos(bg, 90, 324 + newAddY)
		self.inputLayer:addChild(bg)
	
	end
	
	-- 发送输入框
	self.send_btn = KNBtn:new(IMG_PATH .. "image/common", {"btn_bg.png" , "btn_bg_pre.png"} , 373 , 363 + newAddY , {
		priority = -1000,
		-- priority = self.params.priority - 1,
		front = IMG_PATH .. "image/common/send.png",
		scale = true,
		noHide = true,
		callback = function()
			if KNClock:getKeyIsExist("talk") then
				if delayTime ~= 0 then
					KNMsg:getInstance():flashShow("亲，你说话太快了，请隔5秒再发送哦。")
					return
				end
			else
				--delayTime = 5
				--KNClock:addTimeFun( "talk" , delayFun )
			end
			if not friendData and self.curType == "friend" then 
				KNMsg:getInstance():flashShow("请选择说话对象!")
				return
			end
			if self.textfield:getString() == "" or self.textfield:getString() == "点击输入信息"  then 
				KNMsg:getInstance():flashShow("没有输入内容")
			elseif self.textfield:getCharCount() > 45 then	--45个汉字
				KNMsg:getInstance():flashShow("输入内容过长无法发送")
			else
				delayTime = 5
				KNClock:addTimeFun( "talk" , delayFun )
				if self.curType == "world" then
					if not isHorn then
						KNMsg:getInstance():flashShow("亲，你的喇叭不足，请至商城购买道具")
						return
					end
					HTTP:call("message" , "talk" , {
						content = self.textfield:getString()
					} , {
						success_callback = function(data)
							isHorn , hornTotleNum = DATA_Bag:getTypeNum( "prop" , "horn" )
							self.hornNum:setString( hornTotleNum )
							self:changeStauts(false)
						end})
					
				elseif self.curType == "gang" then
					HTTP:call("alliance" , "sendchat" , {
						content = self.textfield:getString()
					} , {
						success_callback = function()
							self:changeStauts(false)
						end
					})
				elseif self.curType == "custom" then
					local paramsData = clone( self.params.custom["sendParams"] )
					paramsData.content = self.textfield:getString()
					HTTP:call("message" , "send_scene_msg" , paramsData , {
						success_callback = function()
							self:changeStauts(false)
						end
					})
				elseif self.curType == "server" or self.curType == "war" then	
					if self.curType == "server" then
						SOCKET:getInstance("swar"):send("kuafu" , "server_chat" , 1103 , {
							key = self.params.key,
							name = DATA_User:get("name"),
							msg = self.textfield:getString()
						} , {
							success_callback = function()
								self:changeStauts(false)
							end
						})
					else
						SOCKET:getInstance("swar"):send("kuafu" , "war_chat" , 1108 , {
							key = self.params.key,
							field_id = self.params.field_id,
							name = DATA_User:get("name"),
							msg = self.textfield:getString()
						} , {
							success_callback = function()
								self:changeStauts(false)
							end
						})
					end
				elseif self.curType == "godwar" then
					HTTP:call("fengshen" , "talk" , {msg = self.textfield:getString()} ,
					 {
						success_callback = function()
							self:changeStauts(false)
						end
					})
				elseif self.curType == "friend" then
					HTTP:call("message" , "siliao" , {content = self.textfield:getString() , touid = friendData.uid } ,
					 {
						success_callback = function()
							self:changeStauts(false)
						end
					})
				end
			end
			self.textfield:setString("")
		end
	}):getLayer()
	
	if device.platform == "wp8" then
		self.inputLayer:addChild( self.send_btn, 11 )
	else
		self.inputLayer:addChild( self.send_btn )
	end
	
	if device.platform ~= "wp8" then
		local beginY = 0
		self.inputLayer:setTouchEnabled(true)
		self.inputLayer:registerScriptTouchHandler( 
						function(event,x,y)
							if event == CCTOUCHBEGAN then
								beginY = y
							end
							
							if event == CCTOUCHENDED then
								if math.abs( beginY - y ) < 30 then	--如果是移动则输入入法不消失
									self:changeStauts(false)
								end
							end 
							return true 
						end , false , self.params.priority - 1 )
						
		self:setState()
	end
	
end
--输入框下信息切换
function M:setState()
	local isFriend = self.curType == "friend"
	self.findPlay:getLayer():setVisible( isFriend )
	self.findPlay:setEnable( isFriend )
	self.toText:setVisible( isFriend )
	self.haveHornNumSp:setVisible( self.curType == "world" )
	self.hornNum:setVisible( self.curType == "world" )
	self.hornNum:setVisible( self.curType == "world" )
end

return M