--[[

		唐门世界属性加成界面

]]

local PATH = IMG_PATH .. "image/scene/detail/"

local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local M = {
	params,
	baseLayer,
	layer,
	addLayer,
}

local typeConfig = { "pve" , "pvp" }

function M:new( params )
	local this = {}
	setmetatable(this , self)
	self.__index = self
	this.params = params or {}
	this.baseLayer = display.newLayer()
	this.layer = display.newLayer()

	-- dump(this.params)
	local title = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(title , 0 , 420 , 0 , 0.5 )
	this.layer:addChild(title)

	-- 背景
	this.layer:addChild( display.newSprite(PATH .. "tmsjAddition_bg.png" , display.cx , 124-35 , 0.5 , 0 ) )

	local itemConfig = {
			{
				"pve",
				"pve.png",
				"pve_pre.png",
			},
			{
				"pvp",
				"pvp.png",
				"pvp_pre.png",
			},
		}

	this.cur_type = 1

	local startX , startY = 10 , 690
	this.group = KNRadioGroup:new()
	for i = 1, #itemConfig do
		temp = KNBtn:new(COMMONPATH .."tab", { "tab_star_normal.png" , "tab_star_select.png" } , startX , startY , {
			front = { IMG_PATH .. "image/scene/dragon/"  .. itemConfig[i][2] , IMG_PATH .. "image/scene/dragon/" .. itemConfig[i][3]},
			upSelect = true ,
			disableWhenChoose = true,
			id = itemConfig[i][1],
			callback = function()
				this.cur_type = i
				this:createAddLayer()
			end
		} , this.group)

		this.layer:addChild(temp:getLayer())
		startX = startX + temp:getWidth() + 4
	end

	this.group:chooseByIndex(this.cur_type, true)

	local line = display.newSprite(COMMONPATH .. "tab_line.png")
	setAnchPos(line , 6 , 685)
	this.layer:addChild(line)

	this.params.parent.layer:getParent():setPositionX(480)
	this.baseLayer:setPositionX(-480)

	local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
	this.layer:addChild( InfoLayer:new("tmsjAdditionInfo" , 0, {tail_hide = true, title_text =  IMG_PATH .. "image/scene/detail/tmsjAddition_title.png" , closeCallback = function() 
			this.params.parent.layer:getParent():setPositionX(0)
			this.baseLayer:removeFromParentAndCleanup(true)
	 end}):getLayer())

	this:createAddLayer()

	this.baseLayer:addChild( this.layer )
	return this
end

function M:createAddLayer(data)
	if self.addLayer then 
		self.layer:removeChild( self.addLayer , true )
	end

	self.addLayer = display.newLayer()
	local data = self.params.data[typeConfig[self.cur_type]]

	--	原始属性  i
	--	装备属性  e
	--	装备附加  ea
	--	组合      g
	--	升阶      s
	--	以上每一种都有四个: 例如  atk_s   def_s  agi_s  hp_s
	local keyElement = { { color = ccc3( 0xff , 0xfb , 0xd4 ) , key = "i"  } ,
					{ color = ccc3( 0x34 , 0x82 , 0x22 ) , 		key = "s"  } ,
					{ color = ccc3( 0x98 , 0x43 , 0x21 ) , 		key = "e"  } ,
					{ color = ccc3( 0x38 , 0x82 , 0xad ) , 		key = "tzzh"  } ,
					{ color = ccc3( 0xb7 , 0x34 , 0x94 ) , 		key = "g"  } ,
					{ color = ccc3( 0x5f , 0x00 , 0xea ) , 		key = "xd"  } ,
					{ color = ccc3( 0xff , 0xff , 0xff ) , 		key = "lm"  } ,
					{ color = ccc3( 0xff , 0xff , 0xff ) , 		key = "kj"  } ,
					{ color = ccc3( 0xff , 0xff , 0xff ) , 		key = "z"  } ,
					{ color = ccc3( 0xbf , 0x00 , 0x00 ) , 		key = "total"  } ,
					}
					
	local vElement = { "atk" , "def" , "hp" , "agi"  }
	local totalElement = { atk = 0 ,  def = 0 , agi = 0 , hp = 0 }
	for i = 1 , #keyElement do
		local key = keyElement[i].key
		for j = 1 , #vElement do
			local v = vElement[j]
			local addX , addY = 139 + ( j - 1 ) * 75 , 675 - ( i - 1 ) * ( i >= 6 and 45 or 48 )
			local curValue
			if key ~= "total" then
				curValue= data[ v .. "_" .. key ] or 0
				totalElement[ v .."" ] = totalElement[ v .."" ] + curValue
			else
				curValue = totalElement[ v .. "" ]
			end
			self.addLayer:addChild( display.strokeLabel( curValue , addX , addY - 88, 20 , keyElement[i].color , nil , nil ,{
					dimensions_width = 75 ,
					dimensions_height = 25,
					align = 1
				}) )
		end	
	end
	
	
	local pulseElement = { 'crit','block','hit','dodge','ctatk','kill' }
	for i = 1 , #pulseElement do
		local addX , addY = 40 + ( i - 1 ) * 65 , 220-30
		local curValue = data[pulseElement[i] .. "" ] or 0
		self.addLayer:addChild( display.strokeLabel( curValue , addX , addY - 88 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil ,{
				dimensions_width = 65 ,
				dimensions_height = 25,
				align = 1
			}) )
	end

	self.layer:addChild( self.addLayer )
end

function M:getLayer()
	return self.baseLayer
end

return M
