local PATH = IMG_PATH .. "image/scene/detail/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local infoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")


local detailLayer = {
	layer,
	info_layer,
	detailLayer,
}

local  dataEquip={}
local  g_gid=nil
local  heroInfos={}

local g_zhenfaData = {}
local g_zhenfaHide = nil
local g_choice = nil
local g_type = nil

function detailLayer:new(detail_name , params)

	dataEquip = {}
	g_gid = nil
	heroInfos = {}

	g_zhenfaData = {}
	g_zhenfaHide = nil
	g_choice = nil
	g_type = nil

	if params.zhenfaHide then 
		g_zhenfaHide=params.zhenfaHide
	end

	if params.heroData then
		
		if params.heroData.Firstshow then 
			if params.heroData.zhenfaData then
				g_zhenfaData = params.heroData.zhenfaData
			end

			if params.heroData.zhenfaData.gid then
				g_gid = params.heroData.zhenfaData.gid
			end

			if params.heroData.zhenfaData.heroInfos then
				heroInfos = params.heroData.zhenfaData.heroInfos
			end

			if params.heroData.choice then
				g_choice = params.heroData.choice
			end

		end  

	end


	

	local this = {}
	setmetatable(this , self)
	self.__index = self


	this.layer = display.newLayer()

	-- 背景
	local bg = display.newSprite(COMMONPATH .. "dark_bg.png")
	setAnchPos(bg , 0 , 88)						-- 70 是底部公用导航栏的高度
	this.layer:addChild(bg)

	this.info_layer = infoLayer:new("detail" , 0 , {
		tail_hide = true,
		noNavigation = params.noNavigation,
		priority = params.priority,
		title_text = detail_name=="groupsoul" and IMG_PATH .. "image/scene/goldequip/suitSoulTitle.png" or PATH .. "title.png",
		closeCallback = function()

			--刷新数据

			if g_zhenfaHide==2 then

				HTTP:call("zhenfa" , "initData",{},{
				success_callback = function(data)
					dataEquip.data = data or {}
					dataEquip.gid = g_gid or nil 
					dataEquip.choice = g_choice or nil
					dataEquip.heroInfos= heroInfos or {}
					switchScene("methodEquipment", {data=dataEquip}, function()  end)

				end
				})

			else 

				popScene()

			end 

			if params.backCallback then
				params.backCallback()
			end
		end
	})

	--将当前层传入，在popScene时可以进行更新
	params["main"] = {this, detail_name, params}

	-- dump(params)
	this:createLayer(detail_name, params)

	this.layer:addChild(this.info_layer:getLayer())
	return this
end

function detailLayer:createLayer(detail_name, params)
	if self.detailLayer then
		self.layer:removeChild(self.detailLayer:getLayer(), true)
	end

	-- 添加对应的 详情层
	local DetailName = nil
	if detail_name == "pet" then
		DetailName = requires(IMG_PATH , "GameLuaScript/Scene/detail/petdetail")
	elseif detail_name == "general" or detail_name == "hero" then
		DetailName = requires(IMG_PATH , "GameLuaScript/Scene/detail/herodetail")
	elseif detail_name == "prop" then
		DetailName = requires(IMG_PATH , "GameLuaScript/Scene/detail/propdetail")
	elseif detail_name == "skill" then
		DetailName = requires(IMG_PATH , "GameLuaScript/Scene/detail/skilldetail")
	elseif detail_name == "petskill" then
		DetailName = requires(IMG_PATH , "GameLuaScript/Scene/detail/petskilldetail")
	elseif detail_name == "equip" then
		DetailName = requires(IMG_PATH , "GameLuaScript/Scene/detail/equipdetail")
	elseif detail_name == "groupsoul" then
		DetailName = requires(IMG_PATH , "GameLuaScript/Scene/detail/groupsouldetail")
	end


	self.detailLayer = DetailName:new(params)
	self.layer:addChild(self.detailLayer:getLayer())
end

function detailLayer:getLayer()
	return self.layer
end


return detailLayer
