local PATH = IMG_PATH .. "image/scene/detail/"
local EQUIP_PATH = IMG_PATH .. "image/equip/"
local COMMONPATH = IMG_PATH .. "image/common/"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local Config = requires(IMG_PATH , "GameLuaScript/Config/Equip")
local Config_Property = requires(IMG_PATH , "GameLuaScript/Config/Property")
local Config_max = requires(IMG_PATH , "GameLuaScript/Config/equipstrongmax")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local GroupConf = requires(IMG_PATH, "GameLuaScript/Config/equipgroup")
local goldEquipLayer = requires(IMG_PATH , "GameLuaScript/Scene/groupequip/goldEquipUpgrade")
local equipgoldconf = requires(IMG_PATH , "GameLuaScript/Config/equipgoldconf")
local washlayer = requires(IMG_PATH , "GameLuaScript/Scene/strengthen/washlayer")

--[[装备信息]]
local EquipDetail = {
	layer,
	params
}

local g_zhenfaData = {}
local g_zhenfaHide = nil
local g_choice = nil
local g_type = nil

function EquipDetail:new(params)
	g_zhenfaHide = nil
	g_zhenfaData = {}
	g_choice = nil
	g_type = nil
	if params.zhenfaHide then
		g_zhenfaHide = params.zhenfaHide
	end

	if params.heroData then
		if params.heroData.Firstshow then 
			if params.heroData.zhenfaData then
				g_zhenfaData = params.heroData.zhenfaData
			end

			if params.heroData.choice then
				g_choice = params.heroData.choice
			end

			if params.heroData.type then
				g_type = params.heroData.type
			end
		end  

	end


	local this = {}
	setmetatable(this,self)
	self.__index = self
	this.layer = display.newLayer()
	this.viewLayer = display.newLayer()
	this.params = params or {}
	local isOther =  params.isOther or false	--是否是他人信息展示
	local otherAttribValue = nil				--后台计算当前值
	local pid = 0
	local _data = {}
	if params.id ~= nil then
		pid = params.id
		_data = isOther and DATA_OTHER:getBag( "equip" , pid ) or DATA_Bag:get("equip" , pid)
	elseif params.data ~= nil then
		_data = params.data
		pid = _data["id"]
		otherAttribValue = _data.otherAttribValue
	end
	pid = tonumber(pid)

	local cid = tostring(_data["cid"])
	local config_data = Config[cid]

	local bg_small = display.newSprite(COMMONPATH .. "bg_small.png")
	local bg = display.newSprite(PATH .. "small_bg.png")
	local big_icon = display.newSprite(getImageByType(cid , "b"))
	local maxLv = createLabel({str = "当前品质装备最高强化到"..Config_max[config_data["star"]]["levmax"].."级", width = 300})

	local name_label = display.strokeLabel( config_data["name"] , 65 , 660 , 24 ,DESCCOLOR )
	_data["lv"] = _data["lv"] or 1
	local lv_label = display.strokeLabel( "Lv" .. _data["lv"] , 250 , 660 , 18 ,DESCCOLOR )
	local split_sprite = display.newSprite(PATH .. "spilt.png")

	local effect_label = nil
	local str, proName

	if _data["effect"] ~= nil and _data["effect"] ~= "" then
		proName = Config_Property[_data["effect"]]
		 str =  proName .. " +" .. ( otherAttribValue and otherAttribValue or ( getConfig("equip" , _data.cid , "isgold" )==0 and _data["figure"] or (_data["figure"]+_data["gfigure"]) or "" ) )
	else
		if _data["type"] then
			if _data["type"] == "weapon" then
				proName = "攻击 "
			elseif _data["type"] == "defender" then
				proName = "防御 "
			elseif _data["type"] == "jewelry" then
				proName = "生命 "
			elseif _data["type"] == "shoe" then
				proName = "敏捷 "
			end
			str = proName.."+".. ( otherAttribValue and otherAttribValue or _data["initial"] )
		end
	end




	setAnchPos(bg_small , 18 , 120)
	setAnchPos(bg , 33 , 430)
	setAnchPos(big_icon , 110 , 450)
	setAnchPos(maxLv, 185, 620, 0.5)
	setAnchPos(split_sprite , 7 , 650)


	this.viewLayer:addChild(bg_small)
	this.viewLayer:addChild(bg)
	this.viewLayer:addChild(big_icon , 10)
	this.viewLayer:addChild(maxLv)
	this.viewLayer:addChild(name_label)
	this.viewLayer:addChild(lv_label)
	this.viewLayer:addChild(split_sprite)


	if _data.clock then
		this.viewLayer:addChild(createLabel({str = "剩余时间:\n".._data.clock, size = 20, x = 350, y = 380, align = 1}))
	end

	-- local border = display.newSprite(COMMONPATH.."star_border/detail_"..config_data["star"]..".png")
	-- setAnchPos(border, 20, 325)
	-- this.viewLayer:addChild(border)

	-- 装备星星
	local temp
	local y = 575
	for i = 1, config_data["star"] do
		temp = display.newSprite(COMMONPATH .. "star.png")
		setAnchPos(temp , 303 , y)
		this.viewLayer:addChild(temp)
		y = y - 32
	end

	--装备属性scrollView
	local equipDetailScrollView = KNScrollView:new(35,190,430,235,3,false,0,{
    		priority = params.godwar and -200 or -131,
    		--debug=true,
    })
	this.viewLayer:addChild(equipDetailScrollView:getLayer())

	local  contentLayer =display.newLayer()
	local contentLayerHeight = 370
	local fixY = 110   -- 纵向偏移修正
	contentLayer:setContentSize(CCSizeMake(400,contentLayerHeight))
	equipDetailScrollView:addChild(contentLayer)

	--套装属性
	if config_data.group ~= 0 then
		fixY=0
		local group_bg =  display.newSprite(PATH.."effect_bg.png")
		local group_txt = display.newSprite(PATH.."group_list.png")
    	setAnchPos(group_txt,3,3)
    	setAnchPos(group_bg,0,contentLayerHeight-27+fixY)
    	group_bg:addChild(group_txt)
    	contentLayer:addChild(group_bg)

    	--equipDetailScrollView:addChild(group_bg)


		local info = GroupConf[config_data.group..""]
		local count = 1
		local x, y = 30, contentLayerHeight-50+fixY
		--套装信息
		local list

		for k, v in pairs(info.condition) do
			local use, items = self:checkActive(pid, v, info.condition, params.godwar, params.equips)
			list = items

			local active = display.newSprite(COMMONPATH..(use and "tianfu_1.png" or "tianfu_2.png"))
			setAnchPos(active, x - active:getContentSize().width - 5, y)
			contentLayer:addChild(active)

			contentLayer:addChild(createLabel({str = getConfig("equip", v, "name"), x = x, y = y, size = 16, color = (use and ccc3(255,0,0) or nil)}))
			x = x + 120
			if count % 2 == 0 then
				x = 30
				y = y - 25
			end
			count = count + 1
		end

		--属性加成
		count = 0
		local key = {}
		for i = 1, 2 do
			for sk, sv in pairs(info.result[(i * 2)..""]) do
				if table.hasValue(key, sk) then

				else
					table.insert(key, sk)
					contentLayer:addChild(createLabel({str = "("..(i * 2).."件)"..Config_Property[sk..""].."+"..sv, x = x, y = y, size = 14,width = 200, color = (#list >= tonumber(i * 2) and ccc3(255,0,0) or nil) }))
					x = x + 120
				end
			end
		end

	end

	--如果是黄金装备，则显示装备之魂按钮
	if  isOther == false and getConfig("equip" , _data.cid , "isgold" ) == 1 then

		local roleId , roleInfo = DATA_ROLE_SKILL_EQUIP:getRoleId(_data["id"], "equip",false,true)
		local flag = false
		local soul_lv , goldCount

		local hero_star = getConfig( "general" , DATA_Bag:get("general" , roleId , "cid") , "star" )

		if roleId and hero_star==5 then
			goldCount , flag , soul_lv = this:getGoldEquipInfoWithRoleId( roleId , false , roleInfo)
		end
		if flag then
			local base_total = _data["figure"]+_data["gfigure"]
			local isCl = false
			if _data.clv and tonumber(_data.clv) > 0  then
				local clequipConfig = getConfig( "clequip" )[ _data.star ]
				local addCoefficient = tonumber(clequipConfig[ _data.type.. "" ])	--单次加成系数
				local cl_total = math.floor( _data.clv * addCoefficient )
				base_total = base_total + cl_total
				isCl = true
			end

			local pos = isCl and { 320 , 261 , 200} or { 250 , 261 , 90}
			local function getEquipgoldconf(lv, type)
				return equipgoldconf[lv..""][type]
			end
			--this.viewLayer:addChild(display.strokeLabel( "(套装之魂)" , pos[3] , 300, 18, ccc3(255, 0 , 0 )), 100)
			--根据不同类型的装备来和套装之魂的等级来判断  加成的百分比
			if _data["type"] == "defender" and soul_lv >= 1 then
				contentLayer:addChild(display.strokeLabel( "+"..math.floor(base_total*tonumber(getEquipgoldconf(1 , "def"))/100)  , 280 , contentLayerHeight-160+fixY, 16, ccc3(223, 229 , 41 )) , 1)
			elseif _data["type"] == "shoe" and soul_lv >= 2 then
				contentLayer:addChild(display.strokeLabel( "+".. math.floor(base_total*tonumber(getEquipgoldconf(2 , "agi"))/100)  , 280 , contentLayerHeight-160+fixY, 16, ccc3(223, 229 , 41 )) , 1)
			elseif _data["type"] == "weapon" and soul_lv >= 3 then
				contentLayer:addChild(display.strokeLabel( "+".. math.floor(base_total*tonumber(getEquipgoldconf(3 , "atk"))/100) , 280 , contentLayerHeight-160+fixY, 16, ccc3(223, 229 , 41 )) , 1)
			elseif _data["type"] == "jewelry" and soul_lv >= 4 then
				contentLayer:addChild(display.strokeLabel( "+".. math.floor(base_total*tonumber(getEquipgoldconf(4 , "hp"))/100)  , 280 ,contentLayerHeight-160+fixY, 16, ccc3(223, 229 , 41 )) , 1)
			end
		end

		local effetFrames1 = display.newFramesWithImage(IMG_PATH .. "image/scene/goldequip/".."soulEquipEffect.png", 12, 2)
		local action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
		setAnchPos(action,70, 410)
		this.viewLayer:addChild(action , 1)

		effetFrames1 = display.newFramesWithImage(IMG_PATH .. "image/scene/goldequip/".."small_effect.png", 7, 1)
		action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
		setAnchPos(action,355, 600)
		this.viewLayer:addChild(action , 11)

		local equipOfSoulBtn = KNBtn:new(IMG_PATH.."image/scene/goldequip/", { "soul_butoon.png","soul_button_pre.png" } , 360 , 605 , {
			scale = true,
			disable = _data["tujian"] or false, -- 从图鉴入口看装备详情,不能点击黄金装备升级按钮
			callback = function()
				pushScene("groupequip", { data = DATA_Bag:get("equip" , pid) , pid = pid, main = params.main})
			end
		}):getLayer()
		local soulImg = display.newSprite( IMG_PATH.."image/scene/goldequip/equip_soul.png" )
		setAnchPos( soulImg , 360 , 585 )
		this.viewLayer:addChild( soulImg , 10)
		this.viewLayer:addChild( equipOfSoulBtn ,10 )
	end

	if str then
		effect_label = display.strokeLabel(str , 15 , 200+fixY, 16 , ccc3( 255 , 0 , 0 ) , 2 , ccc3( 0x00 , 0x00 , 0x00 ) , {
			dimensions_width = 100,
			dimensions_height = 30,
		})
		local act = display.newSprite(COMMONPATH.."tianfu_1.png")
		setAnchPos(act,5,212+fixY)
		contentLayer:addChild(act)
	end

	if effect_label ~= nil then

		--属性sp
		local effect_bg = display.newSprite(PATH .. "effect_bg.png")

		local effect = display.newSprite(PATH .. "effect.png")

		setAnchPos(effect_bg , 0 , contentLayerHeight-140+fixY)
		setAnchPos(effect , 3 , 3)
		effect_bg:addChild(effect)

		contentLayer:addChild(effect_bg)

		--属性值
		contentLayer:addChild(effect_label)

		effect_bg:addChild(display.strokeLabel( replaceStr( "(" .. "淬炼" .. ")" ) , 120 , 4, 18, ccc3(10, 85 , 187 )))
		effect_bg:addChild(display.strokeLabel( replaceStr( "(" .. "附魔" .. ")" ) , 200 , 4, 18, ccc3(135, 11 , 200 )))
		effect_bg:addChild(display.strokeLabel( replaceStr( "(" .. "魂" .. ")" ) , 280 , 4, 18, ccc3(223, 229 , 41 )))

 		--淬炼值
		local cuiLianValue = 0
		if _data.clv and tonumber(_data.clv) > 0  then
			local value = _data.clv

			local clequipConfig = getConfig( "clequip" )[ _data.star ]
			local addCoefficient = tonumber(clequipConfig[ _data.type.. "" ])	--单次加成系数
			cuiLianValue = math.round( _data.clv * addCoefficient )
			contentLayer:addChild(display.strokeLabel( "+" .. cuiLianValue , 120 , contentLayerHeight-160+fixY, 18, ccc3(10, 85 , 187 )))
		end
		--附魔值
		if _data["tujian"] ~= "1"  then
			local fuMoStr,attrArray = washlayer:gatherInfo({ targetID = pid , external = true })
			if attrArray and #attrArray>0 then

				for i=1,#attrArray do

					local strs = string.split(attrArray[i],"+")
					local fuMoTxt = strs[1]
					local fuMoZhi = strs[2]

					local act = display.newSprite(COMMONPATH.."tianfu_1.png")
					setAnchPos(act,5,contentLayerHeight-178+fixY-(19*(i-1)))
					contentLayer:addChild(act)

					act:addChild( display.strokeLabel( fuMoTxt , 20 , 0, 16, ccc3(135, 11 , 200 )))
					act:addChild( display.strokeLabel( "+"..fuMoZhi , 195 , 0, 16, ccc3(135, 11 , 200 )))

				end
			end
		end


		--附加属性
		effect_bg = display.newSprite(PATH .. "effect_bg.png")
		effect = display.newSprite(PATH .. "append.png")
		setAnchPos(effect_bg , 0 , contentLayerHeight-247+fixY)
		setAnchPos(effect , 3 , 3)
		effect_bg:addChild(effect)
		contentLayer:addChild(effect_bg)


		local role = {"人杰","鬼雄","英豪"}
		--查看他人时 自己背包中不存在pid，就报错，所以，屏蔽加成
		local appendText = display.strokeLabel(getConfig("equip", cid, "apstar").."星【"..replaceStr(role[getConfig("equip", cid, "apstype")]).."】穿戴:附加"..proName.."+"..getConfig("equip", cid,"apinit"), 80, 198, 18, ccc3(0x2c, 0 , 0))
		setAnchPos(appendText,20,0)


		local activeImg = COMMONPATH.."tianfu_2.png"

		if (pid and checkActive("equip", {id = pid, cid = cid})) or _data.is_ap_add then
			activeImg = COMMONPATH.."tianfu_1.png"
			appendText:setColor(ccc3(255, 0, 0))
		end


		local appendImg = display.newSprite(activeImg)
		setAnchPos(appendImg, 5, contentLayerHeight-270+fixY)
		appendImg:addChild(appendText)
		contentLayer:addChild(appendImg)

		--如果是专属金装


		local pro_lv = _data.pro_lv or 0
		local isZhuanshu = tonumber(pro_lv) > 0

		local offsetY = 0
		if isZhuanshu then

			local isgold = getConfig("equip" , _data.cid , "isgold" ) == 1

			local jzsj_config = DATA_Info:get_type( isgold and "jzsj_config" or "wxsj_config").config
			local pro_gid = _data.pro_gid

			local roleId = DATA_ROLE_SKILL_EQUIP:getRoleId(pid , "equip" , false , true)
			local isActive = false
			local heroCid

			if roleId then
				heroCid = DATA_Bag:get("general" , roleId , "cid")
				if tonumber(heroCid) == tonumber(pro_gid) then
					isActive = true
				end
			end

			local atrConfig = { def = "防御" , atk = "攻击" , agi = "敏捷" , hp = "血量" }

			this.viewLayer:addChild( display.strokeLabel("专属:".. getConfig("general",_data.pro_gid,"name") ..";品质:专属"..pro_lv.."阶" , 51 , 441, 16 , isActive and ccc3( 255 , 0 , 0 ) or ccc3(0x2c, 0 , 0) ))

			offsetY = -40

			local act2 = display.newSprite(COMMONPATH.. (isActive and "tianfu_1.png" or "tianfu_2.png"))
			setAnchPos(act2,5,contentLayerHeight-250+fixY+offsetY)
			contentLayer:addChild(act2)
			local str = "专属【"..getConfig("general",pro_gid,"name").."】穿戴【专属"..pro_lv.."阶】"..atrConfig[_data.effect].."+" .. jzsj_config[pro_lv..""][_data.effect].."\n"

			local attrNum = 0
			local vipjzConfig = getConfig("vipjz")
			for k,v in pairs(vipjzConfig) do
				if (v["generalid"].."")== heroCid then --如果是vip赠送英雄

					attrNum= v[_data.effect]*(_data.pro_lv)

					if isgold==true then
						str=str.."VIP"..k.."特权英雄金装额外增加+"..attrNum
					end

				end
			end

			local zhuanshuText = display.strokeLabel( str, 80, 19, 17, isActive and ccc3(255, 0, 0) or ccc3(0x2c, 0 , 0))
			setAnchPos(zhuanshuText,20,20,0,1.0)
			act2:addChild( zhuanshuText )


		end


		--装备信息
		effect_bg = display.newSprite(PATH .. "effect_bg.png")
		equip_info_small = display.newSprite(PATH .. "equip_info_small.png")
		setAnchPos(equip_info_small,4,3)
		effect_bg:addChild(equip_info_small)
		setAnchPos(effect_bg,0,contentLayerHeight-305+fixY+offsetY)
		contentLayer:addChild(effect_bg)


		local descTxt = display.strokeLabel( config_data["desc"] , 5 , contentLayerHeight-375+fixY + offsetY , 17 , ccc3( 0x2c , 0x00 , 0x00 ) , 2 , ccc3( 0x00 , 0x00 , 0x00 ) , {
				dimensions_width = 320,
				dimensions_height = 0,
				align = 0,
			})
			setAnchPos(descTxt,5,contentLayerHeight-310+fixY + offsetY,0,1)
		contentLayer:addChild(descTxt)
		--equipDetailScrollView:addChild(descTxt)
	end




	if isOther == false and _data["tujian"] ~= "1" and pid ~= 0 and _data.clock == nil then
		local jinHuaBtn = KNBtn:new(COMMONPATH, { "long_btn.png"  , "long_btn_pre.png" } , 335  , 140 , {
								scale = true,
								priority = -131 ,
								front = COMMONPATH.."uppet.png" ,
								callback = function()
									if _data["star"] < 3 then
										KNMsg:getInstance():flashShow( "三星及以上装备才可以进化" )
									elseif tonumber(config_data["isgold"]) ~= 0 or _data["clock"] ~= nil then
										--专属金装阶位小于4才可以进化
										if _data.pro_lv and tonumber(_data.pro_lv) < table.nums(DATA_Info:get_type("jzsj_config").config) then

											switchScene("forge" , { flag = "zhuanshu" , bagId = _data["id"] })
										else
											KNMsg:getInstance():flashShow( "装备已达到最大阶位" )
										end
										return
									elseif (_data["star"] == 3 and tonumber(_data["lv"]) < 60) or (_data["star"] == 4 and tonumber(_data["lv"]) < 90) or ( tonumber(_data["group"]) ~= 0 and _data["star"] == 5 and tonumber(_data["lv"]) < 100 ) then

										KNMsg:getInstance():flashShow( "装备强化到顶级才能进化" )
										return
									else

										if ( _data["star"] == 3 and tonumber(_data["lv"]) == 60 ) or ( tonumber(_data["group"]) ~= 0 and _data["star"] == 4 and tonumber(_data["lv"]) == 90 ) then

											switchScene("forge" , { flag = "upstar" , bagId = _data["id"] })
										elseif ( _data["star"] == 4 and tonumber(_data["group"]) == 0 ) or ( tonumber(_data["group"]) ==0 and _data["star"] == 5 ) then
											--dump(g_choice)
											--dump(g_zhenfaData["nameset"])
											switchScene("forge" , { flag = "equipGroup" , bagId = _data["id"] })
										elseif ( tonumber(_data["group"]) ~= 0 and _data["star"] == 5 ) then

											switchScene("forge" , { flag = "soul" , bagId = _data["id"] })
										end
									end

								end
								})
		this.viewLayer:addChild( jinHuaBtn:getLayer() )
	end

	--附魔
--	if CHANNEL_GROUP == "tmsj" or CHANNEL_GROUP == "windows" or  CHANNEL_GROUP == "dhsh"  then
		if  tonumber( config_data["star"] ) >= 3 and not isOther and _data["tujian"] ~= "1" and pid ~= 0 and _data.clock == nil then
			local fuMoBtn
			    fuMoBtn = KNBtn:new(PATH, { "fuMoSp.png"  , "fuMoSp_select.png" } , 365, 470 , {
				scale = true,
				priority = -131 ,
				callback = function()
						HTTP:call("equip","init_xilian",{ eid = pid } , {
							success_callback = function( tempData )
								pushScene( "strengthen" , { type = "washlayer" , targetID = pid, main = params.main , isOther = isOther , washData = tempData})
							end
						})

				end
			}):getLayer()
			this.viewLayer:addChild(fuMoBtn)

			local fuMoTxt = display.newSprite(PATH .."fuMo_small.png")
			setAnchPos(fuMoTxt,25,-20)
			fuMoBtn:addChild(fuMoTxt)
			--如果该装备不是金装，将附魔按钮上移
			if getConfig("equip" , _data.cid , "isgold" ) ~= 1 then
				setAnchPos(fuMoBtn,365,615)
			end
		end
--	end

	--器灵
	-- if _data['star'] >=4 then   --四星以上装备
	-- 		local qiLingBtn = KNBtn:new(PATH, { "qiLingSp.png"  , "qiLingSp_select.png" } , 365, 340 , {
	-- 					scale = true,
	-- 					priority = -131 ,
	-- 					callback = function()
	-- 							if  DATA_Vip:get("viplv") >=3 then
	-- 								pushScene("equipSprite",{eid=pid})
	-- 							else
	-- 								KNMsg:getInstance():flashShow("装备器灵需要VIP等级3")
	-- 							end

	-- 					end
	-- 				}):getLayer()
	-- 		this.viewLayer:addChild(qiLingBtn)
	-- 		local qiLingTxt = display.newSprite(PATH .."qiLingLab.png")
	-- 		setAnchPos(qiLingTxt,18,-20)
	-- 		qiLingBtn:addChild(qiLingTxt)
	-- 		--如果该装备不是金装，将器灵按钮上移
	-- 		if getConfig("equip" , _data.cid , "isgold" ) ~= 1 then
	-- 				setAnchPos(qiLingBtn,365,340+145)
	-- 		end
	-- end
	-- 更换装备按钮
	if pid ~= 0 and (not params.godwar) then
		local useBtn = KNBtn:new(COMMONPATH, { "long_btn.png","long_btn_pre.png" } , 40 , 140 , {
			scale = true,
			front = COMMONPATH .. "change_equip.png",
			callback = function()

				if params.heroData then
					--从英雄页面传进 heroData
					local list
					local tempTypeAry = { weapon = 1 , defender = 2 , shoe = 3 , jewelry = 4 }	--装备四个位置
					
					if g_zhenfaHide==2 then

						list = SelectList:new("equip" , this.viewLayer,display.newSprite(COMMONPATH .. "title/equip_text.png") , {
							btn_opt = "equipment.png",
							target = true,
							filter = _data.type,
							equipType = _data.type,
							y = 85 ,
							showTitle = true ,
							zhenfaHide = g_zhenfaHide,
							optCallback = function()
								list:destroy()
								local targetId = list:getCurItem():getId()

								popScene()

								HTTP:call("zhenfa" , "equipDress", {
									eid = targetId ,
									zf_pos = g_choice,
									pos = tostring(g_type)
								} , {
								 	success_callback = function(data)
								 		switchScene("methodEquipment" , { 
								 			data = g_zhenfaData
								 		} , function()
							 				local equip_info = DATA_Bag:get("equip" , targetId)
											local gfigure = tonumber(equip_info["gfigure"]) == -1 and 0 or tonumber(equip_info["gfigure"])   --不是金装装备的  gfigure 等于 -1
											KNMsg:getInstance():flashShow( equip_info["name"] .. "装备成功，" .. Config_Property[equip_info["effect"]] .. "增加" .. (tonumber(equip_info["figure"]) + gfigure) )
										end)
								 	end
								})

							end
						}) 

					elseif g_zhenfaHide==1 then 

						list = SelectList:new("equip" , this.viewLayer,display.newSprite(COMMONPATH .. "title/equip_text.png") , {
							btn_opt = "equipment.png",
							target = true,
							filter = _data.type,
							equipType = _data.type,
							y = 85 ,
							showTitle = true ,
							zhenfaHide = g_zhenfaHide,
							optCallback = function()
								list:destroy()
								local targetId = list:getCurItem():getId()

									--请求换装备
								HTTP:call("equip" , "dress", {
									gid = params.heroData.id ,
									eid = targetId ,
									pos = "e" .. tempTypeAry[ _data.type ]
								} , {
									success_callback = function(_data)
										switchScene("hero" , { gid = params.heroData.id } , function()
											local equip_info = DATA_Bag:get("equip" , targetId)

											local gfigure = tonumber(equip_info["gfigure"]) == -1 and 0 or tonumber(equip_info["gfigure"])   --不是金装装备的  gfigure 等于 -1
											KNMsg:getInstance():flashShow( equip_info["name"] .. "装备成功，" .. Config_Property[equip_info["effect"]] .. "增加" .. (tonumber(equip_info["figure"]) + gfigure) )
										end)
									end
								})
							end
						}) 
					else
						list = SelectList:new("equip" , this.viewLayer,display.newSprite(COMMONPATH .. "title/equip_text.png") , {
							btn_opt = "equipment.png",
							target = true,
							filter = _data.type,
							equipType = _data.type,
							y = 85 ,
							showTitle = true ,
							optCallback = function()
								list:destroy()
								local targetId = list:getCurItem():getId()
								--请求换装备
								HTTP:call("equip" , "dress", {
									gid = params.heroData.id ,
									eid = targetId ,
									pos = "e" .. tempTypeAry[ _data.type ]
								} , {
									success_callback = function(_data)
										switchScene("hero" , { gid = params.heroData.id } , function()
											local equip_info = DATA_Bag:get("equip" , targetId)

											local gfigure = tonumber(equip_info["gfigure"]) == -1 and 0 or tonumber(equip_info["gfigure"])   --不是金装装备的  gfigure 等于 -1
											KNMsg:getInstance():flashShow( equip_info["name"] .. "装备成功，" .. Config_Property[equip_info["effect"]] .. "增加" .. (tonumber(equip_info["figure"]) + gfigure) )
										end)
									end
								})
							end
						})

					end 

					this.layer:addChild(list:getLayer())
				end
			end
		}):getLayer()
		this.viewLayer:addChild(useBtn)


		local btn_bg = {"long_btn.png", "long_btn_pre.png"}
		local btn_front
		if isOther then
			btn_front = ( DATA_OTHER:getLv() >= 50 and DATA_OTHER:isQuench( pid ) ) and "quenching.png" or "strengthen.png"
		else
			btn_front = ( DATA_User:get("lv") >= 50 and DATA_Bag:isQuench( pid ) ) and "quenching.png" or "strengthen.png"
		end
		if checkOpened("equip_strenthen") ~= true then
			btn_bg = {"btn_bg_grey.png"}
			btn_front = "strengthen_grey.png"
		end

		local strengthBtn = KNBtn:new(COMMONPATH, btn_bg , 190 , 140 , {
			scale = true,
			front = COMMONPATH .. btn_front,
			callback = function()
				-- 判断等级开放
				local check_result = checkOpened("equip_strenthen")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end

				if pid == 0 then
					KNMsg.getInstance():flashShow("该装备不能强化")
					return
				end
				local star = DATA_Bag:get( "equip" , pid , "star")
				local curLv = tonumber( DATA_Bag:get( "equip" , pid , "lv"))
				if DATA_User:get("lv") < 50 and curLv >= Config_max[ star ][ "levmax" ] then
					KNMsg:getInstance():flashShow( "装备已经达" .. replaceStr( "强化" ) .. "上限50级后将开启" .. replaceStr( "淬炼" ) )
				else
					HTTP:call("shop","cuilian_config",{} , {
							success_callback = function(tempData)
								pushScene("strengthen",{ type = "strength_equip" , targetID = pid, main = params.main , isOther = isOther ,vipConfig=tempData})
							end
						})
				end
			end
		})
		this.viewLayer:addChild(strengthBtn:getLayer())

		if params.heroData then
			useBtn:setVisible(true)
			setAnchPos(strengthBtn:getLayer() , 190 , 140)
		else
			useBtn:setVisible(false)
			setAnchPos(strengthBtn:getLayer() , 90 , 140)
		end

		if _data.clock ~= nil then
			strengthBtn:showBtn(false)
			strengthBtn:setEnable(false)
			setAnchPos(useBtn , 180 , 140)
		end

		if isOther then
			strengthBtn:showBtn( false )
			useBtn:setVisible( false )
		end


		-- 新手引导
		local guide_step = KNGuide:getStep()
		if guide_step == 204 or guide_step == 15102 then KNGuide:show( strengthBtn:getLayer() ) end
	end

	--神战
	if params.godwar and params.choseFunc then
		local useBtn = KNBtn:new(COMMONPATH, { "long_btn.png","long_btn_pre.png" } , 40 , 140 , {
			scale = true,
			front = COMMONPATH .. "change_equip.png",
			callback = params.choseFunc,
			priority = -200
			})
		this.viewLayer:addChild(useBtn:getLayer())
	end

	this.layer:addChild(this.viewLayer)
	return this
end



function EquipDetail:getLayer()
	return self.layer
end

function EquipDetail:checkActive(eid, cid, info, godwar, equips)

	local function checkActiveForGodwarLogic()
		local function isExistInEquips(cid)
			for k,v in pairs(equips) do
				if v.cid and v.cid == cid then
					return true
				end
			end
		end

		local list = {}
		for i,v in ipairs(info) do
			if isExistInEquips(v) then
				list[#list+1] = v
			end
		end
		return isExistInEquips(cid), list

	end

	if godwar and equips then
		return checkActiveForGodwarLogic()
	end


    local roleId = DATA_ROLE_SKILL_EQUIP:getRoleId(eid , "equip" , false , true)
	if not roleId then
		return false, {}
	end

	local active = false
	local list = {}

	local data = DATA_ROLE_SKILL_EQUIP:get(roleId , true)

	for k, v in pairs(data) do
		if string.find(k, "e") then
			if not active then
				if cid.."" == v.cid.."" then
					active = true
					table.insert(list, v.cid)
				else
					for sk, sv in pairs(info) do
						if sv.."" == v.cid.."" then
							table.insert(list, sv.."")
						end
					end
				end
			else
				for sk, sv in pairs(info) do
					if sv.."" == v.cid.."" then
						table.insert(list, sv.."")
					end
				end
			end
		end
	end
	return active, list
end

function EquipDetail:getRange()
	local x = self.layer:getPositionX()
	local y = self.layer:getPositionY()
	if self.params["parent"] then
		x = x + self.params["parent"]:getX() + self.params["parent"]:getOffsetX()
		y = y + self.params["parent"]:getY() + self.params["parent"]:getOffsetY()
	end
	return CCRectMake(x,y,self.layer:getContentSize().width,self.layer:getContentSize().height)
end

--根据英雄ID获得金装的信息
function EquipDetail:getGoldEquipInfoWithRoleId(roleId , isOther , roleInfo)
	local hero_equip_info
	if isOther then
		hero_equip_info = DATA_OTHER:getSkillEquipTable( roleId )
	elseif self.params and self.params.fromZhenfa then 
		hero_equip_info = roleInfo
	else
		hero_equip_info = DATA_ROLE_SKILL_EQUIP:getIdInfo(roleId)
	end
	local role = isOther and DATA_OTHER:getGeneral(roleId,  "role") or getConfig("general" , DATA_Bag:get("general",roleId)["cid"] , "role")

	local function equipInfo(type , value)
		return isOther and DATA_OTHER:getBag("equip" , hero_equip_info[type..""]["id"])[value..""] or DATA_Bag:get("equip", hero_equip_info[type..""]["id"])[value..""]
	end

	local goldCount = 1
	--判断金色装备是否穿在同类型的人物身上
	local function judgeWithEquipType(type)
		if hero_equip_info and hero_equip_info[type]~=nil then
			local cid = self.params and self.params.fromZhenfa and hero_equip_info[type]["equip_cid"] or hero_equip_info[type]["cid"]

			if getConfig("equip",cid , "isgold")==1 and getConfig("equip",cid , "apstype") == role then
				return true
			end
		else
			return false
		end
	end
	local function getGoldCount()
		if judgeWithEquipType("e1") then  goldCount=goldCount+1 end
		if judgeWithEquipType("e2") then  goldCount=goldCount+1 end
		if judgeWithEquipType("e3") then  goldCount=goldCount+1 end
		if judgeWithEquipType("e4") then  goldCount=goldCount+1 end
		return goldCount
	end
	-- -- e1 = "weapon" , e2 = "defender" , e3 = "shoe" , e4 = "jewelry"
	local function getInfo( param )
		if getGoldCount() < 5 then
			return goldCount , false
		end
		if param["e1"] == nil or param["e2"] == nil or param["e3"] == nil or param["e4"] == nil then return false end

		--记录 e1 e2 e3 e4 的装备之魂等级
		local lv_table = {
			e1 = goldEquipLayer:getLvWithEquipExp(equipInfo("e1", "gexp")),			--根据英雄的金装经验得到等级
			e2 = goldEquipLayer:getLvWithEquipExp(equipInfo("e2", "gexp")),
			e3 = goldEquipLayer:getLvWithEquipExp(equipInfo("e3", "gexp")),
			e4 = goldEquipLayer:getLvWithEquipExp(equipInfo("e4", "gexp")),
		}
		-- 获得套装之魂的等级， 即装备之魂的最低等级
		local soul_lv = math.min( lv_table["e1"] , lv_table["e2"] , lv_table["e3"] , lv_table["e4"] )
		return goldCount , true , soul_lv				-- goldCount 金装个数 , true 是否激活套装之魂 , soul_lv , 套装之魂等级
	end
	-- local flag , soul_lv = getInfo( hero_equip_info )
	return getInfo( hero_equip_info )
end


return EquipDetail
