local PATH = IMG_PATH .. "image/scene/detail/"
local EQUIP_PATH = IMG_PATH .. "image/equip/"
local COMMONPATH = IMG_PATH .. "image/common/"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local Config = requires(IMG_PATH , "GameLuaScript/Config/Equip")
local Config_Property = requires(IMG_PATH , "GameLuaScript/Config/Property")
local Config_max = requires(IMG_PATH , "GameLuaScript/Config/equipstrongmax")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local GroupConf = requires(IMG_PATH, "GameLuaScript/Config/equipgroup")
local GOLDEQUIPPATH = IMG_PATH .. "image/scene/goldequip/"
local data_equipattr = requires(IMG_PATH , "GameLuaScript/Config/data_equipattr")
local equipgoldconf = requires(IMG_PATH , "GameLuaScript/Config/equipgoldconf")
local goldEquipLayer = requires(IMG_PATH , "GameLuaScript/Scene/groupequip/goldEquipUpgrade")


--[[装备信息]]
local GroupSoulDetail = {
	layer,
	params = {},
	gradeNeedExpTable = {}
}


function GroupSoulDetail:new(params)
	local this = {}
	setmetatable(this,self)
	self.__index = self

	this.layer = display.newLayer()
	this.viewLayer = display.newLayer()
	this.params = params or {}

	local bg = display.newSprite(GOLDEQUIPPATH .. "bottom.png")

	local title = display.newSprite(GOLDEQUIPPATH .. "suit_soul.png")
	setAnchPos(bg , 240 , 110 , 0.5)
	setAnchPos(title , 345 , 673)
	this.viewLayer:addChild(bg)
	this.viewLayer:addChild(title)

	local effect_bg = display.newSprite(PATH .. "effect_bg.png")
	local effect = display.newSprite(GOLDEQUIPPATH .. "suit_detail.png")
	setAnchPos(effect_bg , 40 , 295)
	setAnchPos(effect , 45 , 298)
	this.viewLayer:addChild(effect_bg)
	this.viewLayer:addChild(effect)

	local e1_data = DATA_Bag:get("equip", params.groupdata["e1"]["id"])
	dump(e1_data)
	
	-- du
	local function equipInfo(type , value)
		return DATA_Bag:get("equip", params.groupdata[type..""]["id"])[value..""]
	end

	local function getEquipgoldconf(lv, type)
		return equipgoldconf[lv..""][type]
	end

	local lv_table = {
		e1 = goldEquipLayer:getLvWithEquipExp(equipInfo("e1", "gexp")),
		e2 = goldEquipLayer:getLvWithEquipExp(equipInfo("e2", "gexp")),
		e3 = goldEquipLayer:getLvWithEquipExp(equipInfo("e3", "gexp")),
		e4 = goldEquipLayer:getLvWithEquipExp(equipInfo("e4", "gexp")),
		}
	local soul_lv = math.min( lv_table["e1"] , lv_table["e2"] , lv_table["e3"] , lv_table["e4"] )
	print("soul_lv = " .. soul_lv )

	local e1_label = createLabel({str = equipInfo("e1", "name").."  Lv"..lv_table["e1"],width=200, size = 14, x = 90, y = 270, color = ccc3(78, 42,28)})
	local e2_label = createLabel({str = equipInfo("e2", "name").."  Lv"..lv_table["e2"],width=200, size = 14, x = 280, y = 270, color = ccc3(78, 42,28)})
	local e3_label = createLabel({str = equipInfo("e3", "name").."  Lv"..lv_table["e3"],width=200, size = 14, x = 90, y = 245, color = ccc3(78, 42,28)})
	local e4_label = createLabel({str = equipInfo("e4", "name").."  Lv"..lv_table["e4"],width=200, size = 14, x = 280, y = 245, color = ccc3(78, 42,28)})
	this.viewLayer:addChild(e1_label)
	this.viewLayer:addChild(e2_label)
	this.viewLayer:addChild(e3_label)
	this.viewLayer:addChild(e4_label)

	local lv_img = display.newSprite(GOLDEQUIPPATH .. "grade.png")
	setAnchPos(lv_img , 120, 400)
	local soul_lv_label = createLabel({str = "Lv"..soul_lv,width=200, size = 22, x = 185, y = 402, color = ccc3(255, 255,255)})
	this.viewLayer:addChild(soul_lv_label)
	this.viewLayer:addChild(lv_img)

	local active1 = display.newSprite(COMMONPATH..(soul_lv >=1 and "tianfu_1.png" or "tianfu_2.png"))
	setAnchPos(active1, 90, 180)
	this.viewLayer:addChild(active1)
	local active1_label = createLabel({str = "增加防御"..getEquipgoldconf(1 , "def").."% ".." Lv1",width=200, size = 14, x = 110, y = 180, color = soul_lv >=1 and ccc3(249,46,25) or ccc3(102,96,84)})
	this.viewLayer:addChild(active1_label)

	local active3 = display.newSprite(COMMONPATH..(soul_lv >=2 and "tianfu_1.png" or "tianfu_2.png"))
	setAnchPos(active3, 280 , 180)
	this.viewLayer:addChild(active3)
	local active3_label = createLabel({str = "增加敏捷"..getEquipgoldconf(2 , "agi").."% ".." Lv2",width=200, size = 14, x = 300, y = 180, color = soul_lv >=2 and ccc3(249,46,25) or ccc3(102,96,84)})
	this.viewLayer:addChild(active3_label)


	local active2 = display.newSprite(COMMONPATH..(soul_lv >=3 and "tianfu_1.png" or "tianfu_2.png"))
	setAnchPos(active2, 90, 155)
	this.viewLayer:addChild(active2)
	local active2_label = createLabel({str = "增加攻击"..getEquipgoldconf(3 , "atk").."% ".." Lv3",width=200, size = 14, x = 110, y = 155, color = soul_lv >=3 and ccc3(249,46,25) or ccc3(102,96,84)})
	this.viewLayer:addChild(active2_label)

	local active4 = display.newSprite(COMMONPATH..(soul_lv >=4 and "tianfu_1.png" or "tianfu_2.png"))
	setAnchPos(active4, 280, 155)
	this.viewLayer:addChild(active4)
	local active4_label = createLabel({str = "增加血量"..getEquipgoldconf(4 , "hp").."% ".." Lv4",width=200, size = 14, x = 300, y = 155, color = soul_lv >=4 and ccc3(249,46,25) or ccc3(102,96,84)})
	this.viewLayer:addChild(active4_label)

	local effect_bg = display.newSprite(PATH .. "effect_bg.png")
	local effect = display.newSprite(PATH .. "append.png")
	setAnchPos(effect_bg , 40 , 205)
	setAnchPos(effect , 45 , 208)
	this.viewLayer:addChild(effect_bg)
	this.viewLayer:addChild(effect)

	
	local effetFrames
	if e1_data["group"] == 15 then
		effetFrames = display.newFramesWithImage(GOLDEQUIPPATH.."suitSoulEffect1.png", 12, 2)
	elseif e1_data["group"] == 16 then
		effetFrames = display.newFramesWithImage(GOLDEQUIPPATH.."suitSoulEffect2.png", 12, 2)
	elseif e1_data["group"] == 17 then
		effetFrames = display.newFramesWithImage(GOLDEQUIPPATH.."suitSoulEffect3.png", 12, 2)
	else
		effetFrames = display.newFramesWithImage(GOLDEQUIPPATH.."suitSoulEffect1.png", 12, 2)
	end
	local action = display.playFrames(0, 0, effetFrames, 0.2, {
		forever = true,
	})
	setAnchPos(action,90, 460)
	this.viewLayer:addChild(action , 12)

	local descText = display.strokeLabel( GroupConf[e1_data["group"]..""]["desc"] , 350 , 360 , 18 , ccc3( 0x2c , 0x00 , 0x00 ) , 2 , ccc3( 0x00 , 0x00 , 0x00 ) , {
		dimensions_width = 105,
		dimensions_height = 300,
		align = 0,
	})
	this.viewLayer:addChild(descText)
	this.layer:addChild(this.viewLayer)
	return this
end

function GroupSoulDetail:getLayer()
	return self.layer
end

function GroupSoulDetail:getGradeNeedExpTable()
	local t = getSortList(equipgoldconf)
	local temp = 0
	for key, value in pairs(t) do
		temp = temp + tonumber(equipgoldconf[value]["exp"])
		self.gradeNeedExpTable[key] = temp
	end
	return self.gradeNeedExpTable
end

function GroupSoulDetail:getLv(exp)
	for key , value in pairs(self:getGradeNeedExpTable()) do
		if exp==0 then
			print("key = " .. key .. ", value = " .. value)
			return key
		end
		if exp~=0 and exp < value then 
			print("key = " .. key .. ", value = " .. value)
			return key-1
		end
	end
end

return GroupSoulDetail
