--[[

		龙脉界面

]]

local PATH = IMG_PATH .. "image/scene/dragon/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local KNBar = requires(IMG_PATH, "GameLuaScript/Common/KNBar")
-- local lmtext = requires(IMG_PATH, "GameLuaScript/Config/lmtext")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local msg_flag = false
local M = {
	baseLayer,
	layer,
	attrLayer,
	params,
	group,
	tabLayer,
	cur_type,
	cur_index,
	oldParams,
}

local typeConfig = { "pve" , "pvp" }

function M:new( params )
	dump(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	this.params = params or {}
	this.baseLayer = display.newLayer()
	this.layer = display.newLayer()

	local bg = display.newSprite( PATH .. "bg.jpg" )
	setAnchPos( bg , 0 , 0 )
	this.layer:addChild( bg )

	bg = display.newSprite( PATH .. "zero.png" )
	setAnchPos( bg , 15 , 673 )
	this.layer:addChild( bg )

	local helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png","help_press.png"}, 430 , 655 , {
							priority = -122,
							scale = true,
							callback = function()
								local mask

								local tempLayer =display.newLayer()
								--背景
								local bg = display.newSprite(IMG_PATH.."image/scene/chat/".."info_bg_big.png")
								setAnchPos(bg,240,150, 0.5)
								tempLayer:addChild(bg)
								--标题背景
							 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
							 	setAnchPos(title_bgSp,100,520)
							 	bg:addChild(title_bgSp)
								--标题文字
							 	local title_Sp = display.newSprite(COMMONPATH.."help_title.png")
							 	setAnchPos(title_Sp,80,520)
							 	bg:addChild(title_Sp)

							 	local str

						 		str =   "龙脉：\n" ..
						 				"1、阵位龙脉：八个阵位八条龙脉，每个阵位龙脉又分成PVE（与NPC战斗）龙脉 与 PVP（与玩家战斗）龙脉两种。\n"..
								 		"2、升级龙脉：八条龙脉可进行升级，升级消耗神币，每次升级后对应阵位可提升PVE属性\n"..
								 		"3、龙脉品阶：龙脉品阶可进行提升，提升消耗升龙丹（封神战中可获得），每次提升后对应阵位可提升PVP属性\n"..
								 		"属性加成：\n"..
								 		"属性加成对象：龙脉加成的属性加在对应的阵位上 ，受益对象为上阵的英雄，只要英雄上阵即可享受对应阵位的属性加成\n"..
								 		"PVE属性加成：PVE龙脉每次提升境界加的属性为绝对值，PVE龙脉所加的属性只在与NPC的战斗中才会生效。\n"..
								 		"PVP属性加成：PVP龙脉每次提升境界加的属性为百分比，PVP龙脉所加的属性只有与其他玩家进行战斗时才会生效。\n"..
								 		"新功能：\n"..
								 		"龙脉后续精彩功能，敬请期待\n"

							 	local helpTips = createLabel({str = str , x = 40, y = 55,size = 18, width = 370,color = ccc3(46 , 18 , 14)})
							 	-- bg:addChild(helpTips)

							 	local scroll = KNScrollView:new( 20 , 200 , 440 , 450 , 20 , false , 0 , { priority = -241} )
							 	scroll:addChild(helpTips)
								scroll:alignCenter()
								tempLayer:addChild(scroll:getLayer() )

							 	--关闭按钮
							    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 510 , {
										priority = -241,
										scale = true,
										callback = function()
											mask:remove()
										end})
								bg:addChild(close:getLayer())
							 	mask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -240})
							 	this.baseLayer:addChild(mask:getLayer(), 10)
							end
					})
	this.layer:addChild(helpBtn:getLayer() , 22)


	this.baseLayer:addChild( this.layer )

	local startX , startY = 15 , 600
	local tempGroup = KNRadioGroup:new()
	for i = 1, 8 do
		temp = KNBtn:new(PATH, { "tab_"..i..".png" , "tab_pre_"..i..".png" } , startX , startY , {
			front =  PATH  .. "zhen_"..i..".png" ,
			frontScale = { 1 , 5 , -25 },
			upSelect = true ,
			disableWhenChoose = true,
			id = i,
			callback = function()
				this.cur_index = i
				this.oldParams = this.params
				this:createAttrLayer()
			end
		} , tempGroup)

		this.layer:addChild(temp:getLayer())
		startY = startY - temp:getHeight()
	end
	tempGroup:chooseByIndex(1, true)
	
	return this.baseLayer
end

function M:createAttrLayer()
	if self.attrLayer then 
		self.attrLayer:removeFromParentAndCleanup( true )
	end

	self.attrLayer = display.newLayer()
	self.baseLayer:addChild( self.attrLayer )

	local zhenData = self.params.list.item[self.cur_index..""]

	local pvePos = { atk = {232 , 526} , def = {390 , 526} , hp = {232 , 493} , agi = {390 , 493} }
	local pvpPos = { atk = {232 , 202} , def = {390 , 202} , hp = {232 , 168} , agi = {390 , 168} }

	local GODCELLPATH = IMG_PATH .. "image/scene/godCell/"

	local shenglongdan_num = 0

	for key , value in pairs(DATA_Bag:getTable("prop" , { cid = zhenData.hoist.cid.."" })) do
		shenglongdan_num = shenglongdan_num + value["num"]
	end

	local param = self.params.list.item[self.cur_index..""]
	local oldParam = self.oldParams.list.item[self.cur_index..""]

	local pve_flag , pvp_flag = false , false
	if tonumber(param.lv) > tonumber(oldParam.lv) then pve_flag = true end
	if tonumber(param.id) > tonumber(oldParam.id) then pvp_flag = true end

	if pve_flag or pvp_flag then				--判断是否升级，升级则显示播放所加属性的动作 
		local pos_confg = pve_flag and pvePos or pvpPos
		local tempData = getSortList(pos_confg)

		for i = 1 , #tempData do
			local str = ""
			if pve_flag then  
				str = "+"..oldParam.attribute[tempData[i]].pve_up_num 
			else
				str = "+"..(tonumber(oldParam.attribute[tempData[i]].pvp_up_num)*100) .. "%"
			end

			local attrText = display.strokeLabel( str , pos_confg[tempData[i]][1] + 25 , pos_confg[tempData[i]][2] - 3 , 16, ccc3( 0x53 , 0xff , 0x15 ) , nil , nil , {
					dimensions_width = 70 ,
					dimensions_height = 25,
					align = 1
				})
				self.attrLayer:addChild( attrText , 20 )
				transition.moveTo( attrText , { delay = 0.2 , time = 1 , y = attrText.y + 30 , onComplete = function() 
					attrText:removeFromParentAndCleanup( true ) 
				end })
		end
		self.oldParams = self.params
	end

	self.attrLayer:addChild( display.newSprite( PATH .. "zhen_"..self.cur_index.."_text.png" , 		179 , 620 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "dragon_grade.png" ,						176 , 587 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "consum.png" , 								176 , 552 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "attr_bg.png" , 							134 , 475 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "dragon_advance.png" , 						176 , 295 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "consum.png"  , 							176 , 256 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "attr_bg.png" , 							134 , 154 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "shenglongdan.png" , 						217 , 717 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "coin.png", 								402 , 717 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "coin.png", 								231 , 552 , 0 , 0 ))
	self.attrLayer:addChild( display.newSprite( PATH .. "shenglongdan.png" , 						231 , 258 , 0 , 0 ))

	self.attrLayer:addChild( display.strokeLabel("以上属性与游戏NPC战斗有效（比如关卡，副本，忠义塔）" , 112 , 450 , 14 , ccc3(74 , 197 , 176 ) , 2 ) )
	self.attrLayer:addChild( display.strokeLabel("以上属性与玩家战斗有效（比如竞技场，皇权，帮战）" , 112 , 110 , 14 , ccc3(74 , 197 , 176 ) , 2 ) )
	
	self.attrLayer:addChild( display.strokeLabel("(注:加成为英雄的基础属性,组合享受加成)" , 125 , 675 , 16 , ccc3(255 , 0 , 0 ) , 2 ) )
	self.attrLayer:addChild( display.strokeLabel("(注:加成为英雄的基础属性,组合享受加成)" , 138 , 320 , 16 , ccc3(255 , 0 , 0 ) , 2 ) )

	self.attrLayer:addChild( display.strokeLabel(shenglongdan_num or "0" , 247 , 720 , 16 , ccc3(255 , 255 , 255 ) , 2 ) )			--拥有的升龙丹数量
	self.attrLayer:addChild( display.strokeLabel( G_coin or "0" , 428 , 720 , 16 , ccc3(255 , 255 , 255 ) , 2 ) )			--拥有的神币数量

	local offSetX , offSetY = -40 , -5 

	--PVE
	self.attrLayer:addChild( display.strokeLabel(zhenData["lv"] or "0" , 272 , 592 , 16 , ccc3(255 , 255 , 255 ) , 2 ) )				--龙脉等级
	self.attrLayer:addChild( display.strokeLabel(zhenData.consume or "0" , 260 , 557 , 16 , ccc3(255 , 255 , 255 ) , 2 ) )				--消耗神币数量

	for key , value in pairs(pvePos) do 
		self.attrLayer:addChild( display.newSprite( GODCELLPATH .. key.. ".png" , 					value[1] + offSetX , value[2] + offSetY , 0 , 0 , 0.22 ))
		self.attrLayer:addChild( display.strokeLabel(zhenData["attribute"][key]["pve_cur_num"] or "0" , value[1] , value[2] , 16 , ccc3(255 , 255 , 255 ) , 2 ) )
	end

	--PVP
	self.attrLayer:addChild( display.strokeLabel( (zhenData["id"].."阶") or "0" , 272 , 299 , 16 , ccc3(255 , 255 , 255 ) , 2 ) )				--龙脉品阶
	self.attrLayer:addChild( display.strokeLabel(zhenData["hoist"]["num"] or "0" , 260 , 261 , 16 , ccc3(255 , 255 , 255 ) , 2 ) )				--消耗龙脉丹数量

	for key , value in pairs(pvpPos) do 
		self.attrLayer:addChild( display.newSprite( GODCELLPATH .. key.. ".png" , 					value[1] + offSetX , value[2] + offSetY , 0 , 0 , 0.22 ))
		self.attrLayer:addChild( display.strokeLabel( (tonumber(zhenData["attribute"][key]["pvp_cur_num"])*100) .. "%" , value[1] , value[2] , 16 , ccc3(255 , 255 , 255 ) , 2 ) )
	end

	
	local upgradeBtn = KNBtn:new(COMMONPATH, {"btn_bg.png","btn_bg_pre.png" }, 329 , 567 , {
			front = PATH .. "upgrade_text.png",
			callback = function()
				if tonumber(G_coin) < tonumber(zhenData.consume) then 
					self:toGodWarTip("神币")
				else
					self:upGradeTips("pve")
				end
			end})
	self.attrLayer:addChild(upgradeBtn:getLayer())

	local upDragonBtn = KNBtn:new(COMMONPATH, {"btn_bg.png","btn_bg_pre.png" }, 329 , 250 , {
			front = PATH .. "updragon_text.png",
			callback = function()
				if tonumber(shenglongdan_num) < tonumber(zhenData["hoist"]["num"]) then 
					self:toGodWarTip("升龙丹")
				else
					self:upGradeTips("pvp")
				end
			end})
	self.attrLayer:addChild(upDragonBtn:getLayer())

end

function M:toGodWarTip(str)
	showTip({
		content = createLabel({str = "你当前拥有的"..str.."不足，无法进行提升，可前往神战中获得" , width = 360, size = 18}),
		right = {
			remove = true
		},
		left = {
			remove = true,
			callback = function()
				HTTP:call("fengshen", "getEntrance", {}, {
						success_callback = function(data)
							heartBeatCtl(true)
							SOCKET:getInstance("battle"):call("log" , "out" , "logout" , {} , {
								success_callback = function()
									SOCKET:delInstance("battle")
									delayFun(0.1, function()
										SOCKET:getInstance("swar",data.ip, data.port):send("user", "login", 1002, {}, {
											success_callback = function()
												heartBeatCtl(nil, "new")
												HTTP:call("fengshen", "getJFSummary", {}, {
													success_callback = function(data)
														switchScene("godwar", {inWar = true, data = data, first = (data.first == 1 and true or nil)})
														audio.playMusic( IMG_PATH .. "sound/godwar_field.mp3" , true )
													end
												})
											end})
									end)
								end})
						end
					})
			end
		}
	})
end


function M:upGradeTips(type)
	local contentLayer = display.newLayer()

	local zhenData = self.params.list.item[self.cur_index..""]
	-- contentLayer:addChild( display.strokeLabel( type == "pvp" and "下个品阶的加成属性：" or "下个等级的加成属性：" , 80 , 450 , 20 , ccc3(0x00 , 0x00 , 0x00 ) , 2 ) )

	contentLayer:addChild( display.newSprite( PATH .. type .. "_label.png" , 80 , 450 , 0 , 0 ) )

	local atk_text = display.strokeLabel( "攻：" .. (type == "pvp" and (tonumber(zhenData.attribute.atk.pvp_cur_num)*100 .. "% +") or (zhenData.attribute.atk.pve_cur_num.."+")), 80 , 400 , 20 , ccc3(0x00 , 0x00 , 0x00 )  , 2 )
	local def_text = display.strokeLabel( "防：" .. (type == "pvp" and (tonumber(zhenData.attribute.def.pvp_cur_num)*100 .. "% +") or (zhenData.attribute.def.pve_cur_num.."+")), 250 , 400 , 20 , ccc3(0x00 , 0x00 , 0x00 )  , 2 )
	local hp_text = display.strokeLabel( "血：" .. (type == "pvp" and (tonumber(zhenData.attribute.hp.pvp_cur_num)*100 .. "% +" ) or (zhenData.attribute.hp.pve_cur_num.."+")), 80 , 360 , 20 , ccc3(0x00 , 0x00 , 0x00 ) , 2 )
	local agi_text = display.strokeLabel( "敏：" .. (type == "pvp" and (tonumber(zhenData.attribute.agi.pvp_cur_num)*100 .. "% +") or (zhenData.attribute.agi.pve_cur_num .."+")), 250 , 360 , 20 , ccc3(0x00 , 0x00 , 0x00 ) , 2  )

	contentLayer:addChild( atk_text ) 
	contentLayer:addChild( def_text ) 
	contentLayer:addChild( hp_text ) 
	contentLayer:addChild( agi_text ) 

	contentLayer:addChild( display.strokeLabel( type == "pvp" and (tonumber(zhenData.attribute.atk.pvp_up_num)*100 .. "%") or zhenData.attribute.atk.pve_up_num , 80 +atk_text:getContentSize().width , 400 , 20 , SHENZHAN_GROUP == "tgxy" and ccc3(146,233,103) or  ccc3(66,155,30)  , 2 ) )
	contentLayer:addChild( display.strokeLabel( type == "pvp" and (tonumber(zhenData.attribute.def.pvp_up_num)*100 .. "%") or zhenData.attribute.def.pve_up_num , 250+def_text:getContentSize().width , 400 , 20 , SHENZHAN_GROUP == "tgxy" and ccc3(146,233,103) or  ccc3(66,155,30)  , 2 ))
	contentLayer:addChild( display.strokeLabel( type == "pvp" and (tonumber(zhenData.attribute.hp.pvp_up_num)*100 .. "%") or zhenData.attribute.hp.pve_up_num  , 80+hp_text:getContentSize().width , 360 , 20 , SHENZHAN_GROUP == "tgxy" and ccc3(146,233,103) or  ccc3(66,155,30)  , 2 )  )
	contentLayer:addChild( display.strokeLabel( type == "pvp" and (tonumber(zhenData.attribute.agi.pvp_up_num)*100 .. "%") or zhenData.attribute.agi.pve_up_num , 250+agi_text:getContentSize().width , 360 , 20 , SHENZHAN_GROUP == "tgxy" and ccc3(146,233,103) or  ccc3(66,155,30)  , 2 ) )

	showTip({
		content = contentLayer,
		right = {
			remove = true
		},
		left = {
			remove = true,
			callback = function()
				local action , str
				if type == "pvp" then 
					action , str  = "hoist" , "成功提升龙脉品阶"
				else
					action , str = "up_exp" , "升级成功"
				end

				HTTP:call("dragon",action,{ id = self.cur_index },{
						success_callback = function(data)
							KNMsg:getInstance():flashShow(str)
							self.params = data
							self:createAttrLayer()
						end
					})
			end
		}
	})
end

function M:haveMsg(param)
	if param and param.return_msg then
		KNMsg.getInstance():flashShow(param.return_msg or "")
		msg_flag = false
	end
end

return M
