--掠夺主界面

local M = {}

local PATH = IMG_PATH .. "image/scene/equipSprite/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
    --dump(DATA_Bag:get("qlprop"))
	--dump(DATA_Bag:get("inlay"))
	
	--args['eid'] 当前装备id
	local equipInfo = DATA_Bag:get("equip",args['eid'])
	--dump(equipInfo)
	-- 基础层
	this.baseLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "equipSpriteLayer" , 0 , { title_text = PATH.."equipSpriteTitle.png", tail_hide = true, closeCallback = function()
		popScene()
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	--小背景
	local inBg = display.newSprite( PATH .. "inBg.png")
	setAnchPos( inBg , 16 , 25 )						
	bg:addChild( inBg )
	
	--佩戴英雄lab
	local heroOwnerLab = display.newSprite(PATH.."heroOwner.png")
	setAnchPos(heroOwnerLab,15,inBg:getContentSize().height*0.95)
	inBg:addChild(heroOwnerLab)

	 
	local name_str = DATA_Bag:get("general",DATA_ROLE_SKILL_EQUIP:getRoleId(args['eid'], "equip"),"name")
	local heroOwnerName = display.strokeLabel( ( name_str == nil and "未装备" or name_str), heroOwnerLab:getContentSize().width+10 , 0 , 18 ,ccc3(230,219,116) )
	heroOwnerLab:addChild(heroOwnerName)

	local LvStr = DATA_Bag:get("general",DATA_ROLE_SKILL_EQUIP:getRoleId(args['eid'], "equip"),"lv")
	local heroOwnerLv= display.strokeLabel( ( LvStr == nil and "" or "Lv "..LvStr) , heroOwnerName:getContentSize().width+110 , 0 , 18 ,ccc3(230,219,116) )
	heroOwnerName:addChild(heroOwnerLv)

	--帮助
	local help_btn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png","help_press.png"}, 395 , 580 , {				--帮助按钮
				priority = -130,
				scale = true,
				callback = function()
							local mask
							
							local tempLayer =display.newLayer()
							--背景
							local bg = display.newSprite(COMMONPATH.."tip_bg.png")
							setAnchPos(bg,28,320)
							tempLayer:addChild(bg)
							--标题背景
						 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
						 	setAnchPos(title_bgSp,100,240)
						 	bg:addChild(title_bgSp)
							--标题文字
						 	local title_Sp = display.newSprite(COMMONPATH.."help_title.png")
						 	setAnchPos(title_Sp,65,240)
						 	bg:addChild(title_Sp)
						 	local helpTips = createLabel({str = "1.每日8点,系统会随机刷新2个报名时间段,上午、下午各一个\n"..
														 		"2.只可在系统每日刷新出的有效报名时间段内,报名务农\n"..
														 		"3.成功报名务农后,每次完成务农需要10分钟\n"..
														 		"4.成功完成务农后,可领取20黄金奖励\n"..
														 		"5.玩家需在12点(上午)/18点(下午)前领取工资,逾期无法领取\n" , x = 40, y = 30,size = 16, width = 370,color = ccc3(46 , 18 , 14)})
						 	bg:addChild(helpTips)
						 	--关闭按钮
						    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 210 , {
									priority = -201-2,
									scale = true,
									callback = function()
										mask:remove()
									end})
							bg:addChild(close:getLayer())
						 	mask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -201-1})
						 	this.baseLayer:addChild(mask:getLayer(), 10)
				end
	})
	inBg:addChild( help_btn:getLayer() )

	--器灵加成lab
	local spriteAddLab = display.newSprite(PATH.."spriteAdd.png")
	setAnchPos(spriteAddLab,20,inBg:getContentSize().height*0.22)
	inBg:addChild(spriteAddLab)
    

	if  getConfig("equip" , equipInfo['cid'] , "isgold" ) == 1 then 

		local effetFrames1 = display.newFramesWithImage(IMG_PATH .. "image/scene/goldequip/".."soulEquipEffect.png", 12, 2)
		local action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
		setAnchPos(action,inBg:getContentSize().width*0.22,inBg:getContentSize().width*0.57)
		inBg:addChild(action)

	end

	--装备图标
	local big_icon = display.newSprite(getImageByType(equipInfo['cid'] , "b"))
	setAnchPos(big_icon,inBg:getContentSize().width*0.33,inBg:getContentSize().width*0.7)
	inBg:addChild(big_icon)

	

	local equipName = display.strokeLabel(equipInfo['name'] , 15 , -50, 18 ,ccc3(230,219,116) )
	big_icon:addChild(equipName)

	local equipLv = display.strokeLabel("Lv"..equipInfo['lv'] ,equipName:getContentSize().width+ 20 , -50 , 18 ,ccc3(230,219,116) )
	equipName:addChild(equipLv)



	-- local attrNameConfig = {    hp = "生命" ,
	-- 						atk = "攻击" ,
	-- 						def = "防御" ,
	-- 						agi = "敏捷" ,
	-- 						crit = "暴击" ,
	-- 						dodge = "闪避" ,
	-- 						block = "格挡" ,
	-- 						hit = "命中" ,
	-- 						ctatk = "反击" ,
	-- 						kill = "必杀" , }

    
	-- local equipEffect = display.strokeLabel(attrNameConfig[equipInfo["effect"]]	 , 20 , -70 , 18 ,ccc3(255,0,0) )
	-- big_icon:addChild(equipEffect)

	-- local equipValue = display.strokeLabel("+"..equipInfo["figure"]	 , equipEffect:getContentSize().width+20 , -70 , 18 ,ccc3(255,0,0) )
	-- equipEffect:addChild(equipValue)


	for i=1,equipInfo['star'] do
		local starSp = display.newSprite(COMMONPATH.."star.png")
		--setAnchPos(starSp,inBg:getContentSize().width*0.9,inBg:getContentSize().height*0.77+(i-1)*25)
		starSp:setScale(0.9)
		setAnchPos(starSp,inBg:getContentSize().width*0.418+(i-1)*20,inBg:getContentSize().height*0.495)
		starSp:setAnchorPoint(ccp(0.5,0.5))
		inBg:addChild(starSp)
	end
	
	--左右器灵数据
	local leftQlData,rightQlData =this:findEquipQLData(DATA_Bag:get("qlprop"),DATA_Bag:get("inlay"),equipInfo)


	--器灵位置1
	local qiLingBtn1 = KNBtn:new(PATH, { "qiLingBtn.png"  , "qiLingBtn_select.png" } , 38, 444 , {
				scale = true,
				priority = -131 , 
				callback = function()
					if leftQlData==nil then
						switchScene("equipSpriteList",{ eid=args['eid'], posId=1}) --未装备时直接跳转到列表
					else
						HTTP:call("inlay","getQlConfig",{ } , {
							success_callback = function( receiveData )
								
								switchScene("equipSpriteUpdate",{eid= args['eid'],qiLingData = leftQlData,posId=1,updateQLConfigData=receiveData} )
							end
						})
						
					end
				end
			}):getLayer()
	this.baseLayer:addChild(qiLingBtn1)

	--器灵位置2
	local qiLingBtn2 = KNBtn:new(PATH, { "qiLingBtn.png"  , "qiLingBtn_select.png" } , 334, 444 , {
				scale = true,
				priority = -131 , 
				callback = function()
					if rightQlData ==nil then
						switchScene("equipSpriteList",{eid=args['eid'],posId=2})
					else
						HTTP:call("inlay","getQlConfig",{ } , {
							success_callback = function( receiveData )
								
								switchScene("equipSpriteUpdate",{eid=args['eid'] ,qiLingData=rightQlData,posId=2,updateQLConfigData=receiveData})
							end
						})
						
					end
				end
			})
	this.baseLayer:addChild(qiLingBtn2:getLayer())
	qiLingBtn2:setFlip(true)



	
	
	dump(leftQlData)
	dump(rightQlData)

	local colorConfig = {
				[2]="green",
				[3]="blue",
				[4]="purple",
				[5]="golden"
			}

	if leftQlData then
		local color = colorConfig[leftQlData['grade']]
		local effetFrames1 = display.newFramesWithImage(PATH ..leftQlData['cid'].."_"..color..".png", 12, 1)
		local action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
		setAnchPos(action,17,15)
		qiLingBtn1:addChild(action)

		local qilingName = display.strokeLabel(leftQlData['name'] , 10 , -20 , 18 ,ccc3(230,219,116) )
		qiLingBtn1:addChild(qilingName)

		local qiLingDesc = display.strokeLabel(leftQlData['effectdesc']..": +"..leftQlData['propety'] , 5 ,-50  , 15 ,ccc3(75,219,221) )
		qilingName:addChild(qiLingDesc)

		--额外描述
		local descExtra = display.strokeLabel(leftQlData['effectdesc']..":"..leftQlData['geniusdesc'],inBg:getContentSize().width*0.15,inBg:getContentSize().height*0.18, 16 ,ccc3(75,219,221))
		inBg:addChild(descExtra)

		--等级角标
		local sIconBgSp = display.newSprite(COMMONPATH.."egg_num_bg.png")
		setAnchPos(sIconBgSp,action:getContentSize().width*0.75,action:getContentSize().height*0.75)
		action:addChild(sIconBgSp)

		local sIconLv = display.strokeLabel(leftQlData['lv'],sIconBgSp:getContentSize().width*0.5,sIconBgSp:getContentSize().height*0.5,15,ccc3(255,255,255))
		sIconLv:setAnchorPoint(ccp(0.5,0.5))
		sIconBgSp:addChild(sIconLv)		
	else
		--指示点击的动画
		local effetFrames1 = display.newFramesWithImage(IMG_PATH.."image/scene/multiwar/cur.png", 11, 1)
		local action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
		setAnchPos(action,17,15)
		qiLingBtn1:addChild(action)

	end

	if rightQlData then
		local color = colorConfig[rightQlData['grade']]
		local effetFrames1 = display.newFramesWithImage(PATH ..rightQlData['cid'].."_"..color..".png", 12, 1)
		local action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
		setAnchPos(action,15,15)
		qiLingBtn2:getLayer():addChild(action)

		local qilingName = display.strokeLabel(rightQlData['name'] , 20 , -20 , 18 ,ccc3(230,219,116) )
		qiLingBtn2:getLayer():addChild(qilingName)

		local qiLingDesc = display.strokeLabel(rightQlData['effectdesc']..": +"..rightQlData['propety'] , 10 ,-50  , 15 ,ccc3(75,219,221) )
		qilingName:addChild(qiLingDesc)

		--额外描述
		local descExtra = display.strokeLabel(rightQlData['effectdesc']..":"..rightQlData['geniusdesc'],inBg:getContentSize().width*0.15,inBg:getContentSize().height*0.14, 16 ,ccc3(75,219,221))
		inBg:addChild(descExtra)

		--等级角标
		local sIconBgSp = display.newSprite(COMMONPATH.."egg_num_bg.png")
		setAnchPos(sIconBgSp,action:getContentSize().width*0.75,action:getContentSize().height*0.75)
		action:addChild(sIconBgSp)

		local sIconLv = display.strokeLabel(rightQlData['lv'],sIconBgSp:getContentSize().width*0.5,sIconBgSp:getContentSize().height*0.5,15,ccc3(255,255,255))
		sIconLv:setAnchorPoint(ccp(0.5,0.5))
		sIconBgSp:addChild(sIconLv)		
	else
		--指示点击的动画
		local effetFrames1 = display.newFramesWithImage(IMG_PATH.."image/scene/multiwar/cur.png", 11, 1)
		local action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
		setAnchPos(action,15,15)
		qiLingBtn2:getLayer():addChild(action)
		
	end


	--获取器灵
	local huoQuqiLingBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png"  , "btn_bg_red_pre.png" } , 165, 130 , {
				scale = true,
				front = PATH .. "earnSprite.png",
				priority = -131 , 
				callback = function()
						switchScene("fb" , { coming = "pet"})
					
				end
			}):getLayer()
	this.baseLayer:addChild(huoQuqiLingBtn)





	return this.baseLayer 
end

--qiLingBagTab 器灵背包
--equipQlTab 所有装备镶嵌器灵数据
function M:findEquipQLData(qiLingBagTab,equipQlTab,equipData)
	if qiLingBagTab == nil or  equipQlTab == nil then
		return nil,nil
	end
	equipQlTab=equipQlTab['qiling']
	local leftQlData,rightQlData 
		
		for k,v in pairs(equipQlTab) do
			if k== equipData['id'].."" then
				if v['1'] then
					--v['1']['id'] 左边器灵id
					
					for m,n in pairs(qiLingBagTab) do
						
						if n['id'] == v['1']['id'] then
							leftQlData=n
						end
					end
				end
				if v['2'] then					
					--v['2']['id'] 右边器灵id
					for m,n in pairs(qiLingBagTab) do
						if n['id'] == v['2']['id'] then
							rightQlData=n
						end
					end

				end
							
			end
		end
	return leftQlData,rightQlData
end



return M