--主界面

local M = {
	pageIndex=1,
	pageCount,
	listData,
	inLayData,
	scrollView,
	eid,
	posId
	
}

local PATH = IMG_PATH .. "image/scene/equipSpriteList/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	dump(args)

  	this.eid=args['eid'] 
  	this.posId=args['posId']

   -- dump(DATA_Bag:get("qlprop"))
	--dump(DATA_Bag:get("inlay"))
	
	
	this.inLayData= {}
	this.listData={}

	if DATA_Bag:get("inlay") ~=nil then
		this.inLayData=DATA_Bag:get("inlay")['qiling'] --背包装备镶嵌器灵数据
	end
	if DATA_Bag:get("qlprop") ~=nil then
		this.listData=DATA_Bag:get("qlprop") --器灵背包总数据
	end

	this.pageCount = math.ceil( #this.listData/10) --总页码

	--dump(this.pageCount)
	-- 基础层
	this.baseLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "equipSpriteListLayer" , 0 , { title_text = PATH.."equipSpriteListTitle.png", tail_hide = true, closeCallback = function()
		switchScene("equipSprite",{eid=this.eid})
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	
	this.scrollView=this:choosePageData(this.pageIndex)
    if this.scrollView  == nil then
    	print("return nil")
	    return this.baseLayer
    end
    this.baseLayer:addChild(this.scrollView:getLayer())

	local pageLab = display.strokeLabel( this.pageIndex .."/"..this.pageCount, 215, 115 , 22 , ccc3( 223 , 206 , 164) )
    this.baseLayer:addChild(pageLab)
    --增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 255 , 105 , {
				scale = true,
				priority = -130,
				callback = function()
					
					if this.pageIndex<this.pageCount then
						this.scrollView:getLayer():removeFromParentAndCleanup(true)
						this.pageIndex=this.pageIndex+1
						
						this.scrollView=this:choosePageData(this.pageIndex)
						this.baseLayer:addChild(this.scrollView:getLayer())
						pageLab:setString(this.pageIndex .."/"..this.pageCount)
					end
					
			end
			})
	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 175 , 105 ,{
				scale = true,
				priority = -130,
				callback = function()
					
					if this.pageIndex > 1 then
						this.scrollView:getLayer():removeFromParentAndCleanup(true)
						this.pageIndex=this.pageIndex-1
						
						this.scrollView=this:choosePageData(this.pageIndex)
						this.baseLayer:addChild(this.scrollView:getLayer())
						pageLab:setString(this.pageIndex .."/"..this.pageCount)
					end
				end
				})
	minusBtn:setFlip(true)
	addBtn:getLayer():setScale( 0.8 )
	minusBtn:getLayer():setScale( 0.8 )
	
	this.baseLayer:addChild(addBtn:getLayer())
	this.baseLayer:addChild(minusBtn:getLayer())



	return this.baseLayer 
end

function M:choosePageData(choosePageIndex)
	if choosePageIndex > self.pageCount then
		
		return nil
	end

	local tempScrollView = KNScrollView:new(15,150,450,595,5,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
	
    local colorConfig = {
				[2]="green",
				[3]="blue",
				[4]="purple",
				[5]="golden"
			}


    for i= 1+((choosePageIndex-1)*10), choosePageIndex*10 do
    	
    	if self.listData[i]  then

	    	 local  itemBg = display.newSprite(COMMONPATH .."item_bg.png")
	       	 setAnchPos(itemBg,0,0)
	       	 tempScrollView:addChild(itemBg)

	       	 local color = colorConfig[self.listData[i]['grade']]

	       	 local	touXiangFrame = display.newSprite(COMMONPATH .."role_frame.png") 
	       	 setAnchPos(touXiangFrame,25,24)
	       	 itemBg:addChild(touXiangFrame)

	         local	touXiangSp = display.newSprite(PATH .."icon/"..self.listData[i]['cid'].."_"..color..".png") 
	       	 setAnchPos(touXiangSp,25,26)
	       	 touXiangSp:setScale(0.9)
	       	 itemBg:addChild(touXiangSp)

	       	 --器灵名字
	       	 local qilingName = display.strokeLabel( self.listData[i]['name'] , 22 , 5 , 18 ,ccc3(76,44,30) )
	       	 itemBg:addChild(qilingName)

	   	     local lvNameLab =  display.strokeLabel( "等级:  Lv"..self.listData[i]['lv'], 120, 63 , 20 , ccc3( 76,44,30) )
	       	 itemBg:addChild(lvNameLab)
	       	
	       	 local attrLab =  display.strokeLabel("属性:  "..self.listData[i]['effectdesc'].." + "..self.listData[i]['propety'] , 120, 20 , 20 , ccc3(76,44,30) )
	       	 itemBg:addChild(attrLab)

	       	 local  isEquiped = false; --该器灵是否已经装备
	       	 --this.inLayData
	       	 for k,v in pairs(self.inLayData) do
	       	 	--local allEquipInfo = DATA_Bag:get("equip")
	       	 	--q当前item器灵id  self.listData[i]['id']
	       	 	
	       	 	if v['1'] then
	       	 	    if v['1']['id']== self.listData[i]['id'] then  --该item 激活
	       	 	    	local  actviedSp = display.newSprite(PATH.."actived.png")
	       	 	    	setAnchPos(actviedSp,itemBg:getContentSize().width*0.5,25)
	       	 	    	itemBg:addChild(actviedSp)

	       	 	    	isEquiped=true
	       	 	    end
	       	 	end
	       	 	
	       	 	if v['2'] then
	       	 		if v['2']['id']== self.listData[i]['id'] then  --该item 激活
	       	 			local  actviedSp = display.newSprite(PATH.."actived.png")
	       	 			setAnchPos(actviedSp,itemBg:getContentSize().width*0.5,25)
	       	 	    	itemBg:addChild(actviedSp)

	       	 	     	isEquiped=true
	       	 	    end
	       	 	end

	       	 end

	       	 local  font=""
	       	 if isEquiped then
	       	 	font="outLay.png"
	       	 else
	       	 	font="inLay.png"
	       	 end

	       	 --镶嵌 or 卸下
	         local tempBtn = KNBtn:new(COMMONPATH, { "btn_bg.png"  , "btn_bg_pre.png" } , itemBg:getContentSize().width*0.78, 30 , {
				scale = true,
				priority = -131 , 
				front= PATH..font,
				callback = function()
					if isEquiped then
					  --卸下
					   HTTP:call("equip","qilingOff",{  pid = self.listData[i]['id'] } , {
							success_callback = function( receiveData )
								--dump(receiveData)
								switchScene("equipSprite",{eid=self.eid})
							end
						})

					else
					  --镶嵌
					  HTTP:call("equip","qiling",{ eid = self.eid , pos= self.posId , pid = self.listData[i]['id'] } , {
							success_callback = function( receiveData )
								--dump(receiveData)
								switchScene("equipSprite",{eid=self.eid})
							end
						})

					end

				end
			}):getLayer()
			itemBg:addChild(tempBtn)

	       	 

       	end

    end

    return tempScrollView

end


return M