--主界面

local M = {
	listData,
	inLayData,
	qiLingData,--器灵数据
	eid,
	posId,
	updateQLConfigData,--器灵升级配置
	selectQiLingIDs--选择将要升级的器灵id数组
	
}

local PATH = IMG_PATH .. "image/scene/equipSpriteUpdate/"
local SPRITE_PATH = IMG_PATH .. "image/scene/equipSprite/"
local SPRITE_LIST_PATH = IMG_PATH .. "image/scene/equipSpriteList/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	--dump(args)
  	this.eid=args['eid'] --当前装备id
  	this.qiLingData=args['qiLingData']  --将要升级的器灵
  	this.posId=args['posId']  --0,1,2   未装备,左手,右手
  	this.updateQLConfigData=args['updateQLConfigData']

  	this.selectQiLingIDs={}

  	local equipInfo = DATA_Bag:get("equip",this.eid) or {}

   
	
	this.inLayData= {}
	this.listData={}

	if DATA_Bag:get("inlay") ~=nil then
		this.inLayData=DATA_Bag:get("inlay")['qiling'] --背包装备镶嵌器灵数据
	end
	if DATA_Bag:get("qlprop") ~=nil then
		--this.listData=DATA_Bag:get("qlprop") --器灵背包总数据		
		 this.listData= this:findAllQiLingExceptEquiped(this.inLayData,DATA_Bag:get("qlprop"))
	end


	-- 基础层
	this.baseLayer = display.newLayer()

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "equipSpriteUpdateLayer" , 0 , { title_text = PATH.."equipSpriteUpdateTitle.png", tail_hide = true, closeCallback = function()
		if this.posId~=0 then
			switchScene("equipSprite",{eid=this.eid})
		else
			switchScene("fb" , { coming = "pet"})
		end
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	--小背景
	local inBg = display.newSprite( PATH .. "inBg.png")
	setAnchPos( inBg , 16 , 25 )						
	bg:addChild( inBg )

	--佩戴英雄lab
	local heroOwnerLab = display.newSprite(PATH.."heroOwner.png")
	setAnchPos(heroOwnerLab,15,inBg:getContentSize().height*0.95)
	inBg:addChild(heroOwnerLab)

	local name_str = DATA_Bag:get("general",DATA_ROLE_SKILL_EQUIP:getRoleId(args['eid'], "equip"),"name")
	local heroOwnerName = display.strokeLabel( ( name_str == nil and "未装备" or name_str), heroOwnerLab:getContentSize().width+10 , 0 , 18 ,ccc3(230,219,116) )
	heroOwnerLab:addChild(heroOwnerName)

	local LvStr = DATA_Bag:get("general",DATA_ROLE_SKILL_EQUIP:getRoleId(args['eid'], "equip"),"lv")
	local heroOwnerLv= display.strokeLabel( ( LvStr == nil and "" or "Lv "..LvStr) , heroOwnerName:getContentSize().width+110 , 0 , 18 ,ccc3(230,219,116) )
	heroOwnerName:addChild(heroOwnerLv)

	--镶嵌装备
	local inLayLab = display.newSprite(PATH.."inLayEquip.png")
	setAnchPos(inLayLab,17, inBg:getContentSize().height*0.9)
	inBg:addChild(inLayLab)

	local equipName = display.strokeLabel( ( equipInfo['name'] == nil and "未镶嵌" or equipInfo['name']), inLayLab:getContentSize().width+10 , 0 , 18 ,ccc3(230,219,116) )
	inLayLab:addChild(equipName)

	local equipLv = display.strokeLabel((equipInfo['lv']==nil and "" or "Lv"..equipInfo['lv']) ,equipName:getContentSize().width+ 100 , 0 , 18 ,ccc3(230,219,116) )
	equipName:addChild(equipLv)

	local colorConfig = {
				[2]="green",
				[3]="blue",
				[4]="purple",
				[5]="golden"
			}

	local effetFrames1 = display.newFramesWithImage(SPRITE_PATH ..this.qiLingData['cid'].."_"..colorConfig[this.qiLingData['grade']]..".png", 12, 1)
	local action = display.playFrames(0, 0, effetFrames1, 0.15, {
			forever = true,
		})
	setAnchPos(action,188,470)
	inBg:addChild(action)

	--等级角标
	local sIconBgSp = display.newSprite(COMMONPATH.."egg_num_bg.png")
	setAnchPos(sIconBgSp,action:getContentSize().width*0.76,action:getContentSize().height*0.76)
	action:addChild(sIconBgSp)

	local sIconLv = display.strokeLabel(this.qiLingData['lv'],sIconBgSp:getContentSize().width*0.5,sIconBgSp:getContentSize().height*0.5,15,ccc3(255,255,255))
	sIconLv:setAnchorPoint(ccp(0.5,0.5))
	sIconBgSp:addChild(sIconLv)

	--器灵名称
	local qiLingName = display.strokeLabel(this.qiLingData['name'],3,-20,16,ccc3(230,219,116))
	action:addChild(qiLingName)
	--器灵属性
	local qiLingAttr = display.strokeLabel(this.qiLingData['effectdesc'].." + "..this.qiLingData['propety'],3,-40,13,ccc3(255,0,0))
	action:addChild(qiLingAttr)

	--器灵描述
	local qiLingAttrExtra = display.strokeLabel(this.qiLingData['geniusdesc'],25,85,13,ccc3(230,219,130))
	qiLingAttrExtra:setAnchorPoint(ccp(0.5,0.5))
	action:addChild(qiLingAttrExtra)

	--卸下
	if this.posId~=0 then
		local outLayBtn = KNBtn:new(COMMONPATH, { "btn_bg.png"  , "btn_bg_pre.png" } , inBg:getContentSize().width*0.78, inBg:getContentSize().height*0.9 , {
					scale = true,
					priority = -131 , 
					front = PATH.."outLayLab.png",
					callback = function()
						  HTTP:call("equip","qilingOff",{  pid = this.qiLingData['id'] } , {
								success_callback = function( receiveData )
									
									switchScene("equipSprite",{eid=this.eid})
								end
							})
					end
				}):getLayer()
		inBg:addChild(outLayBtn)
	end

	local boardLvLeft = display.strokeLabel(this.qiLingData['lv'].."级" ,inBg:getContentSize().width*0.1 , inBg:getContentSize().height*0.63 , 18 ,ccc3(230,219,116) )
	inBg:addChild(boardLvLeft)
	local boardLvRight = display.strokeLabel((this.qiLingData['lv']+1).."级" ,inBg:getContentSize().width*0.82 , inBg:getContentSize().height*0.63 , 18 ,ccc3(230,219,116) )
	inBg:addChild(boardLvRight)

	--等级进度条
	local fireBoard=display.newSprite(PATH.."progressBar.png")
	setAnchPos(fireBoard,inBg:getContentSize().width*0.18,inBg:getContentSize().height*0.62)
	inBg:addChild(fireBoard)

	local fireBoardIn = display.newSprite(PATH.."progressBarIn.png")
	setAnchPos(fireBoardIn,0,0)
	fireBoard:addChild(fireBoardIn)
	local percent = this.qiLingData['exp']/this.qiLingData['next_level_exp']
	
	fireBoardIn:setTextureRect(CCRectMake(0,0,fireBoard:getContentSize().width*percent,fireBoardIn:getContentSize().height))

	local jingYanZhi = display.strokeLabel( this.qiLingData['exp'].."/"..this.qiLingData['next_level_exp'],fireBoard:getContentSize().width*0.45 , 7 , 13 ,ccc3(0,0,0))
	fireBoard:addChild(jingYanZhi)

	local tempScrollView = KNScrollView:new(25,190,425,300,2,false,0,{	
	   		 priority = -130,
	    	 --debug=true,
	    })
   -- tempScrollView:alignCenter()
    this.baseLayer:addChild(tempScrollView:getLayer())

   	local lineTempLayer 
   	local colunmIndex = 1   --列,每4列换一行
  	local count = 0
  	--器灵背包数据
  	local qiLingBtnTab = {} --qilingbtns集合,用于全选
    for i=1,#this.listData do
     	
     	if  count%4==0 then
		  	lineTempLayer =  display.newLayer()
		   	lineTempLayer:setContentSize(CCSizeMake(445,90))
			setAnchPos(lineTempLayer)
		   	tempScrollView:addChild(lineTempLayer,lineTempLayer)
     	end

     	local  isEquiped = false
		--判断是否是已经装备的器灵
		 for k,v in pairs(this.inLayData) do	       	 	
	       	 	if v['1'] then
	       	 	    if v['1']['id']== this.listData[i]['id'] then  --该item 激活
	       	 	    	
	       	 	    	isEquiped=true
	       	 	    end
	       	 	end
	   
	       	 	if v['2'] then
	       	 		if v['2']['id']== this.listData[i]['id'] then  --该item 激活

	       	 	     	isEquiped=true
	       	 	    end
	       	 	end

	      end

     	local qingLingBtn  --器灵icon
		 qingLingBtn = KNBtn:new(SPRITE_LIST_PATH, { "icon/"..this.listData[i]['cid'].."_".. colorConfig[this.listData[i]['grade']]..".png","check_true.png" } , 15+(colunmIndex-1)*107, 13 , {
				scale = true,
				priority = -131 , 
				noHide = true,
				selectZOrder = 20,
				selectable = true,
				selectOffset={20,-15},
				id={this.listData[i]['grade'] , this.listData[i]['id']},
				parent=tempScrollView,
				callback = function()
						-- this.selectQiLingIDs=this.selectQiLingIDs..","..this.listData[i]['id']
						-- dump(this.selectQiLingIDs)
						if isEquiped then
							KNMsg.getInstance():flashShow("已经装备的器灵无法选择")
							qingLingBtn:select(true)
							
							return
						end

						if not qingLingBtn:isSelect() then --选中
							
							if not table.hasValue(this.selectQiLingIDs,this.listData[i]['id']) then
								this.selectQiLingIDs[this.listData[i]["id"]]= this.listData[i]['id']
								
							end
						else 	--取消
							
							if  table.hasValue(this.selectQiLingIDs,this.listData[i]['id']) then
								this.selectQiLingIDs[this.listData[i]["id"]]=nil
							end
						end
						
						--更新进度条
						local totalExp,leftLv,rightLv,leftExp,rightExp =  this:calculateTotalExp(this.selectQiLingIDs)
						percent =(this.qiLingData['exp']+totalExp)/rightExp					
						fireBoardIn:setTextureRect(CCRectMake(0,0,fireBoard:getContentSize().width*percent ,fireBoardIn:getContentSize().height))
						jingYanZhi:setString(this.qiLingData['exp']+totalExp.."/"..rightExp)
						boardLvLeft:setString(leftLv.."级")
						boardLvRight:setString(rightLv.."级")

				end
			})
		
		table.insert(qiLingBtnTab,qingLingBtn)
		lineTempLayer:addChild(qingLingBtn:getLayer()) 

		  	
	     if isEquiped then   --已经装备的器灵加个锁
	     	local lock = display.newSprite(COMMONPATH.."lock_small.png")
	     	setAnchPos(lock,qingLingBtn:getLayer():getContentSize().width*0.8,0)
	     	qingLingBtn:getLayer():addChild(lock)
	     end
		
		
        --等级角标
		local sIconBgSp = display.newSprite(COMMONPATH.."egg_num_bg.png")
		setAnchPos(sIconBgSp,qingLingBtn:getLayer():getContentSize().width*0.75,qingLingBtn:getLayer():getContentSize().height*0.75)
		qingLingBtn:getLayer():addChild(sIconBgSp)

		local sIconLv = display.strokeLabel(this.listData[i]['lv'],sIconBgSp:getContentSize().width*0.5,sIconBgSp:getContentSize().height*0.5,15,ccc3(255,255,255))
		sIconLv:setAnchorPoint(ccp(0.5,0.5))
		sIconBgSp:addChild(sIconLv)

	    local qiLingName = display.strokeLabel(this.listData[i]['name'],5,-13,15,ccc3(230,219,116))
		qingLingBtn:getLayer():addChild(qiLingName)

	    if (count+1)%4 ==0 then
			colunmIndex=0
		end

		colunmIndex=colunmIndex+1
		count=count+1

     end
 
    

	--全选绿色
	-- local selectAllBtn = KNBtn:new(COMMONPATH, { "long_btn.png"  , "long_btn_pre.png" } , inBg:getContentSize().width*0.07, inBg:getContentSize().height*0.038 , {
	-- 			scale = true,
	-- 			priority = -131 , 
	-- 			front = PATH.."quanXuan.png",
	-- 			callback = function()
					
	-- 				for k,v in pairs(qiLingBtnTab) do

	-- 					if v:getId()[1] == 2 then	--2代表绿色
							
	-- 						if v:isSelect() then
	-- 							v:select(false)
	-- 							this.selectQiLingIDs[v:getId()[2]]=nil
	-- 						else
	-- 							v:select(true) --选中该绿色器灵
	-- 							this.selectQiLingIDs[v:getId()[2]]= v:getId()[2]
	-- 						end
	-- 					end
	-- 				end 

	-- 				--更新进度条
	-- 				local totalExp,leftLv,rightLv,leftExp,rightExp =  this:calculateTotalExp(this.selectQiLingIDs)
	-- 				percent =(this.qiLingData['exp']+totalExp)/rightExp					
	-- 				fireBoardIn:setTextureRect(CCRectMake(0,0,fireBoard:getContentSize().width*percent ,fireBoardIn:getContentSize().height))
	-- 				jingYanZhi:setString(this.qiLingData['exp']+totalExp.."/"..rightExp)
	-- 				boardLvLeft:setString(leftLv.."级")
	-- 				boardLvRight:setString(rightLv.."级")

	-- 			end
	-- 		}):getLayer()
	-- inBg:addChild(selectAllBtn)

	--器灵更换
	-- if this.posId~=0 then
	-- 		
	-- 		local changeBtn = KNBtn:new(COMMONPATH, { "long_btn.png"  , "long_btn_pre.png" } , inBg:getContentSize().width*0.38, inBg:getContentSize().height*0.038 , {
	-- 					scale = true,
	-- 					priority = -131 , 
	-- 					front = PATH.."chuangSprite.png",
	-- 					callback = function()
	-- 						switchScene("equipSpriteList",{ eid=this.eid, posId=this.posId}) 
	-- 					end
	-- 				}):getLayer()
	-- 		inBg:addChild(changeBtn)
	-- end

	--转换经验/吞噬
	local updateBtn = KNBtn:new(COMMONPATH, { "long_btn.png"  , "long_btn_pre.png" } , inBg:getContentSize().width*0.38, inBg:getContentSize().height*0.038 , {
				scale = true,
				priority = -131 , 
				front = COMMONPATH.."tun_chi.png",
				callback = function()
						dump(this.selectQiLingIDs)
						
						local costQiLingIdStrs = "" --消耗的器灵id字串

						for k,v in pairs(this.selectQiLingIDs) do
							if costQiLingIdStrs=="" then
								costQiLingIdStrs=costQiLingIdStrs..v
							else
								costQiLingIdStrs=costQiLingIdStrs..","..v
							end
							
						end
						
						HTTP:call("inlay","qilingUp",{ pid=args['qiLingData']['id'] ,cost_pid=costQiLingIdStrs } , {
							success_callback = function( callBackData )
								--dump(callBackData)
								local  newQilingData 
								for k,v in pairs(callBackData['_G_bag_qlprop']) do
									if v['id'] == this.qiLingData['id'] then
										newQilingData=v
									end
								end

								switchScene("equipSpriteUpdate",{eid= this.eid,qiLingData = newQilingData,posId=this.posId,updateQLConfigData=this.updateQLConfigData} )
							end
						})

				end 
			}):getLayer()
	inBg:addChild(updateBtn)



	return this.baseLayer 
end

--计算所有选中的器灵传递总经验值
function M:calculateTotalExp(selectQiLingIdTabs)
	local colorConfig = {
				[2]="green",
				[3]="blue",
				[4]="purple",
				[5]="golden"
			}
	local totalExp = 0   --总经验
	local leftLv,rightLv,leftExp,rightExp = 0      --总经验所在区间
	
	--计算传递总经验值和
	for k,v in pairs(self.listData) do
		for m,n in pairs(selectQiLingIdTabs) do
			if v['id']==n then
				--颜色colorConfig[v['grade']],等级v['lv']
				local color=colorConfig[v['grade']]
				local lv = v['lv']
				
				totalExp = totalExp+self.updateQLConfigData['config'][color][lv]['useexp']
			end
		end

	end

	--计算总经验值所在的区间
	local qilingColor=colorConfig[self.qiLingData['grade']]  --颜色
	for i=1,#self.updateQLConfigData['config'][qilingColor] do
		if self.updateQLConfigData['config'][qilingColor][i]['lvexp'] > totalExp+self.qiLingData['exp'] then
			leftLv=i-1
		    rightLv=i
			leftExp=self.updateQLConfigData['config'][qilingColor][i-1]['lvexp']
			rightExp=self.updateQLConfigData['config'][qilingColor][i]['lvexp']
	     break
		end
	end
	
	print(totalExp,leftLv,rightLv,leftExp,rightExp)

	return totalExp,leftLv,rightLv,leftExp,rightExp
end


--查找除已装备外的所有器灵
function M:findAllQiLingExceptEquiped(inLayData,allQiLingTab)
	
	local newListQilingTab = {}
	local x = 1
	for i = 1 ,#allQiLingTab do
			local isEquiped = false
			 for m,n in pairs(inLayData) do
			 		    	 	
		       	 	if n['1']~=nil and allQiLingTab[i]~=nil then
		       	 	    if n['1']['id']== allQiLingTab[i]['id'] then  --该item 激活
		       	 	    	
		       	 	    	isEquiped=true
		       	 	    end
		       	 	end
		   
		       	 	if n['2']~=nil and allQiLingTab[i]~=nil  then
		       	 		if n['2']['id']== allQiLingTab[i]['id'] then  --该item 激活
		       	 			
		       	 	     	isEquiped=true
		       	 	    end
		       	 	end

		     end
		     --未装备的加进去
		     if not isEquiped then
		     	
		     	newListQilingTab[x]=allQiLingTab[i]
		     	x=x+1
		     end

	end	
	return newListQilingTab
end


return M