local MAIN, HERO, PET, SKILL, EQUIP, LIST = 0, 1, 2, 3, 4, 5
local LEFT, RIGHT, TOP, BOTTOM = 1, 2, 3, 4
local PATH = IMG_PATH.."image/scene/fb/"
local SPRITE_PATH = IMG_PATH .. "image/scene/equipSprite/"
local SPRITE_LIST_PATH = IMG_PATH .. "image/scene/equipSpriteList/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local Progress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")--require "GameLuaScript/Scene/common/infolayer"
local Property = requires(IMG_PATH, "GameLuaScript/Config/Property")
local KNCardpopup = requires(IMG_PATH,"GameLuaScript/Common/KNCardpopup")
local Lot= requires(IMG_PATH, "GameLuaScript/Scene/fb/lot")
local SelectList = requires(IMG_PATH,"GameLuaScript/Scene/common/selectlist")
local HomeCard = requires(IMG_PATH,"GameLuaScript/Scene/fb/herocard")
--[[
	副本模块，在首页点击副本按钮进入此模块
]]
local FBLayer = {
	layer,
	mainLayer,
	contentLayer,
	state,
	wait,
	onePt,
	info,
	mask,
	needHeroList
	
}

function FBLayer:new(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.layer = display.newLayer()
	this.state = params.state 

	local bg = display.newSprite(SCENECOMMON.."bg.png")
	setAnchPos(bg)
	this.layer:addChild(bg)
	
	local title = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(title, 0, 425, 0, 0.5)
	this.layer:addChild(title)
	
	if params.state == "hero" then
		HTTP:call("penglai", "get", {}, {
			success_callback = function(data)
				this:createHeroFb(data) 
			end
		})
	elseif  params.state == "pet" then	
		this:createPetFb()
	elseif params.state == "skill" then
		this:createSkillFb()
	elseif params.state == "equip" then
		if params.dig then
			this:createDig(params.map)
		else
			this:createEquipFb(params.map)
		end
	elseif params.state == "rob" then
		this:createRobFb(params.robData, params.star)
	else	
		this:createMain(params.coming)
	end	

	return this
end

function FBLayer:createMain(name)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	self.mainLayer = display.newLayer()
	
	local des_scroll 
	des_scroll =  KNScrollView:new(0, 90, 480, 650, 10, false, 0, {
		page_callback = function()
			group:chooseByIndex(des_scroll:getCurIndex())
			if checkOpened("fb_"..group:getId()) == true then
				coming:setFront(COMMONPATH.."coming.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red.png", COMMONPATH.."btn_bg_red_pre.png"})
			else
				coming:setFront(COMMONPATH.."coming_grey.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red2.png",COMMONPATH.."btn_bg_red2.png"})
			end
		end
	})

	local dragon_open = false
	if getConfig("wenzimiaoshu").fb["dragon"] then
		dragon_open = true
	end
	
	local level = {
		"hero",
		"equip",
		"pet",
--		"skill",
		"multi",
		"xinmo",
		dragon_open and "dragon" or nil
	}
	
	for k, v in pairs(level) do
		local back, info, btn, descLayer, giftBtn
		
		info = KNBtn:new(COMMONPATH, {"info.png", "info_pre.png"}, 380, 70, {
			callback = function()
				btn:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.1, 1, 0), CCCallFunc:create(function()
					btn:setBg(1, COMMONPATH.."item_info_bg.png")
					btn:hideOther(true)
					
					info:showBtn(false)
					info:setEnable(false)
					
					giftBtn:showBtn(false)
					giftBtn:setEnable(false)
					
					back = true
					
					descLayer = display.newLayer()
					descLayer:setContentSize(btn:getLayer():getContentSize())
					
					local text = display.newSprite(SCENECOMMON.."res_icon/info_text.png")
					setAnchPos(text,30, 50)
					descLayer:addChild(text)

					local gift = createLabel({str = getConfig("wenzimiaoshu","fb", v, "descshow"), width = 300, color = ccc3(255,255,255)})
					setAnchPos(gift, 125, 80)
					descLayer:addChild(gift)
					
					gift = createLabel({width = 300, str = getConfig("wenzimiaoshu","fb", v, "desc"), size = 16, color = ccc3(255,255,255)})
					setAnchPos(gift, 125, 70,0, 1)
					descLayer:addChild(gift)
					
					btn:getLayer():addChild(descLayer)
				end), CCScaleTo:create(0.1, 1, 1)))
			end
		})
		local open = checkOpened("fb_"..v)		
		btn = KNBtn:new(PATH, {v..(open == true and "_new.png" or "_new_grey.png")}, 0, 0, {
			anchMid = true,
			other = ((open ~= true) and  {SCENECOMMON.."res_icon/lock.png", 0, -20} or nil), 
			callback = function()
				if back then
					btn:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.1, 1, 0), CCCallFunc:create(function()
						btn:setBg(1, PATH..v..(open == true and "_new.png" or "_new_grey.png"))
						btn:hideOther(false)
						info:showBtn(true)
						info:setEnable(true)
						
											
						giftBtn:showBtn(true)
						giftBtn:setEnable(true)
						back = false
						btn:getLayer():removeChild(descLayer, true)
					end), CCScaleTo:create(0.1, 1, 1)))
					return 
				end
					-- 判断等级开放
				local check_result = checkOpened("fb_"..v)
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return false
				end
				
				if v == "hero" then
					HTTP:call("penglai","get",{},{success_callback = function(data)
						
						self:createHeroFb(data)
	--						self:createRoleFb("hero")
					end})
				elseif v == "pet"  then
				
					HTTP:call("inspetnew","get",{},{success_callback = function()
						DATA_Instance:clearMessage()
						self:createPetFb()
					end})
				elseif v  == "equip" then
					 if DATA_Instance:get("equip", DATA_Instance:get("equip", "max", "map_id")) then
					 	self:createEquipFb(DATA_Instance:get("equip", "max", "map_id"))
					 else
						HTTP:call("insequip", "get",{},{success_callback = function()
							
							self:createEquipFb(DATA_Instance:get("equip", "max", "map_id"))
						end})
					end
				elseif v  == "skill" then
					if DATA_Instance:get("skill") then
						self:createSkillFb()
					else
						HTTP:call("insskill","get",{},{
							success_callback = function()
							self:createSkillFb()
						end})
					end	
				elseif v  == "multi" then
						switchScene("multiFb")
				elseif v=="xinmo" then
						HTTP:call("xinmo","initData",{},{
							success_callback = function(data)
								switchScene("xinmo",data)
						end})
						
				elseif v == "dragon" then
					if DATA_Dragon:get()  then
						if DATA_User:get("lv") < DATA_Dragon:get("lv") then
							KNMsg:getInstance():flashShow("等级达到"..DATA_Dragon:get("lv").."才能开启龙脉功能")
							return
						elseif tonumber(DATA_Dragon:get("state")) == 0 then
								showTip({
									priority = -202 , 
									offsetY = -20 , 
									title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
									title_text = IMG_PATH.."image/scene/dragon/openDragon_title.png",
									content = createLabel({str = "开启阵位龙脉功能需要消耗"..DATA_Dragon:get("money").."神币，是否需要开启？", size = 20, width = 360}),
									left = {
										path = COMMONPATH,
										normal = "btn_bg_red.png",
										pre = "btn_bg_red_pre.png",
										front = COMMONPATH.."ok.png",
										remove = true,
										callback = function()
												HTTP:call("dragon","open",{ },{
													success_callback = function(data)
														pushScene("dragon" , data )
													end
												})
										end
									},
									right = {
											 path = COMMONPATH, 
											 normal = "btn_bg_red.png", 
											 pre = "btn_bg_red_pre.png",
											 front = COMMONPATH.."cancel.png",
											 remove = true
					    		}})
						elseif tonumber(DATA_Dragon:get("state")) == 1 then 
								HTTP:call("dragon","get",{ },{
									success_callback = function(data)
										pushScene("dragon" , data )
									end
								})
								
						end	
					
					else
						KNMsg:getInstance():flashShow("龙脉暂未开放")
					end
				end
			end
		
		})
		
		 giftBtn = KNBtn:new(SCENECOMMON.."res_icon/", {"bg.png"}, 10,10, {
			front = SCENECOMMON.."res_icon/"..getConfig("wenzimiaoshu","fb", v, "show")..".png",
			scale = true,
			callback = function()
				KNMsg.getInstance():flashShow("可获得物品:"..getConfig("wenzimiaoshu","fb", v, "descshow"))
			end
		})
		btn:getLayer():addChild(giftBtn:getLayer())
		
		btn:getLayer():addChild(info:getLayer())
		
		des_scroll:addChild(btn:getLayer(), btn)
	end
	des_scroll:alignCenter(true)
	
	self.mainLayer:addChild(des_scroll:getLayer())
	
	
	local num 
	for k, v in pairs(level) do
		if v == name then
			num = k
			break
		end
	end 
	

	des_scroll:setIndex(num or 1,true)
	self.state = MAIN
	
	-- 新手引导
	local guide_step = KNGuide:getStep()
	if guide_step == 801 or guide_step == 3001 or guide_step == 15201 or guide_step == 3101 or guide_step == 3201 or guide_step == 3301 then
		local btn = des_scroll:getItems(num or 1)
		local btn_range = btn:getRange()

		KNGuide:show( btn:getLayer() , {
			x = btn_range:getMinX(),
			y = btn_range:getMinY(),
			remove = true,
			callback = function()
				KNGuide:addStep()
			end
		})
	end
	
	
	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH.."title.png",function()
			switchScene("home")
	end)
end

function FBLayer:createMain1(name)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	self.mainLayer = display.newLayer()
		
--	local title = display.newSprite(PATH.."title.png")
--	setAnchPos(title, 245, 730, 0.5)
--	self.mainLayer:addChild(title)
--	
	local bg = display.newSprite(SCENECOMMON.."level_bg.png")
	setAnchPos(bg, 240, 590, 0.5)
	self.mainLayer:addChild(bg)
	
	bg = display.newSprite(COMMONPATH.."desc_bg.png") 
	setAnchPos(bg, 30, 110)
	self.mainLayer:addChild(bg)
	
	local group = KNRadioGroup:new()
	
	local coming = KNBtn:new(COMMONPATH,{"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 120, {
		scale = true,
		front = COMMONPATH.."coming.png",
		callback = function()
			-- 判断等级开放
			local check_result = checkOpened("fb_"..group:getId())
			if check_result ~= true then
				KNMsg:getInstance():flashShow(check_result)
				return false
			end
			
			if group:getId() == "hero" then
				HTTP:call("penglai","get",{},{success_callback = function(data)
					
					self:createHeroFb(data)
--						self:createRoleFb("hero")
				end})
			elseif group:getId() == "pet" then
			
				HTTP:call("inspetnew","get",{},{success_callback = function()
					DATA_Instance:clearMessage()
					self:createPetFb()
				end})
			elseif group:getId() == "equip" then
				if DATA_Instance:get("equip", DATA_Instance:get("equip", "max", "map_id")) then
					self:createEquipFb(DATA_Instance:get("equip", "max", "map_id"))
				else
					HTTP:call("insequip", "get",{},{success_callback = function()
						self:createEquipFb(DATA_Instance:get("equip", "max", "map_id"))
					end})
				end
			elseif group:getId() == "skill" then
				if DATA_Instance:get("skill") then
					self:createSkillFb()
				else
					HTTP:call("insskill","get",{},{
						success_callback = function()
						self:createSkillFb()
					end})
				end	
			elseif group:getId() == "multi" then
					switchScene("multiFb")
			elseif group:getId() == "rob" then
				HTTP:call("rob", "get", {}, {
					success_callback = function(data)
						self:createRobFb(data)
					end
				})
			end
		end
	})
	self.mainLayer:addChild(coming:getLayer())
	
	local scroll = KNScrollView:new(35, 595, 410, 130, 2, true, 0, {
		priority = -190,
	})
	local des_scroll 
	des_scroll =  KNScrollView:new(35, 90, 405, 490, 0, true, 1, {
		page_callback = function()
			group:chooseByIndex(des_scroll:getCurIndex())
			if checkOpened("fb_"..group:getId()) == true then
				coming:setFront(COMMONPATH.."coming.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red.png", COMMONPATH.."btn_bg_red_pre.png"})
			else
				coming:setFront(COMMONPATH.."coming_grey.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red2.png",COMMONPATH.."btn_bg_red2.png"})
			end
		end
	})
	
	local level = {
		"hero",
		"equip",
		"pet",
--		"skill",
		"multi",
		getConfig("wenzimiaoshu").fb["dragon"] and "dragon" or nil
	}
	
	for i = 1, #level do
		local btn = KNBtn:new(PATH,{level[i].."_icon.png", "select.png"}, 0, 0, {
			id = level[i],
			priority = -188,
			scale = true,
			parent = scroll,
			noHide = true,
			upSelect = true,
			selectZOrder = 1,
--			other = {PATH..level[i].."_name.png", 17, 0},
			callback = function()
--				self:createContent(level[i])
				des_scroll:setIndex(i)	
				
				if checkOpened("fb_"..level[i]) == true then
					coming:setFront(COMMONPATH.."coming.png")
					coming:setBg(1, {COMMONPATH.."btn_bg_red.png", COMMONPATH.."btn_bg_red_pre.png"})
				else
					coming:setFront(COMMONPATH.."coming_grey.png")
					coming:setBg(1, {COMMONPATH.."btn_bg_red2.png",COMMONPATH.."btn_bg_red2.png"})
				end
				
			end
		},group)
		scroll:addChild(btn:getLayer(), btn)
		
		local desc = self:createContent(level[i])
		des_scroll:addChild(desc)
	end
	scroll:alignCenter()
	des_scroll:alignCenter()
	self.mainLayer:addChild(scroll:getLayer())
	self.mainLayer:addChild(des_scroll:getLayer())
		
	local num 
	for k, v in pairs(level) do
		if v == name then
			num = k
			break
		end
	end 
	
	group:chooseByIndex(num or 1)
	scroll:setIndex(num or 1 , true)
	des_scroll:setIndex(num or 1,true)
	self.state = MAIN

	-- 新手引导
	local guide_step = KNGuide:getStep()
	if guide_step == 801 or guide_step == 3001 or guide_step == 3101 or guide_step == 3201 or guide_step == 3301 then
		local btn = scroll:getItems(num or 1)
		local btn_range = btn:getRange()

		KNGuide:show( btn:getLayer() , {
			x = btn_range:getMinX(),
			y = btn_range:getMinY(),
			remove = true,
			callback = function()
				KNGuide:show( coming:getLayer() )
			end
		})
	end
	

	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH.."title.png",function()
			switchScene("home")
	end)
end

function FBLayer:createContent(kind)
--	if self.contentLayer then
--		self.mainLayer:removeChild(self.contentLayer, true)
--	end	
--	
--	self.contentLayer = display.newLayer()
	
	local layer = display.newLayer()
	
	
	local bg = display.newSprite(PATH..kind.."_desc.png")
	setAnchPos(bg, 8, 160)
	layer:addChild(bg)
	
	if kind ~= "multi" then
		layer:addChild( display.newSprite( PATH .. kind .. "_text_tip.png" , display.cx - 33 , 280 + 165 , 0.5 , 0 ))
	end
	
	local text = display.newSprite(PATH..kind.."_text.png")
	setAnchPos(text, 395, 390, 1)
	layer:addChild(text)
	
	local desc = {
		["hero"] =  "英雄殿汇聚英雄好汉，高星级英雄等你来拿, 每天逛逛英雄殿，就可以招募到心仪的英雄",
		["pet"]  =  "狩猎场内有各种珍稀猛兽！ 奇珍异兽！心动不如赶快行动！“主人 快来捕捉我吧”",
		["skill"] = "呼吸吐纳心自在，气沉丹田手心开！ 习武切记仁者无敌！谁练太极风生水起！ 想学好招式！就来如意阁！~",
		["equip"] = "俗话说人靠衣装马靠鞍。 这人在江湖飘，哪能不装备好。 挑战藏宝楼！爆牛B装备助你江湖逍遥！",
		["rob"] = "秋高气爽出门晃晃，英雄武器口袋装装。 每天抢一抢，轻松获得英雄将魂武器碎片！",
		
	 }

   	
	text = display.strokeLabel(getConfig("wenzimiaoshu", "fb", kind, "desc"), 0, 60, 20,nil,nil,nil,{
		dimensions_width = 400,
		dimensions_height = 100,
	} )
	layer:addChild(text)
	

	layer:setContentSize(CCSizeMake(405, 450))
	return layer
end


function FBLayer:createSkillFb(index)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	self.mainLayer = display.newLayer()

	-- 开始按钮，必须放这，因为新手引导要用 - -
	local clickStart
	
	local bg = display.newSprite(PATH.."bg.jpg")
	setAnchPos(bg)
	self.mainLayer:addChild(bg)
	
	self.state = SKILL
	
	--压注选择
	local valueGroup = KNRadioGroup:new()
	for i = 1, 3 do
		local btn = KNBtn:new(PATH, {"v"..i.."_btn.png", "btn_select.png"}, 320 - (i - 1) * 150, 610, {
			id = i,
			noHide = true,
			selectZOrder = 10,
			callback = function()
			end
		}, valueGroup)
		self.mainLayer:addChild(btn:getLayer())

		-- 新手引导
		if i == 2 and KNGuide:getStep() == 3203 then
			KNGuide:show( btn:getLayer() , {
				callback = function()
					KNGuide:show( clickStart:getLayer() , {
						remove = true
					})
				end
			})
		end
	end
	
	local pos = {
		{260,515,RIGHT},
		{380,515,BOTTOM},
		{380,405,BOTTOM},
		{380,295,BOTTOM},
		{380,190,LEFT},
		{260,190,LEFT},
		{140,190,LEFT},
		{20,190,TOP},
		{20,295,TOP},
		{20,405,TOP},
		{20,515,RIGHT},
		{120,505,RIGHT},
	}
	
	local group = KNRadioGroup:new()
	for i = 1, #pos do
		local link = display.newSprite(PATH.."link.png")
		local ox, oy = 0, 0
		
		if pos[i][3] == LEFT then
			ox = -80
			oy = 30
		elseif pos[i][3] == RIGHT then
			oy = 30
			ox = 40
		elseif pos[i][3] == BOTTOM then
			ox = 30
			link:setRotation(90)
		else
			ox = 30
			oy = 120	
			link:setRotation(90)
		end
		
		if i == 12 then
			ox = 60
			oy = 40
		end
		setAnchPos(link,pos[i][1] + ox,pos[i][2] + oy)
		self.mainLayer:addChild(link)
		
		local front,other,text
		local bg = "item_bg.png"
		local data = DATA_Instance:get("skill","list")
		if i == 1 then
			front = PATH.."start.png"
		else
			if data[i..""]["type"] == "silver" or data[i..""]["type"] == "prestige" then
				front = PATH..data[i..""]["type"]..".png"
			elseif data[i..""]["type"] == "thief" then
				front = IMG_PATH.."image/hero/s_general1334.png"
			else
				local pre
				if data[i..""]["type"] ~= "skill" then
					pre = "/s_"	
				else
					pre = "/"
				end
				front = IMG_PATH.."image/"..data[i..""]["type"]..pre..data[i..""]["effect"]..".png"
				
				local x, y
				if i == 12 then
					x = 10
					y = 3				
				else
					x = -3
					y = -5
				end
				other = {{COMMONPATH.."star_border/border_"..getConfig("skill", data[i..""]["effect"], "star")..".png", x, y}}
				
				if getCidType(data[i..""]["effect"]) == "petskill" then
					other[2] = {IMG_PATH.."image/scene/bag/kind_bg.png", 10, 10}
					text = {"兽", 14, ccc3(255, 255, 255), ccp(-20, 22), nil, 17}
				end
			end
		end
		
		if i == 12 then
			bg = "final_item_bg.png"
		end
		local btn = KNBtn:new(PATH, {bg,"cur.png"},pos[i][1],pos[i][2],{
			front = front,
			other = other,
			text = text,
			selectZOrder = 20,
			upSelect = true,
			noHide = true,
			callback = function()
				if i > 1 then
					local k = DATA_Instance:get("skill", "list", i.."")
					if k["type"] == "thief" then
						KNMsg.getInstance():flashShow("小偷：将被偷取"..k["effect"].."银两")
					elseif k["type"] == "silver" then
						KNMsg.getInstance():flashShow("银两:将获得银两"..k["effect"])
					else
						local str = getCidType(k["effect"])
						if str == "petskill" then
							str = "幻兽技能"
						else
							str = "英雄技能"
						end
						str = getConfig(getCidType(k["effect"]), k["effect"],"star").."星"..str
						KNMsg.getInstance():flashShow(str.."【"..getConfig(getCidType(k["effect"]), k["effect"],"name").."】")
					end
					return false
				end
			end
		},group)
		self.mainLayer:addChild(btn:getLayer())
		
		if i > 1 then
			btn = getImageNum(i, COMMONPATH.."small_num.png")
			setAnchPos(btn, pos[i][1] + (i == 12 and 110 or 80) ,pos[i][2] + 10, 1)
			self.mainLayer:addChild(btn)
		end
	end
	
	group:chooseByIndex(index or 1)
	
		--这里是将骰子的点数拆成2数和
	local m, n = math.random(1,6), math.random(1,6)
	if index then
		local max 
		if index > 6 then
			max = 6
		else
			max = index - 1			
		end
		
		n = index - max
		n = math.random(n,max)
		m = index - n
	end
	
	if index and self.onePt then
		m = self.onePt
		n = index - self.onePt
	end
	
	local dice1 = display.newSprite(PATH..m..".png")
	setAnchPos(dice1, 190, 400)
	self.mainLayer:addChild(dice1,1)
	
	local dice2 = display.newSprite(PATH..n..".png")
	setAnchPos(dice2, 230, 360)
	self.mainLayer:addChild(dice2,1)									
										
	
	local stop,pt, add, count, award
	local function playAni(x, y,reverse)
		local frames = display.newFramesWithImage(PATH .. "ani.png" , 5 )
		local sprite 
		sprite = display.playFrames(x, y , frames, 0.1,
						{
							reverse = reverse,
							onComplete = function()
								if stop then
									self.mainLayer:removeChild(sprite,true)
									print(sprite,"停了")
									
									if not add then
										add = true
										
										--这里是将骰子的点数拆成2数和
										local max 
										if pt > 6 then
											max = 6
										else
											max = pt - 1			
										end
										
										self.onePt = pt - max  --其中一个骰子的点数
										self.onePt = math.random(self.onePt, max)
										
										dice1 = display.newSprite(PATH..self.onePt..".png")
										setAnchPos(dice1, 190, 400)
										self.mainLayer:addChild(dice1,1)
										
										dice2 = display.newSprite(PATH..(pt - self.onePt)..".png")
										setAnchPos(dice2, 230, 360)
										self.mainLayer:addChild(dice2,1)									
--										stop = false
									end
								else
									self.mainLayer:removeChild(sprite,true)
									self.mainLayer:addChild(playAni(x ,y,reverse))
								end
							end
						}
					)
--		sprite:runAction(CCJumpTo:create(2,ccp(x,y),50,3))
		return sprite
	end
	
	if DATA_Instance:get("skill", "times") > 0 then
		
		clickStart =  KNBtn:new(PATH, {"click_star.png", "click_star_press.png"}, 180, 345,{
			callback = function()
				audio.playSound(IMG_PATH .. "sound/abaca.mp3")
				local mask
				if not self.wait then
					if DATA_Instance:get("skill", "times") > 0 then
						if isBagFull() then
							return false
						end
						self.wait = true
						self.onePt = nil
						clickStart:showBtn(false)
						mask = KNMask:new({opacity = 0})
						self.mainLayer:addChild(mask:getLayer())
						self.mainLayer:removeChild(dice1, true)
						self.mainLayer:removeChild(dice2, true)
						
						self.mainLayer:addChild(playAni(230, 455))
						self.mainLayer:addChild(playAni(270, 410,true))
						
						local index = 1
						local schedule = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
								
							index = index + 1
							if index > 12 then
								index = 1
							end	
						
							group:chooseByIndex(index)
							
						end,0.01,false)
						stop = false
						add = false
						HTTP:call("insskill","roll",{yazhu = valueGroup:getId()},{
							no_loading = true,	
							error_callback = function()
								CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(schedule)
								self.wait = false
								KNMsg.getInstance():flashShow("请求失败，请检查网络或重试")
								self:createSkillFb()
							end,
							success_callback = function(data)
								pt = data.point
								count = 0
								self.wait = false
								award = data["award"]
								CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(schedule)
								schedule =  CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
									xpcall(function()
										if count == 2 and pt == index then
											mask:remove()
											-- self.mainLayer:removeChild(mask, true)
											local resultImg
											if pt < 9 then
												resultImg = display.newSprite(PATH.."v1_text.png")
											elseif pt < 12 then
												resultImg = display.newSprite(PATH.."v2_text.png")
											else
												resultImg = display.newSprite(PATH.."v3_text.png")
											end
											setAnchPos(resultImg, 240, 425, 0.5, 0.5)
											self.mainLayer:addChild(resultImg,100)
--											
											CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(schedule)
											resultImg:setScale(0.1)	
											resultImg:runAction(getSequenceAction(CCEaseElasticOut:create(CCScaleTo:create(0.8,1.5)), CCCallFunc:create(function()
												if DATA_Instance:get("skill","list",index.."","is_battle") == 1 then
													SOCKET:getInstance("battle"):call("insskill" , "execute" , "execute",{})
												else
													self:createSkillFb(pt)
													for k, v in pairs(award) do
														if k == "thief" then
															KNMsg.getInstance():flashShow("运气不好，被小偷偷了钱包,损失银币:"..v)
														elseif k == "silver" then
															KNMsg.getInstance():flashShow("获得银两:"..v)
														elseif k == "drop" then
															KNMsg.getInstance():flashShow("获得技能书:【"..getConfig("skill", v[1].."", "name").."】")
														else
															KNMsg.getInstance():flashShow("获得"..k.."/"..v)
														end
													end
												end
											end)))
										else
											if pt == index then
												count = count + 1 
											end
											index = index + 1
											if index > 12 then
												index = 1
											end
												
											local stopN = pt - 3
											if stopN <= 0 then
												stopN = 12 + stopN
											end
											
											if count == 1 and index == stopN then
												stop = true
											end
											
											group:chooseByIndex(index)
										end
									end,function()
										--异常时停止定时器
										self.wait = false
										stop = false
										
										CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(schedule)
									end)
								end,0.01,false)
							end})
					else
						KNMsg.getInstance():flashShow("摇点次数已不足，请点增加按钮购买摇点次数")
					end
				else
					print("等待中哦")
				end
			end
		})
		self.mainLayer:addChild(clickStart:getLayer(), 10)
	end
	
	local times = display.newSprite(PATH.."time_text.png")
	setAnchPos(times, 60, 140)
	self.mainLayer:addChild(times)
	
	times = display.strokeLabel(DATA_Instance:get("skill","times").."/"..DATA_Instance:get("skill","max_times"), 120, 145, 20, ccc3(255,255,255))
	setAnchPos(times, 135, 145, 0.5)
	self.mainLayer:addChild(times)
	
	
	local addTimes = KNBtn:new(COMMONPATH,{"add.png", "add_press.png"}, 160, 135, {
		callback = function()
			HTTP:call("insskill","buypoint",{},{
				success_callback = function()
					self:createSkillFb()
				end
			})
		end
	})
	self.mainLayer:addChild(addTimes:getLayer())
	
	local textBtn = KNBtn:new(PATH, {"luck_text.png"}, 160, 280, {
		callback = function()
			KNMsg.getInstance():flashShow("幸运值满30点时100%开出豹子，当色子点数大于6时幸运值+3，其余则幸运值+1")
		end
	})
--	local text = display.newSprite(PATH.."luck_text.png")
--	setAnchPos(text, 160,280)
	self.mainLayer:addChild(textBtn:getLayer())
	
	local bar = Progress:new(PATH,{"luck_bg.png","luck_fro.png"}, 240, 280,{
		showText = true,
		cur = DATA_Instance:get("skill","luck"),
		max = DATA_Instance:get("skill","max_luck")
	})
	self.mainLayer:addChild(bar:getLayer())
	
	
	local refresh = KNBtn:new(COMMONPATH,{"btn_bg.png", "btn_bg_pre.png"}, 330, 140, {
		scale = true,
		front = COMMONPATH.."refresh.png",
		callback = function()
			HTTP:call("insskill","refresh",{},{
				success_callback = function()
					self:createSkillFb()
					
				end
			})
		end
	})
	self.mainLayer:addChild(refresh:getLayer())
	
	--刷新金币
	text = display.newSprite(COMMONPATH.."gold.png")
	setAnchPos(text, 340, 110)
	self.mainLayer:addChild(text)
	
	text = display.strokeLabel(DATA_Instance:get("skill", "refresh_price"), 375, 110, 20, ccc3(0xff,0xe5,0xa6))	
	self.mainLayer:addChild(text)
	
	--增加次数金币
	text = display.newSprite(COMMONPATH.."gold.png")
	setAnchPos(text, 90, 110)
	self.mainLayer:addChild(text)
	
		text = display.strokeLabel(DATA_Instance:get("skill", "point_price"), 125, 110, 20, ccc3(0xff,0xe5,0xa6))	
	self.mainLayer:addChild(text)
	
	
	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH.."skill_title.png",function()
			self:createMain("skill")
		end)
end

--藏宝楼的生成函数
function FBLayer:createEquipFb(map)
	map = tonumber(map)
	--塔的类型， 1是人塔， 2是地塔，3是天
	local kind = math.floor((map - 1) / 6) + 1
	print(kind)
	local tower = {
		[1] = {"low", {0,2}},
		[2] = {"mid", {1,3}},
		[3] = {"high",{2,0}},
	}
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	
	self.state = EQUIP
	
	
	self.mainLayer = display.newLayer()
	
	local bg = display.newSprite(PATH.."equip_"..tower[kind][1].."_bg.jpg")
	setAnchPos(bg, 0, 425, 0, 0.5)
	self.mainLayer:addChild(bg)
	
	local proBg = display.newSprite(PATH.."pro_bg.png")
	setAnchPos(proBg,20,530)
	self.mainLayer:addChild(proBg)
	
	proBg = display.newSprite(PATH.."power_text.png")
	setAnchPos(proBg,32,610)
	self.mainLayer:addChild(proBg)
	
	proBg = CCLabelTTF:create(DATA_Power:get("num").."/"..DATA_Power:get("max"), FONT, 18)
		setAnchPos(proBg, 47, 595, 0.5, 0.5)
	self.mainLayer:addChild(proBg)


	--排行榜
	local zuoRiSaoDang = display.newSprite(SCENECOMMON.."zuoRiSaoDang.png" ,35,720,0,0)
	self.mainLayer:addChild(zuoRiSaoDang)	
 

 	local rankData = DATA_Instance:get("equip","ranking")
	
	rankData['type']="equipFb" --排行榜类型为mission
	
	local rankName = display.strokeLabel(rankData.info.name, 190, 720, 20,ccc3( 255 , 255 , 255 ))
	self.mainLayer:addChild(rankName)	

	local findBtn = KNBtn:new(SCENECOMMON, {"find.png", "find_pre.png"}, 280,712, {
		callback = function ()

				local rankLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/rankLayer")
				rankLayer:new(rankData)


		end})

	self.mainLayer:addChild(findBtn:getLayer())

	
	if 	tonumber(DATA_Instance:get("equip","heroexpcard", "clock")) > 0 then
		local expIcon = KNBtn:new(PATH,{"heroexpcard.png"}, 22, 715, {
			callback = function()
				KNMsg.getInstance():flashShow("挑战藏宝楼可获得"..DATA_Instance:get("equip","heroexpcard","multi").."倍英雄经验")
			end
		})
		dump(DATA_Instance:get("equip","heroexpcard"))
		self.mainLayer:addChild(expIcon:getLayer())
		
		local time = createLabel({str = timeConvert(DATA_Instance:get("equip","heroexpcard", "clock")), size = 16, color = ccc3(0xff,0xff,0xff), x =  10, y =695})
		self.mainLayer:addChild(time)
		Clock:addTimeFun("equip_fb_time", function()
			if DATA_Instance:get("equip","heroexpcard", "clock") > 0 then
	--			DATA_Instance:get("equip","heroexpcard", "clock") = DATA_Instance:get("equip","heroexpcard", "clock") - 1	
				DATA_Instance:set("equip", "heroexpcard","clock", DATA_Instance:get("equip","heroexpcard", "clock") - 1)
				time:setString(timeConvert(DATA_Instance:get("equip","heroexpcard", "clock")))
			end
		end)
				
	end 
	
--  这里是挑战书，现在未使用,暂时保留	
--	proBg = display.newSprite(PATH.."pro_bg.png")
--	setAnchPos(proBg,20,330)
--	self.mainLayer:addChild(proBg)
--	
--	proBg = display.newSprite(PATH.."shu_text.png")
--	setAnchPos(proBg,32,400)
--	self.mainLayer:addChild(proBg)
--	
--	proBg = CCLabelTTF:create(DATA_Instance:get("equip", "point").."/"..DATA_Instance:get("equip", "point_max"), FONT, 18)
--	setAnchPos(proBg, 47, 380, 0.5, 0.5)
--	self.mainLayer:addChild(proBg)
	
	--增加体力按钮
	local addPowerBtn = KNBtn:new(COMMONPATH, {"add.png", "add_press.png"}, 22,515, {
		callback = function()
			local list
			list = SelectList:new("prop",self.viewLayer,display.newSprite(COMMONPATH.."title/prop_text.png"),{ 
				btn_opt = "use.png",
				y = 85,
				showTitle = true , 
				filter = {type = "powerdrug"},
				optCallback = function()
					list:destroy()
					HTTP:call("status", "eat", {id = list:getCurItem():getId()},{success_callback=
						function()
							self:createEquipFb(map)
							KNMsg.getInstance():flashShow("使用成功，体力增加")
						end})
				end
			})
			self.layer:addChild(list:getLayer() , 11)
		end
	})
	self.mainLayer:addChild(addPowerBtn:getLayer())	
--	
--	--这里是挑战书使用按钮，暂时保留
--	local addTimesBtn = KNBtn:new(COMMONPATH, {"add.png", "add_press.png"}, 25,310, {
--		callback = function()
--			local list
--			list = SelectList:new("prop",self.viewLayer,display.newSprite(COMMONPATH.."title/prop_text.png"),{ 
--				btn_opt = "use.png",
--				y = 85,
--				showTitle = true , 
--				filter = {type = "challengebook"},
--				optCallback = function()
--					list:destroy()
--					HTTP:call("insequip","useshu", {id = list:getCurItem():getId()}, {
--						success_callback = function()
--							self:createEquipFb(map)
--							KNMsg.getInstance():flashShow("挑战书已使用，挑战次数增加")
--						end
--					})
--				end
--			})
--			self.layer:addChild(list:getLayer() , 11)
--		end
--	})
--	self.mainLayer:addChild(addTimesBtn:getLayer())	


	for i = 1, 2 do
		local index = tower[kind][2][i] 
		if index ~= 0 then
			local bgStr = tower[index][1] 
				local btn = KNBtn:new(PATH, {bgStr.."_tower.png", bgStr.."_tower_pre.png"}, 8, (i == 1 and 95 or 480), {
				callback = function()
					if (i == 2 and tonumber(DATA_Instance:get("equip", "max", "map_id")) > kind * 6) or i == 1 then
						local mapId = (i == 1 and ((kind - 1) * 6) or (kind * 6 + 1))
						if DATA_Instance:get("equip", mapId) then
							self:createEquipFb(mapId)
						else
							HTTP:call("insequip", "get", {map_id = mapId}, {
								success_callback = function()
									self:createEquipFb(mapId)
								end
							})
						end
					else
						KNMsg.getInstance():flashShow("还想往上爬？？那就赶快通关吧，看好你哦，骚年")
					end
				end
			})
			self.mainLayer:addChild(btn:getLayer())
		end
	end
	
	--塔的背景
	local tower_bg = display.newSprite(PATH.."tower_bg.png")
	setAnchPos(tower_bg, -15, 140)
	self.mainLayer:addChild(tower_bg)
	
	local pos ={45,45,35,33,33,0}
	--塔有六层，每一层是一个按钮放入单选按钮组中管理
	local group = KNRadioGroup:new()
	local y = 195
	for i = 1, 6 do
		local mapId = (kind - 1) * 6 + i
		local tower = KNBtn:new(PATH,{"tower"..i.."_bg.png","tower"..i..".png"},32,y, {
			upSelect = true,
			disableWhenChoose = true,
			callback = function()
				if mapId <= tonumber(DATA_Instance:get("equip", "max", "map_id")) then
					if DATA_Instance:get("equip", mapId) then
						self:createEquipFb(mapId)
					else
						HTTP:call("insequip", "get", {map_id = mapId}, {
							success_callback = function()
								self:createEquipFb(mapId)
							end
						})
					end
				else
					KNMsg.getInstance():flashShow("饭要一口一口吃，塔要一层一层爬，少年")
					return false 
				end
			end
		},group)
		self.mainLayer:addChild(tower:getLayer())
		y = y + pos[i] 
	end
--	group:chooseByIndex(DATA_Instance:get("equip","max","map_id"))
	group:chooseByIndex(tonumber(map) - ((kind - 1) * 6))
	
	
	local scroll = KNScrollView:new(40, 100, 450, 615)
	

	local bossLayer = display.newLayer()
	--添加boss
	
	local bossOpen

	if tonumber(map) < tonumber(DATA_Instance:get("equip", "max", "map_id")) or tonumber(DATA_Instance:get("equip", "max", "ins_id")) == 25 then
		bossOpen = true
	end
	local boss = KNBtn:new(PATH, {"boss"..(tonumber(map) - (kind - 1) * 6)..".png", "boss"..(tonumber(map) - (kind - 1) * 6).."_pre.png"}, 150, 0, {
		callback = function()
			self:createTip(map, 25, function(finish)
				local curData = {map_id = map, ins_id = 25}
				DATA_Instance:setCurEquipData( curData )
				SOCKET:getInstance("battle"):call("insequip" , "execute" , "execute", curData )
				finish()
			end, bossOpen)
		end
	})
	
	--若boss已挑战成功
	if tonumber(DATA_Instance:get("equip", tonumber(map), 25,  "max_dig_times")) > 0  then
		local digBtn = KNBtn:new(COMMONPATH, {"btn_ver_small.png", "btn_ver_small_pre.png"}, 290, 20, {
			front = PATH.."dig_text.png",
			priority = -129,
			callback = function()
				self:createDig(map)
			end
		})
		bossLayer:addChild(digBtn:getLayer(), 1)
	end
	
	bossLayer:setContentSize(CCSizeMake(380, boss:getHeight()))
	bossLayer:addChild(boss:getLayer())
	
	scroll:addChild(bossLayer)
	
	local x, flag = 50, 1
	local str
	for i = 1, 24 do
		local layer = display.newLayer()
		
		if (24 - i - 3 ) % 4 == 0 then  --这个位置是宝箱
			if tonumber(map) < tonumber(DATA_Instance:get("equip", "max", "map_id")) or (25 - i) < tonumber(DATA_Instance:get("equip", "max", "ins_id")) then
				str = {"box_open.png"}
			else
				if tonumber(DATA_Instance:get("equip", "max", "ins_id")) == tonumber(DATA_Instance:get("equip", "current","ins_id")) then
					str = {"box_open.png"}
				else
					str = {"box_disable.png"}
				end
			end
		else
			if tonumber(map) < tonumber(DATA_Instance:get("equip", "max", "map_id")) or (25 - i) < tonumber(DATA_Instance:get("equip", "max", "ins_id")) then
				str = {"equip_enable.png", "equip_enable_pre.png"}
			else
				str = {"equip_disable.png"}
			end
		end
		
		if tonumber(map) == tonumber(DATA_Instance:get("equip", "max", "map_id")) and (25 - i ) == tonumber(DATA_Instance:get("equip", "max" ,"ins_id")) then
			local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
			local ani = display.playFrames(x + 55,50,frames, 0.2, {
				forever = true,
			})
			layer:addChild(ani,5)
		end
		
		local btn = KNBtn:new(PATH,str,x,0,{
			parent = scroll,
			scale = true,
			callback = function()
				if (25 - i) % 4 == 0 then      --这个是根据位置计算，能被4整除的位置是宝箱
--					if map < DATA_Instance:get("equip", "max", "map_id") or (25 - i) < DATA_Instance:get("equip", "max", "ins_id") then
--						KNMsg.getInstance():flashShow("宝箱已打开，请继续向上爬吧")
--					else 
--						if (25 - i) <= DATA_Instance:get("equip", "max", "ins_id") then
--							HTTP:call("insequip","openbox",{map_id = map, ins_id = 25 - i},{
--								success_callback = function(data)
--									self:createEquipFb(map)
--									local card_popup = KNCardpopup:new(data["drop"][1] , function()
--										end , {
----											init_x =  196,
----											init_y = 211,
----											end_x =  196,
----											end_y =  211,
----											top_tips = display.strokeLabel("锦囊已使用，获得物品:", 0, 0, 20),
--										})
--									display.getRunningScene():addChild(card_popup:play())
--									if i == 1 then --最后一个
--										HTTP:call("insequip", "get", {map_id = map + 1}, {success_callback = function()
--											self:createEquipFb(map + 1)
--										end})
--									end	
--								end
--							})
--						else
					local open 
					if tonumber(map) < tonumber(DATA_Instance:get("equip", "max", "map_id")) or (25 - i) <= tonumber(DATA_Instance:get("equip", "max", "ins_id")) then
						open = true
					end
					
					self:createTip(map, 25 - i, function(finish)
						if isBagFull() then
							return false
						end
						
						HTTP:call("insequip","openbox",{map_id = map, ins_id = 25 - i},{
							success_callback = function(data)
								self:createEquipFb(map)
								local card_popup = KNCardpopup:new(data["drop"][1] , function()
									finish()
									end , {
--											init_x =  196,
--											init_y = 211,
--											end_x =  196,
--											end_y =  211,
--											top_tips = display.strokeLabel("锦囊已使用，获得物品:", 0, 0, 20),
									})
								display.getRunningScene():addChild(card_popup:play())
--								if i == 1 then --最后一个
--									HTTP:call("insequip", "get", {map_id = map + 1}, {success_callback = function()
--										self:createEquipFb(map + 1)
--									end})
--								end	
							end
						})
					end, open)	
--						end
--					end
				else   --副本
					local open 
					if tonumber(map) < tonumber(DATA_Instance:get("equip", "max", "map_id")) or (25 - i) <= tonumber(DATA_Instance:get("equip", "max", "ins_id")) then
						open = true
					end
					self:createTip(map, 25 - i, function()
						if isBagFull() then
							return false
						end
						local curData = {map_id = map, ins_id = 25 - i}
						DATA_Instance:setCurEquipData( curData )
						SOCKET:getInstance("battle"):call("insequip" , "execute" , "execute", curData )
					end, open)	
				end
			end
		})
		
		if i == 1 then
			layer:setContentSize(CCSizeMake(380,100))
			x = x + 95 
		elseif (i - 1) % 4 == 0 then -- 这里是宝箱
			layer:setContentSize(CCSizeMake(380,100))	
			if flag > 0 then
				x = x + flag * 95
			else
				x = x + flag * 95
			end
		elseif i % 4 == 0 then
			flag = -flag
			layer:setContentSize(CCSizeMake(380,50))
		else   --这里是副本挑占的按钮
			if flag > 0 then
				x = x + flag * 95
			else
				x = x + flag * 95
			end
			layer:setContentSize(CCSizeMake(380,30))	
		end
		
		layer:addChild(btn:getLayer())
		scroll:addChild(layer , btn)
	end

	if tonumber(map) < tonumber(DATA_Instance:get("equip", "max", "map_id")) then
		scroll:setIndex(0, true, 50)
	else
		scroll:setIndex( 25 - tonumber(DATA_Instance:get("equip", "max", "ins_id")) , true , 50)
	end
	self.mainLayer:addChild(scroll:getLayer())
	
	self.layer:addChild(self.mainLayer)
	
	self:createInfo(PATH.."equip_title.png",function()
		self:createMain("equip")
	end)


	-- 新手引导
	if KNGuide:getStep() == 803 then
		local btn = scroll:getItems(24)
		local btn_range = btn:getRange()

		KNGuide:show( btn:getLayer() , {
			--remove = true,
			x = btn_range:getMinX(),
			y = btn_range:getMinY(),
		})
	end
end

function FBLayer:createPetFb()
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	self.mainLayer = display.newLayer()
	
	
	local bg = display.newSprite(COMMONPATH.."bg_smaller.png")
	setAnchPos(bg, 240, 110, 0.5)
	self.mainLayer:addChild(bg)
	
	
	local content, tabs = nil, {}
	
	local function createContent(tab,pos)
		if content then
			self:stopTimer()
			self.mainLayer:removeChild(content, true)
		end
		content = display.newLayer()
		 
		local moneyType = "gold"
		if pos == 1 then
			moneyType = "silver"
		end
		local img = display.newSprite(PATH..tab.."_img.png")
		setAnchPos(img, 27, 460)
		content:addChild(img)
		
		img = display.newSprite(PATH.."pet_bottom.png")
		setAnchPos(img, 22, 115)
		content:addChild(img)
		
		local showLayer
		local function show()
			-- 狩猎获得的物品展示
			if showLayer then
				content:removeChild(showLayer,true)
			end
				showLayer = display.newLayer()
			local x, y = 35, 280
			local listNum =  #(DATA_Instance:get("pet", "message", pos.."") or {})
			for i = 1, 15 do
				local front, other, text, cid
				local last
				if DATA_Instance:get("pet", "message", pos.."") and i <= listNum then
					if i <= (DATA_Instance:get("pet", "message", pos.."_last") or 0) then
						last = {COMMONPATH.."select2.png",-12,-10, 15}
					end
					cid = DATA_Instance:get("pet", "message", pos.."", listNum - i + 1 ,"cid")
					front = getImageByType(cid, "s")
--					other = {{COMMONPATH.."star_border/border_"..getConfig(getCidType(cid), cid, "star")..".png", -15, -15}}
					local num = DATA_Instance:get("pet", "message", pos.."", listNum - i + 1, "num")
					if  num and num > 0 then
						other = {}
						other[1] = {COMMONPATH.."egg_num_bg.png", 50, -5,16}
						other[2] = last
						text = {num, 18, ccc3(255, 255, 255), ccp(28, -27), nil, 17}
					end
				end
				
				local data 
				if cid then			
					data = getConfig(getCidType(cid),cid)
					data["cid"] = cid
				end
				local gift = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, x, y, {
					front = front,
					other = other,
					text = text,
					scale = true,
					noTouch = (cid == nil),
					callback = function()
							pushScene("detail" , {
							detail = getCidType(cid),
							data = data,
						})
					end
				})
				showLayer:addChild(gift:getLayer())
				
				x = x + gift:getWidth() * 1.3
				if i % 5 == 0 then
					x =35 
					y = y  - gift:getHeight() * 1.15
				end
			end
			content:addChild(showLayer)
		end
		
		show()
		local isNil = false
		for i = 1, 3 do
			local get = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 18 + (i - 1) * 150, 415, {
				front = PATH.."p"..DATA_Instance:get("pet", "instance", pos.."", i.."", "count")..".png",
				callback = function()
					if DATA_Instance:get("pet","instance", pos.."", i.."", "free_time") == 0 and DATA_Account:get(moneyType) < tonumber(DATA_Instance:get("pet","instance", pos.."", i.."",moneyType)) then
						KNMsg.getInstance():flashShow(moneyType == "gold" and "金币不足" or "银币不足")
						return false
					end
--					
					if DATA_Instance:get("pet", "instance",pos.."", i.."", "cd") > 0 then
						KNMsg.getInstance():flashShow("请休息一下，稍候再来吧*_*")
						return false
					end

					if isBagFull() then
						return false
					end

					local success = false
					local aniDone = false
					local http_request
					http_request = HTTP:call("inspetnew", "finish", {
						map_id = pos ,
						ins_id = i ,
						_s_time = SERVER_TIME,
						_s_sign = MD5(SERVER_TIME .. "_" .. pos .. "_" .. i)
					} , {
						no_loading = true,
						success_callback = function( _b )
							isNil = _b
							 success = true
							 if aniDone then
								 local num = 0
								for j = 1, 3 do
									num = num + DATA_Instance:get("pet","instance", pos.."", j.."", "free_time")
								end
								tabs[pos]:setText(num)
								KNMsg.getInstance():flashShow( isNil and "运气真差，本次狩猎扑了个空!" or "您获得的物品已放入背包" )
								createContent(tab, pos)
							 end
						 end
					})
						 
					local mask = KNMask:new({opacity = 0})
					content:addChild(mask:getLayer())
					local function getEffect(cur, max) 
						local frame = display.newFramesWithImage(PATH.."pet_fb_effect.png",4)
						local sprite
						local x = 50 + math.random(300)
						local y = 500 + math.random(100)
						sprite = display.playFrames(x,y, frame, 0.05,{
							onComplete = function()
								content:removeChild(sprite, true)
								local gift = display.newSprite(PATH.."pet_gift.png")	
								setAnchPos(gift, x, y, 0.5, 0.5)
								gift:runAction(getSequenceAction(CCJumpTo:create(0.1, ccp(x,y),50,1), getSpawnAction(CCMoveTo:create(0.2,ccp(65,310)),CCRotateTo:create(0.2,720)),CCCallFunc:create(function()
									if success  then
										if  cur == max then
											content:removeChild(gift, true)
											-- content:removeChild(mask, true)
											mask:remove()
											local num = 0
											for j = 1, 3 do
												num = num + DATA_Instance:get("pet","instance", pos.."", j.."", "free_time")
											end
											tabs[pos]:setText(num)
											KNMsg.getInstance():flashShow( isNil and "运气真差，本次狩猎扑了个空!" or "您获得的物品已放入背包" )
											createContent(tab, pos)
										else
--											show()
										end
									else
										if cur == max then
											aniDone = true
--											http_request:showLoading()
											mask:remove()
										end
											content:removeChild(gift, true)
											content:removeChild(sprite, true)
											sprite:stopAllActions()
									end
								end)))
								content:addChild(gift)
							end
						} )
						content:addChild(sprite)
					end
					
					for j = 1, i == 1 and 1 or i * i + 1 do
						mask:getLayer():runAction(getSequenceAction(CCDelayTime:create((j - 1) * 0.2), CCCallFunc:create(function()
							getEffect(j, i == 1 and 1 or i * i + 1)
						end)))
					end
				end
			})
			content:addChild(get:getLayer())

			-- 新手引导
			if i == 3 and KNGuide:getStep() == 3104 then
				KNGuide:show( get:getLayer() , {
					remove = true
				})
			end
			
			get = display.newSprite(PATH.."text_bg.png")
			setAnchPos(get, 18 + (i - 1) * 150, 360)
			content:addChild(get)
			
			local y = 375
			get = display.newSprite(COMMONPATH..moneyType..".png")
			setAnchPos(get, 40 + (i - 1) * 150, y)
			content:addChild(get)
			
			local str = DATA_Instance:get("pet", "instance",pos.."", i.."", moneyType)
			if DATA_Instance:get("pet","instance", pos.."", i.."", "free_time") > 0 then
				str = "免费 "
			end
			local money = display.strokeLabel(str == 0 and "免费" or str, 80 + (i - 1) * 150, y, 18, ccc3(0x2c, 0, 0))
			content:addChild(money)
			
			if moneyType == "silver" and DATA_Instance:get("pet","instance", pos.."", i.."", "free_time") == 0 then	
				setAnchPos(get, 40 + (i - 1) * 150, y + 10)
				setAnchPos(money, 80 + (i - 1) * 150, y + 10)
			end
			
			
			local time  = DATA_Instance:get("pet", "instance", pos.."", i.."", "cd") 
			if time > 0 then
				local timeLabel = display.strokeLabel(timeConvert(time), 60 + (i - 1) * 150, 365, 18, ccc3(0x2c, 0, 0))
				content:addChild(timeLabel)
				Clock:addTimeFun("inspet_clock"..i, function()
					if time > 0 then
						time = time - 1
						timeLabel:setString(timeConvert(time))
					else
						self:stopTimer(i)
					end
				end)
			end
		end
	
	
		self.mainLayer:addChild(content)
	end


	--查找除已装备外的所有器灵
	local function findAllQiLingExceptEquiped(inLayData,allQiLingTab)
		local newListQilingTab = {}
		local x = 1
		for i = 1 ,#allQiLingTab do
				local isEquiped = false
				 for m,n in pairs(inLayData) do
				 		    	 	
			       	 	if n['1']~=nil and allQiLingTab[i]~=nil then
			       	 	    if n['1']['id']== allQiLingTab[i]['id'] then  --该item 激活
			       	 	    	
			       	 	    	isEquiped=true
			       	 	    end
			       	 	end
			   
			       	 	if n['2']~=nil and allQiLingTab[i]~=nil  then
			       	 		if n['2']['id']== allQiLingTab[i]['id'] then  --该item 激活
			       	 			
			       	 	     	isEquiped=true
			       	 	    end
			       	 	end

			     end
			     --未装备的加进去
			     if not isEquiped then
			     	
			     	newListQilingTab[x]=allQiLingTab[i]
			     	x=x+1
			     end

		end	
		return newListQilingTab
	end

	
	--洞天福地
	--chipData碎片值
	local function createDongTian(chipData)
		if content then
			self:stopTimer()
			self.mainLayer:removeChild(content, true)
		end
		content = display.newLayer()

		local dongTianBg = display.newSprite(PATH.."dongTian_img.png")
		setAnchPos(dongTianBg,15,104)
		content:addChild(dongTianBg)

		local tempScrollView = KNScrollView:new(20,310,445,367,2,false,0,{	
	   		 priority = -130,
	    	 --debug=true,
	    })
  		
   		content:addChild(tempScrollView:getLayer())

   		--------------
   	local  inLayData= {}
	local  listData={}

	if DATA_Bag:get("inlay") ~=nil then
		inLayData=DATA_Bag:get("inlay")['qiling'] --背包装备镶嵌器灵数据
	end
	if DATA_Bag:get("qlprop") ~=nil then
		listData=findAllQiLingExceptEquiped(inLayData,DATA_Bag:get("qlprop")) --器灵背包总数据
	end

	--dump(listData)
   	local lineTempLayer 
   	local colunmIndex = 1   --列,每4列换一行
  	local count = 0
  	--器灵背包数据
  	local colorConfig = {
				[2]="green",
				[3]="blue",
				[4]="purple",
				[5]="golden"
			}

    for i=1,#listData do
     	
     	if  count%4==0 then
		  	lineTempLayer =  display.newLayer()
		   	lineTempLayer:setContentSize(CCSizeMake(445,90))
			setAnchPos(lineTempLayer)
		   	tempScrollView:addChild(lineTempLayer,lineTempLayer)
     	end
     
     	local qingLingBtn  --器灵icon
		 qingLingBtn = KNBtn:new(SPRITE_LIST_PATH, { "icon/"..listData[i]['cid'].."_".. colorConfig[listData[i]['grade']]..".png" } , 15+(colunmIndex-1)*107, 13 , {
				scale = true,
				priority = -131 , 
				parent=tempScrollView,
				callback = function()
							local mask
							
							local tempLayer =display.newLayer()				

							--背景
						 	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
							setAnchPos(bg,30,340)
							tempLayer:addChild(bg)

							--标题背景
						 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
						 	setAnchPos(title_bgSp,85,240)
						 	bg:addChild(title_bgSp)

							--标题文字
						 	local title_Sp = display.newSprite(PATH.."qiLingTitle.png")
						 	setAnchPos(title_Sp,68,22)
						 	title_bgSp:addChild(title_Sp)

						 	--器灵图标
						 	local effetFrames1 = display.newFramesWithImage(SPRITE_PATH ..listData[i]['cid'].."_"..colorConfig[listData[i]['grade']]..".png", 12, 1)
							local action = display.playFrames(0, 0, effetFrames1, 0.15, {
									forever = true,

								})
							setAnchPos(action,170,115)
							bg:addChild(action)

							--等级角标
							local sIconBgSp = display.newSprite(COMMONPATH.."egg_num_bg.png")
							setAnchPos(sIconBgSp,action:getContentSize().width*0.76,action:getContentSize().height*0.76)
							action:addChild(sIconBgSp)

							local sIconLv = display.strokeLabel(listData[i]['lv'],sIconBgSp:getContentSize().width*0.5,sIconBgSp:getContentSize().height*0.5,15,ccc3(255,255,255))
							sIconLv:setAnchorPoint(ccp(0.5,0.5))
							sIconBgSp:addChild(sIconLv)

							--器灵名称
							local qiLingName = display.strokeLabel(listData[i]['name'],3,-20,16,ccc3(0,0,0))
							action:addChild(qiLingName)
							--器灵属性
							local qiLingAttr = display.strokeLabel(listData[i]['effectdesc'].." + "..listData[i]['propety'],action:getContentSize().width*0.5,-30,14,ccc3(255,0,0))
							qiLingAttr:setAnchorPoint(ccp(0.5,0.5))
							action:addChild(qiLingAttr)
							--器灵描述
							local qiLingAttrExtra = display.strokeLabel(listData[i]['geniusdesc'],32,90,13,ccc3(57,19,15))
							qiLingAttrExtra:setAnchorPoint(ccp(0.5,0.5))
							action:addChild(qiLingAttrExtra)
						 	
						 	--关闭按钮
						    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 10 , 210 , {
									priority = -152,
									scale = true,
									callback = function()
										
										mask:remove()

									end})
							bg:addChild(close:getLayer())


							--升级按钮
							local upBtn
						    	  upBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 140 , 20 , {
									priority = -152,
									scale = true,
									front = COMMONPATH.."tun_chi.png",
									id=listData[i]['id'],
									callback = function()
										HTTP:call("inlay","getQlConfig",{ } , {
											success_callback = function( receiveData )
												
												--查找该器灵所属装备
												
												local equipOwenrId --器灵所属装备id
												local qiLingPosId =0 
												for k,v in pairs(inLayData) do
													if v['1']['id'] == upBtn:getId()  then
														equipOwenrId =k
														qiLingPosId=1
													elseif v['2']~=nil and v['2']['id']==upBtn:getId() then
														equipOwenrId=k
														qiLingPosId=2
													end
												end

												switchScene("equipSpriteUpdate",{ eid= equipOwenrId,qiLingData=listData[i],posId=qiLingPosId,updateQLConfigData=receiveData})
											end
										})
										
									end})
							bg:addChild(upBtn:getLayer())


						 	mask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -150})

						 	self.mainLayer:addChild(mask:getLayer())



				end
			})
		
		lineTempLayer:addChild(qingLingBtn:getLayer())  
		local isEquiped = false
		for k,v in pairs(inLayData) do	 	
	       	 	if v['1'] then
	       	 	    if v['1']['id']== listData[i]['id'] then  --该器灵 已经激活
	       	 	    	
	       	 	    	isEquiped=true
	       	 	    end
	       	 	end	       	 	
	       	 	if v['2'] then
	       	 		if v['2']['id']== listData[i]['id'] then  --该器灵 已经激活       	 			

	       	 	     	isEquiped=true
	       	 	    end
	       	 	end
	     end  	
	     if isEquiped then   --已经装备的器灵加个锁
	     	local lock = display.newSprite(COMMONPATH.."lock_small.png")
	     	setAnchPos(lock,qingLingBtn:getLayer():getContentSize().width*0.8,0)
	     	qingLingBtn:getLayer():addChild(lock)
	     end

        --等级角标
		local sIconBgSp = display.newSprite(COMMONPATH.."egg_num_bg.png")
		setAnchPos(sIconBgSp,qingLingBtn:getLayer():getContentSize().width*0.75,qingLingBtn:getLayer():getContentSize().height*0.75)
		qingLingBtn:getLayer():addChild(sIconBgSp)

		local sIconLv = display.strokeLabel(listData[i]['lv'],sIconBgSp:getContentSize().width*0.5,sIconBgSp:getContentSize().height*0.5,15,ccc3(255,255,255))
		sIconLv:setAnchorPoint(ccp(0.5,0.5))
		sIconBgSp:addChild(sIconLv)

	    local qiLingName = display.strokeLabel(listData[i]['name'],5,-13,15,ccc3(230,219,116))
		qingLingBtn:getLayer():addChild(qiLingName)

	    if (count+1)%4 ==0 then
			colunmIndex=0
		end

		colunmIndex=colunmIndex+1
		count=count+1

     end

    	

		--碎片进度条
		local fireBoard=KNBtn:new(COMMONPATH, { "fireBoard.png","fireBoard.png" } , 100, 278 , {
				scale = true,
				priority = -131 , 
				callback = function()
					if chipData['chip'] <chipData['max_chip'] then
						KNMsg.getInstance():flashShow(replaceStr("幸运值满后可以必得高级器灵。"))
					else
						KNMsg.getInstance():flashShow(replaceStr("恭喜你的幸运值满了，再次点击要出高级器灵了。"))
					end
				end
			}):getLayer()
		
		content:addChild(fireBoard)

		local fireBoardIn = display.newSprite(COMMONPATH.."fireBoardIn.png")
		setAnchPos(fireBoardIn,0,0)
		fireBoard:addChild(fireBoardIn)
		local suiPianPercent = chipData['chip']/chipData['max_chip']
		fireBoardIn:setTextureRect(CCRectMake(0,0,fireBoard:getContentSize().width*suiPianPercent,fireBoard:getContentSize().height))

		--碎片值
		local suiPianZhi = display.strokeLabel(chipData['chip'].."/"..chipData['max_chip'],fireBoard:getContentSize().width*0.45 , 7 , 13 ,ccc3(255,255,255))
		fireBoard:addChild(suiPianZhi)

		--说明
		local suiPianShuoMing = display.strokeLabel("说明:幸运值满后可以必得高级器灵。",20 , -15 , 14 ,ccc3(97,223,223))
		fireBoard:addChild(suiPianShuoMing)

		-- --小宝箱
		-- local smBaoxiangSPBtn
		--  smBaoxiangSPBtn = KNBtn:new(PATH, { "box.png" } , 360, 230 , {
		-- 				scale = true,						
		-- 				callback = function()
		-- 				     smBaoxiangSPBtn:getLayer():stopAllActions()
		-- 				     if  chipData['chip'] >=chipData['max_chip'] then
		-- 					     smBaoxiangSPBtn:setBg(1,PATH.."boxOpen.png")
		-- 					     			HTTP:call("inlay","qlChipExchange",{ } , {
		-- 									success_callback = function( receiveData )
		-- 											dump(receiveData['get_qiling'])
		-- 											--smBaoxiangSPBtn:setBg(1,PATH.."box.png")
		-- 											local baoSp = display.newSprite(SPRITE_LIST_PATH .."icon/"..receiveData['get_qiling']['cid'].."_".. colorConfig[receiveData['get_qiling']['grade']]..".png")
		-- 											setAnchPos(baoSp,390,260)
		-- 											baoSp:setScale(0.8)
		-- 											content:addChild(baoSp)
		-- 											local array = CCArray:create()
													
		-- 											array:addObject( CCMoveTo:create( 0.5, ccp( baoSp:getPositionY()-50 , baoSp:getPositionY()+150) ))
													
		-- 											local spw = CCSpawn:create(array);
		-- 											local seq = transition.sequence({
		-- 								       				 spw,
		-- 								       				 CCCallFunc:create(function ()
		-- 								       				 		HTTP:call("inlay","getQLChip",{ } , {
		-- 																success_callback = function( receiveData )
																			
		-- 																	createDongTian(receiveData)
																			
		-- 																end
		-- 																})
		-- 								       				 end),
		-- 								    			})
		-- 											baoSp:runAction(seq)


		-- 									end
		-- 									})
		-- 				     else
		-- 				     	KNMsg:getInstance():flashShow("碎片数量满级时可以打开必得器灵宝箱")
		-- 				     end
		-- 				end
		-- 			})
		-- smBaoxiangSPBtn:getLayer():setScale(0.5)
		-- smBaoxiangSPBtn:getLayer():setAnchorPoint(ccp(0.5,0.5))
		-- content:addChild(smBaoxiangSPBtn:getLayer())
		--碎片满时摇动
		-- if  chipData['chip'] >=chipData['max_chip'] then
			
		-- 	local seq = transition.sequence({
  --      				 CCRotateTo:create(0.4,20),
  --      				 CCRotateTo:create(0.4,-20),
  --   			})
		-- 	seq = tolua.cast(seq,"CCActionInterval")
		-- 	local rep = CCRepeatForever:create( seq )
		-- 	smBaoxiangSPBtn:getLayer():runAction(rep)
		-- end



     	local baoxiangSz = {}
   		--------------
		-- 三个宝箱
		for i=1,3 do
			local baoxiangbtn
			baoxiangbtn = KNBtn:new(PATH, {"box.png" }, 18+(i-1)*160, 145, {
			callback = function()
				HTTP:call("inlay","createQlProp",{ xid=i } , {
							success_callback = function( callBackData )
								dump(callBackData['other_qiling'])
								baoxiangbtn:setId("opend")
								--dump(baoxiangSz)

								baoxiangbtn:setBg(1,PATH.."boxOpen.png")
								
								local  baoSp = display.newSprite(SPRITE_LIST_PATH .."icon/"..callBackData['get_qiling']['cid'].."_".. colorConfig[callBackData['get_qiling']['grade']]..".png" )
								setAnchPos(baoSp,45,35)
								baoSp:setScale(0.8)
								baoxiangbtn:getLayer():addChild(baoSp)
								
								local xPos = baoSp:getPositionX()  --宝箱移动动画坐标
								
								if i==1 then
									xPos=xPos +135		
								elseif i==3 then
									xPos=xPos -135							
								end								
								
								local otherBaoSpSz = {} --其他器灵数组
								local array = CCArray:create()
								array:addObject( CCMoveTo:create( 0.15,ccp(baoSp:getPositionX() ,baoSp:getPositionY()+35)))
								array:addObject( CCDelayTime:create( 0.5 ) )

								array:addObject( CCMoveTo:create( 0.5, ccp( xPos , baoSp:getPositionY()+250) ))
								
								array:addObject( CCCallFunc:create(function()  
									baoSp:setVisible(false)--隐藏
									baoxiangbtn:setBg(1,PATH.."box.png") --关闭自己
																		
									local x = 1
									for k,v in pairs(baoxiangSz) do  --打开其他两个,并显示未抽中的器灵										
										if v:getId()~="opend" then
											v:setBg(1,PATH.."boxOpen.png")
											local othenBaoSp = display.newSprite(SPRITE_LIST_PATH .."icon/"..callBackData['other_qiling'][x..""]['cid'].."_".. colorConfig[callBackData['other_qiling'][x..""]['grade']]..".png" ) --其他两个未抽中的器灵
											setAnchPos(othenBaoSp,45,35)
											othenBaoSp:setScale(0.8)
											v:getLayer():addChild(othenBaoSp)
											table.insert(otherBaoSpSz,othenBaoSp)
											x=x+1
										end

									end
									

								 end))
								array:addObject(CCDelayTime:create( 1.0 )) --延时1秒关闭所有合资
								array:addObject(CCCallFunc:create(function ()
										--先移除其他器灵图标
										for k,v in pairs(otherBaoSpSz) do
											v:removeFromParentAndCleanup(true)
										end

										for k,v in pairs(baoxiangSz) do  --全部关闭
											v:setBg(1,PATH.."box.png")
											v:setId(nil)
										end
										baoSp:removeFromParentAndCleanup(true)
										HTTP:call("inlay","getQLChip",{ } , {
										success_callback = function( receiveData )
											dump(receiveData)
											createDongTian(receiveData)
										end
										})

								end))

								baoSp:runAction(CCSequence:create(array))
																
							end
						})
			end
			})
		   content:addChild(baoxiangbtn:getLayer())
		   table.insert(baoxiangSz,baoxiangbtn)

		   local goldSp = display.newSprite(COMMONPATH.."gold.png")
		   setAnchPos(goldSp,25,-20)
		   baoxiangbtn:getLayer():addChild(goldSp)

		   local goldNum = display.strokeLabel(chipData['gold'], 60, -15, 17, ccc3(189, 183, 155), nil, nil)
		   baoxiangbtn:getLayer():addChild(goldNum)

		end	

		self.mainLayer:addChild(content)
	end 

	local title = {
		{"farmer"},
		{"town"},
		{"gov"},
		--{"dongTian"} --洞天福地
	}
	--这里是标签按钮，有纪录其免费狩猎的次数
	local group = KNRadioGroup:new()
	for i = 1, #title do
		if i ~= 2 then
			local freeNum = 0
			if i~=4 then
				for n = 1, 3 do
					freeNum = freeNum + DATA_Instance:get("pet","instance", i.."", n.."", "free_time")
				end
			end
			--20 + ((i - 1) - (i == 3 and 1 or 0)) * 150
			tabs[i] = KNBtn:new(PATH, {"tab_normal.png", "tab_select.png"},20+ ( (i>=3  and (i-1) or i)-1) *150, 690, {
				front = {PATH..title[i][1]..".png", PATH..title[i][1].."_select.png"},
				other = {COMMONPATH.."egg_num_bg.png", 120, 40},
				text = {freeNum, 18, ccc3(255,255,255), ccp(63, 22), nil, 17},
				callback = function()
						if i~=4 then
							createContent(title[i][1], i)
						else

							  HTTP:call("inlay","getQLChip",{ } , {
								success_callback = function( receiveData )
									
									createDongTian(receiveData)
								end
								})
							
						end
				end
			},group)
			if i==4 then
				tabs[i]:hideOther(true)
				tabs[i]:setText("")
			end
			self.mainLayer:addChild(tabs[i]:getLayer())
		end
	end
	group:chooseByIndex(2, true)
	
	bg = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(bg, 5, 688)
	self.mainLayer:addChild(bg)
	
	
	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH.."pet_title.png",function()
		self:createMain("pet")
	end)


	-- 新手引导
	if KNGuide:getStep() == 3103 then
		KNGuide:show( tabs[1]:getLayer() )
	end		
end


function FBLayer:directScroll(star, noChoose, except)
	if self.scroll then
		self.mainLayer:removeChild(self.scroll:getLayer(),true)
	 end
	 self.scroll = KNScrollView:new(0, 100, 480, 590, 5)

	 local border_pos = { -13 , -10 }										--唐门和水浒的 图鉴图片 边框位置不一样
	 if CHANNEL_GROUP == "tmsj" or CHANNEL_GROUP == "td" or CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then			
	 	border_pos = { -16 , - 11 }
	 end
	 
	 local function createItem(items)
		 local layer = display.newLayer()
		 local bg = display.newSprite(COMMONPATH.."item_bg.png")
		 setAnchPos(bg)
		 layer:setContentSize(bg:getContentSize())
		 layer:addChild(bg)
		 if items then
			 local n = 1
			 for k, v in pairs(items) do
				 local btn = KNBtn:new(SCENECOMMON, {"box.png"}, 10 + 90 * (n - 1), 30, {
					 front = getImageByType(k,"s"),
					 frontScale = {1, -3, 4},
					 scale = true,
			   		parent = self.scroll,
					 other = {COMMONPATH.."star_border/border_"..getConfig("general", k,"star")..".png", border_pos[1], border_pos[2]},
					 text = {v["name"], 20, ccc3(0x2c, 0, 0), ccp(0, -50)},
					 callback = function()
						 local data = v
						 v["cid"] = k
					 	pushScene("detail" , {
							detail = "general",
							toChoose = noChoose,
							chooseCallback = function()
								if getConfig("general", k, "special") == 1 then
									KNMsg.getInstance():flashShow("该英雄为特殊英雄,不能定向合成,只可在VIP礼包或活动获得!")
								else
									HTTP:call("soul","directionalfuse",{g_cid = k},{
										success_callback = function(data, id)
											self.data = data
											self.tempMerge = id
											popScene()
											self:createMergeLayer("general", star - 1)
											local card_popup = KNCardpopup:new(k, function() end , {	
												init_x =  100,
												init_y = -50,
												end_x =  100,
												end_y =  -50,})
												self.mainLayer:runAction(getSequenceAction(CCDelayTime:create(0.1),CCCallFunc:create(function()
												display.getRunningScene():addChild(card_popup:play())
											end)))
										end
									})
								end
							 end,
							data = data})
					 end
				 })
				 layer:addChild(btn:getLayer())
				 n = n + 1
			 end
		else  --特殊英雄提示
			local function colorName(str, x, y)
				return createLabel({str = str, color = ccc3(255, 0, 0), size = 14, x = x, y = y, width = 300})
			end
			
			if CHANNEL_GROUP == "tmsj" then	
				layer:addChild(colorName("千仞雪、阿呆、唐三、雷翔", 20, 80))
				layer:addChild(createLabel({str = "这四个超5星英雄不可通过定向合成:", size = 14, x =190, y = 80, width = 300}))
				
				layer:addChild(colorName("唐三、雷翔", 20, 50))
				layer:addChild(createLabel({str = "分别可在VIP5、VIP6特权礼包中获得", size = 14, x = 100, y = 50, width = 300}))
				
				layer:addChild(colorName("千仞雪、阿呆", 20, 20))
				layer:addChild(createLabel({str = "可在更高级V特权礼包中获得", size = 14, x = 110, y = 20, width = 300}))
			elseif CHANNEL_GROUP == "hy" then
				layer:addChild(colorName("鸣人、鼬、水门、宇智波斑", 20, 80))
				layer:addChild(createLabel({str = "这四个超5星英雄不可通过定向合成:", size = 14, x = 190, y = 80, width = 300}))
				
				layer:addChild(colorName("鸣人、宇智波鼬", 20, 50))
				layer:addChild(createLabel({str = "分别可在VIP5、VIP6特权礼包中获得", size = 14, x = 120, y = 50, width = 300}))
				
				layer:addChild(colorName("水门、宇智波斑", 20, 20))
				layer:addChild(createLabel({str = "可在更高级V特权礼包中获得", size = 14, x = 120, y = 20, width = 300}))
			elseif CHANNEL_GROUP == "td" then
				layer:addChild(colorName("应欢欢、凌青竹、符祖、林动", 20, 80))
				layer:addChild(createLabel({str = "这四个超5星英雄不可通过定向合成:", size = 14, x = 205, y = 80, width = 300}))
				
				layer:addChild(colorName("应欢欢、凌青竹", 20, 50))
				layer:addChild(createLabel({str = "分别可在VIP5、VIP6特权礼包中获得", size = 14, x = 120, y = 50, width = 300}))
				
				layer:addChild(colorName("符祖、林动", 20, 20))
				layer:addChild(createLabel({str = "可在更高级V特权礼包中获得", size = 14, x = 100, y = 20, width = 300}))
			elseif CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
				layer:addChild(colorName("叶凡、 辰南、 柳神、萧晨", 20, 80))
				layer:addChild(createLabel({str = "这四个超5星英雄不可通过定向合成:", size = 14, x = 205, y = 80, width = 300}))
				
				layer:addChild(colorName("辰南、萧晨", 20, 50))
				layer:addChild(createLabel({str = "分别可在VIP5、VIP6特权礼包中获得", size = 14, x = 120, y = 50, width = 300}))
				
				layer:addChild(colorName("叶凡、柳神 ", 20, 20))
				layer:addChild(createLabel({str = "可在更高级V特权礼包中获得", size = 14, x = 100, y = 20, width = 300}))
			end
			
			local btn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 320, 8, {
				front = COMMONPATH.."vip_privilege.png",
				callback = function()
					HTTP:call("vip", "get", {},{success_callback = 
					function()
						switchScene("vip")
					end})
				end
			})
			layer:addChild(btn:getLayer())
--			千仞雪、 阿呆、 唐三、雷翔这四个超5星英雄不可通过定向合成:


--			雷翔和唐三分别可在VIP5、VIP6特权礼包中获得

--			 千仞雪和阿呆可在更高级V特权礼包中获得 
		end
		 return layer
	 end
	 
	 local data = getConfigTable("hero", {star = star, special = (except and 0 or nil)})
	 local count = 0
	 local members = {}
	 for k, v in pairs(data) do
		count = count + 1
		members[k] = v
			
		if count % 5 == 0 or count == table.nums(data) then
			self.scroll:addChild(createItem(members))
			members = {}
		end
	 end
	 
	 if except then
		 --创建特殊英雄提示信息
		 self.scroll:addChild(createItem())
	 end
	 self.scroll:alignCenter()
	 
	 self.mainLayer:addChild(self.scroll:getLayer())
end



function FBLayer:directList(star , kind)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	self.mainLayer = display.newLayer()
	self.curStar = star
	
	self.state = LIST
	
	local title = display.newSprite(COMMONPATH.."title_bg.png")
	setAnchPos(title, 0, 854 - title:getContentSize().height)
	self.mainLayer:addChild(title) 
	
	title = display.newSprite(COMMONPATH.."title_tail.png")
	setAnchPos(title, 0, 854 - title:getContentSize().height * 2)
	self.mainLayer:addChild(title) 
	
	title = display.newSprite(IMG_PATH.."image/scene/forge/"..(star and "direct_text.png" or "info_title.png"))
	--如果是 equip 图鉴，则跳到EQUIPSPLIT ，并且把 title 换掉
	if kind == "equip" then 
		self.state = EQUIPLIST
		title = display.newSprite(IMG_PATH .. "image/scene/goldequip/equip_book.png")
	end
	setAnchPos(title, 245, 765, 0.5)
	self.mainLayer:addChild(title)
	
	title = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(title, 240, 690, 0.5)
	self.mainLayer:addChild(title)
	
	local group = KNRadioGroup:new()
	for i = 1, star and 1 or 5 do
		local curStar = star and star or i
		local btn = KNBtn:new(COMMONPATH.."tab/", {"tab_star_normal.png","tab_star_select.png"},10 + (i - 1) * 90 , 695, {
			id = curStar,
			front =  {COMMONPATH.."tab/".."tab_star"..curStar..".png",COMMONPATH.."tab/".."tab_star"..curStar.."_select.png"},
			callback = function()
				if kind == "equip" then
					self:equip_directScroll(curStar)
				else
					self:directScroll(curStar, star and true or false, star and true or false)
				end
			end
		}, group)
		self.mainLayer:addChild(btn:getLayer(), -1)
	end
--	btn:call()
	group:chooseByIndex(1, true)

	self.layer:addChild(self.mainLayer)		
end

function FBLayer:createHeroFb(data)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	self.mainLayer = display.newLayer()
	self.state = HERO
	
	local bg = display.newSprite(PATH.."hero_new_bg.jpg")
	setAnchPos(bg, 240, 460, 0.5, 0.5)
	self.mainLayer:addChild(bg)
	
		local info = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 20, 690, {
			front = IMG_PATH.."image/scene/forge/info_text.png",
			callback = function()
				self:directList()
			end
		})
		self.mainLayer:addChild(info:getLayer(),1)
	
	--[[bg = display.newSprite(COMMONPATH.."have.png")
	setAnchPos(bg, 300, 700)
	self.mainLayer:addChild(bg)
	
	bg = display.newSprite(COMMONPATH.."gold.png")
	setAnchPos(bg, 350, 700)
	self.mainLayer:addChild(bg)
	
	self.mainLayer:addChild(createLabel({str = DATA_Account:get("gold"), x = 380, y = 702, color = ccc3(0xff,0xff,0xff)}))
	--]]
	
	local curStar = 5
	local select = {}
	local function rdHero()
		if not self.needHeroList then
			self.needHeroList = {}
			for k, v in pairs(getConfig("general")) do
				if v.star >= 4 and v.hidden == 0 then
					if not self.needHeroList[v.star] then
						self.needHeroList[v.star] = {}
					end
					table.insert(self.needHeroList[v.star], k)
				end
			end
		end
		
		if not select[curStar] then
			select[curStar] = {}	
		end
		
		if #select[curStar] == 4 then
			curStar = curStar - 1
			select[curStar] = {}
		end
		
		local rd = self.needHeroList[curStar][math.random(1, #self.needHeroList[curStar])]
		
		while table.hasValue(select[curStar], rd) do
			rd = self.needHeroList[curStar][math.random(1, #self.needHeroList[curStar])]
		end
		
		table.insert(select[curStar], rd)
		
		return rd
	end
	--生成主页滑动卡牌
	local items = {}
	for i = 1, 8 do
		items[i] = HomeCard:new(435 , i , rdHero())
		items[i]:addTo(i,self.mainLayer)
	end
	
	for i = 1, 8 do
		items[i]:move(true, self, 1.5)
	end

    local percent =tonumber(data['progress'])  --进度条百分比
    
    --火势btn
	local fireBoardBtn = KNBtn:new(COMMONPATH, { "fireBoard.png","fireBoard.png" } , 100, 245 , {
				scale = true,
				priority = -131 , 
				callback = function()
					if percent<1.0 then
						KNMsg.getInstance():flashShow(replaceStr("幸运值满了后，“高级招将”必出5星哦。"))
					else
						KNMsg.getInstance():flashShow(replaceStr("恭喜你的幸运值满了，再次“高级招将”要出5星了。"))
					end
				end
			}):getLayer()
	self.mainLayer:addChild(fireBoardBtn)
	
	if KNGuide:getStep() == 3005 or KNGuide:getStep() == 15204 then
		KNGuide:show(fireBoardBtn, {
			callback = function()
				GLOBAL_INFOLAYER:refreshBtn()
			end,
			remove = true,
		})
	end


	local fireBoardIn = display.newSprite(COMMONPATH.."fireBoardIn.png")
	setAnchPos(fireBoardIn,0,0)
	fireBoardBtn:addChild(fireBoardIn)
	
	fireBoardIn:setTextureRect(CCRectMake(0,0,fireBoardIn:getContentSize().width*percent,fireBoardIn:getContentSize().height))
	
	local luckTip = display.newSprite(PATH.."luck_5.png")
	setAnchPos(luckTip, 240, 220, 0.5)
	self.mainLayer:addChild(luckTip)
	

	--火势动画
	local effetFrames1 = display.newFramesWithImage(PATH.."fireFrames.png", 5, 1)
	local action = display.playFrames(0, 0, effetFrames1, 0.15, {
		forever = true,
	})
	setAnchPos(action,0, fireBoardBtn:getContentSize().height + 1)
	fireBoardBtn:addChild(action)

	if percent>=1 then  --
	  action:setVisible(true)
	else
	  action:setVisible(false)
	end
	
	for i = 1, 2 do
		local kind = i == 1 and "xian" or "shen"
		local btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 20 + (i - 1) * 220, 115, {
		front = PATH..(i == 1 and "normal_text.png" or "advance_text.png"),
		callback = function()
			if isBagFull() then
				return false
			end

			if data[kind].gold > 0 and not countGold(data[kind].gold) then
				return false
			end
			for i = 1, 8 do
				items[i]:stop()
				items[i]:move(true, self, 0.01)
			end

			HTTP:call("penglai", "rand", {type = kind }, {
				no_loading = true,
				success_callback = function(data)
					
					if i==2 then  --高级
						
						if percent>=1 then  --显示动画
						  action:setVisible(true)
						else
						  action:setVisible(false)
						end
					end

					local time = 0 
					if CHANNEL_GROUP == "hy" then
						time = 0.2
					end
					local tempMask = KNMask:new()
					self.mainLayer:addChild(tempMask:getLayer())
					--召换特效	
					local frames = display.newFramesWithImage(PATH .. "hero_effect.png" , 12, 2)
					local ani = display.playFrames(240, 425, frames,time, {
						onComplete = function()
							tempMask:remove()
							for i = 1, 8 do
								items[i]:stop()
							end		
							self:popCardList(data["awards"]["drop"], data["_G_penglai"], data.frist)
						end
					})
					self.mainLayer:addChild(ani,50)
				end, error_callback = function(msg)
					KNMsg.getInstance():flashShow(msg.msg)
					self:createHeroFb(data)
				end
			})
			end
		})
		self.mainLayer:addChild(btn:getLayer())

		

		if data[kind].curtimes < data[kind].freetimes then
			self.mainLayer:addChild(createLabel({str = "免费", x = 175 + (i - 1) * 220,y = 138, color = ccc3(0xff,0xd1, 0x39)} ))
			self.mainLayer:addChild(createLabel({str = (data[kind].freetimes - data[kind].curtimes).."/"..data[kind].freetimes, x = 180 + (i - 1) * 220,y = 115, color =DESCCOLOR} ))
		else
			local gold = display.newSprite(COMMONPATH.."gold.png")
			setAnchPos(gold, 165 + (i - 1) * 220, 135 )
			self.mainLayer:addChild(gold)
			
			self.mainLayer:addChild(createLabel({str = data[kind].gold, x = 200 + (i - 1) * 220,y = 138, color = ccc3(0xff,0xd1, 0x39)} ))
			local cool = data[kind].cool
			local timeText = createLabel({str = timeConvert(data[kind].cool), x = 160 + (i - 1) * 220,y = 115, color = DESCCOLOR, size = 14})
			self.mainLayer:addChild(timeText)
			if cool > 0 then
				Clock:addTimeFun("hero_clock"..i, function()
						if cool > 0 then
							cool = cool - 1
							timeText:setString(timeConvert(cool))
						else
							HTTP:call("penglai", "get", {}, {
								success_callback = function(data)
									Clock:removeTimeFun("hero_clock1")
									Clock:removeTimeFun("hero_clock2")
									self:createHeroFb(data) 
								end
							})
						end
					end)
			end
		end

		local guide_step = KNGuide:getStep()
		if i == 1 and guide_step == 3003 then
			KNGuide:show( btn:getLayer() , {remove = true} )
		end

		if i == 2 and (guide_step == 3004 or guide_step == 15203) then
			KNGuide:show( btn:getLayer() , {
				remove = true
			} )
		end
	end
	self.layer:addChild(self.mainLayer)
	
	self:createInfo(PATH.."hero_title.png",function()
		if self.state == LIST then
			self:createHeroFb(data)
		else
			self:createMain("hero")
		end
	end)
end

--修改一次的蓬莱岛
function FBLayer:createHeroFb2(data)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	self.mainLayer = display.newLayer()
	self.state = HERO
	
	local bg = display.newSprite(PATH.."xian.png")
	setAnchPos(bg, 240, 425, 0.5)
	self.mainLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."shen.png")
	setAnchPos(bg, 240, 100, 0.5)
	self.mainLayer:addChild(bg)
	
--	--普通祈将
--	for i = 1, 2 do
--		local kind = i == 1 and "xianonce" or "shenonce"
--		local btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 20, 430 - (i - 1) * 325, {
--			front = PATH.."normal_want.png",
--			callback = function()
--				HTTP:call("penglai", "rand", {type = kind}, {
--					success_callback = function(data)
--						if i == 1 then
--							self:createHeroFb(data["_G_penglai"]["config"])
--						end
--						local card_popup = KNCardpopup:new(data["awards"]["drop"][1], function()
--						
--						end , {
--							end_x = -80,
--							end_y = -350,
--						})
--						display.getRunningScene():addChild(card_popup:play())
--					end
--				})
--			end
--		})
--		self.mainLayer:addChild(btn:getLayer())
--		
--		local gold = display.newSprite(COMMONPATH.."gold.png")
--		setAnchPos(gold,165, 440 - (i - 1) * 325)
--		self.mainLayer:addChild(gold)
--		
--		gold = createLabel({str = (data[kind]["gold"] == 0 and "免费" or data[kind]["gold"]), x = 200, y = 440 - (i - 1) * 325})
--		self.mainLayer:addChild(gold)
--
--
--	end
	
	--虔诚祈将
	for i = 1, 2 do
		local kind = i == 1 and "xianmuti" or "shenmuti"
		local btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 160, 430 - (i - 1) * 325, {
		front = PATH.."better_want.png",
		callback = function()
			HTTP:call("penglai", "rand", {type = kind }, {
				success_callback = function(data)
					self:createHeroFb(data["_G_penglai"]["config"])
					self:popCardList(data["awards"]["drop"])
				end
			})
			end
		})
		self.mainLayer:addChild(btn:getLayer())
		
		if i == 2 then
			local gold = display.newSprite(COMMONPATH.."gold.png")
			setAnchPos(gold,305, 440 - (i - 1) * 325)
			self.mainLayer:addChild(gold)
			
			gold = createLabel({str = data[kind]["gold"], x = 335, y = 440 - (i - 1) * 325})
			self.mainLayer:addChild(gold)
		else
			local times = createLabel({str = "免费:"..data[kind]["count"].."/"..data[kind]["max"], x = 305, y = 440 - (i - 1) * 325})
			self.mainLayer:addChild(times)
		end

		--if i == 1 and KNGuide:getStep() == 3003 then
		--	KNGuide:show( btn:getLayer() , {remove = true} )
		--end
	end
	
	
	
	self.layer:addChild(self.mainLayer)
	
	self:createInfo(PATH.."hero_title.png",function()
		self:createMain("hero")
	end)
end

--保留原来的抽签功能
function FBLayer:createHeroFb1()
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	self.mainLayer = display.newLayer()
	self.state = HERO

	local mask
	local http_request
	if #DATA_Instance:get("hero", "roll_temp") > 0 then
		mask = KNMask:new({opacity = 0})
		self.mainLayer:addChild(mask:getLayer())
	
		local lots = {}
--		local rotate = {
--			{-18, 130, 270},
--			{-10, 155, 300},
--			{-3,  188,320},
--			{ 3,  227, 325},
--			{ 10, 260, 303},
--			{ 18, 285, 285}
--		}
--		local lotNum = 6
		
		local rotate = {
			{-18, 150, 270},
--			{-10, 155, 300},
			{-3,  168,320},
			{ 3,  247, 325},
--			{ 10, 260, 303},
			{ 18, 265, 285}
		}
		local lotNum = 4
		local index = 2
		for i = 1, lotNum do
			lots[i] = Lot:new(DATA_Instance:get("hero", "roll_temp", i), DATA_Instance:get("hero", "roll_temp", i) == 1,  rotate[1][2],  rotate[1][3], rotate[1][1])
			self.mainLayer:addChild(lots[i]:getLayer())
		end
		
		--抽签面开始动画
		local function startMove(start)
			for i = start, lotNum do
				lots[i]:runAction(getSequenceAction(getSpawnAction(CCMoveTo:create(0.05,ccp(rotate[start][2],rotate[start][3])),
									CCRotateTo:create(0.05,rotate[start][1])),
										CCCallFunc:create(function()
					if start < lotNum and i == lotNum then
						startMove(start + 1)
					elseif start == lotNum then
						-- self.mainLayer:removeChild(mask, true)
						mask:remove()
					end
				end)))	
			end
		end
		
		local success, aniDone 
		--改签动画
		local function change(num)
			for i = lotNum - num, lotNum do
				lots[i]:runAction(getSequenceAction(getSpawnAction(CCMoveTo:create(0.05,ccp(rotate[lotNum - num][2],rotate[lotNum - num][3])),
					CCRotateTo:create(0.05,rotate[lotNum - num][1])),
						CCCallFunc:create(function()
						if i == lotNum then
							if num < lotNum - 1 then
								 change(num + 1)
							else
								if success then
									self:createHeroFb()
								else
									http_request:showLoading()
									aniDone = true
								end
							end
						end
				end)))	
			end
		end
		
		startMove(2)
		
		
		local tempLayer = display.newLayer() 
		
		local random = display.newSprite(PATH.."random.png")
		setAnchPos(random)
		
		tempLayer:setContentSize(random:getContentSize())
		tempLayer:ignoreAnchorPointForPosition(false)
		setAnchPos(tempLayer, 240, 350, 0.5,0.5)
		tempLayer:addChild(random)
		
		local text = display.strokeLabel("当前签面有机率获得"..DATA_Instance:get("hero", "hero_star_range", "min").."-"..DATA_Instance:get("hero", "hero_star_range", "max").."星的英雄", 15, 10, 18, ccc3(0xff, 0xfb, 0xd4), nil, nil, {
			dimensions_width = 160,
			dimensions_height = 60
		})
		tempLayer:addChild(text)
		
	
		
		text = display.strokeLabel("普通改签有几率获得更好签面,住持改签一定会获得上签", 10, 115, 18, ccc3(0xff, 0xfb, 0xd4), nil, nil) 
		self.mainLayer:addChild(text)
		
		--消耗的黄金
		text = display.newSprite(COMMONPATH.."gold.png")
		setAnchPos(text, 70, 193)
		self.mainLayer:addChild(text)
		
		text = display.strokeLabel(DATA_Instance:get("hero", "alter_gold") == 0 and "免费" or DATA_Instance:get("hero", "alter_gold"),100, 195, 18, ccc3(0xff, 0xfb, 0xd4), nil, nil) 
		self.mainLayer:addChild(text)
		
		--用户当前黄金
		text = display.newSprite(COMMONPATH.."gold.png")
		setAnchPos(text, 342, 721)
		self.mainLayer:addChild(text)
		
		text = display.strokeLabel("黄金:        "..DATA_Account:get("gold"),300, 725, 18, ccc3(0xff, 0xfb, 0xd4), nil, nil) 
		self.mainLayer:addChild(text)
		
		local function changeLot(type)
			local value = 0
			for i = 1, lotNum do
				value = value + DATA_Instance:get("hero", "roll_temp", i)
			end
			if value == lotNum then
				KNMsg.getInstance():flashShow("不需要改签")
				return false
			end

			local needGold 
			if type == 1 then
				needGold = DATA_Instance:get("hero", "alter_gold") 
			else
				needGold = DATA_Instance:get("hero", "adv_alter_gold") 
			end
			
			if not countGold(needGold ) then
				return false
			end
			mask  = KNMask:new({opacity = 0})
			self.mainLayer:addChild(mask:getLayer())
			change(0)
			http_request = HTTP:call("insheronewnew", "alter", {type = type}, {
				no_loading = true,					
				error_callback = function()
					KNMsg.getInstance():flashShow("请求失败，请检查网络或重试!~")
					-- self.mainLayer:removeChild(mask, true)
					mask:remove()
				end,
				success_callback = function()
					success = true
					if aniDone then
						self:createHeroFb()
					end
				end})
		end
		
		--改签 的按钮
		local change = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 40, 150, {
			front = PATH.."change_text.png",
			callback = function()
				changeLot(1)
			end
		})
		self.mainLayer:addChild(change:getLayer())
		-- 新手引导
		--if KNGuide:getStep() == 3004 then
		--	KNGuide:show( change:getLayer() )
		--end
		
		--消耗的黄金
		text = display.newSprite(COMMONPATH.."gold.png")
		setAnchPos(text, 340, 193)
		self.mainLayer:addChild(text)
		
		text = display.strokeLabel(DATA_Instance:get("hero", "adv_alter_gold"),370, 195, 18, ccc3(0xff, 0xfb, 0xd4), nil, nil) 
		self.mainLayer:addChild(text)
		
		--住持改签
		change = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 300, 150, {
			front = PATH.."exchange_text.png",
			callback = function()
				changeLot(2)
			end
		})
		self.mainLayer:addChild(change:getLayer())
		
		self.mainLayer:addChild(tempLayer)
		tempLayer:setTouchEnabled(true)			
		tempLayer:registerScriptTouchHandler(function(type,x,y)
			if CCRectMake(240 - random:getContentSize().width / 2, 350 - random:getContentSize().height / 2, random:getContentSize().width, random:getContentSize().height):containsPoint(ccp(x, y)) then
				if type == CCTOUCHBEGAN then
					self.mainLayer:addChild(KNMask:new({opacity = 0}):getLayer())
					local loadAction = 	getSpawnAction(CCRotateTo:create(20,36000),CCScaleTo:create(0.5,1.3))
					tempLayer:runAction(loadAction)
					HTTP:call("insheronewnew", "exchange", {}, {
						no_loading = true,
						error_callback = function()
							self:createHeroFb()
							KNMsg.getInstance():flashShow("网络连接失败,请检查网络或重试")
						end,
						success_callback = function(cid)
							tempLayer:runAction(getSequenceAction(CCDelayTime:create(1),getSpawnAction(CCRotateTo:create(0.5, 1800),CCScaleTo:create(0.5,0)),CCCallFunc:create(function()
								local card_popup = KNCardpopup:new(cid , function()
									self:createHeroFb()
								end , {
									offset_y = -100
								 })
								display.getRunningScene():addChild(card_popup:play())					
							end)))
						end
					})
				end
			end
		end,false,0,false)
		
	else
		local tips = {
			"1、点击抽签可以获得四支签",
			"2、普通改签有很大机率获得更好的签面" , 
			"3、住持改签必出一个上签",
			"4、点击卡牌可兑换英雄",
			"5、四个上签必出一个四星英雄"
		}
		for i = 1, #tips do
			local text = display.strokeLabel(replaceStr(tips[i]), 100, 750	 - i * 25, 18, ccc3(0xff, 0xfb, 0xd4), nil, nil, {
			})
			self.mainLayer:addChild(text)
		end
		
		local lotPot = display.newSprite(PATH.."lot_pot.png")
		setAnchPos(lotPot, 240,350, 0.5, 0.3)
		self.mainLayer:addChild(lotPot)
		
		local count= 0
		local function lotFunc(time)
--			audio.playSound(IMG_PATH .. "sound/draw_lots.mp3")
			
			local action = 	getSequenceAction(CCRotateTo:create(time,20),CCRotateTo:create(time,0),CCRotateTo:create(time, -20),CCRotateTo:create(time,0),CCCallFunc:create(function()
				count = count + 1
				if count < 7 then
					lotPot:runAction(lotFunc(time))
				else
					lotPot:runAction(getSequenceAction(CCFadeOut:create(0.5), CCCallFunc:create(function()
						self:createHeroFb()
					end)))
				end
			end))
			return action
		end
		
		local text = display.strokeLabel("抽签次数:"..DATA_Instance:get("hero", "free_roll_times").."/"..DATA_Instance:get("hero","max_roll_times"), 180, 125, 20, ccc3(0xff, 0xfb, 0xd4))
		self.mainLayer:addChild(text)
		
		
		local start = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 160, {
			front = PATH.."draw_text.png",
			callback = function()
				if DATA_Instance:get("hero", "free_roll_times") > 0 then
					if isBagFull() then
						return false
					end
					mask = KNMask:new({opacity = 0})
					self.mainLayer:addChild(mask:getLayer())
					lotPot:runAction(lotFunc(0.1))
					
					HTTP:call("insheronewnew", "draw", {}, {
						no_loading = true,
						error_callback = function()
							KNMsg.getInstance():flashShow("请求失败，请检查网络或重试!~")
							-- self.mainLayer:removeChild(mask, true)
							mask:remove()
						end,
						success_callback = function()
--							lotPot:runAction(lotFunc(0.1))
						end
					})
				else
					KNMsg.getInstance():flashShow("今日抽签次数已用完，请明天再来吧！~")
				end
			end
		})
		self.mainLayer:addChild(start:getLayer())

		-- 新手引导
		--[[
		if KNGuide:getStep() == 3003 then
			KNGuide:show( start:getLayer() )
		end
		]]
	end
	
	self.layer:addChild(self.mainLayer)
	
	self:createInfo(PATH.."hero_title.png",function()
		self:createMain("hero")
	end)
	
end

function FBLayer:createRoleFb(kind)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	self.mainLayer = display.newLayer()
	
	local space
	if kind == "hero" then
		self.state = HERO
		space = 1.25
	else
		self.state = PET
		space = 1.5
	end
	
	local bg = display.newSprite(COMMONPATH.."bg_small.png")
	setAnchPos(bg, 240, 110, 0.5)
	self.mainLayer:addChild(bg)
	
	 bg = display.newSprite(PATH..kind.."_bg.png")
	setAnchPos(bg, 240, 150, 0.5)
	self.mainLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."gift_bg.png")
	setAnchPos(bg, 245, 620, 0.5)
	self.mainLayer:addChild(bg)
	
	local title = display.newSprite(PATH.."rest_time.png")
	setAnchPos(title,50,590)
	self.mainLayer:addChild(title)
	
	title = display.strokeLabel(DATA_Instance:get(kind,"point"), 130, 590, 20, ccc3(0xff, 0xfb, 0xd4))
	self.mainLayer:addChild(title)
	
	title = display.newSprite(PATH.."gift_text.png")
	setAnchPos(title, 130, 680)
	self.mainLayer:addChild(title)
	
	title = display.strokeLabel(getConfig("prop", DATA_Instance:get(kind,"current_award"),"name"),130, 650, 18)
	self.mainLayer:addChild(title)
	
	local refresh = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"},350, 650, {
		scale = true,
		front = COMMONPATH.."refresh_small.png",
		callback = function()
			HTTP:call("ins"..kind,"refresh",{},{
				success_callback = function()
					self:createRoleFb(kind)
					KNMsg.getInstance():flashShow("恭喜你刷到"..getConfig("prop",DATA_Instance:get(kind,"current_award"),"name"))
				end
			})
		end
		
	})
	self.mainLayer:addChild(refresh:getLayer())
	
	local gift = KNBtn:new(SCENECOMMON,{"skill_frame1.png"}, 50, 640, {
		scale = true,
		front = IMG_PATH.."image/"..getCidType(DATA_Instance:get(kind,"current_award")).."/s_"..DATA_Instance:get(kind,"current_award")..".png"
	})
	self.mainLayer:addChild(gift:getLayer())
	
	
	local x, y, t = 50, 490, DATA_Instance:get(kind, "inscount")
	local pass = DATA_Instance:get(kind,"pass")
	for i = 1,t do
		local bgStr = kind.."_disable.png"	
		for k, v in pairs(pass) do
			if v == i then
				bgStr = kind.."_enable.png"
				break
			end			
		end
		
		local btn = KNBtn:new(PATH,{bgStr}, x, y, {
			id = i,
			scale = true,
			callback = function()
				SOCKET:getInstance("battle"):call("ins"..kind , "execute" , "execute",{ins_id = i})
			end
		})
		self.mainLayer:addChild(btn:getLayer())
		x = x + btn:getWidth() * space 
		if i % 3 == 0 then
			x = 50
			y = y - btn:getHeight() * 1.15
		end
	end
	
	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH..kind.."_title.png",function()
		self:createMain(kind)
	end)
end

function FBLayer:createTip(map, ins, func, open)
	map = tonumber(map)
	ins = tonumber(ins)

	
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer})
	
	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	layer:addChild(bg)
	
	local isBox = ins % 4 == 0
	local front 
	if isBox then
		if DATA_Instance:get("equip", "max", "map_id") == map and DATA_Instance:get("equip", "max", "ins_id") == ins then
			front = PATH.."open.png" 	
			bg = {"btn_bg_red.png", "btn_bg_red_pre.png"}
		else
			front = PATH..(open and "opened.png" or "open_grey.png") 	
			bg = {"btn_bg_red2.png"}
			open = false
		end
	else
		front = PATH..(open and "challenge.png" or "challenge_grey.png")	
		bg = {"btn_bg_red.png" , "btn_bg_red_pre.png"}
		if not open then
			bg = {"btn_bg_red2.png"}
		end
	end
	
	
	local okBtn = KNBtn:new(COMMONPATH, bg, 70, 310, {
		priority = -131,
		front = front,
		-- noTouch = not open,
		callback = function() 
			if open then
				if isBagFull() then
					return false
				end
				func(function()
					-- self.layer:removeChild(mask, true)
					mask:remove()
				end)
			else
				if isBox then
					if map < DATA_Instance:get("equip", "max", "map_id") or ins < DATA_Instance:get("equip", "max", "ins_id") then
						KNMsg.getInstance():flashShow("宝箱已打开！~")
					else
						KNMsg.getInstance():flashShow("饭要一口一口吃，塔要一层一层爬，少年")
					end
				else
					KNMsg.getInstance():flashShow("饭要一口一口吃，塔要一层一层爬，少年")
				end
			end
		end
	})
	layer:addChild(okBtn:getLayer())
	if isBox or ins==25 then
		okBtn:setPosition(160,310)
	end

	--扫荡
	local saoDangBg 

	if map >= tonumber(DATA_Instance:get("equip", "max", "map_id")) and ins>= tonumber(DATA_Instance:get("equip", "max", "ins_id")) then
		saoDangBg={"btn_bg_red2.png"}
	else
		saoDangBg= {"btn_bg_red.png", "btn_bg_red_pre.png"}
	end
	if not isBox and ins~=25 then
		local saoDangBtn
		 saoDangBtn =KNBtn:new(COMMONPATH, saoDangBg, 250, 310, {
			priority = -131,
			front = PATH.."wipe.png",
			callback = function ( )
				if isBagFull() then
					return false
				end
				if map >= tonumber(DATA_Instance:get("equip", "max", "map_id")) and ins >= tonumber(DATA_Instance:get("equip", "max", "ins_id")) then
					KNMsg.getInstance():flashShow("当前未挑战过，不能扫荡")	
				elseif DATA_Vip:get( "viplv" )<1 then
					KNMsg.getInstance():flashShow("vip玩家才可以使用")	
				elseif DATA_Instance:get("equip", map, ins, "count")==DATA_Instance:get("equip", map, ins, "max") then
					KNMsg.getInstance():flashShow("可挑战次数已达上限")	
				else--去扫荡		
					

					HTTP:call("insequip", "cleanup", { map_id=map , ins_id=ins }, {success_callback = 
						function(data)
							
							--dump(DATA_Instance:get("equip"))
							DATA_Result:set( data )
							DATA_Instance:set("equip",data["get"]["current_map"],data["get"]["instance"])
							DATA_Instance:set("equip","max",data["get"]["max"])
							DATA_Instance:set("equip","current",data["get"]["current"])
							DATA_Instance:set("equip","point",data["get"]["point"])
							local function callBackFun()
								HTTP:call("insequip" , "get",{},{success_callback = function(data)
									--dump(data)
		  							switchScene("fb" , { state = "equip" , map = map } )
		  						end })
							end

							local tableData = { type = "mopUp" , backFun =callBackFun }
							
							local resultLayer = requires(IMG_PATH,"GameLuaScript/Scene/battle/resultLayer")
							local scene = display.getRunningScene()
							scene:addChild( resultLayer:create( tableData ) )

							saoDangBtn:getLayer():removeFromParentAndCleanup(true)
							okBtn:getLayer():removeFromParentAndCleanup(true)
					end})
					
				

				end
				
			end})

		layer:addChild(saoDangBtn:getLayer())
	end


	-- 新手引导
	if KNGuide:getStep() == 804 then
		KNGuide:show( okBtn:getLayer() )
	end

	
	local cancelBtn = KNBtn:new(COMMONPATH, {"back_img.png", "back_img_press.png"}, 270-240, 310+207, {
		priority = -131,
		callback = function()
			-- self.layer:removeChild(mask, true)			
			mask:remove()
		end
	})
	cancelBtn:getLayer():setScale(0.7)
	layer:addChild(cancelBtn:getLayer())
	
	local text

	
	if isBox then
	
		text = display.newSprite(PATH.."gift_bg.png")
		setAnchPos(text, 30, 400)
		layer:addChild(text)
	
		text = display.newSprite(PATH.."box_gifts.png")
		setAnchPos(text, 70, 480)
		layer:addChild(text)
		
		for i = 1, #DATA_Instance:get("equip", map, ins, "box") do
			local temp = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 110 + (i - 1) * 90, 415, {
				front = getImageByType(DATA_Instance:get("equip", map, ins, "box", i),"s"),
				text = {getConfig(getCidType(DATA_Instance:get("equip", map, ins, "box", i)), DATA_Instance:get("equip", map, ins, "box", i), "name"), 20, ccc3(0x2c, 0, 0), ccp(0, -50)},
				other = {COMMONPATH.."star_border/border_"..getConfig("equip", DATA_Instance:get("equip", map, ins, "box", i), "star")..".png", -15, -16},
			})
			layer:addChild(temp:getLayer())
		end
	
	else
		text = display.newSprite(PATH.."challenge_num.png")
		setAnchPos(text, 70, 500)
		layer:addChild(text)
		
		text = display.strokeLabel(DATA_Instance:get("equip", map, ins, "count").."/"..DATA_Instance:get("equip", map, ins, "max"), 170, 500, 20)
		layer:addChild(text)
		
		text = display.newSprite(PATH.."use.png")	
		setAnchPos(text, 270, 500)
		layer:addChild(text)
		
		text = display.strokeLabel("体力 x1", 325, 502, 20)
		layer:addChild(text)
		
--		text = display.strokeLabel("挑战书 x1", 325, 475, 20)
--		layer:addChild(text)
		
			
		text = display.newSprite(PATH.."gift_bg.png")
		setAnchPos(text, 30, 370)
		layer:addChild(text)
		
		text = display.newSprite(PATH.."gifts.png")
		setAnchPos(text, 70, 450)
		layer:addChild(text)
	
	
		text = display.strokeLabel(DATA_Instance:get("equip", map, ins, "star").."星级的"..Property[DATA_Instance:get("equip", map, ins, "type")], 170, 410, 20, ccc3(0x2c, 0, 0))
		layer:addChild(text)
	end		

	self.layer:addChild(mask:getLayer())
end

function FBLayer:getLayer()
	return self.layer
end

function FBLayer:createInfo(title, func)
	if self.info then
		self.layer:removeChild(self.info:getLayer(), true)
	end
	self.info = InfoLayer:new("fb", 0, {tail_hide = true, title_text = title, closeCallback = func})
	self.layer:addChild(self.info:getLayer(),10)
	
end

function FBLayer:createRobFb(data, star)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	local rob = RobLayer:new({data = data, star = star})
	
	self.mainLayer = rob:getLayer()
	self.layer:addChild(self.mainLayer)
	
	self:createInfo(PATH.."rob_title.png",function()
		if rob:getState() == 1 then
			self:createMain("rob")
		else
			self:createRobFb(data, rob:getStar())	
		end
	end)
end

function FBLayer:stopTimer(index)
	if index then
		if Clock:getKeyIsExist("inspet_clock"..index) then
			Clock:removeTimeFun("inspet_clock"..index)
		end
	else
		Clock:removeTimeFun("inspet_clock1")
		Clock:removeTimeFun("inspet_clock2")
		Clock:removeTimeFun("inspet_clock3")
	end
end

function FBLayer:createDig(map)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	local layer = display.newLayer()
	self.mainLayer = KNMask:new({item = layer}):getLayer()
	
	local bg = display.newSprite(IMG_PATH.."image/scene/battle/battle_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	layer:addChild(bg)
	
	bg = display.newSprite(IMG_PATH.."image/scene/battle/bg_bottom.png")
	setAnchPos(bg, 240, 0, 0.5)
	layer:addChild(bg)
	
	bg = display.newSprite(IMG_PATH.."image/scene/battle/bg_bottom.png")
	bg:setFlipY(true)
	bg:setFlipX(true)
	setAnchPos(bg, 240, 854, 0.5, 1)
	layer:addChild(bg)
	
	HTTP:call("message", "get_wajue", {}, {
		success_callback = function(data)
			layer:addChild(createLabel({str = formatMsg(data["template"], data["msg"]), width = 290, x = 180, y = 130, size = 16, color = ccc3(255, 255,255)}))
		end
	})
	
	local back = KNBtn:new(IMG_PATH.."image/scene/login/", {"back.png", "back_pre.png"}, 30, 200, {
		priority = -131,
		callback = function()
			self:createEquipFb(map)
		end
	})
	layer:addChild(back:getLayer())
	
	local dig = KNBtn:new(PATH, {"dig_btn.png"}, 240, 310, {
		priority = -131,
		anchMid = true,
		scale = true,
		callback = function()
			HTTP:call("insequip", "dig", {map_id = map}, {
				success_callback = function(data)
					if data["silver"] then
						KNMsg.getInstance():flashShow("恭幸喜您挖到了"..data["silver"].."银币！~")
						self:createDig(map)
					else
						local card_popup = KNCardpopup:new(data["drop"][1] , function()
							self:createDig(map)
						end , {})
						display.getRunningScene():addChild(card_popup:play())					
					end
				end
			})
		end
	})
	layer:addChild(dig:getLayer())
	
	local arrow = display.newSprite(PATH.."arrow.png")
	setAnchPos(arrow, 240, 350, 0.5)
	
	local function jump()
		local action = getSequenceAction(CCJumpTo:create(1,  ccp(240,350), 30, 1), CCCallFunc:create(function()
			arrow:runAction(jump())
		end))
		return action
	end
	
	arrow:runAction(jump())
	layer:addChild(arrow)
	
	
	local x = 50
	for k, v in pairs(DATA_Instance:get("equip",map,25,"bossbox")) do
		local front = getImageByType(v, "s")
		local text = {getConfig(getCidType(v), v, "name"), 14, ccc3(0x5c,0x0c,0x0c), ccp(0,-70)}
		local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, x, 570,{
			other = {COMMONPATH.."star_border/border_"..getConfig("equip", v, "star")..".png", -15, -16},		
			front = front,
			text = text
		} )
		self.mainLayer:addChild(btn:getLayer())
		
--			star = display.newSprite(COMMONPATH.."star.png")
--			setAnchPos(star, x + (i - 1) * 20, 520)
--			self.mainLayer:addChild(star)
--		end 
		
		local star
		for i = 1, getConfig(getCidType(v), v, "star") do
			star = display.newSprite(COMMONPATH .. "star.png")
			setAnchPos(star, star:getContentSize().width * (i - 1) + (x + btn:getWidth() / 2) - (star:getContentSize().width * getConfig(getCidType(v), v, "star")) / 2, 540 )
			self.mainLayer:addChild(star)
		end
--			
		x = x + 110
	end
	
	local text = display.strokeLabel("点击墓碑进行挖掘，稀世装备等你来拿！", 100, 645, 16, ccc3(0x5c, 0x0c, 0x0c) )
	layer:addChild(text)
	
	local useGold = display.newSprite(PATH.."use.png")
	setAnchPos(useGold,120,190)
	layer:addChild(useGold)
	
	useGold = display.newSprite(COMMONPATH.."gold.png")
	setAnchPos(useGold, 170, 190)
	layer:addChild(useGold)
	
	useGold = display.strokeLabel(DATA_Instance:get("equip", "dig_fee"), 205, 192, 18, ccc3(0x5c, 0x0c, 0x0c))
	layer:addChild(useGold)
	
	local times = display.newSprite(PATH.."times.png")
	setAnchPos(times,260,190)
	layer:addChild(times)
	
	times = display.strokeLabel(DATA_Instance:get("equip", map, 25, "cur_dig_times").."/"..DATA_Instance:get("equip", map, 25, "max_dig_times"), 315, 192, 18, ccc3(0x5c, 0x0c, 0x0c))
	layer:addChild(times)
	
	self.layer:addChild(self.mainLayer, 10)
end

function FBLayer:popCardList(data, new, share)
	
	local index = 1
	local function pop(index)
		local card_popup = KNCardpopup:new(data[index] , function()
				if index == table.nums(data) then
					self:createHeroFb(new)
					if share == 1 then
						local cid
						for k, v in pairs(data) do
							if getConfig("general", v.."", "star") == 4 then
								cid = v	
								break
							end
						end
						--分享游戏到微博
						shareGame({type = "hero", heroId = cid, heroName = getConfig("general", cid.."", "name")})
					end
				else
					pop(index + 1)
				end
			end , {
				end_x = -80,
				end_y = -350,
			})
		display.getRunningScene():addChild(card_popup:play())						
	end
	pop(index)
end
--祈将弹出的列表
function FBLayer:popCardList1(data)
	if self.mask then
		self.layer:removeChild(self.mask:getLayer(), true)
	end
	
	local layer = display.newLayer()
	local bg = display.newSprite(PATH.."pop_bg.png")
	setAnchPos(bg, 240, 435, 0.5, 0.5)
	layer:addChild(bg)
	
	local btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 305, {
		front = COMMONPATH.."ok.png",
		priority = -131,
		callback = function()
			self.layer:removeChild(self.mask:getLayer(), true)
		end
	})
	layer:addChild(btn:getLayer())
	
	local num = display.newSprite(PATH.."hero_nums.png")
	setAnchPos(num, 20, 310)
	layer:addChild(num)
	
	local n = table.nums(data)
	num = createLabel({str = n, x = 120, y = 310, color =ccc3(255,255,255)})
	layer:addChild(num)
	
	local scroll = KNScrollView:new(22, 330, 435, 250,2,true, 0, {priority = -132})
	layer:addChild(scroll:getLayer())
	
	for i = n, 1, -1 do
		local layer = display.newLayer()
--		local cardBg = display.newSprite(IMG_PATH.."image/scene/uplevel/card_bg.png")
--		layer:setContentSize(cardBg:getContentSize())
		layer:ignoreAnchorPointForPosition(false)
--		
--		setAnchPos(cardBg)
--		layer:addChild(cardBg)
--		
--		scroll:addChild(layer)
		local heroInfo = getConfig("general", data[i])
		heroInfo["cid"] = data[i]
		local card = KNBtn:new(IMG_PATH.."image/scene/uplevel/", {"card_bg.png"}, 0, 0, {
			front = getImageByType(data[i], "b"),
			frontScale = {0.6, 0,10},
			priority = -131,
			parent = scroll,
			other = {PATH.."name_bg.png", 20, 20},
			text = {getConfig("general", data[i], "name"), 18, ccc3(0x2c, 0, 0), ccp(0,-82)},
			callback = function()
				pushScene("detail" , {
						detail = "general",
						data = heroInfo
						})
			end
		})
		layer:setContentSize(CCSizeMake(card:getWidth(), card:getHeight()))
		layer:addChild(card:getLayer())
		
		local star
		for j = 1, getConfig("general", data[i], "star") do
			star = display.newSprite(COMMONPATH .. "star.png")
			setAnchPos(star, (card:getWidth() / 2 - (getConfig("general", data[i], "star") * star:getContentSize().width) / 2) + star:getContentSize().width * (j - 1), 190)
			
			layer:addChild(star)
		end
		scroll:addChild(layer)
	end
	scroll:alignCenter()
	
	self.mask = KNMask:new({item = layer})
	self.layer:addChild(self.mask:getLayer())
	
end


return FBLayer
