local PATH = IMG_PATH.."image/scene/forge/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local GOLDEQUIPPATH = IMG_PATH .. "image/scene/goldequip/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNComboBox = requires(IMG_PATH,"GameLuaScript/Common/KNComboBox")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local Progress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local ListItem = requires(IMG_PATH, "GameLuaScript/Scene/common/listitem")
local KNCardpopup = requires(IMG_PATH,"GameLuaScript/Common/KNCardpopup")
local CombineCfg = requires(IMG_PATH, "GameLuaScript/Config/Natural")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local needConfig = requires(IMG_PATH, "GameLuaScript/Config/evolvepool")
local hcskill = requires(IMG_PATH, "GameLuaScript/Config/hcskill")
local equipcompound = requires(IMG_PATH, "GameLuaScript/Config/equipcompound")
local PoolLayer = {
	layer,
	contentLayer,
	params,
	curType,
	curStar,
	curItem,
	tempLayer,
	empty,
	scroll,
	vipHeroText
}

function PoolLayer:new(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.layer = display.newLayer()
	this.params = params or {}
	this.curItem = {}
		
	local title = display.newSprite(COMMONPATH.."title_bg.png")
	setAnchPos(title, 0, 854 - title:getContentSize().height)
	this.layer:addChild(title) 
	
	title = display.newSprite(COMMONPATH.."title_tail.png")
	setAnchPos(title, 0, 854 - title:getContentSize().height * 2)
	this.layer:addChild(title) 
	
	title = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(title, 240, 425, 0.5, 0.5)
	this.layer:addChild(title, -1)
		
	title = display.newSprite(PATH.."pool_text.png")
	setAnchPos(title, 245, 765, 0.5)
	this.layer:addChild(title)

	title = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(title, 240, 690, 0.5)
	this.layer:addChild(title)
	
	local kinds = {
		"general",
		"pet",
		--"skill",
		"equip",
	}
	
	local group = KNRadioGroup:new()
	for i = 1, #kinds do
		local btn = KNBtn:new(COMMONPATH.."tab/", {"tab_star_normal.png","tab_star_select.png"},30 + (i - 1) * 90 , 695, {
			front =  {COMMONPATH.."tab/".."tab_"..kinds[i].."_big_normal.png",COMMONPATH.."tab/".."tab_"..kinds[i].."_big_select.png"},
			callback = function()
				if kinds[i] == "skill" then
					if DATA_User:get("lv") >= 30 then
						this:createContent(kinds[i])
					else
						KNMsg.getInstance():flashShow("开放该功能需主角等级达到30级!")
						return false
					end
				elseif kinds[i] == "equip" then
					this:equipContent()
				else
					 this:createContent(kinds[i])
				end
				
			end
		}, group)
		this.layer:addChild(btn:getLayer(), -1)
	end

	if params and params.flag == nil then
		group:chooseByIndex(1, true)
	elseif params and params.flag ~= nil then
		group:chooseByIndex(3, true)
		this:equipContent(params)
	else
		group:chooseByIndex(1, true)
	end

	return this
end

function PoolLayer:createContent(kind)
	if self.contentLayer then
		self.layer:removeChild(self.contentLayer, true)	
	end
	self.contentLayer = display.newLayer()
	self.curType = kind
	
	local bg = display.newSprite(PATH.."star_bg.png")
	setAnchPos(bg, 240, 620, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."pool_tool.png")
	setAnchPos(bg, 240, 200, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH..kind.."_pool_tip.png")
	setAnchPos(bg, 240, 580, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."add.png")
	setAnchPos(bg, 240, 490, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."arrow.png")
	setAnchPos(bg, 240, 370, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."use.png")
	setAnchPos(bg, 310, 381)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."has.png")
	setAnchPos(bg, 310, 215)
	self.contentLayer:addChild(bg)
	
	repeat
		local str

		if kind == "general" then
			str = "英雄"
		elseif kind == "pet" then
			str = "幻兽"
		else
			break
		end

		self.contentLayer:addChild(display.strokeLabel(replaceStr(str.."进化符用于同星级"..str.."的进化"), 80, 110, 20 ,ccc3(255,255,255)))
	until true

	local checkChipNums = function(cidOfMap)
		local cid = cidOfMap
		local require_chip = hcskill[ tonumber(cid) .."" ].chip
		local require_num = hcskill[ tonumber(cid) ..""].num
		
		local chip_items = DATA_Bag:getTable( "prop", { cid = tostring( require_chip ) } )

		--检查技能碎片数量
		local chip_nums = 0
		self.curItem[2] = nil
		for k, v in pairs(chip_items) do
			chip_nums = chip_nums + v.num
			if self.curItem[2] == nil then
				self.curItem[2] = v.id
			end
		end
		
		if chip_nums < require_num then
			self.curItem[2] = nil
		end

		self.curItem["chip_num_owned"] = chip_nums
		self.curItem["chip_num_required"] = require_num
	end

	local popTips = function()
		local str
		if kind == "general" or kind == "pet" then
			if self.curStar == 3 then
				str = "初级符文丹不足，可以通过挑战9-7关卡获得。"
			elseif self.curStar == 4 then
				str = "中级符文丹不足，可以通过挑战10-5关卡获得。"
			else
				str = "高级符文丹不足，可以通过挑战10-14关卡获得。"
			end
		elseif kind == "skill" then
			str = "技能碎片不足, 可前去完成任务获得技能碎片"
		end

		KNMsg.getInstance():flashShow(replaceStr(str))
	end
	
	local itemsLayer 
	local function chooseItems()	
		if itemsLayer then
			self.contentLayer:removeChild(itemsLayer, true)
		end
		itemsLayer = display.newLayer()
		local pos = {
			{91, 465, {replaceStr( kind == "general" and "英雄" or ( kind == "pet" and "幻兽" or "技能\n图纸" ) ), 20, ccc3(0x2c, 0, 0), ccp(0,0)}, kind == "skill" and "prop" or kind},
			{322, 465, {kind == "skill" and "技能\n碎片" or "道具", 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "prop"},
			{210, 255, {""}, "prop"}
		}	
		local front, text
		for i = 1, #pos do
			if self.curItem[i] then  --已选择了元素
				local category = (kind == "skill" and i == 3) and "skill" or pos[i][4]
				front = getImageByType(DATA_Bag:get(category, self.curItem[i], "cid"), "s")		
				text = {getConfig(category, DATA_Bag:get(category, self.curItem[i], "cid"), "name")..(DATA_Bag:get(category,self.curItem[i],"lv") and " Lv"..DATA_Bag:get(category,self.curItem[i],"lv") or ""), 14, ccc3(255,255,255), ccp(0, -70)}
				
				--显示消耗符的数量
				if i == 1 and kind == "skill" then
					itemsLayer:addChild(createLabel( { x = 360, y = 382, str = self.curItem["chip_num_required"] .. "/" .. self.curItem["chip_num_owned"], color = ccc3(255,255,255) } ))

				elseif i == 2 and (kind == "general" or kind == "pet") then
					local require_num = needConfig[self.curType][self.curStar]["num"]
					itemsLayer:addChild(createLabel({x = 360, y = 382, str = require_num, color = ccc3(255,255,255)}))
				elseif i == 3 then
					if kind == "skill" then
						local cid = DATA_Bag:get("skill", self.curItem[3], "cid")
						--print(type(cid))

						local skill_items = DATA_Bag:getTable( "skill", { cid = cid } )
						local skill_nums = table.nums(skill_items)

						--dump(skill_items)

						itemsLayer:addChild(createLabel({x = 360, y = 215, str = tostring(skill_nums), color = ccc3(255,255,255)}))

					else
						itemsLayer:addChild(createLabel({x = 360, y = 215, str = DATA_Bag:countItems("prop", false, { type = (kind == "general" and "hero" or "pet") .."jinhuafu", star = self.curStar }), color = ccc3(255,255,255)}))
					end
				end
			else
				text = pos[i][3]
				front = nil
			end
			
			local filter = {}
			filter.star = self.curStar
			if kind == "skill" and i == 1 then
				filter.type = "skillmap"
			elseif kind == "skill" and i == 2 then
				filter.type = "skillchip"
			elseif pos[i][4] == "prop" then
				filter.type = "fuwendan"
			else
				filter.type = nil
			end

			if kind == "general" and i == 1 then 
				filter.exceptZhenfa = true
			end

			local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, pos[i][1], pos[i][2], {
				front = front,
				text = text,
				callback = function()
					if i < 3 then
						if i == 2 then
							if self.curItem[1] 	then
								if not self.curItem[2] then popTips() end
							else
								KNMsg.getInstance():flashShow("请先选择需要消耗的"..( self.curType == "pet" and "幻兽卡牌" or ( self.curType == "general" and "英雄卡牌" or "技能图纸" ) ) )
							end
							return
						end
						
						local list
						list = SelectList:new(pos[i][4], self.contentLayer,display.newSprite(COMMONPATH .. "title/"..(pos[i][4] == "general" and "hero" or pos[i][4]).."_text.png") , {
							btn_opt = "ok.png",
							target = true,
							filter = filter,
							showTitle = true , 
							exceptUse = true,
							optCallback = function()
								list:destroy()
								if i == 1 then
									self.curItem[3] = nil
									self.curItem[i] = list:getCurItem():getId()

									if kind == "general" or kind == "pet" then
										for k, v in pairs(DATA_Bag:getTable("prop", {type = "fuwendan", star = self.curStar})) do
											self.curItem[2] = k
										end

										if tonumber(DATA_Bag:get("prop", self.curItem[2], "num")) < needConfig[self.curType][self.curStar]['num'] then
	--										KNMsg.getInstance():flashShow("所需要的符文丹不足，无法融合")
	--										self.curItem = {}
	--										return 
											self.curItem[2] = nil
										end
									elseif kind == "skill" then
										local cid = DATA_Bag:get("prop", self.curItem[i] .. "", "cid")
										checkChipNums(cid)
									end
									
								elseif i == 2 then
									self.curItem[i] = list:getCurItem():getId() 
								end
								chooseItems()
							end
						})
						self.layer:addChild(list:getLayer())	
					else
						if self.curItem[3] then
							pushScene("detail" , {
									detail = kind == "skill" and "skill" or "prop",
									id = self.curItem[3],
									propOpt = function()
										if DATA_General:haveGet() then
											DATA_Formation:set_index(1)
											switchScene("hero",{gid = DATA_Formation:getCur()})
										else
											HTTP:call("general" , "get",{},{success_callback =
												function()
													DATA_General:haveGet(true)
													DATA_Formation:set_index(1)
													switchScene("hero",{gid = DATA_Formation:getCur() })
												end
											})
										end
									end
								})
						end
					end
				end
			})
			itemsLayer:addChild(btn:getLayer())
			
			if self.curItem[i] then
				local star
				local category = (kind == "skill" and i == 3) and "skill" or pos[i][4]
				local starNum = getConfig(category, DATA_Bag:get(category, self.curItem[i], "cid"), "star") 
				for j = 1, starNum do
					star = display.newSprite(COMMONPATH .. "star.png")
					star:setScale(0.8)
					setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (pos[i][1] + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, pos[i][2] - star:getContentSize().height - 3 )
					itemsLayer:addChild(star)
				end
			end
		end
		self.contentLayer:addChild(itemsLayer)
	end
	
	--进化符炼制星级选择
	local star_config = { general = {start = 3, num = 3},
						  pet = {start = 3, num = 3},
						  skill = {start = 4, num = 2} }
	local group = KNRadioGroup:new()
	if kind ~= "equip" then
		local start_star = star_config[kind].start

		for i = 1, star_config[kind].num do
			local cur_star = start_star + i - 1
			local starChoose = KNBtn:new(COMMONPATH, {"btn_bg_dis.png", "btn_bg.png"}, 60 + (i - 1) * 140, 630, {
				front = PATH .. cur_star .. "_star.png",
				upSelect = true,
				callback = function()
					self.curStar = cur_star
					self.curItem = {}
					chooseItems()
				end
			}, group)
			self.contentLayer:addChild(starChoose:getLayer())	
		end
		group:chooseByIndex(1, true)
	end
	
	
	
	local auto = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 65, 365, {
		front = PATH.."auto_add.png" ,
		callback = function()
			if kind == "general" or kind == "pet" then
					local items = DATA_Bag:getTable(self.curType, {star = self.curStar , exceptZhenfa = (kind == "general")}, nil, true)
					local keyList = getSortList(items, function(l,r)
						return DATA_Bag:get(kind, l, "lv") < DATA_Bag:get(kind, r, "lv")
					end)
					if table.nums(items) > 0 then
						--取一个英雄 数据，后面要调 
						for k, v in pairs(keyList) do
							self.curItem[1] = v
							break
						end
						
						--检查符文丹数量
						for k, v in pairs(DATA_Bag:getTable("prop", {type = "fuwendan", star = self.curStar})) do
							self.curItem[2] = k
						end
									
						if tonumber(DATA_Bag:get("prop", self.curItem[2], "num")) < needConfig[self.curType][self.curStar]['num'] then
		--					KNMsg.getInstance():flashShow("所需要的符文丹不足，无法融合")
		--					self.curItem = {}
		--					return 
							self.curItem[2] = nil
						end
						self.curItem[3] = nil
						chooseItems()
					else
						KNMsg.getInstance():flashShow("没有能炼化的材料卡牌")				
					end
			elseif kind == "skill" then
				local map_items = DATA_Bag:getTable("prop", {type = "skillmap", star = self.curStar}, nil, true)
				if table.nums(map_items) > 0 then
					--取一个技能图纸数据，稍后使用
					local first_map
					for k, v in pairs(map_items) do
						first_map = v
						break
					end

					self.curItem[1] = first_map.id

					checkChipNums(first_map.cid)

					self.curItem[3] = nil
					chooseItems()
				else
					KNMsg.getInstance():flashShow("没有能炼化的技能图纸")				
				end
			end
		end
	})
	self.contentLayer:addChild(auto:getLayer())

	local startBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 140, {
		front = PATH .. (kind == "skill" and "make.png" or "start.png"),
		callback = function()
			if isBagFull() then
			    return false
			end
			if self.curItem[1] then
				if self.curItem[2] then
					local action, params
					
					local function start()
						HTTP:call("evolvepool", action, params, {
							success_callback = function(id, cid)
								self.curItem = {}
								self.curItem[3] = id
								local card_popup = KNCardpopup:new(cid,function()
									chooseItems()
								end ,
								 {	
									init_x =  0,
									init_y = -150,
									end_x =  0,
									end_y =  -150,})
								display.getRunningScene():addChild(card_popup:play())
							end
						})	
					end
					
					if kind == "skill" then
						action = "merge_skill"
						params = {skillmap_id = self.curItem[1], patch_id = self.curItem[2]}
					elseif kind == "general" or kind == "pet" then
						action = "merge"
						params = {type = self.curType, id = self.curItem[1] }
						if DATA_Bag:get(kind, self.curItem[1], "lv") > 1 then
							KNMsg.getInstance():boxShow("该"..(kind == "pet" and "幻兽" or "英雄").."中有经验值，是否用于制符？",{confirmFun = function()
								start()
							end, cancelFun = function()end})
							return 
						end
					end
					start()
				else
					popTips()
				end
			else
				KNMsg.getInstance():flashShow("请先选择进化材料!~")
			end
		end
	})
	self.contentLayer:addChild(startBtn:getLayer())


	-- 新手引导
	if KNGuide:getStep() == 3403 then
		KNGuide:show( auto:getLayer() , {
			callback = function()
				KNGuide:show( startBtn:getLayer() , {remove = true})
			end
		})
	end
	
	
	
	self.layer:addChild(self.contentLayer)
end

--金装合成帮助界面
function PoolLayer:goldEquipHelp(params)
	local goldEquipHelpLayer , tempLayer

	--根据不同金装来显示不同金装的帮助界面
	local function goldEquipType(kind)
		local composeLayer
		--金装不同部位的界面
		local function getComposeLayer(params , stype)
			 if composeLayer then
			 	tempLayer:removeChild(composeLayer, true)
			 end
			composeLayer = display.newLayer()

			local fiveStarSuit_btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 88, 425, {
				-- front = getImageByType( params["basics"], 's' ),
				text = {"任意五星"..stype.. "可\n作为祭品装备" , 14, ccc3(255,255,255), ccp(0, -60)},
				disable = true,
				callback = function()

				end
			})
			composeLayer:addChild( createLabel({ x = 100 , y = 435 , str = "五星\n"..stype , color = ccc3(41,13,1) }) , 4)
			composeLayer:addChild( fiveStarSuit_btn:getLayer() )
			local fiveStar_btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 328, 425, {
				front = getImageByType( params["basics"], 's' ),				
				text = {getConfig("equip" , params["basics"], "name") , 14, ccc3(255,255,255), ccp(0, -73)},
				disable = true,
				other = { COMMONPATH .."equip_lv_bg.png" , 45 , 45 },
				callback = function()

				end
			})
			local lv = CCLabelTTF:create( "100" , FONT , 16)
			lv:setColor( ccc3( 0xff , 0xff , 0xff ) )
			setAnchPos(lv , 328+61 , 425+45 , 0.5)
			composeLayer:addChild( lv , 101)
			composeLayer:addChild( fiveStar_btn:getLayer() )
			local drawing_btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 208, 215, {
				front = getImageByType( params["drawing"], 's' ),				
				text = {getConfig("prop" , params["drawing"], "name") , 14, ccc3(255,255,255), ccp(0, -73)},
				disable = true,
				callback = function()

				end
			})

 			local starNum = getConfig("equip", params["basics"], "star")
			for j = 1, starNum do
				star = display.newSprite(COMMONPATH .. "star.png")
				star:setScale(0.8)
				setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (328 + fiveStar_btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, 425 - star:getContentSize().height - 3 )
				tempLayer:addChild(star)
			end

			starNum = getConfig("prop", params["drawing"], "star")
			for j = 1, starNum do
				star = display.newSprite(COMMONPATH .. "star.png")
				star:setScale(0.8)
				setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (208 + drawing_btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, 215 - star:getContentSize().height - 3 )
				tempLayer:addChild(star)
			end



			 composeLayer:addChild( drawing_btn:getLayer() )

			 return composeLayer
		end

		if tempLayer then
			goldEquipHelpLayer:removeChild(tempLayer, true)
		end

		tempLayer = display.newLayer()

		item_bg = display.newSprite( GOLDEQUIPPATH .. "item_bg.png" )
		setAnchPos( item_bg , 240 , 600 , 0.5 , 0.5 )
		tempLayer:addChild( item_bg )

		local equip_pos

		if kind == "renjie" then
			equip_pos = { 
				{ 30 , 590 , 5530 , "武器" },
				{ 145 , 590 , 5531 , "防具" },
				{ 260 , 590 , 5532 , "饰品" },
				{ 375 , 590 , 5533 , "鞋子" },
			}

		elseif  kind == "guixiong" then
			equip_pos = { 
				{ 30 , 590 , 5534 , "武器" },
				{ 145 , 590 , 5535 , "防具" },
				{ 260 , 590 , 5536 , "饰品" },
				{ 375 , 590 , 5537 , "鞋子" } 
			}
		elseif kind == "yinghao" then
			equip_pos = { 
				{ 30 , 590 , 5538 , "武器" },
				{ 145 , 590 , 5539 , "防具" },
				{ 260 , 590 , 5540 , "饰品" },
				{ 375 , 590 , 5541 , "鞋子"}
			}
		end

		local group = KNRadioGroup:new()
		for i = 1, #equip_pos do
			local btn = KNBtn:new(COMMONPATH, {"role_frame.png","select1.png"},equip_pos[i][1] , equip_pos[i][2], {
				front =  getImageByType( equip_pos[i][3], 's' ),
				text = {getConfig("equip" , equip_pos[i][3], "name") , 14, ccc3(255,255,255), ccp(0, -73)},
				priority = - 202,
				callback = function()
					local data = getConfig("equipGoldCompose" , equip_pos[i][3])
					 tempLayer:addChild( getComposeLayer(data , equip_pos[i][4]) ) 
				end
			}, group)
			tempLayer:addChild(btn:getLayer(), 1)

			local star
			local starNum = getConfig("equip", equip_pos[i][3], "star")
			for j = 1, starNum do
				star = display.newSprite(COMMONPATH .. "star.png")
				star:setScale(0.8)
				setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (equip_pos[i][1] + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, equip_pos[i][2] - star:getContentSize().height - 3 )
				tempLayer:addChild(star)
			end
		end
		group:chooseByIndex(1, true)

		return tempLayer
	end

	goldEquipHelpLayer = display.newLayer()	
	local mask = KNMask:new({item = goldEquipHelpLayer, priority = -202})
	
	local sprite = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(sprite, 240, 425, 0.5, 0.5)
	goldEquipHelpLayer:addChild(sprite, -1)
		
	sprite = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(sprite, 240, 690, 0.5)
	goldEquipHelpLayer:addChild(sprite)

	sprite = display.newSprite( GOLDEQUIPPATH .. "drawing_frame.png" )
	setAnchPos(sprite, 120 , 370 , 0.5 )
	goldEquipHelpLayer:addChild(sprite)

	sprite = display.newSprite( GOLDEQUIPPATH .. "drawing_frame.png" )
	setAnchPos(sprite, 360 , 370 , 0.5 )
	goldEquipHelpLayer:addChild(sprite)

	sprite = display.newSprite( GOLDEQUIPPATH .. "drawing_frame.png" )
	setAnchPos(sprite, 240 , 160 , 0.5 )
	goldEquipHelpLayer:addChild(sprite)

	sprite = display.newSprite( GOLDEQUIPPATH .. "drawing.png" )
	setAnchPos( sprite , 240 , 390 , 0.5 , 0.5 )
	goldEquipHelpLayer:addChild( sprite , -1)

	sprite = display.newSprite( GOLDEQUIPPATH .. "ring.png" )
	setAnchPos( sprite , 240 , 390 , 0.5 , 0.5 )
	goldEquipHelpLayer:addChild( sprite , -1)

	local suit_text = display.newSprite( GOLDEQUIPPATH .. "suit_text.png" )
	setAnchPos( suit_text , 240 , 145 , 0.5 , 0.5 )
	goldEquipHelpLayer:addChild( suit_text )

	suit_text:addChild( createLabel({str = "注：专属装备不可制作灵魂装备" , x = 25, y = -17,size = 14, width = 384 , height =84,color = ccc3(46 , 18 , 14)}) )

	local kinds = {
		"renjie",
		"guixiong",
		"yinghao"
	}
	
	local group = KNRadioGroup:new()
	for i = 1, #kinds do
		local btn = KNBtn:new(COMMONPATH.."tab/", {"tab_star_normal.png","tab_star_select.png"},30 + (i - 1) * 90 , 695, {
			front =  {GOLDEQUIPPATH..kinds[i]..".png",GOLDEQUIPPATH..kinds[i].."_pre.png"},
			priority = - 202,
			callback = function()
				goldEquipHelpLayer:addChild( goldEquipType( kinds[i] ) )
			end
		}, group)
		goldEquipHelpLayer:addChild(btn:getLayer(), -1)
	end
	group:chooseByIndex(1, true)

	local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
	local infoLayer = InfoLayer:new("list" , 0, {title_text = GOLDEQUIPPATH.."compound_drawing.png", tail_hide = true, priority = -202, closeCallback = function()
		self.layer:removeChild(mask:getLayer(),true)
	end})

	goldEquipHelpLayer:addChild( infoLayer:getLayer() )

	return mask:getLayer()
end


function PoolLayer:equipContent(params)
	if self.contentLayer then
		self.layer:removeChild(self.contentLayer, true)	
	end
	self.curItem = {}

	local isFirst = true

	self.contentLayer = display.newLayer()


	self.contentLayer:addChild( display.newSprite( PATH.."star_bg.png" , 240, 621 , 0.5 , 0 ) )

	local function  getBg(str)
		local layer = display.newLayer()

		-- layer:addChild( display.newSprite( PATH.."star_bg.png" , 240, 621 , 0.5 , 0 ) )

		if str == "zhuanshu" then 
			layer:addChild( display.newSprite( GOLDEQUIPPATH.."zhuanshu_bg.png" , 240, 225 , 0.5 , 0 ) )
			layer:addChild( display.newSprite( GOLDEQUIPPATH.."di_frame.png" , 240, 240 , 0.5 , 0 ) )
		else
			layer:addChild( display.newSprite( GOLDEQUIPPATH.."add.png" , 240 , 390 , 0.5 , 0 ) )
			layer:addChild( display.newSprite( GOLDEQUIPPATH.."frame.png" , 240 , 435 , 0.5 , 0 ) )
			layer:addChild( display.newSprite( GOLDEQUIPPATH.."bg_frame.png" , 240 , 145 , 0.5 , 0 ) )
			layer:addChild( display.newSprite( PATH.."arrow.png" , 240, 305 , 0.5 , 0 ) )
			layer:addChild( display.newSprite( GOLDEQUIPPATH.."line.png" , 240, 395 , 0.5 , 0 ) )
		end
		

		return layer
	end
	


	-- soullayer  灵魂层
	-- equipcompoundLayer 装备升星和进化
	-- zhuanshuLayer 专属装备
	-- createList 装备选择列表  createScroll 装备选择列表中的滚动层

	local soulLayer  , equipcompoundLayer , itemsLayer , pos , chooseItems , createList , createScroll , helpBtn , zhuanshuLayer

	equipcompoundLayer = function(type)
		if params and params.bagId and isFirst then 
			isFirst = false
			self.curItem[3] = params.bagId
		end
		chooseItems = function()
			if itemsLayer then
				self.contentLayer:removeChild(itemsLayer, true)
			end
			itemsLayer = display.newLayer()

			itemsLayer:addChild( getBg() )

			helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png","help_press.png"}, 410 , 550 , {
								priority = -122,
								scale = true,
								callback = function()
									local mask

									local tempLayer =display.newLayer()
									--背景
									local bg = display.newSprite(IMG_PATH.."image/scene/chat/".."info_bg_big.png")
									setAnchPos(bg,240,150, 0.5)
									tempLayer:addChild(bg)
									--标题背景
								 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
								 	setAnchPos(title_bgSp,100,520)
								 	bg:addChild(title_bgSp)
									--标题文字
								 	local title_Sp = display.newSprite(COMMONPATH.."help_title.png")
								 	setAnchPos(title_Sp,65,520)
								 	bg:addChild(title_Sp)

								 	local str

								 	if type == "star" then
								 		str =   "1.三星装备升星：\n"..
										 		"+ 强化等级达到60级的任意三星装备*1 \n"..
										 		"+ 四星装备升星图纸\n"..
										 		"+ 银两 \n"..
										 		"+ 四星装备升星材料 \n"..
										 		"= 任意一件同类型四星装备\n"..
										 		"2、四星套装升星：\n"..
										 		"+ 强化等级达到90级的任意四星套装装备*1件 \n"..
										 		"+ 五星装备升星图纸\n"..
										 		"+ 荣誉\n"..
										 		"+ 银两\n"..
										 		"+ 五星装备升星材料\n"..
										 		"= 任意一件同类型五星装备\n"..
										 		"3、装备等级说明：\n"..
										 		"◇3星升4星:升星后强化等级降至50级，并保留附魔属性\n"..
										 		"◇4星套装升5星:升星后强化等级降至75级，淬炼等级、附魔熟练度清零、并保留附魔属性，同时返还部分4星淬炼石、银两\n"..
										 		"4、产出：\n"..
										 		"4.1、图纸产出：在装备本中产出四星、五星装备升星图纸\n"..
										 		"4.2、材料产出：在装备本中产出四星、五星装备升星材料\n"
								 	else
								 		str =   "1、四星装备 进化为 四星套装：\n"..
										 		"+四星装备*1件\n"..
										 		"+四星套装图纸\n"..
										 		"+银两\n"..
										 		"+荣誉点\n"..
										 		"+四星套装材料\n"..
										 		"=任意一件同类型四星套装\n"..
										 		"2、五星装备 进化为 五星套装：\n"..
										 		"+五星装备*1件\n"..
										 		"+荣誉点\n"..
										 		"+银两\n"..
										 		"+五星套装图纸\n"..
										 		"+五星套装材料\n"..
										 		"=任意一件同类型五星套装\n"..
										 		"2.1、注： 专属装备不可制作套装\n"..
										 		"3、装备等级：同星进化后新装备保留原装备强化等级、淬炼等级\n"..
										 		"4、产出：\n"..
										 		"4.1、图纸产出：在装备本中产出四星、五星装备套装图纸\n"..
										 		"4.2、材料产出：在装备本中产出四星、五星装备套装材料\n"
								 	end


								 	local helpTips = createLabel({str = str , x = 40, y = 55,size = 16, width = 370,color = ccc3(46 , 18 , 14)})
								 	-- bg:addChild(helpTips)

								 	local scroll = KNScrollView:new( 20 , 200 , 440 , 450 , 20 , false , 0 , { priority = -230} )
								 	scroll:addChild(helpTips)
									scroll:alignCenter()
									tempLayer:addChild(scroll:getLayer() )

								 	--关闭按钮
								    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 510 , {
											priority = -201-2,
											scale = true,
											callback = function()
												mask:remove()
											end})
									bg:addChild(close:getLayer())
								 	mask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -201-1})
								 	itemsLayer:addChild(mask:getLayer(), 10)
								end
						})
			itemsLayer:addChild(helpBtn:getLayer() , 0)

			local equipcompound_data
			self.curItem[1] = nil
			self.curItem[2] = nil

			--每次进入 chooseItems 都判断是否有装备, 如果有就把 背包里面的材料 自动填上
			if self.curItem[3] then
				local starNum = DATA_Bag:get("equip", self.curItem[3], "star")
				
				if type == "star" and starNum == 3 then 
					equipcompound_data = equipcompound["1"]
				elseif type == "star" and  starNum == 4 then 
					equipcompound_data = equipcompound["3"]
				elseif type == "advance" and  starNum == 4 then 
					equipcompound_data = equipcompound["2"]
				elseif type == "advance" and  starNum == 5 then 
					equipcompound_data = equipcompound["4"]
				end

				for k, v in pairs(DATA_Bag:getTable("prop", { cid = ""..equipcompound_data["equipmap"] } )) do
					self.curItem[1] = tonumber(k)
				end

				for k, v in pairs(DATA_Bag:getTable("prop", { cid = ""..equipcompound_data["equipchip"] } )) do
					self.curItem[2] = tonumber(k)
					itemsLayer:addChild( display.strokeLabel( equipcompound_data["equipchip_num"] , 360 , 280 , 18, ccc3( 255 , 255 , 255 )  )  , 1 )	
				end

				itemsLayer:addChild( display.strokeLabel( equipcompound_data["silver"] , 400 , 127 , 16, ccc3( 255 , 255 , 255 )  ) )	
				itemsLayer:addChild( display.strokeLabel( equipcompound_data["honor"] , 400 , 108 , 16, ccc3( 255 , 255 , 255 )  ) )	
			end

			local front, text
			for i = 1, #pos do

				local category = pos[i][4]

				if self.curItem[i] and i<=4 then  --已选择了元素
					front = getImageByType(DATA_Bag:get(category, self.curItem[i], "cid"), "s")		
					text = {getConfig(category, DATA_Bag:get(category, self.curItem[i], "cid"), "name")..(DATA_Bag:get(category,self.curItem[i],"lv") and " Lv"..DATA_Bag:get(category,self.curItem[i],"lv") or ""), 14, ccc3(255,255,255), ccp(0, -70)}
				else
					text = pos[i][3]
					front = nil
				end
	
				local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, pos[i][1], pos[i][2], {
					front = front,
					text = text,
					callback = function()
						if self.curItem[4] and i == 4 then				-- 如果 合成了装备可以查看详情
							pushScene("detail" , {
									detail = "equip",
									id = self.curItem[4],
									propOpt = function()

									end
							})
						end

						local str = type == "star" and "升星" or "进化"
						if type == "star" and i~=3 then
							if self.curItem[3] then 									--如果选择了装备，会自动把材料填满，如果没有相应的材料则弹出相应的msg
								local equip_star = DATA_Bag:get("equip", self.curItem[3] , "star")
								local strNum = tonumber(equip_star) == 3 and "四" or "五"
								if self.curItem[1]==nil and i == 1 then 
									KNMsg.getInstance():flashShow("您没有"..strNum.."星升星图纸，可前往装备本中获得")
								elseif self.curItem[2]==nil and i == 2 then 
									if equip_star == 3 then
										KNMsg.getInstance():flashShow("可在装备本获得四星装备材料")
									elseif equip_star == 4 then
										KNMsg.getInstance():flashShow("可在装备本获得五星装备材料")
									end
								end
								return 
							else 
								if i ~= 3 and i~=4 then
									KNMsg.getInstance():flashShow("请选择需要"..str.."的装备")
									return
								end
							end
						elseif type == "advance" and i~=3 then
							if self.curItem[3] then 
								local equip_star = DATA_Bag:get("equip", self.curItem[3] , "star")
								local strNum = tonumber(equip_star) == 4 and "四" or "五"
								if self.curItem[i]==nil and i == 1 then 
									KNMsg.getInstance():flashShow("您没有"..strNum.."星套装图纸，可前往装备本中获得")
								elseif self.curItem[i]==nil and i == 2 then 
									if equip_star == 4 then
										KNMsg.getInstance():flashShow("可在装备本获得四星套装材料")
									elseif equip_star == 5 then
										KNMsg.getInstance():flashShow("可在装备本掉落五星套装材料")
									end
								end
								return
							else 
								if i ~= 3 and i ~= 4 then
									KNMsg.getInstance():flashShow("请选择需要"..str.."的装备")
									return
								end
							end
						end
						if i == 3 then 
							if type == "star" then 
								createList("equip" , type , 1 , i)
							elseif type == "advance" then
								createList("equip" , type , 1 , i)
							end

							return 
						end
					end
				})
				itemsLayer:addChild(btn:getLayer())
				
				if self.curItem[i] and i <= 4 then
					local star
					local starNum = getConfig(category, DATA_Bag:get(category, self.curItem[i], "cid"), "star") 
					for j = 1, starNum do
						star = display.newSprite(COMMONPATH .. "star.png")
						star:setScale(0.8)
						setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (pos[i][1] + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, pos[i][2] - star:getContentSize().height - 3 )
						itemsLayer:addChild(star)
					end
				end
			end
			local startBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 100, {
				front = PATH .. "make.png" ,
				callback = function()

					if #self.curItem >= 3 then 										
						local function http_request(post)
							HTTP:call("evolvepool", "merge_equip", post , {
										success_callback = function(data)
										self.curItem = {}
										self.curItem[4] = data.get_equip["id"]
										local card_popup = KNCardpopup:new(data.get_equip["cid"],function()
											chooseItems()
											KNMsg:getInstance():flashShow(data["return_msg"])
										end ,
										 {	
											init_x =  0,
											init_y = -150,
											end_x =  0,
											end_y =  -150,})
										display.getRunningScene():addChild(card_popup:play())

										end
							})
						end

						if type == "star" then					--升星才有确认的tips , 套装没有
							HTTP:call("evolvepool", "merge_equip_notice", { eid = self.curItem[3] } , {
								success_callback = function(data)
									showTip({
									content = createLabel({str = data.msg, size = 24, width = 360}),
									left = {
										path = COMMONPATH,
										normal = "btn_bg_red.png",
										pre = "btn_bg_red_pre.png",
										front = COMMONPATH.."ok.png",
										remove = true,
										callback = function()
											local post = { eid = self.curItem[3] , type = "star" , }
											http_request(post)
										end
									},
									right = {
											 path = COMMONPATH, 
											 normal = "btn_bg_red.png", 
											 pre = "btn_bg_red_pre.png",
											 front = COMMONPATH.."cancel.png",
											 remove = true
							    	}})
					    	end
							})
						else
							local post = { eid = self.curItem[3] , type = "evolve" ,  }
							http_request(post)
						end

					else

						local str = type == "star" and "升星" or "进化"
						KNMsg:getInstance():flashShow("请先选择"..str.."材料!")
						return
					end
					

				end
			})
			itemsLayer:addChild(startBtn:getLayer())

			local str = type == "star" and "upstar" or "grop"
			local label = display.newSprite( GOLDEQUIPPATH .. str .. "_label.png" )
			setAnchPos(label, 240, 590, 0.5)
			itemsLayer:addChild( label )

			label = display.newSprite( PATH .. "use.png" )
			setAnchPos(label, 310, 280 )
			itemsLayer:addChild( label )

			itemsLayer:addChild( display.strokeLabel( "消耗银两： " , 320 , 127 , 16, ccc3( 255 , 255 , 255 )  ) )	
			itemsLayer:addChild( display.strokeLabel( "消耗荣誉： " , 320 , 108 , 16, ccc3( 255 , 255 , 255 )  ) )	

			self.contentLayer:addChild(itemsLayer , 10)
		end

		chooseItems()
	end

	soulLayer = function(param)
		if params and params.bagId and isFirst then 
			isFirst = false
			self.curItem[2] = params.bagId
		end
		chooseItems = function()	
			if itemsLayer then
				self.contentLayer:removeChild(itemsLayer, true)
			end
			itemsLayer = display.newLayer()

			itemsLayer:addChild( getBg() )

			helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png","help_press.png"}, 410 , 550 , {
								priority = -122,
								scale = true,
								callback = function()
									self.layer:addChild( self:goldEquipHelp() )
								end
						})
			itemsLayer:addChild(helpBtn:getLayer() , 0)


			--每次进入 chooseItems 都判断是否有基础装备, 如果有就把 图纸 自动填上
			if self.curItem[2] then 
				self.curItem[1] = nil
				local key , value , drawing = self:getComposeConfigWithCid(DATA_Bag:get("equip" , self.curItem[2] , "cid"))
				for k, v in pairs(DATA_Bag:getTable("prop", { cid = ""..drawing } )) do
					self.curItem[1] = k
				end
			end

			
			local front, text
			local equipgroup = { 7 , 8 , 9 }								-- 7 8 9 套装对应 17001 17002 17003图纸
			local equipmap = { '17001' , '17002' , '17003' }
			for i = 1, #pos do
				if self.curItem[i] and i<4 then  --已选择了元素
					local category = pos[i][4]
					front = getImageByType(DATA_Bag:get(category, self.curItem[i], "cid"), "s")		
					text = {getConfig(category, DATA_Bag:get(category, self.curItem[i], "cid"), "name")..(DATA_Bag:get(category,self.curItem[i],"lv") and " Lv"..DATA_Bag:get(category,self.curItem[i],"lv") or ""), 14, ccc3(255,255,255), ccp(0, -70)}
				elseif self.curItem[i] and i == 4 then 			--i = 4 为合成的装备 self.curItem 为 equip配置表的 cid
					front = getImageByType(self.curItem[i], "s")
					text = { getConfig("equip", self.curItem[i], "name").." Lv100", 14, ccc3(255,255,255), ccp(0, -70) }
				else
					text = pos[i][3]
					front = nil
				end
				
				local filter = {}

				if i == 2 then 
					filter.group = {7, 8 , 9}
					filter.lv = 100
					filter.star = 5
					filter.interval_pro_lv = { 0,0 }  --只有0级的才可以进阶
				elseif i== 3 then
					filter.group = 0
					filter.star = 5
					filter.interval_pro_lv = { 0,0 }  --只有0级的才可以进阶
				else
					filter.type = nil
				end

				local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, pos[i][1], pos[i][2], {
					front = front,
					text = text,
					callback = function()
						if self.curItem[2] and i == 1 then 
							if self.curItem[i]==nil then 
								KNMsg.getInstance():flashShow("您没有对应的灵魂装备图纸")
							end
							return 
						else 
							if i == 1 then
								KNMsg.getInstance():flashShow("请先选择需要进阶的装备")
								return
							end
						end

						if i < 4 and i ~= 1 then
							local list
							list = SelectList:new(pos[i][4], self.contentLayer,display.newSprite(COMMONPATH .. "title/"..(pos[i][4]).."_text.png") , {
								btn_opt = "ok.png",
								target = true,
								all = true,
								filter = filter,
								showTitle = true , 
								-- exceptUse = true,
								optCallback = function()
									list:destroy()
									if i == 2 or i == 3 then
										self.curItem[i] = list:getCurItem():getId()
									end
									chooseItems()
								end
							})

							self.layer:addChild(list:getLayer())	

							if i==2 then 
								list.contentLayer:addChild( createLabel({str = "注：专属装备不可制作灵魂装备" , x = 25, y = 733,size = 16, width = 384 , height =84,color = ccc3(255 , 255 , 238)}) )
							end

						else
							
						end
					end
				})
				itemsLayer:addChild(btn:getLayer())
				
				if self.curItem[i] and i<4 then
					local star
					local category = pos[i][4]
					local starNum = getConfig(category, DATA_Bag:get(category, self.curItem[i], "cid"), "star") 
					for j = 1, starNum do
						star = display.newSprite(COMMONPATH .. "star.png")
						star:setScale(0.8)
						setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (pos[i][1] + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, pos[i][2] - star:getContentSize().height - 3 )
						itemsLayer:addChild(star)
					end
				elseif self.curItem[i] and i == 4 then
					local star
					local category = pos[i][4]
					local starNum = getConfig(category, self.curItem[i] , "star") 
					for j = 1, starNum do
						star = display.newSprite(COMMONPATH .. "star.png")
						star:setScale(0.8)
						setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (pos[i][1] + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, pos[i][2] - star:getContentSize().height - 3 )
						itemsLayer:addChild(star)
					end

				end
				if #self.curItem >= 3 then 
					
					local key , value , drawing = self:getComposeConfigWithCid(DATA_Bag:get("equip" , self.curItem[2] , "cid"))

					local swallowEquipType = getConfig("equip" , DATA_Bag:get("equip" , self.curItem[3] , "cid") , "type" )
					if swallowEquipType == getConfig("equip" , value , "type") and 
						tonumber(DATA_Bag:get("prop" , self.curItem[1] , "cid")) == tonumber(drawing) then 
						self.curItem[4] = key
					else
						self.curItem[4] = nil
					end
				end
			end
			local startBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 100, {
				front = PATH .. "make.png" ,
				callback = function()

					if #self.curItem == 4 then 
						local post = { basic = self.curItem[2] , sacrifice = self.curItem[3] , map_id = self.curItem[1] , new_cid = self.curItem[4] }
						HTTP:call("equip", "newgoldequip", post , {
							success_callback = function(data, func)
								local card_popup = KNCardpopup:new(data.awards["drop"][1] , function()
													end , {
														init_x =  196,
														init_y = 211,
														end_x =  196,
														end_y =  211,
														-- priority = -202,
								})
								self.curItem = {}
								self.contentLayer:addChild( card_popup:play() , 10)
								chooseItems()
							end
						})				
					else
						KNMsg:getInstance():flashShow("请选择合成所需要的材料!")
					end
				end
			})
			itemsLayer:addChild(startBtn:getLayer())

			local label = display.newSprite( GOLDEQUIPPATH .. "soul_label.png" )
			setAnchPos(label, 240, 590, 0.5)
			itemsLayer:addChild( label )

			self.contentLayer:addChild(itemsLayer , -1)
		end

		chooseItems()
	end

	local function getGodHeroName(data)
		local name = data.name

		if tonumber(data.god) == 1 then 
			name = string.sub( name , 9 )
		end

		return name
	end

	local function getHeroStrByIds(heroId)
		local str = ""

		if type(heroId) == "table" then 
			for i,id in pairs(heroId) do

				local data = DATA_Bag:get("general",id)
				local name = getGodHeroName(data)

				local tempStr = ",英雄" .. name .. "Lv" .. data.lv

				str = str .. tempStr
			end
		else
			local data = DATA_Bag:get("general",heroId)
			str = ",英雄" .. data.name .. "Lv" .. data.lv

		end

		return string.sub( str , 2)
	end

	zhuanshuLayer = function()
		if params and params.bagId and isFirst then 
			isFirst = false
			self.curItem[1] = params.bagId
		end



		local param , material = {} , DATA_Info:get_type("jzsj_config").material

		local atrConfig = { def = "防御" , atk = "攻击" , agi  = "敏捷" , hp = "血量" }

		chooseItems = function()	
			if itemsLayer then
				self.contentLayer:removeChild(itemsLayer, true)
			end
			itemsLayer = display.newLayer()

			itemsLayer:addChild( getBg("zhuanshu") )
			
			local pro_lv , need_prorp_num , own_prop_num , need_hero_num , own_hero_num , need_hero_cid , need_hero_data  = 0 , 0 , 0 , 0 , 0 , 0 

			--如果选择了 装备 则把 所需要的道具自动填上
			if self.curItem[1] then 

				local isgold = getConfig("equip" , DATA_Bag:get("equip", self.curItem[1].."" , "cid") , "isgold" ) == 1

				param = DATA_Info:get_type( isgold and "jzsj_config" or "wxsj_config")

				self.curItem[3] = material
				
				-- dump(DATA_Bag:get("equip", self.curItem[1].."" ))

				pro_lv = DATA_Bag:get("equip", self.curItem[1].."" , "pro_lv")
				need_prorp_num = pro_lv and param.config[ (tonumber(pro_lv)+1)..""]["material"] or 0
				own_prop_num = DATA_Bag:getTypeCount( "prop" , material.."" )

				--只有等级大于0的专属装备才自动填上
				-- if pro_lv >= 1 then 
					need_hero_cid = DATA_Bag:get("equip", self.curItem[1].."" , "pro_gid")
					need_hero_num = param.config[ (tonumber(pro_lv)+1)..""]["quantity"] or 0
				-- end

				need_hero_config = getConfig( "general"  , need_hero_cid )

				self.curItem[4] = self.curItem[1]
			end

			local midBagData 
			for i = 1, #pos do
				local category = pos[i][4]

				local bagData , front, text , clickToChoose

				--英雄被当做材料
				local hero_be_material = (i == 2 and pro_lv > 0)

				if category and self.curItem[i] and i ~= 3 and not hero_be_material then 
					bagData = DATA_Bag:get(category, self.curItem[i].."")
					midBagData=bagData
				end
				
				if i == 3 and self.curItem[i] then 			--i = 4 为合成的装备 self.curItem 为 equip配置表的 cid
					front = getImageByType(self.curItem[i], "s")
					text = { getConfig( "prop"  , self.curItem[3] , "name" ) .. "\n"..own_prop_num .. "/" .. need_prorp_num , 14, ccc3(255,255,255), ccp(0, -60) }
				elseif hero_be_material then

					if type(self.curItem[2]) == "table" and table.nums(self.curItem[2]) > 0 then 
						own_hero_num =  table.nums(self.curItem[2]) 
						front = getImageByType( need_hero_cid , "s")
					else
						itemsLayer:addChild( createLabel({str = "点击筛选", x = pos[2][1] + 10 , y = pos[2][2] + 7 , size = 24, width = 64 , height  = 64}) )
					end

					text = { (need_hero_config and need_hero_config.name or "") .. "\n"..own_hero_num .. "/" .. need_hero_num , 14, ccc3(255,255,255), ccp(0, -60) }

				elseif self.curItem[i] then  --已选择了元素
					front = getImageByType( bagData.cid , "s")
					if i == 4 then 	
						local temp_pro_lv =  self.curItem[1] and  bagData.pro_lv+1 or bagData.pro_lv

						local isgold = getConfig("equip" , DATA_Bag:get("equip", self.curItem[4].."" , "cid") , "isgold" ) == 1
						param = DATA_Info:get_type( isgold and "jzsj_config" or "wxsj_config")

						text =  { (need_hero_config and need_hero_config.name or "") .. "专属" .. temp_pro_lv .. "阶\n"..atrConfig[bagData.effect].."+" .. param.config[temp_pro_lv..""][bagData.effect], 14, ccc3(255,255,255), ccp(0,  -95) }
						

					else
						text =  { bagData.name..( bagData.lv and " Lv"..bagData.lv or ""), 14, ccc3(255,255,255), ccp(0, -70) }
					end
				else
					text = pos[i][3]
					front = nil
				end

				local filter = {}

				local exceptUse = true

				if i == 1 then 

					filter.star = 5
					-- filter.group = {15, 16 , 17}
					exceptUse = false
					filter.interval_pro_lv = { 0 , 4 } 					--选择0	- 次最高等级
				elseif i == 2 then 
					filter.star = 5
					
					if hero_be_material and tonumber(need_hero_cid) ~= 0 then 
						filter.cid = need_hero_cid .. ""
					end

					if self.curItem[1] and pro_lv == 0 then 							-- 没有合成过的金装做职业限制，合成过的则不需要
						local apstype = getConfig( "equip" , DATA_Bag:get("equip" , self.curItem[1]).cid , "apstype" ) 
						filter.hero_job = apstype
					end


				elseif i== 3 then
				else
					filter.type = nil
				end

				text[1] = replaceStr( text[1] )
				local btn
				 btn= KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, pos[i][1], pos[i][2], {
					front = front,
					text = text,
					callback = function()
						dump(midBagData)
						if i == 2 then 
							if not self.curItem[1] then 
								KNMsg:getInstance():flashShow("请先选择需要进化的装备")
								return 
							end
						end

						if i < 4 and i~=3  then
							local list
							list = SelectList:new( pos[i][4] == "hero" and "general" or pos[i][4], self.contentLayer,display.newSprite(COMMONPATH .. "title/"..(pos[i][4]=="general" and "hero" or pos[i][4]).."_text.png") , {
								btn_opt = "ok.png",
								-- target = true,
								all = true,
								check = hero_be_material and i==2,
								checked = true,
								filter = filter,
								showTitle = true , 
								exceptUse = exceptUse,
								selectedList =  { source = hero_be_material and i==2 and self.curItem[2] or {} },
								exceptZhenfa = (i == 2),
								optCallback = function(param)

									local select_id = param.id
									--dump(param)
									if tonumber(DATA_Bag:get(category , select_id , "pro_lv")) == table.nums(DATA_Info:get_type("jzsj_config").config) then 
										KNMsg:getInstance():flashShow("您选择的装备已经达到最大阶位")
										return false
									end

									list:destroy()
									self.curItem[i] = select_id
									local str

									if self.vipHeroText~=nil then
								 		self.layer:removeChild(self.vipHeroText,true)
									end
									if i == 1 then 
										self.curItem[4] = nil
										self.curItem[2] = nil
										
										
									end
									--检查是否为VIP赠送的英雄,是则加上特殊描述
									local vipHeroLv,attrNum = 0,0
									if i==2 then
										local atrConfig = { def = "防御" , atk = "攻击" , agi  = "敏捷" , hp = "血量" }
										local vipjzConfig = getConfig("vipjz")
										for k,v in pairs(vipjzConfig) do
											if (v["generalid"].."")== param.cid then --如果是vip赠送英雄
												vipHeroLv=k
												attrNum= v[midBagData.effect]*(midBagData.pro_lv+1)
											end
										end
										if getConfig("equip" , midBagData.cid , "isgold" ) ~= 1 then  --如果不是金装属性变0
											attrNum=0
										end

										if vipHeroLv~=0   then --vip和金装
										
											str="VIP"..vipHeroLv.."特权英雄额外\n"..atrConfig[midBagData.effect].."+"..attrNum
											self.vipHeroText = display.strokeLabel(str , 183 , 245 , 15, ccc3( 255 , 0 , 0 ))
											self.layer:addChild(self.vipHeroText)
										end

									end
									
									chooseItems()
								end,
								checkBoxOpt = function()

									if table.nums(list:getSelectItems())>need_hero_num then 
										KNMsg:getInstance():flashShow("您选择的英雄超过合成所需要的数量")
										return false
									end

									self.curItem[2] = list:getSelectItems()

								end,
								closeCallback = function()
									

									chooseItems()

									local vipHeroLv,attrNum,midCid = 0,0
									local atrConfig = { def = "防御" , atk = "攻击" , agi  = "敏捷" , hp = "血量" }
									local vipjzConfig = getConfig("vipjz")
									
									for k,v in pairs(self.curItem[2] or {}) do
										midCid=k
									end
									local midCid = DATA_Bag:get("general",midCid, "cid")
									
									for k,v in pairs(vipjzConfig) do
										
										if midBagData and (v["generalid"].."")== midCid then --如果是vip赠送英雄
										
											vipHeroLv=k
											attrNum= v[midBagData.effect]*(midBagData.pro_lv+1)
										end
									end
									if midBagData and getConfig("equip" , midBagData.cid , "isgold" ) ~= 1 then  --如果不是金装属性变0
										attrNum=0
									end

									if vipHeroLv~=0   then --vip和金装
									
										str="VIP"..vipHeroLv.."特权英雄额外\n"..atrConfig[midBagData.effect].."+"..attrNum
										self.vipHeroText = display.strokeLabel(str , 183 , 245 , 15, ccc3( 255 , 0 , 0 ))
										self.layer:addChild(self.vipHeroText)
									end

								end
							})

							self.layer:addChild(list:getLayer())	
						else
							
						end

					end
				})

				if bagData then 
					-- 如果 英雄被当做材料的话，则不显示星级
					if not hero_be_material and i~=4 then 
						local starNum = bagData.star
						for j = 1, tonumber(starNum) do
							local star = display.newSprite(COMMONPATH .. "star.png")
							star:setScale(0.8)
							setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (pos[i][1] + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, pos[i][2] - star:getContentSize().height - 3 - (i == 4 and 35 or 0) )
							itemsLayer:addChild(star)
						end
					end

					if bagData.pro_lv and tonumber(bagData.pro_lv) > 0 or i == 4 then 
						--如果是 合成的框 并且 装备框上面有东西则显示 阶位加1 ， 否则阶位不变
						local layer = getZhuanshuLabel( i == 4 and self.curItem[1] and (bagData.pro_lv+1) or bagData.pro_lv ) 
						setAnchPos( layer , 0 , 13  ,0  ,0 )
						btn:getLayer():addChild( layer , 100 )
					end

				end

				itemsLayer:addChild(btn:getLayer())
				
			end
			local startBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 188, {
				front = GOLDEQUIPPATH .. "compound_label.png" ,
				callback = function()

						if not self.curItem[1] then KNMsg:getInstance():flashShow("请先选择需要进化的装备") return end
						if not self.curItem[2] or ( type(self.curItem[2]) == "table" and table.nums(self.curItem[2]) == 0 ) then 
							KNMsg:getInstance():flashShow("请先选择需要进化的英雄") 
							return 
						end

						local jobConfig = {"人杰","鬼雄","英豪"}

						local jobName = jobConfig[getConfig("equip", DATA_Bag:get("equip" , self.curItem[1]).cid, "apstype")]

						local id2
						if type(self.curItem[2]) == "table" then 
							for k,v in pairs(self.curItem[2]) do
								id2 = v
								break
							end
						else
							id2 = self.curItem[2]
						end

						local tipStr = "本次专属合成将消耗精铁："..need_prorp_num.."个," .. getHeroStrByIds( self.curItem[2] ) .. ",当前装备职业：".. replaceStr(jobName).."，装备专属：".. getGodHeroName(DATA_Bag:get("general",id2)).."，是否确定合成？"

						showTip({
						content = createLabel({str = replaceStr(tipStr), size = 20, width = 400 , height  = 300}),
						left = {
							path = COMMONPATH,
							normal = "btn_bg_red.png",
							pre = "btn_bg_red_pre.png",
							front = COMMONPATH.."ok.png",
							remove = true,
							callback = function()

								local ids = ""

								if type(self.curItem[2])=="table" then 
									for i,id in pairs(self.curItem[2]) do
										ids = ids ..",".. id
									end
									ids = string.sub( ids , 2)
								else
									ids = self.curItem[2]
								end

								local post_data = { equip_key = self.curItem[1] , ids = ids }

								HTTP:call("equip", "evolve_proprietary_equip", post_data , {
									success_callback = function(data, func)
										-- dump(data , "config")
										KNMsg:getInstance():flashShow( data.msg or "" )

										for i,v in ipairs(self.curItem) do
											if i ~= 4 then
												self.curItem[i] = nil
											end
										end

										chooseItems()
									end
								})
							end
						},
						right = {
								 path = COMMONPATH, 
								 normal = "btn_bg_red.png", 
								 pre = "btn_bg_red_pre.png",
								 front = COMMONPATH.."cancel.png",
								 remove = true
				    	}})

						

				end
			})


			itemsLayer:addChild(startBtn:getLayer())

			local str = "说明：\n"..
				 		"1.灵魂套装可以通过5星英雄卡牌和材料合成专属套装。 \n"..
				 		"2.专属权为合成时消耗的英雄卡牌。\n"..
				 		"3.专属装备只有灵魂套装可以合成并且只有5星英雄才可以制作专属装备。\n"..
				 		"4.专属装备可以通过消耗专属的英雄和材料升阶。\n"..
				 		"5.只有穿戴金装专属才可享受vip特权英雄的额外属性加成。\n"

			itemsLayer:addChild( createLabel({str = replaceStr(str) , x = 9, y = 90,size = 14, width = 470,color = ccc3(222 , 222 , 222)}) )


			local cleanBtn = KNBtn:new(GOLDEQUIPPATH.."zhuanshu/", {"btn_bg.png"}, 20, 568, {
				front = GOLDEQUIPPATH.."zhuanshu/" .. "clean.png" ,
				callback = function()

						self:zhuanShuClean(
							param, 
							chooseItems  )

					 -- self.contentLayer:addChild( self:zhuanShuClean(param):getLayer() , 11 )
				end
			})
			itemsLayer:addChild( cleanBtn:getLayer() )

			local resolveBtn = KNBtn:new(GOLDEQUIPPATH.."zhuanshu/", {"btn_bg.png"}, 376, 568, {
				front = GOLDEQUIPPATH.."zhuanshu/" .. "resolve.png" ,
				callback = function()
						self:zhuanShuResolve(
							{ refreshCallBack = chooseItems }  )
					 -- self.contentLayer:addChild( self:zhuanShuClean(param):getLayer() , 11 )
				end
			})
			itemsLayer:addChild( resolveBtn:getLayer() )


			self.contentLayer:addChild(itemsLayer , -1)
		end

		chooseItems()
	end

	createList = function(kind, type, star, index)
		if self.tempLayer then
			self.layer:removeChild(self.tempLayer,true)
		end

		--创建templayer的时候把layer移到屏幕外边去，删除templayer的时候把layer位置还原
		
		self.tempLayer = display.newLayer()
		self.layer:setPositionX(480)
		self.tempLayer:setPositionX(-480)
		
		if not self.selectItems then
			self.selectItems = {}
		end
			
		local title = display.newSprite(COMMONPATH.."dark_bg.png")
		setAnchPos(title, 240, 425, 0.5, 0.5)
		self.tempLayer:addChild(title)
		
		title = display.newSprite(COMMONPATH.."title_bg.png")
		setAnchPos(title, 0, 854 - title:getContentSize().height)
		self.tempLayer:addChild(title) 
		
		title = display.newSprite(COMMONPATH.."title_tail.png")
		setAnchPos(title, 0, 854 - title:getContentSize().height * 2)
		self.tempLayer:addChild(title, 2) 
		
		title = display.newSprite(COMMONPATH.."title/".."equip_text.png")
		setAnchPos(title, 245, 765, 0.5)
		self.tempLayer:addChild(title)
		
		title = display.newSprite(COMMONPATH.."tab_line.png")
		setAnchPos(title, 240, 690, 0.5)
		self.tempLayer:addChild(title)

		local close = KNBtn:new(COMMONPATH, {"back_img.png", "back_img_press.png"}, 50, 765, {
			scale = true,
			callback = function()
				if self.tempLayer then
					self.layer:removeChild(self.tempLayer,true)
					setAnchPos(self.layer)

					chooseItems()				--关闭后得刷新下界面
				end
			end
		})

		self.tempLayer:addChild(close:getLayer(), 1)
		
		local result 
		local group = KNRadioGroup:new()
		local start , ended
		if type == "star" then
			start = 3 
			ended = 4
		elseif type == "advance" then 
			start = 4 
			ended = 5
		end
		
		for i = start, ended do
			local btn = KNBtn:new(COMMONPATH.."tab/", {"tab_star_normal.png", "tab_star_select.png"},20 + (i - start) * 90, 695, {
				id = i,
				front = {COMMONPATH.."tab/".."tab_star"..i..".png", COMMONPATH.."tab/".."tab_star"..i.."_select.png"},
				priority = -220,
				callback = function()
					self.curStar = i
					self.selectItems = {}
					result = createScroll("equip",i, index , type)
				end
				
			},group)
			self.tempLayer:addChild(btn:getLayer(), 0)
		end
		group:chooseByIndex(star or 1, true)
		
		local okBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 280, 105, {
			front = COMMONPATH.."ok.png",
			callback = function()
				if table.nums(self.selectItems) < 1 then
					KNMsg.getInstance():flashShow("请选择一件符合条件的装备")
					return false
				end
				self.scroll = nil
				if self.tempLayer then
					self.layer:removeChild(self.tempLayer,true)
					setAnchPos(self.layer)
					chooseItems()								--确认后得刷新下界面
				end

			end
		})
		
		self.tempLayer:addChild(okBtn:getLayer())
		
		self.layer:addChild(self.tempLayer , 100)
	end

	createScroll = function(kind,star, index , flag)
		if self.scroll then
			self.tempLayer:removeChild(self.scroll:getLayer(),true)
		 end
		self.scroll = KNScrollView:new(0, 160, 480, 530, 5)
		
		local rules

		if flag == "advance" and star ==5 then

			self.scroll:getLayer():addChild( createLabel({str = "注：专属装备不可制作套装" , x = 33, y = 115,size = 16, width = 384 , height =84,color = ccc3(255 , 255 , 234)}) )

			local function rule1(v)
				if tonumber(v.pro_lv) > 0 then 
					return true
				end
			end
			rules = {	rule1	} 
		end

		local result = self:getItems(kind, star , rules)
		local mechod_data = DATA_Info:get_type("zhenfa")

		local function sortRule(l , r)
			local lValue, rValue = 0, 0

			local l_bag_info = DATA_Bag:get(kind , l)
			local r_bag_info = DATA_Bag:get(kind , r)

			local typeValue = {
				["weapon"] = 4,
				["defender"] = 3,
				["shoe"] = 2,
				["jewelry"] = 1,
			}
			local lDress = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(l), "equip")
			local rDress = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(r), "equip")
			
			if lDress then
				local _, pos = DATA_Formation:checkIsExist(tonumber(lDress))
				lValue = 1000000 + typeValue[DATA_Bag:get(kind, l, "type")] * 100000 + (8 - pos) * 5000
			end	
			
			if rDress then
				local _, pos =  DATA_Formation:checkIsExist(tonumber(rDress))
				rValue = 1000000 + typeValue[DATA_Bag:get(kind, r, "type")] * 100000 +(8 - pos) * 5000
			end

			if l_bag_info.star and r_bag_info.star then
				l_star = l_bag_info.star
				r_star = r_bag_info.star
			else
				l_star = getConfig(kind, l_bag_info.cid , "star")
				if l_bag_info.cid == r_bag_info.cid then
					r_star = l_star
				else
					r_star = getConfig(kind , r_bag_info.cid , "star")
				end
			end

			local lIsDress , num1 = DATA_ROLE_SKILL_EQUIP:isDressdOnZhenFa(l)
			local rIsDress , num2 = DATA_ROLE_SKILL_EQUIP:isDressdOnZhenFa(r)

			if lIsDress then 
				lValue = lValue + (6-num1)*100000 + typeValue[DATA_Bag:get(kind, l, "type")] * 10000
			end

			if rIsDress then
				rValue = rValue + (6-num2)*100000 + typeValue[DATA_Bag:get(kind, r, "type")] * 10000
			end

			lValue = lValue + l_star * 500 + (l_bag_info.lv or 0)
			rValue = rValue + r_star * 500 + (r_bag_info.lv or 0)	

			return lValue > rValue

		end


		local rs = getSortList(result, sortRule)

		if table.nums(result) > 0 then
			if self.empty then
				self.tempLayer:removeChild(self.empty, true)
				self.empty = nil
			end
			for key, value in ipairs(rs) do

				local v = result[value]
				local k = value

				local item
				item = ListItem:new(kind, k,{
					parent = self.scroll,
					check = true,
					checked = false,
					checkBoxOpt = function()
						if flag == "star" then
							if v["star"] == 3 then
								if tonumber(v["lv"]) < 60 then 
									KNMsg:getInstance():flashShow("装备强化到顶级才能进化")
									return false
								end
							end 

							if tonumber(v["star"]) == 4 then
								if tonumber(v["lv"]) < 90 then 
									KNMsg:getInstance():flashShow("装备强化到顶级才能进化")
									return false
								elseif v["group"] == 0 then 
									KNMsg:getInstance():flashShow("此装备不符合升星条件")
									return false
								end
							end 
						elseif flag == "advance" then
							if v["group"] ~= 0 then
								-- if  tonumber(v["gfigure"]) ~= -1 then
								-- 	KNMsg:getInstance():flashShow("此装备不能进化")
								-- 	return false
								-- end
								KNMsg:getInstance():flashShow("此装备已是套装之一")
								return false
							end
						end

						if item:isSelect() then
							if table.nums(self.selectItems) < 1 then
								table.insert(self.selectItems, tonumber(k))
								self.curItem[index] = tonumber(k)
								self.curItem[4] = nil
							else
								local str = flag == "star" and "升星" or "进化"
								KNMsg:getInstance():flashShow("最多选择一件装备"..str)
								return false
							end
						else
							for sk, sv in pairs(self.selectItems) do
								if tonumber(sv) == tonumber(k) then
									table.remove(self.selectItems,sk)
									self.curItem[3] = nil
									break
								end
							end
						end
					end
				})
				self.scroll:addChild(item:getLayer(), item)
			end	 
			self.scroll:alignCenter()
			self.tempLayer:addChild(self.scroll:getLayer())
		else
			self.empty = display.newSprite(COMMONPATH.."empty.png")
			setAnchPos(self.empty,240, 425, 0.5,0.5)
			self.tempLayer:addChild(self.empty)
		end

		 return result
	end

	
	local kinds = { "upstar" , "group" , "soul" , "zhuanshu" }

	local group = KNRadioGroup:new()

	for i = 1, #kinds do
		local itemChoseBtn = KNBtn:new(COMMONPATH, {"btn_bg_dis.png", "btn_bg.png"}, 45 + (i - 1) * 104, 630, {
				front = GOLDEQUIPPATH .. kinds[i] .. ".png",
				-- priority = - 130 ,
				disableWhenChoose = true, 
				upSelect = true,
				callback = function()
					self.curItem = {}
					
					if self.vipHeroText~=nil then
						self.layer:removeChild(self.vipHeroText,true)
					end
					if i == 1 then
						pos = {
								{208, 490, {"升星\n图纸"}, "prop"},
								{322, 360, {"材料" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "prop"},
								{91, 360, {"装备" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
								{210, 200, {"" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
							}
						equipcompoundLayer("star")
					elseif i == 2 then 
						pos = {
								{208, 490, {"套装\n图纸"}, "prop"},
								{322, 360, {"材料" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "prop"},
								{91, 360, {"装备" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
								{210, 200, {"" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
							}
						equipcompoundLayer("advance")
					elseif i == 3 then 
						pos = {
								{208, 490, {"套装\n图纸"}, "prop"},
								{91, 360, {"五星\n套装" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
								{322, 360, {"五星\n装备" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
								{210, 200, {"" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
							}
						soulLayer()
					elseif i == 4 then 
						pos = {
								{203, 525, {"点击要添加的\n装备", 14, ccc3(255,255,255), ccp(0,-55)}, "equip"},
								{57, 392, {"点击要添加的专\n属英雄" , 14, ccc3(255,255,255), ccp(0,-55)}, "general"},
								{359, 392, {"" , 14, ccc3(255,255,255), ccp(0,-55)}, "prop"},
								{205, 365, {"" , 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "equip"},
							}
						zhuanshuLayer()
					end
				end
			}, group)
		self.contentLayer:addChild( itemChoseBtn:getLayer() )
	end

	if params and params.flag == "upstar" then
		group:chooseByIndex(1, true)
	elseif params and params.flag == "equipGroup" then 
		group:chooseByIndex(2, true)
	elseif params and params.flag == "soul" then 
		group:chooseByIndex(3, true)
	elseif params and params.flag == "zhuanshu" then 
		group:chooseByIndex(4, true)
	else
		group:chooseByIndex(1, true)
	end

	self.layer:addChild(self.contentLayer)	
end

--rules匹配规则
function PoolLayer:getItems(kind, star , rules)
		 
	local data = DATA_Bag:get(kind) or {}
	local result = {}
	--筛选满足条件的卡牌，给定星级，且未上阵
	for k, v in pairs(data) do

		local match = true

		if kind == "pet" then
			if not (getConfig(kind, DATA_Bag:get(kind , k, "cid"), "star") ==  star and 
				DATA_Pet:getFighting() ~= tonumber(k)) then
				match = false
			end	
		else	
			local on
			if kind == "equip" then
				-- on = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(k),kind)
			else
				on = DATA_Formation:checkIsExist(tonumber(k))
			end
			if not (getConfig(kind, DATA_Bag:get(kind , k, "cid"), "star") ==  star and 
				not on) then 
					match = false
			end
		end


		if rules and type(rules) == "table" then 
			for k,func in pairs(rules) do
				if type(func) == "function" then 
					--如果 rule 返回 true,则不匹配
					if func(v) then 
						match = false
						break
					end
				end
			end
		end

		if match then 
			result[k] = v
		end


	end
	return result
end

function PoolLayer:zhuanShuResolve(param)

	local layer = display.newLayer()

	local mask = KNMask:new({item = layer, click = function(x, y)  end ,priority= -201})

	layer:addChild( display.newSprite( IMG_PATH  .. "image/scene/mission/wipe_bg.png", display.cx , 206 , 0.5 , 0 ) )

	layer:addChild( display.newSprite( IMG_PATH  .. "image/scene/mission/title_bg.png" , display.cx + 30 , 548 , 0.5 , 0 ) )
	layer:addChild( display.newSprite( GOLDEQUIPPATH.."zhuanshu/zhuanshu_resolve_title.png" , display.cx , 541 , 0.5 , 0 ) )

	local colseBtn = KNBtn:new(COMMONPATH,{"back_img.png","back_img_press.png"} , 40 , 516 ,{ scale = true,priority = -201-1,callback=
				function()
					mask:remove()
				end}):getLayer()
	layer:addChild( colseBtn )

	local filter = {}

	filter.star = 5
	-- filter.group = {15, 16 , 17}
	filter.interval_pro_lv = { 0,0 } 					-- 只选择在 1到最大等阶的数据

	local bagData , front , text

	local equip_id = param.equip_id

	if equip_id then 
		bagData = DATA_Bag:get("equip", equip_id.."")
		front = getImageByType( bagData.cid , "s")
		text =  { bagData.name..( bagData.lv and " Lv"..bagData.lv or "") .. "\n" .. "分解获得："..param.data.min.."-"..param.data.max.."精铁", 14, ccc3(66 , 24 , 8), ccp(0, -55) }
	end

	local frame = KNBtn:new(SCENECOMMON,{"skill_frame1.png"} , display.cx , 452 ,{ 
		priority = -201-1,
		anchMid = true,
		front = front,
		text = text ,
		callback=function()
			
			local list
			list = SelectList:new( "equip", self.contentLayer,display.newSprite(COMMONPATH .. "title/equip_text.png") , {
				btn_opt = "ok.png",
				all = true,
				filter = filter,
				priority = -202,
				showTitle = true , 
				-- exceptUse = exceptUse,
				optCallback = function(data)
					mask:remove()
					list:destroy()

					HTTP:call("equip", "resolve_fivestar_equip_detail", {equip_key = data.id} , {
					success_callback = function(_data)

						param.data = _data
						param.equip_id = data.id

						self:zhuanShuResolve( param )
					end})

				end
			})

			self.layer:addChild(list:getLayer())

		end
		}):getLayer()
	layer:addChild( frame )

	local zhuanshuResolveBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"} , display.cx , 330 ,{ 
		priority = -201-1,
		anchMid = true,
		front = GOLDEQUIPPATH.."zhuanshu/zhuanshu_resolve_label.png",
		callback=function()

				if not equip_id then 
					KNMsg:getInstance():flashShow("请先选择装备")
					return
				end

				showTip({
					content = createLabel({str = param.data.msg or "", size = 22, width = 400 , height  = 300}),
					priority = -220,
					left = {
						path = COMMONPATH,
						normal = "btn_bg_red.png",
						pre = "btn_bg_red_pre.png",
						front = COMMONPATH.."ok.png",
						remove = true,
						callback = function()
							HTTP:call("equip", "resolve_fivestar_equip", {equip_key = equip_id} , {
								success_callback = function(data)
									KNMsg:getInstance():flashShow(data.msg or "")
									mask:remove()

									if self.curItem[1] and self.curItem[1] == equip_id then 
										self.curItem = {}
									end

									if self.curItem[4] and self.curItem[4] == equip_id then 
										self.curItem = {}
									end
									
									if param.refreshCallBack then 
										param.refreshCallBack()
										dump(self.curItem)
									end

								end
							})
						end
					},
					right = {
							 path = COMMONPATH, 
							 normal = "btn_bg_red.png", 
							 pre = "btn_bg_red_pre.png",
							 front = COMMONPATH.."cancel.png",
							 remove = true
			    	}})

		end
		}):getLayer()
	layer:addChild( zhuanshuResolveBtn )


	local str = "注：可分解装备为5星装备部件、五星套装、以及五星灵魂装备，获得精铁。装备分解不会返还淬炼石，魔导石，灵魂图纸，五星装备，只会返还35%的强化银两。"

	layer:addChild( createLabel({str = str , x = 53, y = 248,size = 14, width = 384 , height =84,color = ccc3(66 , 24 , 8)}) )

	self.contentLayer:addChild( mask:getLayer() )

end


function PoolLayer:zhuanShuClean(param , refreshCallBack ,  equip_id)

	local layer = display.newLayer()

	local mask = KNMask:new({item = layer, click = function(x, y)  end ,priority= -201})

	layer:addChild( display.newSprite( IMG_PATH  .. "image/scene/mission/wipe_bg.png", display.cx , 206 , 0.5 , 0 ) )

	layer:addChild( display.newSprite( IMG_PATH  .. "image/scene/mission/title_bg.png" , display.cx + 30 , 548 , 0.5 , 0 ) )
	layer:addChild( display.newSprite( GOLDEQUIPPATH.."zhuanshu/zhuanshu_clean_title.png" , display.cx , 541 , 0.5 , 0 ) )

	local colseBtn = KNBtn:new(COMMONPATH,{"back_img.png","back_img_press.png"} , 40 , 516 ,{ scale = true,priority = -201-1,callback=
				function()
					mask:remove()
				end}):getLayer()
	layer:addChild( colseBtn )

	local filter = {}

	filter.star = 5
	filter.interval_pro_lv = { 1,5 } 					-- 只选择在 1到最大等阶的数据

	local bagData , front , text

	if equip_id then 
		bagData = DATA_Bag:get("equip", equip_id.."")
		front = getImageByType( bagData.cid , "s")
		text =  { bagData.name..( bagData.lv and " Lv"..bagData.lv or "") .. "\n" .. "专属：".. getConfig("general" , bagData.pro_gid , "name"), 14, ccc3(66 , 24 , 8), ccp(0, -55) }
	end

	local frame = KNBtn:new(SCENECOMMON,{"skill_frame1.png"} , display.cx , 452 ,{ 
		priority = -201-1,
		anchMid = true,
		front = front,
		text = text ,
		callback=function()
			
			local list
			list = SelectList:new( "equip", self.contentLayer,display.newSprite(COMMONPATH .. "title/equip_text.png") , {
				btn_opt = "ok.png",
				all = true,
				filter = filter,
				priority = -202,
				showTitle = true , 
				-- exceptUse = exceptUse,
				optCallback = function(data)
					mask:remove()
					list:destroy()

					self:zhuanShuClean(param , refreshCallBack , data.id)
				end
			})

			self.layer:addChild(list:getLayer())

		end
		}):getLayer()
	layer:addChild( frame )


	if equip_id then 
		local effect = getZhuanshuLabel( bagData.pro_lv ) 
		setAnchPos( effect , 0 , 13  ,0  ,0 )
		frame:addChild( effect , 100 )
	end

	local zhuanshuCleanBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"} , display.cx , 330 ,{ 
		priority = -201-1,
		anchMid = true,
		front = GOLDEQUIPPATH.."zhuanshu/zhuanshu_clean_label.png",
		callback=function()

				if not equip_id then 
					KNMsg:getInstance():flashShow("请先选择装备")
					return
				end

				HTTP:call("equip", "resolve_proprietary_equip_detail", {equip_key = equip_id} , {
					success_callback = function(data)
						showTip({
						content = createLabel({str = replaceStr(data.msg or ""), size = 22, width = 400 , height  = 300}),
						priority = -220,
						left = {
							path = COMMONPATH,
							normal = "btn_bg_red.png",
							pre = "btn_bg_red_pre.png",
							front = COMMONPATH.."ok.png",
							remove = true,
							callback = function()
								HTTP:call("equip", "resolve_proprietary_equip", {equip_key = equip_id} , {
									success_callback = function(data)
										KNMsg:getInstance():flashShow(data.msg or "")
										mask:remove()

										if self.curItem[1] and self.curItem[1] == equip_id then 
											self.curItem = {}
										end

										if self.curItem[4] and self.curItem[4] == equip_id then 
											self.curItem = {}
										end

										if refreshCallBack then 
											dump(self.curItem ,"self.curItem")
											refreshCallBack()
										end

									end
								})
							end
						},
						right = {
								 path = COMMONPATH, 
								 normal = "btn_bg_red.png", 
								 pre = "btn_bg_red_pre.png",
								 front = COMMONPATH.."cancel.png",
								 remove = true
				    	}})

					end
				})

		end
		}):getLayer()
	layer:addChild( zhuanshuCleanBtn )


	local str = replaceStr("装备的专属权移除后，专属效果消失，返还合成时所使用英雄（英雄等级变为1）。材料返还80% 。完全清除此装备的专属阶位。")

	layer:addChild( createLabel({str = str , x = 53, y = 248,size = 14, width = 384 , height =84,color = ccc3(66 , 24 , 8)}) )

	self.contentLayer:addChild( mask:getLayer() )

end

function PoolLayer:getComposeConfigWithCid(cid)
		for key , value in pairs(getConfig("equipGoldCompose")) do
			if tonumber(value["basics"]) == tonumber(cid) then
				return key , value["basics"] , value["drawing"]
			end
		end
end

function PoolLayer:getLayer()
	return self.layer end

return PoolLayer
