local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH, "GameLuaScript/Scene/common/baseElement")
local PATH = IMG_PATH.."image/scene/galaxy/"

local TABLETYPE 	--当前选中场景类型 
local SCENETYPE 	--当前选中场景类型 
local ADDITION , RESOLVE = 1 , 2	--开启 分解
local PET , HERO , SKILL = 1 , 2 , 3 	--场景

local keyElement = { "pet" , "general" , "skill" }
local openLvElement = { 80 , 80 , 8 }	--技能转不开放

local indexKey = { atk = 1 ,  agi = 2 , def = 3 , hp = 4  }
local textConfig = { atk = "攻击" , agi = "敏捷" , def = "防御" , hp = "血量"  }
local attribCofnig = { "atk" , "agi" , "def" , "hp"  }

local M = {
}

function M:new(params)
	params = params or {}
	
	TABLETYPE = params.type or HERO
	
	local this = {}
	setmetatable(this,self)
	self.__index = self
	
	this.baseLayer = display.newLayer()	--基础层
	this.viewLayer = display.newLayer()	--加成层
	this.baseLayer:addChild( this.viewLayer )
	--返回回调
	local function backFun()
		if SCENETYPE == ADDITION then
			params.backFun()
		elseif SCENETYPE == RESOLVE then
			switchScene("galaxy" , { backFun = params.backFun , type = ( TABLETYPE == 3 and 2 or TABLETYPE ) })	--判断屏蔽分解中技能返回加成界面的技能
		end
	end
	--导航信息
	local info = InfoLayer:new( "galaxy" , 0 , {tail_hide = true , title_text = PATH .. "galaxy_title.png" , closeCallback = backFun})
	this.baseLayer:addChild(info:getLayer() , 2)	
	
	--创建角色列表
	this:createRoleList(  )
	return this.baseLayer
end
--过滤数据
function M:filterData( key , lv , params )
	params = params or {}
	local items = DATA_Bag:getTable( key )
	local tempData = {}
	for k , v in pairs( items ) do
		if getConfig( key , v.cid , "star") == lv then
			tempData[ k ] = v 
		end
	end
	items = tempData
	local idGather = {}
	for key , v in pairs( items ) do
		if table.nums( params ) ~= 0  then
			idGather[ #idGather + 1 ] = {}
			idGather[ #idGather].id =  v.id
			for k , value in pairs( params ) do
				idGather[ #idGather][ k .. "" ] = v[ k .. "" ]
			end
		else
			idGather[ #idGather + 1 ] =  v.id
		end
	end
	return items , idGather
end
--创建角色列表
function M:createRoleList( params )
	params = params or {}
	local defID = params.defid or nil
	SCENETYPE = ADDITION 	--当前选中场景类型 
	GLOBAL_INFOLAYER:refreshTitle( PATH .. "galaxy_title.png" )
	
	if self.viewLayer then
		self.viewLayer:removeFromParentAndCleanup( true )
		self.viewLayer = nil
	end
	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )
	
	self.viewLayer:addChild( display.newSprite( PATH .. "bg.jpg" ,  0 , 88 , 0 , 0 ) )	--界面背景
	self.viewLayer:addChild( display.newSprite( PATH .. "add_info_bg.png" ,  display.cx , 584 , 0.5 , 0 ) )	--属性加成背景
	self.viewLayer:addChild( display.newSprite( COMMONPATH.."tab_line.png"  , 6 , 637 , 0 , 0 ) , 11 )		--分隔线
	self.viewLayer:addChild( display.newSprite( PATH .. "add_info_bg.png" ,  display.cx , 584 , 0.5 , 0 ) )	--属性加成背景
	self.viewLayer:addChild( display.newSprite(SCENECOMMON.."cbox.png" , display.cx , 650 , 0.5 , 0 ) )		--角色背景
	
	self.additionText1 = display.strokeLabel( "" , 85  , 585 , 20 , ccc3( 0xf7 , 0xf9 , 0xe1 ) , nil , nil , { dimensions_width = 140 , dimensions_height = 56 , align = 0 } )
	self.viewLayer:addChild( self.additionText1 )
	self.additionText2 = display.strokeLabel( "" , 227  , 585 , 20 , ccc3( 0xf7 , 0xf9 , 0xe1 ) , nil , nil , { dimensions_width = 140 , dimensions_height = 56 , align = 0 } )
	self.viewLayer:addChild( self.additionText2 )
	
	--剩余灵源值
	
	self.lingyuanText = display.strokeLabel( DATA_Account:get( "lingyuan" ) , 237  , 128 , 20 , ccc3( 0xfd , 0xfa , 0xd7 )  ) 
	self.viewLayer:addChild( self.lingyuanText , 10 )	
	
	
	--等级排序
	local _ , items =  self:filterData( keyElement[ TABLETYPE ] , 5 , { lv = true } )
	local function rule( l, r )
		local lValue = items[l].lv
		local rValue = items[r].lv
		
		return lValue > rValue
	end
	local result = getSortList( items , rule )
	local oldIndex = 1
	local iconGroup = KNRadioGroup:new()	--icon单选
	local iconScroll = KNScrollView:new( 60 , 575 + 67  , 360 , 100 , 10 , true , 0 , { turnBtn = COMMONPATH.."next.png" } )
	local pos = 0 --元素所在的位置
	local temp,state
	for i = 1 , #result do
		pos = pos + 1
		local p = pos --需要新定义一个变量，记录当前位置
		local index = result[i]
		local curID = tonumber( items[ index ].id )
		if defID and defID == curID then
			defID = i
		end
		local curLv = items[ index ].lv
		temp = KNBtn:new( SCENECOMMON , {"skill_frame1.png", "select1.png"} , 0 , 0 ,
			{
				id = curID ,
				upSelect = true ,
				selectZOrder = 12,
				parent = iconScroll,
				front = getImageByType( DATA_Bag:get( keyElement[ TABLETYPE ] , curID , "cid" ) , "s" ) ,
				other =( curLv < openLvElement[ TABLETYPE ] and { { PATH .. "lv_lack.png" , 3 , 3} } or nil ) , 
				noHide = true,
				callback = function()
					if curLv < openLvElement[ TABLETYPE ] then
						local str
						if TABLETYPE == PET then
							str = replaceStr( "幻兽" ) .. "等级不到".. openLvElement[PET] .. "级"
						elseif TABLETYPE == HERO then
							str = replaceStr( "英雄" ) .. "等级不到".. openLvElement[HERO] .. "级"
						elseif TABLETYPE == SKILL then
						end
						KNMsg.getInstance():flashShow( str )
						return false
					end
					
					oldIndex = pos
					self:createInfo(curID)
					iconScroll:scrollTo( curID )
						
				end,
			},iconGroup)
		iconScroll:addChild(temp:getLayer(),temp)
	end
	if defID then
		iconGroup:chooseByIndex( oldIndex , true )
	else
		if pos == 0 or items[result[1]]["lv"] < openLvElement[ TABLETYPE ] then
			iconGroup:cancelChoose()
		else
			iconGroup:chooseByIndex( oldIndex , true)
		end	
	end
	iconScroll:alignCenter()
	self.viewLayer:addChild(iconScroll:getLayer())
	
	
	
	--获取灵源值
	self.viewLayer:addChild( KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 357, 592 ,{
				front = PATH .. "get_soul.png",
				callback = function()
					self:createResolve()
				end
			}):getLayer() )
	

	
	
	local lightBg = display.newSprite(IMG_PATH .. "image/scene/home/light_bg.png" , 245 , 60 , 0.5 , 0.5 )
	self.viewLayer:addChild(lightBg)
	lightBg:runAction(CCRepeatForever:create(CCRotateBy:create(5,20)))
	
	
	--角色切换按钮
	local addConfig = { 
						pet = { 30 , 95 } , 
						general = { display.cx - 60 , 176 } , 
						skill = { 330 , 95 }  
						}
	local roleBtn = {} 
	for i = 1  , #keyElement do
		local curKey = keyElement[i] .. ""
		roleBtn[ curKey ] = KNBtn:new( PATH , { curKey .. ".png", curKey .. "_pre.png"}, addConfig[curKey][1], addConfig[curKey][2] ,{
					callback = function()
						if i == 3 then
							KNMsg.getInstance():flashShow("功能暂未开放，敬请期待！")
						else
							TABLETYPE = i
							self:createRoleList()
						end
					end
				}):getLayer() 
		self.viewLayer:addChild( roleBtn[ keyElement[i] .. "" ] )
	end
	
	self.viewLayer:addChild( display.newSprite(PATH .. "residue_bg.png" , display.cx , 115 , 0.5 , 0 ) )	--剩余值背景
	self.viewLayer:addChild( display.newSprite(PATH .. "surplus.png" , display.cx , 115 , 0.5 , 0 ) )	--剩余值背景
end

--生成单个角色星图
function M:createInfo( _id , key )
	local curKey = key or "atk"
	self.lingyuanText:setString( DATA_Account:get( "lingyuan" ) )
	
	if self.mapLayer then
		self.mapLayer:removeFromParentAndCleanup( true )
		self.mapLayer = nil
	end
	
						
	local function createStr( data , key )
		local str = ""
		if data[ key .. "_xdlv" ] and  data[ key .. "_xdlv" ] ~= 0 then
			str = textConfig[key] .. ":" .. data[ key .. "_xd" ]
		else
			str = textConfig[key] .. "：0"
		end
		return str
	end
	local data , str
	if TABLETYPE == PET or TABLETYPE == SKILL then
		data = DATA_Bag:get( keyElement[TABLETYPE] , _id )
		if data.lv < openLvElement[ TABLETYPE ] then
			return
		end
		curKey = attribCofnig[1]
		self.mapLayer = self:createCell( curKey , data )
		str = createStr( data , curKey )
		self.additionText1:setString( str )	--当前加成数据
		setAnchPos( self.mapLayer , 0 , 235 , 0 , 0 )
		self.baseLayer:addChild( self.mapLayer )
	else
		str = { }
		data = DATA_General:get( _id )
		if data.lv < openLvElement[ TABLETYPE ] then
			return
		end
--		local mapScrollLayer = KNScrollView:new( 0 , 0  , 480 , 590 , 0 , true , 1 , { turnBtn = PATH.."next.png" , leftBtnOff = { x = 57 , y = -100 } , rightBtnOff = { x = -57 , y = -100 }  } )
		local mapScrollLayer = KNScrollView:new( 0 , 235  , 480 , 355 , 0 , true , 1  )
		for i = 1  , table.nums( attribCofnig ) do
			str[ #str + 1 ] = createStr( data , attribCofnig[ i ] )
			mapScrollLayer:addChild(self:createCell( attribCofnig[ i ] , data ) )
		end
		
		local curIndex = indexKey[curKey]
		mapScrollLayer:setIndex( curIndex , true )
		
		
		
		self.additionText1:setString( str[1] .. "\n" .. str[2] )
		self.additionText2:setString( str[3] .. "\n" .. str[4] )
		self.mapLayer = mapScrollLayer:getLayer()
		
		local leftBtn = KNBtn:new( PATH , { "next.png" } , 0 , 180 ,
				{
					scale = true , 
					callback = 
					function()
						if curIndex <=1 then
							curIndex = 1
						else
							curIndex = curIndex - 1 
							mapScrollLayer:setIndex( curIndex )
						end
					end
				})
		leftBtn:setFlip(true)
		self.mapLayer:addChild( leftBtn:getLayer()  )
		self.mapLayer:addChild( KNBtn:new( PATH , { "next.png" }  , 425 , 180 ,
				{
--					priority = -130,
					scale = true , 
					callback = 
					function()
						if curIndex >= 4 then
							curIndex = 4
						else
							curIndex = curIndex + 1 
							mapScrollLayer:setIndex( curIndex )
						end
					end
				}):getLayer() )
		self.baseLayer:addChild( self.mapLayer )
	end
	
	
end


function M:createCell( key , data )
	
	local cutType = key
	local starAdd = self:getStarAdd( cutType )
	local layer = display.newLayer()
	
	local openLv = ( data[key .. "_xdlv"] and data[key .. "_xdlv"] or 0 ) + 1 
	local maxNum = table.nums( starAdd ) - 2	--最大星点数
	
	local additionValue = 0
	local additionConfig , str
	if TABLETYPE == PET or TABLETYPE == PET then
		additionConfig = getConfig( keyElement[TABLETYPE] .. "star")
		if openLv >= table.nums( additionConfig ) then
			additionConfig = additionConfig[ table.nums( additionConfig ) ]
		else
			additionConfig = additionConfig[ openLv ]
		end
		additionValue = additionConfig[key .. "_jiacheng"]
		str = { 
				additionConfig[ key .. "_xiaohao" ] , 
				textConfig[key] .. ":" .. additionValue , 
				additionConfig["silver"] ,
				additionConfig[key .. "_gailv"] .. "%" 
				}
	else
		additionConfig = getConfig( keyElement[TABLETYPE] .. "star")[key]
		if openLv >= table.nums( additionConfig ) then
			additionConfig = additionConfig[ table.nums( additionConfig ) ]
		else
			additionConfig = additionConfig[ openLv ]
		end
		additionValue = additionConfig["jiacheng"]
		str = { 
				additionConfig["xiaohao" ] , 
				textConfig[key] .. ":" .. additionValue , 
				additionConfig["silver"]  ,
				additionConfig["gailv"] .. "%" 
				}
	end
	--是否开启
	local function getIsOpen( curIndex )
		return  curIndex < openLv
	end
	--发送请求
	local function sendFun( curValue )
		if getIsOpen( curValue ) then
			KNMsg.getInstance():flashShow( replaceStr( "已开启！" ) )
			return
		end
		
		local function openFun()
			
			if TABLETYPE == HERO then
				if cutType ~= "atk" then
					local preKey = attribCofnig[ indexKey[cutType] - 1 ]
					if tonumber( data[ preKey .. "_xdlv" ] ) < 3 then
						KNMsg.getInstance():flashShow( "请先开启" .. textConfig[ preKey ] .. replaceStr("星图") .. "第三个点!" )
						return			
					end
				end
			end
			
			if DATA_Account:get( "lingyuan" ) < tonumber( str[1] ) then
				KNMsg.getInstance():flashShow( replaceStr( "灵源值" ) .. "不足，请通过活动或".. replaceStr( "分解" ) .. replaceStr( "卡牌" ) .. "来获得" )
				return
			end
			if DATA_Account:get( "silver" ) < tonumber( str[3] ) then
				KNMsg.getInstance():flashShow( replaceStr( "银两" ) .. "不足，无法开启！" )
				return
			end

			HTTP:call(keyElement[TABLETYPE] .. "", "xingtu_up", { type  = ( TABLETYPE == 2 and key or nil )  , id = data.id , tolv = openLv } , {success_callback = 
			function(tempData)
				if tonumber( tempData.isup ) == 1 then
					--成功
					local tempLayer = baseMask( {  titlePath = PATH .. "open_succeed_title.png" , isConfirm = { path = COMMONPATH .. "confirm.png" , confirmFun = function() self:createInfo(data.id , key ) end } } )	
					local tempStr = "恭喜开启" .. textConfig[cutType] .. replaceStr( "星座点" ) .."!\n" .. textConfig[cutType] .. "增加"  .. additionValue
					--最后一个点附加 值
					if tempData.add and tempData.add ~= 0 then
						tempStr = tempStr .. "\n额外获得奖励：" .. textConfig[key] .. replaceStr( "星座" ) .."属性加" .. tempData.add
					end
					
					local nextIndex = indexKey[key] + 1	--下一星图索引 等于四没有下一星图
					if openLv == 3 and TABLETYPE == HERO and nextIndex <= table.nums(indexKey)  then
						tempStr = tempStr .. "\n【" .. replaceStr( "英雄" ) .. textConfig[ attribCofnig[ nextIndex ] ]  .."】" .. replaceStr("星路图") .. "开启!"
					end
					
					tempLayer:addChild( display.strokeLabel( tempStr  , 40 , 320 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , { dimensions_width = 400 , dimensions_height = 200 , align = 1 } ) )
				else
					local tempLayer = baseMask( {  titlePath = PATH .. "open_lost_title.png" , isConfirm = { path = COMMONPATH .. "confirm.png" , confirmFun = function() self:createInfo(data.id , key ) end } } )	
					local tempStr = "开启失败!\n"
					
					if tempData.lys and tonumber(tempData.lys ) ~= 0 then
						tempStr = tempStr .. "恭喜您获得返还道具：\n" .. replaceStr("灵源石") .. "x" .. tempData.lys
					end
					tempLayer:addChild( display.strokeLabel( tempStr  , 40 , 320 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , { dimensions_width = 400 , dimensions_height = 200 , align = 1 } ) )
				end
			end})
		end
		
		local tempLayer = baseMask( {  titlePath = PATH .. "galaxy_popup_title.png" , isShowBack = true , isConfirm = { path = IMG_PATH .. "image/scene/gang/shop/open_text.png" , confirmFun = openFun } } )	
		tempLayer:addChild( display.newSprite( PATH .. "open_tip_text.png" , 100 , 434 , 0 , 0 ))
		
		tempLayer:addChild( display.strokeLabel( str[1] , 245  , 538 , 20 , ccc3( 0x2c , 0x00 , 0x00 )  ))
		tempLayer:addChild( display.strokeLabel( str[2] , 222  , 504 , 20 , ccc3( 0x2c , 0x00 , 0x00 )  ))
		tempLayer:addChild( display.strokeLabel( str[3] , 245  , 470 , 20 , ccc3( 0x2c , 0x00 , 0x00 )  ))
		tempLayer:addChild( display.strokeLabel( str[4] , 206  , 436 , 20 , ccc3( 0x2c , 0x00 , 0x00 )  ))
		
		
	end

	
	--最终按钮
	local endBtn = KNBtn:new( PATH , { ( getIsOpen(maxNum + 1 ) and  cutType or ( cutType .. "_dis" ) ) .. ".png" } , 0 , 0 , {scale = true , callback = function() sendFun( maxNum + 1 ) end})
			
	endBtn:setEnable( getIsOpen( maxNum ) )
	setAnchPos( endBtn:getLayer() , starAdd.x  , starAdd.y )
	layer:addChild( endBtn:getLayer() )
	

	
	local function starCell( temp )
		local starBtn = KNBtn:new( PATH , { ( getIsOpen( temp.index ) and  "star.png" or "star_dis.png" )   } , - 33.5 , -32 , {scale = true , callback = function() sendFun(temp.index) end })
		starBtn:setEnable( getIsOpen( temp.index - 1 ) )
		local bulkingX , bulkingY = ( temp.nextP.x - temp.cutP.x ) / 2  , ( temp.nextP.y - temp.cutP.y ) / 2 	--计算两点中间点偏移值
		local line = display.newSprite( PATH .. "line.png" , 33.5 + bulkingX  , 32 + bulkingY  , 0.5 , 0.5 )
		line:setRotation( countAngle( temp ) )
		starBtn:getLayer():addChild( line )
		return starBtn:getLayer()
	end
	
	for i = 1 , maxNum do
		local curData = starAdd[ i .. "" ]
		local bPoint 
		if i == maxNum then
			bPoint = starAdd
		else
			bPoint = starAdd[ ( i + 1 ) .."" ]
		end
		
		if curData.target then
			bPoint = starAdd[ curData.target .. "" ]
		end
		local curStar = starCell(  { cutP = curData , nextP = bPoint , index = i }  )
		setAnchPos( curStar , curData.x  , curData.y  , 0.5 , 0.5)
		layer:addChild( curStar )
	end
	
	--加成显示
	local function showAddition()
		local curAddress	--当前坐标地址
		if openLv > maxNum then
			curAddress = { x = starAdd.x , y = starAdd.y }
		else
			 curAddress = starAdd[ openLv .. "" ]
		end
		local addX = curAddress.x - 20
		addX = addX<0 and 5 or addX
		addX = ( addX+58 > display.width ) and ( display.width - 58 ) or addX
		local addY = curAddress.y - 20
		local tempY = curAddress.y - 20
		if tempY < 50 then tempY = curAddress.y + 45 + 29 end
		
		layer:addChild( display.newSprite( PATH .. "addition_bg.png" , addX , tempY , 0 , 0 ) )
		layer:addChild( display.strokeLabel( textConfig[key] .. ":" .. additionValue , addX  , tempY , 18, ccc3( 0xfd , 0xfa , 0xd7 ) , nil , nil , { dimensions_width = 106 , dimensions_height = 25 , align = 1 } ) )
		
		local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
		local ani = display.playFrames( addX+55  , addY+51 ,frames, 0.2, {
			forever = true,
		})
		layer:addChild(ani,5)
	end
	if openLv -1 <= maxNum then
		showAddition()
	end
	
	layer:setContentSize( CCSize:new( display.width , 312 ) )
	
	return layer , data
end




--星系配置图
function M:getStarAdd( key )
	local offX = -40
	local offY = -40 - 235
--	local starAdd = { 
--			atk = {
--					["1"] = { x = 73 + offX , y = 525 + offY } ,
--					["2"] = { x = 167 + offX , y = 472 + offY , target = 4 } ,
--					["3"] = { x = 260 + offX , y = 535 + offY , target = 2 } ,
--					["4"] = { x = 79 + offX , y = 391 + offY } ,
--					["5"] = { x = 176 + offX , y = 322 + offY } ,
--					["6"] = { x = 244 + offX , y = 407 + offY } ,
--					x = 380 + offX , 
--					y = 400 + offY , 
--			},
--			def = {
--					["1"] = { x = 78 + offX , y = 536 + offY } ,
--					["2"] = { x = 191 + offX , y = 550 + offY } ,
--					["3"] = { x = 115 + offX , y = 468 + offY } ,
--					["4"] = { x = 240 + offX , y = 469 + offY } ,
--					["5"] = { x = 359 + offX , y = 453 + offY } ,
--					["6"] = { x = 249 + offX , y = 399 + offY } ,
--					["7"] = { x = 117 + offX , y = 353 + offY } ,
--					["8"] = { x = 246 + offX , y = 327 + offY } ,
--					x = 394 + offX , 
--					y = 335 + offY , 
--			} , 
--			agi = {
--					["1"] = { x = 94 + offX , y = 486 + offY } ,
--					["2"] = { x = 201 + offX , y = 548 + offY } ,
--					["3"] = { x = 331 + offX , y = 542 + offY } ,
--					["4"] = { x = 410 + offX , y = 468 + offY } ,
--					["5"] = { x = 379 + offX , y = 355 + offY } ,
--					["6"] = { x = 254 + offX , y = 332 + offY } ,
--					["7"] = { x = 109 + offX , y = 332 + offY } ,
--					x = 230 + offX , 
--					y = 410 + offY , 
--			} , 
--			hp = {
--					["1"] = { x = 102 + offX , y = 553 + offY } ,
--					["2"] = { x = 209 + offX , y = 525 + offY } ,
--					["3"] = { x = 318 + offX , y = 540 + offY } ,
--					["4"] = { x = 442 + offX , y = 541 + offY } ,
--					["5"] = { x = 387 + offX , y = 465 + offY } ,
--					["6"] = { x = 292 + offX , y = 402 + offY , target = 9 } ,
--					["7"] = { x = 188 + offX , y = 438 + offY , target = 6 } ,
--					["8"] = { x = 387 + offX , y = 323 + offY , target = 6 } ,
--					["9"] = { x = 215 + offX , y = 313 + offY } ,
--					x = 50 + offX , 
--					y = 313 + offY , 
--			} , 
--		
--		}
	local starAdd = { 
			atk = {
					["1"] = { x = 228 + offX , y = 553 + offY } ,
					["2"] = { x = 181 + offX , y = 445 + offY } ,
					["3"] = { x = 65 + offX , y = 371 + offY } ,
					["4"] = { x = 195 + offX , y = 300 + offY } ,
					["5"] = { x = 267 + offX , y = 416 + offY } ,
					["6"] = { x = 360 + offX , y = 504 + offY } ,
					x = 400 + offX , 
					y = 360 + offY , 
			},
			agi = {
					["1"] = { x = 163 + offX , y = 540 + offY } ,
					["2"] = { x = 302 + offX , y = 541 + offY } ,
					["3"] = { x = 373 + offX , y = 456 + offY } ,
					["4"] = { x = 350 + offX , y = 348 + offY } ,
					["5"] = { x = 229 + offX , y = 304 + offY } ,
					["6"] = { x = 112 + offX , y = 352 + offY } ,
					x = 236 + offX , 
					y = 436 + offY , 
			} , 
			def = {
					["1"] = { x = 187 + offX , y = 526 + offY } ,
					["2"] = { x = 90 + offX , y = 422 + offY } ,
					["3"] = { x = 220 + offX , y = 440 + offY } ,
					["4"] = { x = 159 + offX , y = 320 + offY } ,
					["5"] = { x = 277 + offX , y = 375 + offY } ,
					["6"] = { x = 343 + offX , y = 474 + offY } ,
					x = 382 + offX , 
					y = 337 + offY , 
			} , 
			hp = {
					["1"] = { x = 187 + offX , y = 509 + offY } ,
					["2"] = { x = 297 + offX , y = 540 + offY } ,
					["3"] = { x = 424 + offX , y = 540 + offY } ,
					["4"] = { x = 395 + offX , y = 436 + offY } ,
					["5"] = { x = 305 + offX , y = 364 + offY } ,
					["6"] = { x = 194 + offX , y = 312 + offY } ,
					x = 83 + offX , 
					y = 415 + offY , 
			} , 
		
		}
	return starAdd[key]
end		
--分解
function M:createResolve( params )
	params = params or {}
	local defTable = params.defTale	--默认table
	SCENETYPE = RESOLVE 	--当前选中场景类型 
	
	local tableLayer , selectLv
	GLOBAL_INFOLAYER:refreshTitle( PATH .. "resolve_title.png" )
	local gatherData = {}
	if self.mapLayer then
		self.mapLayer:removeFromParentAndCleanup( true )
		self.mapLayer = nil
	end
	if self.pageLayer then
		self.pageLayer:removeFromParentAndCleanup( true )
		self.pageLayer = nil
	end
	if self.viewLayer then
		self.viewLayer:removeFromParentAndCleanup( true )
		self.viewLayer = nil
	end
	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )
	
	self.viewLayer:addChild( display.newSprite(COMMONPATH.."dark_bg.png",0,425,0,0.5) )	--背景
	self.viewLayer:addChild( display.newSprite(COMMONPATH.."bg_img.png",display.cx,184,0.5,0) )	--背景
	self.viewLayer:addChild( display.newSprite(PATH.."resolve_flag.png",20,656,0,0) )	--分解logo
	self.viewLayer:addChild( display.newSprite(PATH.."cur_text.png",112,673,0,0) )	--现有及转换后
	
	
	local haveValue , convertValue
	haveValue = display.strokeLabel( DATA_Account:get( "lingyuan" ) , 250 , 708 , 20, ccc3( 0xfd , 0xfa , 0xd7 )  ) 	--当前拥有值
	self.viewLayer:addChild( haveValue )	
	convertValue = display.strokeLabel( "0" , 250 , 678 , 20, ccc3( 0xfd , 0xfa , 0xd7 )  ) 	--转换值
	self.viewLayer:addChild( convertValue )	
	local singleValue
	local function selectFun( value , flag )
		if flag then
			gatherData[ value.id .. "" ] =  nil
		else
			gatherData[ value.id .. "" ] = value.id
		end
		singleValue = getConfig( "lingyuan"  , ( keyElement[TABLETYPE] == "general" and "hero" or keyElement[TABLETYPE] ) .. "" )
		singleValue = tonumber( singleValue[ selectLv ]["num"])
		convertValue:setString( tostring( singleValue * table.nums( gatherData ) ) )
	end
	local listConfig = { { 4 , 5 } , { 3 , 4 , 5 } , { 3 , 4 , 5 } }
	tableLayer = tableList( { listConfig = {  path = COMMONPATH .. "tab/tab_star"  , config = listConfig[TABLETYPE] } , def = ( defTable or listConfig[TABLETYPE][1] ) ,  clickFun = function( key ) convertValue:setString(0) selectLv = key gatherData = {} self:createPage( key , selectFun ) end } )
	self.viewLayer:addChild( tableLayer )
	
	local oneBtn , twoBtn
	local btnConfig = { { "general" , "skill" } ,  { "pet" , "skill" } , { "pet" , "general" }}
	local function clickFun( key )
		for i = 1 , #keyElement do
			if keyElement[i] ==  key then
				TABLETYPE = i
				break
			end
		end
		self:createResolve()
	end
	
	
	oneBtn = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"} , 377 , 696 ,{
				front = PATH .. btnConfig[TABLETYPE][1] .. "_text.png",
				callback = function()
					clickFun( btnConfig[TABLETYPE][1] )
				end
			}):getLayer()
	self.viewLayer:addChild( oneBtn )
	twoBtn = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"} , 377 , 644 ,{
				front = PATH .. btnConfig[TABLETYPE][2] .."_text.png",
				callback = function()
					clickFun( btnConfig[TABLETYPE][2] )
				end
			}):getLayer()	
	self.viewLayer:addChild( twoBtn )
	

	--批量选择
	self.batchBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"} , 48 , 125 ,{
				front = COMMONPATH .. "batchSelect.png",
				callback = function()
					
					gatherData = {}  --清空
					
					local data = self:filterData( keyElement[ TABLETYPE ] , selectLv)
					local allKeys = table.keys(data) --所有key
					
					local  checkedKeys = {} --前20个key
					for i=1,#allKeys do
						if i<=20 then
							checkedKeys[i]=allKeys[i]
						end
					end
					
					self:createPage( selectLv , selectFun ,checkedKeys)
				end
			}):getLayer()
	self.viewLayer:addChild( self.batchBtn )
	self.transformBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"} , 272 , 125 ,{
				front = PATH .. "transform.png",
				callback = function()
					if table.nums( gatherData ) == 0  then
						local textConfig = { "幻兽" , "英雄" , "技能" }
						KNMsg.getInstance():flashShow( "请选择要" .. replaceStr( "分解" ) .. "的" .. replaceStr( textConfig[ TABLETYPE ] ) )
						return
					end
					local function sendFun()
							HTTP:call(keyElement[TABLETYPE] .. "", "exchange_ly", { ids = string.join( gatherData , ",")  } , {success_callback = 
							function()
								KNMsg.getInstance():flashShow( "分解成功,获得" .. tostring( singleValue * table.nums( gatherData ) ) .. replaceStr("灵源值！") )
								self:createResolve( { defTale = selectLv , resetRefresh = { selectLv = selectLv } } )
							end})
					end
					local tipStr = ""
					if TABLETYPE == HERO then
						tipStr = replaceStr( "英雄" ) .. replaceStr( "经验" ) .. "将被消耗掉，若存在".. replaceStr( "宝石" ) .. "，则".. replaceStr( "宝石" ) .. "等级下降一级后自动放入".. replaceStr( "背包" ) .. "中，是否确认转换所有英雄？"
					elseif TABLETYPE == PET then
						tipStr = replaceStr( "幻兽" ) ..  replaceStr( "经验" ) .. "将被消耗掉，".. replaceStr( "幻兽" ) .. "有高等级".. replaceStr( "技能" ) .. "将返还".. replaceStr( "元素之心" ) .. replaceStr( "道具" ) .. "，是否确认转换所有幻兽？"
					else
						tipStr = ""
					end
					
					if tipStr=="" then
						sendFun()
					else
						KNMsg.getInstance():boxShow( tipStr ,{ 
																confirmFun = sendFun, 
																cancelFun = function() end 
																} )
					end
		
				end
			}):getLayer()	
	self.viewLayer:addChild( self.transformBtn )
	
end
--单个页面
function M:createPage( starLv , backFun ,checkedKeys)
	local data = self:filterData( keyElement[ TABLETYPE ] , starLv)
	--上阵武将不可分解
	if TABLETYPE == HERO then
		for key , v in pairs(data) do
			if DATA_Formation:checkIsExist(v.id) then	
				data[key] = nil			
			end
		end
	elseif TABLETYPE == PET then
		--出战宠物不可分解
		for key , v in pairs(data) do
			if DATA_Pet:getFighting() == (v.id) then	
				data[key] = nil			
			end
		end
	elseif TABLETYPE == SKILL then
		--已经装备 技能不可分解
		for key , v in pairs(data) do
			if DATA_ROLE_SKILL_EQUIP:getRoleId(v.id, "skill") then
				data[key] = nil			
			end
		end
	end
	
	if self.pageLayer then
		self.pageLayer:removeFromParentAndCleanup( true )
		self.pageLayer = nil
	end
	self.pageLayer = display.newLayer(0)
	self.viewLayer:addChild(self.pageLayer)
	
	local sv = KNScrollView:new(0,187,480,397,0,false)	
	local temp_count = 0
	local temp_line = 1
	local layers = {}
	
	for k,v in pairs(data) do
		for i = 0 , ( v["num"] and v["num"]- 1 or 0 )  do
			temp_count = temp_count + 1
			if layers[ temp_line ] == nil then
				layers[ temp_line ] = display.newLayer()
				layers[ temp_line ]:setContentSize( CCSizeMake(480 , 80) )
			end
			local the_stone 
			the_stone = KNBtn:new(IMG_PATH.."image/scene/common" , {"skill_frame1.png","yes.png"} , 45 + 80 * (temp_count - 1),0 , {
											front = getImageByType(v["cid"] , "s"),
											other = {{IMG_PATH .. "image/common/egg_num_bg.png",46,46}},
											text = {v["lv"],18,ccc3(0xff,0xff,0xff),ccp(23,24),nil,17},
											noHide = true,
											parent = sv,
											selectable = true,
											selectZOrder = 20,
											selectOffset = {17,-16},
											callback = function()
											    
												backFun( v , the_stone:isSelect())
											end
										})
			layers[ temp_line ]:addChild(the_stone:getLayer())
			--批量选中
			if checkedKeys ~= nil and checkedKeys ~={} then
				if table.hasValue(checkedKeys,k) then
				  	the_stone:select(true,true)
				end
			end

			
			if temp_count == 5 then
				temp_line = temp_line + 1
				temp_count = 0
			end
		end
	end
	for i = 1 , #layers do
		sv:addChild( layers[i] )
	end
	self.pageLayer:addChild( sv:getLayer() )
	
	if table.nums(data) == 0  then
		self.pageLayer:addChild( display.newSprite( COMMONPATH .. "empty.png" , display.cx , display.cy , 0.5 , 0.5) )
	end
end

return M