local Email = {}

local PATH = IMG_PATH .. "image/scene/gang/email/"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")


function Email:create()
	local KNInputText

	if device.platform == "wp8" then
		KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNEditBox")
	else
		KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
	end

	-- 输入框
	local inputText
	local isInputing = false
	local openSoftKeyboard = function()
		if not isInputing then inputText:startInput() isInputing = true end
	end
	local closeSoftKeyboard = function()
		if isInputing then inputText:stopInput() isInputing = false end
	end

	local layer = baseMask( { titlePath = PATH .. "gang_email_title.png", isShowBack = { x = 30, y = 545, backFun = closeSoftKeyboard } } )

	-- 提示信息: 输入新昵称
	layer:addChild( display.newSprite( PATH .. "all_member.png", 45, 533, 0, 1.0 ) )

	if device.platform ~= "wp8" then

	    local inputBgBtn = KNBtn:new( PATH, { "inputBg.png" }, 45, 450,
	    {
				priority = -131,
				-- scale = true,
				callback = function()
					openSoftKeyboard()
				end
		})
		layer:addChild( inputBgBtn:getLayer() )

	end

 	inputText = KNInputText:new(
 				{	width = 365, 
					height = 28, 
					size = 20 , 
					defStr = "(26个汉字以内)", 
					existStr = nil,
					defColor = ccc3( 0x00, 0x00, 0x00 ), 
					inputColor = ccc3( 0x4d, 0x15, 0x15 ),
					normalBg = PATH .. "inputBg.png", -- only for wp8
					priority = -131, -- only for wp8
				})
	setAnchPos( inputText:getLayer() , 55, 473 )
	layer:addChild( inputText:getLayer() )


	-- 提示信息: (6个汉字以内)
	-- layer:addChild( display.strokeLabel( "(35个汉字以内)", 280, 420 + 80, 20 , ccc3(0x2c , 0x00 , 0x00 ), 2, ccc3(0x40 , 0x1d , 0x0c ), { dimensions_width = 130, dimensions_height = 30, align = 0 } ) )
	-- layer:addChild( display.strokeLabel( "说明：切勿使用特殊符号！", display.cx - 124 ,  420  , 20 , ccc3(0xff , 0x00 , 0x00 ), 2, ccc3(0x40 , 0x1d , 0x0c ), { dimensions_width = 250 , dimensions_height = 30 , align = 1 } ) )
	
	-- 确认按钮
	layer:addChild( KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 71,  356,
	{
		priority = -131,
		front = COMMONPATH .. "confirm.png" , 
		callback = function()
			local input = inputText:getString()
			if input == "" then
				KNMsg:getInstance():flashShow( "信息不能为空!" )
			-- elseif string.find(input, "%%") then
			-- 	KNMsg:getInstance():flashShow( "不能输入特殊字符!" )
			else
				closeSoftKeyboard()

				HTTP:call( "alliance", "sendmail", { content = input },
				{
					success_callback = function()
						layer:remove()
						KNMsg:getInstance():flashShow( "发送帮派邮件成功!" )
					end
				})
			end
		end
	} ):getLayer() )

	-- 取消按钮
	layer:addChild( KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 260,  356,
	{
		priority = -131 ,
		front = COMMONPATH .. "cancel.png" , 
		callback = function()
			closeSoftKeyboard()
			layer:remove()
		end
	} ):getLayer() )
	
	return layer
end

return Email