local PATH = IMG_PATH .. "image/scene/gang/red_packet/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNCheckBox = requires (IMG_PATH,"GameLuaScript/Common/KNCheckBox")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")

local M = {}

local selectIndex , paysnum  = 1

if device.platform == "android" then 
	paysnum = {
		{ rmb = 10 , gold = 100   , min = 5 , max = 10 },
		{ rmb = 30 , gold = 300   , min = 5 , max =  10},
		{ rmb = 50 , gold = 550   , min = 10 , max =15 },
		{ rmb = 100 , gold = 1150  , min = 10 , max = 15 },
		{ rmb = 200 , gold = 2400  , min = 10 , max = 20 },
		{ rmb = 500 , gold = 6500  , min = 10 , max = 20 },
	}
else
	paysnum = {
		{ rmb = 6 , gold = 60   , min = 5 , max = 10  },
		{ rmb = 30 , gold = 300   , min = 5 , max =  10 },
		{ rmb = 60 , gold = 660   , min = 10 , max =15 },
		{ rmb = 108 , gold = 1242   ,min = 10 , max = 15},
		{ rmb = 208 , gold = 2496  , min = 10 , max = 20 },
		{ rmb = 518 , gold = 6734   , min = 10 , max = 20 },
	}

end


function M:redPacketDispatcher(param)


	if param.has_get and tonumber(param.has_get) == 0 then 
		self:unpackRedPacket(param)
	else
		self:lookRedPacketList(param)
	end

end


function M:unpackRedPacket(_data)

	local layer = display.newLayer()

	local mask = KNMask:new( {item = layer , priority = -141} )


	local bg = display.newSprite( PATH .. "bg2.png" , display.cx , display.cy , 0.5 , 0.5 ):addTo( layer )
	local bgSize = bg:getContentSize()


	local icon = KNBtn:new(COMMONPATH, { getHeadPath( _data.from_user_logo ) },bgSize.width/2 , 561 ,{
		anchMid = true,
		front = COMMONPATH.."role_frame.png", 
		callback = function()
			
		end,
	} )
	bg:addChild( icon:getLayer() )

	local label1 = createLabel({str =  _data.from_username.."的红包" , width = bgSize.width , x = 0 , y = 472 , size = 18  , color = ccc3(213,213,213) , align = 1})
	setAnchPos( label1 , bgSize.width/2 , 504 , 0.5 , 0 )
	bg:addChild( label1 )

	local label2 = createLabel({str =  "发了一个红包，金额随机" , width = bgSize.width , x = 0 , y = 472 , size = 22  , color = ccc3(255,249,199) , align = 1})
	setAnchPos( label2 , bgSize.width/2 , 473 , 0.5 , 0 )
	bg:addChild( label2 )


	if tonumber(_data.is_over) ~= 0 then 
		local label3 = createLabel({str =  "手慢了，红包派完了" ,width = bgSize.width ,  x = 0 , y = 432 , size = 22  , color = ccc3(255,249,199) , align = 1})
		setAnchPos( label3 , bgSize.width/2 , 432 , 0.5 , 0 )
		bg:addChild( label3 )

		KNBtn:new(PATH, { "kankandajiashouqi.png" },bgSize.width/2 , 89 ,{
			anchMid = true , 
			priority = -142,
			callback = function()
				mask:remove()
				self:lookRedPacketList(_data)
			end,
		} ):getLayer():addTo( bg )

	else
		KNBtn:new(PATH, { "bg3.png" },bgSize.width/2 , 204 ,{
			anchMid = true , 
			text = {  "拆红包" , 28  , ccc3(255,255,255) , { x=0,y=0} }, 
			priority = -142,
			callback = function()
				mask:remove()
				self:lookRedPacketList(_data)
			end,
		} ):getLayer():addTo( bg )
	end

	KNBtn:new(PATH, { "close.png" },382 , 584 ,{
		priority = -142,
		callback = function()
			mask:remove()
			GLOBAL_INFOLAYER:refreshInfo()
		end,
	} ):getLayer():addTo( bg )


	display.getRunningScene():addChild( mask:getLayer() )

	return mask

end

function M:lookRedPacketList(param)

	local layer = display.newLayer()

	local mask = KNMask:new( {item = layer , priority = -141} )

	local bg = display.newSprite( PATH .. "bg1.png" , display.cx , display.cy , 0.5 , 0.5 ):addTo( layer )
	local bgSize = bg:getContentSize()


	local icon = KNBtn:new(COMMONPATH, { getHeadPath( param.from_user_logo ) },bgSize.width/2 , 561 ,{
		anchMid = true,
		front = COMMONPATH.."role_frame.png", 
		callback = function()
			
		end,
	} )
	bg:addChild( icon:getLayer() )

	local label1 = createLabel({str =  param.from_username .. "的红包" , width = bgSize.width , x = 0 , y = 472 , size = 18  , color = ccc3(213,213,213) , align = 1})
	setAnchPos( label1 , bgSize.width/2 , 504 , 0.5 , 0 )
	bg:addChild( label1 )

	display.newSprite( PATH .. "gongxifacai.png" , bg:getContentSize().width/2 , bg:getContentSize().height/2+85 , 0.5 , 0.5 ):addTo(bg)

	local redbag_list = param.redbag_list or {}

	local gold = display.newSprite( COMMONPATH .. "gold.png" , 175 , 345 , 0 ,0 ):addTo( bg )
	local how_much_packet = createLabel({str =  redbag_list.redbag_num .. "个红包，"..redbag_list.money , x = 80 , y = 44 , width=176, size = 18  , color = ccc3(236,238,179) , align = 1})
	setAnchPos( how_much_packet , 0 , 3 , 1 , 0 )
	gold:addChild( how_much_packet )

	if tonumber(redbag_list.is_over) ~= 0 then 
		gold:addChild( createLabel({str =  redbag_list.seconds .. "秒被抢光" , x = gold:getContentSize().width+5 , y = 3 , size = 18 ,width=276 , color = ccc3(236,238,179) , align = 1}) )
	end



	local function getItem(data)

		local item = display.newLayer()
		item:setContentSize( CCSizeMake( bgSize.width , 90) )

		local item = display.newSprite( PATH .. "item_bg1.png" )

		local icon = KNBtn:new(COMMONPATH, { getHeadPath( data.logo ) },56 , 45 ,{
			anchMid = true,
			front = COMMONPATH.."role_frame.png", 
			callback = function()
				
			end,
		} ):getLayer():addTo(item)

		icon:addChild( createLabel({str =  data.username , width = 200 , x = 80 , y = 35 , size = 18  , color = ccc3(255,255,199) , align = 1}) )
		icon:addChild( createLabel({str =  data.time , width = 200 , x = 80 , y = 10 , size = 18  , color = ccc3(254,254,235) , align = 1}) )

		local gold = display.newSprite( COMMONPATH .. "gold.png" , 366 , 50 , 0 ,0 ):addTo( item )
		local gold_num = createLabel({str =  data.money , x = 80 , y = 44 , size = 18  , color = ccc3(255,255,199) , align = 1})
		setAnchPos( gold_num , 0 , 3 , 1 , 0 )
		gold:addChild( gold_num )

		if tonumber(data.luck_man)~=0 then 
			item:addChild( createLabel({str =  "【手气最佳】" , width = 200 , x = 298 , y = 24 , size = 18  , color = ccc3(255,40,38) , align = 1}) )
		end

		return item

	end

	local scroll = KNScrollView:new( 24, 107, bgSize.width, 330 , 0 , false , nil , { priority = -143 }  )

	local list =redbag_list.list or {}
	for i=1, #list do
		local scroll_item  =getItem(list[i])
		scroll:addChild( scroll_item )
	end

	layer:addChild( scroll:getLayer() )


	KNBtn:new(PATH, { "close.png" },382 , 584 ,{
		priority = -142,
		callback = function()
			mask:remove()
			GLOBAL_INFOLAYER:refreshInfo()
		end,
	} ):getLayer():addTo( bg )


	display.getRunningScene():addChild( mask:getLayer() )

	return mask

end

function M:chooseMoney(param)
	local layer = display.newLayer()
	local mask = KNMask:new( {item = layer , priority = -151} )

	display.getRunningScene():addChild( mask:getLayer() )

	local bg = display.newSprite( IMG_PATH .. "image/scene/godCell/tip_bg.png"  ,display.cx , display.cy ,  0.5 , 0.5 ):addTo( layer )

	local bgSize = bg:getContentSize()

	local frame = display.newSprite( PATH .. "frame1.png" , bgSize.width/2 , 86 , 0.5, 0 ):addTo(bg)

	


	local group = KNRadioGroup:new()

	-- local selectedMoney = 0

	for i,v in ipairs(paysnum) do

		local x = 18 + ((i-1)%2)*197
		local y = 164 - (math.ceil(i/2) - 1)*61

		local btn = KNBtn:new( PATH , { "unselect.png" , "selected.png" } , x , y  ,
		{
			id = i , 
			noHide = true,
			upSelect = true,
			selectZOrder = 1,
			priority = -152,
			disableWhenChoose = true ,
			callback = function()
				selectIndex = i
				-- selectedMoney = v.rmb
			end
		},group):getLayer():addTo( frame )

		btn:addChild( createLabel({str =  "充"..v.rmb .. "="..v.gold.."黄金" , width = 200 , x = 30 , y = 5 , size = 18  , color =ccc3(253,252,211) , align = 1}) )

	end
	group:chooseByIndex(1, true)

	KNBtn:new(COMMONPATH, { "back_img.png" , "back_img_press.png" },10 , 310 ,{
		priority = -152,
		callback = function()
			mask:remove()
		end,
	}):getLayer():addTo( bg )


	KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" },bgSize.width/2 , 47 ,{
		priority = -152,
		anchMid = true ,
		front = COMMONPATH .. "confirm.png",
		callback = function()
			mask:remove()
			self:sendRedPacket( { gold = paysnum[selectIndex].gold , rmb =  paysnum[selectIndex].rmb , max_count =  paysnum[selectIndex].max , min_count = paysnum[selectIndex].min } )
			-- param.moneyBtn:setText( paysnum[selectIndex].rmb )
		end,
	}):getLayer():addTo( bg )

	local change_title_bg = display.newSprite( COMMONPATH .. "change_title_bg.png" , bgSize.width/2 , 361 , 0.5 , 0.5 ):addTo(bg)
	display.newSprite( PATH .. "title2.png" , change_title_bg:getContentSize().width/2 , change_title_bg:getContentSize().height/2+5 , 0.5 , 0.5 ):addTo(change_title_bg)

	return mask

end


function M:sendRedPacket( param )
	local layer = display.newLayer()
	local mask = KNMask:new( {item = layer , priority = -141} )


	local param = param or {}

	display.getRunningScene():addChild( mask:getLayer() )

	local bg = display.newSprite( IMG_PATH .. "image/scene/headline/lapiao_bg.png"  ,display.cx , 163 ,  0.5 , 0 ):addTo( layer )

	local bgSize = bg:getContentSize()

	display.newSprite( PATH .. "title1.png" , bgSize.width/2 , 475 , 0.5 , 0.5 ):addTo(bg)

	local frame1 = display.newSprite( PATH .. "item_bg.png" , bgSize.width/2 , 361 - 40 , 0.5 , 0 ):addTo(bg)
	display.newSprite( PATH .. "allofmoney.png" , 28 , frame1:getContentSize().height/2 , 0 , 0.5 ):addTo(frame1)
	-- display.newSprite( PATH .. "choose_money.png" , 187 , frame1:getContentSize().height/2 , 0 , 0.5 ):addTo(frame1)

	local moneyBtn  
	moneyBtn = KNBtn:new(PATH, { "choose_money.png" },253 , frame1:getContentSize().height/2 ,{
		anchMid = true , 
		other = {COMMONPATH.. "gold.png", 105,10 },
		text = { param.gold or "选择金额" , 15  , ccc3(43,23,11) , { x=0,y=0} }, 
		priority = -142,
		callback = function()
			mask:remove()
			self:chooseMoney()
		end,
	} )
	moneyBtn:getLayer():addTo(frame1)


	local frame2 = display.newSprite( PATH .. "item_bg.png" , bgSize.width/2 , 292 - 40 , 0.5 , 0 ):addTo(bg)
	frame2:addChild( createLabel({str =  "本帮成员人数"..DATA_Gang:get("list").count.."人" , width = 200 , x = 28 , y = 15 , size = 15  , color = ccc3(33,20,12) , align = 1}) )


	local frame3 = display.newSprite( PATH .. "item_bg.png" , bgSize.width/2 , 223 - 40 , 0.5 , 0 ):addTo(bg)
	display.newSprite( PATH .. "hongbaogeshu.png" , 28 , frame1:getContentSize().height/2 , 0 , 0.5 ):addTo(frame3)
	
	local min_count, max_count , num_str = param.min_count or 1 , param.max_count or 1
	local redPacket_count = min_count

	local frame3_choose_money = display.newSprite( PATH .. "choose_money.png" ,253 , frame1:getContentSize().height/2 , 0.5 , 0.5  ):addTo(frame3)
	KNBtn:new(PATH, { "add.png"  },119 , frame3_choose_money:getContentSize().height/2 ,{
		anchMid = true , 
		priority = -142,
		callback = function()
			if redPacket_count < max_count then
				redPacket_count = redPacket_count+1
				num_str:setString(redPacket_count)
			end
		end,
	} ):getLayer():addTo( frame3_choose_money )

	num_str = createLabel({str =  redPacket_count , width = 100 , x = 61 , y = 14 , size = 18  , color = ccc3(233,220,222) , align = 1})
	frame3_choose_money:addChild( num_str )

	KNBtn:new(PATH, { "sub.png" },22 , frame3_choose_money:getContentSize().height/2 ,{
		anchMid = true , 
		priority = -142,
		callback = function()

			if redPacket_count > min_count then
				redPacket_count = redPacket_count-1
				num_str:setString(redPacket_count)
			end

		end,
	}):getLayer():addTo( frame3_choose_money )


	local frame4 = display.newSprite( PATH .. "item_bg.png" , bgSize.width/2 , 148 - 40 , 0.5 , 0 ):addTo(bg)
	display.newSprite( PATH .. "gongxifacai.png" , frame4:getContentSize().width/2 , frame4:getContentSize().height/2 , 0.5 , 0.5 ):addTo(frame4)

	--塞红包
	KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" },bg:getContentSize().width/2 , 54 ,{
		front = PATH .. "saihongbao.png",
		anchMid = true , 
		priority = -142,
		callback = function()


			if moneyBtn:getText() ~= "选择金额" then 
				-- HTTP:call("alliance","test_redbag",{ awardnum = moneyBtn:getText() , redbag_num = redPacket_count },{success_callback = 
				-- 	function(_data)
				-- 		-- dump(_data , "_data")
				-- 		KNMsg:getInstance():flashShow( _data.msg or "" )
				-- 		mask:remove()
				-- 	end
				-- })
				mask:remove()
				requires(IMG_PATH , "GameLuaScript/Scene/pay/item"):requestPay({ num = param.rmb*10 , redbag_num = redPacket_count })

			else
				KNMsg:getInstance():flashShow( "请选择金额" )
				-- mask:remove()
				-- requires(IMG_PATH , "GameLuaScript/Scene/pay/item"):requestPay({ num = 10 , redbag_num = 5 })
			end
			
		end,
	}):getLayer():addTo( bg )


	KNBtn:new(COMMONPATH, { "back_img.png" , "back_img_press.png" },15 , 400 ,{
		priority = -142,
		callback = function()
			mask:remove()
		end,
	}):getLayer():addTo( bg )


	return mask

end


return M


