--主界面

local M = {
	data
}

local ACTIVITY_BOSS_PATH = IMG_PATH .. "image/scene/activity_new/boss/"
local GANGPATH = IMG_PATH .. "image/scene/gang/"
local PATH = IMG_PATH .. "image/scene/gang/boss/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNBar = requires(IMG_PATH , "GameLuaScript/Common/KNBar")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNClock = requires(IMG_PATH, "GameLuaScript/Common/KNClock")

-- - "<var>" = {
-- -     "boss" = {
-- -         "cp"     = 104
-- -         "hp"     = 99999
-- -         "max_cp" = 104
-- -         "max_hp" = 99999
-- -         "status" = 1
-- -     }
-- -     "info" = {
-- -         "beat"        = 2
-- -         "beat_cost"   = 100
-- -         "cd"          = 0
-- -         "dou"         = 1
-- -         "feed"        = 8
-- -         "hurt"        = 0
-- -         "max_dou"     = 1
-- -         "revive_cost" = 100
-- -         "status"      = 1
-- -     }
-- -     "rank" = 0
-- - }

function M:new(args)
	dump(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.data = args.data

	-- 基础层
	this.statusLayer = nil
	this.baseLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "gangBossLayer" , 0 , {
		title_text = PATH .. "title.png" ,
		tail_hide = true ,
		closeCallback = function()
			HTTP:call("alliance", "get", {},{
				success_callback = function()
	   				switchScene("gang")
	    		end
	    	})
		end
	})
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	-- boss 层
	this.viewlayer = display.newLayer()

	local bg = display.newSprite( PATH .. "bg.jpg" )
	setAnchPos( bg , 15 , 105 )
	this.viewlayer:addChild( bg )

	local boss_img = display.newSprite( ACTIVITY_BOSS_PATH .. "boss_img.png" )
	setAnchPos( boss_img , 70 , 300 )
	this.viewlayer:addChild( boss_img )

	
	-- 帮助按钮
	local help_btn = KNBtn:new( COMMONPATH , {"help.png" , "help_press.png"} , 35 , 625 , {
		priority = -130,
		callback = function()
			local tempLayer = baseMask({  
				titlePath = COMMONPATH .. "help_title.png" , 
				bgInfo = { y = 270 ,  path = IMG_PATH  .. "image/scene/mission/wipe_bg.png" } , 
				isShowBack = { x = 35 , y = 565 , backFun = function() end } , 
				priority = -131
			})
						
			local scroll
			local strConfig = replaceStr("1.boss怒气达到上限时需要通过帮主或者副帮主激活boss才可以击杀。\n2.每次战斗有一定几率获得奖励。\n3.boss死亡后，会根据帮派成员造成的血量伤害排名来奖励。最后击杀boss的玩家将获得额外奖励。\n4. boss被击杀后奖励通过邮件发放。")
			local function createText()
				local helpTips = createLabel({str = strConfig , x = 60 , y = 55,size = 18, width = 340,color = ccc3(46 , 18 , 14)})
				return helpTips
			end
			
			scroll = KNScrollView:new( 68 , 293  , 380 , 275 , 10 ,  false , nil , { priority = -133 } )	
			scroll:addChild( createText() )
			
			tempLayer:addChild( scroll:getLayer() )
		end
	})
	this.viewlayer:addChild( help_btn:getLayer() )


	--排行榜
	local paiHangBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 315 , 650 , {
		front = COMMONPATH .. "paihangbang.png",
		callback = function()
			HTTP:call("allianceboss", "getHurtRank", { },{
				success_callback = function(data)
					switchScene("gangBossRank" , data)
				end
			})
		end
	})
	this.viewlayer:addChild( paiHangBtn:getLayer() )
	this.baseLayer:addChild( this.viewlayer )

	this:refresh()

	-- 5秒刷新一次
	local config_refresh_time = this.data.timer or 5
	local refresh_time = config_refresh_time
	local function boss_refresh()
		if refresh_time <= 0 then
			refresh_time = config_refresh_time

			HTTP:call("allianceboss", "initData", {} , {
				success_callback = function(ret_data)
					this:merge_data(ret_data)
					this:refresh()
				end
			})
		end
		refresh_time = refresh_time - 1
	end
	Clock:addTimeFun( "gang_boss_timer" , boss_refresh )

	return this.baseLayer 
end

function M:refresh()
	if self.statusLayer then
		self.viewlayer:removeChild( self.statusLayer , true )
		self.statusLayer = nil
	end

	self.statusLayer = display.newLayer()
	if self.data.boss.status == 0 then
		self.statusLayer:addChild( self:boss_wait() )			-- boss 等待状态
	elseif self.data.boss.status == 1 then
		self.statusLayer:addChild( self:boss_atk() )			-- boss 激活状态，可攻击
	elseif self.data.boss.status == 2 then
		self.statusLayer:addChild( self:boss_die() )			-- boss 死亡状态
		
		
		
	end

	self.viewlayer:addChild(self.statusLayer)
end



-- boss 等待状态
function M:boss_wait()
	local data = self.data

	local layer = display.newLayer()

	-- data.boss.cp = 104

	local score_bar = KNBar:new("gangboss_red" ,  40 , 580 , { maxValue = data.boss.max_cp  , curValue = data.boss.cp  , color = ccc3( 255,255,255 ) })
	layer:addChild( score_bar )

	local text = CCLabelTTF:create("怒气: " , FONT , 15)
   	setAnchPos( text , 140 , 265 )
	text:setColor( ccc3( 255,255,255 ) )
	layer:addChild( text )

	local btn_img = { "jihuo.png" , "jihuo_pre.png" }
	if data.boss.cp < data.boss.max_cp then
		btn_img = { "jihuo_dis.png" }
	end
	local jihuo_btn = KNBtn:new( PATH , btn_img , 350 , 229 , {
		callback = function()
			HTTP:call("allianceboss", "activate", { },{
				success_callback = function(data)
					KNMsg.getInstance():flashShow( data.msg )
					self:merge_data(data)
	   				self:refresh()
				end
			})
		end
	})
	layer:addChild( jihuo_btn:getLayer() )

	-- 特效
	if data.boss.cp >= data.boss.max_cp then
		local frames = display.newFrames( PATH .. "effect/%1d.png", 1, 6, false, true)
		layer:addChild( display.playFrames(412 , 270 , frames , 0.15 , {forever = true}) )
	end


	-- 挑逗
	local temp_btn = KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" } , 115 , 160 , {
		front = PATH .. "dou.png",
		callback = function()
			HTTP:call("allianceboss", "dou", { },{
				success_callback = function(data)
					KNMsg.getInstance():flashShow( data.msg )
					self:merge_data(data)
	   				self:refresh()
				end
			})
		end
	})
	layer:addChild( temp_btn:getLayer() )
	layer:addChild( display.strokeLabel( data.info.dou .. "/" .. data.info.max_dou , 118 , 128 , 20 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , { dimensions_width = 77 , dimensions_height = 30 , align = 1 } ) )


	-- 怒气石
	local temp_btn = KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" } , 300 , 160 , {
		front = PATH .. "nuqishi.png",
		callback = function()
			HTTP:call("allianceboss", "feed", { },{
				success_callback = function(data)
					KNMsg.getInstance():flashShow( data.msg )
					self:merge_data(data)
	   				self:refresh()
				end
			})
		end
	})
	layer:addChild( temp_btn:getLayer() )
	local nuqishi_num = DATA_Bag:cidNum( 17155 ) or 0
	layer:addChild( display.strokeLabel( "拥有：" .. nuqishi_num , 280 , 128 , 20 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , { dimensions_width = 120 , dimensions_height = 30 , align = 1 } ) )


	-- 鞭打
	--[[
	local temp_btn = KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" } , 320 , 160 , {
		front = PATH .. "beat.png",
		callback = function()
			HTTP:call("allianceboss", "beat", { },{
				success_callback = function(data)
					KNMsg.getInstance():flashShow( data.msg )
					self:merge_data(data)
	   				self:refresh()
				end
			})
		end
	})
	layer:addChild( temp_btn:getLayer() )
	layer:addChild( display.strokeLabel( data.info.beat_cost , 308 , 128 , 20 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , { dimensions_width = 77 , dimensions_height = 30 , align = 1 } ) )
	local gold = display.newSprite( COMMONPATH .. "gold.png" )
	setAnchPos( gold , 360 , 133 )
	layer:addChild( gold )
	]]

	return layer
end


-- boss 激活状态，可攻击
function M:boss_atk()
	local data = self.data

	-- dump(data)

	local layer = display.newLayer()

	local hp_bar = KNBar:new("gangboss_green" ,  50 , 580 , { maxValue = data.boss.max_hp  , curValue = data.boss.hp  , color = ccc3( 255,255,255 ) })
	layer:addChild( hp_bar )


	layer:addChild( display.strokeLabel( "BOSS将在当天24点重置" , 200 , 295 , 20 , ccc3( 0xff , 0xff , 0xff ) ) )
	


	-- 我的排名
	local my_rank = display.newSprite( PATH .. "my_rank.png" )
	setAnchPos( my_rank , 40 , 210 )
	layer:addChild( my_rank )
	layer:addChild( display.strokeLabel( data.rank , 165 , 210 , 24 , ccc3( 0xff , 0xff , 0xff ) ) )


	-- 当前总伤害
	local cur_hurt = display.newSprite( PATH .. "cur_hurt.png" )
	setAnchPos( cur_hurt , 240 , 210 )
	layer:addChild( cur_hurt )
	layer:addChild( display.strokeLabel( data.info.hurt , 375 , 210 , 24 , ccc3( 0xff , 0xff , 0xff ) ) )

	-- 复活
	if self.data.info.cd > 0 then
		local fuhuo_btn = KNBtn:new( COMMONPATH , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 175 , 160 , {
		    front = ACTIVITY_BOSS_PATH .. "revive.png",
		    callback = function()
		    	HTTP:call("allianceboss", "revive", { },{
					success_callback = function(data)
						KNMsg.getInstance():flashShow( data.msg )
						self:merge_data(data)
		   				self:refresh()
					end
				})
			end
	    })
	    layer:addChild(fuhuo_btn:getLayer())
	    layer:addChild( display.strokeLabel( data.info.revive_cost , 185 , 105 , 20 , ccc3( 0xff , 0xff , 0xff ) , nil , nil , { dimensions_width = 77 , dimensions_height = 30 , align = 1 } ) )
		local gold = display.newSprite( COMMONPATH .. "gold.png" )
		setAnchPos( gold , 240 , 110 )
		layer:addChild( gold )


		-- 倒计时
		local tempText = display.strokeLabel( "复活倒计时：" , 150 , 135 , 20 , ccc3( 0xff , 0xff , 0xff ) )
		layer:addChild(tempText)
	    local timeText = display.strokeLabel( "" , 270 , 135 , 20 , ccc3( 0xff , 0xff , 0xff ) )
	    layer:addChild(timeText)

    	self:downTime( "boss_atk" , timeText , function()
    		self.data.info.cd = self.data.info.cd - 1
    		if self.data.info.cd <= 0 then
    			self.data.info.cd = 0
    			self:refresh()

    			Clock:removeTimeFun( "boss_atk" )
    		end

    		return self.data.info.cd
    	end)
	end


    -- 攻击
    if self.data.info.cd <= 0 then
    	Clock:removeTimeFun( "boss_atk" )


		local act_btn = KNBtn:new( COMMONPATH , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 175 , 160 , {
		    front = ACTIVITY_BOSS_PATH .. "atk.png",
		    callback = function()
		    	if isBagFull() then
					return false
				end

		    	if data.info.cd > 0 then
		    		KNMsg.getInstance():flashShow( "CD时间没到，不能攻击" )
		    		return
		    	end

		    	HTTP:call("allianceboss", "challenge", { },{
					success_callback = function(result)
						DATA_Battle:setMod("guide")
						DATA_Battle:setAct("guide")
						DATA_Battle:set( result )
						DATA_Result:set({data = result , type = "mission"})

						-- 切换到boss战斗界面
						switchScene("boss" , {
							overFun = function()
								-- 返回帮会boss界面
								HTTP:call("allianceboss", "initData", {} , {
									success_callback = function(ret_data)
										switchScene("gangBoss" , {data = ret_data} , function()
											if result.msg then
												KNMsg.getInstance():flashShow(result.msg)
											end
										end)
									end
								})
							end
						})
					end
				})
			end
	    })
	    layer:addChild(act_btn:getLayer())
	end


	return layer
end


-- boss 死亡状态
function M:boss_die()
	local layer = display.newLayer()

	local boss_die = display.newSprite( PATH .. "boss_die.png" )
	setAnchPos( boss_die , display.cx , 180 , 0.5 )
	layer:addChild( boss_die )
	layer:addChild(display.strokeLabel(self.data.kill_info or  "" , 175 , 395-180-60 , 22, ccc3( 255 , 255 , 255 )  ) )

	return layer
end

function M:merge_data( data )
	if data.boss then
		self.data.boss = data.boss
	end

	if data.info then
		self.data.info = data.info
	end
end


-- 倒计时。。。这个应该做个公用组件的
function M:downTime( key , timeText , downFun )
	--24小时，不展示天数
	local function refreshTime()
		local curTime = downFun()
		if curTime < 0 then curTime = 0 end
		local dayNum = math.floor( tonumber(timeConvert( curTime , "hour"))/24 )
		curTime = curTime - dayNum * 86400
		
		timeText:setString( math.mod( timeConvert( curTime , "hour") , 24 ) .. ":" .. timeConvert( curTime , "min") .. ":" .. timeConvert( curTime , "sec") )
		if curTime <= 0 then
			timeText:setString("")
			Clock:removeTimeFun( key )
		end
	end

	Clock:addTimeFun( key , refreshTime )
end


return M