--主界面

local M = {
	techData
	
}

local GANGPATH = IMG_PATH .. "image/scene/gang/"
local PATH = IMG_PATH .. "image/scene/gang/tech/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	--dump(args)
  	this.techData=args['technology']

	-- 基础层
	this.baseLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "gangTechLayer" , 0 , { title_text = PATH.."gangTechTitle.png", tail_hide = true, closeCallback = function()
		HTTP:call("alliance", "get", {},{success_callback = 
    		function()
   				switchScene("gang")
    		end})
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	local tempScrollView = KNScrollView:new(15,190,450,550,5,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
	
	this.baseLayer:addChild(tempScrollView:getLayer())

	local iconType = {"icon_po.png","icon_qiang.png","icon_zhao.png","icon_qie.png","icon_ti.png"}

	for i=1,#this.techData do

		local item = display.newSprite(COMMONPATH.."item_bg.png",0,0,0,0)
		tempScrollView:addChild(item)

		item:addChild(display.newSprite(PATH..iconType[this.techData[i]['type']],20,20,0,0))--icon

		item:addChild(display.newSprite(PATH.."name.png",65,70,0,0))
		item:addChild(display.strokeLabel(this.techData[i]['name'] , 155 , 73 , 20 , ccc3(0x2c,0x00,0x00) ))--名称

		item:addChild(display.newSprite(PATH.."lv.png",260,70,0,0))
		item:addChild(display.strokeLabel(this.techData[i]['lv'] , 290 , 70 , 22 , ccc3(0x2c,0x00,0x00) ))

		--效果
		item:addChild(display.newSprite(PATH.."effect.png",63,40,0,0))
		item:addChild(display.strokeLabel(this.techData[i]['str'] , 155 , 43 , 18 , ccc3(0x2c,0x00,0x00) ))

		--升级需要/开启需要
		if this.techData[i]['state']==0 then--未开启，可开启
			item:addChild(display.newSprite(PATH.."needOpen.png",63+22,12,0,0))
			
			--开启需要的帮贡和资金
			item:addChild(display.strokeLabel(replaceStr("帮贡")..numShift(this.techData[i]['tribute']).." 资金"..numShift(this.techData[i]['funds']) , 185 , 15 , 18 , ccc3(0x2c,0x00,0x00) ))
		elseif this.techData[i]['state']==1 then--已经开启，可升级
			item:addChild(display.newSprite(PATH.."needUp.png",63+22,12,0,0))
			--升级需要的帮贡和荣誉
			item:addChild(display.strokeLabel(replaceStr("帮威")..numShift(this.techData[i]['k_viagra']).."/"..numShift(this.techData[i]['viagra']).." 荣誉"..numShift(this.techData[i]['k_honours']).."/"..numShift(this.techData[i]['honours']) , 185 , 15 , 18 , ccc3(0x2c,0x00,0x00) ))
			
		end


		local optBtn = KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" } , 350 , 40 , {
			front= this.techData[i]['state']==0 and GANGPATH.."shop/open_text.png" or COMMONPATH.."up.png",
			callback = function()
				--dump(DATA_Gang:get())
				if this.techData[i]['state']==0 then--开启
					local tempMask = baseMask( {  titlePath = PATH .. "kaiQiTitle.png" , bgInfo = { y = 240 ,  path = IMG_PATH.."image/scene/mission/wipe_bg.png"} , isShowBack = {x = 35 , y = 540 , backFun = function()  end } , priority = -131 } )
					
					local xiaoHaoTxt = display.strokeLabel("是否消耗"..numShift(this.techData[i]['tribute'])..replaceStr("帮贡").."和"..numShift(this.techData[i]['funds']).."资金开启"..replaceStr("科技").." ["..this.techData[i]['name'].."]" , 100 , 420 , 24 , ccc3(0x2c,0x00,0x00) , -1 , ccc3( 0xa7 , 0xe1 , 0xe6 ) ,
							{ dimensions_width = 320,
							 dimensions_height = 100,
							  align = 0,
							  } )

					tempMask:addChild(xiaoHaoTxt )
					

					--开启科技
					local okBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 160 , 320 , {
							front=COMMONPATH.."ok.png",
							priority=-131,
						 	callback = function()
							
									HTTP:call("alliance", "open_technology", {index=(this.techData[i]['type']-1) },{success_callback = 
										function(data)
											dump(data)

											HTTP:call("alliance", "get", {},{success_callback = 
								    			function()
											    			switchScene("gangTech",data,function()
																    KNMsg.getInstance():flashShow(data['str'])
																end)
								   				
								    			end})
											
											
										
											
									end})

						end
					}):getLayer()
					tempMask:addChild( okBtn )
				elseif this.techData[i]['state']==1 then--升级
						local tempMask = baseMask( {  titlePath = PATH .. "juanXianTitle.png" , bgInfo = { y = 240 ,  path =COMMONPATH.."bg_img.png" } , isShowBack = {x = 35 , y = 580 , backFun = function()  end } , priority = -131 } )
						
						tempMask:addChild(display.newSprite(PATH.."fg.png",35,300,0,0))
						tempMask:addChild(display.newSprite(PATH.."tribute.png",42,532,0,0))
						tempMask:addChild(display.newSprite(PATH.."honour.png",43,400,0,0))
						tempMask:addChild(display.newSprite(PATH.."num_text.png",240,500-8,0,0))
						tempMask:addChild(display.newSprite(PATH.."num_bg.png",300,500-8,0,0))
						local needBangWeiSp = display.newSprite(PATH.."needBangWei.png",157,470-8,0,0)
						tempMask:addChild(needBangWeiSp)
						--升级需要的帮威
						local needBangWeiNum = this.techData[i]['viagra']-this.techData[i]['k_viagra']
						needBangWeiSp:addChild(display.strokeLabel(  needBangWeiNum>0 and needBangWeiNum or 0 , 150 , 5 , 20 , ccc3(108, 12, 13) ))
						
						local bangWeiLab = display.strokeLabel("1" , 310 , 497 , 20 , ccc3(255, 244, 189))
						tempMask:addChild(bangWeiLab)
						
						tempMask:addChild(display.newSprite(PATH.."num_text.png",240,500-130-8,0,0))
						tempMask:addChild(display.newSprite(PATH.."num_bg.png",300,500-130-8,0,0))
						local needRongYuSp = display.newSprite(PATH.."needRongYu.png",157,470-130-8,0,0)
						tempMask:addChild(needRongYuSp)
						local needRongYuNum = this.techData[i]['honours']-this.techData[i]['k_honours']
						needRongYuSp:addChild(display.strokeLabel( needRongYuNum>0 and needRongYuNum or 0, 150 , 5 , 20 , ccc3(108, 12, 13) ))
						
						local rongYuLab = display.strokeLabel("1" , 310 , 497-129 , 20 , ccc3(255, 244, 189))
						tempMask:addChild(rongYuLab)

						--帮威
						local sliderVi = KNSlider:new( "buy" ,  {
							x = 155, 
							y = 300, 
							minimum = 0 , 
							maximum = needBangWeiNum>0 and needBangWeiNum or 0, 
							value = 1100,
							priority = -132, 
							callback  = function( _curIndex )

								bangWeiLab:setString(_curIndex)
								
							end
							
						})
						tempMask:addChild(sliderVi)

						local addViBtn = KNBtn:new(COMMONPATH,{"next_big.png"} ,  128+255 ,  275-60+310  , {
								scale = true,
								priority = -132,
								callback = function()
									sliderVi:setValue( sliderVi:getValue()+10000 )

								end
							})
						addViBtn:getLayer():setScale(0.8)
						tempMask:addChild(addViBtn:getLayer())
						local minusViBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 105 ,  275-60+310  ,{
							scale = true,
							priority = -132,
							callback = function()
								sliderVi:setValue( sliderVi:getValue()-10000 )

							end
						})
						minusViBtn:setFlip(true)
						minusViBtn:getLayer():setScale(0.8)
						tempMask:addChild(minusViBtn:getLayer())

						

						--荣誉
						local sliderHo = KNSlider:new( "buy" ,  {
							x = 155, 
							y = 300+130, 
							minimum = 0 , 
							maximum = needRongYuNum>0 and needRongYuNum or 0, 
							value = 1 ,
							priority = -132, 
							callback  = function( _curIndex )

								rongYuLab:setString(_curIndex)
								
							end
							
						})
						tempMask:addChild(sliderHo)

						local addHoBtn = KNBtn:new(COMMONPATH,{"next_big.png"} ,  128+255 ,  275-60+310-130  , {
								scale = true,
								priority = -132,
								callback = function()
									
									sliderHo:setValue( sliderHo:getValue()+500 )
								end
							})
						addHoBtn:getLayer():setScale(0.8)
						tempMask:addChild(addHoBtn:getLayer())
						local minusHoBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 105 ,  275-60+310-130  ,{
							scale = true,
							priority = -132,
							callback = function()
								
								sliderHo:setValue( sliderHo:getValue()-500 )
							end
						})
						minusHoBtn:setFlip(true)
						minusHoBtn:getLayer():setScale(0.8)
						tempMask:addChild(minusHoBtn:getLayer())

						

						tempMask:addChild(display.strokeLabel("说明：消耗"..replaceStr("帮威").."和荣誉提升"..replaceStr("科技").."等级" , 155-80 , 242 , 19 , ccc3(108, 12, 13) ))--名称

						--升级科技
						local okBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 160 , 265 , {
							front=COMMONPATH.."ok.png",
							priority=-131,
						 	callback = function()
									
									HTTP:call("alliance", "up_technology", {index=(this.techData[i]['type']-1),t_viagra=sliderVi:getValue() ,t_honours=sliderHo:getValue() },{success_callback = 
										function(data)
											dump(data)
											HTTP:call("alliance", "get", {},{success_callback = 
									    		function()
									   				switchScene("gangTech",data,function()
													    KNMsg.getInstance():flashShow(data['str'])
													end)
									    		end})
											
										
											
									end})

						end
						}):getLayer()
						tempMask:addChild( okBtn )



				end

			end
		})

		item:addChild(optBtn:getLayer())

	end


	--排行榜
	local paiHangBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 160 , 143 , {
		front=PATH.."paiHangBang.png",
		callback = function()
					HTTP:call("alliance", "gettechnologyranking", { },{success_callback = 
									function(data)
										--dump(data)

										switchScene("gangTechRank",data)
									
										
								end})
			

		end
	})
	this.baseLayer:addChild( paiHangBtn:getLayer() )

	local str = "注："..replaceStr("帮主").."或"..replaceStr("副帮主").."开启"..replaceStr("科技").."后，所有人可消耗"..replaceStr("帮威").."，荣誉升级，加成效果对"..replaceStr("帮派").."所有人有效。"

 	local text = display.strokeLabel( str , 25 , 60 , 17 , ccc3( 237, 223, 188 ) , -1 , ccc3( 0xa7 , 0xe1 , 0xe6 ) , {
		dimensions_width = 420,
		dimensions_height = 80,
		align = 0,
	})
	this.baseLayer:addChild(text)


	return this.baseLayer 
end




return M