--主界面

local M = {
	listData,
	pageIndex=1,
	pageCount,
	scrollView,
}

local GANGPATH = IMG_PATH .. "image/scene/gang/"
local PATH = IMG_PATH .. "image/scene/gang/tech/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	dump(args)
	this.listData = args['technologyranking']
	this.pageCount = math.ceil( #args['technologyranking']/10) --总页码
	-- 基础层
	this.baseLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "gangTechLayer" , 0 , { title_text = PATH.."jueXianPaiHang.png", tail_hide = true, closeCallback = function()
		HTTP:call("alliance", "gettechnology", {},{success_callback = 
				function(data)
					--dump(data)
					switchScene("gangTech",data)
			end})
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )


	this.scrollView=this:choosePageData(this.pageIndex)
    if this.scrollView  == nil then
	    return this.baseLayer 
    end
    this.baseLayer:addChild(this.scrollView:getLayer())

    local pageLab = display.strokeLabel( this.pageIndex .."/"..this.pageCount, 215, 115 , 22 , ccc3( 223 , 206 , 164) )
     this.baseLayer:addChild(pageLab)


     --增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 255 , 105 , {
				scale = true,
				priority = -130,
				callback = function()
					
					if this.pageIndex<this.pageCount then
						this.scrollView:getLayer():removeFromParentAndCleanup(true)
						this.pageIndex=this.pageIndex+1
						
						this.scrollView=this:choosePageData(this.pageIndex)
						this.baseLayer:addChild(this.scrollView:getLayer())
						pageLab:setString(this.pageIndex .."/"..this.pageCount)
					end
					
			end
			})
	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 175 , 105 ,{
				scale = true,
				priority = -130,
				callback = function()
					
					
					if this.pageIndex > 1 then
						this.scrollView:getLayer():removeFromParentAndCleanup(true)
						this.pageIndex=this.pageIndex-1
						
						this.scrollView=this:choosePageData(this.pageIndex)
						this.baseLayer:addChild(this.scrollView:getLayer())
						pageLab:setString(this.pageIndex .."/"..this.pageCount)
					end
				end
				})
	minusBtn:setFlip(true)
	addBtn:getLayer():setScale( 0.8 )
	minusBtn:getLayer():setScale( 0.8 )

	this.baseLayer:addChild(addBtn:getLayer())
	this.baseLayer:addChild(minusBtn:getLayer())


	return this.baseLayer 
end


function M:choosePageData(choosePageIndex)
	if choosePageIndex > self.pageCount then
		KNMsg.getInstance():flashShow("还没有捐献排行数据")
		return nil
	end

	local tempScrollView = KNScrollView:new(15,150,450,595,5,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
	

    for i= 1+((choosePageIndex-1)*10), choosePageIndex*10 do
    	
    	if self.listData[i] then
	    	 local  itemBg = display.newSprite(COMMONPATH .."item_bg.png")
	       	 setAnchPos(itemBg,0,0)
	       	 tempScrollView:addChild(itemBg)

	         local	touXiangSp = display.newSprite(COMMONPATH ..getHeadPath(self.listData[i]['sex'])) --男
	       	 setAnchPos(touXiangSp,25,30)
	       	 itemBg:addChild(touXiangSp)

	       	 local	touXiangFrame = display.newSprite(COMMONPATH .."role_frame.png") 
	       	 setAnchPos(touXiangFrame,25,28)
	       	 itemBg:addChild(touXiangFrame)

	       	 local playerNameSp = display.newSprite(PATH .. "name.png")
	         setAnchPos(playerNameSp ,80,70)
	   	     itemBg:addChild(playerNameSp)

	   	     local playerName =  display.strokeLabel(self.listData[i]['name'], 170, 70 , 22 , ccc3( 46 , 18 , 14) )
	       	 itemBg:addChild(playerName)

	       	 itemBg:addChild(display.newSprite(PATH.."zong_Juan.png",90,45,0,0))
	       	 itemBg:addChild(display.strokeLabel("荣誉"..numShift(self.listData[i]['honours'])..replaceStr("帮威")..numShift(self.listData[i]['viagra']), 190, 48 , 16 , ccc3( 46 , 18 , 14)))
	       	 itemBg:addChild(display.strokeLabel("荣誉"..numShift(self.listData[i]['v_honours'])..replaceStr("帮威")..numShift(self.listData[i]['v_viagra']), 210, 25 , 16 , ccc3( 46 , 18 , 14)))
	       	 itemBg:addChild(display.newSprite(PATH.."zuiJinJuan.png",100,20,0,0))


	       	 itemBg:addChild(display.strokeLabel( self.listData[i]['time'] , 110 , 0 , 18 , ccc3(0x2c,0x00,0x00) ))
	       	 
	       	 local rankNum = getImageNum(i, COMMONPATH .. "cirt.png")
	       	 setAnchPos(rankNum,375,28)
	       	 itemBg:addChild(rankNum)

       	end

    end

    return tempScrollView

end



return M