local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local baseElement = requires(IMG_PATH, "GameLuaScript/Scene/common/baseElement")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local KNBar = requires(IMG_PATH, "GameLuaScript/Common/KNBar")
local PATH = IMG_PATH.."image/scene/godCell/"
local GALAXYPATH = IMG_PATH.."image/scene/galaxy/"

local TABLETYPE 	--当前选中场景类型 
local SCENETYPE 	--当前选中场景类型 
local ADDITION , RESOLVE , GODCELLSCENE = 1 , 2	 , 3--开启 分解
local PET , HERO , SKILL = 1 , 2 , 3 	--场景

local keyElement = { "pet" , "general" , "skill" }
local openLvElement = { 80 , 80 , 8 }	--技能转不开放

local indexKey = { atk = 1 ,  agi = 2 , def = 3 , hp = 4  }
local textConfig = { atk = "攻击" , agi = "敏捷" , def = "防御" , hp = "血量"  }
local sampleName = { atk = "攻" , agi = "敏" , def = "防" , hp = "血"  }
local attribCofnig = { "atk" , "agi" , "def" , "hp"  }
local numConfig = { "一","二","三","四","五","六","七","八"}
local btn_type = 1

local posConfig = { 
	atk = { 200 , 443 },
	hp = { 45 , 295 },
	def = { 346 , 290 },
	agi = { 193 , 140 }
 }

local M = {
	viewLayer,
	baseLayer,
	roleListLayer,
	mainLayer,
	params,
	cur_zhenwei,
	cur_attr,
	cur_roleType,
	infoLayer,
	shenjielayer,
}

local xingdian_config = {}
local heroxingdianlv_config = {}
local shenwei_config = {}
local yuansu_config = {}
local pet_xingdian_config = {}
local petxingdianlv_config = {}	

function M:new(params)
	TABLETYPE = params.type or HERO
	local this = {}
	setmetatable(this,self)
	self.__index = self

	
	this.params = params or {}
	this.baseLayer = display.newLayer()	--基础层
	this.viewLayer = display.newLayer()	--加成层
	this.baseLayer:addChild( this.viewLayer )

	this:saveConfig()
	--返回回调
	SCENETYPE = ADDITION

	-- dump(params.backInfo)

	local function backFun()
		if SCENETYPE == ADDITION then
			this.params.backFun()
		elseif SCENETYPE == RESOLVE then
			local backInfo = { cur_roleType = this.cur_roleType , cur_zhenwei = this.cur_zhenwei }
			switchScene("godCell" , { data = this.params.data , backFun = this.params.backFun , backInfo = backInfo , type = ( TABLETYPE == 3 and 2 or TABLETYPE ) })	--判断屏蔽分解中技能返回加成界面的技能
		elseif SCENETYPE == ADVANCE then 
			local backInfo = { cur_roleType = this.cur_roleType , cur_zhenwei = this.cur_zhenwei }
			switchScene("godCell" , { data = this.params.data , backFun = this.params.backFun , backInfo = backInfo })
			SCENETYPE = ADDITION
		else
			this.params.backFun()
		end
	end

	--导航信息
	this.infoLayer = InfoLayer:new( "godCell" , 0 , {tail_hide = true , title_text = PATH .. "godCell_title.png" , closeCallback = backFun})
	this.baseLayer:addChild(this.infoLayer:getLayer() , 2)	
	

	
	-- local bg = display.newSprite( PATH .. "bg.jpg" )
	-- setAnchPos( bg , display.cx , display.cy , 0.5 , 0.5 )
	-- this.viewLayer:addChild( bg )

	if params.backInfo then 
		this.cur_roleType = params.backInfo.cur_roleType
		this.cur_zhenwei = params.backInfo.cur_zhenwei
		this.cur_attr = params.backInfo.cur_attr
	else
		this.cur_zhenwei = 1
		this.cur_roleType = "hero"
	end

	if this.cur_attr then 
		this.cur_attr = params.backInfo.cur_attr
		this:createAdvance()
	else
		this:createRoleList()
	end

	return this
end

function M:saveConfig()

	if self.params.data.xingdian_config then 
		xingdian_config = self.params.data.xingdian_config
	end
	if self.params.data.heroxingdianlv_config then 
		heroxingdianlv_config =  self.params.data.heroxingdianlv_config
	end
	if self.params.data.shenwei_config then 
		shenwei_config =  self.params.data.shenwei_config
	end
	if self.params.data.yuansu_config then 
		yuansu_config =  self.params.data.yuansu_config
	end

	if self.params.data.pet_xingdian_config then 
		pet_xingdian_config =  self.params.data.pet_xingdian_config
	end

	if self.params.data.petxingdianlv_config then 
		petxingdianlv_config =  self.params.data.petxingdianlv_config
	end

end

function M:createPetPage(param)
	if self.mainLayer then 
		self.baseLayer:removeChild( self.mainLayer , true )
	end

	self.mainLayer = display.newLayer()
	local bg = display.newSprite( PATH .. "bg1.jpg" )
	setAnchPos( bg , display.cx , display.cy , 0.5 , 0.5 )
	self.mainLayer:addChild( bg , -1 )

	local valueConfig = { "lingyuan" , "qiyun" }
	for i=1,#valueConfig do
		local offSetX = 0
		if i == 2 then 
			offSetX = offSetX + 240
		end

		local label = display.newSprite( PATH .. valueConfig[i].."_value.png" )
		setAnchPos( label , 42 + offSetX , 600 )
		self.mainLayer:addChild( label )

		local num_length = string.len((DATA_GodCell:get( valueConfig[i] ) or 0).."")

		local tempText = display.strokeLabel(DATA_GodCell:get( valueConfig[i] ) or "0", 120 + offSetX  , 603, 18, ccc3(0xff,0xff,0xff))
		self.mainLayer:addChild( tempText )

		local addBtn = KNBtn:new( PATH , { "add.png" , "add_pre.png" } , 125 + offSetX + num_length*10, 595 , {
				callback = function()
					if valueConfig[i] == "lingyuan" then 
						btn_type = 1
						self:refreshResolve()
					else
						
						HTTP:call("trial","getInfo",{  } , {
								success_callback = function( data )
										self:backToSelf(false)
										switchScene("bloodTrial",data)
										end
							})	
					end
				end
			} )
		self.mainLayer:addChild( addBtn:getLayer() )
	end

	local offSetX = 20

	local label = display.newSprite( PATH.."atk_label.png" )
	setAnchPos( label , 147 + offSetX, 230 )
	self.mainLayer:addChild( label )

	local atkText = display.strokeLabel( param.atk.g_cur_num  , 177 + offSetX , 230 , 18, ccc3(0xff,0xff,0xff))
	self.mainLayer:addChild( atkText )

	local num_length = string.len(param["atk"]["g_cur_num"].."")

	local cur_num = display.strokeLabel("+"..param["atk"]["cur_num"], 177 + num_length * 10 + offSetX, 230 , 18, ccc3(77,147,40))
	self.mainLayer:addChild( cur_num )
	
	local atkBtn = KNBtn:new( PATH , {"atk.png", "atk_pre.png"} , 193 , 288 ,
			{
				callback = function()
					self.cur_attr = "atk"
					self:createAdvance()
				end 
			})
	self.mainLayer:addChild( atkBtn:getLayer() )

	local center_effect = display.newFramesWithImage(PATH.."atk_effect.png", 16, 1)
	action = display.playFrames(0, 0, center_effect, 0.2, {
		forever = true,
	})
	setAnchPos(action, 189 , 285 )
	self.mainLayer:addChild(action , 1)
	self.baseLayer:addChild( self.mainLayer )
end

function M:createRoleList()
	if self.roleListLayer then 
		self.baseLayer.removeChild( self.roleListLayer , true )
	end

	self.roleListLayer = display.newLayer()

	local roleList_frame = display.newSprite( PATH .. "roleList_frame.png" )
	setAnchPos( roleList_frame , display.cx , 650 , 0.5 )
	self.roleListLayer:addChild( roleList_frame  )

	local  frame_height = roleList_frame:getContentSize().height

	local pet_label = display.newSprite( PATH .. "pet_label.png" )
	setAnchPos( pet_label , 12 , roleList_frame:getContentSize().height / 2 , 0 , 0.5 )
	roleList_frame:addChild( pet_label  )

	local hero_label = display.newSprite( PATH .. "hero_label.png" )
	setAnchPos( hero_label , 123 , roleList_frame:getContentSize().height / 2 , 0 , 0.5 )
	roleList_frame:addChild( hero_label  )

	local pet_data = DATA_Bag:getTable("pet" , { id = DATA_Pet:getFighting() })[DATA_Pet:getFighting()..""]
	local hero_data = DATA_Formation:get()

	local petIcon , heroBtn
	local iconGroup = KNRadioGroup:new()	--icon单选
	local iconScroll = KNScrollView:new( 174 , 650 , 279 , 100 , 10 , true , 0  )
	local hasPet = false

	if pet_data and table.nums(pet_data) ~= 0 then hasPet = true end
		
	if hasPet then 
		petIcon= KNBtn:new(SCENECOMMON, {"skill_frame1.png", "select1.png"},85,frame_height / 2,{
			anchMid = true,
			front =(pet_data and table.nums(pet_data) ~= 0) and getImageByType( tonumber(pet_data.cid) , cid  ) or nil,
			parent = scroll,
			callback = function()
				print("pet")
				self.cur_roleType = "pet"
				self.cur_zhenwei = nil
				self:createPetPage( self.params.data["pet"] )
			end 
		} ,iconGroup)
	else
		petIcon= KNBtn:new(SCENECOMMON, {"skill_frame1.png"},85,frame_height / 2,{
			anchMid = true,
			callback = function()
				KNMsg:getInstance():flashShow("当前没有出战的幻兽")
			end 
		})
	end

	roleList_frame:addChild(petIcon:getLayer())

	for i = 1 , tonumber(hero_data.count) do
		local cid = DATA_Formation:get_index(i)["cid"]
		local gid = DATA_Formation:get_index(i)["gid"]
		local hero = DATA_Bag:get("general" , gid .. "")

		local hero_img_path = IMG_PATH .. "image/hero/"
		if HAS_GOD_GENERAL and hero["god"] == 1 then
			hero_img_path = IMG_PATH .. "image/hero/shen/"			-- 天神
		end

		heroBtn = KNBtn:new( SCENECOMMON , {"skill_frame1.png", "select1.png"} , 0 , 0 ,
				{
					id = i ,
					upSelect = true ,
					selectZOrder = 12,
					parent = iconScroll,
					front =  hero_img_path .. getImageByType( cid , "s" , true ) ,
					noHide = true,
					parent = iconScroll,
					callback = function()
						self.cur_roleType = "hero"
						self.cur_zhenwei = i 
						self:createHeroPage(self.params.data["general"][self.cur_zhenwei..""] )
					end 
		},iconGroup)
	
		iconScroll:addChild(heroBtn:getLayer())
	end

	for i = tonumber(hero_data.count)+1 , 8 do
		heroBtn = KNBtn:new( SCENECOMMON , {"skill_frame1.png"} , 0 , 0 ,
			{
				upSelect = true ,
				selectZOrder = 12,
				parent = iconScroll,
				noHide = true,
				parent = iconScroll,
				text = { "阵"..numConfig[i] , 22 , ccc3( 0 , 0 , 0 ) },
				callback = function()
					KNMsg:getInstance():flashShow("当前阵位没有上阵的英雄")
				end 
		})
	
		iconScroll:addChild(heroBtn:getLayer())
	end

	iconScroll:alignCenter()

	if self.cur_zhenwei then
		iconGroup:chooseByIndex( hasPet and self.cur_zhenwei+1 or self.cur_zhenwei , true )
		iconScroll:setIndex(hasPet and self.cur_zhenwei+1 or self.cur_zhenwei )
	else
		iconGroup:chooseByIndex( 1 , true )
		-- create
	end

	self.roleListLayer:addChild( iconScroll:getLayer() )
	if CHANNEL_GROUP =="dhsh" or CHANNEL_GROUP =="hy" then   --大话没有该条说明
	else
		-- local have = createLabel({str = "(说明：加成效果为英雄的基础属性)", size = 18, width = 400, color=ccc3(255,0,0)})
		-- setAnchPos(have, 241, 95,0.5)
		-- self.roleListLayer:addChild(have)
	end
	
	self.baseLayer:addChild( self.roleListLayer , 10 )
end

function M:createHeroPage(param)
	if self.mainLayer then 
		self.baseLayer:removeChild( self.mainLayer , true )
	end

	self.mainLayer = display.newLayer()

	local bg = display.newSprite( PATH .. "bg1.jpg" )
	setAnchPos( bg , display.cx , display.cy , 0.5 , 0.5 )
	self.mainLayer:addChild( bg , -1 )

	local valueConfig = { "lingyuan" , "qiyun" }
	local shenwei_lv = tonumber(self.params.data["general"][self.cur_zhenwei..""]["atk"]["shenwei_lv"]) or 0

	for i=1,#valueConfig do
		local offSetX = 0
		if i == 2 then 
			offSetX = offSetX + 240
		end

		local label = display.newSprite( PATH .. valueConfig[i].."_value.png" )
		setAnchPos( label , 42 + offSetX , 600 )
		self.mainLayer:addChild( label )

		local num_length = string.len((DATA_GodCell:get( valueConfig[i] ) or 0).."")

		local tempText = display.strokeLabel(DATA_GodCell:get( valueConfig[i] ) or "0", 120 + offSetX  , 603, 18, ccc3(0xff,0xff,0xff))
		self.mainLayer:addChild( tempText )

		local addBtn = KNBtn:new( PATH , { "add.png" , "add_pre.png" } , 125 + offSetX + num_length*10, 595 , {
				callback = function()
					if valueConfig[i] == "lingyuan" then 
						btn_type = 1
						self:refreshResolve()
					else
						HTTP:call("trial","getInfo",{  } , {
								success_callback = function( data )
										self:backToSelf(false)
										switchScene("bloodTrial",data)
										end
							})
					end
				end
			} )
		self.mainLayer:addChild( addBtn:getLayer() )
	end

	local hasAni = true
	for i = 1 , #attribCofnig do
		local attr = attribCofnig[i]
		if tonumber(param[attr]["lv"]) ~= 0 then hasAni = false end
	end

	
	local temp
	for i = 1 , #attribCofnig do
		local attr = attribCofnig[i]
		local offSetY = -6

		local flag = false

		if tonumber(param[attr]["lv"]) ~= 0 then flag = true end

		temp = KNBtn:new( PATH , flag and {attr..".png", attr.."_pre.png"} or { attr.."_dis.png" } , posConfig[attr][1] , posConfig[attr][2] +offSetY ,
			{
				callback = function()
					self.cur_attr = attr
					self:createAdvance()
				end 
			})
		self.mainLayer:addChild( temp:getLayer() )

		local attr_label = display.newSprite( PATH .. attr .. "_label.png" )
		setAnchPos( attr_label , posConfig[attr][1] - 15 , posConfig[attr][2] - 15+offSetY + (attr == "atk" and 132 or 0) )
		self.mainLayer:addChild( attr_label )

		local g_cur_num = display.strokeLabel(param[attr]["g_cur_num"] , posConfig[attr][1] + 10 , posConfig[attr][2] - 15 +offSetY + (attr == "atk" and 132 or 0) , 18, ccc3(0xff,0xff,0xff))
		self.mainLayer:addChild( g_cur_num )

		local num_length = string.len(param[attr]["g_cur_num"].."")

		local cur_num = display.strokeLabel("+"..param[attr]["cur_num"], posConfig[attr][1] + 10 + num_length * 10 , posConfig[attr][2] - 15 +offSetY + (attr == "atk" and 132 or 0) , 18, ccc3(77,147,40))
		self.mainLayer:addChild( cur_num )

		if shenwei_lv ~= 0 then 
			local shenka_num = display.strokeLabel("+"..param[attr]["shenka_num"] .. "("..param[attr]["shenka"].."%)", posConfig[attr][1] + 10 , posConfig[attr][2] - 35 +offSetY + (attr == "atk" and 132 or 0) , 18, ccc3(77,147,40))
			self.mainLayer:addChild( shenka_num )
		end

		if flag then 
			local effetFrames = display.newFramesWithImage(PATH..attr.."_effect.png", 16, 1)
			local action = display.playFrames(0, 0, effetFrames, 0.2, {
					forever = true,
				})
			setAnchPos(action,posConfig[attr][1], posConfig[attr][2] - 5)
			self.mainLayer:addChild(action , 1)
		else
			if hasAni and attr == "atk" then 
				-- local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
				-- local ani = display.playFrames( posConfig[attr][1] + 47, posConfig[attr][2] + 47 ,frames, 0.2, {
				-- 	forever = true,
				-- })
				-- self.mainLayer:addChild(ani,5)

				local arrow_ani = display.newSprite(PATH.."arrow_ani.png")
				setAnchPos(arrow_ani, posConfig[attr][1] + 34, posConfig[attr][2] + 47)
				local function jump()
					local action = getSequenceAction(CCJumpTo:create(1,  ccp(posConfig[attr][1] + 34,posConfig[attr][2] + 47), 30, 1), CCCallFunc:create(function()
						arrow_ani:runAction(jump())
					end))
					return action
				end
				arrow_ani:runAction(jump())
				self.mainLayer:addChild(arrow_ani , 11)

			end
		end
	end

	if shenwei_lv ~= 0 then 
		self.mainLayer:addChild( display.strokeLabel("攻防敏血", 209, 270 , 18, ccc3(77,147,40)) )
		self.mainLayer:addChild( display.strokeLabel("+"..param["atk"]["shenka"] .. "%", 219, 250 , 18, ccc3(77,147,40)) )
	end
	
	local centerBtn = KNBtn:new( PATH , {"center.png", "center_pre.png"} , 189 , 285 ,
			{
				text = { shenwei_lv == 0 and "未开启" or  "+"..param["atk"]["shenka"] .. "%" , 30 , ccc3(255,255,255) },
				callback = function()
					if shenwei_lv < table.nums(shenwei_config) then
						if 0 == shenwei_lv then
							self.baseLayer:addChild( self:shenkaAdvance():getLayer() , 1)
						else
							self:shenweiUpt(shenwei_lv)
						end
					else
						KNMsg:getInstance():flashShow("已达到下位神满级，无法升级到中位神")
					end
				end 
			})
	self.mainLayer:addChild( centerBtn:getLayer() )

	local center_effect = display.newFramesWithImage(PATH.."center_effect.png", 16, 1)
	action = display.playFrames(0, 0, center_effect, 0.2, {
		forever = true,
	})
	setAnchPos(action, 189 , 285 )
	self.mainLayer:addChild(action , 1)


	self.baseLayer:addChild( self.mainLayer )
end

function M:openGodCell(param)
	-- self:uPAction(param)
	local tempLayer = display.newLayer()
	local mask = KNMask:new({item = tempLayer, priority = -151})
	local bg = display.newSprite( PATH .. "tip_bg.png" )
	setAnchPos( bg , 240 , 218 , 0.5 )
	tempLayer:addChild( bg )

	local title_bgSp = display.newSprite(COMMONPATH .. "change_title_bg.png")
 	setAnchPos(title_bgSp,240,540 , 0.5)
 	tempLayer:addChild(title_bgSp)	

 	local godcellpoint_title = display.newSprite(PATH.."godcellpoint_title.png")
 	setAnchPos(godcellpoint_title,240,560 , 0.5)
 	tempLayer:addChild(godcellpoint_title)

 	local tempImg = display.newSprite( PATH .. "three_row.png" )
 	setAnchPos( tempImg , 240 , 358 , 0.5 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "openget_label.png" )
 	setAnchPos( tempImg , 51 , 484 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "openexpend_label.png" )
 	setAnchPos( tempImg , 51 , 443 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "lucky_value.png" )
 	setAnchPos( tempImg , 61 , 325 )
 	tempLayer:addChild( tempImg )

 	local data , isHero
 	if self.cur_roleType == "pet" then 
 		isHero = false
 		data = pet_xingdian_config[param.index..""]
 	else
 		isHero = true
 		data = xingdian_config[self.cur_attr][param.index..""]
 	end

	tempLayer:addChild( display.strokeLabel(textConfig[self.cur_attr].."加成".. (isHero and data.jiacheng or data.atk_jiacheng) .."，开启后还可海量提升", 156, 489, 18, ccc3(44,0,0)) )  				--开启获得  属性加成
	tempLayer:addChild( display.strokeLabel(replaceStr("需灵源值：")..(isHero and data.xiaohao or data.atk_xiaohao), 182, 416, 18, ccc3(44,0,0)) )  				--需要灵源值
	tempLayer:addChild( display.strokeLabel("需银两："..data.silver or "0", 182, 391, 18, ccc3(44,0,0)) )  												--需银两
	tempLayer:addChild( display.strokeLabel("开启概率："..(isHero and data.gailv or data.atk_gailv ).. "%", 182, 366, 18, ccc3(44,0,0)) )  				--开启概率

	tempLayer:addChild( display.strokeLabel("幸运值满后下一次必定开启", 148, 295, 18, ccc3(183,29,29)) ) 

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 520 , {
				priority = -152,
				scale = true,
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(close:getLayer())

	if self.cur_roleType == "pet" then 
 		jie_data = self.params.data["pet"][self.cur_attr]["jie"][param.index..""]
 	else
 		jie_data = self.params.data["general"][self.cur_zhenwei..""][self.cur_attr]["jie"][param.index..""]
 	end

	local openBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 175 , 242 , {
				priority = -152,
				front = PATH .. "open_text.png",
				callback = function()

					local action = ""
					local post_data = {}
					if self.cur_roleType == "pet" then 
						action = "xingtu_up_pet"
						post_data = { tolv = param.index }
					else
						action = "xingtu_up"
						post_data = { id = self.cur_zhenwei , type = self.cur_attr , tolv = param.index }
					end

					HTTP:call("shenyuan", action, post_data , {success_callback = 
					function(data)
						self.params.data = data
						if data.isup == 0 then 
							if data.return_msg then KNMsg:getInstance():flashShow(data.return_msg) end									
							self:createAdvance()
						else
							KNMsg:getInstance():flashShow("开启成功,当前最大进阶为"..(tonumber(jie_data["max"])+1).."级")
							if param.index == 1 then 
								self:createAdvance()
							else
								self:uPAction( param )
							end
						end
					end})
					
					mask:remove()
				end})
	tempLayer:addChild(openBtn:getLayer())

	local lucky_bar = KNBar:new("lucky" ,  143 , 515 , { maxValue = data["max"] or 0 , curValue = param.failure or 0  , color = ccc3( 0,0,0 ) , closeText = true })
	tempLayer:addChild( lucky_bar )

	setAnchPos( tempLayer , 0 , display.height , 0 , 0 )
	transition.moveTo( tempLayer , { time = 0.5 , y = 0 , easing = "BACKOUT"})

	return mask
end

function M:shenweiUpt(lv)
	local layer = display.newLayer()
	local mask = showTip({
		bg = COMMONPATH.."tip_bg2.png",
		title_text = PATH.."upt/title.png",
		title_bg = COMMONPATH .. "change_title_bg.png",
		titleOffsetY = 50,
		titleTextY = 5,
		parent = self.baseLayer,
		content = layer,
		close = {
			normal = "back_img.png",
			pre = "back_img_press.png",
			y = 300,
		}
	})

	local text = "神火"
	if CHANNEL_GROUP == "hy" then
		text = "仙人"
	elseif CHANNEL_GROUP == "dhsh" then
		text = "官威"
	end

	local curCfg = shenwei_config[lv ..""]
	local nextCfg = shenwei_config[(lv+1) ..""]
	display.newSprite(PATH .."upt/pic.png", display.cx, 350):addTo(layer)
	display.newSprite(PATH .."upt/text1.png", 124, 203):addTo(layer)
	display.newSprite(PATH .."upt/text2.png", 346, 203):addTo(layer)
	display.newSprite(PATH .."upt/text3.png", 124, 454):addTo(layer)
	display.newSprite(PATH .."upt/text4.png", 334, 454):addTo(layer)
	display.strokeLabel(nextCfg.num .."", 184, 187, 20, ccc3(0, 0, 0)):addTo(layer)
	display.strokeLabel(nextCfg.hunnum .."", 406, 187, 20, ccc3(0, 0, 0)):addTo(layer)
	display.strokeLabel(DATA_GodCell:get("shenge") or "0", 204, 438, 20, ccc3(0, 0, 0)):addTo(layer)
	display.strokeLabel(DATA_Bag:countItems("prop",nil,{cid="17158"}), 414, 438, 20, ccc3(0, 0, 0)):addTo(layer)
	display.strokeLabel("下位神" ..lv .."级: " ..text .."属性加成" ..curCfg.jiacheng*100 .."％(可升至" ..nextCfg.jiacheng*100 .."％)", 70, 265, 18, ccc3(255, 255, 0)):addTo(layer)

	local btn = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , display.cx, 235, {
		front = COMMONPATH.."up_small.png",
		anchMid = true,
		priority = -256,
		callback = function()
			HTTP:call("shenyuan", "shenwei", { id = self.cur_zhenwei } , {success_callback = 
				function(data)
					mask:remove()
					self.params.data = data
					self:createHeroPage(self.params.data["general"][self.cur_zhenwei..""] )
					KNMsg:getInstance():flashShow("升级成功")
			end})
		end
	})
	layer:add(btn:getLayer())
end

function M:shenkaAdvance()
	local tempLayer = display.newLayer()
	local mask = KNMask:new({item = tempLayer, priority = -151})

	local offSetY = 10

	local bg = display.newSprite( PATH.. "tip_bg.png" )
	setAnchPos( bg , 240 , 218 , 0.5 )
	tempLayer:addChild( bg )

	local title_bgSp = display.newSprite(COMMONPATH .. "change_title_bg.png")
 	setAnchPos(title_bgSp,240,540 , 0.5)
 	tempLayer:addChild(title_bgSp)	

 	title_bgSp = display.newSprite(PATH.."shenka_advance_bg.png")
 	setAnchPos(title_bgSp,240,325 + offSetY , 0.5)
 	tempLayer:addChild(title_bgSp)

 	local godcellpoint_title = display.newSprite(PATH.."shenka_advance_title.png")
 	setAnchPos(godcellpoint_title,240,560 , 0.5)
 	tempLayer:addChild(godcellpoint_title)

 	local tempImg = display.newSprite( PATH .. "godCell_num_label.png" )
 	setAnchPos( tempImg , 240 , 290 + offSetY, 0.5 )
 	tempLayer:addChild( tempImg )

 	local shenwei_lv = tonumber(self.params.data["general"][self.cur_zhenwei..""]["atk"]["shenwei_lv"])+1 or 0

	tempLayer:addChild( display.strokeLabel(DATA_GodCell:get("shenge") or "0", 210, 293 + offSetY, 18, ccc3(44,0,0)) )  				--剩余神格碎片
	tempLayer:addChild( display.strokeLabel(shenwei_config[shenwei_lv..""]["num"].."", 417, 293 + offSetY , 18, ccc3(44,0,0)) )  				--消耗神格碎片
	
	local desc_text = display.strokeLabel(replaceStr("说明：点燃神火后神格全属性加成10%"), 240, 320, 20, ccc3(241,214,93) , nil , nil  )		--说明
	setAnchPos( desc_text , 240 , 350 , 0.5 )
	tempLayer:addChild( desc_text ) 	

	desc_text = display.strokeLabel(replaceStr("神格碎片在铁血试炼中获得"), 240, 180, 16, ccc3(255,0,0) , nil , nil  )		--说明
	setAnchPos( desc_text , 240 , 228 , 0.5 )
	tempLayer:addChild( desc_text ) 	

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 520 + offSetY , {
				priority = -152,
				scale = true,
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(close:getLayer())

	local txslBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 75 , 243 + offSetY, {
				priority = -152,
				front = PATH .. "txsl_text.png",
				callback = function()
					HTTP:call("trial","getInfo",{  } , {
								success_callback = function( data )
										--dump(data)
										self:backToSelf(false)
										switchScene("bloodTrial",data)
										end
							})
					--mask:remove()
				end})
	tempLayer:addChild(txslBtn:getLayer())

	local confirmBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 275 , 243 + offSetY , {
				priority = -152,
				front = PATH .. "open_text.png",
				callback = function()
					mask:remove()	
					HTTP:call("shenyuan", "shenwei", { id = self.cur_zhenwei } , {success_callback = 
						function(data)
							self.params.data = data
							KNMsg:getInstance():flashShow("开启成功，本阵位神格属性全部加成10%")
							self:createHeroPage(self.params.data["general"][self.cur_zhenwei..""] )
					end})

				end})
	tempLayer:addChild(confirmBtn:getLayer())

	tempLayer:setScale(0)
	tempLayer:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.8, 1)))

	return mask
end

function M:distanceOfPoint(params)
	local dx = params.cutP.x - params.nextP.x 
	local dy = params.cutP.y - params.nextP.y

	return math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))
end

function M:shenjieLayer(param)
	if self.shenjielayer then 
		self.shenjielayer:removeFromParentAndCleanup(true)
	end
	self.shenjielayer = display.newLayer()
	self.baseLayer:addChild( self.shenjielayer )

	local tempLayer = display.newLayer()
	local mask = KNMask:new({item = tempLayer, priority = -151})

	local bg = display.newSprite( COMMONPATH .. "change_bg.png" )
	setAnchPos( bg , 240 , 124 , 0.5 )
	tempLayer:addChild( bg )

	local title_bgSp = display.newSprite(COMMONPATH .. "change_title_bg.png")
 	setAnchPos(title_bgSp,240,540 + 85, 0.5)
 	tempLayer:addChild(title_bgSp)	

 	local godcellpoint_title = display.newSprite(PATH.."godcellpoint_title.png")
 	setAnchPos(godcellpoint_title,240,560 + 85 , 0.5)
 	tempLayer:addChild(godcellpoint_title)

 	local tempImg = display.newSprite( PATH .. "two_row.png" )
 	setAnchPos( tempImg , 240 , 497 , 0.5 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "attr_bg.png" )
 	setAnchPos( tempImg , 49 , 389 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "attr_bg.png" )
 	setAnchPos( tempImg , 259 , 389 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "arrow.png" )
 	setAnchPos( tempImg , 240 , 404 , 0.5 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "four_row.png" )
 	setAnchPos( tempImg , 240 , 200 , 0.5 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "cur_attr_label.png" )
 	setAnchPos( tempImg , 94 , 440 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "cur_label.png" )
 	setAnchPos( tempImg , 65 , 502 )
 	tempLayer:addChild( tempImg )

 	tempImg = display.newSprite( PATH .. "strength_attr_label.png" )
 	setAnchPos( tempImg , 305 , 440 )
 	tempLayer:addChild( tempImg )

 	local jie_data , addition , lv_index

 	if self.cur_roleType == "pet" then 
 		jie_data = self.params.data["pet"][self.cur_attr]["jie"][param.index..""]
 		lv_index = tonumber(jie_data.lv)+1
 		addition = petxingdianlv_config[param.index..""][lv_index..""]
 	else
 		jie_data = self.params.data["general"][self.cur_zhenwei..""][self.cur_attr]["jie"][param.index..""]
 		lv_index = tonumber(jie_data.lv)+1
 		addition = heroxingdianlv_config[param.index..""][lv_index..""]
 	end

 	local additionConfig = { pk = { 160 , 300 , "qiyun"} , xiaohao = { 322 , 300  , "lingyuan"} , silver = { 160 , 259 , "silver" } , userlv = { 328 , 259 } }
 	local canAdvance = true
 	local function isSuit(key)
 		local v = additionConfig[key]
		if key == "userlv" then 
			if DATA_User:get("lv") < addition["userlv"] then 
				canAdvance = false
				return false
			end
		elseif key == "silver" then 
			if tonumber(DATA_Account:get( v[3] )) < tonumber(addition[key]) then 
				canAdvance = false
				return false
			end
		elseif key == "jie" then 
			if tonumber(jie_data.max) == tonumber(jie_data.lv) then 
				canAdvance = false
				return false
			end
		else
			if tonumber(DATA_GodCell:get( v[3] )) < tonumber(addition[key]) then 
				canAdvance = false
				return false
			end
		end

		if tonumber(jie_data.max) == tonumber(jie_data.lv) then 
			canAdvance = false
		end

		return true
 	end

 	local next_attr = ""

 	local jiacheng = 0
	if self.cur_roleType == "pet" then
		jiacheng =  tonumber(pet_xingdian_config[param.index..""]["atk_jiacheng"])
	else
		jiacheng = tonumber(xingdian_config[self.cur_attr][param.index..""]["jiacheng"])
	end


 	if jie_data.lv == jie_data.jie_max then 
 		next_attr = "MAX"
 	else
 		next_attr = "+" .. jie_data.config_num + jie_data.num + jiacheng
 	end

	tempLayer:addChild( display.strokeLabel(jie_data.lv.."/"..jie_data.max, 177, 510, 18, ccc3(44,0,0)) )  				--进阶次数
	tempLayer:addChild( display.strokeLabel(textConfig[self.cur_attr].."+"..(jie_data.num + jiacheng), 100, 409, 20, ccc3(255,255,255)) )  				--当前属性
	tempLayer:addChild( display.strokeLabel(textConfig[self.cur_attr]..next_attr, 305, 409, 20, ccc3(255,255,255)) )  --下一阶属性
	tempLayer:addChild( display.strokeLabel(replaceStr(textConfig[self.cur_attr].."神格开启第"..(jie_data.lv+1).."个点"), 163, 220, 18, isSuit("jie") and ccc3(44,0,0) or ccc3(255,0,0)) )  				--神格点

	for key , v in pairs(additionConfig) do
		tempLayer:addChild( display.strokeLabel(addition[key] or "0", v[1], v[2], 18, isSuit(key) and ccc3(44,0,0) or ccc3(255,0,0)) ) 
	end

	tempLayer:addChild( display.strokeLabel(canAdvance and "可进阶" or "不可进阶" , 177, 553, 18, canAdvance and ccc3(72,200,15) or ccc3(255,0,0) ))  				--当前状态
			

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 520 + 85 , {
				priority = -152,
				scale = true,
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(close:getLayer())

	local txslBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 25 , 150 , {
				priority = -152,
				front = PATH .. "txsl_text.png",
				callback = function()
					HTTP:call("trial","getInfo",{  } , {
								success_callback = function( data )
									self:backToSelf(true)
									switchScene("bloodTrial",data)
								end
							})
					--mask:remove()
				end})
	tempLayer:addChild(txslBtn:getLayer())

	local lyjhBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 170 , 150 , {
				priority = -152,
				front = PATH .. "lyjh_text.png",
				callback = function()
					showTip({
						priority = -153,
						content = createLabel({str = "使用一个灵源精华，可使当前"..replaceStr("神格").."提升一阶，你确定要使用吗？", width = 400}),
						left = {
							remove = true,
							callback = function()	
								local action , post_data
								if self.cur_roleType == "pet" then 
									action = "jie_up_jinghua_pet"
									post_data = { lv = param.index }
								else
									action = "jie_jinghua_up"
									post_data = { id = self.cur_zhenwei , type = self.cur_attr , lv = param.index }
								end

								HTTP:call("shenyuan", action , post_data , {success_callback = 
								function(data)
									KNMsg:getInstance():flashShow("进阶成功")
									self.params.data = data
									self:createAdvance( {index = param.index} )
									self:shenjieLayer( {index = param.index} )
									
								end})
							end
						},right = {
							remove = true	
						}
					})
				end})
	tempLayer:addChild(lyjhBtn:getLayer())

	local advanceBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 313 , 150 , {
				priority = -152,
				front = PATH .. "advance_text.png",
				callback = function()
					local action , post_data
					if self.cur_roleType == "pet" then 
						action = "jie_up_pet"
						post_data = { lv = param.index }
					else
						action = "jie_up"
						post_data = { id = self.cur_zhenwei , type = self.cur_attr , lv = param.index }
					end

					HTTP:call("shenyuan", action , post_data , {success_callback = 
					function(data)
						-- dump(data)
						KNMsg:getInstance():flashShow("进阶成功")
						self.params.data = data
						self:createAdvance( {index = param.index} )
					end})
					mask:remove()

				end})
	tempLayer:addChild(advanceBtn:getLayer())

	if param.action then 
		tempLayer:setScale(0)
		tempLayer:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.8, 1)))
	end

	self.shenjielayer:addChild( mask:getLayer() )

	-- return mask
end

function M:createAdvance(param)
	SCENETYPE = ADVANCE
	if self.advanceLayer then 
		self.baseLayer:removeChild( self.advanceLayer , true )
	end

	if self.pageLayer then
		self.pageLayer:removeFromParentAndCleanup( true )
		self.pageLayer = nil
	end
	if self.viewLayer then
		self.viewLayer:removeFromParentAndCleanup( true )
		self.viewLayer = nil
	end
	if self.mainLayer then
		self.baseLayer:removeChild( self.mainLayer , true )
	end

	if self.roleListLayer then 
		-- self.roleListLayer:setPositionX( 480 )
		self.baseLayer:removeChild( self.roleListLayer , true )
	end

	local data
	if self.cur_roleType == "pet" then 
		data = self.params.data["pet"][self.cur_attr]
	else
		data = self.params.data["general"][self.cur_zhenwei..""][self.cur_attr]
	end
	-- dump(data)
	self.advanceLayer = display.newLayer()
	self.baseLayer:addChild( self.advanceLayer )

	local bg = display.newSprite( PATH .. "bg2.jpg" )
	setAnchPos( bg , display.cx , display.cy , 0.5 , 0.5 )
	self.advanceLayer:addChild( bg , -2 )

	bg = display.newSprite( PATH .. "jinjie_label.png" )
	setAnchPos( bg , 182 , 704 )
	self.advanceLayer:addChild( bg )

	self.advanceLayer:addChild( display.strokeLabel( "最高"..data.jie["1"].max.."阶" , 250 , 710 , 18, ccc3( 0xff , 0xff , 0xff )  ) )

	local attr = self.cur_attr
	local attrPos = self:getPosByAttr(attr)

	local function godCell( temp )

		local layer = display.newLayer()
		layer:setTag(temp.index)

		local offSetX = 87/2
		local offSetY = 87/2

		local bulkingX , bulkingY = ( temp.nextP.x - temp.cutP.x ) / 2  , ( temp.nextP.y - temp.cutP.y ) / 2 	--计算两点中间点偏移值

		local posX , posY = offSetX + bulkingX , offSetY + bulkingY 
		local distance = self:distanceOfPoint( temp )
		local angle = countAngle( temp )

		local line = display.newSprite( PATH .. "line.png" , posX  , posY , 0.5 , 0.5  )
		-- line:setTag(temp.index * 10)
		local scaleX = (distance - 87/2)/line:getContentSize().width

		local jie_data = data.jie[temp.index..""]

		local godCellBtn = KNBtn:new( PATH , temp.status and { attr.."_s.png" , attr.."_s_pre.png" } or { attr.."_s_dis.png" } , - 0 , -0 , {
			scale = true , 
			other = temp.status and {{IMG_PATH .. "image/common/egg_num_bg.png",63,63}},
			text = temp.status and {jie_data.lv,18,ccc3(0xff,0xff,0xff),ccp(30,30),nil,17},
			callback = function()  
				if temp.index -1 ~= temp.lv and temp.status == false then
					KNMsg:getInstance():flashShow("必须顺序开启神格点")
					return 
				end 

				if temp.status == true then 
					if jie_data.lv == jie_data.jie_max then 
						KNMsg:getInstance():flashShow("当前神格已达到最大等级，不可进阶")
						return 
					end
					self:shenjieLayer({index = temp.index , action = true})
				else
					self.baseLayer:addChild( self:openGodCell( {failure =data.failure , index = temp.index ,parent = self.advanceLayer:getChildByTag(temp.index-1) ,temp = temp }  ):getLayer() )
				end
			end })

		
		layer:addChild( godCellBtn:getLayer() , 2 )
	
		local contentSize = godCellBtn:getLayer():getContentSize()
		layer:setContentSize( contentSize )

		local attr_frame = display.newSprite( PATH .. "attr_frame.png" )
		setAnchPos( attr_frame , -15 ,-10 ,0 ,0 )
		layer:addChild( attr_frame  )


		local angleFlag = true
		if math.abs(angle) < 180 then 
			angleFlag = false
		end
		
		line:setRotation( angleFlag and angle or (angle+180)  )
		line:setScaleX( scaleX )
		layer:addChild( line , - 1)


		if temp.status == true then
			if tonumber(data.lv) ~= temp.index then 
				local attr_line = display.newSprite( PATH .. attr.."_line.png" , posX  , posY , 0.5 , 0.5  )
				attr_line:setRotation( angleFlag and angle or (angle+180)  )
				attr_line:setScaleX( scaleX )
				layer:addChild( attr_line  , 1)
			end

			local effetFrames = display.newFramesWithImage(PATH..self.cur_attr.."_effect.png", 16 ,1)
			local action = display.playFrames(40, 43, effetFrames, 0.2, {
					forever = true,
					onComplete = function() 
						
				 	end
				})
			action:setScale( 0.92 )
			layer:addChild( action , 4 )

			local attr_frame1 = display.newSprite( PATH .."attr_frame1.png" )
			setAnchPos( attr_frame1 , -20 ,-40 ,0 ,0 )
			layer:addChild( attr_frame1 , 3 )

			if jie_data.lv ~= jie_data.jie_max then 
				local addAttrBtn = KNBtn:new( PATH , { "add_attr.png" , "add_attr_pre.png" } , 70 , 0 , {				
					callback = function()  
						if jie_data.lv == jie_data.jie_max then 
							KNMsg:getInstance():flashShow("当前神格已达到最大等级，不可进阶")
							return 
						end
						self:shenjieLayer({index = temp.index , action = true})
					end })
				layer:addChild(addAttrBtn:getLayer() , 10)
			end

			-- local advance_label = display.newSprite( PATH .. "grade_label.png" )
			-- setAnchPos( advance_label , -20 ,-31 ,0 ,0 )
			-- layer:addChild( advance_label  , 3)

			local attr_str = "" 

			local attr_num = 0
			if self.cur_roleType == "pet" then
				attr_num = tonumber(jie_data.num) + tonumber(pet_xingdian_config[temp.index..""]["atk_jiacheng"])
			else
				attr_num = tonumber(jie_data.num) + tonumber(xingdian_config[self.cur_attr][temp.index..""]["jiacheng"])
			end


			-- if jie_data.lv == jie_data.jie_max then 
			-- 	attr_str = "MAX"
			-- else
			attr_str = sampleName[self.cur_attr].."+" .. attr_num
			-- end

			if self.cur_roleType == "pet" then 
				layer:addChild( display.strokeLabel( attr_str , 10 , -25 , 16, ccc3( 0xff , 0xff , 0xff )  ) , 10 )	--属性加成
			else
				layer:addChild( display.strokeLabel( attr_str , 10 , -25 , 16, ccc3( 0xff , 0xff , 0xff )  ) , 10 )	--
			end
			local attr_border = display.newSprite( PATH .. attr.."_border.png" )
			setAnchPos( attr_border , -15 ,-10 ,0 ,0 )
			layer:addChild( attr_border )
		else

			if temp.index -1 ~= temp.lv then 
				local lock = display.newSprite( PATH .. "lock.png" )
				setAnchPos( lock , 60 , 5 ,0 ,0 )
				layer:addChild( lock  , 10 )
			end

			if temp.index == 1 then 
				-- local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
				-- local ani = display.playFrames( layer:getContentSize().width/2  , layer:getContentSize().height/2 ,frames, 0.2, {
				-- 	forever = true,
				-- })
				-- layer:addChild(ani,5)

				local arrow_ani = display.newSprite(PATH.."arrow_ani.png")
				setAnchPos(arrow_ani, 32, 50)
				local function jump()
					local action = getSequenceAction(CCJumpTo:create(1,  ccp(32,50), 30, 1), CCCallFunc:create(function()
						arrow_ani:runAction(jump())
					end))
					return action
				end
				arrow_ani:runAction(jump())
				layer:addChild(arrow_ani , 11)
			end
		end	
	
		return layer
	end

	for i = 1 , table.nums(data.jie) do
		local tempData = data.jie[i..""]
		local curData = attrPos[ i .. "" ]
		local status = false
		local bPoint 
		if i == table.nums(data.jie) then
			bPoint = curData
		else
			bPoint = attrPos[ ( i + 1 ) .."" ]
		end
		
		if data.lv < i then 
			status = false
		else
			status = true
		end

		local curStar = godCell(  { cutP = curData , nextP = bPoint , index = i  , status = status , lv = data.lv , failure = data.failure}  )
		setAnchPos( curStar , curData.x  , curData.y  , 0.5 , 0.5)

		if i - 1 == data.lv then 
			local maxValue
		 	if self.cur_roleType == "pet" then 
		 		maxValue = pet_xingdian_config[i..""]["max"]
		 	else
		 		maxValue = xingdian_config[self.cur_attr][i..""]["max"]
		 	end

		 -- 	local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
			-- local ani = display.playFrames( curStar:getContentSize().width/2  , curStar:getContentSize().height/2 ,frames, 0.2, {
			-- 	forever = true,
			-- })
			-- curStar:addChild(ani,5)

			local s_lucky_bar = KNBar:new("sLuck" ,  curData.x, display.height - curData.y , { maxValue = maxValue , curValue =  data.failure , closeText = true })
			self.advanceLayer:addChild( s_lucky_bar , 10 )
		end

		self.advanceLayer:addChild( curStar  )
	end

end

function M:uPAction(param)

	local mask = KNMask:new({priority = -220 , opacity = 0})
	self.baseLayer:addChild( mask:getLayer() )

	local attr = self.cur_attr
	local attrPos = self:getPosByAttr(attr)

	local layer = param.parent

	local index = tonumber(param.index)
	local cutP = attrPos[ index - 1 .. "" ]
	local nextP = attrPos[ index  .."" ]

	local temp = { cutP = cutP , nextP = nextP }
	local layer = param.parent
	local line = display.newSprite( PATH .. "line.png" , posX  , posY , 0.5 , 0.5  )
	-- local line = layer:getChildByTag( (param.index-1)*10 )

	local offSetX = 87/2
	local offSetY = 87/2
	local bulkingX , bulkingY = ( temp.nextP.x - temp.cutP.x ) / 2  , ( temp.nextP.y - temp.cutP.y ) / 2 	--计算两点中间点偏移值
	local posX , posY = offSetX + bulkingX , offSetY + bulkingY 
	local distance = self:distanceOfPoint( temp )

	local action , action2
	local effetFrames1 = display.newFramesWithImage(PATH..self.cur_attr.."_up_effect.png", 14, 2)
	action = display.playFrames(0, 0, effetFrames1, 0.2, {
		onComplete = function() 

			local effetFrames2= display.newFramesWithImage(PATH.."up_grade_eff.png", 14, 2)
			action2 = display.playFrames(0, 0, effetFrames2, 0.2, {
				onComplete = function() 
					transition.stopTarget( action ) 
					delObj( action ) 
					transition.stopTarget( action2 ) 
					delObj( action2 ) 
					action2:removeFromParentAndCleanup(true)
					self:createAdvance()
					mask:remove()
				end
				})
			action2:setScale(0.76)
			setAnchPos(action2, temp.nextP.x + layer:getContentSize().width/2 - 2 , temp.nextP.y+ layer:getContentSize().height/2+7 , 0.5 , 0.5)
			self.baseLayer:addChild( action2  , 12)
	 	end
	})

	local angle = countAngle( temp )
	setAnchPos(action,offSetX + bulkingX, offSetY + bulkingY  , 0.5 , 0.5)				
	action:setRotation( angle )
	
	local scalex = (distance - 87/2)/line:getContentSize().width
	action:setScaleX( scalex )
	if math.abs(angle) < 180 then 
		local rotateBy =  CCRotateBy:create(0 , 180) 
		action:runAction(rotateBy)
	end
	layer:addChild(action , 1)
end

function M:refreshResolve()

	if self.comboBoxLayer then 
		self.comboBoxLayer:removeFromParentAndCleanup( true )
	end
	self:createResolve()
	self.comboBoxLayer = display.newLayer()
	self.baseLayer:addChild( self.comboBoxLayer , 10 )

	local function clickFun( key )
		for i = 1 , #keyElement do
			if keyElement[i] ==  key then
				TABLETYPE = i
				break
			end
		end
		self:createResolve()
	end

	local buttonConfig = { "general" , "skill" , "pet" }
	local KNComboBox = requires(IMG_PATH,"GameLuaScript/Common/KNComboBox")
	btn_group = KNRadioGroup:new()
	local items = {}
	for i = 1,#buttonConfig do
		items[i] = KNBtn:new( PATH, { buttonConfig[i].."_text.png" , "selected.png"}, 0, 0, {
			id = i,
			noHide = true,
			upSelect = true ,
			-- priority = -220 , 
			callback = function()
				btn_type = i
				comboBox:autoShow()
				comboBox:refreshBtn( { front = GALAXYPATH .. buttonConfig[btn_type].."_text.png" })
				clickFun( buttonConfig[btn_type] )

			end
		},btn_group)
	end

	comboBox = KNComboBox:new(377, 674, {
		dir = COMMONPATH,
		res = {"btn_bg.png", "btn_bg_pre.png"},
		front = PATH .. buttonConfig[btn_type].."_text.png" ,
		bg = PATH.."combo_bg.png",
		up = false,
		offset = -10,
		addX = 0,
		-- priority = -220 ,
		additionHeight = 0 ,
		items = items,
		money_default = btn_type,
		itemsGroup = btn_group
	})
	self.comboBoxLayer:addChild( comboBox:getLayer() , 11 )
end

function M:backToSelf(hasAttr)

	local backInfo = { cur_roleType = self.cur_roleType , cur_zhenwei = self.cur_zhenwei , cur_attr = hasAttr and self.cur_attr or nil }
	local backFunc = function()
	  	HTTP:call("shenyuan","enter_xingtu",{},{success_callback=
				function(data)
					switchScene("godCell" , { data = data, backInfo = backInfo , 
						backFun = function()
							switchScene("forge" , { index = 5  } ) 
						end })
				end
			})
	end
	DATA_GodCell:setGodBackFlag(true)
	DATA_GodCell:setBackFunc(backFunc)
end

--分解
function M:createResolve( params )
	params = params or {}
	local defTable = params.defTale	--默认table
	SCENETYPE = RESOLVE 	--当前选中场景类型 
	local tableLayer , selectLv
	self.infoLayer:refreshTitle( GALAXYPATH .. "resolve_title.png" )
	local gatherData = {}
	
	if self.pageLayer then
		self.pageLayer:removeFromParentAndCleanup( true )
		self.pageLayer = nil
	end
	if self.viewLayer then
		self.viewLayer:removeFromParentAndCleanup( true )
		self.viewLayer = nil
	end
	if self.roleListLayer then 
		self.roleListLayer:removeFromParentAndCleanup( self.roleListLayer , true )
		self.roleListLayer = nil
	end
	if self.mainLayer then 
		self.mainLayer:removeFromParentAndCleanup( self.roleListLayer , true )
		self.mainLayer = nil
	end

	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )
	
	self.viewLayer:addChild( display.newSprite(COMMONPATH.."dark_bg.png",0,425,0,0.5) )	--背景
	self.viewLayer:addChild( display.newSprite(COMMONPATH.."bg_img.png",display.cx,184,0.5,0) )	--背景
	self.viewLayer:addChild( display.newSprite(GALAXYPATH.."resolve_flag.png",20,656,0,0) )	--分解logo
	self.viewLayer:addChild( display.newSprite(GALAXYPATH.."cur_text.png",112,673,0,0) )	--现有及转换后
	self.viewLayer:addChild( display.newSprite(PATH .. "choose_label.png",336,674,0,0) )	
	
	
	local haveValue , convertValue
	haveValue = display.strokeLabel( DATA_GodCell:get( "lingyuan" ) or "0" , 250 , 708 , 20, ccc3( 0xfd , 0xfa , 0xd7 )  ) 	--当前拥有值
	self.viewLayer:addChild( haveValue )	
	convertValue = display.strokeLabel( "0" , 250 , 678 , 20, ccc3( 0xfd , 0xfa , 0xd7 )  ) 	--转换值
	self.viewLayer:addChild( convertValue )	
	local singleValue
	local function selectFun( value , flag )
		if flag then
			gatherData[ value.id .. "" ] =  nil
		else
			gatherData[ value.id .. "" ] = value.id
		end
		singleValue = getConfig( "lingyuan"  , (keyElement[TABLETYPE] == "general" and "hero" or keyElement[TABLETYPE]) .. "" )
		singleValue = tonumber( singleValue[ selectLv .. "" ]["num"])
		convertValue:setString( tostring( singleValue * table.nums( gatherData ) ) )
	end
	local listConfig = { { 4 , 5 } , { 3 , 4 , 5 } , { 3 , 4 , 5 } }
	tableLayer = tableList( { listConfig = {  path = COMMONPATH .. "tab/tab_star"  , config = listConfig[TABLETYPE] } , def = ( defTable or listConfig[TABLETYPE][1] ) ,  clickFun = function( key ) convertValue:setString(0) selectLv = key gatherData = {} self:createPage( key , selectFun ) end } )
	self.viewLayer:addChild( tableLayer )
	
	local oneBtn , twoBtn
	local btnConfig = { { "general" , "skill" } ,  { "pet" , "skill" } , { "pet" , "general" }}
	local function clickFun( key )
		for i = 1 , #keyElement do
			if keyElement[i] ==  key then
				TABLETYPE = i
				break
			end
		end
		self:createResolve()
	end
	
	-- local buttonConfig = { "general" , "skill" , "pet" }
	-- local KNComboBox = requires(IMG_PATH,"GameLuaScript/Common/KNComboBox")
	-- btn_group = KNRadioGroup:new()
	-- local items = {}
	-- for i = 1,#buttonConfig do
	-- 	items[i] = KNBtn:new( PATH, { buttonConfig[i].."_text.png" , "selected.png"}, 0, 0, {
	-- 		id = i,
	-- 		noHide = true,
	-- 		upSelect = true ,
	-- 		priority = -220 , 
	-- 		callback = function()
	-- 			btn_type = i
	-- 			comboBox:autoShow()
	-- 			comboBox:refreshBtn( { front = GALAXYPATH .. buttonConfig[btn_type].."_text.png" })
	-- 			clickFun( buttonConfig[btn_type] )

	-- 		end
	-- 	},btn_group)
	-- end
	-- btn_group:chooseByIndex(2)
	-- print("btn_type = " .. btn_type)

	-- comboBox = KNComboBox:new(357, 674, {
	-- 	dir = COMMONPATH,
	-- 	res = {"btn_bg.png", "btn_bg_pre.png"},
	-- 	front = PATH .. buttonConfig[btn_type].."_text.png" ,
	-- 	bg = PATH.."combo_bg.png",
	-- 	up = false,
	-- 	offset = -10,
	-- 	addX = 0,
	-- 	priority = -220 ,
	-- 	additionHeight = 0 ,
	-- 	items = items,
	-- 	money_default = 2,
	-- 	itemsGroup = btn_group
	-- })
	-- self.viewLayer:addChild( comboBox:getLayer() , 11 )

	
	-- oneBtn = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"} , 377 , 696 ,{
	-- 			front = PATH .. btnConfig[TABLETYPE][1] .. "_text.png",
	-- 			callback = function()
	-- 				clickFun( btnConfig[TABLETYPE][1] )
	-- 			end
	-- 		}):getLayer()
	-- self.viewLayer:addChild( oneBtn )
	-- twoBtn = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"} , 377 , 644 ,{
	-- 			front = PATH .. btnConfig[TABLETYPE][2] .."_text.png",
	-- 			callback = function()
	-- 				clickFun( btnConfig[TABLETYPE][2] )
	-- 			end
	-- 		}):getLayer()	
	-- self.viewLayer:addChild( twoBtn )
	

	--批量选择
	self.batchBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"} , 48 , 125 ,{
				front = COMMONPATH .. "batchSelect.png",
				callback = function()
					
					gatherData = {}  --清空
					
					local data = self:filterData( keyElement[ TABLETYPE ] , selectLv)
					local allKeys = table.keys(data) --所有key
					
					local  checkedKeys = {} --前20个key
					for i=1,#allKeys do
						if i<=20 then
							checkedKeys[i]=allKeys[i]
						end
					end
					
					self:createPage( selectLv , selectFun ,checkedKeys)
				end
			}):getLayer()
	self.viewLayer:addChild( self.batchBtn )
	self.transformBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"} , 272 , 125 ,{
				front = GALAXYPATH .. "transform.png",
				callback = function()
					if table.nums( gatherData ) == 0  then
						local textConfig = { "幻兽" , "英雄" , "技能" }
						KNMsg.getInstance():flashShow( "请选择要" .. replaceStr( "分解" ) .. "的" .. replaceStr( textConfig[ TABLETYPE ] ) )
						return
					end
					

					local function sendFun()
							HTTP:call(keyElement[TABLETYPE] .. "", "exchange_ly", { ids = string.join( gatherData , ",")  } , {success_callback = 
							function(data)
								if data["return"] and table.nums(data["return"])~=0 then
									self.baseLayer:addChild( self:resolveBackLayer(data["return"]):getLayer() , 12 )
								else 
									KNMsg.getInstance():flashShow( "分解成功,获得" .. tostring( singleValue * table.nums( gatherData ) ) .. replaceStr("灵源值！") )
								end
								self:createResolve( { defTale = selectLv , resetRefresh = { selectLv = selectLv } } )
							end})
					end
					local tipStr = ""
					if TABLETYPE == HERO then
						tipStr = replaceStr( "英雄" ) .. replaceStr( "经验" ) .. "将被消耗掉，若存在".. replaceStr( "宝石" ) .. "，则".. replaceStr( "宝石" ) .. "等级下降一级后自动放入".. replaceStr( "背包" ) .. "中，是否确认转换所有英雄？"
					elseif TABLETYPE == PET then
						tipStr = replaceStr( "幻兽" ) ..  replaceStr( "经验" ) .. "将被消耗掉，".. replaceStr( "幻兽" ) .. "有高等级".. replaceStr( "技能" ) .. "将返还".. replaceStr( "元素之心" ) .. replaceStr( "道具" ) .. "，是否确认转换所有幻兽？"
					else
						tipStr = ""
					end
					
					if tipStr=="" then
						sendFun()
					else
						KNMsg.getInstance():boxShow( tipStr ,{ 
																confirmFun = sendFun, 
																cancelFun = function() end 
																} )
					end
		
				end
			}):getLayer()	
	self.viewLayer:addChild( self.transformBtn )
end

--单个页面
function M:createPage( starLv , backFun ,checkedKeys)
	local data = self:filterData( keyElement[ TABLETYPE ] , starLv)
	--上阵武将不可分解
	if TABLETYPE == HERO then
		for key , v in pairs(data) do
			if DATA_Formation:checkIsExist(v.id) then	
				data[key] = nil			
			end
		end
	elseif TABLETYPE == PET then
		--出战宠物不可分解
		for key , v in pairs(data) do
			if DATA_Pet:getFighting() == (v.id) then	
				data[key] = nil			
			end
		end
	elseif TABLETYPE == SKILL then
		--已经装备 技能不可分解
		for key , v in pairs(data) do
			if DATA_ROLE_SKILL_EQUIP:getRoleId(v.id, "skill") then
				data[key] = nil			
			end
		end
	end
	
	if self.pageLayer then
		self.pageLayer:removeFromParentAndCleanup( true )
		self.pageLayer = nil
	end
	self.pageLayer = display.newLayer(0)
	self.viewLayer:addChild(self.pageLayer)
	
	local sv = KNScrollView:new(0,187,480,397,0,false)	
	local temp_count = 0
	local temp_line = 1
	local layers = {}
	
	for k,v in pairs(data) do
		for i = 0 , ( v["num"] and v["num"]- 1 or 0 )  do
			temp_count = temp_count + 1
			if layers[ temp_line ] == nil then
				layers[ temp_line ] = display.newLayer()
				layers[ temp_line ]:setContentSize( CCSizeMake(480 , 80) )
			end
			local the_stone 
			the_stone = KNBtn:new(IMG_PATH.."image/scene/common" , {"skill_frame1.png","yes.png"} , 45 + 80 * (temp_count - 1),0 , {
											front = getImageByType(v["cid"] , "s"),
											other = {{IMG_PATH .. "image/common/egg_num_bg.png",46,46}},
											text = {v["lv"],18,ccc3(0xff,0xff,0xff),ccp(23,24),nil,17},
											noHide = true,
											parent = sv,
											selectable = true,
											selectZOrder = 20,
											selectOffset = {17,-16},
											callback = function()
											    
												backFun( v , the_stone:isSelect())
											end
										})
			layers[ temp_line ]:addChild(the_stone:getLayer())
			--批量选中
			if checkedKeys ~= nil and checkedKeys ~={} then
				if table.hasValue(checkedKeys,k) then
				  	the_stone:select(true,true)
				end
			end

			
			if temp_count == 5 then
				temp_line = temp_line + 1
				temp_count = 0
			end
		end
	end
	for i = 1 , #layers do
		sv:addChild( layers[i] )
	end
	self.pageLayer:addChild( sv:getLayer() )
	
	if table.nums(data) == 0  then
		self.pageLayer:addChild( display.newSprite( COMMONPATH .. "empty.png" , display.cx , display.cy , 0.5 , 0.5) )
	end
end

--星系配置图
function M:getPosByAttr( key )
	local offX = 0
	local offY = 0

	local starAdd = { 
			atk = {
					-- ["1"] = { x = 213 + offX , y = 613 + offY } ,
					-- ["2"] = { x = 43 + offX , y = 500 + offY } ,
					-- ["3"] = { x = 215 + offX , y = 486 + offY } ,
					-- ["4"] = { x = 383 + offX , y = 386 + offY } ,
					-- ["5"] = { x = 306 + offX , y = 212 + offY } ,
					-- ["6"] = { x = 208 + offX , y = 108 + offY } ,
					-- ["7"] = { x = 82 + offX , y = 223 + offY } ,
					["1"] = { x = 213 + offX , y = 613 + offY } ,
					["2"] = { x = 43 + offX , y = 500 + offY } ,
					["3"] = { x = 215 + offX , y = 486 + offY } ,
					["4"] = { x = 368 + offX , y = 386 + offY } ,
					["5"] = { x = 306 + offX , y = 212 + offY } ,
					["6"] = { x = 180 + offX , y = 138 + offY } ,
					["7"] = { x = 60 + offX , y = 253 + offY } ,
			},
			agi = {
					["1"] = { x = 384 + offX , y = 588 + offY } ,
					["2"] = { x = 247 + offX , y = 515 + offY } ,
					["3"] = { x = 125 + offX , y = 588 + offY } ,
					["4"] = { x = 46 + offX , y = 333 + offY } ,
					["5"] = { x = 286 + offX , y = 350 + offY } ,
					["6"] = { x = 226 + offX , y = 188 + offY } ,
					["7"] = { x = 47 + offX , y = 130 + offY } ,
			} , 
			def = {
					["1"] = { x = 66 + offX , y = 495 + offY } ,
					["2"] = { x = 177 + offX , y = 563 + offY } ,
					["3"] = { x = 362 + offX , y = 493 + offY } ,
					["4"] = { x = 379 + offX , y = 295 + offY } ,
					["5"] = { x = 151 + offX , y = 141 + offY } ,
					["6"] = { x = 55 + offX , y = 335 + offY } ,
					["7"] = { x = 217 + offX , y = 397 + offY } ,
			} , 
			hp = {
					["1"] = { x = 110 + offX , y = 593 + offY } ,
					["2"] = { x = 215 + offX , y = 563 + offY } ,
					["3"] = { x = 50 + offX , y = 427 + offY } ,
					["4"] = { x = 47 + offX , y = 242 + offY } ,
					["5"] = { x = 217 + offX , y = 127 + offY } ,
					["6"] = { x = 376 + offX , y = 239 + offY } ,
					["7"] = { x = 269 + offX , y = 333 + offY } ,
			} , 
		
		}
	return starAdd[key]
end		

--过滤数据
function M:filterData( key , lv , params )
	params = params or {}

	local filter
	if key == "general" then 
		filter = { exceptZhenfa = true }
	end

	local items = DATA_Bag:getTable( key , filter )
	local tempData = {}
	for k , v in pairs( items ) do
		if getConfig( key , v.cid , "star") == lv then
			tempData[ k ] = v 
		end
	end
	items = tempData
	local idGather = {}
	for key , v in pairs( items ) do
		if table.nums( params ) ~= 0  then
			idGather[ #idGather + 1 ] = {}
			idGather[ #idGather].id =  v.id
			for k , value in pairs( params ) do
				idGather[ #idGather][ k .. "" ] = v[ k .. "" ]
			end
		else
			idGather[ #idGather + 1 ] =  v.id
		end
	end
	return items , idGather
end

--分解灵源返回列表
function M:resolveBackLayer(param)
	local contentLayer = display.newLayer()
	local mask = KNMask:new({item = contentLayer })

	local scroll = KNScrollView:new( 54 , 273 , 370 , 105 , 10 , false , 0  )

	local tempImg = display.newSprite( PATH .. "tip_bg.png" )
	setAnchPos( tempImg ,240, 196, 0.5 )
	contentLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "resolve_back.png" )
	setAnchPos( tempImg , 240 , 470 , 0.5 )
	contentLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "back_list.png" )
	setAnchPos( tempImg , 240 , 260 , 0.5 )
	contentLayer:addChild( tempImg )

	local normal, pre = "btn_bg_red.png", "btn_bg_red_pre.png"

	contentLayer:addChild( display.strokeLabel( param.soul and param.soul[1] or "" , 59 , 390 , 18, ccc3( 155 , 255 , 67 )  ) )

	local stoneList = param.stone or {}
	for i = 1 , math.ceil(#stoneList/2) do
		local layer = display.newLayer()
		layer:setContentSize( CCSizeMake( 340 , 24 ) )

		layer:addChild( display.strokeLabel( stoneList[i*2-1] or "" , 5 , 0 , 18, ccc3( 0xff , 0xff , 0xff )  ) )
		layer:addChild( display.strokeLabel( stoneList[i*2] or "" , 200 , 0 , 18, ccc3( 0xff , 0xff , 0xff )  ) )

		scroll:addChild( layer )
	end

	contentLayer:addChild( scroll:getLayer() , 10 )

	local confirmBtn = KNBtn:new(COMMONPATH, {normal, pre}, 240, 230, {
				priority = -221,
				anchMid = true,
				front = COMMONPATH.."ok.png",
				callback =  function()
					contentLayer:runAction(getSequenceAction(CCScaleTo:create(0.2, 0), CCCallFunc:create(function()
						mask:remove()
					end)))

				end
			
			} )

	contentLayer:addChild( confirmBtn:getLayer() )

	contentLayer:setScale(0)
	contentLayer:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.8, 1)))

	return mask
end

return M