local GodWarShopLayer = requires(IMG_PATH, "GameLuaScript/Scene/godwar/godwarshoplayer")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local PATH = IMG_PATH.."image/scene/godwar/"
local PATH_HELP = IMG_PATH.."image/scene/godwar/help/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local KNProgress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local Property = requires(IMG_PATH,"GameLuaScript/Config/Property")
local M = {
	baseLayer,
	layer,
	menu,
	cityLayer,
	mask,
}

local cityInfo = {
	{2, 3},
	{1,3, 4, 5},
	{1,2,4,9},
	{2,3,5,6,8,9},
	{2,4,6,7},
	{4,5,7,8},
	{5,6},

	{4,6,9,10},
	{3,4,8,10},
	{8,9},
}

--卫城信息
local protect = {
	[2] = 5,
	[3] = 9,
	[5] = 2,
	[6] = 8,
	[8] = 6,
	[9] = 3
}
local name = {
	["tmsj"] = "唐门世界",
	["td"] = "绝世天府",
	["xmws"] = "仙魔无双",
	["tgxy"] = "太古仙域",
	[""] = "中立"
}

local user
if SHENZHAN_GROUP == "tmsj"  then
	user = 7
elseif SHENZHAN_GROUP == "td" then
	user = 1
else
	user = 10
end

local append = {
	[1] = {2,3},
	[7] = {5,6},
	[10] = {8,9}
}

local pos_text = {"平民","士兵","百夫长","千夫长","校尉","副将军", "大将军"}
local pos_text1 = {"平\n民","士\n兵","百\n夫\n长","千\n夫\n长","校\n尉","副\n将\n军", "大\n将\n军"}

local help = {
	"封神战：\n每个月第一周和第三周的周四到周日会按照势力（游戏）进行一次封神战，会决出最强势力（游戏）\n 参与资格：各个势力神力排行前1万名的玩家可在封神战战场进行战斗、迁徙等	\n",
	"神力：\n 可前往我的主城中，获得材料去提升英雄和幻兽等级后，便可提升我的神力\n",
	"神币:\n可在封神战战场通过神币挑战、神币抢劫、完成奖励任务等方式获得\n",
--[[
"战斗：\n 战斗时间为10号早上9点——17号晚上12点。\n 玩家可以攻击自己相邻城市中，其他势力的玩家。\n 每次挑战或抢劫会消耗一个行动力，复仇不会消耗行动力。\n",
"城市：\n 当城市无人占领或者归己方占领时，可以进行迁徙。\n 每次迁徙或占领消耗一个行动力。\n",
"战贡获得：\n 每次成功挑战或抢劫一个敌方势力即可增加一点战贡。\n 在我的主城中为全帮或全势力购买材料，可获得战贡。\n",
"排行榜：	\n 神力排行榜：根据已方势力玩家的神力实时进行排名。（排名决定了是否可以参与神战战场的战斗、迁徙等操作）\n 个人战贡榜：己方势力玩家在封神战中获得的战贡排名，可查看敌方个人战贡榜。（所有势力中战贡第一的玩家将被封为神王）\n 帮会战贡榜：己方势力帮会中参加封神战的成员玩家战贡总和为该帮会的战贡。（所以势力中战贡第一的帮会被封为神战第一帮）\n 势力战贡榜：己方势力所有参加封神战的玩家战贡总和为势力战贡。（战贡排第一的势力为神战最强势力）\n",
"神币获得：\n 神币可用于神币商城兑换物品、也可在龙脉系统中进行消耗。\n 每个人每天第一次占领四个普通城市中的任意一个或占领神圣之城可获得神币。\n 玩家挑战敌人后会获得神币，被挑战时战斗失败不会损失神币。\n 玩家成功抢劫敌人后会获得对方身上的神币，而对方会损失神币。\n 玩家被抢劫后，可向抢劫的人进行复仇，成功复仇后，被复仇对象会损失神币。\n 挑战或抢劫连续胜利达到10次、20次、30次时，可额外获得神币。\n 开启城市宝箱可获得神币。\n 开始战贡宝箱可随机获得神币。\n",
"宝箱：\n 城市宝箱：除势力主城之外，每天在其他城市驻守的人数达到一定数量后，即可开启宝箱领取大量神币奖励。\n ",
"战贡宝箱：神战中，每个势力的战贡达到一定数量后，即可开启战贡宝箱领取大量神币奖励。\n",
"神战结算奖励：\n 哈哈哈哈哈，你才是奖励，你全家都是奖励。\n"]]--
}

local pos = {
	--x  y  num, x, y,hide
	{{"","","绝世天府大千世界的战场主城"},168, 88,2,{{-30, 30},{50, 30}},nil},
	{{"","","绝世天府大千世界的战场卫城"},192, 232,2,{{-30,30},{30,30}},nil,},
	{{"","","绝世天府大千世界的战场卫城"},394, 224,1,{{0,30}},nil},
	{{"【无加成】","【每次胜利战贡+7】","亘古以来存在神战异空间的奇特主城。神力不可毁，魔光不可近。被诸方势力选择作为战场中心 "},323, 386,4,{{-50,30},{30,30},{-30,50},{0,10}},nil},
	{{"【单属性加成】","【每次胜利战贡+5】","唐门大千世界的战场卫城之一。"},100, 483,2,{{-20,35},{20,30}},nil},
	{{"【单属性加成】","【每次胜利战贡+5】","唐门大千世界的战场卫城。"},303, 552,1,{{0,30}},nil,},
	{{"","","唐门大千世界的战场主城"},207, 702,2,{{-30,30},{20,30}},nil},

	{{"","","太古仙域大千世界的战场卫城"},487, 512,2,{{-30,30},{20,30}},nil},
	{{"","","太古仙域大千世界的战场卫城"},487, 332,2,{{-30,30},{20,30}},nil},
	{{"","","太古仙域大千世界的战场主城。采东阳之精，北月之华，南火之灵，西山之锐使用1:1:1:1的比例铸造而成，健康无污染 "},627, 422,2,{{-30,30},{20,30}},nil},
}

function M:new(params, data, parent)
	dump(data)
	local this = {}
	setmetatable(this, self)
	self.__index = self
	this.layer = display.newLayer()
	this.baseLayer = display.newLayer()

	local warBg = display.newSprite(PATH.."war_bg.jpg")
	setAnchPos(warBg,0,-50)
	this.layer:addChild(warBg)
	this.parent = parent or {}
	this.data = data or {}
	parent.field = true
	--游戏积分
	local max = 0
	local last, equal = -1, false
	for k,v in pairs(data.gameScore) do
		if tonumber(last) == tonumber(v) then
			equal = true
		end

		last = tonumber(v)

		if tonumber(v) > max then
			max = tonumber(v)
		end
	end



	local y = 750
	local text, bg
	for k, v in pairs(data.gameScore) do
		bg = display.newSprite(PATH..k.."_score.png")
		setAnchPos(bg, 10, y)
		this.baseLayer:addChild(bg)
--
		text = createLabel({str = v, size = 18, color = ccc3(255,255,255)})
		setAnchPos(text, 105, y + 3)
		this.baseLayer:addChild(text)
--
		if max == tonumber(v) and not equal then
			local king = display.newSprite(PATH.."king.png")
			setAnchPos(king, 105 + text:getContentSize().width + 5, y + 6)
			this.baseLayer:addChild(king )
		end
		y = y - 25
	end
	bg = display.newSprite(PATH.."self_score.png")
	setAnchPos(bg, 10, y)
	this.baseLayer:addChild(bg)

	text = createLabel({str = data.userScore, size = 18, color = ccc3(255,255,255)})
	setAnchPos(text, 105, y + 3)
	this.baseLayer:addChild(text)

	bg = display.newSprite(PATH.."small_bg.png")
	setAnchPos(bg, 0, 420)
	this.baseLayer:addChild(bg)

	bg = display.newSprite(PATH.."level_text.png")
	setAnchPos(bg, 9, 530)
	this.baseLayer:addChild(bg)

	bg = display.newSprite(PATH.."small_bg.png")
	setAnchPos(bg, 0, 200)
	this.baseLayer:addChild(bg)

	bg = display.newSprite(PATH.."move_pt.png")
	setAnchPos(bg, 0, 230)
	this.baseLayer:addChild(bg)

	text = createLabel({str = data.curAction .. "/" ..data.maxAction, size = 18, color = ccc3(255,255,255)})
	setAnchPos(text, 9, 300)
	text:setRotation(90)
	this.baseLayer:addChild(text)

	text = createLabel({str = pos_text1[tonumber(data.abpos)], size = 20, color = ccc3(255,255,255)})
	setAnchPos(text, 9, 450)
	this.baseLayer:addChild(text)

	local function tipAction(node, down)
		local dis, time = 20, 1
		node:runAction(getSequenceAction(CCMoveTo:create(time, ccp(node:getPositionX(), node:getPositionY() + (down and -dis or dis))), CCCallFunc:create(function()
			tipAction(node, not down)
		end)))
	end

	--位置标识
	local myPos = display.newSprite(PATH.."my_pos.png")
	setAnchPos(myPos,  pos[tonumber(data.pos)][2],pos[tonumber(data.pos)][3] + 50, 0.5)
	this.layer:addChild(myPos, 1)
	tipAction(myPos, true)

	for k, v in pairs(cityInfo[tonumber(data.pos)]) do
		if not pos[v][6]  then
			local frames
			if data.city[v..""].game == SHENZHAN_GROUP or data.city[v..""].game == "" then
				if protect[data.pos] ~= v then
					frames = display.newFramesWithImage( PATH .. "move_pos.png" , 7 )
				end
			else
				frames = display.newFramesWithImage( PATH .. "fight_pos.png" , 11 )
			end

			if frames then
				local  tip = display.playFrames( pos[v][2],pos[v][3] + 50, frames , 0.1 , {
					forever = true
				})
				this.layer:addChild(tip, 1)
			end
		end
	end

	local posTip = KNBtn:new(PATH, {"add.png","add_pre.png"}, 2, 400, {
		scale = true,
		priority = -131,
		callback = function()
			HTTP:call("fengshen", "posConfig", {}, {
				success_callback = function(response)
					local config = response.config
					local layer = display.newLayer()

					local bg = display.newSprite(PATH.."stage_bg.png")
					setAnchPos(bg, 240, 400, 0.5,0.5)
					layer:addChild(bg)

					bg = display.newSprite(PATH.."stage_info.png")
					setAnchPos(bg, 40, 400, 0,0.5)
					layer:addChild(bg)

					local max
					if this.data.abpos >= table.nums(config) then
						max = true
					end

					local info = createLabel({str = config[this.data.abpos..""].name.."→", color = ccc3(255,255,255), size = 20, width = 200})
					setAnchPos(info, 140, 470)
					layer:addChild(info)

					local info1 = createLabel({str = config[(max and this.data.abpos or tonumber(this.data.abpos) + 1)..""].name, color = ccc3(84,230,230), size = 20, width = 200})
					setAnchPos(info1, 140 + info:getContentSize().width, 470)
					layer:addChild(info1)

					info = createLabel({str = config[this.data.abpos..""].action_max.."→", color = ccc3(255,255,255), size = 20, width = 200})
					setAnchPos(info, 170, 440)
					layer:addChild(info)

					info1 = createLabel({str = config[(max and this.data.abpos or tonumber(this.data.abpos) + 1)..""].action_max, color = ccc3(84,230,230), size = 20, width = 200})
					setAnchPos(info1, 170+ info:getContentSize().width, 440)
					layer:addChild(info1)

					info = createLabel({str =config[this.data.abpos..""].action_buy_max.."→", color = ccc3(255,255,255), size = 20, width = 200})
					setAnchPos(info, 170, 405)
					layer:addChild(info)

					info1 = createLabel({str =config[(max and this.data.abpos or tonumber(this.data.abpos) + 1)..""].action_buy_max, color = ccc3(84,230,230), size = 20, width = 200})
					setAnchPos(info1, 170+ info:getContentSize().width, 405)
					layer:addChild(info1)

					info = createLabel({str = config[this.data.abpos..""].fight_dragon_action.."→", color = ccc3(255,255,255), size = 20, width = 200})
					setAnchPos(info, 170, 375)
					layer:addChild(info)

					info1 = createLabel({str = config[(max and this.data.abpos or tonumber(this.data.abpos) + 1)..""].fight_dragon_action, color = ccc3(84,230,230), size = 20, width = 200})
					setAnchPos(info1, 170+ info:getContentSize().width, 375)
					layer:addChild(info1)

					info = createLabel({str = config[this.data.abpos..""].fight_coin_gain_coin.."→", color = ccc3(255,255,255), size = 20, width = 200})
					setAnchPos(info, 140, 340)
					layer:addChild(info)

					info1 = createLabel({str = config[(max and this.data.abpos or tonumber(this.data.abpos) + 1)..""].fight_coin_gain_coin, color = ccc3(84,230,230), size = 20, width = 200})
					setAnchPos(info1, 140+ info:getContentSize().width, 340)
					layer:addChild(info1)

					info = createLabel({str =config[this.data.abpos..""].rob_coin.."→", color = ccc3(255,255,255), size = 20, width = 200})
					setAnchPos(info, 140, 310)
					layer:addChild(info)

					info1 = createLabel({str = config[(max and this.data.abpos or tonumber(this.data.abpos) + 1)..""].rob_coin, color = ccc3(84,230,230), size = 20, width = 200})
					setAnchPos(info1, 140+ info:getContentSize().width, 310)
					layer:addChild(info1)

					showTip({
						title_bg = PATH.."change_title_bg.png",
						title_text = PATH.."stage_title.png",
						titleOffsetY = 15,
						titleTextY = 9,
						content = layer,
						offsetY = -18,
						priority = -220,
						parent = self.layer,
						bg = PATH.."tip_bg.png",
						close = {
							normal = "back_img.png",
							pre = "back_img_press.png",
						},
						center = {
							front = PATH.."stage_btn.png",
							callback = function()
								local tipLayer = display.newLayer()

								local bg = display.newSprite(PATH.."stage_detail_bg.png")
								setAnchPos(bg,240, 400, 0.5, 0.5)
								tipLayer:addChild(bg)

								bg = display.newSprite(PATH.."my_rank.png")
								setAnchPos(bg,40, 475)
								tipLayer:addChild(bg)

								local rank = createLabel({str = this.data.abrank, color = ccc3(0x2c, 0, 0), size = 20, width = 400})
								setAnchPos(rank, 140, 478)
								tipLayer:addChild(rank)

								bg = display.newSprite(PATH.."yesterday_rank.png")
								setAnchPos(bg,280, 475)
								tipLayer:addChild(bg)

								rank = createLabel({str = this.data.yesabrank, color = ccc3(0x2c, 0, 0), size = 20, width = 400})
								setAnchPos(rank, 380, 478)
								tipLayer:addChild(rank)


								local title = createLabel({str = "个人神力排行名次对应阶位", color = ccc3(84,230,230), size = 20, width = 400})
								setAnchPos(title, 240, 442, 0.5)
								tipLayer:addChild(title)

								title =  createLabel({str = "1-10名:大将军", color = ccc3(255,255,255), size = 20, width = 400})
								setAnchPos(title, 50, 415)
								tipLayer:addChild(title)

								title =  createLabel({str = "11-100名:副将军", color =ccc3(255,255,255), size = 20, width = 400})
								setAnchPos(title, 50, 390)
								tipLayer:addChild(title)

								title =  createLabel({str = "101-1000名:校尉", color = ccc3(255,255,255), size = 20, width = 400})
								setAnchPos(title, 50, 365)
								tipLayer:addChild(title)

								title =  createLabel({str = "1001-3000名:千夫长", color = ccc3(255,255,255), size = 20, width = 400})
								setAnchPos(title, 50, 340)
								tipLayer:addChild(title)

								title =  createLabel({str = "3001-5000名:百夫长", color =ccc3(255,255,255), size = 20, width = 400})
								setAnchPos(title, 240,415)
								tipLayer:addChild(title)

								title =  createLabel({str = "5000-10000名:士兵", color =ccc3(255,255,255), size = 20, width = 400})
								setAnchPos(title, 240, 390)
								tipLayer:addChild(title)

								title =  createLabel({str = "10000以下:平民", color =ccc3(255,255,255), size = 20, width = 400})
								setAnchPos(title, 240, 365)
								tipLayer:addChild(title)

								title =  createLabel({str = "说明：1:每届封神战第一天所有参战玩家阶位都为士兵\n2：封神战期间每天晚上24：00结算排名划分阶位\n3:阶位决定行动力上限及购买次数、战斗获得奖励等", color =ccc3(255,0,0), size = 18, width = 400})
								setAnchPos(title, 40, 325, 0, 1)
								tipLayer:addChild(title)

								showTip({
									priority = -230,
									bg = PATH.."tip_bg.png",
									content = tipLayer,
									close = {
										normal = "back_img.png",
										pre = "back_img_press.png",
									},
								})
							end
						}
					})
				end
			})
		end
	})
	this.baseLayer:addChild(posTip:getLayer())


	local buy = KNBtn:new(PATH, {"add.png","add_pre.png"}, 2, 190, {
		scale = true,
		priority = -131,
		callback = function()
			if tonumber(this.data.curBuyAction) >= tonumber(this.data.maxBuyAction) then
				KNMsg.getInstance():flashShow("您今日购买次数已用完")
			else
				this:buy(data.actionPrice)
			end
		end
	})
	this.baseLayer:addChild(buy:getLayer())

	if params.action then
		buy:call()
	end

	local back = KNBtn:new(PATH, {"back_btn.png",}, 10, 50, {
		scale = true,
		priority = -131,
		callback = function()
			parent.goOut = true
			FIELDX = nil
			switchScene("pvp", {coming = 'godwar'})
			audio.playMusic( IMG_PATH .. "sound/background.mp3" , true )
		end
	})
	this.baseLayer:addChild(back:getLayer())

	local help = KNBtn:new(IMG_PATH.."image/scene/multiFb/", {"help.png", "help_press.png"}, 435,650,{
		callback = function()
		local tempLayer = baseMask( {
				titlePath = COMMONPATH.."help_title.png" ,
				bgInfo = { y = 100 ,  path = PATH_HELP  .. "gb_help.png"
				} ,
				isShowBack = {x = 12 , y = 675 , backFun = function()  end } ,
				priority = -129 }
			)

			local layer = display.newLayer()
			local bg = display.newSprite(PATH_HELP.."gb.png")
			setAnchPos(bg, 230,320, 0.5, 0.5)
			layer:addChild(bg)
			local mask = KNMask:new({item = layer, priority = -120})
			tempLayer:getBg():addChild(mask:getLayer(),10)


			local myMainct = KNBtn:new( COMMONPATH , {"btn_bg.png","btn_bg_pre.png"},56 ,630 , {
				front=PATH_HELP.."my_main_ct.png",
				scale = true,
				callback = function()
				--	showAwardPage()
				end
			}):getLayer()
			tempLayer:addChild( myMainct,1 )

			tempLayer:addChild(display.newSprite( PATH_HELP .. "up.png" ,122,586+12, 0 , 0 ))

			local myPower = KNBtn:new( PATH_HELP , {"di.png","di.png"},180,565 , {
				front=PATH_HELP.."power.png",
				scale = true,
				callback = function()

				end
			}):getLayer()
			tempLayer:addChild( myPower,1 )


			local our_ct = KNBtn:new( PATH_HELP , {"di.png","di.png"},65,400 , {
				front=PATH_HELP.."our_ct.png",
				scale = true,
				callback = function()

				end
			}):getLayer()
			tempLayer:addChild(our_ct,1 )


			local enemy_ct = KNBtn:new( PATH_HELP , {"di.png","di.png"},295,410 , {
				front=PATH_HELP.."enemy_ct.png",
				scale = true,
				callback = function()

				end
			}):getLayer()
			tempLayer:addChild(enemy_ct,1 )

			local gder = KNBtn:new( PATH_HELP , {"di.png","di.png"},260,150 , {
				front=PATH_HELP.."goder.png",
				scale = true,
				callback = function()

				end
			}):getLayer()
			tempLayer:addChild(gder,1 )


			tempLayer:addChild(display.newSprite( PATH_HELP .. "lower_f.png" ,145,240, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "figter.png" ,183,295, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "up_long.png" ,110,190, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "shenbi.png" ,125,199, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "maid.png" ,158,200, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "upprop.png" ,100,163, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "huangguan.png" ,255,205, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "keqianxi.png" ,100,456+78, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "city.png" ,90,456, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "kegognji.png" ,330,466+78, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "city.png" ,320,466, 0 , 0 ))


			tempLayer:addChild(display.newSprite( PATH_HELP .. "fleft.png" ,130,350, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "fright.png" ,300,360, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "fleftdown.png" ,168,246, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "frightdown.png" ,266,245, 0 , 0 ))


			tempLayer:addChild(display.newSprite( PATH_HELP .. "left.png" ,170,525, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "right.png" ,280,535, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "fight_icon.png" ,225,495, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "down.png" ,200,460, 0 , 0 ))


			tempLayer:addChild(display.newSprite( PATH_HELP .. "upText.png" ,137+25,565+46+10, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "keqianxiText.png" ,100,456+66, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "kegongjiText.png" ,340,466+66, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "jachengText.png" ,220,450, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "gongjiofeachText.png" ,88,340, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "gongjiofeachText.png" ,336,360, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "getText.png" ,137,264, 0 , 0 ))
			tempLayer:addChild(display.newSprite( PATH_HELP .. "rongyuText.png" ,312,262, 0 , 0 ))
		end})
	this.baseLayer:addChild(help:getLayer())




	local infoBtn = KNBtn:new(PATH, {"info_btn.png", "info_btn_pre.png"}, 40, 630,{
		priority = -131,
		anchMid = true,
		callback = function()
			HTTP:call("fengshen", "getJFSummary", {}, {
				success_callback = function(data)
					switchScene("godwar" ,{data = data, cur = "rank", field = true})
				end
			})
		end
	})
	this.baseLayer:addChild(infoBtn:getLayer())

	if data.have_finished_task > 0 then
		local action = getSequenceAction(CCScaleTo:create(0.5,1.2),CCScaleTo:create(0.5,1))
		tolua.cast(action,"CCActionInterval")
		action = CCRepeatForever:create(action)
		infoBtn:getLayer():runAction(action)
	end

	local frames = display.newFramesWithImage( PATH .. "info_effect.png" , 12)
	local action = display.playFrames( 35  , 645 , frames , 0.15 , {
		forever = true
	} )
	this.baseLayer:addChild(action)


	local main = KNBtn:new(COMMONPATH, {"btn_bg.png","btn_bg_pre.png"}, 390, 702, {
		front = PATH.."main_text.png",
		callback = function()
			switchScene("godwar", {data = data, worldMsg = parent.worldMsg, time = parent.time, msg = parent.msg})
			audio.playMusic( IMG_PATH .. "sound/godwar_city.mp3" , true )
		end
	})
	this.baseLayer:addChild(main:getLayer())
--//
--	if SHENZHAN_GROUP == data.city["1"].game then
--		main:setPosition(pos[1][2] + 80,pos[1][3])
--	elseif SHENZHAN_GROUP == data.city["7"].game then
--		main:setPosition(pos[7][2] + 92,pos[7][3])
--	elseif SHENZHAN_GROUP == data.city["10"].game then
--		main:setPosition(pos[10][2] ,pos[10][3] + 80)
--	end

	if  KNGuide:getStep() == 10004 then
		KNGuide:show(main:getLayer() , {
			remove = true
		})
	end

	this:createCity(data, params)

	local btn_icon = {"hp_icon_grey.png"}
	if  data.hpPack.type then
		btn_icon = {"hp_icon.png", "hp_icon_pre.png"}
	end
	local hpAdd = KNBtn:new(PATH, btn_icon , 430, 580, {
		text = data.hpPack.type and {data.hpPack.count.."/"..data.hpPackConfig[data.hpPack.type..""].count, 18, ccc3(255,255,255), ccp(-5, -30)} or nil,
		callback = function()
			this:createHpRecovery()
		end
	})
	this.baseLayer:addChild(hpAdd:getLayer())

	if params.bloodBox then
		hpAdd:call()
	end

	Clock:addTimeFun("field_effect", function()
		local x, y, rotate
		x = math.random(1,2) == 1 and -180	or 480
		rotate = x < 0 and -45	or 45
		for i = 1, math.random(1, 2) do
			y = math.random(400,1200)
			local frames = display.newFramesWithImage( PATH .. "fire_stone.png" , 5 )
			local stone = display.playFrames( x, y, frames , 0.1 , {
				forever = true})
			stone:setRotation(rotate)
			setAnchPos(stone,x, y)
			this.layer:addChild(stone)

			stone:runAction(getSequenceAction(CCMoveTo:create(1 + math.random(1, 10) * 0.1, ccp(math.random(100,500),y - math.random(300, 500))), CCCallFunc:create(function()
				frames = display.newFramesWithImage( PATH .. "stone_explode.png" , 7 )
				local explode
				explode = display.playFrames( stone:getPositionX() + (x < 0 and 0 or stone:getContentSize().width / 2),stone:getPositionY() + (x < 0 and stone:getContentSize().height / 2 or stone:getContentSize().height / 4), frames , 0.15 , {
					onComplete = function()
						this.layer:removeChild(explode, true)
					end
				})
				this.layer:addChild(explode)
				this.layer:removeChild(stone, true)
			end)))
		end

		local index = math.random(1,6)
		local next = index + (math.random(1,2) == 1 and -1 or 1)
		if next == 0 then
			next = 2
		end


		local frames = display.newFramesWithImage( PATH .. "move_effect.png" , 8 )
		local effect = display.playFrames( pos[index][2], pos[index][3], frames , 0.1 , {
			forever = true})
		this.layer:addChild(effect)

		if pos[next][2] < pos[index][2] then
			effect:setFlipX(true)
		end

		effect:runAction(getSequenceAction(CCMoveTo:create(2, ccp(pos[next][2], pos[next][3])), CCFadeOut:create(0.3), CCCallFunc:create(function()
			this.layer:removeChild(effect, true)
		end)))

		local frames = display.newFramesWithImage( PATH .. "shoot_effect.png" , 10 )
		local shoot = display.playFrames( pos[index][2] - 50, pos[index][3], frames , 0.1 , {
			forever = true})
		this.layer:addChild(shoot)

		shoot:runAction(getSequenceAction(CCDelayTime:create(2), CCFadeOut:create(0.3), CCCallFunc:create(function()
			this.layer:removeChild(shoot, true)
		end)))
	end)



	if data.xiangRui.type then

		local click, war_box
		local mask, right, left, tip
		local layer = display.newLayer()

		local function showFunc()
			if click then
				war_box:showBtn(false)
				war_box:setEnable(false)
				local content = display.newLayer()
				local close
				--				if data.xiangRui.type == 1 then
				--					local text = createLabel({str = "恭喜您下次挑战时获得的神币数量翻"..data.xiangRui.discount.."倍", size = 20, width = 400})
				--					setAnchPos(text, 240, 425, 0.5, 0.5)
				--					content:addChild(text)
				--				elseif data.xiangRui.type == 2 then
				--					local text = createLabel({str = "恭喜您下次挑战战斗结束时额外获得"..data.xiangRui.discount.."神币", size = 20, width = 400})
				--					setAnchPos(text, 240, 425, 0.5, 0.5)
				--					content:addChild(text)
				--				elseif data.xiangRui.type == 3 then
				--					local text = createLabel({str = "恭喜您获得:"..data.xiangRui.discount.."神币", size = 20, width = 400})
				--					setAnchPos(text, 240, 425, 0.5, 0.5)
				--					content:addChild(text)
				--				elseif data.xiangRui.type == 4 then
				left =  {
					callback = function()
						HTTP:call("fengshen","useXiangRui", {}, {
							success_callback = function(data)
								local func = requires(IMG_PATH, "GameLuaScript/Network/httpActions")
								func.inform(data)
								tip:remove()
								KNMsg.getInstance():flashShow("当前购买成功，物品已进入背包")
							end
						})
					end
				}
				right = {
					--						remove = true,
					callback = function()
						tip:getLayer():setAnchorPoint(ccp(0.85,0.1))
						tip:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.3,0), CCCallFunc:create(function()
							tip:remove()
							war_box:showBtn(true)
							war_box:setEnable(true)
						end)))
						--							KNMsg.getInstance():boxShow("您 是否确认放天降祥瑞的奖励？",{confirmFun = function()
						--								HTTP:call("fengshen",  "clearXiangRui", {}, {
						--									success_callback = function()
						--										HTTP:call("fengshen", "getJFSummary", {}, {
						--											success_callback = function(data)
						--												switchScene("godwar",{
						--													data = data,
						--													inWar = true,
						--													worldMsg = this.parent.worldMsg,
						--													time = this.parent.time,
						--													msg = this.parent.msg
						--													})
						--											end})
						--									end
						--								})
						--							end, cancelFun = function()end})

					end
				}
				local icon = awardCell({num = 1, cid = data.xiangRui.cid, name = {size = 20}})
				setAnchPos(icon, 100, 430)
				content:addChild(icon)

				local name = {
					["chip"] = {"碎片","用于合成高星级装备"},
					["soul"] =  {"将魂","用于合成高星级英雄"},
					["animal"] =  {"兽魂","用于合成高星级幻兽"},
				}
				dump(data.xiangRui)

				if name[data.xiangRui.type] then
					local text = createLabel({str = "恭喜您获得"..(data.xiangRui.discount / 10).."折购买'"..replaceStr(name[data.xiangRui.type][1]).."'的机会,是否确定购买", size = 20, width = 400})
					setAnchPos(text, 240, 400, 0.5, 0.5)
					content:addChild(text)

					text = createLabel({str ="说明:"..replaceStr(name[data.xiangRui.type][2]), color = ccc3(255,0,0), size = 18, width = 400})
					setAnchPos(text, 40, 290)
					content:addChild(text)

					text = createLabel({str = replaceStr(name[data.xiangRui.type][1]), size = 20, width = 400})
					setAnchPos(text, 180, 470)
					content:addChild(text)
				elseif getCidType(data.xiangRui.cid) then
					local text = createLabel({str = "恭喜您获得"..(data.xiangRui.discount / 10).."折购买'"..getConfig(getCidType(data.xiangRui.cid), data.xiangRui.cid.."", "name").."'的机会,是否确定购买", size = 20, width = 400})
					setAnchPos(text, 240, 400, 0.5, 0.5)
					content:addChild(text)


					text = createLabel({str ="说明:"..getConfig(getCidType(data.xiangRui.cid), data.xiangRui.cid, "desc"), color = ccc3(255,0,0), size = 18, width = 400})
					setAnchPos(text, 40, 290)
					content:addChild(text)

					text = createLabel({str = getConfig(data.xiangRui.type, data.xiangRui.cid, "name") or replaceStr(name[data.xiangRui.type]), size = 20, width = 400})
					setAnchPos(text, 180, 470)
					content:addChild(text)
				end


				icon = display.newSprite(COMMONPATH..(data.xiangRui.currency == 1 and "gold.png" or "silver.png"))
				setAnchPos(icon, 180, 430)
				content:addChild(icon)

				text = createLabel({str = math.ceil(data.xiangRui.discount / 100 * data.xiangRui.org_price), size = 20, width = 400})
				setAnchPos(text, 220, 432)
				content:addChild(text)

				--				end

				if mask then
					this.baseLayer:removeChild(mask:getLayer(), true)
				end

				tip = showTip({
					content = content,
					title_bg = PATH.."change_title_bg.png",
					title_text = PATH.."xiang_title.png",
					titleOffsetY = 15,
					titleTextY = 9,
					priority = -251,
					bg = PATH.."tip_bg.png",
					left = left,
					--					center = center,
					right = right
				})
			end
		end

		if data.xiangRui.checked ~= 1 then
			local frames = display.newFramesWithImage( PATH .. "box_effect.png" , 16 , 2)
			local box = display.playFrames( 100, 500, frames , 0.1 , {
				onComplete = function()
					click = true
				end
			})
			layer:addChild(box)




			mask  = KNMask:new({item = layer, priority = -250, click = showFunc})

			this.baseLayer:addChild(mask:getLayer(), 1)
		end

		war_box= KNBtn:new(PATH, {"war_box.png", "war_box_pre.png"}, 400, 40,{
			callback = function()
				--				 this:createBox(nil, data.gameScoreAward, tonumber(data.gameScore[SHENZHAN_GROUP]))
				click = true
				showFunc()
			end
		})
		this.baseLayer:addChild(war_box:getLayer())

		if data.xiangRui.checked ~= 1 then
			war_box:showBtn(false)
			war_box:setEnable(false)
		end
	end

	local last
	this.layer:setTouchEnabled(true)
	this.layer:registerScriptTouchHandler(function(type, x, y)
		if type == CCTOUCHBEGAN then
			last = x
		elseif type == CCTOUCHMOVED then
			if x < last then
				if this.layer:getPositionX() > 480 - warBg:getContentSize().width then
					this.layer:setPosition(this.layer:getPositionX() + x - last, this.layer:getPositionY())
				else
					this.layer:setPosition(480 - warBg:getContentSize().width, this.layer:getPositionY())
				end
			else
				if this.layer:getPositionX() < 0 then
					this.layer:setPosition(this.layer:getPositionX() + x - last, this.layer:getPositionY())
				else
					this.layer:setPosition(0, this.layer:getPositionY())
				end
			end
			last = x
			FIELDX = this.layer:getPositionX()
		else
		end
		return true
	end, false, -200, false)
	this.baseLayer:addChild(this.layer, -1)
	if FIELDX then
		setAnchPos(this.layer,FIELDX)
	else
		if SHENZHAN_GROUP == "tgxy" then
			setAnchPos(this.layer,480 - warBg:getContentSize().width)
		end
	end
	return this
end

function M:createBox(kind, data, cur, pos, append)
	local content = display.newLayer()
	local bg = display.newSprite(PATH.."box_bg.png")
	setAnchPos(bg, 240, 380, 0.5, 0.5)
	content:addChild(bg)

	bg = display.newSprite(PATH.."cur_"..(kind and kind or "war").."_text.png")
	setAnchPos(bg, 270, 480)
	content:addChild(bg)

	content:addChild(createLabel({str = cur, size = 20, x = kind and 400 or 360, y = 480}))

	if kind then
		bg = display.newSprite(PATH.."rest_times.png")
		setAnchPos(bg, 30, 300)
		content:addChild(bg)

		local tip = createLabel({str = "说明：1、当驻守人数达到宝箱所需驻守人数时可开启宝箱。\n2、宝箱每天24点重置。", size = 18,width = 401, color = ccc3(255,0,0), x = 70, y = 230, ax = 0.5})
		setAnchPos(tip, 240, 220, 0.5)
		content:addChild(tip)

	else
		local tip = createLabel({str = "说明：点击宝箱可领取奖励", size = 24,width = 400, color = ccc3(255,0,0), x = 70, y = 230, ax = 0.5})
		setAnchPos(tip, 240, 230, 0.5)
		content:addChild(tip)
	end

	local progress = {22, 47, 70, 91.8}

	local max = 4
	for k, v in pairs(data.cfg) do
		if cur <= v then
			max = k
			break
		end
	end

	--22, 47, 70, 100
	local progress = KNProgress:new(PATH, {"box_progress_bg.png", "box_progress_front.png"}, 36, 384,{
		--		cur = cur  / data.cfg[max] * progress[max],
		cur = (cur - (data.cfg[max - 1] or 0))  / (data.cfg[max] - (data.cfg[max - 1] or 0)) * (progress[max] - (progress[max - 1] or 0)) + (progress[max-1] or 0),
		max = 100,
	})
	content:addChild(progress:getLayer())

	bg = display.newSprite(PATH.."box_progress.png")
	setAnchPos(bg, 240, 420, 0.5, 0.5)
	content:addChild(bg,1)

	for i = 1, 4 do
		local icon = {"box_grey.png"}
		local other
		if cur >= data.cfg[i] then
			icon = {"box_light.png"}
		end

		if table.hasValue(data.awarded, i) then
			other = {PATH.."got.png", 10, 10}
		end

		local box = KNBtn:new(PATH, icon, 95 + (i - 1) * (i == 4 and 95 or 100), 320, {
			scale = true,
			other = other,
			text = {{data.cfg[i] > 10000 and (data.cfg[i] / 10000 ).."万" or data.cfg[i],18, ccc3(255,255,255), ccp(i == 4 and 0 or -5,93)},append and {append[i..""] and (data.cfg[i] - append[i..""]).."/"..data.cfg[i] or data.cfg[i].."/"..data.cfg[i], 18, ccc3(255,255,255),ccp(0,-35) } or nil},
			priority = -221,
			callback = function()
				if i <= max then
					if kind == "city" then
						if other then
							KNMsg.getInstance():flashShow("已领取")
						else
							HTTP:call("fengshen", "getCityAward", {idx = i}, {
								success_callback = function(award)
									HTTP:call("fengshen", "getJFSummary", {}, {
										success_callback = function(data)
											switchScene("godwar",{
												data = data,
												inWar = true,
												pos = pos,
												worldMsg = self.parent.worldMsg,
												time = self.parent.time,
												msg = self.parent.msg
											}, function()
												KNMsg.getInstance():flashShow("打开城市宝箱，获得神币："..award.add)
											end)
										end})
								end
							})
						end
					else
						if other then
							KNMsg.getInstance():flashShow("已领取")
						else
							HTTP:call("fengshen", "getGameScoreAward", {idx = i}, {
								success_callback = function(award)
									HTTP:call("fengshen", "getJFSummary", {}, {
										success_callback = function(data)
											switchScene("godwar",{
												data = data,
												inWar = true,
												warBox = true,
												worldMsg = self.parent.worldMsg,
												time = self.parent.time,
												msg = self.parent.msg
											}, function()
												KNMsg.getInstance():flashShow("打开战贡宝箱，获得神币："..award.add)
											end)
										end
									})
								end
							})
						end
					end
				else
					KNMsg.getInstance():flashShow("还没有达到领取条件")
				end
			end
		})
		content:addChild(box:getLayer(), 1)
	end


	showTip({
		content = content,
		title_bg = PATH.."change_title_bg.png",
		title_text = PATH..(kind == "city" and "city_box_title.png" or "war_box_title.png"),
		titleOffsetY = 15,
		titleTextY = 9,
		offsetY = -18,
		priority = -220,
		parent = self.baseLayer,
		bg = PATH.."tip_bg.png",
		close = {
			normal = "back_img.png",
			pre = "back_img_press.png"
		}
	})
end

function M:createHpRecovery(noAni)
	HTTP:call("fengshen", "getHPPackInfo", {}, {
		success_callback = function(data)
			local layer = display.newLayer()

			local bg = display.newSprite(PATH.."hp_info_bg.png")
			setAnchPos(bg, 240, 380, 0.5, 0.5)
			layer:addChild(bg)

			local desc = createLabel({str = "恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬恭恭敬敬", color =ccc3(0, 255,0), size = 16, x = 40, y = 170, width = 400})
			layer:addChild(desc)


			local str = {}
			if data.hpPack.type then
				str[1] = data.config[data.hpPack.type..""].hp.."%"
				str[2] = data.hpPack.count.."/"..data.config[data.hpPack.type..""].count.."次"
			else
				str[1] = "无"
				str[2] = "0"
			end
			layer:addChild(createLabel({str = str[1], color =ccc3(0x2c, 0,0), x = 240, y = 575}))
			layer:addChild(createLabel({str = str[2], color =ccc3(0x2c, 0,0), x = 390, y = 575}))


			local x, y
			x = 65
			--武将的状态显示
			for k, v in pairs(data.heroHp) do
				if k <= 4 then
					y = 490
				elseif k == 5 then
					y = 380
					x = 65
				end
				local hero_config = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fsheroconfig")
				local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"},x, y, {
					other = {COMMONPATH.."egg_num_bg.png", 50, 50},
					text = {{v.lv, 18, ccc3(255,255,255), ccp(28, 28), nil, 20},{hero_config[v.cid..""].name, 20, ccc3(255,255,255), ccp(0, -55),nil, 20} },
					front = getImageByType(v.cid, "s",false, false,  hero_config[v.cid .. ""].logo_id)
				})
				layer:addChild(btn:getLayer())

				local hp = KNProgress:new(PATH, {"hp_bg.png", "hp_full.png"}, x, y - 10, {
					percent = v.hp
				})
				layer:addChild(hp:getLayer())

				x = x + 100
			end

			x = 80
			y = 230
			local group = KNRadioGroup:new()
			for i = 1, 3  do
				local v = data.config[i..""]
				local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png", "select1.png"},x, y, {
					front = PATH.."hp_"..i..".png",
					id = i,
					noHide = true,
					priority = -200,
					other = {COMMONPATH.."gold.png", -10, -25},
					text = {v.cost, 20, ccc3(255,255,255), ccp(10, -45),nil, 20},
					callback = function()
						desc:setString("每次主动或被动战斗胜利后，系统自动恢复所有武将损失血量的"..v.hp.."%,可恢复"..v.count.."次")
					end
				},group)
				layer:addChild(btn:getLayer())
				x  = x + 130
			end

			group:chooseByIndex(1, true)

			if self.tip then
				self.tip:remove()
			end

			self.tip = showTip({
				noAni = noAni,
				offsetY = -20,
				bg = PATH.."change_bg.png",
				title_bg = PATH.."change_title_bg.png",
				title_text = PATH.."hp_title.png",
				titleOffsetY = 15,
				titleTextY = 11,
				content = layer,
				close = {
					normal = "back_img.png",
					pre = "back_img_press.png",
					removeCallback = function()
						HTTP:call("fengshen", "getJFSummary", {}, {
							no_mask = true,
							success_callback = function(data)
								switchScene("godwar",{
									data = data,
									inWar = true,
									worldMsg = self.parent.worldMsg,
									time = self.parent.time,
									msg = self.parent.msg
								})
							end
						})
					end
				},
				center = {
					front = COMMONPATH.."buy.png",
					callback = function()
						HTTP:call("fengshen", "buyHPPack", {type = group:getId() }, {
							success_callback = function(data)
								self:createHpRecovery(true)
							end
						})
					end
				},

			})

		end
	})
end

function M:createCity(params, other)
	if self.cityLayer then
		self.layer:removeChild(self.cityLayer)
	end
	self.cityLayer = display.newLayer()


	for k, v in pairs(pos) do
		if not v[6] then  --没有被隐藏的城市
			local front,frontScale
			if k == 4 then
				front = PATH.."fight_icon.png"
				frontScale = {1,-60,-65}
			else

				if k ~= 1 and k ~= 7 and k ~= 10 then
					if not table.hasValue(append[user],k) then
						front = PATH.."rob_icon.png"
						frontScale = {1,-50,-40}
					else
						front = PATH.."fight_icon.png"
						frontScale = {1,-50,-40}
					end
				end
			end
			local btn = KNBtn:new(PATH, {"c"..k.."_normal.png", "c"..k.."_pre.png"}, v[2], v[3],{
				front = front,
				frontScale = frontScale,
				anchMid = true,
				callback = function()
					HTTP:call("fengshen", "getJFCityInfo", {pos = k}, {
						success_callback = function(data)
							if KNGuide:getStep() == 10002 then
								data.game = ""
								data.userList = {}
								data.userList[1] = {
									ability = 100,
									hp = 100,
									name = "疯狂的敌人",
									range = 1,
									robedCD = 1,
								}
							end
							if table.hasValue(cityInfo[tonumber(data.pos)], k) or tonumber(data.pos) == k then
								self:showCityInfo(data, k)
							else
								self:showInfo(data,k)
							end
						end
					})
				end
			})
			self.cityLayer:addChild(btn:getLayer())

			if k == 4 and KNGuide:getStep() == 10000 then
				KNGuide:show(nil, {
					x = -100,
					y = 300,
					width = 1,
					height = 1,
					mask_clickable = true,
					callback = function()
						KNGuide:show(nil , {
							--				mask_clickable = true,
							--				callback = function()
							--					initBtn()
							--				end,
							x = v[2] - btn:getWidth() / 2,
							y = v[3] - btn:getHeight() / 2,
							width = btn:getWidth(),
							height = btn:getHeight(),
						})
					end
				})
			end

			local frames = display.newFramesWithImage( PATH .. "fire_effect.png" , 10 )
			for i = 1, v[4] do
				local effect = display.playFrames( v[2] + v[5][i][1] , v[3] + v[5][i][2] , frames , 0.1 , {
					forever = true})
				self.cityLayer:addChild(effect)
			end

			btn:setOther({display.newSprite(PATH..(params.city[k..""].game == "" and "no" or params.city[k..""].game).."_flag.png"), btn:getWidth() / 2 + 30,btn:getHeight() / 1.5, 20})
		end
	end

	if other  then
		if other.pos then
			HTTP:call("fengshen", "getJFCityInfo", {pos = other.pos}, {
				success_callback = function(data)
					self:showCityInfo(data, other.pos)
				end
			})
		elseif other.report then
			HTTP:call("fengshen","getReportList", {}, {
				success_callback = function(data)
					local index = {
						["atk"] = 2,
						["def"] = 3,
						["rob"] = 1
					}
					self.parent:showReport(data, index[other.report])
				end
			})

		end
	end

	self.layer:addChild(self.cityLayer)
end


function M:showCityInfo(data, index)
	dump(data)
	if self.mask then
		self.mask:remove()
	end
	local layer = display.newLayer()
	self.mask = KNMask:new({item = layer,priority = -140})

	local bg =  display.newSprite(PATH.."change_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	layer:addChild(bg)

	bg =  display.newSprite(PATH.."change_title_bg.png")
	setAnchPos(bg, 240, 690, 0.5, 0.5)
	layer:addChild(bg)

	bg =  display.newSprite(PATH.."city_text.png")
	setAnchPos(bg, 240, 698, 0.5, 0.5)
	layer:addChild(bg)

	local info = display.newSprite(PATH.."city_bg.png")
	setAnchPos(info, 240, 440, 0.5, 0.5)
	layer:addChild(info)

	info = display.newSprite(PATH.."info_text.png")
	setAnchPos(info, 200, 580, 0.5, 0.5)
	layer:addChild(info)

	info = display.newSprite(PATH.."user_info.png")
	setAnchPos(info, 240, 500, 0.5, 0.5)
	layer:addChild(info)

	local cr =  ccc3(255,255,255)

	info = createLabel({str =data.name, size = 20, color = cr, width = 350})
	setAnchPos(info, 150,605)
	layer:addChild(info)

	local str
	if data.buff[1] then
		str = Property[data.buff[1].type].." +"..data.buff[1].effect..(data.buff[1].bfb == 1 and "%" or "")
	else
		str = "无"
	end
	info = createLabel({str = str, size = 16, color = cr, width = 350})
	setAnchPos(info, 150, 575)
	layer:addChild(info)




	if SHENZHAN_GROUP ~= data.game and data.game ~= "" then  --敌对势力
		local info = display.newSprite(PATH.."my_hp.png")
		setAnchPos(info, 100, 245, 0.5)
		layer:addChild(info)

		info = createLabel({str =data.hp.."%", size = 20, color = cr, width = 350})
		setAnchPos(info, 170, 248, 0.5)
		layer:addChild(info)


		info = display.newSprite(PATH.."my_ab.png")
		setAnchPos(info, 300, 245, 0.5)
		layer:addChild(info)

		info = createLabel({str =data.ability, size = 20, color = cr, width = 350})
		setAnchPos(info, 370, 248, 0.5)
		layer:addChild(info)

		cr = ccc3(255,0,0)
		local refresh = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 180, 170, {
			priority = -151,
			front = PATH.."refresh_text.png",
			callback = function()
				HTTP:call("fengshen", "getJFCityInfo", {pos = index}, {
					success_callback = function(data)
						self:showCityInfo(data, index)
					end
				})
			end
		})
		layer:addChild(refresh:getLayer())


	else  --中立及已方势力
		--		 local move = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, data.game == "" and 180 or 100, 180, {
		local refresh
		if data.game == "" then
			cr = ccc3(255,255,255)
		else
			cr = ccc3(0,255,0)
			refresh = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 190, 180, {
				priority = -151,
				front = PATH.."refresh_text.png",
				callback = function()
					HTTP:call("fengshen", "getJFCityInfo", {pos = index}, {
						success_callback = function(data)
							self:showCityInfo(data, index)
						end
					})
				end
			})
			layer:addChild(refresh:getLayer())
		end

		--若是卫城则不可迁徙
		if protect[data.pos] ~= index then
			if refresh then
				refresh:getLayer():setPositionX(290)
			end
			local move = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, data.game == "" and 190 or 80, 180, {
				priority = -151,
				front = data.game == "" and PATH.."get_text.png" or PATH.."move.png",
				callback = function()
					if tonumber(data.pos) == index then
						KNMsg.getInstance():flashShow("您已在此城中")
						return
					elseif not table.hasValue(cityInfo[tonumber(data.pos)],index) then
						KNMsg.getInstance():flashShow("没有路径到达此城")
						return
					end
					HTTP:call("fengshen", "gotoCity", {pos = index}, {
						success_callback = function(goInfo)
							HTTP:call("fengshen", "getJFSummary", {}, {
								success_callback = function(data)
									switchScene("godwar", {inWar = true, inWar = true,  worldMsg = self.parent.worldMsg, time = self.parent.time, msg = self.parent.msg, data = data}, function()
										if goInfo.addScore > 0 then
											KNMsg.getInstance():flashShow("恭喜您今日第一次占领该城市，获得了"..goInfo.addScore.."神币。 ")
										end
										dump(goInfo)
										if goInfo.sysmsg then
											GODWAR:sysMsg(goInfo.sysmsg)
										end
									end)
									--self:showCityInfo(data, index)
								end
							})
						end
					})
				end
			})
			layer:addChild(move:getLayer())
		end


	end
	info = createLabel({str =name[data.game], size = 20, color = cr , width = 350})
	setAnchPos(info, 360,535)
	layer:addChild(info)

	cr = ccc3(255,255,255)

	info = createLabel({str =data.userCount, size = 20, color = cr, width = 350})
	setAnchPos(info, 150,533)
	layer:addChild(info)

	if index ~= 1 and index ~= 7 and index ~= 10 then
		local city_box = KNBtn:new(PATH, data.game~= SHENZHAN_GROUP and {"city_box_grey.png"} or {"city_box.png", "city_box_pre.png"}, 300, 565,{
			priority = -151,
			callback = function()
				if data.game ~= SHENZHAN_GROUP then
					KNMsg.getInstance():flashShow("您所在势力没有战领此城市，无法领取宝箱")
				else
					if tonumber(self.data.pos) == index then
						self:createBox("city", data.cityAward, data.userCount, index, data.gameCityAward)
					else
						KNMsg.getInstance():flashShow("您不在此城市，不能领取该城市的城市宝箱")
					end

				end
			end
		})
		layer:addChild(city_box:getLayer())
	else
		local coin = createLabel({str = "国库神币:"..data.country_funds, size = 20, width = 200, color = ccc3(255,255,0)})
		setAnchPos(coin, 260,570)
		layer:addChild(coin)

		if data.game ~= SHENZHAN_GROUP then
			local tip = createLabel({str = "对敌方势力主城进行神币挑战可额外获得20%神币", size = 18, width = 400, color = ccc3(255,0,0)})
			setAnchPos(tip, 240,220,0.5)
			layer:addChild(tip)
		end
	end

	local close = KNBtn:new(COMMONPATH, {"back_img.png", "back_img_press.png"}, 40, 640, {
		priority = -151,
		callback = function()
			HTTP:call("fengshen", "getJFSummary", {}, {
				no_mask = true,
				success_callback = function(data)
					switchScene("godwar",{
						data = data,
						inWar = true,
						worldMsg = self.parent.worldMsg,
						time = self.parent.time,
						msg = self.parent.msg
					})
				end
			})
		end
	})
	layer:addChild(close:getLayer())

	local temp
	local function createList(list)
		if temp then
			layer:removeChild(temp, true)
		end
		--							 scroll = KNScrollView:new(50, 300, 400, 180, 8, false)
		temp = display.newLayer()

		for k, v in pairs(list) do
			local item = display.newLayer()
			item:setContentSize(CCSizeMake(420, 30))

			local text = {"look.png", "look_pre.png"}
			if SHENZHAN_GROUP ~= data.game then
				text = {"opt.png", "opt_pre.png"}
			end
			local optBtn, tip
			optBtn = KNBtn:new(PATH, text, 340, 5, {
				priority = -151,
				callback = function()
					if SHENZHAN_GROUP == data.game then
						HTTP:call("fengshen", "getUserHeroPos", {uid2 = v.uid, serverID2 = v.server_id}, {
							success_callback = function(data)
								self:viewFormation(false, data)
							end
						})
					else


						local layer = display.newLayer()
						local btn = {"fight", "dragon","rob", "view"}
						for sk, sv in pairs(btn) do
							local path = COMMONPATH
							local btn_bg = {"long_btn.png", "long_btn_pre.png"}
							local front = PATH..(sv == "dragon" and "dragon_fight" or sv)..".png"
							local x, y

							if sv == "view" then
								local optBg = display.newSprite(PATH.."opt_info_bg.png")
								setAnchPos(optBg, 240, 490, 0.5)
								layer:addChild(optBg)

								path = PATH
								btn_bg = {"view.png", "view_pre.png"}
								front = nil
								x = 360
								y = 520

								local info = createLabel({str = "昵称:"..v.name, size = 20, color = ccc3(255,255,255), width = 200})
								setAnchPos(info, 120, 555 )
								layer:addChild(info)

								info = createLabel({str = '势力:'..data.name, size = 20, width  = 200,color = ccc3(255,255,255)})
								setAnchPos(info, 120, 530 )
								layer:addChild(info)

								info = createLabel({str = "神力:"..v.ability, size = 20, color = ccc3(255,255,255), width = 300})
								setAnchPos(info, 120, 500)
								layer:addChild(info)

							else
								local optBg = display.newSprite(PATH.."opt_bg.png")
								setAnchPos(optBg, 10, 380 - (sk - 1) * 120)
								layer:addChild(optBg)

								optBg = display.newSprite(PATH.."opt_info.png")
								setAnchPos(optBg, 30, 390 - (sk - 1) * 120)
								layer:addChild(optBg)

								local str
								if sv == "fight" or sv == "dragon" then
									str = "fight_"..(sv == "fight" and "coin" or sv)
								else
									str = "rob_coin"
								end

								local info = createLabel({str = self.data[str.."_".."award"], size = 20, color = ccc3(255,255,255), width = 400})
								setAnchPos(info, 120, 445 - (sk - 1) * 120 )
								layer:addChild(info)

								data.pos = tonumber(data.pos)
								if data.pos ~= user then
									if table.hasValue(append[user] , index) and (data.pos == 4 or table.hasValue(append[user] , data.pos)) then
									else
										local zhangong_str = "(战贡+5)"

										if data.pos == 4 then 				-- 中央主城
											zhangong_str = "(战贡+7)"
										elseif not table.hasValue(append[user],data.pos) then
											zhangong_str = "(战贡+7)"
										end

										local ap = createLabel({str = zhangong_str , size = 20, width = 400, color = ccc3(255,0,0)})
										setAnchPos(ap, 120 + info:getContentSize().width, 445 - (sk - 1) * 120 )
										layer:addChild(ap)
									end
								end
								-- if not table.hasValue(append[user],data.pos) and not table.hasValue(append[user],index) then
								-- 	local ap = createLabel({str ="(战贡+5)", size = 20, width = 400, color = ccc3(255,0,0)})
								-- 	setAnchPos(ap, 120 + info:getContentSize().width, 445 - (sk - 1) * 120 )
								-- 	layer:addChild(ap)
								-- end

								info = createLabel({str = self.data[str.."_".."action"].."行动力", size = 20, width  = 200,color = ccc3(255,255,255)})
								setAnchPos(info, 120, 420 - (sk - 1) * 120 )
								layer:addChild(info)

								info = createLabel({str = self.data[(sv == "rob" and "rob" or str).."_cur_times"] .. "/".. self.data[(sv == "rob" and "rob" or str).."_max_times"], size = 20, color = ccc3(255,255,255)})
								setAnchPos(info, 120, 395 - (sk - 1) * 120 )
								layer:addChild(info)


								x = 320
								y = 410 - (sk - 1) * 120
							end

							if v.robedCD > 0 and sv == "rob" then
								btn_bg = {"long_btn_grey.png"}
								front = PATH..sv.."_grey.png"
							end

							local btn
							btn = KNBtn:new(path, btn_bg, x, y - 10,{
								front = front,
								priority = -201,
								callback = function()
									if sv == "fight" or sv == "dragon" then
										print(KNGuide:getStep())
										if KNGuide:getStep() ~= 10004 and not table.hasValue(cityInfo[tonumber(data.pos)], index) then
											KNMsg.getInstance():flashShow("您当前位置无法到达此城,不能挑战")
											return
										end

										HTTP:call("fengshen", KNGuide:getStep() == 10004 and "fight2" or "fight", {uid2 = v.uid ,serverID2 = v.server_id, type = (sv == "fight" and 1 or 2), pos = index}, {
											success_callback = function(data)
												self.battle = true
												DATA_Battle:setMod("guide")
												DATA_Battle:setAct("godwar")
												DATA_Battle:set( data )
												DATA_Result:set({type = "godwar", data = data, challenge = sv})

												switchScene("battle" , {})

												--									switchScene("battle" , { resultCallFun = function()end, overFun = function()
												--										switchScene("godwar", {pos = index, inWar = true})
												--									end})
											end})

									elseif sv == "rob" then
										if not table.hasValue(cityInfo[tonumber(data.pos)], index) then
											KNMsg.getInstance():flashShow("您当前位置无法到达此城,不能挑战")
											return
										end

										if data.robedCD > 0 then
											KNMsg.getInstance():boxShow("由于你被别人抢劫进入了保护时间，若你在保护时间内抢劫其他玩家则会解除你的保护状态，是否要进行抢劫？(剩余保护时间"..data.robedCD..")", {confirmFun= function()
													HTTP:call("fengshen", "rob", {uid2 = v.uid ,serverID2 = v.server_id, pos = index}, {
														success_callback = function(data)
															self.battle = true
															DATA_Battle:setMod("guide")
															DATA_Battle:setAct("godwar")
															DATA_Battle:set( data )
															DATA_Result:set({type = "godwar", data = data, fight = "rob", challenge = "fight"})
															switchScene("battle" , {})
															--									switchScene("battle" , { resultCallFun = function()end, overFun = function()
															--										switchScene("godwar", {pos = index, inWar = true})
															--									end})
														end
													})
												end, cancelFun = function()end})
											return
										end

										HTTP:call("fengshen", "rob", {uid2 = v.uid ,serverID2 = v.server_id, pos = index}, {
											success_callback = function(data)
												dump(data)
												self.battle = true
												DATA_Battle:setMod("guide")
												DATA_Battle:setAct("godwar")
												DATA_Battle:set( data )
												DATA_Result:set({type = "godwar", data = data, fight = "rob", challenge = "fight"})
												switchScene("battle" , {})
												--									switchScene("battle" , { resultCallFun = function()end, overFun = function()
												--										switchScene("godwar", {pos = index, inWar = true})
												--									end})
											end
										})
									else
										HTTP:call("fengshen", "getUserHeroPos", {uid2 = v.uid, serverID2 = v.server_id}, {
											success_callback = function(data)
												self:viewFormation(true, data)
											end
										})
									end
								end
							})
							layer:addChild(btn:getLayer())

							if sv == "view" then
								local gold = display.newSprite(COMMONPATH.."gold.png")
								setAnchPos(gold, 360, 495)
								layer:addChild(gold)

								layer:addChild(createLabel({str = data.spyCost, size = 20, color = ccc3(0x2c, 0, 0), width = 200, x = 400, y = 495}))
							elseif sv == "dragon" or sv == "fight" then
								local btn = KNBtn:new(COMMONPATH,{"add.png","add_press.png"}, 200,390 - (sk - 1) * 120,{
									priority = -201,
									callback = function()
										showTip({
											priority = -202,
											content = createLabel({str = "您确定要消耗黄金"..self.data["buy_fight_"..(sv == "dragon" and "dragon" or "coin").."_price"].."增加一次挑战次数？", width = 300, size = 20}),
											left={
												remove= true,
												removeCallback = function()
													HTTP:call("fengshen", "buy_fight_times",{type = sv == "fight" and 1 or 2},{
														success_callback = function(re)
															HTTP:call("fengshen", "getJFSummary", {}, {
																success_callback = function(d)
																	tip:remove()
																	self.data = d
																	optBtn:call()
																	KNMsg.getInstance():flashShow("购买成功")
																end
															})
														end
												})
												end
											},
											right = {
												remove = true,
												callback = function()
												end
											}
										})
									end
								})
								layer:addChild(btn:getLayer())
							end

							if  sv == "fight" and KNGuide:getStep() == 10003 then
								KNGuide:show(nil, {
									x = btn:getX() - btn:getWidth() / 2 ,
									y = btn:getY() + btn:getHeight() / 2 + 5,
									width = btn:getWidth(),
									height = btn:getHeight()
								})
							end
						end

						tip = showTip({
							priority = -200,
							bg = PATH.."change_bg.png",
							title_bg = PATH.."change_title_bg.png",
							title_text = PATH.."info_title.png",
							titleOffsetY = 13,
							titleTextY = 9,
							offsetY = -18,
							content = layer,
							close = {
								normal ="back_img.png" ,
								pre = "back_img_press.png"
							}
						})
					end
				end
			})
			item:addChild(optBtn:getLayer())

			if KNGuide:getStep() == 10002 then
				KNGuide:show(nil, {
					x = btn:getX() + btn:getWidth() / 2 + 7,
					y = btn:getY() + layer:getContentSize().height / 2 + btn:getHeight() / 2,
					width = btn:getWidth(),
					height = btn:getHeight()
				})
			end

			local info = createLabel({str = pos_text[v.range], size = 16, color = cr, width = 350})
			setAnchPos(info, 20, 8, 0.5)
			item:addChild(info)

			info = createLabel({str =v.name, size = 18, color = cr, width = 350})
			setAnchPos(info, 120, 8, 0.5)
			item:addChild(info)

			info = createLabel({str = v.hp.."%", size = 18, color = cr, width = 350})
			setAnchPos(info, 230, 8, 0.5)
			item:addChild(info)

			info = createLabel({str =v.ability, size = 18, color = cr, width = 350})
			setAnchPos(info, 300, 8, 0.5)
			item:addChild(info)

			setAnchPos(item, 40, 480 - k * 40)
			temp:addChild(item)
		end

		return temp
	end

	if (index == 1 or index == #cityInfo) and SHENZHAN_GROUP == data.game and SHENZHAN_GROUP ~= "tgxy" then
		local voice = KNBtn:new(PATH, {"voice.png", "voice_pre.png"}, 340, 600, {
			priority = -200,
			callback = function()
				if not self.play then
					self.play = true
					audio.pauseMusic()
					audio.playSound(IMG_PATH.."sound/"..data.game.."_voice.mp3")
					delayFun(SHENZHAN_GROUP == "td" and 14 or 8,function()
						audio.resumeMusic()
						self.play = false
					end)
				end
			end
		})
		layer:addChild(voice:getLayer())
	end

	layer:addChild(createList(data.userList))
	--
	self.baseLayer:addChild(self.mask:getLayer(), 1)
end


function M:buy(cost )
	self.buyLayer = display.newLayer()
	local baseX = display.cx
	local baseY = display.cy - 28

	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos( bg , baseX - 213 , baseY - 20 , 0 , 0 )
	self.buyLayer:addChild(bg)

	--	--物品Icon
	--	local icon = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , baseX - 148 , baseY + 135 , {  front = getImageByType(DATA_Shop:get(index , "cid") , "s") } )
	--	self.buyLayer:addChild( icon:getLayer() )
	--
	local name = display.strokeLabel(tonumber(self.data.maxBuyAction) -tonumber(self.data.curBuyAction) , 220, baseY + 200 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 330 ,align = 0 } )
	self.buyLayer:addChild(name )

	local name = display.strokeLabel( "说明：当行动力低于上限时，每10分钟回复一点行动力" , 55 , baseY , 16 , ccc3(0xff , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 330 ,align = 0 } )
	self.buyLayer:addChild(name )


	--    name = display.strokeLabel( "您是否现在购买"..self.data.actionBuyNum.."点行动力" , 95 , baseY + 130	 , 24 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 330 ,align = 0 } )
	--	self.buyLayer:addChild(name )

	local rest = display.newSprite(PATH .. "rest_buy.png")
	setAnchPos(rest , baseX - 200  , baseY + 200 )
	self.buyLayer:addChild(rest)

	--	--花费总数
	--	local valueBg = display.newSprite(PATH.."value_bg.png")
	--	valueBg:setScaleY(0.89)
	--	setAnchPos(valueBg , baseX - 17 , baseY + 130 , 0.5)
	--	self.buyLayer:addChild(valueBg)
	--
	local gold = display.newSprite(COMMONPATH .. "gold.png")
	setAnchPos(gold , baseX - 155 + 70  , baseY + 140 )
	self.buyLayer:addChild(gold)

	local priceText = display.strokeLabel(self.data.actionPrice , baseX - 120 + 70 , baseY - 5 + 140, 20 , ccc3(0x2c , 0x00 , 0x00 ) , nil , nil ,{ dimensions_width = 80 , dimensions_height = 30 ,align = 0} )
	self.buyLayer:addChild(priceText)

	--
	--
	--购买数量
	local numText = display.newSprite(PATH.."join/surplus_time_text.png")
	setAnchPos(numText,baseX + 35  , baseY + 140 , 0 )
	self.buyLayer:addChild(numText)

	local numBg = display.newSprite(PATH.."use.png")
	local num = 1
	setAnchPos(numBg,baseX - 144 , baseY + 140 )
	self.buyLayer:addChild(numBg)

	--数量文本
	local numText = display.strokeLabel( 1 .. "" , baseX + 96 , baseY + 136 , 20 , ccc3(0x2c, 0, 0 ) , nil , nil , { dimensions_width = 36 , dimensions_height = 30 ,align = 1 } )
	self.buyLayer:addChild(numText)

	--修改数值
	local function changeValue()
		numText:setString(num)
		priceText:setString(num * cost)
	end

	--划动条
	local slider = KNSlider:new( "buy" ,  {
		x = baseX - 106 ,
		y = baseY -53 ,
		minimum = 1 ,
		maximum = self.data.maxBuyAction - self.data.curBuyAction,
		value = 1 ,
		callback  = function( _curIndex )
			num = _curIndex
			changeValue()
		end,
		priority = -140
	})
	self.buyLayer:addChild( slider )

	--增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX + 128 , baseY + 77 , {
		scale = true,
		priority = -130,
		callback = function()
			if num < 99 then
				num = num + 1
				slider:setValue( num )
				changeValue()
			end
		end
	})

	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX - 165 , baseY + 77 ,{
		scale = true,
		priority = -130,
		callback = function()
			if num > 1 then
				num = num - 1
				slider:setValue( num )
				changeValue()
			end
		end
	})
	minusBtn:setFlip(true)

	addBtn:getLayer():setScale( 0.9 )
	minusBtn:getLayer():setScale( 0.9 )
	self.buyLayer:addChild(addBtn:getLayer())
	self.buyLayer:addChild(minusBtn:getLayer())--]]





	local mask = KNMask:new( {item = self.buyLayer} ):getLayer()
	--确定，取消按钮
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, baseX - 154 , baseY + 28 ,{
		front = COMMONPATH.."ok.png" ,
		scale = true,
		priority = -130,
		callback = function()
			if not countGold(priceText:getLabel():getString()) then
				return
			else
				HTTP:call("fengshen" , "buyAction" , {
					count = num
				} , {
					success_callback = function(data)
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar",{
									data = data,
									inWar = true,
									worldMsg = self.parent.worldMsg,
									time = self.parent.time,
									msg = self.parent.msg
								}, function() KNMsg.getInstance():flashShow("购买成功") end)
							end
						})
					end
				})
			end

		end
	})
	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , baseX + 54 , baseY + 28 ,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			self.baseLayer:removeChild(mask,true)
		end})
	self.buyLayer:addChild(ok:getLayer())
	self.buyLayer:addChild(cancel:getLayer())
	--
	--
	self.baseLayer:addChild(mask, 10)
end

function M:showInfo(data,index)
	local temp = display.newLayer()

	local city = display.newSprite(PATH.."box_bg.png")
	setAnchPos(city,240,320,0.5)
	temp:addChild(city)

	city = display.newSprite(PATH.."c"..index.."_normal.png")
	setAnchPos(city,40,350)
	temp:addChild(city)

	local str = "our_info.png"
	local str1 = "enemy_info.png"
	if index == 1 or index == 7 or index == 10 then
		city:setScale(0.8)
		str = "enemy_info.png"
	elseif index == 4 then
		-- str1 = "our_info.png"
	end

	city = display.newSprite(PATH..str)
	setAnchPos(city,180,450)
	temp:addChild(city)

	city = display.newSprite(PATH..str1)
	setAnchPos(city,180,420)
	temp:addChild(city)

	city = display.newSprite(PATH.."cur_info.png")
	setAnchPos(city,180,360)
	temp:addChild(city)


	if data.buff[1] then
		str = Property[data.buff[1].type].." +"..data.buff[1].effect..(data.buff[1].bfb == 1 and "%" or "")
	elseif index == 4 then
		str = "无加成"
	else
		str = "每次战斗可抢国库"
	end

	local info = createLabel({str = "【"..str.."】", width = 300, size = 18,color = ccc3(255,255,255)})
	setAnchPos(info, 280,455)
	temp:addChild(info)

	local other_str = nil
	local main_str = "【每次胜利战贡+7】"
	if index == 2 then
		other_str = "【圣因城攻击战贡+5】"
		main_str = "【其他敌城则战贡+7】"
	elseif index == 3 then
		other_str = "【圣瑞城攻击战贡+5】"
		main_str = "【其他敌城则战贡+7】"
	elseif index == 5 then
		other_str = "【圣穆城攻击战贡+5】"
		main_str = "【其他敌城则战贡+7】"
	elseif index == 6 then
		other_str = "【圣祥城攻击战贡+5】"
		main_str = "【其他敌城则战贡+7】"
	elseif index == 8 then
		other_str = "【圣凝城攻击战贡+5】"
		main_str = "【其他敌城则战贡+7】"
	elseif index == 9 then
		other_str = "【圣初城攻击战贡+5】"
		main_str = "【其他敌城则战贡+7】"
	elseif index == 4 then
		other_str = "【从己城攻击战贡+5】"
		main_str = "【从敌城攻击战贡+7】"
	end

	if other_str ~= nil then
		info = createLabel({str = other_str , width = 300, size = 18,color = ccc3(255,255,255)})
		setAnchPos(info, 280,425)
		temp:addChild(info)

		info = createLabel({str = main_str, width = 300, size = 18,color = ccc3(255,255,255)})
		setAnchPos(info, 280,395)
		temp:addChild(info)
	else
		info = createLabel({str = main_str, width = 300, size = 18,color = ccc3(255,255,255)})
		setAnchPos(info, 280,425)
		temp:addChild(info)
	end

	info = createLabel({str = "【"..name[data.game].."】", width = 300, size = 18,color = ccc3(255,255,255)})
	setAnchPos(info, 280,365)
	temp:addChild(info)

	info = createLabel({str = pos[index][1][3], width = 400,size = 18, color = ccc3(0x2c,0,0)})
	setAnchPos(info, 240,320,0.5,1)
	temp:addChild(info)

	if index == 2 or index == 3 or index == 5 or index == 6 or index == 8 or index == 9 then
		info = createLabel({str = "攻打己方被占领城市时无战贡加成" , width = 400,size = 18, color = ccc3(0xff , 0 , 0)})
		setAnchPos(info, 120 , 335)
		temp:addChild(info)

	end


	showTip({
		bg = PATH.."tip_bg.png",
		title_bg = PATH.."change_title_bg.png",
		title_text = PATH.."c"..index.."_title.png",
		titleOffsetY = 15,
		titleTextY = 9,
		offsetY = -18,
		priority = -220,
		content = temp,
		center = {
			remove = true,
			front = COMMONPATH.."colse_text.png",
			callback = function()
			end
		}
	})
end

--查看阵容
function M:viewFormation(enemy, data)
	local temp = display.newLayer()
	self.parent:changeLayer(data.hero,temp, data.game)


	if enemy then
		local power = display.newSprite(PATH.."enemy_power.png")
		setAnchPos(power,15, 120)
		temp:addChild(power)

		temp:addChild(createLabel({str = data.ability, size = 18, x = 110, y = 125}))
	end

	local change_layout
	change_layout = showTip({
		bg = PATH.."change_bg.png",
		title_bg = PATH.."change_title_bg.png",
		title_text = PATH..(enemy and "enemy_formation.png" or "our_formation.png"),
		titleOffsetY = 15,
		titleTextY = 9,
		offsetY = -18,
		priority = -220,
		content = temp,
		close = {
			normal = "back_img.png",
			pre = "back_img_press.png",
			remove = true,
			callback = function()
				self.tempChoose = nil
			end
		},
		center = {
			front = PATH.."hero_change.png",
			callback = function()
				HTTP:call("fengshen", "getHeroInfo", {}, {
					success_callback = function(data)
						self.parent:changeFunc(data, -230, true)
					end
				})
			end
		}
	})
end

function M:getLayer()
	return self.baseLayer
end



return M
