local PATH = IMG_PATH.."image/scene/godwar/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local KNProgress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local HomeCard = requires(IMG_PATH,"GameLuaScript/Scene/godwar/herocard")
local Property = requires(IMG_PATH,"GameLuaScript/Config/Property")
local CheckBox = requires (IMG_PATH,"GameLuaScript/Common/KNCheckBox")
local War = requires(IMG_PATH,"GameLuaScript/Scene/godwar/field")
local KNInputText = requires(IMG_PATH,"GameLuaScript/Common/KNInputText")
local KNBar = requires(IMG_PATH , "GameLuaScript/Common/KNBar")
local Item = requires(IMG_PATH, "GameLuaScript/Scene/godwar/rankitem")
local GodWarShopLayer = requires(IMG_PATH, "GameLuaScript/Scene/godwar/godwarshoplayer")
local hero_config = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fsheroconfig")
local bagLayer = requires(IMG_PATH,"GameLuaScript/Scene/godwar/bagLayer")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")

--[[
首页
]]
local GodwarLayer= {
	mainLayer,
	baseLayer,
	msgLayer,
	layer,
	tempLayer,
	mask,
	tempChoose,
	goOut,         --主动退出
	sysLayer,   --系统提示
	worldMsg,  --世界聊天消息
	haveMsg,   --是否还有消息
	isEnemyRank,  --是否在敌方排行
	funcBtns,
	msgColor,
	field,  --是否在战场
	msgNum, --聊天信息数
	reportNum, --战报数
	menuBtns, --菜单中的按钮
	isChange  --是否改变阵形
}


local name = {
	['td'] = "绝世天府",
	['tmsj'] = "唐门世界",
	['tgxy'] = "太古仙域"
}
--世界聊天历史
worldHis = {}

function GodwarLayer:new(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.mainLayer = display.newLayer()
	this.msgLayer = display.newLayer()
	this.baseLayer = display.newLayer()
	this.layer = display.newLayer()
	this.params = params or {}

	this.baseLayer:addChild(this.layer)
	this.mainLayer:addChild(this.baseLayer)
	this.funcBtns = {}
	this.menuBtns = {}
	GODWAR = this

	if params then
		this.worldMsg = params.worldMsg or {}
		this.time = params.time or 0
		this.msg = params.msg or ""
		this.haveMsg = params.haveMsg
		this.field = params.field
		this.msgNum = params.msgNum or 0
		this.reportNum = params.reportNum or 0
		this.data = params.data

		if params.join then
			this:createJoin( params )
			return this
		end

		this:createMain(params)
		if  params.inWar then
			this:createWar(params, params.data)
			return this
		elseif params.cur then
			this:createRank(params)
			return this
		end
	else
		this.worldMsg = {}
		this.time = 0
		this.msgNum = 0
		this.reportNum = 0
	end

	local pos ={
		--		{"stone",  20, 341, 1, function()
		--			HTTP:call("fengshen", "getEntrance",{}, {
		--				success_callback = function(data)
		--					HTTP:call("fengshen", "getMineInfo",{}, {
		--						success_callback = function(param)
		--							this:createNewMaterial(param)
		--						end
		--					})
		--				end
		--			})
		--		end},
		{"pet",   60,371, 1,
			function()
				HTTP:call("fengshen","getPetInfo", {}, {
					success_callback = function(data)
						this:createPet(data)
					end
				})
			end},
		--		{"rank",  236, 410, 1, function(p)
		--			 HTTP:call("fengshen", "getUserFSInfo", {}, {
		--					success_callback = function(data)
		--						this:rankDetail("self", data)
		--					end })
		--		 end},
		{"hero",  216, 410,1,function(p)
				HTTP:call("fengshen", "getHeroInfo", {}, {
					success_callback = function(data)
						this:createHero(data)
					end
				})
			end},
		{"people",348, 277,1,function(p) this:createJoin(p) end },
		{"bag",81, 630,1,function(p)
			HTTP:call("fengshen", "getBagList", {}, {
				success_callback = function(data)
					this:createBag(data, nil, function() self:backToMain() end)
				end
			})
		end}
	}

	local img, current
	for k, v in pairs(pos) do
		if v[4] == 1 then
			img = {v[1]..".png",v[1].."_pre.png"}
		else
			img = {v[1].."_grey.png"}
		end

		this.funcBtns[v[1]] = KNBtn:new(PATH, img, v[2], v[3], {
			callback = function()
				if v[4] == 0 then
					KNMsg.getInstance():flashShow("功能未开放")
					return
				end
				v[5](params)
			end
		})
		this.layer:addChild(this.funcBtns[v[1]]:getLayer())

	end

	if  KNGuide:getStep() == 10005 then
		KNGuide:show(this.funcBtns["stone"]:getLayer() , {
		})
	elseif KNGuide:getStep() == 10008 then
		KNGuide:show(this.funcBtns["hero"]:getLayer() , {
		})
	elseif KNGuide:getStep() == 10014 then
		KNGuide:show(this.funcBtns["pet"]:getLayer() , {
		})
	elseif KNGuide:getStep() == 10017 then
		KNGuide:show(nil, {
			x = -100,
			y = 300,
			width = 1,
			height = 1,
			remove = true,
			mask_clickable = true
		})
	end

	if params.page then
		this.funcBtns[params.page]:call()
	end

	local bg = display.newSprite(PATH .. "bg.jpg")
	setAnchPos(bg , 0 , 0)
	this.layer:addChild(bg,-3)

	local frames = display.newFramesWithImage( PATH .. "enter_effect.png" , 14 )
	local effect = display.playFrames( 160  , 100 , frames , 0.15 , {
		forever = true})
	this.layer:addChild(effect)

	local enter = KNBtn:new(PATH, {"enter_text.png", "enter_pre.png",}, 120, 40, {
		callback = function()
			HTTP:call("fengshen", "getJFSummary", {}, {
				success_callback = function(data)
					self.field = true
					this:createWar(params, data)
					audio.playMusic( IMG_PATH .. "sound/godwar_field.mp3" , true )
				end})
		end})
	this.layer:addChild(enter:getLayer())
	
	local fight = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 390, 702, {
		front = PATH.."field_text.png",
		callback = function()
			HTTP:call("fengshen", "getJFSummary", {}, {
				success_callback = function(data)
					self.field = true
					this:createWar(params, data)
					audio.playMusic( IMG_PATH .. "sound/godwar_field.mp3" , true )
				end})
		end})
	this.layer:addChild(fight:getLayer())

	--	local back = KNBtn:new(IMG_PATH.."image/scene/swar/", {"back_btn.png",}, 10, 50, {
	--		scale = true,
	--		callback = function()
	--			self.goOut = true
	--			switchScene("pvp", {coming = 'godwar'})
	--		end
	--	})
	--	this.layer:addChild(back:getLayer())




	local help = KNBtn:new(IMG_PATH.."image/scene/multiFb/", {"help.png", "help_press.png"}, 5,600,{
		callback = function()
			local layer = display.newLayer()

			local img =	 display.newSprite(PATH.."help_desc.png")
			setAnchPos(img, 240, 400, 0.5, 0.5)
			layer:addChild(img)

			showTip({
				title = PATH.."help.png",
				bg = PATH.."change_bg.png",
				content = layer,
				center = {
					remove = true
				}
			})
		end})
	this.layer:addChild(help:getLayer())
	
--	this.layer:setTouchEnabled(true)
--	this.layer:registerScriptTouchHandler(function(type, x, y)
--		if type == CCTOUCHBEGAN then
--		this:sysMsg({
--			game = "tmsj",
--			msg = "是是是是是是是"
--		})
--		end
--	end)
	return this
end

function GodwarLayer:go2hero(idx)
	HTTP:call("fengshen", "getHeroInfo", {}, {
		success_callback = function(data)
			self:createHero(data, idx)
		end
	})
end

function GodwarLayer:createBag(data, idx, backfunc, optfunc)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
		self.mainLayer:removeChild(self.msgLayer, true)
		self.msgLayer = nil
	end
	self.layer = bagLayer.new(data, idx, backfunc, optfunc):addTo(self.baseLayer)
end

function  GodwarLayer:createWar(params, data)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end


	self.layer =  War:new(params, data, self):getLayer()

	self.baseLayer:addChild(self.layer)
end

function GodwarLayer:showRevengList(data)
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer, priority = -229})

	local bg =  display.newSprite(PATH.."change_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	layer:addChild(bg)

	bg =  display.newSprite(PATH.."change_title_bg.png")
	setAnchPos(bg, 240, 690, 0.5, 0.5)
	layer:addChild(bg)

	bg =  display.newSprite(PATH.."revenge_title.png")
	setAnchPos(bg, 240, 698, 0.5, 0.5)
	layer:addChild(bg)

	local scroll = KNScrollView:new(0, 230, 480, 431,5,false,0,{
		priority = -230
	})
	for i = 0, #data do
		if data[i] and table.nums(data[i]) > 0 then
			local temp = Item:new("rob", self.rankLayer, data[i], i, function()
				HTTP:call("fengshen", "revenge", {uid2 = data[i].uid ,serverID2 = data[i].server_id}, {
					success_callback = function(data)
						self.battle = true
						DATA_Battle:setMod("guide")
						DATA_Battle:setAct("godwar")
						DATA_Battle:set( data )
						DATA_Result:set({type = "godwar", data = data, fight = "revenge"})
						switchScene("battle" , {})
					end
				})
			end)
			scroll:addChild(temp:getLayer())
		end

	end
	scroll:alignCenter()
	layer:addChild(scroll:getLayer())

	local close = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 200, 180, {
		priority = -230,
		front = COMMONPATH.."colse_text.png",
		callback = function()
			mask:remove()
		end
	})
	layer:addChild(close:getLayer())

	self.baseLayer:addChild(mask:getLayer())
end


function GodwarLayer:showReport(parent, tab)


	local bg =  display.newSprite(PATH.."report_bg.png")
	setAnchPos(bg, 240, 0, 0.5)
	parent:addChild(bg)

	bg =  display.newSprite(PATH.."rank_tab_bg.png")
	setAnchPos(bg, 240, 595, 0.5)
	parent:addChild(bg)

	local temp
	local function createList(list, tabKind)
		if temp then
			parent:removeChild(temp, true)
		end

		temp = display.newLayer()

		local scroll = KNScrollView:new(40, 0, 400,585, 10)

		for k, v in pairs(list) do
			if k > 9 then
				break
			end
			local item = display.newLayer()


			local str
			if v.type == "fight" or v.type == nil then
				if v.attacker == 1 then
					if v.win == 1 then
						str = "【胜】您成功击败了「"..v.uid_2_name.."」;"..(v.reviveHP == 0 and "" or "战斗剩余血量:"..v.remainHP.."%,自动使用加血包回复了已损失血量的:"..v.reviveHP.."%。")
					else
						str = "【败】您被「"..v.uid_2_name.."」击败了"
					end
				else
					if v.win == 1 then
						str = "【胜】您成功防御了「"..v.uid_2_name.."」对您的挑战;"..(v.reviveHP == 0 and "" or "战斗剩余血量:"..v.remainHP.."%,自动使用加血包回复了已损失血量的:"..v.reviveHP.."%。")
					else
						str = "【败】您输掉了「"..v.uid_2_name.."」对您的挑战"
					end
				end
			else
				if v.type == "rob" then
					str = "【抢劫】「"..v.uid_2_name.."」成功抢劫了你，夺走了你"..-v.coin.."神币，简直丧心病狂！ "
				else
					str = "【复仇】「"..v.uid_2_name.."」成功对你进行了复仇，让您损失了"..-v.coin.."神币！并对你撂下狠话：啧啧，实力低下就不要出来晃荡。！"
				end
			end

			local timeInfo = os.date("*t", v.time)

			local info = createLabel({str =str.."("..timeInfo.month.."-"..timeInfo.day.." "..timeInfo.hour..":"..timeInfo.min..")", size = 20, color = ccc3(255,255,255), width = 330})
			item:addChild(info)

			item:setContentSize(CCSizeMake(420, info:getContentSize().height))

			setAnchPos(info, 70, item:getContentSize().height, 0, 1)
			scroll:addChild(item)

			local text = {"look.png", "look_pre.png"}
			if v.type == "rob" and tonumber(v.finish) == 0 then
				text = {"loot/fuchou.png", "loot/fuchou_pre.png"}
			end

			local btn = KNBtn:new(PATH, text, 30, item:getContentSize().height / 2, {
				anchMid = true,
				priority = -151,
				callback = function()
					if v.type == "rob" and tonumber(v.finish) == 0 then
						HTTP:call("fengshen", "revenge", {uid2 = v.uid_2 ,serverID2 = v.report_server_id}, {
							success_callback = function(data)
								self.battle = true
								DATA_Battle:setMod("guide")
								DATA_Battle:setAct("godwar")
								DATA_Battle:set( data )
								DATA_Result:set({type = "godwar", data = data, fight = "revenge"})
								switchScene("battle" , {})
							end
						})
					else
						HTTP:call("fengshen", "getReport", {report_id = v.report_id, report_sid = v.report_server_id}, {
							success_callback = function(data)
								-- dump(data)
								DATA_Battle:setMod("guide")
								DATA_Battle:setAct("execute")
								DATA_Battle:set( data )
								switchScene("battle" , { resultCallFun = function()end, overFun = function()
										HTTP:call("fengshen", "getJFSummary", {}, {
											success_callback = function(data)
												switchScene("godwar",{
													data = data,
													cur = "rank",
													kind = "warinfo"
												})
											end
										})
									end})
							end
							})
						end
				end })
			item:addChild(btn:getLayer())
		end
		--
		--		if tabKind == "rob" then
		--			close:getLayer():setPositionX(300)
		--
		--			local revenge = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 100, 180, {
		--				 priority = -151,
		--				 front = PATH.."revenge_text.png",
		--				callback = function()
		--					HTTP:call("fengshen","getReportList", {}, {
		--						success_callback = function(data)
		--							self:showRevengList(data.revengeList)
		--						end
		--					})
		--				end
		--			})
		--			temp:addChild(revenge:getLayer())
		--		else
		--		end

		temp:addChild(scroll:getLayer())
		parent:addChild(temp)
	end

	local kind = {"rob","atk", "def"}
	local group = KNRadioGroup:new()
	for i = 1, #kind do
		local temp = KNBtn:new(COMMONPATH,{"btn_bg_dis.png","btn_bg.png"},50 + (i - 1) * 150, 610,{
			priority = -151,
			disableWhenChoose = true,
			upSelect = true,
			front = {PATH..kind[i].."_normal.png", PATH..kind[i].."_pre.png"},
			callback=
			function()
				HTTP:call("fengshen","getReportList", {}, {
					success_callback = function(data)
						createList(data[kind[i].."ReportList"], kind[i])
					end
				})
			end
		},group)
		parent:addChild(temp:getLayer())
	end

	group:chooseByIndex(tab or 1, true)
end
--交流界面
function GodwarLayer:chat(data)
	DATA_Info:setIsMsg( false )
	if DATA_Info:getIsOpen() then
		local talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/godwar/talk")
		self.talkLayer = talkLayer:new( {
			priority = -250,
			type = "godwar",
			cost = data,
			custom = { customTable = { "custom", "talk", "sys"} , sendParams = { scene = "godwar" , scene_id = "godwar" } }
		} )
		local curScene = display.getRunningScene()
		curScene:addChild( self.talkLayer:getLayer()  )
	else
		self.talkLayer:remove()
	end
	DATA_Info:setIsOpen(  not DATA_Info:getIsOpen( ) )

	--	DATA_Info:addActionBtn( "server" , this.talkBtn )
	--	DATA_Info:addActionBtn( "war" , this.talkBtn )
end
--造物神树
function GodwarLayer:createRank(params, enemy)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
		self.mainLayer:removeChild(self.msgLayer, true)
		self.msgLayer = nil
	end
	self.isEnemyRank = false

	self.layer = display.newLayer()

	local bg = display.newSprite(PATH.."bg.png")
	setAnchPos(bg)
	self.layer:addChild(bg)

	self:createTab(params.kind, enemy)

	self.layer:addChild(InfoLayer:new( "hero" , 0 , {disableChat = true, preCall = function() self.goOut = true end,titleBg = PATH.."top_title_bg.png", title_text = PATH.."rank_title.png", bottom = PATH.."bottom_bg.png",tail_hide = true,  priority = -150, closeOffset = -35 ,hideNavigation = true, closeCallback = function()
			if self.isEnemyRank then
				self:createRank({tab = enemy.t == "user" and 1 or 4})
			else
				HTTP:call("fengshen", "getJFSummary", {}, {
					success_callback = function(data)
						switchScene("godwar", {data =data, inWar = true})
					end})
			end
		end} ):getLayer())
	self.baseLayer:addChild(self.layer, 10)
end


function GodwarLayer:createBasePro(data)
	local hero_data = data

	local layer = display.newLayer()

	-- 姓名
	local name = display.strokeLabel( hero_data["name"] , 35 , 340 , 24 , ccc3(249,239,89) )
	layer:addChild( name )


	-- 经验
	layer:addChild( KNBar:new("exp_general" , 35 , 525 , { maxValue = hero_data["lvup_exp"] , curValue = hero_data["cur_exp"] } ) )

	-- 等级
	local lvNode = display.strokeLabel( "Lv" .. hero_data["lv"] , 353 , 340 , 18 , ccc3(250, 173,65) )
	setAnchPos(lvNode , 230 , 340 , 1 , 0)
	layer:addChild( lvNode )

	-- 属性
	layer:addChild( display.strokeLabel( "攻" .. hero_data.attr["atk"] , 35 , 300 , 14 , ccc3(  162, 226, 48 ) , 2 , ccc3( 162, 226, 48 ) ) )
	layer:addChild( display.strokeLabel( "防" .. hero_data.attr["def"] , 90 , 300 , 14 , ccc3( 162, 226, 48  ) , 2 , ccc3( 162, 226, 48 ) ) )
	layer:addChild( display.strokeLabel( "命" .. hero_data.attr["hp"]  , 145 , 300 , 14 , ccc3( 162, 226, 48  ) , 2 , ccc3( 162, 226, 48 ) ) )
	layer:addChild( display.strokeLabel( "敏" .. hero_data.attr["agi"] , 200 , 300 , 14 , ccc3( 162, 226, 48  ) , 2 , ccc3( 162, 226, 48 ) ) )


	-- 人物大图
	local hero_cid = hero_data["cid"]
	local big_img_btn = KNBtn:new(IMG_PATH .. "image/hero/" , {getImageByType(hero_cid , "b" , true , false , hero_config[hero_cid .. ""].logo_id)} , 149 , 140 , {
		upSelect = true,
		noHide = true,
		anchMid = true,
		parent = self.scroll,
		callback = function()
			local info = hero_config[hero_cid .. ""]
			
			dump(info)
			print(hero_cid)
			info.natural = nil
			info.cid = hero_data.cid
			info.lv = hero_data.lv
			info.atk =hero_data.attr.atk
			info.agi = hero_data.attr.agi
			info.def = hero_data.attr.def
			info.hp = hero_data.attr.hp
			info.stage = hero_data.curStage

			pushScene("detail", {
				detail = "general",
				toChoose = false,
				priority = -150,
				data = info,
				godwar = true,
				noNavigation = true,
				noActive = true
			})
		end
	})
	layer:addChild( big_img_btn:getLayer() ,-1)

	--	-- 武将职业标记
	local	jobFlag = display.newSprite(  COMMONPATH .. "job" .. hero_config[hero_data.cid..""].role .. ".png" )
	setAnchPos(jobFlag , 10 , 213 )
	layer:addChild( jobFlag )


	-- 星级
	local y = 238
	for i = 1 , hero_data["star"] do
		local star_img = display.newSprite( COMMONPATH .. "star.png" )
		setAnchPos(star_img , 280 , y)
		layer:addChild( star_img )

		y = y - 27
	end

	--等阶
	if hero_data["stage"] > 0 then
		local stage = display.newSprite(COMMONPATH.."stage/"..hero_data["stage"]..".png")
		setAnchPos(stage, 280, y - 5)
		layer:addChild(stage)
	end

	-- 天赋
	if hero_data["natural"] and #hero_data["natural"] > 0 then
		layer:addChild( display.strokeLabel( replaceStr("组合") , 59 ,-1 , 18 , ccc3( 0x2c , 0x00 , 0x00 ) ) )
		for key , v in pairs( hero_data["natural"] ) do
			local imgPath = COMMONPATH .. "tianfu_2.png"

			if checkActive("general", {nid = v, id = hero_data["id"], cid = hero_data["cid"]}) then
				imgPath = COMMONPATH .. "tianfu_1.png"
			end

			local star_img = display.newSprite( imgPath )
			setAnchPos(star_img , 105 + (key - 1) * 22 , 0 )
			layer:addChild( star_img )
		end
	end

	layer:setContentSize(CCSizeMake(320,385))

	return layer
end

function GodwarLayer:createScroll(data, index)
	if #data > 0 then
		if self.scroll then
			self.layer:removeChild(self.scroll:getLayer(), true)
		end

		self.scroll = KNScrollView:new(138, 260, 320, 395, 0,true, 1, {
			page_callback = function()
				self:showOneHero(data[self.scroll:getCurIndex()], self.scroll:getCurIndex())
				self.group:chooseByIndex(self.scroll:getCurIndex())
			end
		})
		for i = 1, #data do
			local temp = self:createBasePro(data[i])
			self.scroll:addChild(temp, temp)
		end
		self.scroll:alignCenter()

		if index then
			self.group:chooseByIndex(index)
			self:showOneHero(data[index], index)
			self.scroll:setIndex(index, true)
		else
			self:showOneHero(data[self.scroll:getCurIndex()], self.scroll:getCurIndex())
		end

		self.layer:addChild(self.scroll:getLayer())
	end
end

--[[显示一个英雄]]
function GodwarLayer:showOneHero(hero_data, index)
	-- 先清空
	if self.right then
		self.layer:removeChild(self.right, true)
	end

	self.right = display.newLayer()
	setAnchPos(self.right, 0, -88)


	-- 技能文字
	local tiansheng_bg = display.newSprite(  IMG_PATH .. "image/scene/hero/skill_type_bg.png" )
	self.right:addChild( tiansheng_bg )
	setAnchPos(tiansheng_bg , 135 , 268 )

	local tiansheng = display.newSprite(  IMG_PATH .. "image/scene/hero/tiansheng.png" )
	self.right:addChild( tiansheng )
	setAnchPos(tiansheng , 145 , 285 )

	local xuexi_bg = display.newSprite(  IMG_PATH .. "image/scene/hero/skill_type_bg.png" )
	self.right:addChild( xuexi_bg )
	setAnchPos(xuexi_bg , 255 , 268 )

	local xuexi = display.newSprite(  IMG_PATH .. "image/scene/hero/xuexi.png" )
	self.right:addChild( xuexi )
	setAnchPos(xuexi , 265 , 285 )


	self.right:addChild(createLabel({str = hero_data.maxExp - hero_data.exp, size = 20, color =ccc3(255,255,255), x = 285, y = 130 }))


	local wearEquipCell = requires(IMG_PATH , "GameLuaScript/Scene/hero/wearEquipCell")
	
	-- 天生技能
	local bornSkill = hero_data.skill["0"] or hero_data.skill[1]
	local tempData = {
		cid = bornSkill.cid,
		id = 0,
		lv = bornSkill.lv,
	}
	local equipSeatCell = wearEquipCell:new(
	180 ,
	265 ,
	tempData ,
	function()
		--详情
		local skill_data = getConfig("skill" , hero_data.skill["cid"])
		skill_data["cid"] = bornSkill["cid"]
		skill_data["lv"] = bornSkill["lv"]
		pushScene("detail" , {
			noNavigation = true,
			priority = -150,
			detail = "skill",
			data = skill_data,
			skillSeat = 1,
		})
	end ,
	self.right
	)
	self.right:addChild( equipSeatCell:getLayer() )
	--	--添加升级提示
	--	self:showUpFlag( hero_data.id )


	local equip_opened = false
	local skill_opened = false

	--	local equip_opened = checkOpened("equip")
	--	local skill_opened = checkOpened("skill")
	--
	local function createSkillEquipSeat()
		--装备位
		local equipArr = {
			"weapon",
			"defender",
			"shoe",
			"jewelry"
		}
		local equipNames = {
			"武器",
			"防具",
			"鞋子",
			"饰品",
		}
		for i,v in ipairs(equipArr) do
			local data = hero_data.equip[v] or equipNames[i]
			local equipX = 150 + 76 * (i-1)
			local choseFunc = function()
				HTTP:call("fengshen", "getBagList", {type=v}, {
					success_callback = function(data)
						self:createBag(data, 1,  function() self:go2hero(index) end,
							function(idx) 
								HTTP:call("fengshen", "choseEquip", {equip_id=idx, gid=hero_data["cid"], type=v}, {
									success_callback = function(data) self:go2hero(index) end
								})
							end)
					end
				})
			end			
			local equipSeatCell = wearEquipCell:new(
				equipX ,
				180 ,
				data,
				function()
					--详情
					if type(data) ~= "string" then
						pushScene("detail" , {
							detail = "equip",
							data = data,
							priority = -151,
							godwar = true,
							equips = hero_data.equip,
							noNavigation = true,
							choseFunc=function()
								popScene()
								choseFunc()
							end
						})
					--空
					else
						choseFunc()
					end
				end,
				layer,
				equip_opened,
				false,
				"godwar"
			)
			self.right:addChild( equipSeatCell:getLayer() )
		end

		--技能位
		for i=1,2 do
			local data = hero_data.skill["s" ..i] or "技能"
			local skillX = 226 + 76 * i
			local choseFunc = function()
				HTTP:call("fengshen", "getBagList", {}, {
					success_callback = function(data)
						self:createBag(data, 2,  function() self:go2hero(index) end,
							function(idx) 
								HTTP:call("fengshen", "choseSkill", {skill_id=idx, gid=hero_data["cid"], skill_type="s" ..i}, {
									success_callback = function(data) self:go2hero(index) end
								})
							end)
					end
				})
			end		
			local equipSeatCell = wearEquipCell:new(
				skillX ,
				265 ,
				data,
				function()
					if type(data) ~= "string" then
						pushScene("detail" , {
							detail = "skill",
							data = data,
							priority = -151,
							godwar = true,
							noNavigation = true,
							choseFunc=function()
								popScene()
								choseFunc()
							end
						})
					else
						choseFunc()
					end
				end ,
				self.right,
				skill_opened
			)
			self.right:addChild( equipSeatCell:getLayer() )
		end
	end
	createSkillEquipSeat()

	self.layer:addChild( self.right )
end

function GodwarLayer:createHero(data, index)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
		self.mainLayer:removeChild(self.msgLayer, true)
		self.msgLayer = nil
	end

	self.layer = display.newLayer()
	local bg = display.newSprite(PATH.."bg.png")
	setAnchPos(bg)
	self.layer:addChild(bg)

	local hero_bg = display.newSprite(PATH .. "have_power.png")
	setAnchPos(hero_bg , 30 , 680)
	self.layer:addChild(hero_bg)

	self.layer:addChild(createLabel({str = "每一届重置英雄等级和水晶数量", size = 20, color =ccc3(255,255,255), x = 100, y = 655,width = 400 }))

	hero_bg = display.newSprite(PATH .. "hero_bg.png")
	setAnchPos(hero_bg , 130 , 22)
	self.layer:addChild(hero_bg)

	hero_bg = display.newSprite(PATH .. "list_bg.png")
	setAnchPos(hero_bg , 13 , 22)
	self.layer:addChild(hero_bg)


	hero_bg = display.newSprite(PATH .. "need_power.png")
	setAnchPos(hero_bg , 150 , 40)
	self.layer:addChild(hero_bg)

	self.layer:addChild(createLabel({str = tonumber(data.material), size = 20, color =ccc3(255,255,255), x = 200, y = 682 }))

	local left_tips = display.newSprite(IMG_PATH .. "image/scene/hero/main_queue.png")
	setAnchPos(left_tips , 12 , 465 )
	self.layer:addChild(left_tips)

	local left_tips2 = display.newSprite(IMG_PATH .. "image/scene/hero/sub_queue.png")
	setAnchPos(left_tips2 , 12 , 155 )
	self.layer:addChild(left_tips2)

	self:showHeroList(data.hero)
	self:createScroll(data.hero, index)


	local changeBtn = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 415, 595,{
		anchMid = true,
		front = PATH.."change.png",
		callback = function()
			self:changeFunc(data)
		end

	})
	self.layer:addChild(changeBtn:getLayer())

	--	local upAll = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 350, 670, {
	--		front = PATH.."up_all.png",
	--		callback = function()
	--			HTTP:call("fengshen", "autoUpgradeHero", {}, {
	--				success_callback = function(data)
	--					HTTP:call("fengshen", "getHeroInfo", {}, {
	--						success_callback = function(data)
	--							self:createHero(data, self.scroll:getCurIndex())
	--						end
	--					})
	--				end
	--			})
	--		end
	--	})
	--	self.layer:addChild(upAll:getLayer())


	local infoLayer = InfoLayer:new( "hero" , 0 , { disableChat = true, hideNavigation = true,preCall = function() self.goOut = true end, titleBg = PATH.."top_title_bg.png", title_text = PATH.."hero_title.png", bottom = PATH.."bottom_bg.png",tail_hide = true,  priority = -150, closeOffset = -35 ,closeCallback = function()
			self:backToMain()
		end} )
	self.layer:addChild(infoLayer:getLayer())

	--
	local upHero = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 340,40, {
		front = PATH.."up_hero.png",
		callback = function()
			if  data.hero[self.scroll:getCurIndex()].maxExp - data.hero[self.scroll:getCurIndex()].exp > tonumber(data.material) then
				KNMsg.getInstance():flashShow("能量水晶不足")
				return
			elseif data.hero[self.scroll:getCurIndex()].lv >= table.nums(data.upCfg) then
				KNMsg.getInstance():flashShow("已达最大等级")
				return
			end
			self:buy(data.hero[self.scroll:getCurIndex()], tonumber(data.material), data.upCfg, infoLayer:getBackBtn())
			--
			--			HTTP:call("fengshen", "upgradeHero", {cid = data.hero[self.scroll:getCurIndex()].cid}, {
			--				success_callback = function(up)
			--					HTTP:call("fengshen", "getHeroInfo", {}, {
			--						success_callback = function(data)
			--							self:createHero(data, self.scroll:getCurIndex())
			--							KNMsg.getInstance():flashShow("您的英雄升级到了"..up.lv.."级，神力增加"..up.addAb.."点")
			----							self:buy(data.hero[self.scroll:getCurIndex()], tonumber(data.material))
			--						end
			--					})
			--				end
			--			})
		end
	})
	self.layer:addChild(upHero:getLayer())

	if  KNGuide:getStep() == 10009 then
		KNGuide:show(upHero:getLayer() , {
			callback = function()
			end
		})
		--	elseif KNGuide:getStep() == 10010 then
		--		KNGuide:show(infoLayer:getBackBtn():getLayer() , {
		--		})
	end


	self.baseLayer:addChild(self.layer)
	return infoLayer:getBackBtn()
end



function GodwarLayer:showHeroList(data)
	local layer = display.newLayer()

	local init_x = 44
	local margin_y = 75
	local init_y = 565
	local hero , cid , logo , logo_bg , btn , last_y

	self.group = KNRadioGroup:new()


	local hero_config = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fsheroconfig")

	-- 显示替补上阵武将
	for i = 1 , 8 do
		local _init_y = init_y
		if i > 4 then _init_y = init_y - 12 end

		cid = data[i].cid

		logo_bg = display.newSprite(COMMONPATH .. "small_photo_bg.png")
		setAnchPos(logo_bg , init_x , _init_y - (i - 1) * margin_y )

		btn = KNBtn:new(SCENECOMMON , {"box_bg.png","select1.png"} , init_x + 5 , _init_y - (i - 1) * margin_y + 10 , {
			id = i,
			upSelect = true,
			front = getImageByType(cid , "s" , false , false , hero_config[cid .. ""].logo_id),
			frontScale = {1, -3, -2},
			callback = function()
				self.scroll:setIndex(i)
				self:showOneHero( data[i], i )
			end
		}, self.group)


		layer:addChild(logo_bg)
		layer:addChild(btn:getLayer())
	end

	self.layer:addChild(layer)
end
----英雄校场
--function GodwarLayer:createHero()
--	if self.layer then
--		self.baseLayer:removeChild(self.layer, true)
--	end
--
--	self.layer = display.newLayer()
--
--	local bg = display.newSprite(PATH.."bg.png")
--	setAnchPos(bg)
--	self.layer:addChild(bg)
--
--
--	local kind = {"hero", "equip", "skill", "stone"}
--	local netKind = {"Hero", "Equip", "Skill", "Stone"}
--
--	local group = KNRadioGroup:new()
--	for i = 1, #kind do
--		local temp = KNBtn:new(PATH, {"tab.png","tab_press.png"},51 + (i - 1) * 90, 685,{
--			disableWhenChoose = true,
--			upSelect = true,
--			front = {PATH..kind[i].."_text.png",PATH..kind[i].."_text_press.png"},
--			callback=
--			function()
--				self.cur = nil
--				HTTP:call("fengshen","get"..netKind[i].."Arch", {}, {
--					success_callback = function(data)
--						self:tabDetail(kind[i], data)
--					end
--				})
--			end
--		},group)
--		self.layer:addChild(temp:getLayer())
--
--		if i == 1 then
--			temp:call()
--		end
--	end
--
--	local line = display.newSprite(PATH.."tab_line.png")
--	setAnchPos(line, 0, 675)
--	self.layer:addChild(line)
--
--	self.layer:addChild(InfoLayer:new( "hero" , 0 , { disableChat = true, preCall = function() self.goOut = true end, titleBg = PATH.."top_title_bg.png", title_text = PATH.."hero_title.png", bottom = PATH.."bottom_bg.png",tail_hide = true,  priority = -150, closeOffset = -35 ,closeCallback = function()
--		switchScene("godwar")
--
--	end} ):getLayer())
--	self.baseLayer:addChild(self.layer)
--end

--创建排行列表
function GodwarLayer:createRankLayer(kind, data, enemy)

end

function GodwarLayer:createTab(tabType, enemy)
	if self.tabLayer then
		self.layer:removeChild(self.tabLayer,true)
	end

	self.tabLayer = display.newLayer()
	self.layer:addChild(self.tabLayer)

	local tab = {"task", "rank", "warinfo"}
	local group = KNRadioGroup:new()
	for k, v in pairs(tab) do
		local btn = KNBtn:new(PATH, {"tab_normal.png","tab.png"}, 30 + (k - 1) * 100, 680, {
			front ={PATH..v.."_text_normal.png", PATH..v.."_text.png"},
			callback = function()
				self.isEnemyRank = false
				self:createTab(v)
			end
		}, group)
		self.tabLayer:addChild(btn:getLayer())

		if  tabType == v then
			group:chooseByIndex(k)
		end
	end

	local line = display.newSprite(PATH.."tab_line.png")
	setAnchPos(line, 0, 675)
	self.tabLayer:addChild(line)
	

	if tabType == "task" or tabType == nil then
		HTTP:call("fengshen", "get_task", {}, {
			success_callback = function(data)
				-- dump(data)
				self.rankLayer = KNScrollView:new(0, 0, 480, 680,10)
				self.tabLayer:addChild(self.rankLayer:getLayer())

				for k, v in pairs(data.list) do
					local temp = Item:new("task", v, function()
						self:createTab("task")
					end)
					self.rankLayer:addChild(temp:getLayer())
				end
				self.rankLayer:alignCenter()
			end
		})
	elseif tabType == "warinfo" then
		self:showReport(self.tabLayer)
	elseif tabType == "rank" then
		local tabBg = display.newSprite(PATH.."rank_tab_bg.png")
		setAnchPos(tabBg, 240, 595, 0.5)
		self.tabLayer:addChild(tabBg)

		local kind = enemy and {"tmsj", "td", "tgxy"} or {"user", "power", "group", "gang"}
		local interface = {
			["user"] = "getUserScoreRanking",
			["power"] = "getAbilityRanking",
			["group"] = "getGameScoreRanking",
			["gang"] = "getGangScoreRanking",
			["tmsj"] = enemy and (enemy.t == "gang" and  "getGangScoreRanking" or "getUserScoreRanking"),
			["td"] = enemy and (enemy.t == "gang" and  "getGangScoreRanking" or "getUserScoreRanking"),
			["tgxy"] = enemy and (enemy.t == "gang" and  "getGangScoreRanking" or "getUserScoreRanking"),
		}
		local group = KNRadioGroup:new()
		local count = 0
		for i = 1, #kind do
			if kind[i] ~= SHENZHAN_GROUP then
				local temp = KNBtn:new(COMMONPATH, {"btn_bg_dis.png","btn_bg.png"},51 + count * 90, 615,{
					disableWhenChoose = true,
					upSelect = true,
					front = {PATH..kind[i].."_normal.png",PATH..kind[i].."_pre.png"},
					callback=
					function()
						local pass = {}
						local list
						if kind[i] == "td" or kind[i] == "tmsj" or kind[i] == "tgxy" then
							pass = {game = kind[i], length = 20, start = 1}
						elseif kind[i] == "user" or kind[i] == "gang" then
							pass = {game = SHENZHAN_GROUP, length = 20, start = 1}
						else
							pass = {length = 20, start = 1}
						end
						HTTP:call("fengshen", interface[kind[i]], pass, {
							success_callback = function(data)
							dump(data)
								if kind[i] == "power" or kind[i] == "user" or kind[i] == "gang" then
									if kind[i] == "gang" then
										list = data.list
									else
										list = data.userList
									end
									list[0] = data.self
								elseif kind[i] == "group" then
									list = data.serverList
								else
									if enemy and enemy.t == "gang" then
										list = data.list
									else
										list = data.userList
									end
								end

								local function createList(kind, data, enemy, award)
									if self.listLayer then
										self.tabLayer:removeChild(self.listLayer, true)
									end

									self.listLayer = display.newLayer()
									self.tabLayer:addChild(self.listLayer)

									local desc = {
										["user"] = "个人战贡排行榜显示己方所有个人战贡总榜",
										["gang"] = "帮会战贡排行榜显示己方帮派战贡总榜",
										["group"] = "势力战贡最终决定封神战的输赢",
										["power"] = "最终排行在前1万名的玩家将代表出战封神",
										["td"] =   enemy and (enemy.t == "user" and "敌方战贡排行榜显示敌对势力所有个人战贡总榜" or "敌方帮会战贡排行榜显示敌方帮派战贡总榜") or "",
										["tmsj"] = enemy and (enemy.t == "user" and "敌方战贡排行榜显示敌对势力所有个人战贡总榜" or "敌方帮会战贡排行榜显示敌方帮派战贡总榜") or "",
										["tgxy"] = enemy and (enemy.t == "user" and "敌方战贡排行榜显示敌对势力所有个人战贡总榜" or "敌方帮会战贡排行榜显示敌方帮派战贡总榜") or ""
									}

									self.rankDesc = createLabel({str = "说明："..desc[kind], size = 18, width = 480, color = ccc3(78, 189, 60)})
									setAnchPos(self.rankDesc, 240, 575, 0.5)
									self.listLayer:addChild(self.rankDesc)

									self.curType = kind
									self.rankLayer = KNScrollView:new(0, 65, 480, 500)

									for i = 0, #data do
										if data[i] and table.nums(data[i]) > 0 then
											local temp = Item:new(enemy and enemy.t or kind, self.rankLayer, data[i], i)
											self.rankLayer:addChild(temp:getLayer())
										end

									end
									self.rankLayer:alignCenter()

									if not enemy and kind == "user" or kind == "gang" or kind == "power" then
										if kind == "power" then
											local gift = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 20, 15,{
												front = PATH.."get_award.png",
												callback = function()
													HTTP:call("fengshen", "ability_award", {}, {
														success_callback = function(data)
															KNMsg.getInstance():flashShow(data.award)
														end
													})
												end
											})
											self.listLayer:addChild(gift:getLayer())
											
											local gift_text = createLabel({str = "您昨天的阶位是:"..award.pos_name.."\n可领取奖励:"..award.award,width = 350, size = 18, color = ccc3(255,0,0)})
											setAnchPos(gift_text,130,15)
											self.listLayer:addChild(gift_text)
										else
											local enemyRank = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"},180, 15,{
												front = PATH.."enemy_rank.png",
												callback = function()
													self:createRank({kind = tabType},{t = kind})
													self.isEnemyRank = true
												end
											})
											self.listLayer:addChild(enemyRank:getLayer())
											
											if kind == "user" then
												local gift = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 340, 15,{
													front = PATH.."get_award.png",
													callback = function()
														HTTP:call("fengshen", "userscore_award", {}, {
															success_callback = function(data)
																KNMsg.getInstance():flashShow("您昨天的排名奖励共计：" ..(tonumber(data.rank_award) + tonumber(data.up_award)).."水晶")
															end
														})
													end
												})
												self.listLayer:addChild(gift:getLayer())
											end
										end
									end
									
									

									--	self.pageText = display.strokeLabel(self.page.."/"..math.ceil(DATA_Rank:get(kind,"count") / 20) ,230,117,20,ccc3(0xff,0xfb,0xd4))
									--	setAnchPos(self.pageText, 240, 117, 0.5)
									--	self.layer:addChild(self.pageText)

									self.listLayer:addChild(self.rankLayer:getLayer())
								end
								createList(kind[i], list, enemy, data.gift)
							end
						})
					end
				},group)
				self.tabLayer:addChild(temp:getLayer())
				count = count + 1
			end
		end
		group:chooseByIndex(1, true)
	end
end

function GodwarLayer:rankDetail(kind,data, enemy)
	if self.tempLayer then
		self.layer:removeChild(self.tempLayer, true)
	end
	self.tempLayer = display.newLayer()
	--
	--	 if kind == "self" then
	--		local bg = display.newSprite(PATH.."self_bg.png")
	--		setAnchPos(bg, 240, 300, 0.5)
	--		self.tempLayer:addChild(bg)
	--
	--		bg = display.newSprite(PATH.."self_info1.png")
	--		setAnchPos(bg, 130, 305, 0.5)
	--		self.tempLayer:addChild(bg,1)
	--
	--		bg = display.newSprite(PATH.."coin.png")
	--		setAnchPos(bg, 90, 525)
	--		self.tempLayer:addChild(bg, 1)
	--
	--		bg = display.newSprite(PATH.."self_info3.png")
	--		setAnchPos(bg, 240, 525)
	--		self.tempLayer:addChild(bg, 1)
	--
	--		bg = display.newSprite(PATH.."role_bg.png")
	--		setAnchPos(bg, 80, 560)
	--		self.tempLayer:addChild(bg, 1)
	--
	--		local icon = KNBtn:new(COMMONPATH , {getHeadPath( DATA_Head:get()["default"] )} , 115, 590 , {
	--			front = COMMONPATH.."role_frame.png",
	--			text = {DATA_User:get("name"), 18, ccc3(255,255,255), ccp(0,-45)},
	--			scale = true ,
	--			callback = function()
	--			end
	--		}):getLayer()
	--		self.tempLayer:addChild(icon,1)
	--
	--		--info
	--		local info = createLabel({str = data.abilityRank == 0 and "未上榜" or data.abilityRank, size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info,360, 645 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.gameScoreRank== 0 and "未上榜" or data.gameScoreRank, size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info,360, 610 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.userScoreRank== 0 and "未上榜" or data.userScoreRank, size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info,360, 570 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.gangScoreRank== 0 and "未上榜" or data.gangScoreRank, size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info, 360, 532 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.ability, size = 20, color = ccc3(255,255,255)})
	--		setAnchPos(info,190, 465 )
	--		self.tempLayer:addChild(info)
	--
	--
	--		info = createLabel({str = data.stoneArchLv, size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info,200, 415 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.skillArchLv, size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info,200,385 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.heroLv, size = 20, color = ccc3(255,255,255)})
	--		setAnchPos(info,190, 425 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.petLv, size = 20, color = ccc3(255,255,255)})
	--		setAnchPos(info,190, 385 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.kuli.free_pos..(data.kuli.can_gather == 1 and "(可收获)" or "" ), size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info,190, 350 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = tonumber(data.material), size = 18, color = ccc3(255,255,255)})
	--		setAnchPos(info,190, 315 )
	--		self.tempLayer:addChild(info)
	--
	--		info = createLabel({str = data.coin, size = 20, color = ccc3(255,255,255)})
	--		setAnchPos(info,151, 528 )
	--		self.tempLayer:addChild(info)
	--		local items = {"hero", "pet", "people", "stone"}
	--		for k, v in pairs(items) do
	--			local btn = KNBtn:new(PATH, v == "people" and {"catch.png", "catch_pre.png"} or {"up.png", "up_pre.png"}, 300, 465 - k * 40, {
	--				priority = -200,
	--				callback = function()
	--					self.tip:remove()
	--					self.funcBtns[v]:call()
	--				end
	--			})
	--			self.tempLayer:addChild(btn:getLayer())
	--		end
	--
	--		self.tip = showTip({
	--			title_bg = PATH.."change_title_bg.png",
	--			title_text = PATH.."self_info.png",
	--			titleOffsetY = 15,
	--			titleTextY = 11,
	--			bg = PATH.."change_bg.png",
	--			content = self.tempLayer,
	--			contentOffsetY = -80,
	--			center = {
	--				remove = true,
	--				callback = function()
	--					self.tempLayer = nil
	--				end
	--			}
	--		})
	--	else
	--		self:createRankLayer(kind, data, enemy)
	--		self.tabLayer:addChild(self.tempLayer)
	--	end
end

function GodwarLayer:tabDetail(kind, data, showUp)
	if self.tempLayer then
		self.layer:removeChild(self.tempLayer, true)
	end
	self.tempLayer = display.newLayer()

	local infoBg = display.newSprite(PATH.."info_"..(kind == "stone" and "big" or "small")..".png")
	setAnchPos(infoBg, 240, 90, 0.5)
	self.tempLayer:addChild(infoBg)

	infoBg = display.newSprite(PATH.."pro_bg.png")
	setAnchPos(infoBg, 240, kind == "stone" and 390 or 320,  0.5)
	self.tempLayer:addChild(infoBg)

	infoBg = display.newSprite(PATH..kind.."_pro.png")
	setAnchPos(infoBg, 40, kind == "stone" and 390 or 320)
	self.tempLayer:addChild(infoBg)

	infoBg = display.newSprite(PATH..(kind == "stone" and "stone_info_bg.png" or "info_bg.png"))
	setAnchPos(infoBg, 240,(kind == "hero" and 250 or (kind == "stone" and 215 or 225)), 0.5)
	self.tempLayer:addChild(infoBg)

	if kind ~= "hero" then
		local next = display.newSprite(COMMONPATH.."next.png")
		setAnchPos(next, 450, kind == "stone" and 550 or 500)
		self.tempLayer:addChild(next,1)

		next = display.newSprite(COMMONPATH.."next.png")
		next:setFlipX(true)
		setAnchPos(next, 10, kind == "stone" and 550 or 500)
		self.tempLayer:addChild(next,1)

		infoBg = display.newSprite(PATH.."cur_pro.png")
		setAnchPos(infoBg,100,kind == "stone" and 360 or 290)
		self.tempLayer:addChild(infoBg)

		infoBg = display.newSprite(PATH.."up_pro.png")
		setAnchPos(infoBg, 300,kind == "stone" and 360 or 290)
		self.tempLayer:addChild(infoBg)
	else
		infoBg = display.newSprite(PATH.."up_exp.png")
		setAnchPos(infoBg, 220, 220, 0.5)
		self.tempLayer:addChild(infoBg)

		infoBg = display.newSprite(PATH.."auto_text.png")
		setAnchPos(infoBg, 150, 180, 0.5)
		self.tempLayer:addChild(infoBg)

		local autoCheck = CheckBox:new(75,180,{path=COMMONPATH,checkBoxOpt = function()
				HTTP:call("fengshen", "checkHeroAuto", {}, {
					success_callback = function()
						HTTP:call("fengshen", "getHeroArch", {}, {
							success_callback = function(data)
								self:tabDetail("hero", data)
								if data.auto == 1  then
									showTip({

										content = createLabel({str = "勾选自动分配后，将按照先主队后副队的方式平均分配现有经验点。\n\n下次升级时，将自动按照上述方式平均分配升级获得的经验点。", size = 20,width = 350, color = ccc3(0x2c,0,0)}),
										center = {
											remove = true,
										}
									})
								end
							end
						})
					end
				})
			end,
			file={"check_false.png","check_true.png"}
		})
		self.tempLayer:addChild(autoCheck:getLayer())

		if data.auto == 1 then
			autoCheck:check(true)
		end

	end




	--生成属性信息
	local propertyLayer
	local function createProperty(curKind)
		if propertyLayer then
			self.tempLayer:addChild(propertyLayer)
		end
		propertyLayer = display.newLayer()
		local text

		if curKind == "equip" then
		elseif curKind == "skill" then
		elseif curKind == "stone" then
		else
		end

		self.tempLayer:addChild(propertyLayer)
	end

	local scroll = KNScrollView:new(10,400,460,400, 10, true, 1,{
	})
	self.tempLayer:addChild(scroll:getLayer())

	local addBtn
	local createFun = {
		["hero"] = function()
			local items = {}
			for i = 1, #data.hero do
				items[i] = HomeCard:new(535 , i , data.hero[i].cid)
				items[i]:addTo(i,self.tempLayer)
			end

			local front
			if self.cur then
				for k, v in pairs(data.hero) do
					if v.cid == self.cur then
						front =  k
						break
					end
				end
				print("index pos", front)
				if front >= 3 then
					front = 8 - (front - 3)
				else
					front = 3 - front
				end
			else
				self.cur = data.hero[1].cid
				front = 2
			end
			--默认将武将显示在最前方
			for k, v in pairs(items) do
				v:setState(front ,self)
			end


			addBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 320, 140,{
				anchMid = true,
				front = PATH.."add_text.png",
				callback = function()
					self:upBuilding(data, "hero")
				end

			})
			self.tempLayer:addChild(addBtn:getLayer())

			local time = createLabel({str = timeConvert(data.cd), color = ccc3(255,255,255), width = 200, size = 18})
			setAnchPos(time,320, 100, 0.5)
			self.tempLayer:addChild(time)

			Clock:addTimeFun("godwar_addTime", function()
				if data.cd > 0 then
					data.cd = data.cd - 1
					time:setString(timeConvert(data.cd))
				end
			end)


			local bg = {"long_btn.png", "long_btn_pre.png"}
			if data.auto == 1 then
				bg = {"long_btn_grey.png"}
			end
			local upBtn = KNBtn:new(COMMONPATH, bg, 320, 190,{
				anchMid = true,
				front = data.auto == 1 and PATH.."up_text_grey.png" or PATH.."up_text.png",
				callback = function()
					if data.auto == 1 then
						KNMsg.getInstance():flashShow("当前自动分配升级点数")
						return
					end
					showTip({
						content = createLabel({str = "您确定要消耗经验点数为当前英雄升级吗？", size = 20, width = 300}),
						left = {
							remove = true,
							callback = function()
								HTTP:call("fengshen", "upgradeHero", {cid = self.cur}, {
									success_callback = function(data)
										HTTP:call("fengshen", "getHeroArch", {}, {
											success_callback = function(newdata)
												self:tabDetail("hero", newdata, nil)
											end
										})
									end
								})
							end
						},
						right = {
							remove = true,
						}
					})
				end
			})
			self.tempLayer:addChild(upBtn:getLayer())

			local changeBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 140, 140,{
				anchMid = true,
				front = PATH.."change.png",
				callback = function()
					local cids = {}
					for k, v in pairs(data.hero) do
						table.insert(cids, v)
					end
					local temp = display.newLayer()
					self:changeLayer(cids, temp)

					local help = KNBtn:new(IMG_PATH.."image/scene/multiFb/", {"help.png", "help_press.png"}, 410,600,{
						priority = - 151,
						callback = function()
							local tipLayer = display.newLayer()
							local tipBg = display.newSprite(PATH.."job_tip.png")
							setAnchPos(tipBg, 240, 425, 0.5,0.5)
							tipLayer:addChild(tipBg)

							local job = display.newSprite(PATH.."job1.png")
							setAnchPos(job, 245, 520, 0.5)
							tipLayer:addChild(job)

							job = display.newSprite(PATH.."job2.png")
							setAnchPos(job, 330, 350, 0.5)
							tipLayer:addChild(job)

							job = display.newSprite(PATH.."job3.png")
							setAnchPos(job, 150, 350, 0.5)
							tipLayer:addChild(job)

							showTip({
								priority = -200,
								bg = PATH.."change_bg.png",
								content = tipLayer,
								center = {
									remove = true
								}
							})
						end
					})

					temp:addChild(help:getLayer())

					local change_layout
					change_layout = showTip({
						bg = PATH.."change_bg.png",
						title_bg = PATH.."change_title_bg.png",
						title_text = PATH.."change_title.png",
						titleOffsetY = 15,
						priority = -150,
						content = temp,
						close = {
							normal = "back_img.png",
							pre = "back_img_press.png",
							remove = true,
							callback = function()
								self.tempChoose = nil
							end
						},
						center = {
							callback = function()
								self.tempChoose = nil
								local passCid = {}
								for k, v in pairs(cids) do
									table.insert(passCid, v.cid)
								end
								HTTP:call("fengshen", "posHero", {cids = string.join(passCid, "|")}, {
									success_callback = function()
										HTTP:call("fengshen", "getHeroArch", {}, {
											success_callback = function(data)
												change_layout:remove()
												self:tabDetail(kind, data)
											end
										})
									end
								} )
							end
						}
					})
				end

			})
			self.tempLayer:addChild(changeBtn:getLayer())

			local text = display.newSprite(PATH.."level.png")
			setAnchPos(text, 70, 285)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."level.png")
			setAnchPos(text, 280, 285)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."stage.png")
			setAnchPos(text, 70, 255)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."stage.png")
			setAnchPos(text, 280, 255)
			self.tempLayer:addChild(text)

			local touchX, legal,lastX,time,speed, allow, move
			local touchEvent
			allow = true
			self.tempLayer:setTouchEnabled(true)
			self.tempLayer:registerScriptTouchHandler(function(type,x,y)
				--不在范围内直接跳过
				if not CCRectMake(10,400,480,280):containsPoint(ccp(x,y)) then
					return false
				end
				if type == CCTOUCHBEGAN then
					touchX = x
					lastX = x
					legal = true
					time = os.clock()
					touchEvent = true
				elseif type == CCTOUCHMOVED then
					local dir = x < lastX
					if math.abs(touchX - x) > 10 then
						touchEvent = false
						touchX = x
						speed = os.clock() - time
						time = os.clock()
						if allow then
							move = true
							allow = false
						end
						legal = false
					end

					if move then
						move = false
						for i = 1, #items do
							items[i]:move(dir,self,speed, function()
								allow = true
								local info
								for k, v in pairs(data.hero) do
									if v.cid == self.cur then
										info = v
										break
									end
								end
								self:createInfo("hero", info, data.curPoint)
							end)
						end
					end
					lastX = x
				else
					touchX = 0
					lastX = 0
					legal = false
					if touchEvent then
						local pos
						for k, v in pairs(data.hero) do
							if v.cid == self.cur then
								pos =  k
								break
							end
						end

						local info = getConfig("general", self.cur)
						info.cid = self.cur
						info.lv = data.hero[pos].curLv
						info.atk = data.hero[pos].atk
						info.agi = data.hero[pos].agi
						info.def = data.hero[pos].def
						info.hp = data.hero[pos].hp
						info.stage = data.hero[pos].curStage

						pushScene("detail", {
							detail = "general",
							toChoose = false,
							data = info,
							noActive = true
						})
					end
				end
				return true
			end,false,0,false)

			local default = 1
			if self.cur then
				for k, v in pairs(data.hero) do
					if v.cid == self.cur then
						default = k
						break
					end
				end
			end
			self:createInfo("hero", data.hero[default], data.curPoint)
		end,
		["equip"] = function()
			local group = {}
			for i = 1, 8 do
				local temp = display.newLayer()
				temp:setContentSize(CCSizeMake(460, 400))

				local card = self:createCard(data.hero[i])
				setAnchPos(card, 220, 0, 0.5)
				temp:addChild(card)

				local equip_type = {
					{40, 150},
					{40, 30},
					{340,150},
					{340, 30},
				}
				group[i] = KNRadioGroup:new()
				for k, v in pairs(equip_type) do
					local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png", "select1.png"}, v[1], v[2], {
						noHide = true,
						selectZOrder = 20,
						front = getImageByType(data.hero[i].equip[k].cid, "s"),
						text = {getConfig("equip", data.hero[i].equip[k].cid, "name"), 16, ccc3(255,255,255), ccp(0, -50) },
						callback = function()
							self:createInfo("equip", data.hero[i].equip[k])
						end
					},group[i])
					temp:addChild(btn:getLayer())
				end

				scroll:addChild(temp)
			end
			scroll:alignCenter()

			addBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 240, 160,{
				anchMid = true,
				front = PATH.."add_text.png",
				callback = function()
					self:upBuilding(data, "equip")
				end
			})
			self.tempLayer:addChild(addBtn:getLayer())

			local time = createLabel({str = timeConvert(data.cd), color = ccc3(255,255,255), width = 200, size = 18})
			setAnchPos(time,240, 120, 0.5)
			self.tempLayer:addChild(time)

			Clock:addTimeFun("godwar_addTime", function()
				if data.cd > 0 then
					data.cd = data.cd - 1
					time:setString(timeConvert(data.cd))
				end
			end)

			local text = display.newSprite(PATH.."strength.png")
			setAnchPos(text, 70, 260)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."strength.png")
			setAnchPos(text, 280, 260)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."adv_strength.png")
			setAnchPos(text, 70, 230)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."adv_strength.png")
			setAnchPos(text, 280, 230)
			self.tempLayer:addChild(text)


			self:createInfo("equip", data.hero[1].equip[1])

			scroll:setCallback("page_callback", function()
				group[scroll:getCurIndex()]:chooseByIndex(1)
				self:createInfo("equip", data.hero[scroll:getCurIndex()].equip[1])
			end)
		end,
		["stone"] = function()
			for i = 1, 8 do
				local temp = display.newLayer()
				temp:setContentSize(CCSizeMake(460, 400))

				local pos = {
					{70,160},
					{190,230},
					{310,190},
					{210,110},
					{370,100},
				}

				local group = KNRadioGroup:new()
				for k, v in pairs(pos) do
					if k < #pos then
						local line = display.newSprite(PATH.."stone_line_bg.png")
						setAnchPos(line,v[1],v[2], 0, 0.5)
						temp:addChild(line)

						local dis = math.sqrt(math.pow(pos[k][1] - pos[k + 1][1],2) + math.pow(pos[k][2] - pos[k + 1][2],2))
						local rotate = math.deg(math.acos((pos[k+1][1] - pos[k][1]) / dis))
						if pos[k + 1][2] > pos[k][2] then
							rotate = rotate - 60
						end
						line:setRotation(rotate)
					end

					--					local btn = KNBtn:new(IMG_PATH.."image/scene/Pulse/", bg, v[1], v[2], {
					local btn = KNBtn:new(PATH, {"stone_bg.png", "stone_bg_pre.png"}, v[1], v[2], {
						front = IMG_PATH.."image/scene/Pulse/grua.png",
						anchMid = true,
						other = data.hero[i].stone[k] and {IMG_PATH.."image/scene/Pulse/"..(data.hero[i].stone[k].cid) .. (".png"), 10, 10} or nil,
						callback = function()
							self:createInfo("stone", data.hero[scroll:getCurIndex()].stone, nil,k)
						end
					}, group)
					temp:addChild(btn:getLayer())
				end
				scroll:addChild(temp)
			end
			scroll:alignCenter()

			addBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 240, 160,{
				anchMid = true,
				front = PATH.."add_text.png",
				callback = function()
					self:upBuilding(data, "stone")
				end
			})
			self.tempLayer:addChild(addBtn:getLayer())

			local time = createLabel({str = timeConvert(data.cd), color = ccc3(255,255,255), width = 200, size = 18})
			setAnchPos(time,240, 120, 0.5)
			self.tempLayer:addChild(time)

			Clock:addTimeFun("godwar_addTime", function()
				if data.cd > 0 then
					data.cd = data.cd - 1
					time:setString(timeConvert(data.cd))
				end
			end)

			self:createInfo("stone", data.hero[1].stone, nil, 1)

			scroll:setCallback("page_callback", function()
				self:createInfo("stone", data.hero[scroll:getCurIndex()].stone, nil,1)
			end)
		end,
		["skill"] = function()
			local group = {}
			for i = 1, 8 do
				local temp = display.newLayer()
				temp:setContentSize(CCSizeMake(460, 400))

				local card = self:createCard(data.hero[i])
				setAnchPos(card, 220, 0, 0.5)
				temp:addChild(card)

				local text = display.newSprite(PATH.."natural_skill.png")
				setAnchPos(text, 30, 230)
				temp:addChild(text)

				text = display.newSprite(PATH.."learn_skill.png")
				setAnchPos(text, 330, 230)
				temp:addChild(text)

				local skill_type = {
					{40, 150},
					{340,150},
					{340, 30},
				}

				group[i] = KNRadioGroup:new()
				for k, v in pairs(skill_type) do
					local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png", "select1.png"}, v[1], v[2], {
						noHide = true,
						upSelect = true,
						selectZOrder = 20,
						front = data.hero[i].skill[k] and getImageByType(data.hero[i].skill[k].cid, "s") or nil,
						text = data.hero[i].skill[k] and {getConfig("skill", data.hero[i].skill[k].cid, "name"), 16, ccc3(255,255,255), ccp(0, -50) } or nil,
						callback = function()
							self:createInfo("skill", data.hero[i].skill[k])
						end
					},group[i])
					temp:addChild(btn:getLayer())
				end

				scroll:addChild(temp)
			end
			scroll:alignCenter()

			addBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 240, 160,{
				anchMid = true,
				front = PATH.."add_text.png",
				callback = function()
					self:upBuilding(data, "skill")
				end
			})
			self.tempLayer:addChild(addBtn:getLayer())

			local time = createLabel({str = timeConvert(data.cd), color = ccc3(255,255,255), width = 200, size = 18})
			setAnchPos(time,240, 120, 0.5)
			self.tempLayer:addChild(time)

			Clock:addTimeFun("godwar_addTime", function()
				if data.cd > 0 then
					data.cd = data.cd - 1
					time:setString(timeConvert(data.cd))
				end
			end)

			local text = display.newSprite(PATH.."level.png")
			setAnchPos(text, 70, 260)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."level.png")
			setAnchPos(text, 280, 260)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."star.png")
			setAnchPos(text, 70, 230)
			self.tempLayer:addChild(text)

			text = display.newSprite(PATH.."star.png")
			setAnchPos(text, 280, 230)
			self.tempLayer:addChild(text)

			self:createInfo("skill", data.hero[1].skill[1])

			scroll:setCallback("page_callback", function()
				group[scroll:getCurIndex()]:chooseByIndex(1)
				self:createInfo("skill", data.hero[scroll:getCurIndex()].skill[1])
			end)
		end
	}
	createFun[kind]()
	if showUp then
		addBtn:call()
	else
		if self.mask then
			self.mask:remove()
			self.mask = nil
		end
	end
	self.layer:addChild(self.tempLayer)
end

function GodwarLayer:createInfo(kind, data, other, cur)
	if self.proLayer then
		self.layer:removeChild(self.proLayer, true)
	end
	self.proLayer = display.newLayer()

	local max = data.nextLv == 0 and true or false

	if kind == "hero" then
		local lv = createLabel({str = data.curLv, color = ccc3(255, 255, 255)})
		setAnchPos(lv, 130, 285)
		self.proLayer:addChild(lv)

		lv = createLabel({str = max and "max" or data.nextLv, color = ccc3(255, 255, 255)})
		setAnchPos(lv, 330, 285)
		self.proLayer:addChild(lv)

		local stage = createLabel({str = data.curStage, color = ccc3(255, 255, 255)})
		setAnchPos(stage, 130, 255)
		self.proLayer:addChild(stage)

		stage = createLabel({str = max and "max" or data.nextStage, color = ccc3(255, 255, 255)})
		setAnchPos(stage, 330, 255)
		self.proLayer:addChild(stage)

		local upPt = createLabel({str = data.needPoint, color = ccc3(255, 255, 255)})
		setAnchPos(upPt, 210, 223)
		self.proLayer:addChild(upPt)

		upPt = createLabel({str = other, color = ccc3(255, 255, 255)})
		setAnchPos(upPt, 390, 223)
		self.proLayer:addChild(upPt)
	elseif kind == "equip" then
		local strength = createLabel({str = data.curLv, color = ccc3(255, 255, 255)})
		setAnchPos(strength, 130, 260)
		self.proLayer:addChild(strength)

		strength = createLabel({str = max and "max" or data.nextLv, color = ccc3(255, 255, 255)})
		setAnchPos(strength, 330, 260)
		self.proLayer:addChild(strength)

		local adv_strength = createLabel({str = data.curCLv, color = ccc3(255, 255, 255)})
		setAnchPos(adv_strength, 130, 230)
		self.proLayer:addChild(adv_strength)

		adv_strength = createLabel({str = max and "max" or data.nextCLv, color = ccc3(255, 255, 255)})
		setAnchPos(adv_strength, 330, 230)
		self.proLayer:addChild(adv_strength)

		local proStr = data.name
		for k, v in pairs(data.curAttr) do
			proStr = proStr .. ":  " .. Property[k] .. ": +" .. v .. "  "
		end

		local pro = createLabel({str = proStr, color = ccc3(91,176,64), width = 400})
		setAnchPos(pro, 240, 190, 0.5)
		self.proLayer:addChild(pro)

	elseif kind == "skill" then
		local skill_lv = createLabel({str = data.curLv, color = ccc3(255, 255, 255)})
		setAnchPos(skill_lv, 130, 260)
		self.proLayer:addChild(skill_lv)

		skill_lv = createLabel({str = max and "max" or data.nextLv, color = ccc3(255, 255, 255)})
		setAnchPos(skill_lv, 330, 260)
		self.proLayer:addChild(skill_lv)

		local star = createLabel({str = data.star, color = ccc3(255, 255, 255)})
		setAnchPos(star, 130, 230)
		self.proLayer:addChild(star)

		star = createLabel({str = data.star, color = ccc3(255, 255, 255)})
		setAnchPos(star, 330, 230)
		self.proLayer:addChild(star)

		local proStr = data.name
		proStr = proStr .. ":拥有" .. data.curAttr.success .. "%的概率攻击对方"..data.curAttr.target.."个英雄，并且造成"..data.curAttr.effect.."%的攻击伤害"

		local pro = createLabel({str = proStr, color = ccc3(91,176,64), width = 420, size = 18})
		setAnchPos(pro, 240, 180, 0.5)
		self.proLayer:addChild(pro)

	elseif kind == "stone" then
		local y = 331
		for n, info in pairs(data) do
			for k, v in pairs(info.curAttr) do
				local temp = display.newSprite(PATH..k..".png")
				setAnchPos(temp, 100, y)
				self.proLayer:addChild(temp)

				self.proLayer:addChild(createLabel({str = v, x = 150, y = y, color = ccc3(255,255,255)}))
			end

			for k, v in pairs(info.nextAttr) do
				local temp = display.newSprite(PATH..k..".png")
				setAnchPos(temp, 290, y)
				self.proLayer:addChild(temp)

				self.proLayer:addChild(createLabel({str = v, x = 340, y = y,color = ccc3(255,255,255)}))
			end

			y = y - 28
		end

		if cur and data[cur] then
			local pro
			for k, v in pairs(data[cur].curAttr) do
				pro = Property[k].." +"..v
			end

			local str = getConfig("prop", data[cur].cid,"name")..": Lv "..data[cur].curLv.." "..pro
			local curStone = createLabel({str = str , color = ccc3(0, 255,0), size = 20, width = 400})
			setAnchPos(curStone, 240, 190, 0.5)
			self.proLayer:addChild(curStone)
		end

	elseif kind == "pet" then
		local lv = createLabel({str = data.curLv, color = ccc3(255, 255, 255)})
		setAnchPos(lv, 170, 230)
		self.proLayer:addChild(lv)

		lv = createLabel({str = max and "max" or data.nextLv, color = ccc3(255, 255, 255)})
		setAnchPos(lv, 370, 230)
		self.proLayer:addChild(lv)

		local stage = createLabel({str = data.curStage, color = ccc3(255, 255, 255)})
		setAnchPos(stage, 170, 200)
		self.proLayer:addChild(stage)

		stage = createLabel({str = max and "max" or data.nextStage, color = ccc3(255, 255, 255)})
		setAnchPos(stage, 370, 200)
		self.proLayer:addChild(stage)

		local atk = createLabel({str = data.curAtk, color = ccc3(255, 255, 255)})
		setAnchPos(atk, 170, 173)
		self.proLayer:addChild(atk)

		atk = createLabel({str = max and "max" or data.nextAtk, color = ccc3(255, 255, 255)})
		setAnchPos(atk, 370, 173)
		self.proLayer:addChild(atk)

		local skill_lv = createLabel({str = data.curSkillLv, color = ccc3(255, 255, 255)})
		setAnchPos(skill_lv, 170, 145)
		self.proLayer:addChild(skill_lv)

		skill_lv = createLabel({str = max and "max" or data.nextSkillLv, color = ccc3(255, 255, 255)})
		setAnchPos(skill_lv, 370, 145)
		self.proLayer:addChild(skill_lv)

	end
	self.layer:addChild(self.proLayer, 2)
end

function GodwarLayer:createPet(data, showUp)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
		self.mainLayer:removeChild(self.msgLayer, true)
		self.msgLayer = nil
	end
	self.layer = display.newLayer()
	local bg = display.newSprite(PATH.."bg.png")
	setAnchPos(bg)
	self.layer:addChild(bg)

	bg = display.newSprite(IMG_PATH.."image/scene/uplevel/card_bg.png")
	setAnchPos(bg, 0, 500)
	self.layer:addChild(bg)


	local petConfig = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fsnewpet")
	local petIcon = display.newSprite(getImageByType(data.pet.cid, "b"))
	setAnchPos(petIcon, 100, 610, 0.5, 0.5)
	petIcon:setScale(0.60)
	self.layer:addChild(petIcon)

	local name = createLabel({str = data.pet.name, x = 90, y = 690, width = 300})
	setAnchPos(name, 100, 690, 0.5)
	self.layer:addChild(name)
	
	local desc = createLabel({str = petConfig[data.pet.cid..""]["desc"], x = 10, y = 400, width = 450, color = ccc3(255, 255,255)})
	setAnchPos(desc, 240, 440, 0.5, 1)
	self.layer:addChild(desc)

	for i = 1,data.pet.star do
		local icon = display.newSprite(COMMONPATH .. "star.png")
		setAnchPos(icon, 110 - (icon:getContentSize().width * data.pet.star) / 2 + (i - 1) * icon:getContentSize().width,520)
		self.layer:addChild(icon)
	end

	local x, y = 200, 640
	for i = 1, 6 do
		local skill_cid = data.pet.skill[(i < 4 and "a" or "p")..(i < 4 and i or i - 3)]
		local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"},x, y, {
			noHide = true,
			scale = true,
			selectZOrder = 20,
			front = skill_cid and getImageByType(skill_cid,"s") or nil,
			text = skill_cid and {getConfig("petskill", skill_cid, "name"), 16, ccc3(255,255,255), ccp(0, -45)} or nil,
			callback = function()
				if skill_cid then
					local skill_data = getConfig("petskill", skill_cid)
					skill_data.lv = data.pet.curSkillLv
					skill_data.cid = skill_cid
					pushScene("detail", {
						detail = "petskill",
						data = skill_data,
					})
				end
			end
		})
		self.layer:addChild(btn:getLayer())

		x = x + 100
		if i % 3 == 0 then
			x = 200
			y = y - 120
		end
	end

	bg = display.newSprite(PATH.."pro_bg.png")
	setAnchPos(bg, 20, 450)
	self.layer:addChild(bg)

	bg = display.newSprite(IMG_PATH.."image/scene/detail/pet_info.png")
	setAnchPos(bg, 30, 455)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."info_small.png")
	setAnchPos(bg, 240, 80, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pro_bg.png")
	setAnchPos(bg, 240, 290, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pet_pro.png")
	setAnchPos(bg, 40, 295)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pet_info_bg.png")
	setAnchPos(bg, 240,140, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."cur_pro.png")
	setAnchPos(bg,80,258)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."up_pro.png")
	setAnchPos(bg, 280,258)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pet_level.png")
	setAnchPos(bg, 80,228)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pet_level.png")
	setAnchPos(bg, 280,228)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pet_stage.png")
	setAnchPos(bg, 80,202)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pet_stage.png")
	setAnchPos(bg, 280,202)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."ab_atk.png")
	setAnchPos(bg, 80,176)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."ab_atk.png")
	setAnchPos(bg, 280,176)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."skill_level.png")
	setAnchPos(bg, 80,148)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."skill_level.png")
	setAnchPos(bg, 280,148)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."a_skill.png")
	setAnchPos(bg, 200,710)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."p_skill.png")
	setAnchPos(bg, 200,590)
	self.layer:addChild(bg)

	self:createInfo("pet", data.pet)

	local refreshBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 80, 30,{
		front = PATH.."refresh_pet.png",
		callback = function()
			HTTP:call("fengshen", "refreshPet", {}, {
				success_callback = function(recdata)
					dump(recdata)
					HTTP:call("fengshen", "getPetInfo", {}, {
						success_callback = function(data)

							self:createPet(data)
						end})
				end
			})
--			self:upBuilding(data, "pet")
		end
	})
	self.layer:addChild(refreshBtn:getLayer())

	bg = display.newSprite(PATH.."cost_power.png")
	setAnchPos(bg, 50,0)
	self.layer:addChild(bg)

	self.layer:addChild(createLabel({str = data.crystal or "0", size = 20, color =ccc3(255,255,255), x = 145, y = 5}))

	local upBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 300, 30,{
		front = PATH.."up_pet.png",
		callback = function()
			HTTP:call("fengshen", "upgradePet", {}, {
				success_callback = function()
					HTTP:call("fengshen", "getPetInfo", {}, {
						success_callback = function(data)
							self:createPet(data)
							KNMsg.getInstance():flashShow("幻兽等级提升")
						end})
				end
			})
		end
	})
	self.layer:addChild(upBtn:getLayer())



	bg = display.newSprite(PATH.."rest_power.png")
	setAnchPos(bg, 200,2+90, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."cost_power.png")
	setAnchPos(bg, 315,0, 0.5)
	self.layer:addChild(bg)

	self.layer:addChild(createLabel({str = data.pet.maxExp - data.pet.exp , size = 20, color =ccc3(255,255,255), x = 380, y =5}))--升级消耗
	self.layer:addChild(createLabel({str = data.material , size = 20, color =ccc3(255,255,255), x = 170+90, y =5+93}))--剩余水晶
	

	
	
	--
	--	local time = createLabel({str = timeConvert(data.cd), color = ccc3(255,255,255), width = 200, size = 18})
	--	setAnchPos(time,240, 120, 0.5)
	--	self.layer:addChild(time)
	--
	--	Clock:addTimeFun("godwar_addTime", function()
	--		if data.cd > 0 then
	--			data.cd = data.cd - 1
	--			time:setString(timeConvert(data.cd))
	--		end
	--	end)
	--
	local info = InfoLayer:new( "pet" , 0 , {disableChat = true, hideNavigation = true, preCall = function() self.goOut = true end, titleBg = PATH.."top_title_bg.png", title_text = PATH.."pet_title.png", bottom = PATH.."bottom_bg.png",tail_hide = true,  priority = -150, closeOffset = -35 ,closeCallback = function()
			self:backToMain()
		end} )

	self.layer:addChild(info:getLayer())
	self.baseLayer:addChild(self.layer)

	if  KNGuide:getStep() == 10015 then
		KNGuide:show(upBtn:getLayer() , {
			callback = function()
				KNGuide:show(info:getBackBtn():getLayer(), {})
			end
		})
	end



	if showUp then
	--		addBtn:call()
	else
		if self.mask then
			self.mask:remove()
			self.mask = nil
		end
	end
end

function GodwarLayer:getLayer()
	return self.mainLayer
end

function GodwarLayer:createMain(p)
	local bg = display.newSprite(PATH.."top.png")
	setAnchPos(bg, 0, 854, 0, 1)
	self.msgLayer:addChild(bg)

	local message 
	message = KNBtn:new(PATH, {"laba_normal.png", "laba_pre.png"}, 30, 815,  {
		anchMid = true,
		callback = function()
			--			self:talk(p.data)
			HTTP:call("fengshen", "get_msg", {}, {
				success_callback = function(data)
					DATA_Info:set_type("godwar",{})
					DATA_Info:set_type("godwar_talk",{})
					DATA_Info:set_type("godwar_sys",{})
					local name = {
						['td'] = "绝世天府",
						['tmsj'] = "唐门世界",
						['tgxy'] = "太古仙域"
					}
					local msg
					for pk,pv in pairs(data) do
						for k, v in pairs(pv) do
							if pk == "chat" then
								msg  = {
									msg = {name[v["game"]],v.msg},
									template = "【#s#】#s#"
								}
								DATA_Info:insert("godwar_talk" , msg)
							elseif pk == "talk" then
							dump(v)
								msg  = {
									msg = {name[v["game"]],"["..v["user_name"].."]:"..v["msg"]},
									template = "【#s#】#s#"
								}
								DATA_Info:insert("godwar" , msg)
							elseif pk == "sys" then
								msg  = {
									msg = {name[v["game"]],v.msg},
									template = "【#s#】#s#"
								}
								DATA_Info:insert("godwar_sys" , msg)
							end
						end
					end
					message:getLayer():stopAllActions()		
					self:chat(p.data)
				end
			})

		end
	})
	self.msgLayer:addChild(message:getLayer())

	--	local hisBtn, isHis, layer, mask, list, bg
	--	hisBtn = KNBtn:new(PATH, {"history_btn.png"}, 0, 793,  {
	--		scale = true,
	--		priority = -200,
	--		callback = function()
	--			if isHis then
	--				list:getLayer():setVisible(false)
	--				bg:runAction(getSequenceAction(CCMoveTo:create(0.3,ccp(0, 854)), CCCallFunc:create(function()
	--					isHis = false
	--					hisBtn:setFlip(nil, isHis)
	--					mask:remove()
	--				end)))
	--			else
	--				isHis = true
	--				hisBtn:setFlip(nil, isHis)
	--				layer = display.newLayer()
	--				mask = KNMask:new({item = layer, priority = -199})
	--
	--				bg = display.newSprite(PATH.."msg_bg.png")
	--				setAnchPos(bg, 0, 854)
	--				layer:addChild(bg)
	--
	--				list = KNScrollView:new(0, 440, 480, 350, 5, false, 0, {
	--					priority = -200
	--				})
	--
	--				for k, v in pairs(worldHis) do
	--					local text = createLabel({str = "【"..name[v.game].."】"..v.msg, width = 480, color = ccc3(255,255,255)})
	--					list:addChild(text)
	--				end
	--				layer:addChild(list:getLayer())
	--				list:getLayer():setVisible(false)
	--
	--				bg:runAction(getSequenceAction(CCMoveTo:create(0.2,ccp(0,  854 - bg:getContentSize().height - 40)),CCCallFunc:create(function()
	--					list:getLayer():setVisible(true)
	--				end)))
	--
	--				self.msgLayer:addChild(mask:getLayer(), -1)
	--			end
	--
	--		end
	--	})
	--	hisBtn:setPosition(448, 816)
	----	setAnchPos(hisBtn:getLayer(),480, 854, 1, 1)
	--	self.msgLayer:addChild(hisBtn:getLayer(), 1)



	local msgWindow = WindowLayer:createWindow()
	msgWindow:setContentSize(CCSizeMake(385, 40))
	setAnchPos(msgWindow,60, 814)
	self.msgLayer:addChild(msgWindow)

	local msg = createLabel({str = self.msg.msg, size = 24, width = 800, color =ccc3(self.msg.red or 255, self.msg.green or 255, self.msg.blue or 255)})
	setAnchPos(msg, 440, 8)
	msgWindow:addChild(msg)



	local frames = display.newFramesWithImage( PATH .. "msg_effect.png" , 12 )
	local effect = display.playFrames( -40  , 20 , frames , 0.1 , {
		forever = true})
	msg:addChild(effect)

	Clock:addTimeFun("godwar_msg", function()
		self.time = self.time + 1
		if table.nums(self.worldMsg) > 0 then
			if self.time > 5 then
				self.time = 0
				msg:setPositionX(440)
				msg:stopAllActions()
				msg:setString("【"..name[self.worldMsg[1].game].."】"..self.worldMsg[1].msg)
				msg:setColor(ccc3(self.worldMsg[1].red,self.worldMsg[1].green,self.worldMsg[1].blue))
				self.msg = self.worldMsg[1]

				table.insert(worldHis,1, self.worldMsg[1])
				if #worldHis > 30 then
					table.remove(worldHis,#worldHis)
				end

				table.remove(self.worldMsg, 1)

				--				local action = CCMoveTo:create(4, ccp(msg:getContentSize().width > 450 and 450 - msg:getContentSize().width - 80 or 0,0))
				local action = CCMoveTo:create(5, ccp(-msg:getContentSize().width,0))
				msg:runAction(getSequenceAction(action))

				--					local action = CCMoveBy:create(2, ccp(450 - msg:getContentSize().width - 40,0))
				--				msg:runAction(getSequenceAction(action, action:reverse()))

			end
		else
			if self.haveMsg then
				if self.time > 5 then
					self.time = 0
					msg:setPositionX(440)
					local action = CCMoveTo:create(5, ccp(-msg:getContentSize().width,0))
					msg:runAction(getSequenceAction(action))
				end
			end
		end
	end)

	self:createMenu(p.data.talkPrice,message)
end


--刷 新世界喊话
function GodwarLayer:refreshMsg(content)
	table.insert(self.worldMsg, content)
	self.haveMsg = true
end


--系统消息展示
function GodwarLayer:sysMsg(content)
	if not self.field then
		return
	end
	local name = {
			['td'] = "绝世天府",
			['tmsj'] = "唐门世界",
			['tgxy'] = "太古仙域",
		}	
	if self.sysLayer then
		self.sysLayer:stopAllActions()
		self.sysLayer:removeFromParentAndCleanup(true)
	end
	self.sysLayer = display.newLayer()	
	
	setAnchPos(self.sysLayer,480,0)
	
	local bg = display.newSprite(PATH.."top_show/time_bg.png")
	setAnchPos(bg)
	
	local window = WindowLayer:createWindow()
	window:setContentSize(CCSize(350,80))
	setAnchPos(window,70,600)
	window:addChild(bg)
	
	self.sysLayer:addChild(window)
	
	local text = createLabel({str = "公告:["..name[content.game].."]"..content.msg, width = 1500, size = 20,color = ccc3(255,0,0)})
	setAnchPos(text,0,5)
	
	window:addChild(text)
	
	display.getRunningScene():addChild(self.sysLayer)
	
--	layer:runAction(getSequenceAction(CC:create(CCScaleTo:create(0.4,1))))
	self.sysLayer:runAction(getSequenceAction(CCMoveTo:create(0.4,ccp(0,0)),CCCallFunc:create(function()
		if text:getContentSize().width > 340 then
			text:runAction(CCMoveTo:create(4,ccp(350 - text:getContentSize().width,5)))
		end
	end),CCDelayTime:create(5),CCCallFunc:create(function()
		self.sysLayer:runAction(getSequenceAction(CCMoveTo:create(0.4,ccp(-480,0)),CCCallFunc:create(function()
			display.getRunningScene():removeChild(self.sysLayer,true)
			self.sysLayer = nil
		end)))
	end)))
end


--刷新提示
function GodwarLayer:refreshTip(kind)
--	if kind == "commu" then
--		self.msgNum = self.msgNum + 1
--	else
--		self.reportNum = self.reportNum + 1
--	end
--	
--	if self.msgLayer then
--		self.menuBtns[kind]:setText(kind == "commu" and self.msgNum or self.reportNum)
--		self.menuBtns[kind]:hideOther(false)
--		if not self.show then
--			if not self.msgTip then
--				self.msgTip = display.newSprite(PATH.."tip.png")
--				setAnchPos(self.msgTip,30, 80, 0.5, 0.5)
--				self.menu:addChild(self.msgTip, 10)
--
--				local function scale(node, big)
--					node:runAction(getSequenceAction(CCScaleTo:create(0.5,big and 1.2 or 0.8), CCCallFunc:create(function()
--						scale(node, not big)
--					end)))
--				end
--				scale(self.msgTip, true)
--			else
--				self.msgTip:setVisible(true)
--			end
--		else
--		end
--	end
	if self.msgLayer then
--		self.menuBtns["msg"]:runAction(tolua.cast("CCIntervalAction",getSequenceAction(CCScaleTo:create(1, 1.2), CCScaleTo:create(1,1))))
		local action = getSequenceAction(CCScaleTo:create(0.5, 1.2), CCScaleTo:create(0.5,1))
		local action1 =  tolua.cast(action,"CCActionInterval")
		self.menuBtns["msg"]:getLayer():runAction(CCRepeatForever:create(action1))
	end
end


--喊话界面
function GodwarLayer:talk(data)
	if self.mask then
		self.mask:remove()
	end
	local layer = display.newLayer()
	self.mask = KNMask:new({item = layer, proirotiy = -201})


	local bg = display.newSprite(PATH.."input_bg.png")
	setAnchPos(bg, 0, 540)
	bg:setScaleY(1.1)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."use_world.png")
	setAnchPos(bg, 10, 628)
	layer:addChild(bg)

	bg = display.newSprite(COMMONPATH.."gold.png")
	setAnchPos(bg, 100, 628)
	layer:addChild(bg)

	bg = createLabel({str = data.chatCost, size = 20, color = ccc3(255,255,255)})
	setAnchPos(bg, 140, 630)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."choose_color.png")
	setAnchPos(bg, 10, 548)
	layer:addChild(bg)

	local color = {{97, 210, 60},{229, 205, 71},{206,79,228},{68, 215,231},{232, 84, 84},{90,118,243}}
	local group = KNRadioGroup:new()
	for i = 1, 6 do
		local btn = KNBtn:new(PATH, {"color"..i..".png", "color_choose.png"}, 155 + (i - 1) * 50, 552, {
			priority = -220,
			id = i,
			noHide = true,
			selectZOrder = 20,
			callback = function()
				self.msgColor = i
			end
		} , group)
		layer:addChild(btn:getLayer())
	end
	group:chooseByIndex(self.msgColor or 1)


	-- 切换真假输入框的状态
	local textfield = KNInputText:new( { width = 365 ,
		height = 28 ,
		size = 20 ,
		defStr = "点击输入信息" ,
		existStr = nil ,
		defColor = ccc3( 0x4d , 0x15 , 0x15 ) ,
		inputColor = ccc3( 0x4d , 0x15 , 0x15 )
	} )
	setAnchPos( textfield:getLayer() , 30  , 600)
	layer:addChild( textfield:getLayer() , 10 )

	-- 真假输入框的背景
	local input_bg =  KNBtn:new(IMG_PATH .. "image/scene/chat/", {"talk_input_bg.png"} , 14 , 580  , {
		priority = -220,
		callback = function()
			textfield:startInput()
		end
	}):getLayer()
	layer:addChild(input_bg)

	-- 发送输入框
	local send_btn = KNBtn:new(IMG_PATH .. "image/common", {"btn_bg.png" , "btn_bg_pre.png"} , 373 , 583 , {
		priority = -220,
		front = IMG_PATH .. "image/common/send.png",
		scale = true,
		noHide = true,
		callback = function()
			if textfield:getString() == "" or textfield:getString() == "点击输入信息"  then
				KNMsg:getInstance():flashShow("没有输入内容")
			elseif textfield:getCharCount() > 45 then	--45个汉字
				KNMsg:getInstance():flashShow("输入内容超过45个字无法发送")
			else
				HTTP:call("fengshen", "chat", {red = color[group:getId()][1], blue = color[group:getId()][3], green =color[group:getId()][2] ,msg = textfield:getString()}, {
					success_callback = function(info)
						textfield:stopInput()
						data.chatCost = info.nextCost
						self:talk(data)
					end
				})
			end
		end})
	layer:addChild( send_btn:getLayer() , 10 )

	layer:setTouchEnabled(true)
	layer:registerScriptTouchHandler(function(type, x,y)
		if type == CCTOUCHBEGAN then
			self.mask:remove()
			self.mask = nil
			textfield:stopInput()
		end
		return true
	end, false, -220, false)

	self.mainLayer:addChild(self.mask:getLayer())
end


function GodwarLayer:createMenu(talkPrice, msgBtn)
	--	self.menu = display.newLayer()
	local info = createLabel({str = numChange(self.data.coin), size = 18, color = ccc3(255,255,255)})
	setAnchPos(info,140, 788 )
	self.msgLayer:addChild(info)

	info = createLabel({str = numChange(self.data.ability), size = 18, color = ccc3(255,255,255)})
	setAnchPos(info,280, 788 )
	self.msgLayer:addChild(info)

	info = createLabel({str = numChange(self.data.material), size = 18, color = ccc3(255,255,255)})
	setAnchPos(info,425, 788 )
	self.msgLayer:addChild(info)
	
	--	self.show = false
	--	local showBtn
	--	showBtn = KNBtn:new(PATH,{"button_arrow.png"},0,0,{
	--		callback = function()
	--			if self.msgTip then
	--				self.msgTip:setVisible(false)
	--			end
	--			showBtn:setEnable(false)
	--			if self.show then
	--				self.menu:runAction(getSequenceAction(CCEaseBounceOut:create(CCMoveTo:create(0.5, ccp(480 - showBtn:getWidth(), self.menu:getPositionY()))),CCCallFunc:create(function()
	--					showBtn:setEnable(true)
	--				end)))
	--			else
	--				self.menu:runAction(getSequenceAction(CCEaseBounceOut:create(CCMoveTo:create(0.5, ccp(480 - self.menu:getContentSize().width, self.menu:getPositionY()))),CCCallFunc:create(function()
	--					showBtn:setEnable(true)
	--				end)))
	--			end
	--			self.show = not self.show
	--		end
	--	})
	--	self.menu:addChild(showBtn:getLayer())
	--
	--	local bg = display.newSprite(PATH.."menu_bg.png")
	--	setAnchPos(bg, showBtn:getWidth())
	--	self.menu:addChild(bg)
	--
	--	self.menu:setContentSize(CCSizeMake(bg:getContentSize().width + showBtn:getWidth(), bg:getContentSize().height))
	--
	--	local btns = {
	--		{"exchange", function() self.mainLayer:addChild(GodWarShopLayer:new({ parent = self })) end},
	--		{"report", function()
	--			self.reportNum = 0
	--			self.menuBtns["report"]:setText("")
	--			self.menuBtns["report"]:hideOther(true)
	--			self:showReport()
	--		end},
	--		{"commu",function()
	--			self:chat(talkPrice)
	--			self.msgNum = 0
	--			self.menuBtns["commu"]:setText("")
	--			self.menuBtns["commu"]:hideOther(true)
	--		end},
	--		{"rank_btn", function()
	--			HTTP:call("fengshen", "getEntrance", {}, {
	--				success_callback = function(data)
	--					switchScene("godwar" ,{data = data, cur = "rank", field = self.field})
	--				end
	--				})
	--		end}
	--	}
	--	local other, text
	--	for k, v in pairs(btns) do
	--		if v[1] == "commu" or v[1] == "report" then
	--			other = {COMMONPATH.."egg_num_bg.png", 53, 53}
	--			text = {{v[1] == "commu" and (self.msgNum or 0) or (self.reportNum or 0), 15, ccc3(255,255,255), ccp(25,25),nil,20}}
	--		else
	--			other = nil
	--			text = nil
	--		end
	--
	--		self.menuBtns[v[1]] = KNBtn:new(PATH, {btns[k][1]..".png", btns[k][1].."_pre.png"}, 50 + (k - 1) * 95,5,{
	--			priority = -160,
	--			other = other,
	--			text = text,
	--			callback = function()
	--				v[2]()
	--				self.menu:runAction(getSequenceAction(CCEaseBounceOut:create(CCMoveTo:create(0.5, ccp(480 - showBtn:getWidth(), self.menu:getPositionY()))),CCCallFunc:create(function()
	--					showBtn:setEnable(true)
	--					self.show = not self.show
	--				end)))
	--			end
	--		})
	--		self.menu:addChild(self.menuBtns[v[1]]:getLayer())
	--	end
	--
	--	if self.msgNum == 0 then
	--		self.menuBtns["commu"]:setText("")
	--		self.menuBtns["commu"]:hideOther(true)
	--	end
	--
	--	if self.reportNum == 0 then
	--		self.menuBtns["report"]:setText("")
	--		self.menuBtns["report"]:hideOther(true)
	--	end
	--
	--
	--
	--	setAnchPos(self.menu, 480 - showBtn:getWidth(), 0)
	--	self.msgLayer:addChild(self.menu)
	self.menuBtns["msg"] = msgBtn
	self.mainLayer:addChild(self.msgLayer)
end


function GodwarLayer:changeFunc(data, priority, keep)
	local cids = {}
	for k, v in pairs(data.hero) do
		table.insert(cids, v)
	end
	local temp = display.newLayer()
	self:changeLayer(cids, temp, SHENZHAN_GROUP, priority)


	local help = KNBtn:new(IMG_PATH.."image/scene/multiFb/", {"help.png", "help_press.png"}, 410,600,{
		priority = priority or -151,
		callback = function()
			local tipLayer = display.newLayer()
			local tipBg = display.newSprite(PATH.."job_tip.png")
			setAnchPos(tipBg, 240, 425, 0.5,0.5)
			tipLayer:addChild(tipBg)

			local job = display.newSprite(PATH.."job1.png")
			setAnchPos(job, 245, 520, 0.5)
			tipLayer:addChild(job)

			job = display.newSprite(PATH.."job2.png")
			setAnchPos(job, 330, 350, 0.5)
			tipLayer:addChild(job)

			job = display.newSprite(PATH.."job3.png")
			setAnchPos(job, 150, 350, 0.5)
			tipLayer:addChild(job)

			showTip({
				priority = priority and (priority - 10) or  -200,
				bg = PATH.."change_bg.png",
				content = tipLayer,
				center = {
					remove = true
				}
			})
		end
	})

	temp:addChild(help:getLayer())

	local change_layout

	local function applyChange()
		local passCid = {}
		for k, v in pairs(cids) do
			table.insert(passCid, v.cid)
		end
		HTTP:call("fengshen", "posHero", {cids = string.join(passCid, "|")}, {
			success_callback = function()
				HTTP:call("fengshen", "getHeroInfo", {}, {
					success_callback = function(data)
						if keep then
							self.isChange = false
							KNMsg.getInstance():flashShow("阵容更换成功")
						else
							change_layout:remove()
							self:createHero(data, self.scroll:getCurIndex())
						end
					end
				})
			end
		} )
	end

	change_layout = showTip({
		bg = PATH.."change_bg.png",
		title_bg = PATH.."change_title_bg.png",
		title_text = PATH.."change_title.png",
		titleOffsetY = 15,
		offsetY = -15,
		priority = priority or -150,
		content = temp,
		close = {
			normal = "back_img.png",
			pre = "back_img_press.png",
			noRemove = true,
			callback = function()
				self.tempChoose = nil
				if self.isChange then
					KNMsg:getInstance():boxShow("你的阵形还未保存需要保存吗", {confirmFun = function()
							applyChange()
							change_layout:remove()
						end, cancelFun = function()
							change_layout:remove()
						end})
				else
					change_layout:remove()
				end
			end
		},
		center = {
			callback = function()
				self.tempChoose = nil
				applyChange()
			end
		}
	})
end


function GodwarLayer:changeLayer(cids, parent, game, priority)
	local content = display.newLayer()

	local bg = display.newSprite(PATH.."group_bg.png")
	setAnchPos(bg, 240, 560, 0.5)
	content:addChild(bg)

	bg = display.newSprite(PATH.."main_group.png")
	setAnchPos(bg, 240, 565, 0.5)
	content:addChild(bg)

	bg = display.newSprite(PATH.."group_bg.png")
	setAnchPos(bg, 240, 340, 0.5)
	content:addChild(bg)

	bg = display.newSprite(PATH.."other_group.png")
	setAnchPos(bg, 240, 345, 0.5)
	content:addChild(bg)


	local x,y = 25, game ~= SHENZHAN_GROUP and 390 or 400
	local cards = {}
	for i = 1, 8 do
		cards[i] = self:createCard(cids[i], 0.55, true, game)
		setAnchPos(cards[i], x, y)
		content:addChild(cards[i])

		x = x + 110
		if i % 4 == 0 then
			x = 25
			y = y - (game ~= SHENZHAN_GROUP and 230 or 220)
		end
	end


	content:setTouchEnabled(true)
	content:registerScriptTouchHandler(function(type, x, y)
		if type == CCTOUCHBEGAN then
			for k, card in pairs(cards) do
				if not CCRectMake(card:getPositionX(), card:getPositionY() + 45, card:getContentSize().width * 0.55, card:getContentSize().height * 0.55):containsPoint(ccp(x,y)) then
				else
					if self.tempChoose then
						if k ~= self.tempChoose then
							local temp = cids[self.tempChoose]
							cids[self.tempChoose] = cids[k]
							cids[k] = temp
							self.tempChoose = nil

							parent:removeChild(content, true)
							self:changeLayer(cids, parent, game, priority)
							self.isChange = true
						end
						return false
					else
						self.tempChoose = k
						card.select:setVisible(true)
					end
					--					local posX,posY = card:getPositionX(), card:getPositionY()
					--					card:setPosition(self.tempChoose:getPosition())
					--					self.tempChoose:setPosition(ccp(posX,posY))
					--					card.choose = false
					--					self.tempChoose.choose = false
					--					self.tempChoose.select:setVisible(false)
					--					self.tempChoose = nil

				end
			end
		elseif type == CCTOUCHMOVED then
		else
		end
		return true
	end, false, priority or -151, false)

	parent:addChild(content)
end

--生成属性页通用卡牌
function GodwarLayer:createCard(data, scale, touch, game)
	-- local config = 
	local config = requires(IMG_PATH,"GameLuaScript/Scene/godwar/config/fsheroconfig")

	-- dump(config)

	local scale = scale or 1
	local card = display.newLayer()

	local prefix = IMG_PATH.."image/scene/home/"
	local bg = display.newSprite(prefix.."card_bg.png")
	setAnchPos(bg)
	card:addChild(bg)


	card:setContentSize(bg:getContentSize())
	card:ignoreAnchorPointForPosition(false)
	card:setScale(scale)
	setAnchPos(card)

	card.select = display.newSprite(PATH.."select.png")
	setAnchPos(card.select, 93, 135, 0.5, 0.5)
	card.select:setScale(1.8)
	card:addChild(card.select, 1)
	card.select:setVisible(false)

	local job = display.newSprite(IMG_PATH.."image/scene/battle/job"..config[data.cid..""].role..".png")
	job:setScale(1.6)
	setAnchPos(job, 0, bg:getContentSize().height, 0, 1)
	card:addChild(job, 1)

	local star = config[data.cid..""].star
	
	--
	local icon = display.newSprite( PATH.."other/"..game.."/hero/b_general"..config[data.cid..""].logo_id..".png" )
	setAnchPos(icon , 95 , 135 , 0.5 , 0.5)
	card:addChild(icon)

	local bottom = display.newSprite(IMG_PATH.."image/scene/home/" .. "card_bottom_" .. config[data.cid..""].star .. ".png")
	setAnchPos(bottom , -2 , -2)
	card:addChild(bottom)

	bottom = display.strokeLabel(config[data.cid..""].name,135,5,25)
	setAnchPos(bottom,card:getContentSize().width / 2 , 5 , 0.5)
	card:addChild(bottom)

	for i = 1, star do
		icon = display.newSprite(COMMONPATH .. "star.png")
		setAnchPos(icon,(i - 1) * icon:getContentSize().width +  card:getContentSize().width / 2 - (icon:getContentSize().width * star) / 2  ,SHENZHAN_GROUP == game and 36 or 50)
		card:addChild(icon)
	end




	if game ~= SHENZHAN_GROUP then
		bottom = display.newSprite(PATH.."ke.png")
		setAnchPos(bottom,card:getContentSize().width / 2 , 230 , 0.5)
		--		bottom:setScale(1.5)
		card:addChild(bottom, 20)

		local role = config[data.cid..""].role - 1
		if role == 0 then
			role = 3
		end
		bottom = display.newSprite(PATH.."job"..role..".png")
		setAnchPos(bottom,card:getContentSize().width / 2 , 270 , 0.5)
		bottom:setScale(1.5)
		card:addChild(bottom, 20)

		local hp = KNProgress:new(IMG_PATH.."image/start_bar/hp/", {"bg.png", "fore.png"}, 20, 36,{
			cur = data.curHp,
			max = data.maxHp,
			scaleX = 2,
			iconScale = 1.3,
			leftIcon = {"icon.png", 10, 10,data.lv }
		})
		card:addChild(hp:getLayer())
	end

	return card
end

function GodwarLayer:upBuilding(data, kind)
	if self.mask then
		self.mask:remove()
		self.mask = nil
	end

	if data.maxExp == 0 or data.cd > 0 then
		--if data.maxExp == 0 then
		if data.maxExp == 0 then
			KNMsg.getInstance():flashShow("建筑已达最大等级，不需要升级")
		else
			KNMsg.getInstance():flashShow("建筑升级cd中，请稍候再来")
		end
		return
	end

	local layer = display.newLayer()
	self.mask = KNMask:new({item = layer, priority = -151})

	local bg = display.newSprite(PATH.."tip_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."up_bg.png")
	setAnchPos(bg, 240, 555, 0.5, 0.5)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."up_bg.png")
	setAnchPos(bg, 40, 435, 0, 0.5)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."building_level.png")
	setAnchPos(bg, 40, 555, 0, 0.5)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."use_text.png")
	setAnchPos(bg, 40, 435, 0, 0.5)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."cost_text.png")
	setAnchPos(bg, 40, 390, 0, 0.5)
	layer:addChild(bg)

	bg = display.newSprite(PATH.."level_bg.png")
	setAnchPos(bg, 380, 540)
	layer:addChild(bg)

	local lv = createLabel({str = data.lv.."级", color = ccc3(255,255,255)})
	setAnchPos(lv, 405, 542, 0.5)
	layer:addChild(lv)

	lv = createLabel({str = data.lv.."级", color = ccc3(0x2c, 0, 0)})
	setAnchPos(lv, 95, 490,1)
	layer:addChild(lv)

	lv = createLabel({str = (data.lv + 1).."级", color = ccc3(0x2c, 0, 0)})
	setAnchPos(lv,385, 490)
	layer:addChild(lv)

	local restMaterial = createLabel({str = tonumber(data.material), color = ccc3(0x2c, 0, 0), size = 20 })
	setAnchPos(restMaterial, 140, 378)
	layer:addChild(restMaterial)

	local use = 0
	local max = math.min(tonumber(data.material), data.maxExp - data.curExp)

	local totalNum = createLabel({str = use ,color = ccc3(0x2c,0,0), size = 20})
	setAnchPos(totalNum, 340, 378)
	layer:addChild(totalNum)

	if kind == "hero" then
		local str = createLabel({str = "已获得经验点:"..data.allPoint.."    下一次升级可获得:"..data.nextPoint, color = ccc3(255, 0, 0), size = 18, width =400 })
		setAnchPos(str, 240, 460, 0.5)
		layer:addChild(str)
	end



	--划动条
	local slider = KNSlider:new( "buy" ,  {
		x = 156 ,
		y = 500 ,
		minimum = 1 ,
		maximum = max,
		value = 1 ,
		callback  = function( _curIndex )
			totalNum:setString(_curIndex)
			use = _curIndex
		end ,
		priority = -151
	} )
	layer:addChild( slider )

	--增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next.png"} , 388 , 325 , {
		scale = true,
		priority = -151,
		callback = function()
			if use < max then
				use = use + 1
				slider:setValue( use )
			end
		end
	})

	local minusBtn = KNBtn:new(COMMONPATH,{"next.png"} ,  115 , 325 ,{
		scale = true,
		priority = -151,
		callback = function()
			if use > 1 then
				use = use - 1
				slider:setValue( use )
			end
		end
	})
	minusBtn:setFlip(true)

	layer:addChild(addBtn:getLayer())
	layer:addChild(minusBtn:getLayer())

	local exp = KNProgress:new(PATH, {"exp_bg.png", "exp_front.png"}, 100,490, {
		cur = data.curExp,
		max = data.maxExp,
		showText = true,
	})
	layer:addChild(exp:getLayer())



	local okBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 80, 270, {
		priority = -151,
		front = COMMONPATH.."confirm_big.png",
		callback = function()
			if use > 0 then
				HTTP:call("fengshen", "upgradeArch", {type = kind, count = use}, {
					success_callback = function(upInfo)
						local temp ={
							["hero"] = "Hero",
							["equip"] = "Equip",
							["skill"] = "Skill",
							["stone"] = "Stone",
							["pet"] = "Pet"
						}
						local stillShow = true
						if upInfo.upgrade == 1 then
							KNMsg.getInstance():flashShow("恭喜您消耗材料:"..use.."  建筑等级提升,同时进入cd")
							stillShow = false
						else
							KNMsg.getInstance():flashShow("恭喜您消耗材料:"..use.."  提升建筑经验:"..use)
						end
						HTTP:call("fengshen","get"..temp[kind].."Arch", {}, {
							success_callback = function(data)
								if kind == "pet" then
									self:createPet(data, stillShow)
								else
									self:tabDetail(kind, data, stillShow)
								end
							end
						})
					end
				})
			else
				KNMsg.getInstance():flashShow("材料不足请先获取足够的材料进行升级")
			end
		end
	})
	layer:addChild(okBtn:getLayer())

	local cancelBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 280, 270, {
		priority = -151,
		front = COMMONPATH.."colse_text.png",
		callback = function()
			self.mask:remove()
			self.mask = nil
		end
	})
	layer:addChild(cancelBtn:getLayer())


	self.baseLayer:addChild(self.mask:getLayer())
end

function GodwarLayer:createNewMaterial(param)
	local MATERIALPATH = PATH.."material/"
	local infoLayer
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
		self.mainLayer:removeChild(self.msgLayer, true)
		self.msgLayer = nil
	end
	self.layer = display.newLayer()

	local bg = display.newSprite(PATH.."bg.png")
	setAnchPos(bg)
	self.layer:addChild(bg)

	bg = display.newSprite(MATERIALPATH.."background.png")
	setAnchPos(bg, 240, 375, 0.5, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(MATERIALPATH.."bg.png")
	setAnchPos(bg, 240, 252, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(MATERIALPATH.."own_material.png")
	setAnchPos(bg, 33, 700)
	self.layer:addChild(bg)

	local baoji_text = display.strokeLabel( "" , 135 , 224, 18, ccc3(85, 230 , 220 ))
	self.layer:addChild( baoji_text )

	local material_count = param.material or 0
	local material_text = display.strokeLabel( material_count , 200 , 703, 20, ccc3(255, 255 , 255 ))
	self.layer:addChild( material_text )

	if tonumber(param.baoji) ~= 0 then
		baoji_text:setString("下一次使用黄金矿镐都获得"..tonumber(param.baoji).."倍收益!")
	end

	local function actionFunc(data)
		local tempLayer =display.newLayer()
		local mask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -201-1})
		local baojiEff = nil
		local frames = display.newFramesWithImage( MATERIALPATH .. "baoji_effect.png" , 14 , 2 )
		baojiEff = display.playFrames( 0  , 0 , frames , 0.15 , {
			onComplete = function()
				transition.stopTarget( baojiEff )
				delObj( baojiEff )
				mask:remove()
				showTip({
					priority = -202 ,
					content = createLabel({str = "恭喜发现宝藏，下一次使用黄金矿镐即可获得"..tonumber(data.baoji).."倍收益", size = 20, width = 360}),
					title_bg = MATERIALPATH .. "find_material_title.png" ,
					titleOffsetY = 50,
					titleBgX = -20,
					cy = 130 ,
					center = {
						path = COMMONPATH,
						normal = "btn_bg_red.png",
						pre = "btn_bg_red_pre.png",
						front = COMMONPATH.."ok.png",
						remove = true,
						offsetX = 100 ,
						callback = function()
							self:createNewMaterial(data)
							-- baoji_text:setString("下一次使用黄金矿镐都获得"..tonumber(param.baoji).."倍收益!")
						end
					}})
			end } )
		setAnchPos( baojiEff , 240 , 300 , 0.5 , 0 )
		tempLayer:addChild(baojiEff)
		return mask
	end

	local function buyMaterial()
		local buyMaterialLayer =display.newLayer()
		--背景
		local bg = display.newSprite(PATH.."join/coolie_list_bg.png")
		setAnchPos(bg,240,146, 0.5)
		buyMaterialLayer:addChild(bg)
		--标题背景
		local title_bgSp = display.newSprite(PATH.."change_title_bg.png")
		setAnchPos(title_bgSp,240,495 , 0.5)
		bg:addChild(title_bgSp)
		--标题文字
		local title_Sp = display.newSprite(MATERIALPATH.."buy_material_title.png")
		setAnchPos(title_Sp,240,515 , 0.5)
		bg:addChild(title_Sp)

		--关闭按钮
		local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 480 , {
			priority = -201-2,
			scale = true,
			callback = function()
				mask:remove()
			end})
		bg:addChild(close:getLayer())
		mask = KNMask:new({item = buyMaterialLayer, click = function(x, y)  end ,priority= -201-1})

		local function createItem()

		end

		return mask
	end


	local material_config = {
		{ "normal" , "能量水晶" } ,
		-- { "silver" , "能量水晶" } ,
		{ "gold" , "能量水晶" } ,
	}


	for i = 1 , #material_config do
		if tonumber(param["type"][i..""][3]) ~= 0 then
			local gold = display.newSprite(COMMONPATH.."gold.png")
			setAnchPos(gold, 115 + (i - 1)*200, 187)
			self.layer:addChild(gold)
			self.layer:addChild(display.strokeLabel( param["type"][i..""][3] , 150 + (i - 1)*200 , 187, 18, ccc3(255, 255 , 255 )))
		else
			self.layer:addChild(display.strokeLabel( "免费" , 130 + (i - 1)*200 , 187, 18, ccc3(255, 255 , 255 )))
		end

		local cur_counts = tonumber(param["type"][i..""][1])
		local all_counts = tonumber(param["type"][i..""][2])

		local own_text = display.strokeLabel( "次数: "..cur_counts.." / " .. all_counts , 107 + (i - 1)*200 , 50, 16, ccc3(255, 255 , 255 ))
		self.layer:addChild( own_text )

		local material_btn = KNBtn:new(PATH.."material", {material_config[i][1].."_material.png", material_config[i][1].."_material_pre.png"},90 + (i - 1)*200, 70,{
			callback = function()
				HTTP:call("fengshen", "digMine",{ type = i }, {
					success_callback = function(data)
						-- cur_counts = cur_counts + 1
						-- own_text:setString( "次数: "..cur_counts.." / " .. all_counts )
						-- material_count = material_count + data.add
						-- material_text:setString( material_count )
						KNMsg:getInstance():flashShow("获得"..material_config[tonumber(data["type"])][2]..data["add"])
						if tonumber(data.baoji) ~= 0 then
							self.layer:addChild( actionFunc(data.get):getLayer() )
						else
							baoji_text:setString("")
							self:createNewMaterial(data.get)
						end
					end
				})
			end
		})
		self.layer:addChild(material_btn:getLayer())

		if  i == 1 and KNGuide:getStep() == 10006 then
			KNGuide:show(material_btn:getLayer() , {
				callback = function()
					KNGuide:show(infoLayer:getBackBtn():getLayer() , {
					})
				end
			})
		end
	end

	-- local material_pkg_btn = KNBtn:new(MATERIALPATH, {"material_btn.png", "material_btn_pre.png"},350, 267,{
	-- 		callback = function()
	-- 			self.layer:addChild( buyMaterial():getLayer() )
	-- 		end
	-- })
	-- self.layer:addChild(material_pkg_btn:getLayer())

	local helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb", {"help.png","help_press.png"}, 418 , 680 , {
		priority = -122,
		scale = true,
		callback = function()

			local mask
			local tempLayer =display.newLayer()
			--背景
			local bg = display.newSprite(PATH.."tip_bg.png")
			setAnchPos(bg,240,427 , 0.5 , 0.5)
			tempLayer:addChild(bg)
			--标题背景
			local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
			setAnchPos(title_bgSp,100,320)
			bg:addChild(title_bgSp)
			--标题文字
			local title_Sp = display.newSprite(COMMONPATH.."help_title.png")
			setAnchPos(title_Sp,65,320)
			bg:addChild(title_Sp)

			local str = "能量水晶用处：能量水晶可以快速提升英雄和幻兽的等级！\n" ..
			"能量水晶获得：能量水晶可以通过在建材矿洞中免费获得，也可以通过使用高级矿镐获得更多数量的能量水晶。\n" ..
			"能量水晶宝藏：在挖掘的过程中，有很小的概率发现能量水晶宝藏！那会让你在下一次获得大量的收益！\n" ..
			"材料包：三界之中，只有身家丰厚之辈才可以福泽旁人。给自己的好友、帮派、世界购买材料包获得大量战贡！\n"



			local helpTips = createLabel({str = str, x = 60, y = 40,size = 18, width = 340,color = ccc3(46 , 18 , 14)})
			bg:addChild(helpTips)
			--关闭按钮
			local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 305 , {
				priority = -201-2,
				scale = true,
				callback = function()
					mask:remove()
				end})
			bg:addChild(close:getLayer())
			mask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -201-1})
			self.layer:addChild(mask:getLayer(), 10)

		end
	})
	self.layer:addChild(helpBtn:getLayer() , 0)
	infoLayer = InfoLayer:new( "pet" , 0 , {disableChat = true, hideNavigation = true , tail_hide = true,  preCall = function() self.goOut = true end, titleBg = PATH.."top_title_bg.png", title_text = PATH.."material_title.png", bottom = PATH.."bottom_bg.png",tail_hide = true,  priority = -150, closeOffset = -35 ,closeCallback = function()
			self:backToMain()
		end} )
	self.layer:addChild(infoLayer:getLayer())



	self.baseLayer:addChild(self.layer)

end

function GodwarLayer:backToMain()
	HTTP:call("fengshen", "getJFSummary", {}, {
		success_callback = function(data)
			switchScene("godwar", {data = data, msgNum = GODWAR.msgNum, reportNum = GODWAR.reportNum})
		end})
end

function GodwarLayer:createMaterial(data)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()

	local bg = display.newSprite(PATH.."bg.png")
	setAnchPos(bg)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."center_bg.png")
	setAnchPos(bg, 240, 415, 0.5, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."pos_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."total_num.png")
	setAnchPos(bg, 240, 665, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."free_times.png")
	setAnchPos(bg, 240, 175, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(PATH.."use.png")
	setAnchPos(bg, 200, 100, 0.5)
	self.layer:addChild(bg)

	bg = display.newSprite(COMMONPATH.."gold.png")
	setAnchPos(bg, 240, 100, 0.5)
	self.layer:addChild(bg)

	self.layer:addChild(createLabel({str = data.freeMax, color = ccc3(255,255,255), x = 320, y = 667 }))

	self.layer:addChild(createLabel({str = data.freeTimes > 0 and "免费" or data.cost, color = ccc3(255,255,255), x = 260, y = 103, size = 18 }))

	self.layer:addChild(createLabel({str = data.freeTimes, color = ccc3(255,255,255), x = 170, y = 177 }))

	self.layer:addChild(createLabel({str = data.goldTimes, color = ccc3(255,255,255), x = 410, y = 177 }))

	local arrow = display.newSprite(PATH.."material_arrow.png")
	setAnchPos(arrow, 240, 420, 0.5)
	self.layer:addChild(arrow)

	local success, round = false, 0
	local result, last = 0, 8
	local start, isCrit, centerBtn, mask
	local function arrowRotate()
		if not mask then
			mask = KNMask:new({priority = -200, opacity = 0})
			self.baseLayer:addChild(mask:getLayer())
		end

		arrow:runAction(getSequenceAction(CCRotateBy:create(0.5,720), CCCallFunc:create(function()
			if success then
				round = round + 1
				if round > 4 then
					local des
					if tonumber(result.index) > last then
						des = ( tonumber(result.index) - last) * 45
					else
						des = 360 - (8 - (8 + ( tonumber(result.index) - last))) * 45
					end
					last =  tonumber(result.index)
					arrow:runAction(getSequenceAction(CCEaseExponentialOut:create(CCRotateBy:create(3, des)),CCCallFunc:create(function()
						local content = display.newLayer()
						if isCrit ~= 0 then
							local crit = display.newSprite(PATH.."crit_text.png")
							setAnchPos(crit,240, 440, 0.5)
							content:addChild(crit)
						end

						local str
						if data.freeTimes > 0 then
							str = "恭喜您获得材料:+"..result.add..",当前总材料:"..result.material..",此次抽取免费"
						else
							str = "恭喜您获得材料:+"..result.add..",当前总材料:"..result.material..", 花费黄金:"..data.cost
							if isCrit ~= 0 then
								str = str .. "\n触发暴击状态，下一次抽取必得'坎'，或者‘乾’"
							end
						end

						local tip = createLabel({str = str, width = 400, color = ccc3(0x2c, 0, 0)})
						setAnchPos(tip, 240, (isCrit == 0) and 400 or 350 , 0.5)
						content:addChild(tip)

						if mask then
							mask:remove()
							mask = nil
						end
						showTip({
							bg = (isCrit == 0 and COMMONPATH.."tip_bg.png" or PATH.."tip_bg.png"),
							content = content,
							center ={
								remove = true,
								callback = function()
									HTTP:call("fengshen", "getEntrance",{}, {
										success_callback = function(data)
											self:createNewMaterial(data)
										end
									})
								end
							}
						})
					end)))
				else
					arrowRotate()
				end
			else
				round = round + 1
				arrowRotate()
			end
		end)))
	end

	start = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"},180, 130,{
		front = PATH..(data.isCrit ~= 0 and "crit_get.png" or "get.png"),
		callback = function()
			if data.freeTimes + data.goldTimes > 0 then
				round = 0
				success = false
				HTTP:call("fengshen", "exchangeMaterial", {}, {
					no_loading = true,
					success_callback = function(data)
						success = true
						isCrit = data.isCrit
						result = data
					end, error_callback = function(msg)
						KNMsg.getInstance():flashShow(msg.msg)
						self:createMaterial(data)
					end
				})
				arrowRotate()
			else
				KNMsg.getInstance():flashShow("没有抽取次数")
			end
		end

	})
	self.layer:addChild(start:getLayer())



	local pos = {
		{368, 552},
		{412, 420},
		{367, 297},
		{238, 253},
		{110,294},
		{64, 420},
		{110, 550},
		{238, 600},
	}

	for i = 1, 8 do
		local gift = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, pos[i][1], pos[i][2],{
			anchMid = true,
			front = PATH.."material_icon.png",
			other = {PATH.."num_bg.png", 50, 50},
			scale = true,
			callback = function()
				KNMsg.getInstance():flashShow("可获得升级材料: +"..data.pool[i])
			end,
			text = {data.pool[i], 14, ccc3(255,255,255), ccp(55,25), 1, 20}
		})
		self.layer:addChild(gift:getLayer())
	end

	--	arrow:runAction(CCRepeatForever:create(CCRotateBy:create(0.5, 360)))
	--	arrow:runAction(CCEaseExponentialOut:create(CCRotateTo:create(5, 1800)))

	centerBtn = KNBtn:new(PATH, {"material_center.png", "material_center_pre.png"}, 240, 425, {
		anchMid = true,
		callback = function()
			start:call()
		end
	})
	self.layer:addChild(centerBtn:getLayer())

	self.layer:addChild(InfoLayer:new( "pet" , 0 , {disableChat = true,  preCall = function() self.goOut = true end, titleBg = PATH.."top_title_bg.png", title_text = PATH.."material_title.png", bottom = PATH.."bottom_bg.png",tail_hide = true,  priority = -150, closeOffset = -35 ,closeCallback = function()
			self:backToMain()

		end} ):getLayer())
	self.baseLayer:addChild(self.layer)
end

--招贤纳士
function GodwarLayer:createJoin( params )
	local function createFun( tempData )
		if self.layer then
			self.mainLayer:removeChild(self.msgLayer, true)
			self.baseLayer:removeChild(self.layer, true)
			self.layer = display.newLayer()
		end


		local joinLayer = requires(IMG_PATH, "GameLuaScript/Scene/godwar/joinLayer"):new({ data = tempData , backFunc = function() Clock:removeTimeFun( "joinLayerRefresh" )  self.backToMain() end })
		self.layer:addChild( joinLayer:getLayer() )
		joinLayer:create( params )

		self.baseLayer:addChild(self.layer)
		self.msgLayer = nil
	end
	HTTP:call("fengshenkuli", "get", {}, {
		success_callback = function(tempData)
			createFun( tempData )
		end})

end



function GodwarLayer:buy(data, material, cfg, btn)
	self.buyLayer = display.newLayer()
	local baseX = display.cx + 10
	local baseY = display.cy - 150

	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos( bg , baseX - 213 , baseY - 20 , 0 , 0 )
	self.buyLayer:addChild(bg)

	--	--物品Icon
	--	local icon = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , baseX - 148 , baseY + 135 , {  front = getImageByType(DATA_Shop:get(index , "cid") , "s") } )
	--	self.buyLayer:addChild( icon:getLayer() )
	--
	--	local name = display.strokeLabel( "购买行动力（每天最多可购买50点行动力)" , 55 , baseY + 200 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 330 ,align = 0 } )
	--	self.buyLayer:addChild(name )

	--	--花费总数
	--	local valueBg = display.newSprite(PATH.."value_bg.png")
	--	valueBg:setScaleY(0.89)
	--	setAnchPos(valueBg , baseX - 17 , baseY + 130 , 0.5)
	--	self.buyLayer:addChild(valueBg)
	--
	--	local gold = display.newSprite(COMMONPATH .. "gold.png")
	--	setAnchPos(gold , baseX - 95  , baseY + 140 )
	--	self.buyLayer:addChild(gold)
	local priceText = display.strokeLabel(material , baseX - 70 , baseY + 165 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , nil , nil ,{ dimensions_width = 80 , dimensions_height = 30 ,align = 0} )
	self.buyLayer:addChild(priceText)
	--
	--
	--购买数量
	--	local numText = display.newSprite(PATH.."num_text.png")
	--	setAnchPos(numText,baseX + 35  , baseY + 140 , 0 )
	--	self.buyLayer:addChild(numText)

	local numBg = display.newSprite(PATH.."rest_power.png")
	local num = 1
	setAnchPos(numBg,baseX - 170 , baseY + 168 )
	self.buyLayer:addChild(numBg)

	--数量文本
	local numText = display.strokeLabel( 1 .. "" , baseX + 120 , baseY + 166 , 20 , ccc3(0x2c, 0, 0 ) , nil , nil , { dimensions_width = 86 , dimensions_height = 30  } )
	self.buyLayer:addChild(numText)

	--
	local curLv = createLabel({str = data.lv.."级" ,size  = 18})
	setAnchPos(curLv, 70, 368, 0.5)
	self.buyLayer:addChild(curLv, 10)

	local toLv = createLabel({str = (data.lv + num).."级" ,size  = 18})
	setAnchPos(toLv, 425, 368, 0.5)
	self.buyLayer:addChild(toLv, 10)

	local maxLv = 0
	local preuse = 0
	for i = data.lv, data.lv + 20 do
		if cfg[i..""] then
			if preuse > tonumber(material) then
				maxLv = maxLv - 1
				break
			end
			preuse = preuse + cfg[i ..""].exp
			maxLv = maxLv + 1
		end
	end

	--修改数值
	local function changeValue()
		local total = 0
		for k, v in pairs(cfg) do
			if tonumber(k)>= data.lv and tonumber(k)< data.lv + num then
				total = total + v.exp
			end
		end

		numText:setString(total == 0 and preuse or total)
		toLv:setString((data.lv + num).."级")

	end

	--划动条
	local slider = KNSlider:new( "buy" ,  {
		x = baseX - 106 ,
		y = baseY + 193 ,
		minimum = 1 ,
		maximum = math.min(20, maxLv),
		value = 1 ,
		callback  = function( _curIndex )
			num = _curIndex
			changeValue()
		end,
		priority = -140
	})
	self.buyLayer:addChild( slider )

	--增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX + 118 , baseY + 77 , {
		scale = true,
		priority = -130,
		callback = function()
			if num < 99 then
				num = num + 1
				slider:setValue( num )
				changeValue()
			end
		end
	})


	--


	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX - 155 , baseY + 77 ,{
		scale = true,
		priority = -130,
		callback = function()
			if num > 1 then
				num = num - 1
				slider:setValue( num )
				changeValue()
			end
		end
	})
	minusBtn:setFlip(true)

	addBtn:getLayer():setScale( 0.9 )
	minusBtn:getLayer():setScale( 0.9 )
	self.buyLayer:addChild(addBtn:getLayer())
	self.buyLayer:addChild(minusBtn:getLayer())





	local mask = KNMask:new( {item = self.buyLayer } ):getLayer()
	--确定，取消按钮
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, baseX - 154 , baseY + 28 ,{
		front = COMMONPATH.."ok.png" ,
		scale = true,
		priority = -130,
		callback = function()
			if maxLv == 0 then
				KNMsg.getInstance():flashShow("能量水晶不足")
				return
			end

			HTTP:call("fengshen", "upgradeHero2", {cid = data.cid, tolv = num + data.lv }, {
				success_callback = function(data)
					HTTP:call("fengshen", "getHeroInfo", {}, {
						success_callback = function(data)
							local backBtn = self:createHero(data, self.scroll:getCurIndex())
							KNMsg.getInstance():flashShow("升级成功")
							self:buy(data.hero[self.scroll:getCurIndex()], tonumber(data.material), data.upCfg, backBtn)
						end
					})
				end
			})
		end
	})

	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , baseX + 54 , baseY + 28 ,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			self.layer:removeChild(mask,true)
		end})
	self.buyLayer:addChild(ok:getLayer())
	self.buyLayer:addChild(cancel:getLayer())

	if KNGuide:getStep() == 10010 then
		KNGuide:show(addBtn:getLayer(), {
			callback = function()
				KNGuide:show(ok:getLayer(), {
					callback = function()

					end
				})
			end
		})
	elseif KNGuide:getStep() == 10012 then
		KNGuide:show(cancel:getLayer(), {
			callback = function()
				KNGuide:show(btn:getLayer(), {
					callback = function()
					end
				})
			end
		})
	end




	self.layer:addChild(mask, 10)
end

return GodwarLayer
