--[[商城]]

local PATH = IMG_PATH.."image/scene/godwar/"
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local KNRadioGroup = requires(IMG_PATH, "GameLuaScript/Common/KNRadioGroup")
local ShopItem = requires(IMG_PATH,"GameLuaScript/Scene/shop/shopitem")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local SCENECOMMON = IMG_PATH .. "image/scene/common/"

local GodWarShopLayer = {
	baseLayer,
	layer,
	itemsLayer,
	infoLayer,
	group,
	buyLayer,
	moneyLayer,
}

function GodWarShopLayer:new(param)
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	this.moneyLayer = nil
	this.baseLayer = display.newLayer()
    this.layer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite(PATH .. "bg.png")
	setAnchPos(bg , 0 , 0)						-- 70 是底部公用导航栏的高度
	this.layer:addChild(bg)

	local bagConfig = {
			{
				"fengshen",
				"tab_shenbi.png",
				"tab_shenbi_big.png",
			},
		}
	
	param.parent.mainLayer:setPositionX(480)
	this.baseLayer:setPositionX(-480)

	local temp
	local startX , startY = 10 , 690
	this.group = KNRadioGroup:new()
	for i = 1, #bagConfig do
		temp = KNBtn:new(PATH  , { "tab.png" , "tab_press.png" } , startX , startY , {
			front = { COMMONPATH .. "tab_shop/" .. bagConfig[i][2] , COMMONPATH .. "tab_shop/" .. bagConfig[i][3]},
			disableWhenChoose = true,
			id = bagConfig[i][1],
			callback = function()
				if DATA_Shop:haveData() then
					this:createBag(bagConfig[i][1])
				else
					HTTP:call("shop","get",{},{success_callback=
					function()
						this:createBag(bagConfig[i][1])
					end
					})
				end
			end
		} , this.group)

		this.layer:addChild(temp:getLayer())
		startX = startX + temp:getWidth() + 4
	end

	local line = display.newSprite(PATH .. "tab_line.png")
	setAnchPos(line , 6 , 685)
	this.layer:addChild(line)

	this:refreshMoney()


	HTTP:call("shop","get",{},{success_callback=
					function()
						this:createBag(bagConfig[1][1])
					end
	})

	
	--local godwarLayer = requires(IMG_PATH,"GameLuaScript/Scene/godwar/godwarLayer")
	
	this.infoLayer = InfoLayer:new( "GodWarShopLayer" , 0 , {disableChat = true, hideNavigation = true , tail_hide = true,  preCall = function() godwarLayer.goOut = true end, titleBg = PATH.."top_title_bg.png", title_text = IMG_PATH.."image/scene/shop/".."title.png", bottom = PATH.."bottom_bg.png",tail_hide = true,  priority = -150, closeOffset = -35 ,closeCallback = function()
		-- godwarLayer:backToMain()
		if param.parent.field then
				HTTP:call("fengshen", "getJFSummary", {}, {
					success_callback = function(data)
						switchScene("godwar", {data = data, inWar = true, field = param.field})
					end})	
		else
			param.parent:backToMain()
		end
	end} )

	this.baseLayer:addChild(this.layer)
	this.baseLayer:addChild(this.infoLayer:getLayer(),1)
	return this.baseLayer
end

function GodWarShopLayer:refreshMoney()
	if self.moneyLayer ~= nil then
		self.layer:removeChild(self.moneyLayer , true)
	end

	self.moneyLayer = display.newLayer()

	-- 神币
	self.moneyLayer:addChild( display.newSprite(PATH.."shenbi_label.png" , 387 , 720) )
	self.moneyLayer:addChild( display.strokeLabel( G_coin or "0" , 423 , 706 , 20 , ccc3(255 , 251 , 212) , 2 ) )

	self.layer:addChild(self.moneyLayer)
end



function GodWarShopLayer:createBag(type)
	if self.itemsLayer then
		self.layer:removeChild(self.itemsLayer,true)
	end
	
	local itemsNum = DATA_Shop:count(type)
	if itemsNum <= 0 then return end


	self.itemsLayer = display.newLayer()
	local perpage = 5
	local x , y = 15 , 572

	local scroll = KNScrollView:new(15 , 50 , 450 , 635 , 5)

	local temp_text = display.strokeLabel("说明：神币可在封神战中获得！" , 0 , 0 , 20 , ccc3(66 , 160 , 52 ) , 2 )
	setAnchPos( temp_text , 240 , 20 , 0.5 )
	self.itemsLayer:addChild( temp_text )

	local items = DATA_Shop:getTable(type)
	local keyList = getSortList(items, function(l, r)
--		return getConfig("prop", items[l].cid, "star") < getConfig("prop", items[r].cid, "star") 
		return items[l].sort < items[r].sort
	end)
	for i , v in pairs(keyList) do  --循环初始化当前选中类型的类型的背包显示
		local info = items[v]
		local item = ShopItem:new(type , v["id"] , {
			index = v,
			parent = scroll,
			iconCallback = function()
				--当点击图标按钮后先从全局数据中查找是否存在数据，若没有则请求网络，否则隐藏用户信息栏，显示详细界面
				local detail_type = getCidType(info["cid"])
				local data = getConfig( detail_type , info["cid"] )
				data["cid"] = info["cid"]

				pushScene("detail" , {
					detail = detail_type,
					shopBuyFun = function()
						if getConfig("prop", info["cid"], "type") == "vip" then
							if not countGold(info.price) then
								return
							else
								HTTP:call("shop" , "buy" , {
									id = info["id"],
									num = 1 
								} , {
									success_callback = function()
										KNMsg.getInstance():flashShow("购买成功")
										self:refreshMoney()
									end
								})
							end
						else
							popScene()
							self:buy(type , info["id"] , v)
						end
					end ,
					data = data,
				})
			end,

			optCallback = function()
				if getConfig("prop", info["cid"], "type") == "vip" then
					if not countGold(info.price) then
						return
					else
						HTTP:call("shop" , "buy" , {
							id = info["id"],
							num = 1 
						} , {
							success_callback = function()
								KNMsg.getInstance():flashShow("购买成功")
								self:refreshMoney()
							end
						})
					end
				else
					self:buy(type , info["id"] , v)
				end
			end
		})

		scroll:addChild(item:getLayer())
	end

	scroll:alignCenter()
	scroll:effectIn()
	self.itemsLayer:addChild(scroll:getLayer())
	
	self.layer:addChild(self.itemsLayer)
end

function GodWarShopLayer:buy( type , id , index )
	self.buyLayer = display.newLayer()
	local SHOPPATH = IMG_PATH.."image/scene/shop/"
	local baseX = display.cx
	local baseY = display.cy - 28
	
	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos( bg , baseX - 193 , baseY , 0 , 0 )
	self.buyLayer:addChild(bg)
	
	--物品Icon
	local icon = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , baseX - 148 , baseY + 135 , {  front = getImageByType(DATA_Shop:get(index , "cid") , "s") } )
	self.buyLayer:addChild( icon:getLayer() )	
	
	-- 名字
	self.name = display.strokeLabel( DATA_Shop:get(index,"name") , baseX - 75 , baseY + 170 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 130 , dimensions_height = 30 ,align = 0 } )
	self.buyLayer:addChild( self.name )
	
	--花费总数
	local valueBg = display.newSprite(SHOPPATH.."value_bg.png")
	valueBg:setScaleY(0.89)
	setAnchPos(valueBg , baseX - 17 , baseY + 130 , 0.5)
	self.buyLayer:addChild(valueBg)
	
	local gold = display.newSprite(COMMONPATH .. "coin.png")
	setAnchPos(gold , baseX - 75  , baseY + 140 )
	self.buyLayer:addChild(gold)
	
	local priceText = display.strokeLabel( DATA_Shop:get(index,"real_price") , baseX - 40 , baseY + 135 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , nil , nil ,{ dimensions_width = 80 , dimensions_height = 30 ,align = 0} )
	self.buyLayer:addChild(priceText)
	

	
	
	--购买数量
	local numText = display.newSprite(SHOPPATH.."num_text.png")
	setAnchPos(numText,baseX + 55  , baseY + 140 , 0 )
	self.buyLayer:addChild(numText)
	
	--购买数量
	local numBg = display.newSprite(SHOPPATH.."num_bg.png")
	local num = 1 
	setAnchPos(numBg,baseX + 116 , baseY + 136 , 0 )
	self.buyLayer:addChild(numBg)
	
	--数量文本
	local numText = display.strokeLabel( 1 .. "" , baseX + 116 , baseY + 136 , 20 , ccc3(0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 36 , dimensions_height = 30 ,align = 1 } )
	self.buyLayer:addChild(numText)
	

	--修改数值
	local function changeValue()
		numText:setString(num)
		priceText:setString(num * DATA_Shop:get(index,"real_price"))
	end
	
	
	
	
		--划动条
	local slider = KNSlider:new( "buy" ,  {
		x = baseX - 106 , 
		y = baseY -53 , 
		minimum = 1 , 
		maximum = 20, 
		value = 1 , 
		callback  = function( _curIndex )
			num = _curIndex
			changeValue()
		end,
		priority = -140
	})
	self.buyLayer:addChild( slider )
	
	--增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX + 128 , baseY + 77 , {
		scale = true,
		priority = -130,
		callback = function()
			if num < 99 then
				num = num + 1
				slider:setValue( num )
				changeValue()
			end
		end
	})
	
	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , baseX - 165 , baseY + 77 ,{
		scale = true,
		priority = -130,
		callback = function()
			if num > 1 then
				num = num - 1
				slider:setValue( num )
				changeValue()
			end
		end
	})
	minusBtn:setFlip(true)
	
	addBtn:getLayer():setScale( 0.9 )
	minusBtn:getLayer():setScale( 0.9 )
	self.buyLayer:addChild(addBtn:getLayer())
	self.buyLayer:addChild(minusBtn:getLayer())
	

	

	
	local mask = KNMask:new( {item = self.buyLayer } ):getLayer()
	--确定，取消按钮
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, baseX - 134 , baseY + 28 ,{
		front = COMMONPATH.."ok.png" ,
		scale = true,
		priority = -130,
		callback = function()
			if not countGold(priceText:getLabel():getString()) then
				return
			else
				HTTP:call("shop" , "buy" , {
					id = id,
					num = num
				} , {
					success_callback = function()
						KNMsg.getInstance():flashShow("购买成功")
						
						self.baseLayer:removeChild(mask,true)
						
						self:refreshMoney()
					end
				})
			end

		end
	})
	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , baseX + 54 , baseY + 28 ,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			self.baseLayer:removeChild(mask,true)
		end})
	self.buyLayer:addChild(ok:getLayer())
	self.buyLayer:addChild(cancel:getLayer())
	

	self.baseLayer:addChild(mask)
end


return GodWarShopLayer
