-- 劫掠水晶
local PATH = IMG_PATH.."image/scene/godwar/"
local COMMONPATH = IMG_PATH .. "image/common/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local M = {
	layer , 
	scrollLayer , 
	content,
}


function M:new( params )
	params = params or {}
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	this.layer = display.newLayer()
	this.content = display.newLayer()


	--背景
	local bg = display.newSprite(PATH.."loot/bg.png")
	setAnchPos(bg,240,427, 0.5 , 0.5)
	this.content:addChild(bg)
	--标题背景
 	local title_bgSp = display.newSprite(PATH.."change_title_bg.png")
 	setAnchPos(title_bgSp,240,628 , 0.5)
 	bg:addChild(title_bgSp)
	--标题文字
 	local title_Sp = display.newSprite(PATH.."loot/loot_title.png")
 	setAnchPos(title_Sp,240,650 , 0.5)
 	bg:addChild(title_Sp)

 	local loot_count = display.newSprite(PATH.."loot/loot_count.png")
 	setAnchPos(loot_count,51,170 )
 	this.content:addChild(loot_count)

 	local loot_max = display.newSprite(PATH.."loot/loot_max.png")
	 	setAnchPos(loot_max,261,170 )
 	this.content:addChild(loot_max)

 	this.content:addChild( display.strokeLabel( params.times1.."/"..params.times1max, 155 , 180 , 20 , ccc3(255 , 255 , 255) , 2 ) )			--劫掠次数
 	this.content:addChild( display.strokeLabel( params.times2.."/"..params.times2max, 375 , 180 , 20 , ccc3(255 , 255 , 255) , 2 ) )		--被劫上限

	-- 遮罩
	local mask = KNMask:new({item = this.content , priority = -210})
	this.layer:addChild( mask:getLayer() )
--
-- 	--关闭按钮
--    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 5 , 625 , {
--			priority = -212-2,
--			scale = true,
--			callback = function()
--				if params.backFun then
--					params.backFun()
--				end
--				mask:remove()
--			end})
--	bg:addChild(close:getLayer())
--	
	local function askFun()
		HTTP:call("fengshen","getJieLueRecord",{},{
		success_callback = function(data)
			this.content:addChild( self:recordLayer(data):getLayer() )
		end
		})
	end
	
	if params.isPopup then askFun() end
		
	local record_btn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" },270,115,{
			priority = -221 ,
			front = PATH.."loot/record.png",
			parent = scroll,
			callback = function()
				askFun()
			end 
	} )
	this.content:addChild( record_btn:getLayer() )
	
	bg:addChild(createLabel({str = "劫掠储量为0的对手将没有收获 ", color = ccc3(255,0,0), size = 20, x = 80, y = 150, width = 400}))
 
	local refresh_btn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" },50,115,{
--			other = {COMMONPATH.."gold.png", 135, 10},
--			text = {params.refresh_cd == 0 and 0 or params.refresh_cost, 20, ccc3(0x2c,0 ,0), ccp(105,0)},
			priority = -221 ,
			front = PATH.."loot/refresh_text.png",
			parent = scroll,
			callback = function()
--				HTTP:call("fengshen","getJLList",{refresh = 1 },{
--						success_callback = function(tempData)
--							this:refreshJLList(tempData)
--						end
--					})
				if params.refresh_cd > 0 then 
					local layer = display.newLayer()
					local text = createLabel({str = "是否确定清除等待时间?", size = 20, width = 300, color = ccc3(0x2c,0,0)})
					setAnchPos(text, 240, 425, 0.5, 0.5)
					layer:addChild(text)
					
					local gold = display.newSprite(COMMONPATH.."gold.png")
					setAnchPos(gold, 90, 260)
					layer:addChild(gold)
					
					local cost = createLabel({str = params.refresh_cost, size = 20, color = ccc3(0x2c,0,0)})
					setAnchPos(cost, 130, 260)
					layer:addChild(cost)
					
					
					showTip({
						content = layer,
						priority = -230,
						left = {
							remove = true,
							callback =function()
								this.layer:removeFromParentAndCleanup(true)
								HTTP:call("fengshen","clearJLListCd",{}, {
									success_callback = function()
										params.fun(0)
									end
								})
							end
						},
						right = {
							remove = true
						}
					})
				else
					this.layer:removeFromParentAndCleanup(true)
					params.fun(1)
				end
			end 
	} )
	this.content:addChild( refresh_btn:getLayer() )
	
	local close = KNBtn:new(COMMONPATH, { "back_img.png" , "back_img_press.png" },30,720,{
			priority = -221 ,
			callback = function()
				this.layer:removeFromParentAndCleanup(true)
			end 
	} )
	this.content:addChild( close:getLayer() )
	
	local cd = createLabel({str = timeConvert(params.refresh_cd), color = ccc3(0x2c, 0, 0), size = 20, x = 90, y = 90})
	this.content:addChild( cd)
	
	Clock:addTimeFun("refresh_loot", function()
		if params.refresh_cd > 0 then
			params.refresh_cd = params.refresh_cd - 1	
			cd:setString(timeConvert(params.refresh_cd))
		end
	end)
	

	this:refreshJLList(params)

    return this
end


function M:refreshJLList(param)
	if self.scrollLayer then 
		self.content:removeChild( self.scrollLayer , true )
	end
	self.scrollLayer = display.newLayer()
	local scroll = KNScrollView:new( 17 , 260 , 448 , 460 , 5 , false , 0 , { priority = -221} )

	for i = 1 , #param.userList do
		scroll:addChild( self:createItem(param.userList[i]) )
	end
	self.scrollLayer:addChild( scroll:getLayer() )
	self.content:addChild( self.scrollLayer )

--	for i = 1 , #param.userList do
--		local item =  self:createItem(param.userList[i]) 
--		setAnchPos(item, 10, 425, 0.5, 0.5)
--		self.content:addChild(item)
--	end

end

function M:createItem(param)
	local itemLayer = display.newLayer()
	local item_bg = display.newSprite( COMMONPATH .. "item_bg.png" )
	setAnchPos( item_bg , 0 , 0 )
	itemLayer:addChild( item_bg )

	local icon = KNBtn:new(COMMONPATH, { getHeadPath(param.icon or 19001) },20,23,{
			priority = -221 ,
			other = {COMMONPATH.."role_frame.png", -1, -3},
			parent = scroll,
			callback = function()
			end 
		} )
	itemLayer:addChild(icon:getLayer())

	local hire_btn = KNBtn:new(COMMONPATH, { "btn_bg.png" , "btn_bg_pre.png" },343,40,{
			priority = -221 ,
			front = PATH.."loot/loot.png",
			parent = scroll,
			callback = function()
				HTTP:call("fengshen","jielue",{ uid2 = param.uid , serverID2 = param.server_id },{
						success_callback = function(data)
							DATA_Battle:setMod("guide")
							DATA_Battle:setAct("join")
							DATA_Battle:set( data )
							DATA_Result:set( { type = "join" , join_type = "loot" , material = tonumber(data.mine) , success = data["win"] } )
							switchScene("battle" , {})
						end
					})
			end 
		} )
	itemLayer:addChild(hire_btn:getLayer())

	itemLayer:addChild( display.strokeLabel( "姓名:" .. (param.name or "") , 95 , 70 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	itemLayer:addChild( display.strokeLabel( "大区:" .. (param.server_name or ""), 95 , 45 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	itemLayer:addChild( display.strokeLabel( "战力:" .. (param.ability or "") , 95 , 20 , 20 , ccc3(69 , 28 , 6) , 2 ) )

	itemLayer:addChild( display.strokeLabel( "水晶矿储藏量:" .. (param.material or "") , 250 , 10 , 20 , ccc3(69 , 28 , 6) , 2 ) )


	itemLayer:setContentSize( item_bg:getContentSize() )
	return itemLayer
end

function M:recordLayer(param)
	local recordLayer =display.newLayer()
	--背景
	local bg = display.newSprite(PATH.."join/coolie_list_bg.png")
	setAnchPos(bg,240,146, 0.5)
	recordLayer:addChild(bg , -2)

	local tempImg = display.newSprite( PATH .. "loot/looted_label.png" )
	setAnchPos( tempImg , 35 , 633 )
	recordLayer:addChild( tempImg )
  
	tempImg = display.newSprite( PATH .. "loot/loot_label.png" )
	setAnchPos( tempImg , 35 , 405 )
	recordLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "loot/label_bg.png" )
	setAnchPos( tempImg , 30 , 628 )
	recordLayer:addChild( tempImg , -1 )

	tempImg = display.newSprite( PATH .. "loot/label_bg.png" )
	setAnchPos( tempImg , 30 , 400 )
	recordLayer:addChild( tempImg , -1)

	tempImg = display.newSprite( PATH .. "loot/log_frame.png" )
	setAnchPos( tempImg , 22 , 457 )
	recordLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "loot/log_frame.png" )
	setAnchPos( tempImg , 22 , 230 )
	recordLayer:addChild( tempImg )

	--劫掠列表
	local scroll_loot = KNScrollView:new( 26 , 238 , 425 , 156 , 0 , false , 0 , { priority = -223} )

	for i = 1 , #param.log1 do
		scroll_loot:addChild( self:lootItemLayer(param.log1[i]) )
	end
	recordLayer:addChild( scroll_loot:getLayer() )

	--被劫掠列表
	local scroll_looted = KNScrollView:new( 26 , 468 , 425 , 156 , 0 , false , 0 , { priority = -223} )
	local sortListOfLog2 = getSortList(param.log2)
	for i  = 1 , #sortListOfLog2 do
		scroll_looted:addChild( self:lootedItemLayer(param.log2[sortListOfLog2[i]] ,scroll_looted ))
	end	
	recordLayer:addChild( scroll_looted:getLayer() )

 	--关闭按钮
    local close = KNBtn:new(COMMONPATH, {"long_btn.png","long_btn_pre.png" }, 180 , 20 , {
    		front = COMMONPATH .. "colse_text.png" ,
			priority = -223,
			scale = true,
			callback = function()
				mask:remove()
			end})
	bg:addChild(close:getLayer())
 	mask = KNMask:new({item = recordLayer, click = function(x, y)  end ,priority= -222})

	return mask
end

function M:loot_text(param)
	local tempStr
	if param.type == "jielue"then
		if param.win == 1 then
			tempStr = "成功劫掠【" .. param.name .. " 】, 获得" .. param.add .. "水晶储量"
		else
			tempStr = "劫掠【" .. param.name .. "】失败 " 
		end
	elseif param.type == "fuchou" then
		if param.win == 1 then
			tempStr = "【"..param.name.."】第"..param.count.."次复仇失败"
		end
	end
	return tempStr
end

function M:looted_text(param)
	local tempStr
	if param.type == "jielue"then
		if param.win == 0 then
			tempStr = "被【" .. param.name .. "】劫掠, 损失:" .. param.add .. "水晶储量"
		else
			tempStr = "劫掠【" .. param.name .. "】失败 " 
		end
	elseif param.type == "fuchou"then
		tempStr = "被【" .. param.name .. "】复仇, 损失:" .. param.add .. "水晶储量"
	end
	return tempStr
end

function M:lootItemLayer(param)
	local recordItemLayer = display.newLayer()
	recordItemLayer:addChild( display.strokeLabel( self:loot_text(param) , 50 , 15 , 16 , ccc3(69 , 28 , 6) , 2 ) )

	local img = display.newSprite( PATH .. "loot/line.png" )
	setAnchPos( img , 212 , 0 , 0.5 )
	recordItemLayer:addChild( img )

	img = display.newSprite( PATH .. "loot/looted_point.png" )
	setAnchPos( img , 15 , 10 )
	recordItemLayer:addChild( img )

	recordItemLayer:setContentSize( CCSizeMake( 425 , 52 ) )
	return recordItemLayer
end

function M:lootedItemLayer(param , scroll)
	local recordItemLayer = display.newLayer()
	recordItemLayer:addChild( display.strokeLabel( self:looted_text(param) , 80 , 15 , 16 , ccc3(69 , 28 , 6) , 2 ) )

	local img = display.newSprite( PATH .. "loot/line.png" )
	setAnchPos( img , 212 , 0 , 0.5 )
	recordItemLayer:addChild( img )

	local fuchou_btn = KNBtn:new(PATH.."loot/", { "fuchou.png"  , "fuchou_pre.png" },10,10,{
			priority = -223 ,
			parent = scroll,
			callback = function()
				HTTP:call("fengshen","fuchou",{ uid2 = param.uid , serverID2 = param.server_id },{
						success_callback = function(data)
							DATA_Battle:setMod("guide")
							DATA_Battle:setAct("join")
							DATA_Battle:set( data )
							DATA_Result:set( { type = "join" , join_type = "fuchou" , success = data["win"] , server_name = data.server_name2 , name = param.name ,  material = tonumber(data.material) } )
							switchScene("battle" , {})
						end
					})
			end 
		} )
	recordItemLayer:addChild( fuchou_btn:getLayer() )	

	recordItemLayer:setContentSize( CCSizeMake( 425 , 52 ) )

	return recordItemLayer
end

function M:getLayer()
	return self.layer
end

return M