local PATH = IMG_PATH.."image/scene/ranklist/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local RankItem = { layer }

function RankItem:new(kind,  parent, data, index, callback)
	local this = {}
	setmetatable(this,self)
	self.__index = self

	this.layer = display.newLayer()


	local bg = display.newSprite(index == 0 and IMG_PATH.."image/scene/athletics/self_bg.png" or COMMONPATH.."item_bg.png")
	setAnchPos(bg)
	this.layer:addChild(bg)

	this.layer:setContentSize(bg:getContentSize())

	if kind == "task" then
		local info = display.newSprite(IMG_PATH.."image/scene/godwar/task_info.png")
		setAnchPos(info, 20, 20)
		this.layer:addChild(info)

		info = createLabel({str = parent.desc.."("..parent.progress.."/"..parent.cond..")", color = ccc3(0x2c, 0, 0), size = 16, width = 300})
		setAnchPos(info, 120, 65)
		this.layer:addChild(info)

		info = createLabel({str = parent.award, color = ccc3(0x2c, 0, 0), size = 18, width = 300})
		setAnchPos(info, 90, 26)
		this.layer:addChild(info)

		local btnBg = {"btn_bg.png", "btn_bg_pre.png"}
		local front = COMMONPATH.."get.png"

		if tonumber(parent.finish) == 1 or  parent.progress >= parent.cond then
			if tonumber(parent.finish) == 1 then
				info = display.newSprite(IMG_PATH.."image/scene/godwar/finish.png")
				info:setScale(0.9)
				setAnchPos(info, 200, 0)
				this.layer:addChild(info)

				btnBg ={"btn_bg_dis.png"}
				front = COMMONPATH.."get_complete.png"
			end
		elseif tonumber(parent.finish) == 0 and (parent.progress < parent.cond) then
			front = IMG_PATH.."image/scene/godwar/go.png"
		end


		local btn = KNBtn:new(COMMONPATH, btnBg, 350, 20, {
			front = front,
			callback = function()
				if tonumber(parent.finish) == 1  then
					KNMsg.getInstance():flashShow("已领取")
					return
				elseif parent.progress < parent.cond then
					if parent.tasktype == "herolv" then
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar", {data = data, page = "hero"})
							end
						})
					elseif parent.tasktype == "petlv" then
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar", {data = data, page = "pet"})
							end
						})
					elseif parent.tasktype == "kuli" then
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar", {data = data, page = "people"})
							end
						})
					elseif parent.tasktype == "move" then
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar", {inWar = true, data = data})
							end
						})
					elseif parent.tasktype == "buypower" then
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar", {inWar = true, data = data, action = true})
							end
						})
					elseif parent.tasktype == "blood" then
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar", {inWar = true, data = data, bloodBox = true})
							end
						})

					elseif parent.tasktype == "revenge" then
						HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
								switchScene("godwar" ,{data = data, cur = "rank", field = true, kind = "warinfo"}) 
							end
							})
							else
								HTTP:call("fengshen", "getJFSummary", {}, {
							success_callback = function(data)
						switchScene("godwar", {inWar = true, data = data})
					end })
						end
							return
								end
							HTTP:call("fengshen", "finish_task", {task_id = parent.taskid}, {
					success_callback =function(result)
					data()
				KNMsg.getInstance():flashShow(result.award or "你得到了什么")
				end
					})
						end
						})
					this.layer:addChild(btn:getLayer())


		return this
		end

	local pos = data.index
	if pos then
		local text,y,x
		if pos < 4 and index ~= 0 then
			text = display.newSprite(PATH..pos..".png")
			x = 410
			y = 22
		else
			text = display.strokeLabel(pos.."", 0, 0, 48, ccc3(0xed, 0x17, 0x16))
			x = 410
			y = 30
		end
		
		setAnchPos(text, x,bg:getContentSize().height / 2, 1, 0.5)
		this.layer:addChild(text)
	end

		--	local icon = display.newSprite(SCENECOMMON.."/logo.png")
		--		setAnchPos(icon,17,24)
	--	this.layer:addChild(icon)
	--
	--	icon = display.newSprite(SCENECOMMON.."navigation/logo_bg.png")
	--	setAnchPos(icon,15,20)
	--	this.layer:addChild(icon)
	if kind ~= "gang" then
		local icon = KNBtn:new(IMG_PATH.."image/scene/godwar/" , { getHeadPath( data.icon or "19001", data.game or SHENZHAN_GROUP ) } , 50 ,bg:getContentSize().height / 2 , {
			anchMid = true,
			front = COMMONPATH.."role_frame.png",
			scale = true ,
			parent = parent,
			callback = function()
			end
			}):getLayer()
			this.layer:addChild(icon)
	end

	local game = {
			["tmsj"] = "唐门世界",
			["td"] = "绝世天府",
			["tgxy"] = "太古仙域",
		}

	local apend,str
		dump(data)
	if kind == "power" then
		str = "神力:"
		apend = "   服务器:"..data.server_name
		
		local grade = createLabel({str = "阶位:"..data.pos_name,  width = 200})
		setAnchPos(grade, 250, 25)
		this.layer:addChild(grade)
	elseif kind == "user" then
		str = "战贡:"
		apend = "   服务器:"..data.server_name
	elseif kind == "rob" then
		str = "神力:"
		apend = "   势力:"..game[data.game]
		local optBtn = KNBtn:new(COMMONPATH,{"btn_bg.png", "btn_bg_pre.png"}, 330, 30, {
			priority = -230,
			front = IMG_PATH.."image/scene/godwar/revenge.png",
			callback = callback
			})
		this.layer:addChild(optBtn:getLayer())
	else
		str = "战贡:"
		apend = "   势力:"..game[data.game]
	end
	
	local name = createLabel({str = data.name and data.name..apend or  game[data.game], width = 330, align = 0})
		setAnchPos(name, 90,bg:getContentSize().height / 2 + 20,0, 0.5)

	local y = bg:getContentSize().height / 2
	local timeInfo = os.date("*t", data.time)
	local score = createLabel({str = data.score and str..data.score or str..data.ability.. "    \n"..(data.type == "rob" and "他抢劫了你(" or "他向你复仇(")..timeInfo.month.."-"..timeInfo.day.."  "..timeInfo.hour..":"..timeInfo.min..")", width = 330 })
	setAnchPos(score, 90, y - 18, 0, 0.5)
	this.layer:addChild(score)

	if kind == "gang" then
		name:setString("帮会:"..name:getString())
		setAnchPos(name, 50,bg:getContentSize().height / 2 + 20,0, 0.5)

		setAnchPos(score, 50, y - 20, 0, 0.5)

		this.layer:addChild( display.strokeLabel( "服务器："..(data.server_name or "") , 160, y-31, 20, ccc3( 0x2c , 0x00 , 0x00 )) )

	end
		this.layer:addChild(name)

		return this

	end

	function RankItem:getLayer()
return self.layer
end

function RankItem:getHeight()
	return self.layer:getContentSize().height
end

return RankItem