local GoldEquipLayer = {
					layer,
					selectedItems,  -- 保存当前选择的装备
					lv_bar,			-- 经验条
					lv,				-- 经验
					tempExp,		-- 选择装备的的经验和初始经验想家
					attrLabel,		-- 升级增加的属性Label
					params,			
					initLv,			--初始化等级，用以判断升级增加了多少属性
					infoLayer,		--吞噬的信息层
					scrollLayer		--吞噬的滚动曾
				}
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local GOLDEQUIPPATH = IMG_PATH .. "image/scene/goldequip/"
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBar = requires(IMG_PATH, "GameLuaScript/Common/KNBar")
local Config_Property = requires(IMG_PATH , "GameLuaScript/Config/Property")
local equipgoldconf = requires(IMG_PATH , "GameLuaScript/Config/equipgoldconf")
local data_equipattr = requires(IMG_PATH , "GameLuaScript/Config/data_equipattr")

function GoldEquipLayer:new(param)

	
	local this = {}
	setmetatable(this,self)
	self.__index  = self
	this.layer = display.newLayer()
	this.selectedItems = {}
	this.gradeNeedExpTable = {}
	this.params = param.data
	this.initLv = this:getLvWithEquipExp(this.params["gexp"])
	local mask = KNMask:new({item = this.layer, priority = -202})

	local info_Layer = InfoLayer:new("detail" , 0, {title_text = GOLDEQUIPPATH.."compound_drawing.png", tail_hide = true, priority = -230, closeCallback = function()
		this.layer:removeChild(mask:getLayer(),true)
		popScene()
		if param.main then
			param.main[1]:createLayer(param.main[2], param.main[3])
		end
	end})

	this.layer:addChild( info_Layer:getLayer() , 100)

	local cu_bg = display.newSprite(IMG_PATH.."image/common/dark_bg.png")
	setAnchPos(cu_bg,0,86)
	this.layer:addChild(cu_bg , -1)
	
	local context_bg = display.newSprite(IMG_PATH.."image/scene/mosaic/ston_bg.png")
	setAnchPos(context_bg,17,110)
	this.layer:addChild(context_bg , -1)

	--升级按钮
	local updata_btn = KNBtn:new(IMG_PATH .. "image/common" , {"btn_bg_red.png","btn_bg_red_pre.png"} , 275,120 , {
			front = IMG_PATH.."image/scene/mosaic/font_updata1.png",
			priority = -202,
			scale = true,
			noHide = true,
			callback = function()
				if #getSortList( this.selectedItems) == 0 then
					KNMsg:getInstance():flashShow("请选择您需要吞噬的五星装备！")
					return false
				end
				local str=""

				for i=1 , #getSortList( this.selectedItems) do
					if i == #getSortList( this.selectedItems) then 
						str = str..getSortList( this.selectedItems)[i]
					else
						str = str..getSortList( this.selectedItems)[i]..","
					end
				end	

				HTTP:call("equip" , "goldequipfeed",{ target = param["pid"] ,  destroy = str },{success_callback =
					function(data)
						this.params["gexp"] = this.params["gexp"] + data["gexp_add"]
						this.params["gfigure"] = data["_D_bag"]["equip"][""..param["pid"]]["gfigure"]
						this.initLv = this:getLvWithEquipExp(this.params["gexp"])
						this.selectedItems = {}
						this:goldEquipInfoLayer(this.params)
						this:createScrollList(this.params)
					end
				})
			end
		})
	this.layer:addChild(updata_btn:getLayer())
		
	---取消按钮
	local stornieren = KNBtn:new(IMG_PATH .. "image/common" , {"btn_bg_red.png","btn_bg_red_pre.png"} , 60,120 , {
		front = IMG_PATH.."image/common/cancel.png",
		priority = -202,
		scale = true,
		noHide = true,
		callback = function()	
			popScene()
			if param.main then
			param.main[1]:createLayer(param.main[2], param.main[3])
			end
		end
	})
	this.layer:addChild(stornieren:getLayer())

	this:goldEquipInfoLayer(this.params)
	this:createScrollList(this.params)
	
	return mask:getLayer()
end

function GoldEquipLayer:goldEquipInfoLayer(param)
	if self.infoLayer then
		self.layer:removeChild(self.infoLayer, true)
		self.infoLayer = nil
	end

	self.infoLayer = display.newLayer()
	local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 80, 605, {
		front = getImageByType(param.cid, "s")	,
		text = { getConfig("equip", param.cid, "name")..(param.lv and "     Lv"..param.lv or ""), 14, ccc3(89,50,45), ccp(120, 20) },
		callback = function()
			
		end
	})
	self.infoLayer:addChild( btn:getLayer() )

	local star
	local starNum = getConfig("equip", param.cid , "star")
	for j = 1, starNum do
		star = display.newSprite(COMMONPATH .. "star.png")
		star:setScale(0.7)
		setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (188 + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, 660 - star:getContentSize().height - 3 )
		self.infoLayer:addChild(star)
	end

	local equip_lv , nextLv_exp , curExp= self:getLvWithEquipExp(param["gexp"] )
	-- print("equip_lv = " .. equip_lv .. " , nextLv_exp = " .. nextLv_exp .. " ,curExp = " .. curExp)

	self.infoLayer:addChild(display.strokeLabel(Config_Property[param["effect"]].."  + " .. param["figure"]+param["gfigure"] , 172, 613, 14 ,ccc3(89,50,45)))

	self.lv = display.strokeLabel( "Lv   "..equip_lv , 100 , 557, 14 , ccc3(44 , 0 , 2), 2 , ccc3(44 , 0 , 2))
	self.infoLayer:addChild( self.lv )
	self.tempExp = param["gexp"]
	self.lv_bar = KNBar:new("exp" ,  140 , 290 , { maxValue = nextLv_exp , curValue = curExp })
	self.infoLayer:addChild( self.lv_bar )

	self.layer:addChild(self.infoLayer)

	self:InfochangeWithExp(param["gexp"])
	-- return self.goldEquipInfoLayer
end

function GoldEquipLayer:getLvWithEquipExp(exp)
	--经验不能超过最大经验值，如果超过了，直接变成最大经验值
	local level = 1
	local max_lv = table.nums(equipgoldconf)

	local max_exp = equipgoldconf[""..max_lv]["exp"]
	local current_exp , next_level_exp
	exp = tonumber(exp) > tonumber(max_exp) and max_exp or tonumber(exp)
	exp = tonumber(exp) < 0 and 0 or tonumber(exp)
	--计算当前等级
	if exp == max_exp then
		level = max_lv
	else
		local front = 1
		local tail = table.nums(equipgoldconf)
		local mid = math.floor( (front + tail) / 2 )
		local count = 0
		while true do
			if exp >= equipgoldconf[mid..""]["exp"] and exp < equipgoldconf[(mid+1)..""]["exp"] then
				level = mid
				break
			end
			if equipgoldconf[mid..""]["exp"] > exp then 
				tail = mid
			end
			if equipgoldconf[mid..""]["exp"] < exp then 
				front = mid
			end
			mid = math.floor( (front + tail) / 2 )
			count = count + 1
			if count > max_lv then 
				break
			end
		end
	end
	--这一级到下一级所需要的经验
	if level == 1 then 
		next_level_exp = equipgoldconf["2"]["exp"]
		current_exp = exp
	else
		next_level_exp = equipgoldconf[(level+1)..""] ~= nil and (equipgoldconf[(level+1)..""]["exp"] - equipgoldconf[(level)..""]["exp"]) or 0
		current_exp = exp - equipgoldconf[level..""]["exp"]
	end
	return level , next_level_exp , current_exp 

end


function GoldEquipLayer:InfochangeWithExp(exp , type)
	local attr = data_equipattr["5"]["gold"..self.params["type"]]
	local equip_lv , nextExp , curExp = self:getLvWithEquipExp(exp , type)

	if self.attrLabel then 
		self.layer:removeChild(self.attrLabel , true)
	end
	if self.initLv~=equip_lv then
		self.attrLabel = createLabel({str = "+"..math.floor( (equip_lv-self.initLv) * tonumber(attr) ), x = 270, y = 615,size = 14, width = 310,color = ccc3(44 , 0 , 2)})
		self.layer:addChild( self.attrLabel )
	end
	self.lv:setString("Lv"..equip_lv)
	self.lv_bar:setCurValue( curExp )
	self.lv_bar:setMaxValue( nextExp )
end

function GoldEquipLayer:createScrollList(param)

	if self.scrollLayer then 
		self.layer:removeChild(self.scrollLayer, true)
		self.scrollLayer = nil
	end

	self.scrollLayer = display.newLayer()
	local addLyer = nil
	local sv = KNScrollView:new(20,200,439,340,0,false,false,
				{
					priority = -202
				}
		)	
	local temp_count = 0
	local temp_line = 1
	local layers = {}
	filter = { gfigure=-1 , exceptEquipInZhenfa = true }
	for k,v in pairs(DATA_Bag:getTable("equip", filter, nil, true)) do
		if v["star"] == 5 then
			
			if layers[ temp_line ] == nil then
				layers[ temp_line ] = display.newLayer()
				layers[ temp_line ]:setContentSize( CCSizeMake(480 , 114) )
			end



			-- flag=false
			-- dump(G_zhenfa_equip , "G_zhenfa_equip")
			-- if G_zhenfa_equip and table.nums(G_zhenfa_equip) ~= 0 then 
			-- 	for k1, v1 in pairs(G_zhenfa_equip) do
			-- 		for sk1, sv1 in pairs(v1) do
			-- 			if tonumber(sv1["equip_cid"]) == tonumber(v["cid"]) then
			-- 				flag=true
			-- 				break
			-- 			end
			-- 		end
			-- 	end
			-- end

			local equip_btn = nil

			temp_count = temp_count + 1

			equip_btn = KNBtn:new(IMG_PATH.."image/scene/common" , {"skill_frame1.png","yes.png"} , 65 + 120 * (temp_count - 1),37 , {
				front = getImageByType(v["cid"] , "s"),
				other = {{IMG_PATH .. "image/common/egg_num_bg.png",46,46}},
				text = {v["lv"] or 1,18,ccc3(0xff,0xff,0xff),ccp(23,24),nil,17},
				priority = -202,
				--scale = true,
				noHide = true,
				parent = sv,
				selectable = true,
				selectZOrder = 20,
				selectOffset = {17,-16},
				callback = function()
					if equip_btn:isSelect() == true  then 
						self.selectedItems[k] = nil
						self.tempExp = self.tempExp - GOLDEQUIP_EXP
						self:InfochangeWithExp(self.tempExp, "reduce")					
					else
						if self.tempExp == equipgoldconf[""..table.nums(equipgoldconf)]["exp"] then
							KNMsg:getInstance():flashShow("装备已达到最大等级，不可升级")
							return false
						end
						self.selectedItems[k] = 1
						self.tempExp = self.tempExp + GOLDEQUIP_EXP
						self:InfochangeWithExp(self.tempExp, "addExp")
					end
				end
				})
				layers[ temp_line ]:addChild(equip_btn:getLayer())


				local starNum = 5
				for j = 1, starNum do
					star = display.newSprite(COMMONPATH .. "star.png")
					star:setScale(0.7)
					setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (65 + 120 * (temp_count - 1) + equip_btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, 37- star:getContentSize().height - 3 )
					layers[ temp_line ]:addChild(star)
				end

				if temp_count == 3 then
					temp_line = temp_line + 1
					temp_count = 0
				end	
		end
	end
	
	for i = 1 , #layers do
		sv:addChild( layers[i] )
	end

	self.scrollLayer:addChild(sv:getLayer())
	self.layer:addChild(self.scrollLayer)

end

return GoldEquipLayer
