--[[

		武将装备单元格

]]--
local PATH = IMG_PATH .. "image/scene/hero/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local goldEquipLayer = requires(IMG_PATH , "GameLuaScript/Scene/groupequip/goldEquipUpgrade")

local M = { seatBtn }
function M:new(bx , by , data , touchFunc , parent , opened , isOther, from, priority )
	local this = {}
	setmetatable(this,self)
	self.__index = self
	
	--如果存在则销毁
--	if this.seatBtn then
--		this.seatBtn:removeFromParentAndCleanup( true )
--	end
	local str = nil
	local iconPath = nil
	if isset(data , "cid") then
		iconPath = getImageByType(data.cid , "s")
	else
		str = { data , 16 }
	end

	local btn_image = "skill_frame1.png"
	if opened ~= true then btn_image = "skill_frame3.png" end
	priority = priority or -128
	this.seatBtn = KNBtn:new( SCENECOMMON , { btn_image }, bx , by , { front = iconPath , text = str , scale = true , callback = touchFunc, priority= priority } )
	-- 等级
	local lvStr
	if isset(data , "lv") then
		local lv_bg_png = "skill_lv_bg.png"
		local lv_bg_x = 50
		local cid_type = getCidType(data["cid"])
		if isset(data , "cid") then
			if cid_type == "equip" then
				if from == "godwar" then
					lv_bg_png = "equip_lv_bg.png"
					lvStr = data["lv"]
				else
					if isOther then
						local clv = tonumber( DATA_OTHER:getBag( "equip" , data.id .. "" , "clv" ) )
						if DATA_OTHER:isQuench( data.id ) and clv > 0 then
							lv_bg_png = "equip_lv_bg2.png"
							lvStr = clv
						else
							lv_bg_png = "equip_lv_bg.png"
							lvStr = data["lv"]
						end
					else
						local clv = tonumber( DATA_Bag:get("equip", data.id , "clv" ) )
						if DATA_Bag:isQuench( data.id ) and clv > 0 then
							lv_bg_png = "equip_lv_bg2.png"
							lvStr = clv
						else
							lv_bg_png = "equip_lv_bg.png"
							lvStr = data["lv"]
						end
					end
				end

				lv_bg_x = 45
			else
				lvStr = data["lv"] or ""
			end
		end
	
		local star_border = display.newSprite(COMMONPATH.."star_border/border_"..getConfig(cid_type, data.cid, "star")..".png")
		setAnchPos(star_border, -14, -15)
		this.seatBtn:getLayer():addChild(star_border, 10)
		
		local lv_bg = display.newSprite(COMMONPATH .. lv_bg_png)
		setAnchPos(lv_bg , lv_bg_x , 50)
		this.seatBtn:getLayer():addChild(lv_bg , 10)

		local lv = CCLabelTTF:create( lvStr , FONT , 16)
		lv:setColor( ccc3( 0xff , 0xff , 0xff ) )
		setAnchPos(lv , 61 , 51 , 0.5)
		this.seatBtn:getLayer():addChild(lv , 11)

		local temp_data
		if isOther then
			temp_data = DATA_OTHER:getBag( "equip" , data["id"] )
		else
			if from == "godwar" then
				tmpd_data = data
			else
				temp_data = DATA_Bag:get("equip" , data["id"])
			end
		end

		if temp_data and cid_type == "equip" and getConfig("equip" , temp_data["cid"] , "isgold") == 1 then
			local equipsoul_lv_bg = display.newSprite(IMG_PATH .. "image/scene/goldequip/" .. "equipsoul_lv.png")
			setAnchPos(equipsoul_lv_bg , 55 , -23 , 0.5)
			this.seatBtn:getLayer():addChild(equipsoul_lv_bg , 10)
			local level = goldEquipLayer:getLvWithEquipExp(temp_data["gexp"])

			local lv = CCLabelTTF:create( level , FONT , 16)
			lv:setColor( ccc3( 255 , 255 , 255 ) )
			setAnchPos(lv , 53 , -15 , 0.5)
			this.seatBtn:getLayer():addChild(lv , 11)
		end
	end
	
	return this.seatBtn
end

return M