local PATH = IMG_PATH.."image/scene/home/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local HomeCard = requires(IMG_PATH,"GameLuaScript/Scene/home/homecard")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local infoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")

local SEVENPATH = PATH .. "sevenHaoli/"

GLOBAL_ONLINE_AWARD_TIME=-1
--[[
	首页
]]
local HomeLayer= {
	layer,
	strengthItemLayer ,    --强化按钮所在层，控制强化的子项是否显示
	formationLayer,
	btnLayer,
	cardItems,    --英雄卡片元素
	allow,  --允许进行卡片移动的判断
	move,
	kFtempLayer,
	kFcurLayer,
	kFcurLayer1,
	kFpos,
	kFfreshLayer,
	daySend,
	kFSenvenLayer,
	kFlayer,
	sendType,
}
local aideBtn

function HomeLayer:new(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	this.layer = display.newLayer()
	this.allow = true

	this.layer:addChild( infoLayer:new("home" , 3):getLayer() )
	
	if params and params.isFirst then 
		this:postSdkData(params)
	end

	local bg = display.newSprite(PATH .."main.jpg")
	setAnchPos(bg , 0 , 0)
	this.layer:addChild(bg,-3)
	
	bg = display.newSprite(PATH.."cloud.png")
	setAnchPos(bg,240, 70, 0.5)
	this.layer:addChild(bg , -1)

	this:createformation()

	if IN_COMPANY then
		local version_label = CCLabelTTF:create("公司内网" , FONT , 18)
		setAnchPos(version_label , 10 , 90)
		version_label:setColor( ccc3( 0x00 , 0x00 , 0x00 ) )
		this.layer:addChild( version_label )
	end
	
	--主页图标按钮初始化
	local function initBtn()
		if this.btnLayer then
			this.layer:removeChild(this.btnLayer , true)
		end

		this.btnLayer = display.newLayer()


		local guide_step = KNGuide:getStep()


		-- 出战按钮
		local btn_images = {"mission.png" , "mission_press.png"}
		local temp = KNBtn:new(PATH , btn_images , display.cx-178/2 , 173-181/2 , {
			callback = function()
				DATA_Mission:setByKey("current","map_id",DATA_Mission:get("max","map_id"))
				DATA_Mission:setByKey("current","mission_id",DATA_Mission:get("max","mission_id"))
--				if DATA_Mission:haveData(DATA_Mission:get("max","map_id")) then
--					switchScene("mission")
--				else
					HTTP:call("mission" , "get",{},{success_callback = function()
						switchScene("mission")
					end })
--				end
			end
		})
		this.btnLayer:addChild(temp:getLayer())
		
--		local aniMask = WindowLayer:createWindow()
--		aniMask:setContentSize(CCSizeMake(temp:getWidth() - 25, temp:getHeight() - 25))
--		setAnchPos(aniMask, 202, 124)
--		this.btnLayer:addChild(aniMask)
--		
--		local moveLight = display.newSprite(COMMONPATH.."move_light.png")
--		setAnchPos(moveLight, -moveLight:getContentSize().width)
--		aniMask:addChild(moveLight)
--		
--		local function moveFun()
--			local action
--			action = getSequenceAction(CCMoveTo:create(1, ccp(temp:getWidth(), 0)), CCDelayTime:create(2),CCCallFunc:create(function()
--				setAnchPos(moveLight, -moveLight:getContentSize().width)
--				moveLight:runAction(moveFun())
--			end))	
--			return action	
--		end
--		moveLight:runAction(moveFun())
			

		-- 新手引导
		if guide_step == 101 or guide_step == 209 or guide_step == 304 or guide_step == 505 or guide_step == 704 or guide_step == 810 or guide_step == 10005 or guide_step == 15210 or guide_step == 15006 or guide_step == 15111 or guide_step == 15804 then KNGuide:show( temp:getLayer() ) end


		-- 副本按钮
		local btn_images = {"fb.png" , "fb_press.png"}
		if checkOpened("fb_hero") ~= true then btn_images = {"fb_disable.png"} end
		local temp = KNBtn:new(PATH , btn_images , 128-108/2 , 253-86/2 , {
			callback = function()
				-- 判断等级开放
				local check_result = checkOpened("fb_hero")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end

				local fb_type = "hero"
				if guide_step == 800 then fb_type = "equip"
				elseif guide_step == 3000 or guide_step == 15200 then fb_type = "hero"
				elseif guide_step == 3100 then fb_type = "pet"
				elseif guide_step == 3200 then fb_type = "skill"
				end
				switchScene("fb" , {coming = fb_type})
			end
		})
		this.btnLayer:addChild(temp:getLayer())

		-- 新手引导
		if guide_step == 800 or guide_step == 3000 or guide_step == 15200 or guide_step == 3100 or guide_step == 3200 then KNGuide:show( temp:getLayer() ) end



		
		-- 竞技按钮
		local btn_images = {"compete.png" , "compete_press.png"}
		if checkOpened("athletics") ~= true then btn_images = {"compete_disable.png"} end
		local temp = KNBtn:new(PATH , btn_images , 404-108/2 , 162-86/2 , {
			callback = function()
				-- 判断等级开放
				local check_result = checkOpened("athletics")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end

				local fb_type = "equip"
				if guide_step == 3300 then pvp_type = "rob"
				elseif guide_step == 5000 then pvp_type = "swar"
				end
				switchScene("pvp" , {coming = pvp_type})
				
--
--
--				HTTP:call("athletics","get",{},{success_callback = 
--				function(data)
--					switchScene("athletics",{data = data })	
--				end})
			end
		})
		this.btnLayer:addChild(temp:getLayer())

		-- 新手引导
		if guide_step == 1300 or guide_step == 5000  or guide_step == 3300 then KNGuide:show( temp:getLayer() ) end

		
--日常任务按钮
		if DATA_NewDailyTask:get()['remain_day'] > 0 then
			local dailyTaskBtn = KNBtn:new(PATH , {"daily_task.png" , "daily_task_pre.png"} ,  380 , 615, { 
				callback = function ( )
					switchScene("dailyTask")
				end
			})
			this.btnLayer:addChild(dailyTaskBtn:getLayer())

			local dailyTaskData=DATA_NewDailyTask:get()
			local dailyTaskCountUnGet = 0 --达到条件并未领取奖励计数
			for i=1,#dailyTaskData['list'] do
				if dailyTaskData['list'][i]['finish']== dailyTaskData['list'][i]['num'] and dailyTaskData['list'][i]['receive']==0 then--达到条件并未领取奖励则加上提示动画
					
					dailyTaskCountUnGet=dailyTaskCountUnGet+1
					
					
				end
			end
			if dailyTaskCountUnGet>0 then
				local light = display.newSprite(PATH .. "dailyTaskLight.png",379,589+15,0,0)
				this.btnLayer:addChild(light)	
				local actions = CCArray:create()
				actions:addObject(CCFadeOut:create( 1 ))
				actions:addObject(CCFadeIn:create( 1 ))
				local seq = CCSequence:create(actions)
				seq = tolua.cast(seq,"CCActionInterval")
				local rep = CCRepeatForever:create( seq )
				light:runAction(rep)

				local numBg = display.newSprite(COMMONPATH .. "egg_num_bg.png",448,661,0,0)
				this.btnLayer:addChild(numBg)
				numBg:addChild(display.strokeLabel(dailyTaskCountUnGet , 7 , 3 , 16 , ccc3( 255 , 255 , 255)))

			end
		end

		--				添加战神之路按钮
		local flag=1
		local aresRoadNum=0
		local showaresRoadBtn=1

		if params~=nil then 
			if params._G_road_to_god and params._G_road_to_god~=nil and table.nums(params._G_road_to_god)>0  then
				G_road_to_god=params._G_road_to_god
			end 
		end 


		if G_road_to_god~=nil and table.nums(G_road_to_god)>0 then 

			if G_road_to_god.num then 
				aresRoadNum=G_road_to_god.num
			end

			if G_road_to_god.show then 
				showaresRoadBtn=G_road_to_god.show
			end

		end  

		if showaresRoadBtn==1 then 
			local aresRoadBtn = KNBtn:new(PATH , {"aresRoadBtn.png" , "aresRoadBtn_pre.png"} , 
			280 , 
			610, 
			{
				other = aresRoadNum > 0  and { COMMONPATH .. "egg_num_bg.png" , 60 , 60  } or nil,
				text = aresRoadNum > 0 and { aresRoadNum , 16 , ccc3( 0xff , 0xff , 0xff ) , { x = 26 , y = 27 } , nil , 17 }   or nil ,  
				scale = true,
				callback = function()
					HTTP:call("user" , "the_road_to_god", {} , {
							success_callback = function(data)
								switchScene("aresRoad",{data=data})
							end}
					)
				end
			}
			) 
			this.btnLayer:addChild(aresRoadBtn:getLayer())

				--			添加战神之路特效 
			if aresRoadNum>0 then
				local aresRoadBtnSge = display.newSprite(PATH .. "aresRoadBtnSge.png",275,605,0,0)
				this.btnLayer:addChild(aresRoadBtnSge)
				local actions = CCArray:create()
				actions:addObject(CCFadeOut:create( 1 ))
				actions:addObject(CCFadeIn:create( 1 ))
				local seq = CCSequence:create(actions)
				seq = tolua.cast(seq,"CCActionInterval")
				local rep = CCRepeatForever:create( seq )
				aresRoadBtnSge:runAction(rep)				 
			end 		

		else

		end

		--			七天豪礼
		local lightBl=1
		local showBl=1

		if G_seven_days_reward~=nil and table.nums(G_seven_days_reward)>0 then 
			if G_seven_days_reward.light then
				lightBl=G_seven_days_reward.light
			end
			if G_seven_days_reward.show then
				showBl=G_seven_days_reward.show
			end
		else
			showBl=0
			lightBl=0
		end
		

		if showBl==1 then
		--		添加七日豪礼按钮Icon
			if lightBl==1 then 
				eggIcon=display.newSprite(COMMONPATH.."egg_num_bg.png")
				setAnchPos(eggIcon,210-41,650)
				this.btnLayer:addChild(eggIcon,1)
			end

			local sevenHaoliBtn=KNBtn:new(SEVENPATH,{"sevenHliBtn.png","sevenHliBtn_pre.png"},
				109,
				618,
				{
					-- other = lightBl==1  and { COMMONPATH .. "egg_num_bg.png" , 60 , 60  } or nil,
					priority=-131,
					callback=function()
						--		进入七日豪礼的活动
						HTTP:call("user" , "seven_days_reward", {} , {
							success_callback = function(data)
								-- dump(data)
								self.kFtempLayer=baseMask(
								{
									titlePath={path=SEVENPATH.."kaiFu.png",offX=-10},
									bgInfo={y=96,path=SEVENPATH.."bg.png"},
									isShowBack = { x = 15 , y = 565+77 , backFun = function() 
										switchScene("home")
									end } ,
									special="sevenHaoLi",
									priority = -150
								})
								self:KaifuHappyFun(data)

							end}
						)
					end
				})
			this.btnLayer:addChild(sevenHaoliBtn:getLayer())

			-- 新手引导
			if KNGuide:getStep() == 15800 then
				KNGuide:show( sevenHaoliBtn:getLayer() , {
					remove = true
				})
			end
		end
		--在线奖励
		--dump(DATA_Info:get_type("_G_online_award"))	
		if DATA_Info:get_type("_G_online_award") and table.nums(DATA_Info:get_type("_G_online_award")) ~=0 then  --表不为空是有该活动
			local onLineAwardData = DATA_Info:get_type("_G_online_award")
			if GLOBAL_ONLINE_AWARD_TIME ==-1 then GLOBAL_ONLINE_AWARD_TIME = onLineAwardData.endtime end
			local onLineAwardBtn = KNBtn:new(PATH , {"onLineAward.png" , "onLineAward_pre.png"} ,  0 , 250, { 
					callback = function ( )
						if GLOBAL_ONLINE_AWARD_TIME == 0 then
								HTTP:call("activity" , "receive_online_award", {} , {
									success_callback = function(data)
										dump(data['result'])
										switchScene("home",{},function ()
											KNMsg.getInstance():flashShow(data['result']['str'])
											GLOBAL_ONLINE_AWARD_TIME=data['result']['_G_online_award']['endtime']
										end)
									end
								})
						else
							KNMsg.getInstance():flashShow("领取时间未达到，暂不可领奖")
						end
					end
				})
			this.btnLayer:addChild(onLineAwardBtn:getLayer())
			--在线奖励定时器
			
			local timeLab = display.strokeLabel("" , 5 , 230 , 18 , ccc3( 0 , 0 , 0) )
			this.btnLayer:addChild(timeLab)
			--dump(GLOBAL_ONLINE_AWARD_TIME)
			Clock:addTimeFun("ONLINE_TIME_CLOCK", function()
			    if GLOBAL_ONLINE_AWARD_TIME > 0 then
			    		
						GLOBAL_ONLINE_AWARD_TIME = GLOBAL_ONLINE_AWARD_TIME - 1
						
						if display.getRunningScene().name == "home" then							
							timeLab:setString(timeConvert(GLOBAL_ONLINE_AWARD_TIME,nil,false))
							timeLab:setVisible(true)
						end
						--timeLab:setString(timeConvert(GLOBAL_ONLINE_AWARD_TIME,nil,true))
				else
					Clock:removeTimeFun("ONLINE_TIME_CLOCK")
					timeLab:setVisible(false)
					local light = display.newSprite(PATH .. "onLineAwardLight.png",-5,242,0,0)
					this.btnLayer:addChild(light)	
					local actions = CCArray:create()
					actions:addObject(CCFadeOut:create( 1 ))
					actions:addObject(CCFadeIn:create( 1 ))
					local seq = CCSequence:create(actions)
					seq = tolua.cast(seq,"CCActionInterval")
					local rep = CCRepeatForever:create( seq )
					light:runAction(rep)	
				end
			end)
		end


		--显示红包消息层
		local showMsg = function ( data )
			--dump(data)
			local mask
			
		    local skillLayer = display.newLayer()  --兑换技能layer
		    setAnchPos(skillLayer,0,0,0.5,0.5)
		    skillLayer:setScale(0)
           	--背景
		    local bg =  display.newSprite(COMMONPATH.."tip_bg.png")
		    setAnchPos(bg, 240, 410, 0.5, 0.5)
		    skillLayer:addChild(bg)
		    
		     --前景
		    local fbg =  display.newSprite(COMMONPATH.."shade_bg3.png")
		    setAnchPos(fbg, 220, 243-100, 0.5 ,0.5)
		    bg:addChild(fbg)

		    local msg = display.strokeLabel( "\"".. data.username.."\",给您拜年啦,".. data.msg , 80 , 105 , 18, ccc3(  116, 16, 0 ) ,0,nil, {dimensions_width=250,dimensions_height=80})
		    bg:addChild( msg )

		    local msgType = data.type

		    --给他拜年或发红包
		    if msgType~=3 then
			    local btn = KNBtn:new( COMMONPATH , 
										{"long_btn.png","long_btn_pre.png"},
										(msgType==1 and 160 or 260 ) , 
										25,
										{
											priority = -129,
											front = PATH.. (msgType==1 and "geiTaBaiNian.png" or "geiTaFaHong.png" ),
											callback = 
											function()
												if msgType==1 then --去拜年
													HTTP:call("friends","get",{},{success_callback=
													function()
														pushScene("friend",{type="fromBaiNian", closeFun = function() popScene() end})
													end})
												else --发红包
													KNMsg.getInstance():boxShow( "是否消耗100黄金购买一个红包" ,{ 
																			confirmText = COMMONPATH .. "send.png" , 
																			confirmFun = function()
																					HTTP:call("activity","happy_new_year_give_redbag",{f_uid=data.from_uid},{success_callback=
																								function(receiveData)
																									KNMsg:getInstance():flashShow(receiveData.msg)
																								end})


																			  end , 
																			cancelFun = function() end 
																			} )
												end
											end
										})
			    bg:addChild(btn:getLayer())
		    end
		    --如果是红包消息
		    if msgType==2 then
		    	local hb = {cid="17180",num="1"}
		    	local hongBao = awardCell(hb,{})
		    	setAnchPos( hongBao , 60  , 20 , 0 , 0 )
				bg:addChild( hongBao )

				bg:addChild(display.newSprite( COMMONPATH .. "gold.png" , 140 ,35 , 0 , 0 ))
				bg:addChild(display.strokeLabel( "100" , 180 , 35 , 20, ccc3( 116, 16, 0)  ))
		    end


			local cancle_btn = KNBtn:new(COMMONPATH, {"back_img.png" , "back_img_press.png"}, 260+130 , 180+300 , {
					priority = -131,
					scale = true,
					callback = function()
						 --关闭该弹出层
						 skillLayer:runAction(getSequenceAction(CCEaseElasticIn:create(CCScaleTo:create(0.2,0.3)),CCCallFunc:create(function()
										HTTP:call("activity","happy_new_year_read_wish",{from_uid=data.from_uid,date=data.date,type=msgType},{success_callback=
												function()
													mask:remove()
												end})

							
				  		 end)))
					end
			})
 			skillLayer:addChild(cancle_btn:getLayer())

			--弹出动画
			skillLayer:runAction(getSequenceAction(CCEaseElasticOut:create(CCScaleTo:create(0.5,1)),CCCallFunc:create(function()   end)))

			mask = KNMask:new({item = skillLayer, click = function(x, y)  end,opacity=5})
		    return mask:getLayer()
		end


		--检查是否有恭贺新喜活动
		-- HTTP:call("activity","get",{  } , { success_callback = function(  )
		-- 		local  activityList = DATA_Activity:getlist()

		-- 			for k,v in pairs(activityList) do
		-- 				if v=="happy_new_year" then --如果有恭贺新喜活动,则检查红包,拜年消息
		-- 								HTTP:call("activity","happy_new_year_send_wishes",{},{success_callback=
		-- 													function(receiveData)
		-- 																dump(receiveData)
		-- 																--播放掉金币效果
		-- 																for i=1,#receiveData.wishes do
		-- 																	if receiveData.wishes[i].is_read==0 then
		-- 																		local  particleGold = CCParticleSystemQuad:create( PATH.. "gold.plist"); 
		-- 																 		setAnchPos(particleGold,240,870)
		-- 																 		this.btnLayer:addChild(particleGold)
		-- 																 		break
		-- 																	end
		-- 																end
																		

																		
		-- 																for i=1,#receiveData.wishes do
		-- 																	if receiveData.wishes[i].is_read==0 then
		-- 																		local tempLayer =  showMsg(receiveData.wishes[i])
		-- 																		this.btnLayer:addChild(tempLayer)
		-- 																	end
		-- 																end
																		
																		
		-- 													end})

		-- 				end
		-- 			end
		-- end})

		-- 礼包按钮
		local btn_images = {"gift.png", "gift2.png"}
		local temp = KNBtn:new(PATH , btn_images , 56-89/2 , 659-86/2 , {
			other = DATA_Notice:getGetNum() > 0  and { COMMONPATH .. "egg_num_bg.png" , 60 , 60  } or nil,
			text = DATA_Notice:getGetNum() > 0 and { 1 , 16 , ccc3( 0xff , 0xff , 0xff ) , { x = 26 , y = 27 } , nil , 17 }   or nil ,  
			callback = function()
				-- 判断等级开放
				local check_result = checkOpened("activity")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end

				--活动
				HTTP:call("activity" , "get", {} , {
					success_callback = function()
						switchScene("activity")
					end
				})
				
				--在线礼包
--				local onlineLayer = requires(IMG_PATH, "GameLuaScript/Scene/common/onlinegift")
--				display.getRunningScene():addChild( onlineLayer:new():getLayer() )
			end
		})

		if IN_BANHAO == nil then
			this.btnLayer:addChild(temp:getLayer())
		end

		-- 新手引导
		if guide_step == 10100 then KNGuide:show( temp:getLayer() ) end

		
		-- 打造按钮
		local btn_images = {"activity.png" , "activity_press.png"}
		if checkOpened("forge") ~= true then btn_images = {"activity_grey.png"} end
		local temp = KNBtn:new(PATH , btn_images , 363-108/2 , 253-86/2 , {
			callback = function()
				-- 判断等级开放
				local check_result = checkOpened("forge")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end

				switchScene("forge")
			end
		})
		temp:setEnable(true)
		this.btnLayer:addChild(temp:getLayer())

		-- 新手引导
		if guide_step == 1500 or guide_step == 1509 or guide_step == 3400 or guide_step == 3700 then KNGuide:show( temp:getLayer() ) end


		-- 宠物按钮
		local btn_images = {"pet.png" , "pet_press.png"}
		if checkOpened("pet") ~= true then btn_images = {"pet_disable.png"} end
		local temp = KNBtn:new(PATH , btn_images , 76-108/2 , 162-86/2 , {
			callback = function()
				-- 判断等级开放
				local check_result = checkOpened("pet")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end

				switchScene("pet")
			end
		})
		this.btnLayer:addChild(temp:getLayer())

		this.layer:addChild(this.btnLayer,11)

		-- 新手引导
		if guide_step == 400 or guide_step == 500 or guide_step == 1200 then KNGuide:show( temp:getLayer() ) end
	end

	initBtn()


	-- 进场的引导
	if KNGuide:getStep() == 100 then
		KNGuide:show( nil , {
			mask_clickable = true,
			callback = function()
				initBtn()
			end,
			x = -100,
			y = 300,
			width = 1,
			height = 1,
		})
	end


	--聊天入口
	local btn_images = {"aide.png" , "aide_press.png"}
	 homeTalk=nil
	if checkOpened("talk") ~= true then btn_images = {"aide_press.png"} end
	local temp = KNBtn:new( IMG_PATH .. "image/scene/chat/"  , {"talk_flag1.png"} , 441-85/2 , 284-70/2 , {
		priority = -150,
		scale = true ,
		front = IMG_PATH .. "image/scene/chat/talk_flag.png" , 
		callback = function()
			local tempType = DATA_Info:getSourceType()
			tempType = tempType == "custom" and "world" or tempType
			DATA_Info:setIsMsg( false )
			if DATA_Info:getIsOpen( ) then
				local talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/talk")
				homeTalk = talkLayer:new( { type = tempType } )
				local curScene = display.getRunningScene()
				curScene:addChild( homeTalk:getLayer()  )
			else
				homeTalk:remove()
			end
			DATA_Info:setIsOpen( not DATA_Info:getIsOpen( ) )
		end
	})

	if IN_BANHAO == nil then
		this.btnLayer:addChild(temp:getLayer())
		DATA_Info:addActionBtn( "home" , temp )
	end
	
--	if CHANNEL_ID == "tmsjIosAppStore" then
--		temp:getLayer():setVisible( false )
--		temp:setEnable(false)
--	end
	
--	local gangSp = display.newSprite( IMG_PATH .. "image/scene/chat/talk_flag2.png" , temp:getLayer():getContentSize().width/2 , temp:getLayer():getContentSize().height/2 , 0.5 , 0.5 )
--	gangSp:setVisible(false)
--	temp:getLayer():addChild( gangSp , 5 )
--	
--	local worldSp = display.newSprite( IMG_PATH .. "image/scene/chat/talk_flag3.png" , temp:getLayer():getContentSize().width/2 , temp:getLayer():getContentSize().height/2 , 0.5 , 0.5 )
--	worldSp:setVisible(false)
--	temp:getLayer():addChild( worldSp , 6 )
--	
--	DATA_Info:addActionBtn( "home" , { btn = temp , gang = gangSp , world = worldSp } )
	-- if G_SILVERCARD and G_SILVERCARD > 0 then
	-- 	dump(G_SILVERCARD)
	-- 	local silverUp = KNBtn:new(PATH, {"silver_up.png"}, 10, 640,{
	-- 		callback = function()
	-- 			KNMsg.getInstance():flashShow("当前进行闯关可获得多倍银币,于当日凌晨失效")
	-- 		end
	-- 	}) 
	-- 	this.layer:addChild(silverUp:getLayer())
	-- end
	
	-- if G_EXPCARD and G_EXPCARD > 0 then
	-- 	local expUp = KNBtn:new(PATH,{"exp_up.png"}, 60, 640, {
	-- 		callback = function()
	-- 			KNMsg.getInstance():flashShow("当前进行闯关可获得多倍经验,于当日凌晨失效")
	-- 		end
			
	-- 	})
	-- 	this.layer:addChild(expUp:getLayer())
	-- end

    return this.layer
end

function HomeLayer:aideHandler()

	--关闭小助手
	if not OPENAIDE then return end

	-- 小助手按钮
	local cur_mission_step = DATA_Guide:get()
	if KNGuide:getStep() == 4200 or
	   (
			(cur_mission_step["map_id"] > 2  or (cur_mission_step["map_id"] == 2  and cur_mission_step["mission_id"] >= 6) ) and
			(cur_mission_step["map_id"] < 11 or (cur_mission_step["map_id"] == 11 and cur_mission_step["mission_id"] < 5) )
		)
	then
		aideBtn = KNBtn:new(PATH , {"aide.png" } , 15 , 610 , {
			scale = true ,
			callback = function()
				if KNGuide:getStep() == 4201 then
					self:aideAction()
				else
					self:createAide()
				end
			end
		}):getLayer()
		
		display.getRunningScene():addChild( aideBtn , 0 )
		
		local light = display.newSprite(PATH.."aide_light.png")
		
		local function createAction()
			local action
			action = getSequenceAction(CCScaleTo:create(1,0.8),CCScaleTo:create(1,1),CCCallFunc:create(
			function()
				light:runAction(createAction())
			end))	
			return action
		end
		light:runAction(createAction())	
		setAnchPos( light , 43 , 43 , 0.5 , 0.5 )
		aideBtn:addChild( light )
		
		if KNGuide:getStep() == 4100 or KNGuide:getStep() == 4200 then
			KNGuide:show( aideBtn , {remove = true})
		end
	end
end

function HomeLayer:freshLayer(params,index)

	self.kFfreshLayer=display.newLayer()	
	self.kFtempLayer:addChild(self.kFfreshLayer,5)

	self.daySend=index

	self.kFfreshLayer:addChild(display.strokeLabel("第"..index.."天" or "",69,227,18,ccc3(0xff,0xff,0xff)))
	local  has_get=0
	local  high_light=0
	--	显示底部的奖励
	if params~=nil and table.nums(params)>0 then 
		local value=params[tonumber(index)]
		if value.has_get then 
			has_get=value.has_get
		end 

		if value.high_light then
			high_light=value.high_light
		end 

		if value and table.nums(value)>0 then 
			if value.award then 
				local award=value.award
				for i=1 ,#award do 
					local curProp = awardCell(award[i])
					setAnchPos(curProp,70+(i-1)*85,147)
					self.kFfreshLayer:addChild(curProp,2)
				end 
			end 
		end
	end

	local getBtn=KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},
		305,
		158,
		{
			front=has_get==1  and  COMMONPATH.."get_over.png" or high_light==1 and COMMONPATH.."get.png" or SEVENPATH.."noavaiblr.png",
			priority=-151,
			noTouch=false,
			callback=function()
				dump(self.daySend)
				dump(self.sendType)
				HTTP:call("user" , "get_seven_days_reward", {day=self.daySend,type=self.sendType} , {
					success_callback = function(data)
						
						KNMsg:getInstance():flashShow(data.msg or "")

						if self.curLayer~=nil then
							self.curLayer:removeFromParentAndCleanup(true)
							self.curLayer=nil
						end
							
						if self.curLayer1~=nil then
							self.curLayer1:removeFromParentAndCleanup(true)
							self.curLayer1=nil
						end

						if self.kFfreshLayer~=nil then
							self.kFfreshLayer:removeFromParentAndCleanup(true)
							self.kFfreshLayer=nil
						end

						if data then
							local _G_seven_days_reward={}
							if data._G_seven_days_reward then 
								_G_seven_days_reward=data._G_seven_days_reward
							end 

							if data.data then
								self:KaifuHappyFun(data.data,self.sendType)
								local eggIconBl
								if _G_seven_days_reward then 
									if _G_seven_days_reward.light then 
										eggIconBl=_G_seven_days_reward.light
										if tonumber(eggIconBl)~=1 then 
											if eggIcon~=nil then
												
											end 
										end 
									end 
								end 
								
							end
						end
						
					end
				})


				-- 新手引导
				if KNGuide:getStep() == 15802 then
					KNGuide:show(nil , {
						callback = function()
							KNGuide:setStep(15804)
						end,
						remove = true,
						x = 8,
						y = 638,
						width = 60,
						height = 60,
					})
				end
			end
		})
	self.kFfreshLayer:addChild(getBtn:getLayer(),5)

	if KNGuide:getStep() == 15801 then
		KNGuide:show(getBtn:getLayer() , {remove = true})
	end
end

function HomeLayer:changeChi(index)
	if index<0 or index>100 then return nil end
	if index==0 then return "零" end
	if index==1 then return "一" end
	if index==2 then return "二" end
	if index==3 then return "三" end
	if index==4 then return "四" end
	if index==5 then return "五" end
	if index==6 then return "六" end
	if index==7 then return "七" end
	if index==8 then return "八" end
	if index==9 then return "久" end
	if index==10 then return "十" end
end

function HomeLayer:attendanceFun(params,index)

	self.curLayer1=display.newLayer()
	self.kFtempLayer:addChild(self.curLayer1,10)
	self.sendType = "common"

	if index==1 then
		self.curLayer1:addChild(display.newSprite(SEVENPATH.."textCustom.png",30,463,0,0))
		self.sendType="common"
	else
		self.curLayer1:addChild(display.newSprite(SEVENPATH.."textLux.png",30,463,0,0))
		self.sendType="luxury"
	end

	local high_light={}
	local has_get={}
	local count=1
	if params~=nil and table.nums(params)>0 then
		for i=1,#params do
			if params[i].has_get then
				if  params[i].has_get==1 then
					has_get[count]={name=i}
					count=count+1
				end
			end
		end
	end

	count=1
	if params~=nil and table.nums(params)>0 then
		for i=1,#params do
			if params[i].high_light then
				if params[i].high_light==1 then
					high_light[count]={name=i}
					count=count+1
				end
			end
		end
	end



	if has_get~=nil and table.nums(has_get)>0 then
		table.sort(has_get,function(a,b)
			return a.name<b.name
			end)
	end

	if high_light~=nil and table.nums(high_light)>0 then
		table.sort(high_light,function(a,b)
			return a.name<b.name
			end)
	end

	for i=1 ,#self.kFpos do
		local nowDaysBgX=self.kFpos[i].x+20
		local nowDaysBgY=self.kFpos[i].y

		if i==3 or i==#self.kFpos then
			nowDaysBgX=self.kFpos[i].x+40
		end

		--添加按钮
		local frameBtn=KNBtn:new(SEVENPATH,{"frame1.png","frame1.png"},
		nowDaysBgX-20,
		nowDaysBgY+5,
		{
			priority=-151,
			noTouch=false,
			callback=function()
				if self.kFfreshLayer~=nil then
					self.kFfreshLayer:removeFromParentAndCleanup(true)
					self.kFfreshLayer=nil
				end
				self:freshLayer(params,i)
			end
		}):getLayer()
		self.curLayer1:addChild(frameBtn)

		if high_light~=nil and table.nums(high_light)>0 then
			for j=1,#high_light do
				if high_light[j].name==i then
					local effect = requires(IMG_PATH,"GameLuaScript/Common/KNEffect")
					effect.get(SEVENPATH, "award_eff"):addTo(frameBtn):scale(0.7):pos(frameBtn:getContentSize().width/2-10,frameBtn:getContentSize().height/2):anchor(0.5,0.5)
				end
			end
		else

		end

		if params[i] then
			if params[i].show_award_name then
				local show_award_name=params[i].show_award_name
					local len=string.len(show_award_name)
					if len>12 then
						self.curLayer1:addChild(display.strokeLabel(show_award_name or "",nowDaysBgX-5,nowDaysBgY-32,13,ccc3(0xff,0xff,0xff)))	
					else
						self.curLayer1:addChild(display.strokeLabel(show_award_name or "",nowDaysBgX+5,nowDaysBgY-22,13,ccc3(0xff,0xff,0xff)))
					end  
					
				end

			local award={}

			if params[i].award then
				award=params[i].award
				if award and table.nums(award)>0 then
				local curProp = awardCell(award[1])
					curProp:setScale(0.9)
					setAnchPos(curProp,nowDaysBgX-5,nowDaysBgY+10)
					self.curLayer1:addChild(curProp)
				end
			end


		end

		local nowDaysBg=display.newSprite(SEVENPATH.."bg3.png")
		setAnchPos(nowDaysBg,nowDaysBgX-5,nowDaysBgY+20)
		self.curLayer1:addChild(nowDaysBg)

		local textDays=createLabel({str = "第"..(self:changeChi(i) or "").."天", size = 12,color=ccc3(0xfe,0xfc,0xd3),width = 400})
		setAnchPos(textDays,nowDaysBgX+5,nowDaysBgY+35)
		textDays:setRotation(-38)
		self.curLayer1:addChild(textDays,10)


		if has_get~=nil and table.nums(has_get)>0 then
			for j=1,#has_get do
				if has_get[j].name==i then
					local availbleBg=display.newSprite(SEVENPATH.."availble.png",nowDaysBgX,nowDaysBgY+9,0,0)
					availbleBg:setScale(0.8)
					self.curLayer1:addChild(availbleBg,2)
					self.curLayer1:addChild(display.newSprite(SEVENPATH.."frame2.png",nowDaysBgX-13,nowDaysBgY-1,0,0))
				end			
			end
		else

		end

	end 

	if has_get~=nil and table.nums(has_get)==7 then
		--展示第七天
		self:freshLayer(params,7)
	else
		if high_light~=nil and table.nums(high_light)>0 then
			local index=tonumber(high_light[1].name)
			self:freshLayer(params,index)
		else
			self:freshLayer(params,table.nums(has_get)+1)
		end
	end
end



function HomeLayer:KaifuHappyFun(params,sendType)
	--数据初始化
	self.kFpos={
		{["x"]=100,["y"]=383},
		{["x"]=200,["y"]=383},
		{["x"]=280,["y"]=383},
		{["x"]=45,["y"]=283},
		{["x"]=145,["y"]=283},
		{["x"]=245,["y"]=283},
		{["x"]=325,["y"]=283},
	}


	--刷新数据
	self.curLayer=display.newLayer()
	self.kFtempLayer:addChild(self.curLayer,1)

	local lastDays=nil
	local common={}
	local luxury={}

	if params.surplus_day then
		lastDays=tonumber(params.surplus_day).."天"
	end
	if params.common then
		common=params.common
	end
	if params.luxury then
		luxury=params.luxury
	end

	self.curLayer:addChild(display.strokeLabel(lastDays or "",288,100,18,ccc3(0xed,0xbc,0x45)))

	if sendType~=nil then
		if sendType=="luxury" then 
			self:attendanceFun(luxury,2) 
		else
			self:attendanceFun(common,1) 
		end  
	else
		self:attendanceFun(common,1) 
	end 
	



	self.curLayer:addChild(display.newSprite(SEVENPATH.."newUser.png",16,518,0,0))
	self.curLayer:addChild(display.newSprite(SEVENPATH.."person_bea.png",210,546,0,0))

	--普通

	local customRetBtn=KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},
		90,
		495,
		{
			front=SEVENPATH.."customReg.png",
			priority=-151,
			noTouch=false,
			callback=function()

				if self.kFfreshLayer~=nil then
					self.kFfreshLayer:removeFromParentAndCleanup(true)
					self.kFfreshLayer=nil
				end


				if self.curLayer1~=nil then
					self.curLayer1:removeFromParentAndCleanup(true)
					self.curLayer1=nil
				end

				self:attendanceFun(common,1)
			end
		})
	self.curLayer:addChild(customRetBtn:getLayer(),5)


	--	奢华
	local luxRetBtn=KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},
		250,
		495,
		{
			front=SEVENPATH.."luxReg.png",
			priority=-151,
			noTouch=false,
			callback=function()

				if self.kFfreshLayer~=nil then
					self.kFfreshLayer:removeFromParentAndCleanup(true)
					self.kFfreshLayer=nil
				end


				if self.curLayer1~=nil then
					self.curLayer1:removeFromParentAndCleanup(true)
					self.curLayer1=nil
				end
				self:attendanceFun(luxury,2)
			end
		})
	self.curLayer:addChild(luxRetBtn:getLayer(),5)
	self.curLayer:addChild(display.newSprite(SEVENPATH.."textlastTime.png",130,100,0,0))
	self.curLayer:addChild(display.newSprite(SEVENPATH.."bottonAward.png",20,113,0,0))
	self.curLayer:addChild(display.newSprite(SEVENPATH.."diNdays.png",54,222,0,0))

end




function HomeLayer:aideAction()
    local actionAry = CCArray:create()
    actionAry:addObject( CCCallFunc:create( 
						function()
							if aideBtn then
								aideBtn:removeFromParentAndCleanup( true ) 
								aideBtn = nil
							end
						 	aideBtn = KNBtn:new(PATH , {"aide.png" , "aide_press.png"} , 15 , 620 , {
								callback = function()
									self:createAide()
								end
							}):getLayer()
							
							--打开设置界面
							local infoLayer = requires(IMG_PATH, "GameLuaScript/Scene/common/infolayer")
							infoLayer:showMoreBtn()
							
							local SettingLayer = requires(IMG_PATH, "GameLuaScript/Scene/common/setting")
							display.getRunningScene():addChild( SettingLayer:new():getLayer() )
							
							display.getRunningScene():addChild( aideBtn , 10 )
						 end ) )
    
    actionAry:addObject( CCCallFunc:create(
    					function()
							transition.moveTo( aideBtn , { time = 0.5 , x = 50 , y = 350 , onComplete = 
							function() 
								if aideBtn then
									aideBtn:removeFromParentAndCleanup( true ) 
									aideBtn = nil
								end
							end } )
    					end ))
    actionAry:addObject( CCCallFunc:create( 
						function()
    						aideBtn:removeFromParentAndCleanup( true ) 
							aideBtn = nil 
						end ) )
   aideBtn:runAction( CCSequence:create( actionAry ) )
end

function HomeLayer:basePopup( titlePath )
	local bg = display.newSprite( IMG_PATH .. "image/scene/mission/wipe_bg.png")
	local addX = 90
	local addY = 324
	
	local titleBg = display.newSprite( IMG_PATH .. "image/scene/mission/title_bg.png")
	setAnchPos(titleBg, addX , addY)
	bg:addChild(titleBg)
	
	local title = display.newSprite( titlePath )
	setAnchPos(title, addX - 24 , addY )
	bg:addChild(title)
	
	return bg
end

--小助手配置
function HomeLayer:createAide( params )

	--关闭小助手
	if not OPENAIDE then return end

	params = params or {}
	local layer = display.newLayer()
	local mask
	local AIDEPATH = IMG_PATH .. "image/scene/aide/"
	
	local bg = self:basePopup( AIDEPATH .. "title.png" )
	setAnchPos( bg , display.cx , display.cy + 30 , 0.5 , 0.5 )
	layer:addChild(bg)
	local configElement = { "exp" , "hero" , "equip" , "silver" }
	
	if checkOpened("pet") == true then
		configElement[ #configElement + 1 ] = "pet"
	end	
	if checkOpened("skill") == true then
		configElement[ #configElement + 1 ] = "skill"
	end
	for i = 1 ,#configElement do
		local addX , addY = 79 +  ( ( i - 1 ) % 2 ) * 179 , 486 - math.floor(( i - 1 )/2) * 74
		local tempBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" , "btn_bg_red2.png" }, 
			addX , addY ,
			{
				front = AIDEPATH .. "need_" .. configElement[i] .. ".png" ,
				priority = -142,	
				callback=
				function()
					switchScene( "aide" , { type = configElement[i] , backFun = function() switchScene( "home" , nil , function() self:createAide() end ) end} )
				end
			})
		layer:addChild( tempBtn:getLayer() )
	end
	
	--返回按钮
	local cancelBtn = KNBtn:new(COMMONPATH,{"back_img.png","back_img_press.png"},35,573,{
		scale = true,
		priority = -142,	
		callback = function()
			mask:remove()
		end
	})
	layer:addChild(cancelBtn:getLayer())
	
	setAnchPos( layer , -display.width , 0 )
	transition.moveTo( layer , {time = 0.5 , easing = "BACKOUT" , x = 0 })
	local scene = display.getRunningScene()
	mask = KNMask:new({ item = layer , priority = -141 })
	scene:addChild( mask:getLayer() )
end

function HomeLayer:createformation()
	self.formationLayer = display.newLayer():size(display.width, 360):pos(0, 303)
	self.formationLayer:setTouchEnabled(true)
	self.cardItems = {}
	
	--display.newSprite(PATH.."formation_view_bg.png"):anchor(.5, 1):pos(display.cx, 416):addTo(self.formationLayer)
	--display.newSprite(PATH.."my_formation.png"):anchor(.5, 1):pos(display.cx, 416):addTo(self.formationLayer)
	
	-- 新手引导
	local guide_step = KNGuide:getStep()
	if guide_step == 200 or guide_step == 300 or guide_step == 700 or guide_step == 1100 or guide_step == 2500 or guide_step == 4000 or guide_step == 10104 or guide_step == 15206 or guide_step == 15000 or guide_step == 15100 or guide_step == 806 then KNGuide:show( self.formationLayer , {height = 255} ) end
	
	--生成主页滑动卡牌
	for i = 1, 8 do
		self.cardItems[i] = HomeCard:new(135 , i , i > DATA_Formation:get_lenght())
		self.cardItems[i]:addTo(i,self.formationLayer)
	end
	
	--默认将第一个武将显示在最前方
	for k, v in pairs(self.cardItems) do
		v:setState(2,self)
	end
	
	if DATA_Formation:get_lenght() > 0 then
		DATA_Formation:setCur(DATA_Formation:get_index(1)["gid"])
	end
			
	local touchX, legal,lastX,time,speed
	self.formationLayer:registerScriptTouchHandler(function(type,x,y)
		--不在范围内直接跳过
		if not self.formationLayer:boundingBox():containsPoint(ccp(x,y)) then
			return false
		end
		if type == CCTOUCHBEGAN then
			touchX = x
			lastX = x
			legal = true
			time = os.clock()
		elseif type == CCTOUCHMOVED then
			local dir = x < lastX
			
			if math.abs(touchX - x) > 10 then
				touchX = x
				speed = os.clock() - time
				time = os.clock()
				if self.allow then
					self.move = true
					self.allow = false
					--下面是不进行循环移动的判断
--					if dir then
--						if self.cardItems[1].pos > -(#self.cardItems - 4) then
--							self.move = true
--							self.allow = false
--						end
--					else
--						if self.cardItems[1].pos < 3 then
--							self.move = true
--							self.allow = false
--						end
--					end
				end
				legal = false		
			end
			
			if self.move then
				self.move = false
				for i = 1, #self.cardItems do
					self.cardItems[i]:move(dir,self,speed)
				end
			end
			lastX = x
		else
			if legal and DATA_Formation:getCur() then
				if DATA_General:haveGet() then
					DATA_Formation:set_index(1)
					switchScene("hero",{gid = DATA_Formation:getCur()})
				else
					HTTP:call("general" , "get",{},{success_callback =
						function()
							DATA_General:haveGet(true)
							DATA_Formation:set_index(1)
							switchScene("hero",{gid = DATA_Formation:getCur() })
						end
					})
				end
			end
			touchX = 0
			lastX = 0
			legal = false	
		end
		return true
	end,false,0,false)
	
	self.layer:addChild(self.formationLayer)
end

function HomeLayer:postSdkData(params)

	local new_guy = 0
	if params.new_guy then 
		new_guy = 1 
	end
	if CHANNEL_ID == "tmsj.htios" then
		LuaCallHeiTaoSDK:getInstance():setServNameRoleName(DATA_Session:get("server_id"),DATA_Session:get("uid"),DATA_User:get("name"),DATA_User:get("lv"),new_guy)
	end


	if CHANNEL_ID == "tmsj.heitao" or CHANNEL_ID == "tmsj.heitao1" or CHANNEL_ID == "hy.changmeng" 
		or CHANNEL_ID == "hy.changmeng1" or CHANNEL_ID == "hy.changmeng2" or CHANNEL_ID == "hy.xinmei" 
		or CHANNEL_ID == "tmsj.xinyou1" or CHANNEL_ID == "tmsj.xinyou2" or __INNER_NEWSDK__  then
		
			DirectChannel.instance():call(
			{
				action = "loginServer",
				dataType = "1",
				server_id = DATA_Session:get("server_id"),
				server_name = DATA_GodCell:get("server_name"),
				user_lv = DATA_User:get("lv"),
				user_id = DATA_Session:get("uid"),
				user_name = DATA_User:get("name"),
				new_guy = new_guy,
				callback = function()
					
				end
			})
	end

	if CHANNEL_ID == "hy.changmeng" or CHANNEL_ID == "hy.changmeng1" or CHANNEL_ID == "hy.changmeng2"  then 
		DirectChannel.instance():call(
		{

			action = "recordInfo",
			dataType = "2",
			server_id = DATA_Session:get("server_id") ,
			user_lv = DATA_User:get("lv"),
			user_id = DATA_Session:get("uid"),
			user_name = DATA_User:get("name"),

			callback = function()

			end
		})
	end
end

return HomeLayer
