--[[

首页场景

]]


collectgarbage("setpause"  , 100)
collectgarbage("setstepmul"  , 5000)


-- [[ 包含各种 Layer ]]
local homeLayer = requires(IMG_PATH,"GameLuaScript/Scene/home/homelayer")
local infoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local M = {}
function M:create(params)
--	local noticeData = DATA_Notice:get()

	local scene = display.newScene("home")

	if TOP_THREE and table.nums(TOP_THREE) > 0 then
		local pos = {
			{240, 300},
			{80, 300},
			{410, 300}
		}

		local gameName = {
			["tmsj"] = "【唐门世界】",
			["td"] = "【绝世天府】",
			["tgxy"] = "【太古仙域】",
			["tgxy2"] = "【太古仙域】",
		}
		local path = IMG_PATH.."image/scene/godwar/top_show/"

		local show = display.newLayer()
		local bg = display.newSprite(path.."bg.jpg")
		setAnchPos(bg)
		show:addChild(bg)

		bg = display.newSprite(path.."title_bg.png")
		setAnchPos(bg,240,854,0.5,1)
		show:addChild(bg)

		bg = display.newSprite(path.."title_text.png")
		setAnchPos(bg,240,830,0.5,1)
		show:addChild(bg)

		for i = 1, 3 do
			local sign = display.newSprite(path.."flag_"..(TOP_THREE[i] and TOP_THREE[i].rank or i)..".png")
			setAnchPos(sign,pos[i][1],pos[i][2] + 250 + ( 3 - i) * 50, 0.5)
			show:addChild(sign)

			local icon = display.newSprite(path.."p_"..(TOP_THREE[i] and TOP_THREE[i].sex or 1).."_"..(TOP_THREE[i] and TOP_THREE[i].rank or i)..".png")
			setAnchPos(icon,pos[i][1],pos[i][2], 0.5)
			show:addChild(icon)

			local nameBg = display.newSprite(path.."name_bg.png")
			setAnchPos(nameBg,pos[i][1],pos[i][2] - i * 40, 0.5)
			show:addChild(nameBg)

			local name = createLabel({str = TOP_THREE[i] and gameName[TOP_THREE[i].game]..TOP_THREE[i].user_name or "暂无", color = ccc3(255,255,255), size = 18, width = 300})
			if i == 1 then
				setAnchPos(name, pos[i][1],pos[i][2] + 10 - i  * 40, 0.5)
			elseif i == 2 then
				setAnchPos(name, 0,pos[i][2] + 10 - i  * 40)
			else
				setAnchPos(name, 480,pos[i][2] + 10 - i  * 40, 1)
			end
			show:addChild(name)
		end

		local nameBg = display.newSprite(path.."time_bg.png")
		setAnchPos(nameBg,240, 0, 0.5)
		show:addChild(nameBg)

		local next = createLabel({str = "下届神战开启时间："..SHENZHAN_NEXT, color = ccc3(0xff,0xfb,0xd4), width = 480, size = 24})
		setAnchPos(next, 240, 0, 0.5)
		show:addChild(next)

		local seq = CCSequence:createWithTwoActions(CCRotateTo:create(1.5, 180), CCRotateTo:create(1.5, 360))
		local seq2 = CCSequence:createWithTwoActions(CCFadeTo:create(1, 255*.3), CCFadeTo:create(1, 255))
		display.newSprite(path .."yx-light2.png", display.cx, 170):addTo(show):run(CCRepeatForever:create(tolua.cast(seq, "CCActionInterval")))
		display.newSprite(path .."yx-light1.png", display.cx, 180):addTo(show):run(CCRepeatForever:create(tolua.cast(seq2, "CCActionInterval")))
		display.newSprite(path .."yx.png", display.cx, 170):addTo(show)

		show:setTouchEnabled(true)
		show:registerScriptTouchHandler(function()
			if TOP_THREE == nil then
				return
			end
			TOP_THREE = nil
			switchScene("home" ,{ isFirst = true } )
		end)

		scene:addChild(show)
	else
		scene:addChild(  homeLayer:new(params) )
		-- scene:addChild( infoLayer:new("home" , 3):getLayer() )
	end

	if DATA_Info:get_type("isShowWeiWangInfoLayer") then 
		 DATA_Info:set_type("isShowWeiWangInfoLayer" , nil)
		 local mask
		 mask = showOpenNewModel( {
		 		text = "威望加成将帮助你快速升级",
		 		frontStr = IMG_PATH .. "image/scene/userinfo/weiwan/info_label.png",
		 		title_text = "威望加成",
		 		okBtnCallback = function()
		 			HTTP:call("status" , "get" , {} , {
     					success_callback = function(tempData)
     						mask:remove()
    						switchScene("userinfo",tempData)
     					end
     				})
		 		
		 		end
		 	} )
		 scene:addChild( mask:getLayer() )
	end


	if KNFileManager.readfile("savefile.txt" , "sound" , "=") == "0" then
	else
		audio.stopMusic( false )
		audio.disable()
	end

	if KNFileManager.readfile("savefile.txt" , "audio" , "=") == "0" then
		audio.setIsEffect( true )
	else
		audio.setIsEffect( false )
	end
	--写入是否大于30级标记
	if DATA_User:get("lv")>=30 then
		KNFileManager.updatafile("savefile.txt" , "isOver30" , "=" , 1)
	end

	if audio.isMusicPlaying() == false then
		audio.preloadMusic(IMG_PATH .. "sound/background.mp3")
		SimpleAudioEngine:sharedEngine():setBackgroundMusicVolume(1)
		audio.playMusic( IMG_PATH .. "sound/background.mp3" , true )
	end



	local handle
	local function createNotice()
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
		handle = nil
		if DATA_Notice:getIsFirst() then
			local noticeData = DATA_Notice:get()
			if noticeData.broadcast then
				local noticeLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/notice")
				local curScene = display.getRunningScene()
				curScene:addChild( noticeLayer:new( {isFromHome = true} ):getLayer() )
			elseif DATA_HeadLine:get("_ranking_headlines_state") then
				local headlineLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/headline")
				local curScene = display.getRunningScene()
				curScene:addChild( headlineLayer:new():getLayer() )
			end
		end
	end
	handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc( createNotice , 0.01 , false)

	heartBeatCtl()

	function scene:onEnter()
		homeLayer:aideHandler()
		DATA_Info:setIsMsg()
	end
	function scene:onExit()
		DATA_Info:setIsOpen()
--		DATA_Info:addActionBtn( "home" , nil )	--删主界面聊天动画标记
	end
	return scene
end

return M
