--[[

	孵化层

]]--
local PATH = IMG_PATH.."image/scene/incubation/"
local PROPPATH = IMG_PATH.."image/prop/"
local NORMAL , CHOOSE , COOKING  = 1 , 2 , 3
local card_mask
local KNCardpopup = requires(IMG_PATH,"GameLuaScript/Common/KNCardpopup")
--[[英雄模块，首页点击英雄图标进入]]
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNComboBox = requires(IMG_PATH,"GameLuaScript/Common/KNComboBox")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local default = 2	--孵化花费类型 默认银两
local cellValue = 0 --单个孵化花费
local eggMax = 0	--总孵蛋数

local HatchLayer = {
	baseLayer ,
	layer ,
	eggs , 
	scroll ,
	goldText,
	totalText,
}
function HatchLayer:new( x , y , params )
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	this.state = NORMAL		--当前状态
	this.eggBtn = {}		--宠物蛋按钮
	this.hatchSeat = nil	--孵化位
	this.curEggType = 0 	--当前孵化级别
	this.isAction = false	--收取一个宠物后，是否做动画自动添加一个新的幻兽蛋到孵化位
	if not params then params = {} end
	
	this.baseLayer = display.newLayer()
	this.layer = display.newLayer()
	
	local bg = display.newSprite( COMMONPATH .. "mid_bg.png" )
	--背景纹理
	local topBg = display.newSprite(PATH.."bg.png")
	--幻兽之卵标题
	local petEggTitle = display.newSprite(PATH.."pet_egg.png")
	--孵化栏
	local hatchTitle2 = display.newSprite(PATH.."hatch_title2.png")
	--动画图片
	local effSp = display.newSprite(PATH .. "eff.png")
	--点击幻兽蛋进入孵化位
	local setTip = display.strokeLabel(replaceStr("点击幻兽蛋进入孵化位") , display.cx - 150 , 490 , 18 , ccc3( 0xf8 , 0xd2 , 0x5c ) , nil , nil , { dimensions_width = 300 , dimensions_height = 70 , align = 1 } ) 
	local getTip = display.strokeLabel( replaceStr("黄金孵化，有更高概率孵化出高星级幻兽")  , 104 , 132 , 16 , ccc3( 0xff , 0xf1 , 0xb7 ) )
	this.hatchTip = display.strokeLabel( ""  , 104 , 236 , 18 , ccc3( 0xff , 0xf1 , 0xb7 ) )
	
	setAnchPos( bg , 0 , 86 )
	setAnchPos(topBg , display.cx  , 118 , 0.5 , 0 )
	setAnchPos(petEggTitle , display.cx  , 700 , 0.5 )
	setAnchPos(hatchTitle2 , display.cx  , 485 , 0.5)
	setAnchPos( effSp , display.cx , 372 , 0.5 , 0.5)
	
	this.layer:addChild(bg)
	this.layer:addChild(topBg)
	this.layer:addChild(petEggTitle)
	this.layer:addChild(setTip)
	
	this.layer:addChild(getTip)
	this.layer:addChild(this.hatchTip)
	this.layer:addChild( effSp )
	this.layer:addChild(hatchTitle2)
	
	this.goldText = display.strokeLabel( "" , 120, 158, 18, ccc3( 0xff , 0xf1 , 0xb7 ))
	this.totalText = display.strokeLabel( "" , 325, 158, 18, ccc3( 0xff , 0xf1 , 0xb7 ))
	this.layer:addChild( this.goldText )
	this.layer:addChild( this.totalText )
	
	local rotationFun
	local function rotation( angle )
		transition.rotateTo( effSp , {
			time = 10 ,
			angle = -angle ,
			onComplete = function()
				angle = angle == 180 and 360 or 180
				rotationFun(angle)
			end
		})
	end
	
	
	--孵化请求
	local function askFun(  )
		local _type = default
		if _type == 1 and DATA_Account:get("gold") < cellValue then
			KNMsg:getInstance():flashShow("黄金不足，通过充值可以获得黄金")
			return
		end

		if _type == 2 and DATA_Account:get("silver") < cellValue then
			KNMsg:getInstance():flashShow("银两不足")
			return
		end

		if isBagFull() then
			return false
		end

		rotationFun = rotation( 180 )
		
		HTTP:call("pet", "hatch", { type =( _type == 1 and 2 or 1 )  ,  id = DATA_Bag:getEgg( this.curEggType + 2 ) },{
			success_callback = function( _data)
				this:refreshSeat()

				transition.stopTarget(effSp)
				
				local function dropBagBackFun()
					if DATA_Bag:getEggCount( this.curEggType ) > 0 then
						this.isAction = true
						this:createMachine( this.curEggType )
					else
						this.state = NORMAL
					end 
				end
				
				
				if _data.awards.drop then
					local cids = {}
					for key , v in pairs(_data.awards.drop) do
						cids[#cids + 1] = v
					end
					this:playGetCards(cids , { backFun = dropBagBackFun } )
				end
			end
		})
	end
	--孵化
	this.goldHatchBtn  = KNBtn:new( COMMONPATH , { "long_btn.png"  , "long_btn_pre.png" , "long_btn_grey.png" },
									 90 , 
									 180 , 
									 {
									 	scale = true , 
									 	front = PATH .. "hatch.png" , 
									 	callback = function()
									 		askFun()
									 	end
									 } )
	this.layer:addChild( this.goldHatchBtn:getLayer() )
	
	
	
	--一键孵化
	this.silverHatchBtn  = KNBtn:new( COMMONPATH , { "long_btn.png"  , "long_btn_pre.png" , "long_btn_grey.png" },
									 274 , 
									 180 , 
									 {
									 	scale = true , 
									 	front = PATH .. "one_key.png" , 
									 	callback = 
									 	function()
									 		local labStr=createLabel({str = "一键" .. replaceStr("孵化") .. "会将所选".. replaceStr("幻兽蛋") .. "最大化的用来".. replaceStr("孵化") , size = 24, width = 360})
									 		labStr:setDimensions( CCSize:new(360,labStr:getContentSize().height+10))
								 			showTip({
													title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
													title_text = PATH.."one_key_title.png",
													content = labStr,
													left = {
														path = COMMONPATH,
														normal = "btn_bg_red.png",
														pre = "btn_bg_red_pre.png",
														front = COMMONPATH.."ok.png",
														remove = true,
														callback = function()
															if isBagFull() then
															    return false
															end
															if default == 1 and DATA_Account:get("gold") < cellValue*eggMax then
																KNMsg:getInstance():flashShow("黄金不足，通过充值可以获得黄金")
																return
															end
													
															if default == 2 and DATA_Account:get("silver") < cellValue*eggMax then
																KNMsg:getInstance():flashShow("银两不足")
																return
															end
															
															HTTP:call("pet", "ok_hatch", { type = ( default == 1 and 2 or 1 ) ,  id = DATA_Bag:getEgg( this.curEggType + 2 ) },{
																success_callback = function( _data)
																	KNMsg:getInstance():flashShow( _data.msgstr )
																	
																	transition.stopTarget(effSp)
																		this.state = NORMAL
																		this:refreshSeat()
																		this:createMachine( this.curEggType )
																		this.curEggType = 0
																	
																	local effect = display.newSprite(IMG_PATH .. "image/scene/forge/onekey_effect.png")
																	setAnchPos(effect, 240, 425, 0.5, 0.5)
																	display.getRunningScene():addChild(effect, 10)
																	
																	effect:runAction(CCRepeatForever:create(CCScaleTo:create(0.6, 0.5)))
																	effect:runAction(getSequenceAction(CCJumpTo:create(0.6, ccp(240, 425), 150, 2), CCMoveTo:create(0.3, ccp(160, 40)), CCCallFunc:create(function()
																		display.getRunningScene():removeChild(effect, true)
																	end)))
																	
																	
			--														if _data.awards.drop then
			--															local cids = {}
			--															for key , v in pairs(_data.awards.drop) do
			--																cids[#cids + 1] = v
			--															end
			--															this:playGetCards(cids , { backFun = dropBagBackFun } )
			--														end
																end
															})
														end
													},
													right = {
															 path = COMMONPATH, 
															 normal = "btn_bg_red.png", 
															 pre = "btn_bg_red_pre.png",
															 front = COMMONPATH.."cancel.png",
															 remove = true
													  }})
											
									 	end
									 } )
	this.layer:addChild( this.silverHatchBtn:getLayer() )
	local comboBox
	local group = KNRadioGroup:new()
	
	this.cellSp = display.newSprite( COMMONPATH .. ( default == 2 and "silver.png" or "gold.png" ) ,  100 , 167 , 0.5 , 0.5 )
	this.totalSp = display.newSprite( COMMONPATH .. ( default == 2 and "silver.png" or "gold.png" ) , 305 , 167 , 0.5 , 0.5 )
	this.layer:addChild( this.cellSp )
	this.layer:addChild( this.totalSp )
	local function changeLayout( )
		if this.cellSp then
			this.cellSp:removeFromParentAndCleanup( true )
			this.cellSp = nil 
		end
		
		if this.totalSp then
			this.totalSp:removeFromParentAndCleanup( true )
			this.totalSp = nil 
		end
		
		this.cellSp = display.newSprite( COMMONPATH .. ( default == 2 and "silver.png" or "gold.png" ) ,  100 , 167 , 0.5 , 0.5 )
		this.totalSp = display.newSprite( COMMONPATH .. ( default == 2 and "silver.png" or "gold.png" ) , 305 , 167 , 0.5 , 0.5 )
		this.layer:addChild( this.cellSp )
		this.layer:addChild( this.totalSp )
		
		this.goldText:setString( "" )
		this.totalText:setString( "" )
		
		dump( this.curEggType )
		if this.curEggType ~= 0 then
			local cost = DATA_Incubation:get()
			
			cellValue = ( default == 2 and cost.silver[ this.curEggType + 2 .. "" ] or cost.gold[ this.curEggType + 2 .. "" ] )
			
			this.goldText:setString( cellValue )
			eggMax = ( DATA_Bag:getEggCount(this.curEggType) >= 50 and 50 or DATA_Bag:getEggCount(this.curEggType) )
			this.totalText:setString( eggMax * cellValue )
		end
		
		if this.state == NORMAL then
			this.cellSp:setVisible( false )
			this.totalSp:setVisible( false )
		end
	end
	
	local items = {}
	for i = 1, 2 do
		items[i] = KNBtn:new( COMMONPATH, { i == 1 and "gold.png" or "silver.png" , "star_select.png"}, 0, 0, {
			id = i,
			noHide = true,
			callback = function()
				default = i
				comboBox:autoShow()
				comboBox:refreshBtn( { front = COMMONPATH .. ( default == 1 and "gold.png" or "silver.png" ) })
				changeLayout()
			end
		},group)
	end
	comboBox = KNComboBox:new(80, 280, {
		dir = COMMONPATH,
		res = {"small_btn_bg.png", "small_btn_bg_pre.png"},
		front = COMMONPATH .. ( default == 1 and "gold.png" or "silver.png" ) ,
		bg = IMG_PATH .. "image/scene/gang/task/combo_bg.png",
		up = true,
		offset = 15,
		addX = 12,
		additionHeight = 15 ,
		items = items,
		default = default,
		itemsGroup = group
	})
	this.layer:addChild( comboBox:getLayer() )
	this.layer:addChild( display.newSprite( PATH .. "select_type.png" , 44 , 280 , 0 , 0 ) )--选择类型
	

	--生成宠物蛋
	for i = 1 , 3 do
		this:createMachine( i )
	end
	
	this:refreshSeat()
	


	
	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new("hatch" , 0 , {title_text = PATH.."title_text.png" , closeCallback =function() switchScene("pet") end })
	this.layer:addChild( this.infoLayer:getLayer() )

	return this
end
--刷新数据
function HatchLayer:refreshSeat( index )
	local tempTable
	if not index then
		tempTable = { text = { replaceStr( "孵化位" )  , 18 , ccc3( 0x72 , 0xc6 , 0xe5 ) , { x = 0 , y = 10} } , callback = function()end ,  front = nil , other = { PATH .. "free.png" , 19 , 4 } }
		
		self.cellSp:setVisible( false )
		self.totalSp:setVisible( false )
		self.goldText:setString("")
		self.totalText:setString("")
		
		self.goldHatchBtn:setEnable(false)
		self.silverHatchBtn:setEnable(false)
		
		self.hatchTip:setString( "" )
		
		local tempDelayAction = CCArray:create()
		tempDelayAction:addObject( CCDelayTime:create(0.5) )
		tempDelayAction:addObject( CCCallFunc:create(function()end) )
													
		self.layer:runAction(CCSequence:create( tempDelayAction ))
		
	else
		if self.state == NORMAL then
			self.curEggType = 0
			
			tempTable = { text = { "孵化位" , 18 , ccc3( 0x72 , 0xc6 , 0xe5 ) , { x = 0 , y = 10} } , callback = function()end ,  front = nil , other = { PATH .. "free.png" , 19 , 4 } }
			self.goldHatchBtn:setEnable(false)
			self.silverHatchBtn:setEnable(false)
			
			self.cellSp:setVisible( false )
			self.totalSp:setVisible( false )
			
			self.goldText:setString("")
			self.totalText:setString("")
			
			self.hatchTip:setString( "" )
			
		elseif self.state == CHOOSE then
		
			self.curEggType = index
			
			tempTable = { text = nil ,
							scale = true , 
							front =  PROPPATH .. "s_600" .. index .. ".png" ,
							frontScale = { 1 , nil , 10 } ,
							other = { PATH .. "egg_title" .. index .. ".png" , 8 , 6 } ,
							callback = 
							function()
								self.state = NORMAL
								self:refreshSeat( index )
								self:createMachine( index )
							end , 
						}
			self.goldHatchBtn:setEnable(true)
			self.silverHatchBtn:setEnable(true)
			
			local cost = DATA_Incubation:get()
			local lv = index + 2
			
			cellValue = ( default == 2 and cost.silver[ lv .. "" ] or cost.gold[ lv .. "" ] )
			
			self.goldText:setString( cellValue )
			eggMax = ( DATA_Bag:getEggCount(index) >= 50 and 50 or DATA_Bag:getEggCount(index) )
			self.totalText:setString( eggMax * cellValue )
			
			self.cellSp:setVisible( true )
			self.totalSp:setVisible( true )
			local tipTable = {
								["1"] = "初级幻兽蛋：可孵化出1-2星幻兽" ,
								["2"] = "中级幻兽蛋：可孵化出1-3星幻兽" ,
								["3"] = "高级幻兽蛋：可孵化出1-4星幻兽" ,
								}
			self.hatchTip:setString( replaceStr(tipTable[ index .. "" ]))
		elseif self.state == COOKING then
			
		end	
	end
	
	
	if self.hatchSeat then
		self.hatchSeat:removeFromParentAndCleanup( true )
	end
	--孵化位
	self.hatchSeat  = KNBtn:new( PATH , { "hatch_seat.png"  },
									 display.cx - 50 , 
									 308 , 
									 tempTable):getLayer()
	self.layer:addChild( self.hatchSeat )
	
end

--生成宠物蛋
function HatchLayer:createMachine( index )
	local eggNum = 	self.state == CHOOSE and  DATA_Bag:getEggCount( index ) - 1 or DATA_Bag:getEggCount(index)

	local posx=36 
	local eggNumstr=""

	if eggNum<=99 then 
		eggNumstr=""..eggNum
		posx=38
	else
	   eggNumstr="99+"
	   posx=41
	end 

	local tempData =  { 
						text = {eggNumstr, 18 , ccc3( 0xff , 0xff , 0xff ) , { x = posx , y = -29} , nil , 17 } , 
						scale = true , 
						front = ( eggNum > 0 and PROPPATH .. "s_600"  or PATH .. "g_600" ) .. index .. ".png" , 
						other = { { COMMONPATH .. "equip_lv_bg.png" , 65 , 4 } , {PATH .. "egg_title".. index .. ".png" , nil , -30 } } ,
						callback = function()
							
							if self.curEggType == 0 then
								self.isAction = true
								self.state = CHOOSE
								self:createMachine( index )
							else
								self.state = NORMAL
								self:createMachine( self.curEggType )
								
								self.isAction = true
								self.state = CHOOSE
								self:createMachine( index )
							end
						end ,
					}
					
	if self.eggBtn[index] then
		self.eggBtn[index]:getLayer():removeFromParentAndCleanup( true )
	end
	
	self.eggBtn[index] = KNBtn:new( IMG_PATH .. "image/scene/fb/" , { "item_bg.png"  },
									 116 + ( index - 1 ) * 80 , 
									 610 , 
									 tempData)
	self.eggBtn[index]:setEnable( eggNum > 0 )
	
	if eggNum > 99 then
		self.eggBtn[index]:getLayer():addChild( display.strokeLabel( "+", 86, 10, 16, ccc3( 0xff , 0xff , 0xff )))
	end
	--屏蔽中级幻兽蛋
	if index == 2 then
		self.eggBtn[index]:getLayer():setVisible( false )
		self.eggBtn[index]:setEnable( false )
	end
	self.layer:addChild( self.eggBtn[index]:getLayer() )

	if index == 1 and KNGuide:getStep() == 404 then
		KNGuide:show( self.eggBtn[index]:getLayer() , {
			callback = function()
				KNGuide:show( self.silverHatchBtn:getLayer() , {
					remove = true
				})
			end
		})
	end
	
	if self.isAction then
		self.isAction = false
		
		tempData.callback = nil
		tempData.text = nil
		tempData.other = nil
		--强制转换成正常宠物蛋	
		tempData.front = PROPPATH .. "s_600" .. index .. ".png" 
		
		local actionSp = KNBtn:new( IMG_PATH .. "image/scene/fb/" , { "item_bg.png"  },
									 60 + ( index - 1 ) * 136 , 
									 610 , 
									 tempData):getLayer()
									 
		self.layer:addChild( actionSp , 1)
		transition.moveTo( actionSp , {
			time = 0.5 , 
			x = display.cx - 41 , 
			y = display.cy - 96 ,
			onComplete =
			function()
			 	actionSp:removeFromParentAndCleanup( true )
			 	self:refreshSeat( index )
			end
		})
										
	end
	
end




function HatchLayer:getLayer()
	return self.layer
end
--------------------------------------------------------------------------------------------------
--
--
--[[播放卡牌获得动画]]
--
--
function HatchLayer:playGetCards(cids , params )
	local scene = display.getRunningScene()

	local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
	card_mask = KNMask:new({priority = -133})
	scene:addChild(card_mask:getLayer() , 100)

	local callback
	callback = function(index)
		local next_index = index + 1
		if cids[next_index] then
			self:playOneCard(cids[next_index] , next_index , callback)
		else
			-- scene:removeChild(card_mask , true)
			card_mask:remove()
			if params.backFun then params.backFun() end
		end
	end
	
	self:playOneCard(cids[1] , 1 , callback)
end

function HatchLayer:playOneCard(cid , index , callback)
	local scene = display.getRunningScene()
	local baseX = 42
	local baseY = 256

	local card_x = baseX + 49 + (index - 1) * 74
	local card_y = baseY - 153


	local tempPath = getImageByType(cid , "s")
	local btn = KNBtn:new( IMG_PATH .. "image/scene/common/" , { "skill_frame1.png" },
		card_x ,
		card_y ,
		{
			scale = true ,
			front = tempPath,
			priority = -132,
			callback = function()
				self:popOneCard(cid , index , function()
					-- scene:removeChild(card_mask , true)
					card_mask:remove()
				end)
			end
		})

	local handle
	handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
		award_handle = nil

		self:popOneCard(cid , index , callback)
	end , 0.22 , false)
end

function HatchLayer:popOneCard(cid , index , callback)
	local baseX = 42
	local baseY = 256
	local card_x = baseX + 49 + (index - 1) * 74
	local card_y = baseY - 153





	local card_popup = KNCardpopup:new(cid , function()
		callback(index)
	end , {
		init_x = card_x - 160,
		init_y = card_y - 211,
		end_x = card_x - 170,
		end_y = card_y - 500,
	})


	card_mask:getLayer():addChild( card_popup:play() )
end

return HatchLayer