--御花园主界面

local M = {
	 chooseObjBtn,  --神罚选择对象按钮
	 punishID=1,  --惩罚id 1~9
	 isKingSelf=false,  --是否为帝王本人
	 textLabel

}

local PATH = IMG_PATH .. "image/scene/kingGarden/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local KNComboBox = requires(IMG_PATH,"GameLuaScript/Common/KNComboBox")

--全局的，惩罚对象id
GLOBAL_PUNISH_OBJ_ID = 0
GLOBAL_PUNISH_OBJ_NAME =""
GLOBAL_XIANWU_TIME=0
GLOBAL_SHENFA_TIME=0
GLOBAL_SHENBOX_TIME=0

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
    --dump(args)
	-- 基础层
	this.baseLayer = display.newLayer()
	if args[1]['is_self']==1 then
		isKingSelf=true
	else
		isKingSelf=false
	end
   
	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "kingGarden" , 0 , { title_text = PATH.."gardenTitle.png", tail_hide = true, closeCallback = args.closeCallback or function()
		                 HTTP:call("status" , "get" , {} , {
								success_callback = function(params)
									switchScene("userinfo",params)
								end
							})
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 花园背景
	local gardenBgSp = display.newSprite(PATH .. "gardenBg.jpg")
	setAnchPos(gardenBgSp , 18, 115)
	this.baseLayer:addChild(gardenBgSp)
	
	--帝王lab
	local kingLabSp = display.newSprite(PATH .. "kingLab.png")
	setAnchPos(kingLabSp , 15, 575)
	gardenBgSp:addChild(kingLabSp)
	
	local kingNameLab = display.strokeLabel(args[1]['name'] , 70 , 577 , 20 , ccc3( 230 , 227 , 186) )
    gardenBgSp:addChild(kingNameLab)

    --仙音按钮
    local xianBtnImg
    local xianBtnBg
    if isKingSelf then
    	 xianBtnImg = PATH .. "xianyinLab.png"
    	 xianBtnBg = {"long_btn.png" , "long_btn_pre.png"}
    else
		 xianBtnImg = PATH .. "xianyinLabDisable.png"  --灰显图片
		 xianBtnBg = {"long_btn_grey.png"}
    end
    local xianyinBtn = KNBtn:new(COMMONPATH, xianBtnBg, 10 , 30 , {
			priority = -128,
			scale = true,
			front = xianBtnImg,
			callback = function()
   				if isKingSelf then
					local  xianYinMask = this:showXianYinLayer()
					this.baseLayer:addChild(xianYinMask:getLayer())
				end
			end})
	 gardenBgSp:addChild(xianyinBtn:getLayer())

	 local daoJiShiXian = display.newSprite(PATH .. "daoJiShi.png")
	 setAnchPos(daoJiShiXian,10,8)
	 gardenBgSp:addChild(daoJiShiXian)



	 local daoJiShiXianLab = display.strokeLabel( timeConvert(args[1]['garden']['music']['limit'],nil,true) , 75 , 8 , 18 , ccc3( 230 , 227 , 186) )
     gardenBgSp:addChild(daoJiShiXianLab)

     GLOBAL_XIANWU_TIME=args[1]['garden']['music']['limit']

     Clock:addTimeFun("XIANWU_TIME_CLOCK", function()
     	 if GLOBAL_XIANWU_TIME ~= 0 then
			GLOBAL_XIANWU_TIME = GLOBAL_XIANWU_TIME - 1
			daoJiShiXianLab:setString(timeConvert(GLOBAL_XIANWU_TIME,nil,true))		
		
		 end
	 end)

	 --神罚按钮

    local shenFaBtnImg
    local shenFaBtnBg 
    if isKingSelf then
    	 shenFaBtnImg = PATH .. "shenfaLab.png"
    	 shenFaBtnBg={"long_btn.png" , "long_btn_pre.png"}
    else
		 shenFaBtnImg = PATH .. "shenfaLabDisable.png"  --灰显图片
		 shenFaBtnBg={"long_btn_grey.png"}
    end
    local shenfaBtn = KNBtn:new(COMMONPATH,shenFaBtnBg, 170 , 30 , {
			priority = -128,
			scale = true,
			front = shenFaBtnImg,
			callback = function()
				if isKingSelf then
					local  shenFaMask = this:showShenFaLayer()
					this.baseLayer:addChild(shenFaMask:getLayer())
				end
			end})
	 gardenBgSp:addChild(shenfaBtn:getLayer())

	 local daoJiShiShen = display.newSprite(PATH .. "daoJiShi.png")
	 setAnchPos(daoJiShiShen,170,8)
	 gardenBgSp:addChild(daoJiShiShen)

	 local daoJiShiShenLab = display.strokeLabel(  timeConvert(args[1]['garden']['punish']['limit'],nil,true) , 237 , 8 , 18 , ccc3( 230 , 227 , 186) )
     gardenBgSp:addChild(daoJiShiShenLab)

     GLOBAL_SHENFA_TIME=args[1]['garden']['punish']['limit']

     Clock:addTimeFun("SHENFA_TIME_CLOCK", function()
     	 if GLOBAL_SHENFA_TIME ~= 0 then
			GLOBAL_SHENFA_TIME = GLOBAL_SHENFA_TIME - 1
			daoJiShiShenLab:setString(timeConvert(GLOBAL_SHENFA_TIME,nil,true))		
		
		 end
	 end)


    local shenBoxBtnImg
    local shenBoxBtnBg 
    if isKingSelf then
    	 shenBoxBtnImg = PATH .. "shenBoxLab.png"
    	 shenBoxBtnBg={"long_btn.png" , "long_btn_pre.png"}
    else
		 shenBoxBtnImg = PATH .. "shenBoxLabDisable.png"  --灰显图片
		 shenBoxBtnBg= {"long_btn_grey.png"}
    end
	 --神秘宝箱按钮
    local shenBoxBtn = KNBtn:new(COMMONPATH, shenBoxBtnBg, 320 , 30 , {
			priority = -128,
			scale = true,
			front = shenBoxBtnImg,
			callback = function()
				if isKingSelf then 

					HTTP:call("socialclass","get_boxinfo",{},{success_callback=
						function(buffStatusData)
							--dump(buffStatusData)
							local  shenBoxMask = this:showShenBoxLayer(buffStatusData)
					        this.baseLayer:addChild(shenBoxMask:getLayer())
						end})
					
				end
			end})
	 gardenBgSp:addChild(shenBoxBtn:getLayer())

     local daoJiShiBox = display.newSprite(PATH .. "daoJiShi.png")
	 setAnchPos(daoJiShiBox,320,8)
	 gardenBgSp:addChild(daoJiShiBox)
    
	 local daoJiShiBoxLab = display.strokeLabel( timeConvert(args[1]['garden']['box']['limit'],nil,true) , 386 , 8 , 18 , ccc3( 230 , 227 , 186) )
     gardenBgSp:addChild(daoJiShiBoxLab)
    
     GLOBAL_SHENBOX_TIME=args[1]['garden']['box']['limit']

    Clock:addTimeFun("SHENBOX_TIME_CLOCK", function()
     	 if GLOBAL_SHENBOX_TIME ~= 0 then
			GLOBAL_SHENBOX_TIME = GLOBAL_SHENBOX_TIME - 1
			daoJiShiBoxLab:setString(timeConvert(GLOBAL_SHENBOX_TIME,nil,true))		
		 end
	 end)

    
	return this 
end


function M:showXianYinLayer( )
	local mask
	--local xianYinLayer =CCLayerColor:create( ccc4(152 , 255 , 255 , 100) )   --帮会详情
	local xianYinLayer =display.newLayer()
	--setAnchPos(xianYinLayer,0,0,0.5,0.5)

	--背景
	local bg = display.newSprite(PATH.."layerBg.png")
	setAnchPos(bg,20,200)
	xianYinLayer:addChild(bg)

	--标题背景
 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
 	setAnchPos(title_bgSp,90,450)
 	bg:addChild(title_bgSp)

	--标题文字
 	local title_Sp = display.newSprite(PATH.."xianWuTitle.png")
 	setAnchPos(title_Sp,90,450)
 	bg:addChild(title_Sp)

 	--前景
 	local  fg = display.newSprite(PATH .. "xianWuFg.jpg")
 	setAnchPos(fg,10,20)
 	bg:addChild(fg)

 	--粒子
 	local  particleShine = CCParticleSystemQuad:create(PATH .. "shine.plist"); 
 	setAnchPos(particleShine,30,60)
 	fg:addChild(particleShine)
    
    --粒子
 	local  particleBlue = CCParticleSystemQuad:create(PATH .. "blue.plist"); 
 	setAnchPos(particleBlue,85,330)
 	fg:addChild(particleBlue)

    --邀请按钮
    local yaoQing = KNBtn:new(COMMONPATH, {"long_btn.png" , "long_btn_pre.png" }, 150 , 12 , {
			priority = -131,
			scale = true,
			front = PATH .. "yaoQingFriend.png",
			callback = function()
				HTTP:call("friends","get",{},{success_callback=
				function()
					pushScene("friend",{type="fromXianWu", closeFun = function() popScene() end})
				end})
				
			end})
	fg:addChild(yaoQing:getLayer())

	--关闭按钮
    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 0 , 450 , {
			priority = -131,
			scale = true,
			callback = function()
				mask:remove()
			end})
	bg:addChild(close:getLayer())

    local tips_label = display.strokeLabel("说明:邀请好友观看仙舞可获得荣誉奖励，快快邀请吧！" , 20 , 4 , 16 , ccc3( 255 , 0 , 0) )
    bg:addChild(tips_label)


	mask = KNMask:new({item = xianYinLayer, click = function(x, y)  end})
	return mask
end


function M:showShenFaLayer(  )
	local mask
	--local xianYinLayer =CCLayerColor:create( ccc4(152 , 255 , 255 , 100) )   --帮会详情
	local shenFaLayer =display.newLayer()
	--setAnchPos(shenFaLayer,0,0,0.5,0.5)

	--背景
	local bg = display.newSprite(PATH.."layerBg.png")
	setAnchPos(bg,20,200)
	shenFaLayer:addChild(bg)

	--标题背景
 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
 	setAnchPos(title_bgSp,90,450)
 	bg:addChild(title_bgSp)

	--标题文字
 	local title_Sp = display.newSprite(PATH.."shenFaTitle.png")
 	setAnchPos(title_Sp,90,450)
 	bg:addChild(title_Sp)

	--前景
 	local  fg = display.newSprite(PATH .. "shenFaFg.jpg")
 	setAnchPos(fg,10,73)
 	bg:addChild(fg)

 	--粒子
 	local  particleFire = CCParticleSystemQuad:create(PATH .. "fire.plist"); 
 	setAnchPos(particleFire,40,265)
 	fg:addChild(particleFire)

 	local  particleFireSmall = CCParticleSystemQuad:create(PATH .. "fireSmall.plist"); 
 	setAnchPos(particleFireSmall,306,218)
 	fg:addChild(particleFireSmall)

 	 --选择按钮
    chooseObjBtn = KNBtn:new(COMMONPATH, {"long_btn.png" , "long_btn_pre.png"}, 6 , 3 , {
			priority = -131,
			scale = true,
			text={"选择对象",24,ccc3(0,20,0),ccp(0,0)},
			callback = function()
				HTTP:call("friends","get",{},{success_callback=
				function()
					--switchScene("friend",{type="fromXianWu"})
					pushScene("friend" , { type="fromShenFa",closeFun = function() popScene() end })
				end})

			end})
	 fg:addChild(chooseObjBtn:getLayer())
 	

	local fangShiLab = display.newSprite(PATH .."shenFaFangShi.png")
	setAnchPos(fangShiLab,275,5)
	fg:addChild(fangShiLab)
	
	 self.textLabel = createLabel({str="预览:" ,size = 20, width = 300, color = ccc3(67,255,255)})
	 setAnchPos(self.textLabel,215,300,0.5)
     --fg:addChild(self.textLabel)

	local tableText ={"宠幸","调戏","肥皂","抚摸","海扁","蹂躏","侍候","送花","奚落"}
	local comboBox 
    local group = KNRadioGroup:new()
    local items = {}
    
	for i = 1, 9 do
		items[i] = KNBtn:new(PATH, {"shenFa"..i..".png", "shenFa_selectBg.png"}, 0, 0, {
			priority = -131,
			id = i,
			noHide = true,
			callback = function()
				self.punishID = i
				comboBox:setText(tableText[i])
				comboBox:autoShow()
				--self.textLabel:setString(tableText[i])
		
			end
		},group)
	end

    comboBox = KNComboBox:new(350, 275, {
		dir = COMMONPATH,
		res = {"btn_bg.png" , "btn_bg_pre.png"},
		text = {"宠幸", 23, ccc3(0, 20, 0)},
		priority = -131,
		bg = PATH.."combo_bg.png",
		up = true,
		offset = 15,
		items = items,
		default = 1,
		itemsGroup = group,
		popCallback = function()
			
		end
	})

    shenFaLayer:addChild(comboBox:getLayer())


 	--确认发送按钮
    local confirmBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png" }, 150 , 25 , {
			priority = -131,
			scale = true,
			front = PATH .. "confirmLab.png",
			callback = function()
				   --发送惩罚
				   if GLOBAL_PUNISH_OBJ_ID~=0 then
						HTTP:call("socialclass","usegarden",{type='punish',touid = GLOBAL_PUNISH_OBJ_ID ,punish_id = self.punishID },{success_callback = 
								function(data)
									KNMsg.getInstance():flashShow( "已经发送！" )	
									GLOBAL_SHENFA_TIME=data['garden']['punish']['limit']
								end
							})
				   	else
				   		KNMsg.getInstance():flashShow( "请选择被惩罚的对象！" )
				   	end	
			end})
	bg:addChild(confirmBtn:getLayer())

	--关闭按钮
    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 0 , 450 , {
			priority = -131,
			scale = true,
			callback = function()
				mask:remove()
			end})
	bg:addChild(close:getLayer())

	local tips_label = display.strokeLabel("说明:神罚消息会发送至世界频道及顶端公告栏！" , 50 , 4 , 16 , ccc3( 255 , 0 , 0) )
    bg:addChild(tips_label)

	mask = KNMask:new({item = shenFaLayer, click = function(x, y)  end})
	return mask
end


function M:showShenBoxLayer(buffStatusData)
	local mask
	--local xianYinLayer =CCLayerColor:create( ccc4(152 , 255 , 255 , 100) )   --帮会详情
	local boxLayer =display.newLayer()
	--setAnchPos(boxLayer,0,0,0.5,0.5)

	--背景
	local bg = display.newSprite(PATH.."layerBg.png")
	setAnchPos(bg,20,200)
	boxLayer:addChild(bg)

	--标题背景
 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
 	setAnchPos(title_bgSp,90,450)
 	bg:addChild(title_bgSp)

	--标题文字
 	local title_Sp = display.newSprite(PATH.."shenBoxTitle.png")
 	setAnchPos(title_Sp,90,450)
 	bg:addChild(title_Sp)

	--前景
 	local  fg = display.newSprite(PATH .. "shenBoxFg.jpg")
 	setAnchPos(fg,10,73)
 	bg:addChild(fg)

     --粒子
 	local  particleGold = CCParticleSystemQuad:create(PATH .. "gold.plist"); 
 	setAnchPos(particleGold,170,240)
 	fg:addChild(particleGold)

    local  particleGold2 = CCParticleSystemQuad:create(PATH .. "gold.plist"); 
 	setAnchPos(particleGold2,240,200)
 	fg:addChild(particleGold2)

 	
    --buff状态文字
	if buffStatusData['boxinfo']['str'] then
		local huoDeLab = display.newSprite(PATH.."huode.png")
	 	setAnchPos(huoDeLab,20,15)
	 	fg:addChild(huoDeLab)
	    local buffStatus_label = display.strokeLabel( buffStatusData['boxinfo']['str'], 80 , 20 , 17 , ccc3( 65 , 255 , 255) )
	    fg:addChild(buffStatus_label)
	end

    --倒计时
	local  BOX_BUFF_STATUS_TIME =buffStatusData['boxinfo']['clock']
    local daoJiShiBuffLab
    if BOX_BUFF_STATUS_TIME ~= 0 and BOX_BUFF_STATUS_TIME~=nil then
    	local tips_label = display.strokeLabel("状态倒计时:" , 155 , 4 , 16 , ccc3( 255 , 0 , 0) )
   		bg:addChild(tips_label)

	    daoJiShiBuffLab = display.strokeLabel( timeConvert(BOX_BUFF_STATUS_TIME,nil,true) , 240 , 4 , 16 , ccc3( 255 , 0 , 0) )
	    bg:addChild(daoJiShiBuffLab)
    end


    Clock:addTimeFun("BUFF_TIME_CLOCK", function()
     	 if BOX_BUFF_STATUS_TIME ~= 0 and BOX_BUFF_STATUS_TIME~=nil then
			BOX_BUFF_STATUS_TIME = BOX_BUFF_STATUS_TIME - 1
			daoJiShiBuffLab:setString(timeConvert(BOX_BUFF_STATUS_TIME,nil,true))		
		 end
	 end)

 	--开启宝箱
    local openBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png" }, 150 , 25 , {
			priority = -131,
			scale = true,
			front = PATH .. "openBox.png",
			callback = function()
				HTTP:call("socialclass","usegarden",{type='box'},{success_callback = 
								function(data)
										dump(data)
										GLOBAL_SHENBOX_TIME=data['garden']['box']['limit']
										KNMsg.getInstance():flashShow( data['boxinfo']['str'] )	

								end
							})
			end})
	bg:addChild(openBtn:getLayer())

	
     

	--关闭按钮
    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 0 , 450 , {
			priority = -131,
			scale = true,
			callback = function()
				mask:remove()
			end})
	bg:addChild(close:getLayer())


	mask = KNMask:new({item = boxLayer, click = function(x, y)  end})
	return mask
end

--刷新神罚按钮
function M:refershShenFaLayer(  )
	--self.textLabel:setString("")
	chooseObjBtn:setText(GLOBAL_PUNISH_OBJ_NAME)

end

function M:getLayer(  )
	
	return self.baseLayer
end

--刷新倒计时
function M:refershTime(  )
	

end

return M