
------------------------------------------------
-- common head
local modname = ...
local M = {}
setmetatable( M, { __index = _G } )
package.loaded[modname] = M
setfenv(1, M)
------------------------------------------------

--[[
CHANNEL_GROUP == hy
]]

local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

local layer

-- 火影 多酷
hyDK_login = function(self, params)
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")
	local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			local loading = KNLoading:new()
			local scene = display.getRunningScene()
			scene:addChild( loading:getLayer() )
			
			hyDKSDK:getInstance():hyDKLogin(function(response)
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end

				if data["result"] == "fail" or data["result"] == "cancel" then
					KNMsg:getInstance():flashShow(data["message"])
					loading:remove()
					return
				end

				CCLuaLog("uid : " .. (data["uid"] or "nil"))
				CCLuaLog("sessionid : " .. (data["sessionid"] or "nil"))
				
				-- 发请求
				local post_data =
				{
					platform = "hy_dk",
					uid = data["uid"] ,
					sessionid = data["sessionid"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				
				loading:remove()
				HTTP:call("verify" , "check" , post_data)
				
			end, function()
				Clock:removeTimeFun("heartbeat")
				SOCKET:getInstance("battle"):close()
				SOCKET:delInstance("battle")
				switchScene("login")
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end

-- 火影 91
hy91_login = function(self, params)
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")
	local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			local loading = KNLoading:new()
			local scene = display.getRunningScene()
			scene:addChild( loading:getLayer() )
			
			jiu1SDK:getInstance():jiu1Login(function(response)
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end
				
				--dump(data)
				if data["result"] == "fail" or data["result"] == "cancel" then
					KNMsg:getInstance():flashShow(data["message"])
					loading:remove()
					return
				end
				CCLuaLog("====================>91 lua login<========================")
				
				-- 发请求
				local post_data =
				{
					platform = "hy_91",
					_91_sid = data["sid"],
					_91_uin = data["uid"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				
				loading:remove()
				HTTP:call("verify" , "check" , post_data)
				
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end

------------- 公共代码
local hy_common_login = function(self, callback)
	layer = display.newLayer()

	requires(IMG_PATH, "GameLuaScript/Config/version")

	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg, 0, 0)
	layer:addChild(bg)

	local version_label = CCLabelTTF:create(VERSION, FONT, 18)
	setAnchPos(version_label, 10, 10)
	version_label:setColor( ccc3( 0x4d, 0x15, 0x15 ) )
	layer:addChild(version_label)
	
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png", "select_btn_pre.png"} , display.cx - 100, 70,
	{
		front = IMG_PATH .. "image/scene/login/login.png", 
		callback = function()
			callback()
		end
	})
	layer:addChild( loginBtn:getLayer() )
	
	return layer, loginBtn
end

local parse_response = function(str, sep1, sep2)
	local response = string.split(str, sep1)
	
	local data = {}

	for i = 1, #response do
		local sep = string.find(response[i], sep2, 1, true)
		if sep ~= nil then
			local k = string.sub(response[i], 1, sep - 1)
			local v = string.sub(response[i], sep + 1, -1)
			
			if k ~= nil and k ~= "" then
				data[k] = v and v or ""
			end
		end
	end
	
	dump(data, "response")
	
	return data
end

local login_template = function(self, params, ...)
	-- local vararg = {...}
	-- CCLuaLog("vararg params=")
	-- for i, v in pairs(vararg) do
		-- CCLuaLog( tostring(v) )
	-- end
	
	local post = params.post_data
	local wait = params.wait
	local login = params.login
	local thiz = params.thiz
	local success_callback = params.success_callback or function() end
	-------------------------------------------------------------------
	local layer, loginBtn
	layer, loginBtn = hy_common_login(self, function()
	-------------------------------------------------------------------
		local KNLoading, loading
		
		local onLoginBegin = function()
			if wait then
				KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")
				loading = KNLoading:new()
				local scene = display.getRunningScene()
				scene:addChild( loading:getLayer() )
			else
				loginBtn:setEnable(false)
				
				-- 1秒内禁止重复点击
				local array = CCArray:create()
				array:addObject( CCDelayTime:create(1) )
				array:addObject( CCCallFunc:create( function() loginBtn:setEnable(true) end ) )
				loginBtn:getLayer():runAction( CCSequence:create(array) )
			end
		end
		
		local onLoginEnd = function()
			if wait then
				loading:remove()
			else
			end
		end
		
		onLoginBegin()
		login(thiz, function(response)
			CCLuaLog("====================>lua login<========================")
			local data = parse_response(response["data"], "@@", "=")
			
			if data["result"] == "fail" or data["result"] == "cancel" then
				if data["message"] and data["message"] ~= "" then
					KNMsg:getInstance():flashShow(data["message"])
				end
				onLoginEnd()
				return
			elseif data["result"] == "succeed" then
				-- 准备数据
				-- 每次构造一份新的数据,
				-- 以防第一次点击登录按钮失败后第二次点击出现问题
				local post_data = {}
				for k, v in pairs(post) do
					post_data[k] = v
				end
				
				dump(post_data, "post")
				for k, v in pairs(post_data) do
					
					if k ~= "platform" then
						if type(v) == "table" then
							post_data[k] = v[2](data[v[1]])
						else
							post_data[k] = data[v]
						end
					end
				end
				
				post_data.channel = CHANNEL_ID
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				
				dump(post_data, "post_data")
				
				onLoginEnd()
				
				-- 发请求
				HTTP:call("verify" , "check" , post_data,
				{
					success_callback = success_callback
				})
			elseif data["result"] == "other" then
				onLoginEnd()
				CCLuaLog("login result=other, do nothing")
			end
		end)
	-------------------------------------------------------------------
	end)
	
	return layer
end

-- 火影 奇虎360
hyqihoo_login = function(self, params)
	return login_template( self,
	{
		post_data =
		{
			platform = "hy_qihoo",
			qihoo_code = "code"
		},
		wait = false,
		login = san60SDK:getInstance().san60Login,
		thiz = san60SDK:getInstance(),
		success_callback = function(data)
			dump(data["result"], "login succeed")
			local data = data["result"]["hy_platform_info"]
			
			local handle
			handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
				handle = nil
				san60SDK:getInstance():san60Query(data["token"]["access_token"], data["id"])
			end, 10, false)
		end
	})
end

-- 火影 uc
hyuc_login = function(self, params)
	return login_template( self,
	{
		post_data =
		{
			platform = "hy_uc",
			uc_sid = "sid"
		},
		wait = false,
		login = ucSDK:getInstance().ucLogin,
		thiz = ucSDK:getInstance(),
	})
end

-- 火影 当乐
hydl_login = function(self, params)
	return login_template( self,
	{
		post_data =
		{
			platform = "hy_dl",
			mid = "mid",
			token = "token"
		},
		wait = false,
		login = dlSDK:getInstance().dlLogin,
		thiz = dlSDK:getInstance(),
	})
end

local login = function(self, params)
	-- 参数默认值
	local loginParameters = params.loginParameters or {}	-- table
	local onLoginSucceed = params.onLoginSucceed or function()	-- function expected
		KNMsg.getInstance():flashShow("no onLoginSucceed action!")
	end
	-------------------------------------------------------------------
	local layer, loginBtn
	layer, loginBtn = hy_common_login(self, function()
	-------------------------------------------------------------------
		local onLoginBegin = function()
			loginBtn:setEnable(false)
			
			-- 1秒内禁止重复点击
			local array = CCArray:create()
			array:addObject( CCDelayTime:create(1) )
			array:addObject( CCCallFunc:create( function() loginBtn:setEnable(true) end ) )
			loginBtn:getLayer():runAction( CCSequence:create(array) )
		end
		
		local onLoginEnd = function()
			
		end
		
		onLoginBegin()
		
		loginParameters.action = "login"
		loginParameters.callback = function(response)
			CCLuaLog("====================>lua login<========================")
			dump(response, "response")
		
			if response["result"] == "fail" or response["result"] == "cancel" then
				if response["message"] and response["message"] ~= "" then
					KNMsg.getInstance():flashShow(response["message"])
				end
				return
			elseif response["result"] == "succeed" then
				onLoginSucceed(response)
			else
				CCLuaLog("do nothing")
			end
		end
		
		DirectChannel.instance():call(loginParameters)
	-------------------------------------------------------------------
	end)
	
	return layer
end

-- 火影 小米
hymi_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "one", params2 = "two", params3 = "three", },
		onLoginSucceed = function(response)
			local post_data =
			{
				platform = "hy_mi",
				mi_uid = response["uid"],
				mi_session = response["session"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data)
		end
	})
end

-- 火影 游龙腾
hyylt_login = function(self, params)
	return login(self,
	{
		onLoginSucceed = function(response)
			local post_data =
			{
				platform = "hy_ylt",
				username = response["uid"],
				sign = response["sign"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify", "check", post_data)
		end
	})
end

--火影 欢乐铃铛
hyxinmei_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "one", params2 = "two", params3 = "three", },
		onLoginSucceed = function(response)
			local post_data =
			{
				platform = "hy_hlld",
				userId = response["uid"],
				token = response["token"],
				----------------------------
				channel = CHANNEL_ID,
			}

			for k , v in pairs(device.infos) do
				post_data[k] = v
			end

			HTTP:call("verify" , "check" , post_data , 
			{
				success_callback = function()
					DirectChannel.instance():call(
					{
						action = "logout",
						callback = function()
							if SOCKET:returnInstance("battle") then
								Clock:removeTimeFun("heartbeat")
								SOCKET:getInstance("battle"):close()
								SOCKET:delInstance("battle")
							end
							switchScene("login")
						end
					})
				end
			})
		end
	})
end

-- 火影 豌豆荚
hywdj_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "one", params2 = "two", params3 = "three", },
		onLoginSucceed = function(response)
			local post_data =
			{
				platform = "hy_wdj",
				uid = response["uid"],
				nick = response["nick"],
				token = response["token"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data)
		end
	})
end

-- 火影 机锋
hygfan_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "one", params2 = "two", params3 = "three", },
		onLoginSucceed = function(response)
			local post_data =
			{
				platform = "hy_wdj",
				uid = response["uid"],
				nick = response["nick"],
				token = response["token"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data)
		end
	})
end

-- 火影 17173  (37wan)
hywan37_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "one", params2 = "two", params3 = "three", },
		onLoginSucceed = function(response)
			CCLuaLog("------------------hy_17173----------------------------")
			dump(response)
			local post_data =
			{
				platform = "hy_17173",
				tokenKey = response["token"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data)
		end
	})
end

--火影 51畅梦
hychangmeng_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "one", params2 = "two", params3 = "three", },
		onLoginSucceed = function(response)
			CCLuaLog("------------------51畅梦----------------------------")
			dump(response)
			local post_data =
			{
				platform = "hy_51",
				token = response["token"],
				uid = response["uid"],
				username = response["username"],
				time = response["time"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data)
		end
	})
end

--火影拇指玩
hymzw_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "one", params2 = "two", params3 = "three", },
		onLoginSucceed = function(response)
			CCLuaLog("------------------拇指玩----------------------------")
			dump(response)
			local post_data =
			{
				platform = "hy_mzw",
				token = response["token"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data)
		end
	})
end

--火影搜狗
hysougou_login = function(self, params)
	return login(self,
	{
		loginParameters = { params1 = "搜狗", params2 = "搜狗", params3 = "搜狗", },
		onLoginSucceed = function(response)
			CCLuaLog("------------------搜狗----------------------------")
			dump(response)
			local post_data =
			{
				platform = "hy_sogou",
				session_key = response["session_key"],
				user_id = response["user_id"],
				----------------------------
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data , 
			{
				success_callback = function()
					DirectChannel.instance():call(
					{
						action = "logout",
						callback = function()
							if SOCKET:returnInstance("battle") then
								Clock:removeTimeFun("heartbeat")
								SOCKET:getInstance("battle"):close()
								SOCKET:delInstance("battle")
							end
							switchScene("login")
						end
					})
				end
			})

			
		end
	})
end

local channel_hy =
{
	hyDK = hyDK_login,
	hy91 = hy91_login,
	hyqihoo = hyqihoo_login,
	["hy.uc"] = hyuc_login,
	------------------------
	-- 游龙腾
	hyylt = hyylt_login,
	["hy.leteng"] = hyylt_login,
	hyylt20070 = hyylt_login,
	hyylt20071 = hyylt_login,
	hyylt20072 = hyylt_login,
	hyylt20073 = hyylt_login,
	hyylt20074 = hyylt_login,
	hyylt20075 = hyylt_login,
	------------------------
	["hy.mi"] = hymi_login,
	["hy.gfan"] = hygfan_login,
	["hy.wan37"] = hywan37_login,
	["hy.xinmei"] = hyxinmei_login,
	["hy.changmeng"] = hychangmeng_login,
	["hy.changmeng1"] = hychangmeng_login,
	["hy.changmeng2"] = hychangmeng_login,
	["hy.mzw"] = hymzw_login,	
	["hy.sougou"] = hysougou_login,
	hydl = hydl_login,
	["hy.wdj"] = hywdj_login,
}

go = function(self, params)
	local capture = channel_hy[CHANNEL_ID]
	if capture then
		capture(self, params)
	else
		layer = nil
	end
	
	return capture, layer
end

------------------------------------------------
--
return M
------------------------------------------------