--[[

登录框

]]


local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")

local M = {}

local layer
local isReg 
local loginbox_layer
local logo

local userinfo_file_path = "userinfo.txt"
if device.platform == "windows" then
	userinfo_file_path = "../userinfo.txt"
end

local interface = UpdataRes:getInstance()
local platform_type = interface:get_type()

--ios iTools
function M:ios_iTools_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			LuaCalliToolsSDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
			    
			    local loginUin = response["_iTools_uid"]
			    local sessionId = response["sessionid"]
			    local nickName = response["nickName"]
			  
				if not sessionId or not loginUin then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data
				if CHANNEL_ID == "hyxsdIosItools" then
				post_data = {
					platform = "hy_ios_itools" ,
					sessionid = sessionId ,
					_iTools_uid = loginUin,
					channel = CHANNEL_ID,
				}
				elseif CHANNEL_ID == "tgxyIosItools" then
					post_data = {
					platform = "tgxy_ios_itools" ,
					sessionid = sessionId ,
					_iTools_uid = loginUin,
					channel = CHANNEL_ID,
				}
				else
					post_data = {
					platform = "tmsj_ios_itools" ,
					sessionid = sessionId ,
					_iTools_uid = loginUin,
					channel = CHANNEL_ID,
				}	
				end
				
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end

function M:uc_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	local has_init
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			if not has_init then
				KNMsg.getInstance():flashShow("正在初始化九游用户中心，请稍等")
				UCGameSDK:getInstance():setOrientation(0)
				UCGameSDK:getInstance():setLogoutCallback(function(event)
					if event.type == "init" then
						-- uc 个人中心
						UCGameSDK:getInstance():createFloatButton()
						UCGameSDK:getInstance():showFloatButton(0 , 0 , true);

						UCGameSDK:getInstance():login(false , "COCO号")
						return
					end

					local uc_sid = event.sid
					if not uc_sid then
						KNMsg.getInstance():flashShow("登录失败，请重新登录")
						return
					end

					-- 发请求
					local post_data = {
						platform = "uc" ,
						uc_sid = uc_sid ,
						channel = CHANNEL_ID,
					}
					for k , v in pairs(device.infos) do
						post_data[k] = v
					end
					HTTP:call("verify" , "check" , post_data)
				end)
				-- init
				UCGameSDK:getInstance():initSDK(false , 2 , 27820 , 518084 , 2126 , "安卓大话水浒" , true , true)


				has_init = true
				return
			else
				KNMsg.getInstance():flashShow("正在初始化九游用户中心，请稍等")
				UCGameSDK:getInstance():login(false , "COCO号")
			end
		end
	}):getLayer()
	layer:addChild(loginBtn)


	return layer
end



function M:_91_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			LuaCall91PlatForm:getInstance():login(function()
				-- body  注销
					--SOCKET:getInstance("battle"):closeSocket()
					--SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
			    
			    local loginUin = response["loginUin"]
			    local sessionId = response["sessionId"]
			    local nickName = response["nickName"]

				if not sessionId or not loginUin then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data 
				if CHANNEL_ID == "hysjIos91" then
				post_data= {
					platform = "hy_ios_91" ,
					_91_sid = sessionId ,
					_91_uin = loginUin,
					channel = CHANNEL_ID,
				}
			elseif CHANNEL_ID == "tgxyIos91" then 
				post_data= {
					platform = "tgxy_ios_91" ,
					_91_sid = sessionId ,
					_91_uin = loginUin,
					channel = CHANNEL_ID,
				}
				else
					post_data= {
					platform = "tmsj_ios_91" ,
					_91_sid = sessionId ,
					_91_uin = loginUin,
					channel = CHANNEL_ID,
				}
			end				
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end

--ios 同步推
function M:ios_tbt_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			LuaCallTBTPlatform:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
			    
			    local loginUin = response["loginUin"]
			    local sessionId = response["sessionId"]
			    local nickName = response["nickName"]
			  
				if not sessionId or not loginUin then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data 
				if CHANNEL_ID == "hysjIosTBT" then
				post_data= {
					platform = "hy_ios_tbt" ,
					_tbt_sid = sessionId ,
					_tbt_uin = loginUin,
					channel = CHANNEL_ID,
				}
			elseif CHANNEL_ID == "tgxyIosTBT" then
				post_data= {
					platform = "tgxy_ios_tbt" ,
					_tbt_sid = sessionId ,
					_tbt_uin = loginUin,
					channel = CHANNEL_ID,
				}
				else
				post_data= {
					platform = "tmsj_ios_tbt" ,
					_tbt_sid = sessionId ,
					_tbt_uin = loginUin,
					channel = CHANNEL_ID,
				}	
				end
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end


--ios 游龙腾
function M:ios_ylt_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			LuaCallYLTSDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
			    
			    --local loginUin = response["loginUin"]
			    local token = response["token"]
			    local userName = response["userName"]
			    local meshKey = response["meshKey"]
			  
				if not token or not userName then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data = {
					platform = "hy_ios_ylt" ,
					username = userName ,
					sign = meshKey,
					channel = CHANNEL_ID,
				}
				
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end


--ios 当乐
function M:ios_DownJoy_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			LuaCallDownJoySDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
			    
			    local sdkMid = response["mid"]
			    local sdkToken = response["token"]	    
			    
				if not sdkToken or not sdkMid then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end
				local post_data
				if CHANNEL_ID == "hysjIosDownJoy" then
				-- 发请求
				post_data = {
					platform = "hy_ios_dl" ,
					mid = sdkMid ,
					token = sdkToken,
					channel = CHANNEL_ID,
				}
				elseif CHANNEL_ID == "tgxyIosDj" then 
					post_data = {
					platform = "tgxy_ios_dl" ,
					mid = sdkMid ,
					token = sdkToken,
					channel = CHANNEL_ID,
				}
				else
					post_data = {
					platform = "tmsj_ios_dl" ,
					mid = sdkMid ,
					token = sdkToken,
					channel = CHANNEL_ID,
					}
				end
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end


--ios pp助手
function M:ios_PP_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			LuaCallPPSDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
			    
			    local sdkUid = response["loginUin"]
			    local sdkToken = response["token"]	    
			    
				if not sdkToken or not sdkUid then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data
				if CHANNEL_ID =="hysjIosPP" then
				 post_data= {
					platform = "hy_ios_pp" ,
					loginUin = sdkUid ,
					token_key = sdkToken,
					channel = CHANNEL_ID,
				}
				elseif CHANNEL_ID == "tgxyIosPP" then
				post_data= {
					platform = "tgxy_ios_pp" ,
					loginUin = sdkUid ,
					token_key = sdkToken,
					channel = CHANNEL_ID,
				}
				else
				post_data= {
					platform = "tmsj_ios_pp" ,
					loginUin = sdkUid ,
					token_key = sdkToken,
					channel = CHANNEL_ID,
				}	
			end
				
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end

function M:ios_UC_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			
			LuaCallUCSDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
	
			    local sdkSid = response["sdkSid"]	    
			    
				if not sdkSid  then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data
				if CHANNEL_ID == "hysjIosUC" then
				post_data = {
					platform = "hy_ios_uc" ,
					uc_sid = sdkSid,
					channel = CHANNEL_ID,
				}
				elseif CHANNEL_ID == "tgxyIosUC" then
				post_data = {
					platform = "tgxy_ios_uc" ,
					uc_sid = sdkSid,
					channel = CHANNEL_ID,
				}
				else
				post_data = {
					platform = "tmsj_ios_uc" ,
					uc_sid = sdkSid,
					channel = CHANNEL_ID,
			}
			end
				
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end


--快用
function M:ios_KY_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			
			LuaCallKYSDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)
	
			    local sdkSid = response["sdkSid"]	    
			    
				if not sdkSid  then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data 
				if CHANNEL_ID == "hysjIosKY" then
				 post_data= {
					platform = "hy_ios_ky" ,
					tokenKey = sdkSid,
					channel = CHANNEL_ID,
				}
				elseif CHANNEL_ID == "tgxyIosKY" then
				 post_data= {
					platform = "tgxy_ios_ky" ,
					tokenKey = sdkSid,
					channel = CHANNEL_ID,
				}	
				else
				post_data= {
					platform = "tmsj_ios_ky" ,
					tokenKey = sdkSid,
					channel = CHANNEL_ID,
				}					
				end
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end


--ios 17173
function M:ios_17173_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			
			LuaCall17173SDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
				end ,
				function(response)

			    local sdkToken = response["sdkToken"]	    
			    
				if not sdkToken  then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data = {
					platform = "hy_ios_17173" ,
					tokenKey = sdkToken,
					channel = CHANNEL_ID,
				}
				
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end

-- 龙印
function M:longyin_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")
	local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")

	
	
	local imgStr = IMG_PATH .. "image/scene/login/ly_bg.jpg"
	if CHANNEL_ID == "DK" or CHANNEL_ID == "nd91" or CHANNEL_ID == "BD" then 
		imgStr = IMG_PATH .. "image/scene/login/ly_bg_other.jpg"
	end

	local bg = display.newSprite(imgStr)
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

		
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			local loading = KNLoading:new()
			local scene = display.getRunningScene()
			scene:addChild( loading:getLayer() )
			
			FlySDK:getInstance():FlyInit("100079","100125","47adc1294wxyxa88","dahua",function(response)
				
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end

				if tonumber(data["status"]) == 0 then 
					loading:remove()

					if not data["sessionid"] or not data["accountid"] or not data["status"]or not data["customstring"] then
						KNMsg.getInstance():flashShow("登录失败，请重新登录")
						return
					end

					if data["accountid"] == "" or data["accountid"] == 0 or data["accountid"] == "0" then
						return
					end

						-- 发请求0
					local post_data = {
						platform = "longyin" ,
						accountid = data["accountid"],
						sessionid = data["sessionid"],
						channel = CHANNEL_ID,
					}
					for k , v in pairs(device.infos) do
						post_data[k] = v
					end
					HTTP:call("verify" , "check" , post_data)
				elseif tonumber(data["status"]) == 1  then 
					if SOCKET:returnInstance("battle") then
								Clock:removeTimeFun("heartbeat")
								SOCKET:getInstance("battle"):close()
								SOCKET:delInstance("battle")
					end
					switchScene("login")
				end	
				
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end

-- 有信
function M:youxin_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			youxinSDK:getInstance():youxinLogin(function(response) 
			
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end
				CCLuaLog("openId : " .. (data["openId"] or "nil"))
				CCLuaLog("sign : " .. (data["sign"] or "nil"))
				-- 发请求
				local post_data = {
					platform = "youxin" ,
					youxin_openid = data["openId"] ,
					youxin_sign = data["sign"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
				
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end


-- 唐门世界 多酷
function M:hyDK_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")
	local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			local loading = KNLoading:new()
			local scene = display.getRunningScene()
			scene:addChild( loading:getLayer() )
			
			hyDKSDK:getInstance():hyDKLogin(function(response)
				
			
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end

				if data["result"] == "fail" or data["result"] == "cancel" then
					KNMsg:getInstance():flashShow(data["message"])
					loading:remove()
					return
				end

				CCLuaLog("uid : " .. (data["uid"] or "nil"))
				CCLuaLog("sessionid : " .. (data["sessionid"] or "nil"))
				
				-- 发请求
				local post_data = {
					platform = "tmsj_dk",
					uid = data["uid"] ,
					sessionid = data["sessionid"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				
				loading:remove()
				HTTP:call("verify" , "check" , post_data)
				
				
			end, function()
				Clock:removeTimeFun("heartbeat")
				SOCKET:getInstance("battle"):close()
				SOCKET:delInstance("battle")
				switchScene("login")
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end



-- 百度
function M:baidu_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			baiduSDK:getInstance():baiduLogin(function(response) 
			
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end
				CCLuaLog("token : " .. (data["token"] or "nil"))
				
				-- 发请求
				local post_data = {
					platform = "baidu" ,
					baidu_token = data["token"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
				
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end

function M:ledou_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			ledouSDK:getInstance():ledouLogin("f8be48c08a4f0a9cadc5","007d67014a65b8652db1","dd",function(response) 
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end
				
				if not data["openId"] or not data["sessionId"]  then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end
				-- 发请求
				local post_data = {
					platform = "idreamsky" ,
					open_id = data["openId"] ,
					sessionid = data["sessionId"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end


function M:pada_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			padaSDK:getInstance():padaLogin("101025","243276271df637165b207edaffe5a912",function(response)
				response = string.split(response["data"] , "@@")
				local data = {}
				
				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end
				
				CCLuaLog("roleId : " .. (data["roleId"] or "nil"))
				CCLuaLog("roleName : " .. (data["roleName"] or "nil"))
				CCLuaLog("roleToken : " .. (data["roleToken"] or "nil"))
				
				if not data["roleId"] or not data["roleName"] or not data["roleToken"] then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end
				-- 发请求
				local post_data = {
					platform = "pada" ,
					roleId = data["roleId"] ,
					roleToken = data["roleToken"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end

-- 大话 华为
function M:huawei_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")
	local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			loginBtn:setEnable(false)
			huaweiSDK:getInstance():huaweiLogin(function(response)
				
				response = string.split(response["data"] , "@@")
				
				local data = {}

				-- for i = 1 , #response do
					-- local temp = string.split(response[i] , "=")
					-- if #temp == 2 then
						-- data[temp[1]] = temp[2]
					-- end
				-- end
				
				for i = 1, #response do
					local sep = string.find(response[i], "=", 1, true)
					data[string.sub(response[i], 1, sep - 1)] = string.sub(response[i], sep + 1, -1)
				end
				
				--dump(data, "data")
				
				if data["result"] == "succeed" then
					CCLuaLog("accessToken : " .. (data["accessToken"] or "nil"))
					
					-- 发请求
					local post_data = {
						platform = "huawei",
						access_token = data["accessToken"],
						channel = CHANNEL_ID,
					}
					for k , v in pairs(device.infos) do
						post_data[k] = v
					end
					
					HTTP:call("verify" , "check" , post_data)
				else
					CCLuaLog("++++++++++++++huawei login error+++++++++++")
				end
			end)
			
			-- 1秒内禁止重复点击
			local array = CCArray:create()
			array:addObject( CCDelayTime:create(1) )
			array:addObject( CCCallFunc:create( function() loginBtn:setEnable(true) end ) )
			loginBtn:getLayer():runAction( CCSequence:create(array) )
			
		end
	})
	layer:addChild( loginBtn:getLayer() )
	
	return layer
end

function M:qihoo_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			qihooSDK:getInstance():qihooLogin("false","true",function(response) 
				
				--qihooSDK:getInstance():qihoopay("false","true")
				
				-- 发请求
				local post_data = {
					platform = "qihoo" ,
					qihoo_code = response["data"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	return layer
end


--云顶登录
function M:appFame_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			local userInfo=LuaCallAppFrameSDK:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
			end)
			
			local infoSz = string.split(userInfo , ",")
		    
		    local loginUin = infoSz[1]
			local nickName = infoSz[2]
			local sessionId = infoSz[3]
				
			if not sessionId or not loginUin or not nickName then
				KNMsg.getInstance():flashShow("登录失败，请先在云顶账号中心登录账号再重新登录")
				return
			end
			
			-- 发请求
			local post_data = {
					platform = "appFame" ,
					appFame_sid = sessionId ,
					appFame_uin = loginUin,
					channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
					post_data[k] = v
			end
			HTTP:call("verify" , "check" , post_data )
			
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end


--云顶正版登录
function M:appFameOfficial_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			local userInfo=LuaCallAppFameSDKOfficial:getInstance():login(function()
				-- body  注销
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					switchScene("login")
			end)
			
			local infoSz = string.split(userInfo , ",")
		    
		    local loginUin = infoSz[1]
			local nickName = infoSz[2]
			local sessionId = infoSz[3]
				
			if not sessionId or not loginUin or not nickName then
				KNMsg.getInstance():flashShow("登录失败，请先在云顶账号中心登录账号再重新登录")
				return
			end
			
			-- 发请求
			local post_data = {
					platform = "appFameOfficial" ,
					appFame_sid = sessionId ,
					appFame_uin = loginUin,
					channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
					post_data[k] = v
			end
			HTTP:call("verify" , "check" , post_data )
			
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end



function M:cmge_login( params )
	layer = display.newLayer()

	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , display.cx - 100 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			CMGEsdk:getInstance():cmgeLogin(function(response)
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end
				
				CCLuaLog("userId : " .. (data["userId"] or "nil"))
				CCLuaLog("timestamp : " .. (data["timestamp"] or "nil"))
				CCLuaLog("sign : " .. (data["sign"] or "nil"))
				
				if not data["userId"] or not data["timestamp"] or not data["sign"] then
					KNMsg.getInstance():flashShow("登录失败，请重新登录")
					return
				end

				-- 发请求
				local post_data = {
					platform = "cmge" ,
					cmge_uin = data["userId"] ,
					cmge_timestamp = data["timestamp"],
					cmge_sign = data["sign"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end)
		end
	}):getLayer()
	layer:addChild(loginBtn)

	return layer
end


function M:jstf_login( params )
	isReg = params.isReg or false	--是否是注册
	
	loginbox_layer = nil

	layer = display.newLayer()
	
	requires(IMG_PATH,"GameLuaScript/Config/version")

	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )
	
	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")
	
	if username and username ~= "" then
		M:jstf_showLoginBox()
	else
		M:jstf_gameSelect()
	end

	return layer
end

function M:jstf_showLoginBox()
	local box_bg , username_input_bg , password_input_bg , username_textfield , effBg , 
		password_textfield ,  login_btn , send_btn , backBtn ,registerBtn 

	local jstfLogin = function(open_id, password)
		local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")
		local loading = KNLoading:new()
		local scene = display.getRunningScene()
		scene:addChild( loading:getLayer() )

		jstfSDK:getInstance():jstfLogin(open_id, password, function(response) 
			response = string.split(response["data"] , "@@")
			local data = {}

			for i = 1 , #response do
				local temp = string.split(response[i] , "=")
				if #temp == 2 then
					data[temp[1]] = temp[2]
				end
			end
			
			--CCLuaLog("result : " .. (data["result"] or "nil"))
			--CCLuaLog("sid : " .. (data["sid"] or "nil"))

			loading:remove()
			
			if data["result"] == "fail" then
				KNMsg:getInstance():flashShow(data["message"])
				return
			elseif data["result"] == "succeed" then
				-- 保存最近一次登录的账号和密码
				KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
				KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)
				
				-- 发请求
				local post_data = {
					platform = "jstf" ,
					diyibo_openid = open_id,
					diyibo_sid = data["sid"],
					channel = CHANNEL_ID,
				}
				for k , v in pairs(device.infos) do
					post_data[k] = v
				end
				HTTP:call("verify" , "check" , post_data)
			end
		end)		
	end
	
	--[[登录按钮]]
	local login_callback = function()
		audio.stopMusic( false )
		
		echoLog("Login" , "Click Login Button")

		local open_id = username_textfield:getString()
		open_id = string.trim( open_id )

		local password = password_textfield:getString()
		password = string.trim( password )
	
		if open_id == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入ID")
			return
		end

		if password == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入密码")
			return
		end

		username_textfield:stopInput()
		password_textfield:stopInput()
		
		jstfLogin(open_id, password)
		
	end


	if loginbox_layer ~= nil then
		loginbox_layer:removeFromParentAndCleanup(true)
	end

	loginbox_layer = display.newLayer()

	

	-- 切换真假输入框的状态
	local function changeStauts(status , type)
		if status == true then
			box_bg:setPosition(0 , 432)
			
			setAnchPos( username_textfield:getLayer() , 150  , 516 )
			setAnchPos( password_textfield:getLayer() , 150  , 476 )
			
			username_input_bg:setPosition(140 , 500)
			password_input_bg:setPosition(140 , 460)
			
			effBg:setVisible(true)
			
			if type == "username" then
				setAnchPos( effBg , 140 + 118 , 500 + 16 , 0.5 , 0.5  )
				
				username_textfield:startInput()
				password_textfield:stopInput()
				
			else
				setAnchPos( effBg , 140 + 118 , 460 + 16 , 0.5 , 0.5  )
				
				username_textfield:stopInput()
				password_textfield:startInput()
				
			end

			login_btn:setVisible(false)
			if isReg then
				send_btn:showBtn(false)
				send_btn:setEnable(false)
				
				setAnchPos( registerBtn:getLayer() , 390 , 455 )
			else
				send_btn:showBtn(true)
				send_btn:setEnable(true)
				
				registerBtn:showBtn(false)
				registerBtn:setEnable(false)
				setAnchPos( registerBtn:getLayer() , 390 , 130 )
			end
			
			backBtn:setVisible(true)
		else
			effBg:setVisible( false )	--隐藏提示光效
			
			box_bg:setPosition(0 , 110)
			

			username_input_bg:setPosition(140 , 175)
			password_input_bg:setPosition(140 , 136)

			setAnchPos( username_textfield:getLayer() , 150  , 192 )
			setAnchPos( password_textfield:getLayer() , 150  , 152 )


			username_textfield:stopInput()
			password_textfield:stopInput()

			login_btn:setVisible(true)
			send_btn:showBtn(false)
			backBtn:setVisible(false)
			
			isReg = false
			registerBtn:showBtn(true)
			registerBtn:setEnable(true)
			setAnchPos( registerBtn:getLayer() , 390 , 130 )
		end
	end

	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")

	

	-- 用户名输入框
	username_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入ID" , 
											existStr = ( ( username and username ~= "" ) and username or nil ) ,
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( username_textfield:getLayer() , 10 )
	



	-- 密码输入框
	password_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入密码" , 
											existStr = ( ( password and password ~= "" ) and password or nil ) , 
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( password_textfield:getLayer() , 10 )


	-- 假输入框背景
	box_bg = display.newSprite(IMG_PATH .. "image/scene/login/box_bg.png")
	setAnchPos(box_bg , 0 , 110)
	loginbox_layer:addChild(box_bg)
	
	effBg = display.newSprite(IMG_PATH .. "image/scene/login/eff_bg.png")
	effBg:setVisible( false )
	loginbox_layer:addChild( effBg )
	local function createAction()
			local action
			action = getSequenceAction( CCFadeIn:create( 0.5 ) , CCFadeOut:create( 0.5 ) , CCCallFunc:create(
			function()
				effBg:runAction(createAction())
			end))	
			return action
	end
	effBg:runAction(createAction())	
	
	
	-- 假用户名输入框背景
	username_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 175 , {
		callback = function()
			changeStauts(true , "username")
		end
	}):getLayer()
	loginbox_layer:addChild(username_input_bg)

	-- 假密码输入框背景
	password_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 136 , {
		callback = function()
			changeStauts(true , "password")
		end
	}):getLayer()
	loginbox_layer:addChild(password_input_bg)


	-- 开始按钮
	send_btn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"send_btn.png" , "send_btn_pre.png"} , 390 , 455 , {
		callback = 
		function()
			isReg = false
			login_callback()
		end
	})
	loginbox_layer:addChild( send_btn:getLayer() )
	
	-- 注册按钮
	registerBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"register.png" , "register_pre.png"} , 390 , 130 , {
		callback =
		function()
			if not isReg then
				isReg = true
				changeStauts( true , "username" )
			else
				--login_callback()
				echoLog("Register" , "Click Register Button")

				local open_id = username_textfield:getString()
				open_id = string.trim( open_id )

				local password = password_textfield:getString()
				password = string.trim( password )
			
				if open_id == "" then
					-- 错误提示
					KNMsg:getInstance():flashShow("请输入ID")
					return
				end

				if password == "" then
					-- 错误提示
					KNMsg:getInstance():flashShow("请输入密码")
					return
				end

				username_textfield:stopInput()
				password_textfield:stopInput()
				
				local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")
				local loading = KNLoading:new()
				local scene = display.getRunningScene()
				scene:addChild( loading:getLayer() )
				
				jstfSDK:getInstance():jstfRegister(open_id, password, function(response)
				
					response = string.split(response["data"] , "@@")
					local data = {}

					for i = 1 , #response do
						local temp = string.split(response[i] , "=")
						if #temp == 2 then
							data[temp[1]] = temp[2]
						end
					end
					
					--CCLuaLog("result : " .. (data["result"] or "nil"))
					--CCLuaLog("message : " .. (data["message"] or "nil"))
					--CCLuaLog("username : " .. (data["username"] or "nil"))
					--CCLuaLog("password : " .. (data["password"] or "nil"))
					
					loading:remove()
					
					if data["result"] == "fail" then
						KNMsg:getInstance():flashShow(data["message"])
						return
					elseif data["result"] == "succeed" then
						KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
						KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)
						jstfLogin(open_id, password)
					end
				end)
			end

		end 
	})
	loginbox_layer:addChild( registerBtn:getLayer() )
	
	-- 返回按钮
	backBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"back.png" , "back_pre.png"} , 10 , 460 , {
		callback = 
		function()
			changeStauts()
		end
	}):getLayer()
	loginbox_layer:addChild( backBtn )


	-- 登录按钮
	login_btn = KNButton:new("login" , 0 , display.cx , 20 , login_callback , 1 , { noDisable = true })
	setAnchPos(login_btn , display.cx - 120 , 20 , 0.5)
	loginbox_layer:addChild( login_btn )


	-- 默认为假输入框状态
	changeStauts( isReg )
	
	
	setAnchPos( loginbox_layer , 0 , -display.cy )
	transition.moveTo(loginbox_layer , {time = 0.5 , y = 0 , easing = "BACKOUT" })
	layer:addChild( loginbox_layer , 10)
end

--登陆选择
function M:jstf_gameSelect()
	local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")
	
	local loginBtn , fastGameBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , 42 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			fastGameBtn:removeFromParentAndCleanup( true )
			fastGameBtn = nil 
			
			loginBtn:removeFromParentAndCleanup( true )
			loginBtn = nil 

			M:jstf_showLoginBox()
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	fastGameBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , 264 , 70 , {
		front = IMG_PATH .. "image/scene/login/fast_game.png" , 
		callback = function()
			local loading = KNLoading:new()
			local scene = display.getRunningScene()
			scene:addChild( loading:getLayer() )
			
			jstfSDK:getInstance():jstfOneKeyRegister(function(response)
				
				response = string.split(response["data"] , "@@")
				local data = {}

				for i = 1 , #response do
					local temp = string.split(response[i] , "=")
					if #temp == 2 then
						data[temp[1]] = temp[2]
					end
				end
				
				
				--CCLuaLog("result : " .. (data["result"] or "nil"))
				--CCLuaLog("message : " .. (data["message"] or "nil"))
				--if data["result"] == "succeed" then 
					--CCLuaLog("username : " .. (data["username"] or "nil"))
					--CCLuaLog("password : " .. (data["password"] or "nil"))
				--end
				
				
				--记录用户名和密码
				loading:remove()
				KNMsg.getInstance():flashShow(data["message"])

				if data["result"] == "succeed" then

					KNFileManager.updatafile(userinfo_file_path , "name" , "=" , data["username"])
					KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , data["password"])
					
					fastGameBtn:removeFromParentAndCleanup( true )
					fastGameBtn = nil
					
					loginBtn:removeFromParentAndCleanup( true )
					loginBtn = nil
			
					M:jstf_showLoginBox()
				elseif data["result"] == "fail" then
					KNMsg.getInstance():flashShow(data["message"])
				end
				
				
			end)
		end
	}):getLayer()
	layer:addChild(fastGameBtn)
	
end


function M:jstfIos_login( params )
	isReg = params.isReg or false	--是否是注册
	
	loginbox_layer = nil

	layer = display.newLayer()
	
	requires(IMG_PATH,"GameLuaScript/Config/version")

	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )
	
	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")
	
	if username and username ~= "" then
		M:jstfIos_showLoginBox()
	else
		M:jstfIos_gameSelect()
	end

	return layer
end

function M:jstfIos_showLoginBox()
	local box_bg , username_input_bg , password_input_bg , username_textfield , effBg , 
		password_textfield ,  login_btn , send_btn , backBtn ,registerBtn 

	local jstfLogin = function(open_id, password)

		local function callback(response)
			if response["errorCode"] ~= 1 then
				KNMsg:getInstance():flashShow(response["errorMsg"])
				return
			end
		
			KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
			KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)

			-- 发请求
			local post_data = {
				platform = "jstf_iospj" ,
				diyibo_openid = open_id,
				diyibo_sid = response["sid"],
				channel = CHANNEL_ID,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			HTTP:call("verify" , "check" , post_data)
		end
		
		if __INNER_IOS_SDK_VER then
			local params = {
				type = "send_login",
				ac = open_id,
				pw = password
			}
			channel_delegate:getInst():call(json.encode(params), callback)
		else
			LuaCallDiYiBoSDK:getInstance():login(open_id, password, callback)
		end			
	end
	
	--[[登录按钮]]
	local login_callback = function()
		audio.stopMusic( false )
		
		echoLog("Login" , "Click Login Button")

		local open_id = username_textfield:getString()
		open_id = string.trim( open_id )

		local password = password_textfield:getString()
		password = string.trim( password )
	
		if open_id == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入ID")
			return
		end

		if password == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入密码")
			return
		end

		username_textfield:stopInput()
		password_textfield:stopInput()
		
		jstfLogin(open_id, password)
		
	end


	if loginbox_layer ~= nil then
		loginbox_layer:removeFromParentAndCleanup(true)
	end

	loginbox_layer = display.newLayer()

	

	-- 切换真假输入框的状态
	local function changeStauts(status , type)
		if status == true then
			box_bg:setPosition(0 , 432)
			
			setAnchPos( username_textfield:getLayer() , 150  , 516 )
			setAnchPos( password_textfield:getLayer() , 150  , 476 )
			
			username_input_bg:setPosition(140 , 500)
			password_input_bg:setPosition(140 , 460)
			
			effBg:setVisible(true)
			
			if type == "username" then
				setAnchPos( effBg , 140 + 118 , 500 + 16 , 0.5 , 0.5  )
				
				username_textfield:startInput()
				password_textfield:stopInput()
				
			else
				setAnchPos( effBg , 140 + 118 , 460 + 16 , 0.5 , 0.5  )
				
				username_textfield:stopInput()
				password_textfield:startInput()
				
			end

			login_btn:setVisible(false)
			if isReg then
				send_btn:showBtn(false)
				send_btn:setEnable(false)
				
				setAnchPos( registerBtn:getLayer() , 390 , 455 )
			else
				send_btn:showBtn(true)
				send_btn:setEnable(true)
				
				registerBtn:showBtn(false)
				registerBtn:setEnable(false)
				setAnchPos( registerBtn:getLayer() , 390 , 130 )
			end
			
			backBtn:setVisible(true)
		else
			effBg:setVisible( false )	--隐藏提示光效
			
			box_bg:setPosition(0 , 110)
			

			username_input_bg:setPosition(140 , 175)
			password_input_bg:setPosition(140 , 136)

			setAnchPos( username_textfield:getLayer() , 150  , 192 )
			setAnchPos( password_textfield:getLayer() , 150  , 152 )


			username_textfield:stopInput()
			password_textfield:stopInput()

			login_btn:setVisible(true)
			send_btn:showBtn(false)
			backBtn:setVisible(false)
			
			isReg = false
			registerBtn:showBtn(true)
			registerBtn:setEnable(true)
			setAnchPos( registerBtn:getLayer() , 390 , 130 )
		end
	end

	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")

	

	-- 用户名输入框
	username_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入ID" , 
											existStr = ( ( username and username ~= "" ) and username or nil ) ,
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( username_textfield:getLayer() , 10 )
	



	-- 密码输入框
	password_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入密码" , 
											existStr = ( ( password and password ~= "" ) and password or nil ) , 
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( password_textfield:getLayer() , 10 )


	-- 假输入框背景
	box_bg = display.newSprite(IMG_PATH .. "image/scene/login/box_bg.png")
	setAnchPos(box_bg , 0 , 110)
	loginbox_layer:addChild(box_bg)
	
	effBg = display.newSprite(IMG_PATH .. "image/scene/login/eff_bg.png")
	effBg:setVisible( false )
	loginbox_layer:addChild( effBg )
	local function createAction()
			local action
			action = getSequenceAction( CCFadeIn:create( 0.5 ) , CCFadeOut:create( 0.5 ) , CCCallFunc:create(
			function()
				effBg:runAction(createAction())
			end))	
			return action
	end
	effBg:runAction(createAction())	
	
	
	-- 假用户名输入框背景
	username_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 175 , {
		callback = function()
			changeStauts(true , "username")
		end
	}):getLayer()
	loginbox_layer:addChild(username_input_bg)

	-- 假密码输入框背景
	password_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 136 , {
		callback = function()
			changeStauts(true , "password")
		end
	}):getLayer()
	loginbox_layer:addChild(password_input_bg)


	-- 开始按钮
	send_btn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"send_btn.png" , "send_btn_pre.png"} , 390 , 455 , {
		callback = 
		function()
			isReg = false
			login_callback()
		end
	})
	loginbox_layer:addChild( send_btn:getLayer() )
	
	-- 注册按钮
	registerBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"register.png" , "register_pre.png"} , 390 , 130 , {
		callback =
		function()
			if not isReg then
				isReg = true
				changeStauts( true , "username" )
			else
				--login_callback()
				echoLog("Register" , "Click Register Button")

				local open_id = username_textfield:getString()
				open_id = string.trim( open_id )

				local password = password_textfield:getString()
				password = string.trim( password )
			
				if open_id == "" then
					-- 错误提示
					KNMsg:getInstance():flashShow("请输入ID")
					return
				end

				if password == "" then
					-- 错误提示
					KNMsg:getInstance():flashShow("请输入密码")
					return
				end

				username_textfield:stopInput()
				password_textfield:stopInput()
				
				local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")
				local loading = KNLoading:new()
				local scene = display.getRunningScene()
				scene:addChild( loading:getLayer() )

				local function callback(response)
					if response["errorCode"] ~= 1 then
						KNMsg:getInstance():flashShow(response["errorMsg"])
						loading:remove()
						return
					else
						KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
						KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)
						jstfLogin(open_id, password)
					end
				end

				if __INNER_IOS_SDK_VER then
					local params = {
						type = "send_reg",
						ac = open_id,
						pw = password
					}
					channel_delegate:getInst():call(json.encode(params), callback)
				else
					LuaCallDiYiBoSDK:getInstance():reg(open_id, password, callback)
				end
			end

		end 
	})
	loginbox_layer:addChild( registerBtn:getLayer() )
	
	-- 返回按钮
	backBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"back.png" , "back_pre.png"} , 10 , 460 , {
		callback = 
		function()
			changeStauts()
		end
	}):getLayer()
	loginbox_layer:addChild( backBtn )


	-- 登录按钮
	login_btn = KNButton:new("login" , 0 , display.cx , 20 , login_callback , 1 , { noDisable = true })
	setAnchPos(login_btn , display.cx - 120 , 20 , 0.5)
	loginbox_layer:addChild( login_btn )


	-- 默认为假输入框状态
	changeStauts( isReg )
	
	
	setAnchPos( loginbox_layer , 0 , -display.cy )
	transition.moveTo(loginbox_layer , {time = 0.5 , y = 0 , easing = "BACKOUT" })
	layer:addChild( loginbox_layer , 10)
end

--登陆选择
function M:jstfIos_gameSelect()
	local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")
	
	local loginBtn , fastGameBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , 42 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			fastGameBtn:removeFromParentAndCleanup( true )
			fastGameBtn = nil 
			
			loginBtn:removeFromParentAndCleanup( true )
			loginBtn = nil 

			M:jstfIos_showLoginBox()
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	fastGameBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , 264 , 70 , {
		front = IMG_PATH .. "image/scene/login/fast_game.png" , 
		callback = function()
			local loading = KNLoading:new()
			local scene = display.getRunningScene()
			scene:addChild( loading:getLayer() )

			local function callback(response)
				-- 记录用户名和密码
				if response["callFunName"] == "quickReg" and response["errorCode"] == 1 then
					KNFileManager.updatafile(userinfo_file_path , "name" , "=" , response["userName"])
					KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , response["userPassWord"])
					
					fastGameBtn:removeFromParentAndCleanup( true )
					fastGameBtn = nil
					
					loginBtn:removeFromParentAndCleanup( true )
					loginBtn = nil
			
					M:jstfIos_showLoginBox()
				end
				
				loading:remove()
			end
			
			if __INNER_IOS_SDK_VER then
				local params = {
					type = "send_quick_reg",
				}
				channel_delegate:getInst():call(json.encode(params), callback)
			else
				LuaCallDiYiBoSDK:getInstance():quickReg(callback)
			end
		end
	}):getLayer()
	layer:addChild(fastGameBtn)
	
end

function M:tgxy2_login( params )
	local PATH = IMG_PATH .. "image/scene/login/"

	isReg = params.isReg or false	--是否是注册
	
	loginbox_layer = nil

	layer = display.newLayer()
	
	requires(IMG_PATH,"GameLuaScript/Config/version")

	local bg = display.newSprite(PATH .."bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )

	local effect = requires(IMG_PATH,"GameLuaScript/Common/KNEffect")
	effect.get(PATH, "waterfall"):center():addTo(layer)

	do--云
		local function move(p, left)
			local action = CCArray:create()
			if left then
				action:addObject(CCDelayTime:create(1))
			end
			action:addObject(CCMoveBy:create(15, ccp(display.width*2.5*(left and -1 or 1), 0)))
			action:addObject(CCPlace:create(ccp(-display.width*(left and -1 or 1), p:getPositionY())))
			local seq = CCSequence:create(action)
			return p:run(CCRepeatForever:create(tolua.cast(seq, "CCActionInterval")))
		end
		move(display.newSprite(PATH .."clouddown1.png", -display.width, 0):anchor(.5, 0):addTo(layer))
		move(display.newSprite(PATH .."clouddown2.png", display.width, 0):anchor(0, 0):addTo(layer), true)
		move(display.newSprite(PATH .."cloudup1.png", -display.width, 700):addTo(layer))
		move(display.newSprite(PATH .."cloudup2.png", display.width, 700):anchor(0, .5):addTo(layer), true)
	end

	display.newSprite(PATH .."role.png", display.cx, 536):addTo(layer)
	logo = display.newSprite(PATH .."logo.png", display.cx, 321):addTo(layer, 99)

	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )
	
	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")
	
	if username and username ~= "" then
		M:tgxy2_showLoginBox()
	else
		M:tgxy2_gameSelect()
	end

	return layer
end

function M:tgxy2_showLoginBox()
	local box_bg , username_input_bg , password_input_bg , username_textfield , effBg , 
		password_textfield ,  login_btn , send_btn , backBtn ,registerBtn 

	--[[登录按钮]]
	local login_callback = function()
		audio.stopMusic( false )
		
		echoLog("Login" , "Click Login Button")

		local open_id = username_textfield:getString()
		open_id = string.trim( open_id )

		local password = password_textfield:getString()
		password = string.trim( password )
	
		if open_id == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入ID")
			return
		end

		if password == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入密码")
			return
		end

		username_textfield:stopInput()
		password_textfield:stopInput()

		-- 发请求
		local post_data = {
			open_id = open_id ,
			pwd = password ,
			channel = CHANNEL_ID,
			reg = isReg and 1 or nil ,
		}
		for k , v in pairs(device.infos) do
			post_data[k] = v
		end
		
		HTTP:call("verify" , "check" , post_data , {
			success_callback = function(d)
				KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
				KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)
			end,
			error_callback = function(d)
				switchScene("login" , { isReg = isReg } , function()
					KNMsg.getInstance():flashShow("[" .. d.code .. "]" .. d.msg)
				end)
			end
		})
	end


	if loginbox_layer ~= nil then
		loginbox_layer:removeFromParentAndCleanup(true)
	end

	loginbox_layer = display.newLayer()

	

	-- 切换真假输入框的状态
	local function changeStauts(status , type)
		if status == true then
			logo:pos(display.cx, 643)
			box_bg:setPosition(0 , 390)
			
			setAnchPos( username_textfield:getLayer() , 150  , 526 )
			setAnchPos( password_textfield:getLayer() , 150  , 473 )
			
			username_input_bg:setPosition(140 , 510)
			password_input_bg:setPosition(140 , 457)
			
			-- effBg:setVisible(true)
			
			if type == "username" then
				-- setAnchPos( effBg , 248 , 526 , 0.5 , 0.5  )
				
				username_textfield:startInput()
				password_textfield:stopInput()
				
			else
				-- setAnchPos( effBg , 248 , 473, 0.5 , 0.5  )
				
				username_textfield:stopInput()
				password_textfield:startInput()
				
			end

			login_btn:getLayer():setVisible(false)
			if isReg then
				send_btn:showBtn(false)
				send_btn:setEnable(false)
				
				setAnchPos( registerBtn:getLayer() , 78 , 405 )
			else
				send_btn:showBtn(true)
				send_btn:setEnable(true)
				
				registerBtn:showBtn(false)
				registerBtn:setEnable(false)
				setAnchPos( registerBtn:getLayer() , 390 , 130 )
			end
			
			setAnchPos( backBtn:getLayer() , 265 , 405 )
			backBtn:getLayer():setVisible(true)
		else
			-- effBg:setVisible( false )	--隐藏提示光效

			logo:pos(display.cx, 321)
			box_bg:setPosition(0 , 68)
			

			username_input_bg:setPosition(140 , 185)
			password_input_bg:setPosition(140 , 133)

			setAnchPos( username_textfield:getLayer() , 150  , 202 )
			setAnchPos( password_textfield:getLayer() , 150  , 149 )


			username_textfield:stopInput()
			password_textfield:stopInput()

			login_btn:getLayer():setVisible(true)
			send_btn:showBtn(false)
			backBtn:getLayer():setVisible(false)
			
			isReg = false
			registerBtn:showBtn(true)
			registerBtn:setEnable(true)
			setAnchPos( registerBtn:getLayer() , 265 , 83 )
		end
	end

	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")

	--mac输入框不可用
	if "mac" == device.platform and "" == username then
		username = "antion"
		password = "bjkcamj1ka"
	end

	-- 用户名输入框
	username_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入ID" , 
											existStr = ( ( username and username ~= "" ) and username or nil ) ,
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( username_textfield:getLayer() , 10 )
	



	-- 密码输入框
	password_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入密码" , 
											existStr = ( ( password and password ~= "" ) and password or nil ) , 
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( password_textfield:getLayer() , 10 )


	-- 假输入框背景
	box_bg = display.newSprite(IMG_PATH .. "image/scene/login/box_bg.png")
	setAnchPos(box_bg , 0 , 68)
	loginbox_layer:addChild(box_bg)
	
	-- effBg = display.newSprite(IMG_PATH .. "image/scene/login/eff_bg.png")
	-- effBg:setVisible( false )
	-- loginbox_layer:addChild( effBg )
	-- local function createAction()
	-- 		local action
	-- 		action = getSequenceAction( CCFadeIn:create( 0.5 ) , CCFadeOut:create( 0.5 ) , CCCallFunc:create(
	-- 		function()
	-- 			effBg:runAction(createAction())
	-- 		end))	
	-- 		return action
	-- end
	-- effBg:runAction(createAction())	
	
	
	-- 假用户名输入框背景
	username_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 185 , {
		callback = function()
			changeStauts(true , "username")
		end
	}):getLayer()
	loginbox_layer:addChild(username_input_bg)

	-- 假密码输入框背景
	password_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 133 , {
		callback = function()
			changeStauts(true , "password")
		end
	}):getLayer()
	loginbox_layer:addChild(password_input_bg)


	-- 开始按钮
	send_btn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"loginBtn.png" , "loginBtn_pre.png"} , 78 , 405 , {
		front = IMG_PATH .. "image/scene/login/startGame_txt.png" , 
		callback = 
		function()
			isReg = false
			login_callback()
		end
	})
	loginbox_layer:addChild( send_btn:getLayer() )
	
	-- 注册按钮
	registerBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"loginBtn.png" , "loginBtn_pre.png"} , 265 , 83 , {
		front = IMG_PATH .. "image/scene/login/register_text.png" , 
		callback =
		function()
			if not isReg then
				isReg = true
				changeStauts( true , "username" )
			else
				login_callback()
			end

		end 
	})
	loginbox_layer:addChild( registerBtn:getLayer() )
	
	-- 返回按钮
	backBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"loginBtn.png" , "loginBtn_pre.png"} , 265 , 405 , {
		front = IMG_PATH .. "image/scene/login/back_text.png" , 
		callback = 
		function()
			changeStauts()
		end
	})
	loginbox_layer:addChild( backBtn:getLayer() )


	-- 登录按钮
	login_btn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"loginBtn.png" , "loginBtn_pre.png"} , 78 , 83 , {
		front = IMG_PATH .. "image/scene/login/startGame_txt.png" , 
		callback = login_callback,
	})
	loginbox_layer:addChild( login_btn:getLayer() )


	-- 默认为假输入框状态
	changeStauts( isReg )
	
	
	setAnchPos( loginbox_layer , 0 , -display.cy )
	transition.moveTo(loginbox_layer , {time = 0.5 , y = 0 , easing = "BACKOUT" })
	layer:addChild( loginbox_layer , 10)
end

--登陆选择
function M:tgxy2_gameSelect()
	local loginBtn , fastGameBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"loginBtn.png" , "loginBtn_pre.png"} , 42 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			fastGameBtn:removeFromParentAndCleanup( true )
			fastGameBtn = nil 
			
			loginBtn:removeFromParentAndCleanup( true )
			loginBtn = nil 
				
			M:tgxy2_showLoginBox()
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	fastGameBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"loginBtn.png" , "loginBtn_pre.png"} , 264 , 70 , {
		front = IMG_PATH .. "image/scene/login/fast_game.png" , 
		callback = function()
			local open_id = ""
			local password = ""

			if device.infos["msi"] and type(device.infos["msi"]) == "string" and string.len(device.infos["msi"]) >= 10 then
				open_id = device.infos["msi"]
			elseif device.infos["mac"] and type(device.infos["mac"]) == "string" and string.len(device.infos["mac"]) >= 10 then
				open_id = string.gsub(device.infos["mac"] , ":" , "")
			end

			if string.len(open_id) < 10 then
				KNMsg.getInstance():flashShow("不可快速游戏，请使用帐号登录")
				return
			end

			password = tostring( math.random(10000 , 999999) )
			local fast_login_sign = nil
			if CMD5 ~= nil then
				fast_login_sign = MD5(open_id .. CHANNEL_ID)
			end

			-- 发请求
			local post_data = {
				open_id = open_id ,
				pwd = password ,
				channel = CHANNEL_ID,
				fast_login_sign = fast_login_sign,
				reg = 2 ,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data , {
				success_callback = function(d)
					KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
					if d["result"] and d["result"]["pwd"] then
						password = d["result"]["pwd"]
					end
					KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)
				end
			})
		end
	}):getLayer()
	layer:addChild(fastGameBtn)
	
end

function M:create( params )
	CHANNEL_GAME = nil
	
	if __INNER_NEWSDK__  and __INNER_HASLOGIN__  then 
		local newLoginLayer = requires(IMG_PATH, "GameLuaScript/Scene/login/newSdkLogin")
		local ret_layer = newLoginLayer:create(params)
		if ret_layer then return  ret_layer end
	end

	--------------------------------------------------------------------------
	--新的ios联运方案, 以后旧ios的联运平台会慢慢转移到这[ by antion 2014.09.15 ]
	if __INNER_IOS_SDK_VER then
		layer = requires(IMG_PATH, "GameLuaScript/Scene/login/_ios").run()
		if layer then return layer end
	end
	--------------------------------------------------------------------------

	if CHANNEL_ID == "hysjIos91" or CHANNEL_ID == "tgxyIos91" or CHANNEL_ID == "tmsjIos91" then return M:_91_login( params ) end
	if CHANNEL_ID == "cmge" then return M:cmge_login( params ) end
    if CHANNEL_ID == "appFame"  then return M:appFame_login( params ) end
    if CHANNEL_ID == "appFameOfficial" or CHANNEL_ID == "appFameOfficial2" then return M:appFameOfficial_login( params ) end
    if CHANNEL_ID == "hyxsdIosItools" or CHANNEL_ID == "tgxyIosItools" or CHANNEL_ID == "tmsjIosItools" then return M:ios_iTools_login( params ) end
	if CHANNEL_ID == "longyin" or CHANNEL_ID == "mi" or CHANNEL_ID == "mm" or CHANNEL_ID == "downjoy" or CHANNEL_ID == "DK" or CHANNEL_ID == "anzhi" or CHANNEL_ID == "kugou" or CHANNEL_ID == "sohu" or CHANNEL_ID == "shoumeng" or CHANNEL_ID == "gfan" or CHANNEL_ID == "nearme.gamecenter" or CHANNEL_ID == "dahua" or CHANNEL_ID == "ifeng" or CHANNEL_ID == "changwan" or CHANNEL_ID == "tianyi" or CHANNEL_ID == "wdj" 
		or CHANNEL_ID == "ppw" or CHANNEL_ID == "sky" or CHANNEL_ID == "sqwan" or CHANNEL_ID == "dianjin" or CHANNEL_ID == "lybd" or CHANNEL_ID == "meizu" or CHANNEL_ID == "ywyd" or CHANNEL_ID == "nd91" or CHANNEL_ID == "egame"  or CHANNEL_ID == "fgwan" or CHANNEL_ID == "mg" or CHANNEL_ID == "guobi" or CHANNEL_ID == "BD" or CHANNEL_ID == "cmgame" then

		CHANNEL_GAME = "ayou"

		return M:longyin_login( params )
	end
	if CHANNEL_ID == "ledou" then return M:ledou_login( params ) end
	if CHANNEL_ID == "pada" then return M:pada_login( params ) end
	if CHANNEL_ID == "qihoo" then return M:qihoo_login( params ) end
	if CHANNEL_ID == "youxin" then return M:youxin_login( params ) end
	if CHANNEL_ID == "baidu" or CHANNEL_ID == "hy" then return M:baidu_login( params ) end
	if CHANNEL_ID == "jstf_iospj" then return M:jstfIos_login( params ) end
	if platform_type == 1 and CHANNEL_GROUP == "td" and CHANNEL_ID ~= "jstftest" then return M:jstf_login( params ) end
	if CHANNEL_ID == "tmsjDK" then return M:hyDK_login( params ) end
	
	if CHANNEL_ID == "one.HUAWEI" or CHANNEL_ID == "tgxy.huawei"  then 
		if CHANNEL_ID == "tgxy.huawei" then params.platform = "tgxy_huawei" end
		return M:huawei_login( params ) 
	end
	if CHANNEL_ID == "hysjIosTBT" or CHANNEL_ID == "tgxyIosTBT" or CHANNEL_ID == "tmsjIosTBT" then return M:ios_tbt_login( params ) end
	if CHANNEL_ID == "hysjIosYLT" or CHANNEL_ID=="hysjIosAppStore" then return M:ios_ylt_login( params ) end
	if CHANNEL_ID == "hysjIosDownJoy" or CHANNEL_ID == "tgxyIosDj" or CHANNEL_ID == "tmsjIosDj" then return M:ios_DownJoy_login( params ) end
	if CHANNEL_ID == "hysjIosPP" or CHANNEL_ID == "tgxyIosPP" or CHANNEL_ID == "tmsjIosPP" then return M:ios_PP_login(params) end
	if CHANNEL_ID == "hysjIosUC" or CHANNEL_ID == "tgxyIosUC" or CHANNEL_ID == "tmsjIosUC" then return M:ios_UC_login(params) end
	if CHANNEL_ID == "hysjIosKY" or CHANNEL_ID == "tgxyIosKY" or CHANNEL_ID == "tmsjIosKY" then return M:ios_KY_login(params) end
	if CHANNEL_ID == "hysjIos17173" then return M:ios_17173_login(params) end	
	if CHANNEL_GROUP == "tgxy2" or CHANNEL_GROUP == "tgxy" then return M:tgxy2_login(params) end
	--------------------------------------------------------------------------

	--每个游戏的渠道
	local CHANNEL_CONFIG = {"tmsj" , "tgxy" , "hy"}

	for _ , group in pairs(CHANNEL_CONFIG) do
		local mod = requires(IMG_PATH, "GameLuaScript/Scene/login/"..group)
		if mod then 
			local capture, ret = mod:go(params)
			if capture then return ret end
		end
	end
	
	__INNER_SELF_LOGIN = true
	
	isReg = params.isReg or false	--是否是注册
	
	loginbox_layer = nil

	layer = display.newLayer()
	
	requires(IMG_PATH,"GameLuaScript/Config/version")

	
	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg , 0 , 0)
	layer:addChild( bg )
	
	local version_label = CCLabelTTF:create(VERSION , FONT , 18)
	setAnchPos(version_label , 10 , 10)
	version_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
	layer:addChild( version_label )

	if CHANNEL_ID == "test" then
		local test_label = CCLabelTTF:create("骚年，你运行的是测试版本，有问题请重新安装" , FONT , 18)
		setAnchPos(test_label , 10 , display.height - 30)
		test_label:setColor( ccc3( 0x4d , 0x15 , 0x15 ) )
		layer:addChild( test_label )
	end
	
	local userinfo_file_path = "userinfo.txt"
	if device.platform == "windows" then
		userinfo_file_path = "../userinfo.txt"
	end
	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")
	
	if username and username ~= "" then
		M:showLoginBox()
	else
		M:gameSelect()
	end

	return layer
end


function M:showLoginBox()

	local box_bg , username_input_bg , password_input_bg , username_textfield , effBg , 
		password_textfield ,  login_btn , send_btn , backBtn ,registerBtn 

	

	--[[登录按钮]]
	local login_callback = function()
		audio.stopMusic( false )
		
		echoLog("Login" , "Click Login Button")

		local open_id = username_textfield:getString()
		open_id = string.trim( open_id )

		local password = password_textfield:getString()
		password = string.trim( password )
	
		if open_id == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入ID")
			return
		end

		if password == "" then
			-- 错误提示
			KNMsg:getInstance():flashShow("请输入密码")
			return
		end

		username_textfield:stopInput()
		password_textfield:stopInput()

		-- 发请求
		local post_data = {
			open_id = open_id ,
			pwd = password ,
			channel = CHANNEL_ID,
			reg = isReg and 1 or nil ,
		}
		for k , v in pairs(device.infos) do
			post_data[k] = v
		end
		
		HTTP:call("verify" , "check" , post_data , {
			success_callback = function(d)
				KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
				KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)
			end,
			error_callback = function(d)
				switchScene("login" , { isReg = isReg } , function()
					KNMsg.getInstance():flashShow("[" .. d.code .. "]" .. d.msg)
				end)
			end
		})
	end


	if loginbox_layer ~= nil then
		loginbox_layer:removeFromParentAndCleanup(true)
	end

	loginbox_layer = display.newLayer()

	

	-- 切换真假输入框的状态
	local function changeStauts(status , type)
		if status == true then
			box_bg:setPosition(0 , 432)
			
			setAnchPos( username_textfield:getLayer() , 150  , 516 )
			setAnchPos( password_textfield:getLayer() , 150  , 476 )
			
			username_input_bg:setPosition(140 , 500)
			password_input_bg:setPosition(140 , 460)
			
			effBg:setVisible(true)
			
			if type == "username" then
				setAnchPos( effBg , 140 + 118 , 500 + 16 , 0.5 , 0.5  )
				
				username_textfield:startInput()
				password_textfield:stopInput()
				
			else
				setAnchPos( effBg , 140 + 118 , 460 + 16 , 0.5 , 0.5  )
				
				username_textfield:stopInput()
				password_textfield:startInput()
				
			end

			login_btn:setVisible(false)
			if isReg then
				send_btn:showBtn(false)
				send_btn:setEnable(false)
				
				setAnchPos( registerBtn:getLayer() , 390 , 455 )
			else
				send_btn:showBtn(true)
				send_btn:setEnable(true)
				
				registerBtn:showBtn(false)
				registerBtn:setEnable(false)
				setAnchPos( registerBtn:getLayer() , 390 , 130 )
			end
			
			backBtn:setVisible(true)
		else
			effBg:setVisible( false )	--隐藏提示光效
			
			box_bg:setPosition(0 , 110)
			

			username_input_bg:setPosition(140 , 175)
			password_input_bg:setPosition(140 , 136)

			setAnchPos( username_textfield:getLayer() , 150  , 192 )
			setAnchPos( password_textfield:getLayer() , 150  , 152 )


			username_textfield:stopInput()
			password_textfield:stopInput()

			login_btn:setVisible(true)
			send_btn:showBtn(false)
			backBtn:setVisible(false)
			
			isReg = false
			registerBtn:showBtn(true)
			registerBtn:setEnable(true)
			setAnchPos( registerBtn:getLayer() , 390 , 130 )
		end
	end

	local username = KNFileManager.readfile(userinfo_file_path , "name" , "=")
	local password = KNFileManager.readfile(userinfo_file_path , "pwd" , "=")

	--mac输入框不可用
	if "mac" == device.platform and "" == username then
		username = "kuniu2"
		password = "bjkcamj1ka"
	end

	-- 用户名输入框
	username_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入ID" , 
											existStr = ( ( username and username ~= "" ) and username or nil ) ,
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( username_textfield:getLayer() , 10 )
	



	-- 密码输入框
	password_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 20 , 
											defStr = "请输入密码" , 
											existStr = ( ( password and password ~= "" ) and password or nil ) , 
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
	loginbox_layer:addChild( password_textfield:getLayer() , 10 )


	-- 假输入框背景
	box_bg = display.newSprite(IMG_PATH .. "image/scene/login/box_bg.png")
	setAnchPos(box_bg , 0 , 110)
	loginbox_layer:addChild(box_bg)
	
	effBg = display.newSprite(IMG_PATH .. "image/scene/login/eff_bg.png")
	effBg:setVisible( false )
	loginbox_layer:addChild( effBg )
	local function createAction()
			local action
			action = getSequenceAction( CCFadeIn:create( 0.5 ) , CCFadeOut:create( 0.5 ) , CCCallFunc:create(
			function()
				effBg:runAction(createAction())
			end))	
			return action
	end
	effBg:runAction(createAction())	
	
	
	-- 假用户名输入框背景
	username_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 175 , {
		callback = function()
			changeStauts(true , "username")
		end
	}):getLayer()
	loginbox_layer:addChild(username_input_bg)

	-- 假密码输入框背景
	password_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 140 , 136 , {
		callback = function()
			changeStauts(true , "password")
		end
	}):getLayer()
	loginbox_layer:addChild(password_input_bg)


	-- 开始按钮
	send_btn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"send_btn.png" , "send_btn_pre.png"} , 390 , 455 , {
		callback = 
		function()
			isReg = false
			login_callback()
		end
	})
	loginbox_layer:addChild( send_btn:getLayer() )
	
	-- 注册按钮
	registerBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"register.png" , "register_pre.png"} , 390 , 130 , {
		callback =
		function()
			if not isReg then
				isReg = true
				changeStauts( true , "username" )
			else
				login_callback()
			end

		end 
	})
	loginbox_layer:addChild( registerBtn:getLayer() )
	
	-- 返回按钮
	backBtn = KNBtn:new(IMG_PATH .. "image/scene/login" , {"back.png" , "back_pre.png"} , 10 , 460 , {
		callback = 
		function()
			changeStauts()
		end
	}):getLayer()
	loginbox_layer:addChild( backBtn )


	-- 登录按钮
	login_btn = KNButton:new("login" , 0 , display.cx , 20 , login_callback , 1 , { noDisable = true })
	setAnchPos(login_btn , display.cx - 120 , 20 , 0.5)
	loginbox_layer:addChild( login_btn )


	-- 默认为假输入框状态
	changeStauts( isReg )
	
	
	setAnchPos( loginbox_layer , 0 , -display.cy )
	transition.moveTo(loginbox_layer , {time = 0.5 , y = 0 , easing = "BACKOUT" })
	layer:addChild( loginbox_layer , 10)
end
--登陆选择
function M:gameSelect()
	local loginBtn , fastGameBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , 42 , 70 , {
		front = IMG_PATH .. "image/scene/login/login.png" , 
		callback = function()
			fastGameBtn:removeFromParentAndCleanup( true )
			fastGameBtn = nil 
			
			loginBtn:removeFromParentAndCleanup( true )
			loginBtn = nil 
				
			M:showLoginBox()
		end
	}):getLayer()
	layer:addChild(loginBtn)
	
	fastGameBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png" , "select_btn_pre.png"} , 264 , 70 , {
		front = IMG_PATH .. "image/scene/login/fast_game.png" , 
		callback = function()
			local open_id = ""
			local password = ""

			if device.infos["msi"] and type(device.infos["msi"]) == "string" and string.len(device.infos["msi"]) >= 10 then
				open_id = device.infos["msi"]
			elseif device.infos["mac"] and type(device.infos["mac"]) == "string" and string.len(device.infos["mac"]) >= 10 then
				open_id = string.gsub(device.infos["mac"] , ":" , "")
			end

			if string.len(open_id) < 10 then
				KNMsg.getInstance():flashShow("不可快速游戏，请使用帐号登录")
				return
			end

			password = tostring( math.random(10000 , 999999) )
			local fast_login_sign = nil
			if CMD5 ~= nil then
				fast_login_sign = MD5(open_id .. CHANNEL_ID)
			end

			-- 发请求
			local post_data = {
				open_id = open_id ,
				pwd = password ,
				channel = CHANNEL_ID,
				fast_login_sign = fast_login_sign,
				reg = 2 ,
			}
			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			HTTP:call("verify" , "check" , post_data , {
				success_callback = function(d)
					KNFileManager.updatafile(userinfo_file_path , "name" , "=" , open_id)
					if d["result"] and d["result"]["pwd"] then
						password = d["result"]["pwd"]
					end
					KNFileManager.updatafile(userinfo_file_path , "pwd" , "=" , password)
				end
			})
		end
	}):getLayer()
	layer:addChild(fastGameBtn)
	
end





return M
