
------------------------------------------------
-- common head
local modname = ...
local M = {}
setmetatable( M, { __index = _G } )
package.loaded[modname] = M
setfenv(1, M)
------------------------------------------------

local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")

local layer

local hy_common_login = function(self, callback)
	CCLuaLog("====================>Login 111111111<========================")


	layer = display.newLayer()

	requires(IMG_PATH, "GameLuaScript/Config/version")

	local bg = display.newSprite(IMG_PATH .. "image/scene/login/bg.jpg")
	setAnchPos(bg, 0, 0)
	layer:addChild(bg)

	local version_label = CCLabelTTF:create(VERSION, FONT, 18)
	setAnchPos(version_label, 10, 10)
	version_label:setColor( ccc3( 0x4d, 0x15, 0x15 ) )
	layer:addChild(version_label)
	
	if CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
		display.newSprite(IMG_PATH .. "image/scene/login/role.png", display.cx, 536):addTo(layer)
		display.newSprite(IMG_PATH .. "image/scene/login/logo.png", display.cx, 321):addTo(layer)
	end

	local loginBtn
	loginBtn = KNBtn:new(IMG_PATH .. "image/scene/login", {"select_btn.png", "select_btn_pre.png"} , display.cx - 100, 70,
	{
		front = IMG_PATH .. "image/scene/login/login.png", 
		callback = function()
			callback()
		end
	})
	layer:addChild( loginBtn:getLayer() )

	-- auto login
	local handle
	local function autoLogin()
		CCLuaLog("====================>auto login<========================")
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
		handle = nil

		callback()
	end
    handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc( autoLogin , 0.1 , false )
	
	return layer, loginBtn
end

local login = function(self, params)
	CCLuaLog("====================>Login 222222222<========================")
	-- 参数默认值
	local loginParameters = params.loginParameters or {}	-- table
	local onLoginSucceed = params.onLoginSucceed or function()	-- function expected
		KNMsg.getInstance():flashShow("no onLoginSucceed action!")
	end
	-------------------------------------------------------------------
	local layer, loginBtn
	layer, loginBtn = hy_common_login(self, function()
		CCLuaLog("====================>Login 333333333<========================")
	-------------------------------------------------------------------
		local onLoginBegin = function()
			loginBtn:setEnable(false)
			
			-- 1秒内禁止重复点击
			local array = CCArray:create()
			array:addObject( CCDelayTime:create(1) )
			array:addObject( CCCallFunc:create( function() loginBtn:setEnable(true) end ) )
			loginBtn:getLayer():runAction( CCSequence:create(array) )
		end
		
		local onLoginEnd = function()
			
		end
		
		onLoginBegin()
		
		loginParameters.action = "login"
		loginParameters.callback = function(response)
			CCLuaLog("====================>lua login<========================")
			dump(response, "response")
		
			if response["result"] == "fail" or response["result"] == "cancel" then
				if response["message"] and response["message"] ~= "" then
					KNMsg.getInstance():flashShow(response["message"])
				end
				return
			elseif response["result"] == "succeed" then
				onLoginSucceed(response)
			else
				CCLuaLog("do nothing")
			end
		end

		CCLuaLog("====================>Login 5555555555<========================")
		
		DirectChannel.instance():call(loginParameters)
	-------------------------------------------------------------------
	end)
	
	return layer
end

new_login = function(self, params)
	return login(self,
	{
		loginParameters = {},
		onLoginSucceed = function(response)
			dump(response , "response")
			local post_data =
			{
				channel = CHANNEL_ID,
			}

			for k , v in pairs(response) do
				post_data[k] = v
			end

			for k , v in pairs(device.infos) do
				post_data[k] = v
			end
			
			dump(post_data , "post_data")

			HTTP:call("verify" , "check" , post_data , 
			{
				success_callback = function(data)
					_G.LOGINDATA_FROM_ANDROID = post_data 										--登陆成功后保存从 android 平台传来的参数 

					local login_back_data = data and json.encode(data) or ""

					DirectChannel.instance():call(
					{
						action = "logout",

						login_back_data = login_back_data,

						callback = function()
							if SOCKET:returnInstance("battle") then
								Clock:removeTimeFun("heartbeat")
								SOCKET:getInstance("battle"):close()
								SOCKET:delInstance("battle")
							end
							switchScene("login")
						end
					})
				end
			})

			
		end
	})
end

create = function(self, params)
	new_login(self, params)
	return layer
end

return M
