local PATH = IMG_PATH.."image/scene/method/"
local HERO_PATH = IMG_PATH .. "image/scene/hero/"
local SOUL_PATH = IMG_PATH.."image/scene/soulTemple/"
local effect = requires(IMG_PATH,"GameLuaScript/Common/KNEffect")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")
local prop = {"17141","17142","17143"}
local M = class("methodLayer", function() return display.newLayer() end)
M.__index = M

local  dataEquip={}
local  g_gid=nil
local  heroInfos={}
local  g_filter={}

function M:ctor(params)

	dataEquip=params or {}


	local heroText = "英雄"
	if CHANNEL_GROUP == "hy" then
		heroText = "忍者"
	elseif CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
		heroText = "修者"
	end

	self.params = params
	local data = params.data or {}
	-- dump(params)


	local upData=params.upData or nil
	heroInfos=params.heroInfos or {}


	g_gid=params.gid or nil
	dataEquip.g_gid=g_gid

	
	local curConfig
	if 0 ~= tonumber(data.fid) then
		curConfig = data.config[data.fid ..""]
	end
	local layer = display.newLayer():addTo(self)

	--背景、标题
	display.newSprite(PATH.."bg.png"):center():addTo(layer)
	local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
	local infoLayer = InfoLayer:new("list" , 0, {title_text = PATH.."title.png", tail_hide = true, priority = -202, closeCallback = function()
		if params.backFunc then 
			params.backFunc()
		else
			switchScene("hero",{gid = params.gid})
		end

	end})
	layer:add(infoLayer:getLayer())

	--选择人物
	display.newSprite(SCENECOMMON.."cbox.png", display.cx, 700):addTo(layer)
	local iconGroup = KNRadioGroup:new()	--icon单选
	local iconScroll = KNScrollView:new( 40 , 665 , 400 , 100 , 10 , true , 0)
	layer:add(iconScroll:getLayer())

	local iconPos = {
		--heart, hero1, hero2....
		["1"] = {{display.cx, 383}, {display.cx, 548}, {395, 324}, {84, 324}},
		["2"] = {{display.cx, 383}, {display.cx, 548}, {404, 371}, {display.cx, 235}, {72, 371}},
		["3"] = {{display.cx, 383}, {display.cx, 548}, {409, 420}, {364, 259}, {102, 259}, {68, 420}},
	}
	local roleTypes = {
		rj = {1, "人杰"},
		gx = {2, "鬼雄"},
		yh = {3, "英豪"}
	}
	if CHANNEL_GROUP == "hy" then
		roleTypes = {
		rj = {1, "忍术"},
		gx = {2, "体术"},
		yh = {3, "幻术"}
	}
	end

	--主显示区域
	local mainLayer
	local function upt()
		if mainLayer then mainLayer:remove() end
		mainLayer = display.newLayer():addTo(layer)
		if curConfig and 0 ~= tonumber(data.fid) then
			-- display.newSprite(PATH .."exp2.png", 242, 610):addTo(mainLayer, 1)
			-- display.newSprite(PATH .."exp1.png", 242, 610):addTo(mainLayer, 1)
			local exp_bar = KNBar:new("method" ,  176, 244 , { maxValue = data.lv_up.next.exp , curValue =  data.lv_up.cur.exp  })
			mainLayer:addChild( exp_bar , 10 )

			-- display.strokeLabel(data.data.heart and "1/1" or "未激活", 229, 602, 16, ccc3(0, 0, 0)):addTo(mainLayer, 1)
			display.strokeLabel(curConfig.name .." Lv"..data.lv_up.cur.lv, 15, 598, 20, ccc3(217, 155, 63)):addTo(mainLayer)

			if data.lv_up.cur.lv < 10 then 
				--阵法升级
				local upGrade = KNBtn:new(IMG_PATH.."image/scene/zhenFaWar/" , {"btn_bg.png", "btn_bg_pre.png"} , 325, 581, {
					front = IMG_PATH.."image/scene/zhenFaWar/zhenfa_upgrade.png",
					priority = -301,
					callback = function()
						self:upGradeLayer(params , upt)
					end 
				})
				mainLayer:add(upGrade:getLayer())
			end



			if not data.data.heart then
				display.strokeLabel("在核心位置放入指定的" ..heroText .."即可激活阵法", 55, 120, 20, ccc3(255, 0, 0)):addTo(mainLayer, 1)
			end
			if data.fid > table.nums(iconPos) then
				return
			end
			for i,v in pairs(iconPos[data.fid ..""]) do
				local pos = 1 == i and "heart" or "hero" ..(i-1)
				local id, filter, filename, heroname, other, roleInfo, front = data.data[pos]


				if id then
					roleInfo = DATA_Bag:get("general", id)
					if roleInfo then
						local hero_img_path = IMG_PATH .. "image/hero/"
						if HAS_GOD_GENERAL and roleInfo.god == 1 then
							hero_img_path = IMG_PATH .. "image/hero/shen/"
						end
						front = hero_img_path.. getImageByType(roleInfo.cid, "s", true)
					end
				end

				if 1 == i then
					filter = {cid = curConfig[pos] ..""}
					filename = "main_bg.png"
					other = {PATH .."main_frame.png", 16, 18}
					heroname = "核心" ..heroText ..": " ..getConfig("general", curConfig[pos], "name")
					display.strokeLabel(heroname, v[1]-65, v[2]-70, 18, ccc3(255, 255, 255)):addTo(mainLayer)
				else
					filter = {role = roleTypes[curConfig[pos]][1]}
					filename = "hero_bg.png"
					heroname = "辅助" ..roleTypes[curConfig[pos]][2]
					if roleInfo then
						other = {COMMONPATH.."star_border/border_"..getConfig("general", roleInfo.cid, "star")..".png", 20, 9}
						heroname = heroname ..": " ..roleInfo.name
						display.strokeLabel(heroname, v[1]-65, v[2]-70, 18, ccc3(255, 255, 255)):addTo(mainLayer)
					else
						display.strokeLabel(heroname, v[1]-35, v[2]-70, 18, ccc3(255, 255, 255)):addTo(mainLayer)
					end
				end


				filter.exceptZhenfa = true

				g_filter[pos]=filter

				local function selectHero()
					local list
					list = SelectList:new("general",layer,display.newSprite(COMMONPATH .. "title/hero_text.png"),{
						exceptUse = true,
						btn_opt = "lineup_0.png",
						filter = filter,
						optCallback = function()
							list:destroy()
							HTTP:call("zhenfa" , "up",{gid=list:getCurItem():getId(), pos=pos},{
								success_callback = function(data)
									HTTP:call("zhenfa" , "initData",{},{
										success_callback = function(data)
											switchScene("method", {data=data,gid=params.gid})
										end
									})
								end
							})
						end
					})
					self:addChild(list:getLayer())
				end

				local hero = KNBtn:new(PATH, {filename},v[1],v[2],{
						anchMid = true,
						other = other,
						front = front,
						callback= function()
							if roleInfo then
								self:look(pos, roleInfo, curConfig[pos], curConfig.name, data, selectHero)
							else
								selectHero()
							end
						end
					})
				mainLayer:add(hero:getLayer())
				-- if upData~=nil then
				-- 	dump("CVCVC")
				-- 	dump(roleInfo)
				-- 	dump(pos)
				-- 	dump(curConfig[pos])
				-- 	dump(curConfig.name)
				-- 	dump(data)
				-- 	dump(selectHero)
				-- 	self:look(pos,roleInfo,curConfig[pos],curConfig.name, data, selectHero)
				-- else 
					-- local hero = KNBtn:new(PATH, {filename},v[1],v[2],{
					-- 	anchMid = true,
					-- 	other = other,
					-- 	front = front,
					-- 	callback= function()
					-- 		if roleInfo then
					-- 			self:look(pos, roleInfo, curConfig[pos], curConfig.name, data, selectHero)
					-- 		else
					-- 			selectHero()
					-- 		end
					-- 	end
					-- })
					-- mainLayer:add(hero:getLayer())
				-- end 
			end
			--加成

			if data.attr and table.nums(data.attr) > 0 then
				display.newSprite(PATH .."text1.png", 93, 179):addTo(mainLayer)
				display.newSprite(PATH .."text2.png", 373, 179):addTo(mainLayer)
				local color = CCLayerColor:create(ccc4(0, 200, 200, 20))
				color:setPosition(ccp(14, 103))
				color:setContentSize(CCSize(460, 90))
				mainLayer:addChild(color)
				local scroll = KNScrollView:new(14, 103, 460, 60)
				mainLayer:add(scroll:getLayer())
				local roleNames = {atk={"攻击","人杰"}, def={"防御","英豪"}, hp={"血量","鬼雄"}, agi={"敏捷","英豪"}}
				if CHANNEL_GROUP == "hy" then
					roleNames = {atk={"攻击","忍术"}, def={"防御","幻术"}, hp={"血量","体术"}, agi={"敏捷","幻术"}}
				end
				local function getStr(key, name, job)
					local heartValue = 0
					if data.attr.heart then
						heartValue = data.attr.heart[key]
					end
					local helpValue = 0
					for i=1, curConfig.numb do
						if data.attr["hero" ..i] then
							helpValue = helpValue+data.attr["hero" ..i][key]
						end
					end
					local node = display.newNode():size(490, 18)
					display.strokeLabel("所有上阵" ..heroText ..name .."加成: " ..heartValue, 0, 0, 16, ccc3(0, 255, 255)):addTo(node)
					display.strokeLabel("所有上阵" ..job ..name .."加成: " ..helpValue, 240, 0, 16, ccc3(0, 255, 255)):addTo(node)
					return node
				end
				for k,v in pairs(roleNames) do
					scroll:addChild(getStr(k, v[1], v[2]))
				end
			end
		end
	end upt()

	if heroInfos~=nil and table.nums(heroInfos)>0 then

		local pos=heroInfos.pos
		local roleInfo=heroInfos.roleInfo
		local roleType=heroInfos.roleType
		local methodName=heroInfos.methodName
		local data=heroInfos.data or {}

		local function selectHero()
			local list
			list = SelectList:new("general",layer,display.newSprite(COMMONPATH .. "title/hero_text.png"),{
				exceptUse = true,
				btn_opt = "lineup_0.png",
				filter = g_filter[pos],
				optCallback = function()
					list:destroy()
						HTTP:call("zhenfa" , "up",{gid=list:getCurItem():getId(), pos=pos},{
							success_callback = function(data)
								HTTP:call("zhenfa" , "initData",{},{
									success_callback = function(data)
										switchScene("method", {data=data,gid=params.gid})
									end
								})
							end
						})
					end
			})
			self:addChild(list:getLayer())
		end
		self:look(pos, roleInfo,roleType,methodName, data, selectHero)
	else

	end 

	--已经学习的阵法
	self.effect = nil
	self.zfs = {}
	local function addEff(idx)
		if self.effect then self.effect:removeSelf() end
		self.effect = effect.get(SOUL_PATH, "award_eff",nil,nil,.1):addTo(self.zfs[idx]:getLayer(), 999):scale(.7):anchor(0, 0):pos(-9, -4)
	end
	local cur
	local idx = 1
	for k,v in pairs(data.study_list) do
		local c = data.config[k]
		if c then
			local useIdx = idx
			local zf = KNBtn:new(IMG_PATH.."image/scene/common/", {"skill_frame1.png"},0,0,{
				other = {COMMONPATH.."star_border/border_"..getConfig("prop", c.prop, "star")..".png", -14, -14},
				front = getImageByType(c.prop , "s"),
				callback= function()
					if data.fid .."" ~= k then
						KNMsg.getInstance():boxShow( "切换阵法会自动关闭当前阵, 是否继续? \n\n\n" ,{ 
							confirmFun = function()
								HTTP:call("zhenfa" , "change",{fid = k},{
									success_callback = function(result)
										if result.update then
											for k,v in pairs(result.update) do
												data[k] = v
											end
										end
										curConfig = data.config[data.fid ..""]
										upt()
										addEff(useIdx)
									end
								})
							end,
							cancelFun = function() end 
						})
					end
				end
			}, iconGroup)
			iconScroll:addChild(zf:getLayer(),zf)
			self.zfs[#self.zfs+1] = zf
			if tostring(k) == tostring(data.fid) then
				cur = idx
			end
			idx = idx+1
		end
	end
	if cur then addEff(cur) end

	--添加
	--添加英雄
	local btn = KNBtn:new(PATH , {"add.png", "add2.png"} , 0 , 0 , {
		callback = function()
			local list
			list = SelectList:new("prop",layer,display.newSprite(COMMONPATH.."title/prop_text.png"),{ 
				btn_opt = "use.png",
				y = 85,
				showTitle = true , 
				emptyTip = "你没有任何阵法，可前往帮派商城中购买阵法碎片合成",
				filter = {type = "zfmap"},
				optCallback = function()
					list:destroy()
					HTTP:call("zhenfa" , "study",{id=list:getCurItem():getId()},{
						success_callback = function(data)
							HTTP:call("zhenfa" , "initData",{},{
								success_callback = function(data)
									switchScene("method", {data=data,gid=params.gid})
								end
							})
						end
					})
				end
			})
			self:addChild(list:getLayer())
		end
	}, iconGroup)
	iconScroll:addChild(btn:getLayer(),btn)
	-- iconGroup:chooseByIndex(index,true)
end

function M:look(pos, roleInfo, roleType, methodName, data, selectHero)

		local heroInfos={}
		heroInfos.pos=pos
		heroInfos.roleInfo=roleInfo
		heroInfos.roleType=roleType
		heroInfos.methodName=methodName

		if data[pos] then 
			if data[pos].filter then 
				heroInfos.filter=data[pos].filter
			end 
		end 


		local attr = data.attr[pos]
		-- local lvconfig = data.lv_config["1"]
		local lvconfig = data.lv_up.cur.attr or {}

		local layer = display.newLayer()
		local mask = KNMask:new({item=layer,priority=-300})
		self:add(mask:getLayer())

		display.newSprite(COMMONPATH.."tip_bg.png"):addTo(layer):center():scaley(1.5)
		display.newSprite(PATH.."look/bg.png", display.cx, 407):addTo(layer):scalex(.9)
		display.newSprite(PATH.."look/text1.png", 176, 513):addTo(layer)
		display.strokeLabel(roleInfo.name .."  Lv  " ..roleInfo.lv, 129, 544, 20, ccc3(0, 0, 0)):addTo(layer)
		display.strokeLabel(methodName, 231, 498, 20, ccc3(0, 0, 0)):addTo(layer)

		--头像
		local hero_img_path = IMG_PATH .. "image/hero/"
		if HAS_GOD_GENERAL and roleInfo.god == 1 then
			hero_img_path = IMG_PATH .. "image/hero/shen/"
		end
		local hero = KNBtn:new(IMG_PATH.."image/scene/common/", {"skill_frame1.png"},50, 501,{
			other = {COMMONPATH.."star_border/border_"..getConfig("general", roleInfo.cid, "star")..".png", -14, -14},
			front = hero_img_path.. getImageByType(roleInfo.cid, "s", true),
			callback= function() end
		})
		layer:add(hero:getLayer())

		local cnt = 0

		local roleTypeNames = {all="英雄",rj="人杰",gx="鬼雄",yh="英豪"}
		if CHANNEL_GROUP == "hy" then
			roleTypeNames = {all="忍者",rj="忍术",gx="体术",yh="幻术"}
		elseif CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
			roleTypeNames = {all="修者",rj="人杰",gx="鬼雄",yh="英豪"}
		end
		local config = {
			agi = {"敏捷", "yh"},
			atk = {"攻击", "rj"},
			def = {"防御", "yh"},
			hp = {"生命", "gx"},
		}

		-- dump(attr)

		if attr~=nil and table.nums(attr)>0 then 
			for k,v in pairs(attr) do
				if 0 ~= v then
					local value
					local roletypeName
					if "heart" == pos then
						value = lvconfig.all*100
						roletypeName = roleTypeNames["all"]
					else
						value = lvconfig[config[k][2]]*100
						roletypeName = roleTypeNames[roleType]
					end
					display.strokeLabel("可为所有上阵" ..roletypeName .."加" ..config[k][1] ..":" ..v .."(" ..value .."％)", 66, 441-cnt*29, 20, ccc3(0, 196, 189)):addTo(layer)
					cnt = cnt+1
				end
			end
		end 

		--关闭
		local close = KNBtn:new(COMMONPATH , {"back_img.png", "back_img_press.png"} , 40, 570, {
			priority = -301,
			callback = function()
				mask:remove()
			end 
		})
		layer:add(close:getLayer())

		--查看
		local look = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , 66 , 261 , {
			front = PATH .. "look/btn_look.png",
			priority = -301,
			callback = function()
				HTTP:call("general", "get", {id=roleInfo.id}, {
					success_callback = function()
						pushScene("detail" , {
							detail = "general",
							id = roleInfo.id,
							method = self.params.data.data
						})

					end
				})
			end
		})
		layer:addChild(look:getLayer())

		--换位
		local change = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , 267 , 261 , {
			front = PATH .. "look/btn_change.png",
			priority = -301,
			callback = function()
				mask:remove()
				selectHero()
			end
		})
		layer:addChild(change:getLayer())

		--dump(roleInfo)

		--是否需要进化，不需要进化则显示吞噬
		local needUp = false
		local upConfig = getConfig("generalstageconfig", roleInfo["star"].."")
		if roleInfo["star"] >= 3 and upConfig.initial_lv + tonumber(roleInfo["stage"]) * upConfig.lvadd == roleInfo.lv then
			needUp = true
		end	
		--local bg = {"btn.png", "btn_pre.png"}
		--local front = HERO_PATH..(needUp and  "jinhua.png" or "feed.png")
		--					添加装备按钮
		local bg={"btn_bg.png","btn_bg_pre.png"}
		local front= HERO_PATH..(needUp and  "jinhuaNew.png" or "feedNew.png")

		local jinhuaBtn = KNBtn:new(COMMONPATH,bg,351,565,{
			front = front,
			priority = -301,
			callback = function()
				if needUp then
					if roleInfo["star"] < 3 then
						KNMsg.getInstance():flashShow("三星及三星以上英雄可进化，当前品质英雄最大等级:"..DATA_Uplevel:get(roleInfo["star"].."")["initial_lv"].."级")
						return false
					end
					local method = {gid = self.params.gid}
					local curHeroData = DATA_General:get( roleInfo.id )
					if curHeroData then
						pushScene("uplevel" , { target = curHeroData, method=method} )
					else
						HTTP:call("general" , "get" , {
							id = roleInfo.id
						} , {
							success_callback = function()
								pushScene("uplevel" , { target = DATA_General:get( roleInfo.id ), method=method } )
							end
						})
					end
				else --吞噬药水升级
					local index = 1
					for k, v in pairs(prop) do
						if DATA_Bag:countItems("prop",nil,{cid=v}) > 0 then
							index = k
							break
						end
					end
					self:showFeed(index, roleInfo.id)
				end
			end
		})
		layer:addChild(jinhuaBtn:getLayer())

		--添加装备按钮
		local frontequipBtn = HERO_PATH.."equipmentBtn.png"
		local equipBtn = KNBtn:new(COMMONPATH,bg,351, 520, {
			front = frontequipBtn,
			priority = -301,
			callback = function()
				--以下进入我们的装备界面场景
				dataEquip["choice"]=pos
				dataEquip.heroInfos=heroInfos
				dataEquip.methodLayer=self
				switchScene("methodEquipment", 
				{ 
					data=dataEquip
				} , 
				function()  end)

			end
		})
		layer:addChild(equipBtn:getLayer())


end

function M:showFeed(kind, gid)
	local change = display.newLayer()
	local mask = KNMask:new({item=change,priority=-400})
	
	local bg = display.newSprite(COMMONPATH.."tip_bg2.png")	
	setAnchPos(bg, 240,425,0.5,0.5)
	change:addChild(bg)
	
	bg = display.newSprite(HERO_PATH.."icon_bg.png")	
	setAnchPos(bg, 240,486,0.5,0.5)
	change:addChild(bg)
	
	bg = display.newSprite(HERO_PATH.."exp_text.png")	
	setAnchPos(bg, 80,380)
	change:addChild(bg)
	
	bg = display.newSprite(HERO_PATH.."use_text.png")	
	setAnchPos(bg, 320,380)
	change:addChild(bg)
	
	bg = createLabel({str = "英雄经验丹可在活动中获得", size = 18,width = 400, color = ccc3(255,0,0)})
	setAnchPos(bg, 240, 305,0.5)
	change:addChild(bg)
	
	local expNum = createLabel({str = 100, size = 24, color = ccc3(255,255,255)})
	setAnchPos(expNum, 190, 380)
	change:addChild(expNum)
	
	local useNum = createLabel({str = 100, size = 24, color = ccc3(255,255,255)})
	setAnchPos(useNum, 375, 380)
	change:addChild(useNum)
	
	local use = 0
	
--				--划动条
	local slider = KNSlider:new( "buy" ,  {
		x = 140,
		y = 495,
		minimum = 1 , 
		maximum =  DATA_Bag:countItems("prop",nil,{cid=prop[kind or 1]}), 
		value = 1 , 
		callback  = function( _curIndex )
			use = _curIndex
			expNum:setString(use * getConfig("prop",prop[kind or 1].."","effect"))
			useNum:setString(use)
		end,
		priority = -402
	})
	change:addChild( slider )
	
	--增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} ,  368 ,  325 , {
		scale = true,
		priority = -401,
		callback = function()
			use = use + 1
			slider:setValue( use )
		end
	})
	
	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} ,  75 ,325 ,{
		scale = true,
		priority = -401,
		callback = function()
			if use > 1 then
				use = use - 1
				slider:setValue( use )
			end
		end
	})
	minusBtn:setFlip(true)
	
	change:addChild(minusBtn:getLayer())
	change:addChild(addBtn:getLayer())
	
	local group = KNRadioGroup:new()
	
	for k,v in pairs(prop) do
		local icon = KNBtn:new(SCENECOMMON,{"skill_frame1.png","select1.png"},0,0,{
			id = v,
			priority = -401,
			front = getImageByType(v,"s"),
			text = {{getConfig("prop",v,"name"),16,ccc3(255,255,255),ccp(0,-50)},{ DATA_Bag:countItems("prop",nil,{cid=v}),16,ccc3(255,255,255),ccp(26,28),nil,22}},
			other = {COMMONPATH.."egg_num_bg.png",50,50,21},
			selectZOrder = 20,
			noHide = true,
			upSelect= true,
			callback = function()
				mask:remove()
				self:showFeed(k, gid)
			end
		},group)
		setAnchPos(icon:getLayer(), 70 + (k - 1) * 140, 480)
		change:addChild(icon:getLayer())
	end
	
	group:chooseByIndex(kind or 1)
	
	local okBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},65,255,{
		front = COMMONPATH.."ok.png",
		priority = -411,
		callback = function()
			if DATA_Bag:countItems("prop",nil,{cid = prop[kind or 1]}) and DATA_Bag:countItems("prop",nil,{cid = prop[kind or 1]}) > 0 then
				HTTP:call("bag","use_general_exp",{gid = gid,id = DATA_Bag:cidByData(group:getId()).id, num = use},{
					success_callback = function(data)
						HTTP:call("zhenfa" , "initData",{},{
							success_callback = function(data)
								switchScene("method", {data=data,gid=self.params.gid}, function() 
									KNMsg.getInstance():flashShow("使用成功，英雄经验增加")
								end)
							end
						})
					end
				})
			else
				KNMsg.getInstance():flashShow("道具不足")
			end
		end
	})
	change:addChild(okBtn:getLayer())
	
	local cancelBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},270,255,{
		front = COMMONPATH.."cancel.png",
		priority = -411,
		callback = function()
			mask:remove()
		end
	})
	change:addChild(cancelBtn:getLayer())
	
	self:addChild(mask:getLayer(),10)
end

function M:upGradeLayer(params , refreshFunc)
	local tempLayer = display.newLayer()
	local mask = KNMask:new({item = tempLayer, priority = -151})

	local ZHENFAPATH = IMG_PATH.."image/scene/zhenFaWar/";

	local data = params.data or {}

	local bg = display.newSprite(COMMONPATH.."tip_bg2.png")	
	setAnchPos(bg, 240,249,0.5,0)
	tempLayer:addChild(bg)

	local offSetY = -26

	local cur_data = data.lv_up.cur or {}
	local next_data = data.lv_up.next or {}

	-- display.newSprite( ZHENFAPATH .. "frame1.png" , display.cx , 524 + offSetY , 0.5 , 0 ):addTo(tempLayer)
	display.newSprite( ZHENFAPATH .. "shengjixiaoguo.png" , 38 , 494 + offSetY , 0 , 0 ):addTo(tempLayer)
	display.newSprite( ZHENFAPATH .. "frame1.png" , 40 , 325+offSetY , 0 , 0 ):addTo(tempLayer)
	display.newSprite( ZHENFAPATH .. "frame4.png" , display.cx , 523+offSetY , 0.5 , 0 ):addTo(tempLayer)

	local zhenfashuliandu = display.newSprite( ZHENFAPATH .. "zhenfashuliandu.png" , 70 , 587+offSetY , 0 , 0 ):addTo(tempLayer)
	local xiaohaojilianfu = display.newSprite( ZHENFAPATH .. "xiaohaojilianfu.png" , 70 , 587-25+offSetY , 0 , 0 ):addTo(tempLayer)
	local yongyoujilianfu = display.newSprite( ZHENFAPATH .. "yongyoujilianfu.png" , 70 , 587- 50+offSetY, 0 , 0 ):addTo(tempLayer)

	zhenfashuliandu:addChild(createLabel({ str = cur_data.exp .. "/" .. next_data.exp ,width = 180 , x=zhenfashuliandu:getContentSize().width+2 , y = 5 , size = 20}))
	xiaohaojilianfu:addChild(createLabel({ str = data.lv_up.need_prop or "" ,width = 180 , x=xiaohaojilianfu:getContentSize().width+2 , y = 5 , size = 20}))
	yongyoujilianfu:addChild(createLabel({ str = data.lv_up.total_prop or "" ,width = 180 , x=yongyoujilianfu:getContentSize().width+2 , y = 5 , size = 20}))


	local zhenfadengji = display.newSprite( ZHENFAPATH .. "zhenfadengji.png" , 41 , 452+offSetY , 0 , 0 ):addTo(tempLayer)
	local yingxiongjiacheng = display.newSprite( ZHENFAPATH .. "yingxiongjiacheng.png" , 61 , offSetY+452-27 , 0 , 0 ):addTo(tempLayer)
	local renjiajiacheng = display.newSprite( ZHENFAPATH .. "renjiejiacheng.png" , 61 , 452-54+offSetY , 0 , 0 ):addTo(tempLayer)
	local yinghaojiacheng = display.newSprite( ZHENFAPATH .. "yinghaojiacheng.png" , 61 , 452-81+offSetY , 0 , 0 ):addTo(tempLayer)
	local guixiongjiacheng = display.newSprite( ZHENFAPATH .. "guixiongjiacheng.png" , 61 , 452-108+offSetY , 0 , 0 ):addTo(tempLayer)

	zhenfadengji:addChild( createLabel({ str = cur_data.lv .."→"..next_data.lv ,width = 180 , x=zhenfadengji:getContentSize().width-10 , y = 5 , size = 20 , color = ccc3(222,222,222)}) )
	yingxiongjiacheng:addChild( createLabel({ str = "全属性".. (cur_data.attr.all*100).."%→"..(next_data.attr.all*100).."%" ,width = 180 , x=yingxiongjiacheng:getContentSize().width+2 , y = 5 , size = 20 , color = ccc3(222,222,222)}) )
	renjiajiacheng:addChild( createLabel({ str = "攻".. (cur_data.attr.rj*100).."%→"..(next_data.attr.rj*100).."%" ,width = 180 , x=renjiajiacheng:getContentSize().width+2 , y = 5 , size = 20 , color = ccc3(222,222,222)}) )
	yinghaojiacheng:addChild( createLabel({ str = "防敏"..(cur_data.attr.yh*100).."%→"..(next_data.attr.yh*100).."%" ,width = 180 , x=yinghaojiacheng:getContentSize().width+2 , y = 5 , size = 20 , color = ccc3(222,222,222)}) )
	guixiongjiacheng:addChild( createLabel({ str = "血"..(cur_data.attr.gx*100).."%→"..(next_data.attr.gx*100).."%" ,width = 180 , x=guixiongjiacheng:getContentSize().width+2 , y = 5 , size = 20 , color = ccc3(222,222,222)}) )



	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 569 , {
				priority = -152,
				scale = true,
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(close:getLayer())

	local upBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, display.cx , 282 , {
				priority = -152,
				front = ZHENFAPATH .. "up_label.png",
				anchMid = true,
				callback = function()
					mask:remove()

					HTTP:call("zhenfa" , "upgrade",{},{
						success_callback = function(data)
							KNMsg:getInstance():flashShow(data.msg or "")
							if data.update and type(data.update) == "table" then
								for k,v in pairs(data.update) do
									params.data[k] = v
								end
							end
							self:ctor( params )
						end
					})

				end})
	tempLayer:addChild(upBtn:getLayer())


	self:addChild( mask:getLayer() )
end

return M