
local PATH=IMG_PATH.."image/scene/methodEquipment/"



local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")

local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local wearEquipCell = requires(IMG_PATH , "GameLuaScript/Scene/hero/wearEquipCell")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local Config_Property = requires(IMG_PATH , "GameLuaScript/Config/Property")


local M={

	baseLayer,
	infoLayer,
	curLayer,
	viewLayer,
	width,
	height,
	scroll,
	attr,
	nameset,
	distance,
	data,
	choice,
	curConfig,
	roleTypes,
	heroText,
	list,
	dataEquip,
	gid,
	targetId,
	id,
	heroInfos,
	methodLayer,
}


function M:new(params)

	local this={}
	setmetatable(this,self)
	self.__index=self


	this.baseLayer = display.newLayer()
	this.curLayer = display.newLayer()
	this.viewLayer = display.newLayer()

	local bg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(bg,0,425,0,0.5)
	this.baseLayer:addChild(bg)


	local bgList = display.newSprite(PATH.."equipListbg.png")
	setAnchPos(bgList,17,420,0,0.5)
	this.curLayer:addChild(bgList)



	this.baseLayer:addChild(this.curLayer,1)
	this.baseLayer:addChild(this.viewLayer)


	this.width=bgList:getContentSize().width
	this.height=bgList:getContentSize().height


	this.scroll = KNScrollView:new(0,140,480,590,8,false)

	this.scroll:alignCenter()
	this.curLayer:addChild(this.scroll:getLayer(),1)

	this.dataEquip={}
	this.targetId=nil
	this.choice=nil
	this.id=nil
	this.heroInfos={}


	--初始化data
	if params.data then

		if params.data.heroInfos then 
			this.dataEquip.heroInfos=params.data.heroInfos
			this.heroInfos=params.data.heroInfos
		end 

		if params.data.gid then

			this.dataEquip.gid=params.data.gid
			this.gid=params.data.gid

		end

		if params.data.choice then
			self.choice=params.data.choice

		end

		if params.data.data then

			this.dataEquip.data={}

			if params.data.data.fid then

				this.dataEquip.data.fid=""
				this.dataEquip.data.fid=params.data.data.fid

				if 0 ~= tonumber(params.data.data.fid) then

					this.dataEquip.data.config={}
					this.dataEquip.data.config=params.data.data.config

					self.curConfig = params.data.data.config[params.data.data.fid ..""]
				end
			end

			if params.data.data.data then

				this.dataEquip.data.data={}
				this.dataEquip.data.data=params.data.data.data

				this.data=params.data.data.data

			end
		end

	end

	this.attr={}
	this.nameset={}
	this.distance={}
	this:initAttr(this.data)
	this:initNameset()

	this.roleTypes={
		rj = {1, "人杰"},
		gx = {2, "鬼雄"},
		yh = {3, "英豪"}
	}
	if CHANNEL_GROUP == "hy" then
		this.roleTypes = {
			rj = {1, "忍术"},
			gx = {2, "体术"},
			yh = {3, "幻术"}
		}
	end

	this.heroText="英雄"
	if CHANNEL_GROUP == "hy" then
		this.heroText = "忍者"
	elseif CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
		this.heroText = "修者"
	end

	this.infoLayer = InfoLayer:new(
			"methodEquipmentLayer" ,
			0 ,
			{
				title_text = COMMONPATH.."equipTitle.png",
				tail_hide = true,
				closeCallback = function()
					HTTP:call("zhenfa" , "initData",{},{
						success_callback = function(data)
							this.heroInfos.data=data
							switchScene("method", {data=data,gid=this.gid,heroInfos=this.heroInfos},
							function()end)
						end
					})
				end
			}
		)
	this.baseLayer:addChild(this.infoLayer:getLayer())



	--依次添加列表
	for i = 1,table.getn(this.attr) do
		local item=this:itemOfEquips(this.data,i,self.choice)
		this.scroll:addChild(item)
	end



	return this

end

function M:getLayer()
	return self.baseLayer
end

function M:initAttr(params)

	local attr={}
	local shuzu={}

	local i=1
	for k,v in pairs(params) do
		if k=="heart" then

		else
			attr[i]=k
			i=i+1
		end
	end

	self.attr[1]="heart"
	for i=1,table.getn(attr) do
		local index=string.sub(attr[i],5,5)
		shuzu[i]=index
	end
	table.sort(shuzu)
	for i=1,table.getn(shuzu) do
		self.attr[i+1]="hero"..shuzu[i]
	end
	if 1==table.getn(self.attr) then
		self.distance[self.attr[1]]=0

	elseif  2==table.getn(self.attr) then
		self.distance[self.attr[1]]=0
		self.distance[self.attr[2]]=0
	elseif  3==table.getn(self.attr) then
		self.distance[self.attr[1]]=0
		self.distance[self.attr[2]]=0
		self.distance[self.attr[3]]=95
	elseif  4==table.getn(self.attr) then
		self.distance[self.attr[1]]=0
		self.distance[self.attr[2]]=0
		self.distance[self.attr[3]]=230
		self.distance[self.attr[4]]=300
	elseif  5==table.getn(self.attr) then
		self.distance[self.attr[1]]=0
		self.distance[self.attr[2]]=0
		self.distance[self.attr[3]]=230
		self.distance[self.attr[4]]=450
		self.distance[self.attr[5]]=520
	elseif  6==table.getn(self.attr) then
		self.distance[self.attr[1]]=0
		self.distance[self.attr[2]]=0
		self.distance[self.attr[3]]=230
		self.distance[self.attr[4]]=450
		self.distance[self.attr[5]]=670
		self.distance[self.attr[6]]=750
	end

end

function M:initNameset()
	if table.nums(self.attr) > 0 then
		if G_zhenfa_equip~=nil and table.nums(G_zhenfa_equip)~=0 then
			for key , v in pairs(G_zhenfa_equip) do
				for i=1,table.nums(self.attr) do
					if tostring(self.attr[i])==tostring(key) then
						for key1,v1 in pairs(v) do
							self.nameset[self.attr[i]]=v1["cid"]..""
							break
						end
					end
				end
			end
		end
	end

	self.dataEquip["nameset"] = self.nameset
end

function M:createList(indexSeat,choice)



	if self.list~=nil then
		self.list=nil
	end

	local tempTypeAry = {"weapon","defender","shoe","jewelry" }	--装备四个位置
	local isExsit = DATA_Bag:getTypeNum("equip" , tempTypeAry[indexSeat + 1 ] )
	if not isExsit then
		KNMsg.getInstance():flashShow("您还未获得 " .. equipSeat["e" .. indexSeat + 1 ] .."!" )
		return
	end

	self.list = SelectList:new("equip",self.viewLayer,display.newSprite(COMMONPATH .. "title/equip_text.png"),{ btn_opt = "equipment.png",target = true, equipType = tempTypeAry[ indexSeat + 1 ] ,
		y = 85 ,
		showTitle = true ,
		filter = tempTypeAry[indexSeat + 1],
		zhenfaHide = 2,
		optCallback = function()

			self.targetId = self.list:getCurItem():getId()

			--请求换装备
			HTTP:call("zhenfa" , "equipDress", {
				eid = self.targetId ,
				zf_pos=choice,
				pos = "e" .. indexSeat + 1} ,
				{
					success_callback = function(data)
						self.list:destroy()
						-- popScene()
						self.dataEquip["choice"]=choice
						switchScene("methodEquipment" , 
						{ 
							data=self.dataEquip
						} , 
							function()
								local equip_info = DATA_Bag:get("equip",self.targetId)
								local gfigure = tonumber(equip_info["gfigure"]) == -1 and 0 or tonumber(equip_info["gfigure"])   --不是金装装备的  gfigure 等于 -1
								KNMsg:getInstance():flashShow( equip_info["name"] .. "装备成功，" .. Config_Property[equip_info["effect"]] .. "增加" .. (tonumber(equip_info["figure"]) + gfigure) )
							end
						)
					end
				})
			end
		})

	self.baseLayer:addChild(self.list:getLayer(),2)
end




function M:itemOfEquips(params,index,choice)


	local layer=display.newLayer()
	local pos=self.attr[index]
	local roleInfo={}
	local id = params[pos]
	local front=""
	local hero_Img
	local tempEquipData={}

	if id then
		roleInfo = DATA_Bag:get("general",id)
		if roleInfo then
			hero_Img = IMG_PATH .. "image/hero/"
			if HAS_GOD_GENERAL and roleInfo.god == 1 then
				hero_Img = IMG_PATH .. "image/hero/shen/"
			end
			front =hero_Img..getImageByType(roleInfo.cid, "s", true)
		end
	end

	--英雄头像背景
	local personBg=display.newSprite(PATH.."personbg.png")
	setAnchPos(personBg,16,120)
	layer:addChild(personBg)
	--英雄人物头像背景

	local posx=self.width/2-30
	local posy=130
	local addx=0
	local addy=-20
	if  (CHANNEL_GROUP=="tgxy" or CHANNEL_GROUP=="tgxy2") then
			addx=-12
			addy=-15
	end



	local hero = KNBtn:new(
		IMG_PATH.."image/scene/common/",
		{"boxNew.png"},
		posx,posy,
		{
			other ={COMMONPATH.."star_border/border_"..getConfig("general", roleInfo.cid, "star")..".png",addx,addy},
			front = hero_Img..getImageByType(roleInfo.cid, "s", true),
			callback= function() end
		}
	)
	layer:addChild(hero:getLayer())

	--添加装备背景集合Set
	display.newSprite(PATH.."set.png" , display.cx , 0 , 0.5 , 0):addTo(layer)

	--添加英雄名称
	local heroname=""
	if 1==index then
		heroname = "核心" ..self.heroText
	else
		heroname = "辅助" ..self.roleTypes[self.curConfig[pos]][2]
	end
	layer:addChild(display.strokeLabel(heroname or "",70,160,16,ccc3(0 , 0 , 0)  ) )
	--添加装备列表
	local equipSeat ={
		e1 = "武器" ,
		e2 = "防具" ,
		e3 = "鞋子" ,
		e4 = "首饰" ,
	}

	if G_zhenfa_equip~=nil and table.nums(G_zhenfa_equip)>0 then
		tempEquipData = G_zhenfa_equip[pos] or {}
	end

	local equip_opened=checkOpened("equip")
	for key , v in pairs(equipSeat) do

		local tempData={}
		if tempEquipData[key] then
			tempData.id=tempEquipData[key].id
			local cid=DATA_Bag:get("equip" , tempData["id"] , "cid")
			tempData.cid=cid
			tempData["lv"] = DATA_Bag:get("equip" , tempData["id"] , "lv")
		else
			tempData=v
		end

		local indexSeat = (string.sub(key,2,-1)-1)
		local equipSeatCell
		local equipX = 50 + 103*indexSeat
		equipSeatCell = wearEquipCell:new(
			equipX,
			22,
			tempData,
			function()
				local myChoice=self.attr[index]
				local hero_data=getConfig("general",self.nameset[myChoice])

				local check_result = checkOpened("equip")
				if check_result ~= true then
					KNMsg:getInstance():flashShow(check_result)
					return
				end
				--tempData不是文字就是table是文字的情况下就必须进行List列表的显示
				--否则地话就显示因为上面显示头像而显示装备的详情
				if type(tempData )~= "string" then
					local DATA = DATA_Equip
					local type = "equip"
					local detail
					hero_data.choice = myChoice
					hero_data.zhenfaData = self.dataEquip
					hero_data.type = key
					hero_data.Firstshow = true
					if DATA:haveData(tempData["id"],type) then
						pushScene("detail" , {
							detail = "equip",
							id = tempData["id"],
							heroData = hero_data,
							zhenfaHide = 2,
							fromZhenfa = true,
							backCallback = function()end
						})
					else
						HTTP:call(type,"get",{id = tempData["id"]} , {
							success_callback = function()
								pushScene("detail" , {
									detail = "equip",
									id = tempData["id"],
									heroData = hero_data,
									fromZhenfa = true,
									zhenfaHide = 2,
									backCallback = function()
									end
								})
							end
						})
					end
				else
					local myChoice=self.attr[index]
					self:createList(indexSeat,myChoice)
				end
			end,
			layer,
			equip_opened
		)
		
		--如果装备有阶位，则在装备图标上面加上阶位
		local equipData = DATA_Bag:get("equip" , tempData["id"])
		if equipData and equipData.pro_lv and tonumber(equipData.pro_lv) > 0  then 
			local layer = getZhuanshuLabel( equipData.pro_lv ) 
			setAnchPos( layer , 0 , 13  ,0  ,0 )
			equipSeatCell:getLayer():addChild( layer , 100 )
		end

		layer:addChild(equipSeatCell:getLayer())
	end

	--实行显示的移位
	local offset=self.distance[choice]
	self.scroll:setOffset(offset)

	layer:setContentSize(CCSizeMake(self.width,self.height/3+5))
	return layer


end










return M
