--[[
	任务模块大关卡场景，在首页点击任务按钮,或在世界地图点击关卡时进入
]]
local WIPEOPT, WIPING, WIPEEND = 1, 2, 3
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local PATH = IMG_PATH.."image/scene/mission/"
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")--require "GameLuaScript/Common/KNBtn"
local LevelInfo = requires(IMG_PATH,"GameLuaScript/Scene/mission/levelinfo")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")--require "GameLuaScript/Scene/common/infolayer"
local SelectList = requires(IMG_PATH,"GameLuaScript/Scene/common/selectlist")
local Config = requires(IMG_PATH, "GameLuaScript/Config/User")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local MissionLayer = {
	layer,
	fightLayer,
	mapScroll,
	state,
	mask,
	content
}

local curType , Mission
local STORY_MISSION , HIDE_MISSION = "story" , "hide"
local MissionType = { STORY_MISSION , HIDE_MISSION }

function MissionLayer:new(data)
	local this={}
	setmetatable(this , self)
	self.__index = self

	this.layer = display.newLayer()
	local data = data or {}
	
	local bg = display.newSprite(SCENECOMMON.."bg.png")
	setAnchPos(bg)
	this.layer:addChild(bg , -2)

	local scrollBg = display.newSprite(COMMONPATH.."mid_bg.png")
	setAnchPos(scrollBg, 0 ,425, 0,0.5)
	this.layer:addChild(scrollBg , -2)
	
	this.state = {}

	local group = KNRadioGroup:new()

	for i = 1, #MissionType do
        local btn = KNBtn:new(PATH, {"tab_normal.png","tab_pre.png"},15 + (i-1)*145 , 675, {
        	front =  { PATH..MissionType[i] .. "_mission_grey.png" ,  PATH..MissionType[i] .. "_mission.png"},
            upSelect = true,
            disableWhenChoose = true,
            priority = -240,
            callback = function()

            	if i == 2 then 
            		KNMsg:getInstance():flashShow("隐藏关卡暂未开放")
            		return false
            	end

				curType = MissionType[i]

				if curType == HIDE_MISSION then 
					Mission = DATA_MissionHide
				else
					Mission = DATA_Mission
				end

            	--生成关卡选择
				if not Mission:get("cleanup", "clock") then
					this:createLevel(data)
				else
					if Mission:get("cleanup", "clock") > 0 then
						this:createWipe(nil, nil, WIPING)
					else
						this:createWipe(nil, nil, WIPEEND)
					end
				end
            	
            end
        }, group)
        this.layer:addChild(btn:getLayer())
    end
    group:chooseByIndex(1 , true)

    display.newSprite( COMMONPATH .. "tab_line.png" , display.cx , 674 , 0.5, 0 ):addTo(this.layer)

    

	this.layer:addChild(InfoLayer:new("mission", 0, {title_text = IMG_PATH.."image/scene/mission/title.png", 
		tail_hide = true,
		closeCallback = 
		function()

			if this.state.inAwardPage then 
				this.state.inAwardPage = nil

				if this.state.kind == "map"  then
					this:createLevel( {kind = "map"})			
				elseif this.state.kind == "mission" then
					this:createLevel( {kind = "mission" , level = this.state.curMissionId } )
				end

			else
				if this.state.kind == "map"  then
					switchScene("home")				
				elseif this.state.kind == "mission" then
					this:createLevel( {kind = "map"} )
				else
					switchScene("home")
				end
			end
		end}):getLayer())

	return this 
end


function MissionLayer:createLevelScroll(kind,level)
	-- if self.mapScroll then
	-- 	self.mapScroll:removeAll()
	-- 	self.content:removeChild(self.mapScroll:getLayer(),true)
	-- 	self.mapScroll = nil
	-- end
	local mapScroll = KNScrollView:new(0,105,480,460)

	self.state.kind = kind
	
	local max,cur  --最大显示的关卡和当前关卡
	if kind == "map" then
		--取地图的最大值
		if Mission:get("max","map_id") + 1 > table.nums(getConfig("mission")) then
			max = table.nums(getConfig("mission"))
			cur = max
		else
			max = Mission:get("max","map_id") + 1
			cur = max - 1
		end
	else
		self.state.curMissionId = level
		--取小关卡的最大值
		if level < Mission:get("max","map_id") then
			max = Mission:get(level,"mission_count")
			cur = max 
		else
			max = Mission:get("max","mission_id") + 1
			cur = max - 1
			if max > Mission:get(level,"mission_count") then
				max = Mission:get(level,"mission_count")
				cur = max 
			end
		end
	end
	
	-- max , cur = 10 , 10
	for i = max, 1, -1 do
		local index = level or i         --若level存在说明是小关卡，不存在则是大地图
		local levelState
		local icon =  LevelInfo:new(kind,i,cur,{
			level = index,
			missionType = curType == STORY_MISSION and "mission" or "missionhide",
			max = max,
			parent = mapScroll,
			callback = function()

				if kind == "map" then
					-- Mission:setByKey("current","map_id",index)
					if Mission:haveData(index) and false then
						self:createLevel( { kind = "mission" , level = i } )
					else
						HTTP:call("mission","get",{map_id = index},{success_callback=
							function(data)
								self:createLevel( { kind = "mission" , level = i } )
							end})
					end
				else
					self:createFighting(level,i)
				end
			end})
		mapScroll:addChild(icon:getLayer(),icon)
	end

	if kind == "map" then
		-- 新手引导
		local guide_step = KNGuide:getStep()
		if guide_step == 102 or guide_step == 210 or guide_step == 305 or guide_step == 10006 or guide_step == 15211 or guide_step == 15007 or guide_step == 15112 or guide_step == 15805 then
			local item_offset = 0
			if guide_step == 305 or guide_step == 10006 or guide_step == 15007 or guide_step == 15805 then
				item_offset = 1
			elseif guide_step == 15112 then
				item_offset = 2
			end
			local items = mapScroll:getItems()
			local btn = items[#items - item_offset]
			local btn_range = btn:getRange()

			KNGuide:show( btn:getLayer() , {
				x = btn_range:getMinX() + 25,
				y = btn_range:getMinY(),
				callback = function()
					if guide_step == 15805 then
						KNGuide:setStep(15014)
					end
				end
			})
		end
	else
		-- 新手引导
		local guide_step = KNGuide:getStep()
		if guide_step == 103 or guide_step == 105 or guide_step == 107 or guide_step == 211 
			or guide_step == 213 or guide_step == 215 or guide_step == 306 
			or guide_step == 15212 or guide_step == 15214 or guide_step == 15216 or guide_step == 10007 
			or guide_step == 15008 or guide_step == 15010 or guide_step == 15012 or guide_step == 15014 or guide_step == 15016 
			or guide_step == 15113
		then
			local item_offset = 0
			if guide_step == 105 or guide_step == 15008 then
				item_offset = 1
			elseif guide_step == 107 or guide_step == 15010 then
				item_offset = 2
			elseif guide_step == 211 or guide_step == 15212 or guide_step == 15012 then
				item_offset = 3
			elseif guide_step == 213 or guide_step == 15214 or guide_step == 15014 then
				item_offset = 4
			elseif guide_step == 15016 then
				item_offset = 5
			elseif guide_step == 215 or guide_step == 15216 then
				item_offset = 0
			elseif guide_step == 306 then
				item_offset = 1
			elseif guide_step == 10007 then
				item_offset = 2
			end

			local items = mapScroll:getItems()
			local btn = items[#items - item_offset]
			local btn_range = btn:getRange()

			KNGuide:show( btn:getLayer() , {
				x = btn_range:getMinX() + 25,
				y = btn_range:getMinY(),
				height = 75,
			})
		end

		if guide_step == 15115 then
			KNGuide:show( nil , {
				mask_clickable = true,
				remove = true,
				x = -100,
				y = 0,
				width = 1,
				height = 1,
			})
		end
	end
	
	mapScroll:alignCenter()
	mapScroll:effectIn()
	-- content:addChild(mapScroll:getLayer())

	return mapScroll:getLayer()

end

function MissionLayer:getLayer()
	return self.layer
end

function MissionLayer:createFighting(map,level)
	if self.mask then
		self.layer:removeChild(self.mask, true)
	end
	
	self.fightLayer = display.newLayer()
	local bg = display.newSprite(PATH.."bg.png")
	setAnchPos(bg,240,425,0.5,0.5)
	self.fightLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."des_text_bg.png")
	setAnchPos(bg,240,470,0.5,0)
	self.fightLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."title_bg.png")
	setAnchPos(bg, 280, 600, 0.5)
	self.fightLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."fight_title.png")
	setAnchPos(bg, 270, 600, 0.5)
	self.fightLayer:addChild(bg)
	
	local achieve = display.newSprite(PATH.."achieve.png")
	setAnchPos(achieve,50,440)
	self.fightLayer:addChild(achieve)
	
    achieve = display.newSprite(PATH.."gift.png")
	setAnchPos(achieve,50,370)
	self.fightLayer:addChild(achieve)
	
	achieve = display.newSprite(PATH.."use_power.png")
	setAnchPos(achieve,240,575,0.5)
	self.fightLayer:addChild(achieve)
	
    achieve = display.newSprite(COMMONPATH.."separator.png")
	setAnchPos(achieve,240,400,0.5)
	self.fightLayer:addChild(achieve)
	
	local power = display.strokeLabel(getConfig("mission",map,level,"power"), 0, 0, 16, ccc3( 0x2c , 0x00 , 0x00 ) , 2 , ccc3( 0x40 , 0x1d , 0x0c ))
	setAnchPos(power,300,580)
	self.fightLayer:addChild(power)
	
	local exp = display.strokeLabel("经验:"..getConfig("mission",map,level,"exp"), 0, 0, 16, ccc3( 0x2c , 0x00 , 0x00 ) , 2 , ccc3( 0x40 , 0x1d , 0x0c ))
	setAnchPos(exp,180,450)
	self.fightLayer:addChild(exp)
	
	local silver = display.strokeLabel("银两:"..getConfig("mission",map,level,"silver"), 0, 0, 16, ccc3( 0x2c , 0x00 , 0x00 ) , 2 , ccc3( 0x40 , 0x1d , 0x0c ))
	setAnchPos(silver,300,450)
	self.fightLayer:addChild(silver)
	

--	local fame = display.strokeLabel("功勋:"..getConfig("mission",map,level,"fame"), 0, 0, 16, ccc3( 0x2c , 0x00 , 0x00 ) , 2 , ccc3( 0x40 , 0x1d , 0x0c ))
--	setAnchPos(fame,180,420)
--	self.fightLayer:addChild(fame)
	
	local wei = display.strokeLabel("威望:"..Config[DATA_User:get("lv")..""]["exp_a"], 0, 0, 16, ccc3( 0x2c , 0x00 , 0x00 ) , 2 , ccc3( 0x40 , 0x1d , 0x0c ))
	setAnchPos(wei,180,420)
	self.fightLayer:addChild(wei)
	

	local desc = display.strokeLabel(
		getConfig("mission",map,level,"mission_desc"), 0, 0, 16, 
		ccc3( 0xff , 0xfb , 0xd4 ) , 2 , 
		ccc3( 0x40 , 0x1d , 0x0c ),{dimensions_width = bg:getContentSize().width - 20, dimensions_height = bg:getContentSize().height - 10, align = 0})
	setAnchPos(desc,245,470,0.5)
	self.fightLayer:addChild(desc)
	

	local gift = getConfig("mission",map,level,"award_show")
	local count = 0
	for k, v in pairs(gift) do
		count = count + 1
		local show = KNBtn:new(SCENECOMMON,{"skill_frame1.png"},80 + count * 110,330,{
			front = getImageByType(v),
			text = {getConfig(getCidType(v),v,"name"),14,ccc3(0x2c, 0, 0),ccp(0,-50)}			
		})
		self.fightLayer:addChild(show:getLayer())
	end
	

	local isOpenFriendSys = true

	local check_result = checkOpened("friend")
	if check_result ~= true then
		isOpenFriendSys = false
	end

	local fightBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"}, isOpenFriendSys and 30 or 80 ,240,{
		front = PATH.."fight.png",
		scale = true,
		priority = -131,
		callback = function()
			local tempData = { map_id = map, mission_id = level}
			Mission:setCurMissionData( tempData ) --临时记录当前关卡
--			print(map)
--			print(level)
--			print(DATA_Formation:get_lenght())
--			print(DATA_Formation:getMax())
--			print(DATA_Bag:countItems("general", true))
			
			local max  = 0
			for k, v in pairs(DATA_Formation:getMax()) do
				if DATA_User:get("lv") >= v then
					if max < tonumber(k) then
						max = tonumber(k)
					end
				end 
			end	
			if DATA_Formation:get_lenght() < max and table.nums(DATA_Bag:getTable("general", nil,nil,true)) > 0 then
				local checkLevel = true
				if map < 3 then
					if map == 1 or (map == 2 and level < 3) then
						checkLevel = false
					end
				end
				if checkLevel then
					KNMsg.getInstance():boxShow("当前有英雄可上阵，是否前往上阵英雄？ 点击确定进入英雄首页，点击取消进入战斗", {
						confirmFun = function()
							if DATA_General:haveGet() then
								DATA_Formation:set_index(1)
								switchScene("hero",{gid = DATA_Formation:getCur()})
							else
								HTTP:call("general" , "get",{},{success_callback =
									function()
										DATA_General:haveGet(true)
										DATA_Formation:set_index(1)
										switchScene("hero",{gid = DATA_Formation:getCur() })
									end
								})
							end
						end,
						cancelFun = function()
							if not isBagFull() then
								self.layer:removeChild(self.mask,true)
								SOCKET:getInstance("battle"):call("mission" , "execute" , "execute" , tempData)
							end
						end
					})
					return false
				end
			end
			if not isBagFull() then
				self.layer:removeChild(self.mask,true)
				SOCKET:getInstance("battle"):call("mission" , "execute" , "execute" , tempData )
			end
		end
	})
	self.fightLayer:addChild(fightBtn:getLayer())

	-- 新手引导
	local guide_step = KNGuide:getStep()
	if guide_step == 104 or guide_step == 106 or guide_step == 108 or guide_step == 212
		or guide_step == 15213 or guide_step == 15215 or guide_step == 15217 
		or guide_step == 214 or guide_step == 216 or guide_step == 307 or guide_step == 10008 
		or guide_step == 15009 or guide_step == 15011 or guide_step == 15013 or guide_step == 15015 or guide_step == 15017
		or guide_step == 15114
	then
		KNGuide:show( fightBtn:getLayer() , {remove = true})
	end

	local cancelBtn = KNBtn:new(COMMONPATH,{"back_img.png","back_img_press.png"},35,573,{
		scale = true,
		priority = -131,	
		callback = function()
			self.layer:removeChild(self.mask,true)
		end
	})
	self.fightLayer:addChild(cancelBtn:getLayer())
	
	local wipeBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"}, isOpenFriendSys and 300 or 250,240,{
		front = PATH.."wipe.png",
		scale = true,
		priority = -131,	
		callback = function()
			if isBagFull() then
			    return false
			end
			
			if DATA_Power:get("num") == 0 then
				KNMsg.getInstance():flashShow("体力不足，无法进行扫荡~！")
			else
				if Mission:get(map, "missions", level, "star") == 0 then
					KNMsg.getInstance():flashShow("该关卡未通关，不可扫荡~！")
					return false
				end
				
				if isBagFull() then
					return false
				end
				
				if Mission:get(map, "missions", level, "max") > Mission:get(map, "missions", level, "count") then
					self:createWipe(map, level, WIPEOPT)				
					
				else
					KNMsg.getInstance():flashShow("关卡已达到最大执行次数，不可扫荡~！")
				end
			end
		end
	})
	self.fightLayer:addChild(wipeBtn:getLayer())
	
	if isOpenFriendSys then 
		KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},165,240,{
			front = IMG_PATH.."image/scene/friend/helpToFight/friend_to_fight.png",
			scale = true,
			priority = -131,	
			callback = function()

				self:enterFriendToFight({map = map , level = level})

			end
		}):getLayer():addTo(self.fightLayer)
	end
	
	
	self.mask = KNMask:new({item = self.fightLayer}):getLayer()
	self.layer:addChild(self.mask)
end

function MissionLayer:enterFriendToFight( param )
	HTTP:call("battleassist" , "getFriendGeneralList",{},{
        success_callback = function(_data)
           self:friendToFight(_data , param)
    end })
end

function MissionLayer:friendToFight(data , param)
	
	local FRIENDPATH = IMG_PATH.."image/scene/friend/helpToFight/"

	if self.friendToFightLayer then 
		self.friendToFightLayer:removeSelf()
	end

	self.friendToFightLayer = display.newLayer():addTo(self.layer)
	self.layer:setPositionX(480)
	self.friendToFightLayer:setPositionX(-480)


	display.newSprite(COMMONPATH.."dark_bg.png" , 0 ,  85 , 0  , 0):addTo(self.friendToFightLayer)

	self.friendToFightLayer:addChild(InfoLayer:new("friendToFight", 0, {title_text = IMG_PATH.."image/scene/friend/helpToFight/friend_to_fight_title.png",
		priority = -220,
		closeCallback = 
		function()
			self.layer:removeChild(self.friendToFightLayer,true)
			self.friendToFightLayer = nil
			setAnchPos(self.layer)
	end}):getLayer())

	local map = param.map
	local level = param.level
	local formation_type , selected_index =  param.formation_type or "on" , param.selected_index or 1

	KNBtn:new( COMMONPATH , {"btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx , 145 , {
 		anchMid = true,
        front = PATH .. "fight.png",
        priority = -222,
        callback = function()

        		local tempData = { map_id = map, mission_id = level}
				Mission:setCurMissionData( tempData ) --临时记录当前关卡

	           local max  = 0
				for k, v in pairs(DATA_Formation:getMax()) do
					if DATA_User:get("lv") >= v then
						if max < tonumber(k) then
							max = tonumber(k)
						end
					end 
				end	
				if DATA_Formation:get_lenght() < max and table.nums(DATA_Bag:getTable("general", nil,nil,true)) > 0 then
					local checkLevel = true
					if map < 3 then
						if map == 1 or (map == 2 and level < 3) then
							checkLevel = false
						end
					end
					if checkLevel then
						KNMsg.getInstance():boxShow("当前有英雄可上阵，是否前往上阵英雄？ 点击确定进入英雄首页，点击取消进入战斗", {
							confirmFun = function()
								if DATA_General:haveGet() then
									DATA_Formation:set_index(1)
									switchScene("hero",{gid = DATA_Formation:getCur()})
								else
									HTTP:call("general" , "get",{},{success_callback =
										function()
											DATA_General:haveGet(true)
											DATA_Formation:set_index(1)
											switchScene("hero",{gid = DATA_Formation:getCur() })
										end
									})
								end
							end,
							cancelFun = function()
								if not isBagFull() then
									self.layer:removeChild(self.mask,true)
									SOCKET:getInstance("battle"):call("mission" , "execute" , "execute" , tempData)
								end
							end
						})
						return false
					end
				end
				if not isBagFull() then
					self.layer:removeChild(self.mask,true)
					SOCKET:getInstance("battle"):call("mission" , "execute" , "execute" , tempData )
				end
        end
    }):getLayer():addTo(self.friendToFightLayer)

	self.friendToFightLayer:addChild( createLabel({str = "说明：战斗结束后临时阵位英雄将回到原位" , x = 68 , y = 96,size = 16, width = 480, height = 26 ,color = ccc3(101 , 235 , 238) }) )

	local scrollLayer

	local function getItem(_data)

		local item_data = _data.item_data or {}

        local item = display.newSprite( COMMONPATH .. "item_bg.png" , 0 , 0 , 0,0 )

        if _data.index == 1 then 
        	item:addChild( display.newSprite( FRIENDPATH .. "tuijian.png" , 224,22,0,0 ) )
        end

        local size = item:getContentSize()

        KNBtn:new(COMMONPATH, { "role_frame.png"  },18 , 26 ,{
            front =  getImageByType(item_data.cid),
            other = { COMMONPATH .. "equip_lv_bg.png" , 52 , 56 } , 
  			text = { item_data.lv or "" , 16 , ccc3( 0xff , 0xff , 0xff ) , { x = 32 , y = 32} , nil , 20 },
            callback = function()
                
            end,
        } ):getLayer():addTo(item):addChild( display.newSprite( FRIENDPATH .. "captain_icon.png" , -11,-6 , 0 , 0 ) , 11 )

        item:addChild( createLabel({str = (item_data.user or "") .."("..(item_data.name or  "")..")" , x = 98 , y = 74,size = 14, width = 276, height = 26 ,color = ccc3(42 , 43 , 64)}) )
        item:addChild( createLabel({str = "战力："..(item_data.ability or "") , x = 98 , y = 51,size = 14, width = 276, height = 26 ,color = ccc3(42 , 43 , 64)}) )
        item:addChild( createLabel({str = "消耗银两："..( item_data.cost or "" ) , x = 98 , y = 28,size = 14, width = 276,color = ccc3(42 , 43 , 64)}) )

        item:addChild( createLabel({str = item_data.msg or "" , x = 13 , y = 5,size = 14, width = 276,color = ccc3(101 , 235 , 238)}) )


        if item_data.flag and tonumber(item_data.flag) == 1 then 
        	item:addChild( createLabel({str = "已选中" , x = 341 , y = 18,size = 16, width = 276, height = 26 ,color = ccc3(243 , 43 , 64)}) )
        end

        local isComplete = false

        if item_data.employd and tonumber(item_data.employd) == 1 then 
        	isComplete = true
        end

        local btn = KNBtn:new( COMMONPATH ,  isComplete and {"btn_bg_dis.png"} or {"btn_bg.png" ,"btn_bg_pre.png"}, 332 , 51 , {
            front = FRIENDPATH .. "comeback.png",
            priority = -222,
            callback = function()
                HTTP:call("battleassist" , "employ",{ fuid = item_data.uid , pos = formation_type , pos2 = selected_index-1 },{
                    success_callback = function(_data)
                    	KNMsg:getInstance():flashShow(_data.msg or "")
                    	self:friendToFight( _data , { map = map , level = level , formation_type = formation_type , selected_index = selected_index } )
                end })

            end
        })

        btn:getLayer():addTo(item)
        btn:setEnable( not isComplete )

        return item

    end

	local function createScroll()
		if scrollLayer then scrollLayer:removeSelf() end
		scrollLayer = display.newLayer():addTo(self.friendToFightLayer)

		local scroll = KNScrollView:new( 22 , 170  , 440 , 476 , 5 ,  false , nil , { priority = -133 } )    

		local list = data.list or {}

	    for i=1,#list do
	        scroll:addChild( getItem({ index = i, item_data = list[i] , parent = scroll}) )
	    end

	    scrollLayer:addChild(scroll:getLayer())

	end

	local topFrame
	local fistChoose = true

	-- dump( DATA_Formation:get_data() , "da")

	local function createFrame()
		if topFrame then topFrame:removeSelf() end

		topFrame = display.newLayer():addTo( self.friendToFightLayer )

		local frame_bg = display.newSprite( FRIENDPATH .. "frame_bg.png" ,display.cx,647,0.5,0 ):addTo(topFrame)

		--临时阵位英雄数据
		local temp_hero_data
	    if data.current and tonumber(data.current.fuid) ~= 0 and data.current.pos == formation_type then 
	    	temp_hero_data =  DATA_Formation:get(data.current.pos)[data.current.pos2+1]
	    end
		
		local function queuebtn_handle()
			selected_index = 1
            if formation_type == "on" then 
            	formation_type = "back"
            else
            	formation_type = "on"
            end
            createFrame()
		end

		local queuebtn = KNBtn:new(IMG_PATH.."image/scene/hero/", { "btn.png", "btn_pre.png" },23 , 662 ,{
				priority = -220,
	            callback = function()

	            	if temp_hero_data then 

		            	showTip({
							priority = -240,
							content = createLabel({str ="你确定要放弃更改吗？", width = 300, size = 24}),
							left={
							remove= true,
							removeCallback = function()
								HTTP:call("battleassist", "giveUp", {}, {
									success_callback = function(_data)
										data.current = _data.current
						                queuebtn_handle()
									end
								})
							end 
							},
							right={
							remove = true,
							callback = function()
								print("confirm")
							end}
						})

	            	else
		               queuebtn_handle()
		            end
	            end,
	    } )

	    queuebtn:setFront(FRIENDPATH ..formation_type.."_queue.png")
	    topFrame:addChild( queuebtn:getLayer() )

	    

	    local temp_hero = KNBtn:new(SCENECOMMON, { "skill_frame1.png"},381 , 666 ,{
	            front =  temp_hero_data and getImageByType(temp_hero_data.cid) or nil,
	            other = temp_hero_data and { COMMONPATH .. "equip_lv_bg.png" , 52-10 , 56 } or nil , 
  				text =  temp_hero_data and { DATA_Bag:get( "general" , temp_hero_data.gid , "lv" ) or "" , 16 , ccc3( 0xff , 0xff , 0xff ) , { x = 32-10 , y = 32} , nil , 20 }  or nil,
	            priority = -220,
	            callback = function()
	                
	            end,
	        })
	    topFrame:addChild( temp_hero:getLayer() )


		local scroll = KNScrollView:new( 64 , 660  , 270 , frame_bg:getContentSize().height , 10 ,  true , nil , { priority = -221 , yOffset = 10 } )    
		-- scroll:alignCenter(true)
		local group = KNRadioGroup:new()

		-- dump(data , "data")

	    for i=1,4 do

	    	local formation_data , lv
	    	if temp_hero_data and formation_type == data.current.pos and (data.current.pos2+1)==i then 
	    		formation_data = data.current
	    		lv = data.current.lv or 0
	    	else
	    		formation_data = DATA_Formation:get(formation_type)[i]
	    		lv = DATA_Bag:get( "general" , formation_data.gid , "lv" )
	    	end

	    	local layer = display.newLayer()
			layer:setContentSize( CCSizeMake(66 , 66+10) )

	    	local btn = KNBtn:new(SCENECOMMON, { "skill_frame1.png" , "select1.png" },33 , 38 ,{
	            front =  formation_data and getImageByType(formation_data.cid) or nil,
	            anchMid = true,
	            other = { COMMONPATH .. "equip_lv_bg.png" , 52-10 , 56 } , 
  				text = { lv or "" , 16 , ccc3( 0xff , 0xff , 0xff ) , { x = 32-7 , y = 32} , nil , 20 },
	            priority = -220,
	            upSelect = true,
				disableWhenChoose = true ,
	            callback = function()

	            	if temp_hero_data and formation_data and not fistChoose then 
	            		showTip({
							priority = -240,
							content = createLabel({str ="你确定要放弃更改吗？", width = 300, size = 24}),
							left={
							remove= true,
							removeCallback = function()
								HTTP:call("battleassist", "giveUp", {}, {
									success_callback = function(_data)
										-- dump(_data , "_data")

										if _data.current then data.current = _data.current end
										if _data.list then data.list = _data.list end
										group:chooseByIndex( i )
						                selected_index = i
						                createFrame()
						                createScroll()
									end
								})
							end 
							},
							right={
							remove = true,
							callback = function()
								print("confirm")
							end}
						})
						return false
	            	else
	            		if formation_data then 
		                	selected_index = i
		                else
		                	KNMsg:getInstance():flashShow("没有英雄")
		                	return false
		                end
	            	end

	            end,
	        } , group ):getLayer()

			layer:addChild(btn)

			if i==1 and formation_type == "on" then 
				display.newSprite( FRIENDPATH .. "captain_icon.png" , -8,-6 , 0 , 0 ):addTo(btn , 16)
			end

	        scroll:addChild( layer )
	    end

	    group:chooseByIndex( selected_index , true)

	    fistChoose = false

	    topFrame:addChild( scroll:getLayer() )
	end

	createFrame()
	createScroll()


end

function MissionLayer:createWipe(map, level, state)
	if self.mask then
		self.layer:removeChild(self.mask, true)
	end
	self.fightLayer = display.newLayer()
	
	local bg = display.newSprite(PATH.."wipe_bg.png")
	setAnchPos(bg,240,455,0.5,0.5)
	self.fightLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."title_bg.png")
	setAnchPos(bg, 280, 600, 0.5)
	self.fightLayer:addChild(bg)
	
--	bg = display.strokeLabel(replaceStr("1：扫荡可以快速完成已通关关卡\n2：扫荡只有VIP2以上可以使用 \n3：扫荡无法获得切BOSS奖励"), 0, 0, 20, DESCCOLOR, nil, nil, {align = 0})
	local word = "1：扫荡可以快速完成已通关关卡\n2：扫荡只有VIP1以上可以使用 \n3：扫荡无法获得切BOSS奖励"
	if CHANNEL_GROUP == "hy" then
		word = "1：扫荡可以快速完成已通关关卡\n2：扫荡无法获得切BOSS奖励"
	end
	bg = display.strokeLabel(replaceStr(word), 0, 0, 20, DESCCOLOR, nil, nil, {align = 0})
	setAnchPos(bg, 240, 370, 0.5)
	self.fightLayer:addChild(bg)
	
	if state == WIPEOPT then  --扫荡前设置
		bg = display.newSprite(PATH.."wipe_title.png")
		local legalTimes = math.min(DATA_Power:get("num"), (Mission:get(map, "missions", level, "max") - Mission:get(map, "missions", level, "count")), 10)
		local num = 1
		
		local numText = display.strokeLabel(num, 340, 523, 20, ccc3(0x2c, 0, 0))
		self.fightLayer:addChild(numText)	
		
--		local totalTime = 300
--		local totalText = display.strokeLabel(totalTime, 250, 380, 20, ccc3(0x2c, 0, 0))
--		self.fightLayer:addChild(totalText)	 
		
		local slider = KNSlider:new( "buy" ,  {
			x = 140 , 
			y = 380 , 
			minimum = 1 , 
			maximum = legalTimes,
			value = 1 , 
			callback  = 
				function( _curIndex )
					num = _curIndex
--					totalTime = num * Mission:get("cleanusetime")
					numText:setString(num)
--					totalText:setString(timeConvert(totalTime))
				end ,
			priority = -140
		} )
		self.fightLayer:addChild( slider )

		slider:setValue(legalTimes)--设置最大值
		
		--增减按钮
		local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 370 ,440 , {
			scale = true,
			priority = -130,
			callback = function()
				if num < 99 then
					num = num + 1
					slider:setValue( num )
				end
			end
		})
		
		local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 80 , 440 ,{
			scale = true,
			priority = -130,
			callback = function()
				if num > 1 then
					num = num - 1
					slider:setValue( num )
				end
			end
		})
		minusBtn:setFlip(true)
		
		addBtn:getLayer():setScale( 0.9 )
		minusBtn:getLayer():setScale( 0.9 )
		self.fightLayer:addChild(addBtn:getLayer())
		self.fightLayer:addChild(minusBtn:getLayer())
	
		local text = display.newSprite(PATH.."max_times.png")
		setAnchPos(text, 80, 520)
		self.fightLayer:addChild(text)
		
		text = display.strokeLabel(legalTimes, 200, 520, 20, ccc3(0x2c, 0, 0))
		self.fightLayer:addChild(text)
		
		text = display.newSprite(PATH.."times.png")
		setAnchPos(text, 280, 520)
		self.fightLayer:addChild(text)
		
		
		
--		text = display.newSprite(PATH.."rest_times.png")
--		setAnchPos(text, 130, 380)
--		self.fightLayer:addChild(text)
		
		local wipeBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},150, 300,{
		front = PATH.."wipe.png",
		scale = true,
		priority = -131,	
		callback = function()
--			HTTP:call("mission", "cleanup_start", {map_id = map, mission_id = level, times = num}, {
--				success_callback = function()
--					switchScene("mission",nil,function()
--						KNMsg.getInstance():flashShow("扫荡过程中可以体验其他游戏内容，过段时间来拿去奖励吧!~")
--					end)
--				end
--			})

		HTTP:call("mission", "cleanup", {map_id = map, mission_id = level, times = num}, {success_callback = 
			function(map)
--					local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
--					local response = io.readfile("c:\\battle7.txt")
--					response = json.decode( response )
--					DATA_Result:set( response.result )
				
				local function callBackFun()
					HTTP:call("mission" , "get",{map_id = map},{success_callback = function()
						switchScene("mission", {kind="mission", level=map})
					end })
				end
				local tableData = { type = "mopUp" , backFun =callBackFun }
				
				local resultLayer = requires(IMG_PATH,"GameLuaScript/Scene/battle/resultLayer")
				local scene = display.getRunningScene()
				scene:addChild( resultLayer:create( tableData ) )
			end})
		end
		})
		self.fightLayer:addChild(wipeBtn:getLayer())
		
		self.mask = KNMask:new({item = self.fightLayer}):getLayer()
	elseif state == WIPING then --扫荡中
		self.state.kind = WIPING
		bg = display.newSprite(PATH.."wiping_title.png")
		
		local back = display.newSprite(COMMONPATH.."dark_bg.png")
		setAnchPos(back, 0, 85)	
		self.layer:addChild(back)
		
		local text = display.newSprite(PATH.."rest_times.png")
		setAnchPos(text, 130, 550)
		self.fightLayer:addChild(text)
		
		local rest = Mission:get("cleanup", "clock")
		text = display.strokeLabel(timeConvert(rest),240, 552, 20, ccc3(0x2c, 0, 0))
		self.fightLayer:addChild(text)
		
		Clock:addTimeFun("wipe_clock", function()
					if rest > 0 then
						rest = rest - 1
						text:setString(timeConvert(rest))
					else
						Clock:removeTimeFun("wipe_clock")	
						
						HTTP:call("mission" , "get",{},{success_callback = function()
							switchScene("mission")
						end })
					end
				end)
				
		local propBg = display.newSprite(PATH.."prop_bg.png")
		setAnchPos(propBg, 240, 340, 0.5)
		self.fightLayer:addChild(propBg)
		
		local propInfo = {
			 {16016, 0},
			 {16017, 0}
		}
		local cur = DATA_Bag:getTable("prop", "wipetoken") or {}
		for k, v in pairs(cur) do
			for i = 1, #propInfo do
				if tonumber(v["cid"]) == propInfo[i][1] then
					propInfo[i][2] = v["num"]
					propInfo[i][3] = k
					break
				end
			end
		end	
		for i = 1, 2 do
			local prop = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 100, 440 - (i - 1) * 90, {
				front = getImageByType(propInfo[i][1], "s"),
				other = {COMMONPATH.."egg_num_bg.png", 45, 45, 17},
				text = {{getConfig("prop", propInfo[i][1], "name"), 20, ccc3(0x2c, 0, 0), ccp(100, 0), 17},{propInfo[i][2], 14, ccc3(255,255,255), ccp(25,24), nil, 20}}
			})
			self.fightLayer:addChild(prop:getLayer())
			
			local use = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 300, 450 - (i - 1) * 80, {
				front = COMMONPATH.."use.png",
				callback = function()
					if tonumber(propInfo[i][2]) > 0 then
						HTTP:call("mission", "cleanup_subtime", {id = propInfo[i][3]}, {
							success_callback = function()
								switchScene("mission",nil, function()
									KNMsg.getInstance():flashShow("扫荡令使用成功")
								end)
							end
						} )
					else
						KNMsg.getInstance():flashShow("对不起，扫荡令不足")
					end
				end
			})
			self.fightLayer:addChild(use:getLayer())
		end
		
		local stop = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 290, {
			front = PATH.."stop.png",
			callback = function()
				KNMsg.getInstance():boxShow("取消扫荡，将返回80%的体力消耗，并且无法获得奖励！",{
					confirmFun = function()
						HTTP:call("mission", "cleanup_cancel", {}, {
							success_callback = function()
								switchScene("mission")
							end
						})
					end,
					cancelFun = function()
					end
				})
			end
		})
		self.fightLayer:addChild(stop:getLayer())
		
		
		self.mask = display.newLayer()
		self.mask:addChild(self.fightLayer)
	else  --扫荡结束
		self.state.kind = WIPEEND
		bg = display.newSprite(PATH.."wipeend_title.png")
		
		local back = display.newSprite(COMMONPATH.."dark_bg.png")
		setAnchPos(back, 0, 85)	
		self.layer:addChild(back)
		
		local text = display.newSprite(PATH.."rest_times.png")
		setAnchPos(text, 130, 450)
		self.fightLayer:addChild(text)
		
		text = display.strokeLabel(timeConvert(0),240, 452, 20, ccc3(0x2c, 0, 0))
		self.fightLayer:addChild(text)
		
		local achieve = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 320, {
			front = PATH.."get_gift.png",
			callback = function()
				HTTP:call("mission", "cleanup_finish", {}, {success_callback = 
				function(map)
--					local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
--					local response = io.readfile("c:\\battle7.txt")
--					response = json.decode( response )
--					DATA_Result:set( response.result )
					
					local function callBackFun()
						HTTP:call("mission" , "get",{map_id = map},{success_callback = function()
							switchScene("mission")
						end })
					end
					local tableData = { type = "mopUp" , backFun =callBackFun }
					
					local resultLayer = requires(IMG_PATH,"GameLuaScript/Scene/battle/resultLayer")
					local scene = display.getRunningScene()
					scene:addChild( resultLayer:create( tableData ) )
				end})
			end
		})
		self.fightLayer:addChild(achieve:getLayer())
		
		self.mask = display.newLayer()
		self.mask:addChild(self.fightLayer)
	end
	
	setAnchPos(bg, 270, 600, 0.5)
	self.fightLayer:addChild(bg)
	
	if state == WIPEOPT then
		local cancelBtn = KNBtn:new(COMMONPATH,{"back_img.png","back_img_press.png"},35,573,{
			scale = true,
			priority = -131,	
			callback = function()
				self:createFighting(map, level)
			end
		})
		self.fightLayer:addChild(cancelBtn:getLayer())
	end
	
	self.layer:addChild(self.mask)
end

function MissionLayer:createLevel(data, params)
	if self.content then
		self.layer:removeChild(self.content, true)
		self.content = nil
	end
	
	self.content = display.newLayer()
		
	if not (params and params.wiping) then  --正常情况

		local offsetX , offsetY = 0 , -110

		local starCount = display.newSprite( PATH .. "starCountInStory.png" , 35,755+offsetY ,  0 , 0 ):addTo(self.content)
		starCount:addChild( createLabel({str = Mission:get( Mission:get("current").map_id,"star_num") , x= starCount:getContentSize().width + 5, y = 0 , width = 300, size = 18 , color = ccc3(255,255,255)}) )


		local remain_num = ( tonumber(Mission:get("max_cut_num")) - tonumber(Mission:get("mission_cut_num")) )
		local max_num = tonumber(Mission:get("max_cut_num"))

		starCount:addChild( createLabel({str = "切牌次数：".. remain_num .."/"..max_num , x= starCount:getContentSize().width + 80, y = 0 , width = 300, size = 18 , color = ccc3(255,255,255)}) )

		local zuoRiSaoDang = display.newSprite(SCENECOMMON.."zuoRiSaoDang.png" ,35,720+offsetY,0,0)
		self.content:addChild(zuoRiSaoDang)	

		local  rankData = Mission:get( Mission:get("current").map_id,"ranking")
		if rankData then 
			rankData['type']="mission" --排行榜类型为mission
			
			local rankName = display.strokeLabel(rankData.info.name, 190, 723+offsetY, 20,ccc3( 255 , 255 , 255 ))
			self.content:addChild(rankName)	
		end

		local findBtn = KNBtn:new(SCENECOMMON, {"find.png", "find_pre.png"}, 280,712+offsetY, {
			callback = function ()

					local rankLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/rankLayer")
					rankLayer:new(rankData)


			end})

		self.content:addChild(findBtn:getLayer())

		local powerBg = display.newSprite(PATH.."power_bg.png")
		setAnchPos(powerBg,240,680+offsetY,0.5)
		self.content:addChild(powerBg)
		
		local count = display.strokeLabel("体力:"..DATA_Power:get("num").."/"..DATA_Power:get("max"), 0, 0, 20,ccc3( 0x7e , 0xe8 , 0 ))
		setAnchPos(count,240,688+offsetY,0.5)
		self.content:addChild(count)
		
		local addPowerBtn = KNBtn:new(COMMONPATH, {"add.png", "add_press.png"}, 350,678+offsetY, {
			callback = function()
			if not DATA_Bag:getTypeNum("prop", "powerdrug") then
					KNMsg.getInstance():boxShow(replaceStr("您没有鸡血丸了，要去商城购买吗？"), {cancelFun = function()end, confirmFun = function()
						HTTP:call("shop","get",{},{success_callback=
							function()
								switchScene("shop")
							end
						})
					end})
					return false
				end
				
				local list
				list = SelectList:new("prop",self.viewLayer,display.newSprite(COMMONPATH.."title/prop_text.png"),{ 
					btn_opt = "use.png",
					scrollHeight = 500,
					showTitle = true , 
					filter = {type = "powerdrug"},
					optCallback = function()
						list:destroy()
						HTTP:call("status", "eat", {id = list:getCurItem():getId()},{success_callback=
							function()
								self:createLevel(data)	
								KNMsg.getInstance():flashShow("使用成功，体力增加")
							end})
					end
				})
				self.content:addChild(list:getLayer() , 11)
			end
		})
		self.content:addChild(addPowerBtn:getLayer())	
		

		--奖励按钮
		KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 396,633, {
			front = PATH .. "award_label.png",
			callback = function ()

				HTTP:call("hidemission", "getAwardList", {  },{success_callback = 
					function(data)
						dump(data , "data")
						self:createAwardLayer(data)
					end})

		end}):getLayer():addTo(self.content)



		local scrollLayer = self:createLevelScroll(data["kind"] or "map",data["level"])
		self.content:addChild( scrollLayer )
	else --进行扫荡中
		self:createWipe(nil, nil, WIPING)
	end
	
	self.layer:addChild(self.content ,-1)
end


function MissionLayer:createAwardLayer(data)

	self.state.inAwardPage = true

	if self.content then
		self.layer:removeChild(self.content, true)
	end
	
	self.content = display.newLayer()
	self.layer:addChild( self.content )

	local starCountInStory = display.newSprite( PATH .. "starCountInStory.png" , 35,645 ,  0 , 0 ):addTo(self.content)
	starCountInStory:addChild( createLabel({str = Mission:get( Mission:get("current").map_id,"star_num") , x= starCountInStory:getContentSize().width + 5, y = 0 , width = 300, size = 18 , color = ccc3(255,255,255)}) )

	local starCountInHide = display.newSprite( PATH .. "starCountInHide.png" , 248,645 ,  0 , 0 ):addTo(self.content)
	starCountInHide:addChild( createLabel({str = Mission:get( Mission:get("current").map_id,"hideStar_num") , x= starCountInHide:getContentSize().width + 5, y = 0 , width = 300, size = 18 , color = ccc3(255,255,255)}) )



	local function createItem( params )

		local params = params or {}

		local layer = display.newLayer()
		
		local bg = display.newSprite( COMMONPATH .."item_bg.png" , 0 ,  0, 0 , 0 ):addTo(layer)

		local contentBg = display.newSprite( IMG_PATH.."image/scene/activity_new/gangpay_bg_bar.png" , bg:getContentSize().width/2 , 79 , 0.5 , 0 ):addTo(bg)
		
		contentBg:addChild( display.strokeLabel( params.desc, 0, 0 , 18, ccc3( 253, 251, 221) , nil , nil , { dimensions_width = contentBg:getContentSize().width , dimensions_height = 25 , align = 1 } ) )

		local itemAwardData = params.award or {}
		for i = 1 , #itemAwardData do
			local curProp = awardCell( itemAwardData[i] )
			setAnchPos( curProp , (#itemAwardData == 3 and 28 or 56) + ( i - 1 ) * 100 , 8 )
			layer:addChild( curProp )
		end
		
		local btnImg = {"btn_bg.png" ,"btn_bg_pre.png"}
		local frontImg = "get.png"

		btnImg={"btn_bg.png" ,"btn_bg_pre.png"}
		frontImg = "get.png"
		
		local getBtn = KNBtn:new( COMMONPATH , btnImg,330 , 20 ,
			{
				priority = -130,
				front = COMMONPATH ..frontImg ,
				callback = function()
					if isBagFull() then
					    return false
					end
					HTTP:call("hidemission", "receiveAward", {  award_id = params.award_id },{success_callback = 
						function(data)
							-- inform(data)
							KNMsg:getInstance():flashShow( data.msg or "" )

							HTTP:call("hidemission", "getAwardList", {  },{success_callback = 
								function(_data)
									self:createAwardLayer(_data)
							end})

					end})
					
				end
			})
		layer:addChild( getBtn:getLayer() )

		layer:setContentSize( bg:getContentSize() )

		return layer
	end

	local scroll = KNScrollView:new( 20, 112 , 446, 520 , 5 , false )

	local list = data.list or {}

	for k , v in pairs(list) do
		scroll:addChild( createItem(v) )
	end

	self.content:addChild( scroll:getLayer() )

end

return MissionLayer
