--[[雇佣]]

local PATH = IMG_PATH.."image/scene/multiFb/hire/"
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local KNRadioGroup = requires(IMG_PATH, "GameLuaScript/Common/KNRadioGroup")
local ShopItem = requires(IMG_PATH,"GameLuaScript/Scene/shop/shopitem")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local SHOPPATH = IMG_PATH.."image/scene/shop/"

local HireLayer = {
	baseLayer,
	layer,
	itemsLayer,
	infoLayer,
	group,
	buyLayer,
	moneyLayer,
	scrollLayer,
	cur_index,
	isEmploy,
}

local name_config = { "普通雇佣兵" , "高级雇佣兵" , "特级雇佣兵" }

function HireLayer:new(param , isEmployText)
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	this.moneyLayer = nil
	this.baseLayer = display.newLayer()
    this.layer = display.newLayer()
    this.isEmploy = nil
		
	-- 背景
	local bg = display.newSprite(COMMONPATH .. "dark_bg_long.png")
	setAnchPos(bg , 0 , 0)						-- 70 是底部公用导航栏的高度
	this.layer:addChild(bg)

	local bagConfig = {
			{
				"normal",
				"tab_normal.png",
				"tab_normal_big.png",
			},
			{
				"highGrade",
				"tab_highGrade.png",
				"tab_highGrade_big.png",
			},
			{
				"superGrade",
				"tab_superGrade.png",
				"tab_superGrade_big.png",
			},
		}
	
	param.parent.baseLayer:setPositionX(480)
	this.baseLayer:setPositionX(-480)


	local temp
	local startX , startY = 10 , 690
	this.group = KNRadioGroup:new()
	for i = 1, #bagConfig do
		temp = KNBtn:new(COMMONPATH .."tab", { "tab_star_normal.png" , "tab_star_select.png" } , startX , startY , {
			front = { PATH  .. bagConfig[i][2] , PATH .. bagConfig[i][3]},
			upSelect = true ,
			disableWhenChoose = true,
			id = bagConfig[i][1],
			callback = function()
				this.cur_index = i
				HTTP:call("singlefb", "getEmployList", { type = i }, {
					success_callback = function(data)
						this:createScrollLayer( data )
					end
				})
			end
		} , this.group)

		this.layer:addChild(temp:getLayer())
		startX = startX + temp:getWidth() + 4
	end

	this.group:chooseByIndex(1)
	this.cur_index = 1
	this:refreshScrollLayer()

	local publish_hire_btn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 340 , 692 , {
			front = PATH .. "publish_hire_text.png" , 
			callback = function()
				print("hired_btn")
				HTTP:call("singlefb", "getPublishEmployConfig", {}, {
					success_callback = function(data)
						dump(data)
						this.layer:addChild( this:publishHireLayer(data):getLayer() )
					end
				})
				
			end
		})
	this.layer:addChild( publish_hire_btn:getLayer() )

	local already_hired_btn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 85 , 58 , {
			front = PATH .. "my_hired_people.png" , 
			callback = function()
				HTTP:call("singlefb", "getEmployInfo", {}, {
					success_callback = function(data)
						if table.nums(data) ~= 0 then 
							this.layer:addChild( this:myHireInfoLayer(data):getLayer() )
						else
							KNMsg:getInstance():flashShow("暂时没有佣兵信息")
						end
					end
				})
			end
		})
	this.layer:addChild( already_hired_btn:getLayer() )

	local change_btn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 275 , 58 , {
			front = PATH .. "change.png" , 
			callback = function()
				HTTP:call("singlefb", "getEmployList", { type = this.cur_index }, {
					success_callback = function(data)
						this:createScrollLayer(data)
					end
				})
			end
		})
	this.layer:addChild( change_btn:getLayer() )

	local line = display.newSprite(COMMONPATH .. "tab_line.png")
	setAnchPos(line , 6 , 685)
	this.layer:addChild(line)

	this.infoLayer = InfoLayer:new( "hireLayer" , 0 , { hideNavigation = true , title_text = PATH.."hire_title.png", priority = -150 ,closeCallback = function()
			param.parent.baseLayer:removeChild( this.baseLayer , true )
			param.parent.baseLayer:setPositionX(0)
			if this.isEmploy ~= nil then 
				param.other:setString(this.isEmploy)
			end
	end} )

	this.baseLayer:addChild(this.layer)
	this.baseLayer:addChild(this.infoLayer:getLayer(),1)
	return this.baseLayer
end


function HireLayer:publishHireLayer(param)

	local publishLayer = display.newLayer()
	local mask = KNMask:new({item = publishLayer, priority = -180})

	local tempImg = display.newSprite( IMG_PATH.."image/scene/headline/".."worship_award_bg.png" )
	setAnchPos( tempImg , 240 , 190 , 0.5 )
	publishLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "info_bg.png" )
	setAnchPos( tempImg , 240 , 342 , 0.5)
	publishLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH.."be_hired_count.png" )
	setAnchPos( tempImg , 41 , 507 )
	publishLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH.."status.png" )
	setAnchPos( tempImg , 269 , 507 )
	publishLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH.."money_type.png" )
	setAnchPos( tempImg , 41 , 421 )
	publishLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH.."select_money.png" )
	setAnchPos( tempImg , 41 , 380 )
	publishLayer:addChild( tempImg )

	tempImg = display.newSprite( IMG_PATH.."image/scene/mission/title_bg.png" )
	setAnchPos( tempImg , 280 , 562 , 0.5)
	publishLayer:addChild( tempImg )

	tempImg = display.newSprite( PATH .. "publish_title.png" )
	setAnchPos( tempImg , 250 , 558 , 0.5)
	publishLayer:addChild( tempImg )

	publishLayer:addChild( display.strokeLabel( param.times .. "/" .. param.max_times , 194 , 507 , 20 , ccc3(0 , 0 , 0) , 0 ) )
	publishLayer:addChild( display.strokeLabel( param.employ == 0 and "未发布" or "已发布" , 324 , 511 , 20 , ccc3(0 , 0 , 0) , 2 ) )
	publishLayer:addChild( display.strokeLabel( "您的战斗力属于"..name_config[param.type] , 41 , 460 , 20 , ccc3(0 , 0 , 0) , 2 ) )


	local costFlag , money_type , num_group , money_group , num_type
	
	money_type = 1
	num_type = 1

	if param.employ ~= 0  then 
		local employ_table = param.employ
		local cost_type_table = param.cost_type[employ_table.cost_type..""]
		for k , v in pairs(cost_type_table) do
			if employ_table.num == v then 
				money_type = param.employ.cost_type
				num_type = tonumber(k)
			end
		end
	end

	local num_text1 = display.strokeLabel( numChange(param.cost_type[money_type..""]["1"]) , 220 , 380 , 20 , ccc3(0 , 0 , 0) , 2 )
	local num_text2 = display.strokeLabel( numChange(param.cost_type[money_type..""]["2"]) , 340 , 380 , 20 , ccc3(0 , 0 , 0) , 2 )
	publishLayer:addChild(num_text1)
	publishLayer:addChild(num_text2)

	local KNComboBox = requires(IMG_PATH,"GameLuaScript/Common/KNComboBox")
	money_group = KNRadioGroup:new()
	local items = {}
	for i = 1, 2 do
		items[i] = KNBtn:new( COMMONPATH, { i == 2 and "gold.png" or "silver.png" , "star_select.png"}, 0, 0, {
			id = i,
			noHide = true,
			upSelect = true ,
			priority = -220 , 
			callback = function()
				money_type = i
				comboBox:autoShow()
				comboBox:refreshBtn( { front = COMMONPATH .. ( money_type == 2 and "gold.png" or "silver.png" ) })
				num_group:chooseByIndex( 1 , true )

				num_text1:setString( numChange(param.cost_type[money_type..""]["1"]) )
				num_text2:setString( numChange(param.cost_type[money_type..""]["2"]) )

			end
		},money_group)
	end

	comboBox = KNComboBox:new(204, 414, {
		dir = COMMONPATH,
		res = {"small_btn_bg.png", "small_btn_bg_pre.png"},
		front = COMMONPATH .. ( money_type == 2 and "gold.png" or "silver.png" ) ,
		bg = IMG_PATH .. "image/scene/gang/task/".."combo_bg.png",
		up = true,
		offset = 15,
		addX = 12,
		priority = -220 ,
		additionHeight = 15 ,
		items = items,
		money_default = money_type,
		itemsGroup = money_group
	})
	publishLayer:addChild( comboBox:getLayer() )
	

	num_group = KNRadioGroup:new()
	for i = 1, 2 do
		local btn = KNBtn:new(PATH, {"normalPoint.png" , "selectedPoint.png"},180 + (i - 1) * 120 , 380, {
			priority = -220,
			callback = function()
				num_type = i
			end
		}, num_group)
		publishLayer:addChild(btn:getLayer())
	end
	num_group:chooseByIndex(num_type, true)

	local publish_hire_btn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 85 , 220 , {
			front = PATH .. "publish_hire_text.png" , 
			priority = -220,
			callback = function()
				HTTP:call("singlefb", "publishEmploy", { cost_type = money_type , num = param.cost_type[money_type..""][num_type..""] }, {
					success_callback = function(data)
						KNMsg:getInstance():flashShow("发布成功！")
						-- self:createScrollLayer( data )
						mask:remove()
					end
				})
			end
		})
	publishLayer:addChild( publish_hire_btn:getLayer() )

	local isComplete = false
	if param.employ == 0 then 
		isComplete = true
	end

	local cancel_publish_btn = KNBtn:new( COMMONPATH ,isComplete and { "btn_bg_red2.png" } or { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 275 , 220 , {
			front = PATH .. (isComplete and "cancel_publish_dis_text.png" or "cancel_publish_text.png") , 
			priority = -220,
			disable = isComplete ,
			callback = function()
				HTTP:call("singlefb", "cancelPulishEmploy", { }, {
					success_callback = function(data)
						KNMsg:getInstance():flashShow("取消发布成功！")
						mask:remove()
						-- self:createScrollLayer( data )
					end
				})
			end
		})
	publishLayer:addChild( cancel_publish_btn:getLayer() )


	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 25 , 537 , {
			priority = -220,
			scale = true,
			callback = function()
				mask:remove()
			end})
	publishLayer:addChild(close:getLayer())

	setAnchPos( publishLayer , 0 , display.height , 0 , 0 )
	transition.moveTo( publishLayer , { time = 0.5 , y = 0 , easing = "BACKOUT"})

	return mask

end

function HireLayer:refreshScrollLayer()
	HTTP:call("singlefb", "getEmployList", { type = self.cur_index }, {
		success_callback = function(data)
			self:createScrollLayer( data )
		end
	})
end

function HireLayer:createScrollLayer(param)
	if self.scrollLayer then 
		self.layer:removeChild( self.scrollLayer , true )
	end

	self.scrollLayer = display.newLayer()

	local scroll = KNScrollView:new( 20 , 125 , 448 , 550 , 5 , false , 0 , { priority = -161} )

	local listData = param.list
	-- local indexData = getSortList(param.list)
	for i = 1 , #listData do
		-- scroll:addChild( self:createItem( listData[ getSortList(listData)[i] ] , param.employ , scroll ) )
		scroll:addChild( self:createItem( listData[i] , param.employ , scroll ) )
	end

	if #listData == 0 then 
		local text = display.newSprite(COMMONPATH.."empty.png")
		setAnchPos(text,240, 425, 0.5,0.5)
		self.scrollLayer:addChild(text)
	end

	self.scrollLayer:addChild( scroll:getLayer() )
	self.scrollLayer:addChild( display.strokeLabel( "说明："..name_config[self.cur_index].."战力"..param.config["min_power"]..(param.config["max_power"]==0 and "或以上" or ("~"..param.config["max_power"])) , 110 , 25 , 20 , ccc3(95 , 183 , 205) , 2 ) )

	self.layer:addChild( self.scrollLayer )

end

function HireLayer:createItem(param , isHire , parent )
	-- dump(param)
	local itemLayer = display.newLayer()
	local item_bg = display.newSprite( COMMONPATH .. "item_bg.png" )
	setAnchPos( item_bg , 0 , 0 )
	itemLayer:addChild( item_bg )

	local icon = KNBtn:new(PATH, { "hire_head.png" },20,23,{
			priority = -150 ,
			other = {COMMONPATH.."role_frame.png", -1, -3},
			parent = parent,
			disable = true,
			callback = function()
				
			end 
		} )
	itemLayer:addChild(icon:getLayer())

	local hire_btn = KNBtn:new(COMMONPATH, { "btn_bg.png" , "btn_bg_pre.png" },343,25,{
			priority = -150 ,
			front = PATH.."hire_text.png",
			parent = parent,
			callback = function()
				if isHire == 1 then 
					self.layer:addChild( self:changeHireTipsLayer({employ_uid = param.uid , cost_type = param.cost_type , num = param.num}):getLayer() )
				else
					self.layer:addChild( self:hireTipsLayer({employ_uid = param.uid , cost_type = param.cost_type , num = param.num}):getLayer() )
				end
			end 
		} )
	itemLayer:addChild(hire_btn:getLayer())

	local ability = ""

	for i = 1 , string.len(param.ability) do 
		ability = ability .. "*"
	end

	itemLayer:addChild( display.strokeLabel( name_config[param.type] or "", 95 , 70 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	itemLayer:addChild( display.strokeLabel( "战斗力：" .. param.ability , 95 , 45 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	itemLayer:addChild( display.strokeLabel( "佣金：" .. param.num .. (param.cost_type == 1 and "银两" or "黄金"), 95 , 20 , 20 , ccc3(69 , 28 , 6) , 2 ) )

	itemLayer:setContentSize( item_bg:getContentSize() )
	return itemLayer
end

function HireLayer:hireTipsLayer(post_data)
	local tempLayer = display.newLayer()
	local mask = KNMask:new( { item = tempLayer , priority = -220 } )

	local bg = display.newSprite( PATH .. "hire_bg.png" )
	setAnchPos( bg , 240 , 258 , 0.5 )
	tempLayer:addChild( bg )

	bg = display.newSprite( IMG_PATH.."image/scene/mission/title_bg.png" )
	setAnchPos( bg , 280 , 582 , 0.5)
	tempLayer:addChild( bg )

	bg = display.newSprite( PATH .. "hire_title1.png" )
	setAnchPos( bg , 250 , 578 , 0.5)
	tempLayer:addChild( bg )

	bg = display.newSprite( PATH .. "info_bg.png" )
	setAnchPos( bg , 240 , 373 , 0.5)
	tempLayer:addChild( bg )


	tempLayer:addChild( display.strokeLabel( "是否确定雇佣此玩家与您一起挑战副本？" , 70 , 453 , 20 , ccc3(69 , 28 , 6) , 2 ) )

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 550 , {
				priority = -221,
				scale = true,
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(close:getLayer())

	local confirmBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 80 , 292 , {
				priority = -221,
				front = COMMONPATH .. "confirm.png",
				callback = function()
					HTTP:call("singlefb", "employ", post_data, {
						success_callback = function(data)
							self.isEmploy = "有"
							KNMsg:getInstance():flashShow("雇佣成功,消耗"..post_data.num..(post_data.cost_type == 1 and "银两" or "黄金"))
						end
						})
					mask:remove()
					self:refreshScrollLayer()
				end})
	tempLayer:addChild(confirmBtn:getLayer())

	local cancelBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 270 , 292 , {
				priority = -221,
				front = COMMONPATH .. "cancel.png",
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(cancelBtn:getLayer())

	setAnchPos( tempLayer , 0 , display.height , 0 , 0 )
	transition.moveTo( tempLayer , { time = 0.5 , y = 0 , easing = "BACKOUT"})

	return mask
end

function HireLayer:changeHireTipsLayer(post_data)
	local tempLayer = display.newLayer()
	local mask = KNMask:new( { item = tempLayer , priority = -220 } )

	local bg = display.newSprite( PATH .. "hire_bg.png" )
	setAnchPos( bg , 240 , 258 , 0.5 )
	tempLayer:addChild( bg )

	bg = display.newSprite( IMG_PATH.."image/scene/mission/title_bg.png" )
	setAnchPos( bg , 280 , 582 , 0.5)
	tempLayer:addChild( bg )

	bg = display.newSprite( PATH .. "change_title.png" )
	setAnchPos( bg , 250 , 578 , 0.5)
	tempLayer:addChild( bg )

	bg = display.newSprite( PATH .. "info_bg.png" )
	setAnchPos( bg , 240 , 373 , 0.5)
	tempLayer:addChild( bg )


	tempLayer:addChild( display.strokeLabel( "是否雇佣此玩家替换您当前雇佣的玩家？" , 70 , 453 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	tempLayer:addChild( display.strokeLabel( "(之前雇佣所消耗的雇佣金将不会退还)" , 70 , 416 , 20 , ccc3(120 , 7 , 0) , 2 ) )

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 550 , {
				priority = -221,
				scale = true,
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(close:getLayer())

	local confirmBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 80 , 292 , {
				priority = -221,
				front = COMMONPATH .. "confirm.png",
				callback = function()
					HTTP:call("singlefb", "employ", post_data, {
						success_callback = function(data)
							KNMsg:getInstance():flashShow("替换成功,消耗"..post_data.num..(post_data.cost_type == 1 and "银两" or "黄金"))
							self.isEmploy = "有"
						end
						})
					mask:remove()
					self:refreshScrollLayer()
				end})
	tempLayer:addChild(confirmBtn:getLayer())

	local cancelBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 270 , 292 , {
				priority = -221,
				front = COMMONPATH .. "cancel.png",
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(cancelBtn:getLayer())

	setAnchPos( tempLayer , 0 , display.height , 0 , 0 )
	transition.moveTo( tempLayer , { time = 0.5 , y = 0 , easing = "BACKOUT"})

	return mask
end



function HireLayer:myHireInfoLayer(param)
	local myHireLayer = display.newLayer()
	local mask = KNMask:new( { item = myHireLayer , priority = -220 } )

	local bg = display.newSprite( PATH .. "hire_bg.png" )
	setAnchPos( bg , 240 , 258 , 0.5 )
	myHireLayer:addChild( bg )

	bg = display.newSprite( IMG_PATH.."image/scene/mission/title_bg.png" )
	setAnchPos( bg , 280 , 582 , 0.5)
	myHireLayer:addChild( bg )

	bg = display.newSprite( PATH .. "myHire_title.png" )
	setAnchPos( bg , 250 , 578 , 0.5)
	myHireLayer:addChild( bg )

	bg = display.newSprite( PATH .. "info_bg.png" )
	setAnchPos( bg , 240 , 373 , 0.5)
	myHireLayer:addChild( bg )

	bg = display.newSprite( PATH .. "player_type.png" )
	setAnchPos( bg , 125 , 480 )
	myHireLayer:addChild( bg )

	bg = display.newSprite( PATH .. "player_ability.png" )
	setAnchPos( bg , 125 , 440 )
	myHireLayer:addChild( bg )

	bg = display.newSprite( PATH .. "hire_money.png" )
	setAnchPos( bg , 150 , 400 )
	myHireLayer:addChild( bg )

	myHireLayer:addChild( display.strokeLabel( name_config[param.type] or "", 250 , 483 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	myHireLayer:addChild( display.strokeLabel( param.ability or param.ablity, 250 , 443 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	myHireLayer:addChild( display.strokeLabel( param.num or "", 250 , 403 , 20 , ccc3(69 , 28 , 6) , 2 ) )

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 550 , {
				priority = -221,
				scale = true,
				callback = function()
					mask:remove()
				end})
	myHireLayer:addChild(close:getLayer())

	local confirmBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png","btn_bg_red_pre.png" }, 170 , 292 , {
				priority = -221,
				front = COMMONPATH .. "confirm.png",
				callback = function()
					mask:remove()
				end})
	myHireLayer:addChild(confirmBtn:getLayer())

	setAnchPos( myHireLayer , 0 , display.height , 0 , 0 )
	transition.moveTo( myHireLayer , { time = 0.5 , y = 0 , easing = "BACKOUT"})
	return mask
end

return HireLayer
