--多人副本主界面

local M = {
	baseLayer,
	title,
	layer,
	warObj,
	talk,
	talkLayer,
	refresh,
	receive
}

local PATH = IMG_PATH .. "image/scene/multiwar/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local War = requires(IMG_PATH, "GameLuaScript/Scene/multiwar/warlayer")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")

local priority = -151

function M:new(args)
dump(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	this.params = args or {}
	this.params.msg = {}
	this.baseLayer = display.newLayer()
	
	local bg = display.newSprite(COMMONPATH.."dark_bg_long.png")
	setAnchPos(bg, 240, 0, 0.5)
	this.baseLayer:addChild(bg)
	
	this.talk = KNBtn:new( IMG_PATH .. "image/scene/chat/"  , {"talk_flag1.png"} , 410 , 300 , {
		scale = true ,
		priority = -190,
		front =  IMG_PATH .. "image/scene/chat/talk_flag.png" , 
		callback = function()
			DATA_Info:setIsMsg( false )
			if DATA_Info:getIsOpen( ) then
				local talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/talk")
				this.talkLayer = talkLayer:new( { type = "custom" , priority = -190 , custom = { customTable = { "custom" , "world", "friend" } , sendParams = { scene = "fuben" , scene_id = this.params.fbDid } } } )
--				curTalk = talkLayer:new( {type = "gang", priority = -151 } )
				local curScene = display.getRunningScene()
				curScene:addChild( this.talkLayer:getLayer()  )
			else
				this.talkLayer:remove()
			end
			DATA_Info:setIsOpen(  not DATA_Info:getIsOpen( ) )
		end
	})
	
	this.talk:getLayer():setScale(0.7)
	this.baseLayer:addChild(this.talk:getLayer())
	--注册接收消息
	DATA_Info:setCustomKey( "fuben_"..this.params.fbDid )
	DATA_Info:addActionBtn( "custom" , this.talk )
	
	if this.params.fight then
		this:createFight(this.params.fight)
	else
		this:createMain(this.params)
	end
	return this
end

function M:getLayer()
	return self.baseLayer
end

--创建探索地点对象
function M:createCard(id, x, y, data)
	local layer = display.newLayer()
	local open = data[id..""]
	
	local temp 
	local front
	temp = KNBtn:new(PATH, {open and "front.png" or "back.png"}, 0, 0, {
		anchMid = true,
		priority = priority,
		id = id,
		callback = function()
			if tonumber(self.params.leader) ~= tonumber(DATA_User:get("uid")) then
				KNMsg.getInstance():flashShow("只有队长才能操作")
				return 
			end
			
			if open then
				--翻转动画
--				temp:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.2, 0, 1), CCCallFunc:create(function()
--					front = not front
--					temp:setBg(1,front and PATH.."front.png" or PATH.."back.png")
--					temp:getLayer():runAction(CCScaleTo:create(0.2,1,1))
--				end)))
				if tonumber(self.params.pos) == id then
					if self.params.event > 2 then
						HTTP:call("fuben", "startCL", {}, {
							success_callback = function()
							end
						})
					else
						HTTP:call("fuben", "search", {}, {
							success_callback = function()
							end
						})
					end
				else
					HTTP:call("fuben", "move", {tar = id}, {
						no_loading = true,
						success_callback = function()
						end
					})
				end
			else
				KNMsg.getInstance():flashShow("此点还未开启")
			end
		end
	})
	layer:setContentSize(temp:getLayer():getContentSize())
	layer:addChild(temp:getLayer())
	setAnchPos(layer, x, y)
	
	if open then
		for i = 1, 3 do
			local event = display.newSprite(COMMONPATH..(i <= (3 - data[id..""]) and "tianfu_1.png" or "tianfu_2.png"))
			event:setScale(0.6)
			setAnchPos(event, -33 + (i - 1) * 24, -25)
			layer:addChild(event, 3)
		end
	end
	
	return layer
end

function M:createMain(params)
	self.refresh = 0
	
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	if self.talk then
		self.talk:getLayer():setPositionY(400)
	end
	
	self:hideKeyBoard()
	local giftBg = display.newSprite(PATH.."gift_bg.png")
	setAnchPos(giftBg, 240, 620, 0.5)
	self.layer:addChild(giftBg)
	
	local giftText = display.newSprite(PATH.."gift_tip.png")	
	setAnchPos(giftText, 20, 720)
	self.layer:addChild(giftText)
	
	local award = string.split(getConfig("multi", "skill", "showAwards"), ",")
	for k, v in pairs(award) do
			local icon = awardCell({cid = v}, {name = true, nameColor = ccc3(255, 255, 255), priority = -151, noClick = true})
		setAnchPos(icon, 30 + (k - 1) * 120, 650)
		self.layer:addChild(icon)
	end	
	
	local timeText = display.newSprite(PATH.."rest_time.png")	
	setAnchPos(timeText, 20, 590)
	self.layer:addChild(timeText)
	
	local timeCount = createLabel({str = timeConvert(params.spanRemain), color = ccc3(255, 255, 255), x = 120, y = 593, size = 20})
	self.layer:addChild(timeCount)
	Clock:addTimeFun("multiTime", function()
		if params.spanRemain > 0 then
			params.spanRemain = params.spanRemain - 1
			timeCount:setString(timeConvert(params.spanRemain))
		end
	end)
	
	local numsText = display.newSprite(PATH.."nums.png")	
	setAnchPos(numsText, 250, 590)
	self.layer:addChild(numsText)
	
	self.layer:addChild(createLabel({str = params.remainSearch.."/"..params.maxSearch, x = 350, y = 590, size = 20, color = ccc3(255, 255, 255)}))
	
	local addNumsBtn = KNBtn:new(COMMONPATH, {"add.png", "add_press.png"}, 420, 580,{
		priority = priority,
		callback = function()
			if self.params.remainSearch >= self.params.maxSearch then
				KNMsg.getInstance():flashShow("探索次数已达上限，不可购买")
				return
			end
			
			local num = 1 --购买的次数
			--金币计算
			local function payCount(times)
				local cur = self.params.teamUser[DATA_User:get("uid")].buySearch
				local base = 4 * (cur + 1) 
				
				if base > 20 then
					base = 20 
				end
				
				for i = 1, (times - 1) do
					base = base + (4 * (cur + i + 1) > 20 and 20 or (4 * ( cur + i + 1)))
				end
				return base
			end
			local layer = display.newLayer()
			
			local mask = KNMask:new({item = layer, priority = -170})
			
			local bg = display.newSprite(IMG_PATH.."image/scene/mission/des_bg.png")
			setAnchPos(bg, 240, 425, 0.5, 0.5)
			layer:addChild(bg)
			
			local timesText = display.newSprite(PATH.."add_time_text.png")
			setAnchPos(timesText, 40, 480)
			layer:addChild(timesText)
			
			timesText = display.newSprite(PATH.."times.png")
			setAnchPos(timesText, 80, 380)
			layer:addChild(timesText)
			
			local timesLabel = createLabel({str = num, size = 24, color = ccc3(255,255,255) })
			setAnchPos(timesLabel, 160, 380)
			layer:addChild(timesLabel)
			
			 timesText = display.newSprite(PATH.."pay.png")
			setAnchPos(timesText, 260, 380)
			layer:addChild(timesText)
			
     		 timesText = display.newSprite(COMMONPATH.."gold.png")
			setAnchPos(timesText, 340, 380)
			layer:addChild(timesText)
	
			local payLabel = createLabel({str = payCount(num), size = 24, color = ccc3(255,255,255)})
			setAnchPos(payLabel, 380, 380)
			layer:addChild(payLabel)
			
--				--划动条
			local slider = KNSlider:new( "buy" ,  {
				x = 140,
				y = 400,
				minimum = 1 , 
				maximum = self.params.maxSearch - self.params.remainSearch, 
				value = 1 , 
				callback  = function( _curIndex )
					num = _curIndex
					timesLabel:setString(num)
					payLabel:setString(payCount(num))
				end,
				priority = -172
			})
			layer:addChild( slider )
			
			local okBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png", "btn_bg_red_pre.png"} ,  75 , 330 ,{
				scale = true,
				priority = -171,
				front = COMMONPATH.."ok.png",
				callback = function()
					HTTP:call("fuben", "buySearch", {count = num}, {
						success_callback = function(data)
							self.params.teamUser[DATA_User:get("uid")].buySearch = data.buySearch
						end
					})
				end
			})
			layer:addChild(okBtn:getLayer())
			
			local cancelBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png", "btn_bg_red_pre.png"} ,  245 , 330 ,{
				front = COMMONPATH.."cancel.png",
				priority = -171,
				callback = function()
					mask:remove()
				end
			})
			layer:addChild(cancelBtn:getLayer())
			
			--增减按钮
			local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} ,  368 ,  420 , {
				scale = true,
				priority = -171,
				callback = function()
					if num < self.params.maxSearch - self.params.remainSearch then
						num = num + 1
						slider:setValue( num )
					end
				end
			})
			
			local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} ,  75 ,420 ,{
				scale = true,
				priority = -171,
				callback = function()
					if num > 1 then
						num = num - 1
						slider:setValue( num )
					end
				end
			})
			minusBtn:setFlip(true)
			
			layer:addChild(minusBtn:getLayer())
			layer:addChild(addBtn:getLayer())
			
			self.layer:addChild(mask:getLayer())
		end
	})
	self.layer:addChild(addNumsBtn:getLayer())
	
	local layer
	--创建控索地图
	local function createMap(row, col, cur)
		if layer then
			self.layer:removeChild(layer, true)
		end
		
		layer = display.newLayer()
		local card = display.newSprite(PATH.."back.png")
		
		layer:setContentSize(CCSizeMake(card:getContentSize().width * col, card:getContentSize().height * row))
		layer:ignoreAnchorPointForPosition(false)
		setAnchPos(layer, 280, 420, 0.5, 0.5)
		
		local x = 0
		local y = card:getContentSize().height * (row - 1)
		
		for i = 1, row * col do 
			layer:addChild(self:createCard(i, x, y, params.map))	
			
			--当前所在位置
			if i == cur then
				local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
				local tip = display.playFrames(x, y,frames, 0.2, {
					forever = true,
				})
				layer:addChild(tip, 2)	
			end
			
			--下一个点的坐标
			x = x + card:getContentSize().width
			if i % col == 0 then
				x = 0
				y = y - card:getContentSize().height
			end
		end
		
		return layer
	end
	self.layer:addChild(createMap(params.row, params.column, params.pos))
	
	local msgBg = display.newSprite(PATH.."event_bg.png")
	setAnchPos(msgBg, 240,80 , 0.5)
	self.layer:addChild(msgBg)
	
	local height = 0
	for i = 1, #self.params.msg do
		local msg =  createLabel({str = self.params.msg[i], color = ccc3(0xff, 0xfb, 0xd4), size = 18, x = 20, y = 155 - (i - 1) * 20, width = 470, align = 1})
		setAnchPos(msg, 240,  178 - (i - 1) * height, 0.5, 1)
		self.layer:addChild(msg)
		
		height = msg:getContentSize().height
	end
	
	local exitBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 280, 30, {
		front = PATH.."exit.png",
		priority = priority,
		callback = function()
			self:optTip("exit")
		end
	})
	self.layer:addChild(exitBtn:getLayer())
	
--	print("@@@@@@@@@@@@@event,",self.params.event)
	local optBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 50, 30, {
		priority = priority,
		front = self.params.event > 2 and PATH.."retry.png" or PATH.."start.png",
		callback = function()
			if tonumber(self.params.leader) == tonumber(DATA_User:get("uid")) then
				if self.params.event > 2 then
					HTTP:call("fuben", "startCL", {}, {
						success_callback = function()
						end
					})
				else
					HTTP:call("fuben", "search", {}, {
						success_callback = function()
						end
					})
				end
			else
				KNMsg.getInstance():flashShow("只有队长才能操作 ")
			end
		end
	})
	self.layer:addChild(optBtn:getLayer())
	
		
	-- 显示公用层 底部公用导航以及顶部公用消息
	self.title = InfoLayer:new( "multiwar" , 0 , { title_text = PATH.."title.png", tail_hide = true, hideNavigation = true, priority = -150,closeCallback = function()
		self:optTip("exit")
--		switchScene("fb", {coming = "multi"})
	end} )
	self.layer:addChild(self.title:getLayer() )	
	
	
	self.baseLayer:addChild(self.layer)
	
	--加一个计时器，一段时间未收到消息则重新获取数据
	Clock:addTimeFun("multiWarRefresh", function()
		if self.refresh >10 then
			self.receive = false
			HTTP:call("fuben", "getInfo", { }, {
				no_loading = true,
	 			success_callback = function(data)
		 			if not self.receive then
			 			 self:createMain(data)	
		 			 end
	 			end
	 		})
		 	self.refresh = 0
		else
			self.refresh = self.refresh + 1
		end
	end)
end

function M:optTip(kind)
	if kind == "exit" then
		showTip({
			priority = -160,
			content = createLabel({str = "确定要退出房间吗？", size = 24, width = 300}),
			left = {
				path = COMMONPATH, 
				normal = "btn_bg_red.png",
				pre = "btn_bg_red_pre.png",
				front = COMMONPATH.."ok.png",
				callback = function()
					HTTP:call("fuben", "leave", {}, {
						success_callback = function()
							switchScene("fb", {coming = "multi"})
						end})
				end
			},
			right = {
				path = COMMONPATH,
				front = COMMONPATH.."cancel.png",
				normal = "btn_bg_red.png",
				pre = "btn_bg_red_pre.png",
				remove = true,
			}
		})
	end
end

function M:startWarClock()
	--加一个计时器，一段时间未收到消息则重新获取数据
	Clock:addTimeFun("multiWarRefresh", function()
		if self.refresh > 34 then
			self.receive = false
	 		HTTP:call("fuben", "getCLInfo", {}, {
		 		no_loading = true,
				success_callback = function(data)
					if not self.receive then
				 		self:createFight(data)
			 		end
				end
			})
			self.refresh = 0 
		else
			self.refresh = self.refresh + 1
		end
	end)
end

function M:warLogic(kind, data)
	if self.warObj then
		self.refresh = 0
		self.receive = true
		self.warObj:logic(kind, data)
		self:startWarClock()
	else
		print("no war obj found, maybe error")
	end
end

function M:createFight(data)
	local function newWar(info)
		self.refresh = 0
		if self.layer then
			self.baseLayer:removeChild(self.layer, true)
		end
		self.warObj = War:new(info.event == 3 and "normal" or "boss", info)
		self.layer = self.warObj:getLayer()
		self.baseLayer:addChild(self.layer)
		self.talk:getLayer():setPositionY(700)
		self:hideKeyBoard()
	end
	
	if data then
		newWar(data)
	else
		HTTP:call("fuben", "getCLInfo", {}, {
		success_callback = function(data)
			dump(data)
			newWar(data)
		end
		})
	end
	
end


function M:buy( type , id , index )
	self.buyLayer = display.newLayer()
	local baseX = display.cx
	local baseY = display.cy - 28
	
	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos( bg , baseX - 193 , baseY , 0 , 0 )
	self.buyLayer:addChild(bg)
	
	--物品Icon
	local icon = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , baseX - 148 , baseY + 135 , {  front = getImageByType(DATA_Shop:get(index , "cid") , "s") } )
	self.buyLayer:addChild( icon:getLayer() )	
	
	-- 名字
	self.name = display.strokeLabel( DATA_Shop:get(index,"name") , baseX - 75 , baseY + 170 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 130 , dimensions_height = 30 ,align = 0 } )
	self.buyLayer:addChild( self.name )
	
	--花费总数
	local valueBg = display.newSprite(PATH.."value_bg.png")
	valueBg:setScaleY(0.89)
	setAnchPos(valueBg , baseX - 17 , baseY + 130 , 0.5)
	self.buyLayer:addChild(valueBg)
	
	local gold = display.newSprite(COMMONPATH .. "gold.png")
	setAnchPos(gold , baseX - 75  , baseY + 140 )
	self.buyLayer:addChild(gold)
	
	local priceText = display.strokeLabel( DATA_Shop:get(index,"real_price") , baseX - 40 , baseY + 135 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , nil , nil ,{ dimensions_width = 80 , dimensions_height = 30 ,align = 0} )
	self.buyLayer:addChild(priceText)
	
	
	--购买数量
	local numText = display.newSprite(PATH.."num_text.png")
	setAnchPos(numText,baseX + 55  , baseY + 140 , 0 )
	self.buyLayer:addChild(numText)
	
	--购买数量
	local numBg = display.newSprite(PATH.."num_bg.png")
	local num = 1 
	setAnchPos(numBg,baseX + 116 , baseY + 136 , 0 )
	self.buyLayer:addChild(numBg)
	
	--数量文本
	local numText = display.strokeLabel( 1 .. "" , baseX + 116 , baseY + 136 , 20 , ccc3(0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 36 , dimensions_height = 30 ,align = 1 } )
	self.buyLayer:addChild(numText)
	
	
	addBtn:getLayer():setScale( 0.9 )
	minusBtn:getLayer():setScale( 0.9 )
	self.buyLayer:addChild(addBtn:getLayer())
	self.buyLayer:addChild(minusBtn:getLayer())
	
	local mask = KNMask:new( {item = self.buyLayer } ):getLayer()
	--确定，取消按钮
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, baseX - 134 , baseY + 28 ,{
		front = COMMONPATH.."ok.png" ,
		scale = true,
		priority = -130,
		callback = function()
			if not countGold(priceText:getLabel():getString()) then
				return
			else
				HTTP:call("shop" , "buy" , {
					id = id,
					num = num
				} , {
					success_callback = function()
						KNMsg.getInstance():flashShow("购买成功")
						
						self.baseLayer:removeChild(mask,true)
						
						self:refreshMoney()
					end
				})
			end

		end
	})
	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , baseX + 54 , baseY + 28 ,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			self.baseLayer:removeChild(mask,true)
		end})
	self.buyLayer:addChild(ok:getLayer())
	self.buyLayer:addChild(cancel:getLayer())
	
	self.baseLayer:addChild(mask)
end

function M:refreshData(data, kind)
	self.receive = true
	if kind == "search" then
		if data.event == 1 then -- 开格子
			self.params.map[data.data.pos..""] = data.data.finish
		elseif data.event == 2 then -- 奖励
		elseif data.event == 3 then -- 有怪物
		elseif data.event == 4 then -- boss
		end
		
	elseif kind == "move" then
	elseif kind == "offline" then
		self.params.leader = data.newLeader
	elseif kind == "leave" then
		if isset(data, "leader") then 
			self.params.leader = data.leader 
			if tonumber(DATA_User:get("uid")) == tonumber(data.leader) then
				showTip({
					priority = -171,
					content = createLabel({str = "您成为了房主，请带领队员继续探险", width = 300, size = 20}),
					center = {
						remove = true,
					} 
				})
			else
				KNMsg.getInstance():flashShow("房主"..data.name.."退出副本，房主已变更为"..data.leaderName)
			end
		else
			KNMsg.getInstance():flashShow(data.name.."退出副本")
		end
	elseif kind == "msg" then
		table.insert(self.params.msg, data)
		if table.nums(self.params.msg) > 2 then
			table.remove(self.params.msg, 1)
		end
	elseif kind == "buy" then   --购买探索次数
		KNMsg.getInstance():flashShow("购买探索次数成功，探索次数增加")
	elseif kind == "over" then  --副 本时间结束，强制所有人退出
		HTTP:call("fubenroom", "hasPermission", {}, {
			success_callback = function(data)
				switchScene("multiFb", {data}, function()
					KNMsg.getInstance():flashShow("副本超时，房间强制解散")
				end )
			end})
		return 
	end
	
	if isset(data, "spanRemain") then self.params.spanRemain = data.spanRemain end
	if isset(data, "remainSearch") then self.params.remainSearch = data.remainSearch end
	if isset(data, "pos") then self.params.pos = data.pos end
	if isset(data, "finish") then self.params.map[data.pos..""] = data.finish end
	if isset(data, "event") then self.params.event = data.event end
	
	if kind == "fight" then
		self:startWarClock()
		self:hideKeyBoard()
		self:createFight()
	else
		--若战斗不存在则更新界面，否则保持 原状态
		if not self.warObj then
			self:createMain(self.params)
		else
			self.warObj:removeUser(data.uid)
		end
	end
	
end

function M:hideKeyBoard()
	if self.talkLayer then
		self.talkLayer:stopKeyBoard(true)
		DATA_Info:setIsOpen(false)
	end
end


return M