local PATH = IMG_PATH.."image/scene/multiwar/"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local Role = requires(IMG_PATH , "GameLuaScript/Scene/multiwar/role")

local KNProgress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local WarLayer = {
	baseLayer,
	layer,
	data,
	users,
	points,
	posTip,  --自己的位置提示
	cards,   --胜利后的卡牌奖
	isBoss,
	open,  --是否已翻 开卡牌
	actionTip
	
}
local pos
function WarLayer:new(kind, data)
	local this = {}
	setmetatable(this,self)
	self.__index = self
	this.data = data or {}
	this.users = {}
	this.points = {}
	this.cards = {}
	this.isBoss = kind == "boss"
	
	this.baseLayer = display.newLayer()
	local bg = display.newSprite(PATH..(kind == "boss" and "boss_bg.jpg" or "normal_bg.jpg"))
	setAnchPos(bg)
	this.baseLayer:addChild(bg)
	
	local line = display.newSprite(PATH..(kind == "boss" and "boss_line.png" or "normal_line.png"))
	setAnchPos(line, 240, 350, 0.5, 0.5)
--	this.baseLayer:addChild(line)
	
	local info = display.newSprite(IMG_PATH.."image/scene/strengthen/up_bg.png")
	setAnchPos(info, 270, 20)
	this.baseLayer:addChild(info)
	
	info = display.newSprite(PATH.."info_text.png")
	setAnchPos(info, 280, 40)
	this.baseLayer:addChild(info)
	
	info = createLabel({str = timeConvert(this.data.spanRemain, nil, true), size = 24, color = ccc3(255,255,255)})
	setAnchPos(info, 370, 40)
	this.baseLayer:addChild(info)
	
	Clock:addTimeFun("multi_time_count", function()
		if this.data.spanRemain > 0 then
			this.data.spanRemain = this.data.spanRemain  - 1
			info:setString(timeConvert(this.data.spanRemain, nil, true))
		end
	end)
	
	this.actionTip = createLabel({str = "未行动", color = ccc3(255, 255, 255), size = 20})
	setAnchPos(this.actionTip, 370, 70)
	this.baseLayer:addChild(this.actionTip)
	
	
	
	local curTalk
	if checkOpened("talk") ~= true then btn_images = {"aide_press.png"} end
	local temp = KNBtn:new( IMG_PATH .. "image/scene/chat/"  , {"talk_flag1.png"} , 410 , 700 , {
		scale = true ,
		front =  IMG_PATH .. "image/scene/chat/talk_flag.png" , 
		callback = function()
			DATA_Info:setIsMsg( false )
			if DATA_Info:getIsOpen( ) then
				local talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/talk")
				curTalk = talkLayer:new( { type = "custom" , priority = -151 , custom = { customTable = { "custom" } , sendParams = { scene = "fuben" , scene_id = "lueduo" } } } )
--				curTalk = talkLayer:new( {type = "gang", priority = -151 } )
				local curScene = display.getRunningScene()
				curScene:addChild( curTalk:getLayer()  )
			else
				curTalk:remove()
			end
			DATA_Info:setIsOpen(  not DATA_Info:getIsOpen( ) )
		end
	})
	
	temp:getLayer():setScale(0.7)
	this.baseLayer:addChild(temp:getLayer())
	--注册接收消息
	DATA_Info:setCustomKey( "lueduo_lueduo" )
	DATA_Info:addActionBtn( "custom" , temp )
	
	this.reportBtn = KNBtn:new(IMG_PATH.."image/scene/war", {"report.png", "report_press.png"}, 410, 150, {
			anchMid = true,
			priority = -150,
			callback = function()
				this.reportBtn:getLayer():stopAllActions()
				HTTP:call("fuben", "getreportlist", {}, {
					success_callback = function(data)
						this.baseLayer:addChild(this:showReport(data))
					end
				})
			end
		})
	this.baseLayer:addChild(this.reportBtn:getLayer())
	
	
	this:createWar(kind)
	
	return this
end

function WarLayer:createWar(kind)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	
	if kind == "boss" then
		pos = {
			{420, 620,1, {2}},
			{300, 600,3, {3,4,5,6}},
			{130, 480,2, {}},
			{180, 360,2, {}},
			{300, 300,2, {}},
			{430, 430,2, {}},
		}
	else
		--{x, y, type(1:目标，2出生，3：怪物), map}
		pos = {
			{210, 600, 1, {3}},
			{180, 472, 2, {3}},
			{327, 440, 3, {4,5}},
			{127, 355, 2, {5}},
			{310, 343, 3, {6,7}},
			{238, 249, 2, {7,9}},
			{428, 216, 3, {9}},
			{73, 206,  2,{9}},
			{201, 135, 3,{}},
		}
	end 
	
	--地图信息 
	for k, v in pairs(pos) do
		local str 
		if v[3] == 1 then
			str = "multi_target.png"
		elseif v[3] == 2 then
			str = "self_supreme.png"
		elseif v[3] == 3 then
			if kind == "boss" then
				str = "boss.png"
			else
				if self.data.allPoint[""..k].stat == 1 then  --有怪物
					str = "pt_enemy.png"
				else
					str = "pt_empty.png"
				end
			end
		end
		self.points[k] = {}
		self.points[k][1] = KNBtn:new(PATH, {str}, v[1], v[2], {
			priority = -151,
			anchMid = true,
			callback = function()
				if k == 1 then
					local allKill = true
					for sk, sv in pairs(self.data.allPoint) do
						if sv.stat == 1 then
							allKill = false
							break
						end
					end
					
					if not allKill then
						KNMsg.getInstance():flashShow("地图中还有未击杀的怪物")
						return 
					end
				end
				local moveData = self.users[DATA_User:get("uid")..""]:getInfo() 
				moveData.time = os.time() + TIME_OFFSET
				moveData.tarPos = k
				if moveData.stat == 0 and tonumber(moveData.pos) ~= k and (table.hasValue(pos[(tonumber(moveData.pos))][4],k) or table.hasValue(pos[k][4], tonumber(moveData.pos))) then  --占领状态才可移动
					moveData.stat = 1
					 self.users[DATA_User:get("uid")..""]:move(pos[k][1], pos[k][2], moveData)
					 HTTP:call("fuben", "CLMove", {tar = k}, {
						 no_loading = true,
						 success_callback = function()
						 end
					 })
				else
					if tonumber(moveData.pos) == k and moveData.stat == 0 then
						KNMsg.getInstance():flashShow("您已占据此点")
					elseif moveData.stat == 1 then
						KNMsg.getInstance():flashShow("行动中，请稍候...")
					elseif moveData.stat == 2 then
						KNMsg.getInstance():flashShow("您已经死亡")
					else
						KNMsg.getInstance():flashShow("不可移动")
					end
				 end
			end
		})
		self.layer:addChild(self.points[k][1]:getLayer())
		
		self:mapLine(kind, k)
	end
	
	self:logic("pt", self.data.allPoint)
--	--玩家信息
--	for k, v in pairs(self.data.allUser) do
--		self.users[k] = Role:new(pos[tonumber(v.pos)][1], pos[tonumber(v.pos)][2], 3, {time = self.data.moveSpan , info = v})	
--		self.layer:addChild(self.users[k]:getLayer())
--		if self.users[k]:isUserSelf() then
--			self:selfTip(true, pos[tonumber(v.pos)][1], pos[tonumber(v.pos)][2])
--		end
--	end
	
	self:logic("user", self.data.allUser)
	self.baseLayer:addChild(self.layer)
end

function WarLayer:selfTip(show, x, y)
	if show then
		if not self.posTip then
			local frames = display.newFramesWithImage(PATH.."cur.png" , 11 )
			self.posTip = display.playFrames(x, y,frames, 0.1, {
				forever = true,
			})
			self.layer:addChild(self.posTip, 5)	
		end
	else
		if self.posTip then
			self.layer:removeChild(self.posTip, true)
			self.posTip = nil
		else
		end
	end
end

function WarLayer:logic(kind, data)
--超时，胜利，失败，开宝箱，
	if kind == "timeout" or kind == "win" or kind == "open" or kind == "lose" then
		Clock:removeTimeFun("multiWarRefresh")
		self:warEnd(kind, data)
 		return 
	end
	--更新据点状态	
	if kind == "pt" then
		for k, v in pairs(data) do
			self.data.allPoint[k] = v
			
			if self.isBoss and pos[tonumber(k)] and pos[tonumber(k)][3] == 3  then
			else
				local point, sign, flag
				local index = tonumber(k)
				
				point = self.points[index][1]
				sign = self.points[index][2]
				flag = self.points[index][3]
				
				if sign then
					self.layer:removeChild(sign, true)
				end
				
				if flag then
					flag:showBtn(false)	
				else
					flag = KNBtn:new(PATH, {"flag_enemy.png"}, point:getX() - 18, point:getY() - 5 , {
	--						other = {COMMONPATH.."egg_num_bg.png", 20, 23},
	--						text = {5, 16, ccc3(255, 255, 255), ccp(0,1), nil, 20},
							callback = function()
								point:call()
							end
						})
					flag:showBtn(false)
					self.layer:addChild(flag:getLayer(), 4)
				end
				
				if pos[index][3] == 3 then
					if v.stat == 1 then
						sign = display.newSprite(PATH.."pt_enemy.png")
						flag:setBg(1, PATH.."flag_enemy.png")
					elseif v.stat == 0 then
						sign = display.newSprite(PATH.."pt_our.png")
						flag:setBg(1, PATH.."flag_our.png")
					end
					setAnchPos(sign, point:getX(), point:getY(), 0.5, 0.5)
					self.layer:addChild(sign, 2)
					
					flag:showBtn(true)
				end 
			end
		end
	end
	
	--更新用户状态
	if kind == "user" then
		for k, v in pairs(data) do
			local str 
			self.data.allUser[k] = v
			
			v.endtime = v.tarTime
			v.time = v.endtime - self.data.moveSpan
			--不存在时先生成对象
			if not self.users[k] then
				self.users[k] = Role:new(pos[tonumber(v.pos)][1], pos[tonumber(v.pos)][2], v.stat, {time = self.data.moveSpan, info = v})	
				self.layer:addChild(self.users[k]:getLayer(), 3)
			end
			
			if v.stat == 0 then--占领 	
				str = "未行动"
				self.users[k]:hold(pos[tonumber(v.pos)][1], pos[tonumber(v.pos)][2], 3, v)	
				if self.users[k]:isUserSelf() then
					self:selfTip(true,pos[tonumber(v.pos)][1], pos[tonumber(v.pos)][2])
				end
			elseif v.stat == 1 then --移动
				str = "行动中"
				self.users[k]:move(pos[tonumber(v.tarPos)][1], pos[tonumber(v.tarPos)][2], v)	
				if self.users[k]:isUserSelf() then
					self:selfTip(false)
				end
			elseif v.stat == 2 then -- 死亡
				--
				if not self.users[k]:isDie() then
					self.users[k]:backHome(pos[tonumber(v.burnPos)][1], pos[tonumber(v.burnPos)][2], v)
				end
				str = "死亡"
			end
			
			if tonumber(k) == tonumber(DATA_User:get("uid")) then
				self.actionTip:setString(str)
			end
		end
		
	end
	
	--战斗动画
	if kind == "battle" then
--		if data.battle_action["end"] then
--			self:lueduoOver(data.battle_action["end"])
--			return 
--		end
--		--自己发生战斗
--		if tonumber(data.battle_action.uid) == tonumber(DATA_User:get("uid")) then
--			self.fighting = true
--		end
		if tonumber(data.uid) == tonumber(DATA_User:get("uid")) then	
			local function tip()
				self.reportBtn:getLayer():stopAllActions()
				self.reportBtn:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.2, 1.3),CCScaleTo:create(0.2, 1), CCCallFunc:create(function()
					tip()
				end)))
			end
			tip()
		end
		
		local count = 0	
		local function play()
			local frames = display.newFramesWithImage(PATH .. "fight_effect.png" , 6 )
			local ani 
			ani = display.playFrames(pos[tonumber(data.pos)][1], pos[tonumber(data.pos)][2], frames, 0.1, {
				onComplete = function()
					self.layer:removeChild(ani, true)
					count = count + 1
					if count < 2 then
						play()
					else
					end
				end
				
			})
			self.layer:addChild(ani, 5)
		end
		play()	
	end
end

function WarLayer:warEnd(kind, data)
	local function getData()	
		HTTP:call("fuben", "getCLInfo", {}, {
			success_callback = function(data)
				switchScene("multiwar", {fight = data, fbDid = data.fbDid})
			end,error_callback = function()
				HTTP:call("fuben", "getInfo", { }, {
			 		success_callback = function(data)
			 			switchScene("multiwar", data)
			 		end, error_callback = function()
				 		HTTP:call("fubenroom", "hasPermission", {}, {
						success_callback = function(data)
							switchScene("multiFb", {data} )
						end
					})
		 			end})
			end
		})	
	end
	if	kind == "timeout" or kind == "lose"  then
		showTip({
			priority = -160,
			content = createLabel({str = "您的挑战失败了，布好阵型再试一次吧", size = 24, width = 300}),
			timeFunc = {
				delay = 2,
				func = function()
					getData()	
				end
			}})
		elseif kind == "open" then --发回用户打开的牌
			self.open = true
			for k, v in pairs(self.cards) do
				if v:getId() ~= "open" then   --若没有打开则将其打开
					v:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.2, 0, 1), CCCallFunc:create(function()
						v:setBg(1,PATH.."card_front.png")
						v:setOther({awardCell({num = 1, cid = string.sub(data.award[k], 1, string.find(data.award[k], ":") - 1)}, {
							 star = true, name = {size = 16}, 
						}), 25, 65})
						v:getLayer():runAction(CCScaleTo:create(0.2,1,1))
					end)))
					v:getLayer():setTouchEnabled(false)
					v:select(false)
				end
				if table.hasValue(data.select,(k - 1)) then --是用户选 中的
					v:select(true)
				end 
			end
			self.layer:runAction(getSequenceAction(CCDelayTime:create(3), CCCallFunc:create(function()
				getData()	
			end) ))
		elseif kind == "win"  then --开箱奖励
			local selects = {}
			
			local layer = display.newLayer()
			layer:ignoreAnchorPointForPosition(false)
			
			local countText = display.newSprite(PATH.."count_text.png")
			setAnchPos(countText, 220, 480, 0.5)
			layer:addChild(countText)
			
			local openTime = 5 
			countText = createLabel({str = openTime, size = 24})
			setAnchPos(countText, 320, 480)
			layer:addChild(countText)
			
			Clock:addTimeFun("multiOpen", function()
				if openTime > 0 then
					openTime = openTime - 1
					countText:setString(openTime.."")
				else
					Clock:removeTimeFun("multiOpen")
				end
			end)
			
			local boxIcon = display.newSprite(PATH.."open_box.png")
			setAnchPos(boxIcon, 310, 510)
			layer:addChild(boxIcon)
			
			local tips = createLabel({str = replaceStr("VIP3以上玩家每次可翻两张牌"), color = ccc3(255, 0, 0), size = 20, width = 400})
			setAnchPos(tips, 240, 280, 0.5)
			layer:addChild(tips)
			
			--翻卡牌
			for i = 1, 3 do
				self.cards[i] = KNBtn:new(PATH, {"card_back.png", "card_select.png"}, 105 + (i - 1) * 140, 390, {
				anchMid = true,
				priority = -161,
				noHide = true,
				selectZOrder = 20,
				selectable = true,
				callback = function()
					if self.cards[i]:isSelect() then
						selects[i] = nil
					else
						local max = DATA_Vip:get("viplv") >= 3 and 2 or 1
						if table.nums(selects) < max then
							selects[i] = i - 1
						else
							KNMsg.getInstance():flashShow("您只能选择"..max.."张卡牌, 可以翻牌啦")
							return false
						end
					end
				end
				
				})
				layer:addChild(self.cards[i]:getLayer())
			end
			
			local wait
			showTip({
				bg = IMG_PATH.."image/scene/mission/wipe_bg.png",
				title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
				title_text = PATH.."open.png",
				priority = -160,
				parent = self.layer,
				content = layer,
				center = {
					path = COMMONPATH,
					normal = "btn_bg_red.png",
					pre = "btn_bg_red_pre.png",
					front = COMMONPATH.."ok.png",
					callback = function()
--						--翻转动画
--						for k, v in pairs(selects) do
--							self.cards[k]:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.2, 0, 1), CCCallFunc:create(function()
--								self.cards[k]:setBg(1,PATH.."card_front.png")
--								self.cards[k]:getLayer():runAction(CCScaleTo:create(0.2,1,1))
--							end)))
--						end
						if self.open then
							if not wait then
								wait = true
								self.layer:runAction(getSequenceAction(CCDelayTime:create(3), CCCallFunc:create(function()
									getData()	
								end) ))
							end
							return
						end
						
						local arg = {}
						local count = 1
						for k, v in pairs(selects) do
							arg["sel"..count] = v
							count = count + 1
						end
						
						local max = DATA_Vip:get("viplv") >= 3 and 2 or 1 
						if table.nums(selects) == max then
							HTTP:call("fuben", "CLCard",arg,{
								success_callback = function(gift)
									self.open = true
									--翻转动画
									for k, v in pairs(gift.select) do
										self.cards[v + 1]:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.2, 0, 1), CCCallFunc:create(function()
											self.cards[v + 1]:setBg(1,PATH.."card_front.png")
											print(string.sub(gift.award[v + 1], 1, string.find(gift.award[v + 1], ":")))
											self.cards[v + 1]:setOther({awardCell({num = 1, cid = string.sub(gift.award[v + 1], 1, string.find(gift.award[v + 1], ":") - 1)}, {
												 star = true, name = {size = 16}, 
											}), 25, 65})
											self.cards[v + 1]:getLayer():runAction(CCScaleTo:create(0.2,1,1))
										end)))
										self.cards[v + 1]:getLayer():setTouchEnabled(false)
										self.cards[v + 1]:setId("open")
									end	
								end
							})
						else
							KNMsg.getInstance():flashShow("您当前的vip等级可以选择"..max.."张卡牌呦")
						end
					end
					
				}
			})
		end
end


function WarLayer:mapLine(kind, i)
	local data = pos[i][4]
	for j = 1, #data do
		local line = display.newSprite(PATH..(kind == "boss" and "boss_line.png" or "normal_line.png"))
			
		self.layer:addChild(line, -2)
		
		setAnchPos(line, pos[i][1], pos[i][2], 0, 0.5)
		local dx = pos[data[j]][1] - pos[i][1]
		local dy = pos[data[j]][2] - pos[i][2]
		
		local distance = math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))
		
		local rotate = -math.deg(math.acos(dx / distance))
		
			if dy < 0 then
				rotate = -rotate
			elseif dy == 0 and dx < 0 then
				rotate = 180
			end
		line:setScaleX(distance / line:getContentSize().width)
		line:setRotation(rotate)
	end
end

function WarLayer:getLayer()
	return self.baseLayer
end

function WarLayer:removeUser(uid)
	if self.users[uid] then
		self.layer:removeChild(self.users[uid]:getLayer(), true)	
	end
end

function WarLayer:showReport(data)
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer})
	
	local bg = display.newSprite(IMG_PATH.."image/scene/mission/wipe_bg.png")
	setAnchPos(bg, 250, 425, 0.5, 0.5)
	layer:addChild(bg)
	
	local title = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
	setAnchPos(title, 260, 560, 0.5)
	layer:addChild(title)
	
	title = display.newSprite(IMG_PATH.."image/scene/war/title.png")
	setAnchPos(title, 250, 570, 0.5)
	layer:addChild(title)
	
	local back = KNBtn:new(COMMONPATH, {"back_img.png", "back_img_press.png"}, 50, 540, {
		priority = -161,
		callback = function()
			mask:remove()
		end
	})
	layer:addChild(back:getLayer())
	
	local function createItem(index)
		local report
		report = display.newLayer()
		local itemBg = display.newSprite(IMG_PATH.."image/scene/war/report_bg.png")
		setAnchPos(itemBg)
		
		report:setContentSize(CCSizeMake(bg:getContentSize().width, itemBg:getContentSize().height))
		report:addChild(itemBg)
		
		local opt = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 330, 15, {
			priority = -161,
			front = IMG_PATH.."image/scene/friend/text_operate.png",
			callback = function()
				local result = display.newLayer()
				local mask = KNMask:new({item = result, priority = -132})
				
				local bg = display.newSprite(COMMONPATH.."tip_bg.png")
				setAnchPos(bg, 250, 425, 0.5, 0.5)
				result:addChild(bg)
				
				local x, y
				--武将的状态显示
				for k, v in pairs(data[index].remain_general) do
					if k == "on" then
						y = 480
					else
						y = 380
					end
					for i = 1, #v do 
						local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 65 + (i - 1) * 100, y, {
							other = {COMMONPATH.."egg_num_bg.png", 50, 50},
							text = {v[i].lv, 18, ccc3(255,255,255), ccp(28, 28), nil, 20 },
							front = getImageByType(v[i].cid, "s")
						})
						result:addChild(btn:getLayer())
						
						local hp = KNProgress:new(IMG_PATH.."image/scene/war/", {"hp_bg.png", "hp_full.png"}, 65 + (i - 1) * 100, y - 10, {
							cur = v[i].hp,
							max = v[i].org_hp
						})
						result:addChild(hp:getLayer())
					end
				end
				
				local replay = KNBtn:new(IMG_PATH.."image/scene/war/", {"replay.png", "replay_press.png"}, 380, 310, {
					priority = -163,
					callback = function()
						HTTP:call("fuben", "getreport", {report_id = data[index].report_id}, {
							success_callback = function(data)
								DATA_Battle:setMod("guide")
								DATA_Battle:setAct("execute")
								DATA_Battle:set( data )
								switchScene("battle" , { resultCallFun = function()end, overFun = function()
										HTTP:call("fuben", "getCLInfo", {}, {
											success_callback = function(data)
												switchScene("multiwar", {fight = data, fbDid = data.fbDid})
											end,error_callback = function()
												HTTP:call("fuben", "getInfo", { }, {
											 		success_callback = function(data)
											 			switchScene("multiwar", data)
											 		end, error_callback = function()
												 		HTTP:call("fubenroom", "hasPermission", {}, {
														success_callback = function(data)
															switchScene("multiFb", {data} )
														end
													})
										 			end})
											end
										})
								end })
							end
						})
					end
				})
				result:addChild(replay:getLayer())
				
				local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 180, 310, {
					priority = -163,
					front = COMMONPATH.."colse_text.png",
					callback = function()
						mask:remove()
					end
				})
				result:addChild(close:getLayer())
				
				layer:addChild(mask:getLayer())
			end
		})
		report:addChild(opt:getLayer())
		
		local str 
		if data[index].win == 1 then
			str =  "【"..DATA_User:get("name").."】战胜了【"..data[index]["uid_2_name"].."】"	
		else
			str =  "【"..DATA_User:get("name").."】被【"..data[index]["uid_2_name"].."】打败了"	
		end
		
		local alive = 0
		for k, v in pairs(data[index].remain_general) do
			for sk, sv in pairs(v) do
				if sv.hp > 0 then
					alive = alive + 1
				end
			end
		end
		str = str..",当前存活武将数"..alive.."人"
		local oneMsg = createLabel({str = replaceStr(str), color = ccc3(255, 255, 255), size = 18, width = 310, x = 10, y = 15})
		oneMsg:setDimensions( CCSize:new( oneMsg:getContentSize().width ,0 ) )
		report:addChild(oneMsg)
		return report	
	end
	
	for i = 1, #data do
		local report = createItem(i)
		setAnchPos(report, 45, 475 - (i - 1) * (report:getContentSize().height + 5))
		layer:addChild(report)
	end
	
	return mask:getLayer()
end
return WarLayer
