local PATH = IMG_PATH .. "image/scene/pay/"
local KNLoading = requires(IMG_PATH, "GameLuaScript/Common/KNLoading")
local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")

--[[一条数据]]
local PayItem = {
	layer,
	params,
}



function PayItem:new(data , params)
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	this.params = params or {}

	this.layer = display.newLayer()

	
	local bg = display.newSprite( PATH .. (CHANNEL_ID == "tgxywp_xlive" and "bar_xlive.png" or "bar.png") )

	setAnchPos(bg , 0 , 0)
	this.layer:addChild(bg)

	if data.part30 then
		
		local chong = display.newSprite( PATH .. "card_" .. data.rmb .. ".png" )
		setAnchPos(chong , 30 , 20)
		this.layer:addChild(chong)
	
		local extra = display.newSprite( PATH ..  (data.rmb==78 and "part_90.png" or"part_30.png")  )
		setAnchPos(extra , 360 , 15)
		this.layer:addChild(extra)
	elseif data.flashBuy then
		this.layer:addChild( display.newSprite( PATH .. "flash_text" .. data.type .. ".png" , 55 , 20 , 0 , 0 ) )
		this.layer:addChild( display.newSprite( PATH .. "get_" .. data.rmb/10 .. ".png" ,  128 , 25 , 0 , 0 ) )
		
	else
		local chong = display.newSprite( PATH .. "chong_" .. data.rmb .. ".png" )
		setAnchPos(chong , 30 , 20)
		this.layer:addChild(chong)
	
		if CHANNEL_ID ~= "tgxywp_xlive" then
			local gold = display.newSprite( PATH .. "gold.png" )
			setAnchPos(gold , 200 , 20)
			this.layer:addChild(gold)
		end

		local get = display.newSprite( PATH .. "get_" .. data.rmb .. ".png" )
		setAnchPos(get , 265 , 22)
		this.layer:addChild(get)
	
		if data.extra then
			local extra = display.newSprite( PATH .. "extra_" .. data.rmb .. ".png" )
			setAnchPos(extra , 360 , 15)
			this.layer:addChild(extra)
		end
	end

	


	this.layer:setContentSize( CCSizeMake( 436 , (CHANNEL_ID == "tgxywp_xlive" and 144 or 80) ) )

	--	设置 1秒内禁止所有的充值按钮点击
	__PAY_CLICK_ENABLE =  true

	-- 设置可点击
	local init_y = 0
	this.layer:registerScriptTouchHandler(function( type , x , y )
		if type == CCTOUCHBEGAN then
			local range = this:getRange()
			if y < this.params.parent:getY() + this.params.parent:getHeight() and y > this.params.parent:getY()  then
				if this:getRange():containsPoint( ccp(x , y) ) then
					init_y = y
					return true
				end
			end

			return false
		elseif type == CCTOUCHMOVED then
		elseif type == CCTOUCHENDED then

			if this:getRange():containsPoint( ccp(x , y) ) and __PAY_CLICK_ENABLE  then
				__PAY_CLICK_ENABLE = false
			
				-- 1秒内禁止所有的充值按钮点击
				local array = CCArray:create()
				array:addObject( CCDelayTime:create(1) )
				array:addObject( CCCallFunc:create( function() __PAY_CLICK_ENABLE = true end ) )
				this.layer:runAction( CCSequence:create(array) )

				if math.abs(y - init_y) < 30 then
					self:requestPay(data)
				end
			end
		end

		return true
	end)
	this.layer:setTouchEnabled(true)
	
	return this
end

function PayItem:requestPay(data)
	local post_data = {
			num = data.num , 
			award_id = data.part30 and 1 or nil ,
			redbag_num = data.redbag_num
		}

		for k , v in pairs(device.infos) do
			post_data[k] = v
		end

		local mod , action = "iapppay" , "token"

		if CHANNEL_ID == "tmsj.heitao" or CHANNEL_ID == "tmsj.heitao1" or CHANNEL_ID == "tmsj.htios" then 
			post_data.channel_group = CHANNEL_GROUP
			post_data.plat_index = "android"
			post_data.platform = "heitao"
			mod , action = "pay" , "token"
		end

		if __INNER_NEWSDK__ and LOGINDATA_FROM_ANDROID and LOGINDATA_FROM_ANDROID["new_pay"]=="true" then 			--支付需要的参数每次都从  android平台 传过来， 不用每次都根据 channel_id 传一个 platform
			dump(LOGINDATA_FROM_ANDROID , "LOGINDATA_FROM_ANDROID")
			mod , action = "pay" , "token"
			post_data.plat_index = "android"
			post_data.platform =  LOGINDATA_FROM_ANDROID.platform
			post_data.channel_group = CHANNEL_GROUP
		end

		--------------------------------------------------------------------------
		--新的ios联运方案[ by antion 2014.09.16 ]
		if __INNER_IOS_SDK_VER then
			--正版先用旧的订单请求方式
			if __INNER_IOS_SDK_VER >= 3 and channel_delegate:getInst():isAppstore() then
			elseif __INNER_IOS_SDK_VER >= 4 and channel_delegate:getInst():call(json.encode({type="isUseOldOrder"}), function() end) then
			else
				post_data.channel_group = CHANNEL_GROUP
				post_data.plat_index = "android"
				post_data.platform = channel_delegate:getInst():platformName()
				mod , action = "pay" , "token"
			end
			dump(post_data)
		end
		--------------------------------------------------------------------------

		if data.flashBuy then
			switchScene( "home" )
		end
		
		HTTP:call( mod , action , post_data , {

			success_callback = function(response)

				if device.platform == "wp8" then

					local pay_url = ""

					if CHANNEL_ID == "tmsjwp" then
						pay_url = CONFIG_PAY_URL .. "?from=tmsjwp"
					end
					
					UpdataRes:getInstance():play( response["exorderno"] .. "" , (response["price"] * 100) .. "" , response["waresid"] .. "" , "1" , pay_url)

			    elseif device.platform == "ios" then
			    	--------------------------------------------------------------------------
					--新的ios联运方案[ by antion 2014.09.16 ]
					if __INNER_IOS_SDK_VER then
						local function go()
							local load
							if __INNER_IOS_SDK_VER >= 3 and channel_delegate:getInst():isAppstore() then--正版的话，阻止操作
								load = KNLoading:new()
	                        	display.getRunningScene():addChild(load:getLayer())
							end
							local params = clone(response)
							params._title = data.num .. "两黄金"
							channel_delegate:getInst():pay(json.encode(params), function(dic)
								if load then
									load:remove()
								end
								KNMsg.getInstance():flashShow(dic.msg)
								if dic.receipt and "" ~= dic.receipt then--正版才有的收据
									local function callSendOutGoods(cnt)
										HTTP:call("pay", "callback", { orderNo = params.exorderno, receiptString = dic.receipt } , {
	                						requestUrl = CONFIG_PAY_URL .. "?from=" ..CHANNEL_ID,
	                						success_callback = function()
												KNMsg.getInstance():flashShow("充值已到账")
										    end,
										    error_callback = function()
										    	if 3 == cnt then--要了3次还不到账
													KNMsg.getInstance():flashShow( "抱歉,您本次购买的黄金可能会延迟发货,请您联系客服处理" )
												else
										    		callSendOutGoods(cnt+1)
										    	end
										    end,
										})
									end
									callSendOutGoods(1)
								end
							end)
							dump(response)
						end

						if (CHANNEL_ID == "tmsjios" or CHANNEL_ID == "tgxyIosIpay" or CHANNEL_ID == "dhshIosIpay") and __INNER_IOS_SDK_VER <= 4 then
							KNMsg.getInstance():boxShow( "爱贝云计费平台已升级,\"银联手机支付\"用户需跳转官网重新下载安装包才能正常充值!其余用户可忽略此步骤.您是否要跳转?" ,
							{
								cancelText = COMMONPATH .. "back.png" , 
								confirmFun = function()
									if CHANNEL_ID == "tmsjios" then
										UpdateDataOC:getInstance():openUrl("http://tmsj.szkuniu.com/")
									elseif CHANNEL_ID == "tgxyIosIpay" then
										UpdateDataOC:getInstance():openUrl("http://tgxy.szkuniu.com/")
									elseif CHANNEL_ID == "dhshIosIpay" then
										UpdateDataOC:getInstance():openUrl("http://dhsh.szkuniu.com/")
									end
								end, 
								cancelFun = function()
									go()
								end
							})
						else
							go()
						end
					--------------------------------------------------------------------------
			    	elseif CHANNEL_ID == "hysjIos91" or CHANNEL_ID == "tgxyIos91" or CHANNEL_ID == "tmsjIos91" then
			    	    -- IOS 91平台
						LuaCall91PlatForm:getInstance():buy(response["exorderno"] , response["waresid"] , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "hysjIosTBT" or CHANNEL_ID == "tgxyIosTBT" or CHANNEL_ID == "tmsjIosTBT" then  --同步推
						LuaCallTBTPlatform:getInstance():buy(response["exorderno"] , response["waresid"] , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "hysjIosDownJoy" or CHANNEL_ID == "tgxyIosDj" or CHANNEL_ID == "tmsjIosDj" then  --当乐
						LuaCallDownJoySDK:getInstance():buy(response["exorderno"] , response["waresid"] , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "hysjIosPP" or CHANNEL_ID == "tgxyIosPP" or CHANNEL_ID == "tmsjIosPP" then  --pp
						LuaCallPPSDK:getInstance():buy(response["exorderno"] , response["waresid"] , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "hysjIosUC" or CHANNEL_ID == "tgxyIosUC" or CHANNEL_ID == "tmsjIosUC" then  --UC
						LuaCallUCSDK:getInstance():buy(response["exorderno"] , response["waresid"] , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "hysjIosKY" or CHANNEL_ID == "tgxyIosKY" or CHANNEL_ID == "tmsjIosKY" then  --ky
						LuaCallKYSDK:getInstance():buy(response["exorderno"] , response["guid"] , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "hysjIosYLT" then
						LuaCallYLTSDK:getInstance():buy(response["exorderno"] , DATA_Session:get("server_id") , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "hysjIos17173" then  --17173
						LuaCall17173SDK:getInstance():buy(response["exorderno"] , response["waresid"] , data.num .. "两黄金" , response["price"] , 1)
                    elseif CHANNEL_ID == "hyxsdIosItools" or CHANNEL_ID == "tgxyIosItools" or CHANNEL_ID == "tmsjIosItools" then  --iTools
						LuaCalliToolsSDK:getInstance():buy(response["exorderno"] , response["waresid"] , data.num .. "两黄金" , response["price"] , 1)
					elseif CHANNEL_ID == "appFame"  then			
						--ios 云顶sdk平台
					    LuaCallAppFrameSDK:getInstance():buy(0) --参数为0,不需要传
					
					elseif CHANNEL_ID == "appFameOfficial" or CHANNEL_ID == "appFameOfficial2" then
						
						--ios 云顶sdk平台正版
						local load = KNLoading:new()
                        display.getRunningScene():addChild(load:getLayer())
					    LuaCallAppFameSDKOfficial:getInstance():buy(response["price"] , response["exorderno"],
            				function() 
            					load:remove() 
            				end ,
            				function(response)
            					load:remove()
            					local orderNo = response["orderNo"]
            					local receiptString = response["receiptString"]
            				
            					HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
            						requestUrl = CONFIG_PAY_URL .. "?from=appFameAppStore",
            						success_callback = function()
									   
								    end,
								    error_callback = function()
									  --重发一次请求
											HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
                    						requestUrl = CONFIG_PAY_URL .. "?from=appFameAppStore",
                    						success_callback = function()
											   
										    end,
											error_callback = function()
											--再重发一次请求
													HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
	                        						requestUrl = CONFIG_PAY_URL .. "?from=appFameAppStore",
	                        						success_callback = function()
													   
												    end,
												    error_callback = function()
												    	KNMsg.getInstance():flashShow( "抱歉,您本次购买的黄金可能会延迟发货,请您联系客服处理" )
													end
												    })
										    end


										    })
								    end

								})

            			end) 
                    

                    elseif CHANNEL_ID == "tmsjIosAppStore" then
                         --ios 唐门世界正版
                        local load = KNLoading:new()
                        display.getRunningScene():addChild(load:getLayer())
            			LuaCallAppStore:getInstance():buy( response["price"] , response["exorderno"],
            				function() 
            					load:remove() 
            				end ,
            				function(response)
            					load:remove()
            					local orderNo = response["orderNo"]
            					local receiptString = response["receiptString"]
            				
            					HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
            						requestUrl = CONFIG_PAY_URL .. "?from=tmsjIosAppStore",
            						success_callback = function()
									
									end,
									error_callback = function()
									   
										HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
                    						requestUrl = CONFIG_PAY_URL .. "?from=tmsjIosAppStore",
                    						success_callback = function()
											
											end,
											error_callback = function()
											--再重发一次请求
													HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
	                        						requestUrl = CONFIG_PAY_URL .. "?from=tmsjIosAppStore",
	                        						success_callback = function()
													   
												    end,
												    error_callback = function()
												    	KNMsg.getInstance():flashShow( "抱歉,您本次购买的黄金可能会延迟发货,请您联系客服处理" )
													end
												    })
										    end


										})
									end
								})

            			end)
            		elseif CHANNEL_ID == "hysjIosAppStore" then
                         --ios 火影世界正版
                        local load = KNLoading:new()
                        display.getRunningScene():addChild(load:getLayer())
            			LuaCallAppStore:getInstance():buy( response["price"] , response["exorderno"],
            				function() 
            					load:remove() 
            				end ,
            				function(response)
            					load:remove()
            					local orderNo = response["orderNo"]
            					local receiptString = response["receiptString"]
            				
            					HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
            						requestUrl = CONFIG_PAY_URL .. "?from=hysjIosAppStore",
            						success_callback = function()
									
								    end,
								    error_callback = function()
										    HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
                    						   requestUrl = CONFIG_PAY_URL .. "?from=hysjIosAppStore",
                    						   success_callback = function()
											
										       end,
												error_callback = function()
												--再重发一次请求
														HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
		                        						requestUrl = CONFIG_PAY_URL .. "?from=hysjIosAppStore",
		                        						success_callback = function()
														   
													    end,
													    error_callback = function()
													    	KNMsg.getInstance():flashShow( "抱歉,您本次购买的黄金可能会延迟发货,请您联系客服处理" )
														end
													    })
											    end
										    
										    })
								    end
								})

            			end)
					elseif CHANNEL_ID == "jstfIosAppStore" then
                         --ios 绝世天府正版
                        local load = KNLoading:new()
                        display.getRunningScene():addChild(load:getLayer())
            			LuaCallAppStore:getInstance():buy( response["price"] , response["exorderno"],
            				function() 
            					load:remove() 
            				end ,
            				function(response)
            					load:remove()
            					local orderNo = response["orderNo"]
            					local receiptString = response["receiptString"]
            				
            					HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
            						requestUrl = CONFIG_PAY_URL .. "?from=jstfIosAppStore",
            						success_callback = function()
									
								    end,
								    error_callback = function()
										    HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
                    						   requestUrl = CONFIG_PAY_URL .. "?from=jstfIosAppStore",
                    						   success_callback = function()
											
										       end,
												error_callback = function()
												--再重发一次请求
														HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
		                        						requestUrl = CONFIG_PAY_URL .. "?from=jstfIosAppStore",
		                        						success_callback = function()
														   
													    end,
													    error_callback = function()
													    	KNMsg.getInstance():flashShow( "抱歉,您本次购买的黄金可能会延迟发货,请您联系客服处理" )
														end
													    })
											    end
										    
										    })
								    end
								})

            			end)
					elseif CHANNEL_ID == "tgxyIosAppStore" then
                         --ios 太古仙域正版
                        local load = KNLoading:new()
                        display.getRunningScene():addChild(load:getLayer())
            			LuaCallAppStore:getInstance():buy( response["price"] , response["exorderno"],
            				function() 
            					load:remove() 
            				end ,
            				function(response)
            					load:remove()
            					local orderNo = response["orderNo"]
            					local receiptString = response["receiptString"]
            				
            					HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
            						requestUrl = CONFIG_PAY_URL .. "?from=tgxyIosAppStore",
            						success_callback = function()
									
								    end,
								    error_callback = function()
										    HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
                    						   requestUrl = CONFIG_PAY_URL .. "?from=tgxyIosAppStore",
                    						   success_callback = function()
											
										       end,
												error_callback = function()
												--再重发一次请求
														HTTP:call("pay", "callback", { orderNo = orderNo , receiptString = receiptString } , {
		                        						requestUrl = CONFIG_PAY_URL .. "?from=tgxyIosAppStore",
		                        						success_callback = function()
														   
													    end,
													    error_callback = function()
													    	KNMsg.getInstance():flashShow( "抱歉,您本次购买的黄金可能会延迟发货,请您联系客服处理" )
														end
													    })
											    end
										    
										    })
								    end
								})

            			end)
					elseif CHANNEL_ID == "tmsjios" or CHANNEL_ORIGIN_ID=="tmsjios" then
					    LuaCalliPaySDK:getInstance():buy(response["exorderno"] , response["waresid"],response["price"])
					elseif CHANNEL_ID == "dhshIosIpay"  then
					    LuaCalliPaySDK:getInstance():buy(response["exorderno"] , response["waresid"],response["price"])
					elseif CHANNEL_ID == "tgxyIosIpayKB" or CHANNEL_ORIGIN_ID=="tgxyIosIpay" or CHANNEL_ID == "tgxyIosIpay" or CHANNEL_ID == "tgxyIosIpayMirror" or CHANNEL_ID == "tgxyIosIpayYouy" or CHANNEL_ID == "tgxyIosIpayXYPG" or CHANNEL_ID == "tgxyIosIpayYyh" or CHANNEL_ID == "tgxyIosIpayYouy" or CHANNEL_ID == "tgxyIosIpayPgy" then
					    LuaCalliPaySDK:getInstance():buy(response["exorderno"] , response["waresid"],response["price"])
					elseif CHANNEL_ID == "jstf_iospj" or CHANNEL_ORIGIN_ID=="jstf_iospj"  then
						LuaCallDiYiBoSDK:getInstance():buy(response["exorderno"] ,"10", response["price"])
					elseif CHANNEL_ID == "jstfiosyuedu" then
						LuaCallDiYiBoSDK:getInstance():buy(response["exorderno"] ,"10", response["price"])
					else
					end

			    else
			    	local gameNameConfig = { tgxy = "太古仙域" , hy = "火影小时代" , tmsj = "唐门世界" , td = "绝世天府" , dhsh = "大话水浒" , tmsj2 = "唐门" , tgxy2="太古"}
			    	if __INNER_NEWSDK__ then
			    		CCLuaLog("-------------new pay---------------------")
			    		dump("充值了++是否新的爱贝SDK")
						if _NEWAIBEI and _NEWAIBEI == 2 then 
							dump("充值了+新的爱贝SDK")
							DirectChannel.instance():call(
							{
								action = "pay",
								money = response["price"],
								order = response["exorderno"],
								serverid = tostring( DATA_Session:get("server_id") ),
								user_id = DATA_Session:get("uid"),
								user_name = DATA_User:get("name"),
								user_lv = DATA_User:get("lv"),
								game_name = gameNameConfig[CHANNEL_GROUP],
								productName = "黄金",
								isMonth = data.part30 and "true" or "false",
								ownGold = DATA_Account:get("gold"),
								gangName = _T_alliance_name,
								server_name = DATA_GodCell:get("server_name"),
								isMonth = data.part30 and "true" or "false",
								vipLv = DATA_Vip:get("viplv"),
								desc = "黄金可以在商城购买道具",
								rate = "10",
								extinfo = response["extrainfo"],
								callback = function(data)
									dump(response , "payback_data")

									local payback_data = {}
									for k , v in pairs(data) do
										payback_data[k] = v
									end
									payback_data.orderno = response["exorderno"]
									if payback_data.result == "fail" then 
										KNMsg.getInstance():flashShow( "支付失败" )
									elseif payback_data.result == "cancel" then 
										KNMsg.getInstance():flashShow( "取消支付" )
									elseif payback_data.result == "success" then 
										HTTP:call("pay", "callback", payback_data , {
	                						requestUrl = CONFIG_PAY_URL .. "?from="..payback_data.platform,
	                						success_callback = function()
											   
										    end,
										    error_callback = function()
										    	KNMsg.getInstance():flashShow( "抱歉，充值出现异常，请联系客服处理。" )
											end
									    })
									end
								end
							})
						elseif _NEWAIBEI and _NEWAIBEI == 1 then 
							dump("CHANNEL_ID"..CHANNEL_ID)
						    if CHANNEL_ID == "tmsj" or CHANNEL_ID == "game1" or CHANNEL_ID == "tgxy" or CHANNEL_ID == "jstf" then 
								dump("充值了+新的爱贝SDK")
								local downUrl = ""
								if CHANNEL_ID == "tmsj" then 
									downUrl = "http://tmsj.szkuniu.com"
								elseif CHANNEL_ID == "game1" then 
									downUrl = "http://www.szkuniu.com/dhsh/m/"
								elseif CHANNEL_ID == "tgxy" then 
									downUrl = "http://tgxy.szkuniu.com"
								elseif CHANNEL_ID == "jstf" then
									downUrl = "http://jstf.szkuniu.com"
								end

								if downUrl == "" then 
								else
									KNMsg.getInstance():boxShow("爱贝云计费平台已升级，我们将为您提供更方便快捷的充值方式，避免充值异常，建议您更新游戏最新版本，是否现在跳转官网下载最新版本？" ,
									{
										cancelText = COMMONPATH .. "back.png" , 
										confirmFun = function() 
											dump("到官网中......")
											dump("downUrl"..downUrl)
											UpdataRes:getInstance():openUrl( downUrl )
										end , 
										cancelFun = function() 

											DirectChannel.instance():call(
											{
												action = "pay",
												money = response["price"],
												order = response["exorderno"],
												serverid = tostring( DATA_Session:get("server_id") ),
												user_id = DATA_Session:get("uid"),
												user_name = DATA_User:get("name"),
												user_lv = DATA_User:get("lv"),
												game_name = gameNameConfig[CHANNEL_GROUP],
												productName = "黄金",
												isMonth = data.part30 and "true" or "false",
												ownGold = DATA_Account:get("gold"),
												gangName = _T_alliance_name,
												server_name = DATA_GodCell:get("server_name"),
												isMonth = data.part30 and "true" or "false",
												vipLv = DATA_Vip:get("viplv"),
												desc = "黄金可以在商城购买道具",
												rate = "10",
												extinfo = response["extrainfo"],
												callback = function(data)
													dump(response , "payback_data")

													local payback_data = {}
													for k , v in pairs(data) do
														payback_data[k] = v
													end
													payback_data.orderno = response["exorderno"]
													if payback_data.result == "fail" then 
														KNMsg.getInstance():flashShow( "支付失败" )
													elseif payback_data.result == "cancel" then 
														KNMsg.getInstance():flashShow( "取消支付" )
													elseif payback_data.result == "success" then 
														HTTP:call("pay", "callback", payback_data , {
					                						requestUrl = CONFIG_PAY_URL .. "?from="..payback_data.platform,
					                						success_callback = function()
															   
														    end,
														    error_callback = function()
														    	KNMsg.getInstance():flashShow( "抱歉，充值出现异常，请联系客服处理。" )
															end
													    })
													end
												end
											})
										end
									})
								end
							end
						else
							dump("CHANNEL_ID"..CHANNEL_ID)
						    if CHANNEL_ID == "tmsj" or CHANNEL_ID == "game1" or CHANNEL_ID == "tgxy" or CHANNEL_ID == "jstf" then 
								dump("充值了+新的爱贝SDK")
								local downUrl = ""
								if CHANNEL_ID == "tmsj" then 
									downUrl = "http://tmsj.szkuniu.com"
								elseif CHANNEL_ID == "game1" then 
									downUrl = "http://www.szkuniu.com/dhsh/m/"
								elseif CHANNEL_ID == "tgxy" then 
									downUrl = "http://tgxy.szkuniu.com"
								elseif CHANNEL_ID == "jstf" then
									downUrl = "http://jstf.szkuniu.com"
								end

								if downUrl == "" then 
								else
									KNMsg.getInstance():boxShow( "爱贝云计费平台已升级,\"银联手机支付\"用户需跳转官网重新下载安装包才能正常充值!其余用户可忽略此步骤.您是否要跳转?" ,
									{
										cancelText = COMMONPATH .. "back.png" , 
										confirmFun = function() 
											dump("到官网中......")
											dump("downUrl"..downUrl)
											UpdataRes:getInstance():openUrl( downUrl )
										end , 
										cancelFun = function() 

											DirectChannel.instance():call(
											{
												action = "pay",
												money = response["price"],
												order = response["exorderno"],
												serverid = tostring( DATA_Session:get("server_id") ),
												user_id = DATA_Session:get("uid"),
												user_name = DATA_User:get("name"),
												user_lv = DATA_User:get("lv"),
												game_name = gameNameConfig[CHANNEL_GROUP],
												productName = "黄金",
												isMonth = data.part30 and "true" or "false",
												ownGold = DATA_Account:get("gold"),
												gangName = _T_alliance_name,
												server_name = DATA_GodCell:get("server_name"),
												isMonth = data.part30 and "true" or "false",
												vipLv = DATA_Vip:get("viplv"),
												desc = "黄金可以在商城购买道具",
												rate = "10",
												extinfo = response["extrainfo"],
												callback = function(data)
													dump(response , "payback_data")

													local payback_data = {}
													for k , v in pairs(data) do
														payback_data[k] = v
													end
													payback_data.orderno = response["exorderno"]
													if payback_data.result == "fail" then 
														KNMsg.getInstance():flashShow( "支付失败" )
													elseif payback_data.result == "cancel" then 
														KNMsg.getInstance():flashShow( "取消支付" )
													elseif payback_data.result == "success" then 
														HTTP:call("pay", "callback", payback_data , {
					                						requestUrl = CONFIG_PAY_URL .. "?from="..payback_data.platform,
					                						success_callback = function()
															   
														    end,
														    error_callback = function()
														    	KNMsg.getInstance():flashShow( "抱歉，充值出现异常，请联系客服处理。" )
															end
													    })
													end
												end
											})
										end
									})
								end
							else 
								dump("充值了+旧的爱贝SDK--Others")
								DirectChannel.instance():call(
								{
									action = "pay",
									money = response["price"],
									order = response["exorderno"],
									serverid = tostring( DATA_Session:get("server_id") ),
									user_id = DATA_Session:get("uid"),
									user_name = DATA_User:get("name"),
									user_lv = DATA_User:get("lv"),
									game_name = gameNameConfig[CHANNEL_GROUP],
									productName = "黄金",
									isMonth = data.part30 and "true" or "false",
									ownGold = DATA_Account:get("gold"),
									gangName = _T_alliance_name,
									server_name = DATA_GodCell:get("server_name"),
									isMonth = data.part30 and "true" or "false",
									vipLv = DATA_Vip:get("viplv"),
									desc = "黄金可以在商城购买道具",
									rate = "10",
									extinfo = response["extrainfo"],
									callback = function(data)
										dump(response , "payback_data")

										local payback_data = {}
										for k , v in pairs(data) do
											payback_data[k] = v
										end
										payback_data.orderno = response["exorderno"]
										if payback_data.result == "fail" then 
											KNMsg.getInstance():flashShow( "支付失败" )
										elseif payback_data.result == "cancel" then 
											KNMsg.getInstance():flashShow( "取消支付" )
										elseif payback_data.result == "success" then 
											HTTP:call("pay", "callback", payback_data , {
		                						requestUrl = CONFIG_PAY_URL .. "?from="..payback_data.platform,
		                						success_callback = function()
												   
											    end,
											    error_callback = function()
											    	KNMsg.getInstance():flashShow( "抱歉，充值出现异常，请联系客服处理。" )
												end
										    })
										end
									end
								})
						    end
						end
			    	-- 中国手游集团
			    	elseif CHANNEL_ID == "cmge" then
			    		CMGEsdk:getInstance():cmgepay("1" , "dhsh_game1" , "1" , "cmge" , "orderId=" .. response["exorderno"] , (response["price"] * 100) .. "" , "1" , "3")
			    	elseif CHANNEL_ID == "longyin" or CHANNEL_ID == "mi" or CHANNEL_ID == "mm" or CHANNEL_ID == "downjoy" or CHANNEL_ID == "DK" or CHANNEL_ID == "anzhi" or CHANNEL_ID == "kugou" or CHANNEL_ID == "sohu" or CHANNEL_ID == "shoumeng" or CHANNEL_ID == "gfan" or CHANNEL_ID == "nearme.gamecenter" or CHANNEL_ID == "dahua" or CHANNEL_ID == "ifeng" or CHANNEL_ID == "changwan" or CHANNEL_ID == "tianyi" or CHANNEL_ID == "wdj"
						or CHANNEL_ID == "ppw" or CHANNEL_ID == "sky" or CHANNEL_ID == "sqwan" or CHANNEL_ID == "dianjin" or CHANNEL_ID == "lybd" or CHANNEL_ID == "meizu" or CHANNEL_ID == "ywyd" or CHANNEL_ID == "egame" or CHANNEL_GAME == "ayou" then
						FlySDK:getInstance():FlyPay(response["exorderno"] .. "" , CONFIG_PAY_URL .. "?from=longyin", response["price"] .. "", "黄金",function(response) end)
					elseif CHANNEL_ID == "nd91" then
						FlySDK:getInstance():FlyPay(response["exorderno"] .. "" , CONFIG_PAY_URL .. "?from=longyin", response["price"] .. "", "黄金",function(response) end)
					elseif CHANNEL_ID == "ledou" then
						ledouSDK:getInstance():ledoupay("ss")
					elseif CHANNEL_ID == "pada" then
						CCLuaLog("exorderno"..response["exorderno"])
						padaSDK:getInstance():padapay("黄金",response["exorderno"] .. "", data.num .. "" )
					elseif CHANNEL_ID == "qihoo" then
						qihooSDK:getInstance():qihoopay("false","true", (response["price"] * 100) .. "", data.num .. "黄金","大话水浒",response["access_token"],response["qihoo_id"],response["exorderno"],DATA_User:get("name"),CONFIG_PAY_URL .. "?from=qihoo")
					elseif CHANNEL_ID == "uc" then
						-- UCGameSDK:getInstance():pay(true , response["price"] , 2126 , DATA_Session:get("uid") .. "" , DATA_User:get("name").."" , DATA_User:get("lv") .. "" , "orderId=" .. response["exorderno"])
						ucSDK:getInstance():ucPay(tostring(response["price"]), CONFIG_PAY_URL .. "?from=uc", "orderId=" .. response["exorderno"])
					elseif CHANNEL_ID == "youxin" then
						youxinSDK:getInstance():youxinPay(response["price"], "黄金" , "0.1" , response["exorderno"],  CONFIG_PAY_URL .. "?from=youxin", response["time"])
					elseif CHANNEL_ID == "lenovo" then
						lenovoSDK:getInstance():lenovoPay(response["price"] * 100, response["exorderno"], CONFIG_PAY_URL .. "?from=lenovo", "")
					elseif CHANNEL_ID == "tmsj.lenovo" then 
						lenovoSDK:getInstance():lenovoPay(response["price"] * 100, response["exorderno"], CONFIG_PAY_URL .. "?from=tmsj_lenovo", "")	
					elseif CHANNEL_ID == "baidu" then
						baiduSDK:getInstance():baiduPay(response["price"] * 100, response["exorderno"], CONFIG_PAY_URL .. "?from=baidu", "")
					elseif CHANNEL_ID == "tmsjDK" or CHANNEL_ID == "hyDK" or CHANNEL_ID == "tgxyDK" then
						hyDKSDK:getInstance():hyDKPay("10", "黄金", response["exorderno"], response["price"], "none")
					-----------------------------------------------------------------------------------------------------
					-- hy group
					elseif CHANNEL_ID == "hy91" or CHANNEL_ID == "tgxy91" or CHANNEL_ID == "tmsj91" then
						jiu1SDK:getInstance():jiu1Pay( response["exorderno"], response["price"], tostring(data.num) )
					elseif CHANNEL_ID == "hydl" or CHANNEL_ID == "tgxydl" or CHANNEL_ID == "tmsjdl" then
						dlSDK:getInstance():dlPay( response["price"], response["exorderno"] )
					elseif CHANNEL_ID == "hyylt" or CHANNEL_ID == "hy.leteng" or CHANNEL_ID == "hyylt20070" or CHANNEL_ID == "hyylt20071" or CHANNEL_ID == "hyylt20072" or CHANNEL_ID == "hyylt20073" or CHANNEL_ID == "hyylt20074" or CHANNEL_ID == "hyylt20075" then
						DirectChannel.instance():call(
						{
							action = "pay",
							serverid = tostring( DATA_Session:get("server_id") ),
							exorderno = response["exorderno"],
							price = tostring(response["price"]),
						})
					elseif CHANNEL_ID == "hyqihoo" then
						san60SDK:getInstance():san60Pay(response["access_token"], response["qihoo_id"], tostring(response["price"] * 100), response["exorderno"], "火影小时代", CONFIG_PAY_URL .. "?from=hy_qihoo", DATA_User:get("name"), DATA_User:get("uid"))
					elseif CHANNEL_ID == "tgxyqihoo" then
						san60SDK:getInstance():san60Pay(response["access_token"], response["qihoo_id"], tostring(response["price"] * 100), response["exorderno"], "太古仙域", CONFIG_PAY_URL .. "?from=tgxy_360", DATA_User:get("name"), DATA_User:get("uid"))
					elseif CHANNEL_ID == "tmsjqihoo" then
						san60SDK:getInstance():san60Pay(response["access_token"], response["qihoo_id"], tostring(response["price"] * 100), response["exorderno"], "唐门世界", CONFIG_PAY_URL .. "?from=tmsj_360", DATA_User:get("name"), DATA_User:get("uid"))
					elseif CHANNEL_ID == "hy.uc" then
						ucSDK:getInstance():ucPay(tostring(response["price"]), CONFIG_PAY_URL .. "?from=hy_uc", "orderId=" .. response["exorderno"])
					elseif  CHANNEL_ID == "tgxy.uc" then 
						ucSDK:getInstance():ucPay(tostring(response["price"]), CONFIG_PAY_URL .. "?from=tgxy_uc", "orderId=" .. response["exorderno"])
					elseif  CHANNEL_ID == "tmsj.uc" then 
						ucSDK:getInstance():ucPay(tostring(response["price"]), CONFIG_PAY_URL .. "?from=tmsj_uc", "orderId=" .. response["exorderno"])
					elseif CHANNEL_ID == "hy.mi" or CHANNEL_ID == "tgxy.mi" or CHANNEL_ID == "tmsj.mi" then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							orderId = response["exorderno"],
						})

					elseif CHANNEL_ID == "hy.wan37" then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							orderId = response["exorderno"],
						})
					elseif CHANNEL_ID == "hy.xinmei" then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							orderId = response["exorderno"],
						})
					elseif CHANNEL_ID == "hy.wdj" or CHANNEL_ID == "tgxy.wdj" or CHANNEL_ID == "tmsj.wdj"  then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							order = response["exorderno"],
							game_name = gameNameConfig[CHANNEL_GROUP],
							desc = "黄金",
						})
					elseif CHANNEL_ID == "dhsh_hegame" then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							order = response["exorderno"],
							game_name = "火影小时代",
							desc = "黄金",
						})
					elseif CHANNEL_ID == "hy.changmeng" or CHANNEL_ID == "hy.changmeng1" or CHANNEL_ID == "hy.changmeng2" then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							order = response["exorderno"],
							game_name = "火影小时代",
							desc = "黄金",
						})
					elseif CHANNEL_ID == "hy.mzw" then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							order = response["exorderno"],
							game_name = "火影小时代",
							desc = "黄金",
						})
					elseif CHANNEL_ID == "hy.sougou" or CHANNEL_ID == "tgxy.sougou"  or CHANNEL_ID == "tmsj.sougou"  then
						DirectChannel.instance():call(
						{
							action = "pay",
							money = response["price"],
							order = response["exorderno"],
							desc = "黄金",
						})

					-----------------------------------------------------------------------------------------------------
					elseif CHANNEL_ID == "hy" then
						baiduSDK:getInstance():baiduPay(response["price"] * 100, response["exorderno"], CONFIG_PAY_URL .. "?from=hy_baidu", "")
					elseif CHANNEL_ID == "one.HUAWEI" then
						huaweiSDK:getInstance():huaweiPay(response["price"] .. ".00", response["exorderno"], CONFIG_PAY_URL .. "?from=huawei")
					elseif CHANNEL_ID == "tgxy.huawei" then
						huaweiSDK:getInstance():huaweiPay(response["price"] .. ".00", response["exorderno"], CONFIG_PAY_URL .. "?from=tgxy_huawei")
					elseif CHANNEL_GROUP == "td" then

						dump("---tdtdtd---")

						local KNLoading = requires(IMG_PATH,"GameLuaScript/Common/KNLoading")
						local loading = KNLoading:new()
						local scene = display.getRunningScene()
						scene:addChild( loading:getLayer() )
						dump(response["price"]*100)
						dump(response["exorderno"])
						dump(CONFIG_PAY_URL .. "?from=jstf")
						dump(response["exorderno"])
						--	
						if  _NEWAIBEI  then 
							dump("充值了+新的爱贝SDK")
							jstfSDK:getInstance():jstfPay(response["price"] * 100, response["exorderno"], CONFIG_PAY_URL .. "?from=jstf", response["exorderno"], "10", function()
								loading:remove()
							end)
						else
							dump("充值需要更新SDK了")
							if CHANNEL_ID=="jstf" then 
								local downUrl = "http://jstf.szkuniu.com"
								KNMsg.getInstance():boxShow( "爱贝云计费平台已升级,\"银联手机支付\"用户需跳转官网重新下载安装包才能正常充值!其余用户可忽略此步骤.您是否要跳转?" ,
									{
										cancelText = COMMONPATH .. "back.png" , 
										confirmFun = function() 
											dump("到官网中......")
											dump("downUrl"..downUrl)
											UpdataRes:getInstance():openUrl( downUrl )
									end , 
									cancelFun = function() 
										jstfSDK:getInstance():jstfPay(response["price"] * 100, response["exorderno"], CONFIG_PAY_URL .. "?from=jstf", response["exorderno"], "10", function()
											loading:remove()
										end)			
									end
									})
							end 
						end 
						dump("---tdtdtd---")

					elseif CHANNEL_ID == "uucun" then
						uucon:getInstance():uuconpay(response["exorderno"], "EFfizphjQohcE4FKXbKZqsETzXHYPnpF", "GZilGc", CONFIG_PAY_URL .. "?from=uucun", "", "10", "黄金", "黄金", "1", "1", response["time"])	
					else
						local pay_url = CONFIG_PAY_URL
						if CHANNEL_GROUP == "dhsh" or CHANNEL_ID == "hytest" then
							pay_url = CONFIG_PAY_URL .. "?from=iapppay2"
						elseif CHANNEL_GROUP == "tgxy"  or  CHANNEL_GROUP == "tgxy2" then
							pay_url = CONFIG_PAY_URL .. "?from=tgxy_iapppay"
						elseif CHANNEL_ID == "tmsjriver" then 
							pay_url = CONFIG_PAY_URL .. "?from=android_two"
						elseif CHANNEL_ID == "dhshriver" then 
							pay_url = CONFIG_PAY_URL .. "?from=android_one"
						end
						UpdataRes:getInstance():play( response["exorderno"] .. "" , (response["price"] * 100) .. "" , response["waresid"] .. "" , "1" , pay_url)   --android
					end
			    end
			end
		})
end

function PayItem:getLayer()
	return self.layer
end

--获取所有父组件，取得按钮的绝对位置
function PayItem:getRange()
	local x = self.layer:getPositionX()
	local y = self.layer:getPositionY()

	local parent = self.layer:getParent()
	if parent then
		x = x + parent:getPositionX()
		y = y + parent:getPositionY()
		while parent:getParent() do
			parent = parent:getParent()
			x = x + parent:getPositionX()
			y = y + parent:getPositionY()
		end
	end
	return CCRectMake(x,y,self.layer:getContentSize().width,self.layer:getContentSize().height)
end


return PayItem
