local PATH = IMG_PATH.."image/scene/pet/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBar = requires(IMG_PATH,"GameLuaScript/Common/KNBar")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local Config = requires(IMG_PATH,"GameLuaScript/Config/Pet")
local Config_Natural = requires(IMG_PATH , "GameLuaScript/Config/Petnatural")

--[[幻兽信息]]
local PetInfo = {
	layer,
	params
}

function PetInfo:new(layer_x , layer_y , width , height , params)
	local this = {}
	setmetatable(this,self)
	self.__index = self
	this.params = params or {}
	
	this.layer = display.newLayer()
	setAnchPos(this.layer , layer_x , layer_y )
	this.layer:setContentSize(CCSize:new(width,height))

	local petCard = KNBtn:new(IMG_PATH.."image/pet/", {"b_"..DATA_Bag:get("pet", params["id"],"cid")..".png"}, 0,-15, {
		parent = params.parent,
		upSelect = true,
		callback = function()	
			pushScene("detail" , {
				detail = "pet",
				id = params["id"],
			})
		end
	})

	local star = display.newSprite(COMMONPATH .. "star.png")
	setAnchPos(star , width - 50 , height - 100)


	this.layer:addChild(petCard:getLayer())
	this.layer:addChild(star)

	local pet_data = DATA_Bag:get("pet", params["id"])
	local cid = pet_data.cid
	local config_data = Config[cid]

	local function createPetPro(id)
		--英雄大于一
		local temp
		local y = height - 100 - star:getContentSize().height
		for i = 2, config_data["star"] do
			temp = display.newSprite(COMMONPATH .. "star.png")
			setAnchPos(temp, width - 50, y)
			this.layer:addChild(temp)
			y = y - star:getContentSize().height
		end
		
		local stage = pet_data.stage
		if stage > 0 then
			local img = display.newSprite(COMMONPATH .. "stage/" .. stage .. ".png")	
			setAnchPos(img, width - 50, y - 5)
			this.layer:addChild(img)
		end

		--姓名
		local name = CCLabelTTF:create( config_data.name , FONT , 24)
		name:setColor(DESCCOLOR)
		setAnchPos(name , 30 , 310)
		this.layer:addChild(name)

		if pet_data.xuetong_title and pet_data.xuetong_title ~= "无" then 
			local titlelabel =  display.strokeLabel( pet_data.xuetong_title .."·" , -40 , 0 , 24 , DESCCOLOR , 2 )
			setAnchPos( titlelabel , 0 , 0 , 1 , 0 )
			name:addChild( titlelabel )
			setAnchPos(name , 60 , 310)
		end

		-- 计算等级信息
		local lv , cur_exp , max_exp = DATA_Pet:calcExp(pet_data.exp)
		-- 等级
		local lvNode = display.strokeLabel( "Lv" .. lv , 150 , 310 , 22 ,DESCCOLOR )
		setAnchPos(lvNode , 230 , 310 , 1 , 0)
		this.layer:addChild( lvNode )

		-- 经验
		this.layer:addChild( KNBar:new("exp_general" , 35 , 555 , { maxValue = max_exp , curValue = cur_exp } ) )

		-- 攻击力
		local pet_lv_exp = getConfig("petlvexp" , tostring(lv))
		local atkValue = tonumber( pet_lv_exp["atk" .. config_data["star"]]  ) + tonumber( pet_data.atk_xd )

		local defValue = pet_data.xuetong_absolute_def or 0

		if pet_data.xuetong_absolute then 
			atkValue = atkValue + pet_data.xuetong_absolute
		end



		local str = "绝对伤害:" .. atkValue .. ( tonumber( DATA_User:getGangRank() ) == 1 and  ( "+" .. math.round( atkValue * tonumber( DATA_User:getAtkFactor() )/100 ) ) or "" )

		local defStr = "绝对防御:" .. defValue

		local atk_label = CCLabelTTF:create( str , FONT , 18)
		atk_label:setColor(ccc3( 0x2c , 0x00 , 0x00 ))
		setAnchPos(atk_label , 20 , 270)
		this.layer:addChild(atk_label)

		local def_label = CCLabelTTF:create( defStr , FONT , 18)
		def_label:setColor(ccc3( 0x2c , 0x00 , 0x00 ))
		setAnchPos(def_label ,  tonumber( DATA_User:getGangRank() ) == 1 and 180 or 150 , 270)
		this.layer:addChild(def_label)

		-- 刷技能按钮
		local bg = {"btn_bg_grey.png"}
		local front = PATH.."refresh_skill.png"
		-- 进化按钮
		if config_data.star >= 4 then
			bg = {"btn_bg.png", "btn_bg_pre.png"}
			front = PATH.."refresh_skill.png"
		end
		local refresh_btn = KNBtn:new(COMMONPATH , bg , 240 , 0 , {
			front = front,
			parent = params.parent,
			callback = function()
				if config_data.star < 4 then
					KNMsg.getInstance():flashShow("四星及以上幻兽才可以刷新技能")
					return
				end
				HTTP:call("pet", "get_skill", {}, {
					success_callback = function(data)
						if data.pet_id == 0 then
							switchScene("refreshpetskill" , {id = params["id"], config = data.fee_config})
						else
							if params["id"] ~= data.pet_id then
								KNMsg.getInstance():flashShow("您的幻兽"..getConfig("pet", DATA_Bag:get("pet", data.pet_id, "cid"), "name").."刷新的技能未保存，请先保存新技能")
							else
								switchScene("refreshpetskill" , {id = params["id"], data = data, config = data.fee_config})
							end
						end
					end
				})
				return false
			end
		})
		this.layer:addChild(refresh_btn:getLayer())
		--幻兽传功
		local chuan_btn = KNBtn:new(COMMONPATH , {"btn_bg.png", "btn_bg_pre.png"} , 240 , 50 , {
			front = COMMONPATH.."chuangong.png",
			parent = params.parent,
			callback = function()
				local curHeroData = DATA_Bag:get( "pet" , params["id"] ) 
				switchScene("petByExp",{source = curHeroData,backtype="pet"})
			end
		})
		this.layer:addChild(chuan_btn:getLayer())


		--幻兽血统入口
		if pet_data.lv >= 120 and config_data.star >= 4 then 
			local petBloodBtn = KNBtn:new(IMG_PATH .. "image/scene/petBlood/" , {"petBloodIcon.png", "petBloodIcon_pre.png"} , 0 , -10 , {
				parent = params.parent,
				callback = function()
					HTTP:call("pet", "xuetong", { id = pet_data.id  }, {
						success_callback = function(data)
							dump(data , "data")
							switchScene("petBlood",{ bloodData = data , pet_data = pet_data , closeCallback = function() switchScene("pet") end })
						end
					})
				end
			})
			this.layer:addChild(petBloodBtn:getLayer())
		end

	end

	if params["id"] then
		createPetPro(params["id"])
	end

	return this
end

function PetInfo:getLayer()
	return self.layer
end

function PetInfo:getid()
	return self.params["id"]
end

function PetInfo:getRange()

	return CCRectMake(15 , 300 , 310 , 230)
end
return PetInfo
