--[[

		幻兽血统界面

]]

local PATH = IMG_PATH .. "image/scene/petBlood/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local KNBar = requires(IMG_PATH, "GameLuaScript/Common/KNBar")
-- local lmtext = requires(IMG_PATH, "GameLuaScript/Config/lmtext")
local Config = requires(IMG_PATH,"GameLuaScript/Config/Pet")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local M = {
}

local pet_data , cid , config_data , petBlood_config

function M:new( params )
	-- dump(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	this.params = params or {}


	pet_data = params.pet_data or {}
	cid = pet_data.cid
	config_data = Config[cid]

	this.baseLayer = display.newLayer()

	this.layer = display.newLayer()

	this.baseLayer:addChild( this.layer )

	this:setInfoLayer()

	this:createHome()
	
	return this.baseLayer
end


function M:createHome()

	if self.viewLayer then 
		self.viewLayer:removeSelf()
	end

	self:setInfoLayer()

	self.viewLayer = display.newLayer()
	self.layer:addChild( self.viewLayer )

	pet_data = DATA_Bag:get("pet", pet_data["id"])
	local bloodData = self.params.bloodData or {}
	
	self.viewLayer:addChild(display.newSprite(COMMONPATH .. "bg_big.png" , display.cx , 108 , 0.5, 0  ))
	self.viewLayer:addChild(display.newSprite(PATH .. "petInfo_bg.png" , display.cx , 338 , 0.5, 0  ))

	local name_label = display.strokeLabel( config_data["name"] , 65 , 680 , 24 ,DESCCOLOR )
	self.viewLayer:addChild(name_label)

	if pet_data.xuetong_title and pet_data.xuetong_title ~= "无" then 
		local titlelabel =  display.strokeLabel( pet_data.xuetong_title .."·" , -40 , 0 , 24 , DESCCOLOR , 2 )
		setAnchPos( titlelabel , 0 , 0 , 1 , 0 )
		name_label:getLabel():addChild( titlelabel )
		setAnchPos(name_label , 95 , 680)
	end

	local lv_label = display.strokeLabel( "Lv" .. pet_data["lv"] , 230 , 680 , 18 , DESCCOLOR )
	self.viewLayer:addChild(lv_label)

	local lv , cur_exp , max_exp = DATA_Pet:calcExp(pet_data.exp or 0)

	local exp_bar = KNBar:new("exp_general" , 62 , 185 , {
		maxValue = max_exp,
		curValue = cur_exp,
	})
	exp_bar:setIsShowText(false)
	self.viewLayer:addChild(exp_bar)


	local function createAtrBar(str)
		local layer = display.newLayer()

		local atr_bg = display.newSprite( IMG_PATH .. "image/scene/newguy/title_bg.png" , 0 , 0 , 0 , 0 )
		local size = atr_bg:getContentSize()

		layer:setContentSize( size )

		layer:addChild(atr_bg)
		

		local absolute_atk = display.newSprite( PATH .."absolute_atk.png" , 51 , size.height/2 , 0 , 0.5 )
		local absolute_def = display.newSprite( PATH .."absolute_def.png" , 258 , size.height/2 , 0 , 0.5 )

		layer:addChild( absolute_atk )		--绝对攻击
		layer:addChild( absolute_def )		--绝对防御

		local atk = (str == "lv") and bloodData.xuetong_lvhurt or bloodData.xuetong_titlehurt
		local def = (str == "lv") and bloodData.xuetong_lvdefense or bloodData.xuetong_titledefense

		absolute_atk:addChild( display.strokeLabel( "+" .. atk  , 84 , 5 , 16 , ccc3(43 , 26 , 16 ) , 2 ) )
		absolute_def:addChild( display.strokeLabel( "+" .. def , 84 , 5 , 16 , ccc3(43 , 26 , 16 ) , 2 ) )

		return layer
	end


	local petCard = KNBtn:new(IMG_PATH.."image/pet/", {"b_"..cid..".png"}, display.cx,514, {
		anchMid = true,
		callback = function()	
			pushScene("detail" , {
				detail = "pet",
				id = pet_data["id"],
			})
		end
	})
	self.viewLayer:addChild( petCard:getLayer() )

	local x , y = 401 , 654

	local star = display.newSprite(COMMONPATH .. "star.png")
	setAnchPos(star , x , y)
	self.viewLayer:addChild(star)

	

	y = y - star:getContentSize().height
	for i = 2, config_data["star"] do
		star = display.newSprite(COMMONPATH .. "star.png")
		setAnchPos(star, x, y)
		self.viewLayer:addChild(star)
		y = y - star:getContentSize().height
	end

	local stage = pet_data.stage
	if stage > 0 then
		local img = display.newSprite(COMMONPATH .. "stage/" .. stage .. ".png")	
		setAnchPos(img, x, y - 5)
		self.viewLayer:addChild(img)
	end


	for i=1,2 do
		local atrLabel = createAtrBar( i==1 and "lv" or "title" )
		setAnchPos( atrLabel , 0 , i==1 and 194 or 110 )
		self.viewLayer:addChild( atrLabel )
	end

	self.viewLayer:addChild( KNBar:new("petBlood" , 78 , 565 , { maxValue = bloodData.xuetong_lv_exp , curValue = bloodData.xuetong_cur_exp } ) )

	local upBtn = KNBtn:new( PATH , {"up.png", "up_pre.png"} , 328 , 244 , {
		callback = function()

			HTTP:call("pet", "xuetong_upgrade_page", {}, {
				success_callback = function(data)
					-- dump(data , "data")
					petBlood_config = data.xuetong_config or {}
					feed_config = data.petexp_config or {}
					self:changeConfig()
					self:giftUpgrade()
				end
			})
			
		end
	})
	self.viewLayer:addChild(upBtn:getLayer())

	
	self.viewLayer:addChild( display.newSprite( PATH .."bloodTitle.png" , 144 , 368 , 0 , 0 ) )
	self.viewLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/gang/tech/lv.png" , 117 , 305 , 0 , 0 ) )			
	self.viewLayer:addChild( display.newSprite( PATH .."petBloodLabel.png" , 55 , 305 , 0 , 0 ) )							--血统称号
	self.viewLayer:addChild( display.newSprite( PATH .."curTitle.png" , 55 , 169 , 0 , 0 ) )							--称号加成


	local boold_hint = display.strokeLabel( bloodData.xuetong_hint or "" , 105 , 347 , 14 , ccc3(215 , 50 , 22 ) )
	setAnchPos( boold_hint , display.cx , 347 , 0.5 , 0 )
	self.viewLayer:addChild( boold_hint )

	-- if bloodData.xuetong_title ~= "无" then 
		self.viewLayer:addChild( display.strokeLabel( bloodData.xuetong_title , 234 , 370 , 18 , ccc3(43 , 26 , 16 ) ) )
		-- self.viewLayer:addChild( display.strokeLabel( bloodData.xuetong_title , 167 , 174 , 18 , ccc3(43 , 26 , 16 ) ) )	
	-- end						

	self.viewLayer:addChild( display.strokeLabel( bloodData.xuetong_lv , 151 , 305 , 20 , ccc3(43 , 26 , 16 ) ) )	


end

function M:giftUpgrade()

	if self.viewLayer then 
		self.viewLayer:removeSelf()
	end

	self:setInfoLayer({
		title 			=PATH.. "giftUpgrade_title.png" , 
		closeCallback 	= function() 
			self:createHome()
		end })

	self.viewLayer = display.newLayer()
	self.layer:addChild( self.viewLayer )

	local bloodData = self.params.bloodData or {}

	self.viewLayer:addChild( display.newSprite(IMG_PATH.."image/common/dark_bg.png" , 0 , 86 , 0 ,0) )
	self.viewLayer:addChild( display.newSprite(IMG_PATH.."image/scene/mosaic/ston_bg.png" , 17 , 110 , 0 , 0) )

	local atk_label , def_label , expBar , lvLabel , curPage , createList

	local layers, btns = {} , {}
	local count 
	local row , column = 4 , 3
	local curPageNum = 1
	local selectItems = {}

	local totalexp = bloodData.xuetong_totalexp or 0

	atk_label = display.strokeLabel( "绝对攻击+" .. bloodData.xuetong_lvhurt , 177 , 627 , 15 , ccc3(173 , 30 , 16 ) , 2 )
	self.viewLayer:addChild( atk_label )

	def_label = display.strokeLabel( "绝对防御+" .. bloodData.xuetong_lvdefense , 177 , 607 , 15 , ccc3(173 , 30 , 16 ) , 2 )
	self.viewLayer:addChild( def_label )

	lvLabel = display.strokeLabel("Lv " .. bloodData.xuetong_lv , 60 , 557 , 16 , ccc3(42 , 0 , 0 ) , 2 )
	self.viewLayer:addChild( lvLabel )

	expBar = KNBar:new("exp" ,  110 , 290 , { maxValue = bloodData.xuetong_lv_exp , curValue = bloodData.xuetong_cur_exp })
	self.viewLayer:addChild( expBar )

	self.viewLayer:addChild( display.strokeLabel( bloodData.xuetong_lv or "" , 272 , 649 , 20 , ccc3(43 , 26 , 16 ) ) )

	local function petBtnAction(action , param)
		if action == "select" then 

			selectItems[param.id..""] = param.star
			totalexp = totalexp + self:getFeedExpWithStar(param.star)

		elseif action == "cancel" then 
			selectItems[param.id..""] = nil
			totalexp = totalexp - self:getFeedExpWithStar(param.star)
		end

		local level , next_level_max_exp , current_exp = self:getLvWithExp(totalexp)

		expBar:setMaxValue( next_level_max_exp )
		expBar:setCurValue( current_exp )

		lvLabel:setString( "Lv " .. level )

	end

	--升级按钮
	local upgrade_btn = KNBtn:new(IMG_PATH .. "image/common" , {"btn_bg_red.png","btn_bg_red_pre.png"} , 275,120 , {
			front = IMG_PATH.."image/scene/mosaic/font_updata1.png",
			priority = -202,
			callback = function()

				if table.nums(selectItems) == 0 then 
					KNMsg:getInstance():flashShow("请选择幻兽")
					return false
				end

				local post_data = {}
				local ids = ""

				for k,v in pairs(selectItems) do
					ids = ids .. "," .. k
				end

				ids = string.sub( ids , 2)

				HTTP:call("pet", "xuetong_upgrade", { id = pet_data["id"] , ids = ids }, {
					success_callback = function(data)
						-- dump(data , "data")

						KNMsg:getInstance():flashShow(data.msg or "")

						self.params.bloodData = data
						self:giftUpgrade()
					end
				})

			end
		})
	self.viewLayer:addChild(upgrade_btn:getLayer())
		
	--取消按钮
	local cancelBtn = KNBtn:new(IMG_PATH .. "image/common" , {"btn_bg_red.png","btn_bg_red_pre.png"} , 60,120 , {
		front = IMG_PATH.."image/common/cancel.png",
		priority = -202,
		callback = function()	

			for k,v in pairs(selectItems) do
				petBtnAction( "cancel" , { id = k , star = v } )
			end
			selectItems = {}
			createList()
		end
	})
	self.viewLayer:addChild(cancelBtn:getLayer())

	self.viewLayer:addChild( display.newSprite( PATH .."gift.png" , 177 , 648 , 0 , 0) )
	self.viewLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/gang/tech/lv.png" , 237 , 648 , 0 , 0 ) )

	local icon = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 102, 605, {
		front = getImageByType(cid, "s"),
		callback = function()
			
		end
	})
	self.viewLayer:addChild( icon:getLayer() )

	local pet_bag = DATA_Bag:getTable("pet")
	pet_bag[pet_data.id..""] = nil


	if DATA_Pet:getFighting() then 
		pet_bag[DATA_Pet:getFighting()..""] = nil
	end

	local pet_list = {}
	for k,v in pairs( pet_bag ) do
		pet_list[#pet_list+1] = v 
	end

	local function sortRule(a,b)

		local aStar = Config[a.cid].star
		local bStar = Config[b.cid].star

		if aStar == bStar then 
			return a.lv < b.lv
		else
			return aStar < bStar
		end

	end

	table.sort( pet_list , sortRule )

	--全选按钮
	local allBtn = KNBtn:new(IMG_PATH .. "image/common" , {"btn_bg.png","btn_bg_pre.png"} , 372,548 , {
		front = IMG_PATH.."image/scene/mosaic/all.png",
		priority = -202,
		callback = function()	
			if totalexp >= self:getMaxExpOfPetBlood() then
				KNMsg:getInstance():flashShow("血统等级已达到上限")
				return
			end
			
			local max = #btns - 12 * curPageNum
			if max > 0 then
				max = curPageNum * 12
			else
				max = (curPageNum - 1) * 12 + (max + 12)
			end
			
			local action = "cancelAll"

			for i = (curPageNum - 1) * 12 + 1 , max do
				if not btns[i]:isSelect() then 
					action = "selectAll"
				end
			end

			for i = (curPageNum - 1) * 12 + 1 , max do
				local isFull = btns[i]:getCallback()( {action=action} )

				if isFull == "full" then 
					btns[i]:select(false)
				else
					btns[i]:select( action == "selectAll" and true or false )
				end
			end
		end
	})
	self.viewLayer:addChild(allBtn:getLayer())

	

	createList = function()
		layers = {}
		count = 0
		local temp_count = 0
		local temp_line = 1
		for k,v in ipairs(pet_list) do
			count = count + 1
			temp_count = temp_count + 1
			
			local star = Config[v.cid].star or 1
			local id = v["id"]

			if count > (curPageNum - 1) * 12 and count <= curPageNum * 12 then
				if layers[ temp_line ] == nil then
					layers[ temp_line ] = display.newLayer()
					layers[ temp_line ]:setContentSize( CCSizeMake(480 , 80) )
				end
				
				local petBtn 
				petBtn = KNBtn:new(IMG_PATH.."image/scene/common" , {"skill_frame1.png","yes.png"} , 50 + 90 * (temp_count - 1),0 , {
					front = getImageByType(v["cid"] , "s"),
					other = {{IMG_PATH .. "image/common/egg_num_bg.png",46,46}},
					text = {v["lv"] or 1,18,ccc3(0xff,0xff,0xff),ccp(23,24),nil,17},
					--scale = true,
					noHide = true,
					id = v["id"],
					selectable = true,
					selectZOrder = 20,
					selectOffset = {17,-16},
					callback = function(param)
					
						if param and param.action == "selectAll" then
							if petBtn:isSelect() then
								return false
							end

							if totalexp >= self:getMaxExpOfPetBlood() then 
								return "full"
							end

							petBtnAction("select" , { id = id , star = star })
							return 

						elseif param and param.action == "cancelAll" then 
							if not petBtn:isSelect() then
								return false
							end
							petBtnAction("cancel" , { id = id , star = star })
							return 
						end 

						

						if petBtn:isSelect() == true then
							petBtnAction("cancel" , { id = id , star = star })
						else
							if totalexp >= self:getMaxExpOfPetBlood() then 
								KNMsg:getInstance():flashShow("血统等级已达到上限")
								return false
							end

							petBtnAction("select" , { id = id , star = star })
						end
					end
				})
				
				local nums = { "一" , "二" , "三" , "四" , "五"  }
				petBtn:getLayer():addChild( display.strokeLabel( nums[star] .."星" , 20 , -23 , 18 , ccc3(43 , 0 , 1 ) , 2 ) )

				layers[ temp_line ]:addChild(petBtn:getLayer())
				
				btns[count] = petBtn
				
				if selectItems[petBtn:getId()..""] then
					petBtn:select(true)
				end
				
				if temp_count == 4 then
					temp_line = temp_line + 1
					temp_count = 0
				end
			else
				layers[ temp_line ] = 0
				btns[count] = 0
				if temp_count == 4 then
					temp_line = temp_line + 1
					temp_count = 0
				end
			end
		end
		
		if curPage then
			self.viewLayer:removeChild(curPage, true)
		end
		curPage = display.newLayer()
		
		local max = #layers - curPageNum * 3
		if max > 0 then
			max = curPageNum * 3
		else
			max = (curPageNum - 1) * 3 + (max + 3)
		end
		
		local pageSize = createLabel({str = curPageNum.."/"..math.ceil(#layers / 3), size = 20, color = ccc3(43,0,0)})
		setAnchPos(pageSize, 240, 170, 0.5)
		curPage:addChild(pageSize)

		for i = (curPageNum - 1) * 3 + 1 , max do
			setAnchPos(layers[i], 20, 570 - (i - (curPageNum - 1) * 3) * 105)
			curPage:addChild( layers[i], 10 )
		end
		
		self.viewLayer:addChild(curPage)
	end
	
	createList()
	
	local preBtn = KNBtn:new(IMG_PATH.."image/scene/gang", {"next.png"}, 25, 365, {
		flipX = true,
		callback = function()
			if curPageNum > 1 then
				curPageNum = curPageNum - 1
				createList()
			else
				KNMsg.getInstance():flashShow("已达首页")
			end
		end
		
	})
	self.viewLayer:addChild(preBtn:getLayer())
	
	local nextBtn = KNBtn:new(IMG_PATH.."image/scene/gang", {"next.png"}, 425, 365, {
		callback = function()
			if curPageNum < #layers / 3 then
				curPageNum = curPageNum + 1
				createList()
			else
				KNMsg.getInstance():flashShow("已达最后一页")
			end
		end
	})
	self.viewLayer:addChild(nextBtn:getLayer())


end

function M:getFeedExpWithStar(star)
	return feed_config[star..""]["exp"]
end

function M:getLvWithExp(exp)
	--经验不能超过最大经验值，如果超过了，直接变成最大经验值
	local level = 1
	local max_lv = table.nums(petBlood_config)

	local max_exp = petBlood_config[""..max_lv]["lvexp"]
	local current_exp , next_level_exp
	exp = tonumber(exp) > tonumber(max_exp) and max_exp or tonumber(exp)
	exp = tonumber(exp) < 0 and 0 or tonumber(exp)
	--计算当前等级
	if exp == max_exp then
		level = max_lv
	else
		local front = 1
		local tail = table.nums(petBlood_config)
		local mid = math.floor( (front + tail) / 2 )
		local count = 0
		while true do
			if exp >= petBlood_config[mid..""]["lvexp"]  and exp < petBlood_config[(mid+1)..""]["lvexp"]  then
				level = mid
				break
			end
			if petBlood_config[mid..""]["lvexp"]  > exp then 
				tail = mid
			end
			if petBlood_config[mid..""]["lvexp"]  < exp then 
				front = mid
			end
			mid = math.floor( (front + tail) / 2 )
			count = count + 1
			if count > max_lv then 
				break
			end
		end
	end

	--这一级到下一级所需要的经验
	if level == 1 then 
		next_level_exp = petBlood_config["2"]["lvexp"] 
		current_exp = exp
	else
		next_level_exp = petBlood_config[(level+1)..""] ~= nil and (petBlood_config[(level+1)..""]["lvexp"] - petBlood_config[(level)..""]["lvexp"] ) or 0
		current_exp = exp - petBlood_config[level..""]["lvexp"] 
	end
	return level , next_level_exp , current_exp 

end

function M:getMaxExpOfPetBlood()

	local len = table.nums(petBlood_config)

	 return petBlood_config[len..""]["lvexp"]
end

--设置 InfoLayer 的 title 和 close回调
function M:setInfoLayer(data)
	local param  = data or {}

	if not param.title then 
		param.title = PATH .. "petBlood_title.png"
	end

	if not param.closeCallback then 
		param.closeCallback = function() switchScene("pet") end
	end

	if self.infoLayer then 
		self.infoLayer:refreshTitle(param.title)
		self.infoLayer.params.closeCallback = param.closeCallback
	else
		self.infoLayer = InfoLayer:new("petBlood" , 0, {tail_hide = true, title_text =  param.title , closeCallback = param.closeCallback})
		self.baseLayer:addChild( self.infoLayer:getLayer() , 10 )
	end


end

function M:changeConfig()

	local len = table.nums(petBlood_config)

	for i = 1 , len do
		local allExp = 0

		if i < len then 
			for j=1,len-i do
				allExp = allExp + petBlood_config[j..""]["lvexp"]
			end
		end
		petBlood_config[(len-i+1)..""]["lvexp"] = allExp		
	end
end



return M
