--掠夺主界面

local M = {}

local PATH = IMG_PATH .. "image/scene/plunder/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	--初始化数据
   -- dump(args)
	local receiveDate = args['data'] or {}  --5个帮派数据
	local roomData = args['roomData'] or {}  --牢房数据

	-- 基础层
	this.baseLayer = display.newLayer()
	local index = 1  --帮派级别
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )
	
	local listLayer 
	--tab标签
	local group = KNRadioGroup:new()
		for i = 1 , 3 do  --1~3级顶部标签
			local tempBtn = KNBtn:new( PATH ,{"tab_unselect.png","tab_select.png"} , 10+(i-1)*90 , 692,{
						    priority = -128,
							disableWhenChoose = true,
							upSelect = true,
							id = i,
							front = {PATH .. i .."grade_unselect.png",PATH.. i .."grade_select.png"},
							callback=
							function()
								HTTP:call("alliancerob", "battlefield", {lv=i} , {success_callback = 
									function(data)	
										
										if listLayer then
											listLayer:removeFromParentAndCleanup(true)
										end
										index=i
										listLayer= this:createBangListWithGradeIndex(index,data,roomData)
									    this.baseLayer:addChild(listLayer)
								end})
							end
						},group):getLayer()
						
			this.baseLayer:addChild( tempBtn )
		end	
    --分割线
	local lineSp = display.newSprite(COMMONPATH .. "tab_line.png")
	setAnchPos(lineSp,5,690)
	this.baseLayer:addChild( lineSp )
    

	listLayer= this:createBangListWithGradeIndex(1,receiveDate,roomData)
	this.baseLayer:addChild(listLayer)
	
	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "plunder" , 0 , { title_text = PATH.."plunderTitle.png", tail_hide = true, closeCallback = function()
		switchScene("gang")
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )	


    --换一批按钮
	local changeBatch_btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 160 , 125 , {
					priority = -128,
					scale = true,
					front = PATH .. "change.png",
					callback = function()
							HTTP:call("alliancerob", "battlefield", {lv=index} , {success_callback = 
									function(data)	
										if listLayer then
											listLayer:removeFromParentAndCleanup(true)
										end
										listLayer= this:createBangListWithGradeIndex(index,data,roomData)
									    this.baseLayer:addChild(listLayer)
								end})
					end
			})
 			this.baseLayer:addChild(changeBatch_btn:getLayer())


   local tips_label = display.strokeLabel(replaceStr("说明:点击帮会城堡可查看帮会详情") , 120 , 105 , 16 , ccc3( 111 , 210 , 255) )
   this.baseLayer:addChild(tips_label)

	
	return this.baseLayer 
end

--选取一批帮会,5个,gradeIndex=帮派级别,data=5个帮会数据,roomData=牢房数据
function M:createBangListWithGradeIndex( gradeIndex ,data ,roomData)

	

	local tempLayer=display.newLayer()
	tempLayer:setContentSize(CCSizeMake(468,510))
	setAnchPos(tempLayer,5,170)

	if #data['list'] == 0 then
		local emptySP = display.newSprite(COMMONPATH .."empty.png") --空图标
		setAnchPos(emptySP, 110,180)
		tempLayer:addChild(emptySP)
		return tempLayer
	end

	local shengyuZDLSP = display.newSprite(PATH.."SYZhengDouLin.png")
	setAnchPos(shengyuZDLSP,5,485)
	tempLayer:addChild(shengyuZDLSP)

	local lingNum_label = display.strokeLabel(data['ling'], 120 , 105 , 18 , ccc3( 255 , 255 , 200) )
	setAnchPos(lingNum_label,150,490)
   	tempLayer:addChild(lingNum_label)

	local bangShuoMing --帮派等级说明
   	if gradeIndex==1 then
   		bangShuoMing=display.strokeLabel("1-2级帮派", 120 , 105 , 18 , ccc3( 255 , 255 , 200) )
   	elseif gradeIndex==2 then
   		bangShuoMing=display.strokeLabel("3-4级帮派", 120 , 105 , 18 , ccc3( 255 , 255 , 200) )
   	elseif gradeIndex==3 then
   		bangShuoMing=display.strokeLabel("5级和5级以上帮派", 120 , 105 , 18 , ccc3( 255 , 255 , 200) )
   	end
   	bangShuoMing:setAnchPos(ccp(1.0,0.5))
	setAnchPos(bangShuoMing,450,500)
   	tempLayer:addChild(bangShuoMing)

	local function start(i)
		HTTP:call("alliance","getallianceinfo",{ id = data['list'][i]['id'] },{success_callback = 
			function(resultData)
				local detailLayer= self:showBangDetail( resultData , roomData)
				self.baseLayer:addChild(detailLayer:getLayer())
			end})
			
			
	end
	
   	local  detailLayer
	--第一个帮会
	if data['list'][1] then
		local bangSp1 = KNBtn:new(PATH, {"bangBuilding.png"}, 10 , 350 , {
						priority = -128,
						scale = true,
						callback = function()
							start(1)				
						end
				})
	 	tempLayer:addChild(bangSp1:getLayer())
		
		local bangTxtSp1 = display.newSprite(PATH.."bangHui.png")
		bangTxtSp1:setPosition(25,-3)
		bangSp1:getLayer():addChild(bangTxtSp1)

		local bangName_label1 = display.strokeLabel(data['list'][1]['name'] , 50 , -13 , 18 , ccc3( 255 , 255 , 200) )
		bangSp1:getLayer():addChild(bangName_label1)
	end

    
    --第二个帮会
    if data['list'][2] then
		local bangSp2 = KNBtn:new(PATH, {"bangBuilding.png"}, 290 , 350 , {
						priority = -128,
						scale = true,
						callback = function()
							start(2)				
						end
				})
	 	tempLayer:addChild(bangSp2:getLayer())
		
		local bangTxtSp2 = display.newSprite(PATH.."bangHui.png")
		bangTxtSp2:setPosition(25,-3)
		bangSp2:getLayer():addChild(bangTxtSp2)

		local bangName_label2 = display.strokeLabel(data['list'][2]['name'] , 50 , -13 , 18 , ccc3( 255 , 255 , 200) )
		bangSp2:getLayer():addChild(bangName_label2)
	end

	 --第三个帮会
	if data['list'][3] then
		local bangSp3 = KNBtn:new(PATH, {"bangBuilding.png"}, 160 , 190 , {
						priority = -128,
						scale = true,
						callback = function()
							start(3)				
						end
				})
	 	tempLayer:addChild(bangSp3:getLayer())

		local bangTxtSp3 = display.newSprite(PATH.."bangHui.png")
		bangTxtSp3:setPosition(25,-3)
		bangSp3:getLayer():addChild(bangTxtSp3)

		local bangName_label3 = display.strokeLabel(data['list'][3]['name'] , 50 , -13 , 18 , ccc3( 255 , 255 , 200) )
		bangSp3:getLayer():addChild(bangName_label3)
	end

	--第四个帮会
	if data['list'][4] then
		local bangSp4 = KNBtn:new(PATH, {"bangBuilding.png"}, 10 , 50 , {
						priority = -128,
						scale = true,
						callback = function()
							start(4)				
						end
				})
	 	tempLayer:addChild(bangSp4:getLayer())
		
		local bangTxtSp4 = display.newSprite(PATH.."bangHui.png")
		bangTxtSp4:setPosition(25,-3)
		bangSp4:getLayer():addChild(bangTxtSp4)

		local bangName_label4 = display.strokeLabel(data['list'][4]['name'] , 50 , -13 , 18 , ccc3( 255 , 255 , 200) )
		bangSp4:getLayer():addChild(bangName_label4)
	end

	--第五个帮会
	if data['list'][5] then
		local bangSp5 = KNBtn:new(PATH, {"bangBuilding.png"}, 290 , 50 , {
						priority = -128,
						scale = true,
						callback = function()
							start(5)				
						end
				})
	 	tempLayer:addChild(bangSp5:getLayer())
		
		local bangTxtSp5 = display.newSprite(PATH.."bangHui.png")
		bangTxtSp5:setPosition(25,-3)
		bangSp5:getLayer():addChild(bangTxtSp5)

		local bangName_label5 = display.strokeLabel(data['list'][5]['name'] , 50 , -13 , 18 , ccc3( 255 , 255 , 200) )
		bangSp5:getLayer():addChild(bangName_label5)
	end
	

    return tempLayer
end

--显示帮会详情
function  M:showBangDetail( bangDetailData ,roomData)
	
	--dump(roomData)
	local mask
	--local detailLayer =CCLayerColor:create( ccc4(152 , 255 , 255 , 100) )   --帮会详情
	local detailLayer =display.newLayer()
	setAnchPos(detailLayer,0,0,0.5,0.5)
	--detailLayer:setScale(0)

	--背景
	local bg = display.newSprite(COMMONPATH.."bg_img.png")
	setAnchPos(bg,25,200)
	detailLayer:addChild(bg)

	--标题背景
 	local title_bgSp = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
 	setAnchPos(title_bgSp,80,360)
 	bg:addChild(title_bgSp)

	--标题文字
 	local title_Sp = display.newSprite(IMG_PATH.."image/scene/gang/gang_info.png")
 	setAnchPos(title_Sp,80,360)
 	bg:addChild(title_Sp)

	--分栏
	local fenlanSp = display.newSprite(IMG_PATH .. "image/scene/gang/info_bg.png")
	setAnchPos(fenlanSp,0,100)
	bg:addChild(fenlanSp)
	--详情表头文字
	local bangDetailSp = display.newSprite(PATH.."bangDetail.png")
	setAnchPos(bangDetailSp,105,103)
	bg:addChild(bangDetailSp)

	local bangName = display.strokeLabel( bangDetailData['list']['name'] , 180 , 280 , 18 , ccc3( 32 , 0 , 3) )
    bg:addChild(bangName)

    local zijin = display.strokeLabel( bangDetailData['list']['funds'] , 180 , 230 , 18 , ccc3( 32 , 0 , 3) )
    bg:addChild(zijin)

    local chengyuan = display.strokeLabel( bangDetailData['list']['count'] .." / "..bangDetailData['list']['count_max'] , 180 , 190 , 18 , ccc3( 32 , 0 , 3) )
    bg:addChild(chengyuan)

    local zhanli = display.strokeLabel( bangDetailData['list']['sum_ability'] , 180 , 145 , 18 , ccc3( 32 , 0 , 3) )
    bg:addChild(zhanli)

    local zhufang = display.strokeLabel( bangDetailData['list']['zhufang'].." / "..bangDetailData['list']['zhufang_max'], 180 , 105 , 18 , ccc3( 32 , 0 , 3) )
    bg:addChild(zhufang)
	
 	--掠夺按钮
    local plunderBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 140 , 35 , {
			priority = -131,
			scale = true,
			front = PATH .. "plunder.png",
			callback = function()

				local function http_func()
					HTTP:call("lueduo", "start", {room = roomData['war'], alliance = bangDetailData['list']['id']}, {
								success_callback = function(data)
								HTTP:call("lueduo", "enter", {}, {success_callback = function(data)
									data["summary"]["mapId"] = 2
									data["summary"]["limit_time"] =data["limit_time"] 
									switchScene("war", data["summary"])	
								end})
							end})
				end


				local max_funds = DATA_Gang:get("list").max_funds
				local funds = DATA_Gang:get("list").funds

				if max_funds and funds and tonumber(max_funds) <= tonumber(funds) then
					-- KNMsg:getInstance():flashShow("本帮资金已达到上限，掠夺完成后无法增加资金")
					showTip({
						priority = -202,
							content = createLabel({str ="本帮资金已达到上限，掠夺完成后无法增加资金", width = 300, size = 20}),
							left={
	 					remove= true,
	     				removeCallback = function()
	     					
	     					http_func()

						end},
							right={
						remove = true,
					callback = function()
					end}
	  			  })
				else
					http_func()
				end

				
			end})
	 bg:addChild(plunderBtn:getLayer())

	--关闭按钮
    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png"}, 20 , 340 , {
			priority = -131,
			scale = true,
			callback = function()
				mask:remove()
			end})
	 bg:addChild(close:getLayer())
	 
	 mask = KNMask:new({item = detailLayer, click = function(x, y)  end})
    return mask
end


return M