--[[ showTip弹框调用示例
	showTip({
		title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
		title_text = PATH.."detail_title.png",
		right = {
					 path = COMMONPATH, 
					 normal = "btn_bg_red.png", 
					 pre = "btn_bg_red_pre.png"
				  },
				  left = {
					 path = COMMONPATH, 
					 normal = "btn_bg_red.png", 
					 pre = "btn_bg_red_pre.png"
				  }		
		})
	end
]]		

local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH, "GameLuaScript/Common/KNRadioGroup")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local PATH = IMG_PATH.."image/scene/power/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")

local TREE, WORLD = 1, 2

local PowerLayer = {
	baseLayer,
	contentLayer,
	layer,
	state,
	isPvp   --是否从pvp入口进入
}

function PowerLayer:new(params)
	local this = {}
	setmetatable(this,self)
	self.__index = self
	
	this.baseLayer = display.newLayer()
	this.isPvp = params.pvp
	if this.isPvp then
		params = params.data
	end
	if params.fight then  --是否是从战斗跳转的
		if params.data.get.cur_point > 0 then
			this:createWar(params.data.get.cur_map, params.data.map_info)
		else
			this:createWorldMap(params.data.get)
		end
	else
	
		if params.worldMap then
			this:createWorldMap(params)
		elseif params.war then
			this:createWar(tonumber(params.cur_map),params)
		else
			--创建世界权力地图
			this:createTree(params)
		end
	end
--	this:createWorldMap()
	
	return this
end

function PowerLayer:createContent()
	if self.contentLayer then
		self.baseLayer:removeChild(self.contentLayer, true)
	end
	
	self.contentLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite(COMMONPATH .. "dark_bg.png")
	setAnchPos(bg , 240 , 425, 0.5, 0.5)						-- 70 是底部公用导航栏的高度
	self.contentLayer:addChild(bg)
	
	--导航信息
	local info = InfoLayer:new("power" , 0 , {tail_hide = true , title_text = PATH .. "power_title.png", closeCallback = function()
		if self.state == TREE then
			if self.isPvp then
				switchScene("pvp", {coming = "power"})
			else
				switchScene("gang")
			end
		else
			self:createTree()
		end
	end})
	self.contentLayer:addChild(info:getLayer() , 2)
	
	self.baseLayer:addChild(self.contentLayer)
end

function PowerLayer:createTree(params)
	params = params or {}
	self:createContent()
	
	if self.layer then
		self.contentLayer:removeChild(self.layer, true)
	end
	
	
	
	self.state = TREE
	
	self.layer = display.newLayer()
	
	local bg = display.newSprite(PATH.."state_bg.jpg")
	setAnchPos(bg, 235, 399, 0.5 ,0.5)
	self.layer:addChild(bg)
	
	local function treeInfo(level, data)
		local posX = {
			{50, 200, 362},
			{90, 300},
			{200}		
		}
		local layer = display.newLayer()
		for i = 1, 3 do
			for j = 3 - (i - 1), 1, -1 do
				local name_bg, nameY
				if level == 3 and i == 3 then
					name_bg = {PATH.."king_bg.png",-25, 65} 
					nameY =74 
				else
					name_bg = {IMG_PATH.."image/scene/gang/appoint/position_bg.png",-33, 60} 
					nameY = 65
				end
				local info = (data[i..""] and data[i..""][j]) and data[i..""][j] or nil
				local btn = KNBtn:new(COMMONPATH, {info and getHeadPath(info.sex) or "photo_bg.png"}, posX[i][j], 240 + (i - 1) * 160, {
					other = {{COMMONPATH.."role_frame.png", -4, -6},
							{PATH.."name_bg.png", -30, -38}, 
							name_bg,
							{PATH.."level"..level.."_"..i.."_text.png", 0, nameY}
						},
					text = {info and info.name or "职位空缺", 20, ccc3(255, 255, 255), ccp(0, -53), nil, 20},
					callback = function()
						if info then
							HTTP:call("profile","get",{ touid = info.uid },{success_callback = 
								function()
									local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
									display.getRunningScene():addChild( otherPalyerInfo:new():getLayer() )
								end})
						else
							KNMsg.getInstance():flashShow("当前职位空缺，快来抢呦!~")
						end
					end
				})
				layer:addChild(btn:getLayer())
			end
		end
		
		return layer	
	end
	
	local group = KNRadioGroup:new()
	local tree
	for i = 1, 3 do
		local btn = KNBtn:new(COMMONPATH.."tab/", {"tab_star_normal.png", "tab_star_select.png"}, 190 - (i - 1) * 90, 690,{
			front = {PATH.."tab_"..i..".png", PATH.."tab_"..i.."_select.png"},
			callback = function()
				if params.call then
					if tree then
						self.layer:removeChild(tree, true)
					end
					tree = treeInfo(i,params.list[i..""])
					self.layer:addChild(tree)
					params.call = nil 
				else
					HTTP:call( "socialclass", "get_show_list", {}, {
						success_callback = function(data)
							if tree then
								self.layer:removeChild(tree, true)
							end
							tree = treeInfo(i,data.list[i..""])
							self.layer:addChild(tree)
						end
					})
				end
			end
		}, group)
		self.layer:addChild(btn:getLayer())
	end
	group:chooseByIndex(3, true)
	
	local separator = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(separator, 5, 685)
	self.layer:addChild(separator)
	
	local str = "1、皇权挑战条件：\n 1.1、上周获得的荣誉数量（不计入使用荣誉之石获得的荣誉）决定玩家本周可挑战的宫殿。\n 1.2、皇权宫殿所对应需要的荣誉： 皇宫——8000荣誉、六部——2000荣誉、州县——200荣誉。\n 2、挑战说明：\n 2.1、挑战次数：每次挑战宫殿会消耗次数，不同的宫殿每天可挑战的次数不同；皇宫——5次、六部——4次、州县——3次。\n 2.2、进入挑战：每次进入挑战会进入对应宫殿的起点位置，可点击下一个点进行挑战，但只能前进无法后退。\n 2.3、挑战成败：前进挑战成功则进驻下一个点，挑战失败则被弹出宫殿，再次进入则又会消耗挑战次数且需要从起点重新开始前进。\n 2.4、小贴士：若在宫殿中占据任意点，未被弹出宫殿的话，退出宫殿再次进入挑战宫殿则不会消耗每天的挑战次数。\n 3、权力说明：\n 3.1、职位：三个宫殿中各有6个职位点，占据职位点达到20分钟后，将获得该职位，并开始获得俸禄。\n 3.2、提升身份：获得州县的知州职位 或 获得六部的尚书职位后，可选择是否提升身份，离开当前宫殿，在本周内进入下一个宫殿进行挑战。\n 3.3、御花园：获得皇帝职位的玩家将获得一个御花园，可以进入御花园使用独有的特权。\n 4、其他说明：\n 4.1、每周重置：在每周周一00:00时，会重置清空所有宫殿的点，且重置时未领取的俸禄和特权也将清空。\n 4.2、随机事件：在挑战宫殿中的据点时，可能会触发随机事件。\n" 
	local help = KNBtn:new(PATH, {"help.png", "help_press.png"}, 420, 690, {
		callback = function()
			local temp = display.newLayer()
			
			local mask = KNMask:new({item = temp})			
			
			local bg = display.newSprite(IMG_PATH.."image/scene/mission/bg.png")	
			setAnchPos(bg, 240, 425, 0.5, 0.5)
			temp:addChild(bg)
			
			local scroll = KNScrollView:new(40, 280, 400, 320)
			
			local titleBg = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png") 
			setAnchPos(titleBg, 240, 600, 0.5)
			temp:addChild(titleBg)
			
			local titleText = display.newSprite(PATH.."help_title.png")
			setAnchPos(titleText, 240, 600, 0.5)
			temp:addChild(titleText)
			
--			local helpText = createLabel({str = replaceStr(str), color = ccc3(0, 0, 0), width = 400, height = 0, size = 18, height = 0})
			local helpText = CCLabelTTF:create(replaceStr(str), FONT, 20) 
			helpText:setDimensions(CCSize(400,0))
			helpText:setColor(ccc3(0, 0, 0))
			helpText:setHorizontalAlignment(0)
			
			scroll:addChild(helpText)
			temp:addChild(scroll:getLayer())
			
			local ok = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 160, 230, {
				front = COMMONPATH.."ok.png",
				priority = -132,
				callback = function()
					mask:remove()
				end
			})
			temp:addChild(ok:getLayer())
			
			self.layer:addChild(mask:getLayer())
		end
	})
	self.layer:addChild(help:getLayer())

	
	local challenge = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 160, 145, {
		front = PATH.."challenge_text.png",
		callback = function()
			if isBagFull() then
				return false
			end
			HTTP:call("socialclass", "get", {}, {
				success_callback = function(data)
					self:createWorldMap(data)
				end
			})
		end
	})
	self.layer:addChild(challenge:getLayer())
	
	self.layer:addChild(createLabel({str = replaceStr("每周获得的荣誉为进入条件，荣誉多可直接挑战皇宫"), color = ccc3(77, 249, 255), size = 16, x = 30, y = 120, width = 460}))
	
	self.contentLayer:addChild(self.layer)
end

function PowerLayer:createWorldMap(params)
	params = params or {}
	self:createContent()
	
	
	if self.layer then
		self.contentLayer:removeChild(self.layer, true)
	end
	
	self.state = WORLD
	
	self.layer = display.newLayer()
	
		local pos = {
		{290, 200},
		{50, 330},
		{200, 500},
	}
	
	local map = display.newSprite(PATH.."map.jpg")	
	setAnchPos(map,240,415,0.5,0.5)
	self.layer:addChild(map)
	
		
	local honor = display.newSprite(PATH.."my_honor.png")
	setAnchPos(honor,20, 120)
	self.layer:addChild(honor)
	
	honor = createLabel({str = params.thiswhonor or 0, size = 20, color = ccc3(255, 255, 255)})
	setAnchPos(honor, 140, 120)
	self.layer:addChild(honor)
	
	honor = createLabel({str = params.lastwhonor or 0, size = 20, color = ccc3(255, 255, 255)})
	setAnchPos(honor, 140, 145)
	self.layer:addChild(honor)
--	
	local name = {
		[0] = "荣誉不足，不可挑战",
		"州县",
		"六部",
		"皇宫"
	}
	
	for i = 1, #pos do
		local str 
		local legal = true
		if params.cur_map == 0 then
			if i <= params.default_map then
				str = {"level"..i..".png", "level"..i.."_press.png"}
			else
				str = {"level"..i.."_disable.png"}
				legal = false
			end
		else
			if i == params.cur_map then
				str = {"level"..i..".png", "level"..i.."_press.png"}
			else
				str = {"level"..i.."_disable.png"}
				legal = false
			end
		end
		local btn = KNBtn:new(PATH, str, pos[i][1], pos[i][2], {
--			other = {PATH.."level"..i.."_text.png", 30, -20},
			callback = function()
--				if legal then
--					if params.times[i..""].cur >= params.times[i..""].max then
--						KNMsg.getInstance():flashShow("挑战次数已用完，明天再来试试吧")
--					else
					if params.cur_map == 0 then
						showTip({
							content = createLabel({str = replaceStr("每周只能进入一个区进行挑战，你确认要进入"..name[i].."吗?"), size = 20, width = 380}),
							right = {
								path = COMMONPATH,
								normal = "btn_bg_red.png",
								pre = "btn_bg_red_pre.png",
								front = COMMONPATH.."cancel.png",
								remove = true,
							},
							left = {
								path = COMMONPATH,
								normal = "btn_bg_red.png",
								pre = "btn_bg_red_pre.png",						
								front = COMMONPATH.."ok.png",
								remove = true,
								callback = function()
									HTTP:call("socialclass", "enter_map", {map_id = i}, {
										success_callback = function(data)
											self:createWar(i, data)
										end
									})
								end
							}
						})	
					else
						HTTP:call("socialclass", "enter_map", {map_id = i}, {
							success_callback = function(data)
								self:createWar(i, data)
							end
						})
					end
--					end
--				else
--					KNMsg.getInstance():flashShow("先混个一官半职再来吧,你高攀不起~")
--				end
			end
		})
		self.layer:addChild(btn:getLayer())
	end
	
	local curText = display.newSprite(PATH.."cur_power.png")
	setAnchPos(curText, 30, 690)
	self.layer:addChild(curText)
	
	local cur = params.cur_map ~= 0 and params.cur_map or params.default_map
	curText = createLabel({str = replaceStr(name[cur]), size = 24, color = ccc3(255, 255, 255), width = 400})
	setAnchPos(curText, 150, 690)
	self.layer:addChild(curText)
	
	local curText = display.newSprite(PATH.."rest_times.png")
	setAnchPos(curText, 30, 725)
	self.layer:addChild(curText)
	
	local text = createLabel({str = params.times[params.cur_map..""].cur.."/"..params.times[params.cur_map..""].max, size = 20, color = ccc3(255, 255, 255)})
	setAnchPos(text, 180, 727)
	self.contentLayer:addChild(text)
	
	self.contentLayer:addChild(self.layer)
end

function PowerLayer:createWar(index, data)
	if self.contentLayer then
		self.baseLayer:removeChild(self.contentLayer, true)
	end
	
	self.contentLayer = display.newLayer()
	
	local bg = display.newSprite(PATH .. "war_map.jpg")
	setAnchPos(bg , 240 , 425, 0.5, 0.5)				
	self.contentLayer:addChild(bg)
	
	local back = KNBtn:new(IMG_PATH.."image/scene/login", {"back.png", "back_pre.png"}, 20, 700, {
		callback = function()
			HTTP:call("socialclass", "get", {}, {
				success_callback = function(data)
					self:createWorldMap(data)
				end
			})
		end
	})
	self.contentLayer:addChild(back:getLayer())
	
	local temp, call
	local function getAward(noAni)
		if temp then
			self.baseLayer:removeChild(temp:getLayer(), true)
		end
		
		HTTP:call("socialclass", "award_info", {}, {
					success_callback = function(data)	
						local awardShow = display.newLayer()
						if #data == 0 then
							awardShow = display.newSprite(COMMONPATH.."empty.png")				
							awardShow:setScale(0.5)
						else
							for i = 1, #data do 
								local btn = awardCell(data[i], {
									name = true,
								})
								setAnchPos(btn, -208 + (i - 1) * 84, -40)
								awardShow:addChild(btn)
								
								local timeText = createLabel({str = timeConvert(data[i].cd > 0 and data[i].cd or 0), size = 16})
								setAnchPos(timeText, -208 + (i - 1) * 84, -88)
								awardShow:addChild(timeText)
								
								if data[i].cd >= 0 then
									Clock:addTimeFun("power_award"..i, function()
										if data[i].cd > 0 then
											data[i].cd = data[i].cd - 1
											timeText:setString(timeConvert(data[i].cd))
											call = false
										else
											if not call then
												call = true
												getAward(true)
											end
										end
									end)
								end
							end
						end
						temp = showTip({
							title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
							title_text = PATH.."salary_title.png",
							cx = 215, 
							cy = 190,
							content = awardShow,
							noAni = noAni,
							right = {
									 path = COMMONPATH, 
									 normal = "btn_bg_red.png", 
									 pre = "btn_bg_red_pre.png",
									 front = COMMONPATH.."cancel.png",
									 remove = true,
								  },
						    left = {
									 path = COMMONPATH, 
									 normal = "btn_bg_red.png", 
									 pre = "btn_bg_red_pre.png",
									 front = COMMONPATH.."get.png",
									 remove = true,
									 callback = function()
										 HTTP:call("socialclass", "receive_award", {}, {
											success_callback = function(data, showFunc) 
												showFunc(data)
											end
										 })
									 end
								  }		
						})
						end
				})
	end
	local look 
	look = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 10, 800, {
		front = PATH.."look.png",
		callback = function()
			getAward()
		end
	})
	self.contentLayer:addChild(look:getLayer())
	
	local powerRank = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 190, 800, {
		front = PATH.."power_rank.png",
		callback = function()
			--皇力排行
			HTTP:call("socialclass", "gethlranking", {}, { success_callback = function(receiveData)
	   				pushScene("powerRank",{data=receiveData, closeFun = function() popScene() end})
   				end
			} ) 
		end
	})
	self.contentLayer:addChild(powerRank:getLayer())
	
	
	local front  = PATH.."power_up.png"
	local garden
	if tonumber(data.cur_map) == 3 then
		front = IMG_PATH.."image/scene/userinfo/kingGardenLab.png"
		garden = true
	end
	local powerUp = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 360, 800, {
		front = front,
		callback = function()	
			if garden then
				HTTP:call("socialclass","garden",{ },{success_callback = 
					function(data)
						if data.is_self then
							switchScene("kingGarden",{data, closeCallback = function()
								HTTP:call("socialclass", "enter_map", {map_id = index}, {
									success_callback = function(get)
										get.war = true	
										switchScene("power", get)
									end
								})
							end})
						else
							KNMsg.getInstance():flashShow("你还未成为帝王无法进入御花园!~")
						end
					end
					})
				return 
			end
			showTip({
				title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
				title_text = PATH.."up_title.png",
				content = createLabel({str = "提升身份可以挑战更高级的殿，您确定要放弃当前职位，提升身份吗？", width = 380, size = 22}),
				right = {
						 path = COMMONPATH, 
						 normal = "btn_bg_red.png", 
						 pre = "btn_bg_red_pre.png",
						 front = COMMONPATH.."cancel.png",
						 remove = true,
					  },
			    left = {
						 path = COMMONPATH, 
						 normal = "btn_bg_red.png", 
						 pre = "btn_bg_red_pre.png",
						 front = COMMONPATH.."ok.png",
						 remove = true,
						 callback = function()
							 HTTP:call("socialclass", "jump_map", {}, {
								 success_callback = function(data)
									 self:createWorldMap(data.get)
								 end
							 })
						 end
					  }		
			})
		end
	})
	self.contentLayer:addChild(powerUp:getLayer())
	
	local text = display.newSprite(PATH.."info_text.png")
	setAnchPos(text, -25, 70)
	self.contentLayer:addChild(text)
		
	text = createLabel({str = data.identity, size = 20, width = 200, color = ccc3(255, 255, 255)})
	setAnchPos(text, 90, 105)
	self.contentLayer:addChild(text)
	
	
	local cdText = createLabel({str = timeConvert(data.cd, nil, true), size = 20, color = ccc3(255, 255, 255)})
	setAnchPos(cdText, 25, 75)
	self.contentLayer:addChild(cdText)
	
	Clock:addTimeFun("power_cd", function()
		if data.cd > 0 then
			data.cd = data.cd - 1
			cdText:setString(timeConvert(data.cd, nil, true))
		end
	end)
		
	
	local pos = {
		--x    y,   职位点, 职称, 相连点
		{368, 80,  false, 0,  {2}},
		{407, 208, false, 0,  {3}},
		{265, 174, false, 0,  {4, 5, 6}},
		{71,  211, true,  1,  {7}},
		{217, 285, true,  1,  {7}},
		{397, 308, true,  1,  {7}},
		{221, 391, false, 0,  {8}},
		{45, 384, false, 0,  {9,10}},
		{85, 501, true,  2,  {11}},
		{308, 454, true,  2,  {11}},
		{208, 592, false, 0,  {12}},
		{128, 731, false, 0,  {13}},
		{354, 721, true, 3,   {}},
	}
	for i = 1, #pos do
		local str, other

		if i == 1 then
			str = "pt_start.png"	
		elseif i == #pos then
			if tonumber(data.cur_point) >= i then
				str = "level"..index..".png"
			else
				str = "level"..index.."_disable.png"
			end
		elseif pos[i][3] then
			if tonumber(data.cur_point) == #pos or pos[tonumber(data.cur_point)][5][1] > i then
				str = "small_power.png"
			else
				str = "small_power_disable.png"
			end
		else
			if tonumber(data.cur_point) >= i then
				str = "pt_pass.png"
			else
				str = "pt_empty.png"
			end
		end
		local event = data.map[i..""].event
		--随机事件发生
		if event then
			if event.state == 1 then
				local randomImg = display.newSprite(PATH.."random.png")
				setAnchPos(randomImg, pos[i][1] + 10, pos[i][2] + 10)
				self.contentLayer:addChild(randomImg, 1)
			elseif event.state == 2 then
				local temp 
				temp = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
					local desc = display.newLayer()
	
					
					local honor = createLabel({str = "消耗荣誉:"..event.resethonor, size = 20, width = 380})
					setAnchPos(honor, -130, -160, 0.5)
					desc:addChild(honor)
					
					local lFront, rFront
					if event.type == "fight" then
						lFront = PATH.."jump.png"
						rFront =  PATH.."challenge_text.png"
					elseif event.type == "addcd" then
						lFront = PATH.."go.png"
						rFront =  COMMONPATH.."cancel.png"
					end
					
					local tip = createLabel({str = event.name, size = 20, width = 380})
					setAnchPos(tip, 0, -70, 0.5)
					desc:addChild(tip)
					
					showTip({
						title_text = PATH.."state_title.png",
						title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
						content = desc,
						cx = 220,
						right = {
							 path = COMMONPATH, 
							 normal = "btn_bg_red.png" ,
							 pre = "btn_bg_red_pre.png",
							 remove = true,
			   				 front = rFront,
			   				 callback = function()
				   				 if event.type == "fight" then
					   				 SOCKET:getInstance("battle"):call("socialclassf" , "execute" , "execute" , {})
				   				 else
					   				 HTTP:call("socialclass", "pass_addcd", {pass = 2}, { 
						   				 success_callback = function(data)
							   				self:createWar(index, data)
						   				 end
					   				 })
				   				 end
			   				 end
						},
						left = {
							 path = COMMONPATH, 
							 normal = "btn_bg_red.png" ,
							 pre = "btn_bg_red_pre.png",
							 remove = true,
			   				 front = lFront,
			   				 callback = function()
				   				 if event.type == "fight" then
					   				HTTP:call("socialclass", "pass_fight", {}, {
						   				success_callback = function(data)
							   				self:createWar(index, data)
						   				end
					   				} ) 
				   				else
					   				 HTTP:call("socialclass", "pass_addcd", {pass = 1}, { 
						   				 success_callback = function(data)
							   				self:createWar(index, data)
						   				 end
					   				 })				   				
				   				end
			   				 end
					}})
					 CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(temp)
				end, 0.1, false)
			
			end
		end
		
		if pos[i][3] and i ~= #pos then
			other = {PATH.."level"..index.."_"..pos[i][4]..".png", 30, -20}
		end
		
		
		local btn = KNBtn:new(PATH, {str}, pos[i][1], pos[i][2], {
			anchMid = true,
			other = other,
			scale = true,
			callback = function()
				if i == 1 then
					KNMsg.getInstance():flashShow("前进吧")
				else
--					if pos[i][3] then
					HTTP:call("socialclass", "enter_map", {map_id = index}, {
						success_callback = function(new)
							data = new
							local temp = display.newLayer()
							temp:ignoreAnchorPointForPosition(false)
							
							local text = display.newSprite(PATH.."defender_text.png")
							setAnchPos(text, 180, 400, 0.5, 0.5)
							temp:addChild(text)
							
							if pos[i][3] then
								text = createLabel({str = replaceStr("说明：此点只允许一个玩家进入占领"), size = 20, width = 400, color = ccc3(255, 0, 0)})
								setAnchPos(text, 240, 260, 0.5)
								temp:addChild(text)
							end
							
							text = createLabel({str = event and "未触发" or "无", size = 20, width = 400, color = ccc3(0, 0, 0)})
							setAnchPos(text, 260, 410, 0.5)
							temp:addChild(text)	
							
							--挑战按钮状态
							local front = PATH.."challenge_text_gray.png"
							local normal = "btn_bg_red2.png" 
							local pre, allow
							for k, v in pairs(pos[tonumber(data.cur_point)][5]) do
								if i == v then
									front = PATH.."challenge_text.png"
									normal = "btn_bg_red.png"
									pre = "btn_bg_red_pre.png"
									allow = true  --可以攻击的点
									break
								end
							end
							
							--等候列表，查看阵容状态
							local leftFront, leftNormal, leftPre, npc, name
							
							if pos[i][3] then
								if table.nums(data.map[i..""].list) > 0 then
									 leftNormal = "btn_bg_red.png" 
									 leftPre = "btn_bg_red_pre.png"
									 leftFront = IMG_PATH.."image/scene/diggings/look.png" 
									 name = data.map[i..""].list[1].name
								else
									npc = true
									leftNormal = "btn_bg_red2.png"
									 leftFront = IMG_PATH.."image/scene/diggings/look_grey.png" 
									 name = data.map[i..""].npc.name.."(NPC)"
								end
							else
								 leftNormal = "btn_bg_red.png" 
								 leftPre = "btn_bg_red_pre.png"
								 leftFront = PATH.."wait_list.png"
								 name = data.map[i..""].npc.name.."(NPC)"
							end
							
							text = createLabel({str = name, size = 20, width = 400, color = ccc3(0, 0, 0)})
							setAnchPos(text, 260, 370, 0.5)
							temp:addChild(text)	
							
							if pos[i][3] and data.map[i..""].list[1] and data.map[i..""].list[1].cd > 0 then
								local timeStr = timeConvert(data.map[i..""].list[1].cd)
								
								local timeText = createLabel({str = "("..timeStr.."后将占领此点)",width = 400, size = 18, color = ccc3(255, 0,0)})
								setAnchPos(timeText, 240, 345, 0.5)
								temp:addChild(timeText)
								
								Clock:addTimeFun("getStateTime"..i, function()
									if data.map[i..""].list[1].cd > 0 then
										data.map[i..""].list[1].cd = data.map[i..""].list[1].cd - 1 
										timeStr = timeConvert(data.map[i..""].list[1].cd)
										timeText:setString("("..timeStr.."后将占领此点)")
									else
										temp:removeChild(timeText, true)
										Clock:removeTimeFun("getStateTime"..i)
									end
								end)
							end
							
							
							showTip({
								title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
								title_text = PATH.."detail_title.png",
								content = temp,
								right = {
										 path = COMMONPATH, 
										 normal = normal ,
										 pre = pre,
	   									front = front,
										 callback = function()
											 if allow then
												SOCKET:getInstance("battle"):call("socialclass" , "execute" , "execute" , {
													map = data.cur_map,
													point = i,
													target = pos[i][3] and (data.map[i..""].list[1] and data.map[i..""].list[1].uid or 0) or 0,
												})
											else
												KNMsg.getInstance():flashShow("箭头指向您当前可挑战的位置")
											end
										 end
									  },
							    left = {
										 path = COMMONPATH, 
										 normal = leftNormal,
										 pre = leftPre,
										 front = leftFront,
										 callback = function()
											 if npc then
												KNMsg.getInstance():flashShow("还没有人占领")
											 else
												 if pos[i][3] then
													 HTTP:call("profile","get",{ touid = data.map[i..""].list[1].uid },{success_callback = 
														function()
															local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
															display.getRunningScene():addChild( otherPalyerInfo:new():getLayer() )
														end})
												else  --等候列表
													display.getRunningScene():addChild(self:waitList(data.map[i..""].list))
												end
											 end
										 end
									  },
							   close = {
								 path = COMMONPATH, 
								 normal = "back_img.png", 
								 pre = "back_img_press.png",
								 callback = function()
									 self:createWar(index, new)
								 end
							  }		
							})
	--					else --非职位点，显示所有等候玩家信息，可滑动
	--						local info = display.newLayer()
	--						info:setContentSize(CCSizeMake(300, 300))
	--							
	--						local scroll = KNScrollView:new(10, 10, 100, 100, 0, true, 0, {
	--							priority = -150
	--						})
	--						local temp = display.newSprite(IMG_PATH.."image/scene/login/bg.jpg")
	--						
	--						scroll:addChild(temp)
	--						scroll:alignCenter()
	--						
	--						info:addChild(scroll:getLayer())
	--						
	--						showTip({
	--							bg = IMG_PATH.."image/scene/war/info_bg.png",
	--							content = info,
	--							center = {
	--								 path = COMMONPATH, 
	--								 normal = "btn_bg.png", 
	--								 pre = "btn_bg_pre.png",
	--								 remove = true,
	--								 front = COMMONPATH.."ok.png" 
	--							  }
	--						})
						end
					})
--					end
				end
			end
				
		})
		self.contentLayer:addChild(btn:getLayer())
		
		
		if pos[i][3] and data.map[i..""].list[1] and data.map[i..""].list[1].cd <= 0 then
			--占领旗帜
			local flag = display.newSprite(IMG_PATH.."image/scene/war/flag_enemy.png")
			setAnchPos(flag, pos[i][1], (i == #pos) and pos[i][2] + btn:getHeight() / 3 or pos[i][2])
			self.contentLayer:addChild(flag)
		end
	end
	
	for k, v in pairs(pos[tonumber(data.cur_point)][5]) do
		local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
		local tip = display.playFrames(pos[v][1], pos[v][2],frames, 0.2, {
						forever = true,
					})
		self.contentLayer:addChild(tip, 2)	
	end
	
	self.baseLayer:addChild(self.contentLayer)
	if data.tips then
	print(data.tips)
		local temp 
		temp = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
			local tip = createLabel({str = data.tips, size = 20, width = 380})
			showTip({
				content = tip,
				center = {
					 path = COMMONPATH, 
					 normal = "btn_bg.png" ,
					 pre = "btn_bg_pre.png",
					 remove = true,
	   				 front = COMMONPATH.."ok.png",
				}})
			 CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(temp)
		end, 0.1, false)
	end
	
end

function PowerLayer:getLayer()
	return self.baseLayer
end

function PowerLayer:waitList(data)
		local report = display.newLayer()
		local mask = KNMask:new({item = report, priority = -150})
		
		local bg = display.newSprite(IMG_PATH.."image/scene/war/info_bg.png")
		setAnchPos(bg)
		
		report:setContentSize(CCSizeMake(bg:getContentSize().width, bg:getContentSize().height))
		setAnchPos(report, 30, 300)
		report:addChild(bg)
		
		local count = 0
		for k, v in pairs(data) do
				local btn = KNBtn:new(COMMONPATH, {getHeadPath(v.sex)}, 20 + (count - 5 >= 0 and count - 5 or count) * 80, 200 - (count >= 5 and 1 or 0) * 110, {
					text = {{v.name, 18, ccc3(0xff, 0xfb, 0xd4), ccp(0, -40)},{v.lv, 18, ccc3(0xff, 0xfb, 0xd4), ccp(30, 30), nil, 17}},
					other = {COMMONPATH.."egg_num_bg.png", 50, 50},
					front = COMMONPATH.."role_frame.png",
				})
				report:addChild(btn:getLayer())
				count = count + 1
		end
		
		if count == 0 then
			local empty = display.newSprite(COMMONPATH.."empty.png")
			setAnchPos(empty, 210, 70, 0.5)
			report:addChild(empty)
		end
		
		local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 130, 10, {
			priority = -151,
			front = COMMONPATH.."colse_text.png",
			callback = function()
				mask:remove()
			end
		})
		report:addChild(close:getLayer())
		return mask:getLayer()
end


return PowerLayer