--皇力排行layer

local M = {
	pageIndex=1,
	pageCount,
	listData,
	scrollView,

}

local PATH = IMG_PATH .. "image/scene/powerRank/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	--初始化数据
    --dump(args)
    this.listData=args.data.rank --总数据
    this.pageCount = math.ceil( #args.data.rank/10) --总页码
	
	-- 基础层
	this.baseLayer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )
	
	
	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "powerRank" , 0 , { title_text = PATH .. (args.pre and "pre_title.png" or "powerRankTitle.png"), tail_hide = true, closeCallback = function()
		 popScene()
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )	

    this.scrollView=this:choosePageData(this.pageIndex)
    if this.scrollView  == nil then
	    return
    end
    this.baseLayer:addChild(this.scrollView:getLayer())

    local pageLab = display.strokeLabel( this.pageIndex .."/"..this.pageCount, 215, 115 , 22 , ccc3( 223 , 206 , 164) )
     this.baseLayer:addChild(pageLab)
    --增减按钮
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 255 , 105 , {
				scale = true,
				priority = -130,
				callback = function()
					
					if this.pageIndex<this.pageCount then
						this.scrollView:getLayer():removeFromParentAndCleanup(true)
						this.pageIndex=this.pageIndex+1
						
						this.scrollView=this:choosePageData(this.pageIndex)
						this.baseLayer:addChild(this.scrollView:getLayer())
						pageLab:setString(this.pageIndex .."/"..this.pageCount)
					end
					
			end
			})
	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , 175 , 105 ,{
				scale = true,
				priority = -130,
				callback = function()
					
					
					if this.pageIndex > 1 then
						this.scrollView:getLayer():removeFromParentAndCleanup(true)
						this.pageIndex=this.pageIndex-1
						
						this.scrollView=this:choosePageData(this.pageIndex)
						this.baseLayer:addChild(this.scrollView:getLayer())
						pageLab:setString(this.pageIndex .."/"..this.pageCount)
					end
				end
				})
	minusBtn:setFlip(true)
	addBtn:getLayer():setScale( 0.8 )
	minusBtn:getLayer():setScale( 0.8 )
	
	local my = display.newSprite(PATH.."my_power.png")
	setAnchPos(my, 10, 110)
	this.baseLayer:addChild(my)
	my = createLabel({str = args.data.hl, width = 100, x = 100, y = 107, size = 24, color = ccc3(255, 255, 255)})
	this.baseLayer:addChild(my)
	
	if not args.pre then
		local preRank = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 350, 100,{
			front = PATH.."pre_rank.png",
			callback = function()
				HTTP:call("socialclass", "gethlranking", {week = -1}, { success_callback = function(receiveData)
			   				pushScene("powerRank",{data=receiveData, pre = true, closeFun = function() popScene() end})
		   				end
					} ) 
			end
		})
		this.baseLayer:addChild(preRank:getLayer())
	end
	
	this.baseLayer:addChild(addBtn:getLayer())
	this.baseLayer:addChild(minusBtn:getLayer())


	
	return this.baseLayer 
end

function M:choosePageData(choosePageIndex)
	if choosePageIndex > self.pageCount then
		KNMsg.getInstance():flashShow("还没有皇力排行数据")
		return
	end

	local tempScrollView = KNScrollView:new(15,150,450,595,5,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
	

    for i= 1+((choosePageIndex-1)*10), choosePageIndex*10 do
    	
    	if self.listData[i] then
	    	 local  itemBg = display.newSprite(COMMONPATH .."item_bg.png")
	       	 setAnchPos(itemBg,0,0)
	       	 tempScrollView:addChild(itemBg)

	         local	touXiangSp = display.newSprite(COMMONPATH ..getHeadPath(self.listData[i]['sex'])) --男
	       	 setAnchPos(touXiangSp,25,20)
	       	 itemBg:addChild(touXiangSp)

	       	 local	touXiangFrame = display.newSprite(COMMONPATH .."role_frame.png") 
	       	 setAnchPos(touXiangFrame,25,18)
	       	 itemBg:addChild(touXiangFrame)

	       	 local playerNameSp = display.newSprite(PATH .. "userNameLab.png")
	         setAnchPos(playerNameSp ,100,60)
	   	     itemBg:addChild(playerNameSp)

	   	     local playerName =  display.strokeLabel(self.listData[i]['name'], 170, 63 , 22 , ccc3( 46 , 18 , 14) )
	       	 itemBg:addChild(playerName)

	       	 local powerSp = display.newSprite(PATH .. "powerSp.png")
	       	 setAnchPos(powerSp ,100,20)
	       	 itemBg:addChild(powerSp)

	       	 local powerNum =  display.strokeLabel(self.listData[i]['num'], 170, 20 , 22 , ccc3( 46 , 18 , 14) )
	       	 itemBg:addChild(powerNum)

	       	 local rankSp = display.newSprite(PATH .. "rankSp.png")
	       	 setAnchPos(rankSp ,295,35)
	       	 itemBg:addChild(rankSp)

	       	 -- local rankNum =  display.strokeLabel(self.listData[i]['rank'], 390, 35 , 22 , ccc3( 46 , 18 , 14) )
	       	 -- itemBg:addChild(rankNum)
	       	 local rankNum = getImageNum(self.listData[i]['rank'], COMMONPATH .. "cirt.png")
	       	 setAnchPos(rankNum,365,28)
	       	 itemBg:addChild(rankNum)

       	end

    end

    return tempScrollView

end


return M