--掠夺主界面

local M = {
	baseLayer,
	equipAData,--传递源
	equipBData,--传递目标
	layer,

}

local PATH = IMG_PATH .. "image/scene/propertyTransfer/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	-- 基础层
	this.baseLayer = display.newLayer()
	this.layer = display.newLayer()
	-- 背景
	local bg = display.newSprite( COMMONPATH .. "dark_bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "propertyTransferLayer" , 0 , { title_text = PATH.."propertyTransferTitle.png", tail_hide = true, closeCallback = function()
		popScene()
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	local desc = display.newSprite(PATH.."descText.png",50,700,0,0)
	this.layer:addChild(desc)

	local transferBg = display.newSprite( IMG_PATH.."image/scene/forge/pool_tool.png",240,450,0.5,0.5)
	this.layer:addChild(transferBg)
	
	local arrow = display.newSprite( IMG_PATH.."image/scene/forge/arrow.png",240,555,0.5,0.5)
	this.layer:addChild(arrow)
	arrow:setRotation(-90)



	--三个图标
	local tempLayerA = display.newLayer()
	this.layer:addChild(tempLayerA,12)

	local tempLayerB = display.newLayer()
	this.layer:addChild(tempLayerB,12)

	local equipABtn = KNBtn:new(SCENECOMMON,{"skill_frame1.png"},90 , 527 , {
		--text = {{"装备",15,ccc3( 0x2c, 0, 0),ccp(0,0 )}},
		callback=function( )
			tempLayerA:removeAllChildrenWithCleanup(true)
			tempLayerB:removeAllChildrenWithCleanup(true)
			local list
			list = SelectList:new("equip" , this.layer , COMMONPATH .. "title/equip_text.png" ,
			{
				showTitle = true,
				y = 85,
				btn_opt = "ok.png",
				target = true,
				all=true,
				filter = {transferGroup=true},
				optCallback=
					function()
						list:destroy()
						local curId = list:getCurItem():getId()
						for i,v in pairs(DATA_Bag:getTable("equip")) do
							if v.id == curId then
									this.equipAData = v
								break
							end
						end
						dump(this.equipAData)

						local icon = display.newSprite(getImageByType(this.equipAData.cid , "s"),92,531,0,0)
						tempLayerA:addChild(icon)

						local border = display.newSprite(COMMONPATH.."star_border/border_"..getConfig("equip",this.equipAData.cid,"star")..".png",91-14,535-24,0,0)
						tempLayerA:addChild(border)

						local name = display.strokeLabel(this.equipAData.name , 0 , 0 , 15, ccc3( 0xfe , 0xfc , 0xd3 ) )
						name:setAnchorPoint(ccp(0.5, 0.5))
						name:setPosition(ccp(123,490))
						tempLayerA:addChild(name)


						local num = this.equipAData.star
						for i = 1, num do
							local star = display.newSprite(COMMONPATH.."star.png")
							star:setScale(0.8)
							setAnchPos(star, 126 - (num * 30 * 0.8) / 2 + (i - 1) * 30 * 0.8 , 500  )
							tempLayerA:addChild(star)
						end


					end
			} )
			this.baseLayer:addChild(list:getLayer(),10)
		end

	})
	this.layer:addChild(equipABtn:getLayer())

	
	

	local equipBBtn = KNBtn:new(SCENECOMMON,{"skill_frame1.png"},90+235 , 527 , {
		--text = {{"装备",15,ccc3( 0x2c, 0, 0),ccp(0,0 )}},
		callback=function( )

			if this.equipAData ==nil then
				KNMsg.getInstance():flashShow( "请先选择被转移属性的装备" )
				return
			end
			tempLayerB:removeAllChildrenWithCleanup(true)
			local list
			list = SelectList:new("equip" , this.layer , COMMONPATH .. "title/equip_text.png" ,
			{
				showTitle = true,
				y = 85,
				btn_opt = "ok.png",
				target = true,
				all=true,
				filter = {type = this.equipAData.type,star=this.equipAData.star}, 
				optCallback=
					function()
						list:destroy()
						local curId = list:getCurItem():getId()
						for i,v in pairs(DATA_Bag:getTable("equip")) do
							if v.id == curId then
									this.equipBData = v
								break
							end
						end
						dump(this.equipBData)

						local icon = display.newSprite(getImageByType(this.equipBData.cid , "s"),90+240,531,0,0)
						tempLayerB:addChild(icon)

						local border = display.newSprite(COMMONPATH.."star_border/border_"..getConfig("equip",this.equipBData.cid,"star")..".png",83-10+240,535-24,0,0)
						tempLayerB:addChild(border)

						local name = display.strokeLabel(this.equipBData.name , 0 , 0 , 15, ccc3( 0xfe , 0xfc , 0xd3 ) )
						name:setAnchorPoint(ccp(0.5, 0.5))
						name:setPosition(ccp(360,490))
						tempLayerB:addChild(name)
						
						local num = this.equipBData.star
						for i = 1, num do
							local star = display.newSprite(COMMONPATH.."star.png")
							star:setScale(0.8)
							setAnchPos(star, 120+240 - (num * 30 * 0.8) / 2 + (i - 1) * 30 * 0.8 , 500  )
							tempLayerB:addChild(star)
						end

					end
			} )
			this.baseLayer:addChild(list:getLayer(),10)

		end

	})
	this.layer:addChild(equipBBtn:getLayer())



	local btn = KNBtn:new(SCENECOMMON,{"skill_frame1.png"},207 , 350-30 , {
		text = {{"黑曜石",15,ccc3( 0xfe , 0xfc , 0xd3),ccp(0,-70  )}},
		other = {{COMMONPATH.."star_border/border_"..getConfig("prop","17153","star")..".png", 5-18, 5-22}},
		front = getImageByType("17153","s"),
	})
	this.layer:addChild(btn:getLayer())

	local have = display.newSprite(COMMONPATH.."have.png",322,345,0,0)
	this.layer:addChild(have)
	local heiYaoShiNum = display.strokeLabel( DATA_Bag:cidNum("17153") , 384-15 , 356-10 , 20, ccc3( 0xfe , 0xfc , 0xd3 )  ) 
	this.layer:addChild(heiYaoShiNum)


	local num = getConfig("prop", "17153", "star")
	for i = 1, num do
		local star = display.newSprite(COMMONPATH.."star.png")
		star:setScale(0.8)
		setAnchPos(star, 243 - (num * 30 * 0.8) / 2 + (i - 1) * 30 * 0.8 , 290  )
		this.layer:addChild(star)
	end

	local tip = display.strokeLabel( "说明：同星级同类型的装备才可进行属性转移" , 50 , 130 , 20, ccc3( 99, 235, 221 )  ) 
	this.layer:addChild(tip)


	--转移
	local addBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"} ,  170 ,  190  , {
			scale = true,
			priority = -130,
			front=PATH.."startTransfer.png",
			callback = function()
				if this.equipAData==nil or this.equipBData==nil then
					KNMsg.getInstance():flashShow( "请先选择装备" )
					return
				end 
				KNMsg.getInstance():boxShow("["..this.equipAData.name.."]".."的强化等级，附魔属性，淬炼等级将转化到".."["..this.equipBData.name.."]\n".."是否转移？" ,{ 
																	cancelFun = function() end , 
																	confirmFun = function()
																		HTTP:call("equip" , "moveAttribute",{ eid=this.equipAData.id,  recv_eid=this.equipBData.id} , {
																				success_callback = function(data)
																							dump(data)
																							switchScene("propertyTransfer",{} , function()
																											KNMsg.getInstance():flashShow( "转移成功" )
																									end)
																				end
																			})

																	 end 
																	} )

				

			end
		})
	
	this.layer:addChild(addBtn:getLayer())
	



	this.baseLayer:addChild(this.layer)

	return this.baseLayer 
end





return M