local MAIN, HERO, PET, SKILL, EQUIP = 0, 1, 2, 3, 4
local LEFT, RIGHT, TOP, BOTTOM = 1, 2, 3, 4
local PATH = IMG_PATH.."image/scene/pvp/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local Progress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")--require "GameLuaScript/Scene/common/infolayer"
local Property = requires(IMG_PATH, "GameLuaScript/Config/Property")
local KNCardpopup = requires(IMG_PATH,"GameLuaScript/Common/KNCardpopup")
local RobLayer = requires(IMG_PATH, "GameLuaScript/Scene/pvp/roblayer")
local SelectList = requires(IMG_PATH,"GameLuaScript/Scene/common/selectlist")
--[[
	副本模块，在首页点击副本按钮进入此模块
]]
local PVPLayer = {
	layer,
	mainLayer,
	contentLayer,
	state,
	wait,
	onePt,
	info,
	mask,
	needHeroList,
	
}

function PVPLayer:new(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	params = params or {}

	this.layer = display.newLayer()
--	this.state = params.state 

	local bg = display.newSprite(SCENECOMMON.."bg.png")
	setAnchPos(bg)
	this.layer:addChild(bg)
	
	local title = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(title, 0, 425, 0, 0.5)
	this.layer:addChild(title)
--	
--	if params.state == "hero" then
----		HTTP:call("penglai", "get", {}, {
----			success_callback = function(data)
--				this:createHeroFb(params.data) 
----			end
----		})
--	elseif  params.state == "pet" then	
--		this:createPetFb()
--	elseif params.state == "skill" then
--		this:createSkillFb()
--	elseif params.state == "equip" then
--		if params.dig then
--			this:createDig(params.map)
--		else
--			this:createEquipFb(params.map)
--		end
	if params.state == "rob" then
		this:createRobFb(params.robData, params.star)
	else	
		this:createMain(params.coming)
	end	

	return this
end

function PVPLayer:getOrderList(t)
	local _t = t

	local pvp_config = getConfig("wenzimiaoshu").pvp

	local function isOpen(v)
		if checkOpened(v) ~= true then 
			return false
		elseif DATA_Info:get_type("pvp_open_module") and DATA_Info:get_type("pvp_open_module")[v] and DATA_Info:get_type("pvp_open_module")[v] == 0 then 
			return false
		end
		return true
	end

	local t_open = {}
	local t_not_open = {}

	for i,v in pairs(_t) do
		local open = isOpen(v)
		if open then
			t_open[#t_open+1] = v
		else
			t_not_open[#t_not_open+1] = v
		end
	end

	local function sort_rule(a,b)
		if pvp_config[a].sort and pvp_config[b].sort then 
			return pvp_config[a].sort < pvp_config[b].sort
		else
			return false
		end		
	end

	table.sort( t_open , sort_rule )
	table.sort( t_not_open , sort_rule )

	for i,v in pairs(t_not_open) do
		t_open[#t_open+1] = v
	end
	
	return t_open
end

function PVPLayer:createMain(name)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	self.mainLayer = display.newLayer()
	
	local des_scroll 
	des_scroll =  KNScrollView:new(0, 90, 480, 650, 10, false, 0, {
		page_callback = function()
			group:chooseByIndex(des_scroll:getCurIndex())
			if checkOpened("fb_"..group:getId()) == true then
				coming:setFront(COMMONPATH.."coming.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red.png", COMMONPATH.."btn_bg_red_pre.png"})
			else
				coming:setFront(COMMONPATH.."coming_grey.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red2.png",COMMONPATH.."btn_bg_red2.png"})
			end
		end
	})

	local godwar_open = false
	if getConfig("wenzimiaoshu").pvp["godwar"] then
		godwar_open = true
	end
	
	local level = {
		"athletics",
		"rob",
		"diggings",
		"war",
		"tiexue", 
		"power",
		godwar_open and "godwar" or nil,
		getConfig("wenzimiaoshu").pvp["soulTemple"] and "soulTemple" or nil,
		getConfig("wenzimiaoshu").pvp["zhenFaWar"] and "zhenFaWar" or nil,
	}
	
	
	local open_level = {
		"athletics",
		"fb_rob",
		"diggings",
		"war",
		"tiexue" , 
		"power",
		godwar_open and "godwar" or nil,
		getConfig("wenzimiaoshu").pvp["soulTemple"] and "soulTemple" or nil,
		getConfig("wenzimiaoshu").pvp["zhenFaWar"] and "zhenFaWar" or nil,
	}
	
	level = self:getOrderList(level)

	for k, v in pairs(level) do

		local back, info, btn, descLayer, giftBtn
		
		info = KNBtn:new(COMMONPATH, {"info.png", "info_pre.png"}, 380, 70, {
			callback = function()
				btn:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.1, 1, 0), CCCallFunc:create(function()
					btn:setBg(1, COMMONPATH.."item_info_bg.png")
					info:showBtn(false)
					info:setEnable(false)
					
					giftBtn:showBtn(false)
					giftBtn:setEnable(false)
					
					btn:hideOther(true)
					btn:hideText(true)
					back = true
					
					descLayer = display.newLayer()
					descLayer:setContentSize(btn:getLayer():getContentSize())
					
					local text = display.newSprite(SCENECOMMON.."res_icon/info_text.png")
					setAnchPos(text,30, 50)
					descLayer:addChild(text)

					local gift = createLabel({str = getConfig("wenzimiaoshu","pvp", v, "descshow"),width = 300, color = ccc3(255,255,255)})
					setAnchPos(gift, 125, 80)
					descLayer:addChild(gift)
					
					gift = createLabel({width = 300, str = getConfig("wenzimiaoshu","pvp", v, "desc"), size = 16, color = ccc3(255,255,255)})
					setAnchPos(gift, 125, 70,0, 1)
					descLayer:addChild(gift)
					btn:getLayer():addChild(descLayer)
				end), CCScaleTo:create(0.1, 1, 1)))
			end
		})
		
		local text = { getConfig("wenzimiaoshu","pvp", v, "timedesc") or "" , 18, ccc3(0x32, 0x14, 0x0c), ccp(-120, 35), nil, 17}

		if v == "godwar" then 
			text =  { DATA_Info:get_type("godwarOpenTime") or "" , 18, ccc3(255, 255, 255), ccp(-100, 35), nil, 17} 
		end

		local open = checkOpened(v)		
		btn = KNBtn:new(PATH, {v..(open == true and "_new.png" or "_new_grey.png")}, 0, 0, {
			anchMid = true,
			other = ((open ~= true) and  {SCENECOMMON.."res_icon/lock.png", 0, -20} or nil), 
			text = text,
			callback = function()
				if back then
					btn:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.1, 1, 0), CCCallFunc:create(function()
						btn:setBg(1, PATH..v..(open == true and "_new.png" or "_new_grey.png"))
						btn:hideOther(false)
						btn:hideText(false)
						
						info:showBtn(true)
						info:setEnable(true)
						
						giftBtn:showBtn(true)
						giftBtn:setEnable(true)
						back = false
						btn:getLayer():removeChild(descLayer,true)
					end), CCScaleTo:create(0.0, 1, 1)))
					return 
				end
				if v == "diggings" then
					local check_result = checkOpened("diggings")
					if check_result ~= true then
						KNMsg:getInstance():flashShow(check_result)
						return
					end
	
					HTTP:call("mining","get",{},{success_callback = 
						function(data)
							switchScene("diggings", data)
						end})
				elseif  v  == "athletics" then
					local check_result = checkOpened("athletics")
					if check_result ~= true then
						KNMsg:getInstance():flashShow(check_result)
						return
					end
	
					HTTP:call("athletics","get",{},{success_callback = 
						function(data)
							switchScene("athletics",{data = data })	
						end})
				elseif  v  == "rob" then
					local check_result = checkOpened("fb_rob")
					if check_result ~= true then
						KNMsg:getInstance():flashShow(check_result)
						return
					end
	
					HTTP:call("rob", "get", {}, {
						success_callback = function(data)
							self:createRobFb(data)
						end
					})
				elseif  v  == "war" then
					HTTP:call("bangzhan","get_rank",{ },{success_callback =
					 function()
						 switchScene("gang" , { type = 15 ,back = "pvp", backFun = function() switchScene( "pvp", {coming = "war"} )end} )
					 end})
				 elseif  v  == "power" then
					 local check_result = checkOpened("power")
					if check_result ~= true then
						KNMsg:getInstance():flashShow(check_result)
						return
					end
					HTTP:call("socialclass","get_show_list",{ },{success_callback =
						 function(data)
						 switchScene("power" , {data = data, pvp = true} )
					 end})
				elseif  v  == "godwar" then
					HTTP:call("fengshen", "getEntrance", {}, {
						success_callback = function(data)
--							if data.first == 1 then
--								KNGuide:setStep( 10000 )	-- 新手引导
--							end
							heartBeatCtl(true)
							SOCKET:getInstance("battle"):call("log" , "out" , "logout" , {} , {
								success_callback = function()
									SOCKET:delInstance("battle")
									delayFun(0.1, function()
										SOCKET:getInstance("swar",data.ip, data.port):send("user", "login", 1002, {}, {
											success_callback = function()
												heartBeatCtl(nil, "new")
												HTTP:call("fengshen", "getJFSummary", {}, {
													success_callback = function(data)
														switchScene("godwar", {inWar = true, data = data, first = (data.first == 1 and true or nil)})
														audio.playMusic( IMG_PATH .. "sound/godwar_field.mp3" , true )
													end
												})
											end})
									end)
								end})
						end
					})
				elseif  v  == "swar" then
					HTTP:call("kuafu", "getEntrance", {}, {
						success_callback = function(data)
							if data.to == "corps" then
								HTTP:call("kuafu", "getAllCorps", {}, {
									success_callback = function(data)
										switchScene("swar_pre", data, function()
											if data.message and data.message ~= "" then
												KNMsg.getInstance():flashShow(data.message)
											end
										end)
									end
								})
	--						elseif data.to == "field" then
							else
								HTTP:call("kuafu", "getSummary", {}, {
									success_callback = function(data)
										switchScene("swar", data)
									end
								})
	--						else
	--							KNMsg.getInstance():flashShow("跨服战还未开启或已经结束")
							end
						end
					})
				elseif v == "tiexue" then 
					HTTP:call("trial","getInfo",{  } , {
								success_callback = function( data )
										--dump(data)
										data.backFun = function()

										end
										pushScene("bloodTrial",data)
										end
						})

				elseif v == "soulTemple" then 
					HTTP:call("empire","initEmpire",{  } , {
								success_callback = function(data)
									if tonumber(data.empire_info.first) == 1 then 
										KNGuide:setStep( 20000 )	-- 新手引导
									end
									switchScene("soulTemple" , { data = data ,  closeCallback = function() switchScene("pvp") end } )		
								end
						})
				elseif v == "zhenFaWar" then

					if tonumber(DATA_User:get("lv")) < 40 then 
						KNMsg:getInstance():flashShow("您的等级未达到40级，不能进入阵法战")
						return 
					end

					if table.nums( DATA_Info:get_type("zhenfa") ) == 0 then 
						requires(IMG_PATH, "GameLuaScript/Scene/zhenFaWar/zhenFaWarLayer"):showTip()
					else
						HTTP:call("zhenfawar","initData",{  } , { 
									success_callback = function(data)
										switchScene("zhenFaWar"  , {data = data} )			
									end
						})
					end
				end
			end
		
		})
		

		btn:getLayer():addChild(info:getLayer())
		
		local openTime
		if v == "soulTemple" and back then 
			btn:getLayer():addChild( display.strokeLabel("每周二到周日开放", 13, 80, 18, ccc3(0x32, 0x14, 0x0c)) )
			-- btn:getLayer():addChild( display.strokeLabel("测试时间 9.11-9.16号", 13, 60, 18, ccc3(0x32, 0x14, 0x0c)) )
		end


		giftBtn = KNBtn:new(SCENECOMMON.."res_icon/", {"bg.png"}, 10,10, {
			front = SCENECOMMON.."res_icon/"..getConfig("wenzimiaoshu","pvp", v, "show")..".png",
			scale = true,
			callback = function()
				KNMsg.getInstance():flashShow("可获得物品:"..getConfig("wenzimiaoshu","pvp", v, "descshow"))
			end
		})
		btn:getLayer():addChild(giftBtn:getLayer())
		
		if v == "godwar" then
			local voice = KNBtn:new(PATH,{"voice.png", "voice_pre.png"}, 40, 10,{
				callback = function()
					audio.playMusic("sound/"..CHANNEL_GROUP.."_voice.mp3", false)
				end
			})
			btn:getLayer():addChild(voice:getLayer())
			
		end 	
		
		des_scroll:addChild(btn:getLayer(), btn)
	end
	des_scroll:alignCenter(true)
	
	self.mainLayer:addChild(des_scroll:getLayer())
	
	local num 
	for k, v in pairs(level) do
		if v == name then
			num = k
			break
		end
	end 
	
	des_scroll:setIndex(num or 1,true)
	self.state = MAIN
	
	-- 新手引导
	local guide_step = KNGuide:getStep()
	if guide_step == 801 or guide_step == 3001 or guide_step == 3101 or guide_step == 3201 or guide_step == 3301 or guide_step == 5001 then
		local btn = des_scroll:getItems(num or 1)
		local btn_range = btn:getRange()

		KNGuide:show( btn:getLayer() , {
			x = btn_range:getMinX(),
			y = btn_range:getMinY(),
			callback = function()
				if guide_step == 5001 then
					local btn_range = guide_btn:getRange()
					KNGuide:show( guide_btn:getLayer() , {
						x = btn_range:getMinX(),
						y = btn_range:getMinY(),
						remove = true
					})
				else
					KNGuide:addStep()
				end
			end
		})
	end
	
	
	
	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH.."title.png",function()
			switchScene("home")
	end)
end

function PVPLayer:createMain1(name)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	
	self.mainLayer = display.newLayer()
		
--	local title = display.newSprite(PATH.."title.png")
--	setAnchPos(title, 245, 730, 0.5)
--	self.mainLayer:addChild(title)
--	
	local bg = display.newSprite(SCENECOMMON.."level_bg.png")
	setAnchPos(bg, 240, 590, 0.5)
	self.mainLayer:addChild(bg)
	
	bg = display.newSprite(COMMONPATH.."desc_bg.png") 
	setAnchPos(bg, 30, 110)
	self.mainLayer:addChild(bg)
	
	local group = KNRadioGroup:new()
	
	
	local coming = KNBtn:new(COMMONPATH,{"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 120, {
		scale = true,
		front = COMMONPATH.."coming.png",
		callback = function()
		
		end
	})
	self.mainLayer:addChild(coming:getLayer())
	
	local scroll = KNScrollView:new(35, 595, 410, 130, 2, true, 0, {
		priority = -190
	})
	local des_scroll 
	des_scroll =  KNScrollView:new(35, 90, 405, 490, 0, true, 1, {
		page_callback = function()
			group:chooseByIndex(des_scroll:getCurIndex())
			if checkOpened("fb_"..group:getId()) == true then
				coming:setFront(COMMONPATH.."coming.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red.png", COMMONPATH.."btn_bg_red_pre.png"})
			else
				coming:setFront(COMMONPATH.."coming_grey.png")
				coming:setBg(1, {COMMONPATH.."btn_bg_red2.png",COMMONPATH.."btn_bg_red2.png"})
			end
		end
	})

	local godwar_open = false
	if getConfig("wenzimiaoshu").pvp["godwar"] then
		godwar_open = true
	end
	
	local level = {
		"athletics",
		"rob",
		"diggings",
		"war",
		"power",
--		"swar" , --跨服战
		godwar_open and "godwar" or nil
	}
	local open_level = {
		"athletics",
		"fb_rob",
		"diggings",
		"war",
		"power",
--		"swar",
		godwar_open and "godwar" or nil
	}

	local guide_btn
	local function createContent(kind)
	--	if self.contentLayer then
	--		self.mainLayer:removeChild(self.contentLayer, true)
	--	end	
	--	
	--	self.contentLayer = display.newLayer()
		
		local layer = display.newLayer()
		
		
		local bg = display.newSprite(PATH..kind.."_desc.png")
		setAnchPos(bg, 8, 160)
		layer:addChild(bg)

		local text = display.newSprite(PATH..kind.."_text.png")
		setAnchPos(text, 395, 390, 1)
		layer:addChild(text)

		text = display.strokeLabel(getConfig("wenzimiaoshu", "pvp", kind, "desc"), 0, 60, 20,nil,nil,nil,{
			dimensions_width = 400,
			dimensions_height = 100,
		} )
		layer:addChild(text)
		
		if kind == "swar" then 
			-- 跨服战引导按钮
			guide_btn = KNBtn:new(COMMONPATH,{"btn_bg.png", "btn_bg_pre.png"},10,170,{
				front = PATH .. "guide.png",
				callback = function()
					HTTP:call("kuafu", "getEntrance", {}, {
						success_callback = function(data)
							if data.isZiGe and data.isZiGe == 1 then
								KNGuide:setStep( 5003 )

								KNGuide:show( coming:getLayer() , {
									remove = true
								})
							else
								KNMsg.getInstance():flashShow("当前无法进行引导，请在跨服战-资格赛阶段点击使用")
							end
						end
					})
				end
			})
			layer:addChild(guide_btn:getLayer())
		end
		

		layer:setContentSize(CCSizeMake(405, 450))
		return layer
	end
	
	for i = 1, #level do
		local btn = KNBtn:new(PATH,{level[i].."_icon.png", "select.png"}, 0, 0, {
			id = level[i],
			scale = true,
			parent = scroll,
			noHide = true,
			priority = -188,
			upSelect = true,
			selectZOrder = 1,
--			other = {PATH..level[i].."_name.png", 17, 0},
			callback = function()
--				createContent(level[i])
				des_scroll:setIndex(i)	
				
				if checkOpened(open_level[i]) == true then
					coming:setFront(COMMONPATH.."coming.png")
					coming:setBg(1, {COMMONPATH.."btn_bg_red.png", COMMONPATH.."btn_bg_red_pre.png"})
				else
					coming:setFront(COMMONPATH.."coming_grey.png")
					coming:setBg(1, {COMMONPATH.."btn_bg_red2.png",COMMONPATH.."btn_bg_red2.png"})
				end
				
			end
		},group)
		scroll:addChild(btn:getLayer(), btn)
		
		local desc = createContent(level[i])
		des_scroll:addChild(desc)
	end
	scroll:alignCenter()
	des_scroll:alignCenter()
	self.mainLayer:addChild(scroll:getLayer())
	self.mainLayer:addChild(des_scroll:getLayer())
		
	local num 
	for k, v in pairs(level) do
		if v == name then
			num = k
			break
		end
	end 
	
	group:chooseByIndex(num or 1)
	scroll:setIndex(num or 1 , true)
	des_scroll:setIndex(num or 1,true)
	self.state = MAIN

	-- 新手引导
	local guide_step = KNGuide:getStep()
	if guide_step == 801 or guide_step == 3001 or guide_step == 3101 or guide_step == 3201 or guide_step == 3301 or guide_step == 5001 then
		local btn = scroll:getItems(num or 1)
		local btn_range = btn:getRange()

		KNGuide:show( btn:getLayer() , {
			x = btn_range:getMinX(),
			y = btn_range:getMinY(),
			callback = function()
				if guide_step == 5001 then
					local btn_range = guide_btn:getRange()
					KNGuide:show( guide_btn:getLayer() , {
						x = btn_range:getMinX(),
						y = btn_range:getMinY(),
						remove = true
					})
				else
					KNGuide:show( coming:getLayer() )
				end
			end
		})
	end
	

	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH.."title.png",function()
		switchScene("home")
	end)
end



function PVPLayer:createRoleFb(kind)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	self.mainLayer = display.newLayer()
	
	local space
	if kind == "hero" then
		self.state = HERO
		space = 1.25
	else
		self.state = PET
		space = 1.5
	end
	
	local bg = display.newSprite(COMMONPATH.."bg_small.png")
	setAnchPos(bg, 240, 110, 0.5)
	self.mainLayer:addChild(bg)
	
	 bg = display.newSprite(PATH..kind.."_bg.png")
	setAnchPos(bg, 240, 150, 0.5)
	self.mainLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."gift_bg.png")
	setAnchPos(bg, 245, 620, 0.5)
	self.mainLayer:addChild(bg)
	
	local title = display.newSprite(PATH.."rest_time.png")
	setAnchPos(title,50,590)
	self.mainLayer:addChild(title)
	
	title = display.strokeLabel(DATA_Instance:get(kind,"point"), 130, 590, 20, ccc3(0xff, 0xfb, 0xd4))
	self.mainLayer:addChild(title)
	
	title = display.newSprite(PATH.."gift_text.png")
	setAnchPos(title, 130, 680)
	self.mainLayer:addChild(title)
	
	title = display.strokeLabel(getConfig("prop", DATA_Instance:get(kind,"current_award"),"name"),130, 650, 18)
	self.mainLayer:addChild(title)
	
	local refresh = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"},350, 650, {
		scale = true,
		front = COMMONPATH.."refresh_small.png",
		callback = function()
			HTTP:call("ins"..kind,"refresh",{},{
				success_callback = function()
					self:createRoleFb(kind)
					KNMsg.getInstance():flashShow("恭喜你刷到"..getConfig("prop",DATA_Instance:get(kind,"current_award"),"name"))
				end
			})
		end
		
	})
	self.mainLayer:addChild(refresh:getLayer())
	
	local gift = KNBtn:new(SCENECOMMON,{"skill_frame1.png"}, 50, 640, {
		scale = true,
		front = IMG_PATH.."image/"..getCidType(DATA_Instance:get(kind,"current_award")).."/s_"..DATA_Instance:get(kind,"current_award")..".png"
	})
	self.mainLayer:addChild(gift:getLayer())
	
	
	local x, y, t = 50, 490, DATA_Instance:get(kind, "inscount")
	local pass = DATA_Instance:get(kind,"pass")
	for i = 1,t do
		local bgStr = kind.."_disable.png"	
		for k, v in pairs(pass) do
			if v == i then
				bgStr = kind.."_enable.png"
				break
			end			
		end
		
		local btn = KNBtn:new(PATH,{bgStr}, x, y, {
			id = i,
			scale = true,
			callback = function()
				SOCKET:getInstance("battle"):call("ins"..kind , "execute" , "execute",{ins_id = i})
			end
		})
		self.mainLayer:addChild(btn:getLayer())
		x = x + btn:getWidth() * space 
		if i % 3 == 0 then
			x = 50
			y = y - btn:getHeight() * 1.15
		end
	end
	
	self.layer:addChild(self.mainLayer)
	self:createInfo(PATH..kind.."_title.png",function()
		self:createMain(kind)
	end)
end

function PVPLayer:getLayer()
	return self.layer
end

function PVPLayer:createInfo(title, func)
	if self.info then
		self.layer:removeChild(self.info:getLayer(), true)
	end
	self.info = InfoLayer:new("fb", 0, {tail_hide = true, title_text = title, closeCallback = func})
	self.layer:addChild(self.info:getLayer(),10)
end

function PVPLayer:createRobFb(data, star)
	if self.mainLayer then
		self.layer:removeChild(self.mainLayer,true)
	end
	local rob = RobLayer:new({data = data, star = star})
	
	self.mainLayer = rob:getLayer()
	self.layer:addChild(self.mainLayer)
	
	self:createInfo(PATH.."rob_title.png",function()
		if rob:getState() == 1 then
			self:createMain("rob")
		else
			self:createRobFb(data, rob:getStar())	
		end
	end)
end


function PVPLayer:popCardList(data, new)
	
	local index = 1
	local function pop(index)
		local card_popup = KNCardpopup:new(data[index] , function()
				if index == table.nums(data) then
					self:createHeroFb(new)
				else
					pop(index + 1)
				end
			end , {
				end_x = -80,
				end_y = -350,
			})
		display.getRunningScene():addChild(card_popup:play())						
	end
	pop(index)
end

return PVPLayer
