local Btn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local RadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local Progress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local HEADLINEPATH = IMG_PATH.."image/scene/headline/"
local ACTREEPATH=IMG_PATH.."image/scene/activity_new/moneytree/"
local MISSION=IMG_PATH.."image/scene/mission/"

local M={}
local award={}
local allPersonInfo={}
local amount=0
local myranking=0

--											排行榜场景

function M:new(params)

	dump(params)
	M:dataInit(params)

	local this={}
	setmetatable(this,self)
	self.__index=self 

	this.baseLayer = display.newLayer()
	this.curLayer = display.newLayer()
	this.baseLayer:addChild(this.curLayer,2)
	this.page = 1

	--		添加排行榜场景的背景
	local bg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(bg,0,425,0,0.5)
	this.baseLayer:addChild(bg)

	local scroll = KNScrollView:new(0,155,480,600,8,false)

	this.infoLayer = InfoLayer:new( 
			"rankListLayer" , 
			0 , 
			{ 
				title_text = COMMONPATH.."rankListTitle.png", 
				tail_hide = true, 
				closeCallback = function()
					--			返回我们的那个摇钱树的Layer(活动)
					popScene()
				end
			} 
		)
	this.baseLayer:addChild(this.infoLayer:getLayer())
	--			我的排名
	this.curLayer:addChild(display.newSprite(ACTREEPATH .. "my_rank.png" ,14,112, 0 , 0 ))	--我的排名
	local myLevel=""..myranking
	this.curLayer:addChild(display.strokeLabel(myLevel,131 ,113,24, ccc3( 228 , 227 , 226 )  ) )	--我的排名数据

	--			领取奖励
	local recAwardBtn = KNBtn:new( COMMONPATH , {"btn_bg_red.png","btn_bg_red_pre.png"},319 ,110 , {
				front=COMMONPATH.."get_award.png",
				scale = true,
				callback = function()
					HTTP:call("activity", "get_money_tree_ranking_award_show", {}, {
						success_callback = function(data)
							M:initAward(data)
							M:showShakeAwardPage()
						end
					})
				end
		}):getLayer()
	this.curLayer:addChild(recAwardBtn,1)

	--				添加名次列表
	amount=table.nums(allPersonInfo)
	for i = 1 ,amount do
		local item =M:createItemforPerson(allPersonInfo,i)
		scroll:addChild(item)
	end
	
	scroll:alignCenter()
	this.curLayer:addChild(scroll:getLayer(),10)

	return this 

end

function M:getLayer()
	return self.baseLayer
end

function M:initAward(params)

	if params.award then 
		local award1=params.award
		local awards=params.awards
		local len=table.nums(award1)
		for i=1,len do 
			award[i]=
			{
				cid=award1[i]["cid"],
				num=award1[i]["num"]
			}
		end 
	end
	
end

function M:dataInit(params)

	local len=table.nums(params.data.data)
	local data=params.data.data
	myranking=params.data.my_ranking

	if len>=50 then 

		for i=1,50 do 

			local username=data[i]["username"]
			local uid=data[i]["uid"]
			local ranking=data[i]["ranking"]
			local lv=data[i]["lv"]
			local grow_value=data[i]["grow_value"]
			local logo=data[i]["logo"]

			allPersonInfo[i]={
				name=username,
				lv=lv,
				groupUp="成长值: "..grow_value,
				uidName=uid,
				cid=""..logo
			}

		end 

	else

		for i=1,len do 

			local username=data[i]["username"]
			local uid=data[i]["uid"]
			local ranking=data[i]["ranking"]
			local lv=data[i]["lv"]
			local grow_value=data[i]["grow_value"]
			local logo=data[i]["logo"]

			allPersonInfo[i]={
				name=username,
				lv=lv,
				groupUp="成长值: "..grow_value,
				uidName=uid,
				cid=""..logo
			}

		end 

	end 
end

function M:createItem(params,index)

	params=params or { }
	local layer=display.newLayer()

	local bg = display.newSprite(COMMONPATH.."role_frame.png")
	setAnchPos(bg,-5,-5)
	layer:addChild(bg)
	layer:setContentSize(bg:getContentSize())

	
	local curProp = awardCell(params[index])
	setAnchPos(curProp,0,0)
	layer:addChild(curProp,1)
	layer:setContentSize(curProp:getContentSize())

	return layer

end

function M:showShakeAwardPage()

	local bgpath="tip_bg3.png";
	local tempLayer = baseMask({
			bgInfo = { 
				y = 238 ,  
				path = COMMONPATH  .. bgpath },
				priority = -129 
				}
	)

	local layer = display.newLayer()
	local bg = display.newSprite(ACTREEPATH.."awardshake.png")
	setAnchPos(bg, 238,666, 0.5, 0.5)
	local bgtitle = display.newSprite(MISSION.."title_bg.png")
	setAnchPos(bgtitle, 274,670, 0.5, 0.5)
	layer:addChild(bgtitle)
	layer:addChild(bg,1)
	tempLayer:addChild(layer,10)
	
	local str1="你在摇钱排行榜排第"..myranking.."名,可领取以下奖励:"

	tempLayer:addChild(display.strokeLabel(str1,45,580,20,ccc3(0 , 0 , 0)  ) )
	tempLayer:addChild(display.newSprite(ACTREEPATH.."common_bg.png",50,420,0,0))

		--				确认按钮
	local okBtn = KNBtn:new( COMMONPATH , {"btn_bg_red.png","btn_bg_red_pre.png"},75 ,335 , {
	front=ACTREEPATH.."get.png",
		scale = true,
		priority = -131,
		callback = function()

			HTTP:call("activity", "get_money_tree_ranking_award", {}, {
				success_callback = function(data)
					dump(data)
					KNMsg.getInstance():flashShow(data.msg)
				end
			})
			tempLayer:remove()
		end
	}):getLayer()
	tempLayer:addChild(okBtn)

	--				取消按钮
	local cancelBtn = KNBtn:new( COMMONPATH , {"btn_bg_red.png","btn_bg_red_pre.png"},255 ,335 , {
		front=COMMONPATH.."cancel.png",
		scale = true,
		priority = -131,
		callback = function()
			tempLayer:remove()
		end
	}):getLayer()
	tempLayer:addChild(cancelBtn)


	tempLayer:addChild(display.newSprite(ACTREEPATH.."common_bg.png",50,420,0,0))

	--							左右滑动显示奖励
	if scroll then 
		tempLayer:removeChild(scroll:getLayer(),true)
	end
	local scroll = KNScrollView:new(75,280,320,395,18,8)
	local len=table.nums(award)
	for i = 1 ,len do
		local item =M:createItem(award,i)
		scroll:addChild(item)
	end
	scroll:alignCenter()
	tempLayer:addChild(scroll:getLayer(),10)
end

function M:createItemforPerson(params,index)

		--			这里将做的工作是对我们的排行榜进行展示
	params=params or { }
	local layer=display.newLayer()
	local bg = display.newSprite( COMMONPATH .. "item_bg.png" )
	setAnchPos(bg,0,0)
	layer:addChild(bg)

	local name=params[index]["name"]
	layer:addChild( display.strokeLabel(name,100,56 ,21, ccc3( 0 , 0 , 0 )  ) )	--人物姓名
		
--	local lv=params[index]["lv"]
--	layer:addChild( display.strokeLabel(lv,100,35 ,18, ccc3( 0 , 0 , 0 )  ) )	--人物等级


	local personGroup=params[index]["groupUp"]
	layer:addChild( display.strokeLabel(personGroup,100,22,21, ccc3( 0 , 0 , 0 )  ) )	--人物成长值

--	local uid=params[index]["uidName"]
--	layer:addChild( display.strokeLabel(serverName,200,35 ,18, ccc3( 0 , 0 , 0 )  ) )	--人物等级

	local uid=params[index]["uidName"]
	-- CCLuaLog("uid:"..uid)
	local cid=params[index]["cid"]
	-- CCLuaLog("cid:"..cid)
	--添加英雄背景
	local icon = KNBtn:new(COMMONPATH , {getHeadPath(cid)} , 20 , 20 , {
				front = COMMONPATH.."role_frame.png",
				scale = true , 
				parent = parent,
				callback = function()
					if not uid  then
						switchScene("userinfo")
					else
						HTTP:call("profile","get",{ touid = uid },{success_callback = 
							function()
								local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
								display.getRunningScene():addChild( otherPalyerInfo:new():getLayer() )
							end})
					end
				end
			}):getLayer()
	layer:addChild(icon)

	local text,y,x
	local pos=index
	if pos < 4 then
		text = display.newSprite(ACTREEPATH..pos..".png")
		x = 410
		y = 22
	else
		text = display.strokeLabel(pos.."", 0, 0, 48, ccc3(0xed, 0x17, 0x16))
		if pos<10 then 
			x = 400
		elseif pos<100 then 
			x = 415
		elseif pos<1000 then 
			x = 420
		elseif pos<10000 then 
			x = 425
		elseif pos<100000 then 
			x = 430
		elseif pos<1000000 then 
			x = 435
		else
			x = 440 
		end 
			y = 30
	end
	setAnchPos(text, x, y, 1)
	layer:addChild(text)

	layer:setContentSize(bg:getContentSize())

	return layer
end


return M