local PATH = IMG_PATH.."image/scene/ranklist/"
local Btn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local RadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local Progress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local Item = requires(IMG_PATH, "GameLuaScript/Scene/ranklist/rankitem")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local HEADLINEPATH = IMG_PATH.."image/scene/headline/"
local RankLayer = {
	layer,
	group,
	rankLayer,
	page,
	pageText,
	curType,
	noMore,
	pre,
	next,
	worShipRankLayer,
	rankLayer,
	awardMaskLayer,
}

function RankLayer:new(kind)
	local this = {}
	setmetatable(this,self)
	self.__index = self
	dump(kind , "kind")
	this.layer = display.newLayer()
	this.page = 1
	
	local bg = display.newSprite(IMG_PATH.."image/scene/common/bg.png")
	setAnchPos(bg)
	this.layer:addChild(bg)
	
	bg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(bg,0,425,0,0.5)
	this.layer:addChild(bg)
	
	this.group = RadioGroup:new()

	--榜单类型按钮
	local rankType = {
		{"athletics"},
		{"level"},
		{"ability"},
	}

	if DATA_HeadLine:get("_ranking_headlines_state") then 
		rankType = {
			{'worShip'},
			{"level"},
			{"ability"},
		}
	end
	
	local x = 80
	for k, v in pairs(rankType) do
		
		if v[1] == "worShip" then
			local temp = Btn:new(HEADLINEPATH,{"tab_woship.png", "tab_woship_pre.png"},x-20, 680, {
				id = v[1],
				front = HEADLINEPATH.."woship_text.png",
				callback = function()
					HTTP:call("ranking","get",{type = "worship"},{
					success_callback=function(data)
						this:createWorShipRankLayer(data)
					end})
				end
			}, this.group)
			this.layer:addChild(temp:getLayer())
			x = x + 150
		else
			local temp = Btn:new(COMMONPATH.."tab/",{"tab_star_normal.png", "tab_star_select.png"},x, 680, {
				id = v[1],
				front = PATH..v[1]..".png",
				callback = function()
					this.page = 1
					this.noMore = false
	--				if DATA_Rank:get(v[1]) then
	--					if v[1] == "athletics" then
	--						HTTP:call("ranking","get",{type = v[1]},{success_callback=function()
	--							this:createRankLayer(v[1])
	--						end})
	--					else
	--						this:createRankLayer(v[1])
	--					end
	--				else
						HTTP:call("ranking","get",{type = v[1]},{success_callback=function(data)
							this:createRankLayer(v[1])
						end})
	--				end
				end
			}, this.group)
			this.layer:addChild(temp:getLayer())
			x = x + 120
		end
	end
	
	bg = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(bg, 10 , 675)
	this.layer:addChild(bg)
	
	-- bg = display.newSprite(COMMONPATH.."page_bg.png")
	-- setAnchPos(bg,240,110,0.5)
	-- this.layer:addChild(bg)
	

	
	
	-- 需要延迟发包
	local handle
	handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc( function()
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
		handle = nil
		
		this.group:chooseById(kind,true)
	end , 0.05 , false )
	
	local info = InfoLayer:new("rank", 0, {title_text = PATH.."rank_text.png" })
	this.layer:addChild(info:getLayer())
	
	return this
end

--创建排行列表
function RankLayer:createRankLayer(kind)
	if self.rankLayer then
		self.layer:removeChild(self.rankLayer:getLayer(),true)
	end	

	if self.worShipRankLayer then
		self.layer:removeChild( self.worShipRankLayer , true )
	end

	self:createPageLayer(kind)
	
	self.curType = kind
	self.rankLayer = KNScrollView:new(0, 160, 480, 510) 
	
--	local progress = Progress:new(IMG_PATH.."image/start_bar/bar/",{"bg.png","fore.png"},100,300)
--	self.rankLayer:addChild(progress:getLayer())
--	
	local y = 560
	local max = DATA_Rank:get(kind,"count") - (self.page - 1) * 20 
	if max > 20 then
		max = 20 
	else
		self.noMore = true
	end
	for i = 1, max do
		local temp = Item:new(kind, 15, y, i + (self.page - 1) * 20, self.rankLayer)
		self.rankLayer:addChild(temp:getLayer())
		
		y = y - temp:getHeight() - 10
	end
	self.rankLayer:alignCenter()

	self.layer:addChild(self.rankLayer:getLayer())
end

function RankLayer:createPageLayer(kind)
	if self.pageLayer then 
		self.layer:removeChild( self.pageLayer , true )
	end

	self.pageLayer = display.newLayer()
	--翻页按钮
	self.pre = Btn:new(COMMONPATH,{"next_big.png"}, 150, 100, {
		scale = true,
		flipX = true,
		callback = function()
			if self.page > 1 then
				self.page = self.page - 1
				self.noMore = false
				self:createRankLayer(self.curType)
			end
		end
	})
	self.pageLayer:addChild(self.pre:getLayer())

	self.next = Btn:new(COMMONPATH,{"next_big.png"}, 285, 100, {
		scale = true,
		callback = function()
			if not self.noMore then
				self.page = self.page + 1
				self:createRankLayer(self.curType)
			end
		end
	})
	self.pageLayer:addChild(self.next:getLayer())

	local page_bg = display.newSprite(COMMONPATH.."page_bg.png")
	setAnchPos(page_bg,240,110,0.5)
	self.pageLayer:addChild(page_bg , -1)

	self.pageText = display.strokeLabel(self.page.."/"..math.ceil(DATA_Rank:get(kind,"count") / 20) ,230,117,20,ccc3(0xff,0xfb,0xd4))
	setAnchPos(self.pageText, 240, 117, 0.5)
	self.pageLayer:addChild(self.pageText)

	self.layer:addChild( self.pageLayer )

end

function RankLayer:createWorShipRankLayer(param)
	if self.worShipRankLayer then
		self.layer:removeChild( self.worShipRankLayer , true )
	end

	if self.rankLayer then
		self.layer:removeChild(self.rankLayer:getLayer(),true)
	end	

	if self.pageLayer then 
		self.layer:removeChild( self.pageLayer , true )
	end

	self.worShipRankLayer = display.newLayer()

	local temp_img = display.newSprite( HEADLINEPATH .. "worship_frame.png" )
	setAnchPos( temp_img , 0 , 556 )
	self.worShipRankLayer:addChild( temp_img )	

	temp_img = display.newSprite( HEADLINEPATH .. "flag.png" )
	setAnchPos( temp_img , 10 , 550 )
	self.worShipRankLayer:addChild( temp_img )

	temp_img = display.newSprite( HEADLINEPATH .. "jie_num.png" )
	setAnchPos( temp_img , 50 , 570 )
	self.worShipRankLayer:addChild( temp_img )

	local scroll = KNScrollView:new( 20 , 150 , 440 , 410 , 5 , false , 0 , { priority = -149} )

	for i = 1 , #param.ranking do
		scroll:addChild( self:createWorShipItem(param.ranking[i] , scroll) )
	end

	local getBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png" } ,
			240 , 125 ,
			{
				priority = -201,
				front = HEADLINEPATH .. "award.png"  ,
				anchMid = true, 
				callback = 
				function()
					self:createAwardLayer(param)
				end
			})
	self.worShipRankLayer:addChild( getBtn:getLayer() )


	self.worShipRankLayer:addChild( display.strokeLabel( "第"..param.index.."届双周膜拜值榜："..param.endtime , 126 , 645 , 20 , ccc3(255 , 255 , 255) , 2 ) )
	self.worShipRankLayer:addChild( display.strokeLabel( "第"..param.index.."届新增膜拜值：" ..param.new_integration, 126 , 614 , 20 , ccc3(255 , 255 , 255), 2 ) )
	self.worShipRankLayer:addChild( display.strokeLabel( "累计膜拜值："..param.old_integration  , 126 , 583  , 20 , ccc3(255 , 255 , 255) , 2 ) )
	self.worShipRankLayer:addChild( display.strokeLabel( param.index  , 56 , 601  , 20 , ccc3(255 , 255 , 255) , 2 ) )

	self.worShipRankLayer:addChild( scroll:getLayer() )

	self.layer:addChild( self.worShipRankLayer )

end

function RankLayer:createWorShipItem(param , parent)
	-- dump(param)
	local itemLayer = display.newLayer()

	local item_bg = display.newSprite( COMMONPATH .. "item_bg.png" )
	setAnchPos( item_bg , 0 , 0 )
	itemLayer:addChild( item_bg )

	local icon = KNBtn:new(COMMONPATH, { getHeadPath(param.img) or 19001 },20,23,{
			priority = -150 ,
			front = COMMONPATH.."role_frame.png",
			parent = parent,
			callback = function()
			end 
		} )
	itemLayer:addChild(icon:getLayer())

	local text,y,x
	local pos = param.rank
	if pos < 4 then
		text = display.newSprite(PATH..pos..".png")
		x = 410
		y = 22
	else
		text = display.strokeLabel(pos.."", 0, 0, 48, ccc3(0xed, 0x17, 0x16))
		x = 410
		y = 30
	end
	setAnchPos(text, x, y, 1)
	itemLayer:addChild(text)

	itemLayer:addChild( display.strokeLabel( param.name or "" , 100 , 58 , 18 , ccc3(69 , 28 , 6) , 2 ) )
	itemLayer:addChild( display.strokeLabel( "膜拜新增值：" .. param.num or "", 220 , 50 , 18 , ccc3(69 , 28 , 6) , 2 ) )
	itemLayer:addChild( display.strokeLabel( "【" .. param.game .. "】" , 80 , 22 , 18 , ccc3(69 , 28 , 6) , 2 ) )

	itemLayer:setContentSize( item_bg:getContentSize() )
	return itemLayer
end

function RankLayer:createAwardLayer(param)
	if self.awardMaskLayer then 
		self.awardMaskLayer:remove()
	end

	local awardLayer = display.newLayer()

	local bg = display.newSprite(HEADLINEPATH.."worship_award_bg.png")
	setAnchPos(bg,240,242 , 0.5 )
	awardLayer:addChild(bg)  	

	bg = display.newSprite(IMG_PATH.."image/scene/activity_new/new_pkgame/".."title_bg.png")
	setAnchPos(bg,240,550 , 0.5 )
	awardLayer:addChild(bg) 	

	bg = display.newSprite(HEADLINEPATH.."award_frame_bg.png")
	setAnchPos(bg,240,418 , 0.5 )
	awardLayer:addChild(bg) 

	bg = display.newSprite(HEADLINEPATH.."two_worship_award.png")
	setAnchPos(bg,240,570 , 0.5 )
	awardLayer:addChild(bg) 

	bg = display.newSprite(HEADLINEPATH.."num_worship_award.png")
	setAnchPos(bg,46,377)
	awardLayer:addChild(bg) 

	bg = display.newSprite(HEADLINEPATH.."rank_label.png")
	setAnchPos(bg,125,337)
	awardLayer:addChild(bg) 

	local flag  = false

	if CHANNEL_GROUP == "tmsj" or CHANNEL_GROUP == "td" then
		awardLayer:addChild( display.strokeLabel( "第1名：服务器冠名权" , 110 , 514 , 20 , ccc3(69 , 28 , 6) , 2 ) )
		awardLayer:addChild( display.strokeLabel( "第2名：服务器冠名权" , 110 , 476 , 20 , ccc3(69 , 28 , 6) , 2 ) )
		awardLayer:addChild( display.strokeLabel( "第3名：服务器冠名权" , 110 , 438 , 20 , ccc3(69 , 28 , 6) , 2 ) )
		flag = true
	else
		awardLayer:addChild( display.strokeLabel( "第1名：服务器冠名权" , 110 , 476 , 20 , ccc3(69 , 28 , 6) , 2 ) )
		flag = false
	end

	local rankStr = ""
	if param.old_rank <= 20 then
		rankStr = "第"..param.old_rank.."名"
	else
		rankStr = "未进前20"
	end

	awardLayer:addChild( display.strokeLabel( param.old_index , 113 , 378 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	awardLayer:addChild( display.strokeLabel( param.z_integration , 312 , 378 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	awardLayer:addChild( display.strokeLabel( param.old_index , 167 , 337 , 20 , ccc3(69 , 28 , 6) , 2 ) )
	awardLayer:addChild( display.strokeLabel( rankStr , 270 , 337 , 20 , ccc3(69 , 28 , 6) , 2 ) )

    local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 581 , {
			priority = -201-2,
			scale = true,
			callback = function()
				self.awardMaskLayer:remove()
				self.awardMaskLayer = nil
			end})
	awardLayer:addChild(close:getLayer())
 	self.awardMaskLayer = KNMask:new({item = awardLayer, click = function(x, y)  end ,priority= -201})
 	self.layer:addChild(self.awardMaskLayer:getLayer() , 10)

 	local isComplete = false

 	if param.old_received and param.old_received[DATA_User:get("uid")..""] then
 		isComplete = true
 	end

 	local getBtn = KNBtn:new( COMMONPATH , ( isComplete and { "btn_bg_red2.png" } or { "btn_bg_red.png" ,"btn_bg_red_pre.png" } ) ,
						240 , 275 ,
						{
							priority = -201,
							front = COMMONPATH .. ( isComplete and "get_over.png" or "get_award.png" ) ,
							isEnable = not isComplete , 
							anchMid = true, 
							callback = 
							function()

								if param.index == 1 then 
									KNMsg:getInstance():flashShow( "领取失败，本届奖励需在下届领取" )
									return 
								end

								if (param.old_rank <= 3 and flag == true) or (param.old_rank == 1 and flag == false) then
									awardLayer:addChild(self:getAwardLayer(param):getLayer() , 10)
								else
									KNMsg:getInstance():flashShow( "领取失败，当前没有奖励可领" )
								end
								
							end
						})
	getBtn:setEnable( not isComplete )
	awardLayer:addChild( getBtn:getLayer() )

end

function RankLayer:getAwardLayer(param)

	local tempLayer = display.newLayer()
	local nameMask , name_input

	local bg = display.newSprite(HEADLINEPATH.."name_bg.png")
	setAnchPos(bg,240,300 , 0.5 )
	tempLayer:addChild(bg)  	

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 35 , 491 , {
	priority = -220-2,
	scale = true,
	callback = function()
		name_input:stopInput()
		nameMask:remove()
	end})
	tempLayer:addChild( close:getLayer() )

	tempLayer:addChild( display.strokeLabel( "请在框内，填写你要冠名的服务器名称:" , 72 , 464 , 20 , ccc3(69 , 28 , 6) , 2 ) )

	name_input = KNInputText:new(
 				{	width = 140, 
					height = 34, 
					size = 16 , 
					defStr = "请输入服务器名称", 
					existStr = nil,
					priority = -222,
					defColor = ccc3( 0x00, 0x00, 0x00 ), 
					inputColor = ccc3( 0x4d, 0x15, 0x15 )
				})
	setAnchPos( name_input:getLayer() , 170, 418 )
	tempLayer:addChild( name_input:getLayer() , 1 )


	local name_input_bg = KNBtn:new(HEADLINEPATH, {"input_bg.png"} , 160 , 400 , {
		priority = -222,
		callback = function()
			name_input:startInput()
		end
		}):getLayer()
	tempLayer:addChild( name_input_bg )

	local confirmBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" ,"btn_bg_red_pre.png" }, 240 , 340 , {
		priority = -220-2,
		front = COMMONPATH .. "confirm.png",
		anchMid = true, 
		callback = function()
			local nameString = name_input:getString()
			if nameString == "" then
				KNMsg:getInstance():flashShow( "名称不能为空" )
			elseif string.find(nameString, "%%") or string.find(nameString, "&") then
				KNMsg:getInstance():flashShow( "不能输入特殊字符" )
			else
				HTTP:call("headlines", "receive_gift", { name = nameString },{success_callback = 
					function(data)
						KNMsg:getInstance():flashShow( data.return_msg or "" )
						name_input:stopInput()
						nameMask:remove()
						param.old_received = data.old_received
						self:createAwardLayer(param)
					end})
			end

	end})

	-- local function onTouch(type, x , y)
	-- 	name_input:stopInput()
	-- 	return true
	-- end
	-- nameMask:getLayer():registerScriptTouchHandler(function(type,x,y) return onTouch(type,x,y) end, false , -210) 
	nameMask = KNMask:new({item = tempLayer, click = function(x, y)  end ,priority= -205 , click = function() name_input:stopInput() end})

	tempLayer:addChild( confirmBtn:getLayer() )
	
	return nameMask
end

function RankLayer:getLayer()
	return self.layer
end

return RankLayer