local PATH = IMG_PATH .. "image/scene/refreshpetskill/"
local PET_PATH = IMG_PATH .. "image/scene/pet/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
--[[刷新幻兽技能]]
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local Pet_Config = requires(IMG_PATH,"GameLuaScript/Config/Pet")
local Pet_SkillUpFee = requires(IMG_PATH,"GameLuaScript/Config/petupstagefee")
local Petskill_Config = requires(IMG_PATH,"GameLuaScript/Config/Petskill")
local ElementHeart_Config = requires(IMG_PATH,"GameLuaScript/Config/element")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")


local refreshLayer = {
	baseLayer,
	viewLayer,
	selectLayer,
	infolayer,
	iconGroup,
	select_sprite,
	skillListLayer,
	changeSkillListLayer,--能兑换技能列表
}

function refreshLayer:new(args)
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	this.args = args or {}
	local pet_id = this.args.id
	local pet_data = DATA_Bag:get("pet" , pet_id)
	local cid = pet_data.cid
	local config_data = Pet_Config[cid]
	local choosePetSkillCid   --选中的宠物技能cid,用于兑换


	this.baseLayer = display.newLayer()
	this.viewLayer = display.newLayer()


	-- 背景
	local bg = display.newSprite(COMMONPATH .. "dark_bg.png")
	setAnchPos(bg , 0 , 88)						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild(bg)

	local pet_bg = display.newSprite(COMMONPATH .. "bg_big.png")
	setAnchPos(pet_bg , 18 , 110)
	this.viewLayer:addChild(pet_bg)

	local top_bg = display.newSprite(PATH .. "top_bg.png")
	setAnchPos(top_bg , 28 , 490)
	this.viewLayer:addChild(top_bg)

	local middel_text = display.newSprite(PATH .. "middel_text.png")
	setAnchPos(middel_text , 55 , 455)
	this.viewLayer:addChild(middel_text)

	local bottom_bg = display.newSprite(PATH .. "bottom_bg.png")
	setAnchPos(bottom_bg , 28 , 215)
	this.viewLayer:addChild(bottom_bg)

	local max_skill_star = {
		[1] = 1,
		[2] = 2,
		[3] = 3,
		[4] = 4,
		[5] = 5,
	}
	local middle_label = display.strokeLabel( max_skill_star[config_data.star] , 248 , 456 , 24 , ccc3( 0x2c , 0x00 , 0x00 ) )
	this.viewLayer:addChild(middle_label)


	-- 技能文字
	local tiansheng_bg = display.newSprite(  PET_PATH .. "skill_type_bg.png" )
	this.viewLayer:addChild( tiansheng_bg )
	setAnchPos(tiansheng_bg , 34 , 645 )

	local tiansheng = display.newSprite(  PET_PATH .. "tiansheng.png" )
	this.viewLayer:addChild( tiansheng )
	setAnchPos(tiansheng , 54 , 658 )

	local xuexi_bg = display.newSprite(  PET_PATH .. "skill_type_bg.png" )
	this.viewLayer:addChild( xuexi_bg )
	setAnchPos(xuexi_bg , 34 , 530 )

	local xuexi = display.newSprite(  PET_PATH .. "xuexi.png" )
	this.viewLayer:addChild( xuexi )
	setAnchPos(xuexi , 54 , 543 )

	this.infolayer = InfoLayer:new("refreshpetskill" , 0 , {
		tail_hide = true , 
		title_text = PATH .. "title.png" , 
		closeCallback = function()
			switchScene("pet" , { gid = pet_id })
		end
	})
	this.baseLayer:addChild(this.infolayer:getLayer(),1)
	this.baseLayer:addChild(this.viewLayer)


	if this.args.data then
		this:showList(pet_id , this.args.data.pos)
		this:randOne(pet_id, this.args.data.pos, pet_data.skill[this.args.data.pos], this.args.data.skill_cid, pet_data.lv)
	else
		this:showList(pet_id , "a1")
	end

	return this.baseLayer 
end


function refreshLayer:showList(pet_id , pos)
	local pet_data = DATA_Bag:get("pet" , pet_id)
	local cid = pet_data.cid
	local config_data = Pet_Config[cid]


	if self.skillListLayer then
		self.baseLayer:removeChild(self.skillListLayer , true)
	end
	self.skillListLayer = display.newLayer()

	-- 显示6个技能格
	local pet_skills = pet_data.skill
	local x, y = 130, 650
	for i = 1 , 6 do
		local num = i <= 3 and i or i - 3 
		local kind = i <= 3 and "a" or "p"
		local temp_id = kind .. num
		local pet_skill_cid = pet_skills[temp_id]
		local lock
		local text , front
		local pet_skill_config

		if not isset(pet_skills , temp_id) then
			lock = true
		else
			pet_skill_config = getConfig("petskill" , pet_skill_cid .. "" )
			front = getImageByType(pet_skill_cid , "s")
			text = { { pet_skill_config.name , 14 , ccc3(0x2c, 0, 0) , ccp(0, -62)} }
		end

		local skill = KNBtn:new(SCENECOMMON, {lock and "skill_frame4.png" or "skill_frame2.png"}, x, y, {
			text = text,
			scale = true,
			front = front,
			other = pet_skill_cid and {COMMONPATH.."star_border/border_"..getConfig("petskill", pet_skill_cid, "star")..".png", -15, -16} or nil,
			callback = function()
				if lock then
					return false
				end

				self:selectOne(pet_id , temp_id)
			end
		})	
		self.skillListLayer:addChild(skill:getLayer())

		-- 显示星级
		if pet_skill_config then
			local star_num = pet_skill_config.star
			local star_init_x = x - 16 + (5 - star_num) * 10
			for i = 1 , star_num do
				local star = display.newSprite(COMMONPATH .. "star.png")
				star:setScale(0.7)
				setAnchPos(star , star_init_x + (i - 1) * 20 , y - 20)
				self.skillListLayer:addChild(star)
			end
		end
		
		x = x + 110
		if i % 3 == 0 then
			x = 130
			y = 535
		end
	end

	self.baseLayer:addChild(self.skillListLayer)

	self:selectOne(pet_id , pos)
end

   
--宠物信息界面 
function refreshLayer:selectOne( pet_id , id )
	if self.selectLayer then
		self.baseLayer:removeChild(self.selectLayer , true)
	end
	self.selectLayer = display.newLayer()

	if self.select_sprite == nil then
		self.select_sprite = display.newSprite(COMMONPATH .. "select1.png")
		self.baseLayer:addChild(self.select_sprite)
	end
	local pos_s = {
		["a1"] = {119 , 640},
		["a2"] = {229 , 640},
		["a3"] = {339 , 640},
		["p1"] = {119 , 525},
		["p2"] = {229 , 525},
		["p3"] = {339 , 525},
	}
	setAnchPos(self.select_sprite , pos_s[id][1] , pos_s[id][2])

	local pet_data = DATA_Bag:get("pet" , pet_id)
	local pet_skills = pet_data.skill
	local pet_skill_cid = pet_skills[id]
	local cid = pet_data.cid
	local config_data = Pet_Config[cid]
	self:showOneSkill(pet_skill_cid , 83 , 370 , pet_data.lv)

    --元素之心计量lab
   local yuanSuXin_label = display.strokeLabel("元素之心 : " , 70 , 190 , 18 , ccc3( 0x2c , 0x00 , 0x00) )
   self.selectLayer:addChild(yuanSuXin_label)

   --计量图标
   local elementStone0 = display.newSprite(PATH.."element_stone.png")
   setAnchPos(elementStone0, 155, 188)
   self.selectLayer:addChild(elementStone0)
	
	--元素之心计量
   local yuanSuXin = display.strokeLabel( DATA_Bag:countItems("prop", nil, {type = "heart"}) , 172 , 190 , 18 , ccc3( 0x2c , 0x00 , 0x00) )
   self.selectLayer:addChild(yuanSuXin)


	-- 显示兑换按钮,兑换技能layer
	
	local mask
	local change_btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 60 , 138 , {
		scale = true,
		front = PATH .. "changeSkill_btn.png",
		callback = function()

		    local skillLayer = display.newLayer()  --兑换技能layer
		    setAnchPos(skillLayer,0,0,0.5,0.5)
		    skillLayer:setScale(0)
           	--背景
		    local bg =  display.newSprite(PATH.."changeSkill_bg.png")
		    setAnchPos(bg, 240, 410, 0.5, 0.5)
		    skillLayer:addChild(bg)
		    --前景
		    local fbg =  display.newSprite(PATH.."changeSkill_fbg.png")
		    setAnchPos(fbg, 220, 243, 0.5 ,0.5)
		    bg:addChild(fbg)

		    
			changeSkillListLayer = self:choosePetSkillWithStarIndex(4,Petskill_Config[''..pet_skill_cid]['trigger'])  --默认第一次选中4星
			skillLayer:addChild(changeSkillListLayer)
		    --tab标签
			local group = KNRadioGroup:new()
				for i = 4 , config_data['star'] do  --4星,5星
					local tempBtn = KNBtn:new( PATH ,{"unSelected.png","selected.png"} , 30+(i-4)*110 , 545,{
						    priority = -131,
							disableWhenChoose = true,
							upSelect = true,
							id = i,
							front = {PATH .. i .."star.png",PATH.. i .."star_selected.png"},
							callback=
							function()
								if changeSkillListLayer then --如果存在,先清空
									changeSkillListLayer:removeFromParentAndCleanup(true)
								end
							  
							  changeSkillListLayer = self:choosePetSkillWithStarIndex(i,Petskill_Config[''..pet_skill_cid]['trigger'])
							  skillLayer:addChild(changeSkillListLayer)
							end
						},group):getLayer()
						
					skillLayer:addChild( tempBtn )
			 end

		    --标题背景
		    local changeSkill_title_bg = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
		    setAnchPos(changeSkill_title_bg, 240, 490, 0.5 ,0.5)
		    bg:addChild(changeSkill_title_bg)
		    
		    --标题
		    local changeSkill_title = display.newSprite(PATH.."changeSkill_title.png")
		    setAnchPos(changeSkill_title, 240, 490, 0.5 ,0.5)
		    bg:addChild(changeSkill_title)
  
           --消耗lab
           local elementStone_costLab = display.newSprite(PATH.."elementStone_costLab.png")
		    setAnchPos(elementStone_costLab, 70, 75, 0.5 ,0.5)
		    bg:addChild(elementStone_costLab)

		    
           local elementStone1 = display.newSprite(PATH.."element_stone.png")
		    setAnchPos(elementStone1, 105, 75, 0.5 ,0.5)   
		    bg:addChild(elementStone1)
		    
		    --拥有lab
            local elementStone_haveLab = display.newSprite(PATH.."elementStone_haveLab.png")
		    setAnchPos(elementStone_haveLab, 290, 75, 0.5 ,0.5)
		    bg:addChild(elementStone_haveLab)

		    local elementStone2 = display.newSprite(PATH.."element_stone.png")
		    setAnchPos(elementStone2, 325, 75, 0.5 ,0.5)
		    bg:addChild(elementStone2)

			local yuanSuXin = display.strokeLabel( DATA_Bag:countItems("prop", nil, {type = "heart"}) , 335 , 65 , 18 , ccc3( 0x2c , 0x00 , 0x00) )
   			bg:addChild(yuanSuXin)

   			--确定兑换
			local ok_btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 40 , 180 , {
					priority = -131,
					scale = true,
					front = COMMONPATH .. "ok.png",
					callback = function()
					    if choosePetSkillCid == nil then
					    	KNMsg.getInstance():flashShow("请选择一个需要兑换的技能")
					    	return
					    end
						HTTP:call("pet", "exchange_skill", { target = pet_id , pos = id ,exchange = choosePetSkillCid} , {success_callback = 
							function()
								--关闭该弹出层
								 mask:remove()
								 --刷新界面
						  		 self:showList(pet_id , id)
						  		 KNMsg.getInstance():flashShow("兑换技能成功")
							end})
					end
			})	
           skillLayer:addChild(ok_btn:getLayer())

			local cancle_btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 260 , 180 , {
					priority = -131,
					scale = true,
					front = COMMONPATH .. "cancel.png",
					callback = function()
						 --关闭该弹出层
						 skillLayer:runAction(getSequenceAction(CCEaseElasticIn:create(CCScaleTo:create(0.4,0.5)),CCCallFunc:create(function()
							mask:remove()
				  		 end)))
					end
			})
 			skillLayer:addChild(cancle_btn:getLayer())

			--弹出动画
			skillLayer:runAction(getSequenceAction(CCEaseElasticOut:create(CCScaleTo:create(0.5,1)),CCCallFunc:create(function()   end)))

			mask = KNMask:new({item = skillLayer, click = function(x, y)  end})
		    self.baseLayer:addChild(mask:getLayer())


		end
	})	
	self.selectLayer:addChild(change_btn:getLayer())

	-- 显示按钮
	local btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 280 , 138 , {
		scale = true,
		front = PATH .. "refresh_btn.png",
		callback = function()
			HTTP:call("pet" , "rand_skill" , {
				target = pet_id,
				pos = id
			} , {
				success_callback = function(d)
					self.args.config = d.tmp.fee_config
					local rand_data = d.tmp

					self:randOne(pet_id , id , pet_skill_cid , rand_data.skill_cid , pet_data.lv)
				end
			})
		end
	})
	self.selectLayer:addChild(btn:getLayer())

	-- 显示黄金
	local gold_sprite = display.newSprite(COMMONPATH .. "gold.png")
	setAnchPos(gold_sprite , 320 , 185)
	self.selectLayer:addChild(gold_sprite)

	local star = config_data.star
	local gold = self.args.config[star .. ""]
	local gold_label = display.strokeLabel( gold , 350 , 190 , 18 , ccc3( 0x2c , 0x00 , 0x00 ) )
	self.selectLayer:addChild(gold_label)
	
	self.baseLayer:addChild(self.selectLayer)
end


--petSkillStarIndex 技能星级
--triggerIndex 主被动 1,0
function  refreshLayer:choosePetSkillWithStarIndex( petSkillStarIndex , triggerIndex )
	    local  skillList = {} --某一星级所有技能列表
	    changeSkillListLayer=display.newLayer()
	    --Petskill_Config
	    for  k,v in pairs(Petskill_Config) do
		    if v['star'] == petSkillStarIndex and v['trigger'] == triggerIndex then
		    	skillList[k]=v
		    end
		end

		local tempScrollView = KNScrollView:new(35,273,410,270,5,false,0,{
	   		 priority = -131,
	    	--debug=true,
	    })
	
	 	local colunmIndex = 1   --列,每3列换一行
	 	local count = 0
	 	local tempLayer 

	 	local group = KNRadioGroup:new()
		for k,v in pairs(skillList) do
		 	 	
		 	 	if count%3 == 0 then
			 	 	tempLayer= display.newLayer()
					
			 	 	tempLayer:setContentSize(CCSizeMake(410,135))
			 	    setAnchPos(tempLayer)
			 	 	tempScrollView:addChild(tempLayer,tempLayer)
		 	 	end

				local btn 
				btn = KNBtn:new(SCENECOMMON, {"box.png","select1.png"}, 17+(colunmIndex-1)*150, 60, {
							 front = getImageByType(k,"s"),
							 frontScale = {1, -3, 4},
							 noHide=true,
							 scale = true,
							 priority = -131,
							 id=k,
							 selectZOrder =25,
					   		 parent = tempScrollView,
					   		 other = {COMMONPATH.."star_border/border_"..getConfig("petskill", k,"star")..".png", -15, -13},
							 text = {v["name"], 15, ccc3(0x2c, 0, 0), ccp(0, -70)},
							 callback = function()
								 choosePetSkillCid=btn:getId() --选中要兑换的技能
								 
							 end

						 },group)
				tempLayer:addChild(btn:getLayer())
				group:cancelChoose()

				--创建等级星星标识,4个或者5个星星
	 			local  starIconLayer= display.newLayer()
	 			starIconLayer:setContentSize(CCSizeMake(140,30))
					for i=1,petSkillStarIndex do
						local starSp = display.newSprite(COMMONPATH.."star.png")
						starIconLayer:addChild(starSp)
						setAnchPos(starSp,(i-1)*20,0)
						starSp:setScale(0.7)
					end
	            tempLayer:addChild(starIconLayer)
	            setAnchPos(starIconLayer,5+(colunmIndex-1)*150,38)

				if (count+1)%3 ==0 then
					colunmIndex=0
				end

			 	colunmIndex=colunmIndex+1
			 	count=count+1

	 	end
	 	--读取元素之心配置,获取相应星级的消耗量
 		for  k,v in pairs(ElementHeart_Config) do
		    if k == petSkillStarIndex then
		    	--需要消耗的元素之心计量
		    	local yuanSuXinNum = display.strokeLabel(v['buy'] , 135 , 230 , 18 , ccc3( 0x2c , 0x00 , 0x00) )
                changeSkillListLayer:addChild(yuanSuXinNum)
		    end
		end
 
	tempScrollView:alignCenter()
    changeSkillListLayer:addChild(tempScrollView:getLayer())

    return changeSkillListLayer
end

function refreshLayer:randOne(pet_id , pos , old_cid , new_cid , pet_lv)
	if self.selectLayer then
		self.baseLayer:removeChild(self.selectLayer , true)
	end
	self.selectLayer = display.newLayer()


	self:showOneSkill(old_cid , 83 , 370 , pet_lv)
	self:showOneSkill(new_cid , 323 , 370 , pet_lv)
    
   --元素之心提示文字
   local yuanSuXinTips_label = display.strokeLabel("放弃保存该技能,将获得元素之心,可兑换高级技能." , 30 , 190 , 18 , ccc3( 255 , 0 , 0 ) )
   self.selectLayer:addChild(yuanSuXinTips_label)


	-- 显示放弃按钮
	local cancel_btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 60 , 138 , {
		scale = true,
		front = PATH .. "giveUp_btn.png",
		callback = function()
			HTTP:call("pet", "del_tmp_skill", {}, {
				success_callback = function(data)
					
					self:selectOne(pet_id , pos)
					KNMsg.getInstance():flashShow("元素之心    +" ..data["awards"]["drop"]["16039"])
				end
			})
		end
	})	
	self.selectLayer:addChild(cancel_btn:getLayer())

  

	-- 显示按钮
	local save_btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png" , "btn_bg_red_pre.png"}, 280 , 138 , {
		scale = true,
		front = COMMONPATH .. "save.png",
		callback = function()
			HTTP:call("pet" , "save_skill" , {
				target = pet_id,
				pos = pos
			} , {
				success_callback = function(d)
					self:showList(pet_id , pos)
				end
			})
		end
	})	
	self.selectLayer:addChild(save_btn:getLayer())

	-- 搞一个遮罩层，让用只能点按钮
	local maskLayer = PlayerGuide:createSprite()
	maskLayer:show(440 , 330 , ccp(20 , 120) , 0 , function()
		
	end , function()
		KNMsg.getInstance():flashShow("请先保存或者取消技能刷新结果")
	end)
	self.selectLayer:addChild(maskLayer)


	
	self.baseLayer:addChild(self.selectLayer)
end

function refreshLayer:showOneSkill( cid , x , y , pet_lv )
	local pet_skill_config = getConfig("petskill" , cid .. "" )
	local front = getImageByType(cid , "s")
	local text = { { pet_skill_config.name , 14 , ccc3(0x2c, 0, 0) , ccp(0, -62)} }

	local skill = KNBtn:new(SCENECOMMON, {"skill_frame2.png"} , x , y , {
		text = text,
		front = front,
		other = {COMMONPATH.."star_border/border_"..getConfig("petskill", cid, "star")..".png", -15, -16},
	})	
	self.selectLayer:addChild(skill:getLayer())

	-- 显示星级
	if pet_skill_config then
		local star_num = pet_skill_config.star
		local star_init_x = x - 16 + (5 - star_num) * 10
		for i = 1 , star_num do
			local star = display.newSprite(COMMONPATH .. "star.png")
			star:setScale(0.7)
			setAnchPos(star , star_init_x + (i - 1) * 20 , y - 20)
			self.selectLayer:addChild(star)
		end
	end

	
	--[[
	local desc_label = display.strokeLabel( pet_skill_config[pet_stage .. ""]["desc"] , x - 40 , y - 150 , 16 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , {
		dimensions_width = 155 ,
		dimensions_height = 95,
		align = 0
	})
	]]
	-- self.selectLayer:addChild(desc_label)
	local skill_lv = math.floor(pet_lv / 10) + 1
	skill_lv = skill_lv > 10 and 10 or skill_lv
	local desc_label = KNTextField:create({
		str = pet_skill_config[skill_lv .. ""]["desc"],
		width = 155,
		size = 16,
	})
	--ios 字体兼容
	desc_label:setDimensions( CCSize:new( 155 , desc_label:getContentSize().height+10 ) )


	local scroll = KNScrollView:new( x - 40 , y - 145 , 155 , 95 , 1 , false )
	scroll:addChild( desc_label )
	scroll:alignCenter()
	self.selectLayer:addChild( scroll:getLayer() )
end

return refreshLayer