--[[

选区

]]


local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
local M = {}

local select_server_id , select_server_name
local PATH = IMG_PATH .. "image/scene/servers/"
function M:create( params )
	-- dump(params, "params")
	local default_server_id = params.default_server_id
	local servers = params.servers

	local default_server , tempDefault_server
	local server_name_label
	local curState
	-- 获取默认选区
	for i = 1 , #servers do
		if servers[i].server_id == default_server_id then
			default_server = servers[i]
			break
		end
	end
	tempDefault_server = default_server
	select_server_id = default_server_id
	select_server_name = tempDefault_server.name

	local layer = display.newLayer()

	local imgStr = IMG_PATH .. "image/scene/login/bg.jpg"

	if CHANNEL_GAME == "ayou" then 
		if CHANNEL_ID == "DK" or CHANNEL_ID == "nd91" or CHANNEL_ID == "BD" then 
			imgStr = IMG_PATH .. "image/scene/login/ly_bg_other.jpg"
		else
			imgStr = IMG_PATH .. "image/scene/login/ly_bg.jpg"
		end
	end

	local bg = display.newSprite(imgStr , 0 , 0 , 0 , 0 )
	layer:addChild( bg )

	if CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
		display.newSprite(IMG_PATH .. "image/scene/login/role.png", display.cx, 536):addTo(layer)
		display.newSprite(IMG_PATH .. "image/scene/login/logo.png", display.cx, 321):addTo(layer)
	end
	
	
	local function setCurState()
		if curState then
			curState:removeFromParentAndCleanup( true )
			curState = nil
		end
		curState = display.newSprite( PATH .. default_server.type .. ".png" )
		setAnchPos(curState , 78 , 138)
		layer:addChild( curState )
	end
	
	-----------------------------------------------------------------------------
	-- 合服
	local setLable
	local getLableInfo = function(str, merge)
		local merge_info = ""
		if type(merge) == "table" then

			local sortFunc = function( l , r )
				return l < r
			end

			table.sort( merge, sortFunc )
			merge_info = "合：" .. merge[1] .. "区" .. "至" .. merge[#merge] .. "区" 
			-- for i = 1, #merge do
			-- 	if i == 1 then merge_info = "合" end
			-- 	merge_info = merge_info .. merge[i] .. "区"
			-- 	if i ~= #merge then merge_info = merge_info .. ", " end
			-- end
		end

		local isMerged = merge_info ~= ""
		return isMerged, (isMerged and (str .. "\n" .. merge_info) or str)
	end
	-----------------------------------------------------------------------------

	local function createList()
		
		local listLayer = display.newLayer()
		local mask
		local scroll = KNScrollView:new( 30 , 250 , 420 , 570 , 5 , false , 0 , { priority = -133 } )
		local group = KNRadioGroup:new()
		
		listLayer:addChild( display.newSprite( PATH .. "server_bg.png" , display.cx , 190 , 0.5 , 0 ) )
		
		
		local function createTitle( name )
			local tempTitle = display.newSprite( PATH .. name .. ".png" , display.cx , 0 , 0.5 , 0 )
			tempTitle:addChild( display.newSprite( PATH .. "line.png" , tempTitle:getContentSize().width/2 , -5 , 0.5 , 0 ) )
			return tempTitle
		end
		
		
		
		local function createItem( itemData , itemGroup )
			local _, info = getLableInfo(itemData.name, itemData.merge)
			return KNBtn:new( PATH , { "item_bg.png"  , "select.png" } , 0 , 0 , {
				parent = scroll ,
				priority = -132 ,
				noHide = true ,
				upSelect = true ,
				selectZOrder = 1 ,
				text = { { info, 14 , ccc3( 0xff , 0xfa , 0xd4 ) , { x = 25 , y = 0 }  , true , 20 } }  ,
				other = { PATH .. itemData.type .. ".png"  , 140 , 14 , -2 } ,
				callback = function()
					default_server = itemData
				end
			} , itemGroup or nil )
		end
		
		scroll:addChild( createTitle("recently_title") )
		
		
		local function createItemGroup( _data , isGroup )
			local lastData = _data or {}
			for i = 1 , math.ceil( #lastData/2 ) do
				local itemLayer = display.newLayer()
				itemLayer:setContentSize( CCSize:new( 420 , 57 ) )
				for j = 1 , 2 do
					local index = ( i - 1 ) * 2 + j
					if lastData[index] then
						local curItem = createItem( lastData[index] , isGroup and group or nil )
						setAnchPos( curItem:getLayer() , ( j == 1 and 0 or 210 ), 0 )
						itemLayer:addChild( curItem:getLayer() )
						
						if default_server.server_id == lastData[index].server_id then
							group:chooseBtn( curItem , true )
						end 
					end
				end
				scroll:addChild( itemLayer , itemLayer )
			end
		end
		local lastData = {}
		for i = 1 , #params.last_login_servers do
			for key , v in pairs(servers) do
				if v.server_id == params.last_login_servers[i] then
					lastData[ #lastData + 1 ] = v 
				end
			end
		end
		
		createItemGroup( lastData , true )
		scroll:addChild( createTitle("all_title") )
		createItemGroup( servers , true )	--所有服务器列表
		scroll:alignCenter()
		listLayer:addChild( scroll:getLayer() )
		
		
		--确定
		listLayer:addChild( KNBtn:new(COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 70 , 200 , {
					front =  COMMONPATH .. "confirm.png" ,
					priority = -142,
					scale = true,
					callback = function()
						mask:remove()
						setLable(default_server.name, default_server.merge)
						select_server_id = default_server.server_id
						select_server_name = default_server.name
						tempDefault_server = default_server 
						
						setCurState()
					end
				}):getLayer() )
		--取消
		listLayer:addChild( KNBtn:new(COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png" } , 260 , 200 , {
					front =  COMMONPATH .. "cancel.png" ,
					priority = -142,
					scale = true,
					callback = function()
						default_server = tempDefault_server
						mask:remove()
					end
				}):getLayer() )
	
		mask = KNMask:new( { item = listLayer } )
		setAnchPos( listLayer , 0  , display.height )
		transition.moveTo( listLayer , { time = 0.5 , y = 0 , easing = "BACKOUT" })
		
		layer:addChild( mask:getLayer() )
	end

	local serverBtn = KNBtn:new( PATH , { "small.png" } , 29 , 120 , { 
		text = { { "点击选区" , 20 , ccc3( 0x29 , 0xbc , 0xce ) , { x = 316 , y = 0 }  , true , 20 } } ,
		callback = createList 
	})
	
	layer:addChild(  serverBtn:getLayer() )
	
	--设置当前服务器状态
	setCurState()

	server_name_label = CCLabelTTF:create("", FONT , 20)
	server_name_label:setColor( ccc3( 0xff , 0xff , 0xff ) )
	layer:addChild( server_name_label )

	-- 注意
	local temp = serverBtn:getLayer()
	local info = "相同账号在不同服拥有角色(该2区合服),登录角色以前的服进入游戏"
	local notice = display.strokeLabel( info, temp:getPositionX(), temp:getPositionY() - 18 - 3, 14, ccc3( 0x00, 0xff, 0xff ), nil, nil,
	{
		dimensions_width = temp:getContentSize().width,
		dimensions_height = 18,
		align = 1,
	})
	layer:addChild(notice)

	setLable = function(str, merge)
		local isMerged, info = getLableInfo(str, merge)
		server_name_label:setString(info)

		if isMerged then
			notice:setVisible(true)
			setAnchPos(server_name_label , 140, 124)
		else
			setAnchPos(server_name_label , 145, 140)
			notice:setVisible(false)
		end

	end

	setLable(default_server.name, default_server.merge)

	



	local login_callback = function()
		-- 获取下发的登录服务器
		CONFIG_HOST = default_server.host
		CONFIG_SOCKET_HOST = default_server.socket
		CONFIG_SOCKET_PORT = default_server.port
		if default_server.payurl ~= nil and default_server.payurl ~= "" then
			CONFIG_PAY_URL = default_server.payurl
		end

		-- 发请求
		local post_data = {
			server_id = select_server_id ,
			channel = CHANNEL_ID,
		}
		for k , v in pairs(device.infos) do
			post_data[k] = v
		end
		HTTP:call("login" , "develop" , post_data , {
			success_callback = function()

				--登陆的时候保存 server_name
				DATA_GodCell:setType("server_name" ,select_server_name )

				if CHANNEL_ID == "appFame" then
					LuaCallAppFrameSDK:getInstance():setServIdServName(DATA_Session:get("server_id"),"大话水浒")
					if DATA_User:get("name") then
						LuaCallAppFrameSDK:getInstance():setRoleIdRoleName(DATA_Session:get("uid"),DATA_User:get("name"))
					end
				elseif CHANNEL_ID == "appFameOfficial" or CHANNEL_ID == "appFameOfficial2" then
					if __INNER_IOS_SDK_VER and __INNER_IOS_SDK_VER >= 4 then
						local params = {
							type = "set_server_id",
							id = DATA_Session:get("server_id") .."",
							name = select_server_name
						}
						channel_delegate:getInst():call(json.encode(params), function() end)
						if DATA_User:get("name") then
							params = {
									type = "set_role_id",
									id = DATA_Session:get("uid") .."",
									name = DATA_User:get("name") .."",
									level = DATA_User:get("lv") ..""
							}
							channel_delegate:getInst():call(json.encode(params), function() end)
						end
					else
	                    LuaCallAppFameSDKOfficial:getInstance():setServIdServName(DATA_Session:get("server_id"),"武松XX潘金莲")
	                    if DATA_User:get("name") then
							LuaCallAppFameSDKOfficial:getInstance():setRoleIdRoleName(DATA_Session:get("uid"),DATA_User:get("name"))
						end
					end

				-- elseif CHANNEL_ID == "hy.xinmei" or CHANNEL_ID == "hy.changmeng" or CHANNEL_ID == "hy.changmeng1" or CHANNEL_ID == "hy.changmeng2" or CHANNEL_ID == "hy.changmeng1" or CHANNEL_ID == "hy.changmeng2" or CHANNEL_ID == "tgxy.yiwan.ewan" or CHANNEL_ID == "tmsj.yiwan.ewan" then
				-- 	if DATA_User:get("name") then 
				-- 		DirectChannel.instance():call(
				-- 		{
				-- 			action = "loginServer",
				-- 			dataType = "1",
				-- 			server_id = select_server_id,
				-- 			server_name = select_server_name,
				-- 			user_id = DATA_Session:get("uid"),
				-- 			user_lv = DATA_User:get("lv"),
				-- 			user_name = DATA_User:get("name"),
				-- 			callback = function()
								
				-- 			end
				-- 		})
					-- end
				end
			end
		})
	end


	local start_callback = function()
		if CHANNEL_ID == "tmsj.heitao" or CHANNEL_ID == "tmsj.heitao1" then 
			DirectChannel.instance():call(
				{
					action = "startGame",
			
					callback = function(reponse)
						if reponse["canEnter"] == "true" then 
							login_callback()
						end
					end
				})
		elseif  CHANNEL_ID == "tmsj.htios" then
			if LuaCallHeiTaoSDK:getInstance():startGame() then
				login_callback()
			end
		else
			login_callback()
		end
	end

	-- 登录按钮
	login_btn = KNButton:new("login" , 0 , display.cx , 20 , start_callback , 1 , { noDisable = true })
	setAnchPos(login_btn , display.cx - 120 , 13, 0.5)
	layer:addChild( login_btn )
	

	return layer
end



return M
