--多人副本主界面

local M = {
	baseLayer,
	title,
	layer,
	warObj,
	talk,
	talkLayer,
	refresh,
	receive
}

local PATH = IMG_PATH .. "image/scene/silverwar/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local War = requires(IMG_PATH, "GameLuaScript/Scene/silverwar/warlayer")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")



local run_logic = nil
local scheduler = CCDirector:sharedDirector():getScheduler()
local priority = -151

function M:new(args)
	dump(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	this.params = args or {}
	this.params.msg = {}
	this.baseLayer = display.newLayer()
	
	local bg = display.newSprite(COMMONPATH.."dark_bg_long.png")
	setAnchPos(bg, 240, 0, 0.5)
	this.baseLayer:addChild(bg)
	
	if this.params.fight then
		this:createFight(this.params.fight)
	else
		this:createMain(this.params)
	end
	return this
end

function M:getLayer()
	return self.baseLayer
end

function M:createBtnWithStar(params,x,y,i,k)
	-- body
	local light = params.list[i..""].light ~=0
	dump(light)
	local bg =  light and {i..".png",i.."_pre.png"} or {i.."_dis.png",i.."_dis.png"}
	local checkpointStar  = KNBtn:new(PATH,bg,x,y,{
		priority = priority,
		callback = function()
			-- body
			HTTP:call("commonfuben","getMissionInfo",{fuben_type = params.fuben_type,mission_id=i,degree = params.fuben_type..k},{
				success_callback = function(data)
					-- body
					dump(data)
					local layer = display.newLayer()

					local mask = KNMask:new({item = layer,priority = -170})

					local infoBg = display.newSprite(COMMONPATH .. "change_bg.png")
					setAnchPos(infoBg,10,120)

					local infoTitle = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
					local infoText = display.newSprite(PATH.."title_text.png")
					setAnchPos(infoText,132,38,0.5,0.5)
					infoTitle:addChild(infoText)

					setAnchPos(infoTitle,260,560,0.5,0.5)
					infoBg:addChild(infoTitle)

					local checkpointInfoBg = display.newSprite(PATH.."checkpoint_info_bg.png")
					setAnchPos(checkpointInfoBg,22.5,20)
					infoBg:addChild(checkpointInfoBg)

					for i=0,1 do
						local transparent = display.newSprite(PATH.."transparent.png")
						setAnchPos(transparent,15,171-i*64)
						checkpointInfoBg:addChild(transparent)
					end


					local presentCheckpoint = display.newSprite(PATH.."present_checkpoint.png")
					setAnchPos(presentCheckpoint,30,440)
					checkpointInfoBg:addChild(presentCheckpoint)

					local presentCheckpointText = createLabel({str = data.mission.name,x= 125,y=445,size = 18,width = 100,color = ccc3(233,233,233)})
					checkpointInfoBg:addChild(presentCheckpointText)

					local function refreshInfoStar(data)
						-- body
							local starLayer = display.newLayer()
							dump(data)
							local a = data.mission.star
							local x = 207.5- a*17.5
								for n=1,data.mission.star do
										local star = display.newSprite(PATH.."star.png")
										setAnchPos(star,x+(n-1)*35,387)
										starLayer:addChild(star)
								end
							

						checkpointInfoBg:addChild(starLayer,1,1001)
					end 

					refreshInfoStar(data)

					local noVipX  = data.vip >= 1 and 265 or 165
					local refreshStarBg = data.vip >=1 and {"refreshstar.png","refreshstar_pre.png"} or {"refreshstar_dis.png","refreshstar_dis.png"}

					local refreshStar = KNBtn:new(PATH,refreshStarBg,noVipX,275,{
						priority = -171,
						callback = function()
							-- body
							HTTP:call("commonfuben","refreshStar",{fuben_type = params.fuben_type,five_star = 0,mission_id = i},{
								success_callback = function(refreshData)
									-- body
									dump(refreshData)

									HTTP:call("commonfuben","getMissionInfo",{fuben_type = params.fuben_type,mission_id = i,degree = params.fuben_type..k},{
										success_callback = function(data)
											-- body
										dump(data)
										checkpointInfoBg:removeChildByTag(1001,true)
										refreshInfoStar(data)
										KNMsg:getInstance():flashShow("刷星成功,当前星级:"..data.mission.star)											
										end
										})
								end
								})
						end
						})
					local gold1 = display.newSprite(COMMONPATH.."gold.png")
					setAnchPos(gold1,30,-13,0.5,0.5)
					refreshStar:getLayer():addChild(gold1)
					local refreshPrice = createLabel({str = data.refresh_price.common.."",size = 18,width=50,x=47,y=-23,color = ccc3(255,255,255)})
					refreshStar:getLayer():addChild(refreshPrice)
					checkpointInfoBg:addChild(refreshStar:getLayer())

					if data.vip >=1 then

					local  oneclickBg = data.vip >=4 and {"oneclick.png","oneclick_pre.png"} or {"oneclick_dis.png","oneclick_dis.png"}


					local oneclick = KNBtn:new(PATH,oneclickBg,70,275,{
						priority = -171,
						callback = function()
							-- body
							HTTP:call("commonfuben","refreshStar",{fuben_type = params.fuben_type,five_star = 1,mission_id = i},{
								success_callback = function(data)
									-- body
									dump(data)
									HTTP:call("commonfuben","getMissionInfo",{fuben_type = params.fuben_type,mission_id = i,degree = params.fuben_type..k},{
										success_callback = function(data)
											-- body
											dump(data)
										checkpointInfoBg:removeChildByTag(1001,true)
										refreshInfoStar(data)		
										KNMsg:getInstance():flashShow("一键五星成功")									
										end
										})
								end
								})
						end
						})
					local gold2 = display.newSprite(COMMONPATH.."gold.png")
					setAnchPos(gold2,30,-13,0.5,0.5)
					oneclick:getLayer():addChild(gold2)
					local oneclickPrice = createLabel({str = data.refresh_price.five.."",size = 18,width=50,x=47,y=-23,color = ccc3(255,255,255)})
					oneclick:getLayer():addChild(oneclickPrice)
					checkpointInfoBg:addChild(oneclick:getLayer())
				end


					local starx = 110 
					local stary = 205
					for n=0,4 do
						for m=0,n do
							local star = display.newSprite(COMMONPATH.."star.png")
							setAnchPos(star,starx+m*34,stary)
							checkpointInfoBg:addChild(star)
						end
						starx= starx-17
						stary = stary - 32

					end


					for i=1,5 do
						local reward = display.newSprite(PATH.."reward_text.png")
							setAnchPos(reward,250,205-(i-1)*32)
							checkpointInfoBg:addChild(reward)
						local silver
						if params.fuben_type == "silver" then
							silver = display.newSprite(COMMONPATH.."silver.png")
							setAnchPos(silver,306,205-(i-1)*32)
							checkpointInfoBg:addChild(silver)
						elseif params.fuben_type == "sourcehope" and CHANNEL_GROUP == "hy" then
							silver = createLabel({str = "能量",x = 306,y = 210-(i-1)*32,size = 18, width = 40 , color =ccc3(0,0,0)})
							checkpointInfoBg:addChild(silver)
						elseif params.fuben_type == "sourcehope" and CHANNEL_GROUP ~= "hy" then
							silver = createLabel({str = "灵源",x = 306,y = 210-(i-1)*32,size = 18, width = 40 , color =ccc3(0,0,0)})
							checkpointInfoBg:addChild(silver)
						elseif params.fuben_type == "exp" then
							silver = createLabel({str = "经验",x = 306,y = 210-(i-1)*32,size = 18, width = 40 , color =ccc3(0,0,0)})
							checkpointInfoBg:addChild(silver)
							elseif params.fuben_type == "cuilian" then
							silver = createLabel({str = "淬炼石",x = 306,y = 210-(i-1)*32,size = 14, width = 50 , color =ccc3(0,0,0)})
							checkpointInfoBg:addChild(silver)
							elseif params.fuben_type == "skill" then
							silver = createLabel({str = "技能币",x = 306,y = 210-(i-1)*32,size = 14, width = 50 , color =ccc3(0,0,0)})
							checkpointInfoBg:addChild(silver)
					end
						local rewardNum = createLabel({str = data.award[i],x = 350,y=210-(i-1)*32,size = 18,width = 100,color = ccc3(0,0,0)})
						checkpointInfoBg:addChild(rewardNum)
						
					end

					local challengeBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},35,20,{
						front = PATH.."challenge.png",
						priority = -171,
						callback = function()
							-- body
							if run_logic ~= nil then
								CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(run_logic)
							end
							SOCKET:getInstance("battle"):call("commonfuben" , "challenge" , "execute" , { fuben_type = params.fuben_type,degree = params.fuben_type..k,mission_id = i } )

						end
						})

					local addAttributeBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},232,20,{
						front = PATH.."up_text.png",
						priority = -171,
						callback = function()
							-- body
							HTTP:call("commonfuben","getMissionInfo",{fuben_type = params.fuben_type,mission_id = i,degree = params.fuben_type..k},{success_callback  = function(addAttributeData)
								-- body
							local layer = display.newLayer()

							local mask = KNMask:new({item = layer,priority = -172})

							local addAttributeBg = display.newSprite(IMG_PATH.."image/scene/headline/name_bg.png")
							setAnchPos(addAttributeBg,240,400,0.5,0.5)

							local textInfo
							if params.fuben_type == "silver" then
									textInfo = "银两"
								elseif params.fuben_type == "sourcehope" and CHANNEL_ID == "hy" then
									textInfo = "灵源"
									elseif params.fuben_type == "sourcehope" and CHANNEL_ID ~="hy" then
										textInfo = "能量"
								elseif params.fuben_type == "exp" then
									textInfo = "经验"
									elseif params.fuben_type == "cuilian" then
										textInfo = "淬炼"
                                        elseif params.fuben_type == "skill" then
                                        textInfo = "技能"
							end

							local explainText = createLabel({str = "说明：属性加成针对"..textInfo.."副本中所有关卡有效，重新挑战副本加成属性清零。",x=30,y=180,size=18,width = 380,color = ccc3(255,0,0)})
							addAttributeBg:addChild(explainText)

							local heroUpText = display.newSprite(PATH.."hero_up_text.png")
							setAnchPos(heroUpText,35,120)
							addAttributeBg:addChild(heroUpText)

							local function refreshAttributeNum(data)
								-- body
								local addNumText =createLabel({str = data.addition.."%",x = 256,y = 125,size = 24,width = 200,color = ccc3(0,0,0)}) 
								addAttributeBg:addChild(addNumText,1,1002)
								
								local afterAddtionNumText = createLabel({str = data.after_addition <=100 and data.after_addition.."%" or "" , x = 337, y = 125 , size = 24, width = 180 ,color = ccc3(200,80,80)})
								addAttributeBg:addChild(afterAddtionNumText,1,1003)
								
								local addPrice = createLabel({str = data.promote_price , x= 295,y = 16 ,size = 18, width = 100,color = ccc3(10,10,10)})
								addAttributeBg:addChild(addPrice,1,1004)

								if data.after_addition <=100 then
								local arrow = display.newSprite(PATH.."arrow.png")
								setAnchPos(arrow,310,128)
								addAttributeBg:addChild(arrow,1,1100)
								end
							end 
							refreshAttributeNum(addAttributeData)
							local cancelBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png", "btn_bg_red_pre.png"} ,  30 , 40 ,{
								front = COMMONPATH.."cancel.png",
								priority = -172,
								callback = function()
									mask:remove()
								end
							})
							addAttributeBg:addChild(cancelBtn:getLayer())

							local add = KNBtn:new(COMMONPATH,{"btn_bg_red.png", "btn_bg_red_pre.png"} ,  230 , 40 ,{
								front = PATH.."up.png",
								priority = -172,
								callback = function()
									HTTP:call("commonfuben","promote",{fuben_type = params.fuben_type},{
										success_callback = function(data)
											-- body
											dump(data)
											addAttributeBg:removeChildByTag(1002,true)
											addAttributeBg:removeChildByTag(1003,true)
											addAttributeBg:removeChildByTag(1004,true)
											addAttributeBg:removeChildByTag(1100,true)
											refreshAttributeNum(data)
											KNMsg:getInstance():flashShow("提升成功")
										end
										})
								end
							})
							local gold = display.newSprite(COMMONPATH.."gold.png")
							setAnchPos(gold,50,-13,0.5,0.5)
							add:getLayer():addChild(gold)

							addAttributeBg:addChild(add:getLayer())

							layer:addChild(addAttributeBg)

							self.layer:addChild(mask:getLayer())
						end
							})
						end
						})
					checkpointInfoBg:addChild(addAttributeBtn:getLayer())
					checkpointInfoBg:addChild(challengeBtn:getLayer())

					local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 10 , 495 , {
							priority = -201-2,
							scale = true,
							callback = function()
								mask:remove()
								HTTP:call("commonfuben","getMissionList",{fuben_type = params.fuben_type,degree = params.fuben_type..k},{
									success_callback = function(data)
										-- body
										dump(data)
										if run_logic ~= nil then
											CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(run_logic)
										end
										self:createMain(data)
									end
									})

							end})
					infoBg:addChild(close:getLayer())


					layer:addChild(infoBg)

					self.layer:addChild(mask:getLayer())
			
			end})
		end
		})
	dump(params.list)
	if params.list[i..""].light == 1 then
		local a = params.list[i..""].star
		local x = 70 - a*10
		for n=1,params.list[i..""].star do
		local star = display.newSprite(PATH.."star.png")
		star:setScale(0.6)
		setAnchPos(star,x+20*(n-1),-5,0.5,0.5)
		checkpointStar:getLayer():addChild(star)
	end
end
		if params.list[i..""].pass == 0  and params.list[i..""].light ==1 then

				local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
				local tip = display.playFrames(0, 0,frames, 0.2, {
					forever = true,
				})
				setAnchPos(tip,53,37,0.5,0.5)
				checkpointStar:getLayer():addChild(tip, 2)	
			
	end
	local checkpointUp = display.newSprite(PATH.."checkpoint".."_"..i..".png")
	setAnchPos(checkpointUp,53,75,0.5,0.5)
	checkpointStar:getLayer():addChild(checkpointUp,3)

	return checkpointStar
end

function M:createMain(params)
	self.refresh = 0
	dump(params)
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()

	local bgMap = display.newSprite(PATH.."bgSilver.jpg")
	setAnchPos(bgMap,0,0)
	self.layer:addChild(bgMap)

	local back = KNBtn:new(IMG_PATH .. "image/scene/login/",{"back.png","back_pre.png"},15,770,{
		priority = priority,
		callback = function()
			-- body
			if run_logic ~= nil then
			scheduler:unscheduleScriptEntry(run_logic)
			end
			switchScene("multiFb")
		end
		})
	self.layer:addChild(back:getLayer())

	local checkpoint1 = self:createBtnWithStar(params,158,745,1,params.degree)

	self.layer:addChild(checkpoint1:getLayer())

	local checkpoint2 = self:createBtnWithStar(params,250,605,2,params.degree)

	self.layer:addChild(checkpoint2:getLayer())

	local checkpoint3 = self:createBtnWithStar(params,215,420,3,params.degree)

	self.layer:addChild(checkpoint3:getLayer())

	local checkpoint4 = self:createBtnWithStar(params,110,330,4,params.degree)

	self.layer:addChild(checkpoint4:getLayer())

	local checkpoint5 = self:createBtnWithStar(params,155,185,5,params.degree)

	self.layer:addChild(checkpoint5:getLayer())

	local treasureBox = display.newSprite(PATH.."treasurebox.png")
	setAnchPos(treasureBox,250,100,0.5,0.5)
	self.layer:addChild(treasureBox)

	if CHANNEL_GROUP == "hy" and params.fuben_type == "sourcehope" then

	local treasureText = display.newSprite(PATH.."power_text.png")
	setAnchPos(treasureText,380,100,0.5,0.5)
	self.layer:addChild(treasureText)
else
	local treasureText = display.newSprite(PATH..params.fuben_type.."_text.png")
	setAnchPos(treasureText,380,100,0.5,0.5)
	self.layer:addChild(treasureText)
end

	dump(params.five_star_pass)
	local openBg = (params.five_star_pass == 1 and params.receive_box_award == 0) and {"open.png","open_pre.png"} or {"open_dis.png","open_dis.png"}
	local openBtn = KNBtn:new(PATH,openBg,220,40,{
		priority = priority,
		callback = function()
						 if params.five_star_pass == 1 then
							local  layer = display.newLayer()
							local mask = KNMask:new({item = layer,priority = -171})
							local bg  = display.newSprite(IMG_PATH.."image/scene/headline/name_bg.png")
							setAnchPos(bg,240,427,0.5,0.5)
							layer:addChild(bg)

							local treasureShowText
							if params.fuben_type == "silver" then 
								treasureShowText = "银两"
								elseif params.fuben_type == "sourcehope" and CHANNEL_ID ~= "hy" then
									treasureShowText = "灵源"
									elseif params.fuben_type == "sourcehope" and CHANNEL_ID == "hy" then
										treasureShowText = "能量"
									elseif params.fuben_type == "exp" then 
										treasureShowText = "经验"
										elseif params.fuben_type == "cuilian" then
											treasureShowText = "淬炼石"
                                            elseif params.fuben_type == "skill" then
                                            treasureShowText = "技能币"
									end

							local showAward = display.newSprite( IMG_PATH .. "image/scene/fb/fbBox/" .. params.fuben_type .. "_desc.png" , 30  ,170 , 0  ,0 ):addTo(bg)

							local openTreasureShowNum = createLabel({str = params.award,x = 218, y = 5 , size = 18,width = 100 ,color = ccc3(0,0,0) })
							showAward:addChild(openTreasureShowNum)

							local openNeedGold = display.newSprite(COMMONPATH.."gold.png")
							setAnchPos(openNeedGold,71,69)
							bg:addChild(openNeedGold)

							local openTreasureShowNum = createLabel({str = params.award,x = 218, y = 5 , size = 18,width = 100 ,color = ccc3(0,0,0) })
							showAward:addChild(openTreasureShowNum)

							dump(params , "params")

							local keyImg = display.newSprite( IMG_PATH .. "image/scene/fb/fbBox/"..params.open_key_cid..".png" , 255 , 65 , 0 , 0 ):addTo(bg)
							keyImg:addChild( createLabel({str = params.open_key_need .. " (现拥有 " ..  (params.open_key_num or "")..")" , x = 37 , y = 3 , size = 18 , width = 260, color = ccc3(0,0,0)}) )



							local keyImg = display.newSprite( IMG_PATH .. "image/scene/fb/fbBox/17178.png" , 255 , 37 , 0 , 0 ):addTo(bg)
							keyImg:addChild( createLabel({str = params.open_key_need .. " (现拥有 " ..  params.open_key_universal_num..")" , x = 37 , y = 3 , size = 18 , width = 260, color = ccc3(0,0,0)}) )

							local openTreasureNeedNum = createLabel({str = params.open_box_gold,x = 37 , y = 0 , size = 18 , width = 100, color = ccc3(0,0,0)})
							openNeedGold:addChild(openTreasureNeedNum)

							bg:addChild( createLabel({str = "(钥匙开启时优先消耗副本钥匙,再消耗万能钥匙)",x = 14 , y = 13 , size = 18 , width = 400, color = ccc3(182,49,52)}) )

							local function doSuccess_callback(_data)
								KNMsg:getInstance():flashShow(_data.msg)
								local handler
								local function delayRealize()
									CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handler)
									handler = nil

									switchScene("multiFb")
								end
								handler = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(delayRealize ,1, false)
							end

							local ybOpenBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},41,97,{
								front = IMG_PATH .. "image/scene/fb/fbBox/yuanbao_open.png",
								priority = -171,
								callback = function()
									-- body
									HTTP:call("commonfuben","openAwardBox",{fuben_type = params.fuben_type , type="yuanbao"},{

										success_callback = function(awardData)
											-- body
											doSuccess_callback(awardData)
											
										end
										})
								end
								}):getLayer():addTo(bg)

							local keyOpenBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png", "btn_bg_red_pre.png"} ,  240 , 97 ,{
								front = IMG_PATH .. "image/scene/fb/fbBox/key_open.png",
								priority = -172,
								callback = function()
									HTTP:call("commonfuben","openAwardBox",{fuben_type = params.fuben_type , type="key"},{

										success_callback = function(awardData)
											-- body
											doSuccess_callback(awardData)
										end
										})
								end
							}):getLayer():addTo(bg)

							KNBtn:new(COMMONPATH,{"back_img.png", "back_img_press.png"} ,  7 , 200 ,{
								priority = -172,
								callback = function()
									mask:remove()
								end
							}):getLayer():addTo(bg)

							self.layer:addChild(mask:getLayer())
						 else
						 	KNMsg:getInstance():flashShow("全五星通关方可开启宝箱")
						 end
					end
				})



	self.layer:addChild(openBtn:getLayer())
    self.baseLayer:addChild(self.layer)


	local minute = math.floor(params.box_time/60)
	local second = params.box_time%60
	dump(params)
	dump(minute)
		local function updateTime()
			if 	self.layer then
				self.layer:removeChildByTag(1005,true)
				self.layer:removeChildByTag(1006,true)
			end
		    second = second-1
		    if second == -1 then
		        if minute ~= -1 then
		            minute = minute-1
		            second = 59
		            if minute == -1 then
		                if run_logic ~= nil then
		                    scheduler:unscheduleScriptEntry(run_logic)
		                        run_logic = nil
		                end
		                second = 0
		                minute = 0 
		            end
		        end
		    end
		    
		    second = second..""
		    minute = minute..""
		    
		    if string.len(second) == 1 then
		        second = "0"..second
		    end
		    
		    if string.len(minute) == 1 then
		        minute = "0"..minute
		    end

		    local timeText = createLabel({str = "宝箱消失倒计时：",x= 320,y = 50,size = 18, width = 200 , color =ccc3(255,255,255)})
		    local timeNum = createLabel({str = minute..":"..second,x= 340,y = 25,size = 18 ,width = 200,color= ccc3(255,255,255)})
		    
		    self.layer:addChild(timeText,1,1005)
		    self.layer:addChild(timeNum,1,1006)
		end
	if params.five_star_pass == 1 and params.receive_box_award == 0 then
			run_logic = scheduler:scheduleScriptFunc(updateTime,1,false)
	end
end

function M:optTip(kind)
	if kind == "exit" then
		showTip({
			priority = -160,
			content = createLabel({str = "确定要退出房间吗？", size = 24, width = 300}),
			left = {
				path = COMMONPATH, 
				normal = "btn_bg_red.png",
				pre = "btn_bg_red_pre.png",
				front = COMMONPATH.."ok.png",
				callback = function()
					HTTP:call("singlefb", "leave", {}, {
						success_callback = function()
							switchScene("multiFb")
						end})
				end
			},
			right = {
				path = COMMONPATH,
				front = COMMONPATH.."cancel.png",
				normal = "btn_bg_red.png",
				pre = "btn_bg_red_pre.png",
				remove = true,
			}
		})
	end
end

function M:startWarClock()
--	--加一个计时器，一段时间未收到消息则重新获取数据
--	Clock:addTimeFun("multiWarRefresh", function()
--		if self.refresh > 34 then
--			self.receive = false
--	 		HTTP:call("singlefb", "getCLInfo", {}, {
--		 		no_loading = true,
--				success_callback = function(data)
--					if not self.receive then
--				 		self:createFight(data)
--			 		end
--				end
--			})
--			self.refresh = 0 
--		else
--			self.refresh = self.refresh + 1
--		end
--	end)
end

function M:warLogic(kind, data)
	if self.warObj then
		self.refresh = 0
		self.receive = true
		self.warObj:logic(kind, data)
		self:startWarClock()
	else
		print("no war obj found, maybe error")
	end
end

function M:createFight(data)
	local function newWar(info)
		self.refresh = 0
		if self.layer then
			self.baseLayer:removeChild(self.layer, true)
		end
		dump(info)
		self.warObj = War:new(info.event == 3 and "normal" or "boss", info, self.params.fbCid)
		self.layer = self.warObj:getLayer()
		self.baseLayer:addChild(self.layer)
	end
	
	if data then
		newWar(data)
	else
		HTTP:call("singlefb", "getCLInfo", {}, {
		success_callback = function(data)
			newWar(data)
		end
		})
	end
	
end


function M:buy( type , id , index )
	self.buyLayer = display.newLayer()
	local baseX = display.cx
	local baseY = display.cy - 28
	
	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos( bg , baseX - 193 , baseY , 0 , 0 )
	self.buyLayer:addChild(bg)
	
	--物品Icon
	local icon = KNBtn:new( SCENECOMMON , { "skill_frame1.png" } , baseX - 148 , baseY + 135 , {  front = getImageByType(DATA_Shop:get(index , "cid") , "s") } )
	self.buyLayer:addChild( icon:getLayer() )	
	
	-- 名字
	self.name = display.strokeLabel( DATA_Shop:get(index,"name") , baseX - 75 , baseY + 170 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = 130 , dimensions_height = 30 ,align = 0 } )
	self.buyLayer:addChild( self.name )
	
	--花费总数
	local valueBg = display.newSprite(PATH.."value_bg.png")
	valueBg:setScaleY(0.89)
	setAnchPos(valueBg , baseX - 17 , baseY + 130 , 0.5)
	self.buyLayer:addChild(valueBg)
	
	local gold = display.newSprite(COMMONPATH .. "gold.png")
	setAnchPos(gold , baseX - 75  , baseY + 140 )
	self.buyLayer:addChild(gold)
	
	local priceText = display.strokeLabel( DATA_Shop:get(index,"real_price") , baseX - 40 , baseY + 135 , 20 , ccc3(0x2c , 0x00 , 0x00 ) , nil , nil ,{ dimensions_width = 80 , dimensions_height = 30 ,align = 0} )
	self.buyLayer:addChild(priceText)
	
	
	--购买数量
	local numText = display.newSprite(PATH.."num_text.png")
	setAnchPos(numText,baseX + 55  , baseY + 140 , 0 )
	self.buyLayer:addChild(numText)
	
	--购买数量
	local numBg = display.newSprite(PATH.."num_bg.png")
	local num = 1 
	setAnchPos(numBg,baseX + 116 , baseY + 136 , 0 )
	self.buyLayer:addChild(numBg)
	
	--数量文本
	local numText = display.strokeLabel( 1 .. "" , baseX + 116 , baseY + 136 , 20 , ccc3(0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 36 , dimensions_height = 30 ,align = 1 } )
	self.buyLayer:addChild(numText)
	
	
	addBtn:getLayer():setScale( 0.9 )
	minusBtn:getLayer():setScale( 0.9 )
	self.buyLayer:addChild(addBtn:getLayer())
	self.buyLayer:addChild(minusBtn:getLayer())
	
	local mask = KNMask:new( {item = self.buyLayer } ):getLayer()
	--确定，取消按钮
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, baseX - 134 , baseY + 28 ,{
		front = COMMONPATH.."ok.png" ,
		scale = true,
		priority = -130,
		callback = function()
			if not countGold(priceText:getLabel():getString()) then
				return
			else
				HTTP:call("shop" , "buy" , {
					id = id,
					num = num
				} , {
					success_callback = function()
						KNMsg.getInstance():flashShow("购买成功")
						
						self.baseLayer:removeChild(mask,true)
						
						self:refreshMoney()
					end
				})
			end

		end
	})
	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , baseX + 54 , baseY + 28 ,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			self.baseLayer:removeChild(mask,true)
		end})
	self.buyLayer:addChild(ok:getLayer())
	self.buyLayer:addChild(cancel:getLayer())
	
	self.baseLayer:addChild(mask)
end

function M:refreshData(data, kind)
	self.receive = true
	if kind == "search" then
		if data.event == 1 then -- 开格子
			self.params.map[data.data.pos..""] = data.data.finish
		elseif data.event == 2 then -- 奖励
		elseif data.event == 3 then -- 有怪物
		elseif data.event == 4 then -- boss
		end
		
	elseif kind == "move" then
	elseif kind == "leave" then
		if isset(data, "leader") then 
			self.params.leader = data.leader 
			if tonumber(DATA_User:get("uid")) == tonumber(data.leader) then
				showTip({
					priority = -171,
					content = createLabel({str = "您成为了房主，请带领队员继续探险", width = 300, size = 20}),
					center = {
						remove = true,
					} 
				})
			else
				KNMsg.getInstance():flashShow("房主"..data.name.."退出副本，房主已变更为"..data.leaderName)
			end
		else
			KNMsg.getInstance():flashShow(data.name.."退出副本")
		end
	elseif kind == "msg" then
		table.insert(self.params.msg, data)
		if table.nums(self.params.msg) > 2 then
			table.remove(self.params.msg, 1)
		end
	elseif kind == "buy" then   --购买探索次数
	elseif kind == "over" then  --副 本时间结束，强制所有人退出
		HTTP:call("fubenroom", "hasPermission", {}, {
			success_callback = function(data)
				switchScene("multiFb", {data}, function()
					KNMsg.getInstance():flashShow("副本超时，房间强制解散")
				end )
			end})
		return 
	end
	
	if isset(data, "spanRemain") then self.params.spanRemain = data.spanRemain end
	if isset(data, "remainSearch") then self.params.remainSearch = data.remainSearch end
	if isset(data, "pos") then self.params.pos = data.pos end
	if isset(data, "finish") then self.params.map[data.pos..""] = data.finish end
	if isset(data, "event") then self.params.event = data.event end
	
	if kind == "fight" then
		self:startWarClock()
		self:createFight()
	else
		--若战斗不存在则更新界面，否则保持 原状态
		if not self.warObj then
			self:createMain(self.params)
		else
			self.warObj:removeUser(data.uid)
		end
	end
	
end


return M