--多人副本主界面

local M = {
	baseLayer,
	title,
	layer,
	warObj,
	talk,
	talkLayer,
	refresh,
	receive,
	infoLayer,
	mainLayer,
}

local PATH = IMG_PATH .. "image/scene/skillConvert/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local War = requires(IMG_PATH, "GameLuaScript/Scene/silverwar/warlayer")
local KNSlider = requires(IMG_PATH, "GameLuaScript/Common/KNSlider")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")



local run_logic = nil
local scheduler = CCDirector:sharedDirector():getScheduler()
local priority = -151

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	-- dump(args)
	
	this.params = args or {}
	this.params.msg = {}
	this.baseLayer = display.newLayer()
	
	local bg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(bg, 240, 88, 0.5)
	this.baseLayer:addChild(bg)
	

	this.infoLayer = InfoLayer:new(layerName, 0, {title_text = PATH.."skill_convert_title.png",tail_hide = true, priority = -150, closeCallback = function()
		-- body
		switchScene("multiFb")
	end})

	this.baseLayer:addChild(this.infoLayer:getLayer(),1)

	this:createMain(args)

	return this
end

function M:getLayer()
	return self.baseLayer
end


function M:createMain(params)
	if self.mainLayer then
		self.baseLayer:removeChild(self.mainLayer,true)
	end

	self.mainLayer = display.newLayer()

	local line = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(line, 5, 690)
	self.mainLayer:addChild(line,1)

	local mySkillCoin = display.newSprite(PATH.."left_skill_coin.png")
	setAnchPos(mySkillCoin,20,710)
	self.mainLayer:addChild(mySkillCoin)

	local skillCoinImg = display.newSprite(PATH.."skill_coin.png")
	setAnchPos(skillCoinImg,145,710)
	self.mainLayer:addChild(skillCoinImg)

	local coinNum = params['skill_coin']

	local skillCoinNum = createLabel({str = coinNum,x = 175,y = 712,size = 21,width = 200, color = ccc3(255,255,255)})
	self.mainLayer:addChild(skillCoinNum,1,1024)


	local function createItem( params )
		params = params or {}
		-- dump(params)
		local layer = display.newLayer()
		
		local bg = display.newSprite( COMMONPATH .. "item_bg.png" )
		setAnchPos( bg , 0 , 0 )
		layer:addChild( bg )

		local vipText = createLabel({str = params.data.name,x = 100,y=70,size = 21,width = 200,color = ccc3(0,0,0)})
		bg:addChild(vipText)

		local buyText = createLabel({str = params.data.des,x = 100, y = 45,size = 18,width = 300,color = ccc3(0,0,0)})
		bg:addChild(buyText)

		local skillCoinImg = display.newSprite(PATH.."skill_coin.png")
		setAnchPos(skillCoinImg,105,15)
		bg:addChild(skillCoinImg)

		local skillCoinNum = createLabel({str = params.data.cost.."",x=130,y=17,size = 18,width =100,color = ccc3(0,0,0)})
		bg:addChild(skillCoinNum)
		local btnBg = {"skill_frame1.png","skill_frame1_press.png"}

		if params.data.type ~=1 and params.data.type ~=2 then
			local  icon = awardCell( { cid = params.data.skill_id , num = 0 } , { name = false , star = false,nonum = true } )
			setAnchPos( icon , 20 , 20 , 0 , 0 )
			bg:addChild( icon )
		else
			local iconBtn = KNBtn:new(IMG_PATH.."image/scene/common",btnBg,15,24,{
			scale = true,
			front = params.data.type == 1 and IMG_PATH.."image/skill/box1.png" or params.data.type == 2 and IMG_PATH.."image/skill/box2.png",
			callback = function ()
					KNMsg:getInstance():flashShow("点击兑换可获得宝箱内随机物品")
			end
			})
			bg:addChild(iconBtn:getLayer())
		end

			local function refreshNum(num)
				-- body
					self.mainLayer:removeChildByTag(1024,true)
					local skillCoinNum = createLabel({str = num.."",x = 175,y = 712,size = 21,width = 200, color = ccc3(255,255,255)})
					self.mainLayer:addChild(skillCoinNum,1,1024)
			end 

		local convertBtn = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"},350,40,{
			front = COMMONPATH.."xchange.png",
			scale = true,
			callback = function()
				local function buy(pid, num)
					num = num < 1 and 1 or num
					HTTP:call("shop","exchangeSkillCoin",{pid = pid, num=num},{success_callback = function(convertData)
						KNMsg:getInstance():flashShow(convertData.msg)
						coinNum = convertData.remain_skill_coin
						refreshNum(coinNum)
					end})
				end
				if params.index <= 3 then
					buy(params.index, 1)
				else
					self:buyBox(params, buy)
				end
			end
			})
		bg:addChild(convertBtn:getLayer())
		layer:setContentSize( bg:getContentSize() )

		-- print("######## " ..params.index)
		dump(params)

		return layer
	end

	local scroll = KNScrollView:new(0,100,480,580,10,false)

	
	for i = 1 , table.nums(params.list) do
		local item = createItem({ index = i , data = params.list[i..""] ,coinNum = params['skill_coin']})
		scroll:addChild(item)
	end

	scroll:alignCenter()
	self.mainLayer:addChild(scroll:getLayer())




	 self.baseLayer:addChild(self.mainLayer)



end

function M:buyBox(params, buyFunc)
	dump(params)

	local layer = display.newLayer()
	local mask = KNMask:new({item=layer}):getLayer()
	self.baseLayer:addChild(mask)

	display.newSprite(COMMONPATH.."tip_bg.png", display.cx, display.cy):addTo(layer)
	awardCell({cid=params.data.skill_id,num=0},{name=false,star=false,nonum=true}):pos(display.cx-150, display.cy+20):addTo(layer)
	display.strokeLabel( params.data.name , display.cx-75, display.cy+60, 20 , ccc3(0x2c , 0x00 , 0x00 ) , 2 , ccc3(0x40 , 0x1d , 0x0c ) , { dimensions_width = display.width , dimensions_height = 30 ,align = 0 } ):addTo(layer)
	display.newSprite(PATH.."value_bg.png", display.cx-10, display.cy+40):addTo(layer)
 	display.newSprite(PATH.."skill_coin.png", display.cx-50, display.cy+40):addTo(layer)
	display.newSprite(PATH.."num_text.png", display.cx+90, display.cy+40):addTo(layer)
	display.newSprite(PATH.."num_bg.png", display.cx+150, display.cy+40):addTo(layer)

	local priceText = display.strokeLabel(params.data.cost .."" , display.cx-32, display.cy+29, 20 , ccc3(0x2c , 0x00 , 0x00 ) , nil , nil ,{ dimensions_width = 80 , dimensions_height = 30 ,align = 0} ):addTo(layer)
	local numText = display.strokeLabel("1", display.cx+128, display.cy+28, 20 , ccc3(0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 36 , dimensions_height = 30 ,align = 1 } ):addTo(layer)

	local num = 1
	local max = 20
	local function changeValue()
		numText:setString(num)
		priceText:setString(num * params.data.cost)
	end

	local slider = KNSlider:new( "buy" ,  {
		x = display.cx-100, 
		y = display.cy+30,
		minimum = 1 , 
		maximum = max, 
		value = 1 , 
		callback  = function( _curIndex )
			num = _curIndex
			changeValue()
		end,
		priority = -140
	})
	layer:add(slider)
	
	local addBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , display.cx+135,  display.cy-63, {
		scale = true,
		priority = -130,
		callback = function()
			if num < max then
				num = num + 1
				slider:setValue( num )
				changeValue()
			end
		end
	})
	layer:add(addBtn:getLayer())
	
	local minusBtn = KNBtn:new(COMMONPATH,{"next_big.png"} , display.cx-165,  display.cy-63,{
		scale = true,
		priority = -130,
		callback = function()
			if num > 1 then
				num = num - 1
				slider:setValue( num )
				changeValue()
			end
		end
	})
	minusBtn:setFlip(true)
	layer:add(minusBtn:getLayer())
	
	local ok = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"}, display.cx-110,  display.cy-110,{
		front = COMMONPATH.."ok.png" ,
		scale = true,
		priority = -130,
		callback = function()
			buyFunc(params.index, num)
			self.baseLayer:removeChild(mask, true)
		end
	})
	layer:add(ok:getLayer())

	local cancel = KNBtn:new(COMMONPATH,{"btn_bg.png","btn_bg_pre.png"} , display.cx+45,  display.cy-110,{front = COMMONPATH.."cancel.png",scale = true,priority = -130,callback=
		function()
			self.baseLayer:removeChild(mask, true)
		end})
	layer:add(cancel:getLayer())
end

return M