local M = {}

local PATH = IMG_PATH .. "image/scene/soulTemple/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")


--魂殿商城
function M:createShop(params)
	if self.viewLayer then self.viewLayer:removeSelf() end

	dump(params , "params")

	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )

	self:setInfoLayer({title=PATH.."shop_title.png" , closeCallFunc = function() self:createSoulHome() end })

	local jobInfo = DATA_SoulTemple:get("info")

	self.viewLayer:addChild( display.newSprite(COMMONPATH .. "dark_bg.png" , 0  , 88 , 0 , 0) )

	local own_soul_coin = display.newSprite(PATH.."own_soul_coin_s.png" , 22,721 , 0 , 0)
	self.viewLayer:addChild( own_soul_coin )

	local res_icon = display.newSprite(SCENECOMMON.."res_icon/soulTemple.png" , own_soul_coin:getPositionX() + own_soul_coin:getContentSize().width  + 5,721 , 0 , 0)
	self.viewLayer:addChild( res_icon )

	self.viewLayer:addChild( display.strokeLabel(jobInfo.wh or "",			res_icon:getPositionX() + res_icon:getContentSize().width + 5, 721, 18 , ccc3(255,247,237)) ) 

	local shop_desc = display.strokeLabel("每日12点自动刷新商城",	125, 617, 18 , ccc3(69,227,237))
	setAnchPos( shop_desc , display.cx+125 , 107+617 , 0.5 , 0 )
	self.viewLayer:addChild( shop_desc ) 

	local perpage = 5
	local x , y = 15 , 572
	local scroll = KNScrollView:new(15 , 145 , 450 , 572 , 5)
	local goodsList = params.list or {}
			
	for k , item in pairs(goodsList) do  --循环初始化当前选中类型的类型的背包显示

		local goodsConf = awardCell(nil , { getPropConf = true })


		local itemLayer = M:createShopItem({
			data = item,
			parent = scroll,
			iconCallback = function()
				if goodsConf[item["cid"]] then 
					KNMsg:getInstance():flashShow(goodsConf[item["cid"]].desc or "")
					return 
				end

				--当点击图标按钮后先从全局数据中查找是否存在数据，若没有则请求网络，否则隐藏用户信息栏，显示详细界面
				local detail_type = getCidType(item["cid"])
				local data = getConfig( detail_type , item["cid"] )
				data["cid"] = item["cid"]

				pushScene("detail" , {
					detail = detail_type,
					data = data,
				})
			end,
			optCallback = function()
				HTTP:call("empire","buy",{ id = k } , {
						success_callback = function(data)
							-- dump(data , "data")
							if data.msg then 
								KNMsg.getInstance():flashShow(data.msg)
								data.msg = nil
							end
							self:createShop(data)
						end
				})
			end
		})
		scroll:addChild(itemLayer)
	end

	if KNGuide:getStep() == 20110 then 
		KNGuide:show( nil , {
			mask_clickable = true,
			callback = function()
				self:setInfoLayer({title=PATH.."shop_title.png" , closeCallFunc = function() self:createSoulHome() end })
			end,
			x = -100,
			y = 300,
			width = 1,
			height = 1,
		})
	end

	local refreshBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" },display.cx , 116,{
		anchMid = true,
		front = COMMONPATH .. "refresh.png",
		callback = function()

			HTTP:call("empire","refreshShop",{} , {
					success_callback = function(data)
						-- dump(data , "data")
						KNMsg:getInstance():flashShow( data.msg or "" )
						self:createShop(data)
					end
			})
			
		end,
	} ):getLayer():addTo( self.viewLayer )



	local count = DATA_Bag:getTypeCount( "prop" , "17186" ) or 0	

	local refreshLabel = createLabel({str = "剩余"..count, x = 149 , y = 10 , color = ccc3(255,255,255) })
	refreshBtn:addChild( refreshLabel )
	
	display.newSprite( getImageByType("17135" , "s")  , refreshLabel:getContentSize().width+15 ,  -6 , 0 , 0 ):scale(0.5):addTo( refreshLabel )

	self.viewLayer:addChild(scroll:getLayer())
end


function M:createShopItem(param)
	local itemLayer = display.newLayer()
	local item_bg = display.newSprite( COMMONPATH.."item_bg.png" , 0 , 0 , 0 ,0  )
	local size = item_bg:getContentSize()

	local item_data = param.data or {}

	itemLayer:setContentSize(size)
	itemLayer:addChild( item_bg )

	-- getCidType(item_data["cid"])

	-- print("cid = " ..  item_data["cid"])

	local goodsConf = awardCell(nil , { getPropConf = true })

	local config_data = goodsConf[item_data["cid"]] or getConfig( getCidType(item_data["cid"]) , item_data["cid"])
	itemLayer:addChild( display.newSprite(SCENECOMMON.."res_icon/soulTemple.png" , 104  ,15 ,0 ,0 ) )


	-- if not config_data["cid"] then 
	-- 	dump(config_data , "config_data")
	-- end

	itemLayer:addChild( display.strokeLabel((config_data.name or "").."X"..item_data.propnum, 	104, 71, 18 , ccc3(68,27,7)) )
	itemLayer:addChild( display.strokeLabel("本服剩余：" .. (item_data.num or ""), 		104, 44, 18 , ccc3(68,27,7)) )
	itemLayer:addChild( display.strokeLabel(item_data.pay or "",			131, 17, 18 , ccc3(142,215,74)) )

	local icon = KNBtn:new(IMG_PATH .. "image/scene/common/" , {"skill_frame1.png"},55 , size.height / 2 ,{
		parent = param.parent,
		anchMid = true,
		front = getImageByType(item_data["cid"] , "s"),
		callback = function()
			if param.iconCallback then 
				param.iconCallback()
			end
		end,
	} )
	itemLayer:addChild(icon:getLayer())

	local buyBtn = KNBtn:new(COMMONPATH, { "btn_bg.png" , "btn_bg_pre.png" },380 , size.height / 2 + 10,{
		parent = param.parent,
		anchMid = true,
		front = COMMONPATH .. "buy.png",
		callback = function()
			if param.optCallback then 
				param.optCallback()
			end
		end,
	} )
	itemLayer:addChild(buyBtn:getLayer())

	return itemLayer
end

return M