--[[

		魂殿界面

]]

local PATH = IMG_PATH .. "image/scene/soulTemple/"
local SHOULEIPATH = IMG_PATH .. "image/scene/soulTemple/shoulei/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local KNBar = requires(IMG_PATH, "GameLuaScript/Common/KNBar")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local ColorText = requires(IMG_PATH,"GameLuaScript/Scene/soulTemple/ColorText")
local shopLayer = requires(IMG_PATH,"GameLuaScript/Scene/soulTemple/shopLayer")


--魂殿职位 一些配置信息
local job_config = { 
	
	{ ename = "xinwei" 				,	pid = 1, cname = replaceStr("魂殿新卫") , 		mtype = "center" , 	pos = 	{ x = 298 	, 	y = 134 } , offSetY = 0 } ,
	{ ename = "jingying" 			,	pid = 2, cname = replaceStr("魂殿精英") , 		mtype = "center" , 	pos = 	{ x = 40 	, 	y = 230 } , offSetY = 0 } ,
	{ ename = "baifuzhang" 			,	pid = 3, cname = replaceStr("魂殿百夫长") , 	mtype = "center" ,	pos = 	{ x = 284 	, 	y = 353	} , offSetY = 0 } ,
	{ ename = "three_gongfeng" 		,	pid = 4, cname = replaceStr("魂殿三供奉") , 	mtype = "center" ,  pos = 	{ x = 10 	, 	y = 452	} , offSetY = 0 } ,

	{ ename = "second_gongfeng"	 	,	pid = 5, cname = replaceStr("魂殿二供奉") , 	mtype = "screte" , 	pos = 	{ x = 260 	, 	y = 144 } , offSetY = 30 } ,
	{ ename = "first_gongfeng" 		,	pid = 6, cname = replaceStr("魂殿大供奉") , 	mtype = "screte" , 	pos = 	{ x = 0 	, 	y = 237 } , offSetY = 0  } ,
	{ ename = "jiaohuang" 			,	pid = 7, cname = replaceStr("魂殿教皇") ,  		mtype = "screte" , 	pos = 	{ x = 106 	,	y = 474 } , offSetY = 0  } ,
}

local function getJobConfByPid(pid)
	local _data = {}
	for k , v in pairs(job_config) do 
		if tonumber(v.pid) == tonumber(pid) then 
			_data = v
			break
		end
	end
	return _data 
end

local M = {
	baseLayer,
	layer,
	params,
	infoLayer,
	viewLayer,

	jobInfo,
}


function M:new( params )
	-- dump(params)
	local this = {}
	
	table.merge(self , shopLayer)

	setmetatable(this , self)
	self.__index = self
	this.params = params or {}
	this.baseLayer = display.newLayer()
	this.layer = display.newLayer()

	this.jobInfo = this.params.data and this.params.data.empire_info or {}

	this:saveConfig()
	this:setInfoLayer()
	this:createSoulHome()


	GLOBAL_SOULTEMPLE = this


	

	return this.baseLayer
end

function M:saveConfig()
	for key,value in pairs(self.params.data.config) do
		table.merge( job_config[tonumber(key)] , value )
	end
end

--魂殿首页 
function M:createSoulHome()

	if self.viewLayer then self.viewLayer:removeSelf() end
	
	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )

	self:setInfoLayer( {title = PATH .. "home_title.png",closeCallFunc = function() switchScene("pvp") end } )

	local jobInfo = DATA_SoulTemple:get("info")

	--进场的引导
	if KNGuide:getStep() == 20000 or KNGuide:getStep() == 20010 then 
		KNGuide:show( nil , {
			mask_clickable = true,
			callback = function()
				self:createSoulHome()
			end,
			x =  -100,
			y =   300,
			width =  1,
			height = 1,
		})
	end

	if KNGuide:getStep() == 20060 then 
		KNGuide:show( display.newLayer():pos(76,310):size(347,68) , {
			callback = function()
				self:createSoulHome()
			end,
		})
	end

	if KNGuide:getStep() == 20130 then 
		KNGuide:show( nil , {
			mask_clickable = true,
			remove = true ,
			callback = function()
				self:createSoulHome()
			end,
			x = -100,
			y =  300,
			width =1,
			height =  1,
		})
	end
	
	self.viewLayer:addChild( display.newSprite(PATH .. "bg.jpg" , display.cx , 95 , 0.5 , 0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "own_soul_coin.png" , 33 , 703 , 0,0) )
	self.viewLayer:addChild( display.newSprite(SCENECOMMON .. "res_icon/soulTemple.png" , 153 , 704 , 0,0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "own_soul_points.png" , 130 , 232 , 0,0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "my_job.png" , 33 , 652 , 0,0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "award_bg.png" , display.cx , 275 , 0.5,0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "day_salary.png" , 33 , 380 , 0,0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "next_job_need_points.png" , 130 , 175 , 0,0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "reduce_points.png" , 130 , 200 , 0,0) )
	-- dump(getJobConfByPid(jobInfo.pid) , "jobInfo.diff_poin")

	self.viewLayer:addChild( display.strokeLabel( jobInfo.wh or "", 184, 704, 18 , ccc3(255,255,255)) )								--拥有魂币数
	self.viewLayer:addChild( display.strokeLabel( jobInfo.point or "", 231, 232, 18 , ccc3(255,255,255)) )								--现有积分
	self.viewLayer:addChild( display.strokeLabel( jobInfo.diff_point or "" , 306, 178, 18 , ccc3(255,255,255)) )							--距离下一职位还差多少积分
	self.viewLayer:addChild( display.strokeLabel( getJobConfByPid(jobInfo.pid).cost or "", 306, 205, 18 , ccc3(255,255,255)) )			--每日交税减少积分
	self.viewLayer:addChild( display.strokeLabel("点赞：", 60, 283, 18 , ccc3(255,232,232)) )
	self.viewLayer:addChild( display.strokeLabel( jobInfo.base.liked.."/5", 110, 283, 18 , ccc3(255,79,49)) )
	self.viewLayer:addChild( display.strokeLabel( (tonumber(jobInfo.base.award) == 1) and "(明日可前来领取)" or "(点击图标即可领取)", 221, 283, 18 , ccc3(126,250,250)) )

	local awardData = jobInfo.award or {}
	local awardCount = table.nums( awardData ) or 0

	local awardCofig = { 
		{ disable = (tonumber(jobInfo.base.liked) < 5 ) or (tonumber(jobInfo.base.liked_award) == 1 ) , desc = "被其他玩家点赞5次即可领取，随机获得物品" , icon = "soul_box.png" , type = 2 },
		{ disable = (tonumber(jobInfo.base.award) == 1), desc = "明日可前来领取" , 			 icon = "soul_coin.png" ,  type = 1 , hasnum = true },
		{ disable = (tonumber(jobInfo.base.award) == 1), desc = "明日可前来领取" , icon = "soul_box.png" , type = 1 },
	 }

	for i=1, awardCount do
		local award_type = awardCofig[i].type

		local award_btn = KNBtn:new(SCENECOMMON, { "skill_frame1.png" }, 76 + (i-1)* (awardCount == 3 and 136 or 175), 310, {
			front =PATH.. awardCofig[i].icon, 
			scale = true,
			priority = -132,
			callback = function()
				
				if awardCofig[i].disable then 
					KNMsg:getInstance():flashShow( awardCofig[i].desc or "" )
					return 
				end

				local function httpcall()
					--  领取每日奖励   type 1 职务奖励  2 点赞奖励
					HTTP:call("empire","recevieAward",{ type = award_type } , {
							success_callback = function(data)
								if data.msg then 
									KNMsg:getInstance():flashShow(data.msg)
									data.msg = nil
								end
								self:createSoulHome()
							end
					})
				end

				local job_data = job_config[tonumber(jobInfo.pid)] or {}
				if i ~= 1 and jobInfo.wh >= job_data.max_wh then 
					local contentlayer = display.newLayer()

					contentlayer:ignoreAnchorPointForPosition(false)

					contentlayer:addChild( createLabel({str = "武魂币数量已达到当前职业上限，领取俸禄将不会获得武魂币奖励，是否领取？", x=40,y=430, width = 380, size = 20}) )
					contentlayer:addChild( createLabel({str = "提升职位可增加武魂币上限" ,x=40,y=360, width = 330, size = 20}) )

					showTip({
							content = contentlayer ,
							left = {
								remove = true,
								callback = function()	
									httpcall()
								end
							},right = {
								remove = true	
							}
						})
					return 
				end

				httpcall()

			end
		}):getLayer()

		if awardCofig[i].hasnum then 
			local other =  display.newSprite( IMG_PATH .. "image/scene/activity_new/num_bg.png"  , award_btn:getContentSize().width  , 0  , 0.7 , 0 )
			local text =  display.strokeLabel( awardData[i..""].num or "", 	other:getContentSize().width /2,  other:getContentSize().height/2, 14 , ccc3(255,255,227)) 
			setAnchPos(text ,other:getContentSize().width /2,  other:getContentSize().height/2 , 0.5 , 0.5 )
			other:addChild(text)

			award_btn:addChild( other , 10 )
		end

		if not awardCofig[i].disable then 
			local effect = requires(IMG_PATH,"GameLuaScript/Common/KNEffect")
			effect.get(PATH, "award_eff"):addTo(award_btn):scale(0.75):pos(award_btn:getContentSize().width/2,award_btn:getContentSize().height/2):anchor(0.5,0.5)
		end
		
		self.viewLayer:addChild( award_btn )
	end

	local myjobBtn = KNBtn:new(PATH, { getJobConfByPid(jobInfo.pid).ename .. "_icon.png" }, display.cx, 533, {
		anchMid = true,
		priority = -131,
		other = {PATH.. getJobConfByPid(jobInfo.pid).ename.. "_text.png", -10,-40 },
		callback = function()
			self:createSoulMap({map = "center"})
		end
	})
	self.viewLayer:addChild(myjobBtn:getLayer())


	if KNGuide:getStep() == 20020 then 
		KNGuide:show( myjobBtn:getLayer() , {
				offset_x = -myjobBtn:getLayer():getContentSize().width /2,
				offset_y = -myjobBtn:getLayer():getContentSize().height /2,
			} )
	end

	local shopBtn = KNBtn:new(PATH, {"shop.png", "shop_pre.png"}, 390, 658, {
		priority = -131,
		callback = function()
			HTTP:call("empire","getShopList",{  } , {
				success_callback = function(data)
					-- dump(data , "getShopList")
					self:createShop(data)
				end
			})
		end
	})
	self.viewLayer:addChild(shopBtn:getLayer())


	if KNGuide:getStep() == 20100 then 
		KNGuide:show( shopBtn:getLayer() )
	end

	local noticeBtn = KNBtn:new(PATH, {"notice.png", "notice_pre.png"}, 390, 566, {
		priority = -131,
		callback = function()

			HTTP:call("empire","getNoticeList",{  } , {
					success_callback = function(data)
						-- dump(data , "getNoticeList")
						if data and data.list and table.nums( data.list ) ~= 0 or true then 
							self.baseLayer:addChild( self:createNoticeLayer(data):getLayer() , 11 )
						else
							KNMsg:getInstance():flashShow("当前没有公告")
						end			
					end
			})
		end
	})
	self.viewLayer:addChild(noticeBtn:getLayer())

	local canUp = false
	if tonumber(jobInfo.diff_point) == 0 then 
		canUp = true
	end

	local getPointBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" }, canUp and  (display.cx-100) or display.cx, 139, {
		front = PATH .. "get_point_label.png",
		priority = -131,
		anchMid = true,
		callback = function()
			HTTP:call("empire","getChallengeList",{ pid = jobInfo.pid } , {
					success_callback = function(data)
						-- dump(data , "getChallengeList")
						self:createChallengeList({ type = "points" , _data = data })
					end
			})
		end
	})
	self.viewLayer:addChild(getPointBtn:getLayer())

	if KNGuide:getStep() == 20070 then 
		KNGuide:show( getPointBtn:getLayer(), {
				offset_x = -getPointBtn:getLayer():getContentSize().width /2,
				offset_y = -getPointBtn:getLayer():getContentSize().height/2,
			} )
	end


	if canUp then 
		local upJobBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" }, display.cx + 100, 139, {
			front = PATH .. "upJob_label.png",
			priority = -131,
			anchMid = true,
			callback = function()
				if tonumber(jobInfo.pid) ~= 7 then 
					 self.baseLayer:addChild( self:createUpJobLayer():getLayer() , 11 )
				else
					KNMsg.getInstance():flashShow("当前已是最高职位")
				end
			end
		})
		self.viewLayer:addChild(upJobBtn:getLayer())
	end



	if DATA_User:get("lv") >= 40 then 
		KNBtn:new(SHOULEIPATH, { "icon.png" }, 382+47, 469+42, {
			priority = -131,
			anchMid = true,
			callback = function()

				if DATA_User:get("lv") < 45 then 
					KNMsg:getInstance():flashShow( "魂殿守擂需要45级才能进入" )
					return 
				end

				self:shouleiDispatcher( "shouleijiaofeng" )

			end
		}):getLayer():addTo(self.viewLayer)
	end


end


function M:getFightInfo(data , index)
	local layer = display.newLayer()
	
	-- local team_data = data.team or {}


	local attacker = data.attack or {}
	local defender = data.defend or {}

	local bg =  display.newSprite( COMMONPATH .. "tip_bg2.png" , display.cx , 239 , 0.5 , 0 ):addTo(layer)
    local title_bg = display.newSprite( IMG_PATH .. "image/scene/mission/title_bg.png" , display.cx+50 , 580 , 0.5 , 0 ):addTo(layer)

    display.newSprite( SHOULEIPATH .. "frame_bg3.png" , display.cx - 5 , 31 , 0.5 , 0  ):addTo(bg)

    display.newSprite( SHOULEIPATH .. "leitai_title_"..index..".png" , title_bg:getContentSize().width/2-30 , title_bg:getContentSize().height/2 , 0.5 , 0.5 ):addTo(title_bg)

    local frame3 = display.newSprite( SHOULEIPATH .. "big_frame1.png" ,  20, 103 , 0 , 0  ):addTo( bg )
    local frame2 = display.newSprite( SHOULEIPATH .. "big_frame2.png" ,  245, 41 , 0 , 0  ):addTo( bg )

    --队长
    KNBtn:new(COMMONPATH, { getHeadPath( attacker.logo or "" ) },frame3:getContentSize().width/2 , 153 ,{
		anchMid = true,
		front = COMMONPATH.."role_frame.png", 
		other = {SHOULEIPATH..(tonumber(attacker.leader) == 0 and "duiyou.png" or "duizhang.png" ), -29, 51 },
		text = {  attacker.name or "" , 18  , ccc3(255,255,255) , { x=0,y=-45} }, 
		callback = function()
			
		end,
	} ):getLayer():addTo(frame3)
	if attacker.leader == 1 then  
		display.newSprite( SHOULEIPATH.."duizhang_icon.png" , 2 , 169 , 0 , 0 ):flipX(true):addTo( frame3 )
	end

    local gradeLabel1 = ColorText:create( 62 , 70  ,  110 , 0 ,{ fontSize = 16 , paddingTop = 3 , anchorPoint = { x = 0 , y = 0 } , }  )
    gradeLabel1:addString( "等级：" , ccc3( 255 , 233 , 233 ) )
    gradeLabel1:addString( attacker.lv or "" , ccc3( 255 , 0 , 0 ) )
    gradeLabel1:getLayer():addTo(frame3)

    frame3:addChild( display.strokeLabel( attacker.server_name , 61, 43, 16 , ccc3(86,236,236) ) )
    
    local abilityLabel1 = ColorText:create( 62 , 14  ,  110 , 0 ,{ fontSize = 16 , paddingTop = 3 , anchorPoint = { x = 0 , y = 0 } , }  )
    abilityLabel1:addString( attacker.ability , ccc3( 255 , 233 , 233 ) )
    abilityLabel1:addString( "战力" , ccc3( 255 , 0 , 0 ) )
    abilityLabel1:getLayer():addTo(frame3)

	--他人
    KNBtn:new(COMMONPATH, { getHeadPath( defender.logo ) },frame2:getContentSize().width/2 , 153 ,{
		anchMid = true,
		front = COMMONPATH.."role_frame.png", 
		other = {SHOULEIPATH.. (tonumber(defender.leader) == 0 and "duiyou.png" or "duizhang.png" ), 58, 52 },
		text = {  defender.name , 18  , ccc3(255,255,255) , { x=0,y=-45} }, 
		callback = function()
			
		end,
	} ):getLayer():addTo(frame2)
	if defender.leader == 1 then 
		display.newSprite( SHOULEIPATH.."duizhang_icon.png" , 165 , 169 , 0 , 0 ):addTo( frame2 )
	end

	local gradeLabel2 = ColorText:create( 62 , 70  ,  110 , 0 ,{ fontSize = 16 , paddingTop = 3 , anchorPoint = { x = 0 , y = 0 } , }  )
    gradeLabel2:addString( "等级：" , ccc3( 255 , 233 , 233 ) )
    gradeLabel2:addString( defender.lv , ccc3( 255 , 0 , 0 ) )
    gradeLabel2:getLayer():addTo(frame2)

    frame2:addChild( display.strokeLabel( defender.server_name, 61, 43, 16 , ccc3(86,236,236) ) )
    
    local abilityLabel2 = ColorText:create( 62 , 14  ,  110 , 0 ,{ fontSize = 16 , paddingTop = 3 , anchorPoint = { x = 0 , y = 0 } , }  )
    abilityLabel2:addString( defender.ability , ccc3( 255 , 233 , 233 ) )
    abilityLabel2:addString( "战力" , ccc3( 255 , 0 , 0 ) )
    abilityLabel2:getLayer():addTo(frame2)


    display.newSprite( SHOULEIPATH .. "vs.png" , display.cx , 150 , 0.5 , 0  ):addTo( bg )

    layer:retain()

    return layer

end


function M:shouleijiaofeng(data)

	if data.team and data.team.status and data.team.status == 2 then 
		self:wodeshoulei(data)
		return 
	end


	local layer = display.newLayer()

	self:revmoeMask()

	self.mask = KNMask:new( {item = layer , priority = -141} )
	display.getRunningScene():addChild( self.mask:getLayer() )
	

	KNMsg:getInstance():flashShow( data.msg or "" )	

	local bg = display.newSprite( COMMONPATH .. "change_bg.png" , display.cx , 122 , 0.5 , 0 ):addTo(layer)

	display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png" , display.cx + 40 , 510 , 0.5 , 0 ):addTo(bg)
	display.newSprite(SHOULEIPATH.."shouleijiaofeng_title.png" , display.cx , 516 , 0.5 , 0 ):addTo(bg)

	local sljf_bg = display.newSprite( SHOULEIPATH .. "sljf_bg.jpg" , display.cx, 104 , 0.5 , 0 ):addTo(bg)

	local cur_team_id


	local arena_list = data.arena_list or {}

	local scroll

	if table.nums(arena_list)~=0 then 
		scroll = KNScrollView:new( 46, 311 , 411, 202 , 1 , true , 1 , { turnBtnPriority = -143, leftBtnOff = { x=50 , y=0 } , rightBtnOff = { x=-50 , y=0 }, turnBtn = COMMONPATH .. "next_big.png", priority = -142 }  )
		local function getItem(param)

			local layer = display.newLayer()
			layer:setContentSize( CCSizeMake( 408 , 303 ) )

			local item = display.newSprite( SHOULEIPATH .. "frame4.png" ,sljf_bg:getContentSize().width/2+20 , 0 , 0.5 , 0 )

			KNBtn:new(COMMONPATH, { getHeadPath( param.leader.logo.."" ) }, 56  , 89 ,{
				front = COMMONPATH.."role_frame.png", 
				callback = function()
					
				end,
			} ):getLayer():addTo(item)

			-- item:addChild( display.strokeLabel(  param.leader.name .."（队长）", 7, 166, 18 , ccc3(255,239,199) ))

			local nameLabel = ColorText:create( 13 , 166  ,  220 , 0 ,{ fontSize = 16 , paddingTop = 3 , anchorPoint = { x = 0 , y = 0 } , }  )
		    nameLabel:addString( param.leader.name , ccc3(255,239,199) )
		    nameLabel:addString( "（队长）"or "" , ccc3( 220 , 41 , 41 ) )
		    nameLabel:getLayer():addTo(item)

		    local abilityLabel = ColorText:create( 30 , 54  ,  110 , 0 ,{ fontSize = 16 , paddingTop = 3 , anchorPoint = { x = 0 , y = 0 } , }  )
		    abilityLabel:addString( "战力" , ccc3(255,239,199) )
		    abilityLabel:addString( param.leader.ability , ccc3( 220 , 41 , 41 ) )
		    abilityLabel:getLayer():addTo(item)

			item:addChild( display.strokeLabel(  param.server_name, 30, 31, 18 , ccc3(86,234,239) ))
			item:addChild( display.strokeLabel( "胜场".. param.win_times.."次", 30, 9, 18 , ccc3(255,239,199) ))

			layer:addChild(item)

			return layer
		end


		for i=1, #arena_list do
			local scroll_item  = getItem( arena_list[i] )
			scroll:addChild( scroll_item )
		end

		bg:addChild( display.strokeLabel( "拖动选择攻擂目标", 150, 167, 18 , ccc3(255,239,199)  ) )

		layer:addChild( scroll:getLayer() )
	else

		display.newSprite( SHOULEIPATH .. "zuiduikehuode.png" , 70, 417 , 0 , 0 ):addTo(bg)
		display.newSprite( SHOULEIPATH .. "wurenshoulei.png" , display.cx, 417-225 , 0.5 , 0 ):addTo(bg)

	end

	if tonumber(data.data.attack_times) == 6 then 
		local leitaicishu = display.newSprite( SHOULEIPATH .. "leitaicishuyihaojin.png" , display.cx - 30, 16 , 0.5 , 0 ):addTo(bg)
	else
		local leitaicishu = display.newSprite( SHOULEIPATH .. "leitaicishu.png" , display.cx - 30, 16 , 0.5 , 0 ):addTo(bg)
		leitaicishu:addChild( display.strokeLabel(  (6-data.data.attack_times) .. "/6", leitaicishu:getContentSize().width+10, 0, 20 , ccc3(43,2,2) ) )
	end

	-- local leitaicishu = display.newSprite( SHOULEIPATH .. "leitaicishu.png" , display.cx - 30, 16 , 0.5 , 0 ):addTo(bg)
	-- leitaicishu:addChild( display.strokeLabel(  (6-tonumber(data.data.attack_times)) .. "/6", leitaicishu:getContentSize().width+10, 0, 20 , ccc3(43,2,2) ) )

	bg:addChild( display.strokeLabel( data.notice , 70, 480, 20 , ccc3(43,2,2) ) )


	if table.nums(data.team)==0 then
		--开始组队
		KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx , 77 ,
		{
			anchMid = true,
			priority = -210,
			front = SHOULEIPATH .. "kaishizudui_label.png",
			callback = function()
				HTTP:call("empirearena","getTeamList",{ } , {
						success_callback = function(data)
							dump(data , "data")
							self:revmoeMask()
							self:leitaizudui(data)
						end
				})
			end
		}):getLayer():addTo(bg)
	else
		--队伍管理
		KNBtn:new( SHOULEIPATH , { "duwuguanli_btn.png" }, 54 , 112 ,
		{
			priority = -210,
			callback = function()

				self:chuangjianduiwu(data  ,{ fromShoulei = true })

			end
		}):getLayer():addTo(bg)

		--攻擂
		KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx , 77 ,
		{
			anchMid = true,
			priority = -210,
			front = SHOULEIPATH .. "gonglei.png",
			callback = function()

				if not scroll then 
					KNMsg:getInstance():flashShow("请选择一个攻擂目标")
					return 
				end

				local function toBattle()
					local team_id = arena_list[scroll:getCurIndex()].team_id

					HTTP:call("empirearena","challenge",{ team_id = team_id , to_server_id = arena_list[scroll:getCurIndex()].server_id } , {
						success_callback = function(_data)


								local notes = {}
								for i,v in ipairs(_data.vs_info) do
									table.insert( notes , self:getFightInfo(v , i) )
								end
								self:leitaidiyilun(data , { battle_data = _data , notes = notes } )

						end})
				end

				if table.nums(data.team.leader)~=0 and table.nums(data.team.member)~=0 then 
					if data.team.status and tonumber(data.team.status) <= 0 then 
						HTTP:call("empirearena","changeTeamStatus",{ status = 1 } , {
								success_callback = function(_data)
									toBattle()	
								end
						})
					else
						toBattle()
					end
				else
					KNMsg:getInstance():flashShow( "队伍人员未满，不可以攻擂" )
				end
				
			end
		}):getLayer():addTo(bg)

		--守擂
		KNBtn:new( COMMONPATH , { "btn_bg.png" ,"btn_bg_pre.png"}, 340 , 399 ,
		{
			priority = -210,
			front = SHOULEIPATH .. "shoulei.png",
			callback = function()
				

				if data.team.status and tonumber( data.team.status ) == 2 then
					self:wodeshoulei(data)
				else
					HTTP:call("empirearena","changeTeamStatus",{ status = 2 } , {
							success_callback = function(_data)
								dump(data , "data")
								self:wodeshoulei(data)
							end
					}) 
				end

			end
		}):getLayer():addTo(bg)

	end

	--关闭
	KNBtn:new( COMMONPATH , { "back_img.png" ,"back_img_press.png"}, 5 , 484 ,
	{
		priority = -210,
		callback = function()

			if data.team and data.team.leader and tonumber(data.team.leader["uid"]) == tonumber(DATA_User:get("uid")) and data.team.status==0 then 
				showTip({
					content = createLabel({str = "确定退出队伍吗", width = 400 }),
					priority= -211,
					left = {
						remove = true,
						callback = function()
							HTTP:call("empirearena","leaveTeam",{} , {
								success_callback = function(data)
									self:revmoeMask()
							end})
						end
					},right = {
						remove = true
					}
				})
			else
				self:revmoeMask()
			end
		end
	}):getLayer():addTo(bg)


end


function M:wodeshoulei(data)

	local layer = display.newLayer()

	self:revmoeMask()

	self.mask = KNMask:new( {item = layer , priority = -141} )
	display.getRunningScene():addChild( self.mask:getLayer() )
	

	local team_data = data.team or {}

	local bg = display.newSprite( COMMONPATH .. "change_bg.png" , display.cx , 122 , 0.5 , 0 ):addTo(layer)

	display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png" , display.cx + 40 , 510 , 0.5 , 0 ):addTo(bg)
	display.newSprite(SHOULEIPATH.."wodeshoulei_title.png" , display.cx , 516 , 0.5 , 0 ):addTo(bg)

	local top_frame = display.newSprite( SHOULEIPATH .. "top_frame.png" , display.cx , 389 , 0.5 , 0 ):addTo(bg)
	local frame_bg = display.newSprite( SHOULEIPATH .. "frame_bg2.png" , display.cx - 10 , 90 , 0.5 , 0 ):addTo(bg)

    KNBtn:new(COMMONPATH, { getHeadPath( team_data.leader.logo ) }, 0  , 7 ,{
		front = COMMONPATH.."role_frame.png", 
		text = {  DATA_User:get("name") , 16  , ccc3(255,233,233) , { x=89,y=28} }, 
		callback = function()
			
		end,
	} ):getLayer():addTo(top_frame)

	local shouleizhuangtai = display.newSprite( SHOULEIPATH .. "shouleizhuangtai.png" , 77 , 33 , 0 , 0  ):addTo(top_frame)
	local shouleishengchang = display.newSprite( SHOULEIPATH .. "shouleishengchang.png" , 77 , 9 , 0 , 0  ):addTo(top_frame)
	
	shouleizhuangtai:addChild( display.strokeLabel( "守擂中", shouleizhuangtai:getContentSize().width+5, 0, 16 , ccc3(243,2,2) ) )
	shouleishengchang:addChild( display.strokeLabel( ( data.team.win_times ).. "/6（胜场可额外获得奖励）", shouleishengchang:getContentSize().width+5, 0, 16 , ccc3(43,2,2) ) )


	display.newSprite( SHOULEIPATH .. "duiwurenyuan1.png" , 52 , 327 , 0 , 0 ):addTo(bg)
	display.newSprite( SHOULEIPATH .. "shouleijiangli.png" , 52 , 139 , 0 , 0 ):addTo(bg)

	local frame3 = display.newSprite( SHOULEIPATH .. "frame3.png" ,  59, 182 , 0 , 0  ):addTo( bg )
    local frame2 = display.newSprite( SHOULEIPATH .. "frame2.png" ,  250, 182 , 0 , 0  ):addTo( bg )

    --队长
    KNBtn:new(COMMONPATH, { getHeadPath( team_data.leader.logo or "19001" ) },frame3:getContentSize().width/2 , 87 ,{
		anchMid = true,
		front = COMMONPATH.."role_frame.png", 
		text =  { team_data.leader.lv , 18, ccc3(0xff, 0xfb, 0xd4), ccp(32, 31) , nil , 17} or nil,
		other = {COMMONPATH.."equip_lv_bg.png", 50, 52} or nil,
		callback = function()
			
		end,
	} ):getLayer():addTo(frame3)
	frame3:addChild( display.strokeLabel( team_data.leader.name , 28, 22, 20 , ccc3(255,239,199) ) )
	display.newSprite( SHOULEIPATH.."duizhang_icon.png" , -6 , 106 , 0 , 0 ):flipX(true):addTo( frame3 )
	display.newSprite( SHOULEIPATH.."duizhang.png" , 27 , 114 , 0 , 0 ):addTo( frame3 )

	--队友
    KNBtn:new(COMMONPATH, { getHeadPath( team_data.member.logo or "19001" ) },frame3:getContentSize().width/2 , 87 ,{
		anchMid = true,
		front = COMMONPATH.."role_frame.png", 
		text =  { team_data.member.lv or "" , 18, ccc3(0xff, 0xfb, 0xd4), ccp(32, 31) , nil , 17} or nil,
		other = {COMMONPATH.."equip_lv_bg.png", 50, 52} or nil,
		callback = function()
			
		end,
	} ):getLayer():addTo(frame2)
	frame2:addChild( display.strokeLabel( team_data.member.name or "" , 28, 22, 20 , ccc3(255,239,199) ) )
	display.newSprite( SHOULEIPATH.."duiyou.png" , 27 , 114 , 0 , 0 ):addTo( frame2 )


    bg:addChild( display.strokeLabel( data.award_str, 70, 108, 21 , ccc3(255,248,199) ) )

    local nextTime = data.team.remain_time or 0

    local timetext = createLabel({str = timeConvert( nextTime ) , x = 146 , y = 0,size = 18, width = 180,color = ccc3(0xff , 0xff , 0xff)})
   	shouleizhuangtai:addChild( timetext )

    local timeCount = 0 
    local function refreshTime()
        nextTime = nextTime - 1
        if nextTime <= 0 then
            timetext:setString("00:00:00")
        else 
            timetext:setString( replaceStr( timeConvert( nextTime ) ))
        end
    end


    Clock:addTimeFun("SHOULEI_WODESHOULEI_CLOCK",function()
           if nextTime>0 then
                refreshTime()
            else
                Clock:removeTimeFun("SHOULEI_WODESHOULEI_CLOCK")
            end
    end)



	--我方擂台
	-- KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, 51 , 32 ,
	-- {
	-- 	priority = -210,
	-- 	front = SHOULEIPATH .. "wofangleitai.png",
	-- 	callback = function()
	-- 		mask:remove()
	-- 	end
	-- }):getLayer():addTo(bg)

	--领取奖励
	KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx , 47 ,
	{
		anchMid = true,
		priority = -210,
		front = COMMONPATH .. "get_award.png",
		callback = function()

			HTTP:call("empirearena","receiveAward",{ team_id = data.team.team_id } , {
				success_callback = function(_data)
					KNMsg:getInstance():flashShow( _data.msg or "" )

					if _data.wh then 
						local soul_data = DATA_SoulTemple:get()
						soul_data.info.wh = _data.wh
						self:createSoulHome()
					end

					self:shouleiDispatcher("shouleijiaofeng")
			end})


		end
	}):getLayer():addTo(bg)

	--关闭
	KNBtn:new( COMMONPATH , { "back_img.png" ,"back_img_press.png"}, 5 , 484 ,
	{
		priority = -210,
		callback = function()
			self.mask:remove()
			self.mask = nil
		end
	}):getLayer():addTo(bg)


end


function M:chuangjianduiwu(data , params)

	 local team_data = data.team_data or data.team or {}

	if table.nums( team_data.leader ) == 0 then 
		KNMsg:getInstance():flashShow("队长退出队伍，队伍取消")
		self:shouleiDispatcher("shouleijiaofeng")
		return 
	end

	local layer = display.newLayer()

	self:revmoeMask()

	self.mask = KNMask:new( {item = layer , priority = -141} )
	display.getRunningScene():addChild( self.mask:getLayer() )

	KNMsg:getInstance():flashShow( data.msg or "" )

	local bg = display.newSprite( COMMONPATH .. "tip_bg3.png" , display.cx , 239 , 0.5 , 0 ):addTo(layer)
    local title_bg = display.newSprite( IMG_PATH .. "image/scene/mission/title_bg.png" , display.cx+50 , 620 , 0.5 , 0 ):addTo(layer)

    display.newSprite( SHOULEIPATH .. "duiwuguanli_title.png" , title_bg:getContentSize().width/2-30 , title_bg:getContentSize().height/2 , 0.5 , 0.5 ):addTo(title_bg)

    display.newSprite( SHOULEIPATH .. "frame_bg1.png" ,  display.cx, 141 , 0.5 , 0  ):addTo( bg )

    local frame3 = display.newSprite( SHOULEIPATH .. "frame3.png" ,  60, 164 , 0 , 0  ):addTo( bg )
    local frame2 = display.newSprite( SHOULEIPATH .. "frame2.png" ,  249, 164 , 0 , 0  ):addTo( bg )


    --队长
    local leaderBtn = KNBtn:new(COMMONPATH, { getHeadPath( team_data.leader.logo .. "" ) },frame3:getContentSize().width/2 , 87 ,{
		anchMid = true,
		text =  { team_data.leader.lv , 14, ccc3(0xff, 0xfb, 0xd4), ccp(32, 31) , nil , 17} or nil,
		other = {COMMONPATH.."equip_lv_bg.png", 50, 52} or nil,
		front = COMMONPATH.."role_frame.png", 
		callback = function()
			
		end,
	} )
	leaderBtn:getLayer():addTo(frame3)
	leaderBtn:getLayer():addChild( display.strokeLabel( team_data.leader.name, 0, -25, 18 , ccc3(255,245,199)  ))
	leaderBtn:getLayer():addChild( display.strokeLabel( team_data.leader.ability .. "战力", -13, -46, 18 , ccc3(255,245,199)  ))
	display.newSprite( SHOULEIPATH.."duizhang_icon.png" , -6 , 110 , 0 , 0 ):flipX(true):addTo( frame3 )
	display.newSprite( SHOULEIPATH.."duizhang.png" , 27 , 106 , 0 , 0 ):addTo( frame3 )

	display.newSprite( SHOULEIPATH.."duiyou.png" , 4 , 106 , 0 , 0 ):addTo( frame2)

	Clock:removeTimeFun("SOULTEMPLE_TIME_CLOCK")


	local timetext = createLabel({str = "" , x = 150 , y = 100 ,  width = 303 , height = 50 , color = ccc3(43,2,2)})
	bg:addChild( timetext )


	local isInTime = false

	if table.nums( team_data.member )~=0 then 
		--队员
	    local memberBtn = KNBtn:new(COMMONPATH, { getHeadPath(team_data.member.logo .. "") },frame3:getContentSize().width/2 , 87 ,{
			anchMid = true,
			front = COMMONPATH.."role_frame.png", 
			text =  { team_data.member.lv, 14, ccc3(0xff, 0xfb, 0xd4), ccp(32, 31) , nil , 17} or nil,
			other = {COMMONPATH.."equip_lv_bg.png", 50, 52} or nil,
			callback = function()
				
			end,
		} )
		memberBtn:getLayer():addTo(frame2)
		memberBtn:getLayer():addChild( display.strokeLabel( team_data.member.name, 0, -25, 18 , ccc3(255,245,199)  ))
		memberBtn:getLayer():addChild( display.strokeLabel( team_data.member.ability .."战力", -13, -46, 18 , ccc3(255,245,199)  ))

		if params and params.fromShoulei then 

		else
			local refershTime = 3
			Clock:addTimeFun("SOULTEMPLE_TIME_CLOCK", function()
				isInTime = true
				timetext:setString( "组队成功倒计时："..refershTime.."秒" )
			    if refershTime == 0 then
					Clock:removeTimeFun("SOULTEMPLE_TIME_CLOCK")
					if tonumber(team_data.leader["uid"]) == tonumber(DATA_User:get("uid")) then 
						HTTP:call("empirearena","doCreateTeam",{ team_id = team_data.team_id } , {
							success_callback = function(data)
								self:shouleiDispatcher("shouleijiaofeng")
							end})
					else
						self:shouleiDispatcher("shouleijiaofeng")
					end
					
				end
				refershTime = refershTime - 1
			end)
		end

	else
		bg:addChild( display.strokeLabel( "等待加入中......", 154, 97, 26 , ccc3(43,2,2) ) )

		KNBtn:new(SHOULEIPATH, { "yaoqinghaoyou.png" },frame3:getContentSize().width/2 , frame2:getContentSize().height/2 ,{
			priority = -210,
			anchMid = true,
			callback = function()
				self:shouleiDispatcher( "yaoqinghaoyou" )
			end,
		} ):getLayer():addTo( frame2 )

	end

    --退出队伍
	KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx , 55 ,
	{
		anchMid = true,
		priority = -210,
		front = SHOULEIPATH .. "tuichuduiwu.png",
		callback = function()
				Clock:removeTimeFun("SOULTEMPLE_TIME_CLOCK")

				HTTP:call("empirearena","leaveTeam",{} , {
					success_callback = function(data)
						if params and params.fromShoulei then 
							self:shouleiDispatcher("shouleijiaofeng")
						else
							self:shouleiDispatcher( "leitaizudui")
						end
				end})

		end
	}):getLayer():addTo(bg)


	--关闭
	KNBtn:new( COMMONPATH , { "back_img.png" ,"back_img_press.png"}, 5 , 355 ,
	{
		priority = -210,
		callback = function()
			self:revmoeMask()
			if params and params.fromShoulei then 
				self:shouleiDispatcher("shouleijiaofeng")
			else
				if not isInTime then 
					HTTP:call("empirearena","leaveTeam",{} , {
						success_callback = function(data)
							self:shouleiDispatcher( "leitaizudui")
					end})
				end

			end
		end
	}):getLayer():addTo(bg)

end

function M:leitaidiyilun(data , params)


	local layer = params.notes[1]
	self:revmoeMask()

	self.mask = KNMask:new( {item = layer , priority = -141} )
	display.getRunningScene():addChild( self.mask:getLayer() )


	local team_data = data.team or {}

	

 --    --关闭
	-- KNBtn:new( COMMONPATH , { "back_img.png" ,"back_img_press.png"}, 5 , 317 ,
	-- {
	-- 	priority = -210,
	-- 	callback = function()
	-- 		mask:remove()
	-- 	end
	-- }):getLayer():addTo(bg)


	local refershTime = 3
	Clock:addTimeFun("SOULTEMPLE_BATTLE_CLOCK", function()
		isInTime = true
		refershTime = refershTime - 1
	    if refershTime == 0 then
			Clock:removeTimeFun("SOULTEMPLE_TIME_CLOCK")
				-- HTTP:call("empirearena","challenge",{ team_id = params.team_id } , {
				-- 	success_callback = function(_data)
							params.notes[1]:release()
							params.notes[1] = nil

							DATA_Battle:setMod("empirearena")
							DATA_Battle:setAct("challenge")
							DATA_Battle:set( params.battle_data )

							pushScene("battle" ,  { resultCallFun = function() 
									popScene()
									self:shouleiDispatcher("shouleijiaofeng")
								end,
							 notes = params.notes,
							 })

					-- end})
		end
	end)

    
    
end

function M:yaoqinghaoyou(data)
	local layer = display.newLayer()
		
	local mask = KNMask:new( {item = layer , priority = -220} )

	local bg = display.newSprite( COMMONPATH .. "tip_bg2.png" , display.cx , 239 , 0.5 , 0 ):addTo(layer)
    local title_bg = display.newSprite( IMG_PATH .. "image/scene/mission/title_bg.png" , display.cx+50 , 580 , 0.5 , 0 ):addTo(layer)

    display.newSprite( SHOULEIPATH .. "yaoqinghaoyou_title.png" , title_bg:getContentSize().width/2-30 , title_bg:getContentSize().height/2 , 0.5 , 0.5 ):addTo(title_bg)

    display.newSprite( SHOULEIPATH .. "frame_bg1.png" , display.cx , 96 , 0.5 , 0 ):addTo( bg )
   
	local select_frame = {}

    local function getItem(param)
    	local itemLayer = display.newLayer()
    	itemLayer:setContentSize( display.newSprite( SHOULEIPATH .. "select_frame.png" , 0 , 0  ):getContentSize() )

    	display.newSprite( SHOULEIPATH .. "line.png" , itemLayer:getContentSize().width-5 , itemLayer:getContentSize().height/2 , 0 , 0.5 ):addTo(itemLayer)

    	local icon
	    icon = KNBtn:new(COMMONPATH, {  getHeadPath(param.logo.."") },itemLayer:getContentSize().width/2 , 121 ,{
			anchMid = true,
			front = COMMONPATH.."role_frame.png", 
			priority = -221,
			text =  { param.lv , 14, ccc3(0xff, 0xfb, 0xd4), ccp(32, 31) , nil , 17} or nil,
			other = {COMMONPATH.."equip_lv_bg.png", 50, 52} or nil,
			callback = function()
					
					if select_frame.img then 
						select_frame.img:removeSelf()
						select_frame.uid = nil
						select_frame.img = nil
					end

					select_frame.uid = param.uid
					select_frame.img = display.newSprite( SHOULEIPATH .. "select_frame.png" , 0 , 0 , 0  ,0  )
					itemLayer:addChild( select_frame.img , -1 )

			end,
		} )
		icon:getLayer():addTo( itemLayer )

	    itemLayer:addChild( display.strokeLabel( param.name or "", 14, 62, 16 , ccc3(235,236,199) ) )
	    
	    local abilityLabel = ColorText:create( 14 , 40  ,  110 , 0 ,{ fontSize = 16 , paddingTop = 3 , anchorPoint = { x = 0 , y = 0 } , }  )
	    abilityLabel:addString( param.ability , ccc3( 255 , 233 , 233 ) )
	    abilityLabel:addString( "战力" , ccc3( 255 , 0 , 0 ) )
	    abilityLabel:getLayer():addTo(itemLayer)

	    itemLayer:addChild( display.strokeLabel( "剩余".. param.attck_times .."次", 14, 22, 16 , ccc3(235,236,199) ) )

	    itemLayer:addChild( display.strokeLabel( param.online==0 and "当前不在线" or "当前在线", 14, 2, 16 , ccc3( 85 , 237 , 240 ) ) )

	    -- itemLayer:addChild( select_frame )

    	return itemLayer
    end

    local scroll = KNScrollView:new( 51, 340, 390, 188 , 0 , true , nil , { priority = -222 }  )


    local listData = data.list or {}

	for i=1, #listData do
		
		local scroll_item  =getItem(listData[i])
		scroll:addChild( scroll_item )
	end

	layer:addChild( scroll:getLayer() )

	--邀请
	KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx , 50 ,
	{
		anchMid = true,
		priority = -222,
		front = SHOULEIPATH .. "yaoqing.png",
		callback = function()

				HTTP:call("empirearena","invite",{ fuid = select_frame.uid } , {
				success_callback = function(data)
					mask:remove()
				end})
		end
		}):getLayer():addTo(bg)

    --关闭
	KNBtn:new( COMMONPATH , { "back_img.png" ,"back_img_press.png"}, 5 , 317 ,
	{
		priority = -222,
		callback = function()
			mask:remove()
		end
	}):getLayer():addTo(bg)

	return mask

end


function M:shouleiDispatcher(param , request_data)

	local request_data = request_data or {}

	if param == "shouleijiaofeng" then 
		HTTP:call("empirearena","initData",request_data , {
				success_callback = function(_data)
					if _data.wh then 
						local data = DATA_SoulTemple:get()
						data.info.wh = _data.wh
						self:createSoulHome()
					end
					self:shouleijiaofeng(_data)
					-- dump(data , "data")
					-- display.getRunningScene():addChild( self:shouleijiaofeng(data):getLayer() )
				end
		})
	elseif param == "leitaizudui" then 
		HTTP:call("empirearena","getTeamList",request_data, {
				success_callback = function(data)
					self:leitaizudui(data)
					-- display.getRunningScene():addChild( self:leitaizudui(data):getLayer() )
				end
		})
	elseif param == "chuangjianduiwu" then 
		HTTP:call("empirearena","createTeam",request_data , {
				success_callback = function(data)
					self:chuangjianduiwu(data)
					-- display.getRunningScene():addChild( self:chuangjianduiwu(data):getLayer() )
				end
		})
	elseif param == "yaoqinghaoyou" then 
		HTTP:call("empirearena","getFriendList",request_data , {
				success_callback = function(data)
					dump(data , "data")
					-- self:yaoqinghaoyou(data)
					display.getRunningScene():addChild( self:yaoqinghaoyou(data):getLayer() )
				end
		})
	end

end

function M:revmoeMask()
	if self.mask then 
		self.mask:remove()
		self.mask = nil
	end
end

function M:leitaizudui(param)

	local layer = display.newLayer()

	self:revmoeMask()

	self.mask = KNMask:new( {item = layer , priority = -141} )
	display.getRunningScene():addChild( self.mask:getLayer() )
	

	local bg = display.newSprite( COMMONPATH .. "change_bg.png" , display.cx , 122 , 0.5 , 0 ):addTo(layer)

	display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png" , display.cx + 40 , 510 , 0.5 , 0 ):addTo(bg)
	display.newSprite(SHOULEIPATH.."leitaizudui_title.png" , display.cx , 516 , 0.5 , 0 ):addTo(bg)

	
	local curPage , pageCount , pageSize  , scroll
	pageSize = 10
	curPage = 1

	local function getItem(param)

		local item_bg = display.newSprite( COMMONPATH .. "item_bg.png" )

		local icon = KNBtn:new(COMMONPATH, { getHeadPath( param.leader.logo or "19001" ) },55 , item_bg:getContentSize().height / 2 ,{
			anchMid = true,
			parent = param.parent or nil,
			text =  { param.leader.lv , 14, ccc3(0xff, 0xfb, 0xd4), ccp(32, 31) , nil , 17} or nil,
			other = {COMMONPATH.."equip_lv_bg.png", 50, 52} or nil,
			front = COMMONPATH.."role_frame.png", 
			callback = function()
				
			end,
		} ):getLayer():addTo(item_bg)
		item_bg:addChild( display.strokeLabel( param.leader.name , 26, 3, 16 , ccc3(235,245,199)  ))

		local totalAbility = param.leader.ability + ( param.member.ability or 0 )


		local duiwurenyuan = display.newSprite( SHOULEIPATH .. "duiwurenyuan.png" , 100 , 67 ,  0, 0 ):addTo(item_bg)
		local zongzhanli = display.newSprite( SHOULEIPATH .. "zongzhanli.png" , 100 , 38 ,  0, 0 ):addTo(item_bg)
		local zhuangtai = display.newSprite( SHOULEIPATH .. "zhuangtai.png" , 100 , 8 ,  0, 0 ):addTo(item_bg)

		duiwurenyuan:addChild( display.strokeLabel( param.member.name , 	duiwurenyuan:getContentSize().width + 5, 0, 18 , ccc3(68,27,7)) )								
		zongzhanli:addChild( display.strokeLabel(  totalAbility , 	zongzhanli:getContentSize().width + 5, -3, 18 , ccc3(117,15,11)) )		
		zhuangtai:addChild( display.strokeLabel(  table.nums(param.member) == 0 and "等待加入" or "人员已满",	zhuangtai:getContentSize().width + 5, 0 , 18 ,ccc3(117,15,11) ) ) 											

		KNBtn:new(COMMONPATH, { "btn_bg.png" , "btn_bg_pre.png"},340 , 48 ,{
			priority = -200,
			front = SHOULEIPATH.."join.png",
			callback = function()
				HTTP:call("empirearena","joinTeam",{ team_id = param.team_id } , {
						success_callback = function(data)

							dump(data , "data")

							self:revmoeMask()
							self:chuangjianduiwu(data)
						end
				})
			end,
		} ):getLayer():addTo(item_bg)

		item_bg:addChild( display.strokeLabel(  (table.nums(param.member) == 0 and 1 or 2).."/2",363, 23 , 16 ,ccc3(255,247,237)) )


		return item_bg
	end



	local listData = param.list or {}


	local function createScrollList(params , pageNow)
		local startIndex , endIndex
		curPage = pageNow
		if pageNow * pageSize < #params then
			startIndex = (pageNow-1) * pageSize
			endIndex = pageNow * pageSize
		else
				startIndex = (pageNow-1) * pageSize
			endIndex = #params
		end

		scroll = KNScrollView:new(14 , 234 , 445 , 365 , 3, false, 0,{
					priority = -201
				})
		for i=startIndex + 1,endIndex do
			scroll:addChild( getItem(params[i]) )
		end
		layer:addChild( scroll:getLayer() , 10)

	end


	
	
	pageCount = ( #listData - 1 ) / pageSize + 1
	pageCount = tonumber( string.sub(pageCount , 1 , string.find(pageCount , ".")) )

	createScrollList(listData , curPage)

	local pageNum = display.strokeLabel( curPage.."/"..pageCount, 0, 0, 20, ccc3(0xff, 0xfb, 0xd4))
	setAnchPos(pageNum, 245, 197, 0.5)
	layer:addChild(pageNum)


	display.newSprite( COMMONPATH .. "page_bg.png" , display.cx , 68 , 0.5 , 0 ):addTo( bg )

	--创建队伍
	KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx , 35 ,
	{
		anchMid = true,
		priority = -210,
		front = SHOULEIPATH .. "chuangjianduiwu.png",
		callback = function()
				self:revmoeMask()
				self:shouleiDispatcher( "chuangjianduiwu" )
		end
	}):getLayer():addTo(bg)

	--翻页按钮
	local pre_btn = KNBtn:new(COMMONPATH,{"next.png"}, 175, 188, {
		scale = true,
		flipX = true,
		priority = -201,
		callback = function()
			if curPage > 1 then
				layer:removeChild( scroll:getLayer() , true )
				createScrollList( listData , curPage-1 )
				pageNum:setString( curPage.."/"..pageCount )
			end
		end
	})
	layer:addChild(pre_btn:getLayer())
	
	local next_btn = KNBtn:new(COMMONPATH,{"next.png"}, 293, 188, {
		scale = true,
		priority = -201,
		callback = function()
			if curPage < pageCount then
				layer:removeChild( scroll:getLayer() , true )
				createScrollList( listData , curPage+1 )
				pageNum:setString( curPage.."/"..pageCount )
			end
		end
	})
	layer:addChild(next_btn:getLayer())

	--关闭
	KNBtn:new( COMMONPATH , { "back_img.png" ,"back_img_press.png"}, 5 , 484 ,
	{
		priority = -210,
		callback = function()
			self:revmoeMask()
			self:shouleiDispatcher("shouleijiaofeng")
		end
	}):getLayer():addTo(bg)


end

function M:createNoticeItem( notice_data , parent )

	--[[
		infoType :
				1.	个人积分信息
				2.	职位信息
				3.	升职被挑战方
				4.	每日职位积分消耗
				5.	点赞消息
				6.	被点赞消息
	]]

	local  normal_color , username_color , jobname_color , point_color , server_color = ccc3(255,232,232) , ccc3(251,231,38) , ccc3(77,255,232) , ccc3(232,0,0) , ccc3(255,255,255)

	local jobInfo = DATA_SoulTemple:get("info")

	local infoType = tonumber(notice_data.type) 
	local noticeTitle = ""
	local isWin = (notice_data.win==1)

	local notice = ColorText:create( parent:getWidth() , 0  ,  303 , 0 ,{ fontSize = 20 , paddingTop = 3 , anchorPoint = { x = 1 , y = 0 } , }  )

	if infoType == 1 then 
		noticeTitle = "【个人】: "

		notice:addString( "你挑战"  , normal_color )

		if tonumber(notice_data.flag) == 2 then 
			noticeTitle = "【跨服】: "
			notice:addString( "*" .. notice_data.servername .. "*区的"  , server_color )
		end

		notice:addString( (notice_data.name and notice_data.name ~= "") and "【"..notice_data.name.."】" or ""  , username_color )
		notice:addString(getJobConfByPid(notice_data.pid).cname or "" , jobname_color )
		notice:addString(  isWin and "成功，" or "失败，" , normal_color )
		notice:addString( isWin and "获得积分" or "仅获得积分" ,normal_color )
		notice:addString( notice_data.point or "" , point_color )

	elseif infoType == 2 then 
		noticeTitle = "【职位】: "

		notice:addString( "你挑战"  , normal_color )

		if tonumber(notice_data.flag) == 2 then 
			noticeTitle = "【跨服】: "
			notice:addString( "*" .. notice_data.servername .. "*区的"  , username_color )
		end

		notice:addString( (notice_data.name and notice_data.name ~= "")  and "【"..notice_data.name.."】" or ""  , username_color )
		notice:addString(getJobConfByPid(notice_data.pid).cname or "" , jobname_color )
		notice:addString(  isWin and "成功，" or "失败，" , normal_color )

		if isWin then 
			notice:addString( "升职为" , normal_color )
			notice:addString( getJobConfByPid(notice_data.pid).cname or "" , jobname_color )
			notice:addString( "！" , normal_color )
		else
			notice:addString( "没有升职职位" , normal_color )
		end
	elseif infoType == 3 then 
		noticeTitle = "【职位】: "

		notice:addString( "你在"  , normal_color )
		notice:addString(getJobConfByPid(notice_data.pid).cname or "" , jobname_color )
		notice:addString( "上被"  , normal_color )
		notice:addString( "*" .. notice_data.servername .. "*区的" , server_color )
		notice:addString( (notice_data.name and notice_data.name ~= "") and ("【"..notice_data.name.."】") or ""  , username_color )
		notice:addString( "升职挑战" .. (not isWin and "成功" or "") .. "了，" .. (isWin and "你成功防守了这次攻击！" or "你失去了该职位！")  , normal_color )

	elseif infoType == 4 then 
		noticeTitle = "【职位】: "

		notice:addString( "昨日扣税后，你的积分不满足"  , normal_color )
		notice:addString(getJobConfByPid(notice_data.pid).cname or "" , jobname_color )
		notice:addString( "的资格,你被降职了！"  , normal_color )

	elseif infoType == 5 then 
		noticeTitle = "【个人】: "

		notice:addString( "给"  , normal_color )
		notice:addString( "*" .. notice_data.servername .. "*区的"  , server_color )
		notice:addString( (notice_data.name and notice_data.name ~= "") and "【"..notice_data.name.."】" or ""  , username_color )
		notice:addString( "点赞1次"  , normal_color )
		-- notice:addString( string.format("剩余点赞次数%s次" ,3 - tonumber(jobInfo.base.like) )  , normal_color )

	elseif infoType == 6 then 
		noticeTitle = "【个人】: "

		notice:addString( "被"  , normal_color )
		notice:addString( "*" .. notice_data.servername .. "*区的" , server_color )
		notice:addString( (notice_data.name and notice_data.name ~= "") and "【"..notice_data.name.."】" or ""  , username_color )
		notice:addString( "点赞1次"  , normal_color )
		-- notice:addString( string.format("今日已被点赞%s次" , jobInfo.base.liked)  , normal_color )
	elseif infoType >= 7 then 
		noticeTitle = "【擂台】: "
		notice:addString( notice_data.msg or "" )
	end

	return notice , noticeTitle
end


--魂殿公告
function M:createNoticeLayer(param)
	local noticeLayer = display.newLayer()

	local mask = KNMask:new( {item = noticeLayer , priority = -141} )
	
	noticeLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/headline/frame.png" , display.cx , display.cy , 0.5 , 0.5 ) )
	noticeLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/headline/" .. "bg.png" , display.cx , 90 , 0.5 , 0  ) , -2 )
	noticeLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/headline/item_line.png" , display.cx , 601 , 0.5 , 0 ) )
	noticeLayer:addChild( display.newSprite( IMG_PATH .. "image/scene/headline/" .. "headline_title_bg.png" , display.cx , 495 , 0.5 , 0  ) )
	noticeLayer:addChild( display.newSprite( PATH .. "notice_title.png" , display.cx , 630 , 0.5 , 0  ) )

	local noticeList = param.list or {}

	-- noticeList = {
	-- 	{ 
	-- 		uid = 1,
	-- 		name = "张龙傻逼",
	-- 		to_uid = 2,
	-- 		type = 1,
	-- 		flag = 2,
	-- 		win = 1,
	-- 		pid = 1,
	-- 		point = 12,
	-- 		servername = "飞龙在天",
	-- 	},
	-- 	{ 
	-- 		uid = 1,
	-- 		name = "张龙傻逼",
	-- 		to_uid = 2,
	-- 		type = 2,
	-- 		win = 1,
	-- 		pid = 1,
	-- 		point = 12,
	-- 		servername = "飞龙在天",
	-- 	},
	-- 	{ 
	-- 		uid = 1,
	-- 		name = "张龙傻逼",
	-- 		to_uid = 2,
	-- 		type = 3,
	-- 		win = 1,
	-- 		pid = 1,
	-- 		point = 12,
	-- 		servername = "飞龙在天",
	-- 	},
	-- 	{ 
	-- 		uid = 1,
	-- 		name = "张龙傻逼",
	-- 		to_uid = 2,
	-- 		type = 4,
	-- 		win = 1,
	-- 		pid = 1,
	-- 		point = 12,
	-- 		servername = "飞龙在天",
	-- 	},
	-- 	{ 
	-- 		uid = 1,
	-- 		name = "张龙傻逼",
	-- 		to_uid = 2,
	-- 		type = 5,
	-- 		win = 1,
	-- 		pid = 1,
	-- 		point = 12,
	-- 		servername = "飞龙在天",
	-- 	},
	-- 	{ 
	-- 		uid = 1,
	-- 		name = "张龙傻逼",
	-- 		to_uid = 2,
	-- 		type = 6,
	-- 		win = 1,
	-- 		pid = 1,
	-- 		point = 12,
	-- 		servername = "飞龙在天",
	-- 	},

	-- }

	local scroll = KNScrollView:new( 40, 186, 400, 410 , 5 , false , nil , { priority = -142 }  )

	for i=1,table.nums(noticeList) do
		
		local scroll_item = display.newLayer()

		local notice , noticeTitle = self:createNoticeItem( noticeList[i] , scroll )

		-- local notice_label = createLabel({str =  notice:getStr() or "" , x = scroll:getWidth() , y = 0 ,  width = 303 , height = 50 , color = ccc3(255,232,232)})
		local notice_label = notice:getLayer()
		setAnchPos( notice_label ,scroll:getWidth() ,0 ,1 , 0  )

		local notice_title = display.strokeLabel(  noticeTitle or "", -80, 0, 20 , ccc3(255,232,234))
		setAnchPos(notice_title , 0 , notice:getHeight(),1,1)
		notice_label:addChild( notice_title )

		scroll_item:setContentSize( CCSize( scroll:getWidth() , notice:getHeight() ) )
		scroll_item:addChild( notice_label )

		scroll:addChild( scroll_item )
	end

	noticeLayer:addChild( scroll:getLayer() )

	--关闭
	local closeBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"}, display.cx - 72 , 120 ,
	{
		priority = -210,
		front = COMMONPATH .. "colse_text.png" ,
		callback = 
		function()
			mask:remove()
		end
	}):getLayer()
	noticeLayer:addChild( closeBtn )

	noticeLayer:setScale(0.1)
	transition.scaleTo(noticeLayer , {time = 0.1 , scale = 1 , easing = "BACKOUT" })

	return mask
end


--[[魂殿地图     
		 	center  魂殿中心
			screte  魂殿秘境
]]

function M:createSoulMap(param)
	if self.viewLayer then self.viewLayer:removeSelf() end

	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )

	self:setInfoLayer({title= PATH.. ( param.map or "center").. "_title.png" , 
		closeCallFunc = function()  
			if param.from=="center" then  												--如果是从魂殿中心进入的，则返回到魂殿中心去
				self:createSoulMap({map="center"})
			else
				self:createSoulHome() 
			end 
		end })
	self.viewLayer:addChild( display.newSprite(PATH .. (param.map or "center").."_bg.jpg" , display.cx , display.cy , 0.5 , 0.5) )

	local jobInfo = DATA_SoulTemple:get("info")

	dump(DATA_SoulTemple:get() )

	if  KNGuide:getStep() == 20040  then 
		KNGuide:show( nil , {
			mask_clickable = true,
			callback = function()
				self:createSoulMap({map="screte"})
			end,
			x = -100,
			y = 300,
			width = 1,
			height = 1,
		})
	end


	for k,v in pairs(job_config) do 													--生成每一个 当前地图的 职位信息
		repeat
			if v.mtype ~= param.map  then break end

			local place_data = jobInfo.place_data[v.pid..""] or {}

			local jobBtn = KNBtn:new(PATH, {v.ename.."_img.png"}, v.pos.x, v.pos.y, {
				priority = -131,
				callback = function()
					HTTP:call("empire","getPlaceList",{ pid = v.pid } , {
							success_callback = function(data)
								-- dump(data , "getPlaceList")

								if tonumber(jobInfo.pid)==tonumber(v.pid) and tonumber(place_data.cur_member)==1 then 
									KNMsg:getInstance():flashShow("目前只有您一个人在该军职")		
									return 							
								end 

								if tonumber(place_data.cur_member) == 0 then 
									KNMsg:getInstance():flashShow( tonumber(v.pid) == 1 and "该军职不限制人数" or "该军职玩家人数为0，好机会，快去抢占吧！")
								else
									self:createWorshipLayer({ job = v.ename ,  mtype = v.mtype , list = data.list , pid = v.pid})
								end
							end
					})
					print("v.ename = " .. v.ename)
				end
			}):getLayer()


			if tonumber(jobInfo.pid) == tonumber(v.pid) then
				local arrow_ani = display.newSprite(IMG_PATH.."image/scene/godCell/arrow_ani.png")
				setAnchPos(arrow_ani, jobBtn:getContentSize().width /2, jobBtn:getContentSize().height  /2)
				local function jump()
					local action = getSequenceAction(CCJumpTo:create(1,  ccp(jobBtn:getContentSize().width /2,jobBtn:getContentSize().height  /2), 30, 1), CCCallFunc:create(function()
						arrow_ani:runAction(jump())
					end))
					return action
				end
				arrow_ani:runAction(jump())
				jobBtn:addChild(arrow_ani , 11)
			end  

			-- local job_logo = display.newSprite(PATH .. k.."_icon.png")
			local job_name = display.newSprite(PATH .. v.ename.."_text.png" , jobBtn:getContentSize().width/2 + 10 , v.offSetY or 0 , 0.5 , 0)

			job_name:addChild( display.newSprite( PATH .. v.ename .."_icon.png" , string.utf8len(v.cname)==4 and -29 or -41 , job_name:getContentSize().height/2 , 0 , 0.5 , 0.35 ) )
			jobBtn:addChild( job_name )
		
			if place_data.member ~= 0 then 
				local num = display.strokeLabel( place_data.cur_member .. "/" .. place_data.member , 0, 0, 18 , ccc3(255,255,255))
				setAnchPos( num , job_name:getContentSize().width /2 , 0,  0.5 , 1 )
				job_name:addChild( num )
			end

			if tonumber(v.pid) == 1 then 
				job_name:addChild( display.strokeLabel( "不限人数" , 10, -25, 18 , ccc3(255,255,255)) )
			end


			self.viewLayer:addChild(jobBtn)
		until true
	end

	if param.map == "center" then 											--魂殿中心 有魂殿秘境的入口
		local screteEntry = KNBtn:new(PATH, {"screteEntry_img.png"}, 193, 555, {
			priority = -131,
			text = {  "跨服" , 20  , ccc3(255,255,255) , { x=0,y=-120} }, 
			other = {PATH.."screte_entry_label.png", 40, 0 },
			callback = function()
				self:createSoulMap({map = "screte" , from="center"})
			end
		})
		self.viewLayer:addChild(screteEntry:getLayer())

		if KNGuide:getStep() == 20030 then 
			KNGuide:show( screteEntry:getLayer() )
		end
	elseif param.map == "screte" then 
		local server_info = display.strokeLabel( self.params.data.server_info or "", 20, 70, 15 , ccc3(251,255,0) , nil , nil, { dimensions_width = 440 , dimensions_height = 70 , align = 0 } )
		setAnchPos( server_info , display.cx , 85 , 0.5 , 0 )
		self.viewLayer:addChild( server_info )
	end
end

--魂殿膜拜列表
function M:createWorshipLayer(param)
	if self.viewLayer then self.viewLayer:removeSelf() end

	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )

	self:setInfoLayer({
		title 			=PATH.. param.job.."_title.png" , 
		closeCallFunc 	= function() 
			self:createSoulMap( {map = param.mtype } )
		end })

	local jobInfo = DATA_SoulTemple:get("info")

	self.viewLayer:addChild( display.newSprite(COMMONPATH .. "dark_bg.png" , 0  , 88 , 0 , 0) )
	self.viewLayer:addChild( display.newSprite(PATH .. "worship_counts.png" , 21 ,721 , 0 , 0) )
	self.viewLayer:addChild( display.strokeLabel( jobInfo.base.like .. "/3", 127, 721, 18 , ccc3(255,255,255)) )

	local scroll = KNScrollView:new( 21, 139, 448, 566 , 5 , false )
	local listData = param.list or {}
	for k,v in pairs(listData) do
		local item = {}
		item.type = "worship"
		item.optFront = PATH.."worship_label.png"
		item.parent = scroll
		item.data = v
		item.disabledMsg = "你已经对他点过赞了"
		item.isGrey = (tonumber(v.liked) == 1) 
		item.optCallback = function()
			print("膜拜")
			HTTP:call("empire","like",{ to_uid = v.uid , pid = v.pid } , {
					success_callback = function(data)
						-- dump(data , "getChallengeList111")
						if data and data.msg  then 
							KNMsg:getInstance():flashShow(data.msg)
						end
						HTTP:call("empire","getPlaceList",{ pid = param.pid } , {
								success_callback = function(data)
									self:createWorshipLayer({ job = param.job ,  mtype = param.mtype , list = data.list , pid = param.pid})
									-- dump(data , "getPlaceList")
								end
						})
					end
			})
		end
		scroll:addChild( self:createItem(item) )
	end
	self.viewLayer:addChild( scroll:getLayer() )
end


--魂殿挑战列表
function M:createChallengeList(param)
	if self.viewLayer then self.viewLayer:removeSelf() end

	self.viewLayer = display.newLayer()
	self.baseLayer:addChild( self.viewLayer )

	self:setInfoLayer({
		title 			=PATH.. "challenge_title.png" , 
		closeCallFunc 	= function() 
			self:createSoulHome()
		end })

	-- dump(param , "param")

	local jobInfo = DATA_SoulTemple:get("info")

	local listData = param._data.list or {}

	-- dump(listData , "listData")

	self.viewLayer:addChild( display.newSprite(COMMONPATH .. "dark_bg.png" , 0  , 88 , 0 , 0) )

	if param.type == "points" then 
		self.viewLayer:addChild( display.newSprite(PATH .. "challenge_counts.png" , 21 ,721 , 0 , 0) )
		self.viewLayer:addChild( display.strokeLabel(param._data.times .. "/" ..param._data.free_times , 127, 721, 18 , ccc3(255,255,255)) )

		--重置
		local resetBtn = KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" }, 183 , 711,
		{
			-- priority = -131,
			front = PATH .. "reset_label.png",
			callback = function()

				local content  = display.newLayer()
				
				local label = createLabel({str = "重置则刷新所有列表敌人并回复挑战次数到10次，是否确认？", x = 45 , y = 410 ,  width = 380})
				content:addChild( label )

				content:addChild( display.newSprite( COMMONPATH .. "gold.png" , 70 , 275 ) )

				content:addChild( display.strokeLabel( "50" , 100, 265, 18 ) )

				showTip({
					content = content ,
					left = {
						remove = true,
						front = COMMONPATH .. "buy.png",
						callback = function()	
							HTTP:call("empire","resetTimes",{  } , {
								success_callback = function(data)
									if data and data.msg  then 
										KNMsg:getInstance():flashShow(data.msg)
									end

									self:createChallengeList({ type = param.type , _data = data })

								end
							})
						end
					},right = {
						remove = true	
					}
				})
			end
		}):getLayer()
		self.viewLayer:addChild( resetBtn )	
	end

	local scroll = KNScrollView:new( 21, 139, 448, 566 , 5 , false )
	dump(listData , "listData")
	dump(param.type  ,"param.type")
	for i=1 , table.nums(listData) do
		local v = listData[i]
		local item = {}
		-- item.type = "challenge"
		item.disabledMsg = "本轮已经击败过对手了，你可以向下挑战其他对手或者【重置】"
		item.parent = scroll
		item.isGrey =  param.type == "points" and (tonumber(v.flag) == 1) 
		item.optFront = IMG_PATH .. "image/scene/athletics/fighting.png"
		item.data = v
		item.optCallback = function()

			local function httpfunc()
				HTTP:call("empire","challenge",{  type = (param.type =="points" and 1 or 2) ,  pid = v.pid , to_uid = v.uid } , {
						success_callback = function(data)

							DATA_Battle:setMod("empire")
							DATA_Battle:setAct("challenge")
							DATA_Battle:set( data)
							pushScene("battle" ,  {resultCallFun = function() 
									popScene()

									if param.type == "points" then 
										HTTP:call("empire", "getChallengeList" ,{ pid = jobInfo.pid } , {
												success_callback = function(data)
													dump(data , "data")

													self:createChallengeList({ type = param.type , _data = data })
												end
										})
									elseif param.type == "upJob" then 
										self:createSoulHome()
									end
									
								end} )
						end
				})
			end

			local job_data = job_config[tonumber(jobInfo.pid)] or {}

			if (jobInfo.point >= job_data.max_point) and param.type=="points" then 
				showTip({
					content = createLabel({str = "已达到当前职业上限，进行挑战操作将无法获得积分，是否确定挑战？", width = 380, size = 20}) ,
					left = {
						remove = true,
						callback = function()	
							httpfunc()
						end
					},right = {
						remove = true	
					}
				})
				return 
			end
			httpfunc()
		end
		scroll:addChild( self:createItem(item) )
	end

	if KNGuide:getStep() == 20080 then 
		KNGuide:show( scroll:getItems(1):getLayer() , {
				x = 362,
				y = 634,
				-- remove = true,
			} )
	end


	self.viewLayer:addChild( scroll:getLayer() )
end

--魂殿升职
function M:createUpJobLayer()
	local upJobLayer = display.newLayer()

	local mask = KNMask:new( {item = upJobLayer , priority = -141} )

	upJobLayer:addChild( display.newSprite( PATH.."upJob_bg.png" , display.cx , 38 , 0.5  ,0 ) )
	upJobLayer:addChild( display.newSprite( COMMONPATH .. "change_title_bg.png" , display.cx , 718 , 0.5 ,0.5 ) )
	upJobLayer:addChild( display.newSprite( PATH .. "upJob_title.png" ,  display.cx , 700 , 0.5 , 0 ) )

	local jobInfo = DATA_SoulTemple:get("info")

	local function getUpJobInfo(pid) 													--根据 pid 得到职位的信息
		local layer = display.newLayer()

		local job_data = getJobConfByPid(pid)

		local info_bg = display.newSprite( PATH .. "upjob_info_bg.png" , 0 , 0 , 0 , 0 )
		layer:setContentSize( info_bg:getContentSize() )
		layer:addChild( info_bg )

		layer:addChild( display.newSprite( PATH .. "person_counts.png" , 22 , 17 , 0 ,0  ) )
		layer:addChild( display.newSprite( PATH .. "points_top.png" , 187 , 17 , 0 ,0 ) )

		local place_data = jobInfo.place_data[pid..""] or {}

		layer:addChild( display.strokeLabel(  tonumber(job_data.member) == 0 and "不限" or (place_data.cur_member .. "/".. job_data.member .."位"), 	74, 46, 18 , ccc3(255,237,237)) )									--人数
		layer:addChild( display.strokeLabel( job_data.max_point or "", 	282, 46, 18 , ccc3(255,237,237)) )									--积分上限
		layer:addChild( display.strokeLabel( job_data.cost .."积分/天", 	74, 20, 18 , ccc3(255,237,237)) )								--交税
		layer:addChild( display.strokeLabel( job_data.max_wh or "", 	282, 20, 18 , ccc3(255,237,237)) )									--魂币上限

		layer:addChild( display.newSprite( PATH .. "day_salary.png" , 126 , 165 , 0 ,0  ) )

		layer:addChild( display.newSprite( PATH .. (job_data.ename or "xinwei") .. "_icon.png" , 62 ,95 , 0.5 , 0 , 0.79 ) )
		layer:addChild( display.newSprite( PATH .. (job_data.ename or "xinwei") .. "_text.png" , 62 ,81 , 0.5 , 0 , 0.79) )

		local awardCofig = { 
			{ icon = "soul_coin.png" ,desc = string.format("武魂币X%s，可用来兑换奖励" ,  getJobConfByPid(pid)[jobInfo["week"]] or "0" ),  has = tobool(getJobConfByPid(pid)[jobInfo["week"]]) , num = tonumber(getJobConfByPid(pid)[jobInfo["week"]]) },
			{ icon = "soul_box.png" , desc = "俸禄宝箱，可随机获得物品",  has = not(job_data.box == "0")  }
		 }

		for i=1,2 do
			if awardCofig[i].has then 
				local award_btn = KNBtn:new(SCENECOMMON, { "skill_frame1.png" }, 133 + (i-1)*140 , 90, {
					front =PATH.. awardCofig[i].icon, 
					scale = true,
					priority = -142,
					callback = function()
						KNMsg:getInstance():flashShow(awardCofig[i].desc or "")
					end
				}):getLayer()
				layer:addChild( award_btn )

				if awardCofig[i].num then 
					local other =  display.newSprite( IMG_PATH .. "image/scene/activity_new/num_bg.png"  , award_btn:getContentSize().width  , 0  , 0.7 , 0 )
					local text =  display.strokeLabel( awardCofig[i].num or "", 	other:getContentSize().width /2,  other:getContentSize().height/2, 14 , ccc3(255,255,227)) 
					setAnchPos(text ,other:getContentSize().width /2,  other:getContentSize().height/2 , 0.5 , 0.5 )
					other:addChild(text)

					award_btn:addChild( other , 10 )
				end
			end
		end
		return layer
	end


	for i=0,1 do 
		local layer = getUpJobInfo(jobInfo.pid+i) 
		layer:setPosition( ccp(36, 441 - i*295) )
		upJobLayer:addChild( layer )
	end

	upJobLayer:addChild( display.newSprite(IMG_PATH .. "image/scene/forge/arrow.png" , display.cx , 360 , 0.5 , 0  ) )

	--关闭
	local closeBtn = KNBtn:new( COMMONPATH , { "back_img.png" ,"back_img_press.png"}, 35 , 665,
	{
		priority = -142,
		callback = 
		function()
			mask:remove()
		end
	}):getLayer()
	upJobLayer:addChild( closeBtn )	

	local upJobBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" }, display.cx, 102, {
		front = PATH .. "upJob_label.png",
		priority = -142,
		anchMid = true,
		callback = function()
			HTTP:call("empire","promotePlace",{  } , {
					success_callback = function(data)
						dump(data , "data")

						if tonumber(data.type) == 1 then 
							KNMsg:getInstance():flashShow(data.msg or "")
							mask:remove()
							self:createSoulHome()
						elseif tonumber(data.type) == 2 then 
							mask:remove()
							self:createChallengeList({ type = "upJob" , _data = data })
						end
					end
			})
		end
	})
	upJobLayer:addChild(upJobBtn:getLayer())

	local desc = display.strokeLabel("说明：升职需积分达到".. job_config[(tonumber(jobInfo.pid)+1)].point  .. "点", 	74, 46, 18 , ccc3(185,40,40))
	setAnchPos( desc , display.cx , 56 , 0.5 , 0 )
	upJobLayer:addChild( desc )

	upJobLayer:setScale(0.1)
	transition.scaleTo( upJobLayer , { time = 0.1 , scale = 1 , easing = "BACKOUT" } )

	return mask
end

function M:createItem(param)
	local itemLayer = display.newLayer()
	local item_bg = display.newSprite( COMMONPATH.."item_bg.png" , 0 , 0 , 0 ,0  )

	local size = item_bg:getContentSize()

	itemLayer:setContentSize(size)
	itemLayer:addChild( item_bg )

	local data = param.data or {}
	local hasServer = false

	if data.servername then  
		hasServer = true

		itemLayer:addChild( display.strokeLabel( data.servername or "",			150, 10 , 18 , ccc3(68,27,7)) )
	end
	
	local offSetY = (hasServer and 15 or 0)

	itemLayer:addChild( display.newSprite( PATH .. (hasServer and "info_server.png" or "info_normal.png") , 98 , size.height /2 ,0,0.5 ) )							--玩家所在服务器名称

	itemLayer:addChild( display.strokeLabel( data.name or "", 	150,  hasServer and 79 or 71 + offSetY, 18 , ccc3(68,27,7)) )										--玩家名字
	itemLayer:addChild( display.strokeLabel( getJobConfByPid(data.pid).cname or "", 			150, hasServer and 55 or 44 + offSetY, 18 , ccc3(68,27,7)) )		--玩家职位名称
	itemLayer:addChild( display.strokeLabel( data.ability or "",			150, 17 + offSetY, 18 , ccc3(83,247,237)) )												--玩家战力

	local icon = KNBtn:new(COMMONPATH, { getHeadPath( data.head or "19001" ) },55 , size.height / 2 ,{
		anchMid = true,
		parent = param.parent or nil,
		front = COMMONPATH.."role_frame.png", 
		callback = function()
			if param.iconCallback then 
				param.iconCallback()
			end
		end,
	} )
	itemLayer:addChild(icon:getLayer())

	local optBtn = KNBtn:new(COMMONPATH, param.isGrey and {"btn_bg_grey.png"} or { "btn_bg.png" , "btn_bg_pre.png" },380 , size.height / 2 + 10,{
		anchMid = true,
		parent = param.parent or nil,
		front =  param.optFront,
		callback = function()
			if param.isGrey then 
				KNMsg:getInstance():flashShow(param.disabledMsg or "")
				return 
			end

			if param.optCallback then 
				param.optCallback()
			end
		end,
	} )
	itemLayer:addChild(optBtn:getLayer())

	return itemLayer , optBtn
end

--设置 InfoLayer 的 title 和 close回调
function M:setInfoLayer(data)
	local param  = data or {}

	if not param.title then 
		param.title = PATH .. "screte_title.png"
	end

	if not param.closeCallback then 
		param.closeCallback = function() switchScene("pvp") end
	end

	if self.infoLayer then 
		self.infoLayer:refreshTitle(param.title)
		self.infoLayer.params.closeCallback = param.closeCallFunc
	else
		self.infoLayer = InfoLayer:new("soulTemple" , 0, {tail_hide = true, title_text =  param.title , closeCallback = param.closeCallFunc})
		self.baseLayer:addChild( self.infoLayer:getLayer() , 10 )
	end

	if KNGuide:getStep() == 20050 or KNGuide:getStep() == 20091 or KNGuide:getStep() == 20120 then
		self.infoLayer.params.closeCallback = function() self:createSoulHome() end
		KNGuide:show( self.infoLayer:getBackBtn():getLayer() )
	end

end


return M
