local M = {}
local PATH = IMG_PATH .. "image/scene/strengthen/"

local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNProgress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local baseE = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")

local Property = {
	hp="血量",
    atk="攻击",
    def="防御",
    agi="敏捷",
	crit="暴击",
	block="格挡",
	kill="必杀",
	dodge="闪避",
	hit="命中",
	ctatk="反击",
}
function M:new( param )
	local this = {}
	setmetatable(this,self)
	self.__index  = self
	
	local isData = false	--是否有临时洗炼数据
	local washData = param.washData
	if washData.xl then isData = true end
	
	
	this.baseLayer = display.newLayer()
	this.baseLayer:addChild( display.newSprite( COMMONPATH .. "dark_bg.png" , display.cx, 425 , 0.5 , 0.5) )
	this.viewLayer = display.newLayer()
	this.baseLayer:addChild( this.viewLayer )
	
	
	local layer = display.newLayer()	
	this.viewLayer:addChild( layer )
	
	layer:addChild( display.newSprite( PATH .. "wash_bg.png" , display.cx , 108 , 0.5 , 0 ) )
	local roleid = DATA_ROLE_SKILL_EQUIP:getRoleId( param.targetID , "equip" )
	
	
	local str = DATA_Bag:get("general", roleid ,"name")
	if str then
		layer:addChild( display.newSprite( PATH .. "wear_bg.png" , 50 , 700 , 0 , 0 ) )
		layer:addChild( display.newSprite( PATH .. "wear_hero.png" , 50 , 705 , 0 , 0 ) )
		layer:addChild( display.strokeLabel( str .. "     Lv" .. DATA_Bag:get("general", roleid ,"lv")  , 150 , 705  , 20 , ccc3( 0xfe , 0xf6 , 0xcf ) ) )
	end
	
	
--	layer:addChild( display.newSprite( PATH .. "cur_attrib_text.png" , display.width/4 , 361 , 0.5 , 0 ) )
--	layer:addChild( display.newSprite( PATH .. "wash_attrib_text.png" , display.width/4*3 , 361 , 0.5 , 0 ) )
	
	local targetEquip , star = awardCell( { cid = DATA_Bag:get("equip", param.targetID , "cid") , num = 0 } , { noClick = true , nonum = true , name = { offy = -20 , color = ccc3( 0xf6 , 0xf7 , 0xf2 ) , size = 20   } , star = { offy = -70 } } )
	setAnchPos( targetEquip , display.cx - 27 , 540 , 0.5 , 0 )
	layer:addChild( targetEquip,4 )
	
	local isProp = true
	local costValue
	
	if not isData then
		costValue = DATA_Bag:cidNum( washData.config.prop )
		
		if costValue >= washData.config.prop_num then
			costValue =washData.config.prop_num 
			layer:addChild( display.newSprite( PATH.."stone.png" , 330 , 150 , 0.5 , 0.5   ) )
		else
			layer:addChild( display.newSprite( COMMONPATH .. "gold.png" , 330 , 150  , 0.5 , 0.5  ) )
			isProp = false
			costValue = washData.config.gold
		end
		layer:addChild( display.strokeLabel(  costValue  , 350 , 140  , 20 , ccc3( 0xfe , 0xf6 , 0xcf ) ) )
	end

	layer:addChild( display.newSprite( PATH .. "wash_name.png" , display.cx , 454 + 13  , 0.5 , 0 ) )	

	local nameAry = { "hp" , "atk" , "def" , "agi" , "crit" , "dodge" , "block" , "hit" , "ctatk" , "kill" }
	local i = 0
	for k, v in pairs(DATA_Bag:get("equip", param.targetID,"xl") or {}) do
		i = i + 1
--		local progress = KNProgress:new(IMG_PATH.."image/start_bar/exp/", {"bg.png", "fore.png"}, 160, 355 - (i - 1) * 70,{
		local progress = KNProgress:new(PATH, {"progress_bg.png", "progress_front.png"}, 160, 355 - (i - 1) * 70,{
			showText = true,
			color = ccc3(0,0,0),
			cur = v,
			max = param.washData.max_attr[k],
		})
		layer:addChild(progress:getLayer())
		
		local btn = KNBtn:new(PATH,{"btn_bg.png","btn_bg_pre.png"},45,355 - (i - 1) * 72,{
			front = PATH.."change.png",
			callback = function()
				local change = display.newLayer()
				local mask = KNMask:new({item = change})
				
				local bg = display.newSprite(COMMONPATH.."tip_bg2.png")	
				setAnchPos(bg, 240,425,0.5,0.5)
				change:addChild(bg)
				
				bg = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")	
				setAnchPos(bg, 240,595,0.5,0.5)
				change:addChild(bg)
				
				bg = display.newSprite(PATH.."change_title.png")	
				setAnchPos(bg, 240,595,0.5,0.5)
				change:addChild(bg)
				
				local scroll = KNScrollView:new(250,350,190,180,2,false,0,{
					priority = -152,
				})
				local group = KNRadioGroup:new()
				
				for i = 1, 2 do
					local bg = display.newSprite(PATH.."att_bg"..i..".png")
					setAnchPos(bg, 35 + (i - 1) * bg:getContentSize().width, 340)
					change:addChild(bg)
					
					local text = display.newSprite(PATH.."text"..i..".png")
					setAnchPos(text, 35 + bg:getContentSize().width / 2 + (i - 1) * bg:getContentSize().width, 520, 0.5)
					change:addChild(text,1)
					
					if i == 1 then   --当前
						bg = display.newSprite(PATH.."cur_att_bg.png")
						setAnchPos(bg,40,410)
						change:addChild(bg)
						
						bg = createLabel({str = Property[k],width = 200, size = 24,color = ccc3(0,255,0)})
						setAnchPos(bg,110,420)
						change:addChild(bg)
					else

						for k,v in pairs(nameAry) do
							if not table.hasValue(table.keys(DATA_Bag:get("equip", param.targetID,"xl")),v) then
								local item = display.newLayer()
								
								local itemBg = KNBtn:new(PATH,{"change_att_bg.png","att_select.png"},0,0,{
									id = v,
									noHide = true,
									upSelect = true,
									selectZOrder = 20,
									priority = -151,
									text = {Property[v], 24, ccc3(0,0,0),ccp(0,0)}
								},group)
								item:addChild(itemBg:getLayer())
								item:setContentSize(CCSizeMake(itemBg:getWidth(),itemBg:getHeight()))
								
								scroll:addChild(item)
							end
						end
						change:addChild(scroll:getLayer())
					end
				end
				
				local okBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},65,255,{
					front = COMMONPATH.."ok.png",
					priority = -151,
					callback = function()
						local tip = display.newLayer()
						
						local bg = display.newSprite(PATH.."change_tip.png")
						setAnchPos(bg,240,390,0.5)
						tip:addChild(bg)
						
						bg = display.newSprite(PATH.."change_text.png")
						setAnchPos(bg,240,350,0.5)
						tip:addChild(bg)
						
						bg = display.newSprite(COMMONPATH.."gold.png")
						setAnchPos(bg,70,260)
						tip:addChild(bg)
						
						
						local text = createLabel({str = Property[k].."+"..v, width = 200, size = 22, color = ccc3(0,0,0)})
						setAnchPos(text,270, 440)
						tip:addChild(text)
						
						text = createLabel({str = Property[group:getId()].."+0", width = 200, size = 22, color = ccc3(0,0,0)})
						setAnchPos(text,270, 400)
						tip:addChild(text)
						
						text = createLabel({str = param.washData.config.change_gold, width = 200, size = 22, color = ccc3(0,0,0)})
						setAnchPos(text,100, 260)
						tip:addChild(text)
						
						showTip({
							priority = -152,
							content = tip,
							left = {
								callback = function()
									HTTP:call("equip", "change_xilian", {eid = param.targetID,attr = k,new_attr = group:getId(),  },{
										success_callback = function(data)
											param.washData = washData
											
											popScene()
											pushScene( "strengthen" , param, function()
												KNMsg.getInstance():flashShow("附魔属性更换成功")
											end ) 
										end
									})
								end
							},right = {
								remove = true,
							}	
						})
					end
				})
				change:addChild(okBtn:getLayer())
				
				local cancelBtn = KNBtn:new(COMMONPATH,{"btn_bg_red.png","btn_bg_red_pre.png"},270,255,{
					front = COMMONPATH.."cancel.png",
					priority = -151,
					callback = function()
						mask:remove()
					end
				})
				change:addChild(cancelBtn:getLayer())
				
				
				
				this.baseLayer:addChild(mask:getLayer())
			end
		})
		layer:addChild(btn:getLayer())
		
		local attr = display.newSprite(PATH..k..".png")
		setAnchPos(attr,110,355 - (i - 1) * 72)
		layer:addChild(attr)
		
		if param.washData.xl then
			if param.washData.xl[k] then
				layer:addChild(createLabel({str =  (param.washData.xl[k] > 0 and "+" or "")..param.washData.xl[k], width = 300, size = 20, color = param.washData.xl[k] > 0 and ccc3(0,255,0) or ccc3(255,0,0), x = 375, y = 358 - (i - 1) * 70}))
			else
				layer:addChild(createLabel({str =  "MAX", width = 300, size = 20, color = ccc3(0,255,0), x = 375, y = 358 - (i - 1) * 70}))
			end
		end
	end

			
	local washBtn , saveBtn , cancelBtn
	saveBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"} , 86  , 130 , {
				scale = true,
				front = COMMONPATH .. "save.png"  ,
				callback = function()
					HTTP:call("equip","save_xilian",{ eid = param.targetID } , {
							success_callback = function( tempData )
								param.washData = washData
								param.washData.xl = nil
								param.washData["xl_max"] = nil 
								
								popScene()
								pushScene( "strengthen" , param, function()
									KNMsg.getInstance():flashShow("附魔成功，装备属性提升")
								end ) 
							end
						})
				end
			})

	this.viewLayer:addChild( saveBtn:getLayer() )
	
	cancelBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"} , 264  , 130 , {
				scale = true,
				front = COMMONPATH .. "cancel.png"  ,
				callback = function()
					HTTP:call("equip","cancel_xilian",{ eid = param.targetID } , {
							success_callback = function( tempData )
								param.washData = washData
								param.washData.xl = nil 
								param.washData["xl_max"] = nil 
								
								popScene()
								pushScene( "strengthen" , param ) 
							end
						})

				end
			})
	this.viewLayer:addChild( cancelBtn:getLayer() )
	
	washBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"} , display.cx - 73  , 130 , {
				scale = true,
				front = PATH .. "wash.png"  ,
				callback = function()
						HTTP:call("equip","xilian",{ eid = param.targetID } , {
							success_callback = function( tempData )
								dump(tempData)
								param.washData = washData
								param.washData["xl"] = tempData["xilian"]
								
								popScene()
								pushScene( "strengthen" , param, function()
									if table.nums(tempData.luck) <= 0 then
										return 
									end
									local text = display.newSprite(IMG_PATH.."image/scene/battle/effect/crit_text.png")
									setAnchPos(text,display.cx, display.cy,0.5,0.5)
									text:setScale(0)
									display.getRunningScene():addChild( text,1 )
									
									text:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.5,1)))
									
									local effSprite
									local effFrames = display.newFramesWithImage( IMG_PATH.."image/scene/battle/pet/markup_eff.png" , 4 )
									effSprite =display.playFrames( 0  , 0  , 
																	effFrames ,
																	 0.15 ,
																	  { 
																	  	delay = 0.01,
																	  	onComplete =
																		 function() 
																			effSprite:removeFromParentAndCleanup( true ) 
																			text:removeFromParentAndCleanup( true ) 
																			for k, v in pairs(tempData.luck or {}) do
																				KNMsg.getInstance():flashShow("恭喜您此次附魔获得"..Property[k].."属性"..v.."倍暴击")
																			end
																		 end
																		 } )
									setAnchPos( effSprite , display.cx  , display.cy , 0.5 , 0.5 )
									display.getRunningScene():addChild( effSprite )
									

									
								end ) 
								
								local function radio()
									local function sendMaxMsg()
										HTTP:call("equip","send_xilian_msg" , { post = 1 } , { success_callback = function() end } )
									end
									
									local mask = baseMask( { isShowBack = { y = 600 } , isConfirm = { path = COMMONPATH .. "send.png" , confirmFun = sendMaxMsg } ,  bgInfo = { path = COMMONPATH .. "tip_bg.png",  y = 400 } } )
									mask:addChild( display.newSprite( PATH .. "wash_text_bg.png" , display.cx , 480 , 0.5 , 0  ) )
									mask:addChild( display.strokeLabel( tempData.maxmsg, 60 , 220 , 18, ccc3( 0xfe, 0xff, 0xfa ), nil, nil,
									{
										dimensions_width = 370 ,
										dimensions_height = 357,
										align = 0,
									}) )
								end
								if tempData.maxmsg then delayFun( 0.1  ,  radio )  end
									
								
							end
						})
				end
			})
	this.viewLayer:addChild(washBtn:getLayer())
	
	
	washBtn:getLayer():setVisible( not isData )
	washBtn:setEnable( not isData )
	
	saveBtn:getLayer():setVisible( isData )
	saveBtn:setEnable( isData )
	
	cancelBtn:getLayer():setVisible( isData )
	cancelBtn:setEnable( isData )
	
		
	
	
	-- 获取帮助
	local helpBtn = KNBtn:new(IMG_PATH .. "image/scene/multiFb" , {"help.png", "help_press.png"}, 410 , 690 ,
	{
		callback = function()
			local mask = baseMask( { isConfirm = true ,  bgInfo = { path = IMG_PATH .. "image/scene/chat/" .. "info_bg_small.png",  y = 250 } } )
			mask:addChild( display.newSprite(PATH .. "rule_title.png" , display.cx , 630 , 0.5 , 0 ) )
			-- 规则
			local rule = "1.三星及以上装备可进行附魔，需要消耗相应数量黄金或者魔导石\n" ..
						 "2.装备星级越高，属性max(最大值)也越高,5星>4星>3星\n"	..	
						 "4.装备属性达到当前最大值后锁定，升星后可提升附魔最大值\n"	..	
						 "5.装备升星后保留附魔属性并可继续提升属性最大值\n"	..	
						 "6.装备附魔时有一定几率获得多倍属性数值\n"	..	
						 "7.可自行更换装备属性，更换属性后数值为0\n"

 
			mask:addChild( display.strokeLabel( rule, 29, 250, 18, ccc3( 0x00, 0x00, 0x00 ), nil, nil,
			{
				dimensions_width = 425,
				dimensions_height = 357,
				align = 0,
			}) )
		end
	})
	this.viewLayer:addChild( helpBtn:getLayer() )
	
	
	local info_layer = InfoLayer:new("strength", 0, {tail_hide = true, title_text = PATH.. "wash_title.png" , closeCallback = function()
		popScene()
		if param.main then
			param.main[1]:createLayer(param.main[2], param.main[3])
		end
	 end})
	this.baseLayer:addChild(info_layer:getLayer(),1)
	
	
	if param.washData.first_xilian == 1 then
		local tipLayer = display.newLayer()
		
		 local tip = display.newSprite(PATH.."open_bg.png")
		setAnchPos(tip,240,380,0.5,0.5)
		tipLayer:addChild(tip)
		
		tip = display.newSprite(PATH.."open_text.png")
		setAnchPos(tip,240,360,0.5)
		tipLayer:addChild(tip)
		
		local text = createLabel({str = DATA_Bag:get("equip", param.targetID,"name"), width = 200, size = 20, color = ccc3(255,0,0)})
		setAnchPos(text,190,365,1)
		tipLayer:addChild(text)
		
		local str = ""
		for k, v in pairs(param.washData.attribute) do
			str = str .. Property[k] .. " "
		end
		
		
		text = createLabel({str = "【"..str.."】", width = 200, size = 20, color = ccc3(255,0,0)})
		setAnchPos(text,240,330,0.5)
		tipLayer:addChild(text)
		
		showTip({
			title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
			title_text = PATH.."xilian_title.png",
			content = tipLayer,
			parent = this.baseLayer,
			center = {
				remove = true,
				callback = function()
					param.washData.first_xilian = 0
				end
			}
		})
	end
	
--	delayFun( 1 , function() this:changeAttrib() end )
	return this
end

--收集道具附魔属性值
function M:gatherInfo( params )
	local targetData = nil
	if params.tempData then
		targetData = params.tempData
		targetData.star = DATA_Bag:get( "equip" , params.targetID )[ "star" ]
	else
		targetData =  DATA_Bag:get( "equip" , params.targetID ) 
	end
	local str , strAry , colors = "" , {} ,{ ccc3( 0xff, 0xfc, 0xed ) , ccc3( 0xff, 0xfc, 0xed ) , ccc3( 0xff, 0xfc, 0xed ) }
	
	if not targetData or tonumber(targetData.star) < 3 then
		return str , strAry , colors
	end
	
	
	if params.isAdd then
		strAry = { "未知属性(未激活)" , "未知属性(未激活)" , "未知属性(未激活)" }
	end
	
	local rangeValue = {}
	
	
	if targetData["xl_max"] then
		for key , v in pairs( targetData["xl_max"] ) do
			rangeValue[ v .. "" ] = v
		end
	end

	local nameAry = { "hp" , "atk" , "def" , "agi" , "crit" , "dodge" , "block" , "hit" , "ctatk" , "kill" }
	local nameConfig = {
							hp = "生命" ,
							atk = "攻击" ,
							def = "防御" ,
							agi = "敏捷" ,
							crit = "暴击" ,
							dodge = "闪避" ,
							block = "格挡" ,
							hit = "命中" ,
							ctatk = "反击" ,
							kill = "必杀" , }	
							
	if targetData["xl"] and type( targetData["xl"] ) == "table" then
		local t = 1
		local t2 = 1
		for i = 1  , #nameAry do
			local curValue = targetData["xl"][nameAry[i] .. "" ]
			if curValue then 
				local isMax = false
				if rangeValue[ nameAry[i]] then isMax = true end
				
				if params.isAdd then
					strAry[ t  ] = nameConfig[ nameAry[i] .. "" ] .. "+" .. curValue
					t = t + 1
				else
					strAry[ #strAry + 1  ] = nameConfig[ nameAry[i] .. "" ] .. "+" .. curValue
				end
				
				if isMax then
					local starColor = { 
										["3"] = ccc3( 0x00 , 0xb0 , 0x6f ) , 
										["4"] = ccc3( 0x00 , 0x71 , 0xc1 ) , 
										["5"] = ccc3( 0x70 , 0x30 , 0xc2 ) , 
										}
					local starColor = { 
										["3"] = ccc3( 0xfc , 0xfa , 0x2f ) , 
										["4"] = ccc3( 0xfc , 0xfa , 0x2f ) , 
										["5"] = ccc3( 0xfc , 0xfa , 0x2f ) , 
										}
					colors[ t2 ] = starColor[ targetData.star .. "" ]
				end
				t2 = t2 + 1
			end
		end
	end
	str = string.join( strAry , "\n" )  
	
	return str , strAry , colors
end


function M:getLayer()
	return self.baseLayer
end





	--选择面板
function M:changeAttrib( params )
	params = params or {}
	
	local mask = baseMask( { isShowBack = { y = 609 } ,  titlePath = {offX = -20 , offY = -45 , path = PATH .. "chenge_attrib_title.png" } , bgInfo = { path = COMMONPATH  .. "tip_bg2.png",  y = 300 } , isConfirm = { path = PATH .. "chenge_text.png" , confirmFun = function() end } } )
	mask:addChild( display.newSprite( PATH .. "attrib_bg.png" , display.cx , 505 , 0.5 , 0.5  ) )
	local btnConfig = { 
						["1"] = { "atk" , "hp" ,  "def" , "agi" } , 
						["2"] = { "hit" , "dodge" ,  "ctatk" } , 
						["3"] = { "kill" , "crit" ,  "block" } , 
						}
	local totalNum = 0 
	local cellWidth = 80 
	local isEnable = true 
	local group = KNRadioGroup:new()
	for i = 1 , table.nums(btnConfig) do
		local lineData = btnConfig[i .. "" ]
		totalNum = table.nums( lineData )
		for j = 1 , table.nums( lineData ) do
			local addX , addY =  (  display.width / ( totalNum + 1 ) ) * j - 40 , 540 - ( i - 1 ) * 58  
			local tempBtn = KNBtn:new( COMMONPATH, ( isEnable and {  "btn_bg.png" , "select3.png" }  or  {  "btn_bg_dis.png"  }) , addX , addY , {
				selectZOrder = 20 , 
				priority = -131 ,
				noHide = true ,
				scale = true,
				front =  PATH .. "attrib/" ..  lineData[j] .. ".png"    ,
				callback = function()
				end
			},group)
			
			mask:addChild( tempBtn:getLayer() )
		end
		
	end
	
	group:chooseByIndex( 1 , false )
	
	mask:addChild( display.newSprite( COMMONPATH .. "gold.png" ,305 , 420 - 90  , 0 , 0 ) )
	mask:addChild( display.strokeLabel( "200" , 340  , 410 - 80  , 20 , ccc3( 0x2c , 0x00 , 0x00 ) ) ) 
	mask:addChild( display.strokeLabel( "提示：更换后的属性附魔所加属性值为0" , 0  , 370  , 20 , ccc3( 0xff , 0x00 , 0x00 ) , nil , nil , { dimensions_width = 480 , dimensions_height = 30 , align = 1 } ) ) 
	
end


return M
