local PATH = IMG_PATH.."image/scene/swar/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")--require "GameLuaScript/Scene/common/infolayer"
local Item = requires(IMG_PATH, "GameLuaScript/Scene/swar/rankitem")

local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local Army = requires(IMG_PATH, "GameLuaScript/Scene/swar/army")
local MAIN, RANK,  SERVER, WAR = 1, 2, 3, 4
local KNProgress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")

local state

local M = {
	baseLayer,
	layer,
	infoLayer,
	donate,
	serverTeam, --服务器表示
	armyList,   --用户
	points,   --据点状态
	initTime,  --本服战斗的时间标签
	maxScore,  --最大得分
	maxRecovery, --最大复活
	zoneKey,
	reportBtn,
	recoveryBtn,
	field_id,
	serverMove,  --服务器移动时间
	recoveryCost,  --复活花费
	serverStat    --服务器状态
}

local X, Y, DX, DY = 40, 720, 100, 140
local maps = {	--跨服战地图数据
	{X + 2 * DX, Y,          {2, 3, 4}},   --1
	{X,          Y - DY,     {3, 5, 6}},   --2
	{X + 2 * DX, Y - DY,     {4,6,7,8}},   --3
	{X + 4 * DX, Y - DY,     {8,9}},       --4
	{X,          Y - 2 * DY, {6, 10}},      --5
	{X + DX,     Y - 2 * DY, {7, 10, 11}},  --6
	{X + 2 * DX, Y - 2 * DY, {8, 11}},      --7
	{X + 3 * DX, Y - 2 * DY, {9, 11, 12}}, --8
	{X + 4 * DX, Y - 2 * DY, {12}},    --9
 	{X,          Y - 3 * DY, {11, 13}},  --10
	{X + 2 * DX, Y - 3 * DY, {12,13}},
	{X + 4 * DX, Y - 3 * DY, {13}},
	{X + 2 * DX, Y - 4 * DY, {}},
	
}

local rules = {
"1：每个月的第一周周一到周五举行本服资格赛。以军团赛的方式决定本服参与跨服战的5名玩家。\n2：每个月的第一周周六以及周日和第二周的周六晚举行预选赛。选出全游戏的前十二名服务器晋入半决赛\n 3：每个月的第二周周日举行半决赛和决赛。半决赛选出前六名服务器，决赛决出第一名服务器。\n",
"1：开服在30天以上的服务器，本服实力达到同一时期的标准程度后，经过筛选在论坛和公告放出\n 2：每个月的跨服战开始前自动录入玩家角色属性。",
"1：在跨服战战场中，每获得一次胜利就会记录本次胜场和消耗时间\n 2：根据胜场多少和当前阶段的消耗时间总和多少决定排行榜中的排行\n 3：根据当前阶段从排行榜中筛选前12名（预选赛），前6名（半决赛）和第一名",
}

--服务器页面位置
local pos = {
	{10, 550, 150, 450},
	{170,650, 220, 480},
	{320, 550, 300, 450},
	{10, 150, 150, 380},
	{170, 50, 220, 380},
	{320, 150, 300, 380}
}

function M:new(data)
	local this = {}
	setmetatable(this, self)
	self.__index = self
	data = data or {}
	this.baseLayer = display.newLayer()
	this.zoneKey = data.zoneKey
	
	this.serverTeam = {}
	this.points = {}
	this.armyList = {}
	
	local bg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	this.baseLayer:addChild(bg)
	
		
	this.talkBtn = KNBtn:new( IMG_PATH .. "image/scene/chat/"  , {"talk_flag1.png"} , 350 ,680 , {
		scale = true ,
		priority = -151,
		front =  IMG_PATH .. "image/scene/chat/talk_flag.png" , 
		callback = function()
			DATA_Info:setIsMsg( false )
			if DATA_Info:getIsOpen() then
				local talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/talk")
				this.talkLayer = talkLayer:new( { 
					key = this.zoneKey,
					field_id = this.field_id,
					type = (state == SERVER) and "server" or "war",
					priority = -151, 
					custom = { customTable = { "custom"} , sendParams = { scene = "swar" , scene_id = "swar" } } 
				} )
				local curScene = display.getRunningScene()
				curScene:addChild( this.talkLayer:getLayer()  )
			else
				this.talkLayer:remove()
			end
			DATA_Info:setIsOpen(  not DATA_Info:getIsOpen( ) )
		end
	})
	this.baseLayer:addChild(this.talkBtn:getLayer(),50)
	
	DATA_Info:addActionBtn( "server" , this.talkBtn )
	DATA_Info:addActionBtn( "war" , this.talkBtn )
	
	this.talkBtn:showBtn(false)
	this.talkBtn:setEnable(false)
	
		
	if data.curState == SERVER then
		this:createWars(data)
	elseif data.curState == WAR then
		self.zoneKey = data.zoneKey
		self.initTime = data.initTime
		self.field_id = data.field_id
		this:swarMap(data.field_id, data.result)
	else
		this:createContent(data)
	end
	return this
end

function M:createContent(data)
	if self.talkBtn then
		self.talkBtn:showBtn(false)
		self.talkBtn:setEnable(false)
	end
	
	self.armyList = {}
	self.serverTeam = {}
	self.points = {}
	state = MAIN
	local WARSPATH = IMG_PATH.."image/scene/gang/"
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	
	self.layer:addChild( display.newSprite( WARSPATH .. "hall/notice_bg2.png" , display.cx , 615 , 0.5 , 0 ) )	--上背景
	local shandLayer = display.newLayer()
	shandLayer:addChild( display.newSprite( SCENECOMMON .. "prop_bg.png" , display.cx , 617 , 0.5 , 0 ) )	--阴影
	shandLayer:addChild( display.newSprite( SCENECOMMON .. "prop_bg.png" , display.cx , 617 , 0.5 , 0 ) )	--阴影
	shandLayer:setScaleX( 1.2 )
	self.layer:addChild( shandLayer )
	self.layer:addChild( display.newSprite( PATH .. "swar_info.png" , display.cx , 705 , 0.5 , 0 ) )	--帮战信息标题
	self.layer:addChild( display.newSprite( COMMONPATH .. "half_bg.png" , display.cx , 109 , 0.5 , 0 ) )	--下背景
	self.layer:addChild( display.newSprite( WARSPATH .. "wars/shade_bg2.png" , display.cx , 180 , 0.5 , 0 ) )	--背景框
	self.layer:addChild( display.newSprite( PATH .. "swar_total.png" , display.cx , 570 , 0.5 , 0 ) )	--帮战信息标题
	self.layer:addChild( KNBtn:new( COMMONPATH , { "long_btn.png" , "long_btn_pre.png" } , 335 , 495 , { 
		scale = true ,
		front = PATH .. "rules_text.png" , 
		callback = function()
			local layer = display.newLayer()
			local bg = display.newSprite(PATH.."rule_bg.png")
			setAnchPos(bg, 240, 425, 0.5, 0.5)
			layer:addChild(bg)
			
			bg = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
			setAnchPos(bg, 240, 675, 0.5, 0.5)
			layer:addChild(bg)
			
			bg = display.newSprite(PATH.."rule_title.png")
			setAnchPos(bg, 240, 675, 0.5, 0.5)
			layer:addChild(bg)
			
			local scroll = KNScrollView:new(0, 250, 480, 380)
			
			layer:addChild(scroll:getLayer())
			
			local mask = KNMask:new({item = layer})
			
			local tempLayer = display.newLayer()
			tempLayer:setContentSize(CCSizeMake(480, 380))
			
			tempLayer:addChild( display.newSprite( PATH.."war_time.png" , 35, 354  , 0 , 0 ) )	--帮战时间
			tempLayer:addChild( display.newSprite( PATH.."join_rule.png" , 35, 155   , 0 , 0 ) )	--服名条件
			tempLayer:addChild( display.newSprite( PATH.."win_rule.png" , 35, 30 , 0 , 0 ) )	--胜利条件
			--帮战时间
			tempLayer:addChild( display.strokeLabel( replaceStr(rules[1]) , 150 , 175 , 16 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , {
							dimensions_width = 300 ,
							dimensions_height = 0,
							align = 0 
							}) )	
			--帮战时间
			tempLayer:addChild( display.strokeLabel( replaceStr(rules[2]) , 150 , 70 , 16 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , {
							dimensions_width = 300 ,
							dimensions_height = 0,
							align = 0 
							}) )	
						
			--胜利条件
			tempLayer:addChild( display.strokeLabel( replaceStr(rules[3]) , 150 , -63 , 16 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , {
							dimensions_width = 300 ,
							dimensions_height = 0,
							align = 0 
							}) )
			scroll:addChild(tempLayer)
			
			display.getRunningScene():addChild(mask:getLayer(), 5)
			
			local ok = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 180, 200, {
				front = COMMONPATH.."ok.png",
				priority = -150,
				callback = function()
					mask:remove()	
				end
			})
			layer:addChild(ok:getLayer())
							
--			showTip({
--				cx = 0,
--				cy = 0,
--				content = scroll:getLayer(),
--				bg = PATH.."rule_bg.png",
--				title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
--				title_text = PATH.."rule_title.png",
--				offsetY = -20,
--				center = {
--					remove = true
--				}	
--			})
		end}):getLayer())
		
	self.layer:addChild( display.newSprite(PATH .. "swar_state.png", 38, 442, 0, 0) )
								
	self.layer:addChild( display.newSprite(PATH .. "swar_time.png", 38, 522, 0, 0) )
	
	self.layer:addChild(createLabel({str = data.nextStatTime, size = 24, x = 40,width = 300, y = 490}))
	
	self.layer:addChild(createLabel({str = data.rank == 0 and "(暂无排名)" or "(第"..data.rank.."名)", size = 24, x = 240, y = 285, width = 300}))

	self.layer:addChild( display.newSprite(PATH .. "stat"..(data.curStat < 7 and data.curStat or 0)..".png", display.cx , 350 , 0.5 , 0 ) )	--普级 淘汰	

	self.layer:addChild( display.newSprite( PATH .. "my_rank.png" , 40 , 285, 0 , 0 ) )	
	
	
	local y = 675
	for i = #data.msg, #data.msg - 2, -1 do
		local v = data.msg[i]
		if v then
			self.layer:addChild(createLabel({str = v, size = 20, width = 400, x = 40, y = y}))
			y = y - 25
		end
	end
	
	local y = 235
	for i = #data.awardmsg, #data.awardmsg - 2, -1 do
		local v = data.awardmsg[i]
		if v then
			self.layer:addChild(createLabel({str = v, size = 20, width = 400, x = 40, y = y}))
			y = y - 25
		end
	end
	
	--榜单按钮
	self.layer:addChild( KNBtn:new( COMMONPATH , { "btn_bg.png" , "btn_bg_pre.png" } , 358 , 428 , { 
		scale = true ,
		front = WARSPATH .. "wars/rank.png" , 
		callback = function()
			HTTP:call("kuafu","getServerRanking",{ },{success_callback =
			function(data)
				self:createRank(data)
			end})
		end}):getLayer())	
								

	--领取奖励					
	local getAwarsBtn = KNBtn:new( COMMONPATH , { "long_btn.png" , "long_btn_pre.png" , "long_btn_grey.png" } , 335, 213, { 
		scale = true , 
		front = COMMONPATH .. "get_award.png", 
		callback = function()
			HTTP:call("kuafu","getAward",{},{
				success_callback = function(data)
					KNMsg.getInstance():flashShow("获得跨服战开战奖励 +"..data.award.." 同时获得捐献回礼+"..data.donateAward)
					HTTP:call("kuafu", "getSummary", {}, {
						success_callback = function(main)
						--这里更新一次zoneKey
						self.zoneKey = main.zoneKey
						self:createContent(main)
					end})
				end
			})

		end})
	self.layer:addChild( getAwarsBtn:getLayer() )
	
	local award = display.newSprite(COMMONPATH.."silver.png")
	setAnchPos(award, 330, 185)
	self.layer:addChild(award)
	
	self.layer:addChild(createLabel({str = data.award, size = 21,x = 360, y = 185, color = ccc3(0x2c, 0, 0), width = 200}))
	
	--参与帮战
	self.layer:addChild( KNBtn:new( COMMONPATH , { "btn_bg_red.png" , "btn_bg_red_pre.png"} , 170 , 120 , { 
		scale = true , 
		front = data.watch == 1 and PATH.."live_text.png" or PATH.."enter_text.png",
		callback = function()
			if data.watch == 1 then
				if data.curStat > 6 then
					KNMsg.getInstance():flashShow("当前为非战期间，无战斗可供观看")
					return
				end
				HTTP:call("kuafu", "getZoneList", {}, {
					success_callback = function(data)
						local box
						local layer = display.newLayer()
						local bg = display.newSprite(COMMONPATH.."page_bg.png")
						setAnchPos(bg,240,150,0.5)
						layer:addChild(bg)
						
						local cur, total = 1, math.ceil(#data.zones / 5) 
						total = total == 0 and 1 or total
						local pageNum = display.strokeLabel(cur.."/"..total, 0, 0, 20, ccc3(0xff, 0xfb, 0xd4))
						setAnchPos(pageNum, 235, 155, 0.5)
						layer:addChild(pageNum)
						
						local itemLayer
						local function createItem(start)
							if itemLayer then
								layer:removeChild(itemLayer, true)
							end
							itemLayer = display.newLayer()
							
							local max = 5
							local s = start and (start - 1) * max + 1 or 1 
							local temp = #data.zones - (start or 1) * max 
							local num = s + ((temp > 0) and max or (max - (-temp))) - 1
							
							local y = 485
							for i = s, num do
								local bg = display.newSprite(PATH.."watch_item.png")	
								setAnchPos(bg, 240, y, 0.5)
								itemLayer:addChild(bg)
								
								local btn = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 350, y + 12, {
									front = PATH.."watch_btn.png",
									priority = -150,
									callback = function()
										if data.zones[i].zoneOver == 1 then
											KNMsg.getInstance():flashShow("本场战斗已经结束，请选择其它场次")
										else
											box:remove()
											--进入观战
											heartBeatCtl(true)
											SOCKET:getInstance("battle"):call("log" , "out" , "logout" , {} , {
											success_callback = function()
												-- SOCKET:getInstance("battle"):close()
												SOCKET:delInstance("battle")
												delayFun(0.1, function()
												SOCKET:getInstance("swar",data.zones[i].ip, data.zones[i].port):send("user", "login", 1002, {}, {
													success_callback = function()	
														DATA_Info:set_type("server", {})
														heartBeatCtl(nil, "new")
														SOCKET:getInstance("swar"):send("swar", "getInfo", 1100, {key = data.zones[i].zoneKey}, {success_callback = function(init)
															self.zoneKey = data.zones[i].zoneKey
															self:createWars(init["result"])
														end})
													end})
												end)						
											end})
										end
									end
								})
								itemLayer:addChild(btn:getLayer())
								
								itemLayer:addChild(createLabel({str = data.zones[i].name.."("..string.join(data.zones[i].servers,",")..")", size = 16, width = 300,x = 50, y = y + 8, color = ccc3(0x2c, 0, 0)}))
								
								y = y - bg:getContentSize().height - 4
							end
							
							pageNum:setString(cur.."/"..total)
							layer:addChild(itemLayer)
						end
						
						createItem()
						
						--翻页按钮
						local pre = KNBtn:new(COMMONPATH,{"next_big.png"}, 150, 140, {
							scale = true,
							flipX = true,
							priority = -150,
							callback = function()
								if cur > 1 then
									cur = cur - 1
									createItem(cur)
								end
							end
						})
						layer:addChild(pre:getLayer())
						
						local next = KNBtn:new(COMMONPATH,{"next_big.png"}, 285, 140, {
							scale = true,
							priority = -150,
							callback = function()
								if cur < total then
									cur = cur + 1
									createItem(cur)
								end
							end
						})
						layer:addChild(next:getLayer())
						
						box = showTip({
							bg = PATH.."watch_bg.png",
							content = layer,
							title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
							title_text = PATH.."watch_title.png",
							close = {
								normal = "back_img.png",
								pre = "back_img_press.png",
								remove = true
							}
							
						})
					end
				})
				return 
			end	
			
			heartBeatCtl(true)
			SOCKET:getInstance("battle"):call("log" , "out" , "logout" , {} , {
				success_callback = function()
					-- SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
					delayFun(0.1, function()
					print(data.ip, data.port)
					SOCKET:getInstance("swar",data.ip, data.port):send("user", "login", 1002, {}, {
						success_callback = function()
							HTTP:call("kuafu", "getSummary", {}, {
								success_callback = function(data)
									--这里更新一次zoneKey
									self.zoneKey = data.zoneKey
									SOCKET:getInstance("swar"):send("swar", "getInfo", 1100, {key = self.zoneKey}, {
										success_callback = function(data)
											self:updateServer(data.result.servers, true)
											heartBeatCtl(nil, "new")
											local state = data.result.stat
											local isFight	
											for k, v in pairs(data.result.servers) do
												if v.server_id == DATA_Session:get("server_id") and v.stat == 3 then
													isFight = true
													SOCKET:getInstance("swar"):send("swar", "getWarInfo", 1106, {key = self.zoneKey, field_id = v.field_id}, {
														success_callback = function(init)
															self.initTime = data.result.initTime
															init.result.initTime = self.initTime
															self:swarMap(self.serverTeam[DATA_Session:get("server_id")][2].field_id, init.result)
														end
													})
													break
												end
											end
											if not isFight then
												self:createWars(data["result"])
											end
										end, error_callback = function(data)
											heartBeatCtl(true)
											SOCKET:getInstance("swar"):send("kuafu", "close", 1004, {}, {
												success_callback = function()
													-- SOCKET:getInstance("swar"):close()
													SOCKET:delInstance("swar")
													KNMsg.getInstance():flashShow("跨服战未开启或已结束")
													heartBeatCtl()
													HTTP:call("kuafu", "getSummary", {}, {
														success_callback = function(data)
															--这里更新一次zoneKey
															self.zoneKey = data.zoneKey
															self:createContent(data)
														end})
												end})
										end})
								end
							})
						end
					})
					end)
				end
			})
		end}):getLayer())
	

	
	self.infoLayer = InfoLayer:new("swar_pre", 0, {tail_hide = true, title_text = PATH.."title.png", closeCallback = function()
		if state == MAIN then
			switchScene("pvp", {coming = "swar"})
		else
			HTTP:call("kuafu", "getSummary", {}, {
				success_callback = function(data)
					--这里更新一次zoneKey
					self.zoneKey = data.zoneKey
					self:createContent(data)
				end})
		end
	end})
	self.layer:addChild(self.infoLayer:getLayer(),10)
	
	self.baseLayer:addChild(self.layer)
end


function M:getLayer()
	return self.baseLayer
end

function M:createRank(data)
	state = RANK
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	
	self.infoLayer = InfoLayer:new("swar_pre", 0, {tail_hide = true, title_text = PATH.."rank_title.png", closeCallback = function()
		if state == MAIN then
			switchScene("pvp", {coming = "swar"})
		else
			HTTP:call("kuafu", "getSummary", {}, {
				success_callback = function(data)
					--这里更新一次zoneKey
					self.zoneKey = data.zoneKey
					self:createContent(data)
				end})
		end
	
	end})
	self.layer:addChild(self.infoLayer:getLayer(),10)
	
	
	local scroll = KNScrollView:new(0, 100, 480, 650)
	self.layer:addChild(scroll:getLayer())
	
	for k, v in pairs(data) do
		scroll:addChild(Item:new("server", k,scroll,v, {
			callback = function()
				HTTP:call("kuafu", "getServerInfo", {tarID = v.server_id}, {
					success_callback = function(data)	
						local info = display.newLayer()
						
						local name = createLabel({str = v.server_name, width = 180, x = 150, y = 55, size = 24, color = ccc3(0xff, 0xfb, 0xd4)})
						setAnchPos(name, 250, 590, 0.5)
						info:addChild(name)
						local function users(detail, index)
							local layer = display.newLayer()	
							layer:setContentSize(CCSizeMake(410, 70))
							
							--玩家头像
							local infoBg = display.newSprite(COMMONPATH..getHeadPath(detail.sex))
							setAnchPos(infoBg,0,5)
							layer:addChild(infoBg)
							
							infoBg = display.newSprite(COMMONPATH.."role_frame.png")
							setAnchPos(infoBg,0,0)
							layer:addChild(infoBg)
							
							if index == 1 then
								infoBg = display.newSprite(PATH.."server_leader.png")
							else
								infoBg = display.newSprite(PATH.."server_member.png")
							end
							setAnchPos(infoBg,80,8)
							layer:addChild(infoBg)
							
							infoBg = createLabel({str = detail.name , size = 24, width = 300, color = ccc3(0x2c, 0, 0)})
							setAnchPos(infoBg,140,40)
							layer:addChild(infoBg)
							
							infoBg = createLabel({str = detail.ability , size = 24, width = 300, color = ccc3(0x2c, 0, 0)})
							setAnchPos(infoBg,140,8)
							layer:addChild(infoBg)
							
							return layer
						end
						
						local y = 505
						for k, v in pairs(data.users) do
							local temp = users(v)
							setAnchPos(temp, 50, y)
							info:addChild(temp)
							
							y = y - temp:getContentSize().height - 13
						end
						
						showTip({
							content = info,
							title_text = PATH.."detail_title.png",
							bg = PATH.."detail_bg.png",
							title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
							offsetY = -20,
							titleOffsetY = -10,
							center = {
								remove = true,
							}
						})
					end
				})
			end
		}):getLayer())
	end
	scroll:alignCenter()
	
	self.baseLayer:addChild(self.layer)
end

function M:createWars(data)
	self.talkBtn:showBtn(true)
	self.talkBtn:setEnable(true)
	self.talkBtn:setPosition(350, 750)
	
	self.armyList = {}
	self.serverTeam = {}
	self.initTime = data.initTime
	self.serverMove = data.moveSpan
	self.serverStat = data.stat
	
	state = SERVER
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	local cur_server =  DATA_Session:get("server_id")
	local list = data.servers
	
	self.layer = display.newLayer()
	
	local bg = display.newSprite(PATH.."server_info_bg.jpg")
	setAnchPos(bg)
	self.layer:addChild(bg)
	
	
	if self.serverStat == 1 then
		bg = display.newSprite(IMG_PATH.."image/scene/war/time_bg.png")
		setAnchPos(bg, display.width - bg:getContentSize().width - 10, 10)
		self.layer:addChild(bg)
		--倒计时
		self.serverTime = createLabel({str = timeConvert(data.statRemainTime, nil, true), size = 18, color = ccc3(0xe2, 0xe2, 0xe2)})
		setAnchPos(self.serverTime, 400, 15)
		self.layer:addChild(self.serverTime)
		Clock:addTimeFun("server_stat_time", function()
			if data.statRemainTime > 0 then
				data.statRemainTime = data.statRemainTime - 1
				self.serverTime:setString(timeConvert( data.statRemainTime, nil, true))
			end
		end)
	end
	
	local arena = KNBtn:new(PATH,{"arena.png"}, 240, 425, {
		anchMid = true,
		scale = true,
		callback = function()
			if self.serverStat == 1 then
				KNMsg.getInstance():flashShow("正在准备战斗，请随便看看")
			else
				local look  = true
				if self.serverTeam[DATA_Session:get("server_id")] then
					for k, v in pairs(self.serverTeam[DATA_Session:get("server_id")][2].uids) do
						if v == tonumber(DATA_User:get("uid")) then
							look = false
							break
						end
					end 
				end
				
				if look  then
					KNMsg.getInstance():flashShow("您未参加跨服战，可以观看直播")
				else
					if self.server_cur then
						self.layer:removeChild(self.server_cur, true)
						self.server_cur = nil
					end
					
					if self.serverTeam[cur_server][2].stat == 0 then
						SOCKET:getInstance("swar"):send("kuafu", "move", 1102, {key = self.zoneKey}, {
							no_mask = true,
							no_loading = true,
							success_callback = function()
--								self.serverTeam[cur_server][1]:runAction(CCMoveTo:create(self.serverMove,ccp(240,425)))
							end
						})
					else
						KNMsg.getInstance():flashShow("战斗即将开始，请做好准备")
					end
				end
			end
		end
	}) 
	self.layer:addChild(arena:getLayer())

	for i = 1, #pos do
		local temp = KNBtn:new(PATH, {"server_bg.png"}, pos[list[i].pos][1], pos[list[i].pos][2], {
			id = list[i].server_id,
			other = {PATH.."server_icon.png", 40, 80 + (list[i].pos > 3 and -100 or 0)},
			text = {list[i].server_name, 22, ccc3(255, 255,255), ccp(0, 0)}
		})
		self.layer:addChild(temp:getLayer())
		
		if list[i].pos > 3 then
			temp:setFlip()
		end
	end
	
	
	local back = KNBtn:new(PATH, {"back_btn.png"}, 10, 10, {
		callback = function()
			-- SOCKET:getInstance("swar"):close()
			heartBeatCtl(true)
			SOCKET:getInstance("swar"):send("kuafu", "close", 1004, {}, {
				success_callback = function()
					SOCKET:delInstance("swar")
					heartBeatCtl()
					HTTP:call("kuafu", "getSummary", {}, {
						success_callback = function(data)
							--这里更新一次zoneKey
							self.zoneKey = data.zoneKey
							self:createContent(data)
							end})
				end})
		end
	})
	self.layer:addChild(back:getLayer())
	self.baseLayer:addChild(self.layer)
	
	self:updateServer(data.servers)
end


function M:swarMap(field_id, init)
	self.talkBtn:showBtn(true)
	self.talkBtn:setEnable(true)
	self.talkBtn:setPosition(350, 650)
	
	state = WAR
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.field_id = field_id
	self.maxScore = init.maxScore
	self.recoveryCost = init.reviveCost
	
	self.layer = display.newLayer()
	local bg = display.newSprite(PATH.."swar_bg.jpg")
	setAnchPos(bg)
	self.layer:addChild(bg)
	
	bg = display.newSprite(PATH.."score_bg.png")
	setAnchPos(bg, 10, 10)
	self.layer:addChild(bg)
		
	bg = display.newSprite(PATH.."score_bg.png")
	setAnchPos(bg, 10, display.height - bg:getContentSize().height - 10)
	self.layer:addChild(bg)
	
	local nameA = createLabel({str = init.serverA.server_name, size = 22, color = ccc3(0xe2, 0xe2, 0xe2), width = 200})
	setAnchPos(nameA, 80, 795, 0.5)
	self.layer:addChild(nameA)
	
	self.score_A = createLabel({str = (init.serverA.score or 0).."/"..init.maxScore, size = 18, color = ccc3(0xe2, 0xe2, 0xe2)})
	setAnchPos(self.score_A, 110, 815, 0.5)
	self.layer:addChild(self.score_A)
	
	local nameB = createLabel({str = init.serverB.server_name, size = 22, color = ccc3(0xe2, 0xe2, 0xe2), width = 200})
	setAnchPos(nameB, 80, 15, 0.5)
	self.layer:addChild(nameB)
	
	self.score_B = createLabel({str = (init.serverB.score or 0).."/"..init.maxScore, size = 18, color = ccc3(0xe2, 0xe2, 0xe2)})
	setAnchPos(self.score_B, 110, 35, 0.5)
	self.layer:addChild(self.score_B)
	
	bg = display.newSprite(IMG_PATH.."image/scene/war/time_bg.png")
	setAnchPos(bg, display.width - bg:getContentSize().width - 10, 10)
	self.layer:addChild(bg)
	self.armyList = {}
	
	self.nameA = init.serverA.server_name
	self.nameB = init.serverB.server_name
	
	--倒计时
	self.timeSpan = createLabel({str = timeConvert(init.remainTime, nil, true), size = 18, color = ccc3(0xe2, 0xe2, 0xe2)})
	setAnchPos(self.timeSpan, 400, 15)
	self.layer:addChild(self.timeSpan)
	Clock:addTimeFun("swar_time", function()
		if init.remainTime > 0 then
			init.remainTime = init.remainTime - 1
			self.timeSpan:setString(timeConvert(init.remainTime, nil, true))
		end
	end)

	local back = KNBtn:new(PATH, {"back_btn.png"}, 10, 700, {
		callback = function()
			SOCKET:getInstance("swar"):send("swar", "getInfo", 1100, {key = self.zoneKey}, {success_callback = function(data)
				local fight
				for k, v in pairs(self.armyList) do
					if v:getInfo("uid") == tonumber(DATA_User:get("uid")) then
						fight = true
						break
					end
				end
				
				if fight then
					heartBeatCtl(true)
					SOCKET:getInstance("swar"):send("kuafu", "close", 1004, {}, {
						success_callback = function()
							-- SOCKET:getInstance("swar"):close()
							SOCKET:delInstance("swar")
							heartBeatCtl()
							HTTP:call("kuafu", "getSummary", {}, {
								success_callback = function(data)
									--这里更新一次zoneKey
								self.zoneKey = data.zoneKey
								self:createContent(data)
							end})
						end
					})
				else
					self:createWars(data["result"])
				end
			end})
		end
	})
	self.layer:addChild(back:getLayer())
	
	for i = 1, #maps do
		local str = "pt_empty.png"
		self.points[i] = {}
		self.points[i][1] = KNBtn:new(IMG_PATH.."image/scene/war/", {str}, maps[i][1], maps[i][2], {
			id = i,
			anchMid = true,
			callback = function()
				--观战人员
				if not self.armyList[tonumber(DATA_User:get("uid"))] then
					self:viewFormation(i)
					return
				end
				
				local legal 
				if self.armyList[tonumber(DATA_User:get("uid"))]:getInfo("stat") == 1 then
					for k, v in pairs(maps[i][3]) do
						if v == self.armyList[tonumber(DATA_User:get("uid"))]:getInfo("x") then
							legal = true
							break
						end
					end
					
					for k, v in pairs(maps[self.armyList[tonumber(DATA_User:get("uid"))]:getInfo("x")][3]) do
						if v == i then
							legal = true
							break
						end
					end
				end
				
				if legal then
					SOCKET:getInstance("swar"):send("swar", "move", 1107, {key = self.zoneKey, field_id = field_id, toPointID = tonumber(i)}, {
						no_mask = true,
						success_callback = function(data)
							self:updateWar(data)
						end
					})
				else
					self:viewFormation(i)
					if self.armyList[tonumber(DATA_User:get("uid"))]:getInfo("stat") == 0 then
						KNMsg.getInstance():flashShow("您已阵亡")
					end					
				end
			end})
			
		self.layer:addChild(self.points[i][1]:getLayer(), 1)	
		
		self:mapLine(maps, i)
	end 
	
	for k, v in pairs(init) do
		if k == "serverA" or k == "serverB" then
			self:refreshUser(v.users, k, init.moveTime)
		elseif k == "points" then
			local a, b  --两方对应据点颜色 
			local color = {}
			if init.serverA then
				a = init.serverA.server_id
				color["serverA"] = a
			end
			if init.serverB then
				b = init.serverB.server_id
				color["serverB"] = b
			end
			self:refreshPoint(v, color)
		end
	end
	
	local watch 
	if not self.armyList[tonumber(DATA_User:get("uid"))] then
		watch = true
	end
	
	if not watch then
		self.maxRecovery = init.maxRevive
		self.recoveryBtn = KNBtn:new(PATH, {"recovery.png"}, 300, 100, {
			text = {self.armyList[tonumber(DATA_User:get("uid"))]:getTimes().."/"..init.maxRevive, 24, ccc3(0x2c, 0, 0), ccp(30,0)},
			callback = function()
				showTip({
					content = createLabel({str = "你确定要复活吗", size = 24, width = 300}),
					left = {
						remove = true,
						callback = function()
							SOCKET:getInstance("swar"):send("kuafu", "recovery", 1110, {key = self.zoneKey, field_id = field_id}, {})
						end
					},
					right = {
						remove = true,
					}
				})
			end
		})
		self.layer:addChild(self.recoveryBtn:getLayer())
		
		self.reportBtn = KNBtn:new(IMG_PATH.."image/scene/war/", {"report.png", "report_press.png"}, 400, 200, {
				anchMid = true,
				callback = function()
					self.reportBtn:getLayer():stopAllActions()
					HTTP:call("KFCom"  , "GetReportList", {key = self.zoneKey, field = field_id , initTime = self.initTime}, {
						success_callback = function(data)
							self.layer:addChild(self:showReport(data), 100)
						end
					})
			end
		})
		self.layer:addChild(self.reportBtn:getLayer())
	
		bg = display.newSprite(COMMONPATH.."gold.png")
		setAnchPos(bg, 320, 70)
		self.layer:addChild(bg)
		bg = createLabel({str = init.reviveCost, size = 22, color = ccc3(0x2c, 0, 0)})
		setAnchPos(bg, 350, 70)
		self.layer:addChild(bg)
		
		SOCKET:getInstance("swar"):send("swar", "getScore", 1109,{key = self.zoneKey, field_id = field_id}, {
			mo_mask = true,
			success_callback = function(data)
			for k, v in pairs(data.result.scorePoint) do
				if v.score > 0 then
					self.points[v.point_id][4] = createLabel({str = v.score, size = 16, color = ccc3(0x2c,0,0)})
					setAnchPos(self.points[v.point_id][4],maps[v.point_id][1] - 5, maps[v.point_id][2] + 5,  0.5,0.5)
					self.layer:addChild(self.points[v.point_id][4], 5)
				end
			end
		end})
	end
	
	
	
	self.baseLayer:addChild(self.layer)
end

function M:refreshPoint(data, color)
	for k, v in pairs(data) do
		if self.points[v.pos][2] then
			self.layer:removeChild(self.points[v.pos][2], true)
			self.points[v.pos][2] = nil
		end
		
		if self.points[v.pos][3] then
			
				
			self.layer:removeChild(self.points[v.pos][3], true)
			self.points[v.pos][3] = nil
		end
		
		if v.userCount == 0 then
			self.points[v.pos][1]:setBg(1, IMG_PATH.."image/scene/war/pt_empty.png")
		else
			if v.server_id == color.serverA then
				self.points[v.pos][1]:setBg(1, IMG_PATH.."image/scene/war/pt_enemy.png")
			else
				self.points[v.pos][1]:setBg(1, IMG_PATH.."image/scene/war/pt_our.png")
			end
			
			local battle 
			for sk, sv in pairs(self.armyList) do
				if sv:getInfo("x") == v.pos then
					if sv:getInfo("stat") == 3 then
						battle = true
						break
					end
				end
			end
			if not battle then --战斗时不显示
				self.points[v.pos][2] = display.newSprite(COMMONPATH.."egg_num_bg.png")
				setAnchPos(self.points[v.pos][2], maps[v.pos][1] + 5, maps[v.pos][2] + 15)
				self.layer:addChild(self.points[v.pos][2], 10)
			
				self.points[v.pos][3] = createLabel({str = v.userCount, size = 18, color = ccc3(255,255,255)}) 
				setAnchPos(self.points[v.pos][3], maps[v.pos][1] + 15, maps[v.pos][2] + 15, 0.5)
				self.layer:addChild(self.points[v.pos][3], 10)
			end
		end
	end	
end

function M:refreshUser(data, camp, time)
	for k, v in pairs(data) do
		if self.armyList[v.uid] then
			self.armyList[v.uid]:update(v)
		else
			self.armyList[v.uid] = Army:new(v, camp,maps, time)
			self.layer:addChild(self.armyList[v.uid]:getLayer(),2)	
		end
		if v.uid == tonumber(DATA_User:get("uid"))  then
			if v.stat == 1 and self.points[v.x][4] ~= nil then  
				local text = getImageNum(self.points[v.x][4]:getString(), COMMONPATH.."cirt.png")
				setAnchPos(text, maps[v.x][1], maps[v.x][2], 0.5)
				text:setScale(0)
				self.layer:addChild(text, 10)
				text:runAction(getSequenceAction(CCEaseElasticOut:create(
					CCScaleTo:create(0.5, 1)),
					CCJumpTo:create(0.5, ccp(110, (camp == "serverB" and 50 or 800)), 50, 1), 
					CCCallFunc:create(function()
						self.layer:removeChild(text, true)
					end)))
				
				self.layer:removeChild(self.points[v.x][4], true)
				self.points[v.x][4] = nil
			end
			
			if v.stat == 3 then
				local function tip()
					self.reportBtn:getLayer():stopAllActions()
					self.reportBtn:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.2, 1.3),CCScaleTo:create(0.2, 1), CCCallFunc:create(function()
						tip()
					end)))
				end
				tip()
			end
		end
	end
end

function M:mapLine(pos, i)
	local data = pos[i][3]
	for j = 1, #data do
		local line = display.newSprite(PATH.."map_line.png")
			
		self.layer:addChild(line)
		setAnchPos(line, pos[i][1], pos[i][2], 0, 0.5)
		local dx = pos[data[j]][1] - pos[i][1]
		local dy = pos[data[j]][2] - pos[i][2]
		
		local distance = math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))
		
		local rotate = -math.deg(math.acos(dx / distance))
		if dy < 0 then
			rotate = -rotate
		elseif dy == 0 and dx < 0 then
			rotate = 180
		end
		line:setScaleX(distance / line:getContentSize().width)
		line:setRotation(rotate)
	end
end

function M:tip(data)
	local targetId
	for k, v in pairs(data) do
		for sk, sv in pairs(v) do
			if DATA_Session:get("server_id") == sv then
				if sk =="a_server_id" then
					targetId = v.b_server_id 
				else
					targetId = v.a_server_id
				end
				break
			end
		end
	end
	if  targetId then
		KNMsg.getInstance():flashShow("战斗开始，本服对战【"..self.serverTeam[targetId][2].server_name.."】")
		local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
		self.server_cur = display.playFrames(240, 450,frames, 0.2, {
			forever = true,
		})
		setAnchPos(self.server_cur, 240, 450, 0.5, 0.5)
		self.layer:addChild(self.server_cur, 2)	
	else
		KNMsg.getInstance():flashShow("战斗即将开始，您可以点击直播按钮观看战斗直播")
	end
	self.serverStat = 2 
end

--参战服务器页面显示
function M:updateServer(data, force)
	if state ~= SERVER and not force then
		return
	end
	
	if self.server_cur then
		self.layer:removeChild(self.server_cur, true)
		self.server_cur = nil
	end
	
	local look  = true
	if self.serverTeam[DATA_Session:get("server_id")] then
		for k, v in pairs(self.serverTeam[DATA_Session:get("server_id")][2].uids) do
			if v == tonumber(DATA_User:get("uid")) then
				look = false
				break
			end
		end 
	end
	--可以观看直播
	for k, v in pairs(data) do
		local sx, sy 
		sx = pos[v.pos][1] + 55
		sy = pos[v.pos][2] + (v.pos > 3 and 70 or -10)
		if self.serverTeam[v.server_id] then
			local moving, fighting
			if 	self.serverTeam[v.server_id][2].stat == 1 then
				moving = true
			elseif self.serverTeam[v.server_id][2].stat == 3 then
				fighting = true	
			end
			
			v.uids = self.serverTeam[v.server_id][2].uids
			v.server_name = self.serverTeam[v.server_id][2].server_name
			self.serverTeam[v.server_id][2] = v 
			
			if v.stat == 3 then
				self.layer:removeChild(self.serverTeam[v.server_id][1],true)
				sx = pos[v.pos][3]
				sy = pos[v.pos][4]			
				
				local join 
				if self.serverTeam[v.server_id] then
					for k, v in pairs(self.serverTeam[v.server_id][2].uids) do
						if v == tonumber(DATA_User:get("uid")) then
							join = true
							break
						end
					end 
				end
				
				local frames = display.newFramesWithImage(IMG_PATH .. "image/scene/war/fight_effect.png" , 6 )
				self.serverTeam[v.server_id][1] = display.playFrames(sx, sy, frames, 0.1, {
					forever = not join,
					onComplete = function()
						SOCKET:getInstance("swar"):send("swar", "getWarInfo", 1106, {key = self.zoneKey, field_id = v.field_id}, {
							success_callback = function(init)
								self:swarMap(v.field_id, init.result)
							end
						})
					end
				})
				setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
				self.layer:addChild(self.serverTeam[v.server_id][1])
				
				if look then
					self.serverTeam[v.server_id][3] = KNBtn:new(PATH, {"live.png", "live_press.png"}, pos[v.pos][1] + 50, pos[v.pos][2] + (v.pos > 3 and 80 or 0), {
						callback = function()
							SOCKET:getInstance("swar"):send("swar", "getWarInfo", 1106, {key = self.zoneKey, field_id = v.field_id}, {
								success_callback = function(init)
									DATA_Info:set_type("war", {})
									self:swarMap(v.field_id, init.result)
								end
							})
						end
					})
					self.layer:addChild(self.serverTeam[v.server_id][3]:getLayer())
				end	
--				setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
			else
				if fighting then
					self.layer:removeChild(self.serverTeam[v.server_id][1],true)
					self.serverTeam[v.server_id][1] = display.newSprite(PATH.."server_team.png")
					self.layer:addChild(self.serverTeam[v.server_id][1])

				end
				
				if v.stat == 0 then
					setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
					if self.serverStat ==  2 then
						local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
						self.server_cur = display.playFrames(240, 450,frames, 0.2, {
							forever = true,
						})
						setAnchPos(self.server_cur, 240, 450, 0.5, 0.5)
						self.layer:addChild(self.server_cur, 2)						
					end 
				elseif v.stat == 1 then
					if not moving then
						setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
						self.serverTeam[v.server_id][1]:runAction(CCMoveTo:create(v.tarTime - (os.time() + TIME_OFFSET),ccp(pos[v.pos][3],pos[v.pos][4])))
					end
				elseif v.stat == 2 then
					sx = pos[v.pos][3]
					sy = pos[v.pos][4]
					setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
				else
					sx = pos[v.pos][3]
					sy = pos[v.pos][4]
					setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
				end
			end
		else
			self.serverTeam[v.server_id] = {}
			if not force then
				if v.stat == 3 then  --战斗中
					local frames = display.newFramesWithImage(IMG_PATH .. "image/scene/war/fight_effect.png" , 6 )
					self.serverTeam[v.server_id][1] = display.playFrames(sx, sy, frames, 0.1, {
						forever = true,
					})
					sx = pos[v.pos][3]
					sy = pos[v.pos][4]
					setAnchPos(self.serverTeam[v.server_id][1], sx, sy)

					self.serverTeam[v.server_id][3] = KNBtn:new(PATH, {"live.png", "live_press.png"}, pos[v.pos][1] + 50, pos[v.pos][2] + (v.pos > 3 and 80 or 0), {
						callback = function()
							SOCKET:getInstance("swar"):send("swar", "getWarInfo", 1106, {key = self.zoneKey, field_id = v.field_id}, {
								success_callback = function(init)
									DATA_Info:set_type("war", {})
									self:swarMap(v.field_id, init.result)
								end
							})
						end
					})
					self.layer:addChild(self.serverTeam[v.server_id][3]:getLayer())
				else
					self.serverTeam[v.server_id][1] = display.newSprite(PATH.."server_team.png")
					if v.stat == 1 then
						local percent = (self.serverMove - (v.tarTime - (os.time() + TIME_OFFSET))) / self.serverMove
						sx = sx +( pos[v.pos][3] - sx) * percent
						sy = sy + (pos[v.pos][4] - sy) * percent
						setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
						
						self.serverTeam[v.server_id][1]:runAction(CCMoveTo:create(v.tarTime - (os.time() + TIME_OFFSET), ccp( pos[v.pos][3],  pos[v.pos][4])))
					else
						if v.stat == 0 then
							if self.serverStat ==  2 then
								local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
								self.server_cur = display.playFrames(240, 450,frames, 0.2, {
									forever = true,
								})
								setAnchPos(self.server_cur, 240, 450, 0.5, 0.5)
								self.layer:addChild(self.server_cur, 2)						
							end 
						else
							sx = pos[v.pos][3]
							sy = pos[v.pos][4]
						end
						setAnchPos(self.serverTeam[v.server_id][1], sx, sy)
					end
				end
				self.layer:addChild(self.serverTeam[v.server_id][1])
			end
			self.serverTeam[v.server_id][2] = v 
		end
	end
end

--更新战场 状态
function M:updateWar(data, kind)
	if state ~= WAR then
		return
	end
	
	if kind == "move" then
		self:refreshUser(data)
		local temp 
		for k, v in pairs(data) do
			temp = v
		end
		self:refreshPoint({[temp.x] = {pos = temp.x, server_id = temp.server_id, userCount = tonumber(self.points[temp.x][3]:getString()) - 1}},{[self.armyList[temp.uid]:getCamp()] = temp.server_id})
	elseif kind == "recovery" then
		if data.uid == tonumber(DATA_User:get("uid")) then
			local user =self.armyList[data.uid]
			user:subTimes()
			self.recoveryBtn:setText(user:getTimes().."/"..self.maxRecovery)
			
			local info = user:getInfo()
			info.stat = 1
			info.x = user:getCamp() == "serverA" and 1 or #maps
			self:refreshUser({info})
			KNMsg.getInstance():flashShow("信春哥原地满状态复活，继续战斗吧，骚年")
			
			DATA_Account:setType("gold", DATA_Account:get("gold") - self.recoveryCost)
		else
			KNMsg.getInstance():flashShow("土豪【"..data.name.."】花费大把金币，成功复活，快去交朋友吧")
		end
	elseif kind == "all" then
		local a, b  --两方对应据点颜色 
		local color = {}
		if data.serverA then
			a = data.serverA.server_id
			color["serverA"] = a
		end
		if data.serverB then
			b = data.serverB.server_id
			color["serverB"] = b
		end
		
		for k, v in pairs(data) do	
			if k == "serverA" or k == "serverB" then
				if k == "serverA" then
					self.score_A:setString(v.score.."/"..self.maxScore)
				else
					self.score_B:setString(v.score.."/"..self.maxScore)
				end
				if v.users then
					self:refreshUser(v.users,k)
				else
				end
			elseif k == "points" then
				self:refreshPoint(v, color)
			end
		end
	elseif kind == "singleResult" then
		local stat = {
			{
				x = data.x,
				y = data.y,
				z = data.z,
				stat = 0,
				uid = data.a_win == 0 and data.a_uid or data.b_uid
			}
		}
		self:refreshUser(stat,data.a_win == 0 and "serverA" or "serverB")
	elseif kind == "end" then
		local function overFunc()
			if data["end"] == 0 then
				DATA_Info:set_type("war", {})
				SOCKET:getInstance("swar"):send("swar", "getInfo", 1100, {key =self.zoneKey }, {success_callback = function(data)
					local state = data.result.stat
					local fight
					for k, v in pairs(data.result.servers) do
						if v.server_id == DATA_Session:get("server_id") and data.result.stat == 3 then --战斗中
							fight = true
							break
						end
					end
					
					if fight then
						SOCKET:getInstance("swar"):send("swar", "getWarInfo", 1106, {key = self.zoneKey, field_id = self.field_id}, {
							success_callback = function(init)
								init.result.initTime = self.initTime
								self:swarMap(self.serverTeam[DATA_Session:get("server_id")][2].field_id, init.result)
							end
						})
					else
						self:createWars(data["result"])
					end
				end})
			else
				DATA_Info:set_type("war", {})
				DATA_Info:set_type("server", {})
				heartBeatCtl(true)
				SOCKET:getInstance("swar"):send("kuafu", "close", 1004, {}, {
					success_callback = function()
						-- SOCKET:getInstance("swar"):close()
						SOCKET:delInstance("swar")
						heartBeatCtl()
						HTTP:call("kuafu", "getSummary", {}, {
							success_callback = function(data)
								--这里更新一次zoneKey
							self.zoneKey = data.zoneKey
							self:createContent(data)
						end})
					end
				})
			end
		end
		
		local args, content
		if not self.armyList[tonumber(DATA_User:get("uid"))] then   --观战者
			content = display.newLayer()
			local temp = createLabel({str = "战斗已结束,【"..(data.a_win == 1 and self.nameA or self.nameB).."】获得了胜利", size = 24, width = 380, color = ccc3(0x2c,0, 0)})
			setAnchPos(temp, 240, 425, 0.5, 0.5)	
			content:addChild(temp)
			
			args = {
				parent = self.layer,
				content = content,
				bg = COMMONPATH.."tip_bg.png",
				center = {
					callback = function()
						overFunc()
					end
				}	
			}
		elseif (self.armyList[tonumber(DATA_User:get("uid"))]:getCamp() == "serverA" and data.a_win == 1) or 
			(self.armyList[tonumber(DATA_User:get("uid"))]:getCamp() == "serverB" and data.a_win == 0) then
			content = display.newLayer()
			local temp = createLabel({str = "恭喜您获得了战斗的胜利", size = 24, width = 380, color = ccc3(0x2c,0, 0)})
			setAnchPos(temp, 240, 425, 0.5, 0.5)	
			content:addChild(temp)
			
			local time = display.newSprite(PATH.."total_time.png")
			setAnchPos(time, 80, 330)
			content:addChild(time)
			
			content:addChild(createLabel({str = self.armyList[tonumber(DATA_User:get("uid"))]:getCamp() == "serverA" and data.a_win_count or data.b_win_count, size = 24, x = 400, y = 330}))
			
			content:addChild(createLabel({str = timeConvert(data.win_span, nil, true), size = 24, x = 150, y = 330}))
			
			
			local winCount = display.newSprite(PATH.."win_count.png")
			setAnchPos(winCount, 250, 330)
			content:addChild(winCount)
			
			
			args = {
				parent = self.layer,
				content = content,
				title_bg = IMG_PATH.."image/scene/battle/fruit/win/win_title_bg.png",
				title_text = IMG_PATH.."image/scene/battle/fruit/win/mission_win.png",
				bg = COMMONPATH.."tip_bg.png",
				center = {
					callback = function()
						overFunc()
					end
				}	
			}
		else
			content = display.newLayer()
			
			local winCount = display.newSprite(PATH.."win_count.png")
			setAnchPos(winCount, 150, 330)
			content:addChild(winCount)
			
			local temp = createLabel({str = "战斗失败，本服玩家不能获得奖励", size = 24, width = 380, color = ccc3(0x2c,0, 0)})
			setAnchPos(temp, 220, 425, 0.5, 0.5)	
			content:addChild(temp)
			
			content:addChild(createLabel({str = self.armyList[tonumber(DATA_User:get("uid"))]:getCamp() == "serverA" and data.a_win_count or data.b_win_count, size = 24, x = 300, y = 330}))
			
			
			args = {
				content = content,
				parent = self.layer,
				title_text = IMG_PATH.."image/scene/battle/fruit/lost/lost_title.png",
				bg = COMMONPATH.."tip_bg.png",
				center = {
					callback = function()
						overFunc()
					end
				}	
			}
		end
		
		showTip(args)
	end
end


function M:showReport(data)
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer})
	
	local bg = display.newSprite(IMG_PATH.."image/scene/mission/wipe_bg.png")
	setAnchPos(bg, 250, 425, 0.5, 0.5)
	layer:addChild(bg)
	
	local title = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
	setAnchPos(title, 260, 560, 0.5)
	layer:addChild(title)
	
	title = display.newSprite(IMG_PATH.."image/scene/war/title.png")
	setAnchPos(title, 250, 570, 0.5)
	layer:addChild(title)
	
	local back = KNBtn:new(COMMONPATH, {"back_img.png", "back_img_press.png"}, 50, 540, {
		priority = -131,
		callback = function()
			mask:remove()
		end
	})
	layer:addChild(back:getLayer())
	
	local function createItem(index)
		local report
		report = display.newLayer()
		local itemBg = display.newSprite(IMG_PATH.."image/scene/war/report_bg.png")
		setAnchPos(itemBg)
		
		report:setContentSize(CCSizeMake(bg:getContentSize().width, itemBg:getContentSize().height))
		report:addChild(itemBg)
		
		local opt = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 330, 15, {
			priority = -131,
			front = IMG_PATH.."image/scene/friend/text_operate.png",
			callback = function()
				local result = display.newLayer()
				local mask = KNMask:new({item = result, priority = -132})
				
				local bg = display.newSprite(COMMONPATH.."tip_bg.png")
				setAnchPos(bg, 250, 425, 0.5, 0.5)
				result:addChild(bg)
				
				local x, y
				--武将的状态显示
				for k, v in pairs(data[index].remain_general) do
					if k == "on" then
						y = 480
					else
						y = 380
					end
					for i = 1, #v do 
						local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 65 + (i - 1) * 100, y, {
							other = {COMMONPATH.."egg_num_bg.png", 50, 50},
							text = {v[i].lv, 18, ccc3(255,255,255), ccp(28, 28), nil, 20 },
							front = getImageByType(v[i].cid, "s")
						})
						result:addChild(btn:getLayer())
						
						local hp = KNProgress:new(IMG_PATH.."image/scene/war/", {"hp_bg.png", "hp_full.png"}, 65 + (i - 1) * 100, y - 10, {
							cur = v[i].hp,
							max = v[i].org_hp
						})
						result:addChild(hp:getLayer())
					end
				end
				
				local replay = KNBtn:new(IMG_PATH.."image/scene/war/", {"replay.png", "replay_press.png"}, 380, 310, {
					priority = -133,
					callback = function()
						HTTP:call("KFCom", "GetReport", {report_id = data[index].report_id}, {
							success_callback = function(data)
								DATA_Battle:setMod("guide")
								DATA_Battle:setAct("execute")
								DATA_Battle:set( data )
								switchScene("battle" , { resultCallFun = function()end, overFun = function()
									SOCKET:getInstance("swar"):send("swar", "getInfo", 1100, {key = self.zoneKey}, {success_callback = function(data)
										local state = data.result.stat
										local allInfo
										for k, v in pairs(data.result.servers) do
											if v.server_id == DATA_Session:get("server_id") then
												SOCKET:getInstance("swar"):send("swar", "getWarInfo", 1106, {key = self.zoneKey, field_id = v.field_id}, {
													success_callback = function(init)
														allInfo = {
															curState = WAR,
															field_id = self.field_id, 	
															result = init.result,
															initTime = self.initTime,
															zoneKey = self.zoneKey
														}
														switchScene("swar", allInfo)
													end, error_callback = function()
														heartBeatCtl(true)
														SOCKET:getInstance("swar"):send("kuafu", "close", 1004, {}, {
															success_callback = function()
																HTTP:call("kuafu", "getSummary", {}, {
																	success_callback = function(data)
																		switchScene("swar", data, function()
																			heartBeatCtl()
																		end)
																	end})
															end})
													end
												})
												break
											end
										end
									end, error_callback = function()
										heartBeatCtl(true)
										SOCKET:getInstance("swar"):send("kuafu", "close", 1004, {}, {
											success_callback = function()
												HTTP:call("kuafu", "getSummary", {}, {
													success_callback = function(data)
														switchScene("swar", data, function()
															heartBeatCtl()
														end)
													end})
											end})
									end})
								end })
							end
						})
					end
				})
				result:addChild(replay:getLayer())
				
				local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 180, 310, {
					priority = -133,
					front = COMMONPATH.."colse_text.png",
					callback = function()
						mask:remove()
					end
				})
				result:addChild(close:getLayer())
				
				layer:addChild(mask:getLayer())
			end
		})
		report:addChild(opt:getLayer())
		
		local str 
		if data[index].win == 1 then
			str =  "【"..DATA_User:get("name").."】战胜了【"..data[index]["uid_2_name"].."】"	
		else
			str =  "【"..DATA_User:get("name").."】被【"..data[index]["uid_2_name"].."】打败了"	
		end
		
		local alive = 0
		for k, v in pairs(data[index].remain_general) do
			for sk, sv in pairs(v) do
				if sv.hp > 0 then
					alive = alive + 1
				end
			end
		end
		str = str..",当前存活武将数"..alive.."人"
		local oneMsg = createLabel({str = replaceStr(str), color = ccc3(255, 255, 255), size = 18, width = 310, x = 10, y = 15})
		oneMsg:setDimensions( CCSize:new( oneMsg:getContentSize().width ,0 ) )
		report:addChild(oneMsg)
		return report	
	end
	
	for i = 1, #data do
		local report = createItem(i)
		setAnchPos(report, 45, 475 - (i - 1) * (report:getContentSize().height + 5))
		layer:addChild(report)
	end
	
	return mask:getLayer()
end

function M:viewFormation(index)
	local report = display.newLayer()
	local mask = KNMask:new({item = report})
	
	local bg = display.newSprite(IMG_PATH.."image/scene/war/info_bg.png")
	setAnchPos(bg)
	
	report:setContentSize(CCSizeMake(bg:getContentSize().width, bg:getContentSize().height))
	setAnchPos(report, 30, 300)
	report:addChild(bg)
	
	local count = 0
	for k, v in pairs(self.armyList) do
		if v:getInfo("x") == index and v:getInfo("stat") == 1 then
			local btn = KNBtn:new(COMMONPATH, {getHeadPath(v:getSex())}, 20 + (count - 5 >= 0 and count - 5 or count) * 80, 200 - (count >= 5 and 1 or 0) * 110, {
				text = {{v:getName(), 18, ccc3(0xff, 0xfb, 0xd4), ccp(0, -40)},{v:getLv() or 10, 18, ccc3(0xff, 0xfb, 0xd4), ccp(30, 30), nil, 17}},
				other = {COMMONPATH.."egg_num_bg.png", 50, 50},
				front = COMMONPATH.."role_frame.png",
			})
			report:addChild(btn:getLayer())
			
			count = count + 1
		else
		end
	end
	
	if count == 0 then
		local empty = display.newSprite(COMMONPATH.."empty.png")
		setAnchPos(empty, 210, 70, 0.5)
		report:addChild(empty)
	end
	
	local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 130, 10, {
		priority = -133,
		front = COMMONPATH.."colse_text.png",
		callback = function()
			mask:remove()
		end
	})
	report:addChild(close:getLayer())
	
	self.layer:addChild(mask:getLayer(),15)
end

return M