local PATH = IMG_PATH.."image/scene/swar_pre/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")--require "GameLuaScript/Scene/common/infolayer"
local Item = requires(IMG_PATH, "GameLuaScript/Scene/swar_pre/rankitem")

local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local MAIN, CONRANK, ARMYRANK, UP, TOCON = 1, 2, 3, 4, 5
local state

local M = {
	baseLayer,
	layer,
	infoLayer,
	data,
	donate,
	curPage,
	maxPage,
}

local rules = {
	"一、资格赛-军团\n 1、每个参赛服务器均会有五个军团；满足条件的玩家，在每一届跨服战-资格战阶段中，第一次进入时会被随机分配到其中一个军团中。\n 2、每个军团会选出一个战将，战将为该军团排名第一的玩家；去多战胜其他玩家可以帮助提升排名。\n 3、每个参赛服在资格战结束时，该服五个军团的战将会获得出赛资格，而其中胜场最多的战将成为战王，带领其他4战将一起出赛跨服战。\n",
	"二、预选赛\n 1：预选赛会举行三次，分别在每个月第一周的周六、周日和第二周的周六举行。最终会选出前十二名服务器进入半决赛\n 2：预选赛采用擂台赛的形式。每6个服务器被随机分配到一个战区进行战斗，每次预选赛结束后都会更新排行榜信息。\n 3：预选赛玩家参与会获得大量银两（包括没有参加战斗，但是加入了本服军团的玩家）。\n",
	"三、半决赛\n 1：半决赛在每个月第二周的周日举行。最终会选出前六名服务器进入决赛。\n 2：半决赛结束的10分钟后开始决赛。\n 3：半决赛采用擂台赛形式。每6个服务器被随机分配到一个战区进行战斗，每次预选赛结束后都会更新排行榜信息。\n 4：半决赛玩家参与会获得更多的银两（包括没有参加战斗，但是加入了本服军团的玩家）。\n",
	"四、决赛\n 1:决赛在半决赛结束后的10分钟后开始。\n 2：决赛会选出整个游戏的前三名服务器。\n 3：决赛的赛制和半决赛相同。决赛最后决出的全游戏第一服的军团长即为本月的【跨服圣王】。\n 4：决赛决出的前三名服务器参与跨服战斗的玩家都有【限时超强装备】和超级称号奖励。\n",
	"五、奖励 \n 1:捐献后会获得物资，物资会在跨服战结束后，会成倍的返还银两。\n 2:参与跨服战预选赛、半决赛、决赛战斗的玩家以及职阶为中级勇士及以上的玩家，每轮战斗结束后，都会获得银两奖励。\n 3:跨服战结束时，选出前三名服务器，3个服务器的圣王、圣将可获得独一无二的特殊套装、以及黄金、银两等珍贵奖励。\n 4:跨服战结束后，在名人堂中每日去膜拜还可以额外获得黄金奖励。\n"
}

function M:new(data)
	local this = {}
	setmetatable(this, self)
	self.__index = self
	this.data = data
	this.baseLayer = display.newLayer()
	this.curPage = 1
	this.maxPage = 1
	
	local bg = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	this.baseLayer:addChild(bg)
	
	
	this.infoLayer = InfoLayer:new("swar_pre", 0, {tail_hide = true, title_text = PATH.."prewar_text.png", closeCallback = function()
		if state == MAIN then
			switchScene("pvp",{coming = "swar"})
		else
			this.curPage = 1
			this:createContent()
		end
	
	end})
	this.baseLayer:addChild(this.infoLayer:getLayer(),10)
	
	this:createContent()
	return this
end

function M:createContent()
	state = MAIN
	self.infoLayer:refreshTitle(PATH.."prewar_text.png")
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	
	local text = display.newSprite(PATH.."cur_state.png")
	setAnchPos(text, 50, 720)
	self.layer:addChild(text)
	
	text = createLabel({str = "本服资格赛", size = 20, color = ccc3(0xff, 0xfb, 0xd4), width = 400}) 
	setAnchPos(text, 145, 720)
	self.layer:addChild(text)
	
	text = display.newSprite(PATH.."cur_army.png")
	setAnchPos(text, 300, 720)
	self.layer:addChild(text)
	
	text = display.newSprite(PATH.."army_"..self.data.me.."_name.png")
	setAnchPos(text, 400, 720)
	self.layer:addChild(text)
	
	local help = KNBtn:new(COMMONPATH, {"help.png", "help_press.png"}, 420, 670, {
		priority = -129,
		callback = function()
			local layer = display.newLayer()
			local bg = display.newSprite(IMG_PATH.."image/scene/swar/rule_bg.png")
			setAnchPos(bg, 240, 425, 0.5, 0.5)
			layer:addChild(bg)
			
			bg = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
			setAnchPos(bg, 240, 675, 0.5, 0.5)
			layer:addChild(bg)
			
			bg = display.newSprite(IMG_PATH.."image/scene/swar/rule_title.png")
			setAnchPos(bg, 240, 675, 0.5, 0.5)
			layer:addChild(bg)
			
			local scroll = KNScrollView:new(0, 250, 480, 380)
			
			layer:addChild(scroll:getLayer())
			
			local mask = KNMask:new({item = layer})
			
			local tempLayer = display.newLayer()
			tempLayer:setContentSize(CCSizeMake(480, 700))

			local y = 690
			
			for i = 1, #rules do
				local text = display.strokeLabel( replaceStr(rules[i]) , 35 , 175 , 16 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , {
								dimensions_width = 420 ,
								dimensions_height = 0,
								align = 0 
								}) 	
				setAnchPos(text, 35, y, 0, 1)
				tempLayer:addChild(text)
				
				y = y - text:getContentSize().height - 5
			end
			scroll:addChild(tempLayer)
			
			display.getRunningScene():addChild(mask:getLayer(), 5)
			
			local ok = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 180, 200, {
				front = COMMONPATH.."ok.png",
				priority = -150,
				callback = function()
					mask:remove()	
				end
			})
			layer:addChild(ok:getLayer())
		end
	})
	self.layer:addChild(help:getLayer())
	
	local pos = {
		{10, 520},
		{290, 520},
		{10, 150},
		{290, 150},
		{150, 325},
	}
	
	local effetFrames = display.newFramesWithImage(PATH.."effect.png", 12, 2)
	local action = display.playFrames(0, 0, effetFrames, 0.2, {
		forever = true,
	})
	setAnchPos(action,pos[self.data.me][1] - 20,pos[self.data.me][2])
	self.layer:addChild(action)
	
	for i = 1, 5 do
		local btn = KNBtn:new(PATH, {"army_bg.png"}, pos[i][1], pos[i][2], {
			front = PATH.."army_"..i..".png",
			frontScale = {1, 0, 10},
			other = {PATH.."army_"..i.."_name.png", 50, 10},
			callback = function()
				HTTP:call("kuafu", "getCorpsInfo", {corps = i} ,{
					success_callback = function(data)
						if i == self.data.me then
							HTTP:call("kuafu", "getUserInfo", {corps = i}, {
								success_callback = function(userInfo)
									self:curArmyInfo(data, userInfo)
								end
							})
							return
						end
						
						--通用军团信息页面
						local info, box
						local content = display.newLayer()
						content:ignoreAnchorPointForPosition(false)
						
						info = display.newSprite(PATH.."army_"..i.."_leader.png")
						setAnchPos(info, 100, 420)
						content:addChild(info)
						
						info = createLabel({str = data.zwName, size = 24, width = 300}) 
						setAnchPos(info, 220, 420)
						content:addChild(info)
						
						info = display.newSprite(PATH.."win_num.png")
						setAnchPos(info, 100, 380)
						content:addChild(info)
						
						info = createLabel({str = data.zwWinCount, size = 24, width = 300}) 
						setAnchPos(info, 220, 380)
						content:addChild(info)
						
						info = display.newSprite(PATH.."total_res.png")
						setAnchPos(info, 100, 330)
						content:addChild(info)
						
						info = createLabel({str = data.donateAmount, size = 24, width = 300}) 
						setAnchPos(info, 235, 330)
						content:addChild(info)
			
						showTip({
							content = content,
							title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
							title_text = PATH.."army_"..i.."_title.png",
							center = {
								front = i == self.data.me and COMMONPATH.."ok.png" or COMMONPATH.."colse_text.png",
								remove = true,
								removeCallback = function()
									if i == self.data.me then
										
									end
								end
							},
						})
					end
				})	
			end
				
		})	
		self.layer:addChild(btn:getLayer())

		local guide_step = KNGuide:getStep()
		if i == self.data.me and (guide_step == 5004 or guide_step == 5007) then
			KNGuide:show( btn:getLayer() )
		end
	end
	
	self.baseLayer:addChild(self.layer)
end

	--个人军团的详细信息							
function M:curArmyInfo(armyInfo, userInfo)
	local info
	local content = display.newLayer()
	content:ignoreAnchorPointForPosition(false)
	
	info = display.newSprite(PATH.."army_info.png")
	setAnchPos(info, 40, 555)
	content:addChild(info)
	
	info = display.newSprite(PATH.."army_detail.png")
	setAnchPos(info, 120, 435)
	content:addChild(info)
	
	info = display.newSprite(PATH.."self_info.png")
	setAnchPos(info, 40, 390)
	content:addChild(info)
	
	info = display.newSprite(PATH.."self_detail.png")
	setAnchPos(info, 120, 270)
	content:addChild(info)
	
	--军团信息
	info = createLabel({str = armyInfo.corpsName, size = 24, width = 300}) 
	setAnchPos(info, 230, 505)
	content:addChild(info)
	
	info = createLabel({str = armyInfo.zwName, size = 24, width = 300}) 
	setAnchPos(info, 230, 470)
	content:addChild(info)
	
	info = createLabel({str = armyInfo.donateAmount, size = 24, width = 300}) 
	setAnchPos(info, 255, 435)
	content:addChild(info)	
	
	--个人详情
	info = createLabel({str = userInfo.winCount, size = 24, width = 300}) 
	setAnchPos(info, 190, 340)
	content:addChild(info)
	
	info = createLabel({str = userInfo.corpsRankName, size = 24, width = 300}) 
	setAnchPos(info, 190, 305)
	content:addChild(info)
	
	info = createLabel({str = userInfo.donateCount, size = 24, width = 300}) 
	setAnchPos(info, 250, 270)
	content:addChild(info)	
	
	local optName = {
		--图片名称， 创建方法名称， 接口名称， 
		{"contribute_rank","contributeRank", "getDonationRanking"},
		{"army_rank", "createArmyRank", "getCorpsRanking"},
		{"up_rank", "upRank","getCorpsUser"},
		{"to_contribute", "toContribute","getDonateInfo"}
	}
	
	local x, y = 70, 190
	for i = 1, #optName do
		local btn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"},x, y, {
			priority = -131,
			front = PATH..optName[i][1]..".png",
			callback = function()
				HTTP:call("kuafu", optName[i][3], {corps = self.data.me, page = 1}, {
					success_callback = function(data)
						if i ~= 4 then
							self.userLayer:remove()
						end
						self[optName[i][2]](self, data)
					end
				})
			end
		})
		content:addChild(btn:getLayer())
		
		x = x + 200
		if i % 2 == 0 then
			x = 70
			y = y - 65
		end

		if optName[i][1] == "up_rank" and KNGuide:getStep() == 5005 then
			local btn_range = btn:getRange()

			KNGuide:show( btn:getLayer() , {
				x = btn_range:getMinX() + 240,
				y = btn_range:getMinY() + 475,
			})
		end

		if optName[i][1] == "to_contribute" and KNGuide:getStep() == 5008 then
			local btn_range = btn:getRange()

			KNGuide:show( btn:getLayer() , {
				x = btn_range:getMinX() + 240,
				y = btn_range:getMinY() + 475,
			})
		end
	end
	
	self.userLayer = showTip({
		content = content,
		bg = PATH.."detail_bg.png",
		title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
		title_text = PATH.."detail_title.png",
		close = {
			path = COMMONPATH,
			normal = "back_img.png",
			pre = "back_img_press.png",
			remove = true,
			
		},
	})
end
					

function M:createArmyRank(data, index)
	state = ARMYRANK
	self.infoLayer:refreshTitle(PATH.."army_rank_title.png")
	
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	self.maxPage = data.pageCount
	
	local scroll
	local group = KNRadioGroup:new()
	local function createContent(list)
		if scroll then
			self.layer:removeChild(scroll:getLayer(), true)
			scroll = nil
		end
		
		if #list > 0 then
			scroll = KNScrollView:new(0, 150, 480, 540)
			for i = 1,#list do
				local item = Item:new("athletics",i + ((self.curPage - 1) * 20),scroll, list[i])
				scroll:addChild(item:getLayer())
			end
			self.layer:addChild(scroll:getLayer())
		end
		scroll:alignCenter()
		
		self:turnPage(function()
			HTTP:call("kuafu", "getCorpsRanking", {corps = group:getId(),page = self.curPage}, {
				success_callback = function(data)
					self:createArmyRank(data, group:getId())
				end
			})
		end)
	end
	
	local title = display.newSprite(COMMONPATH.."tab_line.png")
	setAnchPos(title, 240, 690, 0.5)
	self.layer:addChild(title)
	
	local upBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 360, 100, {
		front = PATH.."up_rank.png",
		callback = function()
			HTTP:call("kuafu", "getCorpsUser", {corps = self.data.me, page = 1}, {
				success_callback = function(data)
					self:upRank(data)	
				end
			})
		end
	})
	self.layer:addChild(upBtn:getLayer())
	if index == nil or index == data.myCorpsID then
		upBtn:showBtn(true)
		upBtn:setEnable(true)
	else
		upBtn:showBtn(false)
		upBtn:setEnable(false)
	end
	
	
	for i = 1, 5 do
		local btn = KNBtn:new(COMMONPATH.."tab/", {"tab_star_normal.png","tab_star_select.png"},10 + (i - 1) * 90 , 695, {
			id = i,
			front =  {PATH.."army_"..i.."_normal.png",PATH.."army_"..i.."_select.png"},
			callback = function()
				HTTP:call("kuafu", "getCorpsRanking", {corps = i, page = 1}, {
					success_callback = function(data)
						if i == data.myCorpsID then
							upBtn:showBtn(true)
							upBtn:setEnable(true)
						else
							upBtn:showBtn(false)
							upBtn:setEnable(false)
						end
						self.curPage = 1
						createContent(data.list)
					end
				})
			end
		}, group)
		self.layer:addChild(btn:getLayer(), -1)
	end
	group:chooseByIndex(index or self.data.me, false)
	
	createContent(data.list)
	
--	self:turnPage(function()
--		HTTP:call("kuafu", "getCorpsRanking", {corps = group:getId(),page = self.curPage}, {
--			success_callback = function(data)
--				self:createArmyRank(data, group:getId())
--			end
--		})
--	end)
	self.baseLayer:addChild(self.layer)
end

function M:contributeRank(data)
	state = CONRANK 
	self.infoLayer:refreshTitle(PATH.."con_rank_title.png")
	
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	local scroll = KNScrollView:new(0, 140, 480, 600)
	self.maxPage = data.pageCount
	
	for i = 1, #data.list do
		local item = Item:new("donate",i,scroll, data.list[i])
		scroll:addChild(item:getLayer())
	end
	scroll:alignCenter()
	self.layer:addChild(scroll:getLayer())
	
	self:turnPage(function()
		HTTP:call("kuafu", "getDonationRanking", {corps = self.data.me, page = self.curPage}, {
			success_callback = function(data)
				self:contributeRank(data)
			end
		})
	end)
	self.baseLayer:addChild(self.layer)
end

function M:toContribute(data)
	local content = display.newLayer()
	content:ignoreAnchorPointForPosition(false)
	
	local info = display.newSprite(PATH.."contr_desc.png")
	setAnchPos(info, 240, 430, 0.5)
	content:addChild(info)
	
	info = display.newSprite(PATH.."contr_info.png")
	setAnchPos(info,240, 340, 0.5)
	content:addChild(info)
	
	info = display.newSprite(PATH.."contr_total.png")
	setAnchPos(info,160, 356, 0.5)
	content:addChild(info)
	
	info = display.newSprite(PATH.."contr_times.png")
	setAnchPos(info,130, 305, 0.5)
	content:addChild(info)
	
	info = display.newSprite(SCENECOMMON.."prop_bg.png")
	setAnchPos(info,240, 205, 0.5)
	content:addChild(info)
	
	local total = createLabel({str = data.donateCount, size = 24, color = ccc3(0x2c, 0, 0)})
	setAnchPos(total, 280, 360)
	content:addChild(total)
	
	local times = createLabel({str = data.donateTimes, size = 24, color = ccc3(0x2c, 0, 0)})
	setAnchPos(times, 220, 302)
	content:addChild(times)
	
	
	
	local choose 
	choose = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 240, 255,{
		priority = -181,
		text = {{"点击", 24, ccc3(0x2c, 0, 0), ccp(0, 12)},{"选取", 24, ccc3(0x2c, 0, 0), ccp(0, -12)}},
		anchMid = true,
		scale = true,
		callback = function()
			--if data.donateTimes == 0 then
			--	KNMsg.getInstance():flashShow("今天的捐献次数已经用完啦，明天再来吧")
			--	return 
			--end
			--列表
			local list
			list = SelectList:new("equip",nil,display.newSprite(COMMONPATH .. "title/equip_text.png"),{ 
				btn_opt = "ok.png",
				target = true,
				exceptUse = true,
				y = 85 ,
				starRange = 1,
				filter = {star = 2},
				showTitle = true , 
				priority = -200,
				all = true,
				optCallback = function()
					list:destroy()
					self.donate = list:getCurItem():getId()
					choose:setFront(getImageByType(DATA_Bag:get("equip", self.donate, "cid"), "s"))
					choose:setText("",1)
					choose:setText("",2)
				end
				})
			if table.nums(list:getItems()) == 0 then
				KNMsg.getInstance():flashShow("只能捐献3星以下的装备,您当前没有符合条件的装备")
				return 
			end
			display.getRunningScene():addChild(list:getLayer())
		
		end
	})
	content:addChild(choose:getLayer())


	if KNGuide:getStep() == 5009 then
		local btn_range = choose:getRange()
		KNGuide:show( choose:getLayer() , {
			x = btn_range:getMinX() + 240,
			y = btn_range:getMinY() + 475,
			remove = true
		})
	end
	
	showTip({
		priority = -180,
		content = content,
		bg = PATH.."contr_bg.png",
		title_text = PATH.."contr_title.png",
		title_bg = IMG_PATH.."image/scene/mission/title_bg.png",
		offsetY = -40,
		left = {
			callback = function()
				if self.donate then
					HTTP:call("kuafu", "donate", {ids = self.donate}, {
						success_callback = function(data)
							self.donate = nil
								total:setString(data.donateCount)
								times:setString(data.donateTimes)
								choose:setFront()
								choose:setText("点击",1)
								choose:setText("选取",2)
								KNMsg.getInstance():flashShow("捐献成功，捐献物资+"..data.donateCur)
						end
					})
				else
					KNMsg.getInstance():flashShow("请选择一件捐献的装备")
				end
			end
		},
		right = {
			remove = true,
			removeCallback = function()
				self.userLayer:remove()
				self.donate = nil
				HTTP:call("kuafu", "getCorpsInfo", {corps = self.data.me} ,{
					success_callback = function(data)
						HTTP:call("kuafu", "getUserInfo", {corps = self.data.me}, {
							success_callback = function(userInfo)
								self:curArmyInfo(data, userInfo)
							end
						})
				end})
			end
		}
	})
	
end

function M:upRank(data)
	state = UP 
	self.infoLayer:refreshTitle(PATH.."up_rank_title.png")

	if KNGuide:getStep() == 5006 then
		KNGuide:show( self.infoLayer:getBackBtn():getLayer() )
	end
	
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	
	local scroll = KNScrollView:new(0, 140, 480, 600)
	
	for i = 1, #data.list do
		local item = Item:new("rank",i,scroll, data.list[i])
		scroll:addChild(item:getLayer())
	end
	scroll:alignCenter()
	self.layer:addChild(scroll:getLayer())
	
	local times = display.newSprite(PATH.."fight_num.png")
	setAnchPos(times, 10, 100)
	self.layer:addChild(times)
	
	self.layer:addChild(createLabel({str = data.zigeTimes, size = 20, color =ccc3(255, 255,255), x =110, y = 102 }))
	
	local refresh = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 180, 100, {
		front = IMG_PATH.."image/scene/diggings/change.png",
		callback = function()
			HTTP:call("kuafu", "getCorpsUser", {corps = self.data.me, page = 1}, {
				success_callback = function(data)
					self:upRank(data)	
				end
			})
		end
	})
	self.layer:addChild(refresh:getLayer())
	self.baseLayer:addChild(self.layer)
end

function M:getLayer()
	return self.baseLayer
end


function M:turnPage(callback)
	local bg = display.newSprite(COMMONPATH.."page_bg.png")
	setAnchPos(bg,240,110,0.5)
	self.layer:addChild(bg)
	
	local pageNum = display.strokeLabel(self.curPage.."/"..self.maxPage, 0, 0, 20, ccc3(0xff, 0xfb, 0xd4))
	setAnchPos(pageNum, 240, 115, 0.5)
	self.layer:addChild(pageNum)
	
	--翻页按钮
	local pre = KNBtn:new(COMMONPATH,{"next_big.png"}, 150, 100, {
		scale = true,
		flipX = true,
		callback = function()
			if self.curPage > 1 then
				self.curPage = self.curPage - 1
				callback()
			end
		end
	})
	self.layer:addChild(pre:getLayer())
	
	local next = KNBtn:new(COMMONPATH,{"next_big.png"}, 285, 100, {
		scale = true,
		callback = function()
			if self.curPage < self.maxPage then
				self.curPage = self.curPage + 1
				callback()
			end
		end
	})
	self.layer:addChild(next:getLayer())
end
return M