--[[任务]]

local PATH = IMG_PATH.."image/scene/task/"
local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local M = {}
local TYPE
local data
function M:new()
	local this = {}
	setmetatable(this,self)
	self.__index  = self

	this.baseLayer = display.newLayer()
	this.viewLayer = display.newLayer()
	this.baseLayer:addChild(this.viewLayer)
	-- 背景
	local bg = display.newSprite(COMMONPATH .. "dark_bg.png")
	setAnchPos(bg , 0 , 88)						
	this.baseLayer:addChild(bg)
	
	data =  DATA_Task:get()
	
	TYPE = "skill"
	local function tabFun( key )
		TYPE = key
		this:pageFun( )
	end
	local tableLayer = tableList( { y = 690 , listConfig = {  path = COMMONPATH .. "tab/tab_" , ending = "_normal" , config = { "skill"  } } , def = TYPE ,  clickFun = function( key ) tabFun(key) end } )
	this.baseLayer:addChild( tableLayer )
	
	--刷新
	this.baseLayer:addChild( KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png"} , display.cx - 73 , 113 ,
				{
					front = PATH .. "refresh_text.png",
					callback = 
					function()
						local function refreshFun()
							if DATA_Account:get("gold") < tonumber( data.refresh_gold ) then
								KNMsg.getInstance():flashShow( "您的黄金不足,暂不能刷新!" )
								return
							end
							HTTP:call("dailytask","refresh",{ },{success_callback=
								function()
									switchScene("task")
								end
							})
						end
						refreshFun()
--						KNMsg.getInstance():boxShow( "是否确认花费" .. data.refresh_gold .. "黄金进行刷任务？" ,{ 
--								confirmFun = refreshFun , 
--								cancelFun = function() end 
--								} )
					end
				}):getLayer() )
	--帮助
	local str = "◆如何接受任务:\n    ● 点击任务奖励物品会显示该物品详情，点击物品框周围可查看任务详情\n◆任务次数:\n    ● 每日最多可接10次任务\n    ● 接取任务时即扣一次当天可接任务次数\n    ● 放弃任务不会返还任务次数\n◆任务品质:\n    ●任务一共有：普通，优秀，精良，传说四种\n    ●不同品质任务给予不同的技能碎片\n    ●传说品质的任务会被锁定，就算未接取也不会被刷新\n◆刷新任务：\n    ●任务可接次数每日00:00时会进行重置，同时会重置所有未接取状态的任务\n    ●消耗黄金也可以同时刷新所有未接取状态的任务"
	local help = KNBtn:new( IMG_PATH .. "image/scene/power" , {"help.png", "help_press.png"}, 429 , 694, {
		callback = function()
			local temp = display.newLayer()
			
			local mask = KNMask:new({item = temp})			
			
			local bg = display.newSprite(IMG_PATH.."image/scene/mission/bg.png")	
			setAnchPos(bg, 240, 425, 0.5, 0.5)
			temp:addChild(bg)
			
			local scroll = KNScrollView:new(40, 280, 400, 320)
			
			local titleBg = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png") 
			setAnchPos(titleBg, 240, 600, 0.5)
			temp:addChild(titleBg)
			
			local titleText = display.newSprite(IMG_PATH .. "image/scene/power/help_title.png")
			setAnchPos(titleText, 240, 600, 0.5)
			temp:addChild(titleText)
			
--			local helpText = createLabel({str = replaceStr(str), color = ccc3(0, 0, 0), width = 400, height = 0, size = 18, height = 0})
			local helpText = CCLabelTTF:create(replaceStr(str), FONT, 20) 
			helpText:setDimensions(CCSize(400,0))
			helpText:setColor(ccc3(0, 0, 0))
			helpText:setHorizontalAlignment(0)
			
			scroll:addChild(helpText)
			temp:addChild(scroll:getLayer())
			
			local ok = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 160, 230, {
				front = COMMONPATH.."ok.png",
				priority = -132,
				callback = function()
					mask:remove()
				end
			})
			temp:addChild(ok:getLayer())
			
			this.viewLayer:addChild(mask:getLayer())
		end
	})
	this.baseLayer:addChild(help:getLayer())
		
	this.baseLayer:addChild( display.newSprite(COMMONPATH .. "gold.png" , 320 , 122 , 0 , 0 ) )
	this.baseLayer:addChild( display.strokeLabel( data.refresh_gold , 354 , 125 , 20 , ccc3( 0xfd , 0xf1 , 0xb7 ) )  )
	
	this.baseLayer:addChild( display.newSprite( PATH .. "num_tip.png" ,  236 , 703 , 0 , 0 ) )
	this.baseLayer:addChild( display.strokeLabel( data.accept_cur .. "/" .. data.accept_max  , 365 , 704 , 20 , ccc3( 0xfd , 0xf1 , 0xb7 ) )  )
	
	
	this.infoLayer = InfoLayer:new( "task" , 0 , {tail_hide = true , title_text = PATH .. "task_title.png"})
	this.baseLayer:addChild(this.infoLayer:getLayer() , 1)
	
	
	
	this:pageFun( TYPE )
	
	return this.baseLayer
end
function M:pageFun(  )
	delObj( self.viewLayer )
	self.viewLayer = display.newLayer()
	self.baseLayer:addChild(self.viewLayer)
	local curData = data["list"][TYPE] or {}
	for i = 1 , table.nums( curData ) do
		local tempCell = self:taskCell( curData[i] , { key = TYPE , index = i} )
		setAnchPos( tempCell , 37 + ( ( i - 1 )%2 ) * 213 , 417 - math.floor( ( i - 1 ) / 2 ) * 260 )
		self.viewLayer:addChild( tempCell )
	end
end
--单个任务
function M:taskCell( tempData , params )
---         4 = {
---             "award" = {
---                 1 = {
---                     "cid" = "16018"
---                     "num" = "1"
---                 }
---             }
---             "cur"     = 0
---             "desc"    = "合成1次幻兽"
---             "id"      = 4
---             "max"     = 1
---             "quality" = 2				品质     quality 1普通   2优秀  3精品  4传说
---             "stat"    = 0				任务状态  stat  0 未接,1未完成,2已完成
---             "subtype" = "animal_fuse"
---             "type"    = "fuse"
---         }
	
	params = params or {}
	
	local layer = display.newLayer()
	local isChenge = false
	local color = tempData.quality
	if color == 4 then
		layer:addChild( display.newSprite( PATH .. "lock.png" , 69 , 18 , 0 , 0 ) )
	end
	local function backFun()
		if isChenge then
			switchScene("task")
		end
	end
	layer:addChild( KNBtn:new( PATH , {  "card" .. color ..  ".png" } , 0 , 0 ,
			{
				scale = true ,
				callback = 
				function()
					local tempLayer = baseMask( {  titlePath = PATH .. "detail_title.png" , bgInfo = { path = IMG_PATH .. "image/scene/mission/wipe_bg.png" , x = 30 , y = 260 } , isShowBack = { x = 37 ,  y = 548 , backFun = backFun } } )	
					tempLayer:addChild( display.newSprite( PATH .. "task_content.png" , 75 , 527 , 0 , 0 ) )
					tempLayer:addChild( display.strokeLabel( tempData.desc .."(" .. tempData.cur .. "/" .. tempData.max .. ")"  , 105 , 460 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , { dimensions_width = 325 , dimensions_height = 60 , align = 0 } ) )
					tempLayer:addChild( display.newSprite( PATH .. "task_award.png" , 75 , 426 , 0 , 0 ) )
					local awardBtn = awardCell( tempData.award[1] ) 
					setAnchPos( awardBtn , 215 , 360 , 0 , 0 )
					tempLayer:addChild(awardBtn )
					local tempCoust = DATA_Task:get("ok_config")[ tempData.quality .. "" ]
					tempLayer:addChild( display.newSprite(COMMONPATH .. "gold.png" , 111 , 344 , 0 , 0 ) )
					tempLayer:addChild( display.strokeLabel( tempCoust , 144 , 346 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) )  )
					--一键完成
					local oneKeyBtn , acceptBtn , quitBtn = nil , nil , nil
					local function refreshBtn()
						delObj( oneKeyBtn )
						delObj( acceptBtn )
						delObj( quitBtn )
						oneKeyBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png" , "btn_bg_red2.png" } , 66 , 294 ,
												{
													front = PATH .. (tempData.stat ~= 1 and "one_key_dis.png" or "one_key.png") ,
													priority = -131 ,
													callback = 
													function()
														
														local function oneKeyFun()
															if DATA_Account:get("gold") < tonumber( tempCoust ) then
																KNMsg.getInstance():flashShow( "您的黄金不足,暂不一键完成!" )
																return
															end
															HTTP:call("dailytask","ok_finish",{ index = tempData.id },{success_callback=
																function( _data )
																	showAwards( { data = _data , backFun = function() switchScene("task") end } )
																end})
														end
														KNMsg.getInstance():boxShow( "是否确认花费".. tempCoust .. "黄金一键完成此任务" ,{ 
																		confirmFun = oneKeyFun , 
																		cancelFun = function() end 
																		} )
													end
												})
						oneKeyBtn:setEnable( tempData.stat == 1 )
						tempLayer:addChild( oneKeyBtn:getLayer() )
						--接受
						local function getFront()
							local frontPath
							if tempData.stat == 2 then
								frontPath = COMMONPATH .. "get.png"
							elseif tempData.stat == 1 then
								frontPath = IMG_PATH .. "image/scene/forge/go_text.png"
							elseif tempData.stat == 0 then
								frontPath = COMMONPATH .. "jieShouLab.png"
							end
							return frontPath
						end
	
						acceptBtn = KNBtn:new( COMMONPATH , { "btn_bg_red.png" ,"btn_bg_red_pre.png" , "btn_bg_red2.png" } , 266 , 294 ,
												{
													front =  getFront() ,
													priority = -131 ,
													callback = 
													function()
														
														if tempData.stat == 2 then	--领取
															HTTP:call("dailytask","finish",{ index = tempData.id },{success_callback=
																	function( _data )
																		showAwards( { data = _data , backFun = function() switchScene("task") end } )
																	end
																})
														elseif tempData.stat == 1 then	--前往
															gotoScene( tempData.subtype )
														elseif tempData.stat == 0 then	--接受
															HTTP:call("dailytask","accept",{ index = tempData.id },{success_callback=
																	function( _tempData )
																		isChenge = true
																		tempData = _tempData["list"][ params.key][params.index ]
--																		acceptBtn:setFront( getFront() )
																		refreshBtn()
																	end
																})
														end
													end
												})
						tempLayer:addChild( acceptBtn:getLayer() )
						--放弃
						quitBtn =  KNBtn:new( COMMONPATH , { "btn_bg.png" ,"btn_bg_pre.png" , "btn_bg_dis.png" } , 362 , 555 ,
												{
													front = PATH .. ( tempData.stat ~= 1 and "quit_dis.png" or "quit.png" ) ,
													priority = -131 ,
													callback = 
													function()
														local function confirmFun()
															HTTP:call("dailytask","giveup",{ index = tempData.id },{success_callback=
																	function()
																		switchScene("task")
																	end
																})
														end
														KNMsg.getInstance():boxShow( "确认要放弃当前已接受任务吗,放弃将不返还当天可接任务次数！" ,{ 
																				confirmFun = confirmFun , 
																				cancelFun = function() end 
																				} )
													end
												})
						quitBtn:setEnable( tempData.stat == 1 )
						tempLayer:addChild(quitBtn:getLayer() )
					end
					refreshBtn()
				end
			}):getLayer())
	
	--任务类型
	layer:addChild( display.strokeLabel( tempData.type , 53, 186 , 20 , ccc3( 0xfd , 0xf1 , 0xb7 ) , nil , nil , { dimensions_width = 83 , dimensions_height = 25 , align = 1 } ) )
	--奖励
	local awardBtn = awardCell( tempData.award[1] ) 
	setAnchPos( awardBtn , 62 , 91 , 0 , 0 )
	layer:addChild(awardBtn )
	
	if tempData.stat == 0 and tempData.quality == 4 then
		layer:addChild( display.newSprite( PATH .. "lock.png" , 69 , 18 , 0 , 0 ) )
	elseif tempData.stat == 1 then
		layer:addChild( display.newSprite( PATH .. "no_complete.png", 33 , 58 , 0 , 0 )  )
	elseif tempData.stat == 2 then
		layer:addChild( display.newSprite( PATH .. "complete.png", 33 , 58 , 0 , 0 )  )
	end
	
	layer:setContentSize( CCSizeMake( 195 , 245 ) )
	return layer
end


return M
