local PATH = IMG_PATH.."image/scene/theworld/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local Config_General = requires(IMG_PATH,"GameLuaScript/Config/Hero")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup") 
local KNShowbylist = requires(IMG_PATH , "GameLuaScript/Common/KNShowbylist")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

local TheWorld= {
	layer,
	viewLayer,
	click,
	step,
	open_id
}
function TheWorld:new(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.open_id = params.open_id
	this.step = params.step or 1
	
	this.layer = display.newLayer()
	
	this:next()
	
	this.layer:setTouchEnabled(true)
	this.layer:registerScriptTouchHandler(function()
		if this.click then
			if this.step == 6 then
				switchScene("newguy", {open_id = this.open_id})
			else
				this:next()
			end
		end
	end, false, 0, false)

	return this.layer
end

function TheWorld:next()
	self.click = false

	if self.viewLayer ~= nil then
		self.layer:removeChild(self.viewLayer , true)
	end

	print("open_id: " .. self.open_id)

	self.viewLayer = display.newLayer()
	
	local bg = display.newSprite(PATH.."step_"..self.step..".jpg")
	setAnchPos(bg)
	self.viewLayer:addChild(bg)
	
	local desc = display.newSprite(PATH.."step_"..self.step.."_desc.png")
	setAnchPos(desc, 240, 40, 0.5)
	self.viewLayer:addChild(desc)
	
--	desc:setOpacity(0)
	
	desc:runAction(getSequenceAction(CCFadeIn:create(1.5), CCCallFunc:create(function()
		if self.step == 1 then
			self.click = true
			local go = createLabel({str = "点击继续", size = 30, width = 200, color = ccc3(255, 255, 255) })
			setAnchPos(go, 350, 30)
			self.viewLayer:addChild(go)
			
		elseif self.step == 2 then
			local title = display.newSprite(PATH.."title.png")
			setAnchPos(title, 240, 860, 0.5)
			self.viewLayer:addChild(title)
			
			title:runAction(getSequenceAction(CCEaseBounceOut:create(CCMoveTo:create(0.8, ccp(240, 500))), CCCallFunc:create(function()
				self.click = true
				
				local go = createLabel({str = "点击继续", size = 30, width = 200, color = ccc3(255, 255, 255) })
				setAnchPos(go, 350, 30)
				self.viewLayer:addChild(go)
			end)))
		elseif self.step == 3 then
			self.click = true
			local go = createLabel({str = "点击继续", size = 30, width = 200, color = ccc3(255, 255, 255) })
			setAnchPos(go, 350, 30)
			self.viewLayer:addChild(go)
		elseif self.step == 4 then
--			self.click = true
			local pos = {
				['tmsj'] = {180, 420},
				['xmws'] = {220, 220},
				['td'] = {370, 330},
				['tgxy'] = {350, 530},
				['lock2'] = {200, 630},
			}
			
			local names = {}
			
			for k, v in pairs(pos) do
				local game_name = CHANNEL_GROUP
				if CHANNEL_GROUP == "tgxy2" then game_name = "tgxy" end
				
				names[k] = display.newSprite(PATH..(string.find(k, "lock") and "lock" or (game_name == k and k or k.."_grey"))..".png")
				names[k]:setVisible(false)
				setAnchPos(names[k], v[1], v[2], 0.5)
				self.viewLayer:addChild(names[k])
			end
			
			local array = {'tmsj', 'xmws', 'td', 'tgxy', 'lock2'}
			local cur = 1
			
			local function nameShow(index)
				if cur > #array then
					self.click = true
					local go = createLabel({str = "点击继续", size = 30, width = 200, color = ccc3(255, 255, 255) })
					setAnchPos(go, 350, 30)
					self.viewLayer:addChild(go)
				else
					if string.find(index, 'lock') then
						names[index]:setVisible(true)
						cur = cur + 1
						nameShow(array[cur])
					else
						names[index]:setVisible(true)
						names[index]:setScale(5)
						setAnchPos(names[index], 240, 325, 0.5)
						
						names[index]:runAction(getSequenceAction(getSpawnAction(CCEaseExponentialOut:create(CCMoveTo:create(0.8, ccp(pos[index][1], pos[index][2]))), CCEaseExponentialOut:create(CCScaleTo:create(0.8,1))), CCCallFunc:create(function()
								cur = cur + 1
								nameShow(array[cur])
						end)))
					end
				end
			end
			
			nameShow(array[cur])
			
		elseif self.step == 5 then
			local desc
			if CHANNEL_GROUP == "tmsj" then
				desc = "唐三，神界执法者，善良、邪恶两大神王离去后，神界的最高统治者、神界之主。掌控世间一切，乃众神之神，拥有手握日月摘星辰之力。"
			elseif CHANNEL_GROUP == "td" then
				desc = "窃阴阳，夺造化，转涅盘，握生死，掌轮回.武之极，破苍穹，动乾坤，来到绝世天府便是一家人！让我们为了天府荣耀，一起奋战吧！ "
			elseif CHANNEL_GROUP == "tgxy" or CHANNEL_GROUP == "tgxy2" then
				desc = "群雄并起，万族林立，诸圣争霸，乱天动地,弹指间天翻地覆。问苍茫大地，谁主沉浮？！ 唯我仙域，为了仙域荣耀，一起奋战吧！ " 
			end
			local intro = createLabel({str = desc, width = 138, size = 20, color = ccc3(255, 255, 255)})
			setAnchPos(intro, 350, 425)
			intro:runAction(getSequenceAction(CCProgressTo:create(1, 100), CCCallFunc:create(function()
				self.click = true
				local go = createLabel({str = "点击继续", size = 30, width = 200, color = ccc3(255, 255, 255) })
				setAnchPos(go, 350, 180)
				self.viewLayer:addChild(go)
			end)))
			self.viewLayer:addChild(intro)
		end
		
		self.step = self.step + 1
	end)))
	
	if self.step == 1 then
		local cloud = display.newSprite(PATH.."cloud.png")
		setAnchPos(cloud, 0, 700)
		self.viewLayer:addChild(cloud)
		
		local function move(node)
			node:runAction(getSequenceAction(CCMoveTo:create(60, ccp(480, 700)), CCCallFunc:create(function()
				node:setPositionX(-cloud:getContentSize().width)
				move(node)
			end)))
		end
		
		move(cloud)
		
	elseif self.step == 5 then
		local writer = display.newSprite(PATH.."writer.png")
		setAnchPos(writer, 20, 200)
		self.viewLayer:addChild(writer)
		
		local writerName = display.newSprite(PATH.."writer_name.png")
		setAnchPos(writerName, 40, 220)
		self.viewLayer:addChild(writerName)
		
		local writerSay = display.newSprite(PATH.."writer_say.png")
		setAnchPos(writerSay, 340, 720)
		self.viewLayer:addChild(writerSay)
	end
	
	self.layer:addChild(self.viewLayer)
end

return TheWorld
