local PATH = IMG_PATH.."image/scene/forge/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local GOLDEQUIPPATH = IMG_PATH .. "image/scene/goldequip/"
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")--require "GameLuaScript/Common/KNBtn"
local KNComboBox = requires(IMG_PATH,"GameLuaScript/Common/KNComboBox")--require "GameLuaScript/Common/KNBtn"
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local Progress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local ListItem = requires(IMG_PATH, "GameLuaScript/Scene/common/listitem")
local KNCardpopup = requires(IMG_PATH,"GameLuaScript/Common/KNCardpopup")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local M = {
	layer,
	contentLayer,
	params,
	curType,
	curStar,
	curItem,
	tempLayer,
	empty,
	scroll
}

function M:new(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self

	this.layer = display.newLayer()
	this.params = params or {}
	this.curItem = {}
		
--	local title = display.newSprite(COMMONPATH.."title_bg.png")
--	setAnchPos(title, 0, 854 - title:getContentSize().height)
--	this.layer:addChild(title) 
--	
--	title = display.newSprite(COMMONPATH.."title_tail.png")
--	setAnchPos(title, 0, 854 - title:getContentSize().height * 2)
--	this.layer:addChild(title) 
--	
	local title = display.newSprite(COMMONPATH.."dark_bg.png")
	setAnchPos(title, 240, 425, 0.5, 0.5)
	this.layer:addChild(title, -1)
--		
--	title = display.newSprite(PATH.."pool_text.png")
--	setAnchPos(title, 245, 765, 0.5)
--	this.layer:addChild(title)
--
--	title = display.newSprite(COMMONPATH.."tab_line.png")
--	setAnchPos(title, 240, 690, 0.5)
--	this.layer:addChild(title)


   this:createContent("general")

	local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
	local infoLayer = InfoLayer:new("list" , 0, {title_text = PATH.."tobeGod_title.png", tail_hide = true, priority = -202, closeCallback = function()
		switchScene("hero",{gid = params.gid})
	end})

	this.layer:addChild( infoLayer:getLayer() )

	return this
end

function M:createContent(kind)
	if self.contentLayer then
		self.layer:removeChild(self.contentLayer, true)	
	end
	self.contentLayer = display.newLayer()
	self.curType = kind
	
	local bg = display.newSprite(PATH.."pool_tool.png")
	setAnchPos(bg, 240, 200, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."god_tip.png")
	setAnchPos(bg, 240, 580, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."add.png")
	setAnchPos(bg, 240, 490, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."arrow.png")
	setAnchPos(bg, 240, 370, 0.5)
	self.contentLayer:addChild(bg)
	
	bg = display.newSprite(PATH.."use.png")
	setAnchPos(bg, 310, 381)
	self.contentLayer:addChild(bg)
	
	
	bg = display.newSprite(SCENECOMMON.."cbox.png")
	setAnchPos(bg, 240, 645, 0.5)
	self.contentLayer:addChild(bg)
	

	local checkChipNums = function(cidOfMap)
		local cid = cidOfMap
		local require_chip = hcskill[ tonumber(cid) .."" ].chip
		local require_num = hcskill[ tonumber(cid) ..""].num
		
		local chip_items = DATA_Bag:getTable( "prop", { cid = tostring( require_chip ) } )

		--检查技能碎片数量
		local chip_nums = 0
		self.curItem[2] = nil
		for k, v in pairs(chip_items) do
			chip_nums = chip_nums + v.num
			if self.curItem[2] == nil then
				self.curItem[2] = v.id
			end
		end
		
		if chip_nums < require_num then
			self.curItem[2] = nil
		end

		self.curItem["chip_num_owned"] = chip_nums
		self.curItem["chip_num_required"] = require_num
	end

	local popTips = function()
		local str
		if kind == "general" or kind == "pet" then
			if self.curStar == 3 then
				str = "初级符文丹不足，可以通过挑战9-7关卡获得。"
			elseif self.curStar == 4 then
				str = "中级符文丹不足，可以通过挑战10-5关卡获得。"
			else
				str = "高级符文丹不足，可以通过挑战10-14关卡获得。"
			end
		elseif kind == "skill" then
			str = "技能碎片不足, 可前去完成任务获得技能碎片"
		end

		KNMsg.getInstance():flashShow(replaceStr(str))
	end
	
	local itemsLayer 
	local iconGroup = KNRadioGroup:new()	--icon单选
	local iconScroll = KNScrollView:new( 40 , 650 , 400 , 100 , 10 , true , 0  )
	
	local function chooseItems()	
		if itemsLayer then
			self.contentLayer:removeChild(itemsLayer, true)
		end
		itemsLayer = display.newLayer()
		local pos = {
			{91, 465, {replaceStr( kind == "general" and "英雄" or ( kind == "pet" and "幻兽" or "技能\n图纸" ) ), 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "general"},
			{322, 465, {kind == "skill" and "技能\n碎片" or "道具", 20, ccc3(0x2c, 0, 0), ccp(0,0)}, "prop"},
			{210, 255, {""}, "general"}
		}	
		local front, text
		for i = 1, #pos do
			if self.curItem[i] then  --已选择了元素
				local category = pos[i][4]
				front = getImageByType(i == 2 and self.curItem[i] or DATA_Bag:get(category, self.curItem[i], "cid"), "s")		
				text = {(i == 3 and replaceStr("天神·") or "")..getConfig(category, i == 2 and self.curItem[i].."" or DATA_Bag:get(category, self.curItem[i].."", "cid"), "name"), 16, ccc3(255,255,255), ccp(0, -70)}
				
				if i == 2 then
					itemsLayer:addChild(createLabel({x = 360, y = 382, str = DATA_Bag:countItems("prop",false,{type = "godstone"}).."/"..self.params.config[getConfig("general",DATA_Bag:get("general", self.curItem[1].."","cid"),"type")..""], color = ccc3(255,255,255)}))
				end
			else
				text = pos[i][3]
				front = nil
			end

			local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, pos[i][1], pos[i][2], {
				front = front,
				text = text,
				callback = function()
					
				end
			})
			itemsLayer:addChild(btn:getLayer())
			
			if self.curItem[i] then
				local star
				local category = pos[i][4]
				local starNum = getConfig(category,i == 2 and self.curItem[i] or  DATA_Bag:get(category, self.curItem[i], "cid"), "star") 
				for j = 1, starNum do
					star = display.newSprite(COMMONPATH .. "star.png")
					star:setScale(0.8)
					setAnchPos(star, star:getContentSize().width * 0.8 * (j - 1) + (pos[i][1] + btn:getWidth() / 2) - (star:getContentSize().width * 0.8 * starNum) / 2, pos[i][2] - star:getContentSize().height - 3 )
					itemsLayer:addChild(star)
				end
			end
		end
		self.contentLayer:addChild(itemsLayer)
	end
	

	
	for i = 1 , DATA_Formation:get_lenght() do
		local id = DATA_Formation:get_index(i)["gid"]..""
		dump(DATA_Formation:get_index(i))
		if getConfig("general", DATA_Bag:get("general", id, "cid"),"star") > 4 and DATA_Bag:get("general", id, "lv") >= 120 and  DATA_Bag:get("general",id,"god") == 0  then
			local heroBtn = KNBtn:new( SCENECOMMON , {"skill_frame1.png", "select1.png"} , 0 , 0 ,
					{
						id = id ,
						upSelect = true ,
						selectZOrder = 12,
						parent = iconScroll,
						front =  getImageByType( DATA_Formation:get_index(i)["cid"], "s" ) ,
						noHide = true,
						parent = iconScroll,
						callback = function()
							self.curItem[1] = DATA_Formation:get_index(i)["gid"]
							self.curItem[2] = "17138"
							self.curItem[3] = DATA_Formation:get_index(i)["gid"]
							chooseItems()
						end 
			},iconGroup)
			iconScroll:addChild(heroBtn:getLayer(),heroBtn)
		end
	end
	self.contentLayer:addChild(iconScroll:getLayer())
	
	if self.params.gid then
		iconGroup:chooseById(self.params.gid.."",true)
		iconScroll:scrollTo(self.params.gid.."")
	else
		iconGroup:chooseByIndex(1,true)
	end
	
	
--	local auto = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 65, 365, {
--	0vj
--		front = PATH.."auto_add.png" ,
--		callback = function()
--			if kind == "general" or kind == "pet" then
--					local items = DATA_Bag:getTable(self.curType, {star = self.curStar}, nil, true)
--					local keyList = getSortList(items, function(l,r)
--						return DATA_Bag:get(kind, l, "lv") < DATA_Bag:get(kind, r, "lv")
--					end)
--					if table.nums(items) > 0 then
--						--取一个英雄 数据，后面要调 
--						for k, v in pairs(keyList) do
--							self.curItem[1] = v
--							break
--						end
--						
--						--检查符文丹数量
--						for k, v in pairs(DATA_Bag:getTable("prop", {type = "fuwendan", star = self.curStar})) do
--							self.curItem[2] = k
--						end
--									
--						if tonumber(DATA_Bag:get("prop", self.curItem[2], "num")) < needConfig[self.curType][self.curStar]['num'] then
--		--					KNMsg.getInstance():flashShow("所需要的符文丹不足，无法融合")
--		--					self.curItem = {}
--		--					return 
--							self.curItem[2] = nil
--						end
--						self.curItem[3] = nil
--						chooseItems()
--					else
--						KNMsg.getInstance():flashShow("没有能炼化的材料卡牌")				
--					end
--			elseif kind == "skill" then
--				local map_items = DATA_Bag:getTable("prop", {type = "skillmap", star = self.curStar}, nil, true)
--				if table.nums(map_items) > 0 then
--					--取一个技能图纸数据，稍后使用
--					local first_map
--					for k, v in pairs(map_items) do
--						first_map = v
--						break
--					end
--
--					self.curItem[1] = first_map.id
--
--					checkChipNums(first_map.cid)
--
--					self.curItem[3] = nil
--					chooseItems()
--				else
--					KNMsg.getInstance():flashShow("没有能炼化的技能图纸")				
--				end
--			end
--		end
--	})
--	self.contentLayer:addChild(auto:getLayer())
	
	--拥有限时封神石

	local limitStoneSp = display.newSprite(IMG_PATH.."image/scene/hero/limit_god_stone.png")
	setAnchPos(limitStoneSp,130,170)
	self.contentLayer:addChild(limitStoneSp)
	
	local limitStoneNum = display.strokeLabel( DATA_Bag:countItems("prop", false,{type = "timelimitgodstone"} ) , 320 , 173 , 20, ccc3( 255 , 255 , 255 )  ) 
	self.contentLayer:addChild(limitStoneNum)

	local startBtn = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 170, 120, {
		front = COMMONPATH .. "hecheng_small.png",
		callback = function()
				if DATA_Bag:countItems("prop", false,{type = "timelimitgodstone"} ) >0 then

					KNMsg.getInstance():boxShow("您拥有限时封神石，将优先消耗，不足时用封神石代替，是否升级?", {cancelFun = function()end, confirmFun = function()
							HTTP:call("general","upgradeToGod",{gid = self.curItem[1]},{
								success_callback = function(result)
									if self.curItem[1] then
										switchScene("tobeGod",{config = self.params.config},function()
											KNMsg.getInstance():flashShow(result.msg)
										end)
									else
										KNMsg.getInstance():flashShow("没有满足条件的英雄")
									end
								end
							})
					end})
				else
					HTTP:call("general","upgradeToGod",{gid = self.curItem[1]},{
								success_callback = function(result)
									if self.curItem[1] then
										switchScene("tobeGod",{config = self.params.config},function()
											KNMsg.getInstance():flashShow(result.msg)
										end)
									else
										KNMsg.getInstance():flashShow("没有满足条件的英雄")
									end
								end
							})

				end
		end
	})
	self.contentLayer:addChild(startBtn:getLayer())


	-- 新手引导
	if KNGuide:getStep() == 3403 then
		KNGuide:show( auto:getLayer() , {
			callback = function()
				KNGuide:show( startBtn:getLayer() , {remove = true})
			end
		})
	end
	
	
	
	self.layer:addChild(self.contentLayer)
end

function M:getItems(kind, star)
		 
	local general = DATA_Bag:get(kind) or {}
	local result = {}
	--筛选满足条件的卡牌，给定星级，且未上阵
	for k, v in pairs(general) do
		if kind == "pet" then
			if getConfig(kind, DATA_Bag:get(kind , k, "cid"), "star") ==  star and 
				DATA_Pet:getFighting() ~= tonumber(k) then
					result[k] = v
			end	
		else	
			local on
			if kind == "equip" then
				-- on = DATA_ROLE_SKILL_EQUIP:getRoleId(tonumber(k),kind)
			else
				on = DATA_Formation:checkIsExist(tonumber(k))
			end
			if getConfig(kind, DATA_Bag:get(kind , k, "cid"), "star") ==  star and 
				not on then 
					result[k] = v
			end
		end
	end
	return result
end

function M:getComposeConfigWithCid(cid)
		for key , value in pairs(getConfig("equipGoldCompose")) do
			if tonumber(value["basics"]) == tonumber(cid) then
				return key , value["basics"] , value["drawing"]
			end
		end
end

function M:getLayer()
	return self.layer end

return M
