local PATH = IMG_PATH.."image/scene/tobeGodNew/"
local GODCELLPATH = IMG_PATH.."image/scene/godCell/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local effect = requires(IMG_PATH,"GameLuaScript/Common/KNEffect")
local KNBtn = requires(IMG_PATH,"GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")
local json = requires(IMG_PATH , "GameLuaScript/Network/dkjson")
local M = class("godVeinLayer", function() return display.newLayer() end)
M.__index = M

function M:ctor(params)
	--背景、标题
	display.newSprite(PATH.."bg.jpg"):center():addTo(self)
	local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
	local infoLayer = InfoLayer:new("list" , 0, {title_text = PATH.."title-shenmai.png", tail_hide = true, priority = -202, closeCallback = function()
		switchScene("hero",{gid = params.gid})
	end})
	self:add(infoLayer:getLayer())

	--选择人物
	display.newSprite(SCENECOMMON.."cbox.png", display.cx, 700):addTo(self)
	local iconGroup = KNRadioGroup:new()	--icon单选
	local iconScroll = KNScrollView:new( 40 , 665 , 400 , 100 , 10 , true , 0)
	self:add(iconScroll:getLayer())

	for i = 1 , DATA_Formation:get_lenght() do
		local id = DATA_Formation:get_index(i)["gid"]..""
		local hero_data = DATA_Bag:get("general", id)
		local hero_img_path = IMG_PATH .. "image/hero/"
		if HAS_GOD_GENERAL and hero_data["god"] == 1 then
			hero_img_path = IMG_PATH .. "image/hero/shen/"			-- 天神
		end

		local front_img = hero_img_path .. getImageByType(hero_data.cid , "s" , true)

		if getConfig("general", DATA_Bag:get("general", id, "cid"),"star") > 4 and DATA_Bag:get("general", id, "lv") >= 120 and  DATA_Bag:get("general",id,"god") == 1  then
			local heroBtn = KNBtn:new( SCENECOMMON , {"skill_frame1.png", "select1.png"} , 0 , 0 ,
			{
				id = id ,
				upSelect = true ,
				selectZOrder = 12,
				parent = iconScroll,
				front =  front_img ,
				noHide = true,
				callback = function()
					if params.gid .."" ~= id then
						HTTP:call("general", "getUpgradeGodAttributeConfig", {gid = id}, {
							success_callback = function(result)
								switchScene("tobeGodNew", {result=result,gid=id})
							end
						})
					end
				end 
			},iconGroup)
			iconScroll:addChild(heroBtn:getLayer(),heroBtn)
		end
	end

	if params.gid then
		iconGroup:chooseById(params.gid.."",true)
		iconScroll:scrollTo(params.gid.."")
	else
		iconGroup:chooseByIndex(1,true)
	end

	local updateUI 		--更新ui方法
	local showGoder 	--显示神君
	local showOpen 		--显示开启神脉
	
	showGoder = function()
		local function showShenjun(result, lv)
			dump(result)
			local layer = display.newLayer()
			local mask = KNMask:new({item=layer})
			self:add(mask:getLayer())

			display.newSprite(COMMONPATH.."tip_bg.png"):addTo(layer):center():scaley(2.3)
			display.newSprite(COMMONPATH .. "change_title_bg.png"):addTo(layer):pos(display.cx, display.cy+296)
			display.newSprite(PATH .."upt/title1.png"):addTo(layer):pos(display.cx, display.cy+304)
			display.newSprite(PATH .."upt/bg1.png"):addTo(layer):pos(display.cx, display.cy+40)
			display.newSprite(PATH .."text3.png"):addTo(layer):pos(110, 232)
			display.newSprite(PATH .."upt/shendan.png"):addTo(layer):pos(317, 232)
 			display.strokeLabel(result.cailiao.own_stone .."/" ..result.cailiao.cost_stone, 180, 218, 20, ccc3(0, 0, 0)):addTo(layer)
 			display.strokeLabel(result.cailiao.own_ball .."/" ..result.cailiao.cost_ball, 377, 218, 20, ccc3(0, 0, 0)):addTo(layer)

 			local scroll = KNScrollView:new(72, 280, 340, 380)
 			layer:add(scroll:getLayer())

 			local function addLine(height)
 				local node = display.newNode():size(340, height)
 				scroll:addChild(node)
 				return node
 			end

 			local function getMsg(data)
 				if (0 == data.open) or (1 == data.open and 1 == data.on) then
 					return data.msg
 				end
 				return data.msg .."(未激活)"
 			end

 			local function getColor(data)
 				return (1 == data.on and 1 == data.open) and ccc3(255, 0, 0) or ccc3(190, 190, 190)
 			end

 			addLine(42):add(display.newSprite(PATH .."upt/shenjun" ..lv ..".png", 25, 5):anchor(0, 0))
 						:add(display.strokeLabel(result.attribute_add, 130, 8, 20, ccc3(248, 245, 204)))
 			addLine(36):add(display.newSprite(PATH .."upt/suitAwake.png", 30, 5):anchor(0, 0))
 						:add(display.newSprite(PATH .."upt/goldAwake.png", 200, 5):anchor(0, 0))
 			addLine(42):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["2"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["2"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["2"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["2"])))
 			addLine(36):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["3"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["3"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["3"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["3"])))
 			addLine(42):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["4"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["4"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["4"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["4"])))
 	 		addLine(36):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["5"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["5"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["5"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["5"])))
 			addLine(38):add(display.strokeLabel("（需穿戴相应职业且对应属性的部件）", 10, 6, 18, ccc3(0, 0, 0)))
 			addLine(38):add(display.newSprite(PATH .."upt/nextlv.png", 25, 5):anchor(0, 0))
 						:add(display.strokeLabel(result.next_attribute_add, 130, 8, 20, ccc3(248, 245, 204)))
 			addLine(42):add(display.newSprite(PATH .."upt/suitAwake.png", 30, 5):anchor(0, 0))
 						:add(display.newSprite(PATH .."upt/goldAwake.png", 200, 5):anchor(0, 0))
 			addLine(42):add(display.strokeLabel(result.next_glod_tao_attribute.tao.detail, 30, 8, 18, ccc3(255, 0, 0)))
 						:add(display.strokeLabel(result.next_glod_tao_attribute.gold.detail, 204, 8, 18, ccc3(255, 0, 0)))
 			addLine(24)

			local close = KNBtn:new(COMMONPATH , {"back_img.png", "back_img_press.png"} , 40, 670, {
				priority = -256,
				callback = function()
					mask:remove()
				end 
			})
			layer:add(close:getLayer())

			local cancel = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , display.cx+90, 180, {
				front = COMMONPATH.."cancel.png",
				anchMid = true,
				priority = -256,
				callback = function()
					mask:remove()
				end 
			})
			layer:add(cancel:getLayer())

			local up = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , display.cx-90, 180, {
				front = COMMONPATH.."up_small.png",
				anchMid = true,
				priority = -256,
				callback = function()
					local up2 = function() 
						HTTP:call("general", "upgradeGodFrameAttribute", {gid = params.gid}, {
									success_callback = function(result)
										mask:remove()
										KNMsg.getInstance():flashShow(result.msg)
										updateUI()
									end
								})
					end
					if DATA_Bag:countItems("prop", false,{type = "timelimitgodstone"} ) > 0 then
						KNMsg.getInstance():boxShow("您拥有限时封神石，将优先消耗，不足时用封神石代替，是否升级?", {cancelFun = function()end, confirmFun = function()
							up2()
						end})
					else
						up2()
					end
				end 
			})
			layer:add(up:getLayer())
		end

		local function showShenhuang(result)
			local layer = display.newLayer()
			local mask = KNMask:new({item=layer})
			self:add(mask:getLayer())

			display.newSprite(COMMONPATH.."tip_bg.png"):addTo(layer):center():scaley(1.5)
			display.newSprite(COMMONPATH .. "change_title_bg.png"):addTo(layer):pos(display.cx, display.cy+190)
			display.newSprite(PATH .."upt/title2.png"):addTo(layer):pos(display.cx, display.cy+198)
			display.newSprite(PATH .."upt/bg2.png"):addTo(layer):pos(display.cx, display.cy+5)
			display.newSprite(PATH .."upt/text.png"):addTo(layer):pos(display.cx, display.cy-155)

			local scroll = KNScrollView:new(72, 315, 340, 230)
 			layer:add(scroll:getLayer())

 			local function addLine(height)
 				local node = display.newNode():size(340, height)
 				scroll:addChild(node)
 				return node
 			end

 			local function getMsg(data)
 				if (0 == data.open) or (1 == data.open and 1 == data.on) then
 					return data.msg
 				end
 				return data.msg .."(未激活)"
 			end

 			local function getColor(data)
 				return (1 == data.on and 1 == data.open) and ccc3(255, 0, 0) or ccc3(150, 150, 150)
 			end

 			addLine(42):add(display.newSprite(PATH .."upt/cur.png", 25, 5):anchor(0, 0))
 						:add(display.strokeLabel(result.attribute_add, 130, 8, 20, ccc3(248, 245, 204)))
 			addLine(36):add(display.newSprite(PATH .."upt/suitAwake.png", 30, 5):anchor(0, 0))
 						:add(display.newSprite(PATH .."upt/goldAwake.png", 200, 5):anchor(0, 0))
 			addLine(42):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["2"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["2"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["2"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["2"])))
 			addLine(36):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["3"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["3"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["3"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["3"])))
 			addLine(42):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["4"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["4"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["4"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["4"])))
 	 		addLine(36):add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.tao["5"]), 10, 8, 18, getColor(result.cur_glod_tao_attribute.tao["5"])))
 						:add(display.strokeLabel(getMsg(result.cur_glod_tao_attribute.gold["5"]), 184, 8, 18, getColor(result.cur_glod_tao_attribute.gold["5"])))
 			addLine(38):add(display.strokeLabel("（需穿戴相应职业且对应属性的部件）", 10, 6, 18, ccc3(0, 0, 0)))

			local close = KNBtn:new(COMMONPATH , {"back_img.png", "back_img_press.png"} , 40, 560, {
				priority = -256,
				callback = function()
					mask:remove()
				end 
			})
			layer:add(close:getLayer())
		end

		HTTP:call("general", "getGodFrameStatus", {gid = params.gid}, {
			success_callback = function(result)
				if result.god_frame_lv and result.god_frame_lv >= 5 then
					showShenhuang(result)
				else
					showShenjun(result, result.god_frame_lv or 0)
				end
			end
		})

	end

	showOpen = function(isAtk)
		local layer = display.newLayer()
		local tip = showTip({
			bg = COMMONPATH.."tip_bg2.png",
			title_text = PATH.."title-kaiqishenmai.png",
			title_bg = COMMONPATH .. "change_title_bg.png",
			titleOffsetY = 50,
			titleTextY = 5,
			noAni = true,
			parent = self,
			content = layer,
			close = {
				normal = "back_img.png",
				pre = "back_img_press.png",
				y = 300,
			}
		})

		local curLv = params.result.god_attribute[isAtk and "1" or "2"]
		local curCfg = 0 == curLv and {
			agi = 0, atk = 0, def = 0, hp = 0
		} or params.result.config[curLv ..""]
		local nextCfg = params.result.config[(curLv+1) ..""]

		display.newSprite(PATH .."textbg-shenmai.png", display.cx, display.cy-30):addTo(layer)
		display.newSprite(PATH .."text1.png", display.cx-140, display.cy-130):addTo(layer)
		display.newSprite(PATH .."text3.png", display.cx+90, display.cy-130):addTo(layer)
		display.strokeLabel(DATA_Bag:countItems("prop",nil,{cid = "17138"}) .."", 175, 285, 20, ccc3(0, 0, 0)):addTo(layer)
 		display.strokeLabel(nextCfg.cailiao, 400, 285, 20, ccc3(0, 0, 0)):addTo(layer)

 		if isAtk then
 			display.strokeLabel("攻击加成: " ..curCfg.atk .."％ → " , 160, 400, 20, ccc3(255, 255, 255)):addTo(layer)
 			display.strokeLabel(nextCfg.atk .."％", 315, 400, 20, ccc3(0, 255, 0)):addTo(layer)
 			display.strokeLabel("敏捷加成: " ..curCfg.agi .."％ → ", 160, 370, 20, ccc3(255, 255, 255)):addTo(layer)
 			display.strokeLabel(nextCfg.agi .."％", 315, 370, 20, ccc3(0, 255, 0)):addTo(layer)
 		else
 			display.strokeLabel("防御加成: " ..curCfg.def .."％ → ", 160, 400, 20, ccc3(255, 255, 255)):addTo(layer)
 			display.strokeLabel(nextCfg.def .."％", 315, 400, 20, ccc3(0, 255, 0)):addTo(layer)
 			display.strokeLabel("血量加成: " ..curCfg.hp .."％ → ", 160, 370, 20, ccc3(255, 255, 255)):addTo(layer)
 			display.strokeLabel(nextCfg.hp .."％", 315, 370, 20, ccc3(0, 255, 0)):addTo(layer)
 		end

 		local ok = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , display.cx-100, 236, {
			front = COMMONPATH.."ok.png",
			anchMid = true,
			priority = -256,
			callback = function()
				local up2 = function()
					HTTP:call("general", "upgradeGodAttribute", {gid = params.gid, pos = isAtk and 1 or 2},{
						success_callback = function(result)
							HTTP:call("general", "getUpgradeGodAttributeConfig", {gid = params.gid}, {
								success_callback = function(result)
									params.result = result
									updateUI(true, isAtk, curLv+1)
								end
							})
						end
					})
				end
				if DATA_Bag:countItems("prop", false,{type = "timelimitgodstone"} ) > 0 then
					KNMsg.getInstance():boxShow("您拥有限时封神石，将优先消耗，不足时用封神石代替，是否升级?", {cancelFun = function()end, confirmFun = function()
						up2()
					end})
				else
					up2()
				end
				tip:remove()
			end 
		})
		layer:add(ok:getLayer())

		local cancel = KNBtn:new(COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , display.cx+100, 236, {
			front = COMMONPATH.."cancel.png",
			anchMid = true,
			priority = -256,
			callback = function()
				tip:remove()
			end 
		})
		layer:add(cancel:getLayer())
	end

	--更新主ui(是否显示开启按钮动画， 是否是攻敏， 开启的等级)
	updateUI = function(ani, isAtk, lv)
		if self.content then
			self.content:remove()
		end
		self.content = display.newLayer():addTo(self)

		local atks = {
	--按钮x, 按钮y, 按钮scale, 连线x, 连线y, 连线旋转角度
			{244, 576, 1, 0, 0, 0},
			{142, 534, .8, 186, 552, 330 },
			{77, 450, 1, 108, 496, 315},
			{75, 343, .8, 70, 394, 90},
			{142, 252, 1, 100, 300, 235},
		}
		local dens = {
	--按钮x, 按钮y, 按钮scale, 连线x, 连线y, 连线旋转角度
			{243, 215, .8, 0, 0, 0},
			{350, 251, 1, 292, 229, 330},
			{413, 343, .8, 392, 297, 310},
			{413, 450, 1, 417, 393, 90},
			{344, 537, .8, 383, 499, 235},
		}

		--神君按钮
		local isEnableGoder = 5 == params.result.god_attribute["1"] and 5 == params.result.god_attribute["2"]
		local godbtn = KNBtn:new( PATH, {isEnableGoder and "btn-god1.png" or "btn-god2.png"} , display.cx+5, display.cy-35, {
			anchMid = true,
			callback = function()
				if isEnableGoder then
					showGoder()
				else
					KNMsg.getInstance():flashShow("两条神脉达到LV5时,自动进阶为神君")
				end
			end 
		})
		self.content:add(godbtn:getLayer(), 1)

		local function showGoderBg()
			if isEnableGoder then
				display.newSprite(PATH .."circle.png", display.cx, display.cy-20):addTo(self.content)
				local eff = display.newFramesWithImage(GODCELLPATH.. "center_effect.png", 16, 1)
				display.playFrames(0, 0, eff, 0.1, { forever = true}):pos(display.cx, display.cy-30):addTo(self.content, 2)
			end
		end

		if ani and isEnableGoder then
			effect.get(PATH, "lv5eff", true, showGoderBg):pos(display.cx, display.cy-20):addTo(self.content)
		else
			showGoderBg()
		end
		
		--各级按钮
		for i=1,5 do
			local isEnableAtk = params.result.god_attribute["1"] >= i
			local isEnableDen = params.result.god_attribute["2"] >= i
			local atkbtn = KNBtn:new( PATH, {isEnableAtk and "btn-atk1.png" or "btn-atk3.png", "btn-atk2.png"} , atks[i][1], atks[i][2], {
				anchMid = true,
				callback = function()
					if params.result.god_attribute["1"]+1 == i then
						showOpen(true)
					end
				end 
			})
			atkbtn:getLayer():setScale(atks[i][3])
			self.content:add(atkbtn:getLayer(), 1)

			local denbtn = KNBtn:new( PATH, {isEnableDen and "btn-den1.png" or "btn-den3.png", "btn-den2.png"} , dens[i][1], dens[i][2], {
				anchMid = true,
				callback = function()
					if params.result.god_attribute["2"]+1 == i then
						showOpen(false, denbtn)
					end
				end 
			})
			denbtn:getLayer():setScale(dens[i][3])
			self.content:add(denbtn:getLayer(), 1)

			display.newSprite(PATH .."l" ..i ..".png", atks[i][1], atks[i][2]-30):addTo(self.content, 1)
			display.newSprite(PATH .."l" ..i ..".png", dens[i][1], dens[i][2]-30):addTo(self.content, 1)

			if isEnableAtk and i > 1 then
				display.newSprite(PATH .."line1.png", atks[i][4], atks[i][5]):rotation(atks[i][6]):addTo(self.content)
			end
			if isEnableDen and i > 1 then
				display.newSprite(PATH .."line1.png", dens[i][4], dens[i][5]):rotation(dens[i][6]):addTo(self.content)
			end
		end

		--箭头
		do
			local function showArrow(x, y)
				local seq = CCSequence:createWithTwoActions(CCMoveBy:create(.5, ccp(0, -20)), CCMoveBy:create(.5, ccp(0, 20)))
				display.newSprite(GODCELLPATH .."arrow_ani.png", x, y):flipY(true):addTo(self.content, 1):run(CCRepeatForever:create(tolua.cast(seq, "CCActionInterval")))
			end
			local curAtk = params.result.god_attribute["1"]
			if curAtk < 5 then
				showArrow(atks[math.max(curAtk+1, 1)][1], atks[math.max(curAtk+1, 1)][2]-50)
			end
			local curDen = params.result.god_attribute["2"]
			if curDen < 5 then
				showArrow(dens[math.max(curDen+1, 1)][1], dens[math.max(curDen+1, 1)][2]-50)
			end
		end

		--限时封神石
		display.newSprite(PATH .."text2.png", display.cx-40, 130):addTo(self.content)
		display.strokeLabel(DATA_Bag:countItems("prop", false,{type = "timelimitgodstone"}) .."", display.cx+60, 118, 20, ccc3(255, 255, 255)):addTo(self.content)
		
		--按钮开启动画
		if ani then
			local t = isAtk and atks or dens
			local effect = display.newFramesWithImage(GODCELLPATH.."up_grade_eff.png", 14, 2)
			local action
			action = display.playFrames(t[lv][1], t[lv][2], effect, 0.1, {
				onComplete = function() 
					action:remove()
				end
			}):scale(t[lv][3]):addTo(self.content, 1)
		end
	end

	updateUI()
end

return M