local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local ComboBox =requires(IMG_PATH,"GameLuaScript/Common/KNComboBox") 
local KNRadioGroup = requires(IMG_PATH,"GameLuaScript/Common/KNRadioGroup")--require "GameLuaScript/Common/KNRadioGroup"
local PATH = IMG_PATH.."image/scene/userinfo/"
local HOMEPATH = IMG_PATH.."image/scene/home/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local UserInfoLayer = {
	baseLayer,
	layer,
	timeLayer,
	timeSchedule,
	timeItems
}

function UserInfoLayer:new(params)
	local this = {}
	setmetatable(this,self)
	self.__index = self
	dump(params)
	this.baseLayer = display.newLayer()
	this.layer = display.newLayer()
	
	-- 背景
	local bg = display.newSprite(COMMONPATH .. "dark_bg.png")
	setAnchPos(bg , 0 , 88)						-- 70 是底部公用导航栏的高度

	local infoBg = display.newSprite(PATH.."info_bg.png")	
	setAnchPos(infoBg,245,670,0.5,0.5)
	this.layer:addChild(infoBg)

	local roleImgBtn
	HTTP:call("user" , "get_head_config" , { } , {
		success_callback = function(params)
		    	roleImgBtn = KNBtn:new( COMMONPATH , { getHeadPath( DATA_Head:get()["default"] ) } , 60 , 635 , {
						front = COMMONPATH .."role_frame.png",
						callback = function()
						local scroll , createScrollWithParams , createItem , lastOffset , cur_HeadId

						local changehead_layer, change_head_bg , vipLv_info_img , confirm_btn

						changehead_layer = baseMask( { titlePath = PATH  .. "change_head_tile.png", bgInfo = { path = IMG_PATH.."image/scene/mission/wipe_bg.png" , y = 280 }, isShowBack = { x = 30, y = 578, backFun = closeSoftKeyboard , priority = -201 } , priority = -201} )
						change_head_bg = display.newSprite( PATH .. "change_head_bg.png" )
						setAnchPos( change_head_bg , 245 , 447 , 0.5, 0.5 )
						
						vipLv_info_img = display.newSprite( PATH .. "vipLv_info.png" )
						setAnchPos( vipLv_info_img , 61 , 527 )


						--创建Item
						createItem = function(param , curHeadId)
							local itemLayer = display.newLayer()
							local lv_img , role_head_img , role_head_frame

							change_btn = KNBtn:new( IMG_PATH .. "image/scene/chat", { "btn_gang.png" , "btn_gang.png" , "btn_gray.png" } , 35,  18,
							{
								anchMid = true,
								priority = -201,
								front = PATH .. "change.png" , 
								disableWhenChoose = true,
								callback = function()
									if scroll then
										lastOffset = scroll:getOffset()
  										scroll:getLayer():removeFromParentAndCleanup( true )
    									scroll = nil
    									confirm_btn:setEnable(true)
    									confirm_btn:setFront( PATH .. "confirm_change.png" )
  									end
									createScrollWithParams(params , param.id , lastOffset)
								end
							})
							if param.vip~=nil and param.vip ~= 0  then 
								lv_img = display.newSprite( IMG_PATH.."image/scene/vip/v" .. param.vip .. ".png" )
								setAnchPos( lv_img , 32 , 125 , 0.5 , 0.5 )
								itemLayer:addChild( lv_img )
							end
							if curHeadId == param.id then
								change_btn:setFront( PATH .. "using_disabled.png" )
								change_btn:setEnable(false)
							end
							if DATA_Vip:get()["viplv"] < param.vip or  (param.is_get and tonumber(param.is_get)==0) then
								change_btn:setFront( PATH .. "change_disabled.png")
								change_btn:setEnable(false)
							end

							role_head_img = display.newSprite(COMMONPATH .. "head/" .. param.id .. ".jpg")
							setAnchPos( role_head_img , 35, 78 , 0.5 , 0.5 )

							role_head_frame = display.newSprite(COMMONPATH .."role_frame.png")
							setAnchPos( role_head_frame , 35 , 78 , 0.5 , 0.5 )
							itemLayer:addChild( change_btn:getLayer() )					
							itemLayer:setContentSize( CCSizeMake(80,140) )
							itemLayer:addChild( role_head_img )
							itemLayer:addChild( role_head_frame )

							return itemLayer			
						end

						createScrollWithParams = function(params, curHeadId , offset)
							cur_HeadId = curHeadId
							scroll = KNScrollView:new(61 , 380 , 355 , 140 , 10, true, 0,{
								priority = -201
							})


							local sortIndex = getSortList(params.head_config)
							dump(params.head_config , "params.head_config")
							for i=1,#sortIndex do
								scroll:addChild( createItem(params.head_config[sortIndex[i]], curHeadId) )
							end
							scroll:setOffset(offset)
							changehead_layer:addChild( scroll:getLayer() , 10 )
						end


						local openVipLabel = CCLabelTTF:create( "VIP7开启" , FONT , 18 );
						openVipLabel:setColor( ccc3(81,9,9) )
						setAnchPos( openVipLabel , 360 , 558 )

						local vipLvLabel = CCLabelTTF:create( DATA_Vip:get()["viplv"] , FONT , 18 );
						vipLvLabel:setColor( ccc3(81,9,9) )
						setAnchPos( vipLvLabel , 162 , 528 )

						-- 上传按钮
						upload_btn = KNBtn:new( COMMONPATH, { "btn_bg.png" , "btn_bg_pre.png" , "btn_bg_dis.png" } , 358,  580,
												{
													priority = -201,
													front = PATH .. "upload.png" , 
													disable = DATA_Vip:get()["viplv"] < 7 ,
													callback = function()
														KNMsg.getInstance():flashShow("上传功能暂未开放！")
													end
												})
						if DATA_Vip:get()["viplv"] < 7 then 
							upload_btn:setEnable(false)
							upload_btn:setFront( PATH .. "up_load_disabled.png" )
						end

						changehead_layer:addChild( upload_btn:getLayer() )

						-- 确认更换按钮
						confirm_btn = KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" , "btn_bg_red2.png" } , 71,  306,
												{
													priority = -201,
													front = PATH .. "confirm_change_disabled.png" , 
												--	disable = true,
													callback = function()
														HTTP:call("user","set_head",{ headid = cur_HeadId },{success_callback = 
															function(data)
																changehead_layer:remove()
																KNMsg.getInstance():flashShow("更改头像成功！")
																roleImgBtn:setBg( 1 , COMMONPATH .. "head/".. DATA_Head:get()["default"] .. ".jpg" )
															end
														})
													end
												})
						changehead_layer:addChild( confirm_btn:getLayer() )
						confirm_btn:setEnable(false)
						-- 成为VIP按钮
						changehead_layer:addChild( KNBtn:new( COMMONPATH, { "btn_bg_red.png" , "btn_bg_red_pre.png" , "btn_bg_red2.png" } , 260,  306,
						{
							priority = -201 ,
							front = PATH .. "become_vip.png" , 
							callback = function()
								HTTP:call("vip" , "get" , {} , {
									success_callback = function()
										switchScene("vip")
									end
								})
							end
						} ):getLayer() )

						createScrollWithParams(params , DATA_Head:get()["default"] , 0 )

						changehead_layer:addChild( change_head_bg );
						changehead_layer:addChild( vipLv_info_img )
						changehead_layer:addChild( openVipLabel )
						changehead_layer:addChild( vipLvLabel )
					end
				})
				this.layer:addChild(roleImgBtn:getLayer())
			end
	})
	
	
	--玩家头像
	local bg_big = display.newSprite(COMMONPATH .. "bg_big.png")
	setAnchPos(bg_big , 18 , 108)
	
	--名称显示
	local text = display.newSprite(PATH.."name.png")
	setAnchPos(text,130,680)
	this.layer:addChild(text)
	local curVipLv = DATA_Vip:get("viplv")
	
	if DATA_Vip:isVip() then
		this.layer:addChild( display.newSprite( IMG_PATH .. "image/scene/vip/v" .. curVipLv.. ".png" , 210 , 680  , 0 , 0 ) )
	end
	
	text = display.strokeLabel( DATA_User:get("name") , ( DATA_Vip:isVip() and 260 or 210 ) , 678 , 24 , ccc3(0x4a,0x08,0x08) )
	this.layer:addChild(text)

	--称号显示
	text = display.newSprite(PATH.."title.png")
	setAnchPos(text,130,635)
	this.layer:addChild(text)

	 --御花园按钮
	if params['emperor'] and params['emperor'] == 1  then
	    local enterKingGardenBtn = KNBtn:new(COMMONPATH, {"btn_bg.png" , "btn_bg_pre.png"}, 350 , 625 , {
				priority = -131,
				scale = true,
				front = PATH .. "kingGardenLab.png",
				callback = function()
					HTTP:call("socialclass","garden",{ },{success_callback = 
					function(data)
						switchScene("kingGarden",{data})
					end
					})
					
				end})
		this.layer:addChild(enterKingGardenBtn:getLayer())
	end

	--威望按钮 20-67级才显示威望加成按钮
	if tonumber(DATA_User:get("lv"))>=20 and tonumber(DATA_User:get("lv"))<=77 then 
		local weiwanBtn = KNBtn:new(PATH .. "weiwan/", {"weiwan_icon.png"}, 375 , 400 , {
				priority = -131,
				callback = function()

					HTTP:call("user","weiwang_add_detail",{ },{success_callback = 
					function(data)

						local layer = display.newLayer()

						layer:addChild( display.newSprite( PATH .. "weiwan/cur_weiwan_add.png" , 117, 396 , 0  ,0  ) )
						layer:addChild( display.newSprite( PATH .. "weiwan/next_weiwan_add.png" , 117, 348 , 0  ,0  ) )

						layer:addChild( display.strokeLabel( data.cur_lv or "" , 292  , 398 , 24 , ccc3( 220 , 35 , 43 ) ) )
						layer:addChild( display.strokeLabel( data.next_lv or "" , 292  , 350 , 24 , ccc3( 220 , 35 , 43 ) ) )

						showTip({
					      content = layer,
					      center = {
					        	remove = true,
					        	callback = function() 
						           
					        end
					      },
					      close = {
					        normal = "back_img.png",
					        pre = "back_img_press.png",
					      },
					    })

					end
					})
					
				end})
		this.layer:addChild(weiwanBtn:getLayer() , 10)
	end

	if #params.chenghao > 1 then
		local items = {}
		local group = KNRadioGroup:new()
		local combo
		local curStr
		local curIndex
		local kind
		for k, v in pairs(params.chenghao) do
			local btn
			local str ="v0.png"
			if v.type == 1 then  -- 竞技场排名称号
				for i = 1, #getTitle() do
					if tonumber(v.rank) > 10 then
					elseif tonumber(v.rank) > getTitle()[i][1] then
						str = "v"..(i - 1)..".png"
						break
					end
				end
				if v.select == 1 then
					curStr = str
					curIndex = k
					kind = v.type
				end
			elseif v.type == 2 then
				str = "p"..(v.rank or 1)..".png"
				if v.select == 1 then
					curStr = str
					curIndex = k
					kind = v.type
				end
			elseif v.type == 4 then
				str = "god_"..v.rank..".png"
				kind = v.type
				curStr = str
				curIndex = k
			end
			
			btn = KNBtn:new(PATH, {str, "cur_bg.png"}, 0, 0, {
				id = str,
				noHide = true,
				callback = function()
					kind = v.type
					combo:autoShow()
					combo:refreshBtn({front =PATH..btn:getId()})
				end
			}, group)
			table.insert(items, btn)
		end
		
		
		combo = ComboBox:new(210, 625, {
			dir = COMMONPATH,
			res = {"long_btn.png", "long_btn_pre.png"},
			bg = PATH.."sign_bg.png",
			front = PATH..curStr,
			itemsGroup = group,
			items = items,
			offset = -3,
			closeCallback = function()
				HTTP:call( "user" , "set_chenghao", {type = kind}, {
					success_callback = function(data)
						params.chenghao = data
						switchScene("userinfo",params)
					end,error_callback = function(data)
						switchScene("userinfo",params, function()
							KNMsg.getInstance():flashShow(data.msg)
						end)
					end
				})
			end
			
		})
		this.layer:addChild(combo:getLayer(), 5)
		
		
		group:chooseById(curStr)
	else
		if params.chenghao[1].type == 1 then
			local str ="v0.png"
			for i = 1, #getTitle() do
				if not params.rank or tonumber(params.rank) > 10 then
				
				elseif tonumber(params.rank) > getTitle()[i][1] then
					str = "v"..(i - 1)..".png"
					break
				end
			end
			text = display.newSprite(PATH..str)
			setAnchPos(text, 210, 635)
			this.layer:addChild(text)
		else
			text = display.newSprite(PATH.."p"..params.chenghao[1].rank..".png")
			setAnchPos(text, 210, 635)
			this.layer:addChild(text)
		end
	end
	
	this.layer:addChild( display.newSprite(PATH.."detail_bg.png" , display.cx , 300 , 0.5 , 0 ) )
	
	local showElement = {
			{ text = "id" 		, value = DATA_User:get("uid") 	} ,										--玩家id
			{ text = "level" 	, value = DATA_User:get("lv")	} ,										--玩家等级
			{ text = "on"		, value = DATA_Formation:get_lenght().."/8"	} ,							--上阵武将
			{ text = "value"	, value = params.ability	} ,											--玩家战力
			{ text = "gang"		, value = params.gang	} ,												--帮会
			{ text = "commander", value = ""	} ,										--统帅
			{ text = "exp"		, value = DATA_User:get("cur_exp").."/"..DATA_User:get("lvup_exp")	} ,	--玩家经验
			{ text = ""			, value = 0	} ,															--空
			{ text = "vip_text"	, value = DATA_Vip:get("viplv")	} ,										--vip等级
			{ text = ""			, value = 0	} ,															--空
			{ text = "gold"		, value = DATA_Account:get("gold")	} ,									--黄金
			{ text = "silver"	, value = DATA_Account:get("silver")	} ,								--银两
	}

	local addX , addY
	for i = 1 , #showElement do
		local curData = showElement[i]
		if curData.text ~= "" then
			addX = 60 + ( i - 1 ) % 2 * 212
			addY = 560 - math.floor( ( i - 1 ) / 2 ) * 50
			local pathStr = PATH .. curData.text .. ".png"
			if curData.text == "gold" or curData.text == "silver" then
				pathStr = COMMONPATH .. curData.text .. ".png"
			end

			if curData.text == "pvp_ability" or curData.text == "pve_ability" then
				this.layer:addChild( display.newSprite( pathStr , addX , addY - 12 , 0 , 0  ) )
				addX = addX - 20 
			else
				this.layer:addChild( display.newSprite( pathStr , addX , addY , 0 , 0  ) )
			end 
			
			addX = addX + 93
			if curData.text == "on" then
				addX = addX + 18
			elseif curData.text == "vip_text" then
				addX = addX + 10
			elseif curData.text == "gold" or curData.text == "silver" then
				addX = addX - 50
			end
			this.layer:addChild( display.strokeLabel(curData.value , addX  , addY , 24 , ccc3( 0xff , 0xfb , 0xd4 ) ) )
		end
	end
	
	
	local lookVipBtn = KNBtn:new(COMMONPATH, {"long_btn.png", "long_btn_pre.png"}, 311 , 354, {
			front = PATH.."look_privilege.png",
			callback = function()
				HTTP:call("vip", "get", {},{success_callback = 
				function()
					switchScene("vip")
				end})
			end}):getLayer()
	this.layer:addChild(lookVipBtn)
	
	--体力信息，当前值下次恢复值，总时间 
	this.layer:addChild( display.newSprite(PATH.."data_bg.png" , display.cx , 134 , 0.5 , 0 )	 )			--体力背景
	this.layer:addChild( display.newSprite( PATH .. "power.png"  		, display.cx , 260 , 0.5 , 0 ) )	--体力文字title
	this.layer:addChild( display.newSprite( PATH .. "power_value.png" 	, 60 , 220 , 0 , 0 ) )				--当前体力值
	this.layer:addChild( display.newSprite( PATH .. "next_power.png" 	, 60 , 180 , 0 , 0 ) )				--下个恢复时间
	this.layer:addChild( display.newSprite( PATH .. "all_power.png" 	, 60 , 140 , 0 , 0 ) )				--所有恢复时间
	this.layer:addChild( display.strokeLabel( DATA_Power:get("num").."/"..DATA_Power:get("max"),140,220,22,ccc3(0x4a,0x08,0x08) ) )	--当前体力值/最大体力值
	
	
--	--斗志信息，当前值下次恢复值，总时间 
--	dataBg = display.newSprite(PATH.."data_bg.png")	
--	setAnchPos(dataBg,245,180,0.5,0.5)
--	this.layer:addChild(dataBg)
--
--	text = display.newSprite(PATH.."energy.png")
--	setAnchPos(text,245,225,0.5)
--	this.layer:addChild(text)
--	
--	text = display.newSprite(PATH.."energy_value.png")
--	setAnchPos(text,60,205)
--	this.layer:addChild(text)
--	
--	text = display.strokeLabel(DATA_Energy:get("num").."/"..DATA_Energy:get("max"),140,205,22,ccc3(0x4a,0x08,0x08))
--	this.layer:addChild(text)
--	
--	text = display.newSprite(PATH.."next_energy.png")
--	setAnchPos(text,60,165)
--	this.layer:addChild(text)
--	
--	text = display.newSprite(PATH.."all_energy.png")
--	setAnchPos(text,60,125)
--	this.layer:addChild(text)
	
	--体力与斗志的更新时间
	this.timeItems = {
		DATA_Power:get("next_recover_time"),
		DATA_Power:get("all_recover_time"),
--		DATA_Energy:get("next_recover_time"),
--		DATA_Energy:get("all_recover_time"),
	}
	
	--生成倒计时信息
	this:createTimeLayer()
	
	
	
	this.baseLayer:addChild(bg)
	this.baseLayer:addChild(bg_big)
	this.baseLayer:addChild(this.layer)
	
	--导航信息
	local info = InfoLayer:new("userinfo" , 0 , {tail_hide = true , title_text = PATH .. "user_title.png"})
	this.baseLayer:addChild(info:getLayer() , 2)

	if G_SILVERCARD and G_SILVERCARD > 0 then
		local silverUp = KNBtn:new(HOMEPATH, {"silver_up.png"}, 350, 630,{
			callback = function()
				KNMsg.getInstance():flashShow("当前进行闯关可获得多倍银币,于当日凌晨失效" )
			end
		}) 
		this.baseLayer:addChild(silverUp:getLayer())
	end
	
	if G_EXPCARD and G_EXPCARD > 0 then
		local expUp = KNBtn:new(HOMEPATH,{"exp_up.png"}, 397, 630, {
			callback = function()
				KNMsg.getInstance():flashShow("当前进行闯关可获得多倍经验,于当日凌晨失效" )
			end
			
		})
		this.baseLayer:addChild(expUp:getLayer())
	end
	return this
end


function UserInfoLayer:getLayer()
	return self.baseLayer
end

function UserInfoLayer:createTimeLayer()
	if self.timeLayer then
		self.layer:removeChild(self.timeLayer,true)
	end
	
	
	
	self.timeLayer = display.newLayer()
	
	local time = display.strokeLabel( timeConvert(self.timeItems[1]) , 250 , 182 , 20 )
	self.timeLayer:addChild(time)
	
	time = display.strokeLabel(timeConvert(self.timeItems[2]) , 250 , 142 , 20 )
	self.timeLayer:addChild(time)
--	
--	time = display.strokeLabel(timeConvert(self.timeItems[3]),250,165,20)
--	self.timeLayer:addChild(time)
--	
--	time = display.strokeLabel(timeConvert(self.timeItems[3]),250,125,20)
--	self.timeLayer:addChild(time)
	
	
	if not self.timeSchedule then
		self.timeSchedule = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(
			function()
				local refresh = false
				for i = 1, #self.timeItems do
					if self.timeItems[i] > 0 then
						self.timeItems[i] = self.timeItems[i] - 1
						if self.timeItems[i] == 0 then  --计时到0时请求一次数据
							refresh = true
						end
					end
				end
				if refresh then
					HTTP:call("status","get",{},{success_callback=
						function()
							switchScene("userinfo")
						end
					})
				else
					self:createTimeLayer()
				end
			end,1,false)
	end
	self.layer:addChild(self.timeLayer)	
end

function UserInfoLayer:stopSchedule()
	if self.timeSchedule then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.timeSchedule)
	end
end

				
return UserInfoLayer