local InfoLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local KNBar = requires(IMG_PATH , "GameLuaScript/Common/KNBar")
local KNTextField = requires(IMG_PATH,"GameLuaScript/Common/KNTextField")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")
local PATH = IMG_PATH.."image/scene/vip/"
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local baseElement = requires(IMG_PATH , "GameLuaScript/Scene/common/baseElement")
local M = {
}

function M:new(params)
	params = params or {}
	local this = {}
	setmetatable(this,self)
	self.__index = self
	
	local data = DATA_Vip:get("vip")
	this.baseLayer = display.newLayer()
	local layer = display.newLayer()

	-- 背景
	local bg = display.newSprite(COMMONPATH .. "dark_bg.png")
	setAnchPos(bg , 0 , 88)						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild(bg)
	local highLv = tonumber( DATA_Vip:get("vipinfo")["vipmax"] ) 	--定义最高vip等级
	
	local nextLv = DATA_Vip:get("viplv") + 1
	nextLv = nextLv>highLv and highLv or nextLv
	
	layer:addChild( display.newSprite( IMG_PATH .. "image/scene/gang/hall/notice_bg2.png" , display.cx ,  618 , 0.5 , 0 ) )
	
	local tempBar = KNBar:new("exp_general" , 131 , 183 , { maxValue = data.lvup_exp , curValue = data.cur_exp , color = ccc3(255, 255, 255) })
	tempBar:setIsShowText( nextLv <= highLv )
	layer:addChild( tempBar )
	
	layer:addChild( display.newSprite( PATH .. "cur_vip.png" , 55 ,  654 , 0 , 0 ) )	-- 当前vip等级
	layer:addChild( display.newSprite( PATH .. "cur_vip_title.png" , 150 ,  694 , 0 , 0 ) )	-- 当前vip等级
	if DATA_Vip:get("viplv") <= ( highLv-1 )  then
		layer:addChild( display.newSprite( PATH .. "need_gold.png" , 55 ,  630 , 0 , 0 ) )	--再充值多少黄金即可成为vipN
		layer:addChild( display.strokeLabel( nextLv , 370 , 633 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) ))
		
		local nextGold = data.lvup_exp - data.cur_exp	--到下级还需要充值多少
--		nextGold = nextGold<10000 and nextGold or math.floor(nextGold/10000) .. "万"
		layer:addChild( display.strokeLabel( nextGold , 126 , 633 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , {
				dimensions_width = 92 ,
				dimensions_height = 24,
				align = 1
			}) )
	end 
	layer:addChild( display.strokeLabel( DATA_Vip:get("viplv") , 275 , 696 , 20 , ccc3( 0x2c , 0x00 , 0x00 ) , nil , nil , {
			dimensions_width = 100 ,
			dimensions_height = 24,
			align = 0
		}) )

	

	
	local configData = data.config
	local scroll = KNScrollView:new( 10 , 103 , 460 , 500 , 5 )
	for i = 1 , #configData do
		local tempItem = this:itemCell( { data = configData[i] , parent = scroll , isShowLine = i ~= highLv } )
		scroll:addChild(tempItem , tempItem )
	end
	scroll:alignCenter()
	layer:addChild( scroll:getLayer() )
	
	scroll:setIndex( DATA_Vip:get( "viplv" ) , true )
	
	layer:addChild( display.newSprite( COMMONPATH.."tab_line.png"  , 6 , 607 , 0 , 0 ) )
	this.baseLayer:addChild(layer)
	

	--判断是字符串是否全为数字
	local function isNumber( strName , str , strLen)
		str = string.trim(str)
		if str == nil then
			return  false , strName .. "为空，不能绑定!"
		end
		local len = string.len(str)
		for i = 1 , len do
			local ch = string.sub( str , i , i )
			if ch < '0' or ch > '9' then
				return  false , strName .. "应输入数字"
			end
		end

		if strLen ~= nil and strLen ~= len then 
			return false , strName .. "应输入".. strLen .. "位数字!"
		end

		return  true
	end

	--创建绑定确定层
	local function createBindingConfirmLayer( telStr , qqStr )
		local bindingConfirmLayer = display.newLayer()
		bindingConfirmLayer:ignoreAnchorPointForPosition(false)

		local confirmTxt = KNTextField:create( { str = "请再次确认您的手机号码是否正确，绑定后不可以进行修改！" , size = 16  , color = ccc3(181,9,9) , width = 340 } )
		setAnchPos( confirmTxt ,  60 , 450 , 0 , 0 )

		local bingdingConfirm_img = display.newSprite(PATH .. "bingdingConfirm.png")
		setAnchPos( bingdingConfirm_img , 60 , 350 )

		local tel_label = CCLabelTTF:create( telStr , FONT , 16 )
		tel_label:setColor( ccc3(181,9,9) )
		setAnchPos( tel_label , 200 , 400 )

		local qq_label = CCLabelTTF:create( qqStr , FONT , 16 )
		qq_label:setColor( ccc3(181,9,9) )
		setAnchPos( qq_label , 200 , 356 )

		bindingConfirmLayer:addChild(qq_label)
		bindingConfirmLayer:addChild(tel_label)
		bindingConfirmLayer:addChild(confirmTxt)
		bindingConfirmLayer:addChild(bingdingConfirm_img)

		return bindingConfirmLayer;
	end

	--创建绑定弹出层
	local function createBindingLayer(params)
		local tel_textfield, qq_textfield
		local offsetY = 122
		local function changeInputText(type)
			if type == "tel" then
				tel_textfield:startInput()
				qq_textfield:stopInput()
			else
				tel_textfield:stopInput()
				qq_textfield:startInput()
			end
		end

		local bindingLayer = display.newLayer()
		bindingLayer:ignoreAnchorPointForPosition(false)
		setAnchPos(bindingLayer , 0 , 0)

		local mask = KNMask:new({item = bindingLayer, priority = -200})

		local bg = display.newSprite(IMG_PATH.."image/scene/gang/wars/wars_rule_bg.png")
		setAnchPos(bg, 240, 375 + offsetY, 0.5, 0.5)
		bindingLayer:addChild(bg)

		--Tel输入框背景
		local tel_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 160 , 395 + offsetY , {
			priority = -201,
			callback = function()
				changeInputText("tel")
			end
		}):getLayer()

		-- QQ输入框背景
		local qq_input_bg = KNBtn:new(IMG_PATH .. "image/scene/login", {"input_bg.png"} , 160 , 350 + offsetY , {
			priority = -201,
			callback = function()
				changeInputText("qq")
			end
		}):getLayer()

		--奖励列表
		local awardData = params.config
		for i = 1 , #awardData do
			local curProp = awardCell( awardData[i] )
			curProp:registerScriptTouchHandler(function(type,x,y) return curProp:onTouch(type,x,y) end,false,-201,true)
			setAnchPos( curProp , 100 + ( i - 1 ) * 100 , 230 + offsetY )
			bindingLayer:addChild( curProp )
		end



		--确定按钮
		local confirm_btn = KNBtn:new(COMMONPATH .. "" , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 100 , 140 + offsetY , {
		front = COMMONPATH.."ok.png",
		priority = -201,
		callback = function()
			local telStr = tel_textfield:getString()
			local qqStr = qq_textfield:getString()
			local  tel_flag , tel_retStr = isNumber( "手机号码" , string.trim(telStr) , 11)
			local  qq_flag , qq_retStr = isNumber( "QQ号码" , string.trim(qqStr) , nil)
			
			if tel_flag == false then
				KNMsg.getInstance():flashShow( tel_retStr )
			elseif qq_flag == false then 
				KNMsg.getInstance():flashShow( qq_retStr )
			else
				mask:remove()
				showTip({
							content = createBindingConfirmLayer( telStr , qqStr ),
							right = {
			 					remove = true,
							},
			 				left = {
			 					remove = true,
			 					callback = function()
									HTTP:call( "vip" , "addcollectinfo", { mobile = telStr , qq = qqStr },{success_callback = 
										function(data , func)
											tel_textfield:stopInput()
											qq_textfield:stopInput()
											func( data , "绑定成功！" )
										end
										})
						 		end
							}
						})
			end
		end
		} )
		--取消按钮
		local cancel_btn = KNBtn:new(COMMONPATH .. "" , {"btn_bg_red.png" , "btn_bg_red_pre.png"} , 250 , 140 + offsetY , {
		front = COMMONPATH.."cancel.png",
		priority = -201,
		callback = function()
			tel_textfield:stopInput()
			qq_textfield:stopInput()
			mask:remove()
		end
		} )
		bindingLayer:addChild(confirm_btn:getLayer())
		bindingLayer:addChild(cancel_btn:getLayer())

		--绑定描述
		local textStr = "您是尊贵的VIP" .. DATA_Vip:get()["viplv"] .. ",为让您享受更多的高V特权，请绑定您的手机！高VIP用户专属服务通道，客服萌妹纸一对一专属热线正在紧急筹备中！"
		local textInfo = KNTextField:create( { str = textStr , size = 16  , color = ccc3(181,9,9) , width = 340 } )
		setAnchPos( textInfo ,  60 , 490 + offsetY , 0 , 0 )

		local awardInfo = KNTextField:create( { str = "绑定手机即可领取以下奖励:" , size = 16  , color = ccc3(181,9,9) , width = 340 } )
		setAnchPos( awardInfo ,  60 , 315 + offsetY , 0 , 0 )

	   	--手机号码
	   	local tel_img = display.newSprite(PATH .. "tel.png")
	   	setAnchPos( tel_img , 100 , 400 + offsetY )

		tel_textfield = KNInputText:new( { width = 212 ,
											height = 28 ,    			
											size = 16 , 
											defStr = "请输入手机号码（必填）" , 
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											-- inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
   		setAnchPos(tel_textfield:getLayer(), 170, 412 + offsetY)
   		tel_textfield:startInput()

   		qq_textfield = KNInputText:new( { width = 212 , 
											height = 28 , 
											size = 16 , 
											defStr = "请输入QQ号码（选填）" , 
											defColor = ccc3( 0xff , 0xfb , 0xd4 ) , 
											-- inputColor = ccc3( 0x4d , 0x15 , 0x15 ) 
											} )
   		setAnchPos(qq_textfield:getLayer(), 170, 363 + offsetY)
   		qq_textfield:stopInput()

	   	--QQ号码
	   	local qq_img = display.newSprite(PATH .. "qq.png")
	   	setAnchPos( qq_img , 100 , 350 + offsetY)

	    local function onTouch(eventType, x, y)
	    	tel_textfield:stopInput()
	    	qq_textfield:stopInput()
	        return true
	    end

	    bindingLayer:setTouchEnabled(true)
   		bindingLayer:registerScriptTouchHandler(function(type,x,y) return onTouch(type,x,y) end, false , -220 )

		bindingLayer:addChild(tel_input_bg)
		bindingLayer:addChild(qq_input_bg)
		bindingLayer:addChild(tel_textfield:getLayer())
     	bindingLayer:addChild(qq_textfield:getLayer())
	   	bindingLayer:addChild(tel_img)
	   	bindingLayer:addChild(qq_img)
	   	bindingLayer:addChild(textInfo)
	   	bindingLayer:addChild(awardInfo)
		return mask:getLayer();
	end	



	local function createBindingInfoLayer(params)
		local bindingConfirmLayer = display.newLayer()
		bindingConfirmLayer:ignoreAnchorPointForPosition(false)

		local QQ = nil

		if CHANNEL_GAME == "ayou" then
			QQ = "2725932498"
		elseif CHANNEL_GROUP == "hy" then 
			QQ = "800070366"	
		elseif CHANNEL_ID == "appFame" or CHANNEL_ID == "appFameOfficial" or CHANNEL_ID == "appFameOfficial2" then
			QQ="800072960"
		else
			QQ="800026601"
		end

		local txt = createLabel( { str = "您是尊贵的VIP".. DATA_Vip:get()["viplv"] .. "用户，如需VIP专属服务通道，请联系企业QQ:"..QQ , size = 16  , color = ccc3(181,9,9) , width = 370 } )
		setAnchPos( txt ,  60 , 450 , 0 , 0 )

		local bingdingConfirm_img = display.newSprite(PATH .. "bingdingConfirm.png")
		setAnchPos( bingdingConfirm_img , 60 , 350 )

		local qq_label = CCLabelTTF:create(params.uservipinfo["qq"] , FONT , 16 );
		qq_label:setColor( ccc3(181,9,9) )
		setAnchPos( qq_label , 200 , 356 )

		local tel_label = CCLabelTTF:create(params.uservipinfo["mobile"] , FONT , 16 );
		tel_label:setColor( ccc3(181,9,9) )
		setAnchPos( tel_label , 200 , 400 )

		bindingConfirmLayer:addChild(qq_label)
		bindingConfirmLayer:addChild(tel_label)
		bindingConfirmLayer:addChild(txt)
		bindingConfirmLayer:addChild(bingdingConfirm_img)

		return bindingConfirmLayer
	end

	--VIP绑定按钮
	local binding_btn = KNBtn:new( PATH .. "" , {"binding_normal.png" , "binding_selected.png" } , 300 , 690 , {
		callback = function()
			HTTP:call("vip", "collect", {}, {
				success_callback = function(data)
					if table.nums(data.uservipinfo)==0 then
						layer:addChild(createBindingLayer(data), 100)
					else
						showTip({
							content = createBindingInfoLayer(data),
							close = {
								path = COMMONPATH .. "",
								x = 135,
								y = 20,
								normal = "btn_bg_red.png",
								pre = "btn_bg_red_pre.png",
								front = COMMONPATH .. "colse_text.png",
								callback = function()

								end
							}
						})
					end
				end
			})
		end,
		scale = true 
	})
	binding_btn:showBtn( DATA_Vip:get()["viplv"] >= 6 )
	binding_btn:setEnable( DATA_Vip:get()["viplv"] >= 6 )

	-- 充值按钮
	if IN_BANHAO == nil then
		local charge_btn = KNBtn:new( SCENECOMMON .. "navigation" , {"na_charge.png" , "na_charge_pre.png"} , 363 , 640 , {
			priority = -130,
			callback = function()
				switchScene("pay")
			end,
			scale = true,
		})
		layer:addChild(charge_btn:getLayer())
	end
	
	layer:addChild(binding_btn:getLayer())
	
	--导航信息
	local info = InfoLayer:new( "vip" , 0 , {tail_hide = true , title_text = PATH .. "vip_title.png"})
	this.baseLayer:addChild(info:getLayer() , 2)
	return this.baseLayer
end

function M:itemCell( params )
	params = params or {}
	local data = params.data or {}
	local isShowLine = params.isShowLine
	
	local layer = display.newLayer()
	
	if isShowLine then
		layer:addChild( display.newSprite( IMG_PATH .. "image/scene/notice/line.png" 	, display.cx , 3 , 0.5 , 0  ) )
	end
	
	local pathStr
	if data.status == 0 then
		pathStr = "get_grey.png"
	elseif data.status == 1 then
		pathStr = "get_over.png"
	elseif data.status == 2 then
		pathStr = "quick_get.png"
	end
	local getBtn = KNBtn:new( COMMONPATH , 
		{ "btn_bg_red.png" ,"btn_bg_red_pre.png" , "btn_bg_red2.png" } , 
		154 , 15 ,
		{
			parent = params.parent ,
--			priority = -130,
			front = COMMONPATH .. pathStr ,
			callback = 
			function()
				HTTP:call( "vip" , "receive", { lv = data.lv },{success_callback = 
				function()
--					switchScene( "vip" )
				end})
			end
		})
	getBtn:setEnable( data.status == 2 )
	layer:addChild( getBtn:getLayer() )
	
	layer:addChild( display.newSprite( IMG_PATH .. "image/scene/activity_new/shade1.png" , display.cx , 68 , 0.5 , 0  ) )	--奖励背景
	layer:addChild( display.newSprite( PATH .. "vip_awards_title.png" , 100 , 165 , 0 , 0  ) )
	layer:addChild( display.strokeLabel( data.lv , 136 , 167 , 20 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , { dimensions_width = 41 , dimensions_height = 25 , align = 1} ) )
	
	--奖励
	local awardData = data.gift
	for i = 1 , #awardData do
		local curProp = awardCell( awardData[i] , {
			parent = params.parent
		})
		setAnchPos( curProp , 100 + ( i - 1 ) * 84 , 90 )
		layer:addChild( curProp )
	end
	
	local addY = 204 
	local noticeText = KNTextField:create( { str = data.privilege , size = 18  , color = ccc3( 0xff , 0xfb , 0xd5 ) , width = 345 } )
	addY = addY + noticeText:getContentSize().height
	setAnchPos( noticeText ,  110 , addY , 0 , 1 )
	layer:addChild( noticeText )
	
	addY = addY + 20
	layer:addChild( display.newSprite( PATH .. "tip_title.png" 				, 100 , addY , 0 , 0  ) )
	layer:addChild( display.newSprite( PATH .. "vip" .. data.lv .. ".png" 	, 0 , addY + 25  , 0 , 0  ) )
	layer:addChild( display.strokeLabel( data.gold , 177 , addY + 40 , 20 , ccc3( 0xff , 0xfb , 0xd5 ) , nil , nil , {
		dimensions_width = 100 ,
		dimensions_height = 25,
		align = 1
	}) )
	
	addY = addY + 60 + 30
	

	layer:setContentSize( CCSize:new(  460 , addY  ) )
	return layer
end
				
return M