local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local Role = requires(IMG_PATH, "GameLuaScript/Scene/war/role")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local KNProgress = requires(IMG_PATH, "GameLuaScript/Common/KNProgress")
local PATH = IMG_PATH.."image/scene/war/"
local SCENECOMMON = IMG_PATH.."image/scene/common/"

local L, M, R = 50, 212, 375
local base, space = 10, 130
local mapPos = {
	{	--帮战地图数据
		{L - 25, 20,{2}},                    --1
		{R - 100, base + space + 10,{4,6}},                  --2

		{L, base + space * 2 + 10,{7}},                --3
		{M - 60, base + space * 2 - 50,{3,5}},               --4
		{R - 100 , base + space * 2 + 20,{9}},                  --5
		{R + 10 , base + space * 2 - 50,{5,10}},                  --6

		{L, base + space * 3 - 20,{8,11}},                 --7
		{M - 60, base + space * 3 + 60,{12}},                 --8
		{R - 100, base + space * 3 - 20,{8,10}},               --9
		{R + 10, base + space * 3 + 60,{14}},                --10

		{L, base + space * 4 + 100,{15}},                 --11
		{M - 60, base + space * 4 + 30,{11,13}},                  --12
			{R - 100, base + space * 4 + 80,{15}},         --13
		{R + 10, base + space * 4 + 30,{13}},         --14

		{M - 60, base + space * 5 + 20 ,{16}},         --15


		{M + 50, base + space * 5 + 20,{}},         --16
	},{   --掠夺战数据
		{275, 50, {2}},
		{350, 142,{3}},
		{213, 187,{4}},
		{83, 257,{5}},
		{243, 311,{6}},
		{369, 387,{7}},
		{213, 420,{8}},
		{89, 500,{9}},
		{215, 546,{10}},
		{325, 616,{11}},
		{108, 648,{12}},
		{270, 765,{}},
	}
}

local MapMgr = {
	baseLayer,
	mapLayer,
	logicLayer,
	items,   --参加帮战成员
	points,   --据点
	mapId,
	offsetX, -- 在据点的偏移
	offsetY,
	baseX,   --在大本营的偏移
	baseY,
	fightAni,
	score_1,
	score_2,
	time,
	tips,
	reportBtn,
	parent,
	maxDie,  --最大死亡次数
	allowOpt,  --是否可操作 ，观战者不可操作
	warItems,  --战斗道具
	recoveryBuf,  --恢复buf
	fighting   --自己是否正在战斗

}

function MapMgr:new(params, parent)
	local this = {}
	self.__index = self
	setmetatable(this, self)
	this.params = params or {}
	this.parent = parent
	this.baseLayer = display.newLayer()
	this.items = {}
	this.warItems = {}
	this.points = {}
	this.fightAni = {}
	this.tips = {}
	this.mapId = this.params.mapId or 1
	this.time = this.params.move_time
	this.maxDie = this.params.max_die_times
	this.offsetX = 0
	this.offsetY = 0
	this.baseX = 0
	this.baseY = 0

	if this.params.stat then
		this.allowOpt = this.params.stat[DATA_User:get("uid")..""]
	else
		this.allowOpt = true
	end
	this:createMap()

	if (this.params.mapId ~= 2) and this.params.start_time and (os.time() + TIME_OFFSET - this.params.start_time <= 5) then
		this:showTimeCount(os.time() + TIME_OFFSET - this.params.start_time + 1)
	end
	return this
end

function MapMgr:createMap()
	if self.mapLayer then
		self.baseLayer:removeChild(self.mapLayer, true)
	end
	self.mapLayer = display.newLayer()

	--调用对应的 id的函数来创建地图
	if self.mapId == 1 then
		self["map"..self.mapId](self, self.params.stat, self.params.win)
	else
		self["map"..self.mapId](self, self.params)
	end

	self.time = createLabel({str = timeConvert(self.params.limit_time, nil, true), size = 18, color = ccc3(0xe2, 0xe2, 0xe2)})
	setAnchPos(self.time, 40, 15)
	self.mapLayer:addChild(self.time)
	Clock:addTimeFun("war_time", function()
		if self.params.limit_time > 0 then
			self.params.limit_time = self.params.limit_time - 1
			self.time:setString(timeConvert(self.params.limit_time, nil, true))
		end
	end)


	if self.allowOpt then
		self.reportBtn = KNBtn:new(PATH, {"report.png", "report_press.png"}, 400, 150, {
			anchMid = true,
			callback = function()
				local str
				if self.params.mapId == 1 then
					str = "gangbattle"
				else
					str = "lueduo"
				end
				self.reportBtn:getLayer():stopAllActions()
				HTTP:call(str, "getReportList", {battle_id = self.params.battle_id }, {
					success_callback = function(data)
						self.mapLayer:addChild(self:showReport(data))
					end
				})
			end
		})
		self.mapLayer:addChild(self.reportBtn:getLayer())
	end


	self.baseLayer:addChild(self.mapLayer)
end

function MapMgr:mapLine(pos, i, point)
	local data = pos[i][3]
	for j = 1, #data do
		local line = display.newSprite(PATH.."map_line.png")

		self.logicLayer:addChild(line, -2)

		if self.mapId == 1 then -- 帮战的地图布线
			setAnchPos(line, pos[i][1] + point:getWidth() / 2, pos[i][2] + point:getHeight() / 2, 0, 0.5)
			--
			--			if pos[data[j]][1] - pos[i][1] == 0 or i == 1 or i == 12 then  --垂直旋转90度
			--				line:setRotation(-90)
			--				if i == 1 then
			--					setAnchPos(line,pos[i][1] + 5 + point:getWidth() / 2 + line:getContentSize().height / 2, pos[i][2] + point:getHeight() / 2.5)
			--				elseif i == 12 then
			--					setAnchPos(line,pos[i][1] + point:getWidth() / 2 + line:getContentSize().height / 2, pos[i][2] + point:getHeight() / 2.5 - 20)
			--				end
			--			elseif pos[data[j]][2] == pos[i][2] then  --横向连接
			--			else  --根据位置旋转一定的角度
			--				local rotate = math.deg(math.atan((pos[data[j]][2] - pos[i][2]) / (pos[data[j]][1] - pos[i][1]))) - 90
			--
			--				if pos[data[j]][1] > pos[i][1] then
			--					rotate = rotate + 12
			--				else
			--					rotate = rotate - 12
			--				end
			--				line:setRotation(rotate)
			--				line:setScaleX(1.3)
			--			end
			local curX = pos[i][1]
			local curY = pos[i][2]
			
			local x = pos[data[j]][1]
			local y = pos[data[j]][2]

			local dx = x - curX
			local dy = y - curY

			local distance = math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))

			local degree = -math.deg(math.acos(dx / distance))

			if y < curY then
				if x < curX then
					degree = degree - 90
				elseif x == curX then
					degree = -180
				else
					degree = degree + 90
				end
			end
			
			
			line:setRotation(degree)
			if i == 1 then
				line:setScaleX(1.2)
			elseif i == 15 then
				line:setScaleX(1.2)
			else
				line:setScaleX(distance / line:getContentSize().width)
			end
			
		else
			setAnchPos(line, pos[i][1], pos[i][2], 0, 0.5)
			local dx = pos[data[j]][1] - pos[i][1]
			local dy = pos[data[j]][2] - pos[i][2]

			local distance = math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))

			local rotate = -math.deg(math.acos(dx / distance))

			--			if dy < 0 then
			--				rotate = -rotate
			--			elseif dy == 0 and dx < 0 then
			--				rotate = 180
			--			end
			line:setScaleX(distance / line:getContentSize().width)
			line:setRotation(rotate)
		end
	end
end

function MapMgr:map1(init, win)
	if self.logicLayer then
		self.mapLayer:removeChild(self.logicLayer, true)
	end
	self.logicLayer = display.newLayer()

	self.mapLayer:addChild(self.logicLayer)

	local my = DATA_User:get("uid")..""


	local pos = mapPos[1]

	for i = 1, #pos do
		local point
		if i == 1 or i == #pos then
			local str
			if i == 1 then
				str = "self_supreme.png"
			else
				str = "enemy_supreme.png"
			end
			--大本营
			point = KNBtn:new(PATH, {str}, pos[i][1], pos[i][2], {
				id = i,
				callback = function()
					if self.allowOpt and ((init[my].group == 1 and self.items[my]:getPos() == #pos - 1) or (init[my].group == 2 and self.items[my]:getPos() == 2)) then
						-- 						HTTP:call("gangbattle", "move", {point = i, battle_id = self.params.battle_id}, {
						-- 							no_loading = true,
						-- 							success_callback = function()
						-- --								self.items[my]:move(pos[i][1] + point:getWidth() / 2, pos[i][2] + point:getHeight() / 2, layer)
						-- 							end
						-- 						})
						SOCKET:getInstance("battle"):call("gangbattle" , "move" , "move" , {
							point = i,
							battle_id = self.params.battle_id,
							cmd2 = "activity"
						} , {
							no_loading = true,
							success_callback = function()
							end
						})
					else
						self:viewFormation(i)
					end
				end})
			self.baseX = point:getWidth() / 2
			self.baseY = point:getHeight() / 2
		else
			local text
			if self.allowOpt and init[my] ~=nil and self.params.map.point[i..""]["score".."_"..init[my].group] ~= 0 then
				text = {self.params.map.point[i..""]["score".."_"..init[my].group],18, ccc3(0x2c, 0, 0), ccp(-3, 5)}
			end

			point = KNBtn:new(PATH, {"pt_empty.png"}, pos[i][1], pos[i][2], {
				id = i,
				text = text,
				callback = function()
					if self.allowOpt and self.items[my]:isDie() then
						if self.items[my]:getInfo().die_times >= self.maxDie then
							KNMsg.getInstance():flashShow("您的复活次数已用尽，在大本营为你的基友们加油吧，骚年！~")
						else
							KNMsg.getInstance():flashShow("您已身负重伤，请在大本营休息片刻吧！~")
						end
						self:viewFormation( i)
					else
						local legal
						if self.allowOpt and  self.items[my]:getInfo().stat == "hold" then
							for k, v in pairs(self.params.map.point[self.items[my]:getPos()..""].next) do
								if point:getId() == v then
									legal = true
									break
								end
							end
						end

						if legal then
							local emulate = true   --是否发送模拟命令
							if self.items[my]:getInfo().effect then
								if self.items[my]:getInfo().effect.name == "stop" then
									KNMsg.getInstance():flashShow("你被禁足了，休息一会吧*_*")
									return
								elseif self.items[my]:getInfo().effect.name == "jump" then
									KNMsg.getInstance():flashShow("准备跳跃，将瞬间到达目标")
									--									local data = self.items[my]:getInfo()
									--									data.stat = "move"
									--									data.data = {data.data, i}
									--
									--									self:setPtState(data, my)
									--									self.items[my]:setState(1, 1)
									emulate = false
								end
							end

							if emulate then
								local tmp = {
									["change_stat"] = {self.items[my]:getInfo()}
								}
								tmp.change_stat[1].stat = "move"
								tmp.change_stat[1].time = os.time() + TIME_OFFSET
								tmp.change_stat[1].data = {tmp.change_stat[1].data, i}
								self:mapLogic(tmp, true)
							end

							SOCKET:getInstance("battle"):call("gangbattle" , "move" , "move" , {
								point = i,
								battle_id = self.params.battle_id,
								cmd2 = "activity"
							} , {
								no_loading = true,
								success_callback = function()
								end
							})
						else
							self:viewFormation(i)
						end
					end
				end
			})
			self.offsetX = point:getWidth() / 2
			self.offsetY = point:getHeight() / 2
		end
		--将据点按钮对象加入,据点是table，第一个是据点按钮，第二个 是据点的玩家占领标志,第三个是据点中的玩家
		self.points[i] = {}
		self.points[i][1] = point

		--		local function test()
		--			point:getLayer():runAction(getSequenceAction(CCScaleTo:create(1, 1.5),CCScaleTo:create(1,1), CCCallFunc:create(function()
		--				test()
		--			end)))
		--		end
		--		test()

		self.logicLayer:addChild(point:getLayer())

		--地图布线
		self:mapLine(pos, i, point)
	end

	if win then
		self:warOver(win)
		return
	end

	for k, v in pairs(init) do
		if string.find(k, "point") then
			local index = tonumber(string.sub(k, string.find(k, "([0-9]+)")))
			if v.goods == "box" then
				self.warItems[index] = display.newSprite(PATH.."box.png")
				setAnchPos(self.warItems[index], pos[index][1] - 15, pos[index][2])
				self.logicLayer:addChild(self.warItems[index])
			end
		else
			if v.stat == "hold" or v.stat == "init" or v.stat == "die" then
				if v.data == 1 or v.data == #pos then
					self.items[k] = Role:new(pos[v.data][1] + (v.group == 1 and 150 or 70), pos[v.data][2] + (v.group == 1 and 100 or 25), 3, {time = self.time, info = v})
				else
					if v.stat == "die" then
						self.items[k] = Role:new(pos[v.group == 1 and 1 or #pos][1] + (v.group == 1 and 150 or 70), pos[v.group == 1 and 1 or #pos][2] + (v.group == 1 and 100 or 25) , 3, {time = self.time, info = v})
					else
						self.items[k] = Role:new(pos[v.data][1] + self.offsetX, pos[v.data][2] + self.offsetY, 3, {time = self.time, info = v})
					end
				end
			elseif v.stat == "move" then
--				local startX = (v.data[1] == 1 or v.data[1] == #pos) and (pos[v.data[1]][1] + (v.group == 1 and 150 or self.offsetX)) or pos[v.data[1]][1]
--				local startY = pos[v.data[1]][2] + (v.group == 1 and 100 or self.offsetY)
--				
--				local desX = (v.data[2] == 1 or v.data[2] == #pos) and pos[2][1] or pos[v.data[2]][1]
--				local desY = pos[v.data[2]][2]
--				local tx, ty = 0, 0
--
--				if startX == desX then  --纵方向上
--					ty = (desY - startY) * percent
--				elseif startY == desY then -- 横方向上
--					tx = (desX - startX) * percent
--				else  --斜线上
--					print("------------------------------")
--					tx = (desX - startX) * percent
--					ty = (desY - startY) * percent
--				end
--
--				self.items[k] = Role:new(startX + self.offsetX + tx, startY + self.offsetY + ty, 1, {time = self.time, info = v})
--				--			if v.data[1] == 1 or v.data[1] == #pos then
--				--				self.items[k] = Role:new(pos[2][1] + self.offsetX + tx, pos[v.data[1]][2] + self.offsetY + ty,1, {time = self.time, info = v})
--				--			else
--				--				self.items[k] = Role:new(pos[v.data[1]][1] + self.offsetX + tx, pos[v.data[1]][2] + self.offsetY + ty,1, {time = self.time, info = v})
--				--			end
				local percent = (os.time() + TIME_OFFSET - v.time) / (v.effect and (v.effect.speed or self.params.move_time) or self.params.move_time)

				local startX = pos[v.data[1]][1] + (v.data[1] == 1 and 150 or (v.data[1] == #pos and 70 or self.offsetX))
				local startY = pos[v.data[1]][2] +(v.data[1] == 1 and 100 or (v.data[1] == #pos and 25 or self.offsetY)) 
				
				local desX = pos[v.data[2]][1] + (v.data[2] == 1 and 150 or (v.data[2] == #pos and 70 or self.offsetX))
				local desY = pos[v.data[2]][2] + (v.data[2] == 1 and 100 or (v.data[2] == #pos and 25 or self.offsetY)) 
				
				local curX = startX + (desX - startX) * percent
				local curY = startY + (desY - startY) * percent
				
				self.items[k] = Role:new(curX, curY,1, {time = self.time, info = v})
				local tmp = {
					["change_stat"] = {v}
				}
				self:mapLogic(tmp)
			elseif v.stat == "battle" then
				if type(v.old_data.data) == "table" then
					if v.battle.on_way == 1 then
					else
						self.items[k] = Role:new(pos[v.old_data.data[2]][1] + self.offsetX, pos[v.old_data.data[2]][2] + self.offsetY,1, {time = self.time, info = v})
					end
				else
					self.items[k] = Role:new(pos[v.old_data.data][1] + self.offsetX, pos[v.old_data.data][2] + self.offsetY,1, {time = self.time, info = v})
				end
			end
			self.logicLayer:addChild(self.items[k]:getLayer(), 2)

			--初始化设置据点状态
			self:setPtState(v, k)
		end

		--显示帮派buff
		if k == my then
			local y = 490
			for sk, sv in pairs(v.buff) do
				if sk == "bloodfull" then
					self.recoveryBuf = display.newSprite(PATH..sk..".png")
					self.recoveryBuf:setScale(0.6)
					self.logicLayer:addChild(self.recoveryBuf)
				else
					local sprite = display.newSprite(PATH..(sk == "hp" and "hpfu" or sk)..".png")
					setAnchPos(sprite, 0, y)
					sprite:setScale(0.6)
					self.logicLayer:addChild(sprite)
					y = y - sprite:getContentSize().height * 1.1 * 0.6
				end
			end

			if self.recoveryBuf then
				setAnchPos(self.recoveryBuf, 0, y)
			end
		end
	end


	self.score_1 = createLabel({str = (self.params.group_1_score or 0).."/"..self.params.score_max, size = 18, color = ccc3(0xe2, 0xe2, 0xe2)})
	setAnchPos(self.score_1, 400, 80, 0.5)
	self.logicLayer:addChild(self.score_1)

	local name1 = createLabel({str = self.params.group_1_name, size = 22, color = ccc3(0xe2, 0xe2, 0xe2), width = 200})
	setAnchPos(name1, 370, 15, 0.5)
	self.logicLayer:addChild(name1)

	local bloodBuf1 = createLabel({str = self.params.group_1_buff.blood, size = 20, color = ccc3(0xe2, 0xe2, 0xe2), width = 200})
	setAnchPos(bloodBuf1, 415, 50, 0.5)
	self.logicLayer:addChild(bloodBuf1)


	self.score_2 = createLabel({str = (self.params.group_2_score or 0).."/"..self.params.score_max, size = 18, color = ccc3(0xe2, 0xe2, 0xe2)})
	setAnchPos(self.score_2, 110, 810, 0.5)
	self.logicLayer:addChild(self.score_2)

	local name2 = createLabel({str = self.params.group_2_name, size = 22, color = ccc3(0xe2, 0xe2, 0xe2), width = 200})
	setAnchPos(name2, 80, 750, 0.5)
	self.logicLayer:addChild(name2)

	local bloodBuf2 = createLabel({str = self.params.group_2_buff.blood, size = 20, color = ccc3(0xe2, 0xe2, 0xe2), width = 200})
	setAnchPos(bloodBuf2, 120, 780, 0.5)
	self.logicLayer:addChild(bloodBuf2)
end

--掠夺战战场

function MapMgr:map2()
	if self.logicLayer then
		self.mapLayer:removeChild(self.logicLayer, true)
	end
	self.logicLayer = display.newLayer()

	self.mapLayer:addChild(self.logicLayer)

	--帮派名
	self.logicLayer:addChild(createLabel({str = self.params.b_alliance.name, x = 240, y = 670, width = 300, color = ccc3(255, 255, 255)}))
	--buff等级
	self.logicLayer:addChild(createLabel({str = self.params.a_alliance.buff[1], x = 170, y = 98, color = ccc3(255, 255, 255)}))
	self.logicLayer:addChild(createLabel({str = self.params.a_alliance.buff[2], x = 140, y = 72, color = ccc3(255, 255, 255)}))




	local pos = mapPos[2]
	local my = DATA_User:get("uid")..""

	for i = 1, #pos do
		local str
		if i == 1 then
			str = "lueduo.png"
		elseif i == #pos then
			str = "target.png"
		else
			str = "pt_empty.png"
		end
		local point
		point = KNBtn:new(PATH, {str}, pos[i][1], pos[i][2], {
			id = i,
			anchMid = true,
			callback = function()
				local function move()
					HTTP:call("lueduo", "move", {}, {
						no_loading = true,
						success_callback = function()
						end })
					local temp = self.items[my]:getInfo()
					temp.stat = 1
					temp.time = os.time() + TIME_OFFSET
					self.items[my]:move(pos[i][1], pos[i][2], temp)
				end

				if i == 1 or i == #pos then
					if i == #pos then
						if self.items[my] and self.items[my]:getInfo().point == i - 1 and self.items[my]:getInfo().stat == 0 then
							move()
						else
							self:look(#pos, 100)
						end
					elseif i == 1 then
						if self.params.user_info[my] then
							KNMsg.getInstance():flashShow("全员已做好战斗准备，抢房抢车抢票子啊！~")
						else
							KNMsg.getInstance():flashShow("敌方来势汹汹，请做好战斗准备")
						end
						--						HTTP:call("lueduo", "onend", {alliance = self.params.a_alliance.id}, {
						--
						--						})
					end

				else
					if self.items[my] then  --自己是攻击方
						if not self.fighting and self.items[my]:getInfo().stat == 0 and i == self.items[my]:getInfo().point + 1 then
							move()
						elseif self.items[my]:getInfo().stat == 2 then
							KNMsg.getInstance():flashShow("你已战死，坐看基友们为你报仇吧")
						else
							if self.params.point_info[i..""].stat == 1 then
								self:look(self.params.point_info[i..""])
							else
								if self.items[my]:getInfo().point < i then
									KNMsg.getInstance():flashShow("据点已被基友占领，不要掉队呦~")
								else
									KNMsg.getInstance():flashShow("妹妹你大胆滴往前走哇，莫回呀头！~")
								end
							end
						end
					else  --自己是防守方
						self:look(self.params.point_info[i..""])
					end
				end
			end})

		self.logicLayer:addChild(point:getLayer(), 1)

		self:mapLine(pos, i, point)


		self.points[i] = {}
		self.points[i][1] = point
	end

	self:updateStat(self.params, true)

end

--更新状态
function MapMgr:updateStat(data, enter)
	local pos = mapPos[self.mapId]
	--更新据点状态
	if data.point_info then
		for k, v in pairs(data.point_info) do

			self.params.point_info[k] = v

			local point, sign, flag
			local index = tonumber(k)

			point = self.points[index][1]
			sign = self.points[index][2]
			flag = self.points[index][3]

			if sign then
				self.logicLayer:removeChild(sign, true)
			end

			if flag then
				flag:showBtn(false)
			else
				flag = KNBtn:new(PATH, {"flag_enemy.png"}, point:getX() - 18, point:getY() - 5 , {
					--						other = {COMMONPATH.."egg_num_bg.png", 20, 23},
					--						text = {5, 16, ccc3(255, 255, 255), ccp(0,1), nil, 20},
					callback = function()
						point:call()
					end
				})
				flag:showBtn(false)
				self.logicLayer:addChild(flag:getLayer(), 4)
			end

			if index ~= 1 and index ~= #pos then
				if v.stat == 1 then
					sign = display.newSprite(PATH.."pt_enemy.png")
					flag:setBg(1, PATH.."flag_enemy.png")
				elseif v.stat == 0 then
					sign = display.newSprite(PATH.."pt_our.png")
					flag:setBg(1, PATH.."flag_our.png")
				end
				setAnchPos(sign, point:getX(), point:getY(), 0.5, 0.5)
				self.logicLayer:addChild(sign, 2)

				flag:showBtn(true)
			end
		end
	end

	--更新用户状态
	if data.user_info then
		for k, v in pairs(data.user_info) do
			v.endtime = v.time
			v.time = v.endtime - self.params.move_time
			v.group = 1
			--不存在时先生成对象
			if not self.items[k] then
				self.items[k] = Role:new(pos[v.point][1], pos[v.point][2], 3, {time = self.params.move_time, info = v})
				self.logicLayer:addChild(self.items[k]:getLayer(), 3)
			end

			if v.stat == 0 then--占领
				self.items[k]:hold(pos[v.point][1], pos[v.point][2], 3, v)
			elseif v.stat == 1 then --移动
				self.items[k]:move(pos[v.point + 1][1], pos[v.point + 1][2], v)
			elseif v.stat == 2 then -- 死亡
				if not enter then
					self.items[k]:backHome(pos[1][1], pos[1][2], v)
				end
			end

			--当是自己的移动时显示可移动的位置提示
			if not self.fighting and tonumber(v.uid)== tonumber(DATA_User:get("uid")) then
				if v.stat == 0 then
					self:moveTip(v.point + 1)
				else
					self:moveTip(nil, true)
				end
			end
		end
	end

	--战斗动画
	if data.battle_action then
		if data.battle_action["end"] then
			self:lueduoOver(data.battle_action["end"])
			return
		end

		--自己发生战斗
		if tonumber(data.battle_action.uid) == tonumber(DATA_User:get("uid")) then
			self.fighting = true
		end

		local count = 0
		local function play()
			local frames = display.newFramesWithImage(PATH .. "fight_effect.png" , 6 )
			local ani
			ani = display.playFrames(pos[data.battle_action.point][1], pos[data.battle_action.point][2], frames, 0.1, {
				onComplete = function()
					self.logicLayer:removeChild(ani, true)
					count = count + 1
					if count < 2 then
						play()
					else
						if data.battle_action.win == 1 then
							if self.fighting then
								self:moveTip(data.battle_action.point + 1)
								self.fighting = false
							end
						else
						end
					end
				end

			})
			self.logicLayer:addChild(ani, 5)
		end

		play()
	end

end

--移动数据， click点击发送的移动命令
function MapMgr:mapLogic(data, click)
	print("----------------------")
	if data.win then
		self:warOver(data.win)
		return
	end

	local x, y
	local pos = mapPos[self.mapId]
	--对于所有改变的状态循环处理
	for n, v in pairs(data.change_stat) do
		if v.type == "point" then
			if v.goods == "" then
				if self.warItems[v.data] then
					self.logicLayer:removeChild(self.warItems[v.data], true)
					self.warItems[v.data] = nil
				end
			elseif v.goods == "box" then
				self.warItems[v.data] = display.newSprite(PATH.."box.png")
				setAnchPos(self.warItems[v.data], pos[v.data][1] - 15, pos[v.data][2])
				self.logicLayer:addChild(self.warItems[v.data])
			end
		else
			local k = v.uid..""

			--设置据点的显示	状态
			self:setPtState(v, k)

			if v.stat == "move" then
				local i = v.data[2]
				local j = v.data[1]

				if v.data[2] == 1 or v.data[2] == #pos then
					self.items[k]:move(pos[v.data[2]][1] + (v.group == 2 and 130 or self.offsetX), pos[v.data[2]][2] + (v.group == 2 and 100 or self.offsetY ), v)
				else
					self.items[k]:move(pos[v.data[2]][1] + self.offsetX, pos[v.data[2]][2] + self.offsetY, v)
				end

				--			if self.items[k]:isUserSelf() and not click then
				if false then
					local line = display.newSprite(PATH.."move_line.png")
					self.logicLayer:addChild(line, -1)

					local total = line:getContentSize().width
					local start = v.data[1]
					local des = v.data[2]

					local sx, sy, dx, dy
					sx = (start == 1 or start == #pos) and pos[2][1] or pos[start][1]
					sy = pos[start][2]
					dx = (des == 1 or des == #pos ) and pos[2][1] or pos[des][1]
					dy = pos[des][2]

					local rotate = 0
					local cha = 0

					setAnchPos(line, sx + self.offsetX, sy + self.offsetY , 0, 0.5)

					if sx == dx then--纵方向上
						if sy > dy then
							rotate = 90
						else
							rotate = -90
						end
					elseif sy == dy then-- 横方向上
						if sx > dx then
							rotate = 180
						end
					else  --斜方向上
						rotate = math.deg(math.atan((dy - sy) / (dx - sx)))
						if dy > sy then
							rotate = rotate - 90
							if dx < sx then
								print("------向左上")
								rotate = rotate - 12
							else
								print("------向若上")
								rotate = rotate + 12
							end
						else
							rotate = rotate + 90
							if dx < sx then
								print("向左下")
								rotate = rotate + 12
							else
								print("向右下")
								rotate = rotate - 12.5
							end
						end
						total = total * 1.3
					end

					line:setRotation(rotate)

					line:setTextureRect(CCRectMake(0, 0, 0, line:getContentSize().height))

					local entry
					entry = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
						xpcall(function()
							line:setTextureRect(CCRectMake(0, 0, 0, line:getContentSize().height))
							local x2 = self.items[k]:getLayer():getPositionX()
							local y2 = self.items[k]:getLayer():getPositionY()


							local now = math.sqrt((x2 - sx ) * (x2 - sx) + (y2 - sy) * (y2 - sy))

							line:setTextureRect(CCRectMake(0, 0, now, line:getContentSize().height))
							if self.items[k]:getInfo().stat ~= "move" then
								self.logicLayer:removeChild(line, true)
								CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(entry)
							end
						end
						,function()
							CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(entry)
						end)
					end, 0.1, false)
				end
			elseif v.stat == "jump" then
				self.items[k]:setState(1,1)
			elseif v.stat == "die" then
--				self.items[k] = Role:new(pos[2][1] + self.offsetX, pos[v.group == 1 and 1 or #pos][2] + self.offsetY, 3, {time = self.time, info = v})
				self.items[k]:backHome(pos[v.group == 1 and 1 or #pos][1] + (v.group == 1 and 150 or self.offsetX), pos[v.group == 1 and 1 or #pos][2] + (v.group == 1 and 100 or self.offsetY ), v)
			elseif v.stat == "hold" then
				if v.old_data.battle then   --发生过战斗
					if v.old_data.battle.win == 0 then  --战斗失败
						self.items[k]:backHome(pos[v.group == 1 and 1 or #pos][1] + (v.group == 1 and 150 or self.offsetX), pos[v.group == 1 and 1 or #pos][2] + (v.group == 1 and 100 or self.offsetY ) )
					else
						if v.data == 1 or v.data == #pos then
							self.items[k]:hold(pos[v.data][1] + self.offsetX, pos[v.data][2] + self.baseY, true, v)
						else
							self.items[k]:hold(pos[v.data][1] + self.offsetX, pos[v.data][2] + self.offsetY, false, v)
						end
					end
				else
					if v.data == 1 or v.data == #pos then
						self.items[k]:hold(pos[v.data][1] + self.offsetX, pos[v.data][2] + self.baseY, true, v)
					else
						self.items[k]:hold(pos[v.data][1] + self.offsetX, pos[v.data][2] + self.offsetY, false, v)
					end
				end
				if v.score > v.old_data.score then
					local text = getImageNum(v.score - v.old_data.score, COMMONPATH.."cirt.png")
					setAnchPos(text, pos[v.data][1], pos[v.data][2], 0.5)
					text:setScale(0)
					self.logicLayer:addChild(text, 10)
					text:runAction(getSequenceAction(CCEaseElasticOut:create(
					CCScaleTo:create(0.5, 1)),
					CCJumpTo:create(0.5, ccp(110, (v.group == 1 and 50 or 800)), 50, 1),
					CCCallFunc:create(function()
						self.logicLayer:removeChild(text, true)
					end)))
				end

			elseif v.stat == "battle" then
				if tonumber(v.uid) == tonumber(DATA_User:get("uid")) then   --自己发生战斗时，战报有动画效果
					local function tip()
						self.reportBtn:getLayer():stopAllActions()
						self.reportBtn:getLayer():runAction(getSequenceAction(CCScaleTo:create(0.2, 1.3),CCScaleTo:create(0.2, 1), CCCallFunc:create(function()
							tip()
						end)))
					end
					tip()
				end
				--这里获取战斗发生的位置,
				if v.battle.on_way == 0 then  --在据点战斗
					local desPos
					if type(v.old_data.data) == "number" then
						desPos = v.old_data.data
					else
						desPos = v.old_data.data[2]
					end

					x = pos[desPos][1]
					y = pos[desPos][2]

					if desPos == 1 then
						x = x + self.baseX
						y = y + self.baseY
					elseif desPos == #pos then
						x = x + self.baseX
						y = y - self.baseY
					else
						x = x + self.offsetX
						y = y + self.offsetY
					end
				else
					if pos[v.old_data.data[1]][1] == pos[v.old_data.data[2]][1] then   --纵向发生的战斗
						x = pos[(v.old_data.data[2] == 1 or v.old_data.data[2] == #pos) and 2 or v.old_data.data[2]][1] + self.offsetX
						y = pos[v.old_data.data[1]][2] + self.offsetY + (pos[v.old_data.data[2]][2] - pos[v.old_data.data[1]][2]) / 2
					elseif pos[v.old_data.data[1]][2] == pos[v.old_data.data[2]][2] then --横向发生的战斗
						x = pos[v.old_data.data[1]][1] + self.offsetX + (pos[v.old_data.data[2]][1] - pos[v.old_data.data[1]][1]) / 2
						y = pos[v.old_data.data[1]][2] + self.offsetY
					else -- 斜线上发生的战斗
						x = pos[v.old_data.data[1]][1] + self.offsetX + (pos[v.old_data.data[2]][1] - pos[v.old_data.data[1]][1]) / 2
						y = pos[v.old_data.data[1]][2] + self.offsetY + (pos[v.old_data.data[2]][2] - pos[v.old_data.data[1]][2]) / 2
					end
				end

				self.items[k]:battle(x, y)
				--战斗动画
				if not self.fightAni[v.battle.report_id] then
					local frames = display.newFramesWithImage(PATH .. "fight_effect.png" , 6 )
					self.fightAni[v.battle.report_id] = display.playFrames(x, y, frames, 0.1, {
						forever = true
					})
					self.logicLayer:addChild(self.fightAni[v.battle.report_id], 4)
				end
			end
			if v.old_data.battle then   --发生过战斗
				--将战斗的特效移除
				if self.fightAni[v.old_data.battle.report_id] then
					self.logicLayer:removeChild(self.fightAni[v.old_data.battle.report_id], true)
					self.fightAni[v.old_data.battle.report_id] = nil
				end

				if v.combo == 3 then
					KNMsg.getInstance():flashShow("【"..v.name.."】在帮战战斗中已经【一夫当关】了")
				elseif v.combo == 5 then
					KNMsg.getInstance():flashShow("【"..v.name.."】在帮战战斗中已经【横扫千军】了")
				elseif v.combo >= 7 then
					KNMsg.getInstance():flashShow("【"..v.name.."】在帮战战斗中已经【统令三军】了")
				end
			end

			--若是自己则要更新状态
			if tonumber(k) == tonumber(DATA_User:get("uid")) then
				if self.recoveryBuf and v.buff.bloodfull == nil then
					KNMsg.getInstance():flashShow("恢复道具已使用，您的英雄满状态复活，继续征战吧，少年!~")
					self.logicLayer:removeChild(self.recoveryBuf, true)
					self.recoveryBuf = nil
				end

				if v.stat == "hold" and v.effect then
					local str
					if v.effect.name == "jump" then
						str = "你得到跳跃符，可直接进入下一个可移动节点"
					elseif v.effect.name == "stop" then
						str = "你得到定身符，10秒内不能移动"
					elseif v.effect.name == "fast" then
						str = "你得到加速符，下次移动时间减少到10秒"
					elseif v.effect.name == "slow" then
						str ="得到减速符，下次移动时间增加10秒"
					elseif v.effect.name == "invisibility" then
						str = "你得到隐身符，下次行军可隐身"
					end
					KNMsg.getInstance():flashShow(str)
				end
			end
		end
	end

	if data.score_1 and data.score_2 and data.limit_time then
		self.score_1:setString(data.score_1.."/"..self.params.score_max)
		self.score_2:setString(data.score_2.."/"..self.params.score_max)
		self.params.limit_time = data.limit_time
	end
end

--根据状态设置当前据点的显示, v是用户数据， k是参战人员uid
function MapMgr:setPtState(v, k)
	local index, pt, signs, users
	if v.stat == "hold" then
		index = v.data
	elseif v.stat == "move" or v.stat == "jump" then
		index = v.data[1]
	elseif v.stat == "die" then
		if type(v.data) == "number" then
			index = v.data
		end
	end

	if self.points[index] then
		if not self.points[index][2] then
			self.points[index][2] = {}
		end

		if not self.points[index][3] then
			self.points[index][3] = {}
		end

		pt = self.points[index][1]    --据点
		signs = self.points[index][2] --标志，颜色与旗帜
		users = self.points[index][3] --据点中的玩家

		if v.stat == "move" or v.stat == "die" or v.stat == "jump" then
			users[k] = nil
		else
			users[k] = k
		end

		if index == 1 or index == #mapPos[self.mapId] then
			return
		end

		if not signs["pt"..v.group] then  --玩家占领的据点颜色
			if table.nums(users) > 0 then
				signs["pt"..v.group] = display.newSprite(PATH..(v.group == 1 and "pt_our.png" or "pt_enemy.png"))
				setAnchPos(signs["pt"..v.group], pt:getX(), pt:getY())
				self.logicLayer:addChild(signs["pt"..v.group], 1)
			end
		else
			if v.stat == "move" or v.stat == "jump" then
				if table.nums(users) == 0 then
					if signs["pt1"] then
						signs["pt1"]:setVisible(false)
					end
					if signs["pt2"] then
						signs["pt2"]:setVisible(false)
					end
				end
			else
				signs["pt"..v.group]:setVisible(true)
			end
		end

		if not signs["flag"] then --玩家占领 的据点旗帜
			if table.nums(users) > 0 then
				signs["flag"] = KNBtn:new(PATH, {v.group == 1 and "flag_our.png" or "flag_enemy.png"}, pt:getX() + self.offsetX / 4, pt:getY() + self.offsetY / 1.5, {
					other = {COMMONPATH.."egg_num_bg.png", 20, 23},
					text = {table.nums(users), 16, ccc3(255, 255, 255), ccp(0,1), nil, 20},
					callback = function()
						pt:call()
					end
				})
				self.logicLayer:addChild(signs["flag"]:getLayer(), 3)
			end
		else
			signs["flag"]:setText(table.nums(users))
			if v.stat == "move" or v.stat == "jump" then
				if table.nums(users) == 0 then
					signs["flag"]:showBtn(false)
				end
			else
				signs["flag"]:showBtn(true)
				signs["flag"]:setBg(1, v.group == 1 and PATH.."flag_our.png" or PATH.."flag_enemy.png")
			end
		end
	end

	--当是自己的移动时显示可移动的位置提示
	if tonumber(v.uid)== tonumber(DATA_User:get("uid")) then
		if v.stat == "hold" then
			for sk, sv in pairs(self.params.map.point[v.data..""].next) do
				if sv ~= self.params.map.base["base_"..v.group] then
					self:moveTip(sv)
				end
			end
		else
			self:moveTip(nil, true)
		end
	end
end

function MapMgr:getLayer()
	return self.baseLayer
end

function MapMgr:showReport(data)
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer})

	local bg = display.newSprite(IMG_PATH.."image/scene/mission/wipe_bg.png")
	setAnchPos(bg, 250, 425, 0.5, 0.5)
	layer:addChild(bg)

	local title = display.newSprite(IMG_PATH.."image/scene/mission/title_bg.png")
	setAnchPos(title, 260, 560, 0.5)
	layer:addChild(title)

	title = display.newSprite(PATH.."title.png")
	setAnchPos(title, 250, 570, 0.5)
	layer:addChild(title)

	local back = KNBtn:new(COMMONPATH, {"back_img.png", "back_img_press.png"}, 50, 540, {
		priority = -131,
		callback = function()
			mask:remove()
		end
	})
	layer:addChild(back:getLayer())

	local function createItem(index)
		local report
		report = display.newLayer()
		local itemBg = display.newSprite(PATH.."report_bg.png")
		setAnchPos(itemBg)

		report:setContentSize(CCSizeMake(bg:getContentSize().width, itemBg:getContentSize().height))
		report:addChild(itemBg)

		local opt = KNBtn:new(COMMONPATH, {"btn_bg.png", "btn_bg_pre.png"}, 330, 15, {
			priority = -131,
			front = IMG_PATH.."image/scene/friend/text_operate.png",
			callback = function()
				local result = display.newLayer()
				local mask = KNMask:new({item = result, priority = -132})

				local bg = display.newSprite(COMMONPATH.."tip_bg.png")
				setAnchPos(bg, 250, 425, 0.5, 0.5)
				result:addChild(bg)

				local x, y
				--武将的状态显示
				for k, v in pairs(data[index].remain_general) do
					if k == "on" then
						y = 480
					else
						y = 380
					end
					for i = 1, #v do
						local btn = KNBtn:new(SCENECOMMON, {"skill_frame1.png"}, 65 + (i - 1) * 100, y, {
							other = {COMMONPATH.."egg_num_bg.png", 50, 50},
							text = {v[i].lv, 18, ccc3(255,255,255), ccp(28, 28), nil, 20 },
							front = getImageByType(v[i].cid, "s")
						})
						result:addChild(btn:getLayer())

						local hp = KNProgress:new(PATH, {"hp_bg.png", "hp_full.png"}, 65 + (i - 1) * 100, y - 10, {
							cur = v[i].hp,
							max = v[i].org_hp
						})
						result:addChild(hp:getLayer())
					end
				end

				local replay = KNBtn:new(PATH, {"replay.png", "replay_press.png"}, 380, 310, {
					priority = -133,
					callback = function()
						local str
						if self.params.mapId == 1 then
							str = "gangbattle"
						else
							str = "lueduo"
						end
						HTTP:call(str, "getreport", {report_id = data[index].report_id}, {
							success_callback = function(data)
								DATA_Battle:setMod("guide")
								DATA_Battle:setAct("execute")
								DATA_Battle:set( data )
								switchScene("battle" , { resultCallFun = function()end, overFun = function()
										if self.params.mapId == 1 then
											HTTP:call("gangbattle", "enter", {}, {
												success_callback = function(data)
													switchScene("war", data)
												end,error_callback = function(data)
													HTTP:call("bangzhan","frontpage_info",{ },{success_callback =
														function()
															switchScene("gang",{}, function()
																KNMsg.getInstance():flashShow(data.msg)
															end)
														end})
												end
											})
										else
											HTTP:call("lueduo", "enter", {}, {
												success_callback = function(data)
													data["summary"]["mapId"] = 2
													data["summary"]["limit_time"] =data["limit_time"]
													switchScene("war", data["summary"])
												end, error_callback = function(data)
													switchScene("gang", {}, function()
														KNMsg.getInstance():flashShow(data.msg)
													end)
												end
											})
										end
									end })
							end
						})
					end
				})
				result:addChild(replay:getLayer())

				local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 180, 310, {
					priority = -133,
					front = COMMONPATH.."colse_text.png",
					callback = function()
						mask:remove()
					end
				})
				result:addChild(close:getLayer())

				layer:addChild(mask:getLayer())
			end
		})
		report:addChild(opt:getLayer())

		local str
		if data[index].win == 1 then
			str =  "【"..DATA_User:get("name").."】战胜了【"..data[index]["uid_2_name"].."】"
		else
			str =  "【"..DATA_User:get("name").."】被【"..data[index]["uid_2_name"].."】打败了"
		end

		local alive = 0
		for k, v in pairs(data[index].remain_general) do
			for sk, sv in pairs(v) do
				if sv.hp > 0 then
					alive = alive + 1
				end
			end
		end
		str = str..",当前存活武将数"..alive.."人"
		local oneMsg = createLabel({str = replaceStr(str), color = ccc3(255, 255, 255), size = 18, width = 310, x = 10, y = 15})
		oneMsg:setDimensions( CCSize:new( oneMsg:getContentSize().width ,0 ) )
		report:addChild(oneMsg)
		return report
	end

	for i = 1, #data do
		local report = createItem(i)
		setAnchPos(report, 45, 475 - (i - 1) * (report:getContentSize().height + 5))
		layer:addChild(report)
	end

	return mask:getLayer()
end

--掠夺战结束逻辑
function MapMgr:lueduoOver(data)
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer, priority = -150})

	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	layer:addChild(bg)

	local str
	local my = self.params.user_info[DATA_User:get("uid")..""]
	if (data.win == 1 and my) or (data.win == 0 and not my)  then
		if my then
			if data.beat_back == 0 then
				str = "恭喜你，掠夺成功！ 对方成为你的附属帮派\n,并掠夺帮派资金"..data.a_alliance.funds
			else
				str = "恭喜你，你的帮派在本次反击战中胜利了！成功解除与【"..data.b_alliance.name.."】的附属关系！~"
			end
		else
			str = "本帮成功防守住了敌人的凶狠进攻！再接再厉！"
		end
		bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/win/win_title_bg.png")
		setAnchPos(bg, 240, 500, 0.5)
		layer:addChild(bg)
		bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/win/mission_win.png")
	else
		if my then
			if data.beat_back == 0 then
				str = "你的帮派在本次掠夺战中失败了，请继续努力提升实力！\n 下一次掠夺战可获得等级"..data.a_alliance.buff[1].."的背水一战属性"
			else
				str = "你的帮派在本次反击战中失败了，请继续努力提升实力！ "
			end
		else
			str = "帮派"..self.params.a_alliance.name.."来势汹汹，我帮不敌，赶紧撤吧。"
		end
		bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/lost/lost_title.png")
	end

	setAnchPos(bg, 240, 500, 0.5)
	layer:addChild(bg)
	--
	local tipText = createLabel({str = replaceStr(str), x = 40, y = 400, size = 20, color = ccc3(0x2c, 0, 0), width = 400})
	tipText:setDimensions( CCSize:new( tipText:getContentSize().width ,tipText:getContentSize().height+10  ) )
	setAnchPos(tipText, 240, 400, 0.5)
	layer:addChild(tipText)
	--
	--
	local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 160, 310, {
		front = COMMONPATH.."colse_text.png",
		priority = -151,
		callback = function()
			switchScene("gang")
		end
	})
	layer:addChild(close:getLayer())
	layer:setScale(0)
	layer:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.5, 1)))
	--
	self.parent:getLayer():addChild(mask:getLayer(), 10)
end

--帮战结束，
function MapMgr:warOver(group)
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer, priority = -150})

	local bg = display.newSprite(COMMONPATH.."tip_bg.png")
	setAnchPos(bg, 240, 425, 0.5, 0.5)
	layer:addChild(bg)

	local str
	if self.allowOpt then
		if self.params.stat[DATA_User:get("uid")].group == group then
			str = "恭喜你，你的帮派在本次帮战中胜利了！ "
			bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/win/win_title_bg.png")
			setAnchPos(bg, 240, 500, 0.5)
			layer:addChild(bg)
			bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/win/mission_win.png")
		else
			str = "你的帮派在本次帮战中失败了，请继续努力提升实力！ "
			bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/lost/lost_title.png")
		end

	else
		bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/win/win_title_bg.png")
		setAnchPos(bg, 240, 500, 0.5)
		layer:addChild(bg)
		bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/win/mission_win.png")
		str = "帮战结束，帮派"..self.params["group_"..group.."_name"].."赢得了比赛"
	end

	setAnchPos(bg, 240, 500, 0.5)
	layer:addChild(bg)

	local tipText = createLabel({str = replaceStr(str), x = 40, y = 400, size = 20, color = ccc3(0x2c, 0, 0), width = 400})
	setAnchPos(tipText, 240, 400, 0.5)
	layer:addChild(tipText)


	local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 160, 310, {
		front = COMMONPATH.."colse_text.png",
		priority = -151,
		callback = function()
			--帮派
			HTTP:call("alliance", "get", {},{success_callback =
				function()
					switchScene("gang" , {type = 12})
				end})
		end
	})
	layer:addChild(close:getLayer())
	layer:setScale(0)
	layer:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.5, 1)))

	self.parent:getLayer():addChild(mask:getLayer(), 10)
end

--显示自己可走位置的提示图标
function MapMgr:moveTip(pt, clear)
	if clear then
		for k, v in pairs(self.tips) do
			self.logicLayer:removeChild(self.tips[k], true)
			self.tips[k] = nil
		end
	else
		if not self.tips[pt] then
			local x, y
			x = mapPos[self.mapId][pt][1]
			y = mapPos[self.mapId][pt][2]

			if pt == 1 or pt == #mapPos[self.mapId] then
				x = x + self.baseX
				y = y + self.baseY
			else
				x = x + self.offsetX
				y = y + self.offsetY
			end
			local frames = display.newFramesWithImage(IMG_PATH.."image/scene/battle/pet/click_tip.png" , 6 )
			self.tips[pt] = display.playFrames(x, y,frames, 0.2, {
				forever = true,
			})
			self.logicLayer:addChild(self.tips[pt], 2)
		end
	end
end

--倒计时
function MapMgr:showTimeCount(time)
	local layer = display.newLayer()
	local mask = KNMask:new({item = layer, opacity = 225})

	local text = display.newSprite(PATH.."time_count_text.png")
	setAnchPos(text, 240, 500, 0.5)
	layer:addChild(text)

	local bg = display.newSprite(IMG_PATH.."image/scene/battle/fruit/win/row/row_num_bg.png")
	setAnchPos(bg, 240, 350, 0.5)
	layer:addChild(bg)

	local timeText = getImageNum(time, COMMONPATH.."cirt.png")
	setAnchPos(timeText, 240, 400, 0.5)
	layer:addChild(timeText)

	Clock:addTimeFun("war_time_count", function()
		if time > 1 then
			time = time - 1
			layer:removeChild(timeText, true)
			timeText = getImageNum(time, COMMONPATH.."cirt.png")
			setAnchPos(timeText, 240, 400, 0.5)
			layer:addChild(timeText)
		else
			Clock:removeTimeFun("war_time_count")
			self.parent:getLayer():removeChild(mask:getLayer(), true)
		end
	end)


	self.parent:getLayer():addChild(mask:getLayer(),10)
end

--查看据点
function MapMgr:look(v, value)
	local report = display.newLayer()
	local mask = KNMask:new({item = report})

	local bg = display.newSprite(PATH.."info_bg.png")
	setAnchPos(bg)

	report:setContentSize(CCSizeMake(bg:getContentSize().width, bg:getContentSize().height))
	--		setAnchPos(report, 30, (group == 1 and 20 or 460), 0.5)
	setAnchPos(report, 30, 300)
	report:addChild(bg)


	if value then
		local str
		if self.params.beat_back == 1 then
			str = "反击战胜利可以解除附庸关系"
		else
			str = "预计可抢夺资金："..self.params.funds
		end
		local text = createLabel({str = str, width = 400, size = 24, color = ccc3(255, 255, 255)})
		setAnchPos(text, 210, 140, 0.5)
		report:addChild(text)
	elseif v.name == "null" then
		local empty = display.newSprite(COMMONPATH.."empty.png")
		setAnchPos(empty, 210, 70, 0.5)
		report:addChild(empty)
	else
		local count = 7
		local btn = KNBtn:new(COMMONPATH, {getHeadPath(v.sex)}, 20 + (count - 5 >= 0 and count - 5 or count) * 80, 250 - (count >= 5 and 1 or 0) * 110, {
			text = {{v.name, 18, ccc3(0xff, 0xfb, 0xd4), ccp(0, -40)},{v.lv, 18, ccc3(0xff, 0xfb, 0xd4), ccp(30, 30), nil, 17}},
			other = {COMMONPATH.."egg_num_bg.png", 50, 50},
			front = COMMONPATH.."role_frame.png",
		})
		report:addChild(btn:getLayer())
	end


	local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 130, 10, {
		priority = -133,
		front = COMMONPATH.."colse_text.png",
		callback = function()
			mask:remove()
		end
	})
	report:addChild(close:getLayer())

	self.baseLayer:addChild(mask:getLayer(),15)
end

function MapMgr:viewFormation(index)
	local group
	if index == 1 then
		group = 1
	elseif index == #mapPos[self.mapId] then
		group = 2
	else
		if not self.points[index][3] or table.nums(self.points[index][3]) == 0 then
			return
		else
			for k, v in pairs(self.points[index][3]) do
				group = self.params.stat[k].group
				break
			end
		end
	end


	local report = display.newLayer()
	local mask = KNMask:new({item = report})

	local bg = display.newSprite(PATH.."info_bg.png")
	setAnchPos(bg , 30 , 300)

	-- report:setContentSize(CCSizeMake(bg:getContentSize().width, bg:getContentSize().height))
	--		setAnchPos(report, 30, (group == 1 and 20 or 460), 0.5)
	-- setAnchPos(report, 30, 300)
	report:addChild(bg)

	local scroll = KNScrollView:new( 47, 352, 392, 216 , 5 , false , nil , { priority = -142 }  )
	local count = 0

	local scroll_item

	for k, v in pairs(self.items) do
		local tmp = v:getInfo()
		if tmp.group == group then
			if (group == 1 and tmp.data == index and tmp.stat ~= "die") or (group == 2 and tmp.data == index and tmp.stat ~= "die") or ((index == 1 or index == #mapPos[self.mapId]) and tmp.stat == "die") then
				local btn = KNBtn:new(COMMONPATH, {getHeadPath(tmp.sex)}, (count % 5 ) * 80, 25, {
					text = {{tmp.name, 18, ccc3(0xff, 0xfb, 0xd4), ccp(0, -40)},{tmp.lv, 18, ccc3(0xff, 0xfb, 0xd4), ccp(30, 30), nil, 17}},
					other = {COMMONPATH.."egg_num_bg.png", 50, 50},
					front = COMMONPATH.."role_frame.png",
				})

				if count % 5 == 0 then 
					scroll_item = display.newLayer()
					scroll_item:setContentSize( CCSize( scroll:getWidth() , btn:getLayer():getContentSize().height + 25 ) )

					scroll:addChild( scroll_item )
				end

				scroll_item:addChild(btn:getLayer())

				count = count + 1
			end
		end
	end

	report:addChild( scroll:getLayer() )


	if count == 0 then
		local empty = display.newSprite(COMMONPATH.."empty.png")
		setAnchPos(empty, 210, 70, 0.5)
		report:addChild(empty)
	end

	local close = KNBtn:new(COMMONPATH, {"btn_bg_red.png", "btn_bg_red_pre.png"}, 160, 307, {
		priority = -133,
		front = COMMONPATH.."colse_text.png",
		callback = function()
			mask:remove()
		end
	})
	report:addChild(close:getLayer())

	self.baseLayer:addChild(mask:getLayer(),15)
end

return MapMgr