local KNBtn = requires(IMG_PATH, "GameLuaScript/Common/KNBtn")
local PATH = IMG_PATH.."image/scene/war/"
local Mgr = requires(IMG_PATH, "GameLuaScript/Scene/war/mapmgr")

local WarLayer = {
	baseLayer,
	layer,
	mgr,
	init
}

function WarLayer:new(data)
	local this = {}
	self.__index = self
	setmetatable(this, self)
	
	this.baseLayer = display.newLayer()
	this.init = data
	
	local bg = display.newSprite(PATH.."bg"..(this.init.mapId or 1)..".jpg")
	setAnchPos(bg)
	this.baseLayer:addChild(bg)
	if data.mapId == 2 then
		bg = display.newSprite(IMG_PATH.."image/scene/strengthen/up_bg.png")
		setAnchPos(bg, 30, 60)
		this.baseLayer:addChild(bg)
		
		bg = display.newSprite(PATH.."buf_text.png")
		setAnchPos(bg, 45, 70)
		this.baseLayer:addChild(bg)
		
		bg = display.newSprite(PATH.."gang_text.png")
		setAnchPos(bg, 190, 670)
		this.baseLayer:addChild(bg)
	
	else
		bg = display.newSprite(PATH.."score_bg.png")
		setAnchPos(bg, 300, 10)
		this.baseLayer:addChild(bg)
		
		bg = display.newSprite(PATH.."score_bg.png")
		setAnchPos(bg, 10, display.height - bg:getContentSize().height - 10)
		this.baseLayer:addChild(bg)
	end
	
	bg = display.newSprite(PATH.."time_bg.png")
	setAnchPos(bg, 10, 10)
	this.baseLayer:addChild(bg)
	
	local back = KNBtn:new(IMG_PATH.."image/scene/login", {"back.png", "back_pre.png"}, 20, 675, {
		callback = function()
			if this.init.mapId == 2 then
				switchScene("gang")
			else
				local function enter()
					switchScene(this.init.back and this.init.back or "gang", {coming = (this.init.back == "pvp" and "war" or nil)})
				end
				
				if this.init.stat[DATA_User:get("uid")..""] then
					enter()
				else
					HTTP:call("gangbattle", "quit", {battle_id = this.init.battle_id}, {success_callback = function()
						enter()
					end})
				end
			end
		end
	})
	this.baseLayer:addChild(back:getLayer())
	
	this:warMap()
	
	local btn_images = {"aide.png" , "aide_press.png"}
	local curTalk
	if checkOpened("talk") ~= true then btn_images = {"aide_press.png"} end
	local temp = KNBtn:new( IMG_PATH .. "image/scene/chat/"  , {"talk_flag1.png"} , 410 , 700 , {
		scale = true ,
		front =  IMG_PATH .. "image/scene/chat/talk_flag.png" , 
		callback = function()
			DATA_Info:setIsMsg( false )
			if DATA_Info:getIsOpen( ) then

				local talkLayer

				if device.platform == "android" and ( ( __INNER_VERSION__ and __INNER_VERSION__ >= 4 and CHANNEL_GROUP ~= "td") and  __INNER_HAS_YUNWAVOICESDK__  ) then 
					talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/chat/voiceTalk")
				else
					talkLayer = requires(IMG_PATH,"GameLuaScript/Scene/common/talk")
				end

				curTalk = talkLayer:new( { type = "custom" , priority = -151 , custom = { customTable = { "custom" , "gang" } , sendParams = { scene = "lueduo" , scene_id = "lueduo" } } } )
--				curTalk = talkLayer:new( {type = "gang", priority = -151 } )
				local curScene = display.getRunningScene()
				curScene:addChild( curTalk:getLayer()  )
			else
				curTalk:remove()
			end
			DATA_Info:setIsOpen(  not DATA_Info:getIsOpen( ) )
		end
	})
	
	temp:getLayer():setScale(0.7)
	this.layer:addChild(temp:getLayer())
	--注册接收消息
	DATA_Info:setCustomKey( "lueduo_lueduo" )
	DATA_Info:addActionBtn( "custom" , temp )
	
--	if CHANNEL_ID == "tmsjIosAppStore" then
--		temp:getLayer():setVisible( false )
--		temp:setEnable(false)
--	end
	
	return this
end

function WarLayer:warMap()
	if self.layer then
		self.baseLayer:removeChild(self.layer, true)
	end
	self.layer = display.newLayer()
	
	self.mgr = Mgr:new(self.init, self)
	self.layer:addChild(self.mgr:getLayer())
	
	self.baseLayer:addChild(self.layer)
end

function WarLayer:refresh(data)
	if self.init.mapId == 2 then
		self.mgr:updateStat(data)
	else
		self.mgr:mapLogic(data)
	end
end

function WarLayer:getLayer()
	return self.baseLayer
end


return WarLayer