--主界面

local M = {

	
}

local PATH = IMG_PATH .. "image/scene/xinmo/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNMask = requires(IMG_PATH,"GameLuaScript/Common/KNMask")
local KNInputText = requires(IMG_PATH, "GameLuaScript/Common/KNInputText")

function M:new(args)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	
	
	args.cur_index=args.cur_index+1 --小标0开始,lua +1

	--dump(args)
	-- 基础层
	this.baseLayer = display.newLayer()
	

	-- 背景
	local bg = display.newSprite( PATH .. "bg.png")
	setAnchPos( bg , 0 , 88 )						-- 70 是底部公用导航栏的高度
	this.baseLayer:addChild( bg )

	-- 显示公用层 底部公用导航以及顶部公用消息
	this.infoLayer = InfoLayer:new( "xinmoLayer" , 0 , { title_text = PATH.."xinmoTitle.png", tail_hide = true, closeCallback = function()
		switchScene("fb",{})
	end} )
	this.baseLayer:addChild( this.infoLayer:getLayer() )

	local bossImg = {"boss_big_grey.png"}
	local particleFile = "grey.plist"
 	if args.cur_index>=15 then
		 bossImg = {"boss_big.png"}
		 particleFile="zi3.plist"
	end
	--boss粒子
	local  particleShine = CCParticleSystemQuad:create(PATH .. particleFile); 
 	setAnchPos(particleShine,30+214,60+600)
 	this.baseLayer:addChild(particleShine)


	--boss
	local bossBtn = KNBtn:new(PATH,bossImg,226-80,650-80,{
			scale = true,
			callback = function()
					--dump(args['data'][15])
					if args.cur_index>=15 then
						this:showTip(args['data'][15])
					else
						KNMsg:getInstance():flashShow("之前关卡未通关")
					end

			end})

	this.baseLayer:addChild(bossBtn:getLayer())


	this.baseLayer:addChild( this:list( args ):getLayer() )


	return this.baseLayer 
end


--显示列表数据
function M:list( data )
	local tempScrollView = KNScrollView:new(15,110,450,492,-20,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
    local posX = {290,150,10,150}
    local index = 1
    for i=#data.data-1,1,-1 do
    	--local layer = CCLayerColor:create(ccc4(math.random(1,255),math.random(1,255),math.random(1,255),255))
    	local layer = display.newLayer()
    	layer:setContentSize(CCSizeMake(380+260,100))
    	
    	if (i+2)%4==0 then
    		index=1
    	end

    	local img = {"xinmo_btn_grey.png"}
    	if (data.cur_index)>i and i~=8 then --该关卡已经通过关,cur_index 后台以0 开始计数
    		img={"xinmo_btn.png"}
    	elseif i == 8 and (data.cur_index)<=i then
    		img={"boss_small_grey.png"}
    	elseif i==8 and (data.cur_index)>i then
    		img ={"boss_small.png"}
    	end

    	local btn = KNBtn:new(PATH,img,posX[index],-30,{
    		scale=true,
    		parent=tempScrollView,
			callback = function()
					
					if i>data.cur_index then
						KNMsg.getInstance():flashShow( "请通过前一个关卡" )
					elseif i== data.cur_index then--正好要过的那关
						self:showTip(data.data[i])
					else
						self:showTip(data.data[i])
					end
					

			end})

    	layer:addChild(btn:getLayer())

    	if i== data.cur_index  then--正好要过的那关加动画和箭头
    			local lightImg = "xinmo_light.png"
    			if i==8 then
    				lightImg="boss_small.png"
    			end
    			local light = display.newSprite(PATH .. lightImg,0,0,0,0)
				btn:getLayer():addChild(light)	
				local actions = CCArray:create()
				actions:addObject(CCFadeOut:create( 0.8 ))
				actions:addObject(CCFadeIn:create( 0.8 ))
				local seq = CCSequence:create(actions)
				seq = tolua.cast(seq,"CCActionInterval")
				local rep = CCRepeatForever:create( seq )
				light:runAction(rep)

				local arrow = display.newSprite(PATH .. "arrow.png",60,120,0,0)
				btn:getLayer():addChild(arrow)
				local actions = CCArray:create()
				actions:addObject( CCMoveBy:create(0.6, ccp(0,15) ) )
				actions:addObject( CCMoveBy:create(0.6, ccp(0,-15) ) )
				local seq = CCSequence:create(actions)
				seq = tolua.cast(seq,"CCActionInterval")
				local rep = CCRepeatForever:create( seq )
				arrow:runAction(rep)


    	end


    	index=index+1

    	tempScrollView:addChild(layer)

    end

    tempScrollView:setIndex(#data.data-data.cur_index)


    return tempScrollView

end

--显示弹出框
function M:showTip( data )
	dump(data)
	local tempLayer = baseMask( {  
								titlePath = PATH.."fight_title.png" , 
								bgInfo = { y = 170+85 ,  path  = IMG_PATH  .. "image/scene/mission/wipe_bg.png" 
								} , 
							isShowBack = {x = 30 , y = 560 , backFun = function()  end } , 
							priority = -129 }
							)
    
	tempLayer:addChild(display.newSprite( PATH .. "playLab.png" , 90 , 550 , 0 , 0 )) --玩家

	tempLayer:addChild( display.strokeLabel(data.name , 150 , 550 , 20, ccc3( 39, 40, 34 ))) --玩家名字

	tempLayer:addChild(display.newSprite( PATH .. "achieve.png" , 80 , 510 , 0 , 0 ))

	--获胜奖励
	for i = 1 , #data.award do
			x=160
			y=485
			if i==1 then
				x=160
				y=485
			elseif i==2 then
				x=280
				y=485
			elseif i==3 then
				x=160
				y=460
			end
			local  awardTxt=  display.strokeLabel(data.award[i] ,x, y  , 18, ccc3( 39, 40, 34 ))
			tempLayer:addChild( awardTxt )
			
	end



	tempLayer:addChild(display.newSprite( COMMONPATH .. "line.png" , 20 , 430 , 0 , 0 ))

	tempLayer:addChild(display.newSprite( PATH .. "gift.png" , 80 , 410 , 0 , 0 )) --有几率获得

	for i=1,#data.award_show do
		local sp =  display.newSprite( PATH ..data.award_show[i].type..data.award_show[i].star..".png"  , 120+(i-0)*80 , 360 , 0 , 0 )
		tempLayer:addChild(sp)

	end


	

	tempLayer:addChild( display.strokeLabel("体力消耗     点" , 90 , 330 , 20, ccc3( 39, 40, 34 ))) --玩家名字
	local powerNum = display.strokeLabel( data.power , 180 , 330 , 20, ccc3( 39, 255, 34 ))
	tempLayer:addChild(powerNum)

	tempLayer:addChild( display.strokeLabel("挑战次数" , 280 , 330 , 20, ccc3( 39, 40, 34 ))) --玩家名字
	local tiaoNum = display.strokeLabel( (data.free_times- data.times).."/"..data.free_times , 370 , 330 , 20, ccc3( 39, 255, 34 ))
	tempLayer:addChild(tiaoNum)

	if (data.free_times- data.times)==0 then
		tiaoNum:setColor(ccc3(255,0,0))
	end


	

	--购买次数
	local addTimesBtn = KNBtn:new(COMMONPATH, {"add_small.png", "add_small_press.png"}, 218+185,327, {
		priority=-131,
		callback = function()
				local mask = baseMask( {  
													titlePath = COMMONPATH.."help_title.png" , 
													bgInfo = { y = 270+85 ,  path = COMMONPATH.."tip_bg.png"
												} , 
												isShowBack = {x = 25 , y = 565 ,priority = -136, backFun = function()  end } , 
												priority = -135 }
												)
				mask:addChild(display.strokeLabel("是否花费10黄金,购买一次挑战\n次数,\n今日已购买"..data.buy_times.."/"..data.max_buy_times , 90 , 115+380 , 22, ccc3( 0 , 0 , 0 )))


				local okBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png"  , "btn_bg_red_pre.png"  } , 160, 400 , {
						scale = true,
						priority = -136 , 
						front=COMMONPATH.."ok.png",
						callback = function()

										HTTP:call("xinmo", "buy", {id=data.id}, {
											success_callback = function(data)
												

												HTTP:call("xinmo","initData",{},{
														success_callback = function(data)
															switchScene("xinmo",data, function()
																	KNMsg:getInstance():flashShow("购买成功")
																end)
													end})
											end
										})

								
							
						end
					})
				mask:addChild(okBtn:getLayer())

			
		end
	})
	tempLayer:addChild(addTimesBtn:getLayer())	



	local fightBtn = KNBtn:new(COMMONPATH, { "btn_bg_red.png"  , "btn_bg_red_pre.png"  } , 200-40, 300-25 , {
						scale = true,
						priority = -131 , 
						front=PATH.."fight.png",
						callback = function()

								SOCKET:getInstance("battle"):call("xinmo" , "challenge" , "execute" , { id= data.id } )

								
							
						end
					})
	tempLayer:addChild(fightBtn:getLayer())






	
end




return M