--[[

		幻兽血统界面

]]

local PATH = IMG_PATH .. "image/scene/zhenFaWar/"
local BLOODPATH = IMG_PATH .. "image/scene/bloodTrial/"
local SCENECOMMON = IMG_PATH .. "image/scene/common/"
local InfoLayer = requires(IMG_PATH , "GameLuaScript/Scene/common/infolayer")
local KNBtn = requires(IMG_PATH , "GameLuaScript/Common/KNBtn")
local KNRadioGroup = requires(IMG_PATH , "GameLuaScript/Common/KNRadioGroup")
local SelectList = requires(IMG_PATH, "GameLuaScript/Scene/common/selectlist")
local KNBar = requires(IMG_PATH, "GameLuaScript/Common/KNBar")
-- local lmtext = requires(IMG_PATH, "GameLuaScript/Config/lmtext")
local Config = requires(IMG_PATH,"GameLuaScript/Config/Pet")
local KNMask = requires(IMG_PATH, "GameLuaScript/Common/KNMask")
local M = {
}


function M:new( params )
	-- dump(params)
	local this = {}
	setmetatable(this , self)
	self.__index = self
	this.params = params or {}

	this.baseLayer = display.newLayer()

	this.layer = display.newLayer()

	this.baseLayer:addChild( this.layer )

	this.layer:addChild( display.newSprite(COMMONPATH .. "dark_bg.png" , 0  , 88 , 0 , 0) )

	this:setInfoLayer()

	local tabConfig = {
			{
				"zhenfaWar",
				"zhenfaWar.png",
				"zhenfaWar_pre.png",
			},
			{
				"pointRank",
				"pointRank.png",
				"pointRank_pre.png",
			},
			 {
			 	"pointShop",
			 	"pointShop.png",
			 	"pointShop_pre.png",
			 },
	}


	local startX , startY  = 10 , 695
	this.group = KNRadioGroup:new()
	for i = 1, #tabConfig do
		local temp = KNBtn:new(COMMONPATH .. "tab" , i~=3 and  { "tab_star_normal.png" , "tab_star_select.png" } or { "long.png" , "long_select.png" } , startX - (i==3 and 8 or 0) , startY , {
			front = { PATH .. tabConfig[i][2] , PATH .. tabConfig[i][3]},
			disableWhenChoose = true,
			id = tabConfig[i][1],
			callback = function()
				if i == 1 then 
					this:createZhenFaWarLayer()
				elseif i == 2 then 
					HTTP:call("zhenfawar","getRankingList",{  } , {
						success_callback = function( data )
							-- dump(data , "data")
							this:createPointRankLayer(data)
						end
					})
				elseif i == 3 then 
					HTTP:call("zhenfawar","getShopList",{  } , {
						success_callback = function( data )
							this:createPointShopLayer(data)
						end
					})
				end
			end } , this.group)
		

		this.layer:addChild(temp:getLayer() , 1)
		startX = startX + temp:getWidth() + 4
	end

	this.layer:addChild( display.newSprite( COMMONPATH .."tab_line.png" , display.cx , 690 , 0.5 , 0 ) , 2 )

	this.group:chooseByIndex(1 , true)
	
	return this.baseLayer
end


function M:createPointRankLayer(param)

	if self.viewLayer then 
		self.viewLayer:removeSelf()
	end

	self:setInfoLayer()

	self.viewLayer = display.newLayer()
	self.layer:addChild( self.viewLayer )

	 --分割线
	local lineSp = display.newSprite(COMMONPATH .. "tab_line.png")
	setAnchPos(lineSp,5,583)
	self.viewLayer:addChild( lineSp )

	local lianShengBar = display.newSprite(BLOODPATH.."shengChangBar.jpg")
	setAnchPos(lianShengBar,5,585)
	self.viewLayer:addChild(lianShengBar)

	local wodejinrijifen = display.newSprite(PATH .."wodejinrijifen.png")
	setAnchPos(wodejinrijifen,20,66)
	lianShengBar:addChild(wodejinrijifen)

	local lianShengCiShuNum = display.strokeLabel( self.params.data.point or "" , wodejinrijifen:getContentSize().width, 0 , 24 , ccc3( 110 , 211 , 26))
	wodejinrijifen:addChild(lianShengCiShuNum)

	local myRankLab = display.newSprite(PATH.."wodezuoripaiming.png")
	setAnchPos(myRankLab,335,82)
	lianShengBar:addChild(myRankLab)

	local rankBg =display.newSprite(PATH.."rankBg.png")
	setAnchPos(rankBg,347,0)
	lianShengBar:addChild(rankBg)

	local awardLabel = createLabel({ str = "昨日排名奖励：", x=15 , y = 633 , size = 20,width =250, color = ccc3(221,62,59)})
	self.viewLayer:addChild(awardLabel)

	local descLabel = createLabel({ str = "(注:每日22:00结算排名，24:00重置排行榜和每日挑战积分数据)", x=15 , y = 593 , size = 16,width =360, color = ccc3(255,255,255)})
	self.viewLayer:addChild(descLabel)

	local pointLabel = display.strokeLabel( param.award.point or "" , awardLabel:getContentSize().width, 0 , 20 , ccc3( 110 , 211 , 26))
	awardLabel:addChild( pointLabel )

	local getBtn = KNBtn:new(COMMONPATH, {"btn_bg.png" , "btn_bg_pre.png"}, 250, 640 , {
			priority = -131 , 
			front= COMMONPATH.."get.png",
			callback = function()
				HTTP:call("zhenfawar","receiveAward",{} , {
					success_callback = function( data )
						KNMsg:getInstance():flashShow(data.msg or "")

						for k,v in pairs(data.update) do
							self.params.data[k] = v
						end
					end
				})
			end
		}):getLayer()
	self.viewLayer:addChild(getBtn)

	local rank = tonumber(param.rank)  --判断排名类型
	if rank < 200 then
		local myRankNum = getImageNum( rank , COMMONPATH .. "cirt.png")
		setAnchPos( myRankNum , rankBg:getContentSize().width /2 , rankBg:getContentSize().height /2 , 0.5 , 0.5 )
		myRankNum:setScale(0.5)
		rankBg:addChild(myRankNum)
	else
		local rankDesc = display.strokeLabel( "第200名以外" , 15, 0 , 16 , ccc3( 223 , 222 , 164))
		rankBg:addChild(rankDesc)
 	end

	local tempScrollView = KNScrollView:new(15,102,450,480,8,false,0,{
	
	   		 priority = -130,
	    	 --debug=true,
	    })
    tempScrollView:alignCenter()
    self.viewLayer:addChild(tempScrollView:getLayer())
   	
    local list = param.list or {}

	for i=1,#list do
		local data = list[i]

		local  itemBg = display.newSprite(COMMONPATH .."item_bg.png")
		setAnchPos(itemBg,0,0)
		tempScrollView:addChild(itemBg)

		--头像
		local touXiangBtn = KNBtn:new(COMMONPATH, { getHeadPath( data.head ) }, 25 , 20 , {
		priority = -133,
		parent=tempScrollView,
		callback = function()
		-- print("aaaaaaaaa")
		-- HTTP:call("profile","get",{ touid = lianShengData['list'][i]['uid'] },{success_callback =  function()

		-- 					local otherPalyerInfo = requires(IMG_PATH, "GameLuaScript/Scene/common/otherPlayerInfo")
		-- 					display.getRunningScene():addChild( otherPalyerInfo:new( { isFriend = true } ):getLayer() )
		-- 		end})	

		end})
		itemBg:addChild(touXiangBtn:getLayer())

		local frame = display.newSprite(COMMONPATH.."role_frame.png")
		setAnchPos(frame,-2,-3)
		touXiangBtn:getLayer():addChild(frame)

		local userName = display.strokeLabel("姓名：".. data.name , 120 , 65 , 22 ,ccc3( 44 , 0 , 0 ))
		local jinritiaozhanjifen =  display.newSprite( PATH .. "jinritiaozhanjifen.png" , 120 , 20 , 0  ,0 ) 

		itemBg:addChild(userName)
		itemBg:addChild(jinritiaozhanjifen)

		local jinritiaozhanjifen_label = display.strokeLabel( data.point or "" , 137, 0, 22 , ccc3( 44 , 0 , 0))
		jinritiaozhanjifen:addChild(jinritiaozhanjifen_label)


		local rankBg =display.newSprite(PATH.."rankBg.png")
		setAnchPos(rankBg,330,itemBg:getContentSize().height /2 , 0 , 0.5)
		itemBg:addChild(rankBg)

		local rankNum = getImageNum(i, COMMONPATH .. "cirt.png")
		setAnchPos(rankNum,rankBg:getContentSize().width /2,rankBg:getContentSize().height/2 , 0.5 , 0.5)
		rankNum:setScale(0.6)
		rankBg:addChild(rankNum)

	end

end

function M:createPointShopLayer(param)

	if self.viewLayer then 
		self.viewLayer:removeSelf()
	end

	self:setInfoLayer()

	self.viewLayer = display.newLayer()
	self.layer:addChild( self.viewLayer )
	
	local mineAllPoint = display.newSprite(PATH.."mineAllPoint.png" , 22,658 , 0 , 0)
	self.viewLayer:addChild( mineAllPoint )

	mineAllPoint:addChild( display.strokeLabel( self.params.data.total_point or "" ,120 , 3, 18 , ccc3(255,247,237)) ) 

	local scroll = KNScrollView:new(15 , 95 , 450 , 565 , 5)
	local goodsList = param.list or {}
			
	for i=1,#goodsList do --循环初始化当前选中类型的类型的背包显示
		local cid = goodsList[i].prop

		local itemLayer = self:createShopItem({
			data = goodsList[i],
			parent = scroll,
			iconCallback = function()
				--当点击图标按钮后先从全局数据中查找是否存在数据，若没有则请求网络，否则隐藏用户信息栏，显示详细界面
				local detail_type = getCidType(cid)
				local data = getConfig( detail_type , cid )
				data["cid"] = cid

				pushScene("detail" , {
					detail = detail_type,
					data = data,
				})
			end,
			optCallback = function()
				HTTP:call("zhenfawar","buy",{ id = i } , {
						success_callback = function(data)

							KNMsg.getInstance():flashShow(data.msg or "")

							self.params.data = data.update

							self:createPointShopLayer(param)
						end
				})
			end
		})
		scroll:addChild(itemLayer)
	end

	self.viewLayer:addChild(scroll:getLayer())

end


function M:createZhenFaWarLayer()

	if self.viewLayer then 
		self.viewLayer:removeSelf()
	end

	self:setInfoLayer()

	self.viewLayer = display.newLayer()
	self.layer:addChild( self.viewLayer )


	local data = self.params.data

	self.viewLayer:addChild( display.newSprite( BLOODPATH .."shiLianBg.png" , display.cx , 285 , 0.5 , 0 ) )
	self.viewLayer:addChild( display.newSprite( PATH .."bg_frame.png" , display.cx , 298 , 0.5 , 0 ) )

	self.viewLayer:addChild( display.newSprite(PATH.."frame3.png" , 198 , 385 , 0 , 0)  )
	self.viewLayer:addChild( display.newSprite(PATH.."frame2.png" , 0 , 86 , 0 , 0)  )

	local function getStatusLayer(index)

		local user_data 

		if index == 1 then 
			user_data = DATA_User:get()
			user_data.ability = data.ability
			user_data.head = DATA_Head:get("default")
			user_data.server_name = DATA_GodCell:get("server_name")
		else
			user_data = data.battle_user
			user_data.head = "19001"
		end 

		-- dump(user_data , "user_data")

		local layer = display.newLayer()
		local frame = display.newSprite( BLOODPATH .. "frame.png" , 0 ,  0 , 0 , 0 )

		local size = frame:getContentSize()

		layer:setContentSize( size )

		layer:addChild( frame )

		local name = user_data.name .. "\n" .. user_data.server_name

		layer:addChild( createLabel({ str = name, x=3 , y = 56 , width = 170 , height = 50 , size = 18, color = ccc3(222,222,222) , align = 1}) )

		layer:addChild( createLabel({ str = user_data.ability or "11", x=94 , y = 23 , size = 18, color = ccc3(222,222,222)}) )

		layer:addChild( display.newSprite( BLOODPATH .. (index == 1 and "iStatus.png" or "enemyStatus.png") , size.width /2 , 176 , 0.5 , 0 ) )
		layer:addChild( display.newSprite( BLOODPATH .."zhanLi.png" , 29 , 21 , 0 , 0 ) )

		layer:addChild(KNBtn:new( COMMONPATH , { getHeadPath( user_data.head ) } , 54 , 101 , {
			front = COMMONPATH .."role_frame.png",
			callback = function()
				
			end
		}):getLayer())


		return layer
	end

	self.viewLayer:addChild( display.newSprite( PATH .."zhijizhibi.png" , 184 , 429 , 0 , 0 ) )
	self.viewLayer:addChild( display.newSprite( PATH .."zhinanertui.png" , 184 , 398 , 0 , 0 ) )

	self.viewLayer:addChild( display.newSprite( BLOODPATH .."vs.png" , display.cx , 534 , 0.5 , 0 ) )


	for i=1,2 do
		local layer = getStatusLayer(i)
		setAnchPos( layer , i == 1 and 13 or 283 , 453 )
		self.viewLayer:addChild( layer )
	end

	local fightBtn = KNBtn:new( COMMONPATH , {"btn_bg_red.png", "btn_bg_red_pre.png"} , display.cx , 354 , {
		front = BLOODPATH .. "fight.png",
		anchMid = true,
		callback = function()

			HTTP:call("zhenfawar", "challenge", {   }, {
				success_callback = function(data)

					DATA_Battle:setMod("zhenfawar")

					DATA_Result:set( data );

					local function showResult()
						local function backFunc()
							HTTP:call("zhenfawar","initData",{  } , {
									success_callback = function(data)
										switchScene("zhenFaWar"  , {data = data} )			
									end
							})
						end
						local tableData = { backFun = backFunc }
						
						local resultLayer = requires(IMG_PATH,"GameLuaScript/Scene/battle/resultLayer")
						local scene = display.getRunningScene()
						scene:addChild( resultLayer:create( tableData ) )
					end

					showResult()

					-- 正常情况下，发包给后台，获取战斗结果
					-- local battle_call_data = {
					-- 	report_id = data.report_id,
					-- }
					
					-- SOCKET:getInstance("battle"):call( "zhenfawar" , "challenge_finish" , "finish" , battle_call_data , { success_callback = showResult } )

						end
					})
		end
	})
	self.viewLayer:addChild(fightBtn:getLayer())

	local lookBtn = KNBtn:new( IMG_PATH .. "image/scene/strengthen/" , {"btn_bg.png", "btn_bg_pre.png"} , 320 , 427 , {
		front = PATH .. "private_look.png",
		callback = function()

			HTTP:call("zhenfawar", "check", {}, {
				success_callback = function(data)
					-- self.params.data.battle_user = data.update
					-- self:createZhenFaWarLayer()
					self:privateLookLayer(data)
				end
			})
			
		end
	})
	self.viewLayer:addChild(lookBtn:getLayer())

	local changeBtn = KNBtn:new( IMG_PATH .. "image/scene/strengthen/" , {"btn_bg.png", "btn_bg_pre.png"} , 320 , 392 , {
		front = PATH .. "change.png",
		callback = function()

			HTTP:call("zhenfawar", "refresh", {}, {
				success_callback = function(data)
					-- dump(data , "data")
					KNMsg:getInstance():flashShow("更换成功")

					for k,v in pairs(data.update) do
						self.params.data[k] = v
					end

					self:createZhenFaWarLayer()
				end
			})
			
		end
	})
	self.viewLayer:addChild(changeBtn:getLayer())

	lookBtn:getLayer():addChild( display.newSprite( COMMONPATH .."gold.png" , 65 , 3 , 0 , 0 ) )
	changeBtn:getLayer():addChild( display.newSprite( COMMONPATH .."gold.png" ,  65 , 3 , 0 , 0 ) )

	lookBtn:getLayer():addChild( createLabel({ str = data.check_gold or "", x=100 , y = 6 , size = 18, color = ccc3(222,222,222)}) )
	changeBtn:getLayer():addChild( createLabel({ str = data.refresh_gold, x=100 , y = 6 , size = 18, color = ccc3(222,222,222)}) )


	fightBtn:getLayer():addChild( createLabel({ str = "次数:"..data.times.."/"..data.free_times, x=148 , y = 14 , size = 20, color = ccc3(222,222,222)}) )

	local addBtn = KNBtn:new( IMG_PATH .. "image/scene/godCell/" , {"add.png", "add_pre.png"} , 227 , 5 , {
		callback = function()
			local tempLayer =display.newLayer()
			local buySp = display.newSprite(BLOODPATH .."buy.png",85,446,0,0):addTo(tempLayer)
			local buyDesc = display.strokeLabel("阵法战挑战次数+1" , buySp:getContentSize().width+15 , 0 , 19 ,ccc3(76,36,17) ):addTo(buySp)
			local costSp = display.newSprite(COMMONPATH .."cost.png",85,391,0,0):addTo(tempLayer)
			local costDesc = display.strokeLabel("黄金:"..(self.params.data.buy_gold or "") , costSp:getContentSize().width+15 , 0 , 19 ,ccc3(76,36,17) ):addTo(costSp)
			showTip({
				content = tempLayer,
				priority = -220,
				left = {
					path = COMMONPATH,
					normal = "btn_bg_red.png",
					pre = "btn_bg_red_pre.png",
					front = COMMONPATH.."ok.png",
					remove = true,
					callback = function()
						HTTP:call("zhenfawar", "buyTimes", {}, {
								success_callback = function(data)
									KNMsg:getInstance():flashShow("购买成功，挑战次数+1")

									for k,v in pairs(data.update) do
										self.params.data[k] = v
									end
									self:createZhenFaWarLayer()
								end
							})
					end
				},
				right = {
						 path = COMMONPATH, 
						 normal = "btn_bg_red.png", 
						 pre = "btn_bg_red_pre.png",
						 front = COMMONPATH.."cancel.png",
						 remove = true
		    	}})
		end
	})
	fightBtn:getLayer():addChild( addBtn:getLayer() )

	local jinrizhandoujifen = display.newSprite( PATH .."jinrizhandoujifen.png" , 14 , 271 , 0 , 0 )
	self.viewLayer:addChild( jinrizhandoujifen )

	jinrizhandoujifen:addChild( createLabel({ str = data.point or "", x=127 , y = 1 , size = 20, color = ccc3(222,222,222)}) )				--今日战斗积分

	local zongjifen = display.newSprite( PATH .."zongjifen.png" , 14 , 239 , 0 , 0 )
	self.viewLayer:addChild( zongjifen )
	zongjifen:addChild( createLabel({ str = data.total_point or "", x=73 , y = 1 , size = 20, color = ccc3(222,222,222)}) )					--总积分

	self.viewLayer:addChild( display.newSprite( PATH .."jiangli.png" , 16 , 204 , 0 , 0 ) )

	self.viewLayer:addChild( createLabel({ str = "(注：阵法战模式为上阵VS上阵、阵法VS阵法，战斗结果会出现胜、负、平)", x=14 , y = 164 , width = 450 , height = 50 , size = 16, color = ccc3(198,75,67)}))


	self.viewLayer:addChild( createLabel({ str = "胜（上阵、阵法都胜）：积分+10\n平（上阵、阵法一胜一负）：积分+6\n负（上阵、阵法都负）：积分+3\n", x=14 , y = 103 , width = 450 , height = 70 , size = 16, color = ccc3(222,222,222)}))


end

--设置 InfoLayer 的 title 和 close回调
function M:setInfoLayer(data)
	local param  = data or {}

	if not param.title then 
		param.title = PATH .. "zhenFaWar_title.png"
	end

	if not param.closeCallback then 
		param.closeCallback = function() switchScene("pvp") end
	end

	if self.infoLayer then 
		self.infoLayer:refreshTitle(param.title)
		self.infoLayer.params.closeCallback = param.closeCallback
	else
		self.infoLayer = InfoLayer:new("zhenFaWar" , 0, {tail_hide = true, title_text =  param.title , closeCallback = param.closeCallback})
		self.baseLayer:addChild( self.infoLayer:getLayer() , 10 )
	end


end


function M:createShopItem(param)
	local itemLayer = display.newLayer()
	local item_bg = display.newSprite( COMMONPATH.."item_bg.png" , 0 , 0 , 0 ,0  )
	local size = item_bg:getContentSize()

	local item_data = param.data or {}

	itemLayer:setContentSize(size)
	itemLayer:addChild( item_bg )

	local cid = item_data.prop

	local propConfig = getConfig( "prop" , cid ) or {}

	local name_label = createLabel({ str = propConfig.name or "" , width =280, x= 104, y = 71 , size = 18, color = ccc3(68,27,7)})
	itemLayer:addChild(name_label)

	name_label:addChild( createLabel({ str = "x"..item_data.num , x= name_label:getContentSize().width + 1 , y = 0 , size = 18, color = ccc3(68,27,7)}) )
	-- itemLayer:addChild( display.strokeLabel(  propConfig.name or "" , 	104, 71, 18 , ccc3(68,27,7)) )

	itemLayer:addChild( display.newSprite( PATH .. "kezaishangchenggoumai.png" , 94 , 42 , 0 , 0 ) )

	local price = display.newSprite( PATH .. "price.png" , 94 , 18 , 0 , 0 )
	itemLayer:addChild( price )

	local price_label = createLabel({ str = item_data.point or "" , x=51 , y = 0 , size = 18, color = ccc3(68,27,7)})
	price:addChild( price_label )

	price_label:addChild( createLabel({ str = "积分" , x= price_label:getContentSize().width + 3 , y = 0 , size = 18, color = ccc3(68,27,7)}) )


	local icon = KNBtn:new(IMG_PATH .. "image/scene/common/" , {"skill_frame1.png"},55 , size.height / 2 ,{
		parent = param.parent,
		anchMid = true,
		front = getImageByType( cid , "s"),
		callback = function()
			if param.iconCallback then 
				param.iconCallback()
			end
		end,
	} )
	itemLayer:addChild(icon:getLayer())

	local buyBtn = KNBtn:new(COMMONPATH, { "btn_bg.png" , "btn_bg_pre.png" },380 , size.height / 2 + 10,{
		parent = param.parent,
		anchMid = true,
		front = COMMONPATH .. "buy.png",
		callback = function()
			if param.optCallback then 
				param.optCallback()
			end
		end,
	} )
	itemLayer:addChild(buyBtn:getLayer())

	return itemLayer
end

function M:privateLookLayer(param)

	-- dump(param , "param")

	local tempLayer = display.newLayer()
	local mask = KNMask:new({item = tempLayer, priority = -151})

	local bg = display.newSprite( COMMONPATH .. "change_bg.png" )
	setAnchPos( bg , 240 , 124 , 0.5 )
	tempLayer:addChild( bg )

	local title_bgSp = display.newSprite(COMMONPATH .. "change_title_bg.png")
 	setAnchPos(title_bgSp,240,540 + 85, 0.5)
 	tempLayer:addChild(title_bgSp)	

 	local godcellpoint_title = display.newSprite(PATH.."privateLook_title.png")
 	setAnchPos(godcellpoint_title,240,560 + 85 , 0.5)
 	tempLayer:addChild(godcellpoint_title)

	tempLayer:setScale(0)
	tempLayer:runAction(CCEaseElasticOut:create(CCScaleTo:create(0.8, 1)))

	local close = KNBtn:new(COMMONPATH, {"back_img.png","back_img_press.png" }, 20 , 520 + 85 , {
				priority = -152,
				scale = true,
				callback = function()
					mask:remove()
				end})
	tempLayer:addChild(close:getLayer())


	local battle_user = self.params.data.battle_user

	local name_label = createLabel({ str = battle_user.name or "" ,width = 180 , x=37 , y = 582 , size = 20})
	tempLayer:addChild(name_label)

	name_label:addChild( createLabel({ str = battle_user.server_name or "" , x=name_label:getContentSize().width + 4 , y = 0 , width = 380 , size = 20 , color = ccc3( 203,64,43 )}) )

	name_label:addChild( createLabel({ str = "战力"..battle_user.ability or "" , x=300 , y = 0 ,width = 380 , size = 20 }) )

	local config = { "shangzhen" , "zhenfa" }

	local function getFrame(index)
		local layer = display.newLayer()

		local hero_frame = display.newSprite( PATH .."hero_frame.png" , 35 , 0 , 0 ,0 )
		local size = hero_frame:getContentSize()
		size.width = display.cx
		layer:setContentSize( size )
		layer:addChild( hero_frame )


		if index == 1 then 
			layer:addChild( display.newSprite( PATH .. config[index].. "_label.png" , 35 , 142 , 0 ,0 ) )
		elseif index == 2 then 
			local img = display.newSprite( PATH .. config[index].. "_label.png" , 35 , 200 , 0 ,0 ) 
			img:addChild( createLabel({ str = "(" .. param.zhenfa_info.name .. ")"  , x=img:getContentSize().width + 4 , y = 0 ,width = 380 , size = 20 , color = ccc3( 203,64,43 )}) )
			layer:addChild(img)
		end

		local hero_list = index == 1 and param.formation or param.zhenfa

		local init_x = 120
		for i=1,#hero_list do
			local hero_data = hero_list[i]

			local icon = KNBtn:new(IMG_PATH .. "image/scene/common/" , {"skill_frame1.png"},init_x , i<=4 and 99 or 20,{
				front = getImageByType( hero_data.cid , "s"),
				text = { hero_data.lv ,16,ccc3(255,255,255),ccp(28,-28) , nil , 12},
				other = {COMMONPATH.."equip_lv_bg.png",45,-5,11},
				callback = function()
					
				end,
			} )
			layer:addChild(icon:getLayer())

			if i%4 ~= 0 then 
				init_x = init_x + 83
			else
				init_x = 120
			end

		end

		return layer
	end

	for i=1,#config do
		local frame = getFrame(i)
		setAnchPos( frame , 0 , i==1 and 371 or 142 , 0 , 0 )
		tempLayer:addChild(frame)
	end

	self.baseLayer:addChild( mask:getLayer() )


end

function M:showTip()

	local tipLayer = display.newLayer()

	local tip = showTip({	
      content = tipLayer,
      close = {
        normal = "back_img.png",
        pre = "back_img_press.png",
      },
    })

	local offSetY = -60

	display.newSprite( PATH .. "meiyoukaiqizhenfa.png" , 102 , 516+offSetY , 0 , 0 ):addTo(tipLayer)
	display.newSprite( PATH .. "frame1.png" , display.cx , 333+offSetY , 0.5 , 0 ):addTo(tipLayer)

	display.newSprite( PATH .. "line.png" , display.cx , 440+offSetY , 0.5 , 0 ):addTo(tipLayer)
	display.newSprite( PATH .. "line.png" , display.cx , 392+offSetY , 0.5 , 0 ):addTo(tipLayer)

	KNBtn:new(COMMONPATH, {"btn_bg.png","btn_bg_pre.png" }, 333 , 449+offSetY , {
				priority = -152,
				text = { "前往帮派商城购买阵法碎片" ,18,ccc3(255,255,255),ccp(-180,0) , nil , 12},
				front = PATH .. "gang.png",
				callback = function()
					tip:remove()
					--帮派
					HTTP:call("alliance", "get", {},{success_callback =
					function()
						switchScene("gang")
					end})

				end}):getLayer():addTo(tipLayer)


	KNBtn:new(COMMONPATH, {"btn_bg.png","btn_bg_pre.png" }, 333 , 397+offSetY , {
				priority = -152,
				text = { "前往背包界面合成阵法" ,18,ccc3(255,255,255),ccp(-180,0) , nil , 12},
				front = PATH .. "bag.png",
				callback = function()
					tip:remove()

					switchScene("bag")

				end}):getLayer():addTo(tipLayer)

	KNBtn:new(COMMONPATH, {"btn_bg.png","btn_bg_pre.png" }, 333 , 351+offSetY , {
				priority = -152,
				text = { "前往阵法界面开启阵法" ,18,ccc3(255,255,255),ccp(-180,0) , nil , 12},
				front = PATH .. "zhenfa.png",
				callback = function()
					tip:remove()

					HTTP:call("zhenfa" , "initData",{},{
						success_callback = function(data)
							switchScene("method", {data=data,gid=gid,backFunc = function() switchScene("home") end})
						end
					})

				end}):getLayer():addTo(tipLayer)


end


return M
