--[[

初始化

1、判断 唯一ID是否一致，如果不一致，则需重新初始化 (删除文件夹)

]]

function __G__TRACKBACK__(errorMessage)
    CCLuaLog("LUA ERROR: "..tostring(errorMessage).."\n")
    CCLuaLog(debug.traceback("", 2))
end

require "GameLuaScript/initialization/init_functions"

CCLuaLog("Come to Lua !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")


local interface = UpdataRes:getInstance()
local platform_type = interface:get_type()

-- SD 卡路径
IMG_PATH = ""
WRITE_PATH = ""

-- 全局变量
ERROR_MSG = ""
ERROR_CODE = 0

--[[
	内部标记版本号

version 1
	IMG_PATH = 缓存路径

version 2
	IMG_PATH 为空
	WRITE_PATH ＝ 缓存路径
	CCFileUtils添加WRITE_PATH的资源搜索路径

version 4
	添加帮派语音SDK

]]

--	是否是新的爱贝的SDK(3.4.5)
_NEWAIBEI  = 2

__INNER_VERSION__ = 4

-- 标记是否使用新的方法，接入SDK
__INNER_NEWSDK__ = false

-- 标记接入的SDK是否有登陆
__INNER_HASLOGIN__ = true

-- 标记是否用自己的登录
__INNER_SELF_LOGIN = nil

-- 包是否加密
__INNER_JIAMI__ = 1

--是否含有 安卓语音 通话功能	true:为有此功能 ， false为没有此功能
__INNER_HAS_YUNWAVOICESDK__ = false

--是否有广告SDK
__INNER_HAS_AD_SDK__ = true

if 2 == platform_type then
--[[
ios联运方案， 版本号标记

version 1
新增ios联运方案

version 2
新增注销回调

version 3
新接入appstore

version 4
新接入云顶， 以及动态函数， 兼容以后更高的版本
]]
__INNER_IOS_SDK_VER = 5
end

-- 定义全局 requires 函数
--[[
function requires(filePath , filename)
	return require(filename)
end
]]
if platform_type == 2  then  --ios
    function requires(filePath , filename)
        if INIT_FUNCTION.file_exists(WRITE_PATH .. filename .. ".lua") then
            return require(WRITE_PATH .. filename)
        else
            return require(filename)
        end
    end
else
    function requires(filePath , filename)
        if INIT_FUNCTION.file_exists(WRITE_PATH .. filename .. ".lua") then
            return require(WRITE_PATH .. filename)
        else
            return require(filename)
        end
    end
end

function split(str, delimiter)
    if (delimiter=='') then return false end
    local pos,arr = 0, {}
    -- for each divider found
    for st,sp in function() return string.find(str, delimiter, pos, true) end do
        table.insert(arr, string.sub(str, pos, st - 1))
        pos = sp + 1
    end
    table.insert(arr, string.sub(str, pos))
    return arr
end

function get_info(kind)
	local info = {}

	local temp = interface:DeviceId()
	temp = split(temp , "@@")
    for k , v in pairs(temp) do
        local temp2 = split(v , "=")
        if #temp2 == 2 then
           info[ temp2[1] ] = temp2[2]
        end
    end

	if kind == 1 then  --系统版本
		return info.version
	elseif kind == 2 then  --文件路径
		return CHANNEL_ID
	elseif kind == 3 then  --网络类型，
		return info.netWork
	elseif kind == 4 then  --运营商
		return "MOBILE"
	end
end

-- wp8兼容
if platform_type == 3 then
	CCTOUCHBEGAN = "began"
	CCTOUCHMOVED = "moved"
	CCTOUCHENDED = "ended"
	CCTOUCHCANCELLED = "cancelled"
end

-- Begin
xpcall(function()
    require("GameLuaScript/Config/channel")

	-- 设置SD卡路径
	if platform_type == 0 then 					-- windows or mac
		WRITE_PATH  = ""
	elseif platform_type == 1 then 				-- Android
		-- WRITE_PATH = "/mnt/sdcard/kuniudhsh_" .. CHANNEL_ID .. "/"
		LuaAisle.instance():call({
			tag = "com/android/GameLua/GameLua-getDBPath",
			callback = function(response)
				if response and response.db_path then
					WRITE_PATH = response.db_path .. "/kuniu_" .. response.packageName .. "/"
				else
					WRITE_PATH = "/mnt/sdcard/kuniu_" .. response.packageName .. "/"
				end
			end
		})

		if WRITE_PATH == "" then
			CCLuaLog("出错了，WRITE_PATH 为空~！ ")
			return
		end

	elseif platform_type == 2 then 				-- IOS
		WRITE_PATH = CCFileUtils:sharedFileUtils():getWriteablePath()
		channel_delegate:setChannel(CHANNEL_ID, CHANNEL_GROUP, CHANNEL_SERVER)
    elseif platform_type == 3 then
        WRITE_PATH = CCFileUtils:sharedFileUtils():getWritablePath()
	end

	CCLuaLog("WRITE_PATH = " .. WRITE_PATH)

--	if platform_type == 0 then					-- windows 直接进入游戏
--		requires(IMG_PATH , "GameLuaScript/GameCanvasLua")
--		return
--	end

	-- 非 windows 平台，则要走以下逻辑 (初始化 && 在线升级)
    local scene = require "GameLuaScript/initialization/init_scene"
    CCDirector:sharedDirector():runWithScene(scene:create())
end , __G__TRACKBACK__)
