--[[

初始化场景

]]


collectgarbage("setpause"  ,  100)
collectgarbage("setstepmul"  ,  5000)

local initCopyLayer = require "GameLuaScript/initialization/init_copyfiles"

local M = {}
local scene
function M:create()
	scene = CCScene:create()
	scene.name = "init"

	require("GameLuaScript/Config/channel")
	
	local getSDKHasLogo = function()
		local isDKSDK = string.find(CHANNEL_ID, "DK", 1, true)
		if isDKSDK then return true, "DK_bg.jpg" end
		
		local isUcSDK = CHANNEL_ID == "uc" or CHANNEL_ID == "hy.uc" or CHANNEL_ID == "tgxy.uc" or CHANNEL_ID == "tmsj.uc"
		if isUcSDK then return true, "uc_bg.jpg" end
		
		local isDownjoySDK = CHANNEL_ID == "downjoy" or CHANNEL_ID == "hydl" or CHANNEL_ID == "tgxydl" or CHANNEL_ID == "tmsjdl"
		if isDownjoySDK then return true, "downjoy_bg.jpg" end
		
		local isSohuSDK = CHANNEL_ID == "sohu"
		if isSohuSDK then return true, "sohu_bg.jpg" end
		
		local isAnzhiSDK = CHANNEL_ID == "anzhi"
		if isAnzhiSDK then return true, "anzhi_bg.jpg" end
		
		local isCmgeSDK = CHANNEL_ID == "cmge"
		if isCmgeSDK then return true, "cmge_bg.jpg" end

		local isSqwanSDK = CHANNEL_ID == "sqwan"
		if isSqwanSDK then return true, "sqwan_bg.jpg" end

		local isEgameSDK = CHANNEL_ID == "egame"
		if isEgameSDK then return true, "egame_bg.jpg" end
		
		local isSougouSDK = CHANNEL_ID == "hy.sougou" or CHANNEL_ID == "tgxy.sougou" or CHANNEL_ID == "tmsj.sougou" 
		if isSougouSDK then return true, "sougou_bg.jpg" end
		
		return false
	end
	
	local haslogo, logo = getSDKHasLogo()

	local function logoFunc(logoPath)
		local layer = CCLayer:create()
		local bg = CCSprite:create(logoPath) 

		INIT_FUNCTION.setAnchPos( bg , 0 , 0 )
		layer:addChild( bg )
		scene:addChild(layer)

		local handle
		handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
			handle = nil
			M:flash()
		end , 2 , false)
	end

	CCLuaLog("Check Logo")
	if haslogo  then
		logoFunc("image/other/" .. logo)
	elseif __INNER_IOS_SDK_VER and channel_delegate:getInst():hasLogo("sdk_logo.jpg") then--ios启动页面
		logoFunc("sdk_logo.jpg")
	elseif CHANNEL_ID == "tmsj.heitao" or CHANNEL_ID == "tmsj.heitao1" or CHANNEL_ID == "tgxy.zy" or ( __INNER_NEWSDK__ and __INNER_VERSION__>=3 ) or CHANNEL_ID == "BD" then 
		CCLuaLog("Check Logo Begin")
		local logoPath = "logo.jpg" 
		LuaAisle.instance():call({
			filePath = logoPath,
			tag = "com/android/GameLua/GameLua-fileIsExistInAssets",
			callback = function(response)
				CCLuaLog("Check logo callback")
				if response and response["isExits"] == "true" then
					logoFunc(logoPath)
				else
					M:flash()
				end
			end
		})
	else
		M:flash()
	end
	

	return scene
end

function M:flash()
	CCLuaLog("Init Scene Flash")
	local interface = UpdataRes:getInstance()
	local platform_type = interface:get_type()
	if platform_type == 0 then
		M:go()
		return
	end

	if CHANNEL_GROUP == "hy" then
		M:hyflash()
		return
	end


	local layer = CCLayer:create()
	local bg = ""
	if CHANNEL_GROUP == "td" then
		bg = CCSprite:create("image/other/td_bg.jpg")
	else
		bg = CCSprite:create("image/other/bg.jpg")
	end
	INIT_FUNCTION.setAnchPos( bg , 0 , 0 )
	layer:addChild( bg )
	scene:addChild(layer)

	local handle
	handle = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(function()
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(handle)
		handle = nil
		
		M:go()
	end , 2 , false)
end

function M:hyflash()
	local interface = UpdataRes:getInstance()
	local platform_type = interface:get_type()
	if platform_type == 0 or CHANNEL_ID == "hy.changmeng2" then
		M:go()
		return
	end

	if platform_type == 1 then 				-- Android
		LuaAisle.instance():call({
			tag = "com/kuniu/play/Player-play",
			file = "entrance.mp4",
			callback = function(response)
				M:go()
			end
		})
	elseif platform_type == 2 then 				-- IOS
		 if CHANNEL_ID ~= "hysjIosAppStore"  then
			UpdateDataOC:getInstance():playMovie(function (response )
				M:go()
			end)
		 else
		 	M:go()
		 end
	end
end

function M:IOS_INIT()
	if __INNER_IOS_SDK_VER then
		channel_delegate:init()
		if __INNER_IOS_SDK_VER >= 2 then
			channel_delegate:getInst():setLogoutCallback(function() 
				if SOCKET:returnInstance("battle") then
					Clock:removeTimeFun("heartbeat")
					SOCKET:getInstance("battle"):close()
					SOCKET:delInstance("battle")
				end
				switchScene("login")
			end)
		end
	end
end

function M:go()
	M:IOS_INIT() --sdk 初始化, 放在这里的原因是要等logo显示完才显示sdk的界面
	INIT_FUNCTION.update = initCopyLayer:new()
	scene:addChild(INIT_FUNCTION.update:getLayer())	
end

return M